/* TagTable.c generated by valac 0.56.3, the Vala compiler
 * generated from TagTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>

#define TAG_ID_INVALID ((gint64) -1)
#define TAG_PATH_SEPARATOR_STRING "/"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TAG_ID (tag_id_get_type ())
typedef struct _TagID TagID;

#define TYPE_TAG_ROW (tag_row_get_type ())
#define TAG_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_ROW, TagRow))
#define TAG_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_ROW, TagRowClass))
#define IS_TAG_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_ROW))
#define IS_TAG_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_ROW))
#define TAG_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_ROW, TagRowClass))

typedef struct _TagRow TagRow;
typedef struct _TagRowClass TagRowClass;
typedef struct _TagRowPrivate TagRowPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecTagRow ParamSpecTagRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TAG_TABLE (tag_table_get_type ())
#define TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_TABLE, TagTable))
#define TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_TABLE, TagTableClass))
#define IS_TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_TABLE))
#define IS_TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_TABLE))
#define TAG_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_TABLE, TagTableClass))

typedef struct _TagTable TagTable;
typedef struct _TagTableClass TagTableClass;
typedef struct _TagTablePrivate TagTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _tag_row_unref0(var) ((var == NULL) ? NULL : (var = (tag_row_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TagID {
	gint64 id;
};

struct _TagRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TagRowPrivate * priv;
	TagID tag_id;
	gchar* name;
	GeeSet* source_id_list;
	gint64 time_created;
};

struct _TagRowClass {
	GTypeClass parent_class;
	void (*finalize) (TagRow *self);
};

struct _ParamSpecTagRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TagTable {
	DatabaseTable parent_instance;
	TagTablePrivate * priv;
};

struct _TagTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

struct _PhotoID {
	gint64 id;
};

static gpointer tag_row_parent_class = NULL;
static gpointer tag_table_parent_class = NULL;
static TagTable* tag_table_instance;
static TagTable* tag_table_instance = NULL;
VALA_EXTERN sqlite3* database_table_db;

VALA_EXTERN GType tag_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TagID* tag_id_dup (const TagID* self);
VALA_EXTERN void tag_id_free (TagID* self);
VALA_EXTERN void tag_id_init (TagID *self,
                  gint64 id);
VALA_EXTERN gboolean tag_id_is_invalid (TagID *self);
VALA_EXTERN gboolean tag_id_is_valid (TagID *self);
VALA_EXTERN gpointer tag_row_ref (gpointer instance);
VALA_EXTERN void tag_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_tag_row (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_tag_row (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_tag_row (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_tag_row (const GValue* value);
VALA_EXTERN GType tag_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagRow, tag_row_unref)
VALA_EXTERN TagRow* tag_row_new (void);
VALA_EXTERN TagRow* tag_row_construct (GType object_type);
static void tag_row_finalize (TagRow * obj);
static GType tag_row_get_type_once (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType tag_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagTable, database_table_unref)
static TagTable* tag_table_new (void);
static TagTable* tag_table_construct (GType object_type);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN TagTable* tag_table_get_instance (void);
VALA_EXTERN void tag_table_upgrade_for_htags (void);
VALA_EXTERN GQuark database_error_quark (void);
GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeList* tag_table_get_all_rows (TagTable* self,
                                 GError** error);
VALA_EXTERN void tag_table_rename (TagTable* self,
                       TagID* tag_id,
                       const gchar* new_name,
                       GError** error);
VALA_EXTERN TagRow* tag_table_add (TagTable* self,
                       const gchar* name,
                       GError** error);
VALA_EXTERN gint64 now_sec (void);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN void tag_table_create_from_row (TagTable* self,
                                TagRow* row,
                                TagID* result,
                                GError** error);
static gchar* tag_table_serialize_source_ids (TagTable* self,
                                       GeeCollection* source_ids);
VALA_EXTERN void tag_table_remove (TagTable* self,
                       TagID* tag_id,
                       GError** error);
VALA_EXTERN void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
VALA_EXTERN gchar* tag_table_get_name (TagTable* self,
                           TagID* tag_id,
                           GError** error);
VALA_EXTERN gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt** stmt);
VALA_EXTERN TagRow* tag_table_get_row (TagTable* self,
                           TagID* tag_id,
                           GError** error);
static GeeSet* tag_table_unserialize_source_ids (TagTable* self,
                                          const gchar* text_list);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN void tag_table_set_tagged_sources (TagTable* self,
                                   TagID* tag_id,
                                   GeeCollection* source_ids,
                                   GError** error);
VALA_EXTERN gboolean is_string_empty (const gchar* s);
VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
VALA_EXTERN gint64 parse_int64 (const gchar* str,
                    gint num_base);
VALA_EXTERN void photo_id_init (PhotoID *self,
                    gint64 id);
static void tag_table_finalize (DatabaseTable * obj);
static GType tag_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

void
tag_id_init (TagID *self,
             gint64 id)
{
#line 12 "../src/db/TagTable.vala"
	memset (self, 0, sizeof (TagID));
#line 13 "../src/db/TagTable.vala"
	(*self).id = id;
#line 274 "TagTable.c"
}

gboolean
tag_id_is_invalid (TagID *self)
{
	gboolean result;
#line 17 "../src/db/TagTable.vala"
	result = (*self).id == TAG_ID_INVALID;
#line 17 "../src/db/TagTable.vala"
	return result;
#line 285 "TagTable.c"
}

gboolean
tag_id_is_valid (TagID *self)
{
	gboolean result;
#line 21 "../src/db/TagTable.vala"
	result = (*self).id != TAG_ID_INVALID;
#line 21 "../src/db/TagTable.vala"
	return result;
#line 296 "TagTable.c"
}

TagID*
tag_id_dup (const TagID* self)
{
	TagID* dup;
#line 7 "../src/db/TagTable.vala"
	dup = g_new0 (TagID, 1);
#line 7 "../src/db/TagTable.vala"
	memcpy (dup, self, sizeof (TagID));
#line 7 "../src/db/TagTable.vala"
	return dup;
#line 309 "TagTable.c"
}

void
tag_id_free (TagID* self)
{
#line 7 "../src/db/TagTable.vala"
	g_free (self);
#line 317 "TagTable.c"
}

static GType
tag_id_get_type_once (void)
{
	GType tag_id_type_id;
	tag_id_type_id = g_boxed_type_register_static ("TagID", (GBoxedCopyFunc) tag_id_dup, (GBoxedFreeFunc) tag_id_free);
	return tag_id_type_id;
}

GType
tag_id_get_type (void)
{
	static volatile gsize tag_id_type_id__once = 0;
	if (g_once_init_enter (&tag_id_type_id__once)) {
		GType tag_id_type_id;
		tag_id_type_id = tag_id_get_type_once ();
		g_once_init_leave (&tag_id_type_id__once, tag_id_type_id);
	}
	return tag_id_type_id__once;
}

TagRow*
tag_row_construct (GType object_type)
{
	TagRow* self = NULL;
#line 25 "../src/db/TagTable.vala"
	self = (TagRow*) g_type_create_instance (object_type);
#line 25 "../src/db/TagTable.vala"
	return self;
#line 348 "TagTable.c"
}

TagRow*
tag_row_new (void)
{
#line 25 "../src/db/TagTable.vala"
	return tag_row_construct (TYPE_TAG_ROW);
#line 356 "TagTable.c"
}

static void
value_tag_row_init (GValue* value)
{
#line 25 "../src/db/TagTable.vala"
	value->data[0].v_pointer = NULL;
#line 364 "TagTable.c"
}

static void
value_tag_row_free_value (GValue* value)
{
#line 25 "../src/db/TagTable.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/db/TagTable.vala"
		tag_row_unref (value->data[0].v_pointer);
#line 374 "TagTable.c"
	}
}

static void
value_tag_row_copy_value (const GValue* src_value,
                          GValue* dest_value)
{
#line 25 "../src/db/TagTable.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/db/TagTable.vala"
		dest_value->data[0].v_pointer = tag_row_ref (src_value->data[0].v_pointer);
#line 386 "TagTable.c"
	} else {
#line 25 "../src/db/TagTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 390 "TagTable.c"
	}
}

static gpointer
value_tag_row_peek_pointer (const GValue* value)
{
#line 25 "../src/db/TagTable.vala"
	return value->data[0].v_pointer;
#line 399 "TagTable.c"
}

static gchar*
value_tag_row_collect_value (GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
#line 25 "../src/db/TagTable.vala"
	if (collect_values[0].v_pointer) {
#line 410 "TagTable.c"
		TagRow * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/db/TagTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/db/TagTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 417 "TagTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/db/TagTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 421 "TagTable.c"
		}
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = tag_row_ref (object);
#line 425 "TagTable.c"
	} else {
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = NULL;
#line 429 "TagTable.c"
	}
#line 25 "../src/db/TagTable.vala"
	return NULL;
#line 433 "TagTable.c"
}

static gchar*
value_tag_row_lcopy_value (const GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
	TagRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/db/TagTable.vala"
	if (!object_p) {
#line 25 "../src/db/TagTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 448 "TagTable.c"
	}
#line 25 "../src/db/TagTable.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/db/TagTable.vala"
		*object_p = NULL;
#line 454 "TagTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/db/TagTable.vala"
		*object_p = value->data[0].v_pointer;
#line 458 "TagTable.c"
	} else {
#line 25 "../src/db/TagTable.vala"
		*object_p = tag_row_ref (value->data[0].v_pointer);
#line 462 "TagTable.c"
	}
#line 25 "../src/db/TagTable.vala"
	return NULL;
#line 466 "TagTable.c"
}

GParamSpec*
param_spec_tag_row (const gchar* name,
                    const gchar* nick,
                    const gchar* blurb,
                    GType object_type,
                    GParamFlags flags)
{
	ParamSpecTagRow* spec;
#line 25 "../src/db/TagTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TAG_ROW), NULL);
#line 25 "../src/db/TagTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/db/TagTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/db/TagTable.vala"
	return G_PARAM_SPEC (spec);
#line 485 "TagTable.c"
}

gpointer
value_get_tag_row (const GValue* value)
{
#line 25 "../src/db/TagTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TAG_ROW), NULL);
#line 25 "../src/db/TagTable.vala"
	return value->data[0].v_pointer;
#line 495 "TagTable.c"
}

void
value_set_tag_row (GValue* value,
                   gpointer v_object)
{
	TagRow * old;
#line 25 "../src/db/TagTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TAG_ROW));
#line 25 "../src/db/TagTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/TagTable.vala"
	if (v_object) {
#line 25 "../src/db/TagTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TAG_ROW));
#line 25 "../src/db/TagTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/db/TagTable.vala"
		tag_row_ref (value->data[0].v_pointer);
#line 517 "TagTable.c"
	} else {
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = NULL;
#line 521 "TagTable.c"
	}
#line 25 "../src/db/TagTable.vala"
	if (old) {
#line 25 "../src/db/TagTable.vala"
		tag_row_unref (old);
#line 527 "TagTable.c"
	}
}

void
value_take_tag_row (GValue* value,
                    gpointer v_object)
{
	TagRow * old;
#line 25 "../src/db/TagTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TAG_ROW));
#line 25 "../src/db/TagTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/TagTable.vala"
	if (v_object) {
#line 25 "../src/db/TagTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TAG_ROW));
#line 25 "../src/db/TagTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = v_object;
#line 548 "TagTable.c"
	} else {
#line 25 "../src/db/TagTable.vala"
		value->data[0].v_pointer = NULL;
#line 552 "TagTable.c"
	}
#line 25 "../src/db/TagTable.vala"
	if (old) {
#line 25 "../src/db/TagTable.vala"
		tag_row_unref (old);
#line 558 "TagTable.c"
	}
}

static void
tag_row_class_init (TagRowClass * klass,
                    gpointer klass_data)
{
#line 25 "../src/db/TagTable.vala"
	tag_row_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/db/TagTable.vala"
	((TagRowClass *) klass)->finalize = tag_row_finalize;
#line 570 "TagTable.c"
}

static void
tag_row_instance_init (TagRow * self,
                       gpointer klass)
{
#line 25 "../src/db/TagTable.vala"
	self->ref_count = 1;
#line 579 "TagTable.c"
}

static void
tag_row_finalize (TagRow * obj)
{
	TagRow * self;
#line 25 "../src/db/TagTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAG_ROW, TagRow);
#line 25 "../src/db/TagTable.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/db/TagTable.vala"
	_g_free0 (self->name);
#line 28 "../src/db/TagTable.vala"
	_g_object_unref0 (self->source_id_list);
#line 594 "TagTable.c"
}

static GType
tag_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_tag_row_init, value_tag_row_free_value, value_tag_row_copy_value, value_tag_row_peek_pointer, "p", value_tag_row_collect_value, "p", value_tag_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TagRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tag_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TagRow), 0, (GInstanceInitFunc) tag_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tag_row_type_id;
	tag_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TagRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return tag_row_type_id;
}

GType
tag_row_get_type (void)
{
	static volatile gsize tag_row_type_id__once = 0;
	if (g_once_init_enter (&tag_row_type_id__once)) {
		GType tag_row_type_id;
		tag_row_type_id = tag_row_get_type_once ();
		g_once_init_leave (&tag_row_type_id__once, tag_row_type_id);
	}
	return tag_row_type_id__once;
}

gpointer
tag_row_ref (gpointer instance)
{
	TagRow * self;
	self = instance;
#line 25 "../src/db/TagTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/db/TagTable.vala"
	return instance;
#line 629 "TagTable.c"
}

void
tag_row_unref (gpointer instance)
{
	TagRow * self;
	self = instance;
#line 25 "../src/db/TagTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/db/TagTable.vala"
		TAG_ROW_GET_CLASS (self)->finalize (self);
#line 25 "../src/db/TagTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 643 "TagTable.c"
	}
}

static TagTable*
tag_table_construct (GType object_type)
{
	TagTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 35 "../src/db/TagTable.vala"
	self = (TagTable*) database_table_construct (object_type);
#line 36 "../src/db/TagTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "TagTable");
#line 39 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 39 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "TagTable " "(" "id INTEGER PRIMARY KEY, " "name TEXT UNIQUE NOT NULL, " "photo_id_list TEXT, " "time_created INTEGER" ")", -1, &_tmp1_, NULL);
#line 39 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 39 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 39 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 47 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 49 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 49 "../src/db/TagTable.vala"
	res = sqlite3_step (_tmp3_);
#line 50 "../src/db/TagTable.vala"
	if (res != SQLITE_DONE) {
#line 51 "../src/db/TagTable.vala"
		database_table_fatal ("create TagTable", res);
#line 681 "TagTable.c"
	}
#line 35 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 35 "../src/db/TagTable.vala"
	return self;
#line 687 "TagTable.c"
}

static TagTable*
tag_table_new (void)
{
#line 35 "../src/db/TagTable.vala"
	return tag_table_construct (TYPE_TAG_TABLE);
#line 695 "TagTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 58 "../src/db/TagTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 703 "TagTable.c"
}

TagTable*
tag_table_get_instance (void)
{
	TagTable* _tmp0_;
	TagTable* _tmp2_;
	TagTable* _tmp3_;
	TagTable* result;
#line 55 "../src/db/TagTable.vala"
	_tmp0_ = tag_table_instance;
#line 55 "../src/db/TagTable.vala"
	if (_tmp0_ == NULL) {
#line 717 "TagTable.c"
		TagTable* _tmp1_;
#line 56 "../src/db/TagTable.vala"
		_tmp1_ = tag_table_new ();
#line 56 "../src/db/TagTable.vala"
		_database_table_unref0 (tag_table_instance);
#line 56 "../src/db/TagTable.vala"
		tag_table_instance = _tmp1_;
#line 725 "TagTable.c"
	}
#line 58 "../src/db/TagTable.vala"
	_tmp2_ = tag_table_instance;
#line 58 "../src/db/TagTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 58 "../src/db/TagTable.vala"
	result = _tmp3_;
#line 58 "../src/db/TagTable.vala"
	return result;
#line 735 "TagTable.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 757 "TagTable.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 761 "TagTable.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 767 "TagTable.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 771 "TagTable.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 775 "TagTable.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 783 "TagTable.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 811 "TagTable.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 820 "TagTable.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 834 "TagTable.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 843 "TagTable.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 857 "TagTable.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 866 "TagTable.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 875 "TagTable.c"
}

void
tag_table_upgrade_for_htags (void)
{
	TagTable* table = NULL;
	TagTable* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 62 "../src/db/TagTable.vala"
	_tmp0_ = tag_table_get_instance ();
#line 62 "../src/db/TagTable.vala"
	table = _tmp0_;
#line 888 "TagTable.c"
	{
		GeeList* rows = NULL;
		TagTable* _tmp1_;
		GeeList* _tmp2_;
#line 65 "../src/db/TagTable.vala"
		_tmp1_ = table;
#line 65 "../src/db/TagTable.vala"
		_tmp2_ = tag_table_get_all_rows (_tmp1_, &_inner_error0_);
#line 65 "../src/db/TagTable.vala"
		rows = _tmp2_;
#line 65 "../src/db/TagTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/db/TagTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 903 "TagTable.c"
				goto __catch0_database_error;
			}
#line 65 "../src/db/TagTable.vala"
			_database_table_unref0 (table);
#line 65 "../src/db/TagTable.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/db/TagTable.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../src/db/TagTable.vala"
			return;
#line 914 "TagTable.c"
		}
		{
			GeeList* _row_list = NULL;
			GeeList* _tmp3_;
			gint _row_size = 0;
			GeeList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _row_index = 0;
#line 67 "../src/db/TagTable.vala"
			_tmp3_ = rows;
#line 67 "../src/db/TagTable.vala"
			_row_list = _tmp3_;
#line 67 "../src/db/TagTable.vala"
			_tmp4_ = _row_list;
#line 67 "../src/db/TagTable.vala"
			_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 67 "../src/db/TagTable.vala"
			_tmp6_ = _tmp5_;
#line 67 "../src/db/TagTable.vala"
			_row_size = _tmp6_;
#line 67 "../src/db/TagTable.vala"
			_row_index = -1;
#line 67 "../src/db/TagTable.vala"
			while (TRUE) {
#line 940 "TagTable.c"
				gint _tmp7_;
				gint _tmp8_;
				TagRow* row = NULL;
				GeeList* _tmp9_;
				gpointer _tmp10_;
				TagRow* _tmp11_;
				TagRow* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				TagTable* _tmp15_;
				TagRow* _tmp16_;
				TagID _tmp17_;
				TagRow* _tmp18_;
				const gchar* _tmp19_;
#line 67 "../src/db/TagTable.vala"
				_row_index = _row_index + 1;
#line 67 "../src/db/TagTable.vala"
				_tmp7_ = _row_index;
#line 67 "../src/db/TagTable.vala"
				_tmp8_ = _row_size;
#line 67 "../src/db/TagTable.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 67 "../src/db/TagTable.vala"
					break;
#line 965 "TagTable.c"
				}
#line 67 "../src/db/TagTable.vala"
				_tmp9_ = _row_list;
#line 67 "../src/db/TagTable.vala"
				_tmp10_ = gee_list_get (_tmp9_, _row_index);
#line 67 "../src/db/TagTable.vala"
				row = (TagRow*) _tmp10_;
#line 68 "../src/db/TagTable.vala"
				_tmp11_ = row;
#line 68 "../src/db/TagTable.vala"
				_tmp12_ = row;
#line 68 "../src/db/TagTable.vala"
				_tmp13_ = _tmp12_->name;
#line 68 "../src/db/TagTable.vala"
				_tmp14_ = string_replace (_tmp13_, TAG_PATH_SEPARATOR_STRING, "-");
#line 68 "../src/db/TagTable.vala"
				_g_free0 (_tmp11_->name);
#line 68 "../src/db/TagTable.vala"
				_tmp11_->name = _tmp14_;
#line 69 "../src/db/TagTable.vala"
				_tmp15_ = table;
#line 69 "../src/db/TagTable.vala"
				_tmp16_ = row;
#line 69 "../src/db/TagTable.vala"
				_tmp17_ = _tmp16_->tag_id;
#line 69 "../src/db/TagTable.vala"
				_tmp18_ = row;
#line 69 "../src/db/TagTable.vala"
				_tmp19_ = _tmp18_->name;
#line 69 "../src/db/TagTable.vala"
				tag_table_rename (_tmp15_, &_tmp17_, _tmp19_, &_inner_error0_);
#line 69 "../src/db/TagTable.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/db/TagTable.vala"
					_tag_row_unref0 (row);
#line 69 "../src/db/TagTable.vala"
					_g_object_unref0 (rows);
#line 69 "../src/db/TagTable.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1005 "TagTable.c"
						goto __catch0_database_error;
					}
#line 69 "../src/db/TagTable.vala"
					_database_table_unref0 (table);
#line 69 "../src/db/TagTable.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/db/TagTable.vala"
					g_clear_error (&_inner_error0_);
#line 69 "../src/db/TagTable.vala"
					return;
#line 1016 "TagTable.c"
				}
#line 67 "../src/db/TagTable.vala"
				_tag_row_unref0 (row);
#line 1020 "TagTable.c"
			}
		}
#line 64 "../src/db/TagTable.vala"
		_g_object_unref0 (rows);
#line 1025 "TagTable.c"
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* e = NULL;
		const gchar* _tmp20_;
#line 64 "../src/db/TagTable.vala"
		e = _inner_error0_;
#line 64 "../src/db/TagTable.vala"
		_inner_error0_ = NULL;
#line 72 "../src/db/TagTable.vala"
		_tmp20_ = e->message;
#line 72 "../src/db/TagTable.vala"
		g_error ("TagTable.vala:72: TagTable: can't upgrade tag names for hierarchical t" \
"ag support: %s", _tmp20_);
#line 64 "../src/db/TagTable.vala"
		_g_error_free0 (e);
#line 1042 "TagTable.c"
	}
	__finally0:
#line 64 "../src/db/TagTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/db/TagTable.vala"
		_database_table_unref0 (table);
#line 64 "../src/db/TagTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/db/TagTable.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/db/TagTable.vala"
		return;
#line 1055 "TagTable.c"
	}
#line 61 "../src/db/TagTable.vala"
	_database_table_unref0 (table);
#line 1059 "TagTable.c"
}

TagRow*
tag_table_add (TagTable* self,
               const gchar* name,
               GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	TagRow* row = NULL;
	TagRow* _tmp8_;
	TagRow* _tmp9_;
	sqlite3* _tmp10_;
	TagRow* _tmp11_;
	gchar* _tmp12_;
	TagRow* _tmp13_;
	TagRow* _tmp14_;
	GError* _inner_error0_ = NULL;
	TagRow* result;
#line 76 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 76 "../src/db/TagTable.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 78 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 78 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TagTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 78 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 78 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 78 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 80 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 82 "../src/db/TagTable.vala"
	time_created = now_sec ();
#line 84 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 84 "../src/db/TagTable.vala"
	_tmp4_ = g_strdup (name);
#line 84 "../src/db/TagTable.vala"
	_tmp5_ = g_free;
#line 84 "../src/db/TagTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 85 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 86 "../src/db/TagTable.vala"
	_tmp6_ = stmt;
#line 86 "../src/db/TagTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, time_created);
#line 87 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 89 "../src/db/TagTable.vala"
	_tmp7_ = stmt;
#line 89 "../src/db/TagTable.vala"
	res = sqlite3_step (_tmp7_);
#line 90 "../src/db/TagTable.vala"
	if (res != SQLITE_DONE) {
#line 91 "../src/db/TagTable.vala"
		database_table_throw_error ("TagTable.add", res, &_inner_error0_);
#line 91 "../src/db/TagTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/db/TagTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 91 "../src/db/TagTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 91 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 91 "../src/db/TagTable.vala"
				return NULL;
#line 1140 "TagTable.c"
			} else {
#line 91 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 91 "../src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/db/TagTable.vala"
				g_clear_error (&_inner_error0_);
#line 91 "../src/db/TagTable.vala"
				return NULL;
#line 1150 "TagTable.c"
			}
		}
	}
#line 93 "../src/db/TagTable.vala"
	_tmp8_ = tag_row_new ();
#line 93 "../src/db/TagTable.vala"
	row = _tmp8_;
#line 94 "../src/db/TagTable.vala"
	_tmp9_ = row;
#line 94 "../src/db/TagTable.vala"
	_tmp10_ = database_table_db;
#line 94 "../src/db/TagTable.vala"
	tag_id_init (&_tmp9_->tag_id, sqlite3_last_insert_rowid (_tmp10_));
#line 95 "../src/db/TagTable.vala"
	_tmp11_ = row;
#line 95 "../src/db/TagTable.vala"
	_tmp12_ = g_strdup (name);
#line 95 "../src/db/TagTable.vala"
	_g_free0 (_tmp11_->name);
#line 95 "../src/db/TagTable.vala"
	_tmp11_->name = _tmp12_;
#line 96 "../src/db/TagTable.vala"
	_tmp13_ = row;
#line 96 "../src/db/TagTable.vala"
	_g_object_unref0 (_tmp13_->source_id_list);
#line 96 "../src/db/TagTable.vala"
	_tmp13_->source_id_list = NULL;
#line 97 "../src/db/TagTable.vala"
	_tmp14_ = row;
#line 97 "../src/db/TagTable.vala"
	_tmp14_->time_created = time_created;
#line 99 "../src/db/TagTable.vala"
	result = row;
#line 99 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 99 "../src/db/TagTable.vala"
	return result;
#line 1188 "TagTable.c"
}

void
tag_table_create_from_row (TagTable* self,
                           TagRow* row,
                           TagID* result,
                           GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	GeeSet* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3* _tmp13_;
	TagID _tmp14_ = {0};
	GError* _inner_error0_ = NULL;
#line 103 "../src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 103 "../src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_ROW (row));
#line 105 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 105 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TagTable (name, photo_id_list, time_created) VALUES (?, ?," \
" ?)", -1, &_tmp1_, NULL);
#line 105 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 105 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 105 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 107 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 109 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 109 "../src/db/TagTable.vala"
	_tmp4_ = row->name;
#line 109 "../src/db/TagTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 109 "../src/db/TagTable.vala"
	_tmp6_ = g_free;
#line 109 "../src/db/TagTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 110 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 111 "../src/db/TagTable.vala"
	_tmp7_ = stmt;
#line 111 "../src/db/TagTable.vala"
	_tmp8_ = row->source_id_list;
#line 111 "../src/db/TagTable.vala"
	_tmp9_ = tag_table_serialize_source_ids (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 111 "../src/db/TagTable.vala"
	_tmp10_ = g_free;
#line 111 "../src/db/TagTable.vala"
	res = sqlite3_bind_text (_tmp7_, 2, _tmp9_, -1, _tmp10_);
#line 112 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 113 "../src/db/TagTable.vala"
	_tmp11_ = stmt;
#line 113 "../src/db/TagTable.vala"
	res = sqlite3_bind_int64 (_tmp11_, 3, row->time_created);
#line 114 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 116 "../src/db/TagTable.vala"
	_tmp12_ = stmt;
#line 116 "../src/db/TagTable.vala"
	res = sqlite3_step (_tmp12_);
#line 117 "../src/db/TagTable.vala"
	if (res != SQLITE_DONE) {
#line 118 "../src/db/TagTable.vala"
		database_table_throw_error ("TagTable.create_from_row", res, &_inner_error0_);
#line 118 "../src/db/TagTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/db/TagTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 118 "../src/db/TagTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 118 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 118 "../src/db/TagTable.vala"
				return;
#line 1279 "TagTable.c"
			} else {
#line 118 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 118 "../src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/db/TagTable.vala"
				g_clear_error (&_inner_error0_);
#line 118 "../src/db/TagTable.vala"
				return;
#line 1289 "TagTable.c"
			}
		}
	}
#line 120 "../src/db/TagTable.vala"
	_tmp13_ = database_table_db;
#line 120 "../src/db/TagTable.vala"
	tag_id_init (&_tmp14_, sqlite3_last_insert_rowid (_tmp13_));
#line 120 "../src/db/TagTable.vala"
	*result = _tmp14_;
#line 120 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 120 "../src/db/TagTable.vala"
	return;
#line 1303 "TagTable.c"
}

void
tag_table_remove (TagTable* self,
                  TagID* tag_id,
                  GError** error)
{
	TagID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 123 "../src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 123 "../src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 124 "../src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 124 "../src/db/TagTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 124 "../src/db/TagTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/db/TagTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 124 "../src/db/TagTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/db/TagTable.vala"
			return;
#line 1329 "TagTable.c"
		} else {
#line 124 "../src/db/TagTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/db/TagTable.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/db/TagTable.vala"
			return;
#line 1337 "TagTable.c"
		}
	}
}

gchar*
tag_table_get_name (TagTable* self,
                    TagID* tag_id,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	TagID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 127 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 127 "../src/db/TagTable.vala"
	g_return_val_if_fail (tag_id != NULL, NULL);
#line 129 "../src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 129 "../src/db/TagTable.vala"
	_tmp2_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", &_tmp1_);
#line 129 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 129 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 129 "../src/db/TagTable.vala"
	if (!_tmp2_) {
#line 130 "../src/db/TagTable.vala"
		result = NULL;
#line 130 "../src/db/TagTable.vala"
		_sqlite3_finalize0 (stmt);
#line 130 "../src/db/TagTable.vala"
		return result;
#line 1375 "TagTable.c"
	}
#line 132 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 132 "../src/db/TagTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 132 "../src/db/TagTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 132 "../src/db/TagTable.vala"
	result = _tmp5_;
#line 132 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 132 "../src/db/TagTable.vala"
	return result;
#line 1389 "TagTable.c"
}

TagRow*
tag_table_get_row (TagTable* self,
                   TagID* tag_id,
                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	TagID _tmp4_;
	sqlite3_stmt* _tmp5_;
	TagRow* row = NULL;
	TagRow* _tmp6_;
	TagRow* _tmp7_;
	TagID _tmp8_;
	TagRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	TagRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	GeeSet* _tmp16_;
	TagRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	GError* _inner_error0_ = NULL;
	TagRow* result;
#line 135 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 135 "../src/db/TagTable.vala"
	g_return_val_if_fail (tag_id != NULL, NULL);
#line 137 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 137 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, photo_id_list, time_created FROM TagTable WHERE id=?", -1, &_tmp1_, NULL);
#line 137 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 137 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 137 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 139 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 141 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 141 "../src/db/TagTable.vala"
	_tmp4_ = *tag_id;
#line 141 "../src/db/TagTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 142 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 144 "../src/db/TagTable.vala"
	_tmp5_ = stmt;
#line 144 "../src/db/TagTable.vala"
	res = sqlite3_step (_tmp5_);
#line 145 "../src/db/TagTable.vala"
	if (res == SQLITE_DONE) {
#line 146 "../src/db/TagTable.vala"
		result = NULL;
#line 146 "../src/db/TagTable.vala"
		_sqlite3_finalize0 (stmt);
#line 146 "../src/db/TagTable.vala"
		return result;
#line 1457 "TagTable.c"
	} else {
#line 147 "../src/db/TagTable.vala"
		if (res != SQLITE_ROW) {
#line 148 "../src/db/TagTable.vala"
			database_table_throw_error ("TagTable.get_row", res, &_inner_error0_);
#line 148 "../src/db/TagTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/db/TagTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 148 "../src/db/TagTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 148 "../src/db/TagTable.vala"
					_sqlite3_finalize0 (stmt);
#line 148 "../src/db/TagTable.vala"
					return NULL;
#line 1473 "TagTable.c"
				} else {
#line 148 "../src/db/TagTable.vala"
					_sqlite3_finalize0 (stmt);
#line 148 "../src/db/TagTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/db/TagTable.vala"
					g_clear_error (&_inner_error0_);
#line 148 "../src/db/TagTable.vala"
					return NULL;
#line 1483 "TagTable.c"
				}
			}
		}
	}
#line 150 "../src/db/TagTable.vala"
	_tmp6_ = tag_row_new ();
#line 150 "../src/db/TagTable.vala"
	row = _tmp6_;
#line 151 "../src/db/TagTable.vala"
	_tmp7_ = row;
#line 151 "../src/db/TagTable.vala"
	_tmp8_ = *tag_id;
#line 151 "../src/db/TagTable.vala"
	_tmp7_->tag_id = _tmp8_;
#line 152 "../src/db/TagTable.vala"
	_tmp9_ = row;
#line 152 "../src/db/TagTable.vala"
	_tmp10_ = stmt;
#line 152 "../src/db/TagTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 152 "../src/db/TagTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 152 "../src/db/TagTable.vala"
	_g_free0 (_tmp9_->name);
#line 152 "../src/db/TagTable.vala"
	_tmp9_->name = _tmp12_;
#line 153 "../src/db/TagTable.vala"
	_tmp13_ = row;
#line 153 "../src/db/TagTable.vala"
	_tmp14_ = stmt;
#line 153 "../src/db/TagTable.vala"
	_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 1);
#line 153 "../src/db/TagTable.vala"
	_tmp16_ = tag_table_unserialize_source_ids (self, _tmp15_);
#line 153 "../src/db/TagTable.vala"
	_g_object_unref0 (_tmp13_->source_id_list);
#line 153 "../src/db/TagTable.vala"
	_tmp13_->source_id_list = _tmp16_;
#line 154 "../src/db/TagTable.vala"
	_tmp17_ = row;
#line 154 "../src/db/TagTable.vala"
	_tmp18_ = stmt;
#line 154 "../src/db/TagTable.vala"
	_tmp17_->time_created = sqlite3_column_int64 (_tmp18_, 2);
#line 156 "../src/db/TagTable.vala"
	result = row;
#line 156 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 156 "../src/db/TagTable.vala"
	return result;
#line 1534 "TagTable.c"
}

GeeList*
tag_table_get_all_rows (TagTable* self,
                        GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeList* rows = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 159 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 161 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 161 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, photo_id_list, time_created FROM TagTable", -1, &_tmp1_, NULL);
#line 161 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 161 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 161 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 163 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 165 "../src/db/TagTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_TAG_ROW, (GBoxedCopyFunc) tag_row_ref, (GDestroyNotify) tag_row_unref, NULL, NULL, NULL);
#line 165 "../src/db/TagTable.vala"
	rows = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 1568 "TagTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 167 "../src/db/TagTable.vala"
		_tmp4_ = TRUE;
#line 167 "../src/db/TagTable.vala"
		while (TRUE) {
#line 1575 "TagTable.c"
			sqlite3_stmt* _tmp5_;
			TagRow* row = NULL;
			TagRow* _tmp6_;
			TagRow* _tmp7_;
			sqlite3_stmt* _tmp8_;
			TagRow* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			TagRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			const gchar* _tmp15_;
			GeeSet* _tmp16_;
			TagRow* _tmp17_;
			sqlite3_stmt* _tmp18_;
			GeeList* _tmp19_;
			TagRow* _tmp20_;
#line 167 "../src/db/TagTable.vala"
			if (!_tmp4_) {
#line 1595 "TagTable.c"
			}
#line 167 "../src/db/TagTable.vala"
			_tmp4_ = FALSE;
#line 168 "../src/db/TagTable.vala"
			_tmp5_ = stmt;
#line 168 "../src/db/TagTable.vala"
			res = sqlite3_step (_tmp5_);
#line 169 "../src/db/TagTable.vala"
			if (res == SQLITE_DONE) {
#line 170 "../src/db/TagTable.vala"
				break;
#line 1607 "TagTable.c"
			} else {
#line 171 "../src/db/TagTable.vala"
				if (res != SQLITE_ROW) {
#line 172 "../src/db/TagTable.vala"
					database_table_throw_error ("TagTable.get_all_rows", res, &_inner_error0_);
#line 172 "../src/db/TagTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/db/TagTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 172 "../src/db/TagTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 172 "../src/db/TagTable.vala"
							_g_object_unref0 (rows);
#line 172 "../src/db/TagTable.vala"
							_sqlite3_finalize0 (stmt);
#line 172 "../src/db/TagTable.vala"
							return NULL;
#line 1625 "TagTable.c"
						} else {
#line 172 "../src/db/TagTable.vala"
							_g_object_unref0 (rows);
#line 172 "../src/db/TagTable.vala"
							_sqlite3_finalize0 (stmt);
#line 172 "../src/db/TagTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/db/TagTable.vala"
							g_clear_error (&_inner_error0_);
#line 172 "../src/db/TagTable.vala"
							return NULL;
#line 1637 "TagTable.c"
						}
					}
				}
			}
#line 175 "../src/db/TagTable.vala"
			_tmp6_ = tag_row_new ();
#line 175 "../src/db/TagTable.vala"
			row = _tmp6_;
#line 176 "../src/db/TagTable.vala"
			_tmp7_ = row;
#line 176 "../src/db/TagTable.vala"
			_tmp8_ = stmt;
#line 176 "../src/db/TagTable.vala"
			tag_id_init (&_tmp7_->tag_id, sqlite3_column_int64 (_tmp8_, 0));
#line 177 "../src/db/TagTable.vala"
			_tmp9_ = row;
#line 177 "../src/db/TagTable.vala"
			_tmp10_ = stmt;
#line 177 "../src/db/TagTable.vala"
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 177 "../src/db/TagTable.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 177 "../src/db/TagTable.vala"
			_g_free0 (_tmp9_->name);
#line 177 "../src/db/TagTable.vala"
			_tmp9_->name = _tmp12_;
#line 178 "../src/db/TagTable.vala"
			_tmp13_ = row;
#line 178 "../src/db/TagTable.vala"
			_tmp14_ = stmt;
#line 178 "../src/db/TagTable.vala"
			_tmp15_ = (const gchar*) sqlite3_column_text (_tmp14_, 2);
#line 178 "../src/db/TagTable.vala"
			_tmp16_ = tag_table_unserialize_source_ids (self, _tmp15_);
#line 178 "../src/db/TagTable.vala"
			_g_object_unref0 (_tmp13_->source_id_list);
#line 178 "../src/db/TagTable.vala"
			_tmp13_->source_id_list = _tmp16_;
#line 179 "../src/db/TagTable.vala"
			_tmp17_ = row;
#line 179 "../src/db/TagTable.vala"
			_tmp18_ = stmt;
#line 179 "../src/db/TagTable.vala"
			_tmp17_->time_created = sqlite3_column_int64 (_tmp18_, 3);
#line 181 "../src/db/TagTable.vala"
			_tmp19_ = rows;
#line 181 "../src/db/TagTable.vala"
			_tmp20_ = row;
#line 181 "../src/db/TagTable.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_);
#line 167 "../src/db/TagTable.vala"
			_tag_row_unref0 (row);
#line 1690 "TagTable.c"
		}
	}
#line 184 "../src/db/TagTable.vala"
	result = rows;
#line 184 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 184 "../src/db/TagTable.vala"
	return result;
#line 1699 "TagTable.c"
}

void
tag_table_rename (TagTable* self,
                  TagID* tag_id,
                  const gchar* new_name,
                  GError** error)
{
	TagID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 187 "../src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 187 "../src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 187 "../src/db/TagTable.vala"
	g_return_if_fail (new_name != NULL);
#line 188 "../src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 188 "../src/db/TagTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "name", new_name, &_inner_error0_);
#line 188 "../src/db/TagTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/db/TagTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 188 "../src/db/TagTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 188 "../src/db/TagTable.vala"
			return;
#line 1728 "TagTable.c"
		} else {
#line 188 "../src/db/TagTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/db/TagTable.vala"
			g_clear_error (&_inner_error0_);
#line 188 "../src/db/TagTable.vala"
			return;
#line 1736 "TagTable.c"
		}
	}
}

void
tag_table_set_tagged_sources (TagTable* self,
                              TagID* tag_id,
                              GeeCollection* source_ids,
                              GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	TagID _tmp7_;
	sqlite3_stmt* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 191 "../src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 191 "../src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 191 "../src/db/TagTable.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source_ids, GEE_TYPE_COLLECTION));
#line 193 "../src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 193 "../src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE TagTable SET photo_id_list=? WHERE id=?", -1, &_tmp1_, NULL);
#line 193 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 193 "../src/db/TagTable.vala"
	stmt = _tmp1_;
#line 193 "../src/db/TagTable.vala"
	res = _tmp2_;
#line 194 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 196 "../src/db/TagTable.vala"
	_tmp3_ = stmt;
#line 196 "../src/db/TagTable.vala"
	_tmp4_ = tag_table_serialize_source_ids (self, source_ids);
#line 196 "../src/db/TagTable.vala"
	_tmp5_ = g_free;
#line 196 "../src/db/TagTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 197 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 198 "../src/db/TagTable.vala"
	_tmp6_ = stmt;
#line 198 "../src/db/TagTable.vala"
	_tmp7_ = *tag_id;
#line 198 "../src/db/TagTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, _tmp7_.id);
#line 199 "../src/db/TagTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 201 "../src/db/TagTable.vala"
	_tmp8_ = stmt;
#line 201 "../src/db/TagTable.vala"
	res = sqlite3_step (_tmp8_);
#line 202 "../src/db/TagTable.vala"
	if (res != SQLITE_DONE) {
#line 203 "../src/db/TagTable.vala"
		database_table_throw_error ("TagTable.set_tagged_photos", res, &_inner_error0_);
#line 203 "../src/db/TagTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/db/TagTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 203 "../src/db/TagTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 203 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 203 "../src/db/TagTable.vala"
				return;
#line 1813 "TagTable.c"
			} else {
#line 203 "../src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 203 "../src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/db/TagTable.vala"
				g_clear_error (&_inner_error0_);
#line 203 "../src/db/TagTable.vala"
				return;
#line 1823 "TagTable.c"
			}
		}
	}
#line 191 "../src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1829 "TagTable.c"
}

static gchar*
tag_table_serialize_source_ids (TagTable* self,
                                GeeCollection* source_ids)
{
	GString* _result_ = NULL;
	GString* _tmp0_;
	const gchar* _tmp8_ = NULL;
	GString* _tmp9_;
	gchar* _tmp12_;
	gchar* result;
#line 206 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 206 "../src/db/TagTable.vala"
	g_return_val_if_fail ((source_ids == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (source_ids, GEE_TYPE_COLLECTION), NULL);
#line 207 "../src/db/TagTable.vala"
	if (source_ids == NULL) {
#line 208 "../src/db/TagTable.vala"
		result = NULL;
#line 208 "../src/db/TagTable.vala"
		return result;
#line 1852 "TagTable.c"
	}
#line 210 "../src/db/TagTable.vala"
	_tmp0_ = g_string_new ("");
#line 210 "../src/db/TagTable.vala"
	_result_ = _tmp0_;
#line 1858 "TagTable.c"
	{
		GeeIterator* _source_id_it = NULL;
		GeeIterator* _tmp1_;
#line 212 "../src/db/TagTable.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (source_ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 212 "../src/db/TagTable.vala"
		_source_id_it = _tmp1_;
#line 212 "../src/db/TagTable.vala"
		while (TRUE) {
#line 1868 "TagTable.c"
			GeeIterator* _tmp2_;
			gchar* source_id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GString* _tmp5_;
			const gchar* _tmp6_;
			GString* _tmp7_;
#line 212 "../src/db/TagTable.vala"
			_tmp2_ = _source_id_it;
#line 212 "../src/db/TagTable.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 212 "../src/db/TagTable.vala"
				break;
#line 1882 "TagTable.c"
			}
#line 212 "../src/db/TagTable.vala"
			_tmp3_ = _source_id_it;
#line 212 "../src/db/TagTable.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 212 "../src/db/TagTable.vala"
			source_id = (gchar*) _tmp4_;
#line 213 "../src/db/TagTable.vala"
			_tmp5_ = _result_;
#line 213 "../src/db/TagTable.vala"
			_tmp6_ = source_id;
#line 213 "../src/db/TagTable.vala"
			g_string_append (_tmp5_, _tmp6_);
#line 214 "../src/db/TagTable.vala"
			_tmp7_ = _result_;
#line 214 "../src/db/TagTable.vala"
			g_string_append (_tmp7_, ",");
#line 212 "../src/db/TagTable.vala"
			_g_free0 (source_id);
#line 1902 "TagTable.c"
		}
#line 212 "../src/db/TagTable.vala"
		_g_object_unref0 (_source_id_it);
#line 1906 "TagTable.c"
	}
#line 217 "../src/db/TagTable.vala"
	_tmp9_ = _result_;
#line 217 "../src/db/TagTable.vala"
	if (_tmp9_->len != ((gssize) 0)) {
#line 1912 "TagTable.c"
		GString* _tmp10_;
		const gchar* _tmp11_;
#line 217 "../src/db/TagTable.vala"
		_tmp10_ = _result_;
#line 217 "../src/db/TagTable.vala"
		_tmp11_ = _tmp10_->str;
#line 217 "../src/db/TagTable.vala"
		_tmp8_ = _tmp11_;
#line 1921 "TagTable.c"
	} else {
#line 217 "../src/db/TagTable.vala"
		_tmp8_ = NULL;
#line 1925 "TagTable.c"
	}
#line 217 "../src/db/TagTable.vala"
	_tmp12_ = g_strdup (_tmp8_);
#line 217 "../src/db/TagTable.vala"
	result = _tmp12_;
#line 217 "../src/db/TagTable.vala"
	_g_string_free0 (_result_);
#line 217 "../src/db/TagTable.vala"
	return result;
#line 1935 "TagTable.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1952 "TagTable.c"
}

static GeeSet*
tag_table_unserialize_source_ids (TagTable* self,
                                  const gchar* text_list)
{
	GeeSet* _result_ = NULL;
	GeeHashSet* _tmp0_;
	gchar** split = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint split_length1;
	gint _split_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GeeSet* result;
#line 220 "../src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 221 "../src/db/TagTable.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 221 "../src/db/TagTable.vala"
	_result_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 223 "../src/db/TagTable.vala"
	if (text_list == NULL) {
#line 224 "../src/db/TagTable.vala"
		result = _result_;
#line 224 "../src/db/TagTable.vala"
		return result;
#line 1981 "TagTable.c"
	}
#line 226 "../src/db/TagTable.vala"
	_tmp2_ = _tmp1_ = g_strsplit (text_list, ",", 0);
#line 226 "../src/db/TagTable.vala"
	split = _tmp2_;
#line 226 "../src/db/TagTable.vala"
	split_length1 = _vala_array_length (_tmp1_);
#line 226 "../src/db/TagTable.vala"
	_split_size_ = split_length1;
#line 227 "../src/db/TagTable.vala"
	_tmp3_ = split;
#line 227 "../src/db/TagTable.vala"
	_tmp3__length1 = split_length1;
#line 1995 "TagTable.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 227 "../src/db/TagTable.vala"
		token_collection = _tmp3_;
#line 227 "../src/db/TagTable.vala"
		token_collection_length1 = _tmp3__length1;
#line 227 "../src/db/TagTable.vala"
		for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 2007 "TagTable.c"
			gchar* _tmp4_;
			gchar* token = NULL;
#line 227 "../src/db/TagTable.vala"
			_tmp4_ = g_strdup (token_collection[token_it]);
#line 227 "../src/db/TagTable.vala"
			token = _tmp4_;
#line 2014 "TagTable.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 228 "../src/db/TagTable.vala"
				_tmp5_ = token;
#line 228 "../src/db/TagTable.vala"
				if (is_string_empty (_tmp5_)) {
#line 229 "../src/db/TagTable.vala"
					_g_free0 (token);
#line 229 "../src/db/TagTable.vala"
					continue;
#line 2026 "TagTable.c"
				}
#line 236 "../src/db/TagTable.vala"
				_tmp6_ = token;
#line 236 "../src/db/TagTable.vala"
				if (g_ascii_isdigit (string_get (_tmp6_, (glong) 0))) {
#line 2032 "TagTable.c"
					GeeSet* _tmp7_;
					const gchar* _tmp8_;
					PhotoID _tmp9_ = {0};
					gchar* _tmp10_;
					gchar* _tmp11_;
#line 238 "../src/db/TagTable.vala"
					_tmp7_ = _result_;
#line 238 "../src/db/TagTable.vala"
					_tmp8_ = token;
#line 238 "../src/db/TagTable.vala"
					photo_id_init (&_tmp9_, parse_int64 (_tmp8_, 10));
#line 238 "../src/db/TagTable.vala"
					_tmp10_ = photo_id_upgrade_photo_id_to_source_id (&_tmp9_);
#line 238 "../src/db/TagTable.vala"
					_tmp11_ = _tmp10_;
#line 238 "../src/db/TagTable.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp11_);
#line 238 "../src/db/TagTable.vala"
					_g_free0 (_tmp11_);
#line 2052 "TagTable.c"
				} else {
					const gchar* _tmp12_;
#line 239 "../src/db/TagTable.vala"
					_tmp12_ = token;
#line 239 "../src/db/TagTable.vala"
					if (g_ascii_isalpha (string_get (_tmp12_, (glong) 0))) {
#line 2059 "TagTable.c"
						GeeSet* _tmp13_;
						const gchar* _tmp14_;
#line 241 "../src/db/TagTable.vala"
						_tmp13_ = _result_;
#line 241 "../src/db/TagTable.vala"
						_tmp14_ = token;
#line 241 "../src/db/TagTable.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection), _tmp14_);
#line 2068 "TagTable.c"
					}
				}
#line 227 "../src/db/TagTable.vala"
				_g_free0 (token);
#line 2073 "TagTable.c"
			}
		}
	}
#line 245 "../src/db/TagTable.vala"
	result = _result_;
#line 245 "../src/db/TagTable.vala"
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/db/TagTable.vala"
	return result;
#line 2083 "TagTable.c"
}

static void
tag_table_class_init (TagTableClass * klass,
                      gpointer klass_data)
{
#line 32 "../src/db/TagTable.vala"
	tag_table_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/db/TagTable.vala"
	((DatabaseTableClass *) klass)->finalize = tag_table_finalize;
#line 2094 "TagTable.c"
}

static void
tag_table_instance_init (TagTable * self,
                         gpointer klass)
{
}

static void
tag_table_finalize (DatabaseTable * obj)
{
	TagTable * self;
#line 32 "../src/db/TagTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAG_TABLE, TagTable);
#line 32 "../src/db/TagTable.vala"
	DATABASE_TABLE_CLASS (tag_table_parent_class)->finalize (obj);
#line 2111 "TagTable.c"
}

static GType
tag_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TagTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tag_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TagTable), 0, (GInstanceInitFunc) tag_table_instance_init, NULL };
	GType tag_table_type_id;
	tag_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TagTable", &g_define_type_info, 0);
	return tag_table_type_id;
}

GType
tag_table_get_type (void)
{
	static volatile gsize tag_table_type_id__once = 0;
	if (g_once_init_enter (&tag_table_type_id__once)) {
		GType tag_table_type_id;
		tag_table_type_id = tag_table_get_type_once ();
		g_once_init_leave (&tag_table_type_id__once, tag_table_type_id);
	}
	return tag_table_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

