/* TombstoneTable.c generated by valac 0.56.3, the Vala compiler
 * generated from TombstoneTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>

#define TOMBSTONE_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TOMBSTONE_ID (tombstone_id_get_type ())
typedef struct _TombstoneID TombstoneID;

#define TYPE_TOMBSTONE_ROW (tombstone_row_get_type ())
#define TOMBSTONE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_ROW, TombstoneRow))
#define TOMBSTONE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_ROW, TombstoneRowClass))
#define IS_TOMBSTONE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_ROW))
#define IS_TOMBSTONE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_ROW))
#define TOMBSTONE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_ROW, TombstoneRowClass))

typedef struct _TombstoneRow TombstoneRow;
typedef struct _TombstoneRowClass TombstoneRowClass;
typedef struct _TombstoneRowPrivate TombstoneRowPrivate;
typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecTombstoneRow ParamSpecTombstoneRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TOMBSTONE_TABLE (tombstone_table_get_type ())
#define TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTable))
#define TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))
#define IS_TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_TABLE))
#define IS_TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_TABLE))
#define TOMBSTONE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))

typedef struct _TombstoneTable TombstoneTable;
typedef struct _TombstoneTableClass TombstoneTableClass;
typedef struct _TombstoneTablePrivate TombstoneTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _tombstone_row_unref0(var) ((var == NULL) ? NULL : (var = (tombstone_row_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TombstoneID {
	gint64 id;
};

struct _TombstoneRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TombstoneRowPrivate * priv;
	TombstoneID id;
	gchar* filepath;
	gint64 filesize;
	gchar* md5;
	gint64 time_created;
	TombstoneReason reason;
};

struct _TombstoneRowClass {
	GTypeClass parent_class;
	void (*finalize) (TombstoneRow *self);
};

struct _ParamSpecTombstoneRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TombstoneTable {
	DatabaseTable parent_instance;
	TombstoneTablePrivate * priv;
};

struct _TombstoneTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer tombstone_row_parent_class = NULL;
static gpointer tombstone_table_parent_class = NULL;
static TombstoneTable* tombstone_table_instance;
static TombstoneTable* tombstone_table_instance = NULL;
VALA_EXTERN sqlite3* database_table_db;

VALA_EXTERN GType tombstone_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TombstoneID* tombstone_id_dup (const TombstoneID* self);
VALA_EXTERN void tombstone_id_free (TombstoneID* self);
VALA_EXTERN void tombstone_id_init (TombstoneID *self,
                        gint64 id);
VALA_EXTERN gboolean tombstone_id_is_invalid (TombstoneID *self);
VALA_EXTERN gboolean tombstone_id_is_valid (TombstoneID *self);
VALA_EXTERN gpointer tombstone_row_ref (gpointer instance);
VALA_EXTERN void tombstone_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_tombstone_row (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_tombstone_row (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_tombstone_row (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_tombstone_row (const GValue* value);
VALA_EXTERN GType tombstone_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TombstoneRow, tombstone_row_unref)
VALA_EXTERN GType tombstone_reason_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TombstoneRow* tombstone_row_new (void);
VALA_EXTERN TombstoneRow* tombstone_row_construct (GType object_type);
static void tombstone_row_finalize (TombstoneRow * obj);
static GType tombstone_row_get_type_once (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType tombstone_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TombstoneTable, database_table_unref)
static TombstoneTable* tombstone_table_new (void);
static TombstoneTable* tombstone_table_construct (GType object_type);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN TombstoneTable* tombstone_table_get_instance (void);
VALA_EXTERN GQuark database_error_quark (void);
GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TombstoneRow* tombstone_table_add (TombstoneTable* self,
                                   const gchar* filepath,
                                   gint64 filesize,
                                   const gchar* md5,
                                   TombstoneReason reason,
                                   GError** error);
VALA_EXTERN gint64 now_sec (void);
VALA_EXTERN gint tombstone_reason_serialize (TombstoneReason self);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN TombstoneRow** tombstone_table_fetch_all (TombstoneTable* self,
                                          gint* result_length1,
                                          GError** error);
VALA_EXTERN gint database_table_get_row_count (DatabaseTable* self);
VALA_EXTERN TombstoneReason tombstone_reason_unserialize (gint value);
VALA_EXTERN void tombstone_table_update_file (TombstoneTable* self,
                                  TombstoneID* tombstone_id,
                                  const gchar* filepath,
                                  GError** error);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN void tombstone_table_remove (TombstoneTable* self,
                             TombstoneID* tombstone_id,
                             GError** error);
VALA_EXTERN void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
static void tombstone_table_finalize (DatabaseTable * obj);
static GType tombstone_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
tombstone_id_init (TombstoneID *self,
                   gint64 id)
{
#line 12 "../src/db/TombstoneTable.vala"
	memset (self, 0, sizeof (TombstoneID));
#line 13 "../src/db/TombstoneTable.vala"
	(*self).id = id;
#line 244 "TombstoneTable.c"
}

gboolean
tombstone_id_is_invalid (TombstoneID *self)
{
	gboolean result;
#line 17 "../src/db/TombstoneTable.vala"
	result = (*self).id == TOMBSTONE_ID_INVALID;
#line 17 "../src/db/TombstoneTable.vala"
	return result;
#line 255 "TombstoneTable.c"
}

gboolean
tombstone_id_is_valid (TombstoneID *self)
{
	gboolean result;
#line 21 "../src/db/TombstoneTable.vala"
	result = (*self).id != TOMBSTONE_ID_INVALID;
#line 21 "../src/db/TombstoneTable.vala"
	return result;
#line 266 "TombstoneTable.c"
}

TombstoneID*
tombstone_id_dup (const TombstoneID* self)
{
	TombstoneID* dup;
#line 7 "../src/db/TombstoneTable.vala"
	dup = g_new0 (TombstoneID, 1);
#line 7 "../src/db/TombstoneTable.vala"
	memcpy (dup, self, sizeof (TombstoneID));
#line 7 "../src/db/TombstoneTable.vala"
	return dup;
#line 279 "TombstoneTable.c"
}

void
tombstone_id_free (TombstoneID* self)
{
#line 7 "../src/db/TombstoneTable.vala"
	g_free (self);
#line 287 "TombstoneTable.c"
}

static GType
tombstone_id_get_type_once (void)
{
	GType tombstone_id_type_id;
	tombstone_id_type_id = g_boxed_type_register_static ("TombstoneID", (GBoxedCopyFunc) tombstone_id_dup, (GBoxedFreeFunc) tombstone_id_free);
	return tombstone_id_type_id;
}

GType
tombstone_id_get_type (void)
{
	static volatile gsize tombstone_id_type_id__once = 0;
	if (g_once_init_enter (&tombstone_id_type_id__once)) {
		GType tombstone_id_type_id;
		tombstone_id_type_id = tombstone_id_get_type_once ();
		g_once_init_leave (&tombstone_id_type_id__once, tombstone_id_type_id);
	}
	return tombstone_id_type_id__once;
}

TombstoneRow*
tombstone_row_construct (GType object_type)
{
	TombstoneRow* self = NULL;
#line 25 "../src/db/TombstoneTable.vala"
	self = (TombstoneRow*) g_type_create_instance (object_type);
#line 25 "../src/db/TombstoneTable.vala"
	return self;
#line 318 "TombstoneTable.c"
}

TombstoneRow*
tombstone_row_new (void)
{
#line 25 "../src/db/TombstoneTable.vala"
	return tombstone_row_construct (TYPE_TOMBSTONE_ROW);
#line 326 "TombstoneTable.c"
}

static void
value_tombstone_row_init (GValue* value)
{
#line 25 "../src/db/TombstoneTable.vala"
	value->data[0].v_pointer = NULL;
#line 334 "TombstoneTable.c"
}

static void
value_tombstone_row_free_value (GValue* value)
{
#line 25 "../src/db/TombstoneTable.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/db/TombstoneTable.vala"
		tombstone_row_unref (value->data[0].v_pointer);
#line 344 "TombstoneTable.c"
	}
}

static void
value_tombstone_row_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 25 "../src/db/TombstoneTable.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/db/TombstoneTable.vala"
		dest_value->data[0].v_pointer = tombstone_row_ref (src_value->data[0].v_pointer);
#line 356 "TombstoneTable.c"
	} else {
#line 25 "../src/db/TombstoneTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 360 "TombstoneTable.c"
	}
}

static gpointer
value_tombstone_row_peek_pointer (const GValue* value)
{
#line 25 "../src/db/TombstoneTable.vala"
	return value->data[0].v_pointer;
#line 369 "TombstoneTable.c"
}

static gchar*
value_tombstone_row_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 25 "../src/db/TombstoneTable.vala"
	if (collect_values[0].v_pointer) {
#line 380 "TombstoneTable.c"
		TombstoneRow * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/db/TombstoneTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/db/TombstoneTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 387 "TombstoneTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/db/TombstoneTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 391 "TombstoneTable.c"
		}
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = tombstone_row_ref (object);
#line 395 "TombstoneTable.c"
	} else {
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 399 "TombstoneTable.c"
	}
#line 25 "../src/db/TombstoneTable.vala"
	return NULL;
#line 403 "TombstoneTable.c"
}

static gchar*
value_tombstone_row_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	TombstoneRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/db/TombstoneTable.vala"
	if (!object_p) {
#line 25 "../src/db/TombstoneTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 418 "TombstoneTable.c"
	}
#line 25 "../src/db/TombstoneTable.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/db/TombstoneTable.vala"
		*object_p = NULL;
#line 424 "TombstoneTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/db/TombstoneTable.vala"
		*object_p = value->data[0].v_pointer;
#line 428 "TombstoneTable.c"
	} else {
#line 25 "../src/db/TombstoneTable.vala"
		*object_p = tombstone_row_ref (value->data[0].v_pointer);
#line 432 "TombstoneTable.c"
	}
#line 25 "../src/db/TombstoneTable.vala"
	return NULL;
#line 436 "TombstoneTable.c"
}

GParamSpec*
param_spec_tombstone_row (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecTombstoneRow* spec;
#line 25 "../src/db/TombstoneTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TOMBSTONE_ROW), NULL);
#line 25 "../src/db/TombstoneTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/db/TombstoneTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/db/TombstoneTable.vala"
	return G_PARAM_SPEC (spec);
#line 455 "TombstoneTable.c"
}

gpointer
value_get_tombstone_row (const GValue* value)
{
#line 25 "../src/db/TombstoneTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW), NULL);
#line 25 "../src/db/TombstoneTable.vala"
	return value->data[0].v_pointer;
#line 465 "TombstoneTable.c"
}

void
value_set_tombstone_row (GValue* value,
                         gpointer v_object)
{
	TombstoneRow * old;
#line 25 "../src/db/TombstoneTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW));
#line 25 "../src/db/TombstoneTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/TombstoneTable.vala"
	if (v_object) {
#line 25 "../src/db/TombstoneTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TOMBSTONE_ROW));
#line 25 "../src/db/TombstoneTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/db/TombstoneTable.vala"
		tombstone_row_ref (value->data[0].v_pointer);
#line 487 "TombstoneTable.c"
	} else {
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 491 "TombstoneTable.c"
	}
#line 25 "../src/db/TombstoneTable.vala"
	if (old) {
#line 25 "../src/db/TombstoneTable.vala"
		tombstone_row_unref (old);
#line 497 "TombstoneTable.c"
	}
}

void
value_take_tombstone_row (GValue* value,
                          gpointer v_object)
{
	TombstoneRow * old;
#line 25 "../src/db/TombstoneTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW));
#line 25 "../src/db/TombstoneTable.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/db/TombstoneTable.vala"
	if (v_object) {
#line 25 "../src/db/TombstoneTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TOMBSTONE_ROW));
#line 25 "../src/db/TombstoneTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = v_object;
#line 518 "TombstoneTable.c"
	} else {
#line 25 "../src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 522 "TombstoneTable.c"
	}
#line 25 "../src/db/TombstoneTable.vala"
	if (old) {
#line 25 "../src/db/TombstoneTable.vala"
		tombstone_row_unref (old);
#line 528 "TombstoneTable.c"
	}
}

static void
tombstone_row_class_init (TombstoneRowClass * klass,
                          gpointer klass_data)
{
#line 25 "../src/db/TombstoneTable.vala"
	tombstone_row_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/db/TombstoneTable.vala"
	((TombstoneRowClass *) klass)->finalize = tombstone_row_finalize;
#line 540 "TombstoneTable.c"
}

static void
tombstone_row_instance_init (TombstoneRow * self,
                             gpointer klass)
{
#line 25 "../src/db/TombstoneTable.vala"
	self->ref_count = 1;
#line 549 "TombstoneTable.c"
}

static void
tombstone_row_finalize (TombstoneRow * obj)
{
	TombstoneRow * self;
#line 25 "../src/db/TombstoneTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOMBSTONE_ROW, TombstoneRow);
#line 25 "../src/db/TombstoneTable.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/db/TombstoneTable.vala"
	_g_free0 (self->filepath);
#line 29 "../src/db/TombstoneTable.vala"
	_g_free0 (self->md5);
#line 564 "TombstoneTable.c"
}

static GType
tombstone_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_tombstone_row_init, value_tombstone_row_free_value, value_tombstone_row_copy_value, value_tombstone_row_peek_pointer, "p", value_tombstone_row_collect_value, "p", value_tombstone_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TombstoneRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneRow), 0, (GInstanceInitFunc) tombstone_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tombstone_row_type_id;
	tombstone_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TombstoneRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return tombstone_row_type_id;
}

GType
tombstone_row_get_type (void)
{
	static volatile gsize tombstone_row_type_id__once = 0;
	if (g_once_init_enter (&tombstone_row_type_id__once)) {
		GType tombstone_row_type_id;
		tombstone_row_type_id = tombstone_row_get_type_once ();
		g_once_init_leave (&tombstone_row_type_id__once, tombstone_row_type_id);
	}
	return tombstone_row_type_id__once;
}

gpointer
tombstone_row_ref (gpointer instance)
{
	TombstoneRow * self;
	self = instance;
#line 25 "../src/db/TombstoneTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/db/TombstoneTable.vala"
	return instance;
#line 599 "TombstoneTable.c"
}

void
tombstone_row_unref (gpointer instance)
{
	TombstoneRow * self;
	self = instance;
#line 25 "../src/db/TombstoneTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/db/TombstoneTable.vala"
		TOMBSTONE_ROW_GET_CLASS (self)->finalize (self);
#line 25 "../src/db/TombstoneTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 613 "TombstoneTable.c"
	}
}

static TombstoneTable*
tombstone_table_construct (GType object_type)
{
	TombstoneTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 37 "../src/db/TombstoneTable.vala"
	self = (TombstoneTable*) database_table_construct (object_type);
#line 38 "../src/db/TombstoneTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "TombstoneTable");
#line 41 "../src/db/TombstoneTable.vala"
	_tmp0_ = database_table_db;
#line 41 "../src/db/TombstoneTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "TombstoneTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT NOT NULL, " "filesize INTEGER, " "md5 TEXT, " "time_created INTEGER, " "reason INTEGER DEFAULT 0 " ")", -1, &_tmp1_, NULL);
#line 41 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 41 "../src/db/TombstoneTable.vala"
	stmt = _tmp1_;
#line 41 "../src/db/TombstoneTable.vala"
	res = _tmp2_;
#line 51 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 53 "../src/db/TombstoneTable.vala"
	_tmp3_ = stmt;
#line 53 "../src/db/TombstoneTable.vala"
	res = sqlite3_step (_tmp3_);
#line 54 "../src/db/TombstoneTable.vala"
	if (res != SQLITE_DONE) {
#line 55 "../src/db/TombstoneTable.vala"
		database_table_fatal ("create TombstoneTable", res);
#line 651 "TombstoneTable.c"
	}
#line 37 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 37 "../src/db/TombstoneTable.vala"
	return self;
#line 657 "TombstoneTable.c"
}

static TombstoneTable*
tombstone_table_new (void)
{
#line 37 "../src/db/TombstoneTable.vala"
	return tombstone_table_construct (TYPE_TOMBSTONE_TABLE);
#line 665 "TombstoneTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 62 "../src/db/TombstoneTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 673 "TombstoneTable.c"
}

TombstoneTable*
tombstone_table_get_instance (void)
{
	TombstoneTable* _tmp0_;
	TombstoneTable* _tmp2_;
	TombstoneTable* _tmp3_;
	TombstoneTable* result;
#line 59 "../src/db/TombstoneTable.vala"
	_tmp0_ = tombstone_table_instance;
#line 59 "../src/db/TombstoneTable.vala"
	if (_tmp0_ == NULL) {
#line 687 "TombstoneTable.c"
		TombstoneTable* _tmp1_;
#line 60 "../src/db/TombstoneTable.vala"
		_tmp1_ = tombstone_table_new ();
#line 60 "../src/db/TombstoneTable.vala"
		_database_table_unref0 (tombstone_table_instance);
#line 60 "../src/db/TombstoneTable.vala"
		tombstone_table_instance = _tmp1_;
#line 695 "TombstoneTable.c"
	}
#line 62 "../src/db/TombstoneTable.vala"
	_tmp2_ = tombstone_table_instance;
#line 62 "../src/db/TombstoneTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 62 "../src/db/TombstoneTable.vala"
	result = _tmp3_;
#line 62 "../src/db/TombstoneTable.vala"
	return result;
#line 705 "TombstoneTable.c"
}

TombstoneRow*
tombstone_table_add (TombstoneTable* self,
                     const gchar* filepath,
                     gint64 filesize,
                     const gchar* md5,
                     TombstoneReason reason,
                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	gchar* _tmp8_;
	GDestroyNotify _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	TombstoneRow* row = NULL;
	TombstoneRow* _tmp13_;
	TombstoneRow* _tmp14_;
	sqlite3* _tmp15_;
	TombstoneRow* _tmp16_;
	gchar* _tmp17_;
	TombstoneRow* _tmp18_;
	TombstoneRow* _tmp19_;
	gchar* _tmp20_;
	TombstoneRow* _tmp21_;
	TombstoneRow* _tmp22_;
	GError* _inner_error0_ = NULL;
	TombstoneRow* result;
#line 65 "../src/db/TombstoneTable.vala"
	g_return_val_if_fail (IS_TOMBSTONE_TABLE (self), NULL);
#line 65 "../src/db/TombstoneTable.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 68 "../src/db/TombstoneTable.vala"
	_tmp0_ = database_table_db;
#line 68 "../src/db/TombstoneTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TombstoneTable " "(filepath, filesize, md5, time_created, reason) " "VALUES (?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 68 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 68 "../src/db/TombstoneTable.vala"
	stmt = _tmp1_;
#line 68 "../src/db/TombstoneTable.vala"
	res = _tmp2_;
#line 72 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 74 "../src/db/TombstoneTable.vala"
	time_created = now_sec ();
#line 76 "../src/db/TombstoneTable.vala"
	_tmp3_ = stmt;
#line 76 "../src/db/TombstoneTable.vala"
	_tmp4_ = g_strdup (filepath);
#line 76 "../src/db/TombstoneTable.vala"
	_tmp5_ = g_free;
#line 76 "../src/db/TombstoneTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 77 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 78 "../src/db/TombstoneTable.vala"
	_tmp6_ = stmt;
#line 78 "../src/db/TombstoneTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 2, filesize);
#line 79 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 80 "../src/db/TombstoneTable.vala"
	_tmp7_ = stmt;
#line 80 "../src/db/TombstoneTable.vala"
	_tmp8_ = g_strdup (md5);
#line 80 "../src/db/TombstoneTable.vala"
	_tmp9_ = g_free;
#line 80 "../src/db/TombstoneTable.vala"
	res = sqlite3_bind_text (_tmp7_, 3, _tmp8_, -1, _tmp9_);
#line 81 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 82 "../src/db/TombstoneTable.vala"
	_tmp10_ = stmt;
#line 82 "../src/db/TombstoneTable.vala"
	res = sqlite3_bind_int64 (_tmp10_, 4, (gint64) time_created);
#line 83 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 84 "../src/db/TombstoneTable.vala"
	_tmp11_ = stmt;
#line 84 "../src/db/TombstoneTable.vala"
	res = sqlite3_bind_int (_tmp11_, 5, tombstone_reason_serialize (reason));
#line 85 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 87 "../src/db/TombstoneTable.vala"
	_tmp12_ = stmt;
#line 87 "../src/db/TombstoneTable.vala"
	res = sqlite3_step (_tmp12_);
#line 88 "../src/db/TombstoneTable.vala"
	if (res != SQLITE_DONE) {
#line 89 "../src/db/TombstoneTable.vala"
		database_table_throw_error ("TombstoneTable.add", res, &_inner_error0_);
#line 89 "../src/db/TombstoneTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/db/TombstoneTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 89 "../src/db/TombstoneTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 89 "../src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 89 "../src/db/TombstoneTable.vala"
				return NULL;
#line 819 "TombstoneTable.c"
			} else {
#line 89 "../src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 89 "../src/db/TombstoneTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 89 "../src/db/TombstoneTable.vala"
				g_clear_error (&_inner_error0_);
#line 89 "../src/db/TombstoneTable.vala"
				return NULL;
#line 829 "TombstoneTable.c"
			}
		}
	}
#line 91 "../src/db/TombstoneTable.vala"
	_tmp13_ = tombstone_row_new ();
#line 91 "../src/db/TombstoneTable.vala"
	row = _tmp13_;
#line 92 "../src/db/TombstoneTable.vala"
	_tmp14_ = row;
#line 92 "../src/db/TombstoneTable.vala"
	_tmp15_ = database_table_db;
#line 92 "../src/db/TombstoneTable.vala"
	tombstone_id_init (&_tmp14_->id, sqlite3_last_insert_rowid (_tmp15_));
#line 93 "../src/db/TombstoneTable.vala"
	_tmp16_ = row;
#line 93 "../src/db/TombstoneTable.vala"
	_tmp17_ = g_strdup (filepath);
#line 93 "../src/db/TombstoneTable.vala"
	_g_free0 (_tmp16_->filepath);
#line 93 "../src/db/TombstoneTable.vala"
	_tmp16_->filepath = _tmp17_;
#line 94 "../src/db/TombstoneTable.vala"
	_tmp18_ = row;
#line 94 "../src/db/TombstoneTable.vala"
	_tmp18_->filesize = filesize;
#line 95 "../src/db/TombstoneTable.vala"
	_tmp19_ = row;
#line 95 "../src/db/TombstoneTable.vala"
	_tmp20_ = g_strdup (md5);
#line 95 "../src/db/TombstoneTable.vala"
	_g_free0 (_tmp19_->md5);
#line 95 "../src/db/TombstoneTable.vala"
	_tmp19_->md5 = _tmp20_;
#line 96 "../src/db/TombstoneTable.vala"
	_tmp21_ = row;
#line 96 "../src/db/TombstoneTable.vala"
	_tmp21_->time_created = time_created;
#line 97 "../src/db/TombstoneTable.vala"
	_tmp22_ = row;
#line 97 "../src/db/TombstoneTable.vala"
	_tmp22_->reason = reason;
#line 99 "../src/db/TombstoneTable.vala"
	result = row;
#line 99 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 99 "../src/db/TombstoneTable.vala"
	return result;
#line 877 "TombstoneTable.c"
}

static gpointer
_tombstone_row_ref0 (gpointer self)
{
#line 130 "../src/db/TombstoneTable.vala"
	return self ? tombstone_row_ref (self) : NULL;
#line 885 "TombstoneTable.c"
}

TombstoneRow**
tombstone_table_fetch_all (TombstoneTable* self,
                           gint* result_length1,
                           GError** error)
{
	gint row_count = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	TombstoneRow** rows = NULL;
	TombstoneRow** _tmp4_;
	gint rows_length1;
	gint _rows_size_;
	gint index = 0;
	TombstoneRow** _tmp28_;
	gint _tmp28__length1;
	GError* _inner_error0_ = NULL;
	TombstoneRow** result;
#line 102 "../src/db/TombstoneTable.vala"
	g_return_val_if_fail (IS_TOMBSTONE_TABLE (self), NULL);
#line 103 "../src/db/TombstoneTable.vala"
	row_count = database_table_get_row_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable));
#line 104 "../src/db/TombstoneTable.vala"
	if (row_count == 0) {
#line 914 "TombstoneTable.c"
		TombstoneRow** _tmp0_;
		gint _tmp0__length1;
#line 105 "../src/db/TombstoneTable.vala"
		_tmp0_ = NULL;
#line 105 "../src/db/TombstoneTable.vala"
		_tmp0__length1 = 0;
#line 105 "../src/db/TombstoneTable.vala"
		if (result_length1) {
#line 105 "../src/db/TombstoneTable.vala"
			*result_length1 = _tmp0__length1;
#line 925 "TombstoneTable.c"
		}
#line 105 "../src/db/TombstoneTable.vala"
		result = _tmp0_;
#line 105 "../src/db/TombstoneTable.vala"
		return result;
#line 931 "TombstoneTable.c"
	}
#line 108 "../src/db/TombstoneTable.vala"
	_tmp1_ = database_table_db;
#line 108 "../src/db/TombstoneTable.vala"
	_tmp3_ = sqlite3_prepare_v2 (_tmp1_, "SELECT id, filepath, filesize, md5, time_created, reason " "FROM TombstoneTable", -1, &_tmp2_, NULL);
#line 108 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 108 "../src/db/TombstoneTable.vala"
	stmt = _tmp2_;
#line 108 "../src/db/TombstoneTable.vala"
	res = _tmp3_;
#line 110 "../src/db/TombstoneTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 112 "../src/db/TombstoneTable.vala"
	_tmp4_ = g_new0 (TombstoneRow*, row_count + 1);
#line 112 "../src/db/TombstoneTable.vala"
	rows = _tmp4_;
#line 112 "../src/db/TombstoneTable.vala"
	rows_length1 = row_count;
#line 112 "../src/db/TombstoneTable.vala"
	_rows_size_ = rows_length1;
#line 114 "../src/db/TombstoneTable.vala"
	index = 0;
#line 955 "TombstoneTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 115 "../src/db/TombstoneTable.vala"
		_tmp5_ = TRUE;
#line 115 "../src/db/TombstoneTable.vala"
		while (TRUE) {
#line 962 "TombstoneTable.c"
			sqlite3_stmt* _tmp6_;
			TombstoneRow* row = NULL;
			TombstoneRow* _tmp7_;
			TombstoneRow* _tmp8_;
			sqlite3_stmt* _tmp9_;
			TombstoneRow* _tmp10_;
			sqlite3_stmt* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			TombstoneRow* _tmp14_;
			sqlite3_stmt* _tmp15_;
			TombstoneRow* _tmp16_;
			sqlite3_stmt* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			TombstoneRow* _tmp20_;
			sqlite3_stmt* _tmp21_;
			TombstoneRow* _tmp22_;
			sqlite3_stmt* _tmp23_;
			TombstoneRow** _tmp24_;
			gint _tmp24__length1;
			gint _tmp25_;
			TombstoneRow* _tmp26_;
			TombstoneRow* _tmp27_;
#line 115 "../src/db/TombstoneTable.vala"
			if (!_tmp5_) {
#line 989 "TombstoneTable.c"
			}
#line 115 "../src/db/TombstoneTable.vala"
			_tmp5_ = FALSE;
#line 116 "../src/db/TombstoneTable.vala"
			_tmp6_ = stmt;
#line 116 "../src/db/TombstoneTable.vala"
			res = sqlite3_step (_tmp6_);
#line 117 "../src/db/TombstoneTable.vala"
			if (res == SQLITE_DONE) {
#line 118 "../src/db/TombstoneTable.vala"
				break;
#line 1001 "TombstoneTable.c"
			} else {
#line 119 "../src/db/TombstoneTable.vala"
				if (res != SQLITE_ROW) {
#line 120 "../src/db/TombstoneTable.vala"
					database_table_throw_error ("TombstoneTable.fetch_all", res, &_inner_error0_);
#line 120 "../src/db/TombstoneTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/db/TombstoneTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 120 "../src/db/TombstoneTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 120 "../src/db/TombstoneTable.vala"
							rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) tombstone_row_unref), NULL);
#line 120 "../src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 120 "../src/db/TombstoneTable.vala"
							return NULL;
#line 1019 "TombstoneTable.c"
						} else {
#line 120 "../src/db/TombstoneTable.vala"
							rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) tombstone_row_unref), NULL);
#line 120 "../src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 120 "../src/db/TombstoneTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/db/TombstoneTable.vala"
							g_clear_error (&_inner_error0_);
#line 120 "../src/db/TombstoneTable.vala"
							return NULL;
#line 1031 "TombstoneTable.c"
						}
					}
				}
			}
#line 122 "../src/db/TombstoneTable.vala"
			_tmp7_ = tombstone_row_new ();
#line 122 "../src/db/TombstoneTable.vala"
			row = _tmp7_;
#line 123 "../src/db/TombstoneTable.vala"
			_tmp8_ = row;
#line 123 "../src/db/TombstoneTable.vala"
			_tmp9_ = stmt;
#line 123 "../src/db/TombstoneTable.vala"
			tombstone_id_init (&_tmp8_->id, sqlite3_column_int64 (_tmp9_, 0));
#line 124 "../src/db/TombstoneTable.vala"
			_tmp10_ = row;
#line 124 "../src/db/TombstoneTable.vala"
			_tmp11_ = stmt;
#line 124 "../src/db/TombstoneTable.vala"
			_tmp12_ = (const gchar*) sqlite3_column_text (_tmp11_, 1);
#line 124 "../src/db/TombstoneTable.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 124 "../src/db/TombstoneTable.vala"
			_g_free0 (_tmp10_->filepath);
#line 124 "../src/db/TombstoneTable.vala"
			_tmp10_->filepath = _tmp13_;
#line 125 "../src/db/TombstoneTable.vala"
			_tmp14_ = row;
#line 125 "../src/db/TombstoneTable.vala"
			_tmp15_ = stmt;
#line 125 "../src/db/TombstoneTable.vala"
			_tmp14_->filesize = sqlite3_column_int64 (_tmp15_, 2);
#line 126 "../src/db/TombstoneTable.vala"
			_tmp16_ = row;
#line 126 "../src/db/TombstoneTable.vala"
			_tmp17_ = stmt;
#line 126 "../src/db/TombstoneTable.vala"
			_tmp18_ = (const gchar*) sqlite3_column_text (_tmp17_, 3);
#line 126 "../src/db/TombstoneTable.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 126 "../src/db/TombstoneTable.vala"
			_g_free0 (_tmp16_->md5);
#line 126 "../src/db/TombstoneTable.vala"
			_tmp16_->md5 = _tmp19_;
#line 127 "../src/db/TombstoneTable.vala"
			_tmp20_ = row;
#line 127 "../src/db/TombstoneTable.vala"
			_tmp21_ = stmt;
#line 127 "../src/db/TombstoneTable.vala"
			_tmp20_->time_created = sqlite3_column_int64 (_tmp21_, 4);
#line 128 "../src/db/TombstoneTable.vala"
			_tmp22_ = row;
#line 128 "../src/db/TombstoneTable.vala"
			_tmp23_ = stmt;
#line 128 "../src/db/TombstoneTable.vala"
			_tmp22_->reason = tombstone_reason_unserialize (sqlite3_column_int (_tmp23_, 5));
#line 130 "../src/db/TombstoneTable.vala"
			_tmp24_ = rows;
#line 130 "../src/db/TombstoneTable.vala"
			_tmp24__length1 = rows_length1;
#line 130 "../src/db/TombstoneTable.vala"
			_tmp25_ = index;
#line 130 "../src/db/TombstoneTable.vala"
			index = _tmp25_ + 1;
#line 130 "../src/db/TombstoneTable.vala"
			_tmp26_ = row;
#line 130 "../src/db/TombstoneTable.vala"
			_tmp27_ = _tombstone_row_ref0 (_tmp26_);
#line 130 "../src/db/TombstoneTable.vala"
			_tombstone_row_unref0 (_tmp24_[_tmp25_]);
#line 130 "../src/db/TombstoneTable.vala"
			_tmp24_[_tmp25_] = _tmp27_;
#line 115 "../src/db/TombstoneTable.vala"
			_tombstone_row_unref0 (row);
#line 1106 "TombstoneTable.c"
		}
	}
#line 133 "../src/db/TombstoneTable.vala"
	_vala_assert (index == row_count, "index == row_count");
#line 135 "../src/db/TombstoneTable.vala"
	_tmp28_ = rows;
#line 135 "../src/db/TombstoneTable.vala"
	_tmp28__length1 = rows_length1;
#line 135 "../src/db/TombstoneTable.vala"
	if (result_length1) {
#line 135 "../src/db/TombstoneTable.vala"
		*result_length1 = _tmp28__length1;
#line 1119 "TombstoneTable.c"
	}
#line 135 "../src/db/TombstoneTable.vala"
	result = _tmp28_;
#line 135 "../src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 135 "../src/db/TombstoneTable.vala"
	return result;
#line 1127 "TombstoneTable.c"
}

void
tombstone_table_update_file (TombstoneTable* self,
                             TombstoneID* tombstone_id,
                             const gchar* filepath,
                             GError** error)
{
	TombstoneID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 138 "../src/db/TombstoneTable.vala"
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
#line 138 "../src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 138 "../src/db/TombstoneTable.vala"
	g_return_if_fail (filepath != NULL);
#line 139 "../src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 139 "../src/db/TombstoneTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filepath", filepath, &_inner_error0_);
#line 139 "../src/db/TombstoneTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/db/TombstoneTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 139 "../src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 139 "../src/db/TombstoneTable.vala"
			return;
#line 1156 "TombstoneTable.c"
		} else {
#line 139 "../src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error0_);
#line 139 "../src/db/TombstoneTable.vala"
			return;
#line 1164 "TombstoneTable.c"
		}
	}
}

void
tombstone_table_remove (TombstoneTable* self,
                        TombstoneID* tombstone_id,
                        GError** error)
{
	TombstoneID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 142 "../src/db/TombstoneTable.vala"
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
#line 142 "../src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 143 "../src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 143 "../src/db/TombstoneTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 143 "../src/db/TombstoneTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../src/db/TombstoneTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 143 "../src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 143 "../src/db/TombstoneTable.vala"
			return;
#line 1192 "TombstoneTable.c"
		} else {
#line 143 "../src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error0_);
#line 143 "../src/db/TombstoneTable.vala"
			return;
#line 1200 "TombstoneTable.c"
		}
	}
}

static void
tombstone_table_class_init (TombstoneTableClass * klass,
                            gpointer klass_data)
{
#line 34 "../src/db/TombstoneTable.vala"
	tombstone_table_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/db/TombstoneTable.vala"
	((DatabaseTableClass *) klass)->finalize = tombstone_table_finalize;
#line 1213 "TombstoneTable.c"
}

static void
tombstone_table_instance_init (TombstoneTable * self,
                               gpointer klass)
{
}

static void
tombstone_table_finalize (DatabaseTable * obj)
{
	TombstoneTable * self;
#line 34 "../src/db/TombstoneTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOMBSTONE_TABLE, TombstoneTable);
#line 34 "../src/db/TombstoneTable.vala"
	DATABASE_TABLE_CLASS (tombstone_table_parent_class)->finalize (obj);
#line 1230 "TombstoneTable.c"
}

static GType
tombstone_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TombstoneTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneTable), 0, (GInstanceInitFunc) tombstone_table_instance_init, NULL };
	GType tombstone_table_type_id;
	tombstone_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TombstoneTable", &g_define_type_info, 0);
	return tombstone_table_type_id;
}

GType
tombstone_table_get_type (void)
{
	static volatile gsize tombstone_table_type_id__once = 0;
	if (g_once_init_enter (&tombstone_table_type_id__once)) {
		GType tombstone_table_type_id;
		tombstone_table_type_id = tombstone_table_get_type_once ();
		g_once_init_leave (&tombstone_table_type_id__once, tombstone_table_type_id);
	}
	return tombstone_table_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

