/* VideoTable.c generated by valac 0.56.3, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>

#define VIDEO_ID_INVALID ((gint64) -1)
#define VIDEO_TYPENAME "video"
#define EVENT_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _ParamSpecVideoRow ParamSpecVideoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	GDateTime* exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	gint64 time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	gint64 time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_row_parent_class = NULL;
static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
VALA_EXTERN sqlite3* database_table_db;

VALA_EXTERN GType video_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoID* video_id_dup (const VideoID* self);
VALA_EXTERN void video_id_free (VideoID* self);
VALA_EXTERN void video_id_init (VideoID *self,
                    gint64 id);
VALA_EXTERN gboolean video_id_is_invalid (VideoID *self);
VALA_EXTERN gboolean video_id_is_valid (VideoID *self);
VALA_EXTERN guint video_id_hash (VideoID* a);
VALA_EXTERN guint int64_hash (gint64* n);
VALA_EXTERN gboolean video_id_equal (void* a,
                         void* b);
VALA_EXTERN gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
VALA_EXTERN gpointer video_row_ref (gpointer instance);
VALA_EXTERN void video_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_video_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_video_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_video_row (const GValue* value);
VALA_EXTERN GType video_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN GType event_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EventID* event_id_dup (const EventID* self);
VALA_EXTERN void event_id_free (EventID* self);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoRow* video_row_new (void);
VALA_EXTERN VideoRow* video_row_construct (GType object_type);
static void video_row_finalize (VideoRow * obj);
static GType video_row_get_type_once (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType video_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoTable, database_table_unref)
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN VideoTable* video_table_get_instance (void);
VALA_EXTERN GQuark database_error_quark (void);
GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void video_table_add (VideoTable* self,
                      VideoRow* video_row,
                      VideoID* result,
                      GError** error);
VALA_EXTERN gint64 now_sec (void);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN void event_id_init (EventID *self,
                    gint64 id);
VALA_EXTERN gboolean video_table_drop_event (VideoTable* self,
                                 EventID* event_id);
VALA_EXTERN VideoRow* video_table_get_row (VideoTable* self,
                               VideoID* video_id);
VALA_EXTERN Rating rating_unserialize (gint value);
VALA_EXTERN GeeArrayList* video_table_get_all (VideoTable* self);
VALA_EXTERN void video_table_set_filepath (VideoTable* self,
                               VideoID* video_id,
                               const gchar* filepath,
                               GError** error);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN void video_table_set_title (VideoTable* self,
                            VideoID* video_id,
                            const gchar* new_title,
                            GError** error);
VALA_EXTERN void video_table_set_comment (VideoTable* self,
                              VideoID* video_id,
                              const gchar* new_comment,
                              GError** error);
VALA_EXTERN void video_table_set_exposure_time (VideoTable* self,
                                    VideoID* video_id,
                                    GDateTime* time,
                                    GError** error);
VALA_EXTERN void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
VALA_EXTERN void video_table_set_rating (VideoTable* self,
                             VideoID* video_id,
                             Rating rating,
                             GError** error);
VALA_EXTERN gint rating_serialize (Rating self);
VALA_EXTERN void video_table_set_flags (VideoTable* self,
                            VideoID* video_id,
                            guint64 flags,
                            GError** error);
VALA_EXTERN void video_table_update_backlinks (VideoTable* self,
                                   VideoID* video_id,
                                   const gchar* backlinks,
                                   GError** error);
VALA_EXTERN void video_table_update_is_interpretable (VideoTable* self,
                                          VideoID* video_id,
                                          gboolean is_interpretable,
                                          GError** error);
VALA_EXTERN void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
VALA_EXTERN gboolean video_table_set_event (VideoTable* self,
                                VideoID* video_id,
                                EventID* event_id);
VALA_EXTERN gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
VALA_EXTERN void video_table_remove_by_file (VideoTable* self,
                                 GFile* file,
                                 GError** error);
VALA_EXTERN void video_table_remove (VideoTable* self,
                         VideoID* videoID,
                         GError** error);
VALA_EXTERN gboolean video_table_is_video_stored (VideoTable* self,
                                      GFile* file);
VALA_EXTERN void video_table_get_id (VideoTable* self,
                         GFile* file,
                         VideoID* result);
VALA_EXTERN GeeArrayList* video_table_get_videos (VideoTable* self,
                                      GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self,
                                              GFile* file,
                                              const gchar* md5);
VALA_EXTERN gboolean video_table_has_duplicate (VideoTable* self,
                                    GFile* file,
                                    const gchar* md5);
VALA_EXTERN VideoID* video_table_get_duplicate_ids (VideoTable* self,
                                        GFile* file,
                                        const gchar* md5,
                                        gint* result_length1);
static void _vala_array_add4 (VideoID* * array,
                       gint* length,
                       gint* size,
                       const VideoID* value);
VALA_EXTERN GeeArrayList* video_table_get_event_source_ids (VideoTable* self,
                                                EventID* event_id);
VALA_EXTERN void video_table_set_timestamp (VideoTable* self,
                                VideoID* video_id,
                                GDateTime* timestamp,
                                GError** error);
VALA_EXTERN void video_table_upgrade_for_unset_timestamp (GError** error);
static void video_table_finalize (DatabaseTable * obj);
static GType video_table_get_type_once (void);

void
video_id_init (VideoID *self,
               gint64 id)
{
#line 12 "../src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 13 "../src/db/VideoTable.vala"
	(*self).id = id;
#line 363 "VideoTable.c"
}

gboolean
video_id_is_invalid (VideoID *self)
{
	gboolean result;
#line 17 "../src/db/VideoTable.vala"
	result = (*self).id == VIDEO_ID_INVALID;
#line 17 "../src/db/VideoTable.vala"
	return result;
#line 374 "VideoTable.c"
}

gboolean
video_id_is_valid (VideoID *self)
{
	gboolean result;
#line 21 "../src/db/VideoTable.vala"
	result = (*self).id != VIDEO_ID_INVALID;
#line 21 "../src/db/VideoTable.vala"
	return result;
#line 385 "VideoTable.c"
}

guint
video_id_hash (VideoID* a)
{
	guint result;
#line 25 "../src/db/VideoTable.vala"
	result = int64_hash (&(*a).id);
#line 25 "../src/db/VideoTable.vala"
	return result;
#line 396 "VideoTable.c"
}

gboolean
video_id_equal (void* a,
                void* b)
{
	gboolean result;
#line 29 "../src/db/VideoTable.vala"
	result = (*((VideoID*) a)).id == (*((VideoID*) b)).id;
#line 29 "../src/db/VideoTable.vala"
	return result;
#line 408 "VideoTable.c"
}

gchar*
video_id_upgrade_video_id_to_source_id (VideoID* video_id)
{
	VideoID _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 32 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 33 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 33 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp0_.id);
#line 33 "../src/db/VideoTable.vala"
	result = _tmp1_;
#line 33 "../src/db/VideoTable.vala"
	return result;
#line 427 "VideoTable.c"
}

VideoID*
video_id_dup (const VideoID* self)
{
	VideoID* dup;
#line 7 "../src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 7 "../src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 7 "../src/db/VideoTable.vala"
	return dup;
#line 440 "VideoTable.c"
}

void
video_id_free (VideoID* self)
{
#line 7 "../src/db/VideoTable.vala"
	g_free (self);
#line 448 "VideoTable.c"
}

static GType
video_id_get_type_once (void)
{
	GType video_id_type_id;
	video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
	return video_id_type_id;
}

GType
video_id_get_type (void)
{
	static volatile gsize video_id_type_id__once = 0;
	if (g_once_init_enter (&video_id_type_id__once)) {
		GType video_id_type_id;
		video_id_type_id = video_id_get_type_once ();
		g_once_init_leave (&video_id_type_id__once, video_id_type_id);
	}
	return video_id_type_id__once;
}

VideoRow*
video_row_construct (GType object_type)
{
	VideoRow* self = NULL;
#line 37 "../src/db/VideoTable.vala"
	self = (VideoRow*) g_type_create_instance (object_type);
#line 37 "../src/db/VideoTable.vala"
	return self;
#line 479 "VideoTable.c"
}

VideoRow*
video_row_new (void)
{
#line 37 "../src/db/VideoTable.vala"
	return video_row_construct (TYPE_VIDEO_ROW);
#line 487 "VideoTable.c"
}

static void
value_video_row_init (GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	value->data[0].v_pointer = NULL;
#line 495 "VideoTable.c"
}

static void
value_video_row_free_value (GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	if (value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (value->data[0].v_pointer);
#line 505 "VideoTable.c"
	}
}

static void
value_video_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 37 "../src/db/VideoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = video_row_ref (src_value->data[0].v_pointer);
#line 517 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 521 "VideoTable.c"
	}
}

static gpointer
value_video_row_peek_pointer (const GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 530 "VideoTable.c"
}

static gchar*
value_video_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 37 "../src/db/VideoTable.vala"
	if (collect_values[0].v_pointer) {
#line 541 "VideoTable.c"
		VideoRow * object;
		object = collect_values[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 548 "VideoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "../src/db/VideoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 552 "VideoTable.c"
		}
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = video_row_ref (object);
#line 556 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 560 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	return NULL;
#line 564 "VideoTable.c"
}

static gchar*
value_video_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	VideoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (!object_p) {
#line 37 "../src/db/VideoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 579 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (!value->data[0].v_pointer) {
#line 37 "../src/db/VideoTable.vala"
		*object_p = NULL;
#line 585 "VideoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "../src/db/VideoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 589 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		*object_p = video_row_ref (value->data[0].v_pointer);
#line 593 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	return NULL;
#line 597 "VideoTable.c"
}

GParamSpec*
param_spec_video_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecVideoRow* spec;
#line 37 "../src/db/VideoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_ROW), NULL);
#line 37 "../src/db/VideoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "../src/db/VideoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "../src/db/VideoTable.vala"
	return G_PARAM_SPEC (spec);
#line 616 "VideoTable.c"
}

gpointer
value_get_video_row (const GValue* value)
{
#line 37 "../src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW), NULL);
#line 37 "../src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 626 "VideoTable.c"
}

void
value_set_video_row (GValue* value,
                     gpointer v_object)
{
	VideoRow * old;
#line 37 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (v_object) {
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 37 "../src/db/VideoTable.vala"
		video_row_ref (value->data[0].v_pointer);
#line 648 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 652 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (old) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 658 "VideoTable.c"
	}
}

void
value_take_video_row (GValue* value,
                      gpointer v_object)
{
	VideoRow * old;
#line 37 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 37 "../src/db/VideoTable.vala"
	if (v_object) {
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 37 "../src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 679 "VideoTable.c"
	} else {
#line 37 "../src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 683 "VideoTable.c"
	}
#line 37 "../src/db/VideoTable.vala"
	if (old) {
#line 37 "../src/db/VideoTable.vala"
		video_row_unref (old);
#line 689 "VideoTable.c"
	}
}

static void
video_row_class_init (VideoRowClass * klass,
                      gpointer klass_data)
{
#line 37 "../src/db/VideoTable.vala"
	video_row_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/db/VideoTable.vala"
	((VideoRowClass *) klass)->finalize = video_row_finalize;
#line 701 "VideoTable.c"
}

static void
video_row_instance_init (VideoRow * self,
                         gpointer klass)
{
#line 37 "../src/db/VideoTable.vala"
	self->ref_count = 1;
#line 710 "VideoTable.c"
}

static void
video_row_finalize (VideoRow * obj)
{
	VideoRow * self;
#line 37 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_ROW, VideoRow);
#line 37 "../src/db/VideoTable.vala"
	g_signal_handlers_destroy (self);
#line 39 "../src/db/VideoTable.vala"
	_g_free0 (self->filepath);
#line 41 "../src/db/VideoTable.vala"
	_g_date_time_unref0 (self->timestamp);
#line 46 "../src/db/VideoTable.vala"
	_g_date_time_unref0 (self->exposure_time);
#line 49 "../src/db/VideoTable.vala"
	_g_free0 (self->md5);
#line 52 "../src/db/VideoTable.vala"
	_g_free0 (self->title);
#line 53 "../src/db/VideoTable.vala"
	_g_free0 (self->backlinks);
#line 56 "../src/db/VideoTable.vala"
	_g_free0 (self->comment);
#line 735 "VideoTable.c"
}

static GType
video_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_video_row_init, value_video_row_free_value, value_video_row_copy_value, value_video_row_peek_pointer, "p", value_video_row_collect_value, "p", value_video_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VideoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoRow), 0, (GInstanceInitFunc) video_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType video_row_type_id;
	video_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return video_row_type_id;
}

GType
video_row_get_type (void)
{
	static volatile gsize video_row_type_id__once = 0;
	if (g_once_init_enter (&video_row_type_id__once)) {
		GType video_row_type_id;
		video_row_type_id = video_row_get_type_once ();
		g_once_init_leave (&video_row_type_id__once, video_row_type_id);
	}
	return video_row_type_id__once;
}

gpointer
video_row_ref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 37 "../src/db/VideoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "../src/db/VideoTable.vala"
	return instance;
#line 770 "VideoTable.c"
}

void
video_row_unref (gpointer instance)
{
	VideoRow * self;
	self = instance;
#line 37 "../src/db/VideoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "../src/db/VideoTable.vala"
		VIDEO_ROW_GET_CLASS (self)->finalize (self);
#line 37 "../src/db/VideoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 784 "VideoTable.c"
	}
}

static VideoTable*
video_table_construct (GType object_type)
{
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* stmt2 = NULL;
	gint res2 = 0;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
#line 62 "../src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 64 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 64 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "rating INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0, " "comment TEXT " ")", -1, &_tmp1_, NULL);
#line 64 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 64 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 64 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 85 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 87 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 87 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 88 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 89 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res);
#line 826 "VideoTable.c"
	}
#line 93 "../src/db/VideoTable.vala"
	_tmp4_ = database_table_db;
#line 93 "../src/db/VideoTable.vala"
	_tmp6_ = sqlite3_prepare_v2 (_tmp4_, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)", -1, &_tmp5_, NULL);
#line 93 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 93 "../src/db/VideoTable.vala"
	stmt2 = _tmp5_;
#line 93 "../src/db/VideoTable.vala"
	res2 = _tmp6_;
#line 95 "../src/db/VideoTable.vala"
	_vala_assert (res2 == SQLITE_OK, "res2 == Sqlite.OK");
#line 97 "../src/db/VideoTable.vala"
	_tmp7_ = stmt2;
#line 97 "../src/db/VideoTable.vala"
	res2 = sqlite3_step (_tmp7_);
#line 98 "../src/db/VideoTable.vala"
	if (res2 != SQLITE_DONE) {
#line 99 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", res2);
#line 848 "VideoTable.c"
	}
#line 101 "../src/db/VideoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "VideoTable");
#line 62 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 62 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 62 "../src/db/VideoTable.vala"
	return self;
#line 858 "VideoTable.c"
}

static VideoTable*
video_table_new (void)
{
#line 62 "../src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 866 "VideoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 108 "../src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 874 "VideoTable.c"
}

VideoTable*
video_table_get_instance (void)
{
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
	VideoTable* result;
#line 105 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 105 "../src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 888 "VideoTable.c"
		VideoTable* _tmp1_;
#line 106 "../src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 106 "../src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 106 "../src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 896 "VideoTable.c"
	}
#line 108 "../src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 108 "../src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 108 "../src/db/VideoTable.vala"
	result = _tmp3_;
#line 108 "../src/db/VideoTable.vala"
	return result;
#line 906 "VideoTable.c"
}

void
video_table_add (VideoTable* self,
                 VideoRow* video_row,
                 VideoID* result,
                 GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3_stmt* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	sqlite3_stmt* _tmp19_;
	ImportID _tmp20_;
	sqlite3_stmt* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	GDestroyNotify _tmp25_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	GDestroyNotify _tmp30_;
	sqlite3_stmt* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	GDestroyNotify _tmp34_;
	sqlite3_stmt* _tmp35_;
	sqlite3* _tmp36_;
	VideoID _tmp37_;
	GError* _inner_error0_ = NULL;
#line 113 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 113 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_ROW (video_row));
#line 115 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 115 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 115 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 115 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 115 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 120 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 122 "../src/db/VideoTable.vala"
	time_created = now_sec ();
#line 124 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 124 "../src/db/VideoTable.vala"
	_tmp4_ = video_row->filepath;
#line 124 "../src/db/VideoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 124 "../src/db/VideoTable.vala"
	_tmp6_ = g_free;
#line 124 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 125 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 126 "../src/db/VideoTable.vala"
	_tmp7_ = stmt;
#line 126 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp7_, 2, video_row->width);
#line 127 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 128 "../src/db/VideoTable.vala"
	_tmp8_ = stmt;
#line 128 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 3, video_row->height);
#line 129 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 130 "../src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 130 "../src/db/VideoTable.vala"
	res = sqlite3_bind_double (_tmp9_, 4, video_row->clip_duration);
#line 131 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 132 "../src/db/VideoTable.vala"
	if (video_row->is_interpretable) {
#line 132 "../src/db/VideoTable.vala"
		_tmp10_ = 1;
#line 1006 "VideoTable.c"
	} else {
#line 132 "../src/db/VideoTable.vala"
		_tmp10_ = 0;
#line 1010 "VideoTable.c"
	}
#line 132 "../src/db/VideoTable.vala"
	_tmp11_ = stmt;
#line 132 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 5, _tmp10_);
#line 133 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 134 "../src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 134 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp12_, 6, video_row->filesize);
#line 135 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 136 "../src/db/VideoTable.vala"
	_tmp13_ = stmt;
#line 136 "../src/db/VideoTable.vala"
	_tmp14_ = video_row->timestamp;
#line 136 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp13_, 7, g_date_time_to_unix (_tmp14_));
#line 137 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 138 "../src/db/VideoTable.vala"
	_tmp15_ = video_row->exposure_time;
#line 138 "../src/db/VideoTable.vala"
	if (_tmp15_ == NULL) {
#line 1036 "VideoTable.c"
		sqlite3_stmt* _tmp16_;
#line 139 "../src/db/VideoTable.vala"
		_tmp16_ = stmt;
#line 139 "../src/db/VideoTable.vala"
		sqlite3_bind_null (_tmp16_, 8);
#line 1042 "VideoTable.c"
	} else {
		sqlite3_stmt* _tmp17_;
		GDateTime* _tmp18_;
#line 141 "../src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 141 "../src/db/VideoTable.vala"
		_tmp18_ = video_row->exposure_time;
#line 141 "../src/db/VideoTable.vala"
		res = sqlite3_bind_int64 (_tmp17_, 8, g_date_time_to_unix (_tmp18_));
#line 1052 "VideoTable.c"
	}
#line 143 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 144 "../src/db/VideoTable.vala"
	_tmp19_ = stmt;
#line 144 "../src/db/VideoTable.vala"
	_tmp20_ = video_row->import_id;
#line 144 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp19_, 9, _tmp20_.id);
#line 145 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 146 "../src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 146 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp21_, 10, EVENT_ID_INVALID);
#line 147 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 148 "../src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 148 "../src/db/VideoTable.vala"
	_tmp23_ = video_row->md5;
#line 148 "../src/db/VideoTable.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 148 "../src/db/VideoTable.vala"
	_tmp25_ = g_free;
#line 148 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp22_, 11, _tmp24_, -1, _tmp25_);
#line 149 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 150 "../src/db/VideoTable.vala"
	_tmp26_ = stmt;
#line 150 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp26_, 12, time_created);
#line 151 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 152 "../src/db/VideoTable.vala"
	_tmp27_ = stmt;
#line 152 "../src/db/VideoTable.vala"
	_tmp28_ = video_row->title;
#line 152 "../src/db/VideoTable.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 152 "../src/db/VideoTable.vala"
	_tmp30_ = g_free;
#line 152 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp27_, 13, _tmp29_, -1, _tmp30_);
#line 153 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 154 "../src/db/VideoTable.vala"
	_tmp31_ = stmt;
#line 154 "../src/db/VideoTable.vala"
	_tmp32_ = video_row->comment;
#line 154 "../src/db/VideoTable.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 154 "../src/db/VideoTable.vala"
	_tmp34_ = g_free;
#line 154 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp31_, 14, _tmp33_, -1, _tmp34_);
#line 155 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 157 "../src/db/VideoTable.vala"
	_tmp35_ = stmt;
#line 157 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp35_);
#line 158 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 159 "../src/db/VideoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 160 "../src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", res, &_inner_error0_);
#line 160 "../src/db/VideoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../src/db/VideoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 160 "../src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 160 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 160 "../src/db/VideoTable.vala"
					return;
#line 1132 "VideoTable.c"
				} else {
#line 160 "../src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 160 "../src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 160 "../src/db/VideoTable.vala"
					g_clear_error (&_inner_error0_);
#line 160 "../src/db/VideoTable.vala"
					return;
#line 1142 "VideoTable.c"
				}
			}
		}
	}
#line 164 "../src/db/VideoTable.vala"
	_tmp36_ = database_table_db;
#line 164 "../src/db/VideoTable.vala"
	video_id_init (&video_row->video_id, sqlite3_last_insert_rowid (_tmp36_));
#line 165 "../src/db/VideoTable.vala"
	event_id_init (&video_row->event_id, EVENT_ID_INVALID);
#line 166 "../src/db/VideoTable.vala"
	video_row->time_created = time_created;
#line 167 "../src/db/VideoTable.vala"
	video_row->flags = (guint64) 0;
#line 169 "../src/db/VideoTable.vala"
	_tmp37_ = video_row->video_id;
#line 169 "../src/db/VideoTable.vala"
	*result = _tmp37_;
#line 169 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 169 "../src/db/VideoTable.vala"
	return;
#line 1165 "VideoTable.c"
}

gboolean
video_table_drop_event (VideoTable* self,
                        EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result;
#line 172 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 172 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 174 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 174 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 174 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 174 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 174 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 175 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 177 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 177 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, EVENT_ID_INVALID);
#line 178 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 179 "../src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 179 "../src/db/VideoTable.vala"
	_tmp5_ = *event_id;
#line 179 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, _tmp5_.id);
#line 180 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 182 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 182 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 183 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 184 "../src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", res);
#line 186 "../src/db/VideoTable.vala"
		result = FALSE;
#line 186 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 186 "../src/db/VideoTable.vala"
		return result;
#line 1226 "VideoTable.c"
	}
#line 189 "../src/db/VideoTable.vala"
	result = TRUE;
#line 189 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 189 "../src/db/VideoTable.vala"
	return result;
#line 1234 "VideoTable.c"
}

VideoRow*
video_table_get_row (VideoTable* self,
                     VideoID* video_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	VideoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	VideoRow* row = NULL;
	VideoRow* _tmp6_;
	VideoRow* _tmp7_;
	VideoID _tmp8_;
	VideoRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	VideoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	VideoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	VideoRow* _tmp17_;
	sqlite3_stmt* _tmp18_;
	VideoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	VideoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	VideoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	GDateTime* _tmp25_;
	VideoRow* _tmp26_;
	GDateTime* _tmp27_;
	VideoRow* _tmp32_;
	sqlite3_stmt* _tmp33_;
	VideoRow* _tmp34_;
	sqlite3_stmt* _tmp35_;
	VideoRow* _tmp36_;
	sqlite3_stmt* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	VideoRow* _tmp40_;
	sqlite3_stmt* _tmp41_;
	VideoRow* _tmp42_;
	sqlite3_stmt* _tmp43_;
	VideoRow* _tmp44_;
	sqlite3_stmt* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	VideoRow* _tmp48_;
	sqlite3_stmt* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	VideoRow* _tmp52_;
	sqlite3_stmt* _tmp53_;
	VideoRow* _tmp54_;
	sqlite3_stmt* _tmp55_;
	VideoRow* _tmp56_;
	sqlite3_stmt* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	VideoRow* result;
#line 192 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 192 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 194 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 194 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, rating, title, " \
"backlinks, " "time_reimported, flags, comment FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 194 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 194 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 194 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 199 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 201 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 201 "../src/db/VideoTable.vala"
	_tmp4_ = *video_id;
#line 201 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 202 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 204 "../src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 204 "../src/db/VideoTable.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_ROW) {
#line 205 "../src/db/VideoTable.vala"
		result = NULL;
#line 205 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 205 "../src/db/VideoTable.vala"
		return result;
#line 1335 "VideoTable.c"
	}
#line 207 "../src/db/VideoTable.vala"
	_tmp6_ = video_row_new ();
#line 207 "../src/db/VideoTable.vala"
	row = _tmp6_;
#line 208 "../src/db/VideoTable.vala"
	_tmp7_ = row;
#line 208 "../src/db/VideoTable.vala"
	_tmp8_ = *video_id;
#line 208 "../src/db/VideoTable.vala"
	_tmp7_->video_id = _tmp8_;
#line 209 "../src/db/VideoTable.vala"
	_tmp9_ = row;
#line 209 "../src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 209 "../src/db/VideoTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 209 "../src/db/VideoTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 209 "../src/db/VideoTable.vala"
	_g_free0 (_tmp9_->filepath);
#line 209 "../src/db/VideoTable.vala"
	_tmp9_->filepath = _tmp12_;
#line 210 "../src/db/VideoTable.vala"
	_tmp13_ = row;
#line 210 "../src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 210 "../src/db/VideoTable.vala"
	_tmp13_->width = sqlite3_column_int (_tmp14_, 1);
#line 211 "../src/db/VideoTable.vala"
	_tmp15_ = row;
#line 211 "../src/db/VideoTable.vala"
	_tmp16_ = stmt;
#line 211 "../src/db/VideoTable.vala"
	_tmp15_->height = sqlite3_column_int (_tmp16_, 2);
#line 212 "../src/db/VideoTable.vala"
	_tmp17_ = row;
#line 212 "../src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 212 "../src/db/VideoTable.vala"
	_tmp17_->clip_duration = sqlite3_column_double (_tmp18_, 3);
#line 213 "../src/db/VideoTable.vala"
	_tmp19_ = row;
#line 213 "../src/db/VideoTable.vala"
	_tmp20_ = stmt;
#line 213 "../src/db/VideoTable.vala"
	_tmp19_->is_interpretable = sqlite3_column_int (_tmp20_, 4) == 1;
#line 214 "../src/db/VideoTable.vala"
	_tmp21_ = row;
#line 214 "../src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 214 "../src/db/VideoTable.vala"
	_tmp21_->filesize = sqlite3_column_int64 (_tmp22_, 5);
#line 215 "../src/db/VideoTable.vala"
	_tmp23_ = row;
#line 215 "../src/db/VideoTable.vala"
	_tmp24_ = stmt;
#line 215 "../src/db/VideoTable.vala"
	_tmp25_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp24_, 6));
#line 215 "../src/db/VideoTable.vala"
	_g_date_time_unref0 (_tmp23_->timestamp);
#line 215 "../src/db/VideoTable.vala"
	_tmp23_->timestamp = _tmp25_;
#line 216 "../src/db/VideoTable.vala"
	_tmp26_ = row;
#line 216 "../src/db/VideoTable.vala"
	_tmp27_ = _tmp26_->exposure_time;
#line 216 "../src/db/VideoTable.vala"
	if (_tmp27_ == NULL) {
#line 1405 "VideoTable.c"
		sqlite3_stmt* _tmp28_;
#line 217 "../src/db/VideoTable.vala"
		_tmp28_ = stmt;
#line 217 "../src/db/VideoTable.vala"
		sqlite3_bind_null (_tmp28_, 7);
#line 1411 "VideoTable.c"
	} else {
		sqlite3_stmt* _tmp29_;
		VideoRow* _tmp30_;
		GDateTime* _tmp31_;
#line 219 "../src/db/VideoTable.vala"
		_tmp29_ = stmt;
#line 219 "../src/db/VideoTable.vala"
		_tmp30_ = row;
#line 219 "../src/db/VideoTable.vala"
		_tmp31_ = _tmp30_->exposure_time;
#line 219 "../src/db/VideoTable.vala"
		res = sqlite3_bind_int64 (_tmp29_, 7, g_date_time_to_unix (_tmp31_));
#line 1424 "VideoTable.c"
	}
#line 221 "../src/db/VideoTable.vala"
	_tmp32_ = row;
#line 221 "../src/db/VideoTable.vala"
	_tmp33_ = stmt;
#line 221 "../src/db/VideoTable.vala"
	_tmp32_->import_id.id = sqlite3_column_int64 (_tmp33_, 8);
#line 222 "../src/db/VideoTable.vala"
	_tmp34_ = row;
#line 222 "../src/db/VideoTable.vala"
	_tmp35_ = stmt;
#line 222 "../src/db/VideoTable.vala"
	_tmp34_->event_id.id = sqlite3_column_int64 (_tmp35_, 9);
#line 223 "../src/db/VideoTable.vala"
	_tmp36_ = row;
#line 223 "../src/db/VideoTable.vala"
	_tmp37_ = stmt;
#line 223 "../src/db/VideoTable.vala"
	_tmp38_ = (const gchar*) sqlite3_column_text (_tmp37_, 10);
#line 223 "../src/db/VideoTable.vala"
	_tmp39_ = g_strdup (_tmp38_);
#line 223 "../src/db/VideoTable.vala"
	_g_free0 (_tmp36_->md5);
#line 223 "../src/db/VideoTable.vala"
	_tmp36_->md5 = _tmp39_;
#line 224 "../src/db/VideoTable.vala"
	_tmp40_ = row;
#line 224 "../src/db/VideoTable.vala"
	_tmp41_ = stmt;
#line 224 "../src/db/VideoTable.vala"
	_tmp40_->time_created = sqlite3_column_int64 (_tmp41_, 11);
#line 225 "../src/db/VideoTable.vala"
	_tmp42_ = row;
#line 225 "../src/db/VideoTable.vala"
	_tmp43_ = stmt;
#line 225 "../src/db/VideoTable.vala"
	_tmp42_->rating = rating_unserialize (sqlite3_column_int (_tmp43_, 12));
#line 226 "../src/db/VideoTable.vala"
	_tmp44_ = row;
#line 226 "../src/db/VideoTable.vala"
	_tmp45_ = stmt;
#line 226 "../src/db/VideoTable.vala"
	_tmp46_ = (const gchar*) sqlite3_column_text (_tmp45_, 13);
#line 226 "../src/db/VideoTable.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 226 "../src/db/VideoTable.vala"
	_g_free0 (_tmp44_->title);
#line 226 "../src/db/VideoTable.vala"
	_tmp44_->title = _tmp47_;
#line 227 "../src/db/VideoTable.vala"
	_tmp48_ = row;
#line 227 "../src/db/VideoTable.vala"
	_tmp49_ = stmt;
#line 227 "../src/db/VideoTable.vala"
	_tmp50_ = (const gchar*) sqlite3_column_text (_tmp49_, 14);
#line 227 "../src/db/VideoTable.vala"
	_tmp51_ = g_strdup (_tmp50_);
#line 227 "../src/db/VideoTable.vala"
	_g_free0 (_tmp48_->backlinks);
#line 227 "../src/db/VideoTable.vala"
	_tmp48_->backlinks = _tmp51_;
#line 228 "../src/db/VideoTable.vala"
	_tmp52_ = row;
#line 228 "../src/db/VideoTable.vala"
	_tmp53_ = stmt;
#line 228 "../src/db/VideoTable.vala"
	_tmp52_->time_reimported = sqlite3_column_int64 (_tmp53_, 15);
#line 229 "../src/db/VideoTable.vala"
	_tmp54_ = row;
#line 229 "../src/db/VideoTable.vala"
	_tmp55_ = stmt;
#line 229 "../src/db/VideoTable.vala"
	_tmp54_->flags = (guint64) sqlite3_column_int64 (_tmp55_, 16);
#line 230 "../src/db/VideoTable.vala"
	_tmp56_ = row;
#line 230 "../src/db/VideoTable.vala"
	_tmp57_ = stmt;
#line 230 "../src/db/VideoTable.vala"
	_tmp58_ = (const gchar*) sqlite3_column_text (_tmp57_, 17);
#line 230 "../src/db/VideoTable.vala"
	_tmp59_ = g_strdup (_tmp58_);
#line 230 "../src/db/VideoTable.vala"
	_g_free0 (_tmp56_->comment);
#line 230 "../src/db/VideoTable.vala"
	_tmp56_->comment = _tmp59_;
#line 232 "../src/db/VideoTable.vala"
	result = row;
#line 232 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 232 "../src/db/VideoTable.vala"
	return result;
#line 1516 "VideoTable.c"
}

GeeArrayList*
video_table_get_all (VideoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result;
#line 235 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 237 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 237 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, rati" \
"ng, title, " "backlinks, time_reimported, flags, comment FROM VideoTable", -1, &_tmp1_, NULL);
#line 237 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 237 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 237 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 242 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 244 "../src/db/VideoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_ref, (GDestroyNotify) video_row_unref, NULL, NULL, NULL);
#line 244 "../src/db/VideoTable.vala"
	all = _tmp3_;
#line 246 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 1550 "VideoTable.c"
		sqlite3_stmt* _tmp4_;
		VideoRow* row = NULL;
		VideoRow* _tmp5_;
		VideoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		VideoRow* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		VideoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		VideoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		VideoRow* _tmp16_;
		sqlite3_stmt* _tmp17_;
		VideoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		VideoRow* _tmp20_;
		sqlite3_stmt* _tmp21_;
		VideoRow* _tmp22_;
		sqlite3_stmt* _tmp23_;
		GDateTime* _tmp24_;
		VideoRow* _tmp25_;
		GDateTime* _tmp26_;
		VideoRow* _tmp31_;
		sqlite3_stmt* _tmp32_;
		VideoRow* _tmp33_;
		sqlite3_stmt* _tmp34_;
		VideoRow* _tmp35_;
		sqlite3_stmt* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		VideoRow* _tmp39_;
		sqlite3_stmt* _tmp40_;
		VideoRow* _tmp41_;
		sqlite3_stmt* _tmp42_;
		VideoRow* _tmp43_;
		sqlite3_stmt* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		VideoRow* _tmp47_;
		sqlite3_stmt* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		VideoRow* _tmp51_;
		sqlite3_stmt* _tmp52_;
		VideoRow* _tmp53_;
		sqlite3_stmt* _tmp54_;
		VideoRow* _tmp55_;
		sqlite3_stmt* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		GeeArrayList* _tmp59_;
		VideoRow* _tmp60_;
#line 246 "../src/db/VideoTable.vala"
		_tmp4_ = stmt;
#line 246 "../src/db/VideoTable.vala"
		res = sqlite3_step (_tmp4_);
#line 246 "../src/db/VideoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 246 "../src/db/VideoTable.vala"
			break;
#line 1613 "VideoTable.c"
		}
#line 247 "../src/db/VideoTable.vala"
		_tmp5_ = video_row_new ();
#line 247 "../src/db/VideoTable.vala"
		row = _tmp5_;
#line 248 "../src/db/VideoTable.vala"
		_tmp6_ = row;
#line 248 "../src/db/VideoTable.vala"
		_tmp7_ = stmt;
#line 248 "../src/db/VideoTable.vala"
		_tmp6_->video_id.id = sqlite3_column_int64 (_tmp7_, 0);
#line 249 "../src/db/VideoTable.vala"
		_tmp8_ = row;
#line 249 "../src/db/VideoTable.vala"
		_tmp9_ = stmt;
#line 249 "../src/db/VideoTable.vala"
		_tmp10_ = (const gchar*) sqlite3_column_text (_tmp9_, 1);
#line 249 "../src/db/VideoTable.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 249 "../src/db/VideoTable.vala"
		_g_free0 (_tmp8_->filepath);
#line 249 "../src/db/VideoTable.vala"
		_tmp8_->filepath = _tmp11_;
#line 250 "../src/db/VideoTable.vala"
		_tmp12_ = row;
#line 250 "../src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 250 "../src/db/VideoTable.vala"
		_tmp12_->width = sqlite3_column_int (_tmp13_, 2);
#line 251 "../src/db/VideoTable.vala"
		_tmp14_ = row;
#line 251 "../src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 251 "../src/db/VideoTable.vala"
		_tmp14_->height = sqlite3_column_int (_tmp15_, 3);
#line 252 "../src/db/VideoTable.vala"
		_tmp16_ = row;
#line 252 "../src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 252 "../src/db/VideoTable.vala"
		_tmp16_->clip_duration = sqlite3_column_double (_tmp17_, 4);
#line 253 "../src/db/VideoTable.vala"
		_tmp18_ = row;
#line 253 "../src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 253 "../src/db/VideoTable.vala"
		_tmp18_->is_interpretable = sqlite3_column_int (_tmp19_, 5) == 1;
#line 254 "../src/db/VideoTable.vala"
		_tmp20_ = row;
#line 254 "../src/db/VideoTable.vala"
		_tmp21_ = stmt;
#line 254 "../src/db/VideoTable.vala"
		_tmp20_->filesize = sqlite3_column_int64 (_tmp21_, 6);
#line 255 "../src/db/VideoTable.vala"
		_tmp22_ = row;
#line 255 "../src/db/VideoTable.vala"
		_tmp23_ = stmt;
#line 255 "../src/db/VideoTable.vala"
		_tmp24_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp23_, 7));
#line 255 "../src/db/VideoTable.vala"
		_g_date_time_unref0 (_tmp22_->timestamp);
#line 255 "../src/db/VideoTable.vala"
		_tmp22_->timestamp = _tmp24_;
#line 256 "../src/db/VideoTable.vala"
		_tmp25_ = row;
#line 256 "../src/db/VideoTable.vala"
		_tmp26_ = _tmp25_->exposure_time;
#line 256 "../src/db/VideoTable.vala"
		if (_tmp26_ == NULL) {
#line 1683 "VideoTable.c"
			sqlite3_stmt* _tmp27_;
#line 257 "../src/db/VideoTable.vala"
			_tmp27_ = stmt;
#line 257 "../src/db/VideoTable.vala"
			sqlite3_bind_null (_tmp27_, 8);
#line 1689 "VideoTable.c"
		} else {
			sqlite3_stmt* _tmp28_;
			VideoRow* _tmp29_;
			GDateTime* _tmp30_;
#line 259 "../src/db/VideoTable.vala"
			_tmp28_ = stmt;
#line 259 "../src/db/VideoTable.vala"
			_tmp29_ = row;
#line 259 "../src/db/VideoTable.vala"
			_tmp30_ = _tmp29_->exposure_time;
#line 259 "../src/db/VideoTable.vala"
			res = sqlite3_bind_int64 (_tmp28_, 8, g_date_time_to_unix (_tmp30_));
#line 1702 "VideoTable.c"
		}
#line 261 "../src/db/VideoTable.vala"
		_tmp31_ = row;
#line 261 "../src/db/VideoTable.vala"
		_tmp32_ = stmt;
#line 261 "../src/db/VideoTable.vala"
		_tmp31_->import_id.id = sqlite3_column_int64 (_tmp32_, 9);
#line 262 "../src/db/VideoTable.vala"
		_tmp33_ = row;
#line 262 "../src/db/VideoTable.vala"
		_tmp34_ = stmt;
#line 262 "../src/db/VideoTable.vala"
		_tmp33_->event_id.id = sqlite3_column_int64 (_tmp34_, 10);
#line 263 "../src/db/VideoTable.vala"
		_tmp35_ = row;
#line 263 "../src/db/VideoTable.vala"
		_tmp36_ = stmt;
#line 263 "../src/db/VideoTable.vala"
		_tmp37_ = (const gchar*) sqlite3_column_text (_tmp36_, 11);
#line 263 "../src/db/VideoTable.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 263 "../src/db/VideoTable.vala"
		_g_free0 (_tmp35_->md5);
#line 263 "../src/db/VideoTable.vala"
		_tmp35_->md5 = _tmp38_;
#line 264 "../src/db/VideoTable.vala"
		_tmp39_ = row;
#line 264 "../src/db/VideoTable.vala"
		_tmp40_ = stmt;
#line 264 "../src/db/VideoTable.vala"
		_tmp39_->time_created = sqlite3_column_int64 (_tmp40_, 12);
#line 265 "../src/db/VideoTable.vala"
		_tmp41_ = row;
#line 265 "../src/db/VideoTable.vala"
		_tmp42_ = stmt;
#line 265 "../src/db/VideoTable.vala"
		_tmp41_->rating = rating_unserialize (sqlite3_column_int (_tmp42_, 13));
#line 266 "../src/db/VideoTable.vala"
		_tmp43_ = row;
#line 266 "../src/db/VideoTable.vala"
		_tmp44_ = stmt;
#line 266 "../src/db/VideoTable.vala"
		_tmp45_ = (const gchar*) sqlite3_column_text (_tmp44_, 14);
#line 266 "../src/db/VideoTable.vala"
		_tmp46_ = g_strdup (_tmp45_);
#line 266 "../src/db/VideoTable.vala"
		_g_free0 (_tmp43_->title);
#line 266 "../src/db/VideoTable.vala"
		_tmp43_->title = _tmp46_;
#line 267 "../src/db/VideoTable.vala"
		_tmp47_ = row;
#line 267 "../src/db/VideoTable.vala"
		_tmp48_ = stmt;
#line 267 "../src/db/VideoTable.vala"
		_tmp49_ = (const gchar*) sqlite3_column_text (_tmp48_, 15);
#line 267 "../src/db/VideoTable.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 267 "../src/db/VideoTable.vala"
		_g_free0 (_tmp47_->backlinks);
#line 267 "../src/db/VideoTable.vala"
		_tmp47_->backlinks = _tmp50_;
#line 268 "../src/db/VideoTable.vala"
		_tmp51_ = row;
#line 268 "../src/db/VideoTable.vala"
		_tmp52_ = stmt;
#line 268 "../src/db/VideoTable.vala"
		_tmp51_->time_reimported = sqlite3_column_int64 (_tmp52_, 16);
#line 269 "../src/db/VideoTable.vala"
		_tmp53_ = row;
#line 269 "../src/db/VideoTable.vala"
		_tmp54_ = stmt;
#line 269 "../src/db/VideoTable.vala"
		_tmp53_->flags = (guint64) sqlite3_column_int64 (_tmp54_, 17);
#line 270 "../src/db/VideoTable.vala"
		_tmp55_ = row;
#line 270 "../src/db/VideoTable.vala"
		_tmp56_ = stmt;
#line 270 "../src/db/VideoTable.vala"
		_tmp57_ = (const gchar*) sqlite3_column_text (_tmp56_, 18);
#line 270 "../src/db/VideoTable.vala"
		_tmp58_ = g_strdup (_tmp57_);
#line 270 "../src/db/VideoTable.vala"
		_g_free0 (_tmp55_->comment);
#line 270 "../src/db/VideoTable.vala"
		_tmp55_->comment = _tmp58_;
#line 272 "../src/db/VideoTable.vala"
		_tmp59_ = all;
#line 272 "../src/db/VideoTable.vala"
		_tmp60_ = row;
#line 272 "../src/db/VideoTable.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp60_);
#line 246 "../src/db/VideoTable.vala"
		_video_row_unref0 (row);
#line 1796 "VideoTable.c"
	}
#line 275 "../src/db/VideoTable.vala"
	result = all;
#line 275 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 275 "../src/db/VideoTable.vala"
	return result;
#line 1804 "VideoTable.c"
}

void
video_table_set_filepath (VideoTable* self,
                          VideoID* video_id,
                          const gchar* filepath,
                          GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 278 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 278 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 278 "../src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 279 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 279 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 279 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 279 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 279 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 279 "../src/db/VideoTable.vala"
			return;
#line 1833 "VideoTable.c"
		} else {
#line 279 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 279 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 279 "../src/db/VideoTable.vala"
			return;
#line 1841 "VideoTable.c"
		}
	}
}

void
video_table_set_title (VideoTable* self,
                       VideoID* video_id,
                       const gchar* new_title,
                       GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 282 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 282 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 283 "../src/db/VideoTable.vala"
	if (new_title != NULL) {
#line 283 "../src/db/VideoTable.vala"
		_tmp0_ = new_title;
#line 1863 "VideoTable.c"
	} else {
#line 283 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1867 "VideoTable.c"
	}
#line 283 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 283 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "title", _tmp0_, &_inner_error0_);
#line 283 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 283 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 283 "../src/db/VideoTable.vala"
			return;
#line 1881 "VideoTable.c"
		} else {
#line 283 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 283 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 283 "../src/db/VideoTable.vala"
			return;
#line 1889 "VideoTable.c"
		}
	}
}

void
video_table_set_comment (VideoTable* self,
                         VideoID* video_id,
                         const gchar* new_comment,
                         GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 286 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 286 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 287 "../src/db/VideoTable.vala"
	if (new_comment != NULL) {
#line 287 "../src/db/VideoTable.vala"
		_tmp0_ = new_comment;
#line 1911 "VideoTable.c"
	} else {
#line 287 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1915 "VideoTable.c"
	}
#line 287 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 287 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "comment", _tmp0_, &_inner_error0_);
#line 287 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 287 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 287 "../src/db/VideoTable.vala"
			return;
#line 1929 "VideoTable.c"
		} else {
#line 287 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 287 "../src/db/VideoTable.vala"
			return;
#line 1937 "VideoTable.c"
		}
	}
}

void
video_table_set_exposure_time (VideoTable* self,
                               VideoID* video_id,
                               GDateTime* time,
                               GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 290 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 290 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 290 "../src/db/VideoTable.vala"
	g_return_if_fail (time != NULL);
#line 291 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 291 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "exposure_time", g_date_time_to_unix (time), &_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 291 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 291 "../src/db/VideoTable.vala"
			return;
#line 1968 "VideoTable.c"
		} else {
#line 291 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 291 "../src/db/VideoTable.vala"
			return;
#line 1976 "VideoTable.c"
		}
	}
}

void
video_table_set_rating (VideoTable* self,
                        VideoID* video_id,
                        Rating rating,
                        GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 294 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 294 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 295 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 295 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "rating", (gint64) rating_serialize (rating), &_inner_error0_);
#line 295 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 295 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 295 "../src/db/VideoTable.vala"
			return;
#line 2005 "VideoTable.c"
		} else {
#line 295 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 295 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 295 "../src/db/VideoTable.vala"
			return;
#line 2013 "VideoTable.c"
		}
	}
}

void
video_table_set_flags (VideoTable* self,
                       VideoID* video_id,
                       guint64 flags,
                       GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 298 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 298 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 299 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 299 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "flags", (gint64) flags, &_inner_error0_);
#line 299 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 299 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 299 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 299 "../src/db/VideoTable.vala"
			return;
#line 2042 "VideoTable.c"
		} else {
#line 299 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 299 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 299 "../src/db/VideoTable.vala"
			return;
#line 2050 "VideoTable.c"
		}
	}
}

void
video_table_update_backlinks (VideoTable* self,
                              VideoID* video_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 302 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 302 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 303 "../src/db/VideoTable.vala"
	if (backlinks != NULL) {
#line 303 "../src/db/VideoTable.vala"
		_tmp0_ = backlinks;
#line 2072 "VideoTable.c"
	} else {
#line 303 "../src/db/VideoTable.vala"
		_tmp0_ = "";
#line 2076 "VideoTable.c"
	}
#line 303 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 303 "../src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 303 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 303 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 303 "../src/db/VideoTable.vala"
			return;
#line 2090 "VideoTable.c"
		} else {
#line 303 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 303 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 303 "../src/db/VideoTable.vala"
			return;
#line 2098 "VideoTable.c"
		}
	}
}

void
video_table_update_is_interpretable (VideoTable* self,
                                     VideoID* video_id,
                                     gboolean is_interpretable,
                                     GError** error)
{
	gint _tmp0_ = 0;
	VideoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 306 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 306 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 307 "../src/db/VideoTable.vala"
	if (is_interpretable) {
#line 307 "../src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 2120 "VideoTable.c"
	} else {
#line 307 "../src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 2124 "VideoTable.c"
	}
#line 307 "../src/db/VideoTable.vala"
	_tmp1_ = *video_id;
#line 307 "../src/db/VideoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "is_interpretable", _tmp0_, &_inner_error0_);
#line 307 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 307 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 307 "../src/db/VideoTable.vala"
			return;
#line 2138 "VideoTable.c"
		} else {
#line 307 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 307 "../src/db/VideoTable.vala"
			return;
#line 2146 "VideoTable.c"
		}
	}
}

gboolean
video_table_set_event (VideoTable* self,
                       VideoID* video_id,
                       EventID* event_id)
{
	VideoID _tmp0_;
	EventID _tmp1_;
	gboolean result;
#line 310 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 310 "../src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 310 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 311 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 311 "../src/db/VideoTable.vala"
	_tmp1_ = *event_id;
#line 311 "../src/db/VideoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "event_id", _tmp1_.id);
#line 311 "../src/db/VideoTable.vala"
	return result;
#line 2173 "VideoTable.c"
}

void
video_table_remove_by_file (VideoTable* self,
                            GFile* file,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 314 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 314 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 316 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 316 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 316 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 316 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 316 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 317 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 319 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 319 "../src/db/VideoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 319 "../src/db/VideoTable.vala"
	_tmp5_ = g_free;
#line 319 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 320 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 322 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 322 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 323 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 324 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", res, &_inner_error0_);
#line 324 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 324 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 324 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 324 "../src/db/VideoTable.vala"
				return;
#line 2235 "VideoTable.c"
			} else {
#line 324 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 324 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 324 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 324 "../src/db/VideoTable.vala"
				return;
#line 2245 "VideoTable.c"
			}
		}
	}
#line 314 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2251 "VideoTable.c"
}

void
video_table_remove (VideoTable* self,
                    VideoID* videoID,
                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	VideoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 327 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 327 "../src/db/VideoTable.vala"
	g_return_if_fail (videoID != NULL);
#line 329 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 329 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 329 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 329 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 329 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 330 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 332 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 332 "../src/db/VideoTable.vala"
	_tmp4_ = *videoID;
#line 332 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 333 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 335 "../src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 335 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 336 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 337 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", res, &_inner_error0_);
#line 337 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 337 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 337 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 337 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 337 "../src/db/VideoTable.vala"
				return;
#line 2310 "VideoTable.c"
			} else {
#line 337 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 337 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 337 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 337 "../src/db/VideoTable.vala"
				return;
#line 2320 "VideoTable.c"
			}
		}
	}
#line 327 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2326 "VideoTable.c"
}

gboolean
video_table_is_video_stored (VideoTable* self,
                             GFile* file)
{
	VideoID _tmp0_ = {0};
	gboolean result;
#line 340 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 340 "../src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 341 "../src/db/VideoTable.vala"
	video_table_get_id (self, file, &_tmp0_);
#line 341 "../src/db/VideoTable.vala"
	result = video_id_is_valid (&_tmp0_);
#line 341 "../src/db/VideoTable.vala"
	return result;
#line 2345 "VideoTable.c"
}

void
video_table_get_id (VideoTable* self,
                    GFile* file,
                    VideoID* result)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	VideoID _tmp7_ = {0};
#line 344 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 344 "../src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 346 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 346 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT ID FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 346 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 346 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 346 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 347 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 349 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 349 "../src/db/VideoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 349 "../src/db/VideoTable.vala"
	_tmp5_ = g_free;
#line 349 "../src/db/VideoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 350 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 352 "../src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 352 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 354 "../src/db/VideoTable.vala"
	if (res == SQLITE_ROW) {
#line 2395 "VideoTable.c"
		sqlite3_stmt* _tmp8_;
#line 354 "../src/db/VideoTable.vala"
		_tmp8_ = stmt;
#line 354 "../src/db/VideoTable.vala"
		video_id_init (&_tmp7_, sqlite3_column_int64 (_tmp8_, 0));
#line 2401 "VideoTable.c"
	} else {
#line 354 "../src/db/VideoTable.vala"
		video_id_init (&_tmp7_, VIDEO_ID_INVALID);
#line 2405 "VideoTable.c"
	}
#line 354 "../src/db/VideoTable.vala"
	*result = _tmp7_;
#line 354 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 354 "../src/db/VideoTable.vala"
	return;
#line 2413 "VideoTable.c"
}

GeeArrayList*
video_table_get_videos (VideoTable* self,
                        GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* video_ids = NULL;
	GeeArrayList* _tmp3_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 357 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 359 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 359 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable", -1, &_tmp1_, NULL);
#line 359 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 359 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 359 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 360 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 362 "../src/db/VideoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, (GDestroyNotify) video_id_free, NULL, NULL, NULL);
#line 362 "../src/db/VideoTable.vala"
	video_ids = _tmp3_;
#line 2447 "VideoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 363 "../src/db/VideoTable.vala"
		_tmp4_ = TRUE;
#line 363 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 2454 "VideoTable.c"
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			VideoID _tmp8_ = {0};
#line 363 "../src/db/VideoTable.vala"
			if (!_tmp4_) {
#line 2461 "VideoTable.c"
			}
#line 363 "../src/db/VideoTable.vala"
			_tmp4_ = FALSE;
#line 364 "../src/db/VideoTable.vala"
			_tmp5_ = stmt;
#line 364 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 365 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 366 "../src/db/VideoTable.vala"
				break;
#line 2473 "VideoTable.c"
			} else {
#line 367 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 368 "../src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", res, &_inner_error0_);
#line 368 "../src/db/VideoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 368 "../src/db/VideoTable.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 368 "../src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error0_);
#line 368 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 368 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 368 "../src/db/VideoTable.vala"
							return NULL;
#line 2491 "VideoTable.c"
						} else {
#line 368 "../src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 368 "../src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 368 "../src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 368 "../src/db/VideoTable.vala"
							g_clear_error (&_inner_error0_);
#line 368 "../src/db/VideoTable.vala"
							return NULL;
#line 2503 "VideoTable.c"
						}
					}
				}
			}
#line 371 "../src/db/VideoTable.vala"
			_tmp6_ = video_ids;
#line 371 "../src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 371 "../src/db/VideoTable.vala"
			video_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 371 "../src/db/VideoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp8_);
#line 2516 "VideoTable.c"
		}
	}
#line 374 "../src/db/VideoTable.vala"
	result = video_ids;
#line 374 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 374 "../src/db/VideoTable.vala"
	return result;
#line 2525 "VideoTable.c"
}

static sqlite3_stmt*
video_table_get_duplicate_stmt (VideoTable* self,
                                GFile* file,
                                const gchar* md5)
{
	gboolean _tmp0_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp1_;
	gboolean first = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	gint _tmp11_;
	gint col = 0;
	sqlite3_stmt* result;
#line 377 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 377 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 378 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 378 "../src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 2553 "VideoTable.c"
	} else {
#line 378 "../src/db/VideoTable.vala"
		_tmp0_ = md5 != NULL;
#line 2557 "VideoTable.c"
	}
#line 378 "../src/db/VideoTable.vala"
	_vala_assert (_tmp0_, "file != null || md5 != null");
#line 380 "../src/db/VideoTable.vala"
	_tmp1_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 380 "../src/db/VideoTable.vala"
	sql = _tmp1_;
#line 381 "../src/db/VideoTable.vala"
	first = TRUE;
#line 383 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 2569 "VideoTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 384 "../src/db/VideoTable.vala"
		_tmp2_ = sql;
#line 384 "../src/db/VideoTable.vala"
		_tmp3_ = g_strconcat (_tmp2_, " filename=?", NULL);
#line 384 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 384 "../src/db/VideoTable.vala"
		sql = _tmp3_;
#line 385 "../src/db/VideoTable.vala"
		first = FALSE;
#line 2582 "VideoTable.c"
	}
#line 388 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2586 "VideoTable.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 389 "../src/db/VideoTable.vala"
		if (!first) {
#line 2591 "VideoTable.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 390 "../src/db/VideoTable.vala"
			_tmp4_ = sql;
#line 390 "../src/db/VideoTable.vala"
			_tmp5_ = g_strconcat (_tmp4_, " OR ", NULL);
#line 390 "../src/db/VideoTable.vala"
			_g_free0 (sql);
#line 390 "../src/db/VideoTable.vala"
			sql = _tmp5_;
#line 2602 "VideoTable.c"
		}
#line 392 "../src/db/VideoTable.vala"
		_tmp6_ = sql;
#line 392 "../src/db/VideoTable.vala"
		_tmp7_ = g_strconcat (_tmp6_, " md5=?", NULL);
#line 392 "../src/db/VideoTable.vala"
		_g_free0 (sql);
#line 392 "../src/db/VideoTable.vala"
		sql = _tmp7_;
#line 2612 "VideoTable.c"
	}
#line 396 "../src/db/VideoTable.vala"
	_tmp8_ = database_table_db;
#line 396 "../src/db/VideoTable.vala"
	_tmp9_ = sql;
#line 396 "../src/db/VideoTable.vala"
	_tmp11_ = sqlite3_prepare_v2 (_tmp8_, _tmp9_, -1, &_tmp10_, NULL);
#line 396 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 396 "../src/db/VideoTable.vala"
	stmt = _tmp10_;
#line 396 "../src/db/VideoTable.vala"
	res = _tmp11_;
#line 397 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 399 "../src/db/VideoTable.vala"
	col = 1;
#line 401 "../src/db/VideoTable.vala"
	if (file != NULL) {
#line 2632 "VideoTable.c"
		sqlite3_stmt* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
#line 402 "../src/db/VideoTable.vala"
		_tmp12_ = stmt;
#line 402 "../src/db/VideoTable.vala"
		_tmp13_ = col;
#line 402 "../src/db/VideoTable.vala"
		col = _tmp13_ + 1;
#line 402 "../src/db/VideoTable.vala"
		_tmp14_ = g_file_get_path (file);
#line 402 "../src/db/VideoTable.vala"
		_tmp15_ = g_free;
#line 402 "../src/db/VideoTable.vala"
		res = sqlite3_bind_text (_tmp12_, _tmp13_, _tmp14_, -1, _tmp15_);
#line 403 "../src/db/VideoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2651 "VideoTable.c"
	}
#line 406 "../src/db/VideoTable.vala"
	if (md5 != NULL) {
#line 2655 "VideoTable.c"
		sqlite3_stmt* _tmp16_;
		gint _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		GDestroyNotify _tmp20_;
#line 407 "../src/db/VideoTable.vala"
		_tmp16_ = stmt;
#line 407 "../src/db/VideoTable.vala"
		_tmp17_ = col;
#line 407 "../src/db/VideoTable.vala"
		col = _tmp17_ + 1;
#line 407 "../src/db/VideoTable.vala"
		_tmp18_ = md5;
#line 407 "../src/db/VideoTable.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 407 "../src/db/VideoTable.vala"
		_tmp20_ = g_free;
#line 407 "../src/db/VideoTable.vala"
		res = sqlite3_bind_text (_tmp16_, _tmp17_, _tmp19_, -1, _tmp20_);
#line 408 "../src/db/VideoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2677 "VideoTable.c"
	}
#line 411 "../src/db/VideoTable.vala"
	result = stmt;
#line 411 "../src/db/VideoTable.vala"
	_g_free0 (sql);
#line 411 "../src/db/VideoTable.vala"
	return result;
#line 2685 "VideoTable.c"
}

gboolean
video_table_has_duplicate (VideoTable* self,
                           GFile* file,
                           const gchar* md5)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gboolean result;
#line 414 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 414 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 415 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 415 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 416 "../src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 416 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 418 "../src/db/VideoTable.vala"
	if (res == SQLITE_DONE) {
#line 420 "../src/db/VideoTable.vala"
		result = FALSE;
#line 420 "../src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 420 "../src/db/VideoTable.vala"
		return result;
#line 2718 "VideoTable.c"
	} else {
#line 421 "../src/db/VideoTable.vala"
		if (res == SQLITE_ROW) {
#line 423 "../src/db/VideoTable.vala"
			result = TRUE;
#line 423 "../src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 423 "../src/db/VideoTable.vala"
			return result;
#line 2728 "VideoTable.c"
		} else {
#line 425 "../src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", res);
#line 2732 "VideoTable.c"
		}
	}
#line 428 "../src/db/VideoTable.vala"
	result = FALSE;
#line 428 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 428 "../src/db/VideoTable.vala"
	return result;
#line 2741 "VideoTable.c"
}

static void
_vala_array_add4 (VideoID* * array,
                  gint* length,
                  gint* size,
                  const VideoID* value)
{
#line 438 "../src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 438 "../src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 438 "../src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2756 "VideoTable.c"
	}
#line 438 "../src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2760 "VideoTable.c"
}

VideoID*
video_table_get_duplicate_ids (VideoTable* self,
                               GFile* file,
                               const gchar* md5,
                               gint* result_length1)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	VideoID* ids = NULL;
	VideoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	VideoID* _tmp6_;
	gint _tmp6__length1;
	VideoID* result;
#line 431 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 431 "../src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 432 "../src/db/VideoTable.vala"
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
#line 432 "../src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 434 "../src/db/VideoTable.vala"
	_tmp1_ = g_new0 (VideoID, 0);
#line 434 "../src/db/VideoTable.vala"
	ids = _tmp1_;
#line 434 "../src/db/VideoTable.vala"
	ids_length1 = 0;
#line 434 "../src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 436 "../src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 436 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 437 "../src/db/VideoTable.vala"
	while (TRUE) {
#line 2802 "VideoTable.c"
		sqlite3_stmt* _tmp3_;
		VideoID _tmp4_ = {0};
		sqlite3_stmt* _tmp5_;
#line 437 "../src/db/VideoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 437 "../src/db/VideoTable.vala"
			break;
#line 2810 "VideoTable.c"
		}
#line 438 "../src/db/VideoTable.vala"
		_tmp3_ = stmt;
#line 438 "../src/db/VideoTable.vala"
		video_id_init (&_tmp4_, sqlite3_column_int64 (_tmp3_, 0));
#line 438 "../src/db/VideoTable.vala"
		_vala_array_add4 (&ids, &ids_length1, &_ids_size_, &_tmp4_);
#line 439 "../src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 439 "../src/db/VideoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 2822 "VideoTable.c"
	}
#line 442 "../src/db/VideoTable.vala"
	_tmp6_ = ids;
#line 442 "../src/db/VideoTable.vala"
	_tmp6__length1 = ids_length1;
#line 442 "../src/db/VideoTable.vala"
	if (result_length1) {
#line 442 "../src/db/VideoTable.vala"
		*result_length1 = _tmp6__length1;
#line 2832 "VideoTable.c"
	}
#line 442 "../src/db/VideoTable.vala"
	result = _tmp6_;
#line 442 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 442 "../src/db/VideoTable.vala"
	return result;
#line 2840 "VideoTable.c"
}

GeeArrayList*
video_table_get_event_source_ids (VideoTable* self,
                                  EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* result;
#line 445 "../src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 445 "../src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 447 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 447 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 447 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 447 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 447 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 448 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 450 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 450 "../src/db/VideoTable.vala"
	_tmp4_ = *event_id;
#line 450 "../src/db/VideoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 451 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 453 "../src/db/VideoTable.vala"
	_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 453 "../src/db/VideoTable.vala"
	_result_ = _tmp5_;
#line 2885 "VideoTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 454 "../src/db/VideoTable.vala"
		_tmp6_ = TRUE;
#line 454 "../src/db/VideoTable.vala"
		while (TRUE) {
#line 2892 "VideoTable.c"
			sqlite3_stmt* _tmp7_;
			GeeArrayList* _tmp8_;
			sqlite3_stmt* _tmp9_;
			VideoID _tmp10_ = {0};
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 454 "../src/db/VideoTable.vala"
			if (!_tmp6_) {
#line 2901 "VideoTable.c"
			}
#line 454 "../src/db/VideoTable.vala"
			_tmp6_ = FALSE;
#line 455 "../src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 455 "../src/db/VideoTable.vala"
			res = sqlite3_step (_tmp7_);
#line 456 "../src/db/VideoTable.vala"
			if (res == SQLITE_DONE) {
#line 457 "../src/db/VideoTable.vala"
				break;
#line 2913 "VideoTable.c"
			} else {
#line 458 "../src/db/VideoTable.vala"
				if (res != SQLITE_ROW) {
#line 459 "../src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 461 "../src/db/VideoTable.vala"
					break;
#line 2921 "VideoTable.c"
				}
			}
#line 464 "../src/db/VideoTable.vala"
			_tmp8_ = _result_;
#line 464 "../src/db/VideoTable.vala"
			_tmp9_ = stmt;
#line 464 "../src/db/VideoTable.vala"
			video_id_init (&_tmp10_, sqlite3_column_int64 (_tmp9_, 0));
#line 464 "../src/db/VideoTable.vala"
			_tmp11_ = video_id_upgrade_video_id_to_source_id (&_tmp10_);
#line 464 "../src/db/VideoTable.vala"
			_tmp12_ = _tmp11_;
#line 464 "../src/db/VideoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 464 "../src/db/VideoTable.vala"
			_g_free0 (_tmp12_);
#line 2938 "VideoTable.c"
		}
	}
#line 467 "../src/db/VideoTable.vala"
	result = _result_;
#line 467 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 467 "../src/db/VideoTable.vala"
	return result;
#line 2947 "VideoTable.c"
}

void
video_table_set_timestamp (VideoTable* self,
                           VideoID* video_id,
                           GDateTime* timestamp,
                           GError** error)
{
	VideoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 470 "../src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 470 "../src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 470 "../src/db/VideoTable.vala"
	g_return_if_fail (timestamp != NULL);
#line 471 "../src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 471 "../src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", g_date_time_to_unix (timestamp), &_inner_error0_);
#line 471 "../src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 471 "../src/db/VideoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 471 "../src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 471 "../src/db/VideoTable.vala"
			return;
#line 2976 "VideoTable.c"
		} else {
#line 471 "../src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 471 "../src/db/VideoTable.vala"
			g_clear_error (&_inner_error0_);
#line 471 "../src/db/VideoTable.vala"
			return;
#line 2984 "VideoTable.c"
		}
	}
}

void
video_table_upgrade_for_unset_timestamp (GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 476 "../src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 476 "../src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE VideoTable SET exposure_time = NULL WHERE exposure_time = '0'", -1, &_tmp1_, NULL);
#line 476 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 476 "../src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 476 "../src/db/VideoTable.vala"
	res = _tmp2_;
#line 477 "../src/db/VideoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 478 "../src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 478 "../src/db/VideoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 479 "../src/db/VideoTable.vala"
	if (res != SQLITE_DONE) {
#line 480 "../src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.upgrade_for_unset_timestamp", res, &_inner_error0_);
#line 480 "../src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 480 "../src/db/VideoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 480 "../src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 480 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 480 "../src/db/VideoTable.vala"
				return;
#line 3029 "VideoTable.c"
			} else {
#line 480 "../src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 480 "../src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 480 "../src/db/VideoTable.vala"
				g_clear_error (&_inner_error0_);
#line 480 "../src/db/VideoTable.vala"
				return;
#line 3039 "VideoTable.c"
			}
		}
	}
#line 474 "../src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 3045 "VideoTable.c"
}

static void
video_table_class_init (VideoTableClass * klass,
                        gpointer klass_data)
{
#line 59 "../src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/db/VideoTable.vala"
	((DatabaseTableClass *) klass)->finalize = video_table_finalize;
#line 3056 "VideoTable.c"
}

static void
video_table_instance_init (VideoTable * self,
                           gpointer klass)
{
}

static void
video_table_finalize (DatabaseTable * obj)
{
	VideoTable * self;
#line 59 "../src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_TABLE, VideoTable);
#line 59 "../src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 3073 "VideoTable.c"
}

static GType
video_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
	GType video_table_type_id;
	video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
	return video_table_type_id;
}

GType
video_table_get_type (void)
{
	static volatile gsize video_table_type_id__once = 0;
	if (g_once_init_enter (&video_table_type_id__once)) {
		GType video_table_type_id;
		video_table_type_id = video_table_get_type_once ();
		g_once_init_leave (&video_table_type_id__once, video_table_type_id);
	}
	return video_table_type_id__once;
}

