/* RGBHistogramManipulator.c generated by valac 0.56.3, the Vala compiler
 * generated from RGBHistogramManipulator.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "shotwell-graphics-processor.h"
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE 13
#define RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH (RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE / 2)
#define RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE 4
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_WIDTH (256 + (2 * RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH))
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT 4
#define RGB_HISTOGRAM_MANIPULATOR_TROUGH_BOTTOM_OFFSET 1
#define RGB_HISTOGRAM_MANIPULATOR_CONTROL_WIDTH (RGB_HISTOGRAM_MANIPULATOR_TROUGH_WIDTH + 2)
#define RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT 118
#define RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION (((((RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT - RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT) - RGB_HISTOGRAM_MANIPULATOR_TROUGH_BOTTOM_OFFSET) - ((RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE - RGB_HISTOGRAM_MANIPULATOR_TROUGH_HEIGHT) / 2)) - RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE) - 2)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_RGB_HISTOGRAM_MANIPULATOR (rgb_histogram_manipulator_get_type ())
#define RGB_HISTOGRAM_MANIPULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator))
#define RGB_HISTOGRAM_MANIPULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulatorClass))
#define IS_RGB_HISTOGRAM_MANIPULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR))
#define IS_RGB_HISTOGRAM_MANIPULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_HISTOGRAM_MANIPULATOR))
#define RGB_HISTOGRAM_MANIPULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulatorClass))

typedef struct _RGBHistogramManipulator RGBHistogramManipulator;
typedef struct _RGBHistogramManipulatorClass RGBHistogramManipulatorClass;
typedef struct _RGBHistogramManipulatorPrivate RGBHistogramManipulatorPrivate;
enum  {
	RGB_HISTOGRAM_MANIPULATOR_0_PROPERTY,
	RGB_HISTOGRAM_MANIPULATOR_NUM_PROPERTIES
};
static GParamSpec* rgb_histogram_manipulator_properties[RGB_HISTOGRAM_MANIPULATOR_NUM_PROPERTIES];
typedef enum  {
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH,
	RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA
} RGBHistogramManipulatorLocationCode;

#define RGB_HISTOGRAM_MANIPULATOR_TYPE_LOCATION_CODE (rgb_histogram_manipulator_location_code_get_type ())
#define _rgb_histogram_unref0(var) ((var == NULL) ? NULL : (var = (rgb_histogram_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL,
	RGB_HISTOGRAM_MANIPULATOR_NUM_SIGNALS
};
static guint rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RGBHistogramManipulator {
	GtkDrawingArea parent_instance;
	RGBHistogramManipulatorPrivate * priv;
};

struct _RGBHistogramManipulatorClass {
	GtkDrawingAreaClass parent_class;
};

struct _RGBHistogramManipulatorPrivate {
	gint left_nub_max;
	gint right_nub_min;
	RGBHistogram* histogram;
	gint left_nub_position;
	gint right_nub_position;
	gboolean is_left_nub_tracking;
	gboolean is_right_nub_tracking;
	gint track_start_x;
	gint track_nub_start_position;
	gint offset;
};

static gint RGBHistogramManipulator_private_offset;
static gpointer rgb_histogram_manipulator_parent_class = NULL;
static GtkWidgetPath* rgb_histogram_manipulator_slider_draw_path;
static GtkWidgetPath* rgb_histogram_manipulator_slider_draw_path = NULL;
static GtkWidgetPath* rgb_histogram_manipulator_frame_draw_path;
static GtkWidgetPath* rgb_histogram_manipulator_frame_draw_path = NULL;
static gboolean rgb_histogram_manipulator_paths_setup;
static gboolean rgb_histogram_manipulator_paths_setup = FALSE;

VALA_EXTERN GType rgb_histogram_manipulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RGBHistogramManipulator, g_object_unref)
static GType rgb_histogram_manipulator_location_code_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN RGBHistogramManipulator* rgb_histogram_manipulator_new (void);
VALA_EXTERN RGBHistogramManipulator* rgb_histogram_manipulator_construct (GType object_type);
static gboolean rgb_histogram_manipulator_on_button_press (RGBHistogramManipulator* self,
                                                    GdkEventButton* event_record);
static gboolean _rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
static gboolean rgb_histogram_manipulator_on_button_release (RGBHistogramManipulator* self,
                                                      GdkEventButton* event_record);
static gboolean _rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                       GdkEventButton* event,
                                                                                       gpointer self);
static gboolean rgb_histogram_manipulator_on_button_motion (RGBHistogramManipulator* self,
                                                     GdkEventMotion* event_record);
static gboolean _rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                     GdkEventMotion* event,
                                                                                     gpointer self);
static void rgb_histogram_manipulator_on_size_allocate (RGBHistogramManipulator* self,
                                                 GtkAllocation* region);
static void _rgb_histogram_manipulator_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                           GtkAllocation* allocation,
                                                                           gpointer self);
static RGBHistogramManipulatorLocationCode rgb_histogram_manipulator_hit_test_point (RGBHistogramManipulator* self,
                                                                              gint x,
                                                                              gint y);
static void rgb_histogram_manipulator_force_update (RGBHistogramManipulator* self);
static void rgb_histogram_manipulator_update_nub_extrema (RGBHistogramManipulator* self);
static gboolean rgb_histogram_manipulator_real_focus_out_event (GtkWidget* base,
                                                         GdkEventFocus* event);
static gboolean rgb_histogram_manipulator_real_key_press_event (GtkWidget* base,
                                                         GdkEventKey* event);
static gboolean rgb_histogram_manipulator_real_draw (GtkWidget* base,
                                              cairo_t* ctx);
static void rgb_histogram_manipulator_draw_histogram (RGBHistogramManipulator* self,
                                               cairo_t* ctx,
                                               GdkRectangle* area);
static void rgb_histogram_manipulator_draw_nub (RGBHistogramManipulator* self,
                                         cairo_t* ctx,
                                         GdkRectangle* area,
                                         gint position);
VALA_EXTERN void rgb_histogram_manipulator_update_histogram (RGBHistogramManipulator* self,
                                                 GdkPixbuf* source_pixbuf);
VALA_EXTERN gint rgb_histogram_manipulator_get_left_nub_position (RGBHistogramManipulator* self);
VALA_EXTERN gint rgb_histogram_manipulator_get_right_nub_position (RGBHistogramManipulator* self);
VALA_EXTERN void rgb_histogram_manipulator_set_left_nub_position (RGBHistogramManipulator* self,
                                                      gint user_nub_pos);
VALA_EXTERN void rgb_histogram_manipulator_set_right_nub_position (RGBHistogramManipulator* self,
                                                       gint user_nub_pos);
static void rgb_histogram_manipulator_finalize (GObject * obj);
static GType rgb_histogram_manipulator_get_type_once (void);

static inline gpointer
rgb_histogram_manipulator_get_instance_private (RGBHistogramManipulator* self)
{
	return G_STRUCT_MEMBER_P (self, RGBHistogramManipulator_private_offset);
}

static GType
rgb_histogram_manipulator_location_code_get_type_once (void)
{
	static const GEnumValue values[] = {{RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB", "left-nub"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB", "right-nub"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH", "left-trough"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH", "right-trough"}, {RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA, "RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA", "insensitive-area"}, {0, NULL, NULL}};
	GType rgb_histogram_manipulator_location_code_type_id;
	rgb_histogram_manipulator_location_code_type_id = g_enum_register_static ("RGBHistogramManipulatorLocationCode", values);
	return rgb_histogram_manipulator_location_code_type_id;
}

static GType
rgb_histogram_manipulator_location_code_get_type (void)
{
	static volatile gsize rgb_histogram_manipulator_location_code_type_id__once = 0;
	if (g_once_init_enter (&rgb_histogram_manipulator_location_code_type_id__once)) {
		GType rgb_histogram_manipulator_location_code_type_id;
		rgb_histogram_manipulator_location_code_type_id = rgb_histogram_manipulator_location_code_get_type_once ();
		g_once_init_leave (&rgb_histogram_manipulator_location_code_type_id__once, rgb_histogram_manipulator_location_code_type_id);
	}
	return rgb_histogram_manipulator_location_code_type_id__once;
}

static gboolean
_rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_press ((RGBHistogramManipulator*) self, event);
#line 57 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 198 "RGBHistogramManipulator.c"
}

static gboolean
_rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_release ((RGBHistogramManipulator*) self, event);
#line 58 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 210 "RGBHistogramManipulator.c"
}

static gboolean
_rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                            GdkEventMotion* event,
                                                                            gpointer self)
{
	gboolean result;
	result = rgb_histogram_manipulator_on_button_motion ((RGBHistogramManipulator*) self, event);
#line 59 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 222 "RGBHistogramManipulator.c"
}

static void
_rgb_histogram_manipulator_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self)
{
#line 61 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_on_size_allocate ((RGBHistogramManipulator*) self, allocation);
#line 232 "RGBHistogramManipulator.c"
}

RGBHistogramManipulator*
rgb_histogram_manipulator_construct (GType object_type)
{
	RGBHistogramManipulator * self = NULL;
#line 36 "../src/editing_tools/RGBHistogramManipulator.vala"
	self = (RGBHistogramManipulator*) g_object_new (object_type, NULL);
#line 37 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), RGB_HISTOGRAM_MANIPULATOR_CONTROL_WIDTH, RGB_HISTOGRAM_MANIPULATOR_CONTROL_HEIGHT);
#line 38 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
#line 40 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (!rgb_histogram_manipulator_paths_setup) {
#line 247 "RGBHistogramManipulator.c"
		GtkWidgetPath* _tmp0_;
		GtkWidgetPath* _tmp1_;
		GtkWidgetPath* _tmp2_;
		GtkWidgetPath* _tmp3_;
		GtkWidgetPath* _tmp4_;
#line 41 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = rgb_histogram_manipulator_slider_draw_path;
#line 41 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_widget_path_append_type (_tmp0_, gtk_scale_get_type ());
#line 42 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp1_ = rgb_histogram_manipulator_slider_draw_path;
#line 42 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_widget_path_iter_add_class (_tmp1_, 0, "scale");
#line 43 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp2_ = rgb_histogram_manipulator_slider_draw_path;
#line 43 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_widget_path_iter_add_class (_tmp2_, 0, "range");
#line 45 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp3_ = rgb_histogram_manipulator_frame_draw_path;
#line 45 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_widget_path_append_type (_tmp3_, gtk_frame_get_type ());
#line 46 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp4_ = rgb_histogram_manipulator_frame_draw_path;
#line 46 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_widget_path_iter_add_class (_tmp4_, 0, "default");
#line 48 "../src/editing_tools/RGBHistogramManipulator.vala"
		rgb_histogram_manipulator_paths_setup = TRUE;
#line 275 "RGBHistogramManipulator.c"
	}
#line 51 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) GDK_BUTTON_PRESS_MASK);
#line 52 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) GDK_BUTTON_RELEASE_MASK);
#line 53 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) GDK_BUTTON_MOTION_MASK);
#line 54 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) GDK_FOCUS_CHANGE_MASK);
#line 55 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) GDK_KEY_PRESS_MASK);
#line 57 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _rgb_histogram_manipulator_on_button_press_gtk_widget_button_press_event, self, 0);
#line 58 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "button-release-event", (GCallback) _rgb_histogram_manipulator_on_button_release_gtk_widget_button_release_event, self, 0);
#line 59 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "motion-notify-event", (GCallback) _rgb_histogram_manipulator_on_button_motion_gtk_widget_motion_notify_event, self, 0);
#line 61 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "size-allocate", (GCallback) _rgb_histogram_manipulator_on_size_allocate_gtk_widget_size_allocate, self, 0);
#line 36 "../src/editing_tools/RGBHistogramManipulator.vala"
	return self;
#line 297 "RGBHistogramManipulator.c"
}

RGBHistogramManipulator*
rgb_histogram_manipulator_new (void)
{
#line 36 "../src/editing_tools/RGBHistogramManipulator.vala"
	return rgb_histogram_manipulator_construct (TYPE_RGB_HISTOGRAM_MANIPULATOR);
#line 305 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_on_size_allocate (RGBHistogramManipulator* self,
                                            GtkAllocation* region)
{
	GtkAllocation _tmp0_;
#line 64 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 64 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (region != NULL);
#line 65 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = *region;
#line 65 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->offset = ((_tmp0_.width - RGB_HISTOGRAM_GRAPHIC_WIDTH) - RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) / 2;
#line 321 "RGBHistogramManipulator.c"
}

static RGBHistogramManipulatorLocationCode
rgb_histogram_manipulator_hit_test_point (RGBHistogramManipulator* self,
                                          gint x,
                                          gint y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	RGBHistogramManipulatorLocationCode result;
#line 68 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), 0);
#line 69 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (y < RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION) {
#line 70 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA;
#line 70 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 340 "RGBHistogramManipulator.c"
	}
#line 72 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (x > self->priv->left_nub_position) {
#line 72 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = x < (self->priv->left_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE);
#line 346 "RGBHistogramManipulator.c"
	} else {
#line 72 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = FALSE;
#line 350 "RGBHistogramManipulator.c"
	}
#line 72 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp0_) {
#line 73 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB;
#line 73 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 358 "RGBHistogramManipulator.c"
	}
#line 75 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (x > self->priv->right_nub_position) {
#line 75 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp1_ = x < (self->priv->right_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE);
#line 364 "RGBHistogramManipulator.c"
	} else {
#line 75 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp1_ = FALSE;
#line 368 "RGBHistogramManipulator.c"
	}
#line 75 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp1_) {
#line 76 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB;
#line 76 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 376 "RGBHistogramManipulator.c"
	}
#line 78 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (y < ((RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION + RGB_HISTOGRAM_MANIPULATOR_NUB_V_NUDGE) + 1)) {
#line 79 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_INSENSITIVE_AREA;
#line 79 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 384 "RGBHistogramManipulator.c"
	}
#line 81 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (((x - self->priv->left_nub_position) * (x - self->priv->left_nub_position)) < ((x - self->priv->right_nub_position) * (x - self->priv->right_nub_position))) {
#line 83 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH;
#line 83 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 392 "RGBHistogramManipulator.c"
	} else {
#line 85 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH;
#line 85 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 398 "RGBHistogramManipulator.c"
	}
}

static gboolean
rgb_histogram_manipulator_on_button_press (RGBHistogramManipulator* self,
                                           GdkEventButton* event_record)
{
	RGBHistogramManipulatorLocationCode loc = 0;
	gboolean retval = FALSE;
	gboolean result;
#line 88 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), FALSE);
#line 88 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 91 "../src/editing_tools/RGBHistogramManipulator.vala"
	event_record->x = event_record->x - self->priv->offset;
#line 92 "../src/editing_tools/RGBHistogramManipulator.vala"
	loc = rgb_histogram_manipulator_hit_test_point (self, (gint) event_record->x, (gint) event_record->y);
#line 93 "../src/editing_tools/RGBHistogramManipulator.vala"
	retval = TRUE;
#line 95 "../src/editing_tools/RGBHistogramManipulator.vala"
	switch (loc) {
#line 95 "../src/editing_tools/RGBHistogramManipulator.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_NUB:
#line 423 "RGBHistogramManipulator.c"
		{
#line 97 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->track_start_x = (gint) event_record->x;
#line 98 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->track_nub_start_position = self->priv->left_nub_position;
#line 99 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->is_left_nub_tracking = TRUE;
#line 100 "../src/editing_tools/RGBHistogramManipulator.vala"
			break;
#line 433 "RGBHistogramManipulator.c"
		}
#line 95 "../src/editing_tools/RGBHistogramManipulator.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_NUB:
#line 437 "RGBHistogramManipulator.c"
		{
#line 103 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->track_start_x = (gint) event_record->x;
#line 104 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->track_nub_start_position = self->priv->right_nub_position;
#line 105 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->is_right_nub_tracking = TRUE;
#line 106 "../src/editing_tools/RGBHistogramManipulator.vala"
			break;
#line 447 "RGBHistogramManipulator.c"
		}
#line 95 "../src/editing_tools/RGBHistogramManipulator.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_LEFT_TROUGH:
#line 451 "RGBHistogramManipulator.c"
		{
#line 109 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->left_nub_position = ((gint) event_record->x) - RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH;
#line 110 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->left_nub_position = CLAMP (self->priv->left_nub_position, 0, self->priv->left_nub_max);
#line 111 "../src/editing_tools/RGBHistogramManipulator.vala"
			rgb_histogram_manipulator_force_update (self);
#line 112 "../src/editing_tools/RGBHistogramManipulator.vala"
			g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 113 "../src/editing_tools/RGBHistogramManipulator.vala"
			rgb_histogram_manipulator_update_nub_extrema (self);
#line 114 "../src/editing_tools/RGBHistogramManipulator.vala"
			break;
#line 465 "RGBHistogramManipulator.c"
		}
#line 95 "../src/editing_tools/RGBHistogramManipulator.vala"
		case RGB_HISTOGRAM_MANIPULATOR_LOCATION_CODE_RIGHT_TROUGH:
#line 469 "RGBHistogramManipulator.c"
		{
#line 117 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->right_nub_position = ((gint) event_record->x) - RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH;
#line 118 "../src/editing_tools/RGBHistogramManipulator.vala"
			self->priv->right_nub_position = CLAMP (self->priv->right_nub_position, self->priv->right_nub_min, 255);
#line 119 "../src/editing_tools/RGBHistogramManipulator.vala"
			rgb_histogram_manipulator_force_update (self);
#line 120 "../src/editing_tools/RGBHistogramManipulator.vala"
			g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 121 "../src/editing_tools/RGBHistogramManipulator.vala"
			rgb_histogram_manipulator_update_nub_extrema (self);
#line 122 "../src/editing_tools/RGBHistogramManipulator.vala"
			break;
#line 483 "RGBHistogramManipulator.c"
		}
		default:
		{
#line 125 "../src/editing_tools/RGBHistogramManipulator.vala"
			retval = FALSE;
#line 126 "../src/editing_tools/RGBHistogramManipulator.vala"
			break;
#line 491 "RGBHistogramManipulator.c"
		}
	}
#line 130 "../src/editing_tools/RGBHistogramManipulator.vala"
	event_record->x = event_record->x + self->priv->offset;
#line 132 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = retval;
#line 132 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 500 "RGBHistogramManipulator.c"
}

static gboolean
rgb_histogram_manipulator_on_button_release (RGBHistogramManipulator* self,
                                             GdkEventButton* event_record)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 135 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), FALSE);
#line 135 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 136 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (self->priv->is_left_nub_tracking) {
#line 136 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = TRUE;
#line 517 "RGBHistogramManipulator.c"
	} else {
#line 136 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = self->priv->is_right_nub_tracking;
#line 521 "RGBHistogramManipulator.c"
	}
#line 136 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp0_) {
#line 137 "../src/editing_tools/RGBHistogramManipulator.vala"
		g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 138 "../src/editing_tools/RGBHistogramManipulator.vala"
		rgb_histogram_manipulator_update_nub_extrema (self);
#line 529 "RGBHistogramManipulator.c"
	}
#line 141 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->is_left_nub_tracking = FALSE;
#line 142 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->is_right_nub_tracking = FALSE;
#line 144 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = FALSE;
#line 144 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 539 "RGBHistogramManipulator.c"
}

static gboolean
rgb_histogram_manipulator_on_button_motion (RGBHistogramManipulator* self,
                                            GdkEventMotion* event_record)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 147 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), FALSE);
#line 147 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (event_record != NULL, FALSE);
#line 148 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (!self->priv->is_left_nub_tracking) {
#line 148 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = !self->priv->is_right_nub_tracking;
#line 556 "RGBHistogramManipulator.c"
	} else {
#line 148 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = FALSE;
#line 560 "RGBHistogramManipulator.c"
	}
#line 148 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp0_) {
#line 149 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = FALSE;
#line 149 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 568 "RGBHistogramManipulator.c"
	}
#line 151 "../src/editing_tools/RGBHistogramManipulator.vala"
	event_record->x = event_record->x - self->priv->offset;
#line 152 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (self->priv->is_left_nub_tracking) {
#line 574 "RGBHistogramManipulator.c"
		gint track_x_delta = 0;
#line 153 "../src/editing_tools/RGBHistogramManipulator.vala"
		track_x_delta = ((gint) event_record->x) - self->priv->track_start_x;
#line 154 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->left_nub_position = self->priv->track_nub_start_position + track_x_delta;
#line 155 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->left_nub_position = CLAMP (self->priv->left_nub_position, 0, self->priv->left_nub_max);
#line 582 "RGBHistogramManipulator.c"
	} else {
		gint track_x_delta = 0;
#line 157 "../src/editing_tools/RGBHistogramManipulator.vala"
		track_x_delta = ((gint) event_record->x) - self->priv->track_start_x;
#line 158 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->right_nub_position = self->priv->track_nub_start_position + track_x_delta;
#line 159 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->right_nub_position = CLAMP (self->priv->right_nub_position, self->priv->right_nub_min, 255);
#line 591 "RGBHistogramManipulator.c"
	}
#line 162 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_force_update (self);
#line 163 "../src/editing_tools/RGBHistogramManipulator.vala"
	event_record->x = event_record->x + self->priv->offset;
#line 165 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = TRUE;
#line 165 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 601 "RGBHistogramManipulator.c"
}

static gboolean
rgb_histogram_manipulator_real_focus_out_event (GtkWidget* base,
                                                GdkEventFocus* event)
{
	RGBHistogramManipulator * self;
	gboolean result;
#line 168 "../src/editing_tools/RGBHistogramManipulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator);
#line 168 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 169 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (GTK_WIDGET_CLASS (rgb_histogram_manipulator_parent_class)->focus_out_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), gtk_widget_get_type (), GtkWidget), event)) {
#line 170 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = TRUE;
#line 170 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 620 "RGBHistogramManipulator.c"
	}
#line 173 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 175 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = FALSE;
#line 175 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 628 "RGBHistogramManipulator.c"
}

static gboolean
rgb_histogram_manipulator_real_key_press_event (GtkWidget* base,
                                                GdkEventKey* event)
{
	RGBHistogramManipulator * self;
	gint delta = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 178 "../src/editing_tools/RGBHistogramManipulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator);
#line 178 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 179 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (GTK_WIDGET_CLASS (rgb_histogram_manipulator_parent_class)->key_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), gtk_widget_get_type (), GtkWidget), event)) {
#line 180 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = TRUE;
#line 180 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 650 "RGBHistogramManipulator.c"
	}
#line 183 "../src/editing_tools/RGBHistogramManipulator.vala"
	delta = 0;
#line 185 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (event->keyval == GDK_KEY_Left) {
#line 185 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = TRUE;
#line 658 "RGBHistogramManipulator.c"
	} else {
#line 185 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = event->keyval == GDK_KEY_Up;
#line 662 "RGBHistogramManipulator.c"
	}
#line 185 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp0_) {
#line 186 "../src/editing_tools/RGBHistogramManipulator.vala"
		delta = -1;
#line 668 "RGBHistogramManipulator.c"
	}
#line 189 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (event->keyval == GDK_KEY_Right) {
#line 189 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp1_ = TRUE;
#line 674 "RGBHistogramManipulator.c"
	} else {
#line 189 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp1_ = event->keyval == GDK_KEY_Down;
#line 678 "RGBHistogramManipulator.c"
	}
#line 189 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp1_) {
#line 190 "../src/editing_tools/RGBHistogramManipulator.vala"
		delta = 1;
#line 684 "RGBHistogramManipulator.c"
	}
#line 193 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (!((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)) {
#line 194 "../src/editing_tools/RGBHistogramManipulator.vala"
		delta *= 5;
#line 690 "RGBHistogramManipulator.c"
	}
#line 197 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (delta == 0) {
#line 198 "../src/editing_tools/RGBHistogramManipulator.vala"
		result = FALSE;
#line 198 "../src/editing_tools/RGBHistogramManipulator.vala"
		return result;
#line 698 "RGBHistogramManipulator.c"
	}
#line 201 "../src/editing_tools/RGBHistogramManipulator.vala"
	if ((event->state & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
#line 202 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->right_nub_position = self->priv->right_nub_position + delta;
#line 203 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->right_nub_position = CLAMP (self->priv->right_nub_position, self->priv->right_nub_min, 255);
#line 706 "RGBHistogramManipulator.c"
	} else {
#line 205 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->left_nub_position = self->priv->left_nub_position + delta;
#line 206 "../src/editing_tools/RGBHistogramManipulator.vala"
		self->priv->left_nub_position = CLAMP (self->priv->left_nub_position, 0, self->priv->left_nub_max);
#line 712 "RGBHistogramManipulator.c"
	}
#line 210 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_signal_emit (self, rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL], 0);
#line 211 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_update_nub_extrema (self);
#line 212 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_force_update (self);
#line 214 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = TRUE;
#line 214 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 724 "RGBHistogramManipulator.c"
}

static gboolean
rgb_histogram_manipulator_real_draw (GtkWidget* base,
                                     cairo_t* ctx)
{
	RGBHistogramManipulator * self;
	GtkBorder padding = {0};
	GtkStyleContext* _tmp0_;
	GtkBorder _tmp1_ = {0};
	GdkRectangle area = {0};
	GtkBorder _tmp2_;
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	gboolean result;
#line 217 "../src/editing_tools/RGBHistogramManipulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator);
#line 217 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 218 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 218 "../src/editing_tools/RGBHistogramManipulator.vala"
	gtk_style_context_get_padding (_tmp0_, GTK_STATE_FLAG_NORMAL, &_tmp1_);
#line 218 "../src/editing_tools/RGBHistogramManipulator.vala"
	padding = _tmp1_;
#line 220 "../src/editing_tools/RGBHistogramManipulator.vala"
	memset (&area, 0, sizeof (GdkRectangle));
#line 221 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp2_ = padding;
#line 221 "../src/editing_tools/RGBHistogramManipulator.vala"
	area.x = _tmp2_.left + self->priv->offset;
#line 222 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp3_ = padding;
#line 222 "../src/editing_tools/RGBHistogramManipulator.vala"
	area.y = (gint) _tmp3_.top;
#line 223 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp4_ = padding;
#line 223 "../src/editing_tools/RGBHistogramManipulator.vala"
	area.width = RGB_HISTOGRAM_GRAPHIC_WIDTH + _tmp4_.right;
#line 224 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp5_ = padding;
#line 224 "../src/editing_tools/RGBHistogramManipulator.vala"
	area.height = RGB_HISTOGRAM_GRAPHIC_HEIGHT + _tmp5_.bottom;
#line 226 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "has-focus", &_tmp6_, NULL);
#line 226 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp7_ = _tmp6_;
#line 226 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp7_) {
#line 780 "RGBHistogramManipulator.c"
		GtkStyleContext* _tmp8_;
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_;
		GdkRectangle _tmp11_;
		GdkRectangle _tmp12_;
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp8_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp9_ = area;
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp10_ = area;
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp11_ = area;
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp12_ = area;
#line 227 "../src/editing_tools/RGBHistogramManipulator.vala"
		gtk_render_focus (_tmp8_, ctx, (gdouble) _tmp9_.x, (gdouble) _tmp10_.y, (gdouble) (_tmp11_.width + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE), (gdouble) ((_tmp12_.height + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH));
#line 798 "RGBHistogramManipulator.c"
	}
#line 232 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp13_ = area;
#line 232 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_draw_histogram (self, ctx, &_tmp13_);
#line 233 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp14_ = area;
#line 233 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_draw_nub (self, ctx, &_tmp14_, self->priv->left_nub_position);
#line 234 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp15_ = area;
#line 234 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_draw_nub (self, ctx, &_tmp15_, self->priv->right_nub_position);
#line 236 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = TRUE;
#line 236 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 816 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_draw_histogram (RGBHistogramManipulator* self,
                                          cairo_t* ctx,
                                          GdkRectangle* area)
{
	RGBHistogram* _tmp0_;
	GdkPixbuf* histogram_graphic = NULL;
	RGBHistogram* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
#line 239 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 239 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (ctx != NULL);
#line 239 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (area != NULL);
#line 240 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = self->priv->histogram;
#line 240 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (_tmp0_ == NULL) {
#line 241 "../src/editing_tools/RGBHistogramManipulator.vala"
		return;
#line 843 "RGBHistogramManipulator.c"
	}
#line 243 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp1_ = self->priv->histogram;
#line 243 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp2_ = rgb_histogram_get_graphic (_tmp1_);
#line 243 "../src/editing_tools/RGBHistogramManipulator.vala"
	histogram_graphic = _tmp2_;
#line 245 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp3_ = histogram_graphic;
#line 245 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp4_ = *area;
#line 245 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp5_ = *area;
#line 245 "../src/editing_tools/RGBHistogramManipulator.vala"
	gdk_cairo_set_source_pixbuf (ctx, _tmp3_, (gdouble) (_tmp4_.x + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH), (gdouble) (_tmp5_.y + 2));
#line 246 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_paint (ctx);
#line 248 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (self->priv->left_nub_position > 0) {
#line 863 "RGBHistogramManipulator.c"
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		GdkPixbuf* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp6_ = *area;
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp7_ = *area;
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp8_ = histogram_graphic;
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp9_ = gdk_pixbuf_get_height (_tmp8_);
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp10_ = _tmp9_;
#line 249 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_rectangle (ctx, (gdouble) (_tmp6_.x + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH), (gdouble) (_tmp7_.y + 2), (gdouble) self->priv->left_nub_position, (gdouble) _tmp10_);
#line 252 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.45);
#line 253 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_fill (ctx);
#line 885 "RGBHistogramManipulator.c"
	}
#line 256 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (self->priv->right_nub_position < 255) {
#line 889 "RGBHistogramManipulator.c"
		GdkRectangle _tmp11_;
		GdkRectangle _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp11_ = *area;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp12_ = *area;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp13_ = histogram_graphic;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp15_ = _tmp14_;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp16_ = histogram_graphic;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp18_ = _tmp17_;
#line 257 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_rectangle (ctx, (gdouble) ((_tmp11_.x + self->priv->right_nub_position) + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH), (gdouble) (_tmp12_.y + 2), (gdouble) (_tmp15_ - self->priv->right_nub_position), (gdouble) _tmp18_);
#line 261 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_set_source_rgba (ctx, 1.0, 1.0, 1.0, 0.45);
#line 262 "../src/editing_tools/RGBHistogramManipulator.vala"
		cairo_fill (ctx);
#line 920 "RGBHistogramManipulator.c"
	}
#line 239 "../src/editing_tools/RGBHistogramManipulator.vala"
	_g_object_unref0 (histogram_graphic);
#line 924 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_draw_nub (RGBHistogramManipulator* self,
                                    cairo_t* ctx,
                                    GdkRectangle* area,
                                    gint position)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
#line 266 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 266 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (ctx != NULL);
#line 266 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (area != NULL);
#line 267 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = *area;
#line 267 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp1_ = *area;
#line 267 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_move_to (ctx, (gdouble) (_tmp0_.x + position), (gdouble) ((_tmp1_.y + RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION) + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE));
#line 268 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp2_ = *area;
#line 268 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp3_ = *area;
#line 268 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_line_to (ctx, (gdouble) ((_tmp2_.x + position) + RGB_HISTOGRAM_MANIPULATOR_NUB_HALF_WIDTH), (gdouble) (_tmp3_.y + RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION));
#line 269 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp4_ = *area;
#line 269 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp5_ = *area;
#line 269 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_line_to (ctx, (gdouble) ((_tmp4_.x + position) + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE), (gdouble) ((_tmp5_.y + RGB_HISTOGRAM_MANIPULATOR_NUB_V_POSITION) + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE));
#line 270 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_close_path (ctx);
#line 271 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_set_source_rgb (ctx, 0.333, 0.333, 0.333);
#line 272 "../src/editing_tools/RGBHistogramManipulator.vala"
	cairo_fill (ctx);
#line 969 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_force_update (RGBHistogramManipulator* self)
{
	GdkWindow* _tmp0_;
#line 275 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 276 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 276 "../src/editing_tools/RGBHistogramManipulator.vala"
	gdk_window_invalidate_rect (_tmp0_, NULL, TRUE);
#line 982 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_update_nub_extrema (RGBHistogramManipulator* self)
{
#line 279 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 280 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->right_nub_min = (self->priv->left_nub_position + RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) + 1;
#line 281 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->left_nub_max = (self->priv->right_nub_position - RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) - 1;
#line 994 "RGBHistogramManipulator.c"
}

void
rgb_histogram_manipulator_update_histogram (RGBHistogramManipulator* self,
                                            GdkPixbuf* source_pixbuf)
{
	RGBHistogram* _tmp0_;
#line 286 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 286 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source_pixbuf, gdk_pixbuf_get_type ()));
#line 287 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = rgb_histogram_new (source_pixbuf);
#line 287 "../src/editing_tools/RGBHistogramManipulator.vala"
	_rgb_histogram_unref0 (self->priv->histogram);
#line 287 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->histogram = _tmp0_;
#line 288 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_force_update (self);
#line 1014 "RGBHistogramManipulator.c"
}

gint
rgb_histogram_manipulator_get_left_nub_position (RGBHistogramManipulator* self)
{
	gint result;
#line 291 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), 0);
#line 292 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = self->priv->left_nub_position;
#line 292 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 1027 "RGBHistogramManipulator.c"
}

gint
rgb_histogram_manipulator_get_right_nub_position (RGBHistogramManipulator* self)
{
	gint result;
#line 295 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_val_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self), 0);
#line 296 "../src/editing_tools/RGBHistogramManipulator.vala"
	result = self->priv->right_nub_position;
#line 296 "../src/editing_tools/RGBHistogramManipulator.vala"
	return result;
#line 1040 "RGBHistogramManipulator.c"
}

void
rgb_histogram_manipulator_set_left_nub_position (RGBHistogramManipulator* self,
                                                 gint user_nub_pos)
{
	gboolean _tmp0_ = FALSE;
#line 299 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 300 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (user_nub_pos >= 0) {
#line 300 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = user_nub_pos <= 255;
#line 1054 "RGBHistogramManipulator.c"
	} else {
#line 300 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = FALSE;
#line 1058 "RGBHistogramManipulator.c"
	}
#line 300 "../src/editing_tools/RGBHistogramManipulator.vala"
	_vala_assert (_tmp0_, "(user_nub_pos >= 0) && (user_nub_pos <= 255)");
#line 301 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->left_nub_position = CLAMP (user_nub_pos, 0, self->priv->left_nub_max);
#line 302 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_update_nub_extrema (self);
#line 1066 "RGBHistogramManipulator.c"
}

void
rgb_histogram_manipulator_set_right_nub_position (RGBHistogramManipulator* self,
                                                  gint user_nub_pos)
{
	gboolean _tmp0_ = FALSE;
#line 305 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_return_if_fail (IS_RGB_HISTOGRAM_MANIPULATOR (self));
#line 306 "../src/editing_tools/RGBHistogramManipulator.vala"
	if (user_nub_pos >= 0) {
#line 306 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = user_nub_pos <= 255;
#line 1080 "RGBHistogramManipulator.c"
	} else {
#line 306 "../src/editing_tools/RGBHistogramManipulator.vala"
		_tmp0_ = FALSE;
#line 1084 "RGBHistogramManipulator.c"
	}
#line 306 "../src/editing_tools/RGBHistogramManipulator.vala"
	_vala_assert (_tmp0_, "(user_nub_pos >= 0) && (user_nub_pos <= 255)");
#line 307 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->right_nub_position = CLAMP (user_nub_pos, self->priv->right_nub_min, 255);
#line 308 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_update_nub_extrema (self);
#line 1092 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_class_init (RGBHistogramManipulatorClass * klass,
                                      gpointer klass_data)
{
	GtkWidgetPath* _tmp0_;
	GtkWidgetPath* _tmp1_;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	g_type_class_adjust_private_offset (klass, &RGBHistogramManipulator_private_offset);
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) rgb_histogram_manipulator_real_focus_out_event;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) rgb_histogram_manipulator_real_key_press_event;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) rgb_histogram_manipulator_real_draw;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	G_OBJECT_CLASS (klass)->finalize = rgb_histogram_manipulator_finalize;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_signals[RGB_HISTOGRAM_MANIPULATOR_NUB_POSITION_CHANGED_SIGNAL] = g_signal_new ("nub-position-changed", TYPE_RGB_HISTOGRAM_MANIPULATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp0_ = gtk_widget_path_new ();
#line 23 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_slider_draw_path = _tmp0_;
#line 24 "../src/editing_tools/RGBHistogramManipulator.vala"
	_tmp1_ = gtk_widget_path_new ();
#line 24 "../src/editing_tools/RGBHistogramManipulator.vala"
	rgb_histogram_manipulator_frame_draw_path = _tmp1_;
#line 1123 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_instance_init (RGBHistogramManipulator * self,
                                         gpointer klass)
{
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv = rgb_histogram_manipulator_get_instance_private (self);
#line 20 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->left_nub_max = (255 - RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE) - 1;
#line 21 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->right_nub_min = RGB_HISTOGRAM_MANIPULATOR_NUB_SIZE + 1;
#line 27 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->histogram = NULL;
#line 28 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->left_nub_position = 0;
#line 29 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->right_nub_position = 255;
#line 30 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->is_left_nub_tracking = FALSE;
#line 31 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->is_right_nub_tracking = FALSE;
#line 32 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->track_start_x = 0;
#line 33 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->track_nub_start_position = 0;
#line 34 "../src/editing_tools/RGBHistogramManipulator.vala"
	self->priv->offset = 0;
#line 1152 "RGBHistogramManipulator.c"
}

static void
rgb_histogram_manipulator_finalize (GObject * obj)
{
	RGBHistogramManipulator * self;
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator);
#line 27 "../src/editing_tools/RGBHistogramManipulator.vala"
	_rgb_histogram_unref0 (self->priv->histogram);
#line 7 "../src/editing_tools/RGBHistogramManipulator.vala"
	G_OBJECT_CLASS (rgb_histogram_manipulator_parent_class)->finalize (obj);
#line 1165 "RGBHistogramManipulator.c"
}

static GType
rgb_histogram_manipulator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RGBHistogramManipulatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rgb_histogram_manipulator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RGBHistogramManipulator), 0, (GInstanceInitFunc) rgb_histogram_manipulator_instance_init, NULL };
	GType rgb_histogram_manipulator_type_id;
	rgb_histogram_manipulator_type_id = g_type_register_static (gtk_drawing_area_get_type (), "RGBHistogramManipulator", &g_define_type_info, 0);
	RGBHistogramManipulator_private_offset = g_type_add_instance_private (rgb_histogram_manipulator_type_id, sizeof (RGBHistogramManipulatorPrivate));
	return rgb_histogram_manipulator_type_id;
}

GType
rgb_histogram_manipulator_get_type (void)
{
	static volatile gsize rgb_histogram_manipulator_type_id__once = 0;
	if (g_once_init_enter (&rgb_histogram_manipulator_type_id__once)) {
		GType rgb_histogram_manipulator_type_id;
		rgb_histogram_manipulator_type_id = rgb_histogram_manipulator_get_type_once ();
		g_once_init_leave (&rgb_histogram_manipulator_type_id__once, rgb_histogram_manipulator_type_id);
	}
	return rgb_histogram_manipulator_type_id__once;
}

