/* PhotoFileAdapter.c generated by valac 0.56.3, the Vala compiler
 * generated from PhotoFileAdapter.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/**/
/* PhotoFileAdapter*/
/**/
/* PhotoFileAdapter (and its immediate children, PhotoFileReader and PhotoFileWriter) are drivers*/
/* hiding details of reading and writing image files and their metadata.  They should keep*/
/* minimal state beyond the filename, if any stat at all.  In particular, they should avoid caching*/
/* values, especially the readers, as writers may be created at any time and invalidate that*/
/* information, unless the readers monitor the file for these changes.*/
/**/
/* PhotoFileAdapters should be entirely thread-safe.  They are not, however, responsible for*/
/* atomicity on the filesystem.*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>
#include "metadata.h"
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;
typedef struct _PhotoFileAdapterPrivate PhotoFileAdapterPrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecPhotoFileAdapter ParamSpecPhotoFileAdapter;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoFileReaderPrivate PhotoFileReaderPrivate;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
typedef enum  {
	PHOTO_FILE_READER_ROLE_DEFAULT,
	PHOTO_FILE_READER_ROLE_THUMBNAIL
} PhotoFileReaderRole;

#define PHOTO_FILE_READER_TYPE_ROLE (photo_file_reader_role_get_type ())

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define TYPE_PHOTO_FORMAT_ERROR (photo_format_error_get_type ())
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
typedef struct _PhotoFileWriterPrivate PhotoFileWriterPrivate;
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
typedef struct _PhotoFileMetadataWriterPrivate PhotoFileMetadataWriterPrivate;

struct _PhotoFileAdapter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoFileAdapterPrivate * priv;
};

struct _PhotoFileAdapterClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoFileAdapter *self);
};

struct _PhotoFileAdapterPrivate {
	gchar* filepath;
	PhotoFileFormat file_format;
	GFile* file;
	GRecMutex __lock_file;
};

struct _ParamSpecPhotoFileAdapter {
	GParamSpec parent_instance;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoFileReader {
	PhotoFileAdapter parent_instance;
	PhotoFileReaderPrivate * priv;
};

struct _PhotoFileReaderClass {
	PhotoFileAdapterClass parent_class;
	PhotoMetadata* (*read_metadata) (PhotoFileReader* self, GError** error);
	GdkPixbuf* (*unscaled_read) (PhotoFileReader* self, GError** error);
	GdkPixbuf* (*scaled_read) (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
};

struct _PhotoFileReaderPrivate {
	PhotoFileReaderRole role;
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()

struct _PhotoFileWriter {
	PhotoFileAdapter parent_instance;
	PhotoFileWriterPrivate * priv;
};

struct _PhotoFileWriterClass {
	PhotoFileAdapterClass parent_class;
	void (*write) (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
};

struct _PhotoFileMetadataWriter {
	PhotoFileAdapter parent_instance;
	PhotoFileMetadataWriterPrivate * priv;
};

struct _PhotoFileMetadataWriterClass {
	PhotoFileAdapterClass parent_class;
	void (*write_metadata) (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
};

static gint PhotoFileAdapter_private_offset;
static gpointer photo_file_adapter_parent_class = NULL;
static gint PhotoFileReader_private_offset;
static gpointer photo_file_reader_parent_class = NULL;
static gpointer photo_file_writer_parent_class = NULL;
static gpointer photo_file_metadata_writer_parent_class = NULL;

VALA_EXTERN gpointer photo_file_adapter_ref (gpointer instance);
VALA_EXTERN void photo_file_adapter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_adapter (const GValue* value);
VALA_EXTERN GType photo_file_adapter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileAdapter, photo_file_adapter_unref)
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoFileAdapter* photo_file_adapter_construct (GType object_type,
                                                const gchar* filepath,
                                                PhotoFileFormat file_format);
VALA_EXTERN gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
VALA_EXTERN gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
VALA_EXTERN GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
VALA_EXTERN PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static void photo_file_adapter_finalize (PhotoFileAdapter * obj);
static GType photo_file_adapter_get_type_once (void);
VALA_EXTERN GType photo_file_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileReader, photo_file_adapter_unref)
VALA_EXTERN GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN GType photo_file_reader_role_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
VALA_EXTERN GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
VALA_EXTERN GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
VALA_EXTERN PhotoFileReader* photo_file_reader_construct (GType object_type,
                                              const gchar* filepath,
                                              PhotoFileFormat file_format);
VALA_EXTERN GType photo_file_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileWriter, photo_file_adapter_unref)
VALA_EXTERN GQuark photo_format_error_quark (void);
GType photo_format_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoFileWriter* photo_file_reader_create_writer (PhotoFileReader* self,
                                                  GError** error);
VALA_EXTERN PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
VALA_EXTERN GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileMetadataWriter, photo_file_adapter_unref)
VALA_EXTERN PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
VALA_EXTERN PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
static PhotoMetadata* photo_file_reader_real_read_metadata (PhotoFileReader* self,
                                                     GError** error);
static GdkPixbuf* photo_file_reader_real_unscaled_read (PhotoFileReader* self,
                                                 GError** error);
static GdkPixbuf* photo_file_reader_real_scaled_read (PhotoFileReader* self,
                                               Dimensions* full,
                                               Dimensions* scaled,
                                               GError** error);
VALA_EXTERN GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf,
                          Dimensions* resized,
                          GdkInterpType interp);
VALA_EXTERN void photo_file_reader_set_role (PhotoFileReader* self,
                                 PhotoFileReaderRole role);
VALA_EXTERN PhotoFileReaderRole photo_file_reader_get_role (PhotoFileReader* self);
static void photo_file_reader_finalize (PhotoFileAdapter * obj);
static GType photo_file_reader_get_type_once (void);
VALA_EXTERN GType jpeg_quality_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
VALA_EXTERN PhotoFileWriter* photo_file_writer_construct (GType object_type,
                                              const gchar* filepath,
                                              PhotoFileFormat file_format);
VALA_EXTERN PhotoFileReader* photo_file_writer_create_reader (PhotoFileWriter* self);
VALA_EXTERN PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
static void photo_file_writer_real_write (PhotoFileWriter* self,
                                   GdkPixbuf* pixbuf,
                                   JpegQuality quality,
                                   GError** error);
static GType photo_file_writer_get_type_once (void);
VALA_EXTERN void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
VALA_EXTERN PhotoFileMetadataWriter* photo_file_metadata_writer_construct (GType object_type,
                                                               const gchar* filepath,
                                                               PhotoFileFormat file_format);
VALA_EXTERN PhotoFileReader* photo_file_metadata_writer_create_reader (PhotoFileMetadataWriter* self);
static void photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self,
                                                     PhotoMetadata* metadata,
                                                     GError** error);
static GType photo_file_metadata_writer_get_type_once (void);

static inline gpointer
photo_file_adapter_get_instance_private (PhotoFileAdapter* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoFileAdapter_private_offset);
}

PhotoFileAdapter*
photo_file_adapter_construct (GType object_type,
                              const gchar* filepath,
                              PhotoFileFormat file_format)
{
	PhotoFileAdapter* self = NULL;
	gchar* _tmp0_;
#line 25 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 25 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileAdapter*) g_type_create_instance (object_type);
#line 26 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = g_strdup (filepath);
#line 26 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (self->priv->filepath);
#line 26 "../src/photos/PhotoFileAdapter.vala"
	self->priv->filepath = _tmp0_;
#line 27 "../src/photos/PhotoFileAdapter.vala"
	self->priv->file_format = file_format;
#line 25 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 338 "PhotoFileAdapter.c"
}

gboolean
photo_file_adapter_file_exists (PhotoFileAdapter* self)
{
	const gchar* _tmp0_;
	gboolean result;
#line 30 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), FALSE);
#line 31 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = self->priv->filepath;
#line 31 "../src/photos/PhotoFileAdapter.vala"
	result = g_file_test (_tmp0_, G_FILE_TEST_IS_REGULAR);
#line 31 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 354 "PhotoFileAdapter.c"
}

gchar*
photo_file_adapter_get_filepath (PhotoFileAdapter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 34 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), NULL);
#line 35 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = self->priv->filepath;
#line 35 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 35 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp1_;
#line 35 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 373 "PhotoFileAdapter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/photos/PhotoFileAdapter.vala"
	return self ? g_object_ref (self) : NULL;
#line 381 "PhotoFileAdapter.c"
}

GFile*
photo_file_adapter_get_file (PhotoFileAdapter* self)
{
	GFile* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 38 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), NULL);
#line 392 "PhotoFileAdapter.c"
	{
		GFile* _tmp0_;
#line 40 "../src/photos/PhotoFileAdapter.vala"
		_tmp0_ = self->priv->file;
#line 40 "../src/photos/PhotoFileAdapter.vala"
		g_rec_mutex_lock (&self->priv->__lock_file);
#line 399 "PhotoFileAdapter.c"
		{
			GFile* _tmp1_;
			GFile* _tmp4_;
			GFile* _tmp5_;
#line 41 "../src/photos/PhotoFileAdapter.vala"
			_tmp1_ = self->priv->file;
#line 41 "../src/photos/PhotoFileAdapter.vala"
			if (_tmp1_ == NULL) {
#line 408 "PhotoFileAdapter.c"
				const gchar* _tmp2_;
				GFile* _tmp3_;
#line 42 "../src/photos/PhotoFileAdapter.vala"
				_tmp2_ = self->priv->filepath;
#line 42 "../src/photos/PhotoFileAdapter.vala"
				_tmp3_ = g_file_new_for_path (_tmp2_);
#line 42 "../src/photos/PhotoFileAdapter.vala"
				_g_object_unref0 (self->priv->file);
#line 42 "../src/photos/PhotoFileAdapter.vala"
				self->priv->file = _tmp3_;
#line 419 "PhotoFileAdapter.c"
			}
#line 44 "../src/photos/PhotoFileAdapter.vala"
			_tmp4_ = self->priv->file;
#line 44 "../src/photos/PhotoFileAdapter.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 44 "../src/photos/PhotoFileAdapter.vala"
			_g_object_unref0 (_result_);
#line 44 "../src/photos/PhotoFileAdapter.vala"
			_result_ = _tmp5_;
#line 429 "PhotoFileAdapter.c"
		}
		__finally0:
		{
			GFile* _tmp6_;
#line 40 "../src/photos/PhotoFileAdapter.vala"
			_tmp6_ = self->priv->file;
#line 40 "../src/photos/PhotoFileAdapter.vala"
			g_rec_mutex_unlock (&self->priv->__lock_file);
#line 438 "PhotoFileAdapter.c"
		}
#line 40 "../src/photos/PhotoFileAdapter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../src/photos/PhotoFileAdapter.vala"
			_g_object_unref0 (_result_);
#line 40 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 40 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 450 "PhotoFileAdapter.c"
		}
	}
#line 47 "../src/photos/PhotoFileAdapter.vala"
	result = _result_;
#line 47 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 457 "PhotoFileAdapter.c"
}

PhotoFileFormat
photo_file_adapter_get_file_format (PhotoFileAdapter* self)
{
	PhotoFileFormat result;
#line 50 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), 0);
#line 51 "../src/photos/PhotoFileAdapter.vala"
	result = self->priv->file_format;
#line 51 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 470 "PhotoFileAdapter.c"
}

static void
value_photo_file_adapter_init (GValue* value)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	value->data[0].v_pointer = NULL;
#line 478 "PhotoFileAdapter.c"
}

static void
value_photo_file_adapter_free_value (GValue* value)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (value->data[0].v_pointer);
#line 488 "PhotoFileAdapter.c"
	}
}

static void
value_photo_file_adapter_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		dest_value->data[0].v_pointer = photo_file_adapter_ref (src_value->data[0].v_pointer);
#line 500 "PhotoFileAdapter.c"
	} else {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 504 "PhotoFileAdapter.c"
	}
}

static gpointer
value_photo_file_adapter_peek_pointer (const GValue* value)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return value->data[0].v_pointer;
#line 513 "PhotoFileAdapter.c"
}

static gchar*
value_photo_file_adapter_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (collect_values[0].v_pointer) {
#line 524 "PhotoFileAdapter.c"
		PhotoFileAdapter * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/photos/PhotoFileAdapter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 531 "PhotoFileAdapter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 535 "PhotoFileAdapter.c"
		}
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = photo_file_adapter_ref (object);
#line 539 "PhotoFileAdapter.c"
	} else {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 543 "PhotoFileAdapter.c"
	}
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 547 "PhotoFileAdapter.c"
}

static gchar*
value_photo_file_adapter_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	PhotoFileAdapter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (!object_p) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 562 "PhotoFileAdapter.c"
	}
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		*object_p = NULL;
#line 568 "PhotoFileAdapter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		*object_p = value->data[0].v_pointer;
#line 572 "PhotoFileAdapter.c"
	} else {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		*object_p = photo_file_adapter_ref (value->data[0].v_pointer);
#line 576 "PhotoFileAdapter.c"
	}
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 580 "PhotoFileAdapter.c"
}

GParamSpec*
param_spec_photo_file_adapter (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecPhotoFileAdapter* spec;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_FILE_ADAPTER), NULL);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return G_PARAM_SPEC (spec);
#line 599 "PhotoFileAdapter.c"
}

gpointer
value_get_photo_file_adapter (const GValue* value)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER), NULL);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return value->data[0].v_pointer;
#line 609 "PhotoFileAdapter.c"
}

void
value_set_photo_file_adapter (GValue* value,
                              gpointer v_object)
{
	PhotoFileAdapter * old;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
#line 20 "../src/photos/PhotoFileAdapter.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (v_object) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
#line 20 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_ref (value->data[0].v_pointer);
#line 631 "PhotoFileAdapter.c"
	} else {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 635 "PhotoFileAdapter.c"
	}
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (old) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (old);
#line 641 "PhotoFileAdapter.c"
	}
}

void
value_take_photo_file_adapter (GValue* value,
                               gpointer v_object)
{
	PhotoFileAdapter * old;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
#line 20 "../src/photos/PhotoFileAdapter.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (v_object) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
#line 20 "../src/photos/PhotoFileAdapter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = v_object;
#line 662 "PhotoFileAdapter.c"
	} else {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		value->data[0].v_pointer = NULL;
#line 666 "PhotoFileAdapter.c"
	}
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (old) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		photo_file_adapter_unref (old);
#line 672 "PhotoFileAdapter.c"
	}
}

static void
photo_file_adapter_class_init (PhotoFileAdapterClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	photo_file_adapter_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileAdapterClass *) klass)->finalize = photo_file_adapter_finalize;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_type_class_adjust_private_offset (klass, &PhotoFileAdapter_private_offset);
#line 686 "PhotoFileAdapter.c"
}

static void
photo_file_adapter_instance_init (PhotoFileAdapter * self,
                                  gpointer klass)
{
#line 20 "../src/photos/PhotoFileAdapter.vala"
	self->priv = photo_file_adapter_get_instance_private (self);
#line 23 "../src/photos/PhotoFileAdapter.vala"
	g_rec_mutex_init (&self->priv->__lock_file);
#line 23 "../src/photos/PhotoFileAdapter.vala"
	self->priv->file = NULL;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	self->ref_count = 1;
#line 701 "PhotoFileAdapter.c"
}

static void
photo_file_adapter_finalize (PhotoFileAdapter * obj)
{
	PhotoFileAdapter * self;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_signal_handlers_destroy (self);
#line 21 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (self->priv->filepath);
#line 23 "../src/photos/PhotoFileAdapter.vala"
	g_rec_mutex_clear (&self->priv->__lock_file);
#line 23 "../src/photos/PhotoFileAdapter.vala"
	_g_object_unref0 (self->priv->file);
#line 718 "PhotoFileAdapter.c"
}

static GType
photo_file_adapter_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_file_adapter_init, value_photo_file_adapter_free_value, value_photo_file_adapter_copy_value, value_photo_file_adapter_peek_pointer, "p", value_photo_file_adapter_collect_value, "p", value_photo_file_adapter_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileAdapterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_adapter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileAdapter), 0, (GInstanceInitFunc) photo_file_adapter_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_file_adapter_type_id;
	photo_file_adapter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoFileAdapter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PhotoFileAdapter_private_offset = g_type_add_instance_private (photo_file_adapter_type_id, sizeof (PhotoFileAdapterPrivate));
	return photo_file_adapter_type_id;
}

GType
photo_file_adapter_get_type (void)
{
	static volatile gsize photo_file_adapter_type_id__once = 0;
	if (g_once_init_enter (&photo_file_adapter_type_id__once)) {
		GType photo_file_adapter_type_id;
		photo_file_adapter_type_id = photo_file_adapter_get_type_once ();
		g_once_init_leave (&photo_file_adapter_type_id__once, photo_file_adapter_type_id);
	}
	return photo_file_adapter_type_id__once;
}

gpointer
photo_file_adapter_ref (gpointer instance)
{
	PhotoFileAdapter * self;
	self = instance;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/photos/PhotoFileAdapter.vala"
	return instance;
#line 754 "PhotoFileAdapter.c"
}

void
photo_file_adapter_unref (gpointer instance)
{
	PhotoFileAdapter * self;
	self = instance;
#line 20 "../src/photos/PhotoFileAdapter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/photos/PhotoFileAdapter.vala"
		PHOTO_FILE_ADAPTER_GET_CLASS (self)->finalize (self);
#line 20 "../src/photos/PhotoFileAdapter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 768 "PhotoFileAdapter.c"
	}
}

static inline gpointer
photo_file_reader_get_instance_private (PhotoFileReader* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoFileReader_private_offset);
}

static GType
photo_file_reader_role_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_FILE_READER_ROLE_DEFAULT, "PHOTO_FILE_READER_ROLE_DEFAULT", "default"}, {PHOTO_FILE_READER_ROLE_THUMBNAIL, "PHOTO_FILE_READER_ROLE_THUMBNAIL", "thumbnail"}, {0, NULL, NULL}};
	GType photo_file_reader_role_type_id;
	photo_file_reader_role_type_id = g_enum_register_static ("PhotoFileReaderRole", values);
	return photo_file_reader_role_type_id;
}

GType
photo_file_reader_role_get_type (void)
{
	static volatile gsize photo_file_reader_role_type_id__once = 0;
	if (g_once_init_enter (&photo_file_reader_role_type_id__once)) {
		GType photo_file_reader_role_type_id;
		photo_file_reader_role_type_id = photo_file_reader_role_get_type_once ();
		g_once_init_leave (&photo_file_reader_role_type_id__once, photo_file_reader_role_type_id);
	}
	return photo_file_reader_role_type_id__once;
}

PhotoFileReader*
photo_file_reader_construct (GType object_type,
                             const gchar* filepath,
                             PhotoFileFormat file_format)
{
	PhotoFileReader* self = NULL;
#line 67 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 68 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileReader*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 67 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 811 "PhotoFileAdapter.c"
}

PhotoFileWriter*
photo_file_reader_create_writer (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileWriter* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PhotoFileWriter* _tmp3_;
	PhotoFileWriter* _tmp4_;
	PhotoFileWriter* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoFileWriter* result;
#line 71 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = photo_file_format_create_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp2_, &_inner_error0_);
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp4_ = _tmp3_;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp2_);
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp4_;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/photos/PhotoFileAdapter.vala"
		if (_inner_error0_->domain == PHOTO_FORMAT_ERROR) {
#line 72 "../src/photos/PhotoFileAdapter.vala"
			g_propagate_error (error, _inner_error0_);
#line 72 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 848 "PhotoFileAdapter.c"
		} else {
#line 72 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 72 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 856 "PhotoFileAdapter.c"
		}
	}
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp5_ = _tmp0_;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = NULL;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp5_;
#line 72 "../src/photos/PhotoFileAdapter.vala"
	_photo_file_adapter_unref0 (_tmp0_);
#line 72 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 869 "PhotoFileAdapter.c"
}

PhotoFileMetadataWriter*
photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                          GError** error)
{
	PhotoFileMetadataWriter* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	GError* _inner_error0_ = NULL;
	PhotoFileMetadataWriter* result;
#line 75 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp2_, &_inner_error0_);
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp4_ = _tmp3_;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp2_);
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp4_;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 76 "../src/photos/PhotoFileAdapter.vala"
		if (_inner_error0_->domain == PHOTO_FORMAT_ERROR) {
#line 76 "../src/photos/PhotoFileAdapter.vala"
			g_propagate_error (error, _inner_error0_);
#line 76 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 906 "PhotoFileAdapter.c"
		} else {
#line 76 "../src/photos/PhotoFileAdapter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 76 "../src/photos/PhotoFileAdapter.vala"
			g_clear_error (&_inner_error0_);
#line 76 "../src/photos/PhotoFileAdapter.vala"
			return NULL;
#line 914 "PhotoFileAdapter.c"
		}
	}
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp5_ = _tmp0_;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = NULL;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp5_;
#line 76 "../src/photos/PhotoFileAdapter.vala"
	_photo_file_adapter_unref0 (_tmp0_);
#line 76 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 927 "PhotoFileAdapter.c"
}

static PhotoMetadata*
photo_file_reader_real_read_metadata (PhotoFileReader* self,
                                      GError** error)
{
#line 79 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_read_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 79 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 938 "PhotoFileAdapter.c"
}

PhotoMetadata*
photo_file_reader_read_metadata (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 79 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
#line 79 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 79 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->read_metadata) {
#line 79 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->read_metadata (self, error);
#line 954 "PhotoFileAdapter.c"
	}
#line 79 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 958 "PhotoFileAdapter.c"
}

static GdkPixbuf*
photo_file_reader_real_unscaled_read (PhotoFileReader* self,
                                      GError** error)
{
#line 81 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_unscaled_read'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 81 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 969 "PhotoFileAdapter.c"
}

GdkPixbuf*
photo_file_reader_unscaled_read (PhotoFileReader* self,
                                 GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 81 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
#line 81 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 81 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->unscaled_read) {
#line 81 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->unscaled_read (self, error);
#line 985 "PhotoFileAdapter.c"
	}
#line 81 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 989 "PhotoFileAdapter.c"
}

static GdkPixbuf*
photo_file_reader_real_scaled_read (PhotoFileReader* self,
                                    Dimensions* full,
                                    Dimensions* scaled,
                                    GError** error)
{
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	Dimensions _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 83 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (full != NULL, NULL);
#line 83 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (scaled != NULL, NULL);
#line 84 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = photo_file_reader_unscaled_read (self, &_inner_error0_);
#line 84 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = _tmp1_;
#line 84 "../src/photos/PhotoFileAdapter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/photos/PhotoFileAdapter.vala"
		g_propagate_error (error, _inner_error0_);
#line 84 "../src/photos/PhotoFileAdapter.vala"
		return NULL;
#line 1018 "PhotoFileAdapter.c"
	}
#line 84 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = *scaled;
#line 84 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = resize_pixbuf (_tmp0_, &_tmp2_, GDK_INTERP_BILINEAR);
#line 84 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 84 "../src/photos/PhotoFileAdapter.vala"
	_g_object_unref0 (_tmp0_);
#line 84 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 1030 "PhotoFileAdapter.c"
}

GdkPixbuf*
photo_file_reader_scaled_read (PhotoFileReader* self,
                               Dimensions* full,
                               Dimensions* scaled,
                               GError** error)
{
	PhotoFileReaderClass* _klass_;
#line 83 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
#line 83 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_READER_GET_CLASS (self);
#line 83 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->scaled_read) {
#line 83 "../src/photos/PhotoFileAdapter.vala"
		return _klass_->scaled_read (self, full, scaled, error);
#line 1048 "PhotoFileAdapter.c"
	}
#line 83 "../src/photos/PhotoFileAdapter.vala"
	return NULL;
#line 1052 "PhotoFileAdapter.c"
}

void
photo_file_reader_set_role (PhotoFileReader* self,
                            PhotoFileReaderRole role)
{
#line 87 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (IS_PHOTO_FILE_READER (self));
#line 88 "../src/photos/PhotoFileAdapter.vala"
	self->priv->role = role;
#line 1063 "PhotoFileAdapter.c"
}

PhotoFileReaderRole
photo_file_reader_get_role (PhotoFileReader* self)
{
	PhotoFileReaderRole result;
#line 91 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), 0);
#line 92 "../src/photos/PhotoFileAdapter.vala"
	result = self->priv->role;
#line 92 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 1076 "PhotoFileAdapter.c"
}

static void
photo_file_reader_class_init (PhotoFileReaderClass * klass,
                              gpointer klass_data)
{
#line 59 "../src/photos/PhotoFileAdapter.vala"
	photo_file_reader_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileAdapterClass *) klass)->finalize = photo_file_reader_finalize;
#line 59 "../src/photos/PhotoFileAdapter.vala"
	g_type_class_adjust_private_offset (klass, &PhotoFileReader_private_offset);
#line 59 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->read_metadata = (PhotoMetadata* (*) (PhotoFileReader*, GError**)) photo_file_reader_real_read_metadata;
#line 59 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->unscaled_read = (GdkPixbuf* (*) (PhotoFileReader*, GError**)) photo_file_reader_real_unscaled_read;
#line 59 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileReaderClass *) klass)->scaled_read = (GdkPixbuf* (*) (PhotoFileReader*, Dimensions*, Dimensions*, GError**)) photo_file_reader_real_scaled_read;
#line 1095 "PhotoFileAdapter.c"
}

static void
photo_file_reader_instance_init (PhotoFileReader * self,
                                 gpointer klass)
{
#line 59 "../src/photos/PhotoFileAdapter.vala"
	self->priv = photo_file_reader_get_instance_private (self);
#line 65 "../src/photos/PhotoFileAdapter.vala"
	self->priv->role = PHOTO_FILE_READER_ROLE_DEFAULT;
#line 1106 "PhotoFileAdapter.c"
}

static void
photo_file_reader_finalize (PhotoFileAdapter * obj)
{
	PhotoFileReader * self;
#line 59 "../src/photos/PhotoFileAdapter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_FILE_READER, PhotoFileReader);
#line 59 "../src/photos/PhotoFileAdapter.vala"
	PHOTO_FILE_ADAPTER_CLASS (photo_file_reader_parent_class)->finalize (obj);
#line 1117 "PhotoFileAdapter.c"
}

static GType
photo_file_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileReader), 0, (GInstanceInitFunc) photo_file_reader_instance_init, NULL };
	GType photo_file_reader_type_id;
	photo_file_reader_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileReader", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PhotoFileReader_private_offset = g_type_add_instance_private (photo_file_reader_type_id, sizeof (PhotoFileReaderPrivate));
	return photo_file_reader_type_id;
}

GType
photo_file_reader_get_type (void)
{
	static volatile gsize photo_file_reader_type_id__once = 0;
	if (g_once_init_enter (&photo_file_reader_type_id__once)) {
		GType photo_file_reader_type_id;
		photo_file_reader_type_id = photo_file_reader_get_type_once ();
		g_once_init_leave (&photo_file_reader_type_id__once, photo_file_reader_type_id);
	}
	return photo_file_reader_type_id__once;
}

PhotoFileWriter*
photo_file_writer_construct (GType object_type,
                             const gchar* filepath,
                             PhotoFileFormat file_format)
{
	PhotoFileWriter* self = NULL;
#line 101 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 102 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 101 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 1154 "PhotoFileAdapter.c"
}

PhotoFileReader*
photo_file_writer_create_reader (PhotoFileWriter* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* result;
#line 105 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_WRITER (self), NULL);
#line 106 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 106 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = photo_file_format_create_reader (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp1_);
#line 106 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = _tmp2_;
#line 106 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp1_);
#line 106 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 106 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 1181 "PhotoFileAdapter.c"
}

static void
photo_file_writer_real_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error)
{
#line 109 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_writer_write'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 109 "../src/photos/PhotoFileAdapter.vala"
	return;
#line 1194 "PhotoFileAdapter.c"
}

void
photo_file_writer_write (PhotoFileWriter* self,
                         GdkPixbuf* pixbuf,
                         JpegQuality quality,
                         GError** error)
{
	PhotoFileWriterClass* _klass_;
#line 109 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (IS_PHOTO_FILE_WRITER (self));
#line 109 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_WRITER_GET_CLASS (self);
#line 109 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->write) {
#line 109 "../src/photos/PhotoFileAdapter.vala"
		_klass_->write (self, pixbuf, quality, error);
#line 1212 "PhotoFileAdapter.c"
	}
}

static void
photo_file_writer_class_init (PhotoFileWriterClass * klass,
                              gpointer klass_data)
{
#line 100 "../src/photos/PhotoFileAdapter.vala"
	photo_file_writer_parent_class = g_type_class_peek_parent (klass);
#line 100 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileWriterClass *) klass)->write = (void (*) (PhotoFileWriter*, GdkPixbuf*, JpegQuality, GError**)) photo_file_writer_real_write;
#line 1224 "PhotoFileAdapter.c"
}

static void
photo_file_writer_instance_init (PhotoFileWriter * self,
                                 gpointer klass)
{
}

static GType
photo_file_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileWriter), 0, (GInstanceInitFunc) photo_file_writer_instance_init, NULL };
	GType photo_file_writer_type_id;
	photo_file_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_file_writer_type_id;
}

GType
photo_file_writer_get_type (void)
{
	static volatile gsize photo_file_writer_type_id__once = 0;
	if (g_once_init_enter (&photo_file_writer_type_id__once)) {
		GType photo_file_writer_type_id;
		photo_file_writer_type_id = photo_file_writer_get_type_once ();
		g_once_init_leave (&photo_file_writer_type_id__once, photo_file_writer_type_id);
	}
	return photo_file_writer_type_id__once;
}

PhotoFileMetadataWriter*
photo_file_metadata_writer_construct (GType object_type,
                                      const gchar* filepath,
                                      PhotoFileFormat file_format)
{
	PhotoFileMetadataWriter* self = NULL;
#line 117 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 118 "../src/photos/PhotoFileAdapter.vala"
	self = (PhotoFileMetadataWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
#line 117 "../src/photos/PhotoFileAdapter.vala"
	return self;
#line 1266 "PhotoFileAdapter.c"
}

PhotoFileReader*
photo_file_metadata_writer_create_reader (PhotoFileMetadataWriter* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* result;
#line 121 "../src/photos/PhotoFileAdapter.vala"
	g_return_val_if_fail (IS_PHOTO_FILE_METADATA_WRITER (self), NULL);
#line 122 "../src/photos/PhotoFileAdapter.vala"
	_tmp0_ = photo_file_adapter_get_filepath (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter));
#line 122 "../src/photos/PhotoFileAdapter.vala"
	_tmp1_ = _tmp0_;
#line 122 "../src/photos/PhotoFileAdapter.vala"
	_tmp2_ = photo_file_format_create_reader (photo_file_adapter_get_file_format (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter)), _tmp1_);
#line 122 "../src/photos/PhotoFileAdapter.vala"
	_tmp3_ = _tmp2_;
#line 122 "../src/photos/PhotoFileAdapter.vala"
	_g_free0 (_tmp1_);
#line 122 "../src/photos/PhotoFileAdapter.vala"
	result = _tmp3_;
#line 122 "../src/photos/PhotoFileAdapter.vala"
	return result;
#line 1293 "PhotoFileAdapter.c"
}

static void
photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error)
{
#line 125 "../src/photos/PhotoFileAdapter.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_file_metadata_writer_write_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 125 "../src/photos/PhotoFileAdapter.vala"
	return;
#line 1305 "PhotoFileAdapter.c"
}

void
photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                           PhotoMetadata* metadata,
                                           GError** error)
{
	PhotoFileMetadataWriterClass* _klass_;
#line 125 "../src/photos/PhotoFileAdapter.vala"
	g_return_if_fail (IS_PHOTO_FILE_METADATA_WRITER (self));
#line 125 "../src/photos/PhotoFileAdapter.vala"
	_klass_ = PHOTO_FILE_METADATA_WRITER_GET_CLASS (self);
#line 125 "../src/photos/PhotoFileAdapter.vala"
	if (_klass_->write_metadata) {
#line 125 "../src/photos/PhotoFileAdapter.vala"
		_klass_->write_metadata (self, metadata, error);
#line 1322 "PhotoFileAdapter.c"
	}
}

static void
photo_file_metadata_writer_class_init (PhotoFileMetadataWriterClass * klass,
                                       gpointer klass_data)
{
#line 116 "../src/photos/PhotoFileAdapter.vala"
	photo_file_metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 116 "../src/photos/PhotoFileAdapter.vala"
	((PhotoFileMetadataWriterClass *) klass)->write_metadata = (void (*) (PhotoFileMetadataWriter*, PhotoMetadata*, GError**)) photo_file_metadata_writer_real_write_metadata;
#line 1334 "PhotoFileAdapter.c"
}

static void
photo_file_metadata_writer_instance_init (PhotoFileMetadataWriter * self,
                                          gpointer klass)
{
}

static GType
photo_file_metadata_writer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoFileMetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileMetadataWriter), 0, (GInstanceInitFunc) photo_file_metadata_writer_instance_init, NULL };
	GType photo_file_metadata_writer_type_id;
	photo_file_metadata_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileMetadataWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return photo_file_metadata_writer_type_id;
}

GType
photo_file_metadata_writer_get_type (void)
{
	static volatile gsize photo_file_metadata_writer_type_id__once = 0;
	if (g_once_init_enter (&photo_file_metadata_writer_type_id__once)) {
		GType photo_file_metadata_writer_type_id;
		photo_file_metadata_writer_type_id = photo_file_metadata_writer_get_type_once ();
		g_once_init_leave (&photo_file_metadata_writer_type_id__once, photo_file_metadata_writer_type_id);
	}
	return photo_file_metadata_writer_type_id__once;
}

