/* VideoReader.c generated by valac 0.56.3, the Vala compiler
 * generated from VideoReader.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "metadata.h"
#include <locale.h>
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gunixinputstream.h>
#include <sys/wait.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define VIDEO_READER_UNKNOWN_CLIP_DURATION (-1.0)
#define VIDEO_READER_THUMBNAILER_TIMEOUT ((guint) 10000)
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define VIDEO_ID_INVALID ((gint64) -1)
#define EVENT_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VIDEO_ERROR (video_error_get_type ())

#define TYPE_VIDEO_READER (video_reader_get_type ())
#define VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_READER, VideoReader))
#define VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_READER, VideoReaderClass))
#define IS_VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_READER))
#define IS_VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_READER))
#define VIDEO_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_READER, VideoReaderClass))

typedef struct _VideoReader VideoReader;
typedef struct _VideoReaderClass VideoReaderClass;
typedef struct _VideoReaderPrivate VideoReaderPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
#define _video_reader_unref0(var) ((var == NULL) ? NULL : (var = (video_reader_unref (var), NULL)))

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _ParamSpecVideoReader ParamSpecVideoReader;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	VIDEO_ERROR_FILE,
	VIDEO_ERROR_CONTENTS
} VideoError;
#define VIDEO_ERROR video_error_quark ()

struct _VideoReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoReaderPrivate * priv;
};

struct _VideoReaderClass {
	GTypeClass parent_class;
	void (*finalize) (VideoReader *self);
};

struct _VideoReaderPrivate {
	gdouble clip_duration;
	GdkPixbuf* preview_frame;
	GFile* file;
	GPid thumbnailer_pid;
	GDateTime* _timestamp;
};

struct _ImportID {
	gint64 id;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	GDateTime* exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _VideoID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	GDateTime* exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	gint64 time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	gint64 time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _Block16Data {
	int _ref_count_;
	VideoReader* self;
	guint id;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	GCancellable* cancellable;
};

struct _ParamSpecVideoReader {
	GParamSpec parent_instance;
};

static gint VideoReader_private_offset;
static gpointer video_reader_parent_class = NULL;

VALA_EXTERN GQuark video_error_quark (void);
GType video_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer video_reader_ref (gpointer instance);
VALA_EXTERN void video_reader_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_reader (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_video_reader (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_video_reader (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_video_reader (const GValue* value);
VALA_EXTERN GType video_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoReader, video_reader_unref)
VALA_EXTERN VideoReader* video_reader_new (GFile* file);
VALA_EXTERN VideoReader* video_reader_construct (GType object_type,
                                     GFile* file);
VALA_EXTERN gboolean video_reader_is_supported_video_file (GFile* file);
VALA_EXTERN gboolean video_reader_is_supported_video_filename (const gchar* filename);
VALA_EXTERN void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
VALA_EXTERN gint utf8_ci_compare (const gchar* a,
                      const gchar* b);
VALA_EXTERN gpointer video_import_params_ref (gpointer instance);
VALA_EXTERN void video_import_params_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_video_import_params (const GValue* value);
VALA_EXTERN GType video_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoImportParams, video_import_params_unref)
VALA_EXTERN GType import_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportResult video_reader_prepare_for_import (VideoImportParams* params);
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN gpointer thumbnails_ref (gpointer instance);
VALA_EXTERN void thumbnails_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_thumbnails (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_thumbnails (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_thumbnails (const GValue* value);
VALA_EXTERN GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
VALA_EXTERN gpointer video_row_ref (gpointer instance);
VALA_EXTERN void video_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_video_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_video_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_video_row (const GValue* value);
VALA_EXTERN GType video_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
VALA_EXTERN GdkPixbuf* video_reader_read_preview_frame (VideoReader* self);
VALA_EXTERN gdouble video_reader_read_clip_duration (VideoReader* self,
                                         GError** error);
VALA_EXTERN GType video_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMetadata, media_metadata_unref)
VALA_EXTERN VideoMetadata* video_reader_read_metadata (VideoReader* self,
                                           GError** error);
VALA_EXTERN GDateTime* video_reader_get_timestamp (VideoReader* self);
VALA_EXTERN GType video_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoID* video_id_dup (const VideoID* self);
VALA_EXTERN void video_id_free (VideoID* self);
VALA_EXTERN GType event_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EventID* event_id_dup (const EventID* self);
VALA_EXTERN void event_id_free (EventID* self);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void video_id_init (VideoID *self,
                    gint64 id);
VALA_EXTERN void event_id_init (EventID *self,
                    gint64 id);
VALA_EXTERN Thumbnails* thumbnails_new (void);
VALA_EXTERN Thumbnails* thumbnails_construct (GType object_type);
VALA_EXTERN void thumbnail_cache_generate_for_video_frame (Thumbnails* thumbnails,
                                               GdkPixbuf* preview_frame);
static void video_reader_read_internal (VideoReader* self,
                                 GError** error);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean video_reader_does_file_exist (VideoReader* self);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda11_ (Block17Data* _data17_);
static gboolean ____lambda11__gsource_func (gpointer self);
VALA_EXTERN GFile* app_dirs_get_metadata_helper (void);
static void video_reader_set_timestamp (VideoReader* self,
                                 GDateTime* value);
static gboolean video_reader_on_thumbnailer_timer (VideoReader* self);
static GdkPixbuf* video_reader_thumbnailer (VideoReader* self,
                                     const gchar* video_file);
VALA_EXTERN GFile* app_dirs_get_thumbnailer_bin (void);
static gboolean _video_reader_on_thumbnailer_timer_gsource_func (gpointer self);
VALA_EXTERN GdkPixbuf* resources_get_noninterpretable_badge_pixbuf (void);
VALA_EXTERN VideoMetadata* video_metadata_new (void);
VALA_EXTERN VideoMetadata* video_metadata_construct (GType object_type);
static void video_reader_finalize (VideoReader * obj);
static GType video_reader_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar* VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS[4] = {"bdm", "bdmv", "cpi", "mpl"};

GQuark
video_error_quark (void)
{
	return g_quark_from_static_string ("video-error-quark");
}

static GType
video_error_get_type_once (void)
{
	static const GEnumValue values[] = {{VIDEO_ERROR_FILE, "VIDEO_ERROR_FILE", "file"}, {VIDEO_ERROR_CONTENTS, "VIDEO_ERROR_CONTENTS", "contents"}, {0, NULL, NULL}};
	GType video_error_type_id;
	video_error_type_id = g_enum_register_static ("VideoError", values);
	return video_error_type_id;
}

GType
video_error_get_type (void)
{
	static volatile gsize video_error_type_id__once = 0;
	if (g_once_init_enter (&video_error_type_id__once)) {
		GType video_error_type_id;
		video_error_type_id = video_error_get_type_once ();
		g_once_init_leave (&video_error_type_id__once, video_error_type_id);
	}
	return video_error_type_id__once;
}

static inline gpointer
video_reader_get_instance_private (VideoReader* self)
{
	return G_STRUCT_MEMBER_P (self, VideoReader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/video-support/VideoReader.vala"
	return self ? g_object_ref (self) : NULL;
#line 425 "VideoReader.c"
}

VideoReader*
video_reader_construct (GType object_type,
                        GFile* file)
{
	VideoReader* self = NULL;
	GFile* _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 28 "../src/video-support/VideoReader.vala"
	self = (VideoReader*) g_type_create_instance (object_type);
#line 29 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 29 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 29 "../src/video-support/VideoReader.vala"
	self->priv->file = _tmp0_;
#line 28 "../src/video-support/VideoReader.vala"
	return self;
#line 446 "VideoReader.c"
}

VideoReader*
video_reader_new (GFile* file)
{
#line 28 "../src/video-support/VideoReader.vala"
	return video_reader_construct (TYPE_VIDEO_READER, file);
#line 454 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_file (GFile* file)
{
	gchar* mime_type = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 32 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_file_get_basename (file);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_new0 (guchar, 0);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3__length1 = 0;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_content_type_guess (_tmp1_, _tmp3_, (gsize) 0, NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 33 "../src/video-support/VideoReader.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 33 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp1_);
#line 33 "../src/video-support/VideoReader.vala"
	mime_type = _tmp5_;
#line 35 "../src/video-support/VideoReader.vala"
	_tmp7_ = mime_type;
#line 35 "../src/video-support/VideoReader.vala"
	if (g_strcmp0 (_tmp7_, "audio/ogg") == 0) {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = g_file_has_uri_scheme (file, "file");
#line 503 "VideoReader.c"
	} else {
#line 35 "../src/video-support/VideoReader.vala"
		_tmp6_ = FALSE;
#line 507 "VideoReader.c"
	}
#line 35 "../src/video-support/VideoReader.vala"
	if (_tmp6_) {
#line 511 "VideoReader.c"
		{
			GFileInfo* info = NULL;
			GFileInfo* _tmp8_;
			gchar* content_type = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
#line 37 "../src/video-support/VideoReader.vala"
			_tmp8_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 37 "../src/video-support/VideoReader.vala"
			info = _tmp8_;
#line 37 "../src/video-support/VideoReader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 527 "VideoReader.c"
				goto __catch0_g_error;
			}
#line 39 "../src/video-support/VideoReader.vala"
			_tmp9_ = info;
#line 39 "../src/video-support/VideoReader.vala"
			_tmp10_ = g_file_info_get_content_type (_tmp9_);
#line 39 "../src/video-support/VideoReader.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 39 "../src/video-support/VideoReader.vala"
			content_type = _tmp11_;
#line 40 "../src/video-support/VideoReader.vala"
			_tmp13_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp13_ != NULL) {
#line 542 "VideoReader.c"
				const gchar* _tmp14_;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp14_ = content_type;
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = g_str_has_prefix (_tmp14_, "video/");
#line 548 "VideoReader.c"
			} else {
#line 40 "../src/video-support/VideoReader.vala"
				_tmp12_ = FALSE;
#line 552 "VideoReader.c"
			}
#line 40 "../src/video-support/VideoReader.vala"
			if (_tmp12_) {
#line 41 "../src/video-support/VideoReader.vala"
				result = TRUE;
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (content_type);
#line 41 "../src/video-support/VideoReader.vala"
				_g_object_unref0 (info);
#line 41 "../src/video-support/VideoReader.vala"
				_g_free0 (mime_type);
#line 41 "../src/video-support/VideoReader.vala"
				return result;
#line 566 "VideoReader.c"
			}
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (content_type);
#line 36 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 572 "VideoReader.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 36 "../src/video-support/VideoReader.vala"
			_error_ = _inner_error0_;
#line 36 "../src/video-support/VideoReader.vala"
			_inner_error0_ = NULL;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp15_ = _error_;
#line 44 "../src/video-support/VideoReader.vala"
			_tmp16_ = _tmp15_->message;
#line 44 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:44: Failed to query content type: %s", _tmp16_);
#line 36 "../src/video-support/VideoReader.vala"
			_g_error_free0 (_error_);
#line 592 "VideoReader.c"
		}
		__finally0:
#line 36 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 597 "VideoReader.c"
			gboolean _tmp17_ = FALSE;
#line 36 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 36 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 36 "../src/video-support/VideoReader.vala"
			return _tmp17_;
#line 607 "VideoReader.c"
		}
	}
#line 48 "../src/video-support/VideoReader.vala"
	_tmp18_ = g_file_get_basename (file);
#line 48 "../src/video-support/VideoReader.vala"
	_tmp19_ = _tmp18_;
#line 48 "../src/video-support/VideoReader.vala"
	_tmp20_ = video_reader_is_supported_video_filename (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp19_);
#line 48 "../src/video-support/VideoReader.vala"
	result = _tmp20_;
#line 48 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 48 "../src/video-support/VideoReader.vala"
	return result;
#line 624 "VideoReader.c"
}

gboolean
video_reader_is_supported_video_filename (const gchar* filename)
{
	gchar* mime_type = NULL;
	guchar* _tmp0_;
	guchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean result;
#line 51 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1__length1 = 0;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_content_type_guess (filename, _tmp1_, (gsize) 0, NULL);
#line 53 "../src/video-support/VideoReader.vala"
	_g_free0 (mime_type);
#line 53 "../src/video-support/VideoReader.vala"
	mime_type = _tmp2_;
#line 53 "../src/video-support/VideoReader.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 55 "../src/video-support/VideoReader.vala"
	_tmp4_ = mime_type;
#line 55 "../src/video-support/VideoReader.vala"
	if (g_str_has_prefix (_tmp4_, "video/")) {
#line 55 "../src/video-support/VideoReader.vala"
		_tmp3_ = TRUE;
#line 660 "VideoReader.c"
	} else {
		const gchar* _tmp5_;
#line 55 "../src/video-support/VideoReader.vala"
		_tmp5_ = mime_type;
#line 55 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_str_has_suffix (_tmp5_, "mp4");
#line 667 "VideoReader.c"
	}
#line 55 "../src/video-support/VideoReader.vala"
	if (_tmp3_) {
#line 671 "VideoReader.c"
		gchar* extension = NULL;
		gchar* name = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_;
#line 56 "../src/video-support/VideoReader.vala"
		extension = NULL;
#line 57 "../src/video-support/VideoReader.vala"
		name = NULL;
#line 58 "../src/video-support/VideoReader.vala"
		disassemble_filename (filename, &_tmp6_, &_tmp7_);
#line 58 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 58 "../src/video-support/VideoReader.vala"
		name = _tmp6_;
#line 58 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 58 "../src/video-support/VideoReader.vala"
		extension = _tmp7_;
#line 60 "../src/video-support/VideoReader.vala"
		_tmp8_ = extension;
#line 60 "../src/video-support/VideoReader.vala"
		if (_tmp8_ == NULL) {
#line 61 "../src/video-support/VideoReader.vala"
			result = TRUE;
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (name);
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (extension);
#line 61 "../src/video-support/VideoReader.vala"
			_g_free0 (mime_type);
#line 61 "../src/video-support/VideoReader.vala"
			return result;
#line 705 "VideoReader.c"
		}
		{
			const gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
#line 63 "../src/video-support/VideoReader.vala"
			s_collection = VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS;
#line 63 "../src/video-support/VideoReader.vala"
			s_collection_length1 = G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS);
#line 63 "../src/video-support/VideoReader.vala"
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 718 "VideoReader.c"
				gchar* _tmp9_;
				gchar* s = NULL;
#line 63 "../src/video-support/VideoReader.vala"
				_tmp9_ = g_strdup (s_collection[s_it]);
#line 63 "../src/video-support/VideoReader.vala"
				s = _tmp9_;
#line 725 "VideoReader.c"
				{
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 64 "../src/video-support/VideoReader.vala"
					_tmp10_ = s;
#line 64 "../src/video-support/VideoReader.vala"
					_tmp11_ = extension;
#line 64 "../src/video-support/VideoReader.vala"
					if (utf8_ci_compare (_tmp10_, _tmp11_) == 0) {
#line 65 "../src/video-support/VideoReader.vala"
						result = FALSE;
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (s);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (name);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (extension);
#line 65 "../src/video-support/VideoReader.vala"
						_g_free0 (mime_type);
#line 65 "../src/video-support/VideoReader.vala"
						return result;
#line 747 "VideoReader.c"
					}
#line 63 "../src/video-support/VideoReader.vala"
					_g_free0 (s);
#line 751 "VideoReader.c"
				}
			}
		}
#line 68 "../src/video-support/VideoReader.vala"
		result = TRUE;
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (name);
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (extension);
#line 68 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 68 "../src/video-support/VideoReader.vala"
		return result;
#line 765 "VideoReader.c"
	} else {
		const gchar* _tmp12_;
#line 70 "../src/video-support/VideoReader.vala"
		_tmp12_ = mime_type;
#line 70 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:70: Skipping %s, unsupported mime type %s", filename, _tmp12_);
#line 71 "../src/video-support/VideoReader.vala"
		result = FALSE;
#line 71 "../src/video-support/VideoReader.vala"
		_g_free0 (mime_type);
#line 71 "../src/video-support/VideoReader.vala"
		return result;
#line 778 "VideoReader.c"
	}
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 104 "../src/video-support/VideoReader.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 787 "VideoReader.c"
}

ImportResult
video_reader_prepare_for_import (VideoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GDateTime* timestamp = NULL;
	GFileInfo* _tmp11_;
	GDateTime* _tmp12_;
	const gchar* _tmp13_;
	GDateTime* exposure_time = NULL;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	gchar* title = NULL;
	gchar* _tmp16_;
	gchar* comment = NULL;
	gchar* _tmp17_;
	VideoReader* reader = NULL;
	GFile* _tmp18_;
	VideoReader* _tmp19_;
	gboolean is_interpretable = FALSE;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* _tmp20_;
	GdkPixbuf* _tmp21_;
	GDateTime* _tmp49_;
	VideoRow* _tmp53_;
	VideoRow* _tmp54_;
	GFile* _tmp55_;
	gchar* _tmp56_;
	VideoRow* _tmp57_;
	GFileInfo* _tmp58_;
	VideoRow* _tmp59_;
	GDateTime* _tmp60_;
	GDateTime* _tmp61_;
	VideoRow* _tmp62_;
	GdkPixbuf* _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	VideoRow* _tmp66_;
	GdkPixbuf* _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	VideoRow* _tmp70_;
	VideoRow* _tmp71_;
	VideoRow* _tmp72_;
	GDateTime* _tmp73_;
	GDateTime* _tmp74_;
	VideoRow* _tmp75_;
	ImportID _tmp76_;
	VideoRow* _tmp77_;
	VideoRow* _tmp78_;
	const gchar* _tmp79_;
	gchar* _tmp80_;
	VideoRow* _tmp81_;
	VideoRow* _tmp82_;
	const gchar* _tmp83_;
	gchar* _tmp84_;
	VideoRow* _tmp85_;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	VideoRow* _tmp88_;
	gchar* _tmp89_;
	VideoRow* _tmp90_;
	VideoRow* _tmp91_;
	Thumbnails* _tmp92_;
	GError* _inner_error0_ = NULL;
	ImportResult result;
#line 75 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
#line 79 "../src/video-support/VideoReader.vala"
	_tmp0_ = params->file;
#line 79 "../src/video-support/VideoReader.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 79 "../src/video-support/VideoReader.vala"
	file = _tmp1_;
#line 81 "../src/video-support/VideoReader.vala"
	info = NULL;
#line 871 "VideoReader.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp3_ = file;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 83 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp4_;
#line 83 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 885 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 83 "../src/video-support/VideoReader.vala"
		_tmp5_ = _tmp2_;
#line 83 "../src/video-support/VideoReader.vala"
		_tmp2_ = NULL;
#line 83 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 83 "../src/video-support/VideoReader.vala"
		info = _tmp5_;
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp2_);
#line 898 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 82 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 86 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 86 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 86 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 86 "../src/video-support/VideoReader.vala"
		return result;
#line 913 "VideoReader.c"
	}
	__finally0:
#line 82 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 82 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 82 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../src/video-support/VideoReader.vala"
		return 0;
#line 928 "VideoReader.c"
	}
#line 89 "../src/video-support/VideoReader.vala"
	_tmp6_ = info;
#line 89 "../src/video-support/VideoReader.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 90 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 90 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 90 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 90 "../src/video-support/VideoReader.vala"
		return result;
#line 942 "VideoReader.c"
	}
#line 92 "../src/video-support/VideoReader.vala"
	_tmp7_ = file;
#line 92 "../src/video-support/VideoReader.vala"
	if (!video_reader_is_supported_video_file (_tmp7_)) {
#line 948 "VideoReader.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 93 "../src/video-support/VideoReader.vala"
		_tmp8_ = file;
#line 93 "../src/video-support/VideoReader.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 93 "../src/video-support/VideoReader.vala"
		_tmp10_ = _tmp9_;
#line 93 "../src/video-support/VideoReader.vala"
		g_message ("Not importing %s: file is marked as a video file but doesn't have a" "supported extension", _tmp10_);
#line 93 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp10_);
#line 96 "../src/video-support/VideoReader.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 96 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 96 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 96 "../src/video-support/VideoReader.vala"
		return result;
#line 970 "VideoReader.c"
	}
#line 99 "../src/video-support/VideoReader.vala"
	_tmp11_ = info;
#line 99 "../src/video-support/VideoReader.vala"
	_tmp12_ = g_file_info_get_modification_date_time (_tmp11_);
#line 99 "../src/video-support/VideoReader.vala"
	timestamp = _tmp12_;
#line 102 "../src/video-support/VideoReader.vala"
	_tmp13_ = params->md5;
#line 102 "../src/video-support/VideoReader.vala"
	_vala_assert (_tmp13_ != NULL, "params.md5 != null");
#line 104 "../src/video-support/VideoReader.vala"
	_tmp14_ = params->exposure_time_override;
#line 104 "../src/video-support/VideoReader.vala"
	_tmp15_ = _g_date_time_ref0 (_tmp14_);
#line 104 "../src/video-support/VideoReader.vala"
	exposure_time = _tmp15_;
#line 105 "../src/video-support/VideoReader.vala"
	_tmp16_ = g_strdup ("");
#line 105 "../src/video-support/VideoReader.vala"
	title = _tmp16_;
#line 106 "../src/video-support/VideoReader.vala"
	_tmp17_ = g_strdup ("");
#line 106 "../src/video-support/VideoReader.vala"
	comment = _tmp17_;
#line 108 "../src/video-support/VideoReader.vala"
	_tmp18_ = file;
#line 108 "../src/video-support/VideoReader.vala"
	_tmp19_ = video_reader_new (_tmp18_);
#line 108 "../src/video-support/VideoReader.vala"
	reader = _tmp19_;
#line 109 "../src/video-support/VideoReader.vala"
	is_interpretable = TRUE;
#line 110 "../src/video-support/VideoReader.vala"
	clip_duration = 0.0;
#line 111 "../src/video-support/VideoReader.vala"
	_tmp20_ = reader;
#line 111 "../src/video-support/VideoReader.vala"
	_tmp21_ = video_reader_read_preview_frame (_tmp20_);
#line 111 "../src/video-support/VideoReader.vala"
	preview_frame = _tmp21_;
#line 1012 "VideoReader.c"
	{
		gdouble _tmp22_ = 0.0;
		VideoReader* _tmp23_;
#line 113 "../src/video-support/VideoReader.vala"
		_tmp23_ = reader;
#line 113 "../src/video-support/VideoReader.vala"
		_tmp22_ = video_reader_read_clip_duration (_tmp23_, &_inner_error0_);
#line 113 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 1024 "VideoReader.c"
				goto __catch1_video_error;
			}
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 113 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 113 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 113 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 113 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 113 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (timestamp);
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 113 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 113 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 113 "../src/video-support/VideoReader.vala"
			return 0;
#line 1049 "VideoReader.c"
		}
#line 113 "../src/video-support/VideoReader.vala"
		clip_duration = _tmp22_;
#line 1053 "VideoReader.c"
	}
	goto __finally1;
	__catch1_video_error:
	{
		GError* err = NULL;
		GError* _tmp24_;
#line 112 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 112 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 115 "../src/video-support/VideoReader.vala"
		_tmp24_ = err;
#line 115 "../src/video-support/VideoReader.vala"
		if (g_error_matches (_tmp24_, VIDEO_ERROR, VIDEO_ERROR_FILE)) {
#line 116 "../src/video-support/VideoReader.vala"
			result = IMPORT_RESULT_FILE_ERROR;
#line 116 "../src/video-support/VideoReader.vala"
			_g_error_free0 (err);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (preview_frame);
#line 116 "../src/video-support/VideoReader.vala"
			_video_reader_unref0 (reader);
#line 116 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 116 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 116 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 116 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (timestamp);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (info);
#line 116 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (file);
#line 116 "../src/video-support/VideoReader.vala"
			return result;
#line 1090 "VideoReader.c"
		} else {
			GError* _tmp25_;
#line 117 "../src/video-support/VideoReader.vala"
			_tmp25_ = err;
#line 117 "../src/video-support/VideoReader.vala"
			if (g_error_matches (_tmp25_, VIDEO_ERROR, VIDEO_ERROR_CONTENTS)) {
#line 118 "../src/video-support/VideoReader.vala"
				is_interpretable = FALSE;
#line 119 "../src/video-support/VideoReader.vala"
				clip_duration = 0.0;
#line 1101 "VideoReader.c"
			} else {
#line 121 "../src/video-support/VideoReader.vala"
				g_error ("VideoReader.vala:121: can't prepare video for import: an unknown kind " \
"of video error occurred");
#line 1105 "VideoReader.c"
			}
		}
#line 112 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1110 "VideoReader.c"
	}
	__finally1:
#line 112 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 112 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 112 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 112 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 112 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 112 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (timestamp);
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 112 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 112 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 112 "../src/video-support/VideoReader.vala"
		return 0;
#line 1137 "VideoReader.c"
	}
	{
		VideoMetadata* metadata = NULL;
		VideoReader* _tmp26_;
		VideoMetadata* _tmp27_;
		MetadataDateTime* creation_date_time = NULL;
		VideoMetadata* _tmp28_;
		MetadataDateTime* _tmp29_;
		gboolean _tmp30_ = FALSE;
		MetadataDateTime* _tmp31_;
		gchar* video_title = NULL;
		VideoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* video_comment = NULL;
		VideoMetadata* _tmp39_;
		gchar* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp44_;
#line 126 "../src/video-support/VideoReader.vala"
		_tmp26_ = reader;
#line 126 "../src/video-support/VideoReader.vala"
		_tmp27_ = video_reader_read_metadata (_tmp26_, &_inner_error0_);
#line 126 "../src/video-support/VideoReader.vala"
		metadata = _tmp27_;
#line 126 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1164 "VideoReader.c"
			goto __catch2_g_error;
		}
#line 127 "../src/video-support/VideoReader.vala"
		_tmp28_ = metadata;
#line 127 "../src/video-support/VideoReader.vala"
		_tmp29_ = media_metadata_get_creation_date_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 127 "../src/video-support/VideoReader.vala"
		creation_date_time = _tmp29_;
#line 129 "../src/video-support/VideoReader.vala"
		_tmp31_ = creation_date_time;
#line 129 "../src/video-support/VideoReader.vala"
		if (_tmp31_ != NULL) {
#line 1177 "VideoReader.c"
			MetadataDateTime* _tmp32_;
			GDateTime* _tmp33_;
			GDateTime* _tmp34_;
#line 129 "../src/video-support/VideoReader.vala"
			_tmp32_ = creation_date_time;
#line 129 "../src/video-support/VideoReader.vala"
			_tmp33_ = metadata_date_time_get_timestamp (_tmp32_);
#line 129 "../src/video-support/VideoReader.vala"
			_tmp34_ = _tmp33_;
#line 129 "../src/video-support/VideoReader.vala"
			_tmp30_ = _tmp34_ != NULL;
#line 129 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (_tmp34_);
#line 1191 "VideoReader.c"
		} else {
#line 129 "../src/video-support/VideoReader.vala"
			_tmp30_ = FALSE;
#line 1195 "VideoReader.c"
		}
#line 129 "../src/video-support/VideoReader.vala"
		if (_tmp30_) {
#line 1199 "VideoReader.c"
			MetadataDateTime* _tmp35_;
			GDateTime* _tmp36_;
#line 130 "../src/video-support/VideoReader.vala"
			_tmp35_ = creation_date_time;
#line 130 "../src/video-support/VideoReader.vala"
			_tmp36_ = metadata_date_time_get_timestamp (_tmp35_);
#line 130 "../src/video-support/VideoReader.vala"
			_g_date_time_unref0 (exposure_time);
#line 130 "../src/video-support/VideoReader.vala"
			exposure_time = _tmp36_;
#line 1210 "VideoReader.c"
		}
#line 132 "../src/video-support/VideoReader.vala"
		_tmp37_ = metadata;
#line 132 "../src/video-support/VideoReader.vala"
		_tmp38_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 132 "../src/video-support/VideoReader.vala"
		video_title = _tmp38_;
#line 133 "../src/video-support/VideoReader.vala"
		_tmp39_ = metadata;
#line 133 "../src/video-support/VideoReader.vala"
		_tmp40_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_MEDIA_METADATA, MediaMetadata));
#line 133 "../src/video-support/VideoReader.vala"
		video_comment = _tmp40_;
#line 134 "../src/video-support/VideoReader.vala"
		_tmp41_ = video_title;
#line 134 "../src/video-support/VideoReader.vala"
		if (_tmp41_ != NULL) {
#line 1228 "VideoReader.c"
			const gchar* _tmp42_;
			gchar* _tmp43_;
#line 135 "../src/video-support/VideoReader.vala"
			_tmp42_ = video_title;
#line 135 "../src/video-support/VideoReader.vala"
			_tmp43_ = g_strdup (_tmp42_);
#line 135 "../src/video-support/VideoReader.vala"
			_g_free0 (title);
#line 135 "../src/video-support/VideoReader.vala"
			title = _tmp43_;
#line 1239 "VideoReader.c"
		}
#line 136 "../src/video-support/VideoReader.vala"
		_tmp44_ = video_comment;
#line 136 "../src/video-support/VideoReader.vala"
		if (_tmp44_ != NULL) {
#line 1245 "VideoReader.c"
			const gchar* _tmp45_;
			gchar* _tmp46_;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp45_ = video_comment;
#line 137 "../src/video-support/VideoReader.vala"
			_tmp46_ = g_strdup (_tmp45_);
#line 137 "../src/video-support/VideoReader.vala"
			_g_free0 (comment);
#line 137 "../src/video-support/VideoReader.vala"
			comment = _tmp46_;
#line 1256 "VideoReader.c"
		}
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (video_comment);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (video_title);
#line 125 "../src/video-support/VideoReader.vala"
		_metadata_date_time_unref0 (creation_date_time);
#line 125 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 1266 "VideoReader.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 125 "../src/video-support/VideoReader.vala"
		err = _inner_error0_;
#line 125 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 139 "../src/video-support/VideoReader.vala"
		_tmp47_ = err;
#line 139 "../src/video-support/VideoReader.vala"
		_tmp48_ = _tmp47_->message;
#line 139 "../src/video-support/VideoReader.vala"
		g_warning ("VideoReader.vala:139: Unable to read video metadata: %s", _tmp48_);
#line 125 "../src/video-support/VideoReader.vala"
		_g_error_free0 (err);
#line 1286 "VideoReader.c"
	}
	__finally2:
#line 125 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (preview_frame);
#line 125 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (reader);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (comment);
#line 125 "../src/video-support/VideoReader.vala"
		_g_free0 (title);
#line 125 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 125 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (timestamp);
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (info);
#line 125 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (file);
#line 125 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 125 "../src/video-support/VideoReader.vala"
		return 0;
#line 1313 "VideoReader.c"
	}
#line 142 "../src/video-support/VideoReader.vala"
	_tmp49_ = exposure_time;
#line 142 "../src/video-support/VideoReader.vala"
	if (_tmp49_ == NULL) {
#line 1319 "VideoReader.c"
		VideoReader* _tmp50_;
		GDateTime* _tmp51_;
		GDateTime* _tmp52_;
#line 144 "../src/video-support/VideoReader.vala"
		_tmp50_ = reader;
#line 144 "../src/video-support/VideoReader.vala"
		_tmp51_ = _tmp50_->priv->_timestamp;
#line 144 "../src/video-support/VideoReader.vala"
		_tmp52_ = _g_date_time_ref0 (_tmp51_);
#line 144 "../src/video-support/VideoReader.vala"
		_g_date_time_unref0 (exposure_time);
#line 144 "../src/video-support/VideoReader.vala"
		exposure_time = _tmp52_;
#line 1333 "VideoReader.c"
	}
#line 147 "../src/video-support/VideoReader.vala"
	_tmp53_ = params->row;
#line 147 "../src/video-support/VideoReader.vala"
	video_id_init (&_tmp53_->video_id, VIDEO_ID_INVALID);
#line 148 "../src/video-support/VideoReader.vala"
	_tmp54_ = params->row;
#line 148 "../src/video-support/VideoReader.vala"
	_tmp55_ = file;
#line 148 "../src/video-support/VideoReader.vala"
	_tmp56_ = g_file_get_path (_tmp55_);
#line 148 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp54_->filepath);
#line 148 "../src/video-support/VideoReader.vala"
	_tmp54_->filepath = _tmp56_;
#line 149 "../src/video-support/VideoReader.vala"
	_tmp57_ = params->row;
#line 149 "../src/video-support/VideoReader.vala"
	_tmp58_ = info;
#line 149 "../src/video-support/VideoReader.vala"
	_tmp57_->filesize = g_file_info_get_size (_tmp58_);
#line 150 "../src/video-support/VideoReader.vala"
	_tmp59_ = params->row;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp60_ = timestamp;
#line 150 "../src/video-support/VideoReader.vala"
	_tmp61_ = _g_date_time_ref0 (_tmp60_);
#line 150 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (_tmp59_->timestamp);
#line 150 "../src/video-support/VideoReader.vala"
	_tmp59_->timestamp = _tmp61_;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp62_ = params->row;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp63_ = preview_frame;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp64_ = gdk_pixbuf_get_width (_tmp63_);
#line 151 "../src/video-support/VideoReader.vala"
	_tmp65_ = _tmp64_;
#line 151 "../src/video-support/VideoReader.vala"
	_tmp62_->width = _tmp65_;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp66_ = params->row;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp67_ = preview_frame;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp68_ = gdk_pixbuf_get_height (_tmp67_);
#line 152 "../src/video-support/VideoReader.vala"
	_tmp69_ = _tmp68_;
#line 152 "../src/video-support/VideoReader.vala"
	_tmp66_->height = _tmp69_;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp70_ = params->row;
#line 153 "../src/video-support/VideoReader.vala"
	_tmp70_->clip_duration = clip_duration;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp71_ = params->row;
#line 154 "../src/video-support/VideoReader.vala"
	_tmp71_->is_interpretable = is_interpretable;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp72_ = params->row;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp73_ = exposure_time;
#line 155 "../src/video-support/VideoReader.vala"
	_tmp74_ = _g_date_time_ref0 (_tmp73_);
#line 155 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (_tmp72_->exposure_time);
#line 155 "../src/video-support/VideoReader.vala"
	_tmp72_->exposure_time = _tmp74_;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp75_ = params->row;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp76_ = params->import_id;
#line 156 "../src/video-support/VideoReader.vala"
	_tmp75_->import_id = _tmp76_;
#line 157 "../src/video-support/VideoReader.vala"
	_tmp77_ = params->row;
#line 157 "../src/video-support/VideoReader.vala"
	event_id_init (&_tmp77_->event_id, EVENT_ID_INVALID);
#line 158 "../src/video-support/VideoReader.vala"
	_tmp78_ = params->row;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp79_ = params->md5;
#line 158 "../src/video-support/VideoReader.vala"
	_tmp80_ = g_strdup (_tmp79_);
#line 158 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp78_->md5);
#line 158 "../src/video-support/VideoReader.vala"
	_tmp78_->md5 = _tmp80_;
#line 159 "../src/video-support/VideoReader.vala"
	_tmp81_ = params->row;
#line 159 "../src/video-support/VideoReader.vala"
	_tmp81_->time_created = (gint64) 0;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp82_ = params->row;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp83_ = title;
#line 160 "../src/video-support/VideoReader.vala"
	_tmp84_ = g_strdup (_tmp83_);
#line 160 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp82_->title);
#line 160 "../src/video-support/VideoReader.vala"
	_tmp82_->title = _tmp84_;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp85_ = params->row;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp86_ = comment;
#line 161 "../src/video-support/VideoReader.vala"
	_tmp87_ = g_strdup (_tmp86_);
#line 161 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp85_->comment);
#line 161 "../src/video-support/VideoReader.vala"
	_tmp85_->comment = _tmp87_;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp88_ = params->row;
#line 162 "../src/video-support/VideoReader.vala"
	_tmp89_ = g_strdup ("");
#line 162 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp88_->backlinks);
#line 162 "../src/video-support/VideoReader.vala"
	_tmp88_->backlinks = _tmp89_;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp90_ = params->row;
#line 163 "../src/video-support/VideoReader.vala"
	_tmp90_->time_reimported = (gint64) 0;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp91_ = params->row;
#line 164 "../src/video-support/VideoReader.vala"
	_tmp91_->flags = (guint64) 0;
#line 166 "../src/video-support/VideoReader.vala"
	_tmp92_ = params->thumbnails;
#line 166 "../src/video-support/VideoReader.vala"
	if (_tmp92_ != NULL) {
#line 1467 "VideoReader.c"
		Thumbnails* _tmp93_;
		Thumbnails* _tmp94_;
		GdkPixbuf* _tmp95_;
#line 167 "../src/video-support/VideoReader.vala"
		_tmp93_ = thumbnails_new ();
#line 167 "../src/video-support/VideoReader.vala"
		_thumbnails_unref0 (params->thumbnails);
#line 167 "../src/video-support/VideoReader.vala"
		params->thumbnails = _tmp93_;
#line 168 "../src/video-support/VideoReader.vala"
		_tmp94_ = params->thumbnails;
#line 168 "../src/video-support/VideoReader.vala"
		_tmp95_ = preview_frame;
#line 168 "../src/video-support/VideoReader.vala"
		thumbnail_cache_generate_for_video_frame (_tmp94_, _tmp95_);
#line 1483 "VideoReader.c"
	}
#line 174 "../src/video-support/VideoReader.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 174 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (preview_frame);
#line 174 "../src/video-support/VideoReader.vala"
	_video_reader_unref0 (reader);
#line 174 "../src/video-support/VideoReader.vala"
	_g_free0 (comment);
#line 174 "../src/video-support/VideoReader.vala"
	_g_free0 (title);
#line 174 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (exposure_time);
#line 174 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (timestamp);
#line 174 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (info);
#line 174 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (file);
#line 174 "../src/video-support/VideoReader.vala"
	return result;
#line 1505 "VideoReader.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 177 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 177 "../src/video-support/VideoReader.vala"
	return _data16_;
#line 1515 "VideoReader.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 177 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 1525 "VideoReader.c"
		VideoReader* self;
#line 177 "../src/video-support/VideoReader.vala"
		self = _data16_->self;
#line 177 "../src/video-support/VideoReader.vala"
		_video_reader_unref0 (self);
#line 177 "../src/video-support/VideoReader.vala"
		g_slice_free (Block16Data, _data16_);
#line 1533 "VideoReader.c"
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 183 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 183 "../src/video-support/VideoReader.vala"
	return _data17_;
#line 1544 "VideoReader.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 183 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 1554 "VideoReader.c"
		VideoReader* self;
#line 183 "../src/video-support/VideoReader.vala"
		self = _data17_->_data16_->self;
#line 183 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_data17_->cancellable);
#line 183 "../src/video-support/VideoReader.vala"
		block16_data_unref (_data17_->_data16_);
#line 183 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = NULL;
#line 183 "../src/video-support/VideoReader.vala"
		g_slice_free (Block17Data, _data17_);
#line 1566 "VideoReader.c"
	}
}

static gboolean
___lambda11_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	VideoReader* self;
	GCancellable* _tmp0_;
	gboolean result;
#line 186 "../src/video-support/VideoReader.vala"
	_data16_ = _data17_->_data16_;
#line 186 "../src/video-support/VideoReader.vala"
	self = _data16_->self;
#line 187 "../src/video-support/VideoReader.vala"
	_tmp0_ = _data17_->cancellable;
#line 187 "../src/video-support/VideoReader.vala"
	g_cancellable_cancel (_tmp0_);
#line 188 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 190 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 190 "../src/video-support/VideoReader.vala"
	return result;
#line 1591 "VideoReader.c"
}

static gboolean
____lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda11_ (self);
#line 186 "../src/video-support/VideoReader.vala"
	return result;
#line 1601 "VideoReader.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 1614 "VideoReader.c"
}

static void
video_reader_read_internal (VideoReader* self,
                            GError** error)
{
	Block16Data* _data16_;
	GError* _inner_error0_ = NULL;
#line 177 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 177 "../src/video-support/VideoReader.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 177 "../src/video-support/VideoReader.vala"
	_data16_->_ref_count_ = 1;
#line 177 "../src/video-support/VideoReader.vala"
	_data16_->self = video_reader_ref (self);
#line 178 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 1633 "VideoReader.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 179 "../src/video-support/VideoReader.vala"
		_tmp0_ = self->priv->file;
#line 179 "../src/video-support/VideoReader.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 179 "../src/video-support/VideoReader.vala"
		_tmp2_ = _tmp1_;
#line 179 "../src/video-support/VideoReader.vala"
		_tmp3_ = g_strdup_printf ("video file '%s' does not exist or is inaccessible", _tmp2_);
#line 179 "../src/video-support/VideoReader.vala"
		_tmp4_ = _tmp3_;
#line 179 "../src/video-support/VideoReader.vala"
		_tmp5_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_FILE, _tmp4_);
#line 179 "../src/video-support/VideoReader.vala"
		_tmp6_ = _tmp5_;
#line 179 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp4_);
#line 179 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp2_);
#line 179 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp6_;
#line 179 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 179 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 179 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 179 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 179 "../src/video-support/VideoReader.vala"
			return;
#line 1671 "VideoReader.c"
		} else {
#line 179 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 179 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 179 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 179 "../src/video-support/VideoReader.vala"
			return;
#line 1683 "VideoReader.c"
		}
	}
#line 182 "../src/video-support/VideoReader.vala"
	_data16_->id = (guint) 0;
#line 1688 "VideoReader.c"
	{
		Block17Data* _data17_;
		GCancellable* _tmp7_;
		GBytes* stdout_buf = NULL;
		GBytes* stderr_buf = NULL;
		GSubprocess* process = NULL;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GSubprocess* _tmp15_;
		GSubprocess* _tmp16_;
		gboolean _result_ = FALSE;
		GSubprocess* _tmp17_;
		GCancellable* _tmp18_;
		GBytes* _tmp19_ = NULL;
		GBytes* _tmp20_ = NULL;
		gboolean _tmp21_;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
#line 183 "../src/video-support/VideoReader.vala"
		_data17_ = g_slice_new0 (Block17Data);
#line 183 "../src/video-support/VideoReader.vala"
		_data17_->_ref_count_ = 1;
#line 183 "../src/video-support/VideoReader.vala"
		_data17_->_data16_ = block16_data_ref (_data16_);
#line 184 "../src/video-support/VideoReader.vala"
		_tmp7_ = g_cancellable_new ();
#line 184 "../src/video-support/VideoReader.vala"
		_data17_->cancellable = _tmp7_;
#line 186 "../src/video-support/VideoReader.vala"
		_data16_->id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 10, ____lambda11__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 193 "../src/video-support/VideoReader.vala"
		stdout_buf = NULL;
#line 194 "../src/video-support/VideoReader.vala"
		stderr_buf = NULL;
#line 196 "../src/video-support/VideoReader.vala"
		_tmp8_ = app_dirs_get_metadata_helper ();
#line 196 "../src/video-support/VideoReader.vala"
		_tmp9_ = _tmp8_;
#line 196 "../src/video-support/VideoReader.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 196 "../src/video-support/VideoReader.vala"
		_tmp11_ = _tmp10_;
#line 196 "../src/video-support/VideoReader.vala"
		_tmp12_ = self->priv->file;
#line 196 "../src/video-support/VideoReader.vala"
		_tmp13_ = g_file_get_uri (_tmp12_);
#line 196 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_;
#line 196 "../src/video-support/VideoReader.vala"
		_tmp15_ = g_subprocess_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_, _tmp11_, _tmp14_, NULL);
#line 196 "../src/video-support/VideoReader.vala"
		_tmp16_ = _tmp15_;
#line 196 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp14_);
#line 196 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp11_);
#line 196 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp9_);
#line 196 "../src/video-support/VideoReader.vala"
		process = _tmp16_;
#line 196 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 196 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 196 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 196 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1765 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 197 "../src/video-support/VideoReader.vala"
		_tmp17_ = process;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp18_ = _data17_->cancellable;
#line 197 "../src/video-support/VideoReader.vala"
		_tmp21_ = g_subprocess_communicate (_tmp17_, NULL, _tmp18_, &_tmp19_, &_tmp20_, &_inner_error0_);
#line 197 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 197 "../src/video-support/VideoReader.vala"
		stdout_buf = _tmp19_;
#line 197 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 197 "../src/video-support/VideoReader.vala"
		stderr_buf = _tmp20_;
#line 197 "../src/video-support/VideoReader.vala"
		_result_ = _tmp21_;
#line 197 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (process);
#line 197 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stderr_buf);
#line 197 "../src/video-support/VideoReader.vala"
			_g_bytes_unref0 (stdout_buf);
#line 197 "../src/video-support/VideoReader.vala"
			block17_data_unref (_data17_);
#line 197 "../src/video-support/VideoReader.vala"
			_data17_ = NULL;
#line 1796 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 198 "../src/video-support/VideoReader.vala"
		if (_result_) {
#line 1801 "VideoReader.c"
			GSubprocess* _tmp25_;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp25_ = process;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp24_ = g_subprocess_get_exit_status (_tmp25_) == 0;
#line 1807 "VideoReader.c"
		} else {
#line 198 "../src/video-support/VideoReader.vala"
			_tmp24_ = FALSE;
#line 1811 "VideoReader.c"
		}
#line 198 "../src/video-support/VideoReader.vala"
		if (_tmp24_) {
#line 1815 "VideoReader.c"
			GBytes* _tmp26_;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp26_ = stdout_buf;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp23_ = _tmp26_ != NULL;
#line 1821 "VideoReader.c"
		} else {
#line 198 "../src/video-support/VideoReader.vala"
			_tmp23_ = FALSE;
#line 1825 "VideoReader.c"
		}
#line 198 "../src/video-support/VideoReader.vala"
		if (_tmp23_) {
#line 1829 "VideoReader.c"
			GBytes* _tmp27_;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp27_ = stdout_buf;
#line 198 "../src/video-support/VideoReader.vala"
			_tmp22_ = g_bytes_get_size (_tmp27_) > ((gsize) 0);
#line 1835 "VideoReader.c"
		} else {
#line 198 "../src/video-support/VideoReader.vala"
			_tmp22_ = FALSE;
#line 1839 "VideoReader.c"
		}
#line 198 "../src/video-support/VideoReader.vala"
		if (_tmp22_) {
#line 1843 "VideoReader.c"
			gchar** lines = NULL;
			GBytes* _tmp28_;
			gsize _tmp29_ = 0;
			guint8* _tmp30_;
			gchar** _tmp31_;
			gchar** _tmp32_;
			gint lines_length1;
			gint _lines_size_;
			gchar* old = NULL;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar** _tmp35_;
			gint _tmp35__length1;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar** _tmp38_;
			gint _tmp38__length1;
			const gchar* _tmp39_;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp28_ = stdout_buf;
#line 199 "../src/video-support/VideoReader.vala"
			_tmp30_ = g_bytes_get_data (_tmp28_, &_tmp29_);
#line 199 "../src/video-support/VideoReader.vala"
			_tmp32_ = _tmp31_ = g_strsplit ((const gchar*) _tmp30_, "\n", 0);
#line 199 "../src/video-support/VideoReader.vala"
			lines = _tmp32_;
#line 199 "../src/video-support/VideoReader.vala"
			lines_length1 = _vala_array_length (_tmp31_);
#line 199 "../src/video-support/VideoReader.vala"
			_lines_size_ = lines_length1;
#line 201 "../src/video-support/VideoReader.vala"
			_tmp33_ = setlocale (LC_NUMERIC, "C");
#line 201 "../src/video-support/VideoReader.vala"
			_tmp34_ = g_strdup (_tmp33_);
#line 201 "../src/video-support/VideoReader.vala"
			old = _tmp34_;
#line 202 "../src/video-support/VideoReader.vala"
			_tmp35_ = lines;
#line 202 "../src/video-support/VideoReader.vala"
			_tmp35__length1 = lines_length1;
#line 202 "../src/video-support/VideoReader.vala"
			_tmp36_ = _tmp35_[0];
#line 202 "../src/video-support/VideoReader.vala"
			self->priv->clip_duration = double_parse (_tmp36_);
#line 203 "../src/video-support/VideoReader.vala"
			_tmp37_ = old;
#line 203 "../src/video-support/VideoReader.vala"
			setlocale (LC_NUMERIC, _tmp37_);
#line 204 "../src/video-support/VideoReader.vala"
			_tmp38_ = lines;
#line 204 "../src/video-support/VideoReader.vala"
			_tmp38__length1 = lines_length1;
#line 204 "../src/video-support/VideoReader.vala"
			_tmp39_ = _tmp38_[1];
#line 204 "../src/video-support/VideoReader.vala"
			if (g_strcmp0 (_tmp39_, "none") != 0) {
#line 1900 "VideoReader.c"
				gchar** _tmp40_;
				gint _tmp40__length1;
				const gchar* _tmp41_;
				GDateTime* _tmp42_;
				GDateTime* _tmp43_;
#line 205 "../src/video-support/VideoReader.vala"
				_tmp40_ = lines;
#line 205 "../src/video-support/VideoReader.vala"
				_tmp40__length1 = lines_length1;
#line 205 "../src/video-support/VideoReader.vala"
				_tmp41_ = _tmp40_[1];
#line 205 "../src/video-support/VideoReader.vala"
				_tmp42_ = g_date_time_new_from_iso8601 (_tmp41_, NULL);
#line 205 "../src/video-support/VideoReader.vala"
				_tmp43_ = _tmp42_;
#line 205 "../src/video-support/VideoReader.vala"
				video_reader_set_timestamp (self, _tmp43_);
#line 205 "../src/video-support/VideoReader.vala"
				_g_date_time_unref0 (_tmp43_);
#line 1920 "VideoReader.c"
			}
#line 198 "../src/video-support/VideoReader.vala"
			_g_free0 (old);
#line 198 "../src/video-support/VideoReader.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1926 "VideoReader.c"
		} else {
			gchar* message = NULL;
			gchar* _tmp44_;
			gboolean _tmp45_ = FALSE;
			FILE* _tmp46_;
#line 207 "../src/video-support/VideoReader.vala"
			_tmp44_ = g_strdup ("");
#line 207 "../src/video-support/VideoReader.vala"
			message = _tmp44_;
#line 208 "../src/video-support/VideoReader.vala"
			_tmp46_ = stderr;
#line 208 "../src/video-support/VideoReader.vala"
			if (_tmp46_ != NULL) {
#line 1940 "VideoReader.c"
				GBytes* _tmp47_;
#line 208 "../src/video-support/VideoReader.vala"
				_tmp47_ = stderr_buf;
#line 208 "../src/video-support/VideoReader.vala"
				_tmp45_ = g_bytes_get_size (_tmp47_) > ((gsize) 0);
#line 1946 "VideoReader.c"
			} else {
#line 208 "../src/video-support/VideoReader.vala"
				_tmp45_ = FALSE;
#line 1950 "VideoReader.c"
			}
#line 208 "../src/video-support/VideoReader.vala"
			if (_tmp45_) {
#line 1954 "VideoReader.c"
				GBytes* _tmp48_;
				gsize _tmp49_ = 0;
				guint8* _tmp50_;
				gchar* _tmp51_;
#line 209 "../src/video-support/VideoReader.vala"
				_tmp48_ = stderr_buf;
#line 209 "../src/video-support/VideoReader.vala"
				_tmp50_ = g_bytes_get_data (_tmp48_, &_tmp49_);
#line 209 "../src/video-support/VideoReader.vala"
				_tmp51_ = g_strdup ((const gchar*) _tmp50_);
#line 209 "../src/video-support/VideoReader.vala"
				_g_free0 (message);
#line 209 "../src/video-support/VideoReader.vala"
				message = _tmp51_;
#line 1969 "VideoReader.c"
			}
#line 211 "../src/video-support/VideoReader.vala"
			g_warning ("VideoReader.vala:211: External Metadata helper failed");
#line 198 "../src/video-support/VideoReader.vala"
			_g_free0 (message);
#line 1975 "VideoReader.c"
		}
#line 183 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (process);
#line 183 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stderr_buf);
#line 183 "../src/video-support/VideoReader.vala"
		_g_bytes_unref0 (stdout_buf);
#line 183 "../src/video-support/VideoReader.vala"
		block17_data_unref (_data17_);
#line 183 "../src/video-support/VideoReader.vala"
		_data17_ = NULL;
#line 1987 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp52_;
		const gchar* _tmp53_;
		GError* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		GError* _tmp58_;
		GError* _tmp59_;
#line 183 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 183 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 214 "../src/video-support/VideoReader.vala"
		_tmp52_ = e;
#line 214 "../src/video-support/VideoReader.vala"
		_tmp53_ = _tmp52_->message;
#line 214 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:214: Video read error: %s", _tmp53_);
#line 215 "../src/video-support/VideoReader.vala"
		_tmp54_ = e;
#line 215 "../src/video-support/VideoReader.vala"
		_tmp55_ = _tmp54_->message;
#line 215 "../src/video-support/VideoReader.vala"
		_tmp56_ = g_strdup_printf ("GStreamer couldn't extract clip information: %s", _tmp55_);
#line 215 "../src/video-support/VideoReader.vala"
		_tmp57_ = _tmp56_;
#line 215 "../src/video-support/VideoReader.vala"
		_tmp58_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_CONTENTS, _tmp57_);
#line 215 "../src/video-support/VideoReader.vala"
		_tmp59_ = _tmp58_;
#line 215 "../src/video-support/VideoReader.vala"
		_g_free0 (_tmp57_);
#line 215 "../src/video-support/VideoReader.vala"
		_inner_error0_ = _tmp59_;
#line 215 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 2029 "VideoReader.c"
		goto __finally0;
	}
	__finally0:
#line 183 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/video-support/VideoReader.vala"
		if (_inner_error0_->domain == VIDEO_ERROR) {
#line 183 "../src/video-support/VideoReader.vala"
			g_propagate_error (error, _inner_error0_);
#line 183 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 183 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 183 "../src/video-support/VideoReader.vala"
			return;
#line 2045 "VideoReader.c"
		} else {
#line 183 "../src/video-support/VideoReader.vala"
			block16_data_unref (_data16_);
#line 183 "../src/video-support/VideoReader.vala"
			_data16_ = NULL;
#line 183 "../src/video-support/VideoReader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/video-support/VideoReader.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../src/video-support/VideoReader.vala"
			return;
#line 2057 "VideoReader.c"
		}
	}
#line 219 "../src/video-support/VideoReader.vala"
	if (_data16_->id != ((guint) 0)) {
#line 220 "../src/video-support/VideoReader.vala"
		g_source_remove (_data16_->id);
#line 2064 "VideoReader.c"
	}
#line 177 "../src/video-support/VideoReader.vala"
	block16_data_unref (_data16_);
#line 177 "../src/video-support/VideoReader.vala"
	_data16_ = NULL;
#line 2070 "VideoReader.c"
}

static gboolean
video_reader_on_thumbnailer_timer (VideoReader* self)
{
	gboolean result;
#line 225 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 226 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:226: Thumbnailer timer called");
#line 227 "../src/video-support/VideoReader.vala"
	if (self->priv->thumbnailer_pid != ((GPid) 0)) {
#line 228 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:228: Killing thumbnailer process: %d", (gint) self->priv->thumbnailer_pid);
#line 230 "../src/video-support/VideoReader.vala"
		kill ((pid_t) self->priv->thumbnailer_pid, (gint) SIGKILL);
#line 2087 "VideoReader.c"
	}
#line 235 "../src/video-support/VideoReader.vala"
	result = FALSE;
#line 235 "../src/video-support/VideoReader.vala"
	return result;
#line 2093 "VideoReader.c"
}

static gboolean
_video_reader_on_thumbnailer_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = video_reader_on_thumbnailer_timer ((VideoReader*) self);
#line 258 "../src/video-support/VideoReader.vala"
	return result;
#line 2103 "VideoReader.c"
}

static GdkPixbuf*
video_reader_thumbnailer (VideoReader* self,
                          const gchar* video_file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** argv = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint argv_length1;
	gint _argv_size_;
	gint child_stdout = 0;
	GdkPixbuf* buf = NULL;
	gint child_status = 0;
	gint ret_waitpid = 0;
	gint _tmp22_ = 0;
	pid_t _tmp23_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 240 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 240 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (video_file != NULL, NULL);
#line 242 "../src/video-support/VideoReader.vala"
	_tmp0_ = app_dirs_get_thumbnailer_bin ();
#line 242 "../src/video-support/VideoReader.vala"
	_tmp1_ = _tmp0_;
#line 242 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 242 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 242 "../src/video-support/VideoReader.vala"
	g_debug ("VideoReader.vala:242: Launching thumbnailer process: %s", _tmp3_);
#line 242 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 242 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp1_);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp4_ = app_dirs_get_thumbnailer_bin ();
#line 243 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 243 "../src/video-support/VideoReader.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp7_ = g_strdup (video_file);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 243 "../src/video-support/VideoReader.vala"
	_tmp8_[0] = _tmp6_;
#line 243 "../src/video-support/VideoReader.vala"
	_tmp8_[1] = _tmp7_;
#line 243 "../src/video-support/VideoReader.vala"
	_tmp9_ = _tmp8_;
#line 243 "../src/video-support/VideoReader.vala"
	_tmp9__length1 = 2;
#line 243 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp5_);
#line 243 "../src/video-support/VideoReader.vala"
	argv = _tmp9_;
#line 243 "../src/video-support/VideoReader.vala"
	argv_length1 = _tmp9__length1;
#line 243 "../src/video-support/VideoReader.vala"
	_argv_size_ = argv_length1;
#line 2176 "VideoReader.c"
	{
		gchar** _tmp10_;
		gint _tmp10__length1;
		GPid _tmp11_ = 0;
		gint _tmp12_ = 0;
#line 246 "../src/video-support/VideoReader.vala"
		_tmp10_ = argv;
#line 246 "../src/video-support/VideoReader.vala"
		_tmp10__length1 = argv_length1;
#line 246 "../src/video-support/VideoReader.vala"
		g_spawn_async_with_pipes (NULL, _tmp10_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp11_, NULL, &_tmp12_, NULL, &_inner_error0_);
#line 246 "../src/video-support/VideoReader.vala"
		self->priv->thumbnailer_pid = _tmp11_;
#line 246 "../src/video-support/VideoReader.vala"
		child_stdout = _tmp12_;
#line 246 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2194 "VideoReader.c"
			goto __catch0_g_error;
		}
#line 249 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:249: Spawned thumbnailer, child pid: %d", (gint) self->priv->thumbnailer_pid);
#line 2199 "VideoReader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 245 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 245 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 251 "../src/video-support/VideoReader.vala"
		_tmp13_ = e;
#line 251 "../src/video-support/VideoReader.vala"
		_tmp14_ = _tmp13_->message;
#line 251 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:251: Error spawning process: %s", _tmp14_);
#line 252 "../src/video-support/VideoReader.vala"
		if (self->priv->thumbnailer_pid != ((GPid) 0)) {
#line 253 "../src/video-support/VideoReader.vala"
			g_spawn_close_pid (self->priv->thumbnailer_pid);
#line 2221 "VideoReader.c"
		}
#line 254 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 254 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 254 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 254 "../src/video-support/VideoReader.vala"
		return result;
#line 2231 "VideoReader.c"
	}
	__finally0:
#line 245 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 245 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2244 "VideoReader.c"
	}
#line 258 "../src/video-support/VideoReader.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, VIDEO_READER_THUMBNAILER_TIMEOUT, _video_reader_on_thumbnailer_timer_gsource_func, video_reader_ref (self), video_reader_unref);
#line 261 "../src/video-support/VideoReader.vala"
	buf = NULL;
#line 2250 "VideoReader.c"
	{
		GUnixInputStream* unix_input = NULL;
		GUnixInputStream* _tmp15_;
		GdkPixbuf* _tmp16_ = NULL;
		GUnixInputStream* _tmp17_;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_;
#line 263 "../src/video-support/VideoReader.vala"
		_tmp15_ = (GUnixInputStream*) g_unix_input_stream_new (child_stdout, TRUE);
#line 263 "../src/video-support/VideoReader.vala"
		unix_input = _tmp15_;
#line 264 "../src/video-support/VideoReader.vala"
		_tmp17_ = unix_input;
#line 264 "../src/video-support/VideoReader.vala"
		_tmp18_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
#line 264 "../src/video-support/VideoReader.vala"
		_tmp16_ = _tmp18_;
#line 264 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (unix_input);
#line 2272 "VideoReader.c"
			goto __catch1_g_error;
		}
#line 264 "../src/video-support/VideoReader.vala"
		_tmp19_ = _tmp16_;
#line 264 "../src/video-support/VideoReader.vala"
		_tmp16_ = NULL;
#line 264 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 264 "../src/video-support/VideoReader.vala"
		buf = _tmp19_;
#line 262 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (_tmp16_);
#line 262 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (unix_input);
#line 2287 "VideoReader.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 262 "../src/video-support/VideoReader.vala"
		e = _inner_error0_;
#line 262 "../src/video-support/VideoReader.vala"
		_inner_error0_ = NULL;
#line 266 "../src/video-support/VideoReader.vala"
		_tmp20_ = e;
#line 266 "../src/video-support/VideoReader.vala"
		_tmp21_ = _tmp20_->message;
#line 266 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:266: Error creating pixbuf: %s", _tmp21_);
#line 267 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 267 "../src/video-support/VideoReader.vala"
		buf = NULL;
#line 262 "../src/video-support/VideoReader.vala"
		_g_error_free0 (e);
#line 2311 "VideoReader.c"
	}
	__finally1:
#line 262 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 262 "../src/video-support/VideoReader.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 262 "../src/video-support/VideoReader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../src/video-support/VideoReader.vala"
		g_clear_error (&_inner_error0_);
#line 262 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2326 "VideoReader.c"
	}
#line 271 "../src/video-support/VideoReader.vala"
	child_status = 0;
#line 272 "../src/video-support/VideoReader.vala"
	_tmp23_ = waitpid ((pid_t) self->priv->thumbnailer_pid, &_tmp22_, 0);
#line 272 "../src/video-support/VideoReader.vala"
	child_status = _tmp22_;
#line 272 "../src/video-support/VideoReader.vala"
	ret_waitpid = (gint) _tmp23_;
#line 273 "../src/video-support/VideoReader.vala"
	if (ret_waitpid < 0) {
#line 274 "../src/video-support/VideoReader.vala"
		g_debug ("VideoReader.vala:274: waitpid returned error code: %d", ret_waitpid);
#line 275 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (buf);
#line 275 "../src/video-support/VideoReader.vala"
		buf = NULL;
#line 2344 "VideoReader.c"
	} else {
#line 276 "../src/video-support/VideoReader.vala"
		if (0 != WEXITSTATUS (child_status)) {
#line 277 "../src/video-support/VideoReader.vala"
			g_debug ("VideoReader.vala:277: Thumbnailer exited with error code: %d", WEXITSTATUS (child_status));
#line 279 "../src/video-support/VideoReader.vala"
			_g_object_unref0 (buf);
#line 279 "../src/video-support/VideoReader.vala"
			buf = NULL;
#line 2354 "VideoReader.c"
		}
	}
#line 282 "../src/video-support/VideoReader.vala"
	g_spawn_close_pid (self->priv->thumbnailer_pid);
#line 283 "../src/video-support/VideoReader.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 284 "../src/video-support/VideoReader.vala"
	result = buf;
#line 284 "../src/video-support/VideoReader.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 284 "../src/video-support/VideoReader.vala"
	return result;
#line 2367 "VideoReader.c"
}

static gboolean
video_reader_does_file_exist (VideoReader* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 287 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
#line 288 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->file;
#line 288 "../src/video-support/VideoReader.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 288 "../src/video-support/VideoReader.vala"
	_tmp2_ = _tmp1_;
#line 288 "../src/video-support/VideoReader.vala"
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR);
#line 288 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp2_);
#line 288 "../src/video-support/VideoReader.vala"
	result = _tmp3_;
#line 288 "../src/video-support/VideoReader.vala"
	return result;
#line 2394 "VideoReader.c"
}

GdkPixbuf*
video_reader_read_preview_frame (VideoReader* self)
{
	GdkPixbuf* _tmp0_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* result;
#line 291 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 292 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->preview_frame;
#line 292 "../src/video-support/VideoReader.vala"
	if (_tmp0_ != NULL) {
#line 2415 "VideoReader.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 293 "../src/video-support/VideoReader.vala"
		_tmp1_ = self->priv->preview_frame;
#line 293 "../src/video-support/VideoReader.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 293 "../src/video-support/VideoReader.vala"
		result = _tmp2_;
#line 293 "../src/video-support/VideoReader.vala"
		return result;
#line 2426 "VideoReader.c"
	}
#line 295 "../src/video-support/VideoReader.vala"
	if (!video_reader_does_file_exist (self)) {
#line 296 "../src/video-support/VideoReader.vala"
		result = NULL;
#line 296 "../src/video-support/VideoReader.vala"
		return result;
#line 2434 "VideoReader.c"
	}
#line 299 "../src/video-support/VideoReader.vala"
	_tmp3_ = self->priv->file;
#line 299 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 299 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 299 "../src/video-support/VideoReader.vala"
	_tmp6_ = video_reader_thumbnailer (self, _tmp5_);
#line 299 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 299 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = _tmp6_;
#line 299 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp5_);
#line 300 "../src/video-support/VideoReader.vala"
	_tmp7_ = self->priv->preview_frame;
#line 300 "../src/video-support/VideoReader.vala"
	if (NULL == _tmp7_) {
#line 2454 "VideoReader.c"
		GdkPixbuf* _tmp8_;
#line 301 "../src/video-support/VideoReader.vala"
		_tmp8_ = resources_get_noninterpretable_badge_pixbuf ();
#line 301 "../src/video-support/VideoReader.vala"
		_g_object_unref0 (self->priv->preview_frame);
#line 301 "../src/video-support/VideoReader.vala"
		self->priv->preview_frame = _tmp8_;
#line 2462 "VideoReader.c"
	}
#line 303 "../src/video-support/VideoReader.vala"
	_tmp9_ = self->priv->preview_frame;
#line 303 "../src/video-support/VideoReader.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 303 "../src/video-support/VideoReader.vala"
	result = _tmp10_;
#line 303 "../src/video-support/VideoReader.vala"
	return result;
#line 2472 "VideoReader.c"
}

gdouble
video_reader_read_clip_duration (VideoReader* self,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	gdouble result;
#line 306 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), 0.0);
#line 307 "../src/video-support/VideoReader.vala"
	if (self->priv->clip_duration == VIDEO_READER_UNKNOWN_CLIP_DURATION) {
#line 308 "../src/video-support/VideoReader.vala"
		video_reader_read_internal (self, &_inner_error0_);
#line 308 "../src/video-support/VideoReader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "../src/video-support/VideoReader.vala"
			if (_inner_error0_->domain == VIDEO_ERROR) {
#line 2491 "VideoReader.c"
				gdouble _tmp0_ = -1.0;
#line 308 "../src/video-support/VideoReader.vala"
				g_propagate_error (error, _inner_error0_);
#line 308 "../src/video-support/VideoReader.vala"
				return _tmp0_;
#line 2497 "VideoReader.c"
			} else {
				gdouble _tmp1_ = -1.0;
#line 308 "../src/video-support/VideoReader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 308 "../src/video-support/VideoReader.vala"
				g_clear_error (&_inner_error0_);
#line 308 "../src/video-support/VideoReader.vala"
				return _tmp1_;
#line 2506 "VideoReader.c"
			}
		}
	}
#line 310 "../src/video-support/VideoReader.vala"
	result = self->priv->clip_duration;
#line 310 "../src/video-support/VideoReader.vala"
	return result;
#line 2514 "VideoReader.c"
}

VideoMetadata*
video_reader_read_metadata (VideoReader* self,
                            GError** error)
{
	VideoMetadata* metadata = NULL;
	VideoMetadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	VideoMetadata* result;
#line 313 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 314 "../src/video-support/VideoReader.vala"
	_tmp0_ = video_metadata_new ();
#line 314 "../src/video-support/VideoReader.vala"
	metadata = _tmp0_;
#line 315 "../src/video-support/VideoReader.vala"
	_tmp1_ = self->priv->file;
#line 315 "../src/video-support/VideoReader.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 315 "../src/video-support/VideoReader.vala"
	_tmp3_ = _tmp2_;
#line 315 "../src/video-support/VideoReader.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 315 "../src/video-support/VideoReader.vala"
	_tmp5_ = _tmp4_;
#line 315 "../src/video-support/VideoReader.vala"
	media_metadata_read_from_file (G_TYPE_CHECK_INSTANCE_CAST (metadata, TYPE_MEDIA_METADATA, MediaMetadata), _tmp5_, &_inner_error0_);
#line 315 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (_tmp5_);
#line 315 "../src/video-support/VideoReader.vala"
	_g_free0 (_tmp3_);
#line 315 "../src/video-support/VideoReader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "../src/video-support/VideoReader.vala"
		g_propagate_error (error, _inner_error0_);
#line 315 "../src/video-support/VideoReader.vala"
		_media_metadata_unref0 (metadata);
#line 315 "../src/video-support/VideoReader.vala"
		return NULL;
#line 2560 "VideoReader.c"
	}
#line 317 "../src/video-support/VideoReader.vala"
	result = metadata;
#line 317 "../src/video-support/VideoReader.vala"
	return result;
#line 2566 "VideoReader.c"
}

GDateTime*
video_reader_get_timestamp (VideoReader* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = self->priv->_timestamp;
#line 26 "../src/video-support/VideoReader.vala"
	result = _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	return result;
#line 2582 "VideoReader.c"
}

static void
video_reader_set_timestamp (VideoReader* self,
                            GDateTime* value)
{
	GDateTime* _tmp0_;
#line 26 "../src/video-support/VideoReader.vala"
	g_return_if_fail (IS_VIDEO_READER (self));
#line 26 "../src/video-support/VideoReader.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = _tmp0_;
#line 2598 "VideoReader.c"
}

static void
value_video_reader_init (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	value->data[0].v_pointer = NULL;
#line 2606 "VideoReader.c"
}

static void
value_video_reader_free_value (GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (value->data[0].v_pointer);
#line 2616 "VideoReader.c"
	}
}

static void
value_video_reader_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (src_value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = video_reader_ref (src_value->data[0].v_pointer);
#line 2628 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2632 "VideoReader.c"
	}
}

static gpointer
value_video_reader_peek_pointer (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2641 "VideoReader.c"
}

static gchar*
value_video_reader_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 15 "../src/video-support/VideoReader.vala"
	if (collect_values[0].v_pointer) {
#line 2652 "VideoReader.c"
		VideoReader * object;
		object = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
		if (object->parent_instance.g_class == NULL) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2659 "VideoReader.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 15 "../src/video-support/VideoReader.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2663 "VideoReader.c"
		}
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = video_reader_ref (object);
#line 2667 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2671 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2675 "VideoReader.c"
}

static gchar*
value_video_reader_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	VideoReader ** object_p;
	object_p = collect_values[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (!object_p) {
#line 15 "../src/video-support/VideoReader.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2690 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (!value->data[0].v_pointer) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = NULL;
#line 2696 "VideoReader.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = value->data[0].v_pointer;
#line 2700 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		*object_p = video_reader_ref (value->data[0].v_pointer);
#line 2704 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	return NULL;
#line 2708 "VideoReader.c"
}

GParamSpec*
param_spec_video_reader (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecVideoReader* spec;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 15 "../src/video-support/VideoReader.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 15 "../src/video-support/VideoReader.vala"
	return G_PARAM_SPEC (spec);
#line 2727 "VideoReader.c"
}

gpointer
value_get_video_reader (const GValue* value)
{
#line 15 "../src/video-support/VideoReader.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER), NULL);
#line 15 "../src/video-support/VideoReader.vala"
	return value->data[0].v_pointer;
#line 2737 "VideoReader.c"
}

void
value_set_video_reader (GValue* value,
                        gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_ref (value->data[0].v_pointer);
#line 2759 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2763 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2769 "VideoReader.c"
	}
}

void
value_take_video_reader (GValue* value,
                         gpointer v_object)
{
	VideoReader * old;
#line 15 "../src/video-support/VideoReader.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
	old = value->data[0].v_pointer;
#line 15 "../src/video-support/VideoReader.vala"
	if (v_object) {
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
#line 15 "../src/video-support/VideoReader.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = v_object;
#line 2790 "VideoReader.c"
	} else {
#line 15 "../src/video-support/VideoReader.vala"
		value->data[0].v_pointer = NULL;
#line 2794 "VideoReader.c"
	}
#line 15 "../src/video-support/VideoReader.vala"
	if (old) {
#line 15 "../src/video-support/VideoReader.vala"
		video_reader_unref (old);
#line 2800 "VideoReader.c"
	}
}

static void
video_reader_class_init (VideoReaderClass * klass,
                         gpointer klass_data)
{
#line 15 "../src/video-support/VideoReader.vala"
	video_reader_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/video-support/VideoReader.vala"
	((VideoReaderClass *) klass)->finalize = video_reader_finalize;
#line 15 "../src/video-support/VideoReader.vala"
	g_type_class_adjust_private_offset (klass, &VideoReader_private_offset);
#line 2814 "VideoReader.c"
}

static void
video_reader_instance_init (VideoReader * self,
                            gpointer klass)
{
#line 15 "../src/video-support/VideoReader.vala"
	self->priv = video_reader_get_instance_private (self);
#line 22 "../src/video-support/VideoReader.vala"
	self->priv->clip_duration = VIDEO_READER_UNKNOWN_CLIP_DURATION;
#line 23 "../src/video-support/VideoReader.vala"
	self->priv->preview_frame = NULL;
#line 24 "../src/video-support/VideoReader.vala"
	self->priv->file = NULL;
#line 25 "../src/video-support/VideoReader.vala"
	self->priv->thumbnailer_pid = (GPid) 0;
#line 26 "../src/video-support/VideoReader.vala"
	self->priv->_timestamp = NULL;
#line 15 "../src/video-support/VideoReader.vala"
	self->ref_count = 1;
#line 2835 "VideoReader.c"
}

static void
video_reader_finalize (VideoReader * obj)
{
	VideoReader * self;
#line 15 "../src/video-support/VideoReader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_READER, VideoReader);
#line 15 "../src/video-support/VideoReader.vala"
	g_signal_handlers_destroy (self);
#line 23 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->preview_frame);
#line 24 "../src/video-support/VideoReader.vala"
	_g_object_unref0 (self->priv->file);
#line 26 "../src/video-support/VideoReader.vala"
	_g_date_time_unref0 (self->priv->_timestamp);
#line 2852 "VideoReader.c"
}

static GType
video_reader_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_video_reader_init, value_video_reader_free_value, value_video_reader_copy_value, value_video_reader_peek_pointer, "p", value_video_reader_collect_value, "p", value_video_reader_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VideoReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoReader), 0, (GInstanceInitFunc) video_reader_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType video_reader_type_id;
	video_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
	VideoReader_private_offset = g_type_add_instance_private (video_reader_type_id, sizeof (VideoReaderPrivate));
	return video_reader_type_id;
}

GType
video_reader_get_type (void)
{
	static volatile gsize video_reader_type_id__once = 0;
	if (g_once_init_enter (&video_reader_type_id__once)) {
		GType video_reader_type_id;
		video_reader_type_id = video_reader_get_type_once ();
		g_once_init_leave (&video_reader_type_id__once, video_reader_type_id);
	}
	return video_reader_type_id__once;
}

gpointer
video_reader_ref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	g_atomic_int_inc (&self->ref_count);
#line 15 "../src/video-support/VideoReader.vala"
	return instance;
#line 2888 "VideoReader.c"
}

void
video_reader_unref (gpointer instance)
{
	VideoReader * self;
	self = instance;
#line 15 "../src/video-support/VideoReader.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 15 "../src/video-support/VideoReader.vala"
		VIDEO_READER_GET_CLASS (self)->finalize (self);
#line 15 "../src/video-support/VideoReader.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2902 "VideoReader.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

