/* Commands.c generated by valac 0.56.3, the Vala compiler
 * generated from Commands.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/* PageCommand stores the current page when a Command is created.  Subclasses can call return_to_page()*/
/* if it's appropriate to return to that page when executing an undo() or redo().*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include "shotwell-graphics-processor.h"
#include <gdk/gdk.h>

#define MULTIPLE_DATA_SOURCE_COMMAND_MIN_OPS_FOR_PROGRESS_WINDOW 5
#define RESOURCES_EDIT_TITLE_LABEL NC_ ("Button Label", "Edit Title")
#define RESOURCES_EDIT_COMMENT_LABEL _ ("Edit Comment")
#define RESOURCES_RENAME_EVENT_LABEL _ ("Rename Event")
#define RESOURCES_MAKE_KEY_PHOTO_LABEL _ ("Make Key Photo for Event")
#define RESOURCES_REVERT_LABEL _ ("Revert to Original")
#define RESOURCES_ENHANCE_LABEL _ ("Enhance")
#define RESOURCES_ENHANCE_TOOLTIP _ ("Automatically improve the photo’s appearance")
#define RESOURCES_NEW_EVENT_LABEL _ ("New Event")
#define RESOURCES_SET_PHOTO_EVENT_LABEL _ ("Move Photos")
#define RESOURCES_SET_PHOTO_EVENT_TOOLTIP _ ("Move photos to an event")
#define RESOURCES_MERGE_LABEL _ ("Merge")
#define RESOURCES_DUPLICATE_PHOTO_LABEL _ ("Duplicate")
#define RESOURCES_DUPLICATE_PHOTO_TOOLTIP _ ("Make a duplicate of the photo")
#define RESOURCES_INCREASE_RATING_LABEL _ ("Increase Rating")
#define RESOURCES_DECREASE_RATING_LABEL _ ("Decrease Rating")
#define RESOURCES_ADJUST_DATE_TIME_LABEL _ ("Adjust Date and Time")
#define TAG_PATH_SEPARATOR_STRING "/"
#define RESOURCES_MODIFY_TAGS_LABEL _ ("Modify Tags")
#define FLAG_UNFLAG_COMMAND_MIN_PROGRESS_BAR_THRESHOLD 1000
#define FLAG_UNFLAG_COMMAND_FLAG_SELECTED_STRING _ ("Flag selected photos")
#define FLAG_UNFLAG_COMMAND_UNFLAG_SELECTED_STRING _ ("Unflag selected photos")
#define FLAG_UNFLAG_COMMAND_FLAG_PROGRESS _ ("Flagging selected photos")
#define FLAG_UNFLAG_COMMAND_UNFLAG_PROGRESS _ ("Unflagging selected photos")
#define RESOURCES_MODIFY_FACES_LABEL _ ("Modify Faces")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_COMMAND_DESCRIPTION (command_description_get_type ())
#define COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescription))
#define IS_COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_DESCRIPTION))
#define COMMAND_DESCRIPTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescriptionIface))

typedef struct _CommandDescription CommandDescription;
typedef struct _CommandDescriptionIface CommandDescriptionIface;

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _CommandPrivate CommandPrivate;

#define TYPE_PAGE_COMMAND (page_command_get_type ())
#define PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_COMMAND, PageCommand))
#define PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_COMMAND, PageCommandClass))
#define IS_PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_COMMAND))
#define IS_PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_COMMAND))
#define PAGE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_COMMAND, PageCommandClass))

typedef struct _PageCommand PageCommand;
typedef struct _PageCommandClass PageCommandClass;
typedef struct _PageCommandPrivate PageCommandPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_CHECKERBOARD_PAGE (checkerboard_page_get_type ())
#define CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPage))
#define CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))
#define IS_CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_PAGE))
#define IS_CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_PAGE))
#define CHECKERBOARD_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))

typedef struct _CheckerboardPage CheckerboardPage;
typedef struct _CheckerboardPageClass CheckerboardPageClass;

#define TYPE_MEDIA_PAGE (media_page_get_type ())
#define MEDIA_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_PAGE, MediaPage))
#define MEDIA_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_PAGE, MediaPageClass))
#define IS_MEDIA_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_PAGE))
#define IS_MEDIA_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_PAGE))
#define MEDIA_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_PAGE, MediaPageClass))

typedef struct _MediaPage MediaPage;
typedef struct _MediaPageClass MediaPageClass;

#define TYPE_COLLECTION_PAGE (collection_page_get_type ())
#define COLLECTION_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLLECTION_PAGE, CollectionPage))
#define COLLECTION_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLLECTION_PAGE, CollectionPageClass))
#define IS_COLLECTION_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLLECTION_PAGE))
#define IS_COLLECTION_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLLECTION_PAGE))
#define COLLECTION_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLLECTION_PAGE, CollectionPageClass))

typedef struct _CollectionPage CollectionPage;
typedef struct _CollectionPageClass CollectionPageClass;
enum  {
	PAGE_COMMAND_0_PROPERTY,
	PAGE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* page_command_properties[PAGE_COMMAND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;

#define TYPE_SINGLE_PHOTO_PAGE (single_photo_page_get_type ())
#define SINGLE_PHOTO_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPage))
#define SINGLE_PHOTO_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPageClass))
#define IS_SINGLE_PHOTO_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_PHOTO_PAGE))
#define IS_SINGLE_PHOTO_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_PHOTO_PAGE))
#define SINGLE_PHOTO_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_PHOTO_PAGE, SinglePhotoPageClass))

typedef struct _SinglePhotoPage SinglePhotoPage;
typedef struct _SinglePhotoPageClass SinglePhotoPageClass;

#define TYPE_EDITING_HOST_PAGE (editing_host_page_get_type ())
#define EDITING_HOST_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDITING_HOST_PAGE, EditingHostPage))
#define EDITING_HOST_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDITING_HOST_PAGE, EditingHostPageClass))
#define IS_EDITING_HOST_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDITING_HOST_PAGE))
#define IS_EDITING_HOST_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDITING_HOST_PAGE))
#define EDITING_HOST_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDITING_HOST_PAGE, EditingHostPageClass))

typedef struct _EditingHostPage EditingHostPage;
typedef struct _EditingHostPageClass EditingHostPageClass;

#define TYPE_LIBRARY_PHOTO_PAGE (library_photo_page_get_type ())
#define LIBRARY_PHOTO_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_PAGE, LibraryPhotoPage))
#define LIBRARY_PHOTO_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_PAGE, LibraryPhotoPageClass))
#define IS_LIBRARY_PHOTO_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_PAGE))
#define IS_LIBRARY_PHOTO_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_PAGE))
#define LIBRARY_PHOTO_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_PAGE, LibraryPhotoPageClass))

typedef struct _LibraryPhotoPage LibraryPhotoPage;
typedef struct _LibraryPhotoPageClass LibraryPhotoPageClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_CHECKERBOARD_ITEM (checkerboard_item_get_type ())
#define CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItem))
#define CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))
#define IS_CHECKERBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_ITEM))
#define IS_CHECKERBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_ITEM))
#define CHECKERBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_ITEM, CheckerboardItemClass))

typedef struct _CheckerboardItem CheckerboardItem;
typedef struct _CheckerboardItemClass CheckerboardItemClass;

#define TYPE_MEDIA_SOURCE_ITEM (media_source_item_get_type ())
#define MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItem))
#define MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))
#define IS_MEDIA_SOURCE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_ITEM))
#define IS_MEDIA_SOURCE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_ITEM))
#define MEDIA_SOURCE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_ITEM, MediaSourceItemClass))

typedef struct _MediaSourceItem MediaSourceItem;
typedef struct _MediaSourceItemClass MediaSourceItemClass;

#define TYPE_THUMBNAIL (thumbnail_get_type ())
#define THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL, Thumbnail))
#define THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL, ThumbnailClass))
#define IS_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL))
#define IS_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL))
#define THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL, ThumbnailClass))

typedef struct _Thumbnail Thumbnail;
typedef struct _ThumbnailClass ThumbnailClass;

#define TYPE_LIBRARY_WINDOW (library_window_get_type ())
#define LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_WINDOW, LibraryWindow))
#define LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_WINDOW, LibraryWindowClass))
#define IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_WINDOW))
#define IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_WINDOW))
#define LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_WINDOW, LibraryWindowClass))

typedef struct _LibraryWindow LibraryWindow;
typedef struct _LibraryWindowClass LibraryWindowClass;

#define TYPE_SINGLE_DATA_SOURCE_COMMAND (single_data_source_command_get_type ())
#define SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand))
#define SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))
#define IS_SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define IS_SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define SINGLE_DATA_SOURCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))

typedef struct _SingleDataSourceCommand SingleDataSourceCommand;
typedef struct _SingleDataSourceCommandClass SingleDataSourceCommandClass;
typedef struct _SingleDataSourceCommandPrivate SingleDataSourceCommandPrivate;
enum  {
	SINGLE_DATA_SOURCE_COMMAND_0_PROPERTY,
	SINGLE_DATA_SOURCE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* single_data_source_command_properties[SINGLE_DATA_SOURCE_COMMAND_NUM_PROPERTIES];

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))

#define TYPE_SIMPLE_PROXYABLE_COMMAND (simple_proxyable_command_get_type ())
#define SIMPLE_PROXYABLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand))
#define SIMPLE_PROXYABLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommandClass))
#define IS_SIMPLE_PROXYABLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SIMPLE_PROXYABLE_COMMAND))
#define IS_SIMPLE_PROXYABLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SIMPLE_PROXYABLE_COMMAND))
#define SIMPLE_PROXYABLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommandClass))

typedef struct _SimpleProxyableCommand SimpleProxyableCommand;
typedef struct _SimpleProxyableCommandClass SimpleProxyableCommandClass;
typedef struct _SimpleProxyableCommandPrivate SimpleProxyableCommandPrivate;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
enum  {
	SIMPLE_PROXYABLE_COMMAND_0_PROPERTY,
	SIMPLE_PROXYABLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* simple_proxyable_command_properties[SIMPLE_PROXYABLE_COMMAND_NUM_PROPERTIES];
#define _source_proxy_unref0(var) ((var == NULL) ? NULL : (var = (source_proxy_unref (var), NULL)))

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;

#define TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND (single_photo_transformation_command_get_type ())
#define SINGLE_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND, SinglePhotoTransformationCommand))
#define SINGLE_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND, SinglePhotoTransformationCommandClass))
#define IS_SINGLE_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND))
#define IS_SINGLE_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND))
#define SINGLE_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND, SinglePhotoTransformationCommandClass))

typedef struct _SinglePhotoTransformationCommand SinglePhotoTransformationCommand;
typedef struct _SinglePhotoTransformationCommandClass SinglePhotoTransformationCommandClass;
typedef struct _SinglePhotoTransformationCommandPrivate SinglePhotoTransformationCommandPrivate;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
enum  {
	SINGLE_PHOTO_TRANSFORMATION_COMMAND_0_PROPERTY,
	SINGLE_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES
};
static GParamSpec* single_photo_transformation_command_properties[SINGLE_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES];

#define TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND (generic_photo_transformation_command_get_type ())
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand))
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommandClass))
#define IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND))
#define IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND))
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommandClass))

typedef struct _GenericPhotoTransformationCommand GenericPhotoTransformationCommand;
typedef struct _GenericPhotoTransformationCommandClass GenericPhotoTransformationCommandClass;
typedef struct _GenericPhotoTransformationCommandPrivate GenericPhotoTransformationCommandPrivate;
enum  {
	GENERIC_PHOTO_TRANSFORMATION_COMMAND_0_PROPERTY,
	GENERIC_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES
};
static GParamSpec* generic_photo_transformation_command_properties[GENERIC_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES];

#define TYPE_MULTIPLE_DATA_SOURCE_COMMAND (multiple_data_source_command_get_type ())
#define MULTIPLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand))
#define MULTIPLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommandClass))
#define IS_MULTIPLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTIPLE_DATA_SOURCE_COMMAND))
#define IS_MULTIPLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTIPLE_DATA_SOURCE_COMMAND))
#define MULTIPLE_DATA_SOURCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommandClass))

typedef struct _MultipleDataSourceCommand MultipleDataSourceCommand;
typedef struct _MultipleDataSourceCommandClass MultipleDataSourceCommandClass;
typedef struct _MultipleDataSourceCommandPrivate MultipleDataSourceCommandPrivate;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
enum  {
	MULTIPLE_DATA_SOURCE_COMMAND_0_PROPERTY,
	MULTIPLE_DATA_SOURCE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* multiple_data_source_command_properties[MULTIPLE_DATA_SOURCE_COMMAND_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_PROGRESS_DIALOG (progress_dialog_get_type ())
#define PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROGRESS_DIALOG, ProgressDialog))
#define PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROGRESS_DIALOG, ProgressDialogClass))
#define IS_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROGRESS_DIALOG))
#define IS_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROGRESS_DIALOG))
#define PROGRESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROGRESS_DIALOG, ProgressDialogClass))

typedef struct _ProgressDialog ProgressDialog;
typedef struct _ProgressDialogClass ProgressDialogClass;

#define TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND (multiple_data_source_at_once_command_get_type ())
#define MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommand))
#define MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommandClass))
#define IS_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND))
#define IS_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND))
#define MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommandClass))

typedef struct _MultipleDataSourceAtOnceCommand MultipleDataSourceAtOnceCommand;
typedef struct _MultipleDataSourceAtOnceCommandClass MultipleDataSourceAtOnceCommandClass;
typedef struct _MultipleDataSourceAtOnceCommandPrivate MultipleDataSourceAtOnceCommandPrivate;
enum  {
	MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_0_PROPERTY,
	MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* multiple_data_source_at_once_command_properties[MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_NUM_PROPERTIES];

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND (multiple_photo_transformation_command_get_type ())
#define MULTIPLE_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, MultiplePhotoTransformationCommand))
#define MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, MultiplePhotoTransformationCommandClass))
#define IS_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND))
#define IS_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND))
#define MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, MultiplePhotoTransformationCommandClass))

typedef struct _MultiplePhotoTransformationCommand MultiplePhotoTransformationCommand;
typedef struct _MultiplePhotoTransformationCommandClass MultiplePhotoTransformationCommandClass;
typedef struct _MultiplePhotoTransformationCommandPrivate MultiplePhotoTransformationCommandPrivate;
enum  {
	MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_0_PROPERTY,
	MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES
};
static GParamSpec* multiple_photo_transformation_command_properties[MULTIPLE_PHOTO_TRANSFORMATION_COMMAND_NUM_PROPERTIES];

#define TYPE_ROTATE_SINGLE_COMMAND (rotate_single_command_get_type ())
#define ROTATE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommand))
#define ROTATE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommandClass))
#define IS_ROTATE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROTATE_SINGLE_COMMAND))
#define IS_ROTATE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROTATE_SINGLE_COMMAND))
#define ROTATE_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommandClass))

typedef struct _RotateSingleCommand RotateSingleCommand;
typedef struct _RotateSingleCommandClass RotateSingleCommandClass;
typedef struct _RotateSingleCommandPrivate RotateSingleCommandPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())
enum  {
	ROTATE_SINGLE_COMMAND_0_PROPERTY,
	ROTATE_SINGLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rotate_single_command_properties[ROTATE_SINGLE_COMMAND_NUM_PROPERTIES];

#define TYPE_ROTATE_MULTIPLE_COMMAND (rotate_multiple_command_get_type ())
#define ROTATE_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommand))
#define ROTATE_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommandClass))
#define IS_ROTATE_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROTATE_MULTIPLE_COMMAND))
#define IS_ROTATE_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROTATE_MULTIPLE_COMMAND))
#define ROTATE_MULTIPLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommandClass))

typedef struct _RotateMultipleCommand RotateMultipleCommand;
typedef struct _RotateMultipleCommandClass RotateMultipleCommandClass;
typedef struct _RotateMultipleCommandPrivate RotateMultipleCommandPrivate;
enum  {
	ROTATE_MULTIPLE_COMMAND_0_PROPERTY,
	ROTATE_MULTIPLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rotate_multiple_command_properties[ROTATE_MULTIPLE_COMMAND_NUM_PROPERTIES];

#define TYPE_EDIT_TITLE_COMMAND (edit_title_command_get_type ())
#define EDIT_TITLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_TITLE_COMMAND, EditTitleCommand))
#define EDIT_TITLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_TITLE_COMMAND, EditTitleCommandClass))
#define IS_EDIT_TITLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_TITLE_COMMAND))
#define IS_EDIT_TITLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_TITLE_COMMAND))
#define EDIT_TITLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_TITLE_COMMAND, EditTitleCommandClass))

typedef struct _EditTitleCommand EditTitleCommand;
typedef struct _EditTitleCommandClass EditTitleCommandClass;
typedef struct _EditTitleCommandPrivate EditTitleCommandPrivate;
enum  {
	EDIT_TITLE_COMMAND_0_PROPERTY,
	EDIT_TITLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* edit_title_command_properties[EDIT_TITLE_COMMAND_NUM_PROPERTIES];

#define TYPE_EDIT_COMMENT_COMMAND (edit_comment_command_get_type ())
#define EDIT_COMMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_COMMENT_COMMAND, EditCommentCommand))
#define EDIT_COMMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_COMMENT_COMMAND, EditCommentCommandClass))
#define IS_EDIT_COMMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_COMMENT_COMMAND))
#define IS_EDIT_COMMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_COMMENT_COMMAND))
#define EDIT_COMMENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_COMMENT_COMMAND, EditCommentCommandClass))

typedef struct _EditCommentCommand EditCommentCommand;
typedef struct _EditCommentCommandClass EditCommentCommandClass;
typedef struct _EditCommentCommandPrivate EditCommentCommandPrivate;
enum  {
	EDIT_COMMENT_COMMAND_0_PROPERTY,
	EDIT_COMMENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* edit_comment_command_properties[EDIT_COMMENT_COMMAND_NUM_PROPERTIES];

#define TYPE_EDIT_MULTIPLE_TITLES_COMMAND (edit_multiple_titles_command_get_type ())
#define EDIT_MULTIPLE_TITLES_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommand))
#define EDIT_MULTIPLE_TITLES_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommandClass))
#define IS_EDIT_MULTIPLE_TITLES_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_MULTIPLE_TITLES_COMMAND))
#define IS_EDIT_MULTIPLE_TITLES_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_MULTIPLE_TITLES_COMMAND))
#define EDIT_MULTIPLE_TITLES_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommandClass))

typedef struct _EditMultipleTitlesCommand EditMultipleTitlesCommand;
typedef struct _EditMultipleTitlesCommandClass EditMultipleTitlesCommandClass;
typedef struct _EditMultipleTitlesCommandPrivate EditMultipleTitlesCommandPrivate;
enum  {
	EDIT_MULTIPLE_TITLES_COMMAND_0_PROPERTY,
	EDIT_MULTIPLE_TITLES_COMMAND_NUM_PROPERTIES
};
static GParamSpec* edit_multiple_titles_command_properties[EDIT_MULTIPLE_TITLES_COMMAND_NUM_PROPERTIES];

#define TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND (edit_multiple_comments_command_get_type ())
#define EDIT_MULTIPLE_COMMENTS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommand))
#define EDIT_MULTIPLE_COMMENTS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommandClass))
#define IS_EDIT_MULTIPLE_COMMENTS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND))
#define IS_EDIT_MULTIPLE_COMMENTS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND))
#define EDIT_MULTIPLE_COMMENTS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommandClass))

typedef struct _EditMultipleCommentsCommand EditMultipleCommentsCommand;
typedef struct _EditMultipleCommentsCommandClass EditMultipleCommentsCommandClass;
typedef struct _EditMultipleCommentsCommandPrivate EditMultipleCommentsCommandPrivate;
enum  {
	EDIT_MULTIPLE_COMMENTS_COMMAND_0_PROPERTY,
	EDIT_MULTIPLE_COMMENTS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* edit_multiple_comments_command_properties[EDIT_MULTIPLE_COMMENTS_COMMAND_NUM_PROPERTIES];

#define TYPE_RENAME_EVENT_COMMAND (rename_event_command_get_type ())
#define RENAME_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RENAME_EVENT_COMMAND, RenameEventCommand))
#define RENAME_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RENAME_EVENT_COMMAND, RenameEventCommandClass))
#define IS_RENAME_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RENAME_EVENT_COMMAND))
#define IS_RENAME_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RENAME_EVENT_COMMAND))
#define RENAME_EVENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RENAME_EVENT_COMMAND, RenameEventCommandClass))

typedef struct _RenameEventCommand RenameEventCommand;
typedef struct _RenameEventCommandClass RenameEventCommandClass;
typedef struct _RenameEventCommandPrivate RenameEventCommandPrivate;
enum  {
	RENAME_EVENT_COMMAND_0_PROPERTY,
	RENAME_EVENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rename_event_command_properties[RENAME_EVENT_COMMAND_NUM_PROPERTIES];

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_EDIT_EVENT_COMMENT_COMMAND (edit_event_comment_command_get_type ())
#define EDIT_EVENT_COMMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommand))
#define EDIT_EVENT_COMMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommandClass))
#define IS_EDIT_EVENT_COMMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EDIT_EVENT_COMMENT_COMMAND))
#define IS_EDIT_EVENT_COMMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EDIT_EVENT_COMMENT_COMMAND))
#define EDIT_EVENT_COMMENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommandClass))

typedef struct _EditEventCommentCommand EditEventCommentCommand;
typedef struct _EditEventCommentCommandClass EditEventCommentCommandClass;
typedef struct _EditEventCommentCommandPrivate EditEventCommentCommandPrivate;
enum  {
	EDIT_EVENT_COMMENT_COMMAND_0_PROPERTY,
	EDIT_EVENT_COMMENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* edit_event_comment_command_properties[EDIT_EVENT_COMMENT_COMMAND_NUM_PROPERTIES];

#define TYPE_SET_KEY_PHOTO_COMMAND (set_key_photo_command_get_type ())
#define SET_KEY_PHOTO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommand))
#define SET_KEY_PHOTO_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommandClass))
#define IS_SET_KEY_PHOTO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_KEY_PHOTO_COMMAND))
#define IS_SET_KEY_PHOTO_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_KEY_PHOTO_COMMAND))
#define SET_KEY_PHOTO_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommandClass))

typedef struct _SetKeyPhotoCommand SetKeyPhotoCommand;
typedef struct _SetKeyPhotoCommandClass SetKeyPhotoCommandClass;
typedef struct _SetKeyPhotoCommandPrivate SetKeyPhotoCommandPrivate;
enum  {
	SET_KEY_PHOTO_COMMAND_0_PROPERTY,
	SET_KEY_PHOTO_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_key_photo_command_properties[SET_KEY_PHOTO_COMMAND_NUM_PROPERTIES];

#define TYPE_REVERT_SINGLE_COMMAND (revert_single_command_get_type ())
#define REVERT_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERT_SINGLE_COMMAND, RevertSingleCommand))
#define REVERT_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERT_SINGLE_COMMAND, RevertSingleCommandClass))
#define IS_REVERT_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERT_SINGLE_COMMAND))
#define IS_REVERT_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERT_SINGLE_COMMAND))
#define REVERT_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERT_SINGLE_COMMAND, RevertSingleCommandClass))

typedef struct _RevertSingleCommand RevertSingleCommand;
typedef struct _RevertSingleCommandClass RevertSingleCommandClass;
typedef struct _RevertSingleCommandPrivate RevertSingleCommandPrivate;
enum  {
	REVERT_SINGLE_COMMAND_0_PROPERTY,
	REVERT_SINGLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* revert_single_command_properties[REVERT_SINGLE_COMMAND_NUM_PROPERTIES];

#define TYPE_REVERT_MULTIPLE_COMMAND (revert_multiple_command_get_type ())
#define REVERT_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERT_MULTIPLE_COMMAND, RevertMultipleCommand))
#define REVERT_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERT_MULTIPLE_COMMAND, RevertMultipleCommandClass))
#define IS_REVERT_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERT_MULTIPLE_COMMAND))
#define IS_REVERT_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERT_MULTIPLE_COMMAND))
#define REVERT_MULTIPLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERT_MULTIPLE_COMMAND, RevertMultipleCommandClass))

typedef struct _RevertMultipleCommand RevertMultipleCommand;
typedef struct _RevertMultipleCommandClass RevertMultipleCommandClass;
typedef struct _RevertMultipleCommandPrivate RevertMultipleCommandPrivate;
enum  {
	REVERT_MULTIPLE_COMMAND_0_PROPERTY,
	REVERT_MULTIPLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* revert_multiple_command_properties[REVERT_MULTIPLE_COMMAND_NUM_PROPERTIES];

#define TYPE_ENHANCE_SINGLE_COMMAND (enhance_single_command_get_type ())
#define ENHANCE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommand))
#define ENHANCE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommandClass))
#define IS_ENHANCE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ENHANCE_SINGLE_COMMAND))
#define IS_ENHANCE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ENHANCE_SINGLE_COMMAND))
#define ENHANCE_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommandClass))

typedef struct _EnhanceSingleCommand EnhanceSingleCommand;
typedef struct _EnhanceSingleCommandClass EnhanceSingleCommandClass;
typedef struct _EnhanceSingleCommandPrivate EnhanceSingleCommandPrivate;
enum  {
	ENHANCE_SINGLE_COMMAND_0_PROPERTY,
	ENHANCE_SINGLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* enhance_single_command_properties[ENHANCE_SINGLE_COMMAND_NUM_PROPERTIES];

#define TYPE_ENHANCE_MULTIPLE_COMMAND (enhance_multiple_command_get_type ())
#define ENHANCE_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ENHANCE_MULTIPLE_COMMAND, EnhanceMultipleCommand))
#define ENHANCE_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ENHANCE_MULTIPLE_COMMAND, EnhanceMultipleCommandClass))
#define IS_ENHANCE_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ENHANCE_MULTIPLE_COMMAND))
#define IS_ENHANCE_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ENHANCE_MULTIPLE_COMMAND))
#define ENHANCE_MULTIPLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ENHANCE_MULTIPLE_COMMAND, EnhanceMultipleCommandClass))

typedef struct _EnhanceMultipleCommand EnhanceMultipleCommand;
typedef struct _EnhanceMultipleCommandClass EnhanceMultipleCommandClass;
typedef struct _EnhanceMultipleCommandPrivate EnhanceMultipleCommandPrivate;
enum  {
	ENHANCE_MULTIPLE_COMMAND_0_PROPERTY,
	ENHANCE_MULTIPLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* enhance_multiple_command_properties[ENHANCE_MULTIPLE_COMMAND_NUM_PROPERTIES];

#define TYPE_STRAIGHTEN_COMMAND (straighten_command_get_type ())
#define STRAIGHTEN_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STRAIGHTEN_COMMAND, StraightenCommand))
#define STRAIGHTEN_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STRAIGHTEN_COMMAND, StraightenCommandClass))
#define IS_STRAIGHTEN_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STRAIGHTEN_COMMAND))
#define IS_STRAIGHTEN_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STRAIGHTEN_COMMAND))
#define STRAIGHTEN_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STRAIGHTEN_COMMAND, StraightenCommandClass))

typedef struct _StraightenCommand StraightenCommand;
typedef struct _StraightenCommandClass StraightenCommandClass;
typedef struct _StraightenCommandPrivate StraightenCommandPrivate;

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
enum  {
	STRAIGHTEN_COMMAND_0_PROPERTY,
	STRAIGHTEN_COMMAND_NUM_PROPERTIES
};
static GParamSpec* straighten_command_properties[STRAIGHTEN_COMMAND_NUM_PROPERTIES];

#define TYPE_CROP_COMMAND (crop_command_get_type ())
#define CROP_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_COMMAND, CropCommand))
#define CROP_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_COMMAND, CropCommandClass))
#define IS_CROP_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_COMMAND))
#define IS_CROP_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_COMMAND))
#define CROP_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_COMMAND, CropCommandClass))

typedef struct _CropCommand CropCommand;
typedef struct _CropCommandClass CropCommandClass;
typedef struct _CropCommandPrivate CropCommandPrivate;
enum  {
	CROP_COMMAND_0_PROPERTY,
	CROP_COMMAND_NUM_PROPERTIES
};
static GParamSpec* crop_command_properties[CROP_COMMAND_NUM_PROPERTIES];

#define TYPE_ADJUST_COLORS_SINGLE_COMMAND (adjust_colors_single_command_get_type ())
#define ADJUST_COLORS_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommand))
#define ADJUST_COLORS_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommandClass))
#define IS_ADJUST_COLORS_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND))
#define IS_ADJUST_COLORS_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADJUST_COLORS_SINGLE_COMMAND))
#define ADJUST_COLORS_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommandClass))

typedef struct _AdjustColorsSingleCommand AdjustColorsSingleCommand;
typedef struct _AdjustColorsSingleCommandClass AdjustColorsSingleCommandClass;
typedef struct _AdjustColorsSingleCommandPrivate AdjustColorsSingleCommandPrivate;
enum  {
	ADJUST_COLORS_SINGLE_COMMAND_0_PROPERTY,
	ADJUST_COLORS_SINGLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* adjust_colors_single_command_properties[ADJUST_COLORS_SINGLE_COMMAND_NUM_PROPERTIES];
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))

#define TYPE_ADJUST_COLORS_MULTIPLE_COMMAND (adjust_colors_multiple_command_get_type ())
#define ADJUST_COLORS_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, AdjustColorsMultipleCommand))
#define ADJUST_COLORS_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, AdjustColorsMultipleCommandClass))
#define IS_ADJUST_COLORS_MULTIPLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADJUST_COLORS_MULTIPLE_COMMAND))
#define IS_ADJUST_COLORS_MULTIPLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADJUST_COLORS_MULTIPLE_COMMAND))
#define ADJUST_COLORS_MULTIPLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, AdjustColorsMultipleCommandClass))

typedef struct _AdjustColorsMultipleCommand AdjustColorsMultipleCommand;
typedef struct _AdjustColorsMultipleCommandClass AdjustColorsMultipleCommandClass;
typedef struct _AdjustColorsMultipleCommandPrivate AdjustColorsMultipleCommandPrivate;
enum  {
	ADJUST_COLORS_MULTIPLE_COMMAND_0_PROPERTY,
	ADJUST_COLORS_MULTIPLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* adjust_colors_multiple_command_properties[ADJUST_COLORS_MULTIPLE_COMMAND_NUM_PROPERTIES];

#define TYPE_REDEYE_COMMAND (redeye_command_get_type ())
#define REDEYE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REDEYE_COMMAND, RedeyeCommand))
#define REDEYE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REDEYE_COMMAND, RedeyeCommandClass))
#define IS_REDEYE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REDEYE_COMMAND))
#define IS_REDEYE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REDEYE_COMMAND))
#define REDEYE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REDEYE_COMMAND, RedeyeCommandClass))

typedef struct _RedeyeCommand RedeyeCommand;
typedef struct _RedeyeCommandClass RedeyeCommandClass;
typedef struct _RedeyeCommandPrivate RedeyeCommandPrivate;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;
enum  {
	REDEYE_COMMAND_0_PROPERTY,
	REDEYE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* redeye_command_properties[REDEYE_COMMAND_NUM_PROPERTIES];

#define TYPE_MOVE_PHOTOS_COMMAND (move_photos_command_get_type ())
#define MOVE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand))
#define MOVE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommandClass))
#define IS_MOVE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOVE_PHOTOS_COMMAND))
#define IS_MOVE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOVE_PHOTOS_COMMAND))
#define MOVE_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommandClass))

typedef struct _MovePhotosCommand MovePhotosCommand;
typedef struct _MovePhotosCommandClass MovePhotosCommandClass;
typedef struct _MovePhotosCommandPrivate MovePhotosCommandPrivate;

#define MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND (move_photos_command_real_move_photos_command_get_type ())
#define MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommand))
#define MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommandClass))
#define MOVE_PHOTOS_COMMAND_IS_REAL_MOVE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND))
#define MOVE_PHOTOS_COMMAND_IS_REAL_MOVE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND))
#define MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommandClass))

typedef struct _MovePhotosCommandRealMovePhotosCommand MovePhotosCommandRealMovePhotosCommand;
typedef struct _MovePhotosCommandRealMovePhotosCommandClass MovePhotosCommandRealMovePhotosCommandClass;
enum  {
	MOVE_PHOTOS_COMMAND_0_PROPERTY,
	MOVE_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* move_photos_command_properties[MOVE_PHOTOS_COMMAND_NUM_PROPERTIES];
typedef struct _MovePhotosCommandRealMovePhotosCommandPrivate MovePhotosCommandRealMovePhotosCommandPrivate;
enum  {
	MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND_0_PROPERTY,
	MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* move_photos_command_real_move_photos_command_properties[MOVE_PHOTOS_COMMAND_REAL_MOVE_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_EVENT_PAGE (event_page_get_type ())
#define EVENT_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_PAGE, EventPage))
#define EVENT_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_PAGE, EventPageClass))
#define IS_EVENT_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_PAGE))
#define IS_EVENT_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_PAGE))
#define EVENT_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_PAGE, EventPageClass))

typedef struct _EventPage EventPage;
typedef struct _EventPageClass EventPageClass;

#define TYPE_NEW_EVENT_COMMAND (new_event_command_get_type ())
#define NEW_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_EVENT_COMMAND, NewEventCommand))
#define NEW_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_EVENT_COMMAND, NewEventCommandClass))
#define IS_NEW_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_EVENT_COMMAND))
#define IS_NEW_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_EVENT_COMMAND))
#define NEW_EVENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_EVENT_COMMAND, NewEventCommandClass))

typedef struct _NewEventCommand NewEventCommand;
typedef struct _NewEventCommandClass NewEventCommandClass;
typedef struct _NewEventCommandPrivate NewEventCommandPrivate;
enum  {
	NEW_EVENT_COMMAND_0_PROPERTY,
	NEW_EVENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* new_event_command_properties[NEW_EVENT_COMMAND_NUM_PROPERTIES];

#define TYPE_SET_EVENT_COMMAND (set_event_command_get_type ())
#define SET_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_EVENT_COMMAND, SetEventCommand))
#define SET_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_EVENT_COMMAND, SetEventCommandClass))
#define IS_SET_EVENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_EVENT_COMMAND))
#define IS_SET_EVENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_EVENT_COMMAND))
#define SET_EVENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_EVENT_COMMAND, SetEventCommandClass))

typedef struct _SetEventCommand SetEventCommand;
typedef struct _SetEventCommandClass SetEventCommandClass;
typedef struct _SetEventCommandPrivate SetEventCommandPrivate;
enum  {
	SET_EVENT_COMMAND_0_PROPERTY,
	SET_EVENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_event_command_properties[SET_EVENT_COMMAND_NUM_PROPERTIES];

#define TYPE_MERGE_EVENTS_COMMAND (merge_events_command_get_type ())
#define MERGE_EVENTS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MERGE_EVENTS_COMMAND, MergeEventsCommand))
#define MERGE_EVENTS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MERGE_EVENTS_COMMAND, MergeEventsCommandClass))
#define IS_MERGE_EVENTS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MERGE_EVENTS_COMMAND))
#define IS_MERGE_EVENTS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MERGE_EVENTS_COMMAND))
#define MERGE_EVENTS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MERGE_EVENTS_COMMAND, MergeEventsCommandClass))

typedef struct _MergeEventsCommand MergeEventsCommand;
typedef struct _MergeEventsCommandClass MergeEventsCommandClass;
typedef struct _MergeEventsCommandPrivate MergeEventsCommandPrivate;
enum  {
	MERGE_EVENTS_COMMAND_0_PROPERTY,
	MERGE_EVENTS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* merge_events_command_properties[MERGE_EVENTS_COMMAND_NUM_PROPERTIES];

#define TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND (duplicate_multiple_photos_command_get_type ())
#define DUPLICATE_MULTIPLE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand))
#define DUPLICATE_MULTIPLE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommandClass))
#define IS_DUPLICATE_MULTIPLE_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND))
#define IS_DUPLICATE_MULTIPLE_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND))
#define DUPLICATE_MULTIPLE_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommandClass))

typedef struct _DuplicateMultiplePhotosCommand DuplicateMultiplePhotosCommand;
typedef struct _DuplicateMultiplePhotosCommandClass DuplicateMultiplePhotosCommandClass;
typedef struct _DuplicateMultiplePhotosCommandPrivate DuplicateMultiplePhotosCommandPrivate;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
enum  {
	DUPLICATE_MULTIPLE_PHOTOS_COMMAND_0_PROPERTY,
	DUPLICATE_MULTIPLE_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* duplicate_multiple_photos_command_properties[DUPLICATE_MULTIPLE_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_SET_RATING_SINGLE_COMMAND (set_rating_single_command_get_type ())
#define SET_RATING_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommand))
#define SET_RATING_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommandClass))
#define IS_SET_RATING_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_RATING_SINGLE_COMMAND))
#define IS_SET_RATING_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_RATING_SINGLE_COMMAND))
#define SET_RATING_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommandClass))

typedef struct _SetRatingSingleCommand SetRatingSingleCommand;
typedef struct _SetRatingSingleCommandClass SetRatingSingleCommandClass;
typedef struct _SetRatingSingleCommandPrivate SetRatingSingleCommandPrivate;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
enum  {
	SET_RATING_SINGLE_COMMAND_0_PROPERTY,
	SET_RATING_SINGLE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_rating_single_command_properties[SET_RATING_SINGLE_COMMAND_NUM_PROPERTIES];

#define TYPE_SET_RATING_COMMAND (set_rating_command_get_type ())
#define SET_RATING_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_RATING_COMMAND, SetRatingCommand))
#define SET_RATING_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_RATING_COMMAND, SetRatingCommandClass))
#define IS_SET_RATING_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_RATING_COMMAND))
#define IS_SET_RATING_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_RATING_COMMAND))
#define SET_RATING_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_RATING_COMMAND, SetRatingCommandClass))

typedef struct _SetRatingCommand SetRatingCommand;
typedef struct _SetRatingCommandClass SetRatingCommandClass;
typedef struct _SetRatingCommandPrivate SetRatingCommandPrivate;
enum  {
	SET_RATING_COMMAND_0_PROPERTY,
	SET_RATING_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_rating_command_properties[SET_RATING_COMMAND_NUM_PROPERTIES];

#define TYPE_SET_RAW_DEVELOPER_COMMAND (set_raw_developer_command_get_type ())
#define SET_RAW_DEVELOPER_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand))
#define SET_RAW_DEVELOPER_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommandClass))
#define IS_SET_RAW_DEVELOPER_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_RAW_DEVELOPER_COMMAND))
#define IS_SET_RAW_DEVELOPER_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_RAW_DEVELOPER_COMMAND))
#define SET_RAW_DEVELOPER_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommandClass))

typedef struct _SetRawDeveloperCommand SetRawDeveloperCommand;
typedef struct _SetRawDeveloperCommandClass SetRawDeveloperCommandClass;
typedef struct _SetRawDeveloperCommandPrivate SetRawDeveloperCommandPrivate;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	SET_RAW_DEVELOPER_COMMAND_0_PROPERTY,
	SET_RAW_DEVELOPER_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_raw_developer_command_properties[SET_RAW_DEVELOPER_COMMAND_NUM_PROPERTIES];
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND (adjust_date_time_photo_command_get_type ())
#define ADJUST_DATE_TIME_PHOTO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommand))
#define ADJUST_DATE_TIME_PHOTO_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommandClass))
#define IS_ADJUST_DATE_TIME_PHOTO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND))
#define IS_ADJUST_DATE_TIME_PHOTO_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND))
#define ADJUST_DATE_TIME_PHOTO_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommandClass))

typedef struct _AdjustDateTimePhotoCommand AdjustDateTimePhotoCommand;
typedef struct _AdjustDateTimePhotoCommandClass AdjustDateTimePhotoCommandClass;
typedef struct _AdjustDateTimePhotoCommandPrivate AdjustDateTimePhotoCommandPrivate;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;
enum  {
	ADJUST_DATE_TIME_PHOTO_COMMAND_0_PROPERTY,
	ADJUST_DATE_TIME_PHOTO_COMMAND_NUM_PROPERTIES
};
static GParamSpec* adjust_date_time_photo_command_properties[ADJUST_DATE_TIME_PHOTO_COMMAND_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_EVENT_SOURCE_COLLECTION (event_source_collection_get_type ())
#define EVENT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollection))
#define EVENT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollectionClass))
#define IS_EVENT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE_COLLECTION))
#define IS_EVENT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE_COLLECTION))
#define EVENT_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollectionClass))

typedef struct _EventSourceCollection EventSourceCollection;
typedef struct _EventSourceCollectionClass EventSourceCollectionClass;

#define TYPE_EVENT_VIEW (event_view_get_type ())
#define EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_VIEW, EventView))
#define EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_VIEW, EventViewClass))
#define IS_EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_VIEW))
#define IS_EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_VIEW))
#define EVENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_VIEW, EventViewClass))

typedef struct _EventView EventView;
typedef struct _EventViewClass EventViewClass;

#define TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND (adjust_date_time_photos_command_get_type ())
#define ADJUST_DATE_TIME_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand))
#define ADJUST_DATE_TIME_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommandClass))
#define IS_ADJUST_DATE_TIME_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND))
#define IS_ADJUST_DATE_TIME_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND))
#define ADJUST_DATE_TIME_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommandClass))

typedef struct _AdjustDateTimePhotosCommand AdjustDateTimePhotosCommand;
typedef struct _AdjustDateTimePhotosCommandClass AdjustDateTimePhotosCommandClass;
typedef struct _AdjustDateTimePhotosCommandPrivate AdjustDateTimePhotosCommandPrivate;
enum  {
	ADJUST_DATE_TIME_PHOTOS_COMMAND_0_PROPERTY,
	ADJUST_DATE_TIME_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* adjust_date_time_photos_command_properties[ADJUST_DATE_TIME_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_ADD_TAGS_COMMAND (add_tags_command_get_type ())
#define ADD_TAGS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_TAGS_COMMAND, AddTagsCommand))
#define ADD_TAGS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_TAGS_COMMAND, AddTagsCommandClass))
#define IS_ADD_TAGS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_TAGS_COMMAND))
#define IS_ADD_TAGS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_TAGS_COMMAND))
#define ADD_TAGS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_TAGS_COMMAND, AddTagsCommandClass))

typedef struct _AddTagsCommand AddTagsCommand;
typedef struct _AddTagsCommandClass AddTagsCommandClass;
typedef struct _AddTagsCommandPrivate AddTagsCommandPrivate;
enum  {
	ADD_TAGS_COMMAND_0_PROPERTY,
	ADD_TAGS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* add_tags_command_properties[ADD_TAGS_COMMAND_NUM_PROPERTIES];

#define TYPE_VIDEO_SOURCE_COLLECTION (video_source_collection_get_type ())
#define VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection))
#define VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))
#define IS_VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE_COLLECTION))
#define IS_VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE_COLLECTION))
#define VIDEO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))

typedef struct _VideoSourceCollection VideoSourceCollection;
typedef struct _VideoSourceCollectionClass VideoSourceCollectionClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_RENAME_TAG_COMMAND (rename_tag_command_get_type ())
#define RENAME_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RENAME_TAG_COMMAND, RenameTagCommand))
#define RENAME_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RENAME_TAG_COMMAND, RenameTagCommandClass))
#define IS_RENAME_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RENAME_TAG_COMMAND))
#define IS_RENAME_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RENAME_TAG_COMMAND))
#define RENAME_TAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RENAME_TAG_COMMAND, RenameTagCommandClass))

typedef struct _RenameTagCommand RenameTagCommand;
typedef struct _RenameTagCommandClass RenameTagCommandClass;
typedef struct _RenameTagCommandPrivate RenameTagCommandPrivate;
enum  {
	RENAME_TAG_COMMAND_0_PROPERTY,
	RENAME_TAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rename_tag_command_properties[RENAME_TAG_COMMAND_NUM_PROPERTIES];

#define TYPE_DELETE_TAG_COMMAND (delete_tag_command_get_type ())
#define DELETE_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_TAG_COMMAND, DeleteTagCommand))
#define DELETE_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_TAG_COMMAND, DeleteTagCommandClass))
#define IS_DELETE_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_TAG_COMMAND))
#define IS_DELETE_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_TAG_COMMAND))
#define DELETE_TAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_TAG_COMMAND, DeleteTagCommandClass))

typedef struct _DeleteTagCommand DeleteTagCommand;
typedef struct _DeleteTagCommandClass DeleteTagCommandClass;
typedef struct _DeleteTagCommandPrivate DeleteTagCommandPrivate;
enum  {
	DELETE_TAG_COMMAND_0_PROPERTY,
	DELETE_TAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* delete_tag_command_properties[DELETE_TAG_COMMAND_NUM_PROPERTIES];

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_NEW_CHILD_TAG_COMMAND (new_child_tag_command_get_type ())
#define NEW_CHILD_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommand))
#define NEW_CHILD_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommandClass))
#define IS_NEW_CHILD_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_CHILD_TAG_COMMAND))
#define IS_NEW_CHILD_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_CHILD_TAG_COMMAND))
#define NEW_CHILD_TAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommandClass))

typedef struct _NewChildTagCommand NewChildTagCommand;
typedef struct _NewChildTagCommandClass NewChildTagCommandClass;
typedef struct _NewChildTagCommandPrivate NewChildTagCommandPrivate;
enum  {
	NEW_CHILD_TAG_COMMAND_0_PROPERTY,
	NEW_CHILD_TAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* new_child_tag_command_properties[NEW_CHILD_TAG_COMMAND_NUM_PROPERTIES];

#define TYPE_NEW_ROOT_TAG_COMMAND (new_root_tag_command_get_type ())
#define NEW_ROOT_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommand))
#define NEW_ROOT_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommandClass))
#define IS_NEW_ROOT_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_ROOT_TAG_COMMAND))
#define IS_NEW_ROOT_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_ROOT_TAG_COMMAND))
#define NEW_ROOT_TAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommandClass))

typedef struct _NewRootTagCommand NewRootTagCommand;
typedef struct _NewRootTagCommandClass NewRootTagCommandClass;
typedef struct _NewRootTagCommandPrivate NewRootTagCommandPrivate;
enum  {
	NEW_ROOT_TAG_COMMAND_0_PROPERTY,
	NEW_ROOT_TAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* new_root_tag_command_properties[NEW_ROOT_TAG_COMMAND_NUM_PROPERTIES];

#define TYPE_REPARENT_TAG_COMMAND (reparent_tag_command_get_type ())
#define REPARENT_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REPARENT_TAG_COMMAND, ReparentTagCommand))
#define REPARENT_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REPARENT_TAG_COMMAND, ReparentTagCommandClass))
#define IS_REPARENT_TAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REPARENT_TAG_COMMAND))
#define IS_REPARENT_TAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REPARENT_TAG_COMMAND))
#define REPARENT_TAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REPARENT_TAG_COMMAND, ReparentTagCommandClass))

typedef struct _ReparentTagCommand ReparentTagCommand;
typedef struct _ReparentTagCommandClass ReparentTagCommandClass;
typedef struct _ReparentTagCommandPrivate ReparentTagCommandPrivate;
enum  {
	REPARENT_TAG_COMMAND_0_PROPERTY,
	REPARENT_TAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* reparent_tag_command_properties[REPARENT_TAG_COMMAND_NUM_PROPERTIES];
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define TYPE_MODIFY_TAGS_COMMAND (modify_tags_command_get_type ())
#define MODIFY_TAGS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommand))
#define MODIFY_TAGS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommandClass))
#define IS_MODIFY_TAGS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MODIFY_TAGS_COMMAND))
#define IS_MODIFY_TAGS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MODIFY_TAGS_COMMAND))
#define MODIFY_TAGS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommandClass))

typedef struct _ModifyTagsCommand ModifyTagsCommand;
typedef struct _ModifyTagsCommandClass ModifyTagsCommandClass;
typedef struct _ModifyTagsCommandPrivate ModifyTagsCommandPrivate;
enum  {
	MODIFY_TAGS_COMMAND_0_PROPERTY,
	MODIFY_TAGS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* modify_tags_command_properties[MODIFY_TAGS_COMMAND_NUM_PROPERTIES];

#define TYPE_TAG_UNTAG_PHOTOS_COMMAND (tag_untag_photos_command_get_type ())
#define TAG_UNTAG_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommand))
#define TAG_UNTAG_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommandClass))
#define IS_TAG_UNTAG_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_UNTAG_PHOTOS_COMMAND))
#define IS_TAG_UNTAG_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_UNTAG_PHOTOS_COMMAND))
#define TAG_UNTAG_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommandClass))

typedef struct _TagUntagPhotosCommand TagUntagPhotosCommand;
typedef struct _TagUntagPhotosCommandClass TagUntagPhotosCommandClass;
typedef struct _TagUntagPhotosCommandPrivate TagUntagPhotosCommandPrivate;
enum  {
	TAG_UNTAG_PHOTOS_COMMAND_0_PROPERTY,
	TAG_UNTAG_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* tag_untag_photos_command_properties[TAG_UNTAG_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_RENAME_SAVED_SEARCH_COMMAND (rename_saved_search_command_get_type ())
#define RENAME_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommand))
#define RENAME_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommandClass))
#define IS_RENAME_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RENAME_SAVED_SEARCH_COMMAND))
#define IS_RENAME_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RENAME_SAVED_SEARCH_COMMAND))
#define RENAME_SAVED_SEARCH_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommandClass))

typedef struct _RenameSavedSearchCommand RenameSavedSearchCommand;
typedef struct _RenameSavedSearchCommandClass RenameSavedSearchCommandClass;
typedef struct _RenameSavedSearchCommandPrivate RenameSavedSearchCommandPrivate;

#define TYPE_SAVED_SEARCH (saved_search_get_type ())
#define SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH, SavedSearch))
#define SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH, SavedSearchClass))
#define IS_SAVED_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH))
#define IS_SAVED_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH))
#define SAVED_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH, SavedSearchClass))

typedef struct _SavedSearch SavedSearch;
typedef struct _SavedSearchClass SavedSearchClass;
enum  {
	RENAME_SAVED_SEARCH_COMMAND_0_PROPERTY,
	RENAME_SAVED_SEARCH_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rename_saved_search_command_properties[RENAME_SAVED_SEARCH_COMMAND_NUM_PROPERTIES];

#define TYPE_DELETE_SAVED_SEARCH_COMMAND (delete_saved_search_command_get_type ())
#define DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand))
#define DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))
#define IS_DELETE_SAVED_SEARCH_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define IS_DELETE_SAVED_SEARCH_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_SAVED_SEARCH_COMMAND))
#define DELETE_SAVED_SEARCH_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommandClass))

typedef struct _DeleteSavedSearchCommand DeleteSavedSearchCommand;
typedef struct _DeleteSavedSearchCommandClass DeleteSavedSearchCommandClass;
typedef struct _DeleteSavedSearchCommandPrivate DeleteSavedSearchCommandPrivate;
enum  {
	DELETE_SAVED_SEARCH_COMMAND_0_PROPERTY,
	DELETE_SAVED_SEARCH_COMMAND_NUM_PROPERTIES
};
static GParamSpec* delete_saved_search_command_properties[DELETE_SAVED_SEARCH_COMMAND_NUM_PROPERTIES];

#define TYPE_SAVED_SEARCH_TABLE (saved_search_table_get_type ())
#define SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTable))
#define SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))
#define IS_SAVED_SEARCH_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SAVED_SEARCH_TABLE))
#define IS_SAVED_SEARCH_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SAVED_SEARCH_TABLE))
#define SAVED_SEARCH_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SAVED_SEARCH_TABLE, SavedSearchTableClass))

typedef struct _SavedSearchTable SavedSearchTable;
typedef struct _SavedSearchTableClass SavedSearchTableClass;
#define _saved_search_table_unref0(var) ((var == NULL) ? NULL : (var = (saved_search_table_unref (var), NULL)))

#define TYPE_TRASH_UNTRASH_PHOTOS_COMMAND (trash_untrash_photos_command_get_type ())
#define TRASH_UNTRASH_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommand))
#define TRASH_UNTRASH_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommandClass))
#define IS_TRASH_UNTRASH_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRASH_UNTRASH_PHOTOS_COMMAND))
#define IS_TRASH_UNTRASH_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRASH_UNTRASH_PHOTOS_COMMAND))
#define TRASH_UNTRASH_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommandClass))

typedef struct _TrashUntrashPhotosCommand TrashUntrashPhotosCommand;
typedef struct _TrashUntrashPhotosCommandClass TrashUntrashPhotosCommandClass;
typedef struct _TrashUntrashPhotosCommandPrivate TrashUntrashPhotosCommandPrivate;
enum  {
	TRASH_UNTRASH_PHOTOS_COMMAND_0_PROPERTY,
	TRASH_UNTRASH_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* trash_untrash_photos_command_properties[TRASH_UNTRASH_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_FLAG_UNFLAG_COMMAND (flag_unflag_command_get_type ())
#define FLAG_UNFLAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommand))
#define FLAG_UNFLAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommandClass))
#define IS_FLAG_UNFLAG_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAG_UNFLAG_COMMAND))
#define IS_FLAG_UNFLAG_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FLAG_UNFLAG_COMMAND))
#define FLAG_UNFLAG_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommandClass))

typedef struct _FlagUnflagCommand FlagUnflagCommand;
typedef struct _FlagUnflagCommandClass FlagUnflagCommandClass;
typedef struct _FlagUnflagCommandPrivate FlagUnflagCommandPrivate;
enum  {
	FLAG_UNFLAG_COMMAND_0_PROPERTY,
	FLAG_UNFLAG_COMMAND_NUM_PROPERTIES
};
static GParamSpec* flag_unflag_command_properties[FLAG_UNFLAG_COMMAND_NUM_PROPERTIES];

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND (remove_faces_from_photos_command_get_type ())
#define REMOVE_FACES_FROM_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommand))
#define REMOVE_FACES_FROM_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommandClass))
#define IS_REMOVE_FACES_FROM_PHOTOS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND))
#define IS_REMOVE_FACES_FROM_PHOTOS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND))
#define REMOVE_FACES_FROM_PHOTOS_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommandClass))

typedef struct _RemoveFacesFromPhotosCommand RemoveFacesFromPhotosCommand;
typedef struct _RemoveFacesFromPhotosCommandClass RemoveFacesFromPhotosCommandClass;
typedef struct _RemoveFacesFromPhotosCommandPrivate RemoveFacesFromPhotosCommandPrivate;
enum  {
	REMOVE_FACES_FROM_PHOTOS_COMMAND_0_PROPERTY,
	REMOVE_FACES_FROM_PHOTOS_COMMAND_NUM_PROPERTIES
};
static GParamSpec* remove_faces_from_photos_command_properties[REMOVE_FACES_FROM_PHOTOS_COMMAND_NUM_PROPERTIES];

#define TYPE_FACE (face_get_type ())
#define FACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE, Face))
#define FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE, FaceClass))
#define IS_FACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE))
#define IS_FACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE))
#define FACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE, FaceClass))

typedef struct _Face Face;
typedef struct _FaceClass FaceClass;

#define TYPE_FACE_LOCATION (face_location_get_type ())
#define FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_LOCATION, FaceLocation))
#define FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_LOCATION, FaceLocationClass))
#define IS_FACE_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_LOCATION))
#define IS_FACE_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_LOCATION))
#define FACE_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_LOCATION, FaceLocationClass))

typedef struct _FaceLocation FaceLocation;
typedef struct _FaceLocationClass FaceLocationClass;

#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_FACE_LOCATION_DATA (face_location_data_get_type ())
typedef struct _FaceLocationData FaceLocationData;

#define TYPE_RENAME_FACE_COMMAND (rename_face_command_get_type ())
#define RENAME_FACE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RENAME_FACE_COMMAND, RenameFaceCommand))
#define RENAME_FACE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RENAME_FACE_COMMAND, RenameFaceCommandClass))
#define IS_RENAME_FACE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RENAME_FACE_COMMAND))
#define IS_RENAME_FACE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RENAME_FACE_COMMAND))
#define RENAME_FACE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RENAME_FACE_COMMAND, RenameFaceCommandClass))

typedef struct _RenameFaceCommand RenameFaceCommand;
typedef struct _RenameFaceCommandClass RenameFaceCommandClass;
typedef struct _RenameFaceCommandPrivate RenameFaceCommandPrivate;
enum  {
	RENAME_FACE_COMMAND_0_PROPERTY,
	RENAME_FACE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* rename_face_command_properties[RENAME_FACE_COMMAND_NUM_PROPERTIES];

#define TYPE_SET_FACE_REF_COMMAND (set_face_ref_command_get_type ())
#define SET_FACE_REF_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommand))
#define SET_FACE_REF_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommandClass))
#define IS_SET_FACE_REF_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SET_FACE_REF_COMMAND))
#define IS_SET_FACE_REF_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SET_FACE_REF_COMMAND))
#define SET_FACE_REF_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommandClass))

typedef struct _SetFaceRefCommand SetFaceRefCommand;
typedef struct _SetFaceRefCommandClass SetFaceRefCommandClass;
typedef struct _SetFaceRefCommandPrivate SetFaceRefCommandPrivate;
enum  {
	SET_FACE_REF_COMMAND_0_PROPERTY,
	SET_FACE_REF_COMMAND_NUM_PROPERTIES
};
static GParamSpec* set_face_ref_command_properties[SET_FACE_REF_COMMAND_NUM_PROPERTIES];

#define TYPE_DELETE_FACE_COMMAND (delete_face_command_get_type ())
#define DELETE_FACE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_FACE_COMMAND, DeleteFaceCommand))
#define DELETE_FACE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_FACE_COMMAND, DeleteFaceCommandClass))
#define IS_DELETE_FACE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_FACE_COMMAND))
#define IS_DELETE_FACE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_FACE_COMMAND))
#define DELETE_FACE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_FACE_COMMAND, DeleteFaceCommandClass))

typedef struct _DeleteFaceCommand DeleteFaceCommand;
typedef struct _DeleteFaceCommandClass DeleteFaceCommandClass;
typedef struct _DeleteFaceCommandPrivate DeleteFaceCommandPrivate;
enum  {
	DELETE_FACE_COMMAND_0_PROPERTY,
	DELETE_FACE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* delete_face_command_properties[DELETE_FACE_COMMAND_NUM_PROPERTIES];
#define _photo_id_free0(var) ((var == NULL) ? NULL : (var = (photo_id_free (var), NULL)))

#define TYPE_FACE_SOURCE_COLLECTION (face_source_collection_get_type ())
#define FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollection))
#define FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))
#define IS_FACE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_SOURCE_COLLECTION))
#define IS_FACE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_SOURCE_COLLECTION))
#define FACE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_SOURCE_COLLECTION, FaceSourceCollectionClass))

typedef struct _FaceSourceCollection FaceSourceCollection;
typedef struct _FaceSourceCollectionClass FaceSourceCollectionClass;

#define TYPE_MODIFY_FACES_COMMAND (modify_faces_command_get_type ())
#define MODIFY_FACES_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommand))
#define MODIFY_FACES_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommandClass))
#define IS_MODIFY_FACES_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MODIFY_FACES_COMMAND))
#define IS_MODIFY_FACES_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MODIFY_FACES_COMMAND))
#define MODIFY_FACES_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommandClass))

typedef struct _ModifyFacesCommand ModifyFacesCommand;
typedef struct _ModifyFacesCommandClass ModifyFacesCommandClass;
typedef struct _ModifyFacesCommandPrivate ModifyFacesCommandPrivate;
enum  {
	MODIFY_FACES_COMMAND_0_PROPERTY,
	MODIFY_FACES_COMMAND_NUM_PROPERTIES
};
static GParamSpec* modify_faces_command_properties[MODIFY_FACES_COMMAND_NUM_PROPERTIES];
#define _face_location_data_free0(var) ((var == NULL) ? NULL : (var = (face_location_data_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _CommandDescriptionIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (CommandDescription* self);
	gchar* (*get_explanation) (CommandDescription* self);
};

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
	void (*prepare) (Command* self);
	void (*execute) (Command* self);
	void (*undo) (Command* self);
	void (*redo) (Command* self);
	gboolean (*compress) (Command* self, Command* command);
	gchar* (*get_name) (Command* self);
	gchar* (*get_explanation) (Command* self);
};

struct _PageCommand {
	Command parent_instance;
	PageCommandPrivate * priv;
};

struct _PageCommandClass {
	CommandClass parent_class;
};

struct _PageCommandPrivate {
	Page* page;
	gboolean auto_return;
	Photo* library_photo;
	CollectionPage* collection_page;
};

struct _SingleDataSourceCommand {
	PageCommand parent_instance;
	SingleDataSourceCommandPrivate * priv;
	DataSource* source;
};

struct _SingleDataSourceCommandClass {
	PageCommandClass parent_class;
};

struct _SimpleProxyableCommand {
	PageCommand parent_instance;
	SimpleProxyableCommandPrivate * priv;
};

struct _SimpleProxyableCommandClass {
	PageCommandClass parent_class;
	void (*execute_on_source) (SimpleProxyableCommand* self, DataSource* source);
	void (*undo_on_source) (SimpleProxyableCommand* self, DataSource* source);
};

struct _SimpleProxyableCommandPrivate {
	SourceProxy* proxy;
	GeeHashSet* proxies;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};

struct _SinglePhotoTransformationCommand {
	SingleDataSourceCommand parent_instance;
	SinglePhotoTransformationCommandPrivate * priv;
};

struct _SinglePhotoTransformationCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _SinglePhotoTransformationCommandPrivate {
	PhotoTransformationState* state;
};

struct _GenericPhotoTransformationCommand {
	SingleDataSourceCommand parent_instance;
	GenericPhotoTransformationCommandPrivate * priv;
};

struct _GenericPhotoTransformationCommandClass {
	SingleDataSourceCommandClass parent_class;
	void (*execute_on_photo) (GenericPhotoTransformationCommand* self, Photo* photo);
	gboolean (*can_compress) (GenericPhotoTransformationCommand* self, Command* command);
};

struct _GenericPhotoTransformationCommandPrivate {
	PhotoTransformationState* original_state;
	PhotoTransformationState* transformed_state;
};

struct _MultipleDataSourceCommand {
	PageCommand parent_instance;
	MultipleDataSourceCommandPrivate * priv;
	GeeArrayList* source_list;
};

struct _MultipleDataSourceCommandClass {
	PageCommandClass parent_class;
	void (*execute_on_source) (MultipleDataSourceCommand* self, DataSource* source);
	void (*undo_on_source) (MultipleDataSourceCommand* self, DataSource* source);
};

struct _MultipleDataSourceCommandPrivate {
	gchar* progress_text;
	gchar* undo_progress_text;
	GeeArrayList* acted_upon;
	GeeHashSet* hooked_collections;
};

struct _MultipleDataSourceAtOnceCommand {
	PageCommand parent_instance;
	MultipleDataSourceAtOnceCommandPrivate * priv;
};

struct _MultipleDataSourceAtOnceCommandClass {
	PageCommandClass parent_class;
	void (*execute_on_all) (MultipleDataSourceAtOnceCommand* self, GeeCollection* sources);
	void (*undo_on_all) (MultipleDataSourceAtOnceCommand* self, GeeCollection* sources);
};

struct _MultipleDataSourceAtOnceCommandPrivate {
	GeeHashSet* sources;
	GeeHashSet* hooked_collections;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

struct _MultiplePhotoTransformationCommand {
	MultipleDataSourceCommand parent_instance;
	MultiplePhotoTransformationCommandPrivate * priv;
};

struct _MultiplePhotoTransformationCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _MultiplePhotoTransformationCommandPrivate {
	GeeHashMap* map;
};

struct _RotateSingleCommand {
	SingleDataSourceCommand parent_instance;
	RotateSingleCommandPrivate * priv;
};

struct _RotateSingleCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _RotateSingleCommandPrivate {
	Rotation rotation;
};

struct _RotateMultipleCommand {
	MultipleDataSourceCommand parent_instance;
	RotateMultipleCommandPrivate * priv;
};

struct _RotateMultipleCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _RotateMultipleCommandPrivate {
	Rotation rotation;
};

struct _EditTitleCommand {
	SingleDataSourceCommand parent_instance;
	EditTitleCommandPrivate * priv;
};

struct _EditTitleCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _EditTitleCommandPrivate {
	gchar* new_title;
	gchar* old_title;
};

struct _EditCommentCommand {
	SingleDataSourceCommand parent_instance;
	EditCommentCommandPrivate * priv;
};

struct _EditCommentCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _EditCommentCommandPrivate {
	gchar* new_comment;
	gchar* old_comment;
};

struct _EditMultipleTitlesCommand {
	MultipleDataSourceAtOnceCommand parent_instance;
	EditMultipleTitlesCommandPrivate * priv;
	gchar* new_title;
	GeeHashMap* old_titles;
};

struct _EditMultipleTitlesCommandClass {
	MultipleDataSourceAtOnceCommandClass parent_class;
};

struct _EditMultipleCommentsCommand {
	MultipleDataSourceAtOnceCommand parent_instance;
	EditMultipleCommentsCommandPrivate * priv;
	gchar* new_comment;
	GeeHashMap* old_comments;
};

struct _EditMultipleCommentsCommandClass {
	MultipleDataSourceAtOnceCommandClass parent_class;
};

struct _RenameEventCommand {
	SimpleProxyableCommand parent_instance;
	RenameEventCommandPrivate * priv;
};

struct _RenameEventCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _RenameEventCommandPrivate {
	gchar* new_name;
	gchar* old_name;
};

struct _EditEventCommentCommand {
	SimpleProxyableCommand parent_instance;
	EditEventCommentCommandPrivate * priv;
};

struct _EditEventCommentCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _EditEventCommentCommandPrivate {
	gchar* new_comment;
	gchar* old_comment;
};

struct _SetKeyPhotoCommand {
	SingleDataSourceCommand parent_instance;
	SetKeyPhotoCommandPrivate * priv;
};

struct _SetKeyPhotoCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _SetKeyPhotoCommandPrivate {
	MediaSource* new_primary_source;
	MediaSource* old_primary_source;
};

struct _RevertSingleCommand {
	GenericPhotoTransformationCommand parent_instance;
	RevertSingleCommandPrivate * priv;
};

struct _RevertSingleCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _RevertMultipleCommand {
	MultiplePhotoTransformationCommand parent_instance;
	RevertMultipleCommandPrivate * priv;
};

struct _RevertMultipleCommandClass {
	MultiplePhotoTransformationCommandClass parent_class;
};

struct _EnhanceSingleCommand {
	GenericPhotoTransformationCommand parent_instance;
	EnhanceSingleCommandPrivate * priv;
};

struct _EnhanceSingleCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _EnhanceMultipleCommand {
	MultiplePhotoTransformationCommand parent_instance;
	EnhanceMultipleCommandPrivate * priv;
};

struct _EnhanceMultipleCommandClass {
	MultiplePhotoTransformationCommandClass parent_class;
};

struct _StraightenCommand {
	GenericPhotoTransformationCommand parent_instance;
	StraightenCommandPrivate * priv;
};

struct _StraightenCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _StraightenCommandPrivate {
	gdouble theta;
	Box crop;
};

struct _CropCommand {
	GenericPhotoTransformationCommand parent_instance;
	CropCommandPrivate * priv;
};

struct _CropCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _CropCommandPrivate {
	Box crop;
};

struct _AdjustColorsSingleCommand {
	GenericPhotoTransformationCommand parent_instance;
	AdjustColorsSingleCommandPrivate * priv;
};

struct _AdjustColorsSingleCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _AdjustColorsSingleCommandPrivate {
	PixelTransformationBundle* transformations;
};

struct _AdjustColorsMultipleCommand {
	MultiplePhotoTransformationCommand parent_instance;
	AdjustColorsMultipleCommandPrivate * priv;
};

struct _AdjustColorsMultipleCommandClass {
	MultiplePhotoTransformationCommandClass parent_class;
};

struct _AdjustColorsMultipleCommandPrivate {
	PixelTransformationBundle* transformations;
};

struct _RedeyeCommand {
	GenericPhotoTransformationCommand parent_instance;
	RedeyeCommandPrivate * priv;
};

struct _RedeyeCommandClass {
	GenericPhotoTransformationCommandClass parent_class;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _RedeyeCommandPrivate {
	EditingToolsRedeyeInstance redeye_instance;
};

struct _MovePhotosCommand {
	Command parent_instance;
	MovePhotosCommandPrivate * priv;
	MovePhotosCommandRealMovePhotosCommand* real_command;
};

struct _MovePhotosCommandClass {
	CommandClass parent_class;
};

struct _MovePhotosCommandRealMovePhotosCommand {
	MultipleDataSourceCommand parent_instance;
	MovePhotosCommandRealMovePhotosCommandPrivate * priv;
};

struct _MovePhotosCommandRealMovePhotosCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _MovePhotosCommandRealMovePhotosCommandPrivate {
	SourceProxy* new_event_proxy;
	GeeHashMap* old_events;
};

struct _NewEventCommand {
	MovePhotosCommand parent_instance;
	NewEventCommandPrivate * priv;
};

struct _NewEventCommandClass {
	MovePhotosCommandClass parent_class;
};

struct _SetEventCommand {
	MovePhotosCommand parent_instance;
	SetEventCommandPrivate * priv;
};

struct _SetEventCommandClass {
	MovePhotosCommandClass parent_class;
};

struct _MergeEventsCommand {
	MovePhotosCommand parent_instance;
	MergeEventsCommandPrivate * priv;
};

struct _MergeEventsCommandClass {
	MovePhotosCommandClass parent_class;
};

struct _DuplicateMultiplePhotosCommand {
	MultipleDataSourceCommand parent_instance;
	DuplicateMultiplePhotosCommandPrivate * priv;
};

struct _DuplicateMultiplePhotosCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _DuplicateMultiplePhotosCommandPrivate {
	GeeHashMap* dupes;
	gint failed;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _SetRatingSingleCommand {
	SingleDataSourceCommand parent_instance;
	SetRatingSingleCommandPrivate * priv;
};

struct _SetRatingSingleCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _SetRatingSingleCommandPrivate {
	Rating last_rating;
	Rating new_rating;
	gboolean set_direct;
	gboolean incrementing;
};

struct _SetRatingCommand {
	MultipleDataSourceCommand parent_instance;
	SetRatingCommandPrivate * priv;
};

struct _SetRatingCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _SetRatingCommandPrivate {
	GeeHashMap* last_rating_map;
	Rating new_rating;
	gboolean set_direct;
	gboolean incrementing;
	gint action_count;
};

struct _SetRawDeveloperCommand {
	MultipleDataSourceCommand parent_instance;
	SetRawDeveloperCommandPrivate * priv;
};

struct _SetRawDeveloperCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _SetRawDeveloperCommandPrivate {
	GeeHashMap* last_developer_map;
	GeeHashMap* last_transformation_map;
	RawDeveloper new_developer;
};

struct _AdjustDateTimePhotoCommand {
	SingleDataSourceCommand parent_instance;
	AdjustDateTimePhotoCommandPrivate * priv;
};

struct _AdjustDateTimePhotoCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, GDateTime* target_time);
	GDateTime* (*get_exposure_time) (Dateable* self);
};

struct _AdjustDateTimePhotoCommandPrivate {
	Dateable* dateable;
	Event* prev_event;
	gint64 time_shift;
	gboolean modify_original;
};

struct _AdjustDateTimePhotosCommand {
	MultipleDataSourceCommand parent_instance;
	AdjustDateTimePhotosCommandPrivate * priv;
};

struct _AdjustDateTimePhotosCommandClass {
	MultipleDataSourceCommandClass parent_class;
};

struct _AdjustDateTimePhotosCommandPrivate {
	gint64 time_shift;
	gboolean keep_relativity;
	gboolean modify_originals;
	GeeMap* prev_events;
	GDateTime* new_time;
	GeeHashMap* old_times;
	GeeArrayList* error_list;
};

struct _AddTagsCommand {
	PageCommand parent_instance;
	AddTagsCommandPrivate * priv;
};

struct _AddTagsCommandClass {
	PageCommandClass parent_class;
};

struct _AddTagsCommandPrivate {
	GeeHashMap* map;
};

struct _RenameTagCommand {
	SimpleProxyableCommand parent_instance;
	RenameTagCommandPrivate * priv;
};

struct _RenameTagCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _RenameTagCommandPrivate {
	gchar* old_name;
	gchar* new_name;
};

struct _DeleteTagCommand {
	SimpleProxyableCommand parent_instance;
	DeleteTagCommandPrivate * priv;
};

struct _DeleteTagCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _DeleteTagCommandPrivate {
	GeeList* recursive_victim_proxies;
};

struct _NewChildTagCommand {
	SimpleProxyableCommand parent_instance;
	NewChildTagCommandPrivate * priv;
};

struct _NewChildTagCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _NewChildTagCommandPrivate {
	Tag* created_child;
};

struct _NewRootTagCommand {
	PageCommand parent_instance;
	NewRootTagCommandPrivate * priv;
};

struct _NewRootTagCommandClass {
	PageCommandClass parent_class;
};

struct _NewRootTagCommandPrivate {
	SourceProxy* created_proxy;
};

struct _ReparentTagCommand {
	PageCommand parent_instance;
	ReparentTagCommandPrivate * priv;
};

struct _ReparentTagCommandClass {
	PageCommandClass parent_class;
};

struct _ReparentTagCommandPrivate {
	gchar* from_path;
	gchar* to_path;
	gchar* to_path_parent_path;
	GeeList* src_before_state;
	GeeList* dest_before_state;
	GeeList* after_state;
	GeeHashSet* sources_in_play;
	GeeMap* dest_parent_attachments;
	GeeMap* src_parent_detachments;
	GeeMap* in_play_child_structure;
	GeeMap* existing_dest_child_structure;
	GeeSet* existing_dest_membership;
	gboolean to_path_exists;
};

struct _ModifyTagsCommand {
	SingleDataSourceCommand parent_instance;
	ModifyTagsCommandPrivate * priv;
};

struct _ModifyTagsCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _ModifyTagsCommandPrivate {
	MediaSource* media;
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
};

struct _TagUntagPhotosCommand {
	SimpleProxyableCommand parent_instance;
	TagUntagPhotosCommandPrivate * priv;
};

struct _TagUntagPhotosCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _TagUntagPhotosCommandPrivate {
	GeeCollection* sources;
	gboolean attach;
	GeeMultiMap* detached_from;
	GeeList* attached_to;
};

struct _RenameSavedSearchCommand {
	SingleDataSourceCommand parent_instance;
	RenameSavedSearchCommandPrivate * priv;
};

struct _RenameSavedSearchCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _RenameSavedSearchCommandPrivate {
	SavedSearch* search;
	gchar* old_name;
	gchar* new_name;
};

struct _DeleteSavedSearchCommand {
	SingleDataSourceCommand parent_instance;
	DeleteSavedSearchCommandPrivate * priv;
};

struct _DeleteSavedSearchCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _DeleteSavedSearchCommandPrivate {
	SavedSearch* search;
};

struct _TrashUntrashPhotosCommand {
	PageCommand parent_instance;
	TrashUntrashPhotosCommandPrivate * priv;
};

struct _TrashUntrashPhotosCommandClass {
	PageCommandClass parent_class;
};

struct _TrashUntrashPhotosCommandPrivate {
	GeeCollection* sources;
	gboolean to_trash;
};

struct _FlagUnflagCommand {
	MultipleDataSourceAtOnceCommand parent_instance;
	FlagUnflagCommandPrivate * priv;
};

struct _FlagUnflagCommandClass {
	MultipleDataSourceAtOnceCommandClass parent_class;
};

struct _FlagUnflagCommandPrivate {
	gboolean flag;
	ProgressDialog* progress_dialog;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _RemoveFacesFromPhotosCommand {
	SimpleProxyableCommand parent_instance;
	RemoveFacesFromPhotosCommandPrivate * priv;
};

struct _RemoveFacesFromPhotosCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _RemoveFacesFromPhotosCommandPrivate {
	GeeMap* map_source_geometry;
};

struct _FaceID {
	gint64 id;
};

struct _PhotoID {
	gint64 id;
};

struct _FaceLocationData {
	gchar* geometry;
	gchar* vec;
};

struct _RenameFaceCommand {
	SimpleProxyableCommand parent_instance;
	RenameFaceCommandPrivate * priv;
};

struct _RenameFaceCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _RenameFaceCommandPrivate {
	gchar* old_name;
	gchar* new_name;
};

struct _SetFaceRefCommand {
	SimpleProxyableCommand parent_instance;
	SetFaceRefCommandPrivate * priv;
};

struct _SetFaceRefCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _SetFaceRefCommandPrivate {
	FaceLocation* face_loc;
};

struct _DeleteFaceCommand {
	SimpleProxyableCommand parent_instance;
	DeleteFaceCommandPrivate * priv;
};

struct _DeleteFaceCommandClass {
	SimpleProxyableCommandClass parent_class;
};

struct _DeleteFaceCommandPrivate {
	GeeMap* photo_geometry_map;
};

struct _ModifyFacesCommand {
	SingleDataSourceCommand parent_instance;
	ModifyFacesCommandPrivate * priv;
};

struct _ModifyFacesCommandClass {
	SingleDataSourceCommandClass parent_class;
};

struct _ModifyFacesCommandPrivate {
	MediaSource* media;
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	GeeMap* to_update;
	GeeMap* geometries;
};

static gint PageCommand_private_offset;
static gpointer page_command_parent_class = NULL;
static gpointer single_data_source_command_parent_class = NULL;
static gint SimpleProxyableCommand_private_offset;
static gpointer simple_proxyable_command_parent_class = NULL;
static gint SinglePhotoTransformationCommand_private_offset;
static gpointer single_photo_transformation_command_parent_class = NULL;
static gint GenericPhotoTransformationCommand_private_offset;
static gpointer generic_photo_transformation_command_parent_class = NULL;
static gint MultipleDataSourceCommand_private_offset;
static gpointer multiple_data_source_command_parent_class = NULL;
static gint MultipleDataSourceAtOnceCommand_private_offset;
static gpointer multiple_data_source_at_once_command_parent_class = NULL;
static gint MultiplePhotoTransformationCommand_private_offset;
static gpointer multiple_photo_transformation_command_parent_class = NULL;
static gint RotateSingleCommand_private_offset;
static gpointer rotate_single_command_parent_class = NULL;
static gint RotateMultipleCommand_private_offset;
static gpointer rotate_multiple_command_parent_class = NULL;
static gint EditTitleCommand_private_offset;
static gpointer edit_title_command_parent_class = NULL;
static gint EditCommentCommand_private_offset;
static gpointer edit_comment_command_parent_class = NULL;
static gpointer edit_multiple_titles_command_parent_class = NULL;
static gpointer edit_multiple_comments_command_parent_class = NULL;
static gint RenameEventCommand_private_offset;
static gpointer rename_event_command_parent_class = NULL;
static gint EditEventCommentCommand_private_offset;
static gpointer edit_event_comment_command_parent_class = NULL;
static gint SetKeyPhotoCommand_private_offset;
static gpointer set_key_photo_command_parent_class = NULL;
static gpointer revert_single_command_parent_class = NULL;
static gpointer revert_multiple_command_parent_class = NULL;
static gpointer enhance_single_command_parent_class = NULL;
static gpointer enhance_multiple_command_parent_class = NULL;
static gint StraightenCommand_private_offset;
static gpointer straighten_command_parent_class = NULL;
static gint CropCommand_private_offset;
static gpointer crop_command_parent_class = NULL;
static gint AdjustColorsSingleCommand_private_offset;
static gpointer adjust_colors_single_command_parent_class = NULL;
static gint AdjustColorsMultipleCommand_private_offset;
static gpointer adjust_colors_multiple_command_parent_class = NULL;
static gint RedeyeCommand_private_offset;
static gpointer redeye_command_parent_class = NULL;
static gpointer move_photos_command_parent_class = NULL;
static gint MovePhotosCommandRealMovePhotosCommand_private_offset;
static gpointer move_photos_command_real_move_photos_command_parent_class = NULL;
static gpointer new_event_command_parent_class = NULL;
static gpointer set_event_command_parent_class = NULL;
static gpointer merge_events_command_parent_class = NULL;
static gint DuplicateMultiplePhotosCommand_private_offset;
static gpointer duplicate_multiple_photos_command_parent_class = NULL;
VALA_EXTERN LibraryPhotoSourceCollection* library_photo_global;
static gint SetRatingSingleCommand_private_offset;
static gpointer set_rating_single_command_parent_class = NULL;
static gint SetRatingCommand_private_offset;
static gpointer set_rating_command_parent_class = NULL;
static gint SetRawDeveloperCommand_private_offset;
static gpointer set_raw_developer_command_parent_class = NULL;
static gint AdjustDateTimePhotoCommand_private_offset;
static gpointer adjust_date_time_photo_command_parent_class = NULL;
VALA_EXTERN EventSourceCollection* event_global;
static gint AdjustDateTimePhotosCommand_private_offset;
static gpointer adjust_date_time_photos_command_parent_class = NULL;
static gint AddTagsCommand_private_offset;
static gpointer add_tags_command_parent_class = NULL;
VALA_EXTERN VideoSourceCollection* video_global;
static gint RenameTagCommand_private_offset;
static gpointer rename_tag_command_parent_class = NULL;
static gint DeleteTagCommand_private_offset;
static gpointer delete_tag_command_parent_class = NULL;
VALA_EXTERN TagSourceCollection* tag_global;
static gint NewChildTagCommand_private_offset;
static gpointer new_child_tag_command_parent_class = NULL;
static gint NewRootTagCommand_private_offset;
static gpointer new_root_tag_command_parent_class = NULL;
static gint ReparentTagCommand_private_offset;
static gpointer reparent_tag_command_parent_class = NULL;
static gint ModifyTagsCommand_private_offset;
static gpointer modify_tags_command_parent_class = NULL;
static gint TagUntagPhotosCommand_private_offset;
static gpointer tag_untag_photos_command_parent_class = NULL;
static gint RenameSavedSearchCommand_private_offset;
static gpointer rename_saved_search_command_parent_class = NULL;
static gint DeleteSavedSearchCommand_private_offset;
static gpointer delete_saved_search_command_parent_class = NULL;
static gint TrashUntrashPhotosCommand_private_offset;
static gpointer trash_untrash_photos_command_parent_class = NULL;
static gint FlagUnflagCommand_private_offset;
static gpointer flag_unflag_command_parent_class = NULL;
static gint RemoveFacesFromPhotosCommand_private_offset;
static gpointer remove_faces_from_photos_command_parent_class = NULL;
static gint RenameFaceCommand_private_offset;
static gpointer rename_face_command_parent_class = NULL;
static gint SetFaceRefCommand_private_offset;
static gpointer set_face_ref_command_parent_class = NULL;
static gint DeleteFaceCommand_private_offset;
static gpointer delete_face_command_parent_class = NULL;
VALA_EXTERN FaceSourceCollection* face_global;
static gint ModifyFacesCommand_private_offset;
static gpointer modify_faces_command_parent_class = NULL;

VALA_EXTERN GType command_description_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandDescription, g_object_unref)
VALA_EXTERN GType command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
VALA_EXTERN GType page_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageCommand, g_object_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType checkerboard_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardPage, g_object_unref)
VALA_EXTERN GType media_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaPage, g_object_unref)
VALA_EXTERN GType collection_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CollectionPage, g_object_unref)
VALA_EXTERN void command_prepare (Command* self);
static void page_command_on_page_destroyed (PageCommand* self);
static void _page_command_on_page_destroyed_gtk_widget_destroy (GtkWidget* _sender,
                                                         gpointer self);
static void page_command_on_photo_destroyed (PageCommand* self);
static void _page_command_on_photo_destroyed_data_source_destroyed (DataSource* _sender,
                                                             gpointer self);
static void page_command_on_controller_destroyed (PageCommand* self);
static void _page_command_on_controller_destroyed_gtk_widget_destroy (GtkWidget* _sender,
                                                               gpointer self);
VALA_EXTERN PageCommand* page_command_construct (GType object_type,
                                     const gchar* name,
                                     const gchar* explanation);
VALA_EXTERN Command* command_construct (GType object_type,
                            const gchar* name,
                            const gchar* explanation);
VALA_EXTERN GType page_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageWindow, g_object_unref)
VALA_EXTERN GType app_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWindow, g_object_unref)
VALA_EXTERN AppWindow* app_window_get_instance (void);
VALA_EXTERN Page* page_window_get_current_page (PageWindow* self);
VALA_EXTERN GType single_photo_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SinglePhotoPage, g_object_unref)
VALA_EXTERN GType editing_host_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingHostPage, g_object_unref)
VALA_EXTERN GType library_photo_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoPage, g_object_unref)
VALA_EXTERN Photo* editing_host_page_get_photo (EditingHostPage* self);
VALA_EXTERN CollectionPage* library_photo_page_get_controller_page (LibraryPhotoPage* self);
VALA_EXTERN void page_command_set_auto_return_to_page (PageCommand* self,
                                           gboolean auto_return);
static void page_command_real_prepare (Command* base);
VALA_EXTERN void page_command_return_to_page (PageCommand* self);
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType view_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollection, data_collection_unref)
VALA_EXTERN ViewCollection* page_get_view (Page* self);
VALA_EXTERN gint data_collection_get_count (DataCollection* self);
VALA_EXTERN DataObject* data_collection_get_at (DataCollection* self,
                                    gint index);
VALA_EXTERN GType data_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataView, g_object_unref)
VALA_EXTERN GType thumbnail_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailView, g_object_unref)
VALA_EXTERN GType checkerboard_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheckerboardItem, g_object_unref)
VALA_EXTERN GType media_source_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceItem, g_object_unref)
VALA_EXTERN GType thumbnail_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnail, g_object_unref)
VALA_EXTERN MediaSource* thumbnail_get_media_source (Thumbnail* self);
VALA_EXTERN GType library_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryWindow, g_object_unref)
VALA_EXTERN LibraryWindow* library_window_get_app (void);
VALA_EXTERN void library_window_switch_to_photo_page (LibraryWindow* self,
                                          CollectionPage* controller,
                                          Photo* current);
VALA_EXTERN void page_window_set_current_page (PageWindow* self,
                                   Page* page);
static void page_command_finalize (GObject * obj);
static GType page_command_get_type_once (void);
VALA_EXTERN GType single_data_source_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SingleDataSourceCommand, g_object_unref)
static void single_data_source_command_on_source_destroyed (SingleDataSourceCommand* self);
static void _single_data_source_command_on_source_destroyed_data_source_destroyed (DataSource* _sender,
                                                                            gpointer self);
VALA_EXTERN SingleDataSourceCommand* single_data_source_command_construct (GType object_type,
                                                               DataSource* source,
                                                               const gchar* name,
                                                               const gchar* explanation);
VALA_EXTERN DataSource* single_data_source_command_get_source (SingleDataSourceCommand* self);
VALA_EXTERN gpointer command_manager_ref (gpointer instance);
VALA_EXTERN void command_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_command_manager (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_command_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_command_manager (const GValue* value);
VALA_EXTERN GType command_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandManager, command_manager_unref)
VALA_EXTERN CommandManager* command_get_command_manager (Command* self);
VALA_EXTERN void command_manager_reset (CommandManager* self);
static void single_data_source_command_finalize (GObject * obj);
static GType single_data_source_command_get_type_once (void);
VALA_EXTERN GType simple_proxyable_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SimpleProxyableCommand, g_object_unref)
VALA_EXTERN gpointer source_proxy_ref (gpointer instance);
VALA_EXTERN void source_proxy_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_source_proxy (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_source_proxy (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_source_proxy (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_source_proxy (const GValue* value);
VALA_EXTERN GType source_proxy_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceProxy, source_proxy_unref)
VALA_EXTERN void command_execute (Command* self);
VALA_EXTERN void simple_proxyable_command_execute_on_source (SimpleProxyableCommand* self,
                                                 DataSource* source);
VALA_EXTERN void command_undo (Command* self);
VALA_EXTERN void simple_proxyable_command_undo_on_source (SimpleProxyableCommand* self,
                                              DataSource* source);
static void simple_proxyable_command_on_proxy_broken (SimpleProxyableCommand* self);
static void _simple_proxyable_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                                    gpointer self);
VALA_EXTERN void simple_proxyable_command_clear_added_proxies (SimpleProxyableCommand* self);
VALA_EXTERN GType proxyable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Proxyable, g_object_unref)
VALA_EXTERN SimpleProxyableCommand* simple_proxyable_command_construct (GType object_type,
                                                            Proxyable* proxyable,
                                                            const gchar* name,
                                                            const gchar* explanation);
VALA_EXTERN SourceProxy* proxyable_get_proxy (Proxyable* self);
static void simple_proxyable_command_real_execute (Command* base);
VALA_EXTERN DataSource* source_proxy_get_source (SourceProxy* self);
static void simple_proxyable_command_real_execute_on_source (SimpleProxyableCommand* self,
                                                      DataSource* source);
static void simple_proxyable_command_real_undo (Command* base);
static void simple_proxyable_command_real_undo_on_source (SimpleProxyableCommand* self,
                                                   DataSource* source);
VALA_EXTERN void simple_proxyable_command_add_proxyables (SimpleProxyableCommand* self,
                                              GeeCollection* proxyables);
static void simple_proxyable_command_finalize (GObject * obj);
static GType simple_proxyable_command_get_type_once (void);
VALA_EXTERN GType single_photo_transformation_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SinglePhotoTransformationCommand, g_object_unref)
VALA_EXTERN GType photo_transformation_state_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTransformationState, g_object_unref)
static void single_photo_transformation_command_on_state_broken (SinglePhotoTransformationCommand* self);
static void _single_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                             gpointer self);
VALA_EXTERN SinglePhotoTransformationCommand* single_photo_transformation_command_construct (GType object_type,
                                                                                 Photo* photo,
                                                                                 const gchar* name,
                                                                                 const gchar* explanation);
VALA_EXTERN PhotoTransformationState* photo_save_transformation_state (Photo* self);
static void single_photo_transformation_command_real_undo (Command* base);
VALA_EXTERN gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static void single_photo_transformation_command_finalize (GObject * obj);
static GType single_photo_transformation_command_get_type_once (void);
VALA_EXTERN GType generic_photo_transformation_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GenericPhotoTransformationCommand, g_object_unref)
VALA_EXTERN void generic_photo_transformation_command_execute_on_photo (GenericPhotoTransformationCommand* self,
                                                            Photo* photo);
VALA_EXTERN void command_redo (Command* self);
VALA_EXTERN gboolean generic_photo_transformation_command_can_compress (GenericPhotoTransformationCommand* self,
                                                            Command* command);
VALA_EXTERN gboolean command_compress (Command* self,
                           Command* command);
static void generic_photo_transformation_command_on_state_broken (GenericPhotoTransformationCommand* self);
static void _generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                              gpointer self);
VALA_EXTERN GenericPhotoTransformationCommand* generic_photo_transformation_command_construct (GType object_type,
                                                                                   Photo* photo,
                                                                                   const gchar* name,
                                                                                   const gchar* explanation);
static void generic_photo_transformation_command_real_execute (Command* base);
static void generic_photo_transformation_command_real_execute_on_photo (GenericPhotoTransformationCommand* self,
                                                                 Photo* photo);
static void generic_photo_transformation_command_real_undo (Command* base);
static void generic_photo_transformation_command_real_redo (Command* base);
static gboolean generic_photo_transformation_command_real_can_compress (GenericPhotoTransformationCommand* self,
                                                                 Command* command);
static gboolean generic_photo_transformation_command_real_compress (Command* base,
                                                             Command* command);
static void generic_photo_transformation_command_finalize (GObject * obj);
static GType generic_photo_transformation_command_get_type_once (void);
VALA_EXTERN GType multiple_data_source_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MultipleDataSourceCommand, g_object_unref)
VALA_EXTERN GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
VALA_EXTERN void multiple_data_source_command_execute_on_source (MultipleDataSourceCommand* self,
                                                     DataSource* source);
VALA_EXTERN void multiple_data_source_command_undo_on_source (MultipleDataSourceCommand* self,
                                                  DataSource* source);
static void multiple_data_source_command_on_source_destroyed (MultipleDataSourceCommand* self,
                                                       DataSource* source);
static void _multiple_data_source_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                         DataSource* source,
                                                                                         gpointer self);
VALA_EXTERN MultipleDataSourceCommand* multiple_data_source_command_construct (GType object_type,
                                                                   GeeIterable* iter,
                                                                   const gchar* progress_text,
                                                                   const gchar* undo_progress_text,
                                                                   const gchar* name,
                                                                   const gchar* explanation);
VALA_EXTERN DataSource* data_view_get_source (DataView* self);
VALA_EXTERN DataCollection* data_object_get_membership (DataObject* self);
VALA_EXTERN GeeIterable* multiple_data_source_command_get_sources (MultipleDataSourceCommand* self);
VALA_EXTERN gint multiple_data_source_command_get_source_count (MultipleDataSourceCommand* self);
static void multiple_data_source_command_real_execute (Command* base);
static void multiple_data_source_command_start_transaction (MultipleDataSourceCommand* self);
static void multiple_data_source_command_execute_all (MultipleDataSourceCommand* self,
                                               gboolean exec,
                                               gboolean can_cancel,
                                               GeeArrayList* todo,
                                               GeeArrayList* completed);
static void multiple_data_source_command_commit_transaction (MultipleDataSourceCommand* self);
static void multiple_data_source_command_real_execute_on_source (MultipleDataSourceCommand* self,
                                                          DataSource* source);
static void multiple_data_source_command_real_undo (Command* base);
static void multiple_data_source_command_real_undo_on_source (MultipleDataSourceCommand* self,
                                                       DataSource* source);
VALA_EXTERN GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
VALA_EXTERN GType media_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceCollection, data_collection_unref)
VALA_EXTERN gpointer transaction_controller_ref (gpointer instance);
VALA_EXTERN void transaction_controller_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_transaction_controller (const GValue* value);
VALA_EXTERN GType transaction_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TransactionController, transaction_controller_unref)
VALA_EXTERN TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
VALA_EXTERN void transaction_controller_begin (TransactionController* self);
VALA_EXTERN void transaction_controller_commit (TransactionController* self);
VALA_EXTERN void page_window_set_busy_cursor (PageWindow* self);
VALA_EXTERN GType progress_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ProgressDialog, g_object_unref)
VALA_EXTERN ProgressDialog* progress_dialog_new (GtkWindow* owner,
                                     const gchar* text,
                                     GCancellable* cancellable);
VALA_EXTERN ProgressDialog* progress_dialog_construct (GType object_type,
                                           GtkWindow* owner,
                                           const gchar* text,
                                           GCancellable* cancellable);
VALA_EXTERN void progress_dialog_set_fraction (ProgressDialog* self,
                                   gint current,
                                   gint total);
VALA_EXTERN void spin_event_loop (void);
VALA_EXTERN void progress_dialog_close (ProgressDialog* self);
VALA_EXTERN void page_window_set_normal_cursor (PageWindow* self);
static void multiple_data_source_command_finalize (GObject * obj);
static GType multiple_data_source_command_get_type_once (void);
VALA_EXTERN GType multiple_data_source_at_once_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MultipleDataSourceAtOnceCommand, g_object_unref)
VALA_EXTERN void multiple_data_source_at_once_command_execute_on_all (MultipleDataSourceAtOnceCommand* self,
                                                          GeeCollection* sources);
VALA_EXTERN void multiple_data_source_at_once_command_undo_on_all (MultipleDataSourceAtOnceCommand* self,
                                                       GeeCollection* sources);
static void multiple_data_source_at_once_command_on_sources_destroyed (MultipleDataSourceAtOnceCommand* self,
                                                                GeeCollection* destroyed);
static void _multiple_data_source_at_once_command_on_sources_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                                                   GeeCollection* destroyed,
                                                                                                   gpointer self);
VALA_EXTERN MultipleDataSourceAtOnceCommand* multiple_data_source_at_once_command_construct (GType object_type,
                                                                                 GeeCollection* sources,
                                                                                 const gchar* name,
                                                                                 const gchar* explanation);
static void multiple_data_source_at_once_command_real_execute (Command* base);
VALA_EXTERN void database_table_begin_transaction (void);
VALA_EXTERN gpointer media_collection_registry_ref (gpointer instance);
VALA_EXTERN void media_collection_registry_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_media_collection_registry (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void value_set_media_collection_registry (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void value_take_media_collection_registry (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer value_get_media_collection_registry (const GValue* value);
VALA_EXTERN GType media_collection_registry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaCollectionRegistry, media_collection_registry_unref)
VALA_EXTERN MediaCollectionRegistry* media_collection_registry_get_instance (void);
VALA_EXTERN void media_collection_registry_freeze_all (MediaCollectionRegistry* self);
VALA_EXTERN void media_collection_registry_thaw_all (MediaCollectionRegistry* self);
VALA_EXTERN GQuark database_error_quark (void);
GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void database_table_commit_transaction (GError** error);
VALA_EXTERN void app_window_database_error (GError* err);
static void multiple_data_source_at_once_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* self,
                                                               GeeCollection* sources);
static void multiple_data_source_at_once_command_real_undo (Command* base);
static void multiple_data_source_at_once_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* self,
                                                            GeeCollection* sources);
static void multiple_data_source_at_once_command_finalize (GObject * obj);
static GType multiple_data_source_at_once_command_get_type_once (void);
VALA_EXTERN GType multiple_photo_transformation_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MultiplePhotoTransformationCommand, g_object_unref)
static void multiple_photo_transformation_command_on_state_broken (MultiplePhotoTransformationCommand* self);
static void _multiple_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                               gpointer self);
VALA_EXTERN MultiplePhotoTransformationCommand* multiple_photo_transformation_command_construct (GType object_type,
                                                                                     GeeIterable* iter,
                                                                                     const gchar* progress_text,
                                                                                     const gchar* undo_progress_text,
                                                                                     const gchar* name,
                                                                                     const gchar* explanation);
static void multiple_photo_transformation_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                                DataSource* source);
static void multiple_photo_transformation_command_finalize (GObject * obj);
static GType multiple_photo_transformation_command_get_type_once (void);
VALA_EXTERN GType rotate_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RotateSingleCommand, g_object_unref)
VALA_EXTERN GType rotation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN RotateSingleCommand* rotate_single_command_new (Photo* photo,
                                                Rotation rotation,
                                                const gchar* name,
                                                const gchar* explanation);
VALA_EXTERN RotateSingleCommand* rotate_single_command_construct (GType object_type,
                                                      Photo* photo,
                                                      Rotation rotation,
                                                      const gchar* name,
                                                      const gchar* explanation);
static void rotate_single_command_real_execute (Command* base);
VALA_EXTERN void photo_rotate (Photo* self,
                   Rotation rotation);
static void rotate_single_command_real_undo (Command* base);
VALA_EXTERN Rotation rotation_opposite (Rotation self);
static void rotate_single_command_finalize (GObject * obj);
static GType rotate_single_command_get_type_once (void);
VALA_EXTERN GType rotate_multiple_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RotateMultipleCommand, g_object_unref)
VALA_EXTERN RotateMultipleCommand* rotate_multiple_command_new (GeeIterable* iter,
                                                    Rotation rotation,
                                                    const gchar* name,
                                                    const gchar* explanation,
                                                    const gchar* progress_text,
                                                    const gchar* undo_progress_text);
VALA_EXTERN RotateMultipleCommand* rotate_multiple_command_construct (GType object_type,
                                                          GeeIterable* iter,
                                                          Rotation rotation,
                                                          const gchar* name,
                                                          const gchar* explanation,
                                                          const gchar* progress_text,
                                                          const gchar* undo_progress_text);
static void rotate_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                     DataSource* source);
static void rotate_multiple_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                  DataSource* source);
static void rotate_multiple_command_finalize (GObject * obj);
static GType rotate_multiple_command_get_type_once (void);
VALA_EXTERN GType edit_title_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditTitleCommand, g_object_unref)
VALA_EXTERN EditTitleCommand* edit_title_command_new (MediaSource* source,
                                          const gchar* new_title);
VALA_EXTERN EditTitleCommand* edit_title_command_construct (GType object_type,
                                                MediaSource* source,
                                                const gchar* new_title);
VALA_EXTERN gchar* media_source_get_title (MediaSource* self);
static void edit_title_command_real_execute (Command* base);
VALA_EXTERN void media_source_set_title (MediaSource* self,
                             const gchar* title);
static void edit_title_command_real_undo (Command* base);
static void edit_title_command_finalize (GObject * obj);
static GType edit_title_command_get_type_once (void);
VALA_EXTERN GType edit_comment_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditCommentCommand, g_object_unref)
VALA_EXTERN EditCommentCommand* edit_comment_command_new (MediaSource* source,
                                              const gchar* new_comment);
VALA_EXTERN EditCommentCommand* edit_comment_command_construct (GType object_type,
                                                    MediaSource* source,
                                                    const gchar* new_comment);
VALA_EXTERN gchar* media_source_get_comment (MediaSource* self);
static void edit_comment_command_real_execute (Command* base);
VALA_EXTERN gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
static void edit_comment_command_real_undo (Command* base);
static void edit_comment_command_finalize (GObject * obj);
static GType edit_comment_command_get_type_once (void);
VALA_EXTERN GType edit_multiple_titles_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditMultipleTitlesCommand, g_object_unref)
VALA_EXTERN EditMultipleTitlesCommand* edit_multiple_titles_command_new (GeeCollection* media_sources,
                                                             const gchar* new_title);
VALA_EXTERN EditMultipleTitlesCommand* edit_multiple_titles_command_construct (GType object_type,
                                                                   GeeCollection* media_sources,
                                                                   const gchar* new_title);
static void edit_multiple_titles_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                                       GeeCollection* sources);
static void edit_multiple_titles_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                                    GeeCollection* sources);
static void edit_multiple_titles_command_finalize (GObject * obj);
static GType edit_multiple_titles_command_get_type_once (void);
VALA_EXTERN GType edit_multiple_comments_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditMultipleCommentsCommand, g_object_unref)
VALA_EXTERN EditMultipleCommentsCommand* edit_multiple_comments_command_new (GeeCollection* media_sources,
                                                                 const gchar* new_comment);
VALA_EXTERN EditMultipleCommentsCommand* edit_multiple_comments_command_construct (GType object_type,
                                                                       GeeCollection* media_sources,
                                                                       const gchar* new_comment);
static void edit_multiple_comments_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                                         GeeCollection* sources);
static void edit_multiple_comments_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                                      GeeCollection* sources);
static void edit_multiple_comments_command_finalize (GObject * obj);
static GType edit_multiple_comments_command_get_type_once (void);
VALA_EXTERN GType rename_event_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RenameEventCommand, g_object_unref)
VALA_EXTERN GType event_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSource, g_object_unref)
VALA_EXTERN GType event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Event, g_object_unref)
VALA_EXTERN RenameEventCommand* rename_event_command_new (Event* event,
                                              const gchar* new_name);
VALA_EXTERN RenameEventCommand* rename_event_command_construct (GType object_type,
                                                    Event* event,
                                                    const gchar* new_name);
VALA_EXTERN gchar* event_get_raw_name (Event* self);
static void rename_event_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                  DataSource* source);
VALA_EXTERN gboolean event_rename (Event* self,
                       const gchar* name);
static void rename_event_command_real_undo_on_source (SimpleProxyableCommand* base,
                                               DataSource* source);
static void rename_event_command_finalize (GObject * obj);
static GType rename_event_command_get_type_once (void);
VALA_EXTERN GType edit_event_comment_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditEventCommentCommand, g_object_unref)
VALA_EXTERN EditEventCommentCommand* edit_event_comment_command_new (Event* event,
                                                         const gchar* new_comment);
VALA_EXTERN EditEventCommentCommand* edit_event_comment_command_construct (GType object_type,
                                                               Event* event,
                                                               const gchar* new_comment);
VALA_EXTERN gchar* event_source_get_comment (EventSource* self);
static void edit_event_comment_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                        DataSource* source);
VALA_EXTERN gboolean event_source_set_comment (EventSource* self,
                                   const gchar* comment);
static void edit_event_comment_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                     DataSource* source);
static void edit_event_comment_command_finalize (GObject * obj);
static GType edit_event_comment_command_get_type_once (void);
VALA_EXTERN GType set_key_photo_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetKeyPhotoCommand, g_object_unref)
VALA_EXTERN SetKeyPhotoCommand* set_key_photo_command_new (Event* event,
                                               MediaSource* new_primary_source);
VALA_EXTERN SetKeyPhotoCommand* set_key_photo_command_construct (GType object_type,
                                                     Event* event,
                                                     MediaSource* new_primary_source);
VALA_EXTERN MediaSource* event_get_primary_source (Event* self);
static void set_key_photo_command_real_execute (Command* base);
VALA_EXTERN gboolean event_set_primary_source (Event* self,
                                   MediaSource* source);
static void set_key_photo_command_real_undo (Command* base);
static void set_key_photo_command_finalize (GObject * obj);
static GType set_key_photo_command_get_type_once (void);
VALA_EXTERN GType revert_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RevertSingleCommand, g_object_unref)
VALA_EXTERN RevertSingleCommand* revert_single_command_new (Photo* photo);
VALA_EXTERN RevertSingleCommand* revert_single_command_construct (GType object_type,
                                                      Photo* photo);
static void revert_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                                  Photo* photo);
VALA_EXTERN void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
static gboolean revert_single_command_real_compress (Command* base,
                                              Command* command);
static GType revert_single_command_get_type_once (void);
VALA_EXTERN GType revert_multiple_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RevertMultipleCommand, g_object_unref)
VALA_EXTERN RevertMultipleCommand* revert_multiple_command_new (GeeIterable* iter);
VALA_EXTERN RevertMultipleCommand* revert_multiple_command_construct (GType object_type,
                                                          GeeIterable* iter);
static void revert_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                     DataSource* source);
static GType revert_multiple_command_get_type_once (void);
VALA_EXTERN GType enhance_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EnhanceSingleCommand, g_object_unref)
VALA_EXTERN EnhanceSingleCommand* enhance_single_command_new (Photo* photo);
VALA_EXTERN EnhanceSingleCommand* enhance_single_command_construct (GType object_type,
                                                        Photo* photo);
static void enhance_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                                   Photo* photo);
VALA_EXTERN gboolean photo_enhance (Photo* self);
static gboolean enhance_single_command_real_compress (Command* base,
                                               Command* command);
static GType enhance_single_command_get_type_once (void);
VALA_EXTERN GType enhance_multiple_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EnhanceMultipleCommand, g_object_unref)
VALA_EXTERN EnhanceMultipleCommand* enhance_multiple_command_new (GeeIterable* iter);
VALA_EXTERN EnhanceMultipleCommand* enhance_multiple_command_construct (GType object_type,
                                                            GeeIterable* iter);
static void enhance_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                      DataSource* source);
static GType enhance_multiple_command_get_type_once (void);
VALA_EXTERN GType straighten_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StraightenCommand, g_object_unref)
VALA_EXTERN GType box_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Box* box_dup (const Box* self);
VALA_EXTERN void box_free (Box* self);
VALA_EXTERN StraightenCommand* straighten_command_new (Photo* photo,
                                           gdouble theta,
                                           Box* crop,
                                           const gchar* name,
                                           const gchar* explanation);
VALA_EXTERN StraightenCommand* straighten_command_construct (GType object_type,
                                                 Photo* photo,
                                                 gdouble theta,
                                                 Box* crop,
                                                 const gchar* name,
                                                 const gchar* explanation);
static void straighten_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                               Photo* photo);
VALA_EXTERN void data_collection_freeze_notifications (DataCollection* self);
VALA_EXTERN void photo_set_straighten (Photo* self,
                           gdouble theta);
VALA_EXTERN void photo_set_crop (Photo* self,
                     Box* crop);
VALA_EXTERN void data_collection_thaw_notifications (DataCollection* self);
static void straighten_command_finalize (GObject * obj);
static GType straighten_command_get_type_once (void);
VALA_EXTERN GType crop_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CropCommand, g_object_unref)
VALA_EXTERN CropCommand* crop_command_new (Photo* photo,
                               Box* crop,
                               const gchar* name,
                               const gchar* explanation);
VALA_EXTERN CropCommand* crop_command_construct (GType object_type,
                                     Photo* photo,
                                     Box* crop,
                                     const gchar* name,
                                     const gchar* explanation);
static void crop_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                         Photo* photo);
static void crop_command_finalize (GObject * obj);
static GType crop_command_get_type_once (void);
VALA_EXTERN GType adjust_colors_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdjustColorsSingleCommand, g_object_unref)
VALA_EXTERN AdjustColorsSingleCommand* adjust_colors_single_command_new (Photo* photo,
                                                             PixelTransformationBundle* transformations,
                                                             const gchar* name,
                                                             const gchar* explanation);
VALA_EXTERN AdjustColorsSingleCommand* adjust_colors_single_command_construct (GType object_type,
                                                                   Photo* photo,
                                                                   PixelTransformationBundle* transformations,
                                                                   const gchar* name,
                                                                   const gchar* explanation);
static void adjust_colors_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                                         Photo* photo);
VALA_EXTERN void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
static gboolean adjust_colors_single_command_real_can_compress (GenericPhotoTransformationCommand* base,
                                                         Command* command);
static void adjust_colors_single_command_finalize (GObject * obj);
static GType adjust_colors_single_command_get_type_once (void);
VALA_EXTERN GType adjust_colors_multiple_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdjustColorsMultipleCommand, g_object_unref)
VALA_EXTERN AdjustColorsMultipleCommand* adjust_colors_multiple_command_new (GeeIterable* iter,
                                                                 PixelTransformationBundle* transformations,
                                                                 const gchar* name,
                                                                 const gchar* explanation);
VALA_EXTERN AdjustColorsMultipleCommand* adjust_colors_multiple_command_construct (GType object_type,
                                                                       GeeIterable* iter,
                                                                       PixelTransformationBundle* transformations,
                                                                       const gchar* name,
                                                                       const gchar* explanation);
static void adjust_colors_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                            DataSource* source);
static void adjust_colors_multiple_command_finalize (GObject * obj);
static GType adjust_colors_multiple_command_get_type_once (void);
VALA_EXTERN GType redeye_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RedeyeCommand, g_object_unref)
VALA_EXTERN GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
VALA_EXTERN void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
VALA_EXTERN RedeyeCommand* redeye_command_new (Photo* photo,
                                   EditingToolsRedeyeInstance* redeye_instance,
                                   const gchar* name,
                                   const gchar* explanation);
VALA_EXTERN RedeyeCommand* redeye_command_construct (GType object_type,
                                         Photo* photo,
                                         EditingToolsRedeyeInstance* redeye_instance,
                                         const gchar* name,
                                         const gchar* explanation);
static void redeye_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                           Photo* photo);
VALA_EXTERN void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
static void redeye_command_finalize (GObject * obj);
static GType redeye_command_get_type_once (void);
VALA_EXTERN GType move_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MovePhotosCommand, g_object_unref)
VALA_EXTERN GType move_photos_command_real_move_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MovePhotosCommandRealMovePhotosCommand, g_object_unref)
VALA_EXTERN MovePhotosCommand* move_photos_command_construct (GType object_type,
                                                  const gchar* name,
                                                  const gchar* explanation);
static void move_photos_command_real_prepare (Command* base);
static void move_photos_command_real_execute (Command* base);
static void move_photos_command_real_undo (Command* base);
static void move_photos_command_real_move_photos_command_on_proxy_broken (MovePhotosCommandRealMovePhotosCommand* self);
static void _move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                                                        gpointer self);
VALA_EXTERN MovePhotosCommandRealMovePhotosCommand* move_photos_command_real_move_photos_command_new (Event* new_event,
                                                                                          GeeIterable* source_views,
                                                                                          const gchar* progress_text,
                                                                                          const gchar* undo_progress_text,
                                                                                          const gchar* name,
                                                                                          const gchar* explanation);
VALA_EXTERN MovePhotosCommandRealMovePhotosCommand* move_photos_command_real_move_photos_command_construct (GType object_type,
                                                                                                Event* new_event,
                                                                                                GeeIterable* source_views,
                                                                                                const gchar* progress_text,
                                                                                                const gchar* undo_progress_text,
                                                                                                const gchar* name,
                                                                                                const gchar* explanation);
VALA_EXTERN Event* media_source_get_event (MediaSource* self);
static void move_photos_command_real_move_photos_command_real_execute (Command* base);
VALA_EXTERN GType event_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventPage, g_object_unref)
VALA_EXTERN Event* event_page_get_event (EventPage* self);
VALA_EXTERN gint event_source_get_media_count (EventSource* self);
VALA_EXTERN void library_window_switch_to_event (LibraryWindow* self,
                                     Event* event);
static void move_photos_command_real_move_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                                          DataSource* source);
VALA_EXTERN gboolean media_source_set_event (MediaSource* self,
                                 Event* new_event);
static void move_photos_command_real_move_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                                       DataSource* source);
static void move_photos_command_real_move_photos_command_finalize (GObject * obj);
static GType move_photos_command_real_move_photos_command_get_type_once (void);
static void move_photos_command_finalize (GObject * obj);
static GType move_photos_command_get_type_once (void);
VALA_EXTERN GType new_event_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewEventCommand, g_object_unref)
VALA_EXTERN NewEventCommand* new_event_command_new (GeeIterable* iter);
VALA_EXTERN NewEventCommand* new_event_command_construct (GType object_type,
                                              GeeIterable* iter);
VALA_EXTERN Event* event_create_empty_event (MediaSource* source);
static GType new_event_command_get_type_once (void);
VALA_EXTERN GType set_event_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetEventCommand, g_object_unref)
VALA_EXTERN SetEventCommand* set_event_command_new (GeeIterable* iter,
                                        Event* new_event);
VALA_EXTERN SetEventCommand* set_event_command_construct (GType object_type,
                                              GeeIterable* iter,
                                              Event* new_event);
static GType set_event_command_get_type_once (void);
VALA_EXTERN GType merge_events_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MergeEventsCommand, g_object_unref)
VALA_EXTERN MergeEventsCommand* merge_events_command_new (GeeIterable* iter);
VALA_EXTERN MergeEventsCommand* merge_events_command_construct (GType object_type,
                                                    GeeIterable* iter);
VALA_EXTERN gboolean event_has_name (Event* self);
VALA_EXTERN GeeCollection* event_source_get_media (EventSource* self);
VALA_EXTERN ThumbnailView* thumbnail_view_new (ThumbnailSource* source);
VALA_EXTERN ThumbnailView* thumbnail_view_construct (GType object_type,
                                         ThumbnailSource* source);
static GType merge_events_command_get_type_once (void);
VALA_EXTERN GType duplicate_multiple_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DuplicateMultiplePhotosCommand, g_object_unref)
VALA_EXTERN GType library_photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhoto, g_object_unref)
VALA_EXTERN GType library_photo_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceCollection, data_collection_unref)
static void duplicate_multiple_photos_command_on_photo_destroyed (DuplicateMultiplePhotosCommand* self,
                                                           DataSource* source);
static void _duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                             DataSource* source,
                                                                                             gpointer self);
VALA_EXTERN DuplicateMultiplePhotosCommand* duplicate_multiple_photos_command_new (GeeIterable* iter);
VALA_EXTERN DuplicateMultiplePhotosCommand* duplicate_multiple_photos_command_construct (GType object_type,
                                                                             GeeIterable* iter);
static void duplicate_multiple_photos_command_real_execute (Command* base);
VALA_EXTERN void app_window_error_message (const gchar* message,
                               GtkWindow* parent);
static void duplicate_multiple_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                               DataSource* source);
VALA_EXTERN LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
VALA_EXTERN GFile* media_source_get_file (MediaSource* self);
static void duplicate_multiple_photos_command_real_undo (Command* base);
static void duplicate_multiple_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                            DataSource* source);
VALA_EXTERN GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, g_object_unref)
VALA_EXTERN Marker* data_collection_mark (DataCollection* self,
                              DataObject* object);
VALA_EXTERN gint source_collection_destroy_marked (SourceCollection* self,
                                       Marker* marker,
                                       gboolean delete_backing,
                                       ProgressMonitor monitor,
                                       gpointer monitor_target,
                                       GeeList* not_removed);
static void duplicate_multiple_photos_command_finalize (GObject * obj);
static GType duplicate_multiple_photos_command_get_type_once (void);
VALA_EXTERN GType set_rating_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetRatingSingleCommand, g_object_unref)
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SetRatingSingleCommand* set_rating_single_command_new (DataSource* source,
                                                       Rating rating);
VALA_EXTERN SetRatingSingleCommand* set_rating_single_command_construct (GType object_type,
                                                             DataSource* source,
                                                             Rating rating);
VALA_EXTERN const gchar* resources_rating_label (Rating rating);
VALA_EXTERN Rating media_source_get_rating (MediaSource* self);
VALA_EXTERN SetRatingSingleCommand* set_rating_single_command_new_inc_dec (DataSource* source,
                                                               gboolean is_incrementing);
VALA_EXTERN SetRatingSingleCommand* set_rating_single_command_construct_inc_dec (GType object_type,
                                                                     DataSource* source,
                                                                     gboolean is_incrementing);
static void set_rating_single_command_real_execute (Command* base);
VALA_EXTERN void media_source_set_rating (MediaSource* self,
                              Rating rating);
VALA_EXTERN void media_source_increase_rating (MediaSource* self);
VALA_EXTERN void media_source_decrease_rating (MediaSource* self);
static void set_rating_single_command_real_undo (Command* base);
static void set_rating_single_command_finalize (GObject * obj);
static GType set_rating_single_command_get_type_once (void);
VALA_EXTERN GType set_rating_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetRatingCommand, g_object_unref)
VALA_EXTERN SetRatingCommand* set_rating_command_new (GeeIterable* iter,
                                          Rating rating);
VALA_EXTERN SetRatingCommand* set_rating_command_construct (GType object_type,
                                                GeeIterable* iter,
                                                Rating rating);
VALA_EXTERN gchar* resources_rating_progress (Rating rating);
static void set_rating_command_save_source_states (SetRatingCommand* self,
                                            GeeIterable* iter);
VALA_EXTERN SetRatingCommand* set_rating_command_new_inc_dec (GeeIterable* iter,
                                                  gboolean is_incrementing);
VALA_EXTERN SetRatingCommand* set_rating_command_construct_inc_dec (GType object_type,
                                                        GeeIterable* iter,
                                                        gboolean is_incrementing);
static void set_rating_command_real_execute (Command* base);
static void set_rating_command_real_undo (Command* base);
static void set_rating_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                DataSource* source);
static void set_rating_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                             DataSource* source);
static void set_rating_command_finalize (GObject * obj);
static GType set_rating_command_get_type_once (void);
VALA_EXTERN GType set_raw_developer_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetRawDeveloperCommand, g_object_unref)
VALA_EXTERN GType raw_developer_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SetRawDeveloperCommand* set_raw_developer_command_new (GeeIterable* iter,
                                                       RawDeveloper developer);
VALA_EXTERN SetRawDeveloperCommand* set_raw_developer_command_construct (GType object_type,
                                                             GeeIterable* iter,
                                                             RawDeveloper developer);
static void set_raw_developer_command_save_source_states (SetRawDeveloperCommand* self,
                                                   GeeIterable* iter);
static gboolean set_raw_developer_command_is_raw_photo (SetRawDeveloperCommand* self,
                                                 Photo* photo);
VALA_EXTERN RawDeveloper photo_get_raw_developer (Photo* self);
static void set_raw_developer_command_real_execute (Command* base);
static void set_raw_developer_command_real_undo (Command* base);
static void set_raw_developer_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                       DataSource* source);
VALA_EXTERN gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
VALA_EXTERN void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
static void set_raw_developer_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                    DataSource* source);
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoFileFormat photo_get_master_file_format (Photo* self);
static void set_raw_developer_command_finalize (GObject * obj);
static GType set_raw_developer_command_get_type_once (void);
VALA_EXTERN GType adjust_date_time_photo_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdjustDateTimePhotoCommand, g_object_unref)
VALA_EXTERN GType dateable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Dateable, g_object_unref)
VALA_EXTERN AdjustDateTimePhotoCommand* adjust_date_time_photo_command_new (Dateable* dateable,
                                                                gint64 time_shift,
                                                                gboolean modify_original);
VALA_EXTERN AdjustDateTimePhotoCommand* adjust_date_time_photo_command_construct (GType object_type,
                                                                      Dateable* dateable,
                                                                      gint64 time_shift,
                                                                      gboolean modify_original);
static GDateTime* adjust_date_time_photo_command_get_base_time (AdjustDateTimePhotoCommand* self);
VALA_EXTERN GDateTime* dateable_get_exposure_time (Dateable* self);
static void adjust_date_time_photo_command_real_execute (Command* base);
static void adjust_date_time_photo_command_set_time (AdjustDateTimePhotoCommand* self,
                                              Dateable* dateable,
                                              GDateTime* exposure_time);
VALA_EXTERN ViewCollection* view_collection_new (const gchar* name);
VALA_EXTERN ViewCollection* view_collection_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
VALA_EXTERN GType event_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSourceCollection, data_collection_unref)
VALA_EXTERN GeeCollection* data_collection_get_all (DataCollection* self);
VALA_EXTERN gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
VALA_EXTERN EventView* event_view_new (EventSource* source);
VALA_EXTERN EventView* event_view_construct (GType object_type,
                                 EventSource* source);
VALA_EXTERN GType event_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventView, g_object_unref)
VALA_EXTERN void event_generate_single_event (MediaSource* media,
                                  ViewCollection* events_so_far,
                                  const gchar* event_name);
static void adjust_date_time_photo_command_real_undo (Command* base);
VALA_EXTERN void photo_set_exposure_time_persistent (Photo* self,
                                         GDateTime* time,
                                         GError** error);
VALA_EXTERN void dateable_set_exposure_time (Dateable* self,
                                 GDateTime* target_time);
static void adjust_date_time_photo_command_finalize (GObject * obj);
static GType adjust_date_time_photo_command_get_type_once (void);
VALA_EXTERN GType adjust_date_time_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdjustDateTimePhotosCommand, g_object_unref)
VALA_EXTERN AdjustDateTimePhotosCommand* adjust_date_time_photos_command_new (GeeIterable* iter,
                                                                  gint64 time_shift,
                                                                  gboolean keep_relativity,
                                                                  gboolean modify_originals);
VALA_EXTERN AdjustDateTimePhotosCommand* adjust_date_time_photos_command_construct (GType object_type,
                                                                        GeeIterable* iter,
                                                                        gint64 time_shift,
                                                                        gboolean keep_relativity,
                                                                        gboolean modify_originals);
static GDateTime* adjust_date_time_photos_command_get_base_time (AdjustDateTimePhotosCommand* self,
                                                          Dateable* dateable);
static void adjust_date_time_photos_command_real_execute (Command* base);
VALA_EXTERN void multiple_object_error_dialog (GeeArrayList* objects,
                                   const gchar* message,
                                   const gchar* title);
static void adjust_date_time_photos_command_real_undo (Command* base);
static void adjust_date_time_photos_command_set_time (AdjustDateTimePhotosCommand* self,
                                               Dateable* dateable,
                                               GDateTime* exposure_time);
static void adjust_date_time_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                             DataSource* source);
static void adjust_date_time_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                          DataSource* source);
static void adjust_date_time_photos_command_finalize (GObject * obj);
static GType adjust_date_time_photos_command_get_type_once (void);
VALA_EXTERN GType add_tags_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AddTagsCommand, g_object_unref)
static void add_tags_command_on_proxy_broken (AddTagsCommand* self);
static void _add_tags_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                            gpointer self);
static void add_tags_command_on_source_destroyed (AddTagsCommand* self,
                                           DataSource* source);
static void _add_tags_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                             DataSource* source,
                                                                             gpointer self);
VALA_EXTERN GType video_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSourceCollection, data_collection_unref)
VALA_EXTERN AddTagsCommand* add_tags_command_new (gchar** paths,
                                      gint paths_length1,
                                      GeeCollection* sources);
VALA_EXTERN AddTagsCommand* add_tags_command_construct (GType object_type,
                                            gchar** paths,
                                            gint paths_length1,
                                            GeeCollection* sources);
VALA_EXTERN gchar* resources_add_tags_label (gchar** names,
                                 gint names_length1);
VALA_EXTERN GeeList* hierarchical_tag_utilities_enumerate_parent_paths (const gchar* in_path);
VALA_EXTERN GType tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tag, g_object_unref)
VALA_EXTERN Tag* tag_for_path (const gchar* name);
VALA_EXTERN gboolean tag_contains (Tag* self,
                       MediaSource* source);
static void add_tags_command_real_execute (Command* base);
VALA_EXTERN void tag_attach_many (Tag* self,
                      GeeCollection* sources);
static void add_tags_command_real_undo (Command* base);
VALA_EXTERN GeeMultiMap* tag_detach_many (Tag* self,
                              GeeCollection* sources);
static void add_tags_command_finalize (GObject * obj);
static GType add_tags_command_get_type_once (void);
VALA_EXTERN GType rename_tag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RenameTagCommand, g_object_unref)
VALA_EXTERN RenameTagCommand* rename_tag_command_new (Tag* tag,
                                          const gchar* new_name);
VALA_EXTERN RenameTagCommand* rename_tag_command_construct (GType object_type,
                                                Tag* tag,
                                                const gchar* new_name);
VALA_EXTERN gchar* resources_rename_tag_label (const gchar* old_name,
                                   const gchar* new_name);
VALA_EXTERN gchar* tag_get_user_visible_name (Tag* self);
VALA_EXTERN gchar* data_object_get_name (DataObject* self);
static void rename_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                DataSource* source);
VALA_EXTERN gboolean tag_rename (Tag* self,
                     const gchar* name);
VALA_EXTERN gchar* resources_rename_tag_exists_message (const gchar* name);
static void rename_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                             DataSource* source);
static void rename_tag_command_finalize (GObject * obj);
static GType rename_tag_command_get_type_once (void);
VALA_EXTERN GType delete_tag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteTagCommand, g_object_unref)
VALA_EXTERN DeleteTagCommand* delete_tag_command_new (Tag* tag);
VALA_EXTERN DeleteTagCommand* delete_tag_command_construct (GType object_type,
                                                Tag* tag);
VALA_EXTERN gchar* resources_delete_tag_label (const gchar* name);
static void delete_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                DataSource* source);
VALA_EXTERN GeeList* tag_get_hierarchical_children (Tag* self);
static void delete_tag_command_on_proxy_broken (DeleteTagCommand* self);
static void _delete_tag_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                              gpointer self);
VALA_EXTERN GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
static void delete_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                             DataSource* source);
static void delete_tag_command_finalize (GObject * obj);
static GType delete_tag_command_get_type_once (void);
VALA_EXTERN GType new_child_tag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewChildTagCommand, g_object_unref)
VALA_EXTERN NewChildTagCommand* new_child_tag_command_new (Tag* tag);
VALA_EXTERN NewChildTagCommand* new_child_tag_command_construct (GType object_type,
                                                     Tag* tag);
static void new_child_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                   DataSource* source);
VALA_EXTERN Tag* tag_create_new_child (Tag* self);
static void new_child_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                DataSource* source);
VALA_EXTERN Tag* new_child_tag_command_get_created_child (NewChildTagCommand* self);
static void new_child_tag_command_finalize (GObject * obj);
static GType new_child_tag_command_get_type_once (void);
VALA_EXTERN GType new_root_tag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewRootTagCommand, g_object_unref)
VALA_EXTERN NewRootTagCommand* new_root_tag_command_new (void);
VALA_EXTERN NewRootTagCommand* new_root_tag_command_construct (GType object_type);
static void new_root_tag_command_real_execute (Command* base);
VALA_EXTERN Tag* tag_create_new_root (void);
static void new_root_tag_command_real_undo (Command* base);
VALA_EXTERN Tag* new_root_tag_command_get_created_tag (NewRootTagCommand* self);
static void new_root_tag_command_finalize (GObject * obj);
static GType new_root_tag_command_get_type_once (void);
VALA_EXTERN GType reparent_tag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReparentTagCommand, g_object_unref)
static void reparent_tag_command_on_items_destroyed (ReparentTagCommand* self,
                                              GeeCollection* destroyed);
static void _reparent_tag_command_on_items_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                                 GeeCollection* destroyed,
                                                                                 gpointer self);
VALA_EXTERN ReparentTagCommand* reparent_tag_command_new (Tag* tag,
                                              const gchar* new_parent_path);
VALA_EXTERN ReparentTagCommand* reparent_tag_command_construct (GType object_type,
                                                    Tag* tag,
                                                    const gchar* new_parent_path);
VALA_EXTERN gchar* tag_get_path (Tag* self);
VALA_EXTERN gchar* hierarchical_tag_utilities_get_root_path_form (const gchar* client_path);
VALA_EXTERN gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
VALA_EXTERN GeeCollection* tag_get_sources (Tag* self);
static GeeMap* reparent_tag_command_get_child_structure_at (ReparentTagCommand* self,
                                                     const gchar* client_path);
static void reparent_tag_command_restore_child_attachments_at (ReparentTagCommand* self,
                                                        const gchar* client_path,
                                                        GeeMap* child_structure);
VALA_EXTERN void tag_promote (Tag* self);
VALA_EXTERN void tag_attach (Tag* self,
                 MediaSource* source);
static void reparent_tag_command_reattach_in_play_sources_at (ReparentTagCommand* self,
                                                       const gchar* client_path);
static void reparent_tag_command_save_before_state (ReparentTagCommand* self);
static void reparent_tag_command_restore_before_state (ReparentTagCommand* self);
VALA_EXTERN GeeList* tag_detach (Tag* self,
                     MediaSource* source);
static void reparent_tag_command_save_after_state (ReparentTagCommand* self);
static void reparent_tag_command_restore_after_state (ReparentTagCommand* self);
static void reparent_tag_command_prepare_parent (ReparentTagCommand* self,
                                          const gchar* path);
static void reparent_tag_command_do_source_parent_detachments (ReparentTagCommand* self);
VALA_EXTERN Tag* tag_get_hierarchical_parent (Tag* self);
VALA_EXTERN gint tag_get_attachment_count (Tag* self,
                               MediaSource* source);
static void reparent_tag_command_do_source_parent_reattachments (ReparentTagCommand* self);
static void reparent_tag_command_do_destination_parent_detachments (ReparentTagCommand* self);
static void reparent_tag_command_do_destination_parent_reattachments (ReparentTagCommand* self);
static void reparent_tag_command_copy_subtree (ReparentTagCommand* self,
                                        const gchar* from,
                                        const gchar* to);
static void reparent_tag_command_destroy_subtree (ReparentTagCommand* self,
                                           const gchar* client_path);
static void reparent_tag_command_real_execute (Command* base);
static void reparent_tag_command_real_undo (Command* base);
VALA_EXTERN void hierarchical_tag_utilities_cleanup_root_path (const gchar* path);
static void reparent_tag_command_finalize (GObject * obj);
static GType reparent_tag_command_get_type_once (void);
VALA_EXTERN GType modify_tags_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ModifyTagsCommand, g_object_unref)
static void modify_tags_command_on_proxy_broken (ModifyTagsCommand* self);
static void _modify_tags_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                               gpointer self);
VALA_EXTERN ModifyTagsCommand* modify_tags_command_new (MediaSource* media,
                                            GeeCollection* new_tag_list);
VALA_EXTERN ModifyTagsCommand* modify_tags_command_construct (GType object_type,
                                                  MediaSource* media,
                                                  GeeCollection* new_tag_list);
VALA_EXTERN GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
static void modify_tags_command_real_execute (Command* base);
static void modify_tags_command_real_undo (Command* base);
static void modify_tags_command_finalize (GObject * obj);
static GType modify_tags_command_get_type_once (void);
VALA_EXTERN GType tag_untag_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagUntagPhotosCommand, g_object_unref)
static void tag_untag_photos_command_on_source_destroyed (TagUntagPhotosCommand* self,
                                                   DataSource* source);
static void _tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                     DataSource* source,
                                                                                     gpointer self);
VALA_EXTERN TagUntagPhotosCommand* tag_untag_photos_command_new (Tag* tag,
                                                     GeeCollection* sources,
                                                     gint count,
                                                     gboolean attach);
VALA_EXTERN TagUntagPhotosCommand* tag_untag_photos_command_construct (GType object_type,
                                                           Tag* tag,
                                                           GeeCollection* sources,
                                                           gint count,
                                                           gboolean attach);
VALA_EXTERN gchar* resources_tag_photos_label (const gchar* name,
                                   gint count);
VALA_EXTERN gchar* resources_untag_photos_label (const gchar* name,
                                     gint count);
static void tag_untag_photos_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                      DataSource* source);
static void tag_untag_photos_command_do_attach (TagUntagPhotosCommand* self,
                                         Tag* tag);
static void tag_untag_photos_command_do_detach (TagUntagPhotosCommand* self,
                                         Tag* tag);
static void tag_untag_photos_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                   DataSource* source);
VALA_EXTERN gchar* data_object_to_string (DataObject* self);
static void tag_untag_photos_command_finalize (GObject * obj);
static GType tag_untag_photos_command_get_type_once (void);
VALA_EXTERN GType rename_saved_search_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RenameSavedSearchCommand, g_object_unref)
VALA_EXTERN GType saved_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearch, g_object_unref)
VALA_EXTERN RenameSavedSearchCommand* rename_saved_search_command_new (SavedSearch* search,
                                                           const gchar* new_name);
VALA_EXTERN RenameSavedSearchCommand* rename_saved_search_command_construct (GType object_type,
                                                                 SavedSearch* search,
                                                                 const gchar* new_name);
VALA_EXTERN gchar* resources_rename_search_label (const gchar* old_name,
                                      const gchar* new_name);
static void rename_saved_search_command_real_execute (Command* base);
VALA_EXTERN gboolean saved_search_rename (SavedSearch* self,
                              const gchar* new_name);
VALA_EXTERN gchar* resources_rename_search_exists_message (const gchar* name);
static void rename_saved_search_command_real_undo (Command* base);
static void rename_saved_search_command_finalize (GObject * obj);
static GType rename_saved_search_command_get_type_once (void);
VALA_EXTERN GType delete_saved_search_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteSavedSearchCommand, g_object_unref)
VALA_EXTERN DeleteSavedSearchCommand* delete_saved_search_command_new (SavedSearch* search);
VALA_EXTERN DeleteSavedSearchCommand* delete_saved_search_command_construct (GType object_type,
                                                                 SavedSearch* search);
VALA_EXTERN gchar* resources_delete_search_label (const gchar* name);
static void delete_saved_search_command_real_execute (Command* base);
VALA_EXTERN gpointer saved_search_table_ref (gpointer instance);
VALA_EXTERN void saved_search_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_saved_search_table (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_saved_search_table (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_saved_search_table (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_saved_search_table (const GValue* value);
VALA_EXTERN GType saved_search_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SavedSearchTable, saved_search_table_unref)
VALA_EXTERN SavedSearchTable* saved_search_table_get_instance (void);
VALA_EXTERN void saved_search_table_remove (SavedSearchTable* self,
                                SavedSearch* search);
static void delete_saved_search_command_real_undo (Command* base);
VALA_EXTERN void saved_search_reconstitute (SavedSearch* self);
static void delete_saved_search_command_finalize (GObject * obj);
static GType delete_saved_search_command_get_type_once (void);
VALA_EXTERN GType trash_untrash_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TrashUntrashPhotosCommand, g_object_unref)
static void trash_untrash_photos_command_on_photo_destroyed (TrashUntrashPhotosCommand* self,
                                                      DataSource* source);
static void _trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                        DataSource* source,
                                                                                        gpointer self);
VALA_EXTERN TrashUntrashPhotosCommand* trash_untrash_photos_command_new (GeeCollection* sources,
                                                             gboolean to_trash);
VALA_EXTERN TrashUntrashPhotosCommand* trash_untrash_photos_command_construct (GType object_type,
                                                                   GeeCollection* sources,
                                                                   gboolean to_trash);
static ProgressDialog* trash_untrash_photos_command_get_progress_dialog (TrashUntrashPhotosCommand* self,
                                                                  gboolean to_trash);
VALA_EXTERN void progress_dialog_update_display_every (ProgressDialog* self,
                                           gint update_every);
static void trash_untrash_photos_command_real_execute (Command* base);
VALA_EXTERN gboolean progress_dialog_monitor (ProgressDialog* self,
                                  guint64 count,
                                  guint64 total,
                                  gboolean do_event_loop);
static gboolean _progress_dialog_monitor_progress_monitor (guint64 current,
                                                    guint64 total,
                                                    gboolean do_event_loop,
                                                    gpointer self);
static void trash_untrash_photos_command_trash (TrashUntrashPhotosCommand* self,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
static void trash_untrash_photos_command_untrash (TrashUntrashPhotosCommand* self,
                                           ProgressMonitor monitor,
                                           gpointer monitor_target);
static void trash_untrash_photos_command_real_undo (Command* base);
VALA_EXTERN void media_source_trash (MediaSource* self);
VALA_EXTERN void media_source_untrash (MediaSource* self);
static void trash_untrash_photos_command_finalize (GObject * obj);
static GType trash_untrash_photos_command_get_type_once (void);
VALA_EXTERN GType flag_unflag_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FlagUnflagCommand, g_object_unref)
VALA_EXTERN FlagUnflagCommand* flag_unflag_command_new (GeeCollection* sources,
                                            gboolean flag);
VALA_EXTERN FlagUnflagCommand* flag_unflag_command_construct (GType object_type,
                                                  GeeCollection* sources,
                                                  gboolean flag);
static void flag_unflag_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                              GeeCollection* sources);
static void flag_unflag_command_flag_unflag (FlagUnflagCommand* self,
                                      DataSource* source,
                                      gboolean flag);
static void flag_unflag_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                           GeeCollection* sources);
VALA_EXTERN GType flaggable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Flaggable, g_object_unref)
VALA_EXTERN void flaggable_mark_flagged (Flaggable* self);
VALA_EXTERN void flaggable_mark_unflagged (Flaggable* self);
static void flag_unflag_command_finalize (GObject * obj);
static GType flag_unflag_command_get_type_once (void);
VALA_EXTERN GType remove_faces_from_photos_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RemoveFacesFromPhotosCommand, g_object_unref)
static void remove_faces_from_photos_command_on_source_destroyed (RemoveFacesFromPhotosCommand* self,
                                                           DataSource* source);
static void _remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                             DataSource* source,
                                                                                             gpointer self);
VALA_EXTERN GType face_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Face, g_object_unref)
VALA_EXTERN RemoveFacesFromPhotosCommand* remove_faces_from_photos_command_new (Face* face,
                                                                    GeeCollection* sources);
VALA_EXTERN RemoveFacesFromPhotosCommand* remove_faces_from_photos_command_construct (GType object_type,
                                                                          Face* face,
                                                                          GeeCollection* sources);
VALA_EXTERN gchar* resources_remove_face_from_photos_label (const gchar* name,
                                                gint count);
VALA_EXTERN GType face_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceLocation, g_object_unref)
VALA_EXTERN GType face_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceID* face_id_dup (const FaceID* self);
VALA_EXTERN void face_id_free (FaceID* self);
VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN FaceLocation* face_location_get_face_location (FaceID* face_id,
                                               PhotoID* photo_id);
VALA_EXTERN void face_get_face_id (Face* self,
                       FaceID* result);
VALA_EXTERN void photo_get_photo_id (Photo* self,
                         PhotoID* result);
VALA_EXTERN gchar* face_location_get_serialized_geometry (FaceLocation* self);
static void remove_faces_from_photos_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                              DataSource* source);
VALA_EXTERN gint face_detach_many (Face* self,
                       GeeCollection* sources);
static void remove_faces_from_photos_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                           DataSource* source);
VALA_EXTERN void face_attach_many (Face* self,
                       GeeCollection* sources);
VALA_EXTERN GType face_location_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FaceLocationData* face_location_data_dup (const FaceLocationData* self);
VALA_EXTERN void face_location_data_free (FaceLocationData* self);
VALA_EXTERN void face_location_data_copy (const FaceLocationData* self,
                              FaceLocationData* dest);
VALA_EXTERN void face_location_data_destroy (FaceLocationData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FaceLocationData, face_location_data_destroy)
VALA_EXTERN FaceLocation* face_location_create (FaceID* face_id,
                                    PhotoID* photo_id,
                                    FaceLocationData* face_data);
static void remove_faces_from_photos_command_finalize (GObject * obj);
static GType remove_faces_from_photos_command_get_type_once (void);
VALA_EXTERN GType rename_face_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RenameFaceCommand, g_object_unref)
VALA_EXTERN RenameFaceCommand* rename_face_command_new (Face* face,
                                            const gchar* new_name);
VALA_EXTERN RenameFaceCommand* rename_face_command_construct (GType object_type,
                                                  Face* face,
                                                  const gchar* new_name);
VALA_EXTERN gchar* resources_rename_face_label (const gchar* old_name,
                                    const gchar* new_name);
static void rename_face_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                 DataSource* source);
VALA_EXTERN gboolean face_rename (Face* self,
                      const gchar* name);
VALA_EXTERN gchar* resources_rename_face_exists_message (const gchar* name);
static void rename_face_command_real_undo_on_source (SimpleProxyableCommand* base,
                                              DataSource* source);
static void rename_face_command_finalize (GObject * obj);
static GType rename_face_command_get_type_once (void);
VALA_EXTERN GType set_face_ref_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SetFaceRefCommand, g_object_unref)
VALA_EXTERN SetFaceRefCommand* set_face_ref_command_new (Face* face,
                                             MediaSource* source);
VALA_EXTERN SetFaceRefCommand* set_face_ref_command_construct (GType object_type,
                                                   Face* face,
                                                   MediaSource* source);
VALA_EXTERN gchar* resources_set_face_from_photo_label (const gchar* name);
VALA_EXTERN GeeMap* face_location_get_locations_by_photo (Photo* photo);
static void set_face_ref_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                  DataSource* source);
VALA_EXTERN gboolean face_set_reference (Face* self,
                             FaceLocation* face_loc);
VALA_EXTERN gchar* resources_set_face_from_photo_error (void);
static void set_face_ref_command_real_undo_on_source (SimpleProxyableCommand* base,
                                               DataSource* source);
static void set_face_ref_command_finalize (GObject * obj);
static GType set_face_ref_command_get_type_once (void);
VALA_EXTERN GType delete_face_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteFaceCommand, g_object_unref)
VALA_EXTERN guint face_location_photo_id_hash (void* p);
VALA_EXTERN gboolean face_location_photo_ids_equal (void* a,
                                        void* b);
VALA_EXTERN DeleteFaceCommand* delete_face_command_new (Face* face);
VALA_EXTERN DeleteFaceCommand* delete_face_command_construct (GType object_type,
                                                  Face* face);
VALA_EXTERN gchar* resources_delete_face_label (const gchar* name);
VALA_EXTERN GeeMap* face_location_get_locations_by_face (Face* face);
static void delete_face_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                 DataSource* source);
VALA_EXTERN void face_location_destroy (FaceID* face_id,
                            PhotoID* photo_id);
VALA_EXTERN GType face_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FaceSourceCollection, data_collection_unref)
static void delete_face_command_real_undo_on_source (SimpleProxyableCommand* base,
                                              DataSource* source);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
VALA_EXTERN void face_attach (Face* self,
                  MediaSource* source);
static void delete_face_command_finalize (GObject * obj);
static GType delete_face_command_get_type_once (void);
VALA_EXTERN GType modify_faces_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ModifyFacesCommand, g_object_unref)
static void modify_faces_command_on_proxy_broken (ModifyFacesCommand* self);
static void _modify_faces_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                                gpointer self);
VALA_EXTERN ModifyFacesCommand* modify_faces_command_new (MediaSource* media,
                                              GeeMap* new_face_list);
VALA_EXTERN ModifyFacesCommand* modify_faces_command_construct (GType object_type,
                                                    MediaSource* media,
                                                    GeeMap* new_face_list);
VALA_EXTERN GeeList* face_source_collection_fetch_for_source (FaceSourceCollection* self,
                                                  MediaSource* source);
VALA_EXTERN void face_location_get_face_data (FaceLocation* self,
                                  FaceLocationData* result);
static void modify_faces_command_real_execute (Command* base);
VALA_EXTERN gboolean face_detach (Face* self,
                      MediaSource* source);
static void modify_faces_command_real_undo (Command* base);
static void modify_faces_command_finalize (GObject * obj);
static GType modify_faces_command_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
page_command_get_instance_private (PageCommand* self)
{
	return G_STRUCT_MEMBER_P (self, PageCommand_private_offset);
}

static void
_page_command_on_page_destroyed_gtk_widget_destroy (GtkWidget* _sender,
                                                    gpointer self)
{
#line 45 "../src/Commands.vala"
	page_command_on_page_destroyed ((PageCommand*) self);
#line 3780 "Commands.c"
}

static void
_page_command_on_photo_destroyed_data_source_destroyed (DataSource* _sender,
                                                        gpointer self)
{
#line 48 "../src/Commands.vala"
	page_command_on_photo_destroyed ((PageCommand*) self);
#line 3789 "Commands.c"
}

static void
_page_command_on_controller_destroyed_gtk_widget_destroy (GtkWidget* _sender,
                                                          gpointer self)
{
#line 51 "../src/Commands.vala"
	page_command_on_controller_destroyed ((PageCommand*) self);
#line 3798 "Commands.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/Commands.vala"
	return self ? g_object_ref (self) : NULL;
#line 3806 "Commands.c"
}

PageCommand*
page_command_construct (GType object_type,
                        const gchar* name,
                        const gchar* explanation)
{
	PageCommand * self = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
#line 15 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 15 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 16 "../src/Commands.vala"
	self = (PageCommand*) command_construct (object_type, name, explanation);
#line 18 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 18 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 18 "../src/Commands.vala"
	_tmp2_ = page_window_get_current_page (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 18 "../src/Commands.vala"
	_g_object_unref0 (self->priv->page);
#line 18 "../src/Commands.vala"
	self->priv->page = _tmp2_;
#line 18 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 20 "../src/Commands.vala"
	_tmp3_ = self->priv->page;
#line 20 "../src/Commands.vala"
	if (_tmp3_ != NULL) {
#line 3841 "Commands.c"
		Page* _tmp4_;
		LibraryPhotoPage* photo_page = NULL;
		Page* _tmp5_;
		LibraryPhotoPage* _tmp6_;
		LibraryPhotoPage* _tmp7_;
#line 21 "../src/Commands.vala"
		_tmp4_ = self->priv->page;
#line 21 "../src/Commands.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), "destroy", (GCallback) _page_command_on_page_destroyed_gtk_widget_destroy, self, 0);
#line 27 "../src/Commands.vala"
		_tmp5_ = self->priv->page;
#line 27 "../src/Commands.vala"
		_tmp6_ = _g_object_ref0 (IS_LIBRARY_PHOTO_PAGE (_tmp5_) ? ((LibraryPhotoPage*) _tmp5_) : NULL);
#line 27 "../src/Commands.vala"
		photo_page = _tmp6_;
#line 28 "../src/Commands.vala"
		_tmp7_ = photo_page;
#line 28 "../src/Commands.vala"
		if (_tmp7_ != NULL) {
#line 3861 "Commands.c"
			LibraryPhotoPage* _tmp8_;
			Photo* _tmp9_;
			LibraryPhotoPage* _tmp10_;
			CollectionPage* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Photo* _tmp13_;
#line 29 "../src/Commands.vala"
			_tmp8_ = photo_page;
#line 29 "../src/Commands.vala"
			_tmp9_ = editing_host_page_get_photo (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_EDITING_HOST_PAGE, EditingHostPage));
#line 29 "../src/Commands.vala"
			_g_object_unref0 (self->priv->library_photo);
#line 29 "../src/Commands.vala"
			self->priv->library_photo = _tmp9_;
#line 30 "../src/Commands.vala"
			_tmp10_ = photo_page;
#line 30 "../src/Commands.vala"
			_tmp11_ = library_photo_page_get_controller_page (_tmp10_);
#line 30 "../src/Commands.vala"
			_g_object_unref0 (self->priv->collection_page);
#line 30 "../src/Commands.vala"
			self->priv->collection_page = _tmp11_;
#line 32 "../src/Commands.vala"
			_tmp13_ = self->priv->library_photo;
#line 32 "../src/Commands.vala"
			if (_tmp13_ != NULL) {
#line 3888 "Commands.c"
				CollectionPage* _tmp14_;
#line 32 "../src/Commands.vala"
				_tmp14_ = self->priv->collection_page;
#line 32 "../src/Commands.vala"
				_tmp12_ = _tmp14_ != NULL;
#line 3894 "Commands.c"
			} else {
#line 32 "../src/Commands.vala"
				_tmp12_ = FALSE;
#line 3898 "Commands.c"
			}
#line 32 "../src/Commands.vala"
			if (_tmp12_) {
#line 3902 "Commands.c"
				Photo* _tmp15_;
				CollectionPage* _tmp16_;
#line 33 "../src/Commands.vala"
				_tmp15_ = self->priv->library_photo;
#line 33 "../src/Commands.vala"
				g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_DATA_SOURCE, DataSource), "destroyed", (GCallback) _page_command_on_photo_destroyed_data_source_destroyed, self, 0);
#line 34 "../src/Commands.vala"
				_tmp16_ = self->priv->collection_page;
#line 34 "../src/Commands.vala"
				g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), "destroy", (GCallback) _page_command_on_controller_destroyed_gtk_widget_destroy, self, 0);
#line 3913 "Commands.c"
			} else {
#line 36 "../src/Commands.vala"
				_g_object_unref0 (self->priv->library_photo);
#line 36 "../src/Commands.vala"
				self->priv->library_photo = NULL;
#line 37 "../src/Commands.vala"
				_g_object_unref0 (self->priv->collection_page);
#line 37 "../src/Commands.vala"
				self->priv->collection_page = NULL;
#line 3923 "Commands.c"
			}
		}
#line 20 "../src/Commands.vala"
		_g_object_unref0 (photo_page);
#line 3928 "Commands.c"
	}
#line 15 "../src/Commands.vala"
	return self;
#line 3932 "Commands.c"
}

void
page_command_set_auto_return_to_page (PageCommand* self,
                                      gboolean auto_return)
{
#line 54 "../src/Commands.vala"
	g_return_if_fail (IS_PAGE_COMMAND (self));
#line 55 "../src/Commands.vala"
	self->priv->auto_return = auto_return;
#line 3943 "Commands.c"
}

static void
page_command_real_prepare (Command* base)
{
	PageCommand * self;
#line 58 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PAGE_COMMAND, PageCommand);
#line 59 "../src/Commands.vala"
	if (self->priv->auto_return) {
#line 60 "../src/Commands.vala"
		page_command_return_to_page (self);
#line 3956 "Commands.c"
	}
#line 62 "../src/Commands.vala"
	COMMAND_CLASS (page_command_parent_class)->prepare (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 3960 "Commands.c"
}

void
page_command_return_to_page (PageCommand* self)
{
	LibraryPhotoPage* photo_page = NULL;
	Page* _tmp0_;
	LibraryPhotoPage* _tmp1_;
	LibraryPhotoPage* _tmp2_;
#line 65 "../src/Commands.vala"
	g_return_if_fail (IS_PAGE_COMMAND (self));
#line 66 "../src/Commands.vala"
	_tmp0_ = self->priv->page;
#line 66 "../src/Commands.vala"
	_tmp1_ = _g_object_ref0 (IS_LIBRARY_PHOTO_PAGE (_tmp0_) ? ((LibraryPhotoPage*) _tmp0_) : NULL);
#line 66 "../src/Commands.vala"
	photo_page = _tmp1_;
#line 68 "../src/Commands.vala"
	_tmp2_ = photo_page;
#line 68 "../src/Commands.vala"
	if (_tmp2_ != NULL) {
#line 3982 "Commands.c"
		gboolean _tmp3_ = FALSE;
		Photo* _tmp4_;
#line 69 "../src/Commands.vala"
		_tmp4_ = self->priv->library_photo;
#line 69 "../src/Commands.vala"
		if (_tmp4_ != NULL) {
#line 3989 "Commands.c"
			CollectionPage* _tmp5_;
#line 69 "../src/Commands.vala"
			_tmp5_ = self->priv->collection_page;
#line 69 "../src/Commands.vala"
			_tmp3_ = _tmp5_ != NULL;
#line 3995 "Commands.c"
		} else {
#line 69 "../src/Commands.vala"
			_tmp3_ = FALSE;
#line 3999 "Commands.c"
		}
#line 69 "../src/Commands.vala"
		if (_tmp3_) {
#line 4003 "Commands.c"
			gboolean photo_in_collection = FALSE;
			gint count = 0;
			CollectionPage* _tmp6_;
			ViewCollection* _tmp7_;
			ViewCollection* _tmp8_;
			gint _tmp9_;
#line 70 "../src/Commands.vala"
			photo_in_collection = FALSE;
#line 71 "../src/Commands.vala"
			_tmp6_ = self->priv->collection_page;
#line 71 "../src/Commands.vala"
			_tmp7_ = page_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PAGE, Page));
#line 71 "../src/Commands.vala"
			_tmp8_ = _tmp7_;
#line 71 "../src/Commands.vala"
			_tmp9_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_COLLECTION, DataCollection));
#line 71 "../src/Commands.vala"
			_data_collection_unref0 (_tmp8_);
#line 71 "../src/Commands.vala"
			count = _tmp9_;
#line 4024 "Commands.c"
			{
				gint i = 0;
#line 72 "../src/Commands.vala"
				i = 0;
#line 4029 "Commands.c"
				{
					gboolean _tmp10_ = FALSE;
#line 72 "../src/Commands.vala"
					_tmp10_ = TRUE;
#line 72 "../src/Commands.vala"
					while (TRUE) {
#line 4036 "Commands.c"
						CollectionPage* _tmp12_;
						ViewCollection* _tmp13_;
						ViewCollection* _tmp14_;
						DataObject* _tmp15_;
						Thumbnail* _tmp16_;
						MediaSource* _tmp17_;
						MediaSource* _tmp18_;
						Photo* _tmp19_;
						gboolean _tmp20_;
#line 72 "../src/Commands.vala"
						if (!_tmp10_) {
#line 4048 "Commands.c"
							gint _tmp11_;
#line 72 "../src/Commands.vala"
							_tmp11_ = i;
#line 72 "../src/Commands.vala"
							i = _tmp11_ + 1;
#line 4054 "Commands.c"
						}
#line 72 "../src/Commands.vala"
						_tmp10_ = FALSE;
#line 72 "../src/Commands.vala"
						if (!(i < count)) {
#line 72 "../src/Commands.vala"
							break;
#line 4062 "Commands.c"
						}
#line 73 "../src/Commands.vala"
						_tmp12_ = self->priv->collection_page;
#line 73 "../src/Commands.vala"
						_tmp13_ = page_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PAGE, Page));
#line 73 "../src/Commands.vala"
						_tmp14_ = _tmp13_;
#line 73 "../src/Commands.vala"
						_tmp15_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_DATA_COLLECTION, DataCollection), i);
#line 73 "../src/Commands.vala"
						_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_THUMBNAIL, Thumbnail);
#line 73 "../src/Commands.vala"
						_tmp17_ = thumbnail_get_media_source (_tmp16_);
#line 73 "../src/Commands.vala"
						_tmp18_ = _tmp17_;
#line 73 "../src/Commands.vala"
						_tmp19_ = self->priv->library_photo;
#line 73 "../src/Commands.vala"
						_tmp20_ = _tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_MEDIA_SOURCE, MediaSource);
#line 73 "../src/Commands.vala"
						_g_object_unref0 (_tmp18_);
#line 73 "../src/Commands.vala"
						_g_object_unref0 (_tmp16_);
#line 73 "../src/Commands.vala"
						_data_collection_unref0 (_tmp14_);
#line 73 "../src/Commands.vala"
						if (_tmp20_) {
#line 74 "../src/Commands.vala"
							photo_in_collection = TRUE;
#line 75 "../src/Commands.vala"
							break;
#line 4094 "Commands.c"
						}
					}
				}
			}
#line 79 "../src/Commands.vala"
			if (photo_in_collection) {
#line 4101 "Commands.c"
				LibraryWindow* _tmp21_;
				LibraryWindow* _tmp22_;
				CollectionPage* _tmp23_;
				Photo* _tmp24_;
#line 80 "../src/Commands.vala"
				_tmp21_ = library_window_get_app ();
#line 80 "../src/Commands.vala"
				_tmp22_ = _tmp21_;
#line 80 "../src/Commands.vala"
				_tmp23_ = self->priv->collection_page;
#line 80 "../src/Commands.vala"
				_tmp24_ = self->priv->library_photo;
#line 80 "../src/Commands.vala"
				library_window_switch_to_photo_page (_tmp22_, _tmp23_, _tmp24_);
#line 80 "../src/Commands.vala"
				_g_object_unref0 (_tmp22_);
#line 4118 "Commands.c"
			}
		}
	} else {
		Page* _tmp25_;
#line 82 "../src/Commands.vala"
		_tmp25_ = self->priv->page;
#line 82 "../src/Commands.vala"
		if (_tmp25_ != NULL) {
#line 4127 "Commands.c"
			AppWindow* _tmp26_;
			AppWindow* _tmp27_;
			Page* _tmp28_;
#line 83 "../src/Commands.vala"
			_tmp26_ = app_window_get_instance ();
#line 83 "../src/Commands.vala"
			_tmp27_ = _tmp26_;
#line 83 "../src/Commands.vala"
			_tmp28_ = self->priv->page;
#line 83 "../src/Commands.vala"
			page_window_set_current_page (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_PAGE_WINDOW, PageWindow), _tmp28_);
#line 83 "../src/Commands.vala"
			_g_object_unref0 (_tmp27_);
#line 4141 "Commands.c"
		}
	}
#line 65 "../src/Commands.vala"
	_g_object_unref0 (photo_page);
#line 4146 "Commands.c"
}

static void
page_command_on_page_destroyed (PageCommand* self)
{
	Page* _tmp0_;
	guint _tmp1_;
#line 86 "../src/Commands.vala"
	g_return_if_fail (IS_PAGE_COMMAND (self));
#line 87 "../src/Commands.vala"
	_tmp0_ = self->priv->page;
#line 87 "../src/Commands.vala"
	g_signal_parse_name ("destroy", gtk_widget_get_type (), &_tmp1_, NULL, FALSE);
#line 87 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_command_on_page_destroyed_gtk_widget_destroy, self);
#line 88 "../src/Commands.vala"
	_g_object_unref0 (self->priv->page);
#line 88 "../src/Commands.vala"
	self->priv->page = NULL;
#line 4166 "Commands.c"
}

static void
page_command_on_photo_destroyed (PageCommand* self)
{
	Photo* _tmp0_;
	guint _tmp1_;
#line 91 "../src/Commands.vala"
	g_return_if_fail (IS_PAGE_COMMAND (self));
#line 92 "../src/Commands.vala"
	_tmp0_ = self->priv->library_photo;
#line 92 "../src/Commands.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp1_, NULL, FALSE);
#line 92 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_SOURCE, DataSource), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_command_on_photo_destroyed_data_source_destroyed, self);
#line 93 "../src/Commands.vala"
	_g_object_unref0 (self->priv->library_photo);
#line 93 "../src/Commands.vala"
	self->priv->library_photo = NULL;
#line 4186 "Commands.c"
}

static void
page_command_on_controller_destroyed (PageCommand* self)
{
	CollectionPage* _tmp0_;
	guint _tmp1_;
#line 96 "../src/Commands.vala"
	g_return_if_fail (IS_PAGE_COMMAND (self));
#line 97 "../src/Commands.vala"
	_tmp0_ = self->priv->collection_page;
#line 97 "../src/Commands.vala"
	g_signal_parse_name ("destroy", gtk_widget_get_type (), &_tmp1_, NULL, FALSE);
#line 97 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_command_on_controller_destroyed_gtk_widget_destroy, self);
#line 98 "../src/Commands.vala"
	_g_object_unref0 (self->priv->collection_page);
#line 98 "../src/Commands.vala"
	self->priv->collection_page = NULL;
#line 4206 "Commands.c"
}

static void
page_command_class_init (PageCommandClass * klass,
                         gpointer klass_data)
{
#line 9 "../src/Commands.vala"
	page_command_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &PageCommand_private_offset);
#line 9 "../src/Commands.vala"
	((CommandClass *) klass)->prepare = (void (*) (Command*)) page_command_real_prepare;
#line 9 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = page_command_finalize;
#line 4221 "Commands.c"
}

static void
page_command_instance_init (PageCommand * self,
                            gpointer klass)
{
#line 9 "../src/Commands.vala"
	self->priv = page_command_get_instance_private (self);
#line 11 "../src/Commands.vala"
	self->priv->auto_return = TRUE;
#line 12 "../src/Commands.vala"
	self->priv->library_photo = NULL;
#line 13 "../src/Commands.vala"
	self->priv->collection_page = NULL;
#line 4236 "Commands.c"
}

static void
page_command_finalize (GObject * obj)
{
	PageCommand * self;
	Page* _tmp0_;
	Photo* _tmp3_;
	CollectionPage* _tmp6_;
#line 9 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_COMMAND, PageCommand);
#line 44 "../src/Commands.vala"
	_tmp0_ = self->priv->page;
#line 44 "../src/Commands.vala"
	if (_tmp0_ != NULL) {
#line 4252 "Commands.c"
		Page* _tmp1_;
		guint _tmp2_;
#line 45 "../src/Commands.vala"
		_tmp1_ = self->priv->page;
#line 45 "../src/Commands.vala"
		g_signal_parse_name ("destroy", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 45 "../src/Commands.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _page_command_on_page_destroyed_gtk_widget_destroy, self);
#line 4261 "Commands.c"
	}
#line 47 "../src/Commands.vala"
	_tmp3_ = self->priv->library_photo;
#line 47 "../src/Commands.vala"
	if (_tmp3_ != NULL) {
#line 4267 "Commands.c"
		Photo* _tmp4_;
		guint _tmp5_;
#line 48 "../src/Commands.vala"
		_tmp4_ = self->priv->library_photo;
#line 48 "../src/Commands.vala"
		g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp5_, NULL, FALSE);
#line 48 "../src/Commands.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_SOURCE, DataSource), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_command_on_photo_destroyed_data_source_destroyed, self);
#line 4276 "Commands.c"
	}
#line 50 "../src/Commands.vala"
	_tmp6_ = self->priv->collection_page;
#line 50 "../src/Commands.vala"
	if (_tmp6_ != NULL) {
#line 4282 "Commands.c"
		CollectionPage* _tmp7_;
		guint _tmp8_;
#line 51 "../src/Commands.vala"
		_tmp7_ = self->priv->collection_page;
#line 51 "../src/Commands.vala"
		g_signal_parse_name ("destroy", gtk_widget_get_type (), &_tmp8_, NULL, FALSE);
#line 51 "../src/Commands.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _page_command_on_controller_destroyed_gtk_widget_destroy, self);
#line 4291 "Commands.c"
	}
#line 10 "../src/Commands.vala"
	_g_object_unref0 (self->priv->page);
#line 12 "../src/Commands.vala"
	_g_object_unref0 (self->priv->library_photo);
#line 13 "../src/Commands.vala"
	_g_object_unref0 (self->priv->collection_page);
#line 9 "../src/Commands.vala"
	G_OBJECT_CLASS (page_command_parent_class)->finalize (obj);
#line 4301 "Commands.c"
}

static GType
page_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PageCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageCommand), 0, (GInstanceInitFunc) page_command_instance_init, NULL };
	GType page_command_type_id;
	page_command_type_id = g_type_register_static (TYPE_COMMAND, "PageCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PageCommand_private_offset = g_type_add_instance_private (page_command_type_id, sizeof (PageCommandPrivate));
	return page_command_type_id;
}

GType
page_command_get_type (void)
{
	static volatile gsize page_command_type_id__once = 0;
	if (g_once_init_enter (&page_command_type_id__once)) {
		GType page_command_type_id;
		page_command_type_id = page_command_get_type_once ();
		g_once_init_leave (&page_command_type_id__once, page_command_type_id);
	}
	return page_command_type_id__once;
}

static void
_single_data_source_command_on_source_destroyed_data_source_destroyed (DataSource* _sender,
                                                                       gpointer self)
{
#line 115 "../src/Commands.vala"
	single_data_source_command_on_source_destroyed ((SingleDataSourceCommand*) self);
#line 4332 "Commands.c"
}

SingleDataSourceCommand*
single_data_source_command_construct (GType object_type,
                                      DataSource* source,
                                      const gchar* name,
                                      const gchar* explanation)
{
	SingleDataSourceCommand * self = NULL;
	DataSource* _tmp0_;
#line 106 "../src/Commands.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 106 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 106 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 107 "../src/Commands.vala"
	self = (SingleDataSourceCommand*) page_command_construct (object_type, name, explanation);
#line 109 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 109 "../src/Commands.vala"
	_g_object_unref0 (self->source);
#line 109 "../src/Commands.vala"
	self->source = _tmp0_;
#line 111 "../src/Commands.vala"
	g_signal_connect_object (source, "destroyed", (GCallback) _single_data_source_command_on_source_destroyed_data_source_destroyed, self, 0);
#line 106 "../src/Commands.vala"
	return self;
#line 4361 "Commands.c"
}

DataSource*
single_data_source_command_get_source (SingleDataSourceCommand* self)
{
	DataSource* _tmp0_;
	DataSource* _tmp1_;
	DataSource* result;
#line 118 "../src/Commands.vala"
	g_return_val_if_fail (IS_SINGLE_DATA_SOURCE_COMMAND (self), NULL);
#line 119 "../src/Commands.vala"
	_tmp0_ = self->source;
#line 119 "../src/Commands.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 119 "../src/Commands.vala"
	result = _tmp1_;
#line 119 "../src/Commands.vala"
	return result;
#line 4380 "Commands.c"
}

static void
single_data_source_command_on_source_destroyed (SingleDataSourceCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 122 "../src/Commands.vala"
	g_return_if_fail (IS_SINGLE_DATA_SOURCE_COMMAND (self));
#line 125 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 125 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 125 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 4398 "Commands.c"
}

static void
single_data_source_command_class_init (SingleDataSourceCommandClass * klass,
                                       gpointer klass_data)
{
#line 103 "../src/Commands.vala"
	single_data_source_command_parent_class = g_type_class_peek_parent (klass);
#line 103 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = single_data_source_command_finalize;
#line 4409 "Commands.c"
}

static void
single_data_source_command_instance_init (SingleDataSourceCommand * self,
                                          gpointer klass)
{
}

static void
single_data_source_command_finalize (GObject * obj)
{
	SingleDataSourceCommand * self;
	DataSource* _tmp0_;
	guint _tmp1_;
#line 103 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand);
#line 115 "../src/Commands.vala"
	_tmp0_ = self->source;
#line 115 "../src/Commands.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp1_, NULL, FALSE);
#line 115 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _single_data_source_command_on_source_destroyed_data_source_destroyed, self);
#line 104 "../src/Commands.vala"
	_g_object_unref0 (self->source);
#line 103 "../src/Commands.vala"
	G_OBJECT_CLASS (single_data_source_command_parent_class)->finalize (obj);
#line 4436 "Commands.c"
}

static GType
single_data_source_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SingleDataSourceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) single_data_source_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SingleDataSourceCommand), 0, (GInstanceInitFunc) single_data_source_command_instance_init, NULL };
	GType single_data_source_command_type_id;
	single_data_source_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "SingleDataSourceCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return single_data_source_command_type_id;
}

GType
single_data_source_command_get_type (void)
{
	static volatile gsize single_data_source_command_type_id__once = 0;
	if (g_once_init_enter (&single_data_source_command_type_id__once)) {
		GType single_data_source_command_type_id;
		single_data_source_command_type_id = single_data_source_command_get_type_once ();
		g_once_init_leave (&single_data_source_command_type_id__once, single_data_source_command_type_id);
	}
	return single_data_source_command_type_id__once;
}

static inline gpointer
simple_proxyable_command_get_instance_private (SimpleProxyableCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SimpleProxyableCommand_private_offset);
}

static void
_simple_proxyable_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                               gpointer self)
{
#line 141 "../src/Commands.vala"
	simple_proxyable_command_on_proxy_broken ((SimpleProxyableCommand*) self);
#line 4472 "Commands.c"
}

SimpleProxyableCommand*
simple_proxyable_command_construct (GType object_type,
                                    Proxyable* proxyable,
                                    const gchar* name,
                                    const gchar* explanation)
{
	SimpleProxyableCommand * self = NULL;
	SourceProxy* _tmp0_;
	SourceProxy* _tmp1_;
#line 133 "../src/Commands.vala"
	g_return_val_if_fail (IS_PROXYABLE (proxyable), NULL);
#line 133 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 133 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 134 "../src/Commands.vala"
	self = (SimpleProxyableCommand*) page_command_construct (object_type, name, explanation);
#line 136 "../src/Commands.vala"
	_tmp0_ = proxyable_get_proxy (proxyable);
#line 136 "../src/Commands.vala"
	_source_proxy_unref0 (self->priv->proxy);
#line 136 "../src/Commands.vala"
	self->priv->proxy = _tmp0_;
#line 137 "../src/Commands.vala"
	_tmp1_ = self->priv->proxy;
#line 137 "../src/Commands.vala"
	g_signal_connect_object (_tmp1_, "broken", (GCallback) _simple_proxyable_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 133 "../src/Commands.vala"
	return self;
#line 4504 "Commands.c"
}

static void
simple_proxyable_command_real_execute (Command* base)
{
	SimpleProxyableCommand * self;
	SourceProxy* _tmp0_;
	DataSource* _tmp1_;
	DataSource* _tmp2_;
#line 145 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand);
#line 146 "../src/Commands.vala"
	_tmp0_ = self->priv->proxy;
#line 146 "../src/Commands.vala"
	_tmp1_ = source_proxy_get_source (_tmp0_);
#line 146 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 146 "../src/Commands.vala"
	simple_proxyable_command_execute_on_source (self, _tmp2_);
#line 146 "../src/Commands.vala"
	_g_object_unref0 (_tmp2_);
#line 4526 "Commands.c"
}

static void
simple_proxyable_command_real_execute_on_source (SimpleProxyableCommand* self,
                                                 DataSource* source)
{
#line 149 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `simple_proxyable_command_execute_on_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 149 "../src/Commands.vala"
	return;
#line 4537 "Commands.c"
}

void
simple_proxyable_command_execute_on_source (SimpleProxyableCommand* self,
                                            DataSource* source)
{
	SimpleProxyableCommandClass* _klass_;
#line 149 "../src/Commands.vala"
	g_return_if_fail (IS_SIMPLE_PROXYABLE_COMMAND (self));
#line 149 "../src/Commands.vala"
	_klass_ = SIMPLE_PROXYABLE_COMMAND_GET_CLASS (self);
#line 149 "../src/Commands.vala"
	if (_klass_->execute_on_source) {
#line 149 "../src/Commands.vala"
		_klass_->execute_on_source (self, source);
#line 4553 "Commands.c"
	}
}

static void
simple_proxyable_command_real_undo (Command* base)
{
	SimpleProxyableCommand * self;
	SourceProxy* _tmp0_;
	DataSource* _tmp1_;
	DataSource* _tmp2_;
#line 151 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand);
#line 152 "../src/Commands.vala"
	_tmp0_ = self->priv->proxy;
#line 152 "../src/Commands.vala"
	_tmp1_ = source_proxy_get_source (_tmp0_);
#line 152 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 152 "../src/Commands.vala"
	simple_proxyable_command_undo_on_source (self, _tmp2_);
#line 152 "../src/Commands.vala"
	_g_object_unref0 (_tmp2_);
#line 4576 "Commands.c"
}

static void
simple_proxyable_command_real_undo_on_source (SimpleProxyableCommand* self,
                                              DataSource* source)
{
#line 155 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `simple_proxyable_command_undo_on_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 155 "../src/Commands.vala"
	return;
#line 4587 "Commands.c"
}

void
simple_proxyable_command_undo_on_source (SimpleProxyableCommand* self,
                                         DataSource* source)
{
	SimpleProxyableCommandClass* _klass_;
#line 155 "../src/Commands.vala"
	g_return_if_fail (IS_SIMPLE_PROXYABLE_COMMAND (self));
#line 155 "../src/Commands.vala"
	_klass_ = SIMPLE_PROXYABLE_COMMAND_GET_CLASS (self);
#line 155 "../src/Commands.vala"
	if (_klass_->undo_on_source) {
#line 155 "../src/Commands.vala"
		_klass_->undo_on_source (self, source);
#line 4603 "Commands.c"
	}
}

void
simple_proxyable_command_add_proxyables (SimpleProxyableCommand* self,
                                         GeeCollection* proxyables)
{
#line 161 "../src/Commands.vala"
	g_return_if_fail (IS_SIMPLE_PROXYABLE_COMMAND (self));
#line 161 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (proxyables, GEE_TYPE_COLLECTION));
#line 4615 "Commands.c"
	{
		GeeIterator* _proxyable_it = NULL;
		GeeIterator* _tmp0_;
#line 162 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (proxyables, GEE_TYPE_ITERABLE, GeeIterable));
#line 162 "../src/Commands.vala"
		_proxyable_it = _tmp0_;
#line 162 "../src/Commands.vala"
		while (TRUE) {
#line 4625 "Commands.c"
			GeeIterator* _tmp1_;
			Proxyable* proxyable = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			SourceProxy* added_proxy = NULL;
			Proxyable* _tmp4_;
			SourceProxy* _tmp5_;
			SourceProxy* _tmp6_;
			GeeHashSet* _tmp7_;
			SourceProxy* _tmp8_;
#line 162 "../src/Commands.vala"
			_tmp1_ = _proxyable_it;
#line 162 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 162 "../src/Commands.vala"
				break;
#line 4642 "Commands.c"
			}
#line 162 "../src/Commands.vala"
			_tmp2_ = _proxyable_it;
#line 162 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 162 "../src/Commands.vala"
			proxyable = (Proxyable*) _tmp3_;
#line 163 "../src/Commands.vala"
			_tmp4_ = proxyable;
#line 163 "../src/Commands.vala"
			_tmp5_ = proxyable_get_proxy (_tmp4_);
#line 163 "../src/Commands.vala"
			added_proxy = _tmp5_;
#line 164 "../src/Commands.vala"
			_tmp6_ = added_proxy;
#line 164 "../src/Commands.vala"
			g_signal_connect_object (_tmp6_, "broken", (GCallback) _simple_proxyable_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 165 "../src/Commands.vala"
			_tmp7_ = self->priv->proxies;
#line 165 "../src/Commands.vala"
			_tmp8_ = added_proxy;
#line 165 "../src/Commands.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 162 "../src/Commands.vala"
			_source_proxy_unref0 (added_proxy);
#line 162 "../src/Commands.vala"
			_g_object_unref0 (proxyable);
#line 4670 "Commands.c"
		}
#line 162 "../src/Commands.vala"
		_g_object_unref0 (_proxyable_it);
#line 4674 "Commands.c"
	}
}

void
simple_proxyable_command_clear_added_proxies (SimpleProxyableCommand* self)
{
	GeeHashSet* _tmp7_;
#line 170 "../src/Commands.vala"
	g_return_if_fail (IS_SIMPLE_PROXYABLE_COMMAND (self));
#line 4684 "Commands.c"
	{
		GeeIterator* _added_proxy_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 171 "../src/Commands.vala"
		_tmp0_ = self->priv->proxies;
#line 171 "../src/Commands.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 171 "../src/Commands.vala"
		_added_proxy_it = _tmp1_;
#line 171 "../src/Commands.vala"
		while (TRUE) {
#line 4697 "Commands.c"
			GeeIterator* _tmp2_;
			SourceProxy* added_proxy = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceProxy* _tmp5_;
			guint _tmp6_;
#line 171 "../src/Commands.vala"
			_tmp2_ = _added_proxy_it;
#line 171 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 171 "../src/Commands.vala"
				break;
#line 4710 "Commands.c"
			}
#line 171 "../src/Commands.vala"
			_tmp3_ = _added_proxy_it;
#line 171 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 171 "../src/Commands.vala"
			added_proxy = (SourceProxy*) _tmp4_;
#line 172 "../src/Commands.vala"
			_tmp5_ = added_proxy;
#line 172 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp6_, NULL, FALSE);
#line 172 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _simple_proxyable_command_on_proxy_broken_source_proxy_broken, self);
#line 171 "../src/Commands.vala"
			_source_proxy_unref0 (added_proxy);
#line 4726 "Commands.c"
		}
#line 171 "../src/Commands.vala"
		_g_object_unref0 (_added_proxy_it);
#line 4730 "Commands.c"
	}
#line 174 "../src/Commands.vala"
	_tmp7_ = self->priv->proxies;
#line 174 "../src/Commands.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 4736 "Commands.c"
}

static void
simple_proxyable_command_on_proxy_broken (SimpleProxyableCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 177 "../src/Commands.vala"
	g_return_if_fail (IS_SIMPLE_PROXYABLE_COMMAND (self));
#line 178 "../src/Commands.vala"
	g_debug ("Commands.vala:178: on_proxy_broken");
#line 179 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 179 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 179 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 179 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 4756 "Commands.c"
}

static void
simple_proxyable_command_class_init (SimpleProxyableCommandClass * klass,
                                     gpointer klass_data)
{
#line 129 "../src/Commands.vala"
	simple_proxyable_command_parent_class = g_type_class_peek_parent (klass);
#line 129 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SimpleProxyableCommand_private_offset);
#line 129 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) simple_proxyable_command_real_execute;
#line 129 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) simple_proxyable_command_real_execute_on_source;
#line 129 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) simple_proxyable_command_real_undo;
#line 129 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) simple_proxyable_command_real_undo_on_source;
#line 129 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = simple_proxyable_command_finalize;
#line 4777 "Commands.c"
}

static void
simple_proxyable_command_instance_init (SimpleProxyableCommand * self,
                                        gpointer klass)
{
	GeeHashSet* _tmp0_;
#line 129 "../src/Commands.vala"
	self->priv = simple_proxyable_command_get_instance_private (self);
#line 131 "../src/Commands.vala"
	_tmp0_ = gee_hash_set_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 131 "../src/Commands.vala"
	self->priv->proxies = _tmp0_;
#line 4791 "Commands.c"
}

static void
simple_proxyable_command_finalize (GObject * obj)
{
	SimpleProxyableCommand * self;
	SourceProxy* _tmp0_;
	guint _tmp1_;
#line 129 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand);
#line 141 "../src/Commands.vala"
	_tmp0_ = self->priv->proxy;
#line 141 "../src/Commands.vala"
	g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp1_, NULL, FALSE);
#line 141 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _simple_proxyable_command_on_proxy_broken_source_proxy_broken, self);
#line 142 "../src/Commands.vala"
	simple_proxyable_command_clear_added_proxies (self);
#line 130 "../src/Commands.vala"
	_source_proxy_unref0 (self->priv->proxy);
#line 131 "../src/Commands.vala"
	_g_object_unref0 (self->priv->proxies);
#line 129 "../src/Commands.vala"
	G_OBJECT_CLASS (simple_proxyable_command_parent_class)->finalize (obj);
#line 4816 "Commands.c"
}

static GType
simple_proxyable_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SimpleProxyableCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) simple_proxyable_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SimpleProxyableCommand), 0, (GInstanceInitFunc) simple_proxyable_command_instance_init, NULL };
	GType simple_proxyable_command_type_id;
	simple_proxyable_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "SimpleProxyableCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SimpleProxyableCommand_private_offset = g_type_add_instance_private (simple_proxyable_command_type_id, sizeof (SimpleProxyableCommandPrivate));
	return simple_proxyable_command_type_id;
}

GType
simple_proxyable_command_get_type (void)
{
	static volatile gsize simple_proxyable_command_type_id__once = 0;
	if (g_once_init_enter (&simple_proxyable_command_type_id__once)) {
		GType simple_proxyable_command_type_id;
		simple_proxyable_command_type_id = simple_proxyable_command_get_type_once ();
		g_once_init_leave (&simple_proxyable_command_type_id__once, simple_proxyable_command_type_id);
	}
	return simple_proxyable_command_type_id__once;
}

static inline gpointer
single_photo_transformation_command_get_instance_private (SinglePhotoTransformationCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SinglePhotoTransformationCommand_private_offset);
}

static void
_single_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                        gpointer self)
{
#line 194 "../src/Commands.vala"
	single_photo_transformation_command_on_state_broken ((SinglePhotoTransformationCommand*) self);
#line 4853 "Commands.c"
}

SinglePhotoTransformationCommand*
single_photo_transformation_command_construct (GType object_type,
                                               Photo* photo,
                                               const gchar* name,
                                               const gchar* explanation)
{
	SinglePhotoTransformationCommand * self = NULL;
	PhotoTransformationState* _tmp0_;
	PhotoTransformationState* _tmp1_;
#line 186 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 186 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 186 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 187 "../src/Commands.vala"
	self = (SinglePhotoTransformationCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_DATA_SOURCE, DataSource), name, explanation);
#line 189 "../src/Commands.vala"
	_tmp0_ = photo_save_transformation_state (photo);
#line 189 "../src/Commands.vala"
	_g_object_unref0 (self->priv->state);
#line 189 "../src/Commands.vala"
	self->priv->state = _tmp0_;
#line 190 "../src/Commands.vala"
	_tmp1_ = self->priv->state;
#line 190 "../src/Commands.vala"
	g_signal_connect_object (_tmp1_, "broken", (GCallback) _single_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self, 0);
#line 186 "../src/Commands.vala"
	return self;
#line 4885 "Commands.c"
}

static void
single_photo_transformation_command_real_undo (Command* base)
{
	SinglePhotoTransformationCommand * self;
	DataSource* _tmp0_;
	PhotoTransformationState* _tmp1_;
#line 197 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND, SinglePhotoTransformationCommand);
#line 198 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 198 "../src/Commands.vala"
	_tmp1_ = self->priv->state;
#line 198 "../src/Commands.vala"
	photo_load_transformation_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo), _tmp1_);
#line 4902 "Commands.c"
}

static void
single_photo_transformation_command_on_state_broken (SinglePhotoTransformationCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 201 "../src/Commands.vala"
	g_return_if_fail (IS_SINGLE_PHOTO_TRANSFORMATION_COMMAND (self));
#line 202 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 202 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 202 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 202 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 4920 "Commands.c"
}

static void
single_photo_transformation_command_class_init (SinglePhotoTransformationCommandClass * klass,
                                                gpointer klass_data)
{
#line 183 "../src/Commands.vala"
	single_photo_transformation_command_parent_class = g_type_class_peek_parent (klass);
#line 183 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SinglePhotoTransformationCommand_private_offset);
#line 183 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) single_photo_transformation_command_real_undo;
#line 183 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = single_photo_transformation_command_finalize;
#line 4935 "Commands.c"
}

static void
single_photo_transformation_command_instance_init (SinglePhotoTransformationCommand * self,
                                                   gpointer klass)
{
#line 183 "../src/Commands.vala"
	self->priv = single_photo_transformation_command_get_instance_private (self);
#line 4944 "Commands.c"
}

static void
single_photo_transformation_command_finalize (GObject * obj)
{
	SinglePhotoTransformationCommand * self;
	PhotoTransformationState* _tmp0_;
	guint _tmp1_;
#line 183 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SINGLE_PHOTO_TRANSFORMATION_COMMAND, SinglePhotoTransformationCommand);
#line 194 "../src/Commands.vala"
	_tmp0_ = self->priv->state;
#line 194 "../src/Commands.vala"
	g_signal_parse_name ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, &_tmp1_, NULL, FALSE);
#line 194 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _single_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self);
#line 184 "../src/Commands.vala"
	_g_object_unref0 (self->priv->state);
#line 183 "../src/Commands.vala"
	G_OBJECT_CLASS (single_photo_transformation_command_parent_class)->finalize (obj);
#line 4965 "Commands.c"
}

static GType
single_photo_transformation_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SinglePhotoTransformationCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) single_photo_transformation_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SinglePhotoTransformationCommand), 0, (GInstanceInitFunc) single_photo_transformation_command_instance_init, NULL };
	GType single_photo_transformation_command_type_id;
	single_photo_transformation_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "SinglePhotoTransformationCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SinglePhotoTransformationCommand_private_offset = g_type_add_instance_private (single_photo_transformation_command_type_id, sizeof (SinglePhotoTransformationCommandPrivate));
	return single_photo_transformation_command_type_id;
}

GType
single_photo_transformation_command_get_type (void)
{
	static volatile gsize single_photo_transformation_command_type_id__once = 0;
	if (g_once_init_enter (&single_photo_transformation_command_type_id__once)) {
		GType single_photo_transformation_command_type_id;
		single_photo_transformation_command_type_id = single_photo_transformation_command_get_type_once ();
		g_once_init_leave (&single_photo_transformation_command_type_id__once, single_photo_transformation_command_type_id);
	}
	return single_photo_transformation_command_type_id__once;
}

static inline gpointer
generic_photo_transformation_command_get_instance_private (GenericPhotoTransformationCommand* self)
{
	return G_STRUCT_MEMBER_P (self, GenericPhotoTransformationCommand_private_offset);
}

static void
_generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                         gpointer self)
{
#line 216 "../src/Commands.vala"
	generic_photo_transformation_command_on_state_broken ((GenericPhotoTransformationCommand*) self);
#line 5002 "Commands.c"
}

GenericPhotoTransformationCommand*
generic_photo_transformation_command_construct (GType object_type,
                                                Photo* photo,
                                                const gchar* name,
                                                const gchar* explanation)
{
	GenericPhotoTransformationCommand * self = NULL;
#line 210 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 210 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 210 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 211 "../src/Commands.vala"
	self = (GenericPhotoTransformationCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_DATA_SOURCE, DataSource), name, explanation);
#line 210 "../src/Commands.vala"
	return self;
#line 5022 "Commands.c"
}

static void
generic_photo_transformation_command_real_execute (Command* base)
{
	GenericPhotoTransformationCommand * self;
	Photo* photo = NULL;
	DataSource* _tmp0_;
	Photo* _tmp1_;
	PhotoTransformationState* _tmp2_;
	PhotoTransformationState* _tmp3_;
	PhotoTransformationState* _tmp4_;
	PhotoTransformationState* _tmp5_;
#line 222 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand);
#line 223 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 223 "../src/Commands.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo));
#line 223 "../src/Commands.vala"
	photo = _tmp1_;
#line 225 "../src/Commands.vala"
	_tmp2_ = photo_save_transformation_state (photo);
#line 225 "../src/Commands.vala"
	_g_object_unref0 (self->priv->original_state);
#line 225 "../src/Commands.vala"
	self->priv->original_state = _tmp2_;
#line 226 "../src/Commands.vala"
	_tmp3_ = self->priv->original_state;
#line 226 "../src/Commands.vala"
	g_signal_connect_object (_tmp3_, "broken", (GCallback) _generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self, 0);
#line 228 "../src/Commands.vala"
	generic_photo_transformation_command_execute_on_photo (self, photo);
#line 230 "../src/Commands.vala"
	_tmp4_ = photo_save_transformation_state (photo);
#line 230 "../src/Commands.vala"
	_g_object_unref0 (self->priv->transformed_state);
#line 230 "../src/Commands.vala"
	self->priv->transformed_state = _tmp4_;
#line 231 "../src/Commands.vala"
	_tmp5_ = self->priv->transformed_state;
#line 231 "../src/Commands.vala"
	g_signal_connect_object (_tmp5_, "broken", (GCallback) _generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self, 0);
#line 222 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 5068 "Commands.c"
}

static void
generic_photo_transformation_command_real_execute_on_photo (GenericPhotoTransformationCommand* self,
                                                            Photo* photo)
{
#line 234 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `generic_photo_transformation_command_execute_on_photo'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 234 "../src/Commands.vala"
	return;
#line 5079 "Commands.c"
}

void
generic_photo_transformation_command_execute_on_photo (GenericPhotoTransformationCommand* self,
                                                       Photo* photo)
{
	GenericPhotoTransformationCommandClass* _klass_;
#line 234 "../src/Commands.vala"
	g_return_if_fail (IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND (self));
#line 234 "../src/Commands.vala"
	_klass_ = GENERIC_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS (self);
#line 234 "../src/Commands.vala"
	if (_klass_->execute_on_photo) {
#line 234 "../src/Commands.vala"
		_klass_->execute_on_photo (self, photo);
#line 5095 "Commands.c"
	}
}

static void
generic_photo_transformation_command_real_undo (Command* base)
{
	GenericPhotoTransformationCommand * self;
	DataSource* _tmp0_;
	PhotoTransformationState* _tmp1_;
#line 236 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand);
#line 238 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 238 "../src/Commands.vala"
	_tmp1_ = self->priv->original_state;
#line 238 "../src/Commands.vala"
	photo_load_transformation_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo), _tmp1_);
#line 5113 "Commands.c"
}

static void
generic_photo_transformation_command_real_redo (Command* base)
{
	GenericPhotoTransformationCommand * self;
	DataSource* _tmp0_;
	PhotoTransformationState* _tmp1_;
#line 241 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand);
#line 243 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 243 "../src/Commands.vala"
	_tmp1_ = self->priv->transformed_state;
#line 243 "../src/Commands.vala"
	photo_load_transformation_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo), _tmp1_);
#line 5130 "Commands.c"
}

static gboolean
generic_photo_transformation_command_real_can_compress (GenericPhotoTransformationCommand* self,
                                                        Command* command)
{
	gboolean result;
#line 246 "../src/Commands.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 247 "../src/Commands.vala"
	result = FALSE;
#line 247 "../src/Commands.vala"
	return result;
#line 5144 "Commands.c"
}

gboolean
generic_photo_transformation_command_can_compress (GenericPhotoTransformationCommand* self,
                                                   Command* command)
{
	GenericPhotoTransformationCommandClass* _klass_;
#line 246 "../src/Commands.vala"
	g_return_val_if_fail (IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND (self), FALSE);
#line 246 "../src/Commands.vala"
	_klass_ = GENERIC_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS (self);
#line 246 "../src/Commands.vala"
	if (_klass_->can_compress) {
#line 246 "../src/Commands.vala"
		return _klass_->can_compress (self, command);
#line 5160 "Commands.c"
	}
#line 246 "../src/Commands.vala"
	return FALSE;
#line 5164 "Commands.c"
}

static gboolean
generic_photo_transformation_command_real_compress (Command* base,
                                                    Command* command)
{
	GenericPhotoTransformationCommand * self;
	GenericPhotoTransformationCommand* generic = NULL;
	GenericPhotoTransformationCommand* _tmp0_;
	GenericPhotoTransformationCommand* _tmp1_;
	GenericPhotoTransformationCommand* _tmp2_;
	DataSource* _tmp3_;
	DataSource* _tmp4_;
	GenericPhotoTransformationCommand* _tmp5_;
	GenericPhotoTransformationCommand* _tmp6_;
	PhotoTransformationState* _tmp7_;
	PhotoTransformationState* _tmp8_;
	gboolean result;
#line 250 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand);
#line 250 "../src/Commands.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 251 "../src/Commands.vala"
	if (!generic_photo_transformation_command_can_compress (self, command)) {
#line 252 "../src/Commands.vala"
		result = FALSE;
#line 252 "../src/Commands.vala"
		return result;
#line 5193 "Commands.c"
	}
#line 254 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND (command) ? ((GenericPhotoTransformationCommand*) command) : NULL);
#line 254 "../src/Commands.vala"
	generic = _tmp0_;
#line 255 "../src/Commands.vala"
	_tmp1_ = generic;
#line 255 "../src/Commands.vala"
	if (_tmp1_ == NULL) {
#line 256 "../src/Commands.vala"
		result = FALSE;
#line 256 "../src/Commands.vala"
		_g_object_unref0 (generic);
#line 256 "../src/Commands.vala"
		return result;
#line 5209 "Commands.c"
	}
#line 258 "../src/Commands.vala"
	_tmp2_ = generic;
#line 258 "../src/Commands.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 258 "../src/Commands.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 258 "../src/Commands.vala"
	if (_tmp3_ != _tmp4_) {
#line 259 "../src/Commands.vala"
		result = FALSE;
#line 259 "../src/Commands.vala"
		_g_object_unref0 (generic);
#line 259 "../src/Commands.vala"
		return result;
#line 5225 "Commands.c"
	}
#line 262 "../src/Commands.vala"
	_tmp5_ = generic;
#line 262 "../src/Commands.vala"
	command_execute (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_COMMAND, Command));
#line 265 "../src/Commands.vala"
	_tmp6_ = generic;
#line 265 "../src/Commands.vala"
	_tmp7_ = _tmp6_->priv->transformed_state;
#line 265 "../src/Commands.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 265 "../src/Commands.vala"
	_g_object_unref0 (self->priv->transformed_state);
#line 265 "../src/Commands.vala"
	self->priv->transformed_state = _tmp8_;
#line 267 "../src/Commands.vala"
	result = TRUE;
#line 267 "../src/Commands.vala"
	_g_object_unref0 (generic);
#line 267 "../src/Commands.vala"
	return result;
#line 5247 "Commands.c"
}

static void
generic_photo_transformation_command_on_state_broken (GenericPhotoTransformationCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 270 "../src/Commands.vala"
	g_return_if_fail (IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND (self));
#line 271 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 271 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 271 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 271 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 5265 "Commands.c"
}

static void
generic_photo_transformation_command_class_init (GenericPhotoTransformationCommandClass * klass,
                                                 gpointer klass_data)
{
#line 206 "../src/Commands.vala"
	generic_photo_transformation_command_parent_class = g_type_class_peek_parent (klass);
#line 206 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &GenericPhotoTransformationCommand_private_offset);
#line 206 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) generic_photo_transformation_command_real_execute;
#line 206 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) generic_photo_transformation_command_real_execute_on_photo;
#line 206 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) generic_photo_transformation_command_real_undo;
#line 206 "../src/Commands.vala"
	((CommandClass *) klass)->redo = (void (*) (Command*)) generic_photo_transformation_command_real_redo;
#line 206 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->can_compress = (gboolean (*) (GenericPhotoTransformationCommand*, Command*)) generic_photo_transformation_command_real_can_compress;
#line 206 "../src/Commands.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) generic_photo_transformation_command_real_compress;
#line 206 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = generic_photo_transformation_command_finalize;
#line 5290 "Commands.c"
}

static void
generic_photo_transformation_command_instance_init (GenericPhotoTransformationCommand * self,
                                                    gpointer klass)
{
#line 206 "../src/Commands.vala"
	self->priv = generic_photo_transformation_command_get_instance_private (self);
#line 207 "../src/Commands.vala"
	self->priv->original_state = NULL;
#line 208 "../src/Commands.vala"
	self->priv->transformed_state = NULL;
#line 5303 "Commands.c"
}

static void
generic_photo_transformation_command_finalize (GObject * obj)
{
	GenericPhotoTransformationCommand * self;
	PhotoTransformationState* _tmp0_;
	PhotoTransformationState* _tmp3_;
#line 206 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand);
#line 215 "../src/Commands.vala"
	_tmp0_ = self->priv->original_state;
#line 215 "../src/Commands.vala"
	if (_tmp0_ != NULL) {
#line 5318 "Commands.c"
		PhotoTransformationState* _tmp1_;
		guint _tmp2_;
#line 216 "../src/Commands.vala"
		_tmp1_ = self->priv->original_state;
#line 216 "../src/Commands.vala"
		g_signal_parse_name ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, &_tmp2_, NULL, FALSE);
#line 216 "../src/Commands.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self);
#line 5327 "Commands.c"
	}
#line 218 "../src/Commands.vala"
	_tmp3_ = self->priv->transformed_state;
#line 218 "../src/Commands.vala"
	if (_tmp3_ != NULL) {
#line 5333 "Commands.c"
		PhotoTransformationState* _tmp4_;
		guint _tmp5_;
#line 219 "../src/Commands.vala"
		_tmp4_ = self->priv->transformed_state;
#line 219 "../src/Commands.vala"
		g_signal_parse_name ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, &_tmp5_, NULL, FALSE);
#line 219 "../src/Commands.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _generic_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self);
#line 5342 "Commands.c"
	}
#line 207 "../src/Commands.vala"
	_g_object_unref0 (self->priv->original_state);
#line 208 "../src/Commands.vala"
	_g_object_unref0 (self->priv->transformed_state);
#line 206 "../src/Commands.vala"
	G_OBJECT_CLASS (generic_photo_transformation_command_parent_class)->finalize (obj);
#line 5350 "Commands.c"
}

static GType
generic_photo_transformation_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GenericPhotoTransformationCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) generic_photo_transformation_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GenericPhotoTransformationCommand), 0, (GInstanceInitFunc) generic_photo_transformation_command_instance_init, NULL };
	GType generic_photo_transformation_command_type_id;
	generic_photo_transformation_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "GenericPhotoTransformationCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	GenericPhotoTransformationCommand_private_offset = g_type_add_instance_private (generic_photo_transformation_command_type_id, sizeof (GenericPhotoTransformationCommandPrivate));
	return generic_photo_transformation_command_type_id;
}

GType
generic_photo_transformation_command_get_type (void)
{
	static volatile gsize generic_photo_transformation_command_type_id__once = 0;
	if (g_once_init_enter (&generic_photo_transformation_command_type_id__once)) {
		GType generic_photo_transformation_command_type_id;
		generic_photo_transformation_command_type_id = generic_photo_transformation_command_get_type_once ();
		g_once_init_leave (&generic_photo_transformation_command_type_id__once, generic_photo_transformation_command_type_id);
	}
	return generic_photo_transformation_command_type_id__once;
}

static inline gpointer
multiple_data_source_command_get_instance_private (MultipleDataSourceCommand* self)
{
	return G_STRUCT_MEMBER_P (self, MultipleDataSourceCommand_private_offset);
}

static void
_multiple_data_source_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                    DataSource* source,
                                                                                    gpointer self)
{
#line 309 "../src/Commands.vala"
	multiple_data_source_command_on_source_destroyed ((MultipleDataSourceCommand*) self, source);
#line 5388 "Commands.c"
}

MultipleDataSourceCommand*
multiple_data_source_command_construct (GType object_type,
                                        GeeIterable* iter,
                                        const gchar* progress_text,
                                        const gchar* undo_progress_text,
                                        const gchar* name,
                                        const gchar* explanation)
{
	MultipleDataSourceCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 285 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 285 "../src/Commands.vala"
	g_return_val_if_fail (progress_text != NULL, NULL);
#line 285 "../src/Commands.vala"
	g_return_val_if_fail (undo_progress_text != NULL, NULL);
#line 285 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 285 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 287 "../src/Commands.vala"
	self = (MultipleDataSourceCommand*) page_command_construct (object_type, name, explanation);
#line 289 "../src/Commands.vala"
	_tmp0_ = g_strdup (progress_text);
#line 289 "../src/Commands.vala"
	_g_free0 (self->priv->progress_text);
#line 289 "../src/Commands.vala"
	self->priv->progress_text = _tmp0_;
#line 290 "../src/Commands.vala"
	_tmp1_ = g_strdup (undo_progress_text);
#line 290 "../src/Commands.vala"
	_g_free0 (self->priv->undo_progress_text);
#line 290 "../src/Commands.vala"
	self->priv->undo_progress_text = _tmp1_;
#line 5426 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp2_;
#line 292 "../src/Commands.vala"
		_tmp2_ = gee_iterable_iterator (iter);
#line 292 "../src/Commands.vala"
		_view_it = _tmp2_;
#line 292 "../src/Commands.vala"
		while (TRUE) {
#line 5436 "Commands.c"
			GeeIterator* _tmp3_;
			DataView* view = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			DataSource* source = NULL;
			DataView* _tmp6_;
			DataSource* _tmp7_;
			SourceCollection* collection = NULL;
			DataSource* _tmp8_;
			DataCollection* _tmp9_;
			SourceCollection* _tmp10_;
			GeeArrayList* _tmp13_;
			DataSource* _tmp14_;
#line 292 "../src/Commands.vala"
			_tmp3_ = _view_it;
#line 292 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 292 "../src/Commands.vala"
				break;
#line 5456 "Commands.c"
			}
#line 292 "../src/Commands.vala"
			_tmp4_ = _view_it;
#line 292 "../src/Commands.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 292 "../src/Commands.vala"
			view = (DataView*) _tmp5_;
#line 293 "../src/Commands.vala"
			_tmp6_ = view;
#line 293 "../src/Commands.vala"
			_tmp7_ = data_view_get_source (_tmp6_);
#line 293 "../src/Commands.vala"
			source = _tmp7_;
#line 294 "../src/Commands.vala"
			_tmp8_ = source;
#line 294 "../src/Commands.vala"
			_tmp9_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_OBJECT, DataObject));
#line 294 "../src/Commands.vala"
			collection = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_SOURCE_COLLECTION, SourceCollection);
#line 296 "../src/Commands.vala"
			_tmp10_ = collection;
#line 296 "../src/Commands.vala"
			if (_tmp10_ != NULL) {
#line 5480 "Commands.c"
				GeeHashSet* _tmp11_;
				SourceCollection* _tmp12_;
#line 297 "../src/Commands.vala"
				_tmp11_ = self->priv->hooked_collections;
#line 297 "../src/Commands.vala"
				_tmp12_ = collection;
#line 297 "../src/Commands.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 5489 "Commands.c"
			}
#line 299 "../src/Commands.vala"
			_tmp13_ = self->source_list;
#line 299 "../src/Commands.vala"
			_tmp14_ = source;
#line 299 "../src/Commands.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 292 "../src/Commands.vala"
			_data_collection_unref0 (collection);
#line 292 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 292 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 5503 "Commands.c"
		}
#line 292 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 5507 "Commands.c"
	}
	{
		GeeIterator* _current_collection_it = NULL;
		GeeHashSet* _tmp15_;
		GeeIterator* _tmp16_;
#line 302 "../src/Commands.vala"
		_tmp15_ = self->priv->hooked_collections;
#line 302 "../src/Commands.vala"
		_tmp16_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 302 "../src/Commands.vala"
		_current_collection_it = _tmp16_;
#line 302 "../src/Commands.vala"
		while (TRUE) {
#line 5521 "Commands.c"
			GeeIterator* _tmp17_;
			SourceCollection* current_collection = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			SourceCollection* _tmp20_;
#line 302 "../src/Commands.vala"
			_tmp17_ = _current_collection_it;
#line 302 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 302 "../src/Commands.vala"
				break;
#line 5533 "Commands.c"
			}
#line 302 "../src/Commands.vala"
			_tmp18_ = _current_collection_it;
#line 302 "../src/Commands.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 302 "../src/Commands.vala"
			current_collection = (SourceCollection*) _tmp19_;
#line 303 "../src/Commands.vala"
			_tmp20_ = current_collection;
#line 303 "../src/Commands.vala"
			g_signal_connect_object (_tmp20_, "item-destroyed", (GCallback) _multiple_data_source_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 302 "../src/Commands.vala"
			_data_collection_unref0 (current_collection);
#line 5547 "Commands.c"
		}
#line 302 "../src/Commands.vala"
		_g_object_unref0 (_current_collection_it);
#line 5551 "Commands.c"
	}
#line 285 "../src/Commands.vala"
	return self;
#line 5555 "Commands.c"
}

GeeIterable*
multiple_data_source_command_get_sources (MultipleDataSourceCommand* self)
{
	GeeArrayList* _tmp0_;
	GeeIterable* _tmp1_;
	GeeIterable* result;
#line 313 "../src/Commands.vala"
	g_return_val_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self), NULL);
#line 314 "../src/Commands.vala"
	_tmp0_ = self->source_list;
#line 314 "../src/Commands.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 314 "../src/Commands.vala"
	result = _tmp1_;
#line 314 "../src/Commands.vala"
	return result;
#line 5574 "Commands.c"
}

gint
multiple_data_source_command_get_source_count (MultipleDataSourceCommand* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 317 "../src/Commands.vala"
	g_return_val_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self), 0);
#line 318 "../src/Commands.vala"
	_tmp0_ = self->source_list;
#line 318 "../src/Commands.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 318 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 318 "../src/Commands.vala"
	result = _tmp2_;
#line 318 "../src/Commands.vala"
	return result;
#line 5596 "Commands.c"
}

static void
multiple_data_source_command_on_source_destroyed (MultipleDataSourceCommand* self,
                                                  DataSource* source)
{
	GeeArrayList* _tmp0_;
#line 321 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 321 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 324 "../src/Commands.vala"
	_tmp0_ = self->source_list;
#line 324 "../src/Commands.vala"
	if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), source)) {
#line 5612 "Commands.c"
		CommandManager* _tmp1_;
		CommandManager* _tmp2_;
#line 325 "../src/Commands.vala"
		_tmp1_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 325 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 325 "../src/Commands.vala"
		command_manager_reset (_tmp2_);
#line 325 "../src/Commands.vala"
		_command_manager_unref0 (_tmp2_);
#line 5623 "Commands.c"
	}
}

static void
multiple_data_source_command_real_execute (Command* base)
{
	MultipleDataSourceCommand * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 328 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand);
#line 329 "../src/Commands.vala"
	_tmp0_ = self->priv->acted_upon;
#line 329 "../src/Commands.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 331 "../src/Commands.vala"
	multiple_data_source_command_start_transaction (self);
#line 332 "../src/Commands.vala"
	_tmp1_ = self->source_list;
#line 332 "../src/Commands.vala"
	_tmp2_ = self->priv->acted_upon;
#line 332 "../src/Commands.vala"
	multiple_data_source_command_execute_all (self, TRUE, TRUE, _tmp1_, _tmp2_);
#line 333 "../src/Commands.vala"
	multiple_data_source_command_commit_transaction (self);
#line 5650 "Commands.c"
}

static void
multiple_data_source_command_real_execute_on_source (MultipleDataSourceCommand* self,
                                                     DataSource* source)
{
#line 336 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `multiple_data_source_command_execute_on_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 336 "../src/Commands.vala"
	return;
#line 5661 "Commands.c"
}

void
multiple_data_source_command_execute_on_source (MultipleDataSourceCommand* self,
                                                DataSource* source)
{
	MultipleDataSourceCommandClass* _klass_;
#line 336 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 336 "../src/Commands.vala"
	_klass_ = MULTIPLE_DATA_SOURCE_COMMAND_GET_CLASS (self);
#line 336 "../src/Commands.vala"
	if (_klass_->execute_on_source) {
#line 336 "../src/Commands.vala"
		_klass_->execute_on_source (self, source);
#line 5677 "Commands.c"
	}
}

static void
multiple_data_source_command_real_undo (Command* base)
{
	MultipleDataSourceCommand * self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 338 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand);
#line 339 "../src/Commands.vala"
	_tmp0_ = self->priv->acted_upon;
#line 339 "../src/Commands.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 339 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 339 "../src/Commands.vala"
	if (_tmp2_ > 0) {
#line 5698 "Commands.c"
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
#line 340 "../src/Commands.vala"
		multiple_data_source_command_start_transaction (self);
#line 341 "../src/Commands.vala"
		_tmp3_ = self->priv->acted_upon;
#line 341 "../src/Commands.vala"
		multiple_data_source_command_execute_all (self, FALSE, FALSE, _tmp3_, NULL);
#line 342 "../src/Commands.vala"
		multiple_data_source_command_commit_transaction (self);
#line 344 "../src/Commands.vala"
		_tmp4_ = self->priv->acted_upon;
#line 344 "../src/Commands.vala"
		gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 5713 "Commands.c"
	}
}

static void
multiple_data_source_command_real_undo_on_source (MultipleDataSourceCommand* self,
                                                  DataSource* source)
{
#line 348 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `multiple_data_source_command_undo_on_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 348 "../src/Commands.vala"
	return;
#line 5725 "Commands.c"
}

void
multiple_data_source_command_undo_on_source (MultipleDataSourceCommand* self,
                                             DataSource* source)
{
	MultipleDataSourceCommandClass* _klass_;
#line 348 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 348 "../src/Commands.vala"
	_klass_ = MULTIPLE_DATA_SOURCE_COMMAND_GET_CLASS (self);
#line 348 "../src/Commands.vala"
	if (_klass_->undo_on_source) {
#line 348 "../src/Commands.vala"
		_klass_->undo_on_source (self, source);
#line 5741 "Commands.c"
	}
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 352 "../src/Commands.vala"
	return self ? data_collection_ref (self) : NULL;
#line 5750 "Commands.c"
}

static void
multiple_data_source_command_start_transaction (MultipleDataSourceCommand* self)
{
#line 350 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 5758 "Commands.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 351 "../src/Commands.vala"
		_tmp0_ = self->priv->hooked_collections;
#line 351 "../src/Commands.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 351 "../src/Commands.vala"
		_sources_it = _tmp1_;
#line 351 "../src/Commands.vala"
		while (TRUE) {
#line 5771 "Commands.c"
			GeeIterator* _tmp2_;
			SourceCollection* sources = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MediaSourceCollection* media_collection = NULL;
			SourceCollection* _tmp5_;
			MediaSourceCollection* _tmp6_;
			MediaSourceCollection* _tmp7_;
#line 351 "../src/Commands.vala"
			_tmp2_ = _sources_it;
#line 351 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 351 "../src/Commands.vala"
				break;
#line 5786 "Commands.c"
			}
#line 351 "../src/Commands.vala"
			_tmp3_ = _sources_it;
#line 351 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 351 "../src/Commands.vala"
			sources = (SourceCollection*) _tmp4_;
#line 352 "../src/Commands.vala"
			_tmp5_ = sources;
#line 352 "../src/Commands.vala"
			_tmp6_ = _data_collection_ref0 (IS_MEDIA_SOURCE_COLLECTION (_tmp5_) ? ((MediaSourceCollection*) _tmp5_) : NULL);
#line 352 "../src/Commands.vala"
			media_collection = _tmp6_;
#line 353 "../src/Commands.vala"
			_tmp7_ = media_collection;
#line 353 "../src/Commands.vala"
			if (_tmp7_ != NULL) {
#line 5804 "Commands.c"
				MediaSourceCollection* _tmp8_;
				TransactionController* _tmp9_;
				TransactionController* _tmp10_;
#line 354 "../src/Commands.vala"
				_tmp8_ = media_collection;
#line 354 "../src/Commands.vala"
				_tmp9_ = media_source_collection_get_transaction_controller (_tmp8_);
#line 354 "../src/Commands.vala"
				_tmp10_ = _tmp9_;
#line 354 "../src/Commands.vala"
				transaction_controller_begin (_tmp10_);
#line 5816 "Commands.c"
			}
#line 351 "../src/Commands.vala"
			_data_collection_unref0 (media_collection);
#line 351 "../src/Commands.vala"
			_data_collection_unref0 (sources);
#line 5822 "Commands.c"
		}
#line 351 "../src/Commands.vala"
		_g_object_unref0 (_sources_it);
#line 5826 "Commands.c"
	}
}

static void
multiple_data_source_command_commit_transaction (MultipleDataSourceCommand* self)
{
#line 358 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 5835 "Commands.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 359 "../src/Commands.vala"
		_tmp0_ = self->priv->hooked_collections;
#line 359 "../src/Commands.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 359 "../src/Commands.vala"
		_sources_it = _tmp1_;
#line 359 "../src/Commands.vala"
		while (TRUE) {
#line 5848 "Commands.c"
			GeeIterator* _tmp2_;
			SourceCollection* sources = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MediaSourceCollection* media_collection = NULL;
			SourceCollection* _tmp5_;
			MediaSourceCollection* _tmp6_;
			MediaSourceCollection* _tmp7_;
#line 359 "../src/Commands.vala"
			_tmp2_ = _sources_it;
#line 359 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 359 "../src/Commands.vala"
				break;
#line 5863 "Commands.c"
			}
#line 359 "../src/Commands.vala"
			_tmp3_ = _sources_it;
#line 359 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 359 "../src/Commands.vala"
			sources = (SourceCollection*) _tmp4_;
#line 360 "../src/Commands.vala"
			_tmp5_ = sources;
#line 360 "../src/Commands.vala"
			_tmp6_ = _data_collection_ref0 (IS_MEDIA_SOURCE_COLLECTION (_tmp5_) ? ((MediaSourceCollection*) _tmp5_) : NULL);
#line 360 "../src/Commands.vala"
			media_collection = _tmp6_;
#line 361 "../src/Commands.vala"
			_tmp7_ = media_collection;
#line 361 "../src/Commands.vala"
			if (_tmp7_ != NULL) {
#line 5881 "Commands.c"
				MediaSourceCollection* _tmp8_;
				TransactionController* _tmp9_;
				TransactionController* _tmp10_;
#line 362 "../src/Commands.vala"
				_tmp8_ = media_collection;
#line 362 "../src/Commands.vala"
				_tmp9_ = media_source_collection_get_transaction_controller (_tmp8_);
#line 362 "../src/Commands.vala"
				_tmp10_ = _tmp9_;
#line 362 "../src/Commands.vala"
				transaction_controller_commit (_tmp10_);
#line 5893 "Commands.c"
			}
#line 359 "../src/Commands.vala"
			_data_collection_unref0 (media_collection);
#line 359 "../src/Commands.vala"
			_data_collection_unref0 (sources);
#line 5899 "Commands.c"
		}
#line 359 "../src/Commands.vala"
		_g_object_unref0 (_sources_it);
#line 5903 "Commands.c"
	}
}

static void
multiple_data_source_command_execute_all (MultipleDataSourceCommand* self,
                                          gboolean exec,
                                          gboolean can_cancel,
                                          GeeArrayList* todo,
                                          GeeArrayList* completed)
{
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	gint count = 0;
	gint total = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint two_percent = 0;
	const gchar* _tmp4_ = NULL;
	gchar* text = NULL;
	gchar* _tmp7_;
	GCancellable* cancellable = NULL;
	ProgressDialog* progress = NULL;
	ProgressDialog* _tmp33_;
	AppWindow* _tmp35_;
	AppWindow* _tmp36_;
#line 366 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_COMMAND (self));
#line 366 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (todo, GEE_TYPE_ARRAY_LIST));
#line 366 "../src/Commands.vala"
	g_return_if_fail ((completed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (completed, GEE_TYPE_ARRAY_LIST));
#line 368 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 368 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 368 "../src/Commands.vala"
	page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 368 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 370 "../src/Commands.vala"
	count = 0;
#line 371 "../src/Commands.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (todo, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 371 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 371 "../src/Commands.vala"
	total = _tmp3_;
#line 372 "../src/Commands.vala"
	two_percent = (gint) (((gdouble) total) / 50.0);
#line 373 "../src/Commands.vala"
	if (two_percent <= 0) {
#line 374 "../src/Commands.vala"
		two_percent = 1;
#line 5957 "Commands.c"
	}
#line 376 "../src/Commands.vala"
	if (exec) {
#line 5961 "Commands.c"
		const gchar* _tmp5_;
#line 376 "../src/Commands.vala"
		_tmp5_ = self->priv->progress_text;
#line 376 "../src/Commands.vala"
		_tmp4_ = _tmp5_;
#line 5967 "Commands.c"
	} else {
		const gchar* _tmp6_;
#line 376 "../src/Commands.vala"
		_tmp6_ = self->priv->undo_progress_text;
#line 376 "../src/Commands.vala"
		_tmp4_ = _tmp6_;
#line 5974 "Commands.c"
	}
#line 376 "../src/Commands.vala"
	_tmp7_ = g_strdup (_tmp4_);
#line 376 "../src/Commands.vala"
	text = _tmp7_;
#line 378 "../src/Commands.vala"
	cancellable = NULL;
#line 379 "../src/Commands.vala"
	progress = NULL;
#line 380 "../src/Commands.vala"
	if (total >= MULTIPLE_DATA_SOURCE_COMMAND_MIN_OPS_FOR_PROGRESS_WINDOW) {
#line 5986 "Commands.c"
		GCancellable* _tmp8_ = NULL;
		GCancellable* _tmp10_;
		AppWindow* _tmp11_;
		AppWindow* _tmp12_;
		const gchar* _tmp13_;
		GCancellable* _tmp14_;
		ProgressDialog* _tmp15_;
#line 381 "../src/Commands.vala"
		if (can_cancel) {
#line 5996 "Commands.c"
			GCancellable* _tmp9_;
#line 381 "../src/Commands.vala"
			_tmp9_ = g_cancellable_new ();
#line 381 "../src/Commands.vala"
			_g_object_unref0 (_tmp8_);
#line 381 "../src/Commands.vala"
			_tmp8_ = _tmp9_;
#line 6004 "Commands.c"
		} else {
#line 381 "../src/Commands.vala"
			_g_object_unref0 (_tmp8_);
#line 381 "../src/Commands.vala"
			_tmp8_ = NULL;
#line 6010 "Commands.c"
		}
#line 381 "../src/Commands.vala"
		_tmp10_ = _g_object_ref0 (_tmp8_);
#line 381 "../src/Commands.vala"
		_g_object_unref0 (cancellable);
#line 381 "../src/Commands.vala"
		cancellable = _tmp10_;
#line 382 "../src/Commands.vala"
		_tmp11_ = app_window_get_instance ();
#line 382 "../src/Commands.vala"
		_tmp12_ = _tmp11_;
#line 382 "../src/Commands.vala"
		_tmp13_ = text;
#line 382 "../src/Commands.vala"
		_tmp14_ = cancellable;
#line 382 "../src/Commands.vala"
		_tmp15_ = progress_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_window_get_type (), GtkWindow), _tmp13_, _tmp14_);
#line 382 "../src/Commands.vala"
		g_object_ref_sink (_tmp15_);
#line 382 "../src/Commands.vala"
		_g_object_unref0 (progress);
#line 382 "../src/Commands.vala"
		progress = _tmp15_;
#line 382 "../src/Commands.vala"
		_g_object_unref0 (_tmp12_);
#line 380 "../src/Commands.vala"
		_g_object_unref0 (_tmp8_);
#line 6038 "Commands.c"
	}
	{
		GeeArrayList* _source_list = NULL;
		gint _source_size = 0;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _source_index = 0;
#line 385 "../src/Commands.vala"
		_source_list = todo;
#line 385 "../src/Commands.vala"
		_tmp16_ = _source_list;
#line 385 "../src/Commands.vala"
		_tmp17_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 385 "../src/Commands.vala"
		_tmp18_ = _tmp17_;
#line 385 "../src/Commands.vala"
		_source_size = _tmp18_;
#line 385 "../src/Commands.vala"
		_source_index = -1;
#line 385 "../src/Commands.vala"
		while (TRUE) {
#line 6061 "Commands.c"
			gint _tmp19_;
			gint _tmp20_;
			DataSource* source = NULL;
			GeeArrayList* _tmp21_;
			gpointer _tmp22_;
			ProgressDialog* _tmp26_;
#line 385 "../src/Commands.vala"
			_source_index = _source_index + 1;
#line 385 "../src/Commands.vala"
			_tmp19_ = _source_index;
#line 385 "../src/Commands.vala"
			_tmp20_ = _source_size;
#line 385 "../src/Commands.vala"
			if (!(_tmp19_ < _tmp20_)) {
#line 385 "../src/Commands.vala"
				break;
#line 6078 "Commands.c"
			}
#line 385 "../src/Commands.vala"
			_tmp21_ = _source_list;
#line 385 "../src/Commands.vala"
			_tmp22_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _source_index);
#line 385 "../src/Commands.vala"
			source = (DataSource*) _tmp22_;
#line 386 "../src/Commands.vala"
			if (exec) {
#line 6088 "Commands.c"
				DataSource* _tmp23_;
#line 387 "../src/Commands.vala"
				_tmp23_ = source;
#line 387 "../src/Commands.vala"
				multiple_data_source_command_execute_on_source (self, _tmp23_);
#line 6094 "Commands.c"
			} else {
				DataSource* _tmp24_;
#line 389 "../src/Commands.vala"
				_tmp24_ = source;
#line 389 "../src/Commands.vala"
				multiple_data_source_command_undo_on_source (self, _tmp24_);
#line 6101 "Commands.c"
			}
#line 391 "../src/Commands.vala"
			if (completed != NULL) {
#line 6105 "Commands.c"
				DataSource* _tmp25_;
#line 392 "../src/Commands.vala"
				_tmp25_ = source;
#line 392 "../src/Commands.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (completed, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp25_);
#line 6111 "Commands.c"
			}
#line 394 "../src/Commands.vala"
			_tmp26_ = progress;
#line 394 "../src/Commands.vala"
			if (_tmp26_ != NULL) {
#line 6117 "Commands.c"
				gint _tmp27_;
				gint _tmp28_;
				gboolean _tmp30_ = FALSE;
				GCancellable* _tmp31_;
#line 395 "../src/Commands.vala"
				count = count + 1;
#line 395 "../src/Commands.vala"
				_tmp27_ = count;
#line 395 "../src/Commands.vala"
				_tmp28_ = two_percent;
#line 395 "../src/Commands.vala"
				if ((_tmp27_ % _tmp28_) == 0) {
#line 6130 "Commands.c"
					ProgressDialog* _tmp29_;
#line 396 "../src/Commands.vala"
					_tmp29_ = progress;
#line 396 "../src/Commands.vala"
					progress_dialog_set_fraction (_tmp29_, count, total);
#line 397 "../src/Commands.vala"
					spin_event_loop ();
#line 6138 "Commands.c"
				}
#line 400 "../src/Commands.vala"
				_tmp31_ = cancellable;
#line 400 "../src/Commands.vala"
				if (_tmp31_ != NULL) {
#line 6144 "Commands.c"
					GCancellable* _tmp32_;
#line 400 "../src/Commands.vala"
					_tmp32_ = cancellable;
#line 400 "../src/Commands.vala"
					_tmp30_ = g_cancellable_is_cancelled (_tmp32_);
#line 6150 "Commands.c"
				} else {
#line 400 "../src/Commands.vala"
					_tmp30_ = FALSE;
#line 6154 "Commands.c"
				}
#line 400 "../src/Commands.vala"
				if (_tmp30_) {
#line 401 "../src/Commands.vala"
					_g_object_unref0 (source);
#line 401 "../src/Commands.vala"
					break;
#line 6162 "Commands.c"
				}
			}
#line 385 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 6167 "Commands.c"
		}
	}
#line 405 "../src/Commands.vala"
	_tmp33_ = progress;
#line 405 "../src/Commands.vala"
	if (_tmp33_ != NULL) {
#line 6174 "Commands.c"
		ProgressDialog* _tmp34_;
#line 406 "../src/Commands.vala"
		_tmp34_ = progress;
#line 406 "../src/Commands.vala"
		progress_dialog_close (_tmp34_);
#line 6180 "Commands.c"
	}
#line 408 "../src/Commands.vala"
	_tmp35_ = app_window_get_instance ();
#line 408 "../src/Commands.vala"
	_tmp36_ = _tmp35_;
#line 408 "../src/Commands.vala"
	page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_PAGE_WINDOW, PageWindow));
#line 408 "../src/Commands.vala"
	_g_object_unref0 (_tmp36_);
#line 366 "../src/Commands.vala"
	_g_object_unref0 (progress);
#line 366 "../src/Commands.vala"
	_g_object_unref0 (cancellable);
#line 366 "../src/Commands.vala"
	_g_free0 (text);
#line 6196 "Commands.c"
}

static void
multiple_data_source_command_class_init (MultipleDataSourceCommandClass * klass,
                                         gpointer klass_data)
{
#line 275 "../src/Commands.vala"
	multiple_data_source_command_parent_class = g_type_class_peek_parent (klass);
#line 275 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &MultipleDataSourceCommand_private_offset);
#line 275 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) multiple_data_source_command_real_execute;
#line 275 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) multiple_data_source_command_real_execute_on_source;
#line 275 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) multiple_data_source_command_real_undo;
#line 275 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) multiple_data_source_command_real_undo_on_source;
#line 275 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = multiple_data_source_command_finalize;
#line 6217 "Commands.c"
}

static void
multiple_data_source_command_instance_init (MultipleDataSourceCommand * self,
                                            gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashSet* _tmp2_;
#line 275 "../src/Commands.vala"
	self->priv = multiple_data_source_command_get_instance_private (self);
#line 278 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 278 "../src/Commands.vala"
	self->source_list = _tmp0_;
#line 282 "../src/Commands.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 282 "../src/Commands.vala"
	self->priv->acted_upon = _tmp1_;
#line 283 "../src/Commands.vala"
	_tmp2_ = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 283 "../src/Commands.vala"
	self->priv->hooked_collections = _tmp2_;
#line 6241 "Commands.c"
}

static void
multiple_data_source_command_finalize (GObject * obj)
{
	MultipleDataSourceCommand * self;
#line 275 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand);
#line 6250 "Commands.c"
	{
		GeeIterator* _current_collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 308 "../src/Commands.vala"
		_tmp0_ = self->priv->hooked_collections;
#line 308 "../src/Commands.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 308 "../src/Commands.vala"
		_current_collection_it = _tmp1_;
#line 308 "../src/Commands.vala"
		while (TRUE) {
#line 6263 "Commands.c"
			GeeIterator* _tmp2_;
			SourceCollection* current_collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
			guint _tmp6_;
#line 308 "../src/Commands.vala"
			_tmp2_ = _current_collection_it;
#line 308 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 308 "../src/Commands.vala"
				break;
#line 6276 "Commands.c"
			}
#line 308 "../src/Commands.vala"
			_tmp3_ = _current_collection_it;
#line 308 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 308 "../src/Commands.vala"
			current_collection = (SourceCollection*) _tmp4_;
#line 309 "../src/Commands.vala"
			_tmp5_ = current_collection;
#line 309 "../src/Commands.vala"
			g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 309 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _multiple_data_source_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 308 "../src/Commands.vala"
			_data_collection_unref0 (current_collection);
#line 6292 "Commands.c"
		}
#line 308 "../src/Commands.vala"
		_g_object_unref0 (_current_collection_it);
#line 6296 "Commands.c"
	}
#line 278 "../src/Commands.vala"
	_g_object_unref0 (self->source_list);
#line 280 "../src/Commands.vala"
	_g_free0 (self->priv->progress_text);
#line 281 "../src/Commands.vala"
	_g_free0 (self->priv->undo_progress_text);
#line 282 "../src/Commands.vala"
	_g_object_unref0 (self->priv->acted_upon);
#line 283 "../src/Commands.vala"
	_g_object_unref0 (self->priv->hooked_collections);
#line 275 "../src/Commands.vala"
	G_OBJECT_CLASS (multiple_data_source_command_parent_class)->finalize (obj);
#line 6310 "Commands.c"
}

static GType
multiple_data_source_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MultipleDataSourceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multiple_data_source_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultipleDataSourceCommand), 0, (GInstanceInitFunc) multiple_data_source_command_instance_init, NULL };
	GType multiple_data_source_command_type_id;
	multiple_data_source_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "MultipleDataSourceCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MultipleDataSourceCommand_private_offset = g_type_add_instance_private (multiple_data_source_command_type_id, sizeof (MultipleDataSourceCommandPrivate));
	return multiple_data_source_command_type_id;
}

GType
multiple_data_source_command_get_type (void)
{
	static volatile gsize multiple_data_source_command_type_id__once = 0;
	if (g_once_init_enter (&multiple_data_source_command_type_id__once)) {
		GType multiple_data_source_command_type_id;
		multiple_data_source_command_type_id = multiple_data_source_command_get_type_once ();
		g_once_init_leave (&multiple_data_source_command_type_id__once, multiple_data_source_command_type_id);
	}
	return multiple_data_source_command_type_id__once;
}

static inline gpointer
multiple_data_source_at_once_command_get_instance_private (MultipleDataSourceAtOnceCommand* self)
{
	return G_STRUCT_MEMBER_P (self, MultipleDataSourceAtOnceCommand_private_offset);
}

static void
_multiple_data_source_at_once_command_on_sources_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                                              GeeCollection* destroyed,
                                                                                              gpointer self)
{
#line 435 "../src/Commands.vala"
	multiple_data_source_at_once_command_on_sources_destroyed ((MultipleDataSourceAtOnceCommand*) self, destroyed);
#line 6348 "Commands.c"
}

MultipleDataSourceAtOnceCommand*
multiple_data_source_at_once_command_construct (GType object_type,
                                                GeeCollection* sources,
                                                const gchar* name,
                                                const gchar* explanation)
{
	MultipleDataSourceAtOnceCommand * self = NULL;
	GeeHashSet* _tmp0_;
#line 417 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 417 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 417 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 419 "../src/Commands.vala"
	self = (MultipleDataSourceAtOnceCommand*) page_command_construct (object_type, name, explanation);
#line 421 "../src/Commands.vala"
	_tmp0_ = self->priv->sources;
#line 421 "../src/Commands.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), sources);
#line 6371 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeHashSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 423 "../src/Commands.vala"
		_tmp1_ = self->priv->sources;
#line 423 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 423 "../src/Commands.vala"
		_source_it = _tmp2_;
#line 423 "../src/Commands.vala"
		while (TRUE) {
#line 6384 "Commands.c"
			GeeIterator* _tmp3_;
			DataSource* source = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			SourceCollection* membership = NULL;
			DataSource* _tmp6_;
			DataCollection* _tmp7_;
			SourceCollection* _tmp8_;
			SourceCollection* _tmp9_;
#line 423 "../src/Commands.vala"
			_tmp3_ = _source_it;
#line 423 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 423 "../src/Commands.vala"
				break;
#line 6400 "Commands.c"
			}
#line 423 "../src/Commands.vala"
			_tmp4_ = _source_it;
#line 423 "../src/Commands.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 423 "../src/Commands.vala"
			source = (DataSource*) _tmp5_;
#line 424 "../src/Commands.vala"
			_tmp6_ = source;
#line 424 "../src/Commands.vala"
			_tmp7_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_OBJECT, DataObject));
#line 424 "../src/Commands.vala"
			_tmp8_ = IS_SOURCE_COLLECTION (_tmp7_) ? ((SourceCollection*) _tmp7_) : NULL;
#line 424 "../src/Commands.vala"
			if (_tmp8_ == NULL) {
#line 424 "../src/Commands.vala"
				_data_collection_unref0 (_tmp7_);
#line 6418 "Commands.c"
			}
#line 424 "../src/Commands.vala"
			membership = _tmp8_;
#line 425 "../src/Commands.vala"
			_tmp9_ = membership;
#line 425 "../src/Commands.vala"
			if (_tmp9_ != NULL) {
#line 6426 "Commands.c"
				GeeHashSet* _tmp10_;
				SourceCollection* _tmp11_;
#line 426 "../src/Commands.vala"
				_tmp10_ = self->priv->hooked_collections;
#line 426 "../src/Commands.vala"
				_tmp11_ = membership;
#line 426 "../src/Commands.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp11_);
#line 6435 "Commands.c"
			}
#line 423 "../src/Commands.vala"
			_data_collection_unref0 (membership);
#line 423 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 6441 "Commands.c"
		}
#line 423 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 6445 "Commands.c"
	}
	{
		GeeIterator* _source_collection_it = NULL;
		GeeHashSet* _tmp12_;
		GeeIterator* _tmp13_;
#line 429 "../src/Commands.vala"
		_tmp12_ = self->priv->hooked_collections;
#line 429 "../src/Commands.vala"
		_tmp13_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 429 "../src/Commands.vala"
		_source_collection_it = _tmp13_;
#line 429 "../src/Commands.vala"
		while (TRUE) {
#line 6459 "Commands.c"
			GeeIterator* _tmp14_;
			SourceCollection* source_collection = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			SourceCollection* _tmp17_;
#line 429 "../src/Commands.vala"
			_tmp14_ = _source_collection_it;
#line 429 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 429 "../src/Commands.vala"
				break;
#line 6471 "Commands.c"
			}
#line 429 "../src/Commands.vala"
			_tmp15_ = _source_collection_it;
#line 429 "../src/Commands.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 429 "../src/Commands.vala"
			source_collection = (SourceCollection*) _tmp16_;
#line 430 "../src/Commands.vala"
			_tmp17_ = source_collection;
#line 430 "../src/Commands.vala"
			g_signal_connect_object (_tmp17_, "items-destroyed", (GCallback) _multiple_data_source_at_once_command_on_sources_destroyed_source_collection_items_destroyed, self, 0);
#line 429 "../src/Commands.vala"
			_data_collection_unref0 (source_collection);
#line 6485 "Commands.c"
		}
#line 429 "../src/Commands.vala"
		_g_object_unref0 (_source_collection_it);
#line 6489 "Commands.c"
	}
#line 417 "../src/Commands.vala"
	return self;
#line 6493 "Commands.c"
}

static void
multiple_data_source_at_once_command_real_execute (Command* base)
{
	MultipleDataSourceAtOnceCommand * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	MediaCollectionRegistry* _tmp2_;
	MediaCollectionRegistry* _tmp3_;
	GeeHashSet* _tmp4_;
	MediaCollectionRegistry* _tmp5_;
	MediaCollectionRegistry* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 438 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommand);
#line 439 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 439 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 439 "../src/Commands.vala"
	page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 439 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 441 "../src/Commands.vala"
	database_table_begin_transaction ();
#line 442 "../src/Commands.vala"
	_tmp2_ = media_collection_registry_get_instance ();
#line 442 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 442 "../src/Commands.vala"
	media_collection_registry_freeze_all (_tmp3_);
#line 442 "../src/Commands.vala"
	_media_collection_registry_unref0 (_tmp3_);
#line 444 "../src/Commands.vala"
	_tmp4_ = self->priv->sources;
#line 444 "../src/Commands.vala"
	multiple_data_source_at_once_command_execute_on_all (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 446 "../src/Commands.vala"
	_tmp5_ = media_collection_registry_get_instance ();
#line 446 "../src/Commands.vala"
	_tmp6_ = _tmp5_;
#line 446 "../src/Commands.vala"
	media_collection_registry_thaw_all (_tmp6_);
#line 446 "../src/Commands.vala"
	_media_collection_registry_unref0 (_tmp6_);
#line 6540 "Commands.c"
	{
#line 448 "../src/Commands.vala"
		database_table_commit_transaction (&_inner_error0_);
#line 448 "../src/Commands.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 448 "../src/Commands.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6548 "Commands.c"
				goto __catch0_database_error;
			}
#line 448 "../src/Commands.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 448 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 448 "../src/Commands.vala"
			return;
#line 6557 "Commands.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
#line 447 "../src/Commands.vala"
		err = _inner_error0_;
#line 447 "../src/Commands.vala"
		_inner_error0_ = NULL;
#line 450 "../src/Commands.vala"
		_tmp7_ = err;
#line 450 "../src/Commands.vala"
		app_window_database_error (_tmp7_);
#line 447 "../src/Commands.vala"
		_g_error_free0 (err);
#line 6575 "Commands.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		AppWindow* _tmp8_;
		AppWindow* _tmp9_;
#line 452 "../src/Commands.vala"
		_tmp8_ = app_window_get_instance ();
#line 452 "../src/Commands.vala"
		_tmp9_ = _tmp8_;
#line 452 "../src/Commands.vala"
		page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PAGE_WINDOW, PageWindow));
#line 452 "../src/Commands.vala"
		_g_object_unref0 (_tmp9_);
#line 6590 "Commands.c"
	}
#line 447 "../src/Commands.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 447 "../src/Commands.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 447 "../src/Commands.vala"
		g_clear_error (&_inner_error0_);
#line 447 "../src/Commands.vala"
		return;
#line 6600 "Commands.c"
	}
}

static void
multiple_data_source_at_once_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* self,
                                                          GeeCollection* sources)
{
#line 456 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `multiple_data_source_at_once_command_execute_on_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 456 "../src/Commands.vala"
	return;
#line 6612 "Commands.c"
}

void
multiple_data_source_at_once_command_execute_on_all (MultipleDataSourceAtOnceCommand* self,
                                                     GeeCollection* sources)
{
	MultipleDataSourceAtOnceCommandClass* _klass_;
#line 456 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND (self));
#line 456 "../src/Commands.vala"
	_klass_ = MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_GET_CLASS (self);
#line 456 "../src/Commands.vala"
	if (_klass_->execute_on_all) {
#line 456 "../src/Commands.vala"
		_klass_->execute_on_all (self, sources);
#line 6628 "Commands.c"
	}
}

static void
multiple_data_source_at_once_command_real_undo (Command* base)
{
	MultipleDataSourceAtOnceCommand * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	MediaCollectionRegistry* _tmp2_;
	MediaCollectionRegistry* _tmp3_;
	GeeHashSet* _tmp4_;
	MediaCollectionRegistry* _tmp5_;
	MediaCollectionRegistry* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 458 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommand);
#line 459 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 459 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 459 "../src/Commands.vala"
	page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 459 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 461 "../src/Commands.vala"
	database_table_begin_transaction ();
#line 462 "../src/Commands.vala"
	_tmp2_ = media_collection_registry_get_instance ();
#line 462 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 462 "../src/Commands.vala"
	media_collection_registry_freeze_all (_tmp3_);
#line 462 "../src/Commands.vala"
	_media_collection_registry_unref0 (_tmp3_);
#line 464 "../src/Commands.vala"
	_tmp4_ = self->priv->sources;
#line 464 "../src/Commands.vala"
	multiple_data_source_at_once_command_undo_on_all (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 466 "../src/Commands.vala"
	_tmp5_ = media_collection_registry_get_instance ();
#line 466 "../src/Commands.vala"
	_tmp6_ = _tmp5_;
#line 466 "../src/Commands.vala"
	media_collection_registry_thaw_all (_tmp6_);
#line 466 "../src/Commands.vala"
	_media_collection_registry_unref0 (_tmp6_);
#line 6676 "Commands.c"
	{
#line 468 "../src/Commands.vala"
		database_table_commit_transaction (&_inner_error0_);
#line 468 "../src/Commands.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 468 "../src/Commands.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 6684 "Commands.c"
				goto __catch0_database_error;
			}
#line 468 "../src/Commands.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 468 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 468 "../src/Commands.vala"
			return;
#line 6693 "Commands.c"
		}
	}
	goto __finally0;
	__catch0_database_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
#line 467 "../src/Commands.vala"
		err = _inner_error0_;
#line 467 "../src/Commands.vala"
		_inner_error0_ = NULL;
#line 470 "../src/Commands.vala"
		_tmp7_ = err;
#line 470 "../src/Commands.vala"
		app_window_database_error (_tmp7_);
#line 467 "../src/Commands.vala"
		_g_error_free0 (err);
#line 6711 "Commands.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
		AppWindow* _tmp8_;
		AppWindow* _tmp9_;
#line 472 "../src/Commands.vala"
		_tmp8_ = app_window_get_instance ();
#line 472 "../src/Commands.vala"
		_tmp9_ = _tmp8_;
#line 472 "../src/Commands.vala"
		page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PAGE_WINDOW, PageWindow));
#line 472 "../src/Commands.vala"
		_g_object_unref0 (_tmp9_);
#line 6726 "Commands.c"
	}
#line 467 "../src/Commands.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 467 "../src/Commands.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 467 "../src/Commands.vala"
		g_clear_error (&_inner_error0_);
#line 467 "../src/Commands.vala"
		return;
#line 6736 "Commands.c"
	}
}

static void
multiple_data_source_at_once_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* self,
                                                       GeeCollection* sources)
{
#line 476 "../src/Commands.vala"
	g_critical ("Type `%s' does not implement abstract method `multiple_data_source_at_once_command_undo_on_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 476 "../src/Commands.vala"
	return;
#line 6748 "Commands.c"
}

void
multiple_data_source_at_once_command_undo_on_all (MultipleDataSourceAtOnceCommand* self,
                                                  GeeCollection* sources)
{
	MultipleDataSourceAtOnceCommandClass* _klass_;
#line 476 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND (self));
#line 476 "../src/Commands.vala"
	_klass_ = MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND_GET_CLASS (self);
#line 476 "../src/Commands.vala"
	if (_klass_->undo_on_all) {
#line 476 "../src/Commands.vala"
		_klass_->undo_on_all (self, sources);
#line 6764 "Commands.c"
	}
}

static void
multiple_data_source_at_once_command_on_sources_destroyed (MultipleDataSourceAtOnceCommand* self,
                                                           GeeCollection* destroyed)
{
#line 478 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND (self));
#line 478 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destroyed, GEE_TYPE_COLLECTION));
#line 6776 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 479 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (destroyed, GEE_TYPE_ITERABLE, GeeIterable));
#line 479 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 479 "../src/Commands.vala"
		while (TRUE) {
#line 6786 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashSet* _tmp4_;
			DataSource* _tmp5_;
#line 479 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 479 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 479 "../src/Commands.vala"
				break;
#line 6799 "Commands.c"
			}
#line 479 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 479 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 479 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 480 "../src/Commands.vala"
			_tmp4_ = self->priv->sources;
#line 480 "../src/Commands.vala"
			_tmp5_ = source;
#line 480 "../src/Commands.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp5_)) {
#line 6813 "Commands.c"
				CommandManager* _tmp6_;
				CommandManager* _tmp7_;
#line 481 "../src/Commands.vala"
				_tmp6_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 481 "../src/Commands.vala"
				_tmp7_ = _tmp6_;
#line 481 "../src/Commands.vala"
				command_manager_reset (_tmp7_);
#line 481 "../src/Commands.vala"
				_command_manager_unref0 (_tmp7_);
#line 483 "../src/Commands.vala"
				_g_object_unref0 (source);
#line 483 "../src/Commands.vala"
				break;
#line 6828 "Commands.c"
			}
#line 479 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 6832 "Commands.c"
		}
#line 479 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 6836 "Commands.c"
	}
}

static void
multiple_data_source_at_once_command_class_init (MultipleDataSourceAtOnceCommandClass * klass,
                                                 gpointer klass_data)
{
#line 413 "../src/Commands.vala"
	multiple_data_source_at_once_command_parent_class = g_type_class_peek_parent (klass);
#line 413 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &MultipleDataSourceAtOnceCommand_private_offset);
#line 413 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) multiple_data_source_at_once_command_real_execute;
#line 413 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->execute_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) multiple_data_source_at_once_command_real_execute_on_all;
#line 413 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) multiple_data_source_at_once_command_real_undo;
#line 413 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->undo_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) multiple_data_source_at_once_command_real_undo_on_all;
#line 413 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = multiple_data_source_at_once_command_finalize;
#line 6858 "Commands.c"
}

static void
multiple_data_source_at_once_command_instance_init (MultipleDataSourceAtOnceCommand * self,
                                                    gpointer klass)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
#line 413 "../src/Commands.vala"
	self->priv = multiple_data_source_at_once_command_get_instance_private (self);
#line 414 "../src/Commands.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 414 "../src/Commands.vala"
	self->priv->sources = _tmp0_;
#line 415 "../src/Commands.vala"
	_tmp1_ = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 415 "../src/Commands.vala"
	self->priv->hooked_collections = _tmp1_;
#line 6877 "Commands.c"
}

static void
multiple_data_source_at_once_command_finalize (GObject * obj)
{
	MultipleDataSourceAtOnceCommand * self;
#line 413 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, MultipleDataSourceAtOnceCommand);
#line 6886 "Commands.c"
	{
		GeeIterator* _source_collection_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 434 "../src/Commands.vala"
		_tmp0_ = self->priv->hooked_collections;
#line 434 "../src/Commands.vala"
		_tmp1_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 434 "../src/Commands.vala"
		_source_collection_it = _tmp1_;
#line 434 "../src/Commands.vala"
		while (TRUE) {
#line 6899 "Commands.c"
			GeeIterator* _tmp2_;
			SourceCollection* source_collection = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			SourceCollection* _tmp5_;
			guint _tmp6_;
#line 434 "../src/Commands.vala"
			_tmp2_ = _source_collection_it;
#line 434 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 434 "../src/Commands.vala"
				break;
#line 6912 "Commands.c"
			}
#line 434 "../src/Commands.vala"
			_tmp3_ = _source_collection_it;
#line 434 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 434 "../src/Commands.vala"
			source_collection = (SourceCollection*) _tmp4_;
#line 435 "../src/Commands.vala"
			_tmp5_ = source_collection;
#line 435 "../src/Commands.vala"
			g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 435 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _multiple_data_source_at_once_command_on_sources_destroyed_source_collection_items_destroyed, self);
#line 434 "../src/Commands.vala"
			_data_collection_unref0 (source_collection);
#line 6928 "Commands.c"
		}
#line 434 "../src/Commands.vala"
		_g_object_unref0 (_source_collection_it);
#line 6932 "Commands.c"
	}
#line 414 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources);
#line 415 "../src/Commands.vala"
	_g_object_unref0 (self->priv->hooked_collections);
#line 413 "../src/Commands.vala"
	G_OBJECT_CLASS (multiple_data_source_at_once_command_parent_class)->finalize (obj);
#line 6940 "Commands.c"
}

static GType
multiple_data_source_at_once_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MultipleDataSourceAtOnceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multiple_data_source_at_once_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultipleDataSourceAtOnceCommand), 0, (GInstanceInitFunc) multiple_data_source_at_once_command_instance_init, NULL };
	GType multiple_data_source_at_once_command_type_id;
	multiple_data_source_at_once_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "MultipleDataSourceAtOnceCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MultipleDataSourceAtOnceCommand_private_offset = g_type_add_instance_private (multiple_data_source_at_once_command_type_id, sizeof (MultipleDataSourceAtOnceCommandPrivate));
	return multiple_data_source_at_once_command_type_id;
}

GType
multiple_data_source_at_once_command_get_type (void)
{
	static volatile gsize multiple_data_source_at_once_command_type_id__once = 0;
	if (g_once_init_enter (&multiple_data_source_at_once_command_type_id__once)) {
		GType multiple_data_source_at_once_command_type_id;
		multiple_data_source_at_once_command_type_id = multiple_data_source_at_once_command_get_type_once ();
		g_once_init_leave (&multiple_data_source_at_once_command_type_id__once, multiple_data_source_at_once_command_type_id);
	}
	return multiple_data_source_at_once_command_type_id__once;
}

static inline gpointer
multiple_photo_transformation_command_get_instance_private (MultiplePhotoTransformationCommand* self)
{
	return G_STRUCT_MEMBER_P (self, MultiplePhotoTransformationCommand_private_offset);
}

static void
_multiple_photo_transformation_command_on_state_broken_photo_transformation_state_broken (PhotoTransformationState* _sender,
                                                                                          gpointer self)
{
#line 508 "../src/Commands.vala"
	multiple_photo_transformation_command_on_state_broken ((MultiplePhotoTransformationCommand*) self);
#line 6977 "Commands.c"
}

MultiplePhotoTransformationCommand*
multiple_photo_transformation_command_construct (GType object_type,
                                                 GeeIterable* iter,
                                                 const gchar* progress_text,
                                                 const gchar* undo_progress_text,
                                                 const gchar* name,
                                                 const gchar* explanation)
{
	MultiplePhotoTransformationCommand * self = NULL;
#line 493 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 493 "../src/Commands.vala"
	g_return_val_if_fail (progress_text != NULL, NULL);
#line 493 "../src/Commands.vala"
	g_return_val_if_fail (undo_progress_text != NULL, NULL);
#line 493 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 493 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 495 "../src/Commands.vala"
	self = (MultiplePhotoTransformationCommand*) multiple_data_source_command_construct (object_type, iter, progress_text, undo_progress_text, name, explanation);
#line 7001 "Commands.c"
	{
		GeeArrayList* _source_list = NULL;
		GeeArrayList* _tmp0_;
		gint _source_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _source_index = 0;
#line 497 "../src/Commands.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand)->source_list;
#line 497 "../src/Commands.vala"
		_source_list = _tmp0_;
#line 497 "../src/Commands.vala"
		_tmp1_ = _source_list;
#line 497 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 497 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 497 "../src/Commands.vala"
		_source_size = _tmp3_;
#line 497 "../src/Commands.vala"
		_source_index = -1;
#line 497 "../src/Commands.vala"
		while (TRUE) {
#line 7026 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			DataSource* source = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Photo* photo = NULL;
			DataSource* _tmp8_;
			Photo* _tmp9_;
			PhotoTransformationState* state = NULL;
			Photo* _tmp10_;
			PhotoTransformationState* _tmp11_;
			PhotoTransformationState* _tmp12_;
			GeeHashMap* _tmp13_;
			Photo* _tmp14_;
			PhotoTransformationState* _tmp15_;
#line 497 "../src/Commands.vala"
			_source_index = _source_index + 1;
#line 497 "../src/Commands.vala"
			_tmp4_ = _source_index;
#line 497 "../src/Commands.vala"
			_tmp5_ = _source_size;
#line 497 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 497 "../src/Commands.vala"
				break;
#line 7052 "Commands.c"
			}
#line 497 "../src/Commands.vala"
			_tmp6_ = _source_list;
#line 497 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _source_index);
#line 497 "../src/Commands.vala"
			source = (DataSource*) _tmp7_;
#line 498 "../src/Commands.vala"
			_tmp8_ = source;
#line 498 "../src/Commands.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_PHOTO, Photo));
#line 498 "../src/Commands.vala"
			photo = _tmp9_;
#line 499 "../src/Commands.vala"
			_tmp10_ = photo;
#line 499 "../src/Commands.vala"
			_tmp11_ = photo_save_transformation_state (_tmp10_);
#line 499 "../src/Commands.vala"
			state = _tmp11_;
#line 500 "../src/Commands.vala"
			_tmp12_ = state;
#line 500 "../src/Commands.vala"
			g_signal_connect_object (_tmp12_, "broken", (GCallback) _multiple_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self, 0);
#line 502 "../src/Commands.vala"
			_tmp13_ = self->priv->map;
#line 502 "../src/Commands.vala"
			_tmp14_ = photo;
#line 502 "../src/Commands.vala"
			_tmp15_ = state;
#line 502 "../src/Commands.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, _tmp15_);
#line 497 "../src/Commands.vala"
			_g_object_unref0 (state);
#line 497 "../src/Commands.vala"
			_g_object_unref0 (photo);
#line 497 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 7090 "Commands.c"
		}
	}
#line 493 "../src/Commands.vala"
	return self;
#line 7095 "Commands.c"
}

static void
multiple_photo_transformation_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                           DataSource* source)
{
	MultiplePhotoTransformationCommand * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	PhotoTransformationState* state = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
#line 511 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, MultiplePhotoTransformationCommand);
#line 511 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 512 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo));
#line 512 "../src/Commands.vala"
	photo = _tmp0_;
#line 514 "../src/Commands.vala"
	_tmp1_ = self->priv->map;
#line 514 "../src/Commands.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), photo);
#line 514 "../src/Commands.vala"
	state = (PhotoTransformationState*) _tmp2_;
#line 515 "../src/Commands.vala"
	_vala_assert (state != NULL, "state != null");
#line 517 "../src/Commands.vala"
	photo_load_transformation_state (photo, state);
#line 511 "../src/Commands.vala"
	_g_object_unref0 (state);
#line 511 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 7130 "Commands.c"
}

static void
multiple_photo_transformation_command_on_state_broken (MultiplePhotoTransformationCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 520 "../src/Commands.vala"
	g_return_if_fail (IS_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND (self));
#line 521 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 521 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 521 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 521 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 7148 "Commands.c"
}

static void
multiple_photo_transformation_command_class_init (MultiplePhotoTransformationCommandClass * klass,
                                                  gpointer klass_data)
{
#line 489 "../src/Commands.vala"
	multiple_photo_transformation_command_parent_class = g_type_class_peek_parent (klass);
#line 489 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &MultiplePhotoTransformationCommand_private_offset);
#line 489 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) multiple_photo_transformation_command_real_undo_on_source;
#line 489 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = multiple_photo_transformation_command_finalize;
#line 7163 "Commands.c"
}

static void
multiple_photo_transformation_command_instance_init (MultiplePhotoTransformationCommand * self,
                                                     gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 489 "../src/Commands.vala"
	self->priv = multiple_photo_transformation_command_get_instance_private (self);
#line 490 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_PHOTO_TRANSFORMATION_STATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 490 "../src/Commands.vala"
	self->priv->map = _tmp0_;
#line 7177 "Commands.c"
}

static void
multiple_photo_transformation_command_finalize (GObject * obj)
{
	MultiplePhotoTransformationCommand * self;
#line 489 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, MultiplePhotoTransformationCommand);
#line 7186 "Commands.c"
	{
		GeeIterator* _state_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 507 "../src/Commands.vala"
		_tmp0_ = self->priv->map;
#line 507 "../src/Commands.vala"
		_tmp1_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 507 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 507 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 507 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 507 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 507 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 507 "../src/Commands.vala"
		_state_it = _tmp5_;
#line 507 "../src/Commands.vala"
		while (TRUE) {
#line 7213 "Commands.c"
			GeeIterator* _tmp6_;
			PhotoTransformationState* state = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			PhotoTransformationState* _tmp9_;
			guint _tmp10_;
#line 507 "../src/Commands.vala"
			_tmp6_ = _state_it;
#line 507 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 507 "../src/Commands.vala"
				break;
#line 7226 "Commands.c"
			}
#line 507 "../src/Commands.vala"
			_tmp7_ = _state_it;
#line 507 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 507 "../src/Commands.vala"
			state = (PhotoTransformationState*) _tmp8_;
#line 508 "../src/Commands.vala"
			_tmp9_ = state;
#line 508 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, &_tmp10_, NULL, FALSE);
#line 508 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _multiple_photo_transformation_command_on_state_broken_photo_transformation_state_broken, self);
#line 507 "../src/Commands.vala"
			_g_object_unref0 (state);
#line 7242 "Commands.c"
		}
#line 507 "../src/Commands.vala"
		_g_object_unref0 (_state_it);
#line 7246 "Commands.c"
	}
#line 490 "../src/Commands.vala"
	_g_object_unref0 (self->priv->map);
#line 489 "../src/Commands.vala"
	G_OBJECT_CLASS (multiple_photo_transformation_command_parent_class)->finalize (obj);
#line 7252 "Commands.c"
}

static GType
multiple_photo_transformation_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MultiplePhotoTransformationCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multiple_photo_transformation_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultiplePhotoTransformationCommand), 0, (GInstanceInitFunc) multiple_photo_transformation_command_instance_init, NULL };
	GType multiple_photo_transformation_command_type_id;
	multiple_photo_transformation_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "MultiplePhotoTransformationCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MultiplePhotoTransformationCommand_private_offset = g_type_add_instance_private (multiple_photo_transformation_command_type_id, sizeof (MultiplePhotoTransformationCommandPrivate));
	return multiple_photo_transformation_command_type_id;
}

GType
multiple_photo_transformation_command_get_type (void)
{
	static volatile gsize multiple_photo_transformation_command_type_id__once = 0;
	if (g_once_init_enter (&multiple_photo_transformation_command_type_id__once)) {
		GType multiple_photo_transformation_command_type_id;
		multiple_photo_transformation_command_type_id = multiple_photo_transformation_command_get_type_once ();
		g_once_init_leave (&multiple_photo_transformation_command_type_id__once, multiple_photo_transformation_command_type_id);
	}
	return multiple_photo_transformation_command_type_id__once;
}

static inline gpointer
rotate_single_command_get_instance_private (RotateSingleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RotateSingleCommand_private_offset);
}

RotateSingleCommand*
rotate_single_command_construct (GType object_type,
                                 Photo* photo,
                                 Rotation rotation,
                                 const gchar* name,
                                 const gchar* explanation)
{
	RotateSingleCommand * self = NULL;
#line 528 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 528 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 528 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 529 "../src/Commands.vala"
	self = (RotateSingleCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_DATA_SOURCE, DataSource), name, explanation);
#line 531 "../src/Commands.vala"
	self->priv->rotation = rotation;
#line 528 "../src/Commands.vala"
	return self;
#line 7303 "Commands.c"
}

RotateSingleCommand*
rotate_single_command_new (Photo* photo,
                           Rotation rotation,
                           const gchar* name,
                           const gchar* explanation)
{
#line 528 "../src/Commands.vala"
	return rotate_single_command_construct (TYPE_ROTATE_SINGLE_COMMAND, photo, rotation, name, explanation);
#line 7314 "Commands.c"
}

static void
rotate_single_command_real_execute (Command* base)
{
	RotateSingleCommand * self;
	DataSource* _tmp0_;
#line 534 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommand);
#line 535 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 535 "../src/Commands.vala"
	photo_rotate (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo), self->priv->rotation);
#line 7328 "Commands.c"
}

static void
rotate_single_command_real_undo (Command* base)
{
	RotateSingleCommand * self;
	DataSource* _tmp0_;
#line 538 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommand);
#line 539 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 539 "../src/Commands.vala"
	photo_rotate (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_PHOTO, Photo), rotation_opposite (self->priv->rotation));
#line 7342 "Commands.c"
}

static void
rotate_single_command_class_init (RotateSingleCommandClass * klass,
                                  gpointer klass_data)
{
#line 525 "../src/Commands.vala"
	rotate_single_command_parent_class = g_type_class_peek_parent (klass);
#line 525 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RotateSingleCommand_private_offset);
#line 525 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) rotate_single_command_real_execute;
#line 525 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) rotate_single_command_real_undo;
#line 525 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rotate_single_command_finalize;
#line 7359 "Commands.c"
}

static void
rotate_single_command_instance_init (RotateSingleCommand * self,
                                     gpointer klass)
{
#line 525 "../src/Commands.vala"
	self->priv = rotate_single_command_get_instance_private (self);
#line 7368 "Commands.c"
}

static void
rotate_single_command_finalize (GObject * obj)
{
	RotateSingleCommand * self;
#line 525 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ROTATE_SINGLE_COMMAND, RotateSingleCommand);
#line 525 "../src/Commands.vala"
	G_OBJECT_CLASS (rotate_single_command_parent_class)->finalize (obj);
#line 7379 "Commands.c"
}

static GType
rotate_single_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RotateSingleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rotate_single_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RotateSingleCommand), 0, (GInstanceInitFunc) rotate_single_command_instance_init, NULL };
	GType rotate_single_command_type_id;
	rotate_single_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "RotateSingleCommand", &g_define_type_info, 0);
	RotateSingleCommand_private_offset = g_type_add_instance_private (rotate_single_command_type_id, sizeof (RotateSingleCommandPrivate));
	return rotate_single_command_type_id;
}

GType
rotate_single_command_get_type (void)
{
	static volatile gsize rotate_single_command_type_id__once = 0;
	if (g_once_init_enter (&rotate_single_command_type_id__once)) {
		GType rotate_single_command_type_id;
		rotate_single_command_type_id = rotate_single_command_get_type_once ();
		g_once_init_leave (&rotate_single_command_type_id__once, rotate_single_command_type_id);
	}
	return rotate_single_command_type_id__once;
}

static inline gpointer
rotate_multiple_command_get_instance_private (RotateMultipleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RotateMultipleCommand_private_offset);
}

RotateMultipleCommand*
rotate_multiple_command_construct (GType object_type,
                                   GeeIterable* iter,
                                   Rotation rotation,
                                   const gchar* name,
                                   const gchar* explanation,
                                   const gchar* progress_text,
                                   const gchar* undo_progress_text)
{
	RotateMultipleCommand * self = NULL;
#line 546 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 546 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 546 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 546 "../src/Commands.vala"
	g_return_val_if_fail (progress_text != NULL, NULL);
#line 546 "../src/Commands.vala"
	g_return_val_if_fail (undo_progress_text != NULL, NULL);
#line 548 "../src/Commands.vala"
	self = (RotateMultipleCommand*) multiple_data_source_command_construct (object_type, iter, progress_text, undo_progress_text, name, explanation);
#line 550 "../src/Commands.vala"
	self->priv->rotation = rotation;
#line 546 "../src/Commands.vala"
	return self;
#line 7436 "Commands.c"
}

RotateMultipleCommand*
rotate_multiple_command_new (GeeIterable* iter,
                             Rotation rotation,
                             const gchar* name,
                             const gchar* explanation,
                             const gchar* progress_text,
                             const gchar* undo_progress_text)
{
#line 546 "../src/Commands.vala"
	return rotate_multiple_command_construct (TYPE_ROTATE_MULTIPLE_COMMAND, iter, rotation, name, explanation, progress_text, undo_progress_text);
#line 7449 "Commands.c"
}

static void
rotate_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                DataSource* source)
{
	RotateMultipleCommand * self;
#line 553 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommand);
#line 553 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 554 "../src/Commands.vala"
	photo_rotate (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo), self->priv->rotation);
#line 7463 "Commands.c"
}

static void
rotate_multiple_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                             DataSource* source)
{
	RotateMultipleCommand * self;
#line 557 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommand);
#line 557 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 558 "../src/Commands.vala"
	photo_rotate (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo), rotation_opposite (self->priv->rotation));
#line 7477 "Commands.c"
}

static void
rotate_multiple_command_class_init (RotateMultipleCommandClass * klass,
                                    gpointer klass_data)
{
#line 543 "../src/Commands.vala"
	rotate_multiple_command_parent_class = g_type_class_peek_parent (klass);
#line 543 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RotateMultipleCommand_private_offset);
#line 543 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) rotate_multiple_command_real_execute_on_source;
#line 543 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) rotate_multiple_command_real_undo_on_source;
#line 543 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rotate_multiple_command_finalize;
#line 7494 "Commands.c"
}

static void
rotate_multiple_command_instance_init (RotateMultipleCommand * self,
                                       gpointer klass)
{
#line 543 "../src/Commands.vala"
	self->priv = rotate_multiple_command_get_instance_private (self);
#line 7503 "Commands.c"
}

static void
rotate_multiple_command_finalize (GObject * obj)
{
	RotateMultipleCommand * self;
#line 543 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ROTATE_MULTIPLE_COMMAND, RotateMultipleCommand);
#line 543 "../src/Commands.vala"
	G_OBJECT_CLASS (rotate_multiple_command_parent_class)->finalize (obj);
#line 7514 "Commands.c"
}

static GType
rotate_multiple_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RotateMultipleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rotate_multiple_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RotateMultipleCommand), 0, (GInstanceInitFunc) rotate_multiple_command_instance_init, NULL };
	GType rotate_multiple_command_type_id;
	rotate_multiple_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "RotateMultipleCommand", &g_define_type_info, 0);
	RotateMultipleCommand_private_offset = g_type_add_instance_private (rotate_multiple_command_type_id, sizeof (RotateMultipleCommandPrivate));
	return rotate_multiple_command_type_id;
}

GType
rotate_multiple_command_get_type (void)
{
	static volatile gsize rotate_multiple_command_type_id__once = 0;
	if (g_once_init_enter (&rotate_multiple_command_type_id__once)) {
		GType rotate_multiple_command_type_id;
		rotate_multiple_command_type_id = rotate_multiple_command_get_type_once ();
		g_once_init_leave (&rotate_multiple_command_type_id__once, rotate_multiple_command_type_id);
	}
	return rotate_multiple_command_type_id__once;
}

static inline gpointer
edit_title_command_get_instance_private (EditTitleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditTitleCommand_private_offset);
}

EditTitleCommand*
edit_title_command_construct (GType object_type,
                              MediaSource* source,
                              const gchar* new_title)
{
	EditTitleCommand * self = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 566 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (source), NULL);
#line 566 "../src/Commands.vala"
	g_return_val_if_fail (new_title != NULL, NULL);
#line 567 "../src/Commands.vala"
	_tmp0_ = g_strdup (g_dpgettext2 (NULL, "Button Label", RESOURCES_EDIT_TITLE_LABEL));
#line 567 "../src/Commands.vala"
	title = _tmp0_;
#line 569 "../src/Commands.vala"
	self = (EditTitleCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATA_SOURCE, DataSource), title, "");
#line 571 "../src/Commands.vala"
	_tmp1_ = g_strdup (new_title);
#line 571 "../src/Commands.vala"
	_g_free0 (self->priv->new_title);
#line 571 "../src/Commands.vala"
	self->priv->new_title = _tmp1_;
#line 572 "../src/Commands.vala"
	_tmp2_ = media_source_get_title (source);
#line 572 "../src/Commands.vala"
	_g_free0 (self->priv->old_title);
#line 572 "../src/Commands.vala"
	self->priv->old_title = _tmp2_;
#line 566 "../src/Commands.vala"
	_g_free0 (title);
#line 566 "../src/Commands.vala"
	return self;
#line 7581 "Commands.c"
}

EditTitleCommand*
edit_title_command_new (MediaSource* source,
                        const gchar* new_title)
{
#line 566 "../src/Commands.vala"
	return edit_title_command_construct (TYPE_EDIT_TITLE_COMMAND, source, new_title);
#line 7590 "Commands.c"
}

static void
edit_title_command_real_execute (Command* base)
{
	EditTitleCommand * self;
	DataSource* _tmp0_;
	const gchar* _tmp1_;
#line 575 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_TITLE_COMMAND, EditTitleCommand);
#line 576 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 576 "../src/Commands.vala"
	_tmp1_ = self->priv->new_title;
#line 576 "../src/Commands.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), _tmp1_);
#line 7607 "Commands.c"
}

static void
edit_title_command_real_undo (Command* base)
{
	EditTitleCommand * self;
	DataSource* _tmp0_;
	const gchar* _tmp1_;
#line 579 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_TITLE_COMMAND, EditTitleCommand);
#line 580 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 580 "../src/Commands.vala"
	_tmp1_ = self->priv->old_title;
#line 580 "../src/Commands.vala"
	media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), _tmp1_);
#line 7624 "Commands.c"
}

static void
edit_title_command_class_init (EditTitleCommandClass * klass,
                               gpointer klass_data)
{
#line 562 "../src/Commands.vala"
	edit_title_command_parent_class = g_type_class_peek_parent (klass);
#line 562 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &EditTitleCommand_private_offset);
#line 562 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) edit_title_command_real_execute;
#line 562 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) edit_title_command_real_undo;
#line 562 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = edit_title_command_finalize;
#line 7641 "Commands.c"
}

static void
edit_title_command_instance_init (EditTitleCommand * self,
                                  gpointer klass)
{
#line 562 "../src/Commands.vala"
	self->priv = edit_title_command_get_instance_private (self);
#line 7650 "Commands.c"
}

static void
edit_title_command_finalize (GObject * obj)
{
	EditTitleCommand * self;
#line 562 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDIT_TITLE_COMMAND, EditTitleCommand);
#line 563 "../src/Commands.vala"
	_g_free0 (self->priv->new_title);
#line 564 "../src/Commands.vala"
	_g_free0 (self->priv->old_title);
#line 562 "../src/Commands.vala"
	G_OBJECT_CLASS (edit_title_command_parent_class)->finalize (obj);
#line 7665 "Commands.c"
}

static GType
edit_title_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditTitleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_title_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditTitleCommand), 0, (GInstanceInitFunc) edit_title_command_instance_init, NULL };
	GType edit_title_command_type_id;
	edit_title_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "EditTitleCommand", &g_define_type_info, 0);
	EditTitleCommand_private_offset = g_type_add_instance_private (edit_title_command_type_id, sizeof (EditTitleCommandPrivate));
	return edit_title_command_type_id;
}

GType
edit_title_command_get_type (void)
{
	static volatile gsize edit_title_command_type_id__once = 0;
	if (g_once_init_enter (&edit_title_command_type_id__once)) {
		GType edit_title_command_type_id;
		edit_title_command_type_id = edit_title_command_get_type_once ();
		g_once_init_leave (&edit_title_command_type_id__once, edit_title_command_type_id);
	}
	return edit_title_command_type_id__once;
}

static inline gpointer
edit_comment_command_get_instance_private (EditCommentCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditCommentCommand_private_offset);
}

EditCommentCommand*
edit_comment_command_construct (GType object_type,
                                MediaSource* source,
                                const gchar* new_comment)
{
	EditCommentCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 588 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (source), NULL);
#line 588 "../src/Commands.vala"
	g_return_val_if_fail (new_comment != NULL, NULL);
#line 589 "../src/Commands.vala"
	self = (EditCommentCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATA_SOURCE, DataSource), RESOURCES_EDIT_COMMENT_LABEL, "");
#line 591 "../src/Commands.vala"
	_tmp0_ = g_strdup (new_comment);
#line 591 "../src/Commands.vala"
	_g_free0 (self->priv->new_comment);
#line 591 "../src/Commands.vala"
	self->priv->new_comment = _tmp0_;
#line 592 "../src/Commands.vala"
	_tmp1_ = media_source_get_comment (source);
#line 592 "../src/Commands.vala"
	_g_free0 (self->priv->old_comment);
#line 592 "../src/Commands.vala"
	self->priv->old_comment = _tmp1_;
#line 588 "../src/Commands.vala"
	return self;
#line 7724 "Commands.c"
}

EditCommentCommand*
edit_comment_command_new (MediaSource* source,
                          const gchar* new_comment)
{
#line 588 "../src/Commands.vala"
	return edit_comment_command_construct (TYPE_EDIT_COMMENT_COMMAND, source, new_comment);
#line 7733 "Commands.c"
}

static void
edit_comment_command_real_execute (Command* base)
{
	EditCommentCommand * self;
	DataSource* _tmp0_;
	const gchar* _tmp1_;
#line 595 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_COMMENT_COMMAND, EditCommentCommand);
#line 596 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 596 "../src/Commands.vala"
	_tmp1_ = self->priv->new_comment;
#line 596 "../src/Commands.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), _tmp1_);
#line 7750 "Commands.c"
}

static void
edit_comment_command_real_undo (Command* base)
{
	EditCommentCommand * self;
	DataSource* _tmp0_;
	const gchar* _tmp1_;
#line 599 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_COMMENT_COMMAND, EditCommentCommand);
#line 600 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 600 "../src/Commands.vala"
	_tmp1_ = self->priv->old_comment;
#line 600 "../src/Commands.vala"
	media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), _tmp1_);
#line 7767 "Commands.c"
}

static void
edit_comment_command_class_init (EditCommentCommandClass * klass,
                                 gpointer klass_data)
{
#line 584 "../src/Commands.vala"
	edit_comment_command_parent_class = g_type_class_peek_parent (klass);
#line 584 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &EditCommentCommand_private_offset);
#line 584 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) edit_comment_command_real_execute;
#line 584 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) edit_comment_command_real_undo;
#line 584 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = edit_comment_command_finalize;
#line 7784 "Commands.c"
}

static void
edit_comment_command_instance_init (EditCommentCommand * self,
                                    gpointer klass)
{
#line 584 "../src/Commands.vala"
	self->priv = edit_comment_command_get_instance_private (self);
#line 7793 "Commands.c"
}

static void
edit_comment_command_finalize (GObject * obj)
{
	EditCommentCommand * self;
#line 584 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDIT_COMMENT_COMMAND, EditCommentCommand);
#line 585 "../src/Commands.vala"
	_g_free0 (self->priv->new_comment);
#line 586 "../src/Commands.vala"
	_g_free0 (self->priv->old_comment);
#line 584 "../src/Commands.vala"
	G_OBJECT_CLASS (edit_comment_command_parent_class)->finalize (obj);
#line 7808 "Commands.c"
}

static GType
edit_comment_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditCommentCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_comment_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditCommentCommand), 0, (GInstanceInitFunc) edit_comment_command_instance_init, NULL };
	GType edit_comment_command_type_id;
	edit_comment_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "EditCommentCommand", &g_define_type_info, 0);
	EditCommentCommand_private_offset = g_type_add_instance_private (edit_comment_command_type_id, sizeof (EditCommentCommandPrivate));
	return edit_comment_command_type_id;
}

GType
edit_comment_command_get_type (void)
{
	static volatile gsize edit_comment_command_type_id__once = 0;
	if (g_once_init_enter (&edit_comment_command_type_id__once)) {
		GType edit_comment_command_type_id;
		edit_comment_command_type_id = edit_comment_command_get_type_once ();
		g_once_init_leave (&edit_comment_command_type_id__once, edit_comment_command_type_id);
	}
	return edit_comment_command_type_id__once;
}

EditMultipleTitlesCommand*
edit_multiple_titles_command_construct (GType object_type,
                                        GeeCollection* media_sources,
                                        const gchar* new_title)
{
	EditMultipleTitlesCommand * self = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 608 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (media_sources, GEE_TYPE_COLLECTION), NULL);
#line 608 "../src/Commands.vala"
	g_return_val_if_fail (new_title != NULL, NULL);
#line 609 "../src/Commands.vala"
	_tmp0_ = g_strdup (g_dpgettext2 (NULL, "Button Label", RESOURCES_EDIT_TITLE_LABEL));
#line 609 "../src/Commands.vala"
	title = _tmp0_;
#line 611 "../src/Commands.vala"
	_tmp1_ = title;
#line 611 "../src/Commands.vala"
	self = (EditMultipleTitlesCommand*) multiple_data_source_at_once_command_construct (object_type, media_sources, _tmp1_, "");
#line 613 "../src/Commands.vala"
	_tmp2_ = g_strdup (new_title);
#line 613 "../src/Commands.vala"
	_g_free0 (self->new_title);
#line 613 "../src/Commands.vala"
	self->new_title = _tmp2_;
#line 7861 "Commands.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp3_;
#line 614 "../src/Commands.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 614 "../src/Commands.vala"
		_media_it = _tmp3_;
#line 614 "../src/Commands.vala"
		while (TRUE) {
#line 7871 "Commands.c"
			GeeIterator* _tmp4_;
			MediaSource* media = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GeeHashMap* _tmp7_;
			MediaSource* _tmp8_;
			MediaSource* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 614 "../src/Commands.vala"
			_tmp4_ = _media_it;
#line 614 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 614 "../src/Commands.vala"
				break;
#line 7887 "Commands.c"
			}
#line 614 "../src/Commands.vala"
			_tmp5_ = _media_it;
#line 614 "../src/Commands.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 614 "../src/Commands.vala"
			media = (MediaSource*) _tmp6_;
#line 615 "../src/Commands.vala"
			_tmp7_ = self->old_titles;
#line 615 "../src/Commands.vala"
			_tmp8_ = media;
#line 615 "../src/Commands.vala"
			_tmp9_ = media;
#line 615 "../src/Commands.vala"
			_tmp10_ = media_source_get_title (_tmp9_);
#line 615 "../src/Commands.vala"
			_tmp11_ = _tmp10_;
#line 615 "../src/Commands.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, _tmp11_);
#line 615 "../src/Commands.vala"
			_g_free0 (_tmp11_);
#line 614 "../src/Commands.vala"
			_g_object_unref0 (media);
#line 7911 "Commands.c"
		}
#line 614 "../src/Commands.vala"
		_g_object_unref0 (_media_it);
#line 7915 "Commands.c"
	}
#line 608 "../src/Commands.vala"
	_g_free0 (title);
#line 608 "../src/Commands.vala"
	return self;
#line 7921 "Commands.c"
}

EditMultipleTitlesCommand*
edit_multiple_titles_command_new (GeeCollection* media_sources,
                                  const gchar* new_title)
{
#line 608 "../src/Commands.vala"
	return edit_multiple_titles_command_construct (TYPE_EDIT_MULTIPLE_TITLES_COMMAND, media_sources, new_title);
#line 7930 "Commands.c"
}

static void
edit_multiple_titles_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                                  GeeCollection* sources)
{
	EditMultipleTitlesCommand * self;
#line 618 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommand);
#line 618 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 7942 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 619 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 619 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 619 "../src/Commands.vala"
		while (TRUE) {
#line 7952 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
			const gchar* _tmp5_;
#line 619 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 619 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 619 "../src/Commands.vala"
				break;
#line 7965 "Commands.c"
			}
#line 619 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 619 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 619 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 620 "../src/Commands.vala"
			_tmp4_ = source;
#line 620 "../src/Commands.vala"
			_tmp5_ = self->new_title;
#line 620 "../src/Commands.vala"
			media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource), _tmp5_);
#line 619 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 7981 "Commands.c"
		}
#line 619 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 7985 "Commands.c"
	}
}

static void
edit_multiple_titles_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                               GeeCollection* sources)
{
	EditMultipleTitlesCommand * self;
#line 623 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommand);
#line 623 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 7998 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 624 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 624 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 624 "../src/Commands.vala"
		while (TRUE) {
#line 8008 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
			GeeHashMap* _tmp5_;
			DataSource* _tmp6_;
			gpointer _tmp7_;
			gchar* _tmp8_;
#line 624 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 624 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 624 "../src/Commands.vala"
				break;
#line 8024 "Commands.c"
			}
#line 624 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 624 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 624 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 625 "../src/Commands.vala"
			_tmp4_ = source;
#line 625 "../src/Commands.vala"
			_tmp5_ = self->old_titles;
#line 625 "../src/Commands.vala"
			_tmp6_ = source;
#line 625 "../src/Commands.vala"
			_tmp7_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_SOURCE, MediaSource));
#line 625 "../src/Commands.vala"
			_tmp8_ = (gchar*) _tmp7_;
#line 625 "../src/Commands.vala"
			media_source_set_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource), _tmp8_);
#line 625 "../src/Commands.vala"
			_g_free0 (_tmp8_);
#line 624 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 8048 "Commands.c"
		}
#line 624 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 8052 "Commands.c"
	}
}

static void
edit_multiple_titles_command_class_init (EditMultipleTitlesCommandClass * klass,
                                         gpointer klass_data)
{
#line 604 "../src/Commands.vala"
	edit_multiple_titles_command_parent_class = g_type_class_peek_parent (klass);
#line 604 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->execute_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) edit_multiple_titles_command_real_execute_on_all;
#line 604 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->undo_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) edit_multiple_titles_command_real_undo_on_all;
#line 604 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = edit_multiple_titles_command_finalize;
#line 8068 "Commands.c"
}

static void
edit_multiple_titles_command_instance_init (EditMultipleTitlesCommand * self,
                                            gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 606 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 606 "../src/Commands.vala"
	self->old_titles = _tmp0_;
#line 8080 "Commands.c"
}

static void
edit_multiple_titles_command_finalize (GObject * obj)
{
	EditMultipleTitlesCommand * self;
#line 604 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDIT_MULTIPLE_TITLES_COMMAND, EditMultipleTitlesCommand);
#line 605 "../src/Commands.vala"
	_g_free0 (self->new_title);
#line 606 "../src/Commands.vala"
	_g_object_unref0 (self->old_titles);
#line 604 "../src/Commands.vala"
	G_OBJECT_CLASS (edit_multiple_titles_command_parent_class)->finalize (obj);
#line 8095 "Commands.c"
}

static GType
edit_multiple_titles_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditMultipleTitlesCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_multiple_titles_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditMultipleTitlesCommand), 0, (GInstanceInitFunc) edit_multiple_titles_command_instance_init, NULL };
	GType edit_multiple_titles_command_type_id;
	edit_multiple_titles_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, "EditMultipleTitlesCommand", &g_define_type_info, 0);
	return edit_multiple_titles_command_type_id;
}

GType
edit_multiple_titles_command_get_type (void)
{
	static volatile gsize edit_multiple_titles_command_type_id__once = 0;
	if (g_once_init_enter (&edit_multiple_titles_command_type_id__once)) {
		GType edit_multiple_titles_command_type_id;
		edit_multiple_titles_command_type_id = edit_multiple_titles_command_get_type_once ();
		g_once_init_leave (&edit_multiple_titles_command_type_id__once, edit_multiple_titles_command_type_id);
	}
	return edit_multiple_titles_command_type_id__once;
}

EditMultipleCommentsCommand*
edit_multiple_comments_command_construct (GType object_type,
                                          GeeCollection* media_sources,
                                          const gchar* new_comment)
{
	EditMultipleCommentsCommand * self = NULL;
	gchar* _tmp0_;
#line 633 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (media_sources, GEE_TYPE_COLLECTION), NULL);
#line 633 "../src/Commands.vala"
	g_return_val_if_fail (new_comment != NULL, NULL);
#line 634 "../src/Commands.vala"
	self = (EditMultipleCommentsCommand*) multiple_data_source_at_once_command_construct (object_type, media_sources, RESOURCES_EDIT_COMMENT_LABEL, "");
#line 636 "../src/Commands.vala"
	_tmp0_ = g_strdup (new_comment);
#line 636 "../src/Commands.vala"
	_g_free0 (self->new_comment);
#line 636 "../src/Commands.vala"
	self->new_comment = _tmp0_;
#line 8138 "Commands.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 637 "../src/Commands.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (media_sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 637 "../src/Commands.vala"
		_media_it = _tmp1_;
#line 637 "../src/Commands.vala"
		while (TRUE) {
#line 8148 "Commands.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeHashMap* _tmp5_;
			MediaSource* _tmp6_;
			MediaSource* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 637 "../src/Commands.vala"
			_tmp2_ = _media_it;
#line 637 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 637 "../src/Commands.vala"
				break;
#line 8164 "Commands.c"
			}
#line 637 "../src/Commands.vala"
			_tmp3_ = _media_it;
#line 637 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 637 "../src/Commands.vala"
			media = (MediaSource*) _tmp4_;
#line 638 "../src/Commands.vala"
			_tmp5_ = self->old_comments;
#line 638 "../src/Commands.vala"
			_tmp6_ = media;
#line 638 "../src/Commands.vala"
			_tmp7_ = media;
#line 638 "../src/Commands.vala"
			_tmp8_ = media_source_get_comment (_tmp7_);
#line 638 "../src/Commands.vala"
			_tmp9_ = _tmp8_;
#line 638 "../src/Commands.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_, _tmp9_);
#line 638 "../src/Commands.vala"
			_g_free0 (_tmp9_);
#line 637 "../src/Commands.vala"
			_g_object_unref0 (media);
#line 8188 "Commands.c"
		}
#line 637 "../src/Commands.vala"
		_g_object_unref0 (_media_it);
#line 8192 "Commands.c"
	}
#line 633 "../src/Commands.vala"
	return self;
#line 8196 "Commands.c"
}

EditMultipleCommentsCommand*
edit_multiple_comments_command_new (GeeCollection* media_sources,
                                    const gchar* new_comment)
{
#line 633 "../src/Commands.vala"
	return edit_multiple_comments_command_construct (TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, media_sources, new_comment);
#line 8205 "Commands.c"
}

static void
edit_multiple_comments_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                                    GeeCollection* sources)
{
	EditMultipleCommentsCommand * self;
#line 641 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommand);
#line 641 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 8217 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 642 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 642 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 642 "../src/Commands.vala"
		while (TRUE) {
#line 8227 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
			const gchar* _tmp5_;
#line 642 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 642 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 642 "../src/Commands.vala"
				break;
#line 8240 "Commands.c"
			}
#line 642 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 642 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 642 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 643 "../src/Commands.vala"
			_tmp4_ = source;
#line 643 "../src/Commands.vala"
			_tmp5_ = self->new_comment;
#line 643 "../src/Commands.vala"
			media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource), _tmp5_);
#line 642 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 8256 "Commands.c"
		}
#line 642 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 8260 "Commands.c"
	}
}

static void
edit_multiple_comments_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                                 GeeCollection* sources)
{
	EditMultipleCommentsCommand * self;
#line 646 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommand);
#line 646 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 8273 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 647 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 647 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 647 "../src/Commands.vala"
		while (TRUE) {
#line 8283 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
			GeeHashMap* _tmp5_;
			DataSource* _tmp6_;
			gpointer _tmp7_;
			gchar* _tmp8_;
#line 647 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 647 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 647 "../src/Commands.vala"
				break;
#line 8299 "Commands.c"
			}
#line 647 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 647 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 647 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 648 "../src/Commands.vala"
			_tmp4_ = source;
#line 648 "../src/Commands.vala"
			_tmp5_ = self->old_comments;
#line 648 "../src/Commands.vala"
			_tmp6_ = source;
#line 648 "../src/Commands.vala"
			_tmp7_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_SOURCE, MediaSource));
#line 648 "../src/Commands.vala"
			_tmp8_ = (gchar*) _tmp7_;
#line 648 "../src/Commands.vala"
			media_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_MEDIA_SOURCE, MediaSource), _tmp8_);
#line 648 "../src/Commands.vala"
			_g_free0 (_tmp8_);
#line 647 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 8323 "Commands.c"
		}
#line 647 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 8327 "Commands.c"
	}
}

static void
edit_multiple_comments_command_class_init (EditMultipleCommentsCommandClass * klass,
                                           gpointer klass_data)
{
#line 629 "../src/Commands.vala"
	edit_multiple_comments_command_parent_class = g_type_class_peek_parent (klass);
#line 629 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->execute_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) edit_multiple_comments_command_real_execute_on_all;
#line 629 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->undo_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) edit_multiple_comments_command_real_undo_on_all;
#line 629 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = edit_multiple_comments_command_finalize;
#line 8343 "Commands.c"
}

static void
edit_multiple_comments_command_instance_init (EditMultipleCommentsCommand * self,
                                              gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 631 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 631 "../src/Commands.vala"
	self->old_comments = _tmp0_;
#line 8355 "Commands.c"
}

static void
edit_multiple_comments_command_finalize (GObject * obj)
{
	EditMultipleCommentsCommand * self;
#line 629 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDIT_MULTIPLE_COMMENTS_COMMAND, EditMultipleCommentsCommand);
#line 630 "../src/Commands.vala"
	_g_free0 (self->new_comment);
#line 631 "../src/Commands.vala"
	_g_object_unref0 (self->old_comments);
#line 629 "../src/Commands.vala"
	G_OBJECT_CLASS (edit_multiple_comments_command_parent_class)->finalize (obj);
#line 8370 "Commands.c"
}

static GType
edit_multiple_comments_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditMultipleCommentsCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_multiple_comments_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditMultipleCommentsCommand), 0, (GInstanceInitFunc) edit_multiple_comments_command_instance_init, NULL };
	GType edit_multiple_comments_command_type_id;
	edit_multiple_comments_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, "EditMultipleCommentsCommand", &g_define_type_info, 0);
	return edit_multiple_comments_command_type_id;
}

GType
edit_multiple_comments_command_get_type (void)
{
	static volatile gsize edit_multiple_comments_command_type_id__once = 0;
	if (g_once_init_enter (&edit_multiple_comments_command_type_id__once)) {
		GType edit_multiple_comments_command_type_id;
		edit_multiple_comments_command_type_id = edit_multiple_comments_command_get_type_once ();
		g_once_init_leave (&edit_multiple_comments_command_type_id__once, edit_multiple_comments_command_type_id);
	}
	return edit_multiple_comments_command_type_id__once;
}

static inline gpointer
rename_event_command_get_instance_private (RenameEventCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RenameEventCommand_private_offset);
}

RenameEventCommand*
rename_event_command_construct (GType object_type,
                                Event* event,
                                const gchar* new_name)
{
	RenameEventCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 656 "../src/Commands.vala"
	g_return_val_if_fail (IS_EVENT (event), NULL);
#line 656 "../src/Commands.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 657 "../src/Commands.vala"
	self = (RenameEventCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (event, TYPE_PROXYABLE, Proxyable), RESOURCES_RENAME_EVENT_LABEL, "");
#line 659 "../src/Commands.vala"
	_tmp0_ = g_strdup (new_name);
#line 659 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 659 "../src/Commands.vala"
	self->priv->new_name = _tmp0_;
#line 660 "../src/Commands.vala"
	_tmp1_ = event_get_raw_name (event);
#line 660 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 660 "../src/Commands.vala"
	self->priv->old_name = _tmp1_;
#line 656 "../src/Commands.vala"
	return self;
#line 8428 "Commands.c"
}

RenameEventCommand*
rename_event_command_new (Event* event,
                          const gchar* new_name)
{
#line 656 "../src/Commands.vala"
	return rename_event_command_construct (TYPE_RENAME_EVENT_COMMAND, event, new_name);
#line 8437 "Commands.c"
}

static void
rename_event_command_real_execute_on_source (SimpleProxyableCommand* base,
                                             DataSource* source)
{
	RenameEventCommand * self;
	const gchar* _tmp0_;
#line 663 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_EVENT_COMMAND, RenameEventCommand);
#line 663 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 664 "../src/Commands.vala"
	_tmp0_ = self->priv->new_name;
#line 664 "../src/Commands.vala"
	event_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_EVENT, Event), _tmp0_);
#line 8454 "Commands.c"
}

static void
rename_event_command_real_undo_on_source (SimpleProxyableCommand* base,
                                          DataSource* source)
{
	RenameEventCommand * self;
	const gchar* _tmp0_;
#line 667 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_EVENT_COMMAND, RenameEventCommand);
#line 667 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 668 "../src/Commands.vala"
	_tmp0_ = self->priv->old_name;
#line 668 "../src/Commands.vala"
	event_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_EVENT, Event), _tmp0_);
#line 8471 "Commands.c"
}

static void
rename_event_command_class_init (RenameEventCommandClass * klass,
                                 gpointer klass_data)
{
#line 652 "../src/Commands.vala"
	rename_event_command_parent_class = g_type_class_peek_parent (klass);
#line 652 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RenameEventCommand_private_offset);
#line 652 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_event_command_real_execute_on_source;
#line 652 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_event_command_real_undo_on_source;
#line 652 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rename_event_command_finalize;
#line 8488 "Commands.c"
}

static void
rename_event_command_instance_init (RenameEventCommand * self,
                                    gpointer klass)
{
#line 652 "../src/Commands.vala"
	self->priv = rename_event_command_get_instance_private (self);
#line 8497 "Commands.c"
}

static void
rename_event_command_finalize (GObject * obj)
{
	RenameEventCommand * self;
#line 652 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RENAME_EVENT_COMMAND, RenameEventCommand);
#line 653 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 654 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 652 "../src/Commands.vala"
	G_OBJECT_CLASS (rename_event_command_parent_class)->finalize (obj);
#line 8512 "Commands.c"
}

static GType
rename_event_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RenameEventCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rename_event_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RenameEventCommand), 0, (GInstanceInitFunc) rename_event_command_instance_init, NULL };
	GType rename_event_command_type_id;
	rename_event_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "RenameEventCommand", &g_define_type_info, 0);
	RenameEventCommand_private_offset = g_type_add_instance_private (rename_event_command_type_id, sizeof (RenameEventCommandPrivate));
	return rename_event_command_type_id;
}

GType
rename_event_command_get_type (void)
{
	static volatile gsize rename_event_command_type_id__once = 0;
	if (g_once_init_enter (&rename_event_command_type_id__once)) {
		GType rename_event_command_type_id;
		rename_event_command_type_id = rename_event_command_get_type_once ();
		g_once_init_leave (&rename_event_command_type_id__once, rename_event_command_type_id);
	}
	return rename_event_command_type_id__once;
}

static inline gpointer
edit_event_comment_command_get_instance_private (EditEventCommentCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditEventCommentCommand_private_offset);
}

EditEventCommentCommand*
edit_event_comment_command_construct (GType object_type,
                                      Event* event,
                                      const gchar* new_comment)
{
	EditEventCommentCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 676 "../src/Commands.vala"
	g_return_val_if_fail (IS_EVENT (event), NULL);
#line 676 "../src/Commands.vala"
	g_return_val_if_fail (new_comment != NULL, NULL);
#line 677 "../src/Commands.vala"
	self = (EditEventCommentCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (event, TYPE_PROXYABLE, Proxyable), RESOURCES_EDIT_COMMENT_LABEL, "");
#line 679 "../src/Commands.vala"
	_tmp0_ = g_strdup (new_comment);
#line 679 "../src/Commands.vala"
	_g_free0 (self->priv->new_comment);
#line 679 "../src/Commands.vala"
	self->priv->new_comment = _tmp0_;
#line 680 "../src/Commands.vala"
	_tmp1_ = event_source_get_comment (G_TYPE_CHECK_INSTANCE_CAST (event, TYPE_EVENT_SOURCE, EventSource));
#line 680 "../src/Commands.vala"
	_g_free0 (self->priv->old_comment);
#line 680 "../src/Commands.vala"
	self->priv->old_comment = _tmp1_;
#line 676 "../src/Commands.vala"
	return self;
#line 8571 "Commands.c"
}

EditEventCommentCommand*
edit_event_comment_command_new (Event* event,
                                const gchar* new_comment)
{
#line 676 "../src/Commands.vala"
	return edit_event_comment_command_construct (TYPE_EDIT_EVENT_COMMENT_COMMAND, event, new_comment);
#line 8580 "Commands.c"
}

static void
edit_event_comment_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                   DataSource* source)
{
	EditEventCommentCommand * self;
	const gchar* _tmp0_;
#line 683 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommand);
#line 683 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 684 "../src/Commands.vala"
	_tmp0_ = self->priv->new_comment;
#line 684 "../src/Commands.vala"
	event_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_EVENT, Event), TYPE_EVENT_SOURCE, EventSource), _tmp0_);
#line 8597 "Commands.c"
}

static void
edit_event_comment_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                DataSource* source)
{
	EditEventCommentCommand * self;
	const gchar* _tmp0_;
#line 687 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommand);
#line 687 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 688 "../src/Commands.vala"
	_tmp0_ = self->priv->old_comment;
#line 688 "../src/Commands.vala"
	event_source_set_comment (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_EVENT, Event), TYPE_EVENT_SOURCE, EventSource), _tmp0_);
#line 8614 "Commands.c"
}

static void
edit_event_comment_command_class_init (EditEventCommentCommandClass * klass,
                                       gpointer klass_data)
{
#line 672 "../src/Commands.vala"
	edit_event_comment_command_parent_class = g_type_class_peek_parent (klass);
#line 672 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &EditEventCommentCommand_private_offset);
#line 672 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) edit_event_comment_command_real_execute_on_source;
#line 672 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) edit_event_comment_command_real_undo_on_source;
#line 672 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = edit_event_comment_command_finalize;
#line 8631 "Commands.c"
}

static void
edit_event_comment_command_instance_init (EditEventCommentCommand * self,
                                          gpointer klass)
{
#line 672 "../src/Commands.vala"
	self->priv = edit_event_comment_command_get_instance_private (self);
#line 8640 "Commands.c"
}

static void
edit_event_comment_command_finalize (GObject * obj)
{
	EditEventCommentCommand * self;
#line 672 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EDIT_EVENT_COMMENT_COMMAND, EditEventCommentCommand);
#line 673 "../src/Commands.vala"
	_g_free0 (self->priv->new_comment);
#line 674 "../src/Commands.vala"
	_g_free0 (self->priv->old_comment);
#line 672 "../src/Commands.vala"
	G_OBJECT_CLASS (edit_event_comment_command_parent_class)->finalize (obj);
#line 8655 "Commands.c"
}

static GType
edit_event_comment_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditEventCommentCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) edit_event_comment_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditEventCommentCommand), 0, (GInstanceInitFunc) edit_event_comment_command_instance_init, NULL };
	GType edit_event_comment_command_type_id;
	edit_event_comment_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "EditEventCommentCommand", &g_define_type_info, 0);
	EditEventCommentCommand_private_offset = g_type_add_instance_private (edit_event_comment_command_type_id, sizeof (EditEventCommentCommandPrivate));
	return edit_event_comment_command_type_id;
}

GType
edit_event_comment_command_get_type (void)
{
	static volatile gsize edit_event_comment_command_type_id__once = 0;
	if (g_once_init_enter (&edit_event_comment_command_type_id__once)) {
		GType edit_event_comment_command_type_id;
		edit_event_comment_command_type_id = edit_event_comment_command_get_type_once ();
		g_once_init_leave (&edit_event_comment_command_type_id__once, edit_event_comment_command_type_id);
	}
	return edit_event_comment_command_type_id__once;
}

static inline gpointer
set_key_photo_command_get_instance_private (SetKeyPhotoCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SetKeyPhotoCommand_private_offset);
}

SetKeyPhotoCommand*
set_key_photo_command_construct (GType object_type,
                                 Event* event,
                                 MediaSource* new_primary_source)
{
	SetKeyPhotoCommand * self = NULL;
	MediaSource* _tmp0_;
	MediaSource* _tmp1_;
#line 696 "../src/Commands.vala"
	g_return_val_if_fail (IS_EVENT (event), NULL);
#line 696 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (new_primary_source), NULL);
#line 697 "../src/Commands.vala"
	self = (SetKeyPhotoCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (event, TYPE_DATA_SOURCE, DataSource), RESOURCES_MAKE_KEY_PHOTO_LABEL, "");
#line 699 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (new_primary_source);
#line 699 "../src/Commands.vala"
	_g_object_unref0 (self->priv->new_primary_source);
#line 699 "../src/Commands.vala"
	self->priv->new_primary_source = _tmp0_;
#line 700 "../src/Commands.vala"
	_tmp1_ = event_get_primary_source (event);
#line 700 "../src/Commands.vala"
	_g_object_unref0 (self->priv->old_primary_source);
#line 700 "../src/Commands.vala"
	self->priv->old_primary_source = _tmp1_;
#line 696 "../src/Commands.vala"
	return self;
#line 8714 "Commands.c"
}

SetKeyPhotoCommand*
set_key_photo_command_new (Event* event,
                           MediaSource* new_primary_source)
{
#line 696 "../src/Commands.vala"
	return set_key_photo_command_construct (TYPE_SET_KEY_PHOTO_COMMAND, event, new_primary_source);
#line 8723 "Commands.c"
}

static void
set_key_photo_command_real_execute (Command* base)
{
	SetKeyPhotoCommand * self;
	DataSource* _tmp0_;
	MediaSource* _tmp1_;
#line 703 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommand);
#line 704 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 704 "../src/Commands.vala"
	_tmp1_ = self->priv->new_primary_source;
#line 704 "../src/Commands.vala"
	event_set_primary_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_EVENT, Event), _tmp1_);
#line 8740 "Commands.c"
}

static void
set_key_photo_command_real_undo (Command* base)
{
	SetKeyPhotoCommand * self;
	DataSource* _tmp0_;
	MediaSource* _tmp1_;
#line 707 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommand);
#line 708 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 708 "../src/Commands.vala"
	_tmp1_ = self->priv->old_primary_source;
#line 708 "../src/Commands.vala"
	event_set_primary_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_EVENT, Event), _tmp1_);
#line 8757 "Commands.c"
}

static void
set_key_photo_command_class_init (SetKeyPhotoCommandClass * klass,
                                  gpointer klass_data)
{
#line 692 "../src/Commands.vala"
	set_key_photo_command_parent_class = g_type_class_peek_parent (klass);
#line 692 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SetKeyPhotoCommand_private_offset);
#line 692 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) set_key_photo_command_real_execute;
#line 692 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) set_key_photo_command_real_undo;
#line 692 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = set_key_photo_command_finalize;
#line 8774 "Commands.c"
}

static void
set_key_photo_command_instance_init (SetKeyPhotoCommand * self,
                                     gpointer klass)
{
#line 692 "../src/Commands.vala"
	self->priv = set_key_photo_command_get_instance_private (self);
#line 8783 "Commands.c"
}

static void
set_key_photo_command_finalize (GObject * obj)
{
	SetKeyPhotoCommand * self;
#line 692 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SET_KEY_PHOTO_COMMAND, SetKeyPhotoCommand);
#line 693 "../src/Commands.vala"
	_g_object_unref0 (self->priv->new_primary_source);
#line 694 "../src/Commands.vala"
	_g_object_unref0 (self->priv->old_primary_source);
#line 692 "../src/Commands.vala"
	G_OBJECT_CLASS (set_key_photo_command_parent_class)->finalize (obj);
#line 8798 "Commands.c"
}

static GType
set_key_photo_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetKeyPhotoCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_key_photo_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetKeyPhotoCommand), 0, (GInstanceInitFunc) set_key_photo_command_instance_init, NULL };
	GType set_key_photo_command_type_id;
	set_key_photo_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "SetKeyPhotoCommand", &g_define_type_info, 0);
	SetKeyPhotoCommand_private_offset = g_type_add_instance_private (set_key_photo_command_type_id, sizeof (SetKeyPhotoCommandPrivate));
	return set_key_photo_command_type_id;
}

GType
set_key_photo_command_get_type (void)
{
	static volatile gsize set_key_photo_command_type_id__once = 0;
	if (g_once_init_enter (&set_key_photo_command_type_id__once)) {
		GType set_key_photo_command_type_id;
		set_key_photo_command_type_id = set_key_photo_command_get_type_once ();
		g_once_init_leave (&set_key_photo_command_type_id__once, set_key_photo_command_type_id);
	}
	return set_key_photo_command_type_id__once;
}

RevertSingleCommand*
revert_single_command_construct (GType object_type,
                                 Photo* photo)
{
	RevertSingleCommand * self = NULL;
#line 713 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 714 "../src/Commands.vala"
	self = (RevertSingleCommand*) generic_photo_transformation_command_construct (object_type, photo, RESOURCES_REVERT_LABEL, "");
#line 713 "../src/Commands.vala"
	return self;
#line 8834 "Commands.c"
}

RevertSingleCommand*
revert_single_command_new (Photo* photo)
{
#line 713 "../src/Commands.vala"
	return revert_single_command_construct (TYPE_REVERT_SINGLE_COMMAND, photo);
#line 8842 "Commands.c"
}

static void
revert_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                             Photo* photo)
{
	RevertSingleCommand * self;
#line 717 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REVERT_SINGLE_COMMAND, RevertSingleCommand);
#line 717 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 718 "../src/Commands.vala"
	photo_remove_all_transformations (photo, TRUE);
#line 8856 "Commands.c"
}

static gboolean
revert_single_command_real_compress (Command* base,
                                     Command* command)
{
	RevertSingleCommand * self;
	RevertSingleCommand* revert_single_command = NULL;
	RevertSingleCommand* _tmp0_;
	RevertSingleCommand* _tmp1_;
	RevertSingleCommand* _tmp2_;
	DataSource* _tmp3_;
	DataSource* _tmp4_;
	gboolean result;
#line 721 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REVERT_SINGLE_COMMAND, RevertSingleCommand);
#line 721 "../src/Commands.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 722 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_REVERT_SINGLE_COMMAND (command) ? ((RevertSingleCommand*) command) : NULL);
#line 722 "../src/Commands.vala"
	revert_single_command = _tmp0_;
#line 723 "../src/Commands.vala"
	_tmp1_ = revert_single_command;
#line 723 "../src/Commands.vala"
	if (_tmp1_ == NULL) {
#line 724 "../src/Commands.vala"
		result = FALSE;
#line 724 "../src/Commands.vala"
		_g_object_unref0 (revert_single_command);
#line 724 "../src/Commands.vala"
		return result;
#line 8889 "Commands.c"
	}
#line 726 "../src/Commands.vala"
	_tmp2_ = revert_single_command;
#line 726 "../src/Commands.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 726 "../src/Commands.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 726 "../src/Commands.vala"
	if (_tmp3_ != _tmp4_) {
#line 727 "../src/Commands.vala"
		result = FALSE;
#line 727 "../src/Commands.vala"
		_g_object_unref0 (revert_single_command);
#line 727 "../src/Commands.vala"
		return result;
#line 8905 "Commands.c"
	}
#line 731 "../src/Commands.vala"
	result = TRUE;
#line 731 "../src/Commands.vala"
	_g_object_unref0 (revert_single_command);
#line 731 "../src/Commands.vala"
	return result;
#line 8913 "Commands.c"
}

static void
revert_single_command_class_init (RevertSingleCommandClass * klass,
                                  gpointer klass_data)
{
#line 712 "../src/Commands.vala"
	revert_single_command_parent_class = g_type_class_peek_parent (klass);
#line 712 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) revert_single_command_real_execute_on_photo;
#line 712 "../src/Commands.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) revert_single_command_real_compress;
#line 8926 "Commands.c"
}

static void
revert_single_command_instance_init (RevertSingleCommand * self,
                                     gpointer klass)
{
}

static GType
revert_single_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RevertSingleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) revert_single_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RevertSingleCommand), 0, (GInstanceInitFunc) revert_single_command_instance_init, NULL };
	GType revert_single_command_type_id;
	revert_single_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "RevertSingleCommand", &g_define_type_info, 0);
	return revert_single_command_type_id;
}

GType
revert_single_command_get_type (void)
{
	static volatile gsize revert_single_command_type_id__once = 0;
	if (g_once_init_enter (&revert_single_command_type_id__once)) {
		GType revert_single_command_type_id;
		revert_single_command_type_id = revert_single_command_get_type_once ();
		g_once_init_leave (&revert_single_command_type_id__once, revert_single_command_type_id);
	}
	return revert_single_command_type_id__once;
}

RevertMultipleCommand*
revert_multiple_command_construct (GType object_type,
                                   GeeIterable* iter)
{
	RevertMultipleCommand * self = NULL;
#line 736 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 737 "../src/Commands.vala"
	self = (RevertMultipleCommand*) multiple_photo_transformation_command_construct (object_type, iter, _ ("Reverting"), _ ("Undoing Revert"), RESOURCES_REVERT_LABEL, "");
#line 736 "../src/Commands.vala"
	return self;
#line 8967 "Commands.c"
}

RevertMultipleCommand*
revert_multiple_command_new (GeeIterable* iter)
{
#line 736 "../src/Commands.vala"
	return revert_multiple_command_construct (TYPE_REVERT_MULTIPLE_COMMAND, iter);
#line 8975 "Commands.c"
}

static void
revert_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                DataSource* source)
{
	RevertMultipleCommand * self;
#line 741 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REVERT_MULTIPLE_COMMAND, RevertMultipleCommand);
#line 741 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 742 "../src/Commands.vala"
	photo_remove_all_transformations (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo), TRUE);
#line 8989 "Commands.c"
}

static void
revert_multiple_command_class_init (RevertMultipleCommandClass * klass,
                                    gpointer klass_data)
{
#line 735 "../src/Commands.vala"
	revert_multiple_command_parent_class = g_type_class_peek_parent (klass);
#line 735 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) revert_multiple_command_real_execute_on_source;
#line 9000 "Commands.c"
}

static void
revert_multiple_command_instance_init (RevertMultipleCommand * self,
                                       gpointer klass)
{
}

static GType
revert_multiple_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RevertMultipleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) revert_multiple_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RevertMultipleCommand), 0, (GInstanceInitFunc) revert_multiple_command_instance_init, NULL };
	GType revert_multiple_command_type_id;
	revert_multiple_command_type_id = g_type_register_static (TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, "RevertMultipleCommand", &g_define_type_info, 0);
	return revert_multiple_command_type_id;
}

GType
revert_multiple_command_get_type (void)
{
	static volatile gsize revert_multiple_command_type_id__once = 0;
	if (g_once_init_enter (&revert_multiple_command_type_id__once)) {
		GType revert_multiple_command_type_id;
		revert_multiple_command_type_id = revert_multiple_command_get_type_once ();
		g_once_init_leave (&revert_multiple_command_type_id__once, revert_multiple_command_type_id);
	}
	return revert_multiple_command_type_id__once;
}

EnhanceSingleCommand*
enhance_single_command_construct (GType object_type,
                                  Photo* photo)
{
	EnhanceSingleCommand * self = NULL;
#line 747 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 748 "../src/Commands.vala"
	self = (EnhanceSingleCommand*) generic_photo_transformation_command_construct (object_type, photo, RESOURCES_ENHANCE_LABEL, RESOURCES_ENHANCE_TOOLTIP);
#line 747 "../src/Commands.vala"
	return self;
#line 9041 "Commands.c"
}

EnhanceSingleCommand*
enhance_single_command_new (Photo* photo)
{
#line 747 "../src/Commands.vala"
	return enhance_single_command_construct (TYPE_ENHANCE_SINGLE_COMMAND, photo);
#line 9049 "Commands.c"
}

static void
enhance_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                              Photo* photo)
{
	EnhanceSingleCommand * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
#line 751 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommand);
#line 751 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 752 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 752 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 752 "../src/Commands.vala"
	page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 752 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 757 "../src/Commands.vala"
	photo_enhance (photo);
#line 763 "../src/Commands.vala"
	_tmp2_ = app_window_get_instance ();
#line 763 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 763 "../src/Commands.vala"
	page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PAGE_WINDOW, PageWindow));
#line 763 "../src/Commands.vala"
	_g_object_unref0 (_tmp3_);
#line 9083 "Commands.c"
}

static gboolean
enhance_single_command_real_compress (Command* base,
                                      Command* command)
{
	EnhanceSingleCommand * self;
	EnhanceSingleCommand* enhance_single_command = NULL;
	EnhanceSingleCommand* _tmp0_;
	EnhanceSingleCommand* _tmp1_;
	EnhanceSingleCommand* _tmp2_;
	DataSource* _tmp3_;
	DataSource* _tmp4_;
	gboolean result;
#line 766 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommand);
#line 766 "../src/Commands.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 767 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_ENHANCE_SINGLE_COMMAND (command) ? ((EnhanceSingleCommand*) command) : NULL);
#line 767 "../src/Commands.vala"
	enhance_single_command = _tmp0_;
#line 768 "../src/Commands.vala"
	_tmp1_ = enhance_single_command;
#line 768 "../src/Commands.vala"
	if (_tmp1_ == NULL) {
#line 769 "../src/Commands.vala"
		result = FALSE;
#line 769 "../src/Commands.vala"
		_g_object_unref0 (enhance_single_command);
#line 769 "../src/Commands.vala"
		return result;
#line 9116 "Commands.c"
	}
#line 771 "../src/Commands.vala"
	_tmp2_ = enhance_single_command;
#line 771 "../src/Commands.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 771 "../src/Commands.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 771 "../src/Commands.vala"
	if (_tmp3_ != _tmp4_) {
#line 772 "../src/Commands.vala"
		result = FALSE;
#line 772 "../src/Commands.vala"
		_g_object_unref0 (enhance_single_command);
#line 772 "../src/Commands.vala"
		return result;
#line 9132 "Commands.c"
	}
#line 775 "../src/Commands.vala"
	result = TRUE;
#line 775 "../src/Commands.vala"
	_g_object_unref0 (enhance_single_command);
#line 775 "../src/Commands.vala"
	return result;
#line 9140 "Commands.c"
}

static void
enhance_single_command_class_init (EnhanceSingleCommandClass * klass,
                                   gpointer klass_data)
{
#line 746 "../src/Commands.vala"
	enhance_single_command_parent_class = g_type_class_peek_parent (klass);
#line 746 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) enhance_single_command_real_execute_on_photo;
#line 746 "../src/Commands.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) enhance_single_command_real_compress;
#line 9153 "Commands.c"
}

static void
enhance_single_command_instance_init (EnhanceSingleCommand * self,
                                      gpointer klass)
{
}

static GType
enhance_single_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EnhanceSingleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) enhance_single_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EnhanceSingleCommand), 0, (GInstanceInitFunc) enhance_single_command_instance_init, NULL };
	GType enhance_single_command_type_id;
	enhance_single_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "EnhanceSingleCommand", &g_define_type_info, 0);
	return enhance_single_command_type_id;
}

GType
enhance_single_command_get_type (void)
{
	static volatile gsize enhance_single_command_type_id__once = 0;
	if (g_once_init_enter (&enhance_single_command_type_id__once)) {
		GType enhance_single_command_type_id;
		enhance_single_command_type_id = enhance_single_command_get_type_once ();
		g_once_init_leave (&enhance_single_command_type_id__once, enhance_single_command_type_id);
	}
	return enhance_single_command_type_id__once;
}

EnhanceMultipleCommand*
enhance_multiple_command_construct (GType object_type,
                                    GeeIterable* iter)
{
	EnhanceMultipleCommand * self = NULL;
#line 780 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 781 "../src/Commands.vala"
	self = (EnhanceMultipleCommand*) multiple_photo_transformation_command_construct (object_type, iter, _ ("Enhancing"), _ ("Undoing Enhance"), RESOURCES_ENHANCE_LABEL, RESOURCES_ENHANCE_TOOLTIP);
#line 780 "../src/Commands.vala"
	return self;
#line 9194 "Commands.c"
}

EnhanceMultipleCommand*
enhance_multiple_command_new (GeeIterable* iter)
{
#line 780 "../src/Commands.vala"
	return enhance_multiple_command_construct (TYPE_ENHANCE_MULTIPLE_COMMAND, iter);
#line 9202 "Commands.c"
}

static void
enhance_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                 DataSource* source)
{
	EnhanceMultipleCommand * self;
#line 785 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ENHANCE_MULTIPLE_COMMAND, EnhanceMultipleCommand);
#line 785 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 786 "../src/Commands.vala"
	photo_enhance (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo));
#line 9216 "Commands.c"
}

static void
enhance_multiple_command_class_init (EnhanceMultipleCommandClass * klass,
                                     gpointer klass_data)
{
#line 779 "../src/Commands.vala"
	enhance_multiple_command_parent_class = g_type_class_peek_parent (klass);
#line 779 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) enhance_multiple_command_real_execute_on_source;
#line 9227 "Commands.c"
}

static void
enhance_multiple_command_instance_init (EnhanceMultipleCommand * self,
                                        gpointer klass)
{
}

static GType
enhance_multiple_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EnhanceMultipleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) enhance_multiple_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EnhanceMultipleCommand), 0, (GInstanceInitFunc) enhance_multiple_command_instance_init, NULL };
	GType enhance_multiple_command_type_id;
	enhance_multiple_command_type_id = g_type_register_static (TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, "EnhanceMultipleCommand", &g_define_type_info, 0);
	return enhance_multiple_command_type_id;
}

GType
enhance_multiple_command_get_type (void)
{
	static volatile gsize enhance_multiple_command_type_id__once = 0;
	if (g_once_init_enter (&enhance_multiple_command_type_id__once)) {
		GType enhance_multiple_command_type_id;
		enhance_multiple_command_type_id = enhance_multiple_command_get_type_once ();
		g_once_init_leave (&enhance_multiple_command_type_id__once, enhance_multiple_command_type_id);
	}
	return enhance_multiple_command_type_id__once;
}

static inline gpointer
straighten_command_get_instance_private (StraightenCommand* self)
{
	return G_STRUCT_MEMBER_P (self, StraightenCommand_private_offset);
}

StraightenCommand*
straighten_command_construct (GType object_type,
                              Photo* photo,
                              gdouble theta,
                              Box* crop,
                              const gchar* name,
                              const gchar* explanation)
{
	StraightenCommand * self = NULL;
	Box _tmp0_;
#line 794 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 794 "../src/Commands.vala"
	g_return_val_if_fail (crop != NULL, NULL);
#line 794 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 794 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 795 "../src/Commands.vala"
	self = (StraightenCommand*) generic_photo_transformation_command_construct (object_type, photo, name, explanation);
#line 797 "../src/Commands.vala"
	self->priv->theta = theta;
#line 798 "../src/Commands.vala"
	_tmp0_ = *crop;
#line 798 "../src/Commands.vala"
	self->priv->crop = _tmp0_;
#line 794 "../src/Commands.vala"
	return self;
#line 9291 "Commands.c"
}

StraightenCommand*
straighten_command_new (Photo* photo,
                        gdouble theta,
                        Box* crop,
                        const gchar* name,
                        const gchar* explanation)
{
#line 794 "../src/Commands.vala"
	return straighten_command_construct (TYPE_STRAIGHTEN_COMMAND, photo, theta, crop, name, explanation);
#line 9303 "Commands.c"
}

static void
straighten_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                          Photo* photo)
{
	StraightenCommand * self;
	DataCollection* collection = NULL;
	DataCollection* _tmp0_;
	DataCollection* _tmp1_;
	Box _tmp3_;
	DataCollection* _tmp4_;
#line 801 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_STRAIGHTEN_COMMAND, StraightenCommand);
#line 801 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 803 "../src/Commands.vala"
	_tmp0_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_DATA_OBJECT, DataObject));
#line 803 "../src/Commands.vala"
	collection = _tmp0_;
#line 804 "../src/Commands.vala"
	_tmp1_ = collection;
#line 804 "../src/Commands.vala"
	if (_tmp1_ != NULL) {
#line 9328 "Commands.c"
		DataCollection* _tmp2_;
#line 805 "../src/Commands.vala"
		_tmp2_ = collection;
#line 805 "../src/Commands.vala"
		data_collection_freeze_notifications (_tmp2_);
#line 9334 "Commands.c"
	}
#line 807 "../src/Commands.vala"
	photo_set_straighten (photo, self->priv->theta);
#line 808 "../src/Commands.vala"
	_tmp3_ = self->priv->crop;
#line 808 "../src/Commands.vala"
	photo_set_crop (photo, &_tmp3_);
#line 810 "../src/Commands.vala"
	_tmp4_ = collection;
#line 810 "../src/Commands.vala"
	if (_tmp4_ != NULL) {
#line 9346 "Commands.c"
		DataCollection* _tmp5_;
#line 811 "../src/Commands.vala"
		_tmp5_ = collection;
#line 811 "../src/Commands.vala"
		data_collection_thaw_notifications (_tmp5_);
#line 9352 "Commands.c"
	}
#line 801 "../src/Commands.vala"
	_data_collection_unref0 (collection);
#line 9356 "Commands.c"
}

static void
straighten_command_class_init (StraightenCommandClass * klass,
                               gpointer klass_data)
{
#line 790 "../src/Commands.vala"
	straighten_command_parent_class = g_type_class_peek_parent (klass);
#line 790 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &StraightenCommand_private_offset);
#line 790 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) straighten_command_real_execute_on_photo;
#line 790 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = straighten_command_finalize;
#line 9371 "Commands.c"
}

static void
straighten_command_instance_init (StraightenCommand * self,
                                  gpointer klass)
{
#line 790 "../src/Commands.vala"
	self->priv = straighten_command_get_instance_private (self);
#line 9380 "Commands.c"
}

static void
straighten_command_finalize (GObject * obj)
{
	StraightenCommand * self;
#line 790 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STRAIGHTEN_COMMAND, StraightenCommand);
#line 790 "../src/Commands.vala"
	G_OBJECT_CLASS (straighten_command_parent_class)->finalize (obj);
#line 9391 "Commands.c"
}

static GType
straighten_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StraightenCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) straighten_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StraightenCommand), 0, (GInstanceInitFunc) straighten_command_instance_init, NULL };
	GType straighten_command_type_id;
	straighten_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "StraightenCommand", &g_define_type_info, 0);
	StraightenCommand_private_offset = g_type_add_instance_private (straighten_command_type_id, sizeof (StraightenCommandPrivate));
	return straighten_command_type_id;
}

GType
straighten_command_get_type (void)
{
	static volatile gsize straighten_command_type_id__once = 0;
	if (g_once_init_enter (&straighten_command_type_id__once)) {
		GType straighten_command_type_id;
		straighten_command_type_id = straighten_command_get_type_once ();
		g_once_init_leave (&straighten_command_type_id__once, straighten_command_type_id);
	}
	return straighten_command_type_id__once;
}

static inline gpointer
crop_command_get_instance_private (CropCommand* self)
{
	return G_STRUCT_MEMBER_P (self, CropCommand_private_offset);
}

CropCommand*
crop_command_construct (GType object_type,
                        Photo* photo,
                        Box* crop,
                        const gchar* name,
                        const gchar* explanation)
{
	CropCommand * self = NULL;
	Box _tmp0_;
#line 818 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 818 "../src/Commands.vala"
	g_return_val_if_fail (crop != NULL, NULL);
#line 818 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 818 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 819 "../src/Commands.vala"
	self = (CropCommand*) generic_photo_transformation_command_construct (object_type, photo, name, explanation);
#line 821 "../src/Commands.vala"
	_tmp0_ = *crop;
#line 821 "../src/Commands.vala"
	self->priv->crop = _tmp0_;
#line 818 "../src/Commands.vala"
	return self;
#line 9447 "Commands.c"
}

CropCommand*
crop_command_new (Photo* photo,
                  Box* crop,
                  const gchar* name,
                  const gchar* explanation)
{
#line 818 "../src/Commands.vala"
	return crop_command_construct (TYPE_CROP_COMMAND, photo, crop, name, explanation);
#line 9458 "Commands.c"
}

static void
crop_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                    Photo* photo)
{
	CropCommand * self;
	Box _tmp0_;
#line 824 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CROP_COMMAND, CropCommand);
#line 824 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 825 "../src/Commands.vala"
	_tmp0_ = self->priv->crop;
#line 825 "../src/Commands.vala"
	photo_set_crop (photo, &_tmp0_);
#line 9475 "Commands.c"
}

static void
crop_command_class_init (CropCommandClass * klass,
                         gpointer klass_data)
{
#line 815 "../src/Commands.vala"
	crop_command_parent_class = g_type_class_peek_parent (klass);
#line 815 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &CropCommand_private_offset);
#line 815 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) crop_command_real_execute_on_photo;
#line 815 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = crop_command_finalize;
#line 9490 "Commands.c"
}

static void
crop_command_instance_init (CropCommand * self,
                            gpointer klass)
{
#line 815 "../src/Commands.vala"
	self->priv = crop_command_get_instance_private (self);
#line 9499 "Commands.c"
}

static void
crop_command_finalize (GObject * obj)
{
	CropCommand * self;
#line 815 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_COMMAND, CropCommand);
#line 815 "../src/Commands.vala"
	G_OBJECT_CLASS (crop_command_parent_class)->finalize (obj);
#line 9510 "Commands.c"
}

static GType
crop_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CropCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crop_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CropCommand), 0, (GInstanceInitFunc) crop_command_instance_init, NULL };
	GType crop_command_type_id;
	crop_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "CropCommand", &g_define_type_info, 0);
	CropCommand_private_offset = g_type_add_instance_private (crop_command_type_id, sizeof (CropCommandPrivate));
	return crop_command_type_id;
}

GType
crop_command_get_type (void)
{
	static volatile gsize crop_command_type_id__once = 0;
	if (g_once_init_enter (&crop_command_type_id__once)) {
		GType crop_command_type_id;
		crop_command_type_id = crop_command_get_type_once ();
		g_once_init_leave (&crop_command_type_id__once, crop_command_type_id);
	}
	return crop_command_type_id__once;
}

static inline gpointer
adjust_colors_single_command_get_instance_private (AdjustColorsSingleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, AdjustColorsSingleCommand_private_offset);
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 836 "../src/Commands.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 9546 "Commands.c"
}

AdjustColorsSingleCommand*
adjust_colors_single_command_construct (GType object_type,
                                        Photo* photo,
                                        PixelTransformationBundle* transformations,
                                        const gchar* name,
                                        const gchar* explanation)
{
	AdjustColorsSingleCommand * self = NULL;
	PixelTransformationBundle* _tmp0_;
#line 832 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 832 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (transformations, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 832 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 832 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 834 "../src/Commands.vala"
	self = (AdjustColorsSingleCommand*) generic_photo_transformation_command_construct (object_type, photo, name, explanation);
#line 836 "../src/Commands.vala"
	_tmp0_ = _pixel_transformation_bundle_ref0 (transformations);
#line 836 "../src/Commands.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 836 "../src/Commands.vala"
	self->priv->transformations = _tmp0_;
#line 832 "../src/Commands.vala"
	return self;
#line 9576 "Commands.c"
}

AdjustColorsSingleCommand*
adjust_colors_single_command_new (Photo* photo,
                                  PixelTransformationBundle* transformations,
                                  const gchar* name,
                                  const gchar* explanation)
{
#line 832 "../src/Commands.vala"
	return adjust_colors_single_command_construct (TYPE_ADJUST_COLORS_SINGLE_COMMAND, photo, transformations, name, explanation);
#line 9587 "Commands.c"
}

static void
adjust_colors_single_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                                    Photo* photo)
{
	AdjustColorsSingleCommand * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	PixelTransformationBundle* _tmp2_;
	AppWindow* _tmp3_;
	AppWindow* _tmp4_;
#line 839 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommand);
#line 839 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 840 "../src/Commands.vala"
	_tmp0_ = app_window_get_instance ();
#line 840 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 840 "../src/Commands.vala"
	page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 840 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 842 "../src/Commands.vala"
	_tmp2_ = self->priv->transformations;
#line 842 "../src/Commands.vala"
	photo_set_color_adjustments (photo, _tmp2_);
#line 844 "../src/Commands.vala"
	_tmp3_ = app_window_get_instance ();
#line 844 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 844 "../src/Commands.vala"
	page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_PAGE_WINDOW, PageWindow));
#line 844 "../src/Commands.vala"
	_g_object_unref0 (_tmp4_);
#line 9624 "Commands.c"
}

static gboolean
adjust_colors_single_command_real_can_compress (GenericPhotoTransformationCommand* base,
                                                Command* command)
{
	AdjustColorsSingleCommand * self;
	gboolean result;
#line 847 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommand);
#line 847 "../src/Commands.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 848 "../src/Commands.vala"
	result = IS_ADJUST_COLORS_SINGLE_COMMAND (command);
#line 848 "../src/Commands.vala"
	return result;
#line 9641 "Commands.c"
}

static void
adjust_colors_single_command_class_init (AdjustColorsSingleCommandClass * klass,
                                         gpointer klass_data)
{
#line 829 "../src/Commands.vala"
	adjust_colors_single_command_parent_class = g_type_class_peek_parent (klass);
#line 829 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &AdjustColorsSingleCommand_private_offset);
#line 829 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) adjust_colors_single_command_real_execute_on_photo;
#line 829 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->can_compress = (gboolean (*) (GenericPhotoTransformationCommand*, Command*)) adjust_colors_single_command_real_can_compress;
#line 829 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = adjust_colors_single_command_finalize;
#line 9658 "Commands.c"
}

static void
adjust_colors_single_command_instance_init (AdjustColorsSingleCommand * self,
                                            gpointer klass)
{
#line 829 "../src/Commands.vala"
	self->priv = adjust_colors_single_command_get_instance_private (self);
#line 9667 "Commands.c"
}

static void
adjust_colors_single_command_finalize (GObject * obj)
{
	AdjustColorsSingleCommand * self;
#line 829 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommand);
#line 830 "../src/Commands.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 829 "../src/Commands.vala"
	G_OBJECT_CLASS (adjust_colors_single_command_parent_class)->finalize (obj);
#line 9680 "Commands.c"
}

static GType
adjust_colors_single_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdjustColorsSingleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adjust_colors_single_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdjustColorsSingleCommand), 0, (GInstanceInitFunc) adjust_colors_single_command_instance_init, NULL };
	GType adjust_colors_single_command_type_id;
	adjust_colors_single_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "AdjustColorsSingleCommand", &g_define_type_info, 0);
	AdjustColorsSingleCommand_private_offset = g_type_add_instance_private (adjust_colors_single_command_type_id, sizeof (AdjustColorsSingleCommandPrivate));
	return adjust_colors_single_command_type_id;
}

GType
adjust_colors_single_command_get_type (void)
{
	static volatile gsize adjust_colors_single_command_type_id__once = 0;
	if (g_once_init_enter (&adjust_colors_single_command_type_id__once)) {
		GType adjust_colors_single_command_type_id;
		adjust_colors_single_command_type_id = adjust_colors_single_command_get_type_once ();
		g_once_init_leave (&adjust_colors_single_command_type_id__once, adjust_colors_single_command_type_id);
	}
	return adjust_colors_single_command_type_id__once;
}

static inline gpointer
adjust_colors_multiple_command_get_instance_private (AdjustColorsMultipleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, AdjustColorsMultipleCommand_private_offset);
}

AdjustColorsMultipleCommand*
adjust_colors_multiple_command_construct (GType object_type,
                                          GeeIterable* iter,
                                          PixelTransformationBundle* transformations,
                                          const gchar* name,
                                          const gchar* explanation)
{
	AdjustColorsMultipleCommand * self = NULL;
	PixelTransformationBundle* _tmp0_;
#line 855 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 855 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (transformations, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 855 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 855 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 857 "../src/Commands.vala"
	self = (AdjustColorsMultipleCommand*) multiple_photo_transformation_command_construct (object_type, iter, _ ("Applying Color Transformations"), _ ("Undoing Color Transformations"), name, explanation);
#line 860 "../src/Commands.vala"
	_tmp0_ = _pixel_transformation_bundle_ref0 (transformations);
#line 860 "../src/Commands.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 860 "../src/Commands.vala"
	self->priv->transformations = _tmp0_;
#line 855 "../src/Commands.vala"
	return self;
#line 9738 "Commands.c"
}

AdjustColorsMultipleCommand*
adjust_colors_multiple_command_new (GeeIterable* iter,
                                    PixelTransformationBundle* transformations,
                                    const gchar* name,
                                    const gchar* explanation)
{
#line 855 "../src/Commands.vala"
	return adjust_colors_multiple_command_construct (TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, iter, transformations, name, explanation);
#line 9749 "Commands.c"
}

static void
adjust_colors_multiple_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                       DataSource* source)
{
	AdjustColorsMultipleCommand * self;
	PixelTransformationBundle* _tmp0_;
#line 863 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, AdjustColorsMultipleCommand);
#line 863 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 864 "../src/Commands.vala"
	_tmp0_ = self->priv->transformations;
#line 864 "../src/Commands.vala"
	photo_set_color_adjustments (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo), _tmp0_);
#line 9766 "Commands.c"
}

static void
adjust_colors_multiple_command_class_init (AdjustColorsMultipleCommandClass * klass,
                                           gpointer klass_data)
{
#line 852 "../src/Commands.vala"
	adjust_colors_multiple_command_parent_class = g_type_class_peek_parent (klass);
#line 852 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &AdjustColorsMultipleCommand_private_offset);
#line 852 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) adjust_colors_multiple_command_real_execute_on_source;
#line 852 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = adjust_colors_multiple_command_finalize;
#line 9781 "Commands.c"
}

static void
adjust_colors_multiple_command_instance_init (AdjustColorsMultipleCommand * self,
                                              gpointer klass)
{
#line 852 "../src/Commands.vala"
	self->priv = adjust_colors_multiple_command_get_instance_private (self);
#line 9790 "Commands.c"
}

static void
adjust_colors_multiple_command_finalize (GObject * obj)
{
	AdjustColorsMultipleCommand * self;
#line 852 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_COLORS_MULTIPLE_COMMAND, AdjustColorsMultipleCommand);
#line 853 "../src/Commands.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 852 "../src/Commands.vala"
	G_OBJECT_CLASS (adjust_colors_multiple_command_parent_class)->finalize (obj);
#line 9803 "Commands.c"
}

static GType
adjust_colors_multiple_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdjustColorsMultipleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adjust_colors_multiple_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdjustColorsMultipleCommand), 0, (GInstanceInitFunc) adjust_colors_multiple_command_instance_init, NULL };
	GType adjust_colors_multiple_command_type_id;
	adjust_colors_multiple_command_type_id = g_type_register_static (TYPE_MULTIPLE_PHOTO_TRANSFORMATION_COMMAND, "AdjustColorsMultipleCommand", &g_define_type_info, 0);
	AdjustColorsMultipleCommand_private_offset = g_type_add_instance_private (adjust_colors_multiple_command_type_id, sizeof (AdjustColorsMultipleCommandPrivate));
	return adjust_colors_multiple_command_type_id;
}

GType
adjust_colors_multiple_command_get_type (void)
{
	static volatile gsize adjust_colors_multiple_command_type_id__once = 0;
	if (g_once_init_enter (&adjust_colors_multiple_command_type_id__once)) {
		GType adjust_colors_multiple_command_type_id;
		adjust_colors_multiple_command_type_id = adjust_colors_multiple_command_get_type_once ();
		g_once_init_leave (&adjust_colors_multiple_command_type_id__once, adjust_colors_multiple_command_type_id);
	}
	return adjust_colors_multiple_command_type_id__once;
}

static inline gpointer
redeye_command_get_instance_private (RedeyeCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RedeyeCommand_private_offset);
}

RedeyeCommand*
redeye_command_construct (GType object_type,
                          Photo* photo,
                          EditingToolsRedeyeInstance* redeye_instance,
                          const gchar* name,
                          const gchar* explanation)
{
	RedeyeCommand * self = NULL;
	EditingToolsRedeyeInstance _tmp0_;
#line 871 "../src/Commands.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 871 "../src/Commands.vala"
	g_return_val_if_fail (redeye_instance != NULL, NULL);
#line 871 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 871 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 873 "../src/Commands.vala"
	self = (RedeyeCommand*) generic_photo_transformation_command_construct (object_type, photo, name, explanation);
#line 875 "../src/Commands.vala"
	_tmp0_ = *redeye_instance;
#line 875 "../src/Commands.vala"
	self->priv->redeye_instance = _tmp0_;
#line 871 "../src/Commands.vala"
	return self;
#line 9859 "Commands.c"
}

RedeyeCommand*
redeye_command_new (Photo* photo,
                    EditingToolsRedeyeInstance* redeye_instance,
                    const gchar* name,
                    const gchar* explanation)
{
#line 871 "../src/Commands.vala"
	return redeye_command_construct (TYPE_REDEYE_COMMAND, photo, redeye_instance, name, explanation);
#line 9870 "Commands.c"
}

static void
redeye_command_real_execute_on_photo (GenericPhotoTransformationCommand* base,
                                      Photo* photo)
{
	RedeyeCommand * self;
	EditingToolsRedeyeInstance _tmp0_;
#line 878 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REDEYE_COMMAND, RedeyeCommand);
#line 878 "../src/Commands.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 879 "../src/Commands.vala"
	_tmp0_ = self->priv->redeye_instance;
#line 879 "../src/Commands.vala"
	photo_add_redeye_instance (photo, &_tmp0_);
#line 9887 "Commands.c"
}

static void
redeye_command_class_init (RedeyeCommandClass * klass,
                           gpointer klass_data)
{
#line 868 "../src/Commands.vala"
	redeye_command_parent_class = g_type_class_peek_parent (klass);
#line 868 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RedeyeCommand_private_offset);
#line 868 "../src/Commands.vala"
	((GenericPhotoTransformationCommandClass *) klass)->execute_on_photo = (void (*) (GenericPhotoTransformationCommand*, Photo*)) redeye_command_real_execute_on_photo;
#line 868 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = redeye_command_finalize;
#line 9902 "Commands.c"
}

static void
redeye_command_instance_init (RedeyeCommand * self,
                              gpointer klass)
{
#line 868 "../src/Commands.vala"
	self->priv = redeye_command_get_instance_private (self);
#line 9911 "Commands.c"
}

static void
redeye_command_finalize (GObject * obj)
{
	RedeyeCommand * self;
#line 868 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REDEYE_COMMAND, RedeyeCommand);
#line 868 "../src/Commands.vala"
	G_OBJECT_CLASS (redeye_command_parent_class)->finalize (obj);
#line 9922 "Commands.c"
}

static GType
redeye_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RedeyeCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) redeye_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RedeyeCommand), 0, (GInstanceInitFunc) redeye_command_instance_init, NULL };
	GType redeye_command_type_id;
	redeye_command_type_id = g_type_register_static (TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, "RedeyeCommand", &g_define_type_info, 0);
	RedeyeCommand_private_offset = g_type_add_instance_private (redeye_command_type_id, sizeof (RedeyeCommandPrivate));
	return redeye_command_type_id;
}

GType
redeye_command_get_type (void)
{
	static volatile gsize redeye_command_type_id__once = 0;
	if (g_once_init_enter (&redeye_command_type_id__once)) {
		GType redeye_command_type_id;
		redeye_command_type_id = redeye_command_get_type_once ();
		g_once_init_leave (&redeye_command_type_id__once, redeye_command_type_id);
	}
	return redeye_command_type_id__once;
}

MovePhotosCommand*
move_photos_command_construct (GType object_type,
                               const gchar* name,
                               const gchar* explanation)
{
	MovePhotosCommand * self = NULL;
#line 966 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 966 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 967 "../src/Commands.vala"
	self = (MovePhotosCommand*) command_construct (object_type, name, explanation);
#line 966 "../src/Commands.vala"
	return self;
#line 9961 "Commands.c"
}

static void
move_photos_command_real_prepare (Command* base)
{
	MovePhotosCommand * self;
	MovePhotosCommandRealMovePhotosCommand* _tmp0_;
	MovePhotosCommandRealMovePhotosCommand* _tmp1_;
#line 970 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand);
#line 971 "../src/Commands.vala"
	_tmp0_ = self->real_command;
#line 971 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "real_command != null");
#line 972 "../src/Commands.vala"
	_tmp1_ = self->real_command;
#line 972 "../src/Commands.vala"
	command_prepare (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_COMMAND, Command));
#line 9980 "Commands.c"
}

static void
move_photos_command_real_execute (Command* base)
{
	MovePhotosCommand * self;
	MovePhotosCommandRealMovePhotosCommand* _tmp0_;
	MovePhotosCommandRealMovePhotosCommand* _tmp1_;
#line 975 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand);
#line 976 "../src/Commands.vala"
	_tmp0_ = self->real_command;
#line 976 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "real_command != null");
#line 977 "../src/Commands.vala"
	_tmp1_ = self->real_command;
#line 977 "../src/Commands.vala"
	command_execute (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_COMMAND, Command));
#line 9999 "Commands.c"
}

static void
move_photos_command_real_undo (Command* base)
{
	MovePhotosCommand * self;
	MovePhotosCommandRealMovePhotosCommand* _tmp0_;
	MovePhotosCommandRealMovePhotosCommand* _tmp1_;
#line 980 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand);
#line 981 "../src/Commands.vala"
	_tmp0_ = self->real_command;
#line 981 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "real_command != null");
#line 982 "../src/Commands.vala"
	_tmp1_ = self->real_command;
#line 982 "../src/Commands.vala"
	command_undo (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_COMMAND, Command));
#line 10018 "Commands.c"
}

static inline gpointer
move_photos_command_real_move_photos_command_get_instance_private (MovePhotosCommandRealMovePhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, MovePhotosCommandRealMovePhotosCommand_private_offset);
}

static void
_move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                                                   gpointer self)
{
#line 914 "../src/Commands.vala"
	move_photos_command_real_move_photos_command_on_proxy_broken ((MovePhotosCommandRealMovePhotosCommand*) self);
#line 10033 "Commands.c"
}

static gpointer
_source_proxy_ref0 (gpointer self)
{
#line 899 "../src/Commands.vala"
	return self ? source_proxy_ref (self) : NULL;
#line 10041 "Commands.c"
}

MovePhotosCommandRealMovePhotosCommand*
move_photos_command_real_move_photos_command_construct (GType object_type,
                                                        Event* new_event,
                                                        GeeIterable* source_views,
                                                        const gchar* progress_text,
                                                        const gchar* undo_progress_text,
                                                        const gchar* name,
                                                        const gchar* explanation)
{
	MovePhotosCommandRealMovePhotosCommand * self = NULL;
	SourceProxy* _tmp22_;
	SourceProxy* _tmp23_;
#line 891 "../src/Commands.vala"
	g_return_val_if_fail ((new_event == NULL) || IS_EVENT (new_event), NULL);
#line 891 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source_views, GEE_TYPE_ITERABLE), NULL);
#line 891 "../src/Commands.vala"
	g_return_val_if_fail (progress_text != NULL, NULL);
#line 891 "../src/Commands.vala"
	g_return_val_if_fail (undo_progress_text != NULL, NULL);
#line 891 "../src/Commands.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 891 "../src/Commands.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 893 "../src/Commands.vala"
	self = (MovePhotosCommandRealMovePhotosCommand*) multiple_data_source_command_construct (object_type, source_views, progress_text, undo_progress_text, name, explanation);
#line 10070 "Commands.c"
	{
		GeeArrayList* _source_list = NULL;
		GeeArrayList* _tmp0_;
		gint _source_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _source_index = 0;
#line 896 "../src/Commands.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand)->source_list;
#line 896 "../src/Commands.vala"
		_source_list = _tmp0_;
#line 896 "../src/Commands.vala"
		_tmp1_ = _source_list;
#line 896 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 896 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 896 "../src/Commands.vala"
		_source_size = _tmp3_;
#line 896 "../src/Commands.vala"
		_source_index = -1;
#line 896 "../src/Commands.vala"
		while (TRUE) {
#line 10095 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			DataSource* source = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MediaSource* current_media = NULL;
			DataSource* _tmp8_;
			MediaSource* _tmp9_;
			Event* old_event = NULL;
			MediaSource* _tmp10_;
			Event* _tmp11_;
			SourceProxy* _tmp12_ = NULL;
			Event* _tmp13_;
			SourceProxy* old_event_proxy = NULL;
			SourceProxy* _tmp16_;
			SourceProxy* _tmp17_;
			GeeHashMap* _tmp19_;
			MediaSource* _tmp20_;
			SourceProxy* _tmp21_;
#line 896 "../src/Commands.vala"
			_source_index = _source_index + 1;
#line 896 "../src/Commands.vala"
			_tmp4_ = _source_index;
#line 896 "../src/Commands.vala"
			_tmp5_ = _source_size;
#line 896 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 896 "../src/Commands.vala"
				break;
#line 10125 "Commands.c"
			}
#line 896 "../src/Commands.vala"
			_tmp6_ = _source_list;
#line 896 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _source_index);
#line 896 "../src/Commands.vala"
			source = (DataSource*) _tmp7_;
#line 897 "../src/Commands.vala"
			_tmp8_ = source;
#line 897 "../src/Commands.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 897 "../src/Commands.vala"
			current_media = _tmp9_;
#line 898 "../src/Commands.vala"
			_tmp10_ = current_media;
#line 898 "../src/Commands.vala"
			_tmp11_ = media_source_get_event (_tmp10_);
#line 898 "../src/Commands.vala"
			old_event = _tmp11_;
#line 899 "../src/Commands.vala"
			_tmp13_ = old_event;
#line 899 "../src/Commands.vala"
			if (_tmp13_ != NULL) {
#line 10149 "Commands.c"
				Event* _tmp14_;
				SourceProxy* _tmp15_;
#line 899 "../src/Commands.vala"
				_tmp14_ = old_event;
#line 899 "../src/Commands.vala"
				_tmp15_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PROXYABLE, Proxyable));
#line 899 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp12_);
#line 899 "../src/Commands.vala"
				_tmp12_ = _tmp15_;
#line 10160 "Commands.c"
			} else {
#line 899 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp12_);
#line 899 "../src/Commands.vala"
				_tmp12_ = NULL;
#line 10166 "Commands.c"
			}
#line 899 "../src/Commands.vala"
			_tmp16_ = _source_proxy_ref0 (_tmp12_);
#line 899 "../src/Commands.vala"
			old_event_proxy = _tmp16_;
#line 902 "../src/Commands.vala"
			_tmp17_ = old_event_proxy;
#line 902 "../src/Commands.vala"
			if (_tmp17_ != NULL) {
#line 10176 "Commands.c"
				SourceProxy* _tmp18_;
#line 903 "../src/Commands.vala"
				_tmp18_ = old_event_proxy;
#line 903 "../src/Commands.vala"
				g_signal_connect_object (_tmp18_, "broken", (GCallback) _move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 10182 "Commands.c"
			}
#line 905 "../src/Commands.vala"
			_tmp19_ = self->priv->old_events;
#line 905 "../src/Commands.vala"
			_tmp20_ = current_media;
#line 905 "../src/Commands.vala"
			_tmp21_ = old_event_proxy;
#line 905 "../src/Commands.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp20_, _tmp21_);
#line 896 "../src/Commands.vala"
			_source_proxy_unref0 (old_event_proxy);
#line 896 "../src/Commands.vala"
			_source_proxy_unref0 (_tmp12_);
#line 896 "../src/Commands.vala"
			_g_object_unref0 (old_event);
#line 896 "../src/Commands.vala"
			_g_object_unref0 (current_media);
#line 896 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 10202 "Commands.c"
		}
	}
#line 909 "../src/Commands.vala"
	_tmp22_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (new_event, TYPE_PROXYABLE, Proxyable));
#line 909 "../src/Commands.vala"
	_source_proxy_unref0 (self->priv->new_event_proxy);
#line 909 "../src/Commands.vala"
	self->priv->new_event_proxy = _tmp22_;
#line 910 "../src/Commands.vala"
	_tmp23_ = self->priv->new_event_proxy;
#line 910 "../src/Commands.vala"
	g_signal_connect_object (_tmp23_, "broken", (GCallback) _move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 891 "../src/Commands.vala"
	return self;
#line 10217 "Commands.c"
}

MovePhotosCommandRealMovePhotosCommand*
move_photos_command_real_move_photos_command_new (Event* new_event,
                                                  GeeIterable* source_views,
                                                  const gchar* progress_text,
                                                  const gchar* undo_progress_text,
                                                  const gchar* name,
                                                  const gchar* explanation)
{
#line 891 "../src/Commands.vala"
	return move_photos_command_real_move_photos_command_construct (MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, new_event, source_views, progress_text, undo_progress_text, name, explanation);
#line 10230 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_real_execute (Command* base)
{
	MovePhotosCommandRealMovePhotosCommand * self;
	LibraryWindow* _tmp0_;
	LibraryWindow* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	gboolean _tmp4_;
#line 922 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommand);
#line 924 "../src/Commands.vala"
	COMMAND_CLASS (move_photos_command_real_move_photos_command_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 927 "../src/Commands.vala"
	_tmp0_ = library_window_get_app ();
#line 927 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 927 "../src/Commands.vala"
	_tmp2_ = page_window_get_current_page (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_PAGE_WINDOW, PageWindow));
#line 927 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 927 "../src/Commands.vala"
	_tmp4_ = IS_EVENT_PAGE (_tmp3_);
#line 927 "../src/Commands.vala"
	_g_object_unref0 (_tmp3_);
#line 927 "../src/Commands.vala"
	_g_object_unref0 (_tmp1_);
#line 927 "../src/Commands.vala"
	if (_tmp4_) {
#line 10262 "Commands.c"
		Event* evt = NULL;
		LibraryWindow* _tmp5_;
		LibraryWindow* _tmp6_;
		Page* _tmp7_;
		EventPage* _tmp8_;
		Event* _tmp9_;
		Event* _tmp10_;
		Event* _tmp11_;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 928 "../src/Commands.vala"
		_tmp5_ = library_window_get_app ();
#line 928 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 928 "../src/Commands.vala"
		_tmp7_ = page_window_get_current_page (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_PAGE_WINDOW, PageWindow));
#line 928 "../src/Commands.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_EVENT_PAGE, EventPage);
#line 928 "../src/Commands.vala"
		_tmp9_ = event_page_get_event (_tmp8_);
#line 928 "../src/Commands.vala"
		_tmp10_ = _tmp9_;
#line 928 "../src/Commands.vala"
		_g_object_unref0 (_tmp8_);
#line 928 "../src/Commands.vala"
		_g_object_unref0 (_tmp6_);
#line 928 "../src/Commands.vala"
		evt = _tmp10_;
#line 931 "../src/Commands.vala"
		_tmp11_ = evt;
#line 931 "../src/Commands.vala"
		_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand)->source_list;
#line 931 "../src/Commands.vala"
		_tmp13_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 931 "../src/Commands.vala"
		_tmp14_ = _tmp13_;
#line 931 "../src/Commands.vala"
		if (event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_EVENT_SOURCE, EventSource)) == _tmp14_) {
#line 10302 "Commands.c"
			LibraryWindow* _tmp15_;
			LibraryWindow* _tmp16_;
			SourceProxy* _tmp17_;
			DataSource* _tmp18_;
			Event* _tmp19_;
#line 934 "../src/Commands.vala"
			_tmp15_ = library_window_get_app ();
#line 934 "../src/Commands.vala"
			_tmp16_ = _tmp15_;
#line 934 "../src/Commands.vala"
			_tmp17_ = self->priv->new_event_proxy;
#line 934 "../src/Commands.vala"
			_tmp18_ = source_proxy_get_source (_tmp17_);
#line 934 "../src/Commands.vala"
			_tmp19_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_EVENT, Event);
#line 934 "../src/Commands.vala"
			library_window_switch_to_event (_tmp16_, _tmp19_);
#line 934 "../src/Commands.vala"
			_g_object_unref0 (_tmp19_);
#line 934 "../src/Commands.vala"
			_g_object_unref0 (_tmp16_);
#line 10324 "Commands.c"
		}
#line 927 "../src/Commands.vala"
		_g_object_unref0 (evt);
#line 10328 "Commands.c"
	} else {
		SourceProxy* _tmp20_;
		DataSource* _tmp21_;
		Event* _tmp22_;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gboolean _tmp26_;
#line 940 "../src/Commands.vala"
		_tmp20_ = self->priv->new_event_proxy;
#line 940 "../src/Commands.vala"
		_tmp21_ = source_proxy_get_source (_tmp20_);
#line 940 "../src/Commands.vala"
		_tmp22_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_EVENT, Event);
#line 940 "../src/Commands.vala"
		_tmp23_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand)->source_list;
#line 940 "../src/Commands.vala"
		_tmp24_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 940 "../src/Commands.vala"
		_tmp25_ = _tmp24_;
#line 940 "../src/Commands.vala"
		_tmp26_ = event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_EVENT_SOURCE, EventSource)) == _tmp25_;
#line 940 "../src/Commands.vala"
		_g_object_unref0 (_tmp22_);
#line 940 "../src/Commands.vala"
		if (_tmp26_) {
#line 10355 "Commands.c"
			LibraryWindow* _tmp27_;
			LibraryWindow* _tmp28_;
			SourceProxy* _tmp29_;
			DataSource* _tmp30_;
			Event* _tmp31_;
#line 942 "../src/Commands.vala"
			_tmp27_ = library_window_get_app ();
#line 942 "../src/Commands.vala"
			_tmp28_ = _tmp27_;
#line 942 "../src/Commands.vala"
			_tmp29_ = self->priv->new_event_proxy;
#line 942 "../src/Commands.vala"
			_tmp30_ = source_proxy_get_source (_tmp29_);
#line 942 "../src/Commands.vala"
			_tmp31_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_EVENT, Event);
#line 942 "../src/Commands.vala"
			library_window_switch_to_event (_tmp28_, _tmp31_);
#line 942 "../src/Commands.vala"
			_g_object_unref0 (_tmp31_);
#line 942 "../src/Commands.vala"
			_g_object_unref0 (_tmp28_);
#line 10377 "Commands.c"
		}
	}
}

static void
move_photos_command_real_move_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                                     DataSource* source)
{
	MovePhotosCommandRealMovePhotosCommand * self;
	SourceProxy* _tmp0_;
	DataSource* _tmp1_;
	Event* _tmp2_;
#line 948 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommand);
#line 948 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 949 "../src/Commands.vala"
	_tmp0_ = self->priv->new_event_proxy;
#line 949 "../src/Commands.vala"
	_tmp1_ = source_proxy_get_source (_tmp0_);
#line 949 "../src/Commands.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_EVENT, Event);
#line 949 "../src/Commands.vala"
	media_source_set_event (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource), _tmp2_);
#line 949 "../src/Commands.vala"
	_g_object_unref0 (_tmp2_);
#line 10404 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                                  DataSource* source)
{
	MovePhotosCommandRealMovePhotosCommand * self;
	MediaSource* current_media = NULL;
	MediaSource* _tmp0_;
	SourceProxy* event_proxy = NULL;
	GeeHashMap* _tmp1_;
	MediaSource* _tmp2_;
	gpointer _tmp3_;
	Event* _tmp4_ = NULL;
	SourceProxy* _tmp5_;
	MediaSource* _tmp8_;
#line 952 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommand);
#line 952 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 953 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 953 "../src/Commands.vala"
	current_media = _tmp0_;
#line 954 "../src/Commands.vala"
	_tmp1_ = self->priv->old_events;
#line 954 "../src/Commands.vala"
	_tmp2_ = current_media;
#line 954 "../src/Commands.vala"
	_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_);
#line 954 "../src/Commands.vala"
	event_proxy = (SourceProxy*) _tmp3_;
#line 956 "../src/Commands.vala"
	_tmp5_ = event_proxy;
#line 956 "../src/Commands.vala"
	if (_tmp5_ != NULL) {
#line 10441 "Commands.c"
		SourceProxy* _tmp6_;
		DataSource* _tmp7_;
#line 956 "../src/Commands.vala"
		_tmp6_ = event_proxy;
#line 956 "../src/Commands.vala"
		_tmp7_ = source_proxy_get_source (_tmp6_);
#line 956 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 956 "../src/Commands.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_EVENT, Event);
#line 10452 "Commands.c"
	} else {
#line 956 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 956 "../src/Commands.vala"
		_tmp4_ = NULL;
#line 10458 "Commands.c"
	}
#line 956 "../src/Commands.vala"
	_tmp8_ = current_media;
#line 956 "../src/Commands.vala"
	media_source_set_event (_tmp8_, _tmp4_);
#line 952 "../src/Commands.vala"
	_g_object_unref0 (_tmp4_);
#line 952 "../src/Commands.vala"
	_source_proxy_unref0 (event_proxy);
#line 952 "../src/Commands.vala"
	_g_object_unref0 (current_media);
#line 10470 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_on_proxy_broken (MovePhotosCommandRealMovePhotosCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 959 "../src/Commands.vala"
	g_return_if_fail (MOVE_PHOTOS_COMMAND_IS_REAL_MOVE_PHOTOS_COMMAND (self));
#line 960 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 960 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 960 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 960 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 10488 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_class_init (MovePhotosCommandRealMovePhotosCommandClass * klass,
                                                         gpointer klass_data)
{
#line 886 "../src/Commands.vala"
	move_photos_command_real_move_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 886 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &MovePhotosCommandRealMovePhotosCommand_private_offset);
#line 886 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) move_photos_command_real_move_photos_command_real_execute;
#line 886 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) move_photos_command_real_move_photos_command_real_execute_on_source;
#line 886 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) move_photos_command_real_move_photos_command_real_undo_on_source;
#line 886 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = move_photos_command_real_move_photos_command_finalize;
#line 10507 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_instance_init (MovePhotosCommandRealMovePhotosCommand * self,
                                                            gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 886 "../src/Commands.vala"
	self->priv = move_photos_command_real_move_photos_command_get_instance_private (self);
#line 887 "../src/Commands.vala"
	self->priv->new_event_proxy = NULL;
#line 888 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 888 "../src/Commands.vala"
	self->priv->old_events = _tmp0_;
#line 10523 "Commands.c"
}

static void
move_photos_command_real_move_photos_command_finalize (GObject * obj)
{
	MovePhotosCommandRealMovePhotosCommand * self;
	SourceProxy* _tmp0_;
	guint _tmp1_;
#line 886 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MOVE_PHOTOS_COMMAND_TYPE_REAL_MOVE_PHOTOS_COMMAND, MovePhotosCommandRealMovePhotosCommand);
#line 914 "../src/Commands.vala"
	_tmp0_ = self->priv->new_event_proxy;
#line 914 "../src/Commands.vala"
	g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp1_, NULL, FALSE);
#line 914 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken, self);
#line 10540 "Commands.c"
	{
		GeeIterator* _proxy_it = NULL;
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 916 "../src/Commands.vala"
		_tmp2_ = self->priv->old_events;
#line 916 "../src/Commands.vala"
		_tmp3_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 916 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 916 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 916 "../src/Commands.vala"
		_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 916 "../src/Commands.vala"
		_tmp7_ = _tmp6_;
#line 916 "../src/Commands.vala"
		_g_object_unref0 (_tmp5_);
#line 916 "../src/Commands.vala"
		_proxy_it = _tmp7_;
#line 916 "../src/Commands.vala"
		while (TRUE) {
#line 10567 "Commands.c"
			GeeIterator* _tmp8_;
			SourceProxy* proxy = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			SourceProxy* _tmp11_;
#line 916 "../src/Commands.vala"
			_tmp8_ = _proxy_it;
#line 916 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 916 "../src/Commands.vala"
				break;
#line 10579 "Commands.c"
			}
#line 916 "../src/Commands.vala"
			_tmp9_ = _proxy_it;
#line 916 "../src/Commands.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 916 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp10_;
#line 917 "../src/Commands.vala"
			_tmp11_ = proxy;
#line 917 "../src/Commands.vala"
			if (_tmp11_ != NULL) {
#line 10591 "Commands.c"
				SourceProxy* _tmp12_;
				guint _tmp13_;
#line 918 "../src/Commands.vala"
				_tmp12_ = proxy;
#line 918 "../src/Commands.vala"
				g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp13_, NULL, FALSE);
#line 918 "../src/Commands.vala"
				g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _move_photos_command_real_move_photos_command_on_proxy_broken_source_proxy_broken, self);
#line 10600 "Commands.c"
			}
#line 916 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 10604 "Commands.c"
		}
#line 916 "../src/Commands.vala"
		_g_object_unref0 (_proxy_it);
#line 10608 "Commands.c"
	}
#line 887 "../src/Commands.vala"
	_source_proxy_unref0 (self->priv->new_event_proxy);
#line 888 "../src/Commands.vala"
	_g_object_unref0 (self->priv->old_events);
#line 886 "../src/Commands.vala"
	G_OBJECT_CLASS (move_photos_command_real_move_photos_command_parent_class)->finalize (obj);
#line 10616 "Commands.c"
}

static GType
move_photos_command_real_move_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MovePhotosCommandRealMovePhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) move_photos_command_real_move_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MovePhotosCommandRealMovePhotosCommand), 0, (GInstanceInitFunc) move_photos_command_real_move_photos_command_instance_init, NULL };
	GType move_photos_command_real_move_photos_command_type_id;
	move_photos_command_real_move_photos_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "MovePhotosCommandRealMovePhotosCommand", &g_define_type_info, 0);
	MovePhotosCommandRealMovePhotosCommand_private_offset = g_type_add_instance_private (move_photos_command_real_move_photos_command_type_id, sizeof (MovePhotosCommandRealMovePhotosCommandPrivate));
	return move_photos_command_real_move_photos_command_type_id;
}

GType
move_photos_command_real_move_photos_command_get_type (void)
{
	static volatile gsize move_photos_command_real_move_photos_command_type_id__once = 0;
	if (g_once_init_enter (&move_photos_command_real_move_photos_command_type_id__once)) {
		GType move_photos_command_real_move_photos_command_type_id;
		move_photos_command_real_move_photos_command_type_id = move_photos_command_real_move_photos_command_get_type_once ();
		g_once_init_leave (&move_photos_command_real_move_photos_command_type_id__once, move_photos_command_real_move_photos_command_type_id);
	}
	return move_photos_command_real_move_photos_command_type_id__once;
}

static void
move_photos_command_class_init (MovePhotosCommandClass * klass,
                                gpointer klass_data)
{
#line 883 "../src/Commands.vala"
	move_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 883 "../src/Commands.vala"
	((CommandClass *) klass)->prepare = (void (*) (Command*)) move_photos_command_real_prepare;
#line 883 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) move_photos_command_real_execute;
#line 883 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) move_photos_command_real_undo;
#line 883 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = move_photos_command_finalize;
#line 10655 "Commands.c"
}

static void
move_photos_command_instance_init (MovePhotosCommand * self,
                                   gpointer klass)
{
}

static void
move_photos_command_finalize (GObject * obj)
{
	MovePhotosCommand * self;
#line 883 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand);
#line 964 "../src/Commands.vala"
	_g_object_unref0 (self->real_command);
#line 883 "../src/Commands.vala"
	G_OBJECT_CLASS (move_photos_command_parent_class)->finalize (obj);
#line 10674 "Commands.c"
}

static GType
move_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MovePhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) move_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MovePhotosCommand), 0, (GInstanceInitFunc) move_photos_command_instance_init, NULL };
	GType move_photos_command_type_id;
	move_photos_command_type_id = g_type_register_static (TYPE_COMMAND, "MovePhotosCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return move_photos_command_type_id;
}

GType
move_photos_command_get_type (void)
{
	static volatile gsize move_photos_command_type_id__once = 0;
	if (g_once_init_enter (&move_photos_command_type_id__once)) {
		GType move_photos_command_type_id;
		move_photos_command_type_id = move_photos_command_get_type_once ();
		g_once_init_leave (&move_photos_command_type_id__once, move_photos_command_type_id);
	}
	return move_photos_command_type_id__once;
}

NewEventCommand*
new_event_command_construct (GType object_type,
                             GeeIterable* iter)
{
	NewEventCommand * self = NULL;
	MediaSource* key_source = NULL;
	MediaSource* _tmp9_;
	Event* new_event = NULL;
	MediaSource* _tmp10_;
	Event* _tmp11_;
	MovePhotosCommandRealMovePhotosCommand* _tmp12_;
#line 987 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 988 "../src/Commands.vala"
	self = (NewEventCommand*) move_photos_command_construct (object_type, RESOURCES_NEW_EVENT_LABEL, "");
#line 991 "../src/Commands.vala"
	key_source = NULL;
#line 10715 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp0_;
#line 992 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (iter);
#line 992 "../src/Commands.vala"
		_view_it = _tmp0_;
#line 992 "../src/Commands.vala"
		while (TRUE) {
#line 10725 "Commands.c"
			GeeIterator* _tmp1_;
			DataView* view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MediaSource* current_source = NULL;
			DataView* _tmp4_;
			DataSource* _tmp5_;
			MediaSource* _tmp6_;
#line 992 "../src/Commands.vala"
			_tmp1_ = _view_it;
#line 992 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 992 "../src/Commands.vala"
				break;
#line 10740 "Commands.c"
			}
#line 992 "../src/Commands.vala"
			_tmp2_ = _view_it;
#line 992 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 992 "../src/Commands.vala"
			view = (DataView*) _tmp3_;
#line 993 "../src/Commands.vala"
			_tmp4_ = view;
#line 993 "../src/Commands.vala"
			_tmp5_ = data_view_get_source (_tmp4_);
#line 993 "../src/Commands.vala"
			current_source = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MEDIA_SOURCE, MediaSource);
#line 995 "../src/Commands.vala"
			_tmp6_ = key_source;
#line 995 "../src/Commands.vala"
			if (_tmp6_ == NULL) {
#line 10758 "Commands.c"
				MediaSource* _tmp7_;
				MediaSource* _tmp8_;
#line 996 "../src/Commands.vala"
				_tmp7_ = current_source;
#line 996 "../src/Commands.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 996 "../src/Commands.vala"
				_g_object_unref0 (key_source);
#line 996 "../src/Commands.vala"
				key_source = _tmp8_;
#line 997 "../src/Commands.vala"
				_g_object_unref0 (current_source);
#line 997 "../src/Commands.vala"
				_g_object_unref0 (view);
#line 997 "../src/Commands.vala"
				break;
#line 10775 "Commands.c"
			}
#line 992 "../src/Commands.vala"
			_g_object_unref0 (current_source);
#line 992 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 10781 "Commands.c"
		}
#line 992 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 10785 "Commands.c"
	}
#line 1002 "../src/Commands.vala"
	_tmp9_ = key_source;
#line 1002 "../src/Commands.vala"
	_vala_assert (_tmp9_ != NULL, "key_source != null");
#line 1004 "../src/Commands.vala"
	_tmp10_ = key_source;
#line 1004 "../src/Commands.vala"
	_tmp11_ = event_create_empty_event (_tmp10_);
#line 1004 "../src/Commands.vala"
	new_event = _tmp11_;
#line 1006 "../src/Commands.vala"
	_tmp12_ = move_photos_command_real_move_photos_command_new (new_event, iter, _ ("Creating New Event"), _ ("Removing Event"), RESOURCES_NEW_EVENT_LABEL, "");
#line 1006 "../src/Commands.vala"
	_g_object_unref0 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command);
#line 1006 "../src/Commands.vala"
	G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command = _tmp12_;
#line 987 "../src/Commands.vala"
	_g_object_unref0 (new_event);
#line 987 "../src/Commands.vala"
	_g_object_unref0 (key_source);
#line 987 "../src/Commands.vala"
	return self;
#line 10809 "Commands.c"
}

NewEventCommand*
new_event_command_new (GeeIterable* iter)
{
#line 987 "../src/Commands.vala"
	return new_event_command_construct (TYPE_NEW_EVENT_COMMAND, iter);
#line 10817 "Commands.c"
}

static void
new_event_command_class_init (NewEventCommandClass * klass,
                              gpointer klass_data)
{
#line 986 "../src/Commands.vala"
	new_event_command_parent_class = g_type_class_peek_parent (klass);
#line 10826 "Commands.c"
}

static void
new_event_command_instance_init (NewEventCommand * self,
                                 gpointer klass)
{
}

static GType
new_event_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NewEventCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_event_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewEventCommand), 0, (GInstanceInitFunc) new_event_command_instance_init, NULL };
	GType new_event_command_type_id;
	new_event_command_type_id = g_type_register_static (TYPE_MOVE_PHOTOS_COMMAND, "NewEventCommand", &g_define_type_info, 0);
	return new_event_command_type_id;
}

GType
new_event_command_get_type (void)
{
	static volatile gsize new_event_command_type_id__once = 0;
	if (g_once_init_enter (&new_event_command_type_id__once)) {
		GType new_event_command_type_id;
		new_event_command_type_id = new_event_command_get_type_once ();
		g_once_init_leave (&new_event_command_type_id__once, new_event_command_type_id);
	}
	return new_event_command_type_id__once;
}

SetEventCommand*
set_event_command_construct (GType object_type,
                             GeeIterable* iter,
                             Event* new_event)
{
	SetEventCommand * self = NULL;
	MovePhotosCommandRealMovePhotosCommand* _tmp0_;
#line 1013 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1013 "../src/Commands.vala"
	g_return_val_if_fail (IS_EVENT (new_event), NULL);
#line 1014 "../src/Commands.vala"
	self = (SetEventCommand*) move_photos_command_construct (object_type, RESOURCES_SET_PHOTO_EVENT_LABEL, RESOURCES_SET_PHOTO_EVENT_TOOLTIP);
#line 1016 "../src/Commands.vala"
	_tmp0_ = move_photos_command_real_move_photos_command_new (new_event, iter, _ ("Moving Photos to New Event"), _ ("Setting Photos to Previous Event"), RESOURCES_SET_PHOTO_EVENT_LABEL, "");
#line 1016 "../src/Commands.vala"
	_g_object_unref0 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command);
#line 1016 "../src/Commands.vala"
	G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command = _tmp0_;
#line 1013 "../src/Commands.vala"
	return self;
#line 10877 "Commands.c"
}

SetEventCommand*
set_event_command_new (GeeIterable* iter,
                       Event* new_event)
{
#line 1013 "../src/Commands.vala"
	return set_event_command_construct (TYPE_SET_EVENT_COMMAND, iter, new_event);
#line 10886 "Commands.c"
}

static void
set_event_command_class_init (SetEventCommandClass * klass,
                              gpointer klass_data)
{
#line 1012 "../src/Commands.vala"
	set_event_command_parent_class = g_type_class_peek_parent (klass);
#line 10895 "Commands.c"
}

static void
set_event_command_instance_init (SetEventCommand * self,
                                 gpointer klass)
{
}

static GType
set_event_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetEventCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_event_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetEventCommand), 0, (GInstanceInitFunc) set_event_command_instance_init, NULL };
	GType set_event_command_type_id;
	set_event_command_type_id = g_type_register_static (TYPE_MOVE_PHOTOS_COMMAND, "SetEventCommand", &g_define_type_info, 0);
	return set_event_command_type_id;
}

GType
set_event_command_get_type (void)
{
	static volatile gsize set_event_command_type_id__once = 0;
	if (g_once_init_enter (&set_event_command_type_id__once)) {
		GType set_event_command_type_id;
		set_event_command_type_id = set_event_command_get_type_once ();
		g_once_init_leave (&set_event_command_type_id__once, set_event_command_type_id);
	}
	return set_event_command_type_id__once;
}

MergeEventsCommand*
merge_events_command_construct (GType object_type,
                                GeeIterable* iter)
{
	MergeEventsCommand * self = NULL;
	Event* master_event = NULL;
	gint named_evt_src_count = 0;
	gint unnamed_evt_src_count = 0;
	GeeArrayList* media_thumbs = NULL;
	GeeArrayList* _tmp0_;
	Event* _tmp34_;
	GeeArrayList* _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	Event* _tmp38_;
	GeeArrayList* _tmp39_;
	MovePhotosCommandRealMovePhotosCommand* _tmp40_;
#line 1023 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1024 "../src/Commands.vala"
	self = (MergeEventsCommand*) move_photos_command_construct (object_type, RESOURCES_MERGE_LABEL, "");
#line 1030 "../src/Commands.vala"
	master_event = NULL;
#line 1031 "../src/Commands.vala"
	named_evt_src_count = 0;
#line 1032 "../src/Commands.vala"
	unnamed_evt_src_count = 0;
#line 1033 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_THUMBNAIL_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1033 "../src/Commands.vala"
	media_thumbs = _tmp0_;
#line 10956 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp1_;
#line 1035 "../src/Commands.vala"
		_tmp1_ = gee_iterable_iterator (iter);
#line 1035 "../src/Commands.vala"
		_view_it = _tmp1_;
#line 1035 "../src/Commands.vala"
		while (TRUE) {
#line 10966 "Commands.c"
			GeeIterator* _tmp2_;
			DataView* view = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			Event* event = NULL;
			DataView* _tmp5_;
			DataSource* _tmp6_;
			Event* _tmp7_;
#line 1035 "../src/Commands.vala"
			_tmp2_ = _view_it;
#line 1035 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1035 "../src/Commands.vala"
				break;
#line 10981 "Commands.c"
			}
#line 1035 "../src/Commands.vala"
			_tmp3_ = _view_it;
#line 1035 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1035 "../src/Commands.vala"
			view = (DataView*) _tmp4_;
#line 1036 "../src/Commands.vala"
			_tmp5_ = view;
#line 1036 "../src/Commands.vala"
			_tmp6_ = data_view_get_source (_tmp5_);
#line 1036 "../src/Commands.vala"
			event = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_EVENT, Event);
#line 1039 "../src/Commands.vala"
			_tmp7_ = master_event;
#line 1039 "../src/Commands.vala"
			if (_tmp7_ == NULL) {
#line 10999 "Commands.c"
				Event* _tmp8_;
				Event* _tmp9_;
				Event* _tmp10_;
				Event* _tmp11_;
#line 1042 "../src/Commands.vala"
				_tmp8_ = event;
#line 1042 "../src/Commands.vala"
				_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1042 "../src/Commands.vala"
				_g_object_unref0 (master_event);
#line 1042 "../src/Commands.vala"
				master_event = _tmp9_;
#line 1043 "../src/Commands.vala"
				_tmp10_ = master_event;
#line 1043 "../src/Commands.vala"
				unnamed_evt_src_count = event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_EVENT_SOURCE, EventSource));
#line 1044 "../src/Commands.vala"
				_tmp11_ = event;
#line 1044 "../src/Commands.vala"
				if (event_has_name (_tmp11_)) {
#line 11020 "Commands.c"
					Event* _tmp12_;
#line 1045 "../src/Commands.vala"
					_tmp12_ = master_event;
#line 1045 "../src/Commands.vala"
					named_evt_src_count = event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_EVENT_SOURCE, EventSource));
#line 11026 "Commands.c"
				}
			} else {
				Event* _tmp13_;
#line 1049 "../src/Commands.vala"
				_tmp13_ = event;
#line 1049 "../src/Commands.vala"
				if (event_has_name (_tmp13_)) {
#line 11034 "Commands.c"
					Event* _tmp14_;
#line 1050 "../src/Commands.vala"
					_tmp14_ = event;
#line 1050 "../src/Commands.vala"
					if (event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_EVENT_SOURCE, EventSource)) > named_evt_src_count) {
#line 11040 "Commands.c"
						Event* _tmp15_;
						Event* _tmp16_;
						Event* _tmp17_;
#line 1051 "../src/Commands.vala"
						_tmp15_ = event;
#line 1051 "../src/Commands.vala"
						named_evt_src_count = event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_EVENT_SOURCE, EventSource));
#line 1052 "../src/Commands.vala"
						_tmp16_ = event;
#line 1052 "../src/Commands.vala"
						_tmp17_ = _g_object_ref0 (_tmp16_);
#line 1052 "../src/Commands.vala"
						_g_object_unref0 (master_event);
#line 1052 "../src/Commands.vala"
						master_event = _tmp17_;
#line 11056 "Commands.c"
					}
				} else {
#line 1054 "../src/Commands.vala"
					if (named_evt_src_count == 0) {
#line 11061 "Commands.c"
						Event* _tmp18_;
#line 1058 "../src/Commands.vala"
						_tmp18_ = event;
#line 1058 "../src/Commands.vala"
						if (event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_EVENT_SOURCE, EventSource)) > unnamed_evt_src_count) {
#line 11067 "Commands.c"
							Event* _tmp19_;
							Event* _tmp20_;
							Event* _tmp21_;
#line 1059 "../src/Commands.vala"
							_tmp19_ = event;
#line 1059 "../src/Commands.vala"
							unnamed_evt_src_count = event_source_get_media_count (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_EVENT_SOURCE, EventSource));
#line 1060 "../src/Commands.vala"
							_tmp20_ = event;
#line 1060 "../src/Commands.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1060 "../src/Commands.vala"
							_g_object_unref0 (master_event);
#line 1060 "../src/Commands.vala"
							master_event = _tmp21_;
#line 11083 "Commands.c"
						}
					}
				}
			}
			{
				GeeIterator* _media_source_it = NULL;
				Event* _tmp22_;
				GeeCollection* _tmp23_;
				GeeCollection* _tmp24_;
				GeeIterator* _tmp25_;
				GeeIterator* _tmp26_;
#line 1067 "../src/Commands.vala"
				_tmp22_ = event;
#line 1067 "../src/Commands.vala"
				_tmp23_ = event_source_get_media (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_EVENT_SOURCE, EventSource));
#line 1067 "../src/Commands.vala"
				_tmp24_ = _tmp23_;
#line 1067 "../src/Commands.vala"
				_tmp25_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1067 "../src/Commands.vala"
				_tmp26_ = _tmp25_;
#line 1067 "../src/Commands.vala"
				_g_object_unref0 (_tmp24_);
#line 1067 "../src/Commands.vala"
				_media_source_it = _tmp26_;
#line 1067 "../src/Commands.vala"
				while (TRUE) {
#line 11111 "Commands.c"
					GeeIterator* _tmp27_;
					MediaSource* media_source = NULL;
					GeeIterator* _tmp28_;
					gpointer _tmp29_;
					GeeArrayList* _tmp30_;
					MediaSource* _tmp31_;
					ThumbnailView* _tmp32_;
					ThumbnailView* _tmp33_;
#line 1067 "../src/Commands.vala"
					_tmp27_ = _media_source_it;
#line 1067 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp27_)) {
#line 1067 "../src/Commands.vala"
						break;
#line 11126 "Commands.c"
					}
#line 1067 "../src/Commands.vala"
					_tmp28_ = _media_source_it;
#line 1067 "../src/Commands.vala"
					_tmp29_ = gee_iterator_get (_tmp28_);
#line 1067 "../src/Commands.vala"
					media_source = (MediaSource*) _tmp29_;
#line 1068 "../src/Commands.vala"
					_tmp30_ = media_thumbs;
#line 1068 "../src/Commands.vala"
					_tmp31_ = media_source;
#line 1068 "../src/Commands.vala"
					_tmp32_ = thumbnail_view_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
#line 1068 "../src/Commands.vala"
					_tmp33_ = _tmp32_;
#line 1068 "../src/Commands.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp33_);
#line 1068 "../src/Commands.vala"
					_g_object_unref0 (_tmp33_);
#line 1067 "../src/Commands.vala"
					_g_object_unref0 (media_source);
#line 11148 "Commands.c"
				}
#line 1067 "../src/Commands.vala"
				_g_object_unref0 (_media_source_it);
#line 11152 "Commands.c"
			}
#line 1035 "../src/Commands.vala"
			_g_object_unref0 (event);
#line 1035 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 11158 "Commands.c"
		}
#line 1035 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 11162 "Commands.c"
	}
#line 1071 "../src/Commands.vala"
	_tmp34_ = master_event;
#line 1071 "../src/Commands.vala"
	_vala_assert (_tmp34_ != NULL, "master_event != null");
#line 1072 "../src/Commands.vala"
	_tmp35_ = media_thumbs;
#line 1072 "../src/Commands.vala"
	_tmp36_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1072 "../src/Commands.vala"
	_tmp37_ = _tmp36_;
#line 1072 "../src/Commands.vala"
	_vala_assert (_tmp37_ > 0, "media_thumbs.size > 0");
#line 1074 "../src/Commands.vala"
	_tmp38_ = master_event;
#line 1074 "../src/Commands.vala"
	_tmp39_ = media_thumbs;
#line 1074 "../src/Commands.vala"
	_tmp40_ = move_photos_command_real_move_photos_command_new (_tmp38_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_ITERABLE, GeeIterable), _ ("Merging"), _ ("Unmerging"), RESOURCES_MERGE_LABEL, "");
#line 1074 "../src/Commands.vala"
	_g_object_unref0 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command);
#line 1074 "../src/Commands.vala"
	G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MOVE_PHOTOS_COMMAND, MovePhotosCommand)->real_command = _tmp40_;
#line 1023 "../src/Commands.vala"
	_g_object_unref0 (media_thumbs);
#line 1023 "../src/Commands.vala"
	_g_object_unref0 (master_event);
#line 1023 "../src/Commands.vala"
	return self;
#line 11192 "Commands.c"
}

MergeEventsCommand*
merge_events_command_new (GeeIterable* iter)
{
#line 1023 "../src/Commands.vala"
	return merge_events_command_construct (TYPE_MERGE_EVENTS_COMMAND, iter);
#line 11200 "Commands.c"
}

static void
merge_events_command_class_init (MergeEventsCommandClass * klass,
                                 gpointer klass_data)
{
#line 1022 "../src/Commands.vala"
	merge_events_command_parent_class = g_type_class_peek_parent (klass);
#line 11209 "Commands.c"
}

static void
merge_events_command_instance_init (MergeEventsCommand * self,
                                    gpointer klass)
{
}

static GType
merge_events_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MergeEventsCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) merge_events_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MergeEventsCommand), 0, (GInstanceInitFunc) merge_events_command_instance_init, NULL };
	GType merge_events_command_type_id;
	merge_events_command_type_id = g_type_register_static (TYPE_MOVE_PHOTOS_COMMAND, "MergeEventsCommand", &g_define_type_info, 0);
	return merge_events_command_type_id;
}

GType
merge_events_command_get_type (void)
{
	static volatile gsize merge_events_command_type_id__once = 0;
	if (g_once_init_enter (&merge_events_command_type_id__once)) {
		GType merge_events_command_type_id;
		merge_events_command_type_id = merge_events_command_get_type_once ();
		g_once_init_leave (&merge_events_command_type_id__once, merge_events_command_type_id);
	}
	return merge_events_command_type_id__once;
}

static inline gpointer
duplicate_multiple_photos_command_get_instance_private (DuplicateMultiplePhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, DuplicateMultiplePhotosCommand_private_offset);
}

static void
_duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                        DataSource* source,
                                                                                        gpointer self)
{
#line 1091 "../src/Commands.vala"
	duplicate_multiple_photos_command_on_photo_destroyed ((DuplicateMultiplePhotosCommand*) self, source);
#line 11252 "Commands.c"
}

DuplicateMultiplePhotosCommand*
duplicate_multiple_photos_command_construct (GType object_type,
                                             GeeIterable* iter)
{
	DuplicateMultiplePhotosCommand * self = NULL;
	LibraryPhotoSourceCollection* _tmp0_;
#line 1083 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1084 "../src/Commands.vala"
	self = (DuplicateMultiplePhotosCommand*) multiple_data_source_command_construct (object_type, iter, _ ("Duplicating photos"), _ ("Removing duplicated photos"), RESOURCES_DUPLICATE_PHOTO_LABEL, RESOURCES_DUPLICATE_PHOTO_TOOLTIP);
#line 1087 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 1087 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed, self, 0);
#line 1083 "../src/Commands.vala"
	return self;
#line 11271 "Commands.c"
}

DuplicateMultiplePhotosCommand*
duplicate_multiple_photos_command_new (GeeIterable* iter)
{
#line 1083 "../src/Commands.vala"
	return duplicate_multiple_photos_command_construct (TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, iter);
#line 11279 "Commands.c"
}

static void
duplicate_multiple_photos_command_on_photo_destroyed (DuplicateMultiplePhotosCommand* self,
                                                      DataSource* source)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
#line 1094 "../src/Commands.vala"
	g_return_if_fail (IS_DUPLICATE_MULTIPLE_PHOTOS_COMMAND (self));
#line 1094 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1096 "../src/Commands.vala"
	_tmp0_ = self->priv->dupes;
#line 1096 "../src/Commands.vala"
	_tmp1_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1096 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 1096 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1096 "../src/Commands.vala"
	_tmp4_ = gee_collection_contains (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 1096 "../src/Commands.vala"
	_g_object_unref0 (_tmp3_);
#line 1096 "../src/Commands.vala"
	if (_tmp4_) {
#line 11309 "Commands.c"
		CommandManager* _tmp5_;
		CommandManager* _tmp6_;
#line 1097 "../src/Commands.vala"
		_tmp5_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 1097 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 1097 "../src/Commands.vala"
		command_manager_reset (_tmp6_);
#line 1097 "../src/Commands.vala"
		_command_manager_unref0 (_tmp6_);
#line 11320 "Commands.c"
	}
}

static void
duplicate_multiple_photos_command_real_execute (Command* base)
{
	DuplicateMultiplePhotosCommand * self;
	GeeHashMap* _tmp0_;
#line 1100 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand);
#line 1101 "../src/Commands.vala"
	_tmp0_ = self->priv->dupes;
#line 1101 "../src/Commands.vala"
	gee_abstract_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1102 "../src/Commands.vala"
	self->priv->failed = 0;
#line 1104 "../src/Commands.vala"
	COMMAND_CLASS (duplicate_multiple_photos_command_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 1106 "../src/Commands.vala"
	if (self->priv->failed > 0) {
#line 11341 "Commands.c"
		gchar* error_string = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 1107 "../src/Commands.vala"
		_tmp1_ = g_strdup_printf (ngettext ("Unable to duplicate one photo due to a file error", "Unable to duplicate %d photos due to file errors", (gulong) self->priv->failed), self->priv->failed);
#line 1107 "../src/Commands.vala"
		error_string = _tmp1_;
#line 1109 "../src/Commands.vala"
		_tmp2_ = error_string;
#line 1109 "../src/Commands.vala"
		app_window_error_message (_tmp2_, NULL);
#line 1106 "../src/Commands.vala"
		_g_free0 (error_string);
#line 11355 "Commands.c"
	}
}

static void
duplicate_multiple_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                          DataSource* source)
{
	DuplicateMultiplePhotosCommand * self;
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1113 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand);
#line 1113 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1114 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 1114 "../src/Commands.vala"
	photo = _tmp0_;
#line 11375 "Commands.c"
	{
		LibraryPhoto* dupe = NULL;
		LibraryPhoto* _tmp1_;
		GeeHashMap* _tmp2_;
#line 1117 "../src/Commands.vala"
		_tmp1_ = library_photo_duplicate (photo, &_inner_error0_);
#line 1117 "../src/Commands.vala"
		dupe = _tmp1_;
#line 1117 "../src/Commands.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11386 "Commands.c"
			goto __catch0_g_error;
		}
#line 1118 "../src/Commands.vala"
		_tmp2_ = self->priv->dupes;
#line 1118 "../src/Commands.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), photo, dupe);
#line 1116 "../src/Commands.vala"
		_g_object_unref0 (dupe);
#line 11395 "Commands.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
#line 1116 "../src/Commands.vala"
		err = _inner_error0_;
#line 1116 "../src/Commands.vala"
		_inner_error0_ = NULL;
#line 1120 "../src/Commands.vala"
		_tmp3_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_MEDIA_SOURCE, MediaSource));
#line 1120 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 1120 "../src/Commands.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 1120 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 1120 "../src/Commands.vala"
		_tmp7_ = err;
#line 1120 "../src/Commands.vala"
		_tmp8_ = _tmp7_->message;
#line 1120 "../src/Commands.vala"
		g_critical ("Commands.vala:1120: Unable to duplicate file %s: %s", _tmp6_, _tmp8_);
#line 1120 "../src/Commands.vala"
		_g_free0 (_tmp6_);
#line 1120 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 1121 "../src/Commands.vala"
		_tmp9_ = self->priv->failed;
#line 1121 "../src/Commands.vala"
		self->priv->failed = _tmp9_ + 1;
#line 1116 "../src/Commands.vala"
		_g_error_free0 (err);
#line 11436 "Commands.c"
	}
	__finally0:
#line 1116 "../src/Commands.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1116 "../src/Commands.vala"
		_g_object_unref0 (photo);
#line 1116 "../src/Commands.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1116 "../src/Commands.vala"
		g_clear_error (&_inner_error0_);
#line 1116 "../src/Commands.vala"
		return;
#line 11449 "Commands.c"
	}
#line 1113 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 11453 "Commands.c"
}

static void
duplicate_multiple_photos_command_real_undo (Command* base)
{
	DuplicateMultiplePhotosCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	GeeHashMap* _tmp2_;
	LibraryPhotoSourceCollection* _tmp3_;
#line 1125 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand);
#line 1127 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 1127 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1127 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed, self);
#line 1129 "../src/Commands.vala"
	COMMAND_CLASS (duplicate_multiple_photos_command_parent_class)->undo (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 1132 "../src/Commands.vala"
	_tmp2_ = self->priv->dupes;
#line 1132 "../src/Commands.vala"
	gee_abstract_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1133 "../src/Commands.vala"
	self->priv->failed = 0;
#line 1136 "../src/Commands.vala"
	_tmp3_ = library_photo_global;
#line 1136 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed, self, 0);
#line 11484 "Commands.c"
}

static void
duplicate_multiple_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                       DataSource* source)
{
	DuplicateMultiplePhotosCommand * self;
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	Marker* marker = NULL;
	LibraryPhotoSourceCollection* _tmp1_;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	LibraryPhoto* _tmp4_;
	Marker* _tmp5_;
	Marker* _tmp6_;
	LibraryPhotoSourceCollection* _tmp7_;
#line 1139 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand);
#line 1139 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1140 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 1140 "../src/Commands.vala"
	photo = _tmp0_;
#line 1142 "../src/Commands.vala"
	_tmp1_ = library_photo_global;
#line 1142 "../src/Commands.vala"
	_tmp2_ = self->priv->dupes;
#line 1142 "../src/Commands.vala"
	_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), photo);
#line 1142 "../src/Commands.vala"
	_tmp4_ = (LibraryPhoto*) _tmp3_;
#line 1142 "../src/Commands.vala"
	_tmp5_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_OBJECT, DataObject));
#line 1142 "../src/Commands.vala"
	_tmp6_ = _tmp5_;
#line 1142 "../src/Commands.vala"
	_g_object_unref0 (_tmp4_);
#line 1142 "../src/Commands.vala"
	marker = _tmp6_;
#line 1143 "../src/Commands.vala"
	_tmp7_ = library_photo_global;
#line 1143 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_SOURCE_COLLECTION, SourceCollection), marker, TRUE, NULL, NULL, NULL);
#line 1139 "../src/Commands.vala"
	_g_object_unref0 (marker);
#line 1139 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 11534 "Commands.c"
}

static void
duplicate_multiple_photos_command_class_init (DuplicateMultiplePhotosCommandClass * klass,
                                              gpointer klass_data)
{
#line 1079 "../src/Commands.vala"
	duplicate_multiple_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 1079 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &DuplicateMultiplePhotosCommand_private_offset);
#line 1079 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) duplicate_multiple_photos_command_real_execute;
#line 1079 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) duplicate_multiple_photos_command_real_execute_on_source;
#line 1079 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) duplicate_multiple_photos_command_real_undo;
#line 1079 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) duplicate_multiple_photos_command_real_undo_on_source;
#line 1079 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = duplicate_multiple_photos_command_finalize;
#line 11555 "Commands.c"
}

static void
duplicate_multiple_photos_command_instance_init (DuplicateMultiplePhotosCommand * self,
                                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 1079 "../src/Commands.vala"
	self->priv = duplicate_multiple_photos_command_get_instance_private (self);
#line 1080 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1080 "../src/Commands.vala"
	self->priv->dupes = _tmp0_;
#line 1081 "../src/Commands.vala"
	self->priv->failed = 0;
#line 11571 "Commands.c"
}

static void
duplicate_multiple_photos_command_finalize (GObject * obj)
{
	DuplicateMultiplePhotosCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
#line 1079 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICATE_MULTIPLE_PHOTOS_COMMAND, DuplicateMultiplePhotosCommand);
#line 1091 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 1091 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1091 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _duplicate_multiple_photos_command_on_photo_destroyed_source_collection_item_destroyed, self);
#line 1080 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dupes);
#line 1079 "../src/Commands.vala"
	G_OBJECT_CLASS (duplicate_multiple_photos_command_parent_class)->finalize (obj);
#line 11592 "Commands.c"
}

static GType
duplicate_multiple_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DuplicateMultiplePhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) duplicate_multiple_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DuplicateMultiplePhotosCommand), 0, (GInstanceInitFunc) duplicate_multiple_photos_command_instance_init, NULL };
	GType duplicate_multiple_photos_command_type_id;
	duplicate_multiple_photos_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "DuplicateMultiplePhotosCommand", &g_define_type_info, 0);
	DuplicateMultiplePhotosCommand_private_offset = g_type_add_instance_private (duplicate_multiple_photos_command_type_id, sizeof (DuplicateMultiplePhotosCommandPrivate));
	return duplicate_multiple_photos_command_type_id;
}

GType
duplicate_multiple_photos_command_get_type (void)
{
	static volatile gsize duplicate_multiple_photos_command_type_id__once = 0;
	if (g_once_init_enter (&duplicate_multiple_photos_command_type_id__once)) {
		GType duplicate_multiple_photos_command_type_id;
		duplicate_multiple_photos_command_type_id = duplicate_multiple_photos_command_get_type_once ();
		g_once_init_leave (&duplicate_multiple_photos_command_type_id__once, duplicate_multiple_photos_command_type_id);
	}
	return duplicate_multiple_photos_command_type_id__once;
}

static inline gpointer
set_rating_single_command_get_instance_private (SetRatingSingleCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SetRatingSingleCommand_private_offset);
}

SetRatingSingleCommand*
set_rating_single_command_construct (GType object_type,
                                     DataSource* source,
                                     Rating rating)
{
	SetRatingSingleCommand * self = NULL;
	const gchar* _tmp0_;
#line 1153 "../src/Commands.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1154 "../src/Commands.vala"
	_tmp0_ = resources_rating_label (rating);
#line 1154 "../src/Commands.vala"
	self = (SetRatingSingleCommand*) single_data_source_command_construct (object_type, source, _tmp0_, "");
#line 1155 "../src/Commands.vala"
	self->priv->set_direct = TRUE;
#line 1156 "../src/Commands.vala"
	self->priv->new_rating = rating;
#line 1158 "../src/Commands.vala"
	self->priv->last_rating = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), TYPE_MEDIA_SOURCE, MediaSource));
#line 1153 "../src/Commands.vala"
	return self;
#line 11644 "Commands.c"
}

SetRatingSingleCommand*
set_rating_single_command_new (DataSource* source,
                               Rating rating)
{
#line 1153 "../src/Commands.vala"
	return set_rating_single_command_construct (TYPE_SET_RATING_SINGLE_COMMAND, source, rating);
#line 11653 "Commands.c"
}

SetRatingSingleCommand*
set_rating_single_command_construct_inc_dec (GType object_type,
                                             DataSource* source,
                                             gboolean is_incrementing)
{
	SetRatingSingleCommand * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 1161 "../src/Commands.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1162 "../src/Commands.vala"
	if (is_incrementing) {
#line 1162 "../src/Commands.vala"
		_tmp0_ = RESOURCES_INCREASE_RATING_LABEL;
#line 11669 "Commands.c"
	} else {
#line 1163 "../src/Commands.vala"
		_tmp0_ = RESOURCES_DECREASE_RATING_LABEL;
#line 11673 "Commands.c"
	}
#line 1162 "../src/Commands.vala"
	self = (SetRatingSingleCommand*) single_data_source_command_construct (object_type, source, _tmp0_, "");
#line 1164 "../src/Commands.vala"
	self->priv->set_direct = FALSE;
#line 1165 "../src/Commands.vala"
	self->priv->incrementing = is_incrementing;
#line 1167 "../src/Commands.vala"
	self->priv->last_rating = media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 1161 "../src/Commands.vala"
	return self;
#line 11685 "Commands.c"
}

SetRatingSingleCommand*
set_rating_single_command_new_inc_dec (DataSource* source,
                                       gboolean is_incrementing)
{
#line 1161 "../src/Commands.vala"
	return set_rating_single_command_construct_inc_dec (TYPE_SET_RATING_SINGLE_COMMAND, source, is_incrementing);
#line 11694 "Commands.c"
}

static void
set_rating_single_command_real_execute (Command* base)
{
	SetRatingSingleCommand * self;
#line 1170 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommand);
#line 1171 "../src/Commands.vala"
	if (self->priv->set_direct) {
#line 11705 "Commands.c"
		DataSource* _tmp0_;
#line 1172 "../src/Commands.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 1172 "../src/Commands.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), self->priv->new_rating);
#line 11711 "Commands.c"
	} else {
#line 1174 "../src/Commands.vala"
		if (self->priv->incrementing) {
#line 11715 "Commands.c"
			DataSource* _tmp1_;
#line 1175 "../src/Commands.vala"
			_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 1175 "../src/Commands.vala"
			media_source_increase_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource));
#line 11721 "Commands.c"
		} else {
			DataSource* _tmp2_;
#line 1177 "../src/Commands.vala"
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 1177 "../src/Commands.vala"
			media_source_decrease_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_MEDIA_SOURCE, MediaSource));
#line 11728 "Commands.c"
		}
	}
}

static void
set_rating_single_command_real_undo (Command* base)
{
	SetRatingSingleCommand * self;
	DataSource* _tmp0_;
#line 1181 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommand);
#line 1182 "../src/Commands.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand)->source;
#line 1182 "../src/Commands.vala"
	media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_SOURCE, MediaSource), self->priv->last_rating);
#line 11744 "Commands.c"
}

static void
set_rating_single_command_class_init (SetRatingSingleCommandClass * klass,
                                      gpointer klass_data)
{
#line 1147 "../src/Commands.vala"
	set_rating_single_command_parent_class = g_type_class_peek_parent (klass);
#line 1147 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SetRatingSingleCommand_private_offset);
#line 1147 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) set_rating_single_command_real_execute;
#line 1147 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) set_rating_single_command_real_undo;
#line 1147 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = set_rating_single_command_finalize;
#line 11761 "Commands.c"
}

static void
set_rating_single_command_instance_init (SetRatingSingleCommand * self,
                                         gpointer klass)
{
#line 1147 "../src/Commands.vala"
	self->priv = set_rating_single_command_get_instance_private (self);
#line 11770 "Commands.c"
}

static void
set_rating_single_command_finalize (GObject * obj)
{
	SetRatingSingleCommand * self;
#line 1147 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SET_RATING_SINGLE_COMMAND, SetRatingSingleCommand);
#line 1147 "../src/Commands.vala"
	G_OBJECT_CLASS (set_rating_single_command_parent_class)->finalize (obj);
#line 11781 "Commands.c"
}

static GType
set_rating_single_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetRatingSingleCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_rating_single_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetRatingSingleCommand), 0, (GInstanceInitFunc) set_rating_single_command_instance_init, NULL };
	GType set_rating_single_command_type_id;
	set_rating_single_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "SetRatingSingleCommand", &g_define_type_info, 0);
	SetRatingSingleCommand_private_offset = g_type_add_instance_private (set_rating_single_command_type_id, sizeof (SetRatingSingleCommandPrivate));
	return set_rating_single_command_type_id;
}

GType
set_rating_single_command_get_type (void)
{
	static volatile gsize set_rating_single_command_type_id__once = 0;
	if (g_once_init_enter (&set_rating_single_command_type_id__once)) {
		GType set_rating_single_command_type_id;
		set_rating_single_command_type_id = set_rating_single_command_get_type_once ();
		g_once_init_leave (&set_rating_single_command_type_id__once, set_rating_single_command_type_id);
	}
	return set_rating_single_command_type_id__once;
}

static inline gpointer
set_rating_command_get_instance_private (SetRatingCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SetRatingCommand_private_offset);
}

SetRatingCommand*
set_rating_command_construct (GType object_type,
                              GeeIterable* iter,
                              Rating rating)
{
	SetRatingCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 1193 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1194 "../src/Commands.vala"
	_tmp0_ = resources_rating_progress (rating);
#line 1194 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1194 "../src/Commands.vala"
	_tmp2_ = resources_rating_label (rating);
#line 1194 "../src/Commands.vala"
	self = (SetRatingCommand*) multiple_data_source_command_construct (object_type, iter, _tmp1_, _ ("Restoring previous rating"), _tmp2_, "");
#line 1194 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 1196 "../src/Commands.vala"
	self->priv->set_direct = TRUE;
#line 1197 "../src/Commands.vala"
	self->priv->new_rating = rating;
#line 1199 "../src/Commands.vala"
	set_rating_command_save_source_states (self, iter);
#line 1193 "../src/Commands.vala"
	return self;
#line 11841 "Commands.c"
}

SetRatingCommand*
set_rating_command_new (GeeIterable* iter,
                        Rating rating)
{
#line 1193 "../src/Commands.vala"
	return set_rating_command_construct (TYPE_SET_RATING_COMMAND, iter, rating);
#line 11850 "Commands.c"
}

SetRatingCommand*
set_rating_command_construct_inc_dec (GType object_type,
                                      GeeIterable* iter,
                                      gboolean is_incrementing)
{
	SetRatingCommand * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 1202 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1204 "../src/Commands.vala"
	if (is_incrementing) {
#line 1204 "../src/Commands.vala"
		_tmp0_ = _ ("Increasing ratings");
#line 11868 "Commands.c"
	} else {
#line 1204 "../src/Commands.vala"
		_tmp0_ = _ ("Decreasing ratings");
#line 11872 "Commands.c"
	}
#line 1205 "../src/Commands.vala"
	if (is_incrementing) {
#line 1205 "../src/Commands.vala"
		_tmp1_ = _ ("Decreasing ratings");
#line 11878 "Commands.c"
	} else {
#line 1205 "../src/Commands.vala"
		_tmp1_ = _ ("Increasing ratings");
#line 11882 "Commands.c"
	}
#line 1206 "../src/Commands.vala"
	if (is_incrementing) {
#line 1206 "../src/Commands.vala"
		_tmp2_ = RESOURCES_INCREASE_RATING_LABEL;
#line 11888 "Commands.c"
	} else {
#line 1206 "../src/Commands.vala"
		_tmp2_ = RESOURCES_DECREASE_RATING_LABEL;
#line 11892 "Commands.c"
	}
#line 1203 "../src/Commands.vala"
	self = (SetRatingCommand*) multiple_data_source_command_construct (object_type, iter, _tmp0_, _tmp1_, _tmp2_, "");
#line 1208 "../src/Commands.vala"
	self->priv->set_direct = FALSE;
#line 1209 "../src/Commands.vala"
	self->priv->incrementing = is_incrementing;
#line 1211 "../src/Commands.vala"
	set_rating_command_save_source_states (self, iter);
#line 1202 "../src/Commands.vala"
	return self;
#line 11904 "Commands.c"
}

SetRatingCommand*
set_rating_command_new_inc_dec (GeeIterable* iter,
                                gboolean is_incrementing)
{
#line 1202 "../src/Commands.vala"
	return set_rating_command_construct_inc_dec (TYPE_SET_RATING_COMMAND, iter, is_incrementing);
#line 11913 "Commands.c"
}

static void
set_rating_command_save_source_states (SetRatingCommand* self,
                                       GeeIterable* iter)
{
	GeeHashMap* _tmp0_;
#line 1214 "../src/Commands.vala"
	g_return_if_fail (IS_SET_RATING_COMMAND (self));
#line 1214 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE));
#line 1215 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_RATING, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1215 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_rating_map);
#line 1215 "../src/Commands.vala"
	self->priv->last_rating_map = _tmp0_;
#line 11931 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp1_;
#line 1217 "../src/Commands.vala"
		_tmp1_ = gee_iterable_iterator (iter);
#line 1217 "../src/Commands.vala"
		_view_it = _tmp1_;
#line 1217 "../src/Commands.vala"
		while (TRUE) {
#line 11941 "Commands.c"
			GeeIterator* _tmp2_;
			DataView* view = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataSource* source = NULL;
			DataView* _tmp5_;
			DataSource* _tmp6_;
			GeeHashMap* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
#line 1217 "../src/Commands.vala"
			_tmp2_ = _view_it;
#line 1217 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1217 "../src/Commands.vala"
				break;
#line 11958 "Commands.c"
			}
#line 1217 "../src/Commands.vala"
			_tmp3_ = _view_it;
#line 1217 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1217 "../src/Commands.vala"
			view = (DataView*) _tmp4_;
#line 1218 "../src/Commands.vala"
			_tmp5_ = view;
#line 1218 "../src/Commands.vala"
			_tmp6_ = data_view_get_source (_tmp5_);
#line 1218 "../src/Commands.vala"
			source = _tmp6_;
#line 1219 "../src/Commands.vala"
			_tmp7_ = self->priv->last_rating_map;
#line 1219 "../src/Commands.vala"
			_tmp8_ = source;
#line 1219 "../src/Commands.vala"
			_tmp9_ = source;
#line 1219 "../src/Commands.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, (gpointer) ((gintptr) media_source_get_rating (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_MEDIA_SOURCE, MediaSource))));
#line 1217 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 1217 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 11984 "Commands.c"
		}
#line 1217 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 11988 "Commands.c"
	}
}

static void
set_rating_command_real_execute (Command* base)
{
	SetRatingCommand * self;
#line 1223 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_COMMAND, SetRatingCommand);
#line 1224 "../src/Commands.vala"
	self->priv->action_count = 0;
#line 1225 "../src/Commands.vala"
	COMMAND_CLASS (set_rating_command_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 12002 "Commands.c"
}

static void
set_rating_command_real_undo (Command* base)
{
	SetRatingCommand * self;
#line 1228 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_COMMAND, SetRatingCommand);
#line 1229 "../src/Commands.vala"
	self->priv->action_count = 0;
#line 1230 "../src/Commands.vala"
	COMMAND_CLASS (set_rating_command_parent_class)->undo (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 12015 "Commands.c"
}

static void
set_rating_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                           DataSource* source)
{
	SetRatingCommand * self;
#line 1233 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_COMMAND, SetRatingCommand);
#line 1233 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1234 "../src/Commands.vala"
	if (self->priv->set_direct) {
#line 1235 "../src/Commands.vala"
		media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource), self->priv->new_rating);
#line 12031 "Commands.c"
	} else {
#line 1237 "../src/Commands.vala"
		if (self->priv->incrementing) {
#line 1238 "../src/Commands.vala"
			media_source_increase_rating (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 12037 "Commands.c"
		} else {
#line 1240 "../src/Commands.vala"
			media_source_decrease_rating (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 12041 "Commands.c"
		}
	}
}

static void
set_rating_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                        DataSource* source)
{
	SetRatingCommand * self;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 1244 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RATING_COMMAND, SetRatingCommand);
#line 1244 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1245 "../src/Commands.vala"
	_tmp0_ = self->priv->last_rating_map;
#line 1245 "../src/Commands.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), source);
#line 1245 "../src/Commands.vala"
	media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource), (Rating) ((gintptr) _tmp1_));
#line 12063 "Commands.c"
}

static void
set_rating_command_class_init (SetRatingCommandClass * klass,
                               gpointer klass_data)
{
#line 1186 "../src/Commands.vala"
	set_rating_command_parent_class = g_type_class_peek_parent (klass);
#line 1186 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SetRatingCommand_private_offset);
#line 1186 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) set_rating_command_real_execute;
#line 1186 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) set_rating_command_real_undo;
#line 1186 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) set_rating_command_real_execute_on_source;
#line 1186 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) set_rating_command_real_undo_on_source;
#line 1186 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = set_rating_command_finalize;
#line 12084 "Commands.c"
}

static void
set_rating_command_instance_init (SetRatingCommand * self,
                                  gpointer klass)
{
#line 1186 "../src/Commands.vala"
	self->priv = set_rating_command_get_instance_private (self);
#line 1191 "../src/Commands.vala"
	self->priv->action_count = 0;
#line 12095 "Commands.c"
}

static void
set_rating_command_finalize (GObject * obj)
{
	SetRatingCommand * self;
#line 1186 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SET_RATING_COMMAND, SetRatingCommand);
#line 1187 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_rating_map);
#line 1186 "../src/Commands.vala"
	G_OBJECT_CLASS (set_rating_command_parent_class)->finalize (obj);
#line 12108 "Commands.c"
}

static GType
set_rating_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetRatingCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_rating_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetRatingCommand), 0, (GInstanceInitFunc) set_rating_command_instance_init, NULL };
	GType set_rating_command_type_id;
	set_rating_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "SetRatingCommand", &g_define_type_info, 0);
	SetRatingCommand_private_offset = g_type_add_instance_private (set_rating_command_type_id, sizeof (SetRatingCommandPrivate));
	return set_rating_command_type_id;
}

GType
set_rating_command_get_type (void)
{
	static volatile gsize set_rating_command_type_id__once = 0;
	if (g_once_init_enter (&set_rating_command_type_id__once)) {
		GType set_rating_command_type_id;
		set_rating_command_type_id = set_rating_command_get_type_once ();
		g_once_init_leave (&set_rating_command_type_id__once, set_rating_command_type_id);
	}
	return set_rating_command_type_id__once;
}

static inline gpointer
set_raw_developer_command_get_instance_private (SetRawDeveloperCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SetRawDeveloperCommand_private_offset);
}

SetRawDeveloperCommand*
set_raw_developer_command_construct (GType object_type,
                                     GeeIterable* iter,
                                     RawDeveloper developer)
{
	SetRawDeveloperCommand * self = NULL;
#line 1254 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1255 "../src/Commands.vala"
	self = (SetRawDeveloperCommand*) multiple_data_source_command_construct (object_type, iter, _ ("Setting RAW developer"), _ ("Restoring previous RAW developer"), _ ("Set Developer"), "");
#line 1257 "../src/Commands.vala"
	self->priv->new_developer = developer;
#line 1258 "../src/Commands.vala"
	set_raw_developer_command_save_source_states (self, iter);
#line 1254 "../src/Commands.vala"
	return self;
#line 12155 "Commands.c"
}

SetRawDeveloperCommand*
set_raw_developer_command_new (GeeIterable* iter,
                               RawDeveloper developer)
{
#line 1254 "../src/Commands.vala"
	return set_raw_developer_command_construct (TYPE_SET_RAW_DEVELOPER_COMMAND, iter, developer);
#line 12164 "Commands.c"
}

static void
set_raw_developer_command_save_source_states (SetRawDeveloperCommand* self,
                                              GeeIterable* iter)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 1261 "../src/Commands.vala"
	g_return_if_fail (IS_SET_RAW_DEVELOPER_COMMAND (self));
#line 1261 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE));
#line 1262 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_RAW_DEVELOPER, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1262 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_developer_map);
#line 1262 "../src/Commands.vala"
	self->priv->last_developer_map = _tmp0_;
#line 1263 "../src/Commands.vala"
	_tmp1_ = gee_hash_map_new (TYPE_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_PHOTO_TRANSFORMATION_STATE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1263 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_transformation_map);
#line 1263 "../src/Commands.vala"
	self->priv->last_transformation_map = _tmp1_;
#line 12189 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp2_;
#line 1265 "../src/Commands.vala"
		_tmp2_ = gee_iterable_iterator (iter);
#line 1265 "../src/Commands.vala"
		_view_it = _tmp2_;
#line 1265 "../src/Commands.vala"
		while (TRUE) {
#line 12199 "Commands.c"
			GeeIterator* _tmp3_;
			DataView* view = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			Photo* photo = NULL;
			DataView* _tmp6_;
			DataSource* _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
#line 1265 "../src/Commands.vala"
			_tmp3_ = _view_it;
#line 1265 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 1265 "../src/Commands.vala"
				break;
#line 12215 "Commands.c"
			}
#line 1265 "../src/Commands.vala"
			_tmp4_ = _view_it;
#line 1265 "../src/Commands.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 1265 "../src/Commands.vala"
			view = (DataView*) _tmp5_;
#line 1266 "../src/Commands.vala"
			_tmp6_ = view;
#line 1266 "../src/Commands.vala"
			_tmp7_ = data_view_get_source (_tmp6_);
#line 1266 "../src/Commands.vala"
			_tmp8_ = IS_PHOTO (_tmp7_) ? ((Photo*) _tmp7_) : NULL;
#line 1266 "../src/Commands.vala"
			if (_tmp8_ == NULL) {
#line 1266 "../src/Commands.vala"
				_g_object_unref0 (_tmp7_);
#line 12233 "Commands.c"
			}
#line 1266 "../src/Commands.vala"
			photo = _tmp8_;
#line 1267 "../src/Commands.vala"
			_tmp9_ = photo;
#line 1267 "../src/Commands.vala"
			if (set_raw_developer_command_is_raw_photo (self, _tmp9_)) {
#line 12241 "Commands.c"
				GeeHashMap* _tmp10_;
				Photo* _tmp11_;
				Photo* _tmp12_;
				GeeHashMap* _tmp13_;
				Photo* _tmp14_;
				Photo* _tmp15_;
				PhotoTransformationState* _tmp16_;
				PhotoTransformationState* _tmp17_;
#line 1268 "../src/Commands.vala"
				_tmp10_ = self->priv->last_developer_map;
#line 1268 "../src/Commands.vala"
				_tmp11_ = photo;
#line 1268 "../src/Commands.vala"
				_tmp12_ = photo;
#line 1268 "../src/Commands.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_, (gpointer) ((gintptr) photo_get_raw_developer (_tmp12_)));
#line 1269 "../src/Commands.vala"
				_tmp13_ = self->priv->last_transformation_map;
#line 1269 "../src/Commands.vala"
				_tmp14_ = photo;
#line 1269 "../src/Commands.vala"
				_tmp15_ = photo;
#line 1269 "../src/Commands.vala"
				_tmp16_ = photo_save_transformation_state (_tmp15_);
#line 1269 "../src/Commands.vala"
				_tmp17_ = _tmp16_;
#line 1269 "../src/Commands.vala"
				gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, _tmp17_);
#line 1269 "../src/Commands.vala"
				_g_object_unref0 (_tmp17_);
#line 12272 "Commands.c"
			}
#line 1265 "../src/Commands.vala"
			_g_object_unref0 (photo);
#line 1265 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 12278 "Commands.c"
		}
#line 1265 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 12282 "Commands.c"
	}
}

static void
set_raw_developer_command_real_execute (Command* base)
{
	SetRawDeveloperCommand * self;
#line 1274 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand);
#line 1275 "../src/Commands.vala"
	COMMAND_CLASS (set_raw_developer_command_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 12294 "Commands.c"
}

static void
set_raw_developer_command_real_undo (Command* base)
{
	SetRawDeveloperCommand * self;
#line 1278 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand);
#line 1279 "../src/Commands.vala"
	COMMAND_CLASS (set_raw_developer_command_parent_class)->undo (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 12305 "Commands.c"
}

static void
set_raw_developer_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                  DataSource* source)
{
	SetRawDeveloperCommand * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 1282 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand);
#line 1282 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1283 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 1283 "../src/Commands.vala"
	photo = _tmp0_;
#line 1284 "../src/Commands.vala"
	_tmp1_ = photo;
#line 1284 "../src/Commands.vala"
	if (set_raw_developer_command_is_raw_photo (self, _tmp1_)) {
#line 12328 "Commands.c"
		gboolean _tmp2_ = FALSE;
#line 1285 "../src/Commands.vala"
		if (self->priv->new_developer == RAW_DEVELOPER_CAMERA) {
#line 12332 "Commands.c"
			Photo* _tmp3_;
#line 1285 "../src/Commands.vala"
			_tmp3_ = photo;
#line 1285 "../src/Commands.vala"
			_tmp2_ = !photo_is_raw_developer_available (_tmp3_, RAW_DEVELOPER_CAMERA);
#line 12338 "Commands.c"
		} else {
#line 1285 "../src/Commands.vala"
			_tmp2_ = FALSE;
#line 12342 "Commands.c"
		}
#line 1285 "../src/Commands.vala"
		if (_tmp2_) {
#line 12346 "Commands.c"
			Photo* _tmp4_;
#line 1286 "../src/Commands.vala"
			_tmp4_ = photo;
#line 1286 "../src/Commands.vala"
			photo_set_raw_developer (_tmp4_, RAW_DEVELOPER_EMBEDDED, TRUE);
#line 12352 "Commands.c"
		} else {
			Photo* _tmp5_;
#line 1288 "../src/Commands.vala"
			_tmp5_ = photo;
#line 1288 "../src/Commands.vala"
			photo_set_raw_developer (_tmp5_, self->priv->new_developer, TRUE);
#line 12359 "Commands.c"
		}
	}
#line 1282 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 12364 "Commands.c"
}

static void
set_raw_developer_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                               DataSource* source)
{
	SetRawDeveloperCommand * self;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 1292 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand);
#line 1292 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1293 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_PHOTO (source) ? ((Photo*) source) : NULL);
#line 1293 "../src/Commands.vala"
	photo = _tmp0_;
#line 1294 "../src/Commands.vala"
	_tmp1_ = photo;
#line 1294 "../src/Commands.vala"
	if (set_raw_developer_command_is_raw_photo (self, _tmp1_)) {
#line 12387 "Commands.c"
		Photo* _tmp2_;
		GeeHashMap* _tmp3_;
		Photo* _tmp4_;
		gpointer _tmp5_;
		Photo* _tmp6_;
		GeeHashMap* _tmp7_;
		Photo* _tmp8_;
		gpointer _tmp9_;
		PhotoTransformationState* _tmp10_;
#line 1295 "../src/Commands.vala"
		_tmp2_ = photo;
#line 1295 "../src/Commands.vala"
		_tmp3_ = self->priv->last_developer_map;
#line 1295 "../src/Commands.vala"
		_tmp4_ = photo;
#line 1295 "../src/Commands.vala"
		_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 1295 "../src/Commands.vala"
		photo_set_raw_developer (_tmp2_, (RawDeveloper) ((gintptr) _tmp5_), TRUE);
#line 1296 "../src/Commands.vala"
		_tmp6_ = photo;
#line 1296 "../src/Commands.vala"
		_tmp7_ = self->priv->last_transformation_map;
#line 1296 "../src/Commands.vala"
		_tmp8_ = photo;
#line 1296 "../src/Commands.vala"
		_tmp9_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_);
#line 1296 "../src/Commands.vala"
		_tmp10_ = (PhotoTransformationState*) _tmp9_;
#line 1296 "../src/Commands.vala"
		photo_load_transformation_state (_tmp6_, _tmp10_);
#line 1296 "../src/Commands.vala"
		_g_object_unref0 (_tmp10_);
#line 12421 "Commands.c"
	}
#line 1292 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 12425 "Commands.c"
}

static gboolean
set_raw_developer_command_is_raw_photo (SetRawDeveloperCommand* self,
                                        Photo* photo)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1300 "../src/Commands.vala"
	g_return_val_if_fail (IS_SET_RAW_DEVELOPER_COMMAND (self), FALSE);
#line 1300 "../src/Commands.vala"
	g_return_val_if_fail ((photo == NULL) || IS_PHOTO (photo), FALSE);
#line 1301 "../src/Commands.vala"
	if (photo != NULL) {
#line 1301 "../src/Commands.vala"
		_tmp0_ = photo_get_master_file_format (photo) == PHOTO_FILE_FORMAT_RAW;
#line 12442 "Commands.c"
	} else {
#line 1301 "../src/Commands.vala"
		_tmp0_ = FALSE;
#line 12446 "Commands.c"
	}
#line 1301 "../src/Commands.vala"
	result = _tmp0_;
#line 1301 "../src/Commands.vala"
	return result;
#line 12452 "Commands.c"
}

static void
set_raw_developer_command_class_init (SetRawDeveloperCommandClass * klass,
                                      gpointer klass_data)
{
#line 1249 "../src/Commands.vala"
	set_raw_developer_command_parent_class = g_type_class_peek_parent (klass);
#line 1249 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SetRawDeveloperCommand_private_offset);
#line 1249 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) set_raw_developer_command_real_execute;
#line 1249 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) set_raw_developer_command_real_undo;
#line 1249 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) set_raw_developer_command_real_execute_on_source;
#line 1249 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) set_raw_developer_command_real_undo_on_source;
#line 1249 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = set_raw_developer_command_finalize;
#line 12473 "Commands.c"
}

static void
set_raw_developer_command_instance_init (SetRawDeveloperCommand * self,
                                         gpointer klass)
{
#line 1249 "../src/Commands.vala"
	self->priv = set_raw_developer_command_get_instance_private (self);
#line 12482 "Commands.c"
}

static void
set_raw_developer_command_finalize (GObject * obj)
{
	SetRawDeveloperCommand * self;
#line 1249 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SET_RAW_DEVELOPER_COMMAND, SetRawDeveloperCommand);
#line 1250 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_developer_map);
#line 1251 "../src/Commands.vala"
	_g_object_unref0 (self->priv->last_transformation_map);
#line 1249 "../src/Commands.vala"
	G_OBJECT_CLASS (set_raw_developer_command_parent_class)->finalize (obj);
#line 12497 "Commands.c"
}

static GType
set_raw_developer_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetRawDeveloperCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_raw_developer_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetRawDeveloperCommand), 0, (GInstanceInitFunc) set_raw_developer_command_instance_init, NULL };
	GType set_raw_developer_command_type_id;
	set_raw_developer_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "SetRawDeveloperCommand", &g_define_type_info, 0);
	SetRawDeveloperCommand_private_offset = g_type_add_instance_private (set_raw_developer_command_type_id, sizeof (SetRawDeveloperCommandPrivate));
	return set_raw_developer_command_type_id;
}

GType
set_raw_developer_command_get_type (void)
{
	static volatile gsize set_raw_developer_command_type_id__once = 0;
	if (g_once_init_enter (&set_raw_developer_command_type_id__once)) {
		GType set_raw_developer_command_type_id;
		set_raw_developer_command_type_id = set_raw_developer_command_get_type_once ();
		g_once_init_leave (&set_raw_developer_command_type_id__once, set_raw_developer_command_type_id);
	}
	return set_raw_developer_command_type_id__once;
}

static inline gpointer
adjust_date_time_photo_command_get_instance_private (AdjustDateTimePhotoCommand* self)
{
	return G_STRUCT_MEMBER_P (self, AdjustDateTimePhotoCommand_private_offset);
}

AdjustDateTimePhotoCommand*
adjust_date_time_photo_command_construct (GType object_type,
                                          Dateable* dateable,
                                          gint64 time_shift,
                                          gboolean modify_original)
{
	AdjustDateTimePhotoCommand * self = NULL;
	Dateable* _tmp0_;
#line 1311 "../src/Commands.vala"
	g_return_val_if_fail (IS_DATEABLE (dateable), NULL);
#line 1312 "../src/Commands.vala"
	self = (AdjustDateTimePhotoCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (dateable, TYPE_DATA_SOURCE, DataSource), RESOURCES_ADJUST_DATE_TIME_LABEL, "");
#line 1314 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (dateable);
#line 1314 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dateable);
#line 1314 "../src/Commands.vala"
	self->priv->dateable = _tmp0_;
#line 1315 "../src/Commands.vala"
	self->priv->time_shift = time_shift;
#line 1316 "../src/Commands.vala"
	self->priv->modify_original = modify_original;
#line 1311 "../src/Commands.vala"
	return self;
#line 12552 "Commands.c"
}

AdjustDateTimePhotoCommand*
adjust_date_time_photo_command_new (Dateable* dateable,
                                    gint64 time_shift,
                                    gboolean modify_original)
{
#line 1311 "../src/Commands.vala"
	return adjust_date_time_photo_command_construct (TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, dateable, time_shift, modify_original);
#line 12562 "Commands.c"
}

static GDateTime*
adjust_date_time_photo_command_get_base_time (AdjustDateTimePhotoCommand* self)
{
	GDateTime* exposure_time = NULL;
	Dateable* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* result;
#line 1319 "../src/Commands.vala"
	g_return_val_if_fail (IS_ADJUST_DATE_TIME_PHOTO_COMMAND (self), NULL);
#line 1320 "../src/Commands.vala"
	_tmp0_ = self->priv->dateable;
#line 1320 "../src/Commands.vala"
	_tmp1_ = dateable_get_exposure_time (_tmp0_);
#line 1320 "../src/Commands.vala"
	exposure_time = _tmp1_;
#line 1321 "../src/Commands.vala"
	_tmp2_ = exposure_time;
#line 1321 "../src/Commands.vala"
	if (_tmp2_ == NULL) {
#line 12585 "Commands.c"
		GDateTime* _tmp3_;
#line 1322 "../src/Commands.vala"
		_tmp3_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 1322 "../src/Commands.vala"
		_g_date_time_unref0 (exposure_time);
#line 1322 "../src/Commands.vala"
		exposure_time = _tmp3_;
#line 12593 "Commands.c"
	}
#line 1325 "../src/Commands.vala"
	result = exposure_time;
#line 1325 "../src/Commands.vala"
	return result;
#line 12599 "Commands.c"
}

static void
adjust_date_time_photo_command_real_execute (Command* base)
{
	AdjustDateTimePhotoCommand * self;
	Dateable* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	Dateable* _tmp5_;
	Event* _tmp6_;
	ViewCollection* all_events = NULL;
	ViewCollection* _tmp7_;
	Dateable* _tmp23_;
	ViewCollection* _tmp24_;
#line 1328 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommand);
#line 1329 "../src/Commands.vala"
	_tmp0_ = self->priv->dateable;
#line 1329 "../src/Commands.vala"
	_tmp1_ = adjust_date_time_photo_command_get_base_time (self);
#line 1329 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 1329 "../src/Commands.vala"
	_tmp3_ = g_date_time_add_seconds (_tmp2_, (gdouble) self->priv->time_shift);
#line 1329 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 1329 "../src/Commands.vala"
	adjust_date_time_photo_command_set_time (self, _tmp0_, _tmp4_);
#line 1329 "../src/Commands.vala"
	_g_date_time_unref0 (_tmp4_);
#line 1329 "../src/Commands.vala"
	_g_date_time_unref0 (_tmp2_);
#line 1331 "../src/Commands.vala"
	_tmp5_ = self->priv->dateable;
#line 1331 "../src/Commands.vala"
	_tmp6_ = media_source_get_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1331 "../src/Commands.vala"
	_g_object_unref0 (self->priv->prev_event);
#line 1331 "../src/Commands.vala"
	self->priv->prev_event = _tmp6_;
#line 1333 "../src/Commands.vala"
	_tmp7_ = view_collection_new ("tmp");
#line 1333 "../src/Commands.vala"
	all_events = _tmp7_;
#line 12647 "Commands.c"
	{
		GeeIterator* _dobj_it = NULL;
		EventSourceCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
		GeeIterator* _tmp11_;
		GeeIterator* _tmp12_;
#line 1335 "../src/Commands.vala"
		_tmp8_ = event_global;
#line 1335 "../src/Commands.vala"
		_tmp9_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_COLLECTION, DataCollection));
#line 1335 "../src/Commands.vala"
		_tmp10_ = _tmp9_;
#line 1335 "../src/Commands.vala"
		_tmp11_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1335 "../src/Commands.vala"
		_tmp12_ = _tmp11_;
#line 1335 "../src/Commands.vala"
		_g_object_unref0 (_tmp10_);
#line 1335 "../src/Commands.vala"
		_dobj_it = _tmp12_;
#line 1335 "../src/Commands.vala"
		while (TRUE) {
#line 12671 "Commands.c"
			GeeIterator* _tmp13_;
			DataObject* dobj = NULL;
			GeeIterator* _tmp14_;
			gpointer _tmp15_;
			Event* event = NULL;
			DataObject* _tmp16_;
			Event* _tmp17_;
			Event* _tmp18_;
#line 1335 "../src/Commands.vala"
			_tmp13_ = _dobj_it;
#line 1335 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp13_)) {
#line 1335 "../src/Commands.vala"
				break;
#line 12686 "Commands.c"
			}
#line 1335 "../src/Commands.vala"
			_tmp14_ = _dobj_it;
#line 1335 "../src/Commands.vala"
			_tmp15_ = gee_iterator_get (_tmp14_);
#line 1335 "../src/Commands.vala"
			dobj = (DataObject*) _tmp15_;
#line 1336 "../src/Commands.vala"
			_tmp16_ = dobj;
#line 1336 "../src/Commands.vala"
			_tmp17_ = _g_object_ref0 (IS_EVENT (_tmp16_) ? ((Event*) _tmp16_) : NULL);
#line 1336 "../src/Commands.vala"
			event = _tmp17_;
#line 1337 "../src/Commands.vala"
			_tmp18_ = event;
#line 1337 "../src/Commands.vala"
			if (_tmp18_ != NULL) {
#line 12704 "Commands.c"
				ViewCollection* _tmp19_;
				Event* _tmp20_;
				EventView* _tmp21_;
				EventView* _tmp22_;
#line 1338 "../src/Commands.vala"
				_tmp19_ = all_events;
#line 1338 "../src/Commands.vala"
				_tmp20_ = event;
#line 1338 "../src/Commands.vala"
				_tmp21_ = event_view_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_EVENT_SOURCE, EventSource));
#line 1338 "../src/Commands.vala"
				_tmp22_ = _tmp21_;
#line 1338 "../src/Commands.vala"
				data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_DATA_OBJECT, DataObject));
#line 1338 "../src/Commands.vala"
				_g_object_unref0 (_tmp22_);
#line 12721 "Commands.c"
			}
#line 1335 "../src/Commands.vala"
			_g_object_unref0 (event);
#line 1335 "../src/Commands.vala"
			_g_object_unref0 (dobj);
#line 12727 "Commands.c"
		}
#line 1335 "../src/Commands.vala"
		_g_object_unref0 (_dobj_it);
#line 12731 "Commands.c"
	}
#line 1341 "../src/Commands.vala"
	_tmp23_ = self->priv->dateable;
#line 1341 "../src/Commands.vala"
	_tmp24_ = all_events;
#line 1341 "../src/Commands.vala"
	event_generate_single_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_MEDIA_SOURCE, MediaSource), _tmp24_, NULL);
#line 1328 "../src/Commands.vala"
	_data_collection_unref0 (all_events);
#line 12741 "Commands.c"
}

static void
adjust_date_time_photo_command_real_undo (Command* base)
{
	AdjustDateTimePhotoCommand * self;
	Dateable* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	Dateable* _tmp5_;
	Event* _tmp6_;
#line 1344 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommand);
#line 1345 "../src/Commands.vala"
	_tmp0_ = self->priv->dateable;
#line 1345 "../src/Commands.vala"
	_tmp1_ = adjust_date_time_photo_command_get_base_time (self);
#line 1345 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 1345 "../src/Commands.vala"
	_tmp3_ = g_date_time_add_seconds (_tmp2_, (gdouble) (-1 * self->priv->time_shift));
#line 1345 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 1345 "../src/Commands.vala"
	adjust_date_time_photo_command_set_time (self, _tmp0_, _tmp4_);
#line 1345 "../src/Commands.vala"
	_g_date_time_unref0 (_tmp4_);
#line 1345 "../src/Commands.vala"
	_g_date_time_unref0 (_tmp2_);
#line 1347 "../src/Commands.vala"
	_tmp5_ = self->priv->dateable;
#line 1347 "../src/Commands.vala"
	_tmp6_ = self->priv->prev_event;
#line 1347 "../src/Commands.vala"
	media_source_set_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MEDIA_SOURCE, MediaSource), _tmp6_);
#line 12779 "Commands.c"
}

static void
adjust_date_time_photo_command_set_time (AdjustDateTimePhotoCommand* self,
                                         Dateable* dateable,
                                         GDateTime* exposure_time)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1350 "../src/Commands.vala"
	g_return_if_fail (IS_ADJUST_DATE_TIME_PHOTO_COMMAND (self));
#line 1350 "../src/Commands.vala"
	g_return_if_fail (IS_DATEABLE (dateable));
#line 1350 "../src/Commands.vala"
	g_return_if_fail (exposure_time != NULL);
#line 1351 "../src/Commands.vala"
	if (self->priv->modify_original) {
#line 1351 "../src/Commands.vala"
		_tmp0_ = IS_PHOTO (dateable);
#line 12799 "Commands.c"
	} else {
#line 1351 "../src/Commands.vala"
		_tmp0_ = FALSE;
#line 12803 "Commands.c"
	}
#line 1351 "../src/Commands.vala"
	if (_tmp0_) {
#line 12807 "Commands.c"
		{
#line 1353 "../src/Commands.vala"
			photo_set_exposure_time_persistent (G_TYPE_CHECK_INSTANCE_CAST (dateable, TYPE_PHOTO, Photo), exposure_time, &_inner_error0_);
#line 1353 "../src/Commands.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12813 "Commands.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 1352 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 1355 "../src/Commands.vala"
			app_window_error_message (_ ("Original photo could not be adjusted."), NULL);
#line 12824 "Commands.c"
		}
		__finally0:
#line 1352 "../src/Commands.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1352 "../src/Commands.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1352 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 1352 "../src/Commands.vala"
			return;
#line 12835 "Commands.c"
		}
	} else {
#line 1358 "../src/Commands.vala"
		dateable_set_exposure_time (dateable, exposure_time);
#line 12840 "Commands.c"
	}
}

static void
adjust_date_time_photo_command_class_init (AdjustDateTimePhotoCommandClass * klass,
                                           gpointer klass_data)
{
#line 1305 "../src/Commands.vala"
	adjust_date_time_photo_command_parent_class = g_type_class_peek_parent (klass);
#line 1305 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &AdjustDateTimePhotoCommand_private_offset);
#line 1305 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) adjust_date_time_photo_command_real_execute;
#line 1305 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) adjust_date_time_photo_command_real_undo;
#line 1305 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = adjust_date_time_photo_command_finalize;
#line 12858 "Commands.c"
}

static void
adjust_date_time_photo_command_instance_init (AdjustDateTimePhotoCommand * self,
                                              gpointer klass)
{
#line 1305 "../src/Commands.vala"
	self->priv = adjust_date_time_photo_command_get_instance_private (self);
#line 12867 "Commands.c"
}

static void
adjust_date_time_photo_command_finalize (GObject * obj)
{
	AdjustDateTimePhotoCommand * self;
#line 1305 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_DATE_TIME_PHOTO_COMMAND, AdjustDateTimePhotoCommand);
#line 1306 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dateable);
#line 1307 "../src/Commands.vala"
	_g_object_unref0 (self->priv->prev_event);
#line 1305 "../src/Commands.vala"
	G_OBJECT_CLASS (adjust_date_time_photo_command_parent_class)->finalize (obj);
#line 12882 "Commands.c"
}

static GType
adjust_date_time_photo_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdjustDateTimePhotoCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adjust_date_time_photo_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdjustDateTimePhotoCommand), 0, (GInstanceInitFunc) adjust_date_time_photo_command_instance_init, NULL };
	GType adjust_date_time_photo_command_type_id;
	adjust_date_time_photo_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "AdjustDateTimePhotoCommand", &g_define_type_info, 0);
	AdjustDateTimePhotoCommand_private_offset = g_type_add_instance_private (adjust_date_time_photo_command_type_id, sizeof (AdjustDateTimePhotoCommandPrivate));
	return adjust_date_time_photo_command_type_id;
}

GType
adjust_date_time_photo_command_get_type (void)
{
	static volatile gsize adjust_date_time_photo_command_type_id__once = 0;
	if (g_once_init_enter (&adjust_date_time_photo_command_type_id__once)) {
		GType adjust_date_time_photo_command_type_id;
		adjust_date_time_photo_command_type_id = adjust_date_time_photo_command_get_type_once ();
		g_once_init_leave (&adjust_date_time_photo_command_type_id__once, adjust_date_time_photo_command_type_id);
	}
	return adjust_date_time_photo_command_type_id__once;
}

static inline gpointer
adjust_date_time_photos_command_get_instance_private (AdjustDateTimePhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, AdjustDateTimePhotosCommand_private_offset);
}

AdjustDateTimePhotosCommand*
adjust_date_time_photos_command_construct (GType object_type,
                                           GeeIterable* iter,
                                           gint64 time_shift,
                                           gboolean keep_relativity,
                                           gboolean modify_originals)
{
	AdjustDateTimePhotosCommand * self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp22_;
#line 1374 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (iter, GEE_TYPE_ITERABLE), NULL);
#line 1376 "../src/Commands.vala"
	self = (AdjustDateTimePhotosCommand*) multiple_data_source_command_construct (object_type, iter, _ ("Adjusting Date and Time"), _ ("Undoing Date and Time Adjustment"), RESOURCES_ADJUST_DATE_TIME_LABEL, "");
#line 1379 "../src/Commands.vala"
	self->priv->time_shift = time_shift;
#line 1380 "../src/Commands.vala"
	self->priv->keep_relativity = keep_relativity;
#line 1381 "../src/Commands.vala"
	self->priv->modify_originals = modify_originals;
#line 1385 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_DATEABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1385 "../src/Commands.vala"
	_g_object_unref0 (self->priv->prev_events);
#line 1385 "../src/Commands.vala"
	self->priv->prev_events = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 12939 "Commands.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp1_;
#line 1388 "../src/Commands.vala"
		_tmp1_ = gee_iterable_iterator (iter);
#line 1388 "../src/Commands.vala"
		_view_it = _tmp1_;
#line 1388 "../src/Commands.vala"
		while (TRUE) {
#line 12949 "Commands.c"
			GeeIterator* _tmp2_;
			DataView* view = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeMap* _tmp5_;
			DataView* _tmp6_;
			DataSource* _tmp7_;
			Dateable* _tmp8_;
			Dateable* _tmp9_;
			DataView* _tmp10_;
			DataSource* _tmp11_;
			MediaSource* _tmp12_;
			Event* _tmp13_;
			Event* _tmp14_;
			GDateTime* _tmp15_;
#line 1388 "../src/Commands.vala"
			_tmp2_ = _view_it;
#line 1388 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1388 "../src/Commands.vala"
				break;
#line 12971 "Commands.c"
			}
#line 1388 "../src/Commands.vala"
			_tmp3_ = _view_it;
#line 1388 "../src/Commands.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1388 "../src/Commands.vala"
			view = (DataView*) _tmp4_;
#line 1389 "../src/Commands.vala"
			_tmp5_ = self->priv->prev_events;
#line 1389 "../src/Commands.vala"
			_tmp6_ = view;
#line 1389 "../src/Commands.vala"
			_tmp7_ = data_view_get_source (_tmp6_);
#line 1389 "../src/Commands.vala"
			_tmp8_ = IS_DATEABLE (_tmp7_) ? ((Dateable*) _tmp7_) : NULL;
#line 1389 "../src/Commands.vala"
			if (_tmp8_ == NULL) {
#line 1389 "../src/Commands.vala"
				_g_object_unref0 (_tmp7_);
#line 12991 "Commands.c"
			}
#line 1389 "../src/Commands.vala"
			_tmp9_ = _tmp8_;
#line 1389 "../src/Commands.vala"
			_tmp10_ = view;
#line 1389 "../src/Commands.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 1389 "../src/Commands.vala"
			_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_MEDIA_SOURCE, MediaSource);
#line 1389 "../src/Commands.vala"
			_tmp13_ = media_source_get_event (_tmp12_);
#line 1389 "../src/Commands.vala"
			_tmp14_ = _tmp13_;
#line 1389 "../src/Commands.vala"
			gee_map_set (_tmp5_, _tmp9_, _tmp14_);
#line 1389 "../src/Commands.vala"
			_g_object_unref0 (_tmp14_);
#line 1389 "../src/Commands.vala"
			_g_object_unref0 (_tmp12_);
#line 1389 "../src/Commands.vala"
			_g_object_unref0 (_tmp9_);
#line 1391 "../src/Commands.vala"
			_tmp15_ = self->priv->new_time;
#line 1391 "../src/Commands.vala"
			if (_tmp15_ == NULL) {
#line 13017 "Commands.c"
				DataView* _tmp16_;
				DataSource* _tmp17_;
				Dateable* _tmp18_;
				GDateTime* _tmp19_;
				GDateTime* _tmp20_;
				GDateTime* _tmp21_;
#line 1392 "../src/Commands.vala"
				_tmp16_ = view;
#line 1392 "../src/Commands.vala"
				_tmp17_ = data_view_get_source (_tmp16_);
#line 1392 "../src/Commands.vala"
				_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_DATEABLE, Dateable);
#line 1392 "../src/Commands.vala"
				_tmp19_ = adjust_date_time_photos_command_get_base_time (self, _tmp18_);
#line 1392 "../src/Commands.vala"
				_tmp20_ = _tmp19_;
#line 1392 "../src/Commands.vala"
				_tmp21_ = g_date_time_add_seconds (_tmp20_, (gdouble) time_shift);
#line 1392 "../src/Commands.vala"
				_g_date_time_unref0 (self->priv->new_time);
#line 1392 "../src/Commands.vala"
				self->priv->new_time = _tmp21_;
#line 1392 "../src/Commands.vala"
				_g_date_time_unref0 (_tmp20_);
#line 1392 "../src/Commands.vala"
				_g_object_unref0 (_tmp18_);
#line 1393 "../src/Commands.vala"
				_g_object_unref0 (view);
#line 1393 "../src/Commands.vala"
				break;
#line 13048 "Commands.c"
			}
#line 1388 "../src/Commands.vala"
			_g_object_unref0 (view);
#line 13052 "Commands.c"
		}
#line 1388 "../src/Commands.vala"
		_g_object_unref0 (_view_it);
#line 13056 "Commands.c"
	}
#line 1397 "../src/Commands.vala"
	_tmp22_ = gee_hash_map_new (TYPE_DATEABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1397 "../src/Commands.vala"
	_g_object_unref0 (self->priv->old_times);
#line 1397 "../src/Commands.vala"
	self->priv->old_times = _tmp22_;
#line 1374 "../src/Commands.vala"
	return self;
#line 13066 "Commands.c"
}

AdjustDateTimePhotosCommand*
adjust_date_time_photos_command_new (GeeIterable* iter,
                                     gint64 time_shift,
                                     gboolean keep_relativity,
                                     gboolean modify_originals)
{
#line 1374 "../src/Commands.vala"
	return adjust_date_time_photos_command_construct (TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, iter, time_shift, keep_relativity, modify_originals);
#line 13077 "Commands.c"
}

static GDateTime*
adjust_date_time_photos_command_get_base_time (AdjustDateTimePhotosCommand* self,
                                               Dateable* dateable)
{
	GDateTime* exposure_time = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* result;
#line 1400 "../src/Commands.vala"
	g_return_val_if_fail (IS_ADJUST_DATE_TIME_PHOTOS_COMMAND (self), NULL);
#line 1400 "../src/Commands.vala"
	g_return_val_if_fail (IS_DATEABLE (dateable), NULL);
#line 1401 "../src/Commands.vala"
	_tmp0_ = dateable_get_exposure_time (dateable);
#line 1401 "../src/Commands.vala"
	exposure_time = _tmp0_;
#line 1402 "../src/Commands.vala"
	_tmp1_ = exposure_time;
#line 1402 "../src/Commands.vala"
	if (_tmp1_ == NULL) {
#line 13100 "Commands.c"
		GDateTime* _tmp2_;
#line 1403 "../src/Commands.vala"
		_tmp2_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 1403 "../src/Commands.vala"
		_g_date_time_unref0 (exposure_time);
#line 1403 "../src/Commands.vala"
		exposure_time = _tmp2_;
#line 13108 "Commands.c"
	}
#line 1406 "../src/Commands.vala"
	result = exposure_time;
#line 1406 "../src/Commands.vala"
	return result;
#line 13114 "Commands.c"
}

static void
adjust_date_time_photos_command_real_execute (Command* base)
{
	AdjustDateTimePhotosCommand * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	ViewCollection* all_events = NULL;
	ViewCollection* _tmp8_;
#line 1409 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand);
#line 1410 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATEABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1410 "../src/Commands.vala"
	_g_object_unref0 (self->priv->error_list);
#line 1410 "../src/Commands.vala"
	self->priv->error_list = _tmp0_;
#line 1411 "../src/Commands.vala"
	COMMAND_CLASS (adjust_date_time_photos_command_parent_class)->execute (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 1413 "../src/Commands.vala"
	_tmp1_ = self->priv->error_list;
#line 1413 "../src/Commands.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1413 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1413 "../src/Commands.vala"
	if (_tmp3_ > 0) {
#line 13145 "Commands.c"
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 1414 "../src/Commands.vala"
		_tmp4_ = self->priv->error_list;
#line 1414 "../src/Commands.vala"
		_tmp5_ = self->priv->error_list;
#line 1414 "../src/Commands.vala"
		_tmp6_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1414 "../src/Commands.vala"
		_tmp7_ = _tmp6_;
#line 1414 "../src/Commands.vala"
		multiple_object_error_dialog (_tmp4_, ngettext ("One original photo could not be adjusted.", "The following original photos could not be adjusted.", (gulong) _tmp7_), _ ("Time Adjustment Error"));
#line 13160 "Commands.c"
	}
#line 1420 "../src/Commands.vala"
	_tmp8_ = view_collection_new ("tmp");
#line 1420 "../src/Commands.vala"
	all_events = _tmp8_;
#line 13166 "Commands.c"
	{
		GeeIterator* _d_it = NULL;
		GeeMap* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
		GeeSet* _tmp12_;
		GeeIterator* _tmp13_;
		GeeIterator* _tmp14_;
#line 1422 "../src/Commands.vala"
		_tmp9_ = self->priv->prev_events;
#line 1422 "../src/Commands.vala"
		_tmp10_ = gee_map_get_keys (_tmp9_);
#line 1422 "../src/Commands.vala"
		_tmp11_ = _tmp10_;
#line 1422 "../src/Commands.vala"
		_tmp12_ = _tmp11_;
#line 1422 "../src/Commands.vala"
		_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1422 "../src/Commands.vala"
		_tmp14_ = _tmp13_;
#line 1422 "../src/Commands.vala"
		_g_object_unref0 (_tmp12_);
#line 1422 "../src/Commands.vala"
		_d_it = _tmp14_;
#line 1422 "../src/Commands.vala"
		while (TRUE) {
#line 13193 "Commands.c"
			GeeIterator* _tmp15_;
			Dateable* d = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			Dateable* _tmp33_;
			ViewCollection* _tmp34_;
#line 1422 "../src/Commands.vala"
			_tmp15_ = _d_it;
#line 1422 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp15_)) {
#line 1422 "../src/Commands.vala"
				break;
#line 13206 "Commands.c"
			}
#line 1422 "../src/Commands.vala"
			_tmp16_ = _d_it;
#line 1422 "../src/Commands.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 1422 "../src/Commands.vala"
			d = (Dateable*) _tmp17_;
#line 13214 "Commands.c"
			{
				GeeIterator* _dobj_it = NULL;
				EventSourceCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeCollection* _tmp20_;
				GeeIterator* _tmp21_;
				GeeIterator* _tmp22_;
#line 1423 "../src/Commands.vala"
				_tmp18_ = event_global;
#line 1423 "../src/Commands.vala"
				_tmp19_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_DATA_COLLECTION, DataCollection));
#line 1423 "../src/Commands.vala"
				_tmp20_ = _tmp19_;
#line 1423 "../src/Commands.vala"
				_tmp21_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1423 "../src/Commands.vala"
				_tmp22_ = _tmp21_;
#line 1423 "../src/Commands.vala"
				_g_object_unref0 (_tmp20_);
#line 1423 "../src/Commands.vala"
				_dobj_it = _tmp22_;
#line 1423 "../src/Commands.vala"
				while (TRUE) {
#line 13238 "Commands.c"
					GeeIterator* _tmp23_;
					DataObject* dobj = NULL;
					GeeIterator* _tmp24_;
					gpointer _tmp25_;
					Event* event = NULL;
					DataObject* _tmp26_;
					Event* _tmp27_;
					Event* _tmp28_;
#line 1423 "../src/Commands.vala"
					_tmp23_ = _dobj_it;
#line 1423 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp23_)) {
#line 1423 "../src/Commands.vala"
						break;
#line 13253 "Commands.c"
					}
#line 1423 "../src/Commands.vala"
					_tmp24_ = _dobj_it;
#line 1423 "../src/Commands.vala"
					_tmp25_ = gee_iterator_get (_tmp24_);
#line 1423 "../src/Commands.vala"
					dobj = (DataObject*) _tmp25_;
#line 1424 "../src/Commands.vala"
					_tmp26_ = dobj;
#line 1424 "../src/Commands.vala"
					_tmp27_ = _g_object_ref0 (IS_EVENT (_tmp26_) ? ((Event*) _tmp26_) : NULL);
#line 1424 "../src/Commands.vala"
					event = _tmp27_;
#line 1425 "../src/Commands.vala"
					_tmp28_ = event;
#line 1425 "../src/Commands.vala"
					if (_tmp28_ != NULL) {
#line 13271 "Commands.c"
						ViewCollection* _tmp29_;
						Event* _tmp30_;
						EventView* _tmp31_;
						EventView* _tmp32_;
#line 1426 "../src/Commands.vala"
						_tmp29_ = all_events;
#line 1426 "../src/Commands.vala"
						_tmp30_ = event;
#line 1426 "../src/Commands.vala"
						_tmp31_ = event_view_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_EVENT_SOURCE, EventSource));
#line 1426 "../src/Commands.vala"
						_tmp32_ = _tmp31_;
#line 1426 "../src/Commands.vala"
						data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_DATA_OBJECT, DataObject));
#line 1426 "../src/Commands.vala"
						_g_object_unref0 (_tmp32_);
#line 13288 "Commands.c"
					}
#line 1423 "../src/Commands.vala"
					_g_object_unref0 (event);
#line 1423 "../src/Commands.vala"
					_g_object_unref0 (dobj);
#line 13294 "Commands.c"
				}
#line 1423 "../src/Commands.vala"
				_g_object_unref0 (_dobj_it);
#line 13298 "Commands.c"
			}
#line 1429 "../src/Commands.vala"
			_tmp33_ = d;
#line 1429 "../src/Commands.vala"
			_tmp34_ = all_events;
#line 1429 "../src/Commands.vala"
			event_generate_single_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, TYPE_MEDIA_SOURCE, MediaSource), _tmp34_, NULL);
#line 1422 "../src/Commands.vala"
			_g_object_unref0 (d);
#line 13308 "Commands.c"
		}
#line 1422 "../src/Commands.vala"
		_g_object_unref0 (_d_it);
#line 13312 "Commands.c"
	}
#line 1409 "../src/Commands.vala"
	_data_collection_unref0 (all_events);
#line 13316 "Commands.c"
}

static void
adjust_date_time_photos_command_real_undo (Command* base)
{
	AdjustDateTimePhotosCommand * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 1433 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand);
#line 1434 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATEABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1434 "../src/Commands.vala"
	_g_object_unref0 (self->priv->error_list);
#line 1434 "../src/Commands.vala"
	self->priv->error_list = _tmp0_;
#line 1435 "../src/Commands.vala"
	COMMAND_CLASS (adjust_date_time_photos_command_parent_class)->undo (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MULTIPLE_DATA_SOURCE_COMMAND, MultipleDataSourceCommand), TYPE_COMMAND, Command));
#line 1437 "../src/Commands.vala"
	_tmp1_ = self->priv->error_list;
#line 1437 "../src/Commands.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1437 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1437 "../src/Commands.vala"
	if (_tmp3_ > 0) {
#line 13345 "Commands.c"
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 1438 "../src/Commands.vala"
		_tmp4_ = self->priv->error_list;
#line 1438 "../src/Commands.vala"
		_tmp5_ = self->priv->error_list;
#line 1438 "../src/Commands.vala"
		_tmp6_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1438 "../src/Commands.vala"
		_tmp7_ = _tmp6_;
#line 1438 "../src/Commands.vala"
		multiple_object_error_dialog (_tmp4_, ngettext ("Time adjustments could not be undone on the following photo file.", "Time adjustments could not be undone on the following photo files.", (gulong) _tmp7_), _ ("Time Adjustment Error"));
#line 13360 "Commands.c"
	}
}

static void
adjust_date_time_photos_command_set_time (AdjustDateTimePhotosCommand* self,
                                          Dateable* dateable,
                                          GDateTime* exposure_time)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1445 "../src/Commands.vala"
	g_return_if_fail (IS_ADJUST_DATE_TIME_PHOTOS_COMMAND (self));
#line 1445 "../src/Commands.vala"
	g_return_if_fail (IS_DATEABLE (dateable));
#line 1445 "../src/Commands.vala"
	g_return_if_fail (exposure_time != NULL);
#line 1449 "../src/Commands.vala"
	if (self->priv->modify_originals) {
#line 1449 "../src/Commands.vala"
		_tmp0_ = IS_PHOTO (dateable);
#line 13381 "Commands.c"
	} else {
#line 1449 "../src/Commands.vala"
		_tmp0_ = FALSE;
#line 13385 "Commands.c"
	}
#line 1449 "../src/Commands.vala"
	if (_tmp0_) {
#line 13389 "Commands.c"
		{
#line 1451 "../src/Commands.vala"
			photo_set_exposure_time_persistent (G_TYPE_CHECK_INSTANCE_CAST (dateable, TYPE_PHOTO, Photo), exposure_time, &_inner_error0_);
#line 1451 "../src/Commands.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13395 "Commands.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GeeArrayList* _tmp1_;
#line 1450 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 1453 "../src/Commands.vala"
			_tmp1_ = self->priv->error_list;
#line 1453 "../src/Commands.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), dateable);
#line 13409 "Commands.c"
		}
		__finally0:
#line 1450 "../src/Commands.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1450 "../src/Commands.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1450 "../src/Commands.vala"
			g_clear_error (&_inner_error0_);
#line 1450 "../src/Commands.vala"
			return;
#line 13420 "Commands.c"
		}
	} else {
#line 1458 "../src/Commands.vala"
		dateable_set_exposure_time (dateable, exposure_time);
#line 13425 "Commands.c"
	}
}

static void
adjust_date_time_photos_command_real_execute_on_source (MultipleDataSourceCommand* base,
                                                        DataSource* source)
{
	AdjustDateTimePhotosCommand * self;
	Dateable* dateable = NULL;
	Dateable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ViewCollection* all_events = NULL;
	ViewCollection* _tmp18_;
	Dateable* _tmp34_;
	ViewCollection* _tmp35_;
#line 1462 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand);
#line 1462 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1463 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATEABLE, Dateable));
#line 1463 "../src/Commands.vala"
	dateable = _tmp0_;
#line 1465 "../src/Commands.vala"
	if (self->priv->keep_relativity) {
#line 13451 "Commands.c"
		Dateable* _tmp2_;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 1465 "../src/Commands.vala"
		_tmp2_ = dateable;
#line 1465 "../src/Commands.vala"
		_tmp3_ = dateable_get_exposure_time (_tmp2_);
#line 1465 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 1465 "../src/Commands.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 1465 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp4_);
#line 13465 "Commands.c"
	} else {
#line 1465 "../src/Commands.vala"
		_tmp1_ = FALSE;
#line 13469 "Commands.c"
	}
#line 1465 "../src/Commands.vala"
	if (_tmp1_) {
#line 13473 "Commands.c"
		Dateable* _tmp5_;
		Dateable* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
#line 1466 "../src/Commands.vala"
		_tmp5_ = dateable;
#line 1466 "../src/Commands.vala"
		_tmp6_ = dateable;
#line 1466 "../src/Commands.vala"
		_tmp7_ = dateable_get_exposure_time (_tmp6_);
#line 1466 "../src/Commands.vala"
		_tmp8_ = _tmp7_;
#line 1466 "../src/Commands.vala"
		_tmp9_ = g_date_time_add_seconds (_tmp8_, (gdouble) self->priv->time_shift);
#line 1466 "../src/Commands.vala"
		_tmp10_ = _tmp9_;
#line 1466 "../src/Commands.vala"
		adjust_date_time_photos_command_set_time (self, _tmp5_, _tmp10_);
#line 1466 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp10_);
#line 1466 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp8_);
#line 13498 "Commands.c"
	} else {
		GeeHashMap* _tmp11_;
		Dateable* _tmp12_;
		Dateable* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		Dateable* _tmp16_;
		GDateTime* _tmp17_;
#line 1468 "../src/Commands.vala"
		_tmp11_ = self->priv->old_times;
#line 1468 "../src/Commands.vala"
		_tmp12_ = dateable;
#line 1468 "../src/Commands.vala"
		_tmp13_ = dateable;
#line 1468 "../src/Commands.vala"
		_tmp14_ = dateable_get_exposure_time (_tmp13_);
#line 1468 "../src/Commands.vala"
		_tmp15_ = _tmp14_;
#line 1468 "../src/Commands.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp12_, _tmp15_);
#line 1468 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp15_);
#line 1469 "../src/Commands.vala"
		_tmp16_ = dateable;
#line 1469 "../src/Commands.vala"
		_tmp17_ = self->priv->new_time;
#line 1469 "../src/Commands.vala"
		adjust_date_time_photos_command_set_time (self, _tmp16_, _tmp17_);
#line 13527 "Commands.c"
	}
#line 1472 "../src/Commands.vala"
	_tmp18_ = view_collection_new ("tmp");
#line 1472 "../src/Commands.vala"
	all_events = _tmp18_;
#line 13533 "Commands.c"
	{
		GeeIterator* _dobj_it = NULL;
		EventSourceCollection* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
#line 1474 "../src/Commands.vala"
		_tmp19_ = event_global;
#line 1474 "../src/Commands.vala"
		_tmp20_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_DATA_COLLECTION, DataCollection));
#line 1474 "../src/Commands.vala"
		_tmp21_ = _tmp20_;
#line 1474 "../src/Commands.vala"
		_tmp22_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1474 "../src/Commands.vala"
		_tmp23_ = _tmp22_;
#line 1474 "../src/Commands.vala"
		_g_object_unref0 (_tmp21_);
#line 1474 "../src/Commands.vala"
		_dobj_it = _tmp23_;
#line 1474 "../src/Commands.vala"
		while (TRUE) {
#line 13557 "Commands.c"
			GeeIterator* _tmp24_;
			DataObject* dobj = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			Event* event = NULL;
			DataObject* _tmp27_;
			Event* _tmp28_;
			Event* _tmp29_;
#line 1474 "../src/Commands.vala"
			_tmp24_ = _dobj_it;
#line 1474 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 1474 "../src/Commands.vala"
				break;
#line 13572 "Commands.c"
			}
#line 1474 "../src/Commands.vala"
			_tmp25_ = _dobj_it;
#line 1474 "../src/Commands.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 1474 "../src/Commands.vala"
			dobj = (DataObject*) _tmp26_;
#line 1475 "../src/Commands.vala"
			_tmp27_ = dobj;
#line 1475 "../src/Commands.vala"
			_tmp28_ = _g_object_ref0 (IS_EVENT (_tmp27_) ? ((Event*) _tmp27_) : NULL);
#line 1475 "../src/Commands.vala"
			event = _tmp28_;
#line 1476 "../src/Commands.vala"
			_tmp29_ = event;
#line 1476 "../src/Commands.vala"
			if (_tmp29_ != NULL) {
#line 13590 "Commands.c"
				ViewCollection* _tmp30_;
				Event* _tmp31_;
				EventView* _tmp32_;
				EventView* _tmp33_;
#line 1477 "../src/Commands.vala"
				_tmp30_ = all_events;
#line 1477 "../src/Commands.vala"
				_tmp31_ = event;
#line 1477 "../src/Commands.vala"
				_tmp32_ = event_view_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, TYPE_EVENT_SOURCE, EventSource));
#line 1477 "../src/Commands.vala"
				_tmp33_ = _tmp32_;
#line 1477 "../src/Commands.vala"
				data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, TYPE_DATA_OBJECT, DataObject));
#line 1477 "../src/Commands.vala"
				_g_object_unref0 (_tmp33_);
#line 13607 "Commands.c"
			}
#line 1474 "../src/Commands.vala"
			_g_object_unref0 (event);
#line 1474 "../src/Commands.vala"
			_g_object_unref0 (dobj);
#line 13613 "Commands.c"
		}
#line 1474 "../src/Commands.vala"
		_g_object_unref0 (_dobj_it);
#line 13617 "Commands.c"
	}
#line 1480 "../src/Commands.vala"
	_tmp34_ = dateable;
#line 1480 "../src/Commands.vala"
	_tmp35_ = all_events;
#line 1480 "../src/Commands.vala"
	event_generate_single_event (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_MEDIA_SOURCE, MediaSource), _tmp35_, NULL);
#line 1462 "../src/Commands.vala"
	_data_collection_unref0 (all_events);
#line 1462 "../src/Commands.vala"
	_g_object_unref0 (dateable);
#line 13629 "Commands.c"
}

static void
adjust_date_time_photos_command_real_undo_on_source (MultipleDataSourceCommand* base,
                                                     DataSource* source)
{
	AdjustDateTimePhotosCommand * self;
	Dateable* photo = NULL;
	Dateable* _tmp0_;
	GeeHashMap* _tmp1_;
	Dateable* _tmp2_;
	GeeMap* _tmp16_;
	gpointer _tmp17_;
	Event* _tmp18_;
#line 1483 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand);
#line 1483 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1484 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATEABLE, Dateable));
#line 1484 "../src/Commands.vala"
	photo = _tmp0_;
#line 1486 "../src/Commands.vala"
	_tmp1_ = self->priv->old_times;
#line 1486 "../src/Commands.vala"
	_tmp2_ = photo;
#line 1486 "../src/Commands.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp2_)) {
#line 13658 "Commands.c"
		Dateable* _tmp3_;
		GeeHashMap* _tmp4_;
		Dateable* _tmp5_;
		gpointer _tmp6_;
		GDateTime* _tmp7_;
		GeeHashMap* _tmp8_;
		Dateable* _tmp9_;
#line 1487 "../src/Commands.vala"
		_tmp3_ = photo;
#line 1487 "../src/Commands.vala"
		_tmp4_ = self->priv->old_times;
#line 1487 "../src/Commands.vala"
		_tmp5_ = photo;
#line 1487 "../src/Commands.vala"
		_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_);
#line 1487 "../src/Commands.vala"
		_tmp7_ = (GDateTime*) _tmp6_;
#line 1487 "../src/Commands.vala"
		adjust_date_time_photos_command_set_time (self, _tmp3_, _tmp7_);
#line 1487 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp7_);
#line 1488 "../src/Commands.vala"
		_tmp8_ = self->priv->old_times;
#line 1488 "../src/Commands.vala"
		_tmp9_ = photo;
#line 1488 "../src/Commands.vala"
		gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp9_, NULL);
#line 13686 "Commands.c"
	} else {
		Dateable* _tmp10_;
		Dateable* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
#line 1490 "../src/Commands.vala"
		_tmp10_ = photo;
#line 1490 "../src/Commands.vala"
		_tmp11_ = photo;
#line 1490 "../src/Commands.vala"
		_tmp12_ = dateable_get_exposure_time (_tmp11_);
#line 1490 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 1490 "../src/Commands.vala"
		_tmp14_ = g_date_time_add_seconds (_tmp13_, (gdouble) (-1 * self->priv->time_shift));
#line 1490 "../src/Commands.vala"
		_tmp15_ = _tmp14_;
#line 1490 "../src/Commands.vala"
		adjust_date_time_photos_command_set_time (self, _tmp10_, _tmp15_);
#line 1490 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp15_);
#line 1490 "../src/Commands.vala"
		_g_date_time_unref0 (_tmp13_);
#line 13712 "Commands.c"
	}
#line 1493 "../src/Commands.vala"
	_tmp16_ = self->priv->prev_events;
#line 1493 "../src/Commands.vala"
	_tmp17_ = gee_map_get (_tmp16_, IS_DATEABLE (source) ? ((Dateable*) source) : NULL);
#line 1493 "../src/Commands.vala"
	_tmp18_ = (Event*) _tmp17_;
#line 1493 "../src/Commands.vala"
	media_source_set_event (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource), _tmp18_);
#line 1493 "../src/Commands.vala"
	_g_object_unref0 (_tmp18_);
#line 1483 "../src/Commands.vala"
	_g_object_unref0 (photo);
#line 13726 "Commands.c"
}

static void
adjust_date_time_photos_command_class_init (AdjustDateTimePhotosCommandClass * klass,
                                            gpointer klass_data)
{
#line 1363 "../src/Commands.vala"
	adjust_date_time_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 1363 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &AdjustDateTimePhotosCommand_private_offset);
#line 1363 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) adjust_date_time_photos_command_real_execute;
#line 1363 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) adjust_date_time_photos_command_real_undo;
#line 1363 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->execute_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) adjust_date_time_photos_command_real_execute_on_source;
#line 1363 "../src/Commands.vala"
	((MultipleDataSourceCommandClass *) klass)->undo_on_source = (void (*) (MultipleDataSourceCommand*, DataSource*)) adjust_date_time_photos_command_real_undo_on_source;
#line 1363 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = adjust_date_time_photos_command_finalize;
#line 13747 "Commands.c"
}

static void
adjust_date_time_photos_command_instance_init (AdjustDateTimePhotosCommand * self,
                                               gpointer klass)
{
#line 1363 "../src/Commands.vala"
	self->priv = adjust_date_time_photos_command_get_instance_private (self);
#line 1370 "../src/Commands.vala"
	self->priv->new_time = NULL;
#line 13758 "Commands.c"
}

static void
adjust_date_time_photos_command_finalize (GObject * obj)
{
	AdjustDateTimePhotosCommand * self;
#line 1363 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADJUST_DATE_TIME_PHOTOS_COMMAND, AdjustDateTimePhotosCommand);
#line 1367 "../src/Commands.vala"
	_g_object_unref0 (self->priv->prev_events);
#line 1370 "../src/Commands.vala"
	_g_date_time_unref0 (self->priv->new_time);
#line 1371 "../src/Commands.vala"
	_g_object_unref0 (self->priv->old_times);
#line 1372 "../src/Commands.vala"
	_g_object_unref0 (self->priv->error_list);
#line 1363 "../src/Commands.vala"
	G_OBJECT_CLASS (adjust_date_time_photos_command_parent_class)->finalize (obj);
#line 13777 "Commands.c"
}

static GType
adjust_date_time_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdjustDateTimePhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adjust_date_time_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdjustDateTimePhotosCommand), 0, (GInstanceInitFunc) adjust_date_time_photos_command_instance_init, NULL };
	GType adjust_date_time_photos_command_type_id;
	adjust_date_time_photos_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_COMMAND, "AdjustDateTimePhotosCommand", &g_define_type_info, 0);
	AdjustDateTimePhotosCommand_private_offset = g_type_add_instance_private (adjust_date_time_photos_command_type_id, sizeof (AdjustDateTimePhotosCommandPrivate));
	return adjust_date_time_photos_command_type_id;
}

GType
adjust_date_time_photos_command_get_type (void)
{
	static volatile gsize adjust_date_time_photos_command_type_id__once = 0;
	if (g_once_init_enter (&adjust_date_time_photos_command_type_id__once)) {
		GType adjust_date_time_photos_command_type_id;
		adjust_date_time_photos_command_type_id = adjust_date_time_photos_command_get_type_once ();
		g_once_init_leave (&adjust_date_time_photos_command_type_id__once, adjust_date_time_photos_command_type_id);
	}
	return adjust_date_time_photos_command_type_id__once;
}

static inline gpointer
add_tags_command_get_instance_private (AddTagsCommand* self)
{
	return G_STRUCT_MEMBER_P (self, AddTagsCommand_private_offset);
}

static void
_add_tags_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                       gpointer self)
{
#line 1537 "../src/Commands.vala"
	add_tags_command_on_proxy_broken ((AddTagsCommand*) self);
#line 13814 "Commands.c"
}

static void
_add_tags_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                        DataSource* source,
                                                                        gpointer self)
{
#line 1539 "../src/Commands.vala"
	add_tags_command_on_source_destroyed ((AddTagsCommand*) self, source);
#line 13824 "Commands.c"
}

AddTagsCommand*
add_tags_command_construct (GType object_type,
                            gchar** paths,
                            gint paths_length1,
                            GeeCollection* sources)
{
	AddTagsCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	LibraryPhotoSourceCollection* _tmp35_;
	VideoSourceCollection* _tmp36_;
#line 1501 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 1502 "../src/Commands.vala"
	_tmp0_ = resources_add_tags_label (paths, (gint) paths_length1);
#line 1502 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1502 "../src/Commands.vala"
	self = (AddTagsCommand*) page_command_construct (object_type, _tmp1_, "");
#line 1502 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 13848 "Commands.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 1507 "../src/Commands.vala"
		path_collection = paths;
#line 1507 "../src/Commands.vala"
		path_collection_length1 = paths_length1;
#line 1507 "../src/Commands.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 13860 "Commands.c"
			gchar* _tmp2_;
			gchar* path = NULL;
#line 1507 "../src/Commands.vala"
			_tmp2_ = g_strdup (path_collection[path_it]);
#line 1507 "../src/Commands.vala"
			path = _tmp2_;
#line 13867 "Commands.c"
			{
				GeeList* paths_to_create = NULL;
				const gchar* _tmp3_;
				GeeList* _tmp4_;
				GeeList* _tmp5_;
				const gchar* _tmp6_;
#line 1508 "../src/Commands.vala"
				_tmp3_ = path;
#line 1508 "../src/Commands.vala"
				_tmp4_ = hierarchical_tag_utilities_enumerate_parent_paths (_tmp3_);
#line 1508 "../src/Commands.vala"
				paths_to_create = _tmp4_;
#line 1510 "../src/Commands.vala"
				_tmp5_ = paths_to_create;
#line 1510 "../src/Commands.vala"
				_tmp6_ = path;
#line 1510 "../src/Commands.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), _tmp6_);
#line 13886 "Commands.c"
				{
					GeeList* _create_path_list = NULL;
					GeeList* _tmp7_;
					gint _create_path_size = 0;
					GeeList* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					gint _create_path_index = 0;
#line 1512 "../src/Commands.vala"
					_tmp7_ = paths_to_create;
#line 1512 "../src/Commands.vala"
					_create_path_list = _tmp7_;
#line 1512 "../src/Commands.vala"
					_tmp8_ = _create_path_list;
#line 1512 "../src/Commands.vala"
					_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1512 "../src/Commands.vala"
					_tmp10_ = _tmp9_;
#line 1512 "../src/Commands.vala"
					_create_path_size = _tmp10_;
#line 1512 "../src/Commands.vala"
					_create_path_index = -1;
#line 1512 "../src/Commands.vala"
					while (TRUE) {
#line 13911 "Commands.c"
						gint _tmp11_;
						gint _tmp12_;
						gchar* create_path = NULL;
						GeeList* _tmp13_;
						gpointer _tmp14_;
						Tag* tag = NULL;
						const gchar* _tmp15_;
						Tag* _tmp16_;
						SourceProxy* tag_proxy = NULL;
						Tag* _tmp17_;
						SourceProxy* _tmp18_;
						GeeArrayList* add_sources = NULL;
						GeeArrayList* _tmp19_;
						GeeArrayList* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
#line 1512 "../src/Commands.vala"
						_create_path_index = _create_path_index + 1;
#line 1512 "../src/Commands.vala"
						_tmp11_ = _create_path_index;
#line 1512 "../src/Commands.vala"
						_tmp12_ = _create_path_size;
#line 1512 "../src/Commands.vala"
						if (!(_tmp11_ < _tmp12_)) {
#line 1512 "../src/Commands.vala"
							break;
#line 13938 "Commands.c"
						}
#line 1512 "../src/Commands.vala"
						_tmp13_ = _create_path_list;
#line 1512 "../src/Commands.vala"
						_tmp14_ = gee_list_get (_tmp13_, _create_path_index);
#line 1512 "../src/Commands.vala"
						create_path = (gchar*) _tmp14_;
#line 1513 "../src/Commands.vala"
						_tmp15_ = create_path;
#line 1513 "../src/Commands.vala"
						_tmp16_ = tag_for_path (_tmp15_);
#line 1513 "../src/Commands.vala"
						tag = _tmp16_;
#line 1514 "../src/Commands.vala"
						_tmp17_ = tag;
#line 1514 "../src/Commands.vala"
						_tmp18_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_PROXYABLE, Proxyable));
#line 1514 "../src/Commands.vala"
						tag_proxy = _tmp18_;
#line 1518 "../src/Commands.vala"
						_tmp19_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1518 "../src/Commands.vala"
						add_sources = _tmp19_;
#line 13962 "Commands.c"
						{
							GeeIterator* _source_it = NULL;
							GeeIterator* _tmp20_;
#line 1519 "../src/Commands.vala"
							_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 1519 "../src/Commands.vala"
							_source_it = _tmp20_;
#line 1519 "../src/Commands.vala"
							while (TRUE) {
#line 13972 "Commands.c"
								GeeIterator* _tmp21_;
								MediaSource* source = NULL;
								GeeIterator* _tmp22_;
								gpointer _tmp23_;
								Tag* _tmp24_;
								MediaSource* _tmp25_;
#line 1519 "../src/Commands.vala"
								_tmp21_ = _source_it;
#line 1519 "../src/Commands.vala"
								if (!gee_iterator_next (_tmp21_)) {
#line 1519 "../src/Commands.vala"
									break;
#line 13985 "Commands.c"
								}
#line 1519 "../src/Commands.vala"
								_tmp22_ = _source_it;
#line 1519 "../src/Commands.vala"
								_tmp23_ = gee_iterator_get (_tmp22_);
#line 1519 "../src/Commands.vala"
								source = (MediaSource*) _tmp23_;
#line 1520 "../src/Commands.vala"
								_tmp24_ = tag;
#line 1520 "../src/Commands.vala"
								_tmp25_ = source;
#line 1520 "../src/Commands.vala"
								if (!tag_contains (_tmp24_, _tmp25_)) {
#line 13999 "Commands.c"
									GeeArrayList* _tmp26_;
									MediaSource* _tmp27_;
#line 1521 "../src/Commands.vala"
									_tmp26_ = add_sources;
#line 1521 "../src/Commands.vala"
									_tmp27_ = source;
#line 1521 "../src/Commands.vala"
									gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp27_);
#line 14008 "Commands.c"
								}
#line 1519 "../src/Commands.vala"
								_g_object_unref0 (source);
#line 14012 "Commands.c"
							}
#line 1519 "../src/Commands.vala"
							_g_object_unref0 (_source_it);
#line 14016 "Commands.c"
						}
#line 1524 "../src/Commands.vala"
						_tmp28_ = add_sources;
#line 1524 "../src/Commands.vala"
						_tmp29_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1524 "../src/Commands.vala"
						_tmp30_ = _tmp29_;
#line 1524 "../src/Commands.vala"
						if (_tmp30_ > 0) {
#line 14026 "Commands.c"
							SourceProxy* _tmp31_;
							GeeHashMap* _tmp32_;
							SourceProxy* _tmp33_;
							GeeArrayList* _tmp34_;
#line 1525 "../src/Commands.vala"
							_tmp31_ = tag_proxy;
#line 1525 "../src/Commands.vala"
							g_signal_connect_object (_tmp31_, "broken", (GCallback) _add_tags_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 1526 "../src/Commands.vala"
							_tmp32_ = self->priv->map;
#line 1526 "../src/Commands.vala"
							_tmp33_ = tag_proxy;
#line 1526 "../src/Commands.vala"
							_tmp34_ = add_sources;
#line 1526 "../src/Commands.vala"
							gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp33_, _tmp34_);
#line 14043 "Commands.c"
						}
#line 1512 "../src/Commands.vala"
						_g_object_unref0 (add_sources);
#line 1512 "../src/Commands.vala"
						_source_proxy_unref0 (tag_proxy);
#line 1512 "../src/Commands.vala"
						_g_object_unref0 (tag);
#line 1512 "../src/Commands.vala"
						_g_free0 (create_path);
#line 14053 "Commands.c"
					}
				}
#line 1507 "../src/Commands.vala"
				_g_object_unref0 (paths_to_create);
#line 1507 "../src/Commands.vala"
				_g_free0 (path);
#line 14060 "Commands.c"
			}
		}
	}
#line 1531 "../src/Commands.vala"
	_tmp35_ = library_photo_global;
#line 1531 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _add_tags_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 1532 "../src/Commands.vala"
	_tmp36_ = video_global;
#line 1532 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _add_tags_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 1501 "../src/Commands.vala"
	return self;
#line 14074 "Commands.c"
}

AddTagsCommand*
add_tags_command_new (gchar** paths,
                      gint paths_length1,
                      GeeCollection* sources)
{
#line 1501 "../src/Commands.vala"
	return add_tags_command_construct (TYPE_ADD_TAGS_COMMAND, paths, paths_length1, sources);
#line 14084 "Commands.c"
}

static void
add_tags_command_real_execute (Command* base)
{
	AddTagsCommand * self;
#line 1543 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADD_TAGS_COMMAND, AddTagsCommand);
#line 14093 "Commands.c"
	{
		GeeIterator* _tag_proxy_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1544 "../src/Commands.vala"
		_tmp0_ = self->priv->map;
#line 1544 "../src/Commands.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1544 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 1544 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1544 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1544 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 1544 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 1544 "../src/Commands.vala"
		_tag_proxy_it = _tmp5_;
#line 1544 "../src/Commands.vala"
		while (TRUE) {
#line 14120 "Commands.c"
			GeeIterator* _tmp6_;
			SourceProxy* tag_proxy = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			SourceProxy* _tmp9_;
			DataSource* _tmp10_;
			Tag* _tmp11_;
			GeeHashMap* _tmp12_;
			SourceProxy* _tmp13_;
			gpointer _tmp14_;
			GeeArrayList* _tmp15_;
#line 1544 "../src/Commands.vala"
			_tmp6_ = _tag_proxy_it;
#line 1544 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1544 "../src/Commands.vala"
				break;
#line 14138 "Commands.c"
			}
#line 1544 "../src/Commands.vala"
			_tmp7_ = _tag_proxy_it;
#line 1544 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1544 "../src/Commands.vala"
			tag_proxy = (SourceProxy*) _tmp8_;
#line 1545 "../src/Commands.vala"
			_tmp9_ = tag_proxy;
#line 1545 "../src/Commands.vala"
			_tmp10_ = source_proxy_get_source (_tmp9_);
#line 1545 "../src/Commands.vala"
			_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_TAG, Tag);
#line 1545 "../src/Commands.vala"
			_tmp12_ = self->priv->map;
#line 1545 "../src/Commands.vala"
			_tmp13_ = tag_proxy;
#line 1545 "../src/Commands.vala"
			_tmp14_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_);
#line 1545 "../src/Commands.vala"
			_tmp15_ = (GeeArrayList*) _tmp14_;
#line 1545 "../src/Commands.vala"
			tag_attach_many (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1545 "../src/Commands.vala"
			_g_object_unref0 (_tmp15_);
#line 1545 "../src/Commands.vala"
			_g_object_unref0 (_tmp11_);
#line 1544 "../src/Commands.vala"
			_source_proxy_unref0 (tag_proxy);
#line 14168 "Commands.c"
		}
#line 1544 "../src/Commands.vala"
		_g_object_unref0 (_tag_proxy_it);
#line 14172 "Commands.c"
	}
}

static void
add_tags_command_real_undo (Command* base)
{
	AddTagsCommand * self;
#line 1548 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADD_TAGS_COMMAND, AddTagsCommand);
#line 14182 "Commands.c"
	{
		GeeIterator* _tag_proxy_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1549 "../src/Commands.vala"
		_tmp0_ = self->priv->map;
#line 1549 "../src/Commands.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1549 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 1549 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1549 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1549 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 1549 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 1549 "../src/Commands.vala"
		_tag_proxy_it = _tmp5_;
#line 1549 "../src/Commands.vala"
		while (TRUE) {
#line 14209 "Commands.c"
			GeeIterator* _tmp6_;
			SourceProxy* tag_proxy = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			Tag* tag = NULL;
			SourceProxy* _tmp9_;
			DataSource* _tmp10_;
			Tag* _tmp11_;
			GeeHashMap* _tmp12_;
			SourceProxy* _tmp13_;
			gpointer _tmp14_;
			GeeArrayList* _tmp15_;
			GeeMultiMap* _tmp16_;
			GeeMultiMap* _tmp17_;
#line 1549 "../src/Commands.vala"
			_tmp6_ = _tag_proxy_it;
#line 1549 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1549 "../src/Commands.vala"
				break;
#line 14230 "Commands.c"
			}
#line 1549 "../src/Commands.vala"
			_tmp7_ = _tag_proxy_it;
#line 1549 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1549 "../src/Commands.vala"
			tag_proxy = (SourceProxy*) _tmp8_;
#line 1550 "../src/Commands.vala"
			_tmp9_ = tag_proxy;
#line 1550 "../src/Commands.vala"
			_tmp10_ = source_proxy_get_source (_tmp9_);
#line 1550 "../src/Commands.vala"
			tag = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_TAG, Tag);
#line 1552 "../src/Commands.vala"
			_tmp11_ = tag;
#line 1552 "../src/Commands.vala"
			_tmp12_ = self->priv->map;
#line 1552 "../src/Commands.vala"
			_tmp13_ = tag_proxy;
#line 1552 "../src/Commands.vala"
			_tmp14_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_);
#line 1552 "../src/Commands.vala"
			_tmp15_ = (GeeArrayList*) _tmp14_;
#line 1552 "../src/Commands.vala"
			_tmp16_ = tag_detach_many (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1552 "../src/Commands.vala"
			_tmp17_ = _tmp16_;
#line 1552 "../src/Commands.vala"
			_g_object_unref0 (_tmp17_);
#line 1552 "../src/Commands.vala"
			_g_object_unref0 (_tmp15_);
#line 1549 "../src/Commands.vala"
			_g_object_unref0 (tag);
#line 1549 "../src/Commands.vala"
			_source_proxy_unref0 (tag_proxy);
#line 14266 "Commands.c"
		}
#line 1549 "../src/Commands.vala"
		_g_object_unref0 (_tag_proxy_it);
#line 14270 "Commands.c"
	}
}

static void
add_tags_command_on_source_destroyed (AddTagsCommand* self,
                                      DataSource* source)
{
#line 1556 "../src/Commands.vala"
	g_return_if_fail (IS_ADD_TAGS_COMMAND (self));
#line 1556 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 14282 "Commands.c"
	{
		GeeIterator* _sources_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1557 "../src/Commands.vala"
		_tmp0_ = self->priv->map;
#line 1557 "../src/Commands.vala"
		_tmp1_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1557 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 1557 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1557 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1557 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 1557 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 1557 "../src/Commands.vala"
		_sources_it = _tmp5_;
#line 1557 "../src/Commands.vala"
		while (TRUE) {
#line 14309 "Commands.c"
			GeeIterator* _tmp6_;
			GeeArrayList* sources = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeArrayList* _tmp9_;
#line 1557 "../src/Commands.vala"
			_tmp6_ = _sources_it;
#line 1557 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1557 "../src/Commands.vala"
				break;
#line 14321 "Commands.c"
			}
#line 1557 "../src/Commands.vala"
			_tmp7_ = _sources_it;
#line 1557 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1557 "../src/Commands.vala"
			sources = (GeeArrayList*) _tmp8_;
#line 1558 "../src/Commands.vala"
			_tmp9_ = sources;
#line 1558 "../src/Commands.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource))) {
#line 14333 "Commands.c"
				CommandManager* _tmp10_;
				CommandManager* _tmp11_;
#line 1559 "../src/Commands.vala"
				_tmp10_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 1559 "../src/Commands.vala"
				_tmp11_ = _tmp10_;
#line 1559 "../src/Commands.vala"
				command_manager_reset (_tmp11_);
#line 1559 "../src/Commands.vala"
				_command_manager_unref0 (_tmp11_);
#line 1561 "../src/Commands.vala"
				_g_object_unref0 (sources);
#line 1561 "../src/Commands.vala"
				_g_object_unref0 (_sources_it);
#line 1561 "../src/Commands.vala"
				return;
#line 14350 "Commands.c"
			}
#line 1557 "../src/Commands.vala"
			_g_object_unref0 (sources);
#line 14354 "Commands.c"
		}
#line 1557 "../src/Commands.vala"
		_g_object_unref0 (_sources_it);
#line 14358 "Commands.c"
	}
}

static void
add_tags_command_on_proxy_broken (AddTagsCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 1566 "../src/Commands.vala"
	g_return_if_fail (IS_ADD_TAGS_COMMAND (self));
#line 1567 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 1567 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1567 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 1567 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 14377 "Commands.c"
}

static void
add_tags_command_class_init (AddTagsCommandClass * klass,
                             gpointer klass_data)
{
#line 1497 "../src/Commands.vala"
	add_tags_command_parent_class = g_type_class_peek_parent (klass);
#line 1497 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &AddTagsCommand_private_offset);
#line 1497 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) add_tags_command_real_execute;
#line 1497 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) add_tags_command_real_undo;
#line 1497 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = add_tags_command_finalize;
#line 14394 "Commands.c"
}

static void
add_tags_command_instance_init (AddTagsCommand * self,
                                gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 1497 "../src/Commands.vala"
	self->priv = add_tags_command_get_instance_private (self);
#line 1498 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1498 "../src/Commands.vala"
	self->priv->map = _tmp0_;
#line 14408 "Commands.c"
}

static void
add_tags_command_finalize (GObject * obj)
{
	AddTagsCommand * self;
	LibraryPhotoSourceCollection* _tmp11_;
	guint _tmp12_;
	VideoSourceCollection* _tmp13_;
	guint _tmp14_;
#line 1497 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADD_TAGS_COMMAND, AddTagsCommand);
#line 14421 "Commands.c"
	{
		GeeIterator* _tag_proxy_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1536 "../src/Commands.vala"
		_tmp0_ = self->priv->map;
#line 1536 "../src/Commands.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1536 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 1536 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1536 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1536 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 1536 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 1536 "../src/Commands.vala"
		_tag_proxy_it = _tmp5_;
#line 1536 "../src/Commands.vala"
		while (TRUE) {
#line 14448 "Commands.c"
			GeeIterator* _tmp6_;
			SourceProxy* tag_proxy = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			SourceProxy* _tmp9_;
			guint _tmp10_;
#line 1536 "../src/Commands.vala"
			_tmp6_ = _tag_proxy_it;
#line 1536 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1536 "../src/Commands.vala"
				break;
#line 14461 "Commands.c"
			}
#line 1536 "../src/Commands.vala"
			_tmp7_ = _tag_proxy_it;
#line 1536 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1536 "../src/Commands.vala"
			tag_proxy = (SourceProxy*) _tmp8_;
#line 1537 "../src/Commands.vala"
			_tmp9_ = tag_proxy;
#line 1537 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp10_, NULL, FALSE);
#line 1537 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _add_tags_command_on_proxy_broken_source_proxy_broken, self);
#line 1536 "../src/Commands.vala"
			_source_proxy_unref0 (tag_proxy);
#line 14477 "Commands.c"
		}
#line 1536 "../src/Commands.vala"
		_g_object_unref0 (_tag_proxy_it);
#line 14481 "Commands.c"
	}
#line 1539 "../src/Commands.vala"
	_tmp11_ = library_photo_global;
#line 1539 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp12_, NULL, FALSE);
#line 1539 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _add_tags_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 1540 "../src/Commands.vala"
	_tmp13_ = video_global;
#line 1540 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp14_, NULL, FALSE);
#line 1540 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _add_tags_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 1498 "../src/Commands.vala"
	_g_object_unref0 (self->priv->map);
#line 1497 "../src/Commands.vala"
	G_OBJECT_CLASS (add_tags_command_parent_class)->finalize (obj);
#line 14499 "Commands.c"
}

static GType
add_tags_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AddTagsCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) add_tags_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AddTagsCommand), 0, (GInstanceInitFunc) add_tags_command_instance_init, NULL };
	GType add_tags_command_type_id;
	add_tags_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "AddTagsCommand", &g_define_type_info, 0);
	AddTagsCommand_private_offset = g_type_add_instance_private (add_tags_command_type_id, sizeof (AddTagsCommandPrivate));
	return add_tags_command_type_id;
}

GType
add_tags_command_get_type (void)
{
	static volatile gsize add_tags_command_type_id__once = 0;
	if (g_once_init_enter (&add_tags_command_type_id__once)) {
		GType add_tags_command_type_id;
		add_tags_command_type_id = add_tags_command_get_type_once ();
		g_once_init_leave (&add_tags_command_type_id__once, add_tags_command_type_id);
	}
	return add_tags_command_type_id__once;
}

static inline gpointer
rename_tag_command_get_instance_private (RenameTagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RenameTagCommand_private_offset);
}

RenameTagCommand*
rename_tag_command_construct (GType object_type,
                              Tag* tag,
                              const gchar* new_name)
{
	RenameTagCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1576 "../src/Commands.vala"
	g_return_val_if_fail (IS_TAG (tag), NULL);
#line 1576 "../src/Commands.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 1577 "../src/Commands.vala"
	_tmp0_ = tag_get_user_visible_name (tag);
#line 1577 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1577 "../src/Commands.vala"
	_tmp2_ = resources_rename_tag_label (_tmp1_, new_name);
#line 1577 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1577 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_DATA_OBJECT, DataObject));
#line 1577 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 1577 "../src/Commands.vala"
	self = (RenameTagCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_PROXYABLE, Proxyable), _tmp3_, _tmp5_);
#line 1577 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 1577 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 1577 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 1580 "../src/Commands.vala"
	_tmp6_ = tag_get_user_visible_name (tag);
#line 1580 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 1580 "../src/Commands.vala"
	self->priv->old_name = _tmp6_;
#line 1581 "../src/Commands.vala"
	_tmp7_ = g_strdup (new_name);
#line 1581 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 1581 "../src/Commands.vala"
	self->priv->new_name = _tmp7_;
#line 1576 "../src/Commands.vala"
	return self;
#line 14582 "Commands.c"
}

RenameTagCommand*
rename_tag_command_new (Tag* tag,
                        const gchar* new_name)
{
#line 1576 "../src/Commands.vala"
	return rename_tag_command_construct (TYPE_RENAME_TAG_COMMAND, tag, new_name);
#line 14591 "Commands.c"
}

static void
rename_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                           DataSource* source)
{
	RenameTagCommand * self;
	const gchar* _tmp0_;
#line 1584 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_TAG_COMMAND, RenameTagCommand);
#line 1584 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1585 "../src/Commands.vala"
	_tmp0_ = self->priv->new_name;
#line 1585 "../src/Commands.vala"
	if (!tag_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag), _tmp0_)) {
#line 14608 "Commands.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1586 "../src/Commands.vala"
		_tmp1_ = self->priv->new_name;
#line 1586 "../src/Commands.vala"
		_tmp2_ = resources_rename_tag_exists_message (_tmp1_);
#line 1586 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1586 "../src/Commands.vala"
		app_window_error_message (_tmp3_, NULL);
#line 1586 "../src/Commands.vala"
		_g_free0 (_tmp3_);
#line 14622 "Commands.c"
	}
}

static void
rename_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                        DataSource* source)
{
	RenameTagCommand * self;
	const gchar* _tmp0_;
#line 1589 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_TAG_COMMAND, RenameTagCommand);
#line 1589 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1590 "../src/Commands.vala"
	_tmp0_ = self->priv->old_name;
#line 1590 "../src/Commands.vala"
	if (!tag_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag), _tmp0_)) {
#line 14640 "Commands.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1591 "../src/Commands.vala"
		_tmp1_ = self->priv->old_name;
#line 1591 "../src/Commands.vala"
		_tmp2_ = resources_rename_tag_exists_message (_tmp1_);
#line 1591 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1591 "../src/Commands.vala"
		app_window_error_message (_tmp3_, NULL);
#line 1591 "../src/Commands.vala"
		_g_free0 (_tmp3_);
#line 14654 "Commands.c"
	}
}

static void
rename_tag_command_class_init (RenameTagCommandClass * klass,
                               gpointer klass_data)
{
#line 1571 "../src/Commands.vala"
	rename_tag_command_parent_class = g_type_class_peek_parent (klass);
#line 1571 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RenameTagCommand_private_offset);
#line 1571 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_tag_command_real_execute_on_source;
#line 1571 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_tag_command_real_undo_on_source;
#line 1571 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rename_tag_command_finalize;
#line 14672 "Commands.c"
}

static void
rename_tag_command_instance_init (RenameTagCommand * self,
                                  gpointer klass)
{
#line 1571 "../src/Commands.vala"
	self->priv = rename_tag_command_get_instance_private (self);
#line 14681 "Commands.c"
}

static void
rename_tag_command_finalize (GObject * obj)
{
	RenameTagCommand * self;
#line 1571 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RENAME_TAG_COMMAND, RenameTagCommand);
#line 1572 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 1573 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 1571 "../src/Commands.vala"
	G_OBJECT_CLASS (rename_tag_command_parent_class)->finalize (obj);
#line 14696 "Commands.c"
}

static GType
rename_tag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RenameTagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rename_tag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RenameTagCommand), 0, (GInstanceInitFunc) rename_tag_command_instance_init, NULL };
	GType rename_tag_command_type_id;
	rename_tag_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "RenameTagCommand", &g_define_type_info, 0);
	RenameTagCommand_private_offset = g_type_add_instance_private (rename_tag_command_type_id, sizeof (RenameTagCommandPrivate));
	return rename_tag_command_type_id;
}

GType
rename_tag_command_get_type (void)
{
	static volatile gsize rename_tag_command_type_id__once = 0;
	if (g_once_init_enter (&rename_tag_command_type_id__once)) {
		GType rename_tag_command_type_id;
		rename_tag_command_type_id = rename_tag_command_get_type_once ();
		g_once_init_leave (&rename_tag_command_type_id__once, rename_tag_command_type_id);
	}
	return rename_tag_command_type_id__once;
}

static inline gpointer
delete_tag_command_get_instance_private (DeleteTagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, DeleteTagCommand_private_offset);
}

DeleteTagCommand*
delete_tag_command_construct (GType object_type,
                              Tag* tag)
{
	DeleteTagCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1598 "../src/Commands.vala"
	g_return_val_if_fail (IS_TAG (tag), NULL);
#line 1599 "../src/Commands.vala"
	_tmp0_ = tag_get_user_visible_name (tag);
#line 1599 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1599 "../src/Commands.vala"
	_tmp2_ = resources_delete_tag_label (_tmp1_);
#line 1599 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1599 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_DATA_OBJECT, DataObject));
#line 1599 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 1599 "../src/Commands.vala"
	self = (DeleteTagCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_PROXYABLE, Proxyable), _tmp3_, _tmp5_);
#line 1599 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 1599 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 1599 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 1598 "../src/Commands.vala"
	return self;
#line 14762 "Commands.c"
}

DeleteTagCommand*
delete_tag_command_new (Tag* tag)
{
#line 1598 "../src/Commands.vala"
	return delete_tag_command_construct (TYPE_DELETE_TAG_COMMAND, tag);
#line 14770 "Commands.c"
}

static void
_delete_tag_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                         gpointer self)
{
#line 1613 "../src/Commands.vala"
	delete_tag_command_on_proxy_broken ((DeleteTagCommand*) self);
#line 14779 "Commands.c"
}

static void
delete_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                           DataSource* source)
{
	DeleteTagCommand * self;
	Tag* tag = NULL;
	Tag* _tmp0_;
	GeeList* recursive_victims = NULL;
	Tag* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	TagSourceCollection* _tmp25_;
	TagSourceCollection* _tmp26_;
	Marker* _tmp27_;
	Marker* _tmp28_;
#line 1602 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_TAG_COMMAND, DeleteTagCommand);
#line 1602 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1603 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 1603 "../src/Commands.vala"
	tag = _tmp0_;
#line 1606 "../src/Commands.vala"
	_tmp1_ = tag;
#line 1606 "../src/Commands.vala"
	_tmp2_ = tag_get_hierarchical_children (_tmp1_);
#line 1606 "../src/Commands.vala"
	recursive_victims = _tmp2_;
#line 1607 "../src/Commands.vala"
	_tmp3_ = recursive_victims;
#line 1607 "../src/Commands.vala"
	_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1607 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 1607 "../src/Commands.vala"
	if (_tmp5_ > 0) {
#line 14821 "Commands.c"
		GeeArrayList* _tmp6_;
#line 1610 "../src/Commands.vala"
		_tmp6_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 1610 "../src/Commands.vala"
		_g_object_unref0 (self->priv->recursive_victim_proxies);
#line 1610 "../src/Commands.vala"
		self->priv->recursive_victim_proxies = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList);
#line 14829 "Commands.c"
		{
			GeeList* _victim_list = NULL;
			GeeList* _tmp7_;
			gint _victim_size = 0;
			GeeList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gint _victim_index = 0;
#line 1611 "../src/Commands.vala"
			_tmp7_ = recursive_victims;
#line 1611 "../src/Commands.vala"
			_victim_list = _tmp7_;
#line 1611 "../src/Commands.vala"
			_tmp8_ = _victim_list;
#line 1611 "../src/Commands.vala"
			_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1611 "../src/Commands.vala"
			_tmp10_ = _tmp9_;
#line 1611 "../src/Commands.vala"
			_victim_size = _tmp10_;
#line 1611 "../src/Commands.vala"
			_victim_index = -1;
#line 1611 "../src/Commands.vala"
			while (TRUE) {
#line 14854 "Commands.c"
				gint _tmp11_;
				gint _tmp12_;
				Tag* victim = NULL;
				GeeList* _tmp13_;
				gpointer _tmp14_;
				SourceProxy* proxy = NULL;
				Tag* _tmp15_;
				SourceProxy* _tmp16_;
				SourceProxy* _tmp17_;
				GeeList* _tmp18_;
				SourceProxy* _tmp19_;
				TagSourceCollection* _tmp20_;
				TagSourceCollection* _tmp21_;
				Tag* _tmp22_;
				Marker* _tmp23_;
				Marker* _tmp24_;
#line 1611 "../src/Commands.vala"
				_victim_index = _victim_index + 1;
#line 1611 "../src/Commands.vala"
				_tmp11_ = _victim_index;
#line 1611 "../src/Commands.vala"
				_tmp12_ = _victim_size;
#line 1611 "../src/Commands.vala"
				if (!(_tmp11_ < _tmp12_)) {
#line 1611 "../src/Commands.vala"
					break;
#line 14881 "Commands.c"
				}
#line 1611 "../src/Commands.vala"
				_tmp13_ = _victim_list;
#line 1611 "../src/Commands.vala"
				_tmp14_ = gee_list_get (_tmp13_, _victim_index);
#line 1611 "../src/Commands.vala"
				victim = (Tag*) _tmp14_;
#line 1612 "../src/Commands.vala"
				_tmp15_ = victim;
#line 1612 "../src/Commands.vala"
				_tmp16_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_PROXYABLE, Proxyable));
#line 1612 "../src/Commands.vala"
				proxy = _tmp16_;
#line 1613 "../src/Commands.vala"
				_tmp17_ = proxy;
#line 1613 "../src/Commands.vala"
				g_signal_connect_object (_tmp17_, "broken", (GCallback) _delete_tag_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 1614 "../src/Commands.vala"
				_tmp18_ = self->priv->recursive_victim_proxies;
#line 1614 "../src/Commands.vala"
				_tmp19_ = proxy;
#line 1614 "../src/Commands.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection), _tmp19_);
#line 1616 "../src/Commands.vala"
				_tmp20_ = tag_global;
#line 1616 "../src/Commands.vala"
				_tmp21_ = tag_global;
#line 1616 "../src/Commands.vala"
				_tmp22_ = victim;
#line 1616 "../src/Commands.vala"
				_tmp23_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_DATA_OBJECT, DataObject));
#line 1616 "../src/Commands.vala"
				_tmp24_ = _tmp23_;
#line 1616 "../src/Commands.vala"
				source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp24_, FALSE, NULL, NULL, NULL);
#line 1616 "../src/Commands.vala"
				_g_object_unref0 (_tmp24_);
#line 1611 "../src/Commands.vala"
				_source_proxy_unref0 (proxy);
#line 1611 "../src/Commands.vala"
				_g_object_unref0 (victim);
#line 14923 "Commands.c"
			}
		}
	}
#line 1621 "../src/Commands.vala"
	_tmp25_ = tag_global;
#line 1621 "../src/Commands.vala"
	_tmp26_ = tag_global;
#line 1621 "../src/Commands.vala"
	_tmp27_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATA_OBJECT, DataObject));
#line 1621 "../src/Commands.vala"
	_tmp28_ = _tmp27_;
#line 1621 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp28_, FALSE, NULL, NULL, NULL);
#line 1621 "../src/Commands.vala"
	_g_object_unref0 (_tmp28_);
#line 1602 "../src/Commands.vala"
	_g_object_unref0 (recursive_victims);
#line 1602 "../src/Commands.vala"
	_g_object_unref0 (tag);
#line 14943 "Commands.c"
}

static void
delete_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                        DataSource* source)
{
	DeleteTagCommand * self;
	GeeList* _tmp0_;
#line 1624 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_TAG_COMMAND, DeleteTagCommand);
#line 1624 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1627 "../src/Commands.vala"
	_vala_assert (IS_TAG (source), "source is Tag");
#line 1630 "../src/Commands.vala"
	_tmp0_ = self->priv->recursive_victim_proxies;
#line 1630 "../src/Commands.vala"
	if (_tmp0_ != NULL) {
#line 14962 "Commands.c"
		{
			gint i = 0;
			GeeList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
#line 1631 "../src/Commands.vala"
			_tmp1_ = self->priv->recursive_victim_proxies;
#line 1631 "../src/Commands.vala"
			_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1631 "../src/Commands.vala"
			_tmp3_ = _tmp2_;
#line 1631 "../src/Commands.vala"
			i = _tmp3_ - 1;
#line 14976 "Commands.c"
			{
				gboolean _tmp4_ = FALSE;
#line 1631 "../src/Commands.vala"
				_tmp4_ = TRUE;
#line 1631 "../src/Commands.vala"
				while (TRUE) {
#line 14983 "Commands.c"
					SourceProxy* proxy = NULL;
					GeeList* _tmp6_;
					gpointer _tmp7_;
					DataSource* victim_source = NULL;
					SourceProxy* _tmp8_;
					DataSource* _tmp9_;
					DataSource* _tmp10_;
					SourceProxy* _tmp11_;
					guint _tmp12_;
#line 1631 "../src/Commands.vala"
					if (!_tmp4_) {
#line 14995 "Commands.c"
						gint _tmp5_;
#line 1631 "../src/Commands.vala"
						_tmp5_ = i;
#line 1631 "../src/Commands.vala"
						i = _tmp5_ - 1;
#line 15001 "Commands.c"
					}
#line 1631 "../src/Commands.vala"
					_tmp4_ = FALSE;
#line 1631 "../src/Commands.vala"
					if (!(i >= 0)) {
#line 1631 "../src/Commands.vala"
						break;
#line 15009 "Commands.c"
					}
#line 1632 "../src/Commands.vala"
					_tmp6_ = self->priv->recursive_victim_proxies;
#line 1632 "../src/Commands.vala"
					_tmp7_ = gee_list_get (_tmp6_, i);
#line 1632 "../src/Commands.vala"
					proxy = (SourceProxy*) _tmp7_;
#line 1634 "../src/Commands.vala"
					_tmp8_ = proxy;
#line 1634 "../src/Commands.vala"
					_tmp9_ = source_proxy_get_source (_tmp8_);
#line 1634 "../src/Commands.vala"
					victim_source = _tmp9_;
#line 1635 "../src/Commands.vala"
					_tmp10_ = victim_source;
#line 1635 "../src/Commands.vala"
					_vala_assert (IS_TAG (_tmp10_), "victim_source is Tag");
#line 1637 "../src/Commands.vala"
					_tmp11_ = proxy;
#line 1637 "../src/Commands.vala"
					g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp12_, NULL, FALSE);
#line 1637 "../src/Commands.vala"
					g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _delete_tag_command_on_proxy_broken_source_proxy_broken, self);
#line 1631 "../src/Commands.vala"
					_g_object_unref0 (victim_source);
#line 1631 "../src/Commands.vala"
					_source_proxy_unref0 (proxy);
#line 15037 "Commands.c"
				}
			}
		}
#line 1640 "../src/Commands.vala"
		_g_object_unref0 (self->priv->recursive_victim_proxies);
#line 1640 "../src/Commands.vala"
		self->priv->recursive_victim_proxies = NULL;
#line 15045 "Commands.c"
	}
}

static void
delete_tag_command_on_proxy_broken (DeleteTagCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 1644 "../src/Commands.vala"
	g_return_if_fail (IS_DELETE_TAG_COMMAND (self));
#line 1645 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 1645 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1645 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 1645 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 15064 "Commands.c"
}

static void
delete_tag_command_class_init (DeleteTagCommandClass * klass,
                               gpointer klass_data)
{
#line 1595 "../src/Commands.vala"
	delete_tag_command_parent_class = g_type_class_peek_parent (klass);
#line 1595 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &DeleteTagCommand_private_offset);
#line 1595 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) delete_tag_command_real_execute_on_source;
#line 1595 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) delete_tag_command_real_undo_on_source;
#line 1595 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = delete_tag_command_finalize;
#line 15081 "Commands.c"
}

static void
delete_tag_command_instance_init (DeleteTagCommand * self,
                                  gpointer klass)
{
#line 1595 "../src/Commands.vala"
	self->priv = delete_tag_command_get_instance_private (self);
#line 1596 "../src/Commands.vala"
	self->priv->recursive_victim_proxies = NULL;
#line 15092 "Commands.c"
}

static void
delete_tag_command_finalize (GObject * obj)
{
	DeleteTagCommand * self;
#line 1595 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELETE_TAG_COMMAND, DeleteTagCommand);
#line 1596 "../src/Commands.vala"
	_g_object_unref0 (self->priv->recursive_victim_proxies);
#line 1595 "../src/Commands.vala"
	G_OBJECT_CLASS (delete_tag_command_parent_class)->finalize (obj);
#line 15105 "Commands.c"
}

static GType
delete_tag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeleteTagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delete_tag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeleteTagCommand), 0, (GInstanceInitFunc) delete_tag_command_instance_init, NULL };
	GType delete_tag_command_type_id;
	delete_tag_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "DeleteTagCommand", &g_define_type_info, 0);
	DeleteTagCommand_private_offset = g_type_add_instance_private (delete_tag_command_type_id, sizeof (DeleteTagCommandPrivate));
	return delete_tag_command_type_id;
}

GType
delete_tag_command_get_type (void)
{
	static volatile gsize delete_tag_command_type_id__once = 0;
	if (g_once_init_enter (&delete_tag_command_type_id__once)) {
		GType delete_tag_command_type_id;
		delete_tag_command_type_id = delete_tag_command_get_type_once ();
		g_once_init_leave (&delete_tag_command_type_id__once, delete_tag_command_type_id);
	}
	return delete_tag_command_type_id__once;
}

static inline gpointer
new_child_tag_command_get_instance_private (NewChildTagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, NewChildTagCommand_private_offset);
}

NewChildTagCommand*
new_child_tag_command_construct (GType object_type,
                                 Tag* tag)
{
	NewChildTagCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1652 "../src/Commands.vala"
	g_return_val_if_fail (IS_TAG (tag), NULL);
#line 1653 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_DATA_OBJECT, DataObject));
#line 1653 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1653 "../src/Commands.vala"
	self = (NewChildTagCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_PROXYABLE, Proxyable), _ ("Create Tag"), _tmp1_);
#line 1653 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 1652 "../src/Commands.vala"
	return self;
#line 15155 "Commands.c"
}

NewChildTagCommand*
new_child_tag_command_new (Tag* tag)
{
#line 1652 "../src/Commands.vala"
	return new_child_tag_command_construct (TYPE_NEW_CHILD_TAG_COMMAND, tag);
#line 15163 "Commands.c"
}

static void
new_child_tag_command_real_execute_on_source (SimpleProxyableCommand* base,
                                              DataSource* source)
{
	NewChildTagCommand * self;
	Tag* tag = NULL;
	Tag* _tmp0_;
	Tag* _tmp1_;
#line 1656 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommand);
#line 1656 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1657 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 1657 "../src/Commands.vala"
	tag = _tmp0_;
#line 1658 "../src/Commands.vala"
	_tmp1_ = tag_create_new_child (tag);
#line 1658 "../src/Commands.vala"
	_g_object_unref0 (self->priv->created_child);
#line 1658 "../src/Commands.vala"
	self->priv->created_child = _tmp1_;
#line 1656 "../src/Commands.vala"
	_g_object_unref0 (tag);
#line 15190 "Commands.c"
}

static void
new_child_tag_command_real_undo_on_source (SimpleProxyableCommand* base,
                                           DataSource* source)
{
	NewChildTagCommand * self;
	TagSourceCollection* _tmp0_;
	TagSourceCollection* _tmp1_;
	Tag* _tmp2_;
	Marker* _tmp3_;
	Marker* _tmp4_;
#line 1661 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommand);
#line 1661 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 1662 "../src/Commands.vala"
	_tmp0_ = tag_global;
#line 1662 "../src/Commands.vala"
	_tmp1_ = tag_global;
#line 1662 "../src/Commands.vala"
	_tmp2_ = self->priv->created_child;
#line 1662 "../src/Commands.vala"
	_tmp3_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_OBJECT, DataObject));
#line 1662 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 1662 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp4_, TRUE, NULL, NULL, NULL);
#line 1662 "../src/Commands.vala"
	_g_object_unref0 (_tmp4_);
#line 15221 "Commands.c"
}

Tag*
new_child_tag_command_get_created_child (NewChildTagCommand* self)
{
	Tag* _tmp0_;
	Tag* _tmp1_;
	Tag* _tmp2_;
	Tag* result;
#line 1665 "../src/Commands.vala"
	g_return_val_if_fail (IS_NEW_CHILD_TAG_COMMAND (self), NULL);
#line 1666 "../src/Commands.vala"
	_tmp0_ = self->priv->created_child;
#line 1666 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "created_child != null");
#line 1668 "../src/Commands.vala"
	_tmp1_ = self->priv->created_child;
#line 1668 "../src/Commands.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1668 "../src/Commands.vala"
	result = _tmp2_;
#line 1668 "../src/Commands.vala"
	return result;
#line 15245 "Commands.c"
}

static void
new_child_tag_command_class_init (NewChildTagCommandClass * klass,
                                  gpointer klass_data)
{
#line 1649 "../src/Commands.vala"
	new_child_tag_command_parent_class = g_type_class_peek_parent (klass);
#line 1649 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &NewChildTagCommand_private_offset);
#line 1649 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) new_child_tag_command_real_execute_on_source;
#line 1649 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) new_child_tag_command_real_undo_on_source;
#line 1649 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = new_child_tag_command_finalize;
#line 15262 "Commands.c"
}

static void
new_child_tag_command_instance_init (NewChildTagCommand * self,
                                     gpointer klass)
{
#line 1649 "../src/Commands.vala"
	self->priv = new_child_tag_command_get_instance_private (self);
#line 1650 "../src/Commands.vala"
	self->priv->created_child = NULL;
#line 15273 "Commands.c"
}

static void
new_child_tag_command_finalize (GObject * obj)
{
	NewChildTagCommand * self;
#line 1649 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_CHILD_TAG_COMMAND, NewChildTagCommand);
#line 1650 "../src/Commands.vala"
	_g_object_unref0 (self->priv->created_child);
#line 1649 "../src/Commands.vala"
	G_OBJECT_CLASS (new_child_tag_command_parent_class)->finalize (obj);
#line 15286 "Commands.c"
}

static GType
new_child_tag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NewChildTagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_child_tag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewChildTagCommand), 0, (GInstanceInitFunc) new_child_tag_command_instance_init, NULL };
	GType new_child_tag_command_type_id;
	new_child_tag_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "NewChildTagCommand", &g_define_type_info, 0);
	NewChildTagCommand_private_offset = g_type_add_instance_private (new_child_tag_command_type_id, sizeof (NewChildTagCommandPrivate));
	return new_child_tag_command_type_id;
}

GType
new_child_tag_command_get_type (void)
{
	static volatile gsize new_child_tag_command_type_id__once = 0;
	if (g_once_init_enter (&new_child_tag_command_type_id__once)) {
		GType new_child_tag_command_type_id;
		new_child_tag_command_type_id = new_child_tag_command_get_type_once ();
		g_once_init_leave (&new_child_tag_command_type_id__once, new_child_tag_command_type_id);
	}
	return new_child_tag_command_type_id__once;
}

static inline gpointer
new_root_tag_command_get_instance_private (NewRootTagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, NewRootTagCommand_private_offset);
}

NewRootTagCommand*
new_root_tag_command_construct (GType object_type)
{
	NewRootTagCommand * self = NULL;
#line 1676 "../src/Commands.vala"
	self = (NewRootTagCommand*) page_command_construct (object_type, _ ("Create Tag"), "");
#line 1675 "../src/Commands.vala"
	return self;
#line 15325 "Commands.c"
}

NewRootTagCommand*
new_root_tag_command_new (void)
{
#line 1675 "../src/Commands.vala"
	return new_root_tag_command_construct (TYPE_NEW_ROOT_TAG_COMMAND);
#line 15333 "Commands.c"
}

static void
new_root_tag_command_real_execute (Command* base)
{
	NewRootTagCommand * self;
	SourceProxy* _tmp0_;
#line 1679 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommand);
#line 1680 "../src/Commands.vala"
	_tmp0_ = self->priv->created_proxy;
#line 1680 "../src/Commands.vala"
	if (_tmp0_ == NULL) {
#line 15347 "Commands.c"
		Tag* _tmp1_;
		Tag* _tmp2_;
		SourceProxy* _tmp3_;
#line 1681 "../src/Commands.vala"
		_tmp1_ = tag_create_new_root ();
#line 1681 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 1681 "../src/Commands.vala"
		_tmp3_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_PROXYABLE, Proxyable));
#line 1681 "../src/Commands.vala"
		_source_proxy_unref0 (self->priv->created_proxy);
#line 1681 "../src/Commands.vala"
		self->priv->created_proxy = _tmp3_;
#line 1681 "../src/Commands.vala"
		_g_object_unref0 (_tmp2_);
#line 15363 "Commands.c"
	} else {
		SourceProxy* _tmp4_;
		DataSource* _tmp5_;
		DataSource* _tmp6_;
#line 1683 "../src/Commands.vala"
		_tmp4_ = self->priv->created_proxy;
#line 1683 "../src/Commands.vala"
		_tmp5_ = source_proxy_get_source (_tmp4_);
#line 1683 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 1683 "../src/Commands.vala"
		_g_object_unref0 (_tmp6_);
#line 15376 "Commands.c"
	}
}

static void
new_root_tag_command_real_undo (Command* base)
{
	NewRootTagCommand * self;
	TagSourceCollection* _tmp0_;
	TagSourceCollection* _tmp1_;
	SourceProxy* _tmp2_;
	DataSource* _tmp3_;
	DataSource* _tmp4_;
	Marker* _tmp5_;
	Marker* _tmp6_;
#line 1686 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommand);
#line 1687 "../src/Commands.vala"
	_tmp0_ = tag_global;
#line 1687 "../src/Commands.vala"
	_tmp1_ = tag_global;
#line 1687 "../src/Commands.vala"
	_tmp2_ = self->priv->created_proxy;
#line 1687 "../src/Commands.vala"
	_tmp3_ = source_proxy_get_source (_tmp2_);
#line 1687 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 1687 "../src/Commands.vala"
	_tmp5_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_OBJECT, DataObject));
#line 1687 "../src/Commands.vala"
	_tmp6_ = _tmp5_;
#line 1687 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp6_, TRUE, NULL, NULL, NULL);
#line 1687 "../src/Commands.vala"
	_g_object_unref0 (_tmp6_);
#line 1687 "../src/Commands.vala"
	_g_object_unref0 (_tmp4_);
#line 15413 "Commands.c"
}

Tag*
new_root_tag_command_get_created_tag (NewRootTagCommand* self)
{
	SourceProxy* _tmp0_;
	DataSource* _tmp1_;
	Tag* result;
#line 1690 "../src/Commands.vala"
	g_return_val_if_fail (IS_NEW_ROOT_TAG_COMMAND (self), NULL);
#line 1691 "../src/Commands.vala"
	_tmp0_ = self->priv->created_proxy;
#line 1691 "../src/Commands.vala"
	_tmp1_ = source_proxy_get_source (_tmp0_);
#line 1691 "../src/Commands.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TAG, Tag);
#line 1691 "../src/Commands.vala"
	return result;
#line 15432 "Commands.c"
}

static void
new_root_tag_command_class_init (NewRootTagCommandClass * klass,
                                 gpointer klass_data)
{
#line 1672 "../src/Commands.vala"
	new_root_tag_command_parent_class = g_type_class_peek_parent (klass);
#line 1672 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &NewRootTagCommand_private_offset);
#line 1672 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) new_root_tag_command_real_execute;
#line 1672 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) new_root_tag_command_real_undo;
#line 1672 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = new_root_tag_command_finalize;
#line 15449 "Commands.c"
}

static void
new_root_tag_command_instance_init (NewRootTagCommand * self,
                                    gpointer klass)
{
#line 1672 "../src/Commands.vala"
	self->priv = new_root_tag_command_get_instance_private (self);
#line 1673 "../src/Commands.vala"
	self->priv->created_proxy = NULL;
#line 15460 "Commands.c"
}

static void
new_root_tag_command_finalize (GObject * obj)
{
	NewRootTagCommand * self;
#line 1672 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_ROOT_TAG_COMMAND, NewRootTagCommand);
#line 1673 "../src/Commands.vala"
	_source_proxy_unref0 (self->priv->created_proxy);
#line 1672 "../src/Commands.vala"
	G_OBJECT_CLASS (new_root_tag_command_parent_class)->finalize (obj);
#line 15473 "Commands.c"
}

static GType
new_root_tag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NewRootTagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_root_tag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewRootTagCommand), 0, (GInstanceInitFunc) new_root_tag_command_instance_init, NULL };
	GType new_root_tag_command_type_id;
	new_root_tag_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "NewRootTagCommand", &g_define_type_info, 0);
	NewRootTagCommand_private_offset = g_type_add_instance_private (new_root_tag_command_type_id, sizeof (NewRootTagCommandPrivate));
	return new_root_tag_command_type_id;
}

GType
new_root_tag_command_get_type (void)
{
	static volatile gsize new_root_tag_command_type_id__once = 0;
	if (g_once_init_enter (&new_root_tag_command_type_id__once)) {
		GType new_root_tag_command_type_id;
		new_root_tag_command_type_id = new_root_tag_command_get_type_once ();
		g_once_init_leave (&new_root_tag_command_type_id__once, new_root_tag_command_type_id);
	}
	return new_root_tag_command_type_id__once;
}

static inline gpointer
reparent_tag_command_get_instance_private (ReparentTagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, ReparentTagCommand_private_offset);
}

static void
_reparent_tag_command_on_items_destroyed_source_collection_items_destroyed (SourceCollection* _sender,
                                                                            GeeCollection* destroyed,
                                                                            gpointer self)
{
#line 1740 "../src/Commands.vala"
	reparent_tag_command_on_items_destroyed ((ReparentTagCommand*) self, destroyed);
#line 15511 "Commands.c"
}

ReparentTagCommand*
reparent_tag_command_construct (GType object_type,
                                Tag* tag,
                                const gchar* new_parent_path)
{
	ReparentTagCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean has_children = FALSE;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gboolean _tmp9_;
	gchar* basename = NULL;
	gchar* _tmp10_;
	gchar* new_to_path = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	TagSourceCollection* _tmp32_;
	const gchar* _tmp33_;
	GeeHashSet* _tmp34_;
	GeeCollection* _tmp35_;
	GeeCollection* _tmp36_;
	LibraryPhotoSourceCollection* _tmp37_;
	VideoSourceCollection* _tmp38_;
#line 1710 "../src/Commands.vala"
	g_return_val_if_fail (IS_TAG (tag), NULL);
#line 1710 "../src/Commands.vala"
	g_return_val_if_fail (new_parent_path != NULL, NULL);
#line 1711 "../src/Commands.vala"
	_tmp0_ = tag_get_user_visible_name (tag);
#line 1711 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 1711 "../src/Commands.vala"
	_tmp2_ = g_strdup_printf (_ ("Move Tag “%s”"), _tmp1_);
#line 1711 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 1711 "../src/Commands.vala"
	self = (ReparentTagCommand*) page_command_construct (object_type, _tmp3_, "");
#line 1711 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 1711 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 1713 "../src/Commands.vala"
	_tmp4_ = tag_get_path (tag);
#line 1713 "../src/Commands.vala"
	_g_free0 (self->priv->from_path);
#line 1713 "../src/Commands.vala"
	self->priv->from_path = _tmp4_;
#line 1715 "../src/Commands.vala"
	_tmp5_ = tag_get_hierarchical_children (tag);
#line 1715 "../src/Commands.vala"
	_tmp6_ = _tmp5_;
#line 1715 "../src/Commands.vala"
	_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1715 "../src/Commands.vala"
	_tmp8_ = _tmp7_;
#line 1715 "../src/Commands.vala"
	_tmp9_ = _tmp8_ > 0;
#line 1715 "../src/Commands.vala"
	_g_object_unref0 (_tmp6_);
#line 1715 "../src/Commands.vala"
	has_children = _tmp9_;
#line 1716 "../src/Commands.vala"
	_tmp10_ = tag_get_user_visible_name (tag);
#line 1716 "../src/Commands.vala"
	basename = _tmp10_;
#line 1718 "../src/Commands.vala"
	if (g_strcmp0 (new_parent_path, TAG_PATH_SEPARATOR_STRING) == 0) {
#line 15588 "Commands.c"
		gchar* _tmp11_ = NULL;
		gchar* _tmp16_;
#line 1719 "../src/Commands.vala"
		if (has_children) {
#line 15593 "Commands.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 1719 "../src/Commands.vala"
			_tmp12_ = basename;
#line 1719 "../src/Commands.vala"
			_tmp13_ = g_strconcat (TAG_PATH_SEPARATOR_STRING, _tmp12_, NULL);
#line 1719 "../src/Commands.vala"
			_g_free0 (_tmp11_);
#line 1719 "../src/Commands.vala"
			_tmp11_ = _tmp13_;
#line 15604 "Commands.c"
		} else {
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 1719 "../src/Commands.vala"
			_tmp14_ = basename;
#line 1719 "../src/Commands.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 1719 "../src/Commands.vala"
			_g_free0 (_tmp11_);
#line 1719 "../src/Commands.vala"
			_tmp11_ = _tmp15_;
#line 15616 "Commands.c"
		}
#line 1719 "../src/Commands.vala"
		_tmp16_ = g_strdup (_tmp11_);
#line 1719 "../src/Commands.vala"
		_g_free0 (self->priv->to_path);
#line 1719 "../src/Commands.vala"
		self->priv->to_path = _tmp16_;
#line 1718 "../src/Commands.vala"
		_g_free0 (_tmp11_);
#line 15626 "Commands.c"
	} else {
#line 1720 "../src/Commands.vala"
		if (g_str_has_prefix (new_parent_path, TAG_PATH_SEPARATOR_STRING)) {
#line 15630 "Commands.c"
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 1721 "../src/Commands.vala"
			_tmp17_ = g_strconcat (new_parent_path, TAG_PATH_SEPARATOR_STRING, NULL);
#line 1721 "../src/Commands.vala"
			_tmp18_ = _tmp17_;
#line 1721 "../src/Commands.vala"
			_tmp19_ = basename;
#line 1721 "../src/Commands.vala"
			_tmp20_ = g_strconcat (_tmp18_, _tmp19_, NULL);
#line 1721 "../src/Commands.vala"
			_g_free0 (self->priv->to_path);
#line 1721 "../src/Commands.vala"
			self->priv->to_path = _tmp20_;
#line 1721 "../src/Commands.vala"
			_g_free0 (_tmp18_);
#line 15649 "Commands.c"
		} else {
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 1723 "../src/Commands.vala"
			_tmp21_ = g_strconcat (TAG_PATH_SEPARATOR_STRING, new_parent_path, NULL);
#line 1723 "../src/Commands.vala"
			_tmp22_ = _tmp21_;
#line 1723 "../src/Commands.vala"
			_tmp23_ = g_strconcat (_tmp22_, TAG_PATH_SEPARATOR_STRING, NULL);
#line 1723 "../src/Commands.vala"
			_tmp24_ = _tmp23_;
#line 1723 "../src/Commands.vala"
			_tmp25_ = basename;
#line 1723 "../src/Commands.vala"
			_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 1723 "../src/Commands.vala"
			_g_free0 (self->priv->to_path);
#line 1723 "../src/Commands.vala"
			self->priv->to_path = _tmp26_;
#line 1723 "../src/Commands.vala"
			_g_free0 (_tmp24_);
#line 1723 "../src/Commands.vala"
			_g_free0 (_tmp22_);
#line 15677 "Commands.c"
		}
	}
#line 1726 "../src/Commands.vala"
	_tmp27_ = self->priv->to_path;
#line 1726 "../src/Commands.vala"
	_tmp28_ = hierarchical_tag_utilities_get_root_path_form (_tmp27_);
#line 1726 "../src/Commands.vala"
	new_to_path = _tmp28_;
#line 1727 "../src/Commands.vala"
	_tmp29_ = new_to_path;
#line 1727 "../src/Commands.vala"
	if (_tmp29_ != NULL) {
#line 15690 "Commands.c"
		const gchar* _tmp30_;
		gchar* _tmp31_;
#line 1728 "../src/Commands.vala"
		_tmp30_ = new_to_path;
#line 1728 "../src/Commands.vala"
		_tmp31_ = g_strdup (_tmp30_);
#line 1728 "../src/Commands.vala"
		_g_free0 (self->priv->to_path);
#line 1728 "../src/Commands.vala"
		self->priv->to_path = _tmp31_;
#line 15701 "Commands.c"
	}
#line 1730 "../src/Commands.vala"
	_tmp32_ = tag_global;
#line 1730 "../src/Commands.vala"
	_tmp33_ = self->priv->to_path;
#line 1730 "../src/Commands.vala"
	if (tag_source_collection_exists (_tmp32_, _tmp33_, FALSE)) {
#line 1731 "../src/Commands.vala"
		self->priv->to_path_exists = TRUE;
#line 15711 "Commands.c"
	}
#line 1733 "../src/Commands.vala"
	_tmp34_ = self->priv->sources_in_play;
#line 1733 "../src/Commands.vala"
	_tmp35_ = tag_get_sources (tag);
#line 1733 "../src/Commands.vala"
	_tmp36_ = _tmp35_;
#line 1733 "../src/Commands.vala"
	gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_COLLECTION, GeeCollection), _tmp36_);
#line 1733 "../src/Commands.vala"
	_g_object_unref0 (_tmp36_);
#line 1735 "../src/Commands.vala"
	_tmp37_ = library_photo_global;
#line 1735 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_SOURCE_COLLECTION, SourceCollection), "items-destroyed", (GCallback) _reparent_tag_command_on_items_destroyed_source_collection_items_destroyed, self, 0);
#line 1736 "../src/Commands.vala"
	_tmp38_ = video_global;
#line 1736 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_SOURCE_COLLECTION, SourceCollection), "items-destroyed", (GCallback) _reparent_tag_command_on_items_destroyed_source_collection_items_destroyed, self, 0);
#line 1710 "../src/Commands.vala"
	_g_free0 (new_to_path);
#line 1710 "../src/Commands.vala"
	_g_free0 (basename);
#line 1710 "../src/Commands.vala"
	return self;
#line 15737 "Commands.c"
}

ReparentTagCommand*
reparent_tag_command_new (Tag* tag,
                          const gchar* new_parent_path)
{
#line 1710 "../src/Commands.vala"
	return reparent_tag_command_construct (TYPE_REPARENT_TAG_COMMAND, tag, new_parent_path);
#line 15746 "Commands.c"
}

static void
reparent_tag_command_on_items_destroyed (ReparentTagCommand* self,
                                         GeeCollection* destroyed)
{
#line 1744 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1744 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destroyed, GEE_TYPE_COLLECTION));
#line 15757 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 1745 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (destroyed, GEE_TYPE_ITERABLE, GeeIterable));
#line 1745 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 1745 "../src/Commands.vala"
		while (TRUE) {
#line 15767 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashSet* _tmp4_;
			DataSource* _tmp5_;
#line 1745 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 1745 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 1745 "../src/Commands.vala"
				break;
#line 15780 "Commands.c"
			}
#line 1745 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 1745 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 1745 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 1746 "../src/Commands.vala"
			_tmp4_ = self->priv->sources_in_play;
#line 1746 "../src/Commands.vala"
			_tmp5_ = source;
#line 1746 "../src/Commands.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MEDIA_SOURCE, MediaSource))) {
#line 15794 "Commands.c"
				CommandManager* _tmp6_;
				CommandManager* _tmp7_;
#line 1747 "../src/Commands.vala"
				_tmp6_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 1747 "../src/Commands.vala"
				_tmp7_ = _tmp6_;
#line 1747 "../src/Commands.vala"
				command_manager_reset (_tmp7_);
#line 1747 "../src/Commands.vala"
				_command_manager_unref0 (_tmp7_);
#line 15805 "Commands.c"
			}
#line 1745 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 15809 "Commands.c"
		}
#line 1745 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 15813 "Commands.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 15836 "Commands.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 15840 "Commands.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 15846 "Commands.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 15850 "Commands.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 15854 "Commands.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 15862 "Commands.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 15890 "Commands.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 15899 "Commands.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 15913 "Commands.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 15922 "Commands.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 15936 "Commands.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 15945 "Commands.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 15954 "Commands.c"
}

static GeeMap*
reparent_tag_command_get_child_structure_at (ReparentTagCommand* self,
                                             const gchar* client_path)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp4_;
	GeeMap* _result_ = NULL;
	GeeHashMap* _tmp5_;
	TagSourceCollection* _tmp6_;
	const gchar* _tmp7_;
	Tag* tag = NULL;
	const gchar* _tmp8_;
	Tag* _tmp9_;
	gchar* path_prefix = NULL;
	Tag* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GeeMap* result;
#line 1751 "../src/Commands.vala"
	g_return_val_if_fail (IS_REPARENT_TAG_COMMAND (self), NULL);
#line 1751 "../src/Commands.vala"
	g_return_val_if_fail (client_path != NULL, NULL);
#line 1752 "../src/Commands.vala"
	_tmp0_ = hierarchical_tag_utilities_get_root_path_form (client_path);
#line 1752 "../src/Commands.vala"
	path = _tmp0_;
#line 1753 "../src/Commands.vala"
	_tmp2_ = path;
#line 1753 "../src/Commands.vala"
	if (_tmp2_ != NULL) {
#line 15992 "Commands.c"
		const gchar* _tmp3_;
#line 1753 "../src/Commands.vala"
		_tmp3_ = path;
#line 1753 "../src/Commands.vala"
		_tmp1_ = _tmp3_;
#line 15998 "Commands.c"
	} else {
#line 1753 "../src/Commands.vala"
		_tmp1_ = client_path;
#line 16002 "Commands.c"
	}
#line 1753 "../src/Commands.vala"
	_tmp4_ = g_strdup (_tmp1_);
#line 1753 "../src/Commands.vala"
	_g_free0 (path);
#line 1753 "../src/Commands.vala"
	path = _tmp4_;
#line 1755 "../src/Commands.vala"
	_tmp5_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1755 "../src/Commands.vala"
	_result_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MAP, GeeMap);
#line 1758 "../src/Commands.vala"
	_tmp6_ = tag_global;
#line 1758 "../src/Commands.vala"
	_tmp7_ = path;
#line 1758 "../src/Commands.vala"
	if (!tag_source_collection_exists (_tmp6_, _tmp7_, FALSE)) {
#line 1759 "../src/Commands.vala"
		result = _result_;
#line 1759 "../src/Commands.vala"
		_g_free0 (path);
#line 1759 "../src/Commands.vala"
		return result;
#line 16026 "Commands.c"
	}
#line 1761 "../src/Commands.vala"
	_tmp8_ = path;
#line 1761 "../src/Commands.vala"
	_tmp9_ = tag_for_path (_tmp8_);
#line 1761 "../src/Commands.vala"
	tag = _tmp9_;
#line 1763 "../src/Commands.vala"
	_tmp10_ = tag;
#line 1763 "../src/Commands.vala"
	_tmp11_ = tag_get_path (_tmp10_);
#line 1763 "../src/Commands.vala"
	_tmp12_ = _tmp11_;
#line 1763 "../src/Commands.vala"
	_tmp13_ = g_strconcat (_tmp12_, TAG_PATH_SEPARATOR_STRING, NULL);
#line 1763 "../src/Commands.vala"
	_tmp14_ = _tmp13_;
#line 1763 "../src/Commands.vala"
	_g_free0 (_tmp12_);
#line 1763 "../src/Commands.vala"
	path_prefix = _tmp14_;
#line 16048 "Commands.c"
	{
		GeeList* _t_list = NULL;
		Tag* _tmp15_;
		GeeList* _tmp16_;
		gint _t_size = 0;
		GeeList* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _t_index = 0;
#line 1764 "../src/Commands.vala"
		_tmp15_ = tag;
#line 1764 "../src/Commands.vala"
		_tmp16_ = tag_get_hierarchical_children (_tmp15_);
#line 1764 "../src/Commands.vala"
		_t_list = _tmp16_;
#line 1764 "../src/Commands.vala"
		_tmp17_ = _t_list;
#line 1764 "../src/Commands.vala"
		_tmp18_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1764 "../src/Commands.vala"
		_tmp19_ = _tmp18_;
#line 1764 "../src/Commands.vala"
		_t_size = _tmp19_;
#line 1764 "../src/Commands.vala"
		_t_index = -1;
#line 1764 "../src/Commands.vala"
		while (TRUE) {
#line 16076 "Commands.c"
			gint _tmp20_;
			gint _tmp21_;
			Tag* t = NULL;
			GeeList* _tmp22_;
			gpointer _tmp23_;
			gchar* child_subpath = NULL;
			Tag* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			GeeMap* _tmp30_;
			const gchar* _tmp31_;
			GeeHashSet* _tmp32_;
			GeeHashSet* _tmp33_;
			GeeMap* _tmp34_;
			const gchar* _tmp35_;
			gpointer _tmp36_;
			GeeSet* _tmp37_;
			Tag* _tmp38_;
			GeeCollection* _tmp39_;
			GeeCollection* _tmp40_;
#line 1764 "../src/Commands.vala"
			_t_index = _t_index + 1;
#line 1764 "../src/Commands.vala"
			_tmp20_ = _t_index;
#line 1764 "../src/Commands.vala"
			_tmp21_ = _t_size;
#line 1764 "../src/Commands.vala"
			if (!(_tmp20_ < _tmp21_)) {
#line 1764 "../src/Commands.vala"
				break;
#line 16110 "Commands.c"
			}
#line 1764 "../src/Commands.vala"
			_tmp22_ = _t_list;
#line 1764 "../src/Commands.vala"
			_tmp23_ = gee_list_get (_tmp22_, _t_index);
#line 1764 "../src/Commands.vala"
			t = (Tag*) _tmp23_;
#line 1765 "../src/Commands.vala"
			_tmp24_ = t;
#line 1765 "../src/Commands.vala"
			_tmp25_ = tag_get_path (_tmp24_);
#line 1765 "../src/Commands.vala"
			_tmp26_ = _tmp25_;
#line 1765 "../src/Commands.vala"
			_tmp27_ = path_prefix;
#line 1765 "../src/Commands.vala"
			_tmp28_ = string_replace (_tmp26_, _tmp27_, "");
#line 1765 "../src/Commands.vala"
			_tmp29_ = _tmp28_;
#line 1765 "../src/Commands.vala"
			_g_free0 (_tmp26_);
#line 1765 "../src/Commands.vala"
			child_subpath = _tmp29_;
#line 1767 "../src/Commands.vala"
			_tmp30_ = _result_;
#line 1767 "../src/Commands.vala"
			_tmp31_ = child_subpath;
#line 1767 "../src/Commands.vala"
			_tmp32_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1767 "../src/Commands.vala"
			_tmp33_ = _tmp32_;
#line 1767 "../src/Commands.vala"
			gee_map_set (_tmp30_, _tmp31_, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_SET, GeeSet));
#line 1767 "../src/Commands.vala"
			_g_object_unref0 (_tmp33_);
#line 1768 "../src/Commands.vala"
			_tmp34_ = _result_;
#line 1768 "../src/Commands.vala"
			_tmp35_ = child_subpath;
#line 1768 "../src/Commands.vala"
			_tmp36_ = gee_map_get (_tmp34_, _tmp35_);
#line 1768 "../src/Commands.vala"
			_tmp37_ = (GeeSet*) _tmp36_;
#line 1768 "../src/Commands.vala"
			_tmp38_ = t;
#line 1768 "../src/Commands.vala"
			_tmp39_ = tag_get_sources (_tmp38_);
#line 1768 "../src/Commands.vala"
			_tmp40_ = _tmp39_;
#line 1768 "../src/Commands.vala"
			gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection), _tmp40_);
#line 1768 "../src/Commands.vala"
			_g_object_unref0 (_tmp40_);
#line 1768 "../src/Commands.vala"
			_g_object_unref0 (_tmp37_);
#line 1764 "../src/Commands.vala"
			_g_free0 (child_subpath);
#line 1764 "../src/Commands.vala"
			_g_object_unref0 (t);
#line 16170 "Commands.c"
		}
#line 1764 "../src/Commands.vala"
		_g_object_unref0 (_t_list);
#line 16174 "Commands.c"
	}
#line 1771 "../src/Commands.vala"
	result = _result_;
#line 1771 "../src/Commands.vala"
	_g_free0 (path_prefix);
#line 1771 "../src/Commands.vala"
	_g_object_unref0 (tag);
#line 1771 "../src/Commands.vala"
	_g_free0 (path);
#line 1771 "../src/Commands.vala"
	return result;
#line 16186 "Commands.c"
}

static void
reparent_tag_command_restore_child_attachments_at (ReparentTagCommand* self,
                                                   const gchar* client_path,
                                                   GeeMap* child_structure)
{
	gchar* new_path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* path = NULL;
	gchar* _tmp4_;
	TagSourceCollection* _tmp5_;
	const gchar* _tmp6_;
	Tag* tag = NULL;
	const gchar* _tmp7_;
	Tag* _tmp8_;
#line 1774 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1774 "../src/Commands.vala"
	g_return_if_fail (client_path != NULL);
#line 1774 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (child_structure, GEE_TYPE_MAP));
#line 1777 "../src/Commands.vala"
	_tmp0_ = hierarchical_tag_utilities_get_root_path_form (client_path);
#line 1777 "../src/Commands.vala"
	new_path = _tmp0_;
#line 1778 "../src/Commands.vala"
	_tmp2_ = new_path;
#line 1778 "../src/Commands.vala"
	if (_tmp2_ != NULL) {
#line 16219 "Commands.c"
		const gchar* _tmp3_;
#line 1778 "../src/Commands.vala"
		_tmp3_ = new_path;
#line 1778 "../src/Commands.vala"
		_tmp1_ = _tmp3_;
#line 16225 "Commands.c"
	} else {
#line 1778 "../src/Commands.vala"
		_tmp1_ = client_path;
#line 16229 "Commands.c"
	}
#line 1778 "../src/Commands.vala"
	_tmp4_ = g_strdup (_tmp1_);
#line 1778 "../src/Commands.vala"
	path = _tmp4_;
#line 1780 "../src/Commands.vala"
	_tmp5_ = tag_global;
#line 1780 "../src/Commands.vala"
	_tmp6_ = path;
#line 1780 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp5_, _tmp6_, FALSE), "Tag.global.exists(path)");
#line 1781 "../src/Commands.vala"
	_tmp7_ = path;
#line 1781 "../src/Commands.vala"
	_tmp8_ = tag_for_path (_tmp7_);
#line 1781 "../src/Commands.vala"
	tag = _tmp8_;
#line 16247 "Commands.c"
	{
		GeeIterator* _child_subpath_it = NULL;
		GeeSet* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 1783 "../src/Commands.vala"
		_tmp9_ = gee_map_get_keys (child_structure);
#line 1783 "../src/Commands.vala"
		_tmp10_ = _tmp9_;
#line 1783 "../src/Commands.vala"
		_tmp11_ = _tmp10_;
#line 1783 "../src/Commands.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1783 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 1783 "../src/Commands.vala"
		_g_object_unref0 (_tmp11_);
#line 1783 "../src/Commands.vala"
		_child_subpath_it = _tmp13_;
#line 1783 "../src/Commands.vala"
		while (TRUE) {
#line 16271 "Commands.c"
			GeeIterator* _tmp14_;
			gchar* child_subpath = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			gchar* child_path = NULL;
			Tag* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			Tag* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gboolean _tmp28_;
			TagSourceCollection* _tmp37_;
			const gchar* _tmp38_;
#line 1783 "../src/Commands.vala"
			_tmp14_ = _child_subpath_it;
#line 1783 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 1783 "../src/Commands.vala"
				break;
#line 16297 "Commands.c"
			}
#line 1783 "../src/Commands.vala"
			_tmp15_ = _child_subpath_it;
#line 1783 "../src/Commands.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 1783 "../src/Commands.vala"
			child_subpath = (gchar*) _tmp16_;
#line 1784 "../src/Commands.vala"
			_tmp17_ = tag;
#line 1784 "../src/Commands.vala"
			_tmp18_ = tag_get_path (_tmp17_);
#line 1784 "../src/Commands.vala"
			_tmp19_ = _tmp18_;
#line 1784 "../src/Commands.vala"
			_tmp20_ = g_strconcat (_tmp19_, TAG_PATH_SEPARATOR_STRING, NULL);
#line 1784 "../src/Commands.vala"
			_tmp21_ = _tmp20_;
#line 1784 "../src/Commands.vala"
			_tmp22_ = child_subpath;
#line 1784 "../src/Commands.vala"
			_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
#line 1784 "../src/Commands.vala"
			_tmp24_ = _tmp23_;
#line 1784 "../src/Commands.vala"
			_g_free0 (_tmp21_);
#line 1784 "../src/Commands.vala"
			_g_free0 (_tmp19_);
#line 1784 "../src/Commands.vala"
			child_path = _tmp24_;
#line 1786 "../src/Commands.vala"
			_tmp25_ = tag;
#line 1786 "../src/Commands.vala"
			_tmp26_ = tag_get_path (_tmp25_);
#line 1786 "../src/Commands.vala"
			_tmp27_ = _tmp26_;
#line 1786 "../src/Commands.vala"
			_tmp28_ = !g_str_has_prefix (_tmp27_, TAG_PATH_SEPARATOR_STRING);
#line 1786 "../src/Commands.vala"
			_g_free0 (_tmp27_);
#line 1786 "../src/Commands.vala"
			if (_tmp28_) {
#line 16339 "Commands.c"
				Tag* _tmp29_;
				Tag* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
#line 1787 "../src/Commands.vala"
				_tmp29_ = tag;
#line 1787 "../src/Commands.vala"
				tag_promote (_tmp29_);
#line 1788 "../src/Commands.vala"
				_tmp30_ = tag;
#line 1788 "../src/Commands.vala"
				_tmp31_ = tag_get_path (_tmp30_);
#line 1788 "../src/Commands.vala"
				_tmp32_ = _tmp31_;
#line 1788 "../src/Commands.vala"
				_tmp33_ = g_strconcat (_tmp32_, TAG_PATH_SEPARATOR_STRING, NULL);
#line 1788 "../src/Commands.vala"
				_tmp34_ = _tmp33_;
#line 1788 "../src/Commands.vala"
				_tmp35_ = child_subpath;
#line 1788 "../src/Commands.vala"
				_tmp36_ = g_strconcat (_tmp34_, _tmp35_, NULL);
#line 1788 "../src/Commands.vala"
				_g_free0 (child_path);
#line 1788 "../src/Commands.vala"
				child_path = _tmp36_;
#line 1788 "../src/Commands.vala"
				_g_free0 (_tmp34_);
#line 1788 "../src/Commands.vala"
				_g_free0 (_tmp32_);
#line 16374 "Commands.c"
			}
#line 1791 "../src/Commands.vala"
			_tmp37_ = tag_global;
#line 1791 "../src/Commands.vala"
			_tmp38_ = child_path;
#line 1791 "../src/Commands.vala"
			_vala_assert (tag_source_collection_exists (_tmp37_, _tmp38_, FALSE), "Tag.global.exists(child_path)");
#line 16382 "Commands.c"
			{
				GeeIterator* _s_it = NULL;
				const gchar* _tmp39_;
				gpointer _tmp40_;
				GeeSet* _tmp41_;
				GeeIterator* _tmp42_;
				GeeIterator* _tmp43_;
#line 1793 "../src/Commands.vala"
				_tmp39_ = child_subpath;
#line 1793 "../src/Commands.vala"
				_tmp40_ = gee_map_get (child_structure, _tmp39_);
#line 1793 "../src/Commands.vala"
				_tmp41_ = (GeeSet*) _tmp40_;
#line 1793 "../src/Commands.vala"
				_tmp42_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1793 "../src/Commands.vala"
				_tmp43_ = _tmp42_;
#line 1793 "../src/Commands.vala"
				_g_object_unref0 (_tmp41_);
#line 1793 "../src/Commands.vala"
				_s_it = _tmp43_;
#line 1793 "../src/Commands.vala"
				while (TRUE) {
#line 16406 "Commands.c"
					GeeIterator* _tmp44_;
					MediaSource* s = NULL;
					GeeIterator* _tmp45_;
					gpointer _tmp46_;
					const gchar* _tmp47_;
					Tag* _tmp48_;
					Tag* _tmp49_;
					MediaSource* _tmp50_;
#line 1793 "../src/Commands.vala"
					_tmp44_ = _s_it;
#line 1793 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp44_)) {
#line 1793 "../src/Commands.vala"
						break;
#line 16421 "Commands.c"
					}
#line 1793 "../src/Commands.vala"
					_tmp45_ = _s_it;
#line 1793 "../src/Commands.vala"
					_tmp46_ = gee_iterator_get (_tmp45_);
#line 1793 "../src/Commands.vala"
					s = (MediaSource*) _tmp46_;
#line 1794 "../src/Commands.vala"
					_tmp47_ = child_path;
#line 1794 "../src/Commands.vala"
					_tmp48_ = tag_for_path (_tmp47_);
#line 1794 "../src/Commands.vala"
					_tmp49_ = _tmp48_;
#line 1794 "../src/Commands.vala"
					_tmp50_ = s;
#line 1794 "../src/Commands.vala"
					tag_attach (_tmp49_, _tmp50_);
#line 1794 "../src/Commands.vala"
					_g_object_unref0 (_tmp49_);
#line 1793 "../src/Commands.vala"
					_g_object_unref0 (s);
#line 16443 "Commands.c"
				}
#line 1793 "../src/Commands.vala"
				_g_object_unref0 (_s_it);
#line 16447 "Commands.c"
			}
#line 1783 "../src/Commands.vala"
			_g_free0 (child_path);
#line 1783 "../src/Commands.vala"
			_g_free0 (child_subpath);
#line 16453 "Commands.c"
		}
#line 1783 "../src/Commands.vala"
		_g_object_unref0 (_child_subpath_it);
#line 16457 "Commands.c"
	}
#line 1774 "../src/Commands.vala"
	_g_object_unref0 (tag);
#line 1774 "../src/Commands.vala"
	_g_free0 (path);
#line 1774 "../src/Commands.vala"
	_g_free0 (new_path);
#line 16465 "Commands.c"
}

static void
reparent_tag_command_reattach_in_play_sources_at (ReparentTagCommand* self,
                                                  const gchar* client_path)
{
	gchar* new_path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* path = NULL;
	gchar* _tmp4_;
	TagSourceCollection* _tmp5_;
	const gchar* _tmp6_;
	Tag* tag = NULL;
	const gchar* _tmp7_;
	Tag* _tmp8_;
#line 1798 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1798 "../src/Commands.vala"
	g_return_if_fail (client_path != NULL);
#line 1799 "../src/Commands.vala"
	_tmp0_ = hierarchical_tag_utilities_get_root_path_form (client_path);
#line 1799 "../src/Commands.vala"
	new_path = _tmp0_;
#line 1800 "../src/Commands.vala"
	_tmp2_ = new_path;
#line 1800 "../src/Commands.vala"
	if (_tmp2_ != NULL) {
#line 16495 "Commands.c"
		const gchar* _tmp3_;
#line 1800 "../src/Commands.vala"
		_tmp3_ = new_path;
#line 1800 "../src/Commands.vala"
		_tmp1_ = _tmp3_;
#line 16501 "Commands.c"
	} else {
#line 1800 "../src/Commands.vala"
		_tmp1_ = client_path;
#line 16505 "Commands.c"
	}
#line 1800 "../src/Commands.vala"
	_tmp4_ = g_strdup (_tmp1_);
#line 1800 "../src/Commands.vala"
	path = _tmp4_;
#line 1802 "../src/Commands.vala"
	_tmp5_ = tag_global;
#line 1802 "../src/Commands.vala"
	_tmp6_ = path;
#line 1802 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp5_, _tmp6_, FALSE), "Tag.global.exists(path)");
#line 1804 "../src/Commands.vala"
	_tmp7_ = path;
#line 1804 "../src/Commands.vala"
	_tmp8_ = tag_for_path (_tmp7_);
#line 1804 "../src/Commands.vala"
	tag = _tmp8_;
#line 16523 "Commands.c"
	{
		GeeIterator* _s_it = NULL;
		GeeHashSet* _tmp9_;
		GeeIterator* _tmp10_;
#line 1806 "../src/Commands.vala"
		_tmp9_ = self->priv->sources_in_play;
#line 1806 "../src/Commands.vala"
		_tmp10_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1806 "../src/Commands.vala"
		_s_it = _tmp10_;
#line 1806 "../src/Commands.vala"
		while (TRUE) {
#line 16536 "Commands.c"
			GeeIterator* _tmp11_;
			MediaSource* s = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			Tag* _tmp14_;
			MediaSource* _tmp15_;
#line 1806 "../src/Commands.vala"
			_tmp11_ = _s_it;
#line 1806 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 1806 "../src/Commands.vala"
				break;
#line 16549 "Commands.c"
			}
#line 1806 "../src/Commands.vala"
			_tmp12_ = _s_it;
#line 1806 "../src/Commands.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 1806 "../src/Commands.vala"
			s = (MediaSource*) _tmp13_;
#line 1807 "../src/Commands.vala"
			_tmp14_ = tag;
#line 1807 "../src/Commands.vala"
			_tmp15_ = s;
#line 1807 "../src/Commands.vala"
			tag_attach (_tmp14_, _tmp15_);
#line 1806 "../src/Commands.vala"
			_g_object_unref0 (s);
#line 16565 "Commands.c"
		}
#line 1806 "../src/Commands.vala"
		_g_object_unref0 (_s_it);
#line 16569 "Commands.c"
	}
#line 1798 "../src/Commands.vala"
	_g_object_unref0 (tag);
#line 1798 "../src/Commands.vala"
	_g_free0 (path);
#line 1798 "../src/Commands.vala"
	_g_free0 (new_path);
#line 16577 "Commands.c"
}

static void
reparent_tag_command_save_before_state (ReparentTagCommand* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeMap* _tmp4_;
	const gchar* _tmp5_;
	GeeMap* _tmp6_;
	TagSourceCollection* _tmp7_;
	const gchar* _tmp8_;
	Tag* from_tag = NULL;
	const gchar* _tmp9_;
	Tag* _tmp10_;
	GeeList* _tmp11_;
	Tag* _tmp12_;
	SourceProxy* _tmp13_;
	SourceProxy* _tmp14_;
	GeeList* parent_paths = NULL;
	const gchar* _tmp15_;
	GeeList* _tmp16_;
	GeeList* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	const gchar* _tmp25_;
	const gchar* _tmp29_;
	const gchar* _tmp41_;
	const gchar* _tmp57_;
	GeeList* from_children = NULL;
	Tag* _tmp64_;
	GeeList* _tmp65_;
	const gchar* _tmp77_;
	const gchar* _tmp94_;
#line 1810 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1811 "../src/Commands.vala"
	_tmp0_ = self->priv->src_before_state;
#line 1811 "../src/Commands.vala"
	_vala_assert (_tmp0_ == NULL, "src_before_state == null");
#line 1812 "../src/Commands.vala"
	_tmp1_ = self->priv->dest_before_state;
#line 1812 "../src/Commands.vala"
	_vala_assert (_tmp1_ == NULL, "dest_before_state == null");
#line 1814 "../src/Commands.vala"
	_tmp2_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 1814 "../src/Commands.vala"
	_g_object_unref0 (self->priv->src_before_state);
#line 1814 "../src/Commands.vala"
	self->priv->src_before_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 1815 "../src/Commands.vala"
	_tmp3_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 1815 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dest_before_state);
#line 1815 "../src/Commands.vala"
	self->priv->dest_before_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 1818 "../src/Commands.vala"
	_tmp4_ = self->priv->in_play_child_structure;
#line 1818 "../src/Commands.vala"
	_vala_assert (_tmp4_ == NULL, "in_play_child_structure == null");
#line 1819 "../src/Commands.vala"
	_tmp5_ = self->priv->from_path;
#line 1819 "../src/Commands.vala"
	_tmp6_ = reparent_tag_command_get_child_structure_at (self, _tmp5_);
#line 1819 "../src/Commands.vala"
	_g_object_unref0 (self->priv->in_play_child_structure);
#line 1819 "../src/Commands.vala"
	self->priv->in_play_child_structure = _tmp6_;
#line 1822 "../src/Commands.vala"
	_tmp7_ = tag_global;
#line 1822 "../src/Commands.vala"
	_tmp8_ = self->priv->from_path;
#line 1822 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp7_, _tmp8_, FALSE), "Tag.global.exists(from_path)");
#line 1823 "../src/Commands.vala"
	_tmp9_ = self->priv->from_path;
#line 1823 "../src/Commands.vala"
	_tmp10_ = tag_for_path (_tmp9_);
#line 1823 "../src/Commands.vala"
	from_tag = _tmp10_;
#line 1824 "../src/Commands.vala"
	_tmp11_ = self->priv->src_before_state;
#line 1824 "../src/Commands.vala"
	_tmp12_ = from_tag;
#line 1824 "../src/Commands.vala"
	_tmp13_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PROXYABLE, Proxyable));
#line 1824 "../src/Commands.vala"
	_tmp14_ = _tmp13_;
#line 1824 "../src/Commands.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), _tmp14_);
#line 1824 "../src/Commands.vala"
	_source_proxy_unref0 (_tmp14_);
#line 1827 "../src/Commands.vala"
	_tmp15_ = self->priv->to_path;
#line 1827 "../src/Commands.vala"
	_tmp16_ = hierarchical_tag_utilities_enumerate_parent_paths (_tmp15_);
#line 1827 "../src/Commands.vala"
	parent_paths = _tmp16_;
#line 1828 "../src/Commands.vala"
	_tmp17_ = parent_paths;
#line 1828 "../src/Commands.vala"
	_tmp18_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1828 "../src/Commands.vala"
	_tmp19_ = _tmp18_;
#line 1828 "../src/Commands.vala"
	if (_tmp19_ > 0) {
#line 16686 "Commands.c"
		GeeList* _tmp20_;
		GeeList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gpointer _tmp24_;
#line 1829 "../src/Commands.vala"
		_tmp20_ = parent_paths;
#line 1829 "../src/Commands.vala"
		_tmp21_ = parent_paths;
#line 1829 "../src/Commands.vala"
		_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1829 "../src/Commands.vala"
		_tmp23_ = _tmp22_;
#line 1829 "../src/Commands.vala"
		_tmp24_ = gee_list_get (_tmp20_, _tmp23_ - 1);
#line 1829 "../src/Commands.vala"
		_g_free0 (self->priv->to_path_parent_path);
#line 1829 "../src/Commands.vala"
		self->priv->to_path_parent_path = (gchar*) _tmp24_;
#line 16706 "Commands.c"
	}
#line 1830 "../src/Commands.vala"
	_tmp25_ = self->priv->to_path_parent_path;
#line 1830 "../src/Commands.vala"
	if (_tmp25_ != NULL) {
#line 16712 "Commands.c"
		GeeMap* _tmp26_;
		const gchar* _tmp27_;
		GeeMap* _tmp28_;
#line 1831 "../src/Commands.vala"
		_tmp26_ = self->priv->existing_dest_child_structure;
#line 1831 "../src/Commands.vala"
		_vala_assert (_tmp26_ == NULL, "existing_dest_child_structure == null");
#line 1832 "../src/Commands.vala"
		_tmp27_ = self->priv->to_path_parent_path;
#line 1832 "../src/Commands.vala"
		_tmp28_ = reparent_tag_command_get_child_structure_at (self, _tmp27_);
#line 1832 "../src/Commands.vala"
		_g_object_unref0 (self->priv->existing_dest_child_structure);
#line 1832 "../src/Commands.vala"
		self->priv->existing_dest_child_structure = _tmp28_;
#line 16728 "Commands.c"
	}
#line 1836 "../src/Commands.vala"
	_tmp29_ = self->priv->to_path_parent_path;
#line 1836 "../src/Commands.vala"
	if (_tmp29_ == NULL) {
#line 16734 "Commands.c"
		GeeMap* _tmp30_;
		GeeSet* _tmp31_;
		const gchar* _tmp32_;
		GeeMap* _tmp33_;
		GeeHashSet* _tmp34_;
		GeeSet* _tmp35_;
		const gchar* _tmp36_;
		Tag* _tmp37_;
		Tag* _tmp38_;
		GeeCollection* _tmp39_;
		GeeCollection* _tmp40_;
#line 1837 "../src/Commands.vala"
		_tmp30_ = self->priv->existing_dest_child_structure;
#line 1837 "../src/Commands.vala"
		_vala_assert (_tmp30_ == NULL, "existing_dest_child_structure == null");
#line 1838 "../src/Commands.vala"
		_tmp31_ = self->priv->existing_dest_membership;
#line 1838 "../src/Commands.vala"
		_vala_assert (_tmp31_ == NULL, "existing_dest_membership == null");
#line 1839 "../src/Commands.vala"
		_tmp32_ = self->priv->to_path;
#line 1839 "../src/Commands.vala"
		_tmp33_ = reparent_tag_command_get_child_structure_at (self, _tmp32_);
#line 1839 "../src/Commands.vala"
		_g_object_unref0 (self->priv->existing_dest_child_structure);
#line 1839 "../src/Commands.vala"
		self->priv->existing_dest_child_structure = _tmp33_;
#line 1840 "../src/Commands.vala"
		_tmp34_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1840 "../src/Commands.vala"
		_g_object_unref0 (self->priv->existing_dest_membership);
#line 1840 "../src/Commands.vala"
		self->priv->existing_dest_membership = G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_SET, GeeSet);
#line 1841 "../src/Commands.vala"
		_tmp35_ = self->priv->existing_dest_membership;
#line 1841 "../src/Commands.vala"
		_tmp36_ = self->priv->to_path;
#line 1841 "../src/Commands.vala"
		_tmp37_ = tag_for_path (_tmp36_);
#line 1841 "../src/Commands.vala"
		_tmp38_ = _tmp37_;
#line 1841 "../src/Commands.vala"
		_tmp39_ = tag_get_sources (_tmp38_);
#line 1841 "../src/Commands.vala"
		_tmp40_ = _tmp39_;
#line 1841 "../src/Commands.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_COLLECTION, GeeCollection), _tmp40_);
#line 1841 "../src/Commands.vala"
		_g_object_unref0 (_tmp40_);
#line 1841 "../src/Commands.vala"
		_g_object_unref0 (_tmp38_);
#line 16786 "Commands.c"
	}
#line 1845 "../src/Commands.vala"
	_tmp41_ = self->priv->to_path_parent_path;
#line 1845 "../src/Commands.vala"
	if (_tmp41_ != NULL) {
#line 16792 "Commands.c"
		gchar* new_tpp = NULL;
		const gchar* _tmp42_;
		gchar* _tmp43_;
		const gchar* _tmp44_ = NULL;
		const gchar* _tmp45_;
		gchar* _tmp48_;
		TagSourceCollection* _tmp49_;
		const gchar* _tmp50_;
		GeeList* _tmp51_;
		const gchar* _tmp52_;
		Tag* _tmp53_;
		Tag* _tmp54_;
		SourceProxy* _tmp55_;
		SourceProxy* _tmp56_;
#line 1846 "../src/Commands.vala"
		_tmp42_ = self->priv->to_path_parent_path;
#line 1846 "../src/Commands.vala"
		_tmp43_ = hierarchical_tag_utilities_get_root_path_form (_tmp42_);
#line 1846 "../src/Commands.vala"
		new_tpp = _tmp43_;
#line 1847 "../src/Commands.vala"
		_tmp45_ = new_tpp;
#line 1847 "../src/Commands.vala"
		if (_tmp45_ != NULL) {
#line 16817 "Commands.c"
			const gchar* _tmp46_;
#line 1847 "../src/Commands.vala"
			_tmp46_ = new_tpp;
#line 1847 "../src/Commands.vala"
			_tmp44_ = _tmp46_;
#line 16823 "Commands.c"
		} else {
			const gchar* _tmp47_;
#line 1847 "../src/Commands.vala"
			_tmp47_ = self->priv->to_path_parent_path;
#line 1847 "../src/Commands.vala"
			_tmp44_ = _tmp47_;
#line 16830 "Commands.c"
		}
#line 1847 "../src/Commands.vala"
		_tmp48_ = g_strdup (_tmp44_);
#line 1847 "../src/Commands.vala"
		_g_free0 (self->priv->to_path_parent_path);
#line 1847 "../src/Commands.vala"
		self->priv->to_path_parent_path = _tmp48_;
#line 1848 "../src/Commands.vala"
		_tmp49_ = tag_global;
#line 1848 "../src/Commands.vala"
		_tmp50_ = self->priv->to_path_parent_path;
#line 1848 "../src/Commands.vala"
		_vala_assert (tag_source_collection_exists (_tmp49_, _tmp50_, FALSE), "Tag.global.exists(to_path_parent_path)");
#line 1849 "../src/Commands.vala"
		_tmp51_ = self->priv->dest_before_state;
#line 1849 "../src/Commands.vala"
		_tmp52_ = self->priv->to_path_parent_path;
#line 1849 "../src/Commands.vala"
		_tmp53_ = tag_for_path (_tmp52_);
#line 1849 "../src/Commands.vala"
		_tmp54_ = _tmp53_;
#line 1849 "../src/Commands.vala"
		_tmp55_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, TYPE_PROXYABLE, Proxyable));
#line 1849 "../src/Commands.vala"
		_tmp56_ = _tmp55_;
#line 1849 "../src/Commands.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GEE_TYPE_COLLECTION, GeeCollection), _tmp56_);
#line 1849 "../src/Commands.vala"
		_source_proxy_unref0 (_tmp56_);
#line 1849 "../src/Commands.vala"
		_g_object_unref0 (_tmp54_);
#line 1845 "../src/Commands.vala"
		_g_free0 (new_tpp);
#line 16864 "Commands.c"
	}
#line 1853 "../src/Commands.vala"
	_tmp57_ = self->priv->to_path_parent_path;
#line 1853 "../src/Commands.vala"
	if (_tmp57_ == NULL) {
#line 16870 "Commands.c"
		GeeList* _tmp58_;
		const gchar* _tmp59_;
		Tag* _tmp60_;
		Tag* _tmp61_;
		SourceProxy* _tmp62_;
		SourceProxy* _tmp63_;
#line 1854 "../src/Commands.vala"
		_tmp58_ = self->priv->dest_before_state;
#line 1854 "../src/Commands.vala"
		_tmp59_ = self->priv->to_path;
#line 1854 "../src/Commands.vala"
		_tmp60_ = tag_for_path (_tmp59_);
#line 1854 "../src/Commands.vala"
		_tmp61_ = _tmp60_;
#line 1854 "../src/Commands.vala"
		_tmp62_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_PROXYABLE, Proxyable));
#line 1854 "../src/Commands.vala"
		_tmp63_ = _tmp62_;
#line 1854 "../src/Commands.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GEE_TYPE_COLLECTION, GeeCollection), _tmp63_);
#line 1854 "../src/Commands.vala"
		_source_proxy_unref0 (_tmp63_);
#line 1854 "../src/Commands.vala"
		_g_object_unref0 (_tmp61_);
#line 16895 "Commands.c"
	}
#line 1858 "../src/Commands.vala"
	_tmp64_ = from_tag;
#line 1858 "../src/Commands.vala"
	_tmp65_ = tag_get_hierarchical_children (_tmp64_);
#line 1858 "../src/Commands.vala"
	from_children = _tmp65_;
#line 16903 "Commands.c"
	{
		gint i = 0;
		GeeList* _tmp66_;
		gint _tmp67_;
		gint _tmp68_;
#line 1859 "../src/Commands.vala"
		_tmp66_ = from_children;
#line 1859 "../src/Commands.vala"
		_tmp67_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1859 "../src/Commands.vala"
		_tmp68_ = _tmp67_;
#line 1859 "../src/Commands.vala"
		i = _tmp68_ - 1;
#line 16917 "Commands.c"
		{
			gboolean _tmp69_ = FALSE;
#line 1859 "../src/Commands.vala"
			_tmp69_ = TRUE;
#line 1859 "../src/Commands.vala"
			while (TRUE) {
#line 16924 "Commands.c"
				GeeList* _tmp71_;
				GeeList* _tmp72_;
				gpointer _tmp73_;
				Tag* _tmp74_;
				SourceProxy* _tmp75_;
				SourceProxy* _tmp76_;
#line 1859 "../src/Commands.vala"
				if (!_tmp69_) {
#line 16933 "Commands.c"
					gint _tmp70_;
#line 1859 "../src/Commands.vala"
					_tmp70_ = i;
#line 1859 "../src/Commands.vala"
					i = _tmp70_ - 1;
#line 16939 "Commands.c"
				}
#line 1859 "../src/Commands.vala"
				_tmp69_ = FALSE;
#line 1859 "../src/Commands.vala"
				if (!(i >= 0)) {
#line 1859 "../src/Commands.vala"
					break;
#line 16947 "Commands.c"
				}
#line 1860 "../src/Commands.vala"
				_tmp71_ = self->priv->src_before_state;
#line 1860 "../src/Commands.vala"
				_tmp72_ = from_children;
#line 1860 "../src/Commands.vala"
				_tmp73_ = gee_list_get (_tmp72_, i);
#line 1860 "../src/Commands.vala"
				_tmp74_ = (Tag*) _tmp73_;
#line 1860 "../src/Commands.vala"
				_tmp75_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, TYPE_PROXYABLE, Proxyable));
#line 1860 "../src/Commands.vala"
				_tmp76_ = _tmp75_;
#line 1860 "../src/Commands.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, GEE_TYPE_COLLECTION, GeeCollection), _tmp76_);
#line 1860 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp76_);
#line 1860 "../src/Commands.vala"
				_g_object_unref0 (_tmp74_);
#line 16967 "Commands.c"
			}
		}
	}
#line 1864 "../src/Commands.vala"
	_tmp77_ = self->priv->to_path_parent_path;
#line 1864 "../src/Commands.vala"
	if (_tmp77_ != NULL) {
#line 16975 "Commands.c"
		GeeList* to_children = NULL;
		const gchar* _tmp78_;
		Tag* _tmp79_;
		Tag* _tmp80_;
		GeeList* _tmp81_;
		GeeList* _tmp82_;
#line 1865 "../src/Commands.vala"
		_tmp78_ = self->priv->to_path_parent_path;
#line 1865 "../src/Commands.vala"
		_tmp79_ = tag_for_path (_tmp78_);
#line 1865 "../src/Commands.vala"
		_tmp80_ = _tmp79_;
#line 1865 "../src/Commands.vala"
		_tmp81_ = tag_get_hierarchical_children (_tmp80_);
#line 1865 "../src/Commands.vala"
		_tmp82_ = _tmp81_;
#line 1865 "../src/Commands.vala"
		_g_object_unref0 (_tmp80_);
#line 1865 "../src/Commands.vala"
		to_children = _tmp82_;
#line 16996 "Commands.c"
		{
			gint i = 0;
			GeeList* _tmp83_;
			gint _tmp84_;
			gint _tmp85_;
#line 1866 "../src/Commands.vala"
			_tmp83_ = to_children;
#line 1866 "../src/Commands.vala"
			_tmp84_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp83_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1866 "../src/Commands.vala"
			_tmp85_ = _tmp84_;
#line 1866 "../src/Commands.vala"
			i = _tmp85_ - 1;
#line 17010 "Commands.c"
			{
				gboolean _tmp86_ = FALSE;
#line 1866 "../src/Commands.vala"
				_tmp86_ = TRUE;
#line 1866 "../src/Commands.vala"
				while (TRUE) {
#line 17017 "Commands.c"
					GeeList* _tmp88_;
					GeeList* _tmp89_;
					gpointer _tmp90_;
					Tag* _tmp91_;
					SourceProxy* _tmp92_;
					SourceProxy* _tmp93_;
#line 1866 "../src/Commands.vala"
					if (!_tmp86_) {
#line 17026 "Commands.c"
						gint _tmp87_;
#line 1866 "../src/Commands.vala"
						_tmp87_ = i;
#line 1866 "../src/Commands.vala"
						i = _tmp87_ - 1;
#line 17032 "Commands.c"
					}
#line 1866 "../src/Commands.vala"
					_tmp86_ = FALSE;
#line 1866 "../src/Commands.vala"
					if (!(i >= 0)) {
#line 1866 "../src/Commands.vala"
						break;
#line 17040 "Commands.c"
					}
#line 1867 "../src/Commands.vala"
					_tmp88_ = self->priv->dest_before_state;
#line 1867 "../src/Commands.vala"
					_tmp89_ = to_children;
#line 1867 "../src/Commands.vala"
					_tmp90_ = gee_list_get (_tmp89_, i);
#line 1867 "../src/Commands.vala"
					_tmp91_ = (Tag*) _tmp90_;
#line 1867 "../src/Commands.vala"
					_tmp92_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, TYPE_PROXYABLE, Proxyable));
#line 1867 "../src/Commands.vala"
					_tmp93_ = _tmp92_;
#line 1867 "../src/Commands.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, GEE_TYPE_COLLECTION, GeeCollection), _tmp93_);
#line 1867 "../src/Commands.vala"
					_source_proxy_unref0 (_tmp93_);
#line 1867 "../src/Commands.vala"
					_g_object_unref0 (_tmp91_);
#line 17060 "Commands.c"
				}
			}
		}
#line 1864 "../src/Commands.vala"
		_g_object_unref0 (to_children);
#line 17066 "Commands.c"
	}
#line 1872 "../src/Commands.vala"
	_tmp94_ = self->priv->to_path_parent_path;
#line 1872 "../src/Commands.vala"
	if (_tmp94_ == NULL) {
#line 17072 "Commands.c"
		GeeList* to_children = NULL;
		const gchar* _tmp95_;
		Tag* _tmp96_;
		Tag* _tmp97_;
		GeeList* _tmp98_;
		GeeList* _tmp99_;
#line 1873 "../src/Commands.vala"
		_tmp95_ = self->priv->to_path;
#line 1873 "../src/Commands.vala"
		_tmp96_ = tag_for_path (_tmp95_);
#line 1873 "../src/Commands.vala"
		_tmp97_ = _tmp96_;
#line 1873 "../src/Commands.vala"
		_tmp98_ = tag_get_hierarchical_children (_tmp97_);
#line 1873 "../src/Commands.vala"
		_tmp99_ = _tmp98_;
#line 1873 "../src/Commands.vala"
		_g_object_unref0 (_tmp97_);
#line 1873 "../src/Commands.vala"
		to_children = _tmp99_;
#line 17093 "Commands.c"
		{
			gint i = 0;
			GeeList* _tmp100_;
			gint _tmp101_;
			gint _tmp102_;
#line 1874 "../src/Commands.vala"
			_tmp100_ = to_children;
#line 1874 "../src/Commands.vala"
			_tmp101_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1874 "../src/Commands.vala"
			_tmp102_ = _tmp101_;
#line 1874 "../src/Commands.vala"
			i = _tmp102_ - 1;
#line 17107 "Commands.c"
			{
				gboolean _tmp103_ = FALSE;
#line 1874 "../src/Commands.vala"
				_tmp103_ = TRUE;
#line 1874 "../src/Commands.vala"
				while (TRUE) {
#line 17114 "Commands.c"
					GeeList* _tmp105_;
					GeeList* _tmp106_;
					gpointer _tmp107_;
					Tag* _tmp108_;
					SourceProxy* _tmp109_;
					SourceProxy* _tmp110_;
#line 1874 "../src/Commands.vala"
					if (!_tmp103_) {
#line 17123 "Commands.c"
						gint _tmp104_;
#line 1874 "../src/Commands.vala"
						_tmp104_ = i;
#line 1874 "../src/Commands.vala"
						i = _tmp104_ - 1;
#line 17129 "Commands.c"
					}
#line 1874 "../src/Commands.vala"
					_tmp103_ = FALSE;
#line 1874 "../src/Commands.vala"
					if (!(i >= 0)) {
#line 1874 "../src/Commands.vala"
						break;
#line 17137 "Commands.c"
					}
#line 1875 "../src/Commands.vala"
					_tmp105_ = self->priv->dest_before_state;
#line 1875 "../src/Commands.vala"
					_tmp106_ = to_children;
#line 1875 "../src/Commands.vala"
					_tmp107_ = gee_list_get (_tmp106_, i);
#line 1875 "../src/Commands.vala"
					_tmp108_ = (Tag*) _tmp107_;
#line 1875 "../src/Commands.vala"
					_tmp109_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, TYPE_PROXYABLE, Proxyable));
#line 1875 "../src/Commands.vala"
					_tmp110_ = _tmp109_;
#line 1875 "../src/Commands.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, GEE_TYPE_COLLECTION, GeeCollection), _tmp110_);
#line 1875 "../src/Commands.vala"
					_source_proxy_unref0 (_tmp110_);
#line 1875 "../src/Commands.vala"
					_g_object_unref0 (_tmp108_);
#line 17157 "Commands.c"
				}
			}
		}
#line 1872 "../src/Commands.vala"
		_g_object_unref0 (to_children);
#line 17163 "Commands.c"
	}
#line 1810 "../src/Commands.vala"
	_g_object_unref0 (from_children);
#line 1810 "../src/Commands.vala"
	_g_object_unref0 (parent_paths);
#line 1810 "../src/Commands.vala"
	_g_object_unref0 (from_tag);
#line 17171 "Commands.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 17194 "Commands.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 17203 "Commands.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 17222 "Commands.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 17226 "Commands.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 17232 "Commands.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 17242 "Commands.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 17250 "Commands.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 17254 "Commands.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 17260 "Commands.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 17270 "Commands.c"
}

static void
reparent_tag_command_restore_before_state (ReparentTagCommand* self)
{
	GeeList* _tmp0_;
	GeeMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	gchar* unwind_target = NULL;
	gchar* _tmp14_;
	const gchar* _tmp83_;
#line 1879 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1880 "../src/Commands.vala"
	_tmp0_ = self->priv->src_before_state;
#line 1880 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "src_before_state != null");
#line 1881 "../src/Commands.vala"
	_tmp1_ = self->priv->existing_dest_child_structure;
#line 1881 "../src/Commands.vala"
	_vala_assert (_tmp1_ != NULL, "existing_dest_child_structure != null");
#line 1884 "../src/Commands.vala"
	_tmp2_ = self->priv->to_path_parent_path;
#line 1884 "../src/Commands.vala"
	if (_tmp2_ != NULL) {
#line 17298 "Commands.c"
		gchar* new_tpp = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		gchar* _tmp9_;
#line 1885 "../src/Commands.vala"
		_tmp3_ = self->priv->to_path_parent_path;
#line 1885 "../src/Commands.vala"
		_tmp4_ = hierarchical_tag_utilities_get_root_path_form (_tmp3_);
#line 1885 "../src/Commands.vala"
		new_tpp = _tmp4_;
#line 1886 "../src/Commands.vala"
		_tmp6_ = new_tpp;
#line 1886 "../src/Commands.vala"
		if (_tmp6_ != NULL) {
#line 17315 "Commands.c"
			const gchar* _tmp7_;
#line 1886 "../src/Commands.vala"
			_tmp7_ = new_tpp;
#line 1886 "../src/Commands.vala"
			_tmp5_ = _tmp7_;
#line 17321 "Commands.c"
		} else {
			const gchar* _tmp8_;
#line 1886 "../src/Commands.vala"
			_tmp8_ = self->priv->to_path_parent_path;
#line 1886 "../src/Commands.vala"
			_tmp5_ = _tmp8_;
#line 17328 "Commands.c"
		}
#line 1886 "../src/Commands.vala"
		_tmp9_ = g_strdup (_tmp5_);
#line 1886 "../src/Commands.vala"
		_g_free0 (self->priv->to_path_parent_path);
#line 1886 "../src/Commands.vala"
		self->priv->to_path_parent_path = _tmp9_;
#line 1884 "../src/Commands.vala"
		_g_free0 (new_tpp);
#line 17338 "Commands.c"
	}
#line 1889 "../src/Commands.vala"
	_tmp11_ = self->priv->to_path_parent_path;
#line 1889 "../src/Commands.vala"
	if (_tmp11_ != NULL) {
#line 17344 "Commands.c"
		const gchar* _tmp12_;
#line 1889 "../src/Commands.vala"
		_tmp12_ = self->priv->to_path_parent_path;
#line 1889 "../src/Commands.vala"
		_tmp10_ = _tmp12_;
#line 17350 "Commands.c"
	} else {
		const gchar* _tmp13_;
#line 1889 "../src/Commands.vala"
		_tmp13_ = self->priv->to_path;
#line 1889 "../src/Commands.vala"
		_tmp10_ = _tmp13_;
#line 17357 "Commands.c"
	}
#line 1889 "../src/Commands.vala"
	_tmp14_ = g_strdup (_tmp10_);
#line 1889 "../src/Commands.vala"
	unwind_target = _tmp14_;
#line 17363 "Commands.c"
	{
		GeeList* _t_list = NULL;
		const gchar* _tmp15_;
		Tag* _tmp16_;
		Tag* _tmp17_;
		GeeList* _tmp18_;
		GeeList* _tmp19_;
		gint _t_size = 0;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _t_index = 0;
#line 1890 "../src/Commands.vala"
		_tmp15_ = unwind_target;
#line 1890 "../src/Commands.vala"
		_tmp16_ = tag_for_path (_tmp15_);
#line 1890 "../src/Commands.vala"
		_tmp17_ = _tmp16_;
#line 1890 "../src/Commands.vala"
		_tmp18_ = tag_get_hierarchical_children (_tmp17_);
#line 1890 "../src/Commands.vala"
		_tmp19_ = _tmp18_;
#line 1890 "../src/Commands.vala"
		_g_object_unref0 (_tmp17_);
#line 1890 "../src/Commands.vala"
		_t_list = _tmp19_;
#line 1890 "../src/Commands.vala"
		_tmp20_ = _t_list;
#line 1890 "../src/Commands.vala"
		_tmp21_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1890 "../src/Commands.vala"
		_tmp22_ = _tmp21_;
#line 1890 "../src/Commands.vala"
		_t_size = _tmp22_;
#line 1890 "../src/Commands.vala"
		_t_index = -1;
#line 1890 "../src/Commands.vala"
		while (TRUE) {
#line 17402 "Commands.c"
			gint _tmp23_;
			gint _tmp24_;
			Tag* t = NULL;
			GeeList* _tmp25_;
			gpointer _tmp26_;
			gchar* child_subpath = NULL;
			Tag* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			const gchar* _tmp33_;
			GeeMap* _tmp36_;
			const gchar* _tmp37_;
#line 1890 "../src/Commands.vala"
			_t_index = _t_index + 1;
#line 1890 "../src/Commands.vala"
			_tmp23_ = _t_index;
#line 1890 "../src/Commands.vala"
			_tmp24_ = _t_size;
#line 1890 "../src/Commands.vala"
			if (!(_tmp23_ < _tmp24_)) {
#line 1890 "../src/Commands.vala"
				break;
#line 17428 "Commands.c"
			}
#line 1890 "../src/Commands.vala"
			_tmp25_ = _t_list;
#line 1890 "../src/Commands.vala"
			_tmp26_ = gee_list_get (_tmp25_, _t_index);
#line 1890 "../src/Commands.vala"
			t = (Tag*) _tmp26_;
#line 1891 "../src/Commands.vala"
			_tmp27_ = t;
#line 1891 "../src/Commands.vala"
			_tmp28_ = tag_get_path (_tmp27_);
#line 1891 "../src/Commands.vala"
			_tmp29_ = _tmp28_;
#line 1891 "../src/Commands.vala"
			_tmp30_ = unwind_target;
#line 1891 "../src/Commands.vala"
			_tmp31_ = string_replace (_tmp29_, _tmp30_, "");
#line 1891 "../src/Commands.vala"
			_tmp32_ = _tmp31_;
#line 1891 "../src/Commands.vala"
			_g_free0 (_tmp29_);
#line 1891 "../src/Commands.vala"
			child_subpath = _tmp32_;
#line 1892 "../src/Commands.vala"
			_tmp33_ = child_subpath;
#line 1892 "../src/Commands.vala"
			if (g_str_has_prefix (_tmp33_, TAG_PATH_SEPARATOR_STRING)) {
#line 17456 "Commands.c"
				const gchar* _tmp34_;
				gchar* _tmp35_;
#line 1893 "../src/Commands.vala"
				_tmp34_ = child_subpath;
#line 1893 "../src/Commands.vala"
				_tmp35_ = string_substring (_tmp34_, (glong) 1, (glong) -1);
#line 1893 "../src/Commands.vala"
				_g_free0 (child_subpath);
#line 1893 "../src/Commands.vala"
				child_subpath = _tmp35_;
#line 17467 "Commands.c"
			}
#line 1895 "../src/Commands.vala"
			_tmp36_ = self->priv->existing_dest_child_structure;
#line 1895 "../src/Commands.vala"
			_tmp37_ = child_subpath;
#line 1895 "../src/Commands.vala"
			if (!gee_map_has_key (_tmp36_, _tmp37_)) {
#line 17475 "Commands.c"
				TagSourceCollection* _tmp38_;
				TagSourceCollection* _tmp39_;
				Tag* _tmp40_;
				Marker* _tmp41_;
				Marker* _tmp42_;
#line 1896 "../src/Commands.vala"
				_tmp38_ = tag_global;
#line 1896 "../src/Commands.vala"
				_tmp39_ = tag_global;
#line 1896 "../src/Commands.vala"
				_tmp40_ = t;
#line 1896 "../src/Commands.vala"
				_tmp41_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_OBJECT, DataObject));
#line 1896 "../src/Commands.vala"
				_tmp42_ = _tmp41_;
#line 1896 "../src/Commands.vala"
				source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp42_, TRUE, NULL, NULL, NULL);
#line 1896 "../src/Commands.vala"
				_g_object_unref0 (_tmp42_);
#line 17495 "Commands.c"
			} else {
				GeeSet* starting_sources = NULL;
				GeeHashSet* _tmp43_;
				GeeSet* _tmp44_;
				Tag* _tmp45_;
				GeeCollection* _tmp46_;
				GeeCollection* _tmp47_;
#line 1898 "../src/Commands.vala"
				_tmp43_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1898 "../src/Commands.vala"
				starting_sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_SET, GeeSet);
#line 1899 "../src/Commands.vala"
				_tmp44_ = starting_sources;
#line 1899 "../src/Commands.vala"
				_tmp45_ = t;
#line 1899 "../src/Commands.vala"
				_tmp46_ = tag_get_sources (_tmp45_);
#line 1899 "../src/Commands.vala"
				_tmp47_ = _tmp46_;
#line 1899 "../src/Commands.vala"
				gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEE_TYPE_COLLECTION, GeeCollection), _tmp47_);
#line 1899 "../src/Commands.vala"
				_g_object_unref0 (_tmp47_);
#line 17519 "Commands.c"
				{
					GeeIterator* _source_it = NULL;
					GeeSet* _tmp48_;
					GeeIterator* _tmp49_;
#line 1900 "../src/Commands.vala"
					_tmp48_ = starting_sources;
#line 1900 "../src/Commands.vala"
					_tmp49_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1900 "../src/Commands.vala"
					_source_it = _tmp49_;
#line 1900 "../src/Commands.vala"
					while (TRUE) {
#line 17532 "Commands.c"
						GeeIterator* _tmp50_;
						MediaSource* source = NULL;
						GeeIterator* _tmp51_;
						gpointer _tmp52_;
						GeeMap* _tmp53_;
						const gchar* _tmp54_;
						gpointer _tmp55_;
						GeeSet* _tmp56_;
						MediaSource* _tmp57_;
						gboolean _tmp58_;
#line 1900 "../src/Commands.vala"
						_tmp50_ = _source_it;
#line 1900 "../src/Commands.vala"
						if (!gee_iterator_next (_tmp50_)) {
#line 1900 "../src/Commands.vala"
							break;
#line 17549 "Commands.c"
						}
#line 1900 "../src/Commands.vala"
						_tmp51_ = _source_it;
#line 1900 "../src/Commands.vala"
						_tmp52_ = gee_iterator_get (_tmp51_);
#line 1900 "../src/Commands.vala"
						source = (MediaSource*) _tmp52_;
#line 1901 "../src/Commands.vala"
						_tmp53_ = self->priv->existing_dest_child_structure;
#line 1901 "../src/Commands.vala"
						_tmp54_ = child_subpath;
#line 1901 "../src/Commands.vala"
						_tmp55_ = gee_map_get (_tmp53_, _tmp54_);
#line 1901 "../src/Commands.vala"
						_tmp56_ = (GeeSet*) _tmp55_;
#line 1901 "../src/Commands.vala"
						_tmp57_ = source;
#line 1901 "../src/Commands.vala"
						_tmp58_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, GEE_TYPE_COLLECTION, GeeCollection), _tmp57_);
#line 1901 "../src/Commands.vala"
						_g_object_unref0 (_tmp56_);
#line 1901 "../src/Commands.vala"
						if (_tmp58_) {
#line 17573 "Commands.c"
							Tag* _tmp59_;
							MediaSource* _tmp60_;
							GeeList* _tmp61_;
							GeeList* _tmp62_;
#line 1902 "../src/Commands.vala"
							_tmp59_ = t;
#line 1902 "../src/Commands.vala"
							_tmp60_ = source;
#line 1902 "../src/Commands.vala"
							_tmp61_ = tag_detach (_tmp59_, _tmp60_);
#line 1902 "../src/Commands.vala"
							_tmp62_ = _tmp61_;
#line 1902 "../src/Commands.vala"
							_g_object_unref0 (_tmp62_);
#line 17588 "Commands.c"
						}
#line 1900 "../src/Commands.vala"
						_g_object_unref0 (source);
#line 17592 "Commands.c"
					}
#line 1900 "../src/Commands.vala"
					_g_object_unref0 (_source_it);
#line 17596 "Commands.c"
				}
#line 1895 "../src/Commands.vala"
				_g_object_unref0 (starting_sources);
#line 17600 "Commands.c"
			}
#line 1890 "../src/Commands.vala"
			_g_free0 (child_subpath);
#line 1890 "../src/Commands.vala"
			_g_object_unref0 (t);
#line 17606 "Commands.c"
		}
#line 1890 "../src/Commands.vala"
		_g_object_unref0 (_t_list);
#line 17610 "Commands.c"
	}
	{
		gint i = 0;
#line 1906 "../src/Commands.vala"
		i = 0;
#line 17616 "Commands.c"
		{
			gboolean _tmp63_ = FALSE;
#line 1906 "../src/Commands.vala"
			_tmp63_ = TRUE;
#line 1906 "../src/Commands.vala"
			while (TRUE) {
#line 17623 "Commands.c"
				GeeList* _tmp65_;
				gint _tmp66_;
				gint _tmp67_;
				GeeList* _tmp68_;
				gpointer _tmp69_;
				SourceProxy* _tmp70_;
				DataSource* _tmp71_;
				DataSource* _tmp72_;
#line 1906 "../src/Commands.vala"
				if (!_tmp63_) {
#line 17634 "Commands.c"
					gint _tmp64_;
#line 1906 "../src/Commands.vala"
					_tmp64_ = i;
#line 1906 "../src/Commands.vala"
					i = _tmp64_ + 1;
#line 17640 "Commands.c"
				}
#line 1906 "../src/Commands.vala"
				_tmp63_ = FALSE;
#line 1906 "../src/Commands.vala"
				_tmp65_ = self->priv->src_before_state;
#line 1906 "../src/Commands.vala"
				_tmp66_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1906 "../src/Commands.vala"
				_tmp67_ = _tmp66_;
#line 1906 "../src/Commands.vala"
				if (!(i < _tmp67_)) {
#line 1906 "../src/Commands.vala"
					break;
#line 17654 "Commands.c"
				}
#line 1907 "../src/Commands.vala"
				_tmp68_ = self->priv->src_before_state;
#line 1907 "../src/Commands.vala"
				_tmp69_ = gee_list_get (_tmp68_, i);
#line 1907 "../src/Commands.vala"
				_tmp70_ = (SourceProxy*) _tmp69_;
#line 1907 "../src/Commands.vala"
				_tmp71_ = source_proxy_get_source (_tmp70_);
#line 1907 "../src/Commands.vala"
				_tmp72_ = _tmp71_;
#line 1907 "../src/Commands.vala"
				_g_object_unref0 (_tmp72_);
#line 1907 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp70_);
#line 17670 "Commands.c"
			}
		}
	}
	{
		gint i = 0;
#line 1909 "../src/Commands.vala"
		i = 0;
#line 17678 "Commands.c"
		{
			gboolean _tmp73_ = FALSE;
#line 1909 "../src/Commands.vala"
			_tmp73_ = TRUE;
#line 1909 "../src/Commands.vala"
			while (TRUE) {
#line 17685 "Commands.c"
				GeeList* _tmp75_;
				gint _tmp76_;
				gint _tmp77_;
				GeeList* _tmp78_;
				gpointer _tmp79_;
				SourceProxy* _tmp80_;
				DataSource* _tmp81_;
				DataSource* _tmp82_;
#line 1909 "../src/Commands.vala"
				if (!_tmp73_) {
#line 17696 "Commands.c"
					gint _tmp74_;
#line 1909 "../src/Commands.vala"
					_tmp74_ = i;
#line 1909 "../src/Commands.vala"
					i = _tmp74_ + 1;
#line 17702 "Commands.c"
				}
#line 1909 "../src/Commands.vala"
				_tmp73_ = FALSE;
#line 1909 "../src/Commands.vala"
				_tmp75_ = self->priv->dest_before_state;
#line 1909 "../src/Commands.vala"
				_tmp76_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp75_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1909 "../src/Commands.vala"
				_tmp77_ = _tmp76_;
#line 1909 "../src/Commands.vala"
				if (!(i < _tmp77_)) {
#line 1909 "../src/Commands.vala"
					break;
#line 17716 "Commands.c"
				}
#line 1910 "../src/Commands.vala"
				_tmp78_ = self->priv->dest_before_state;
#line 1910 "../src/Commands.vala"
				_tmp79_ = gee_list_get (_tmp78_, i);
#line 1910 "../src/Commands.vala"
				_tmp80_ = (SourceProxy*) _tmp79_;
#line 1910 "../src/Commands.vala"
				_tmp81_ = source_proxy_get_source (_tmp80_);
#line 1910 "../src/Commands.vala"
				_tmp82_ = _tmp81_;
#line 1910 "../src/Commands.vala"
				_g_object_unref0 (_tmp82_);
#line 1910 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp80_);
#line 17732 "Commands.c"
			}
		}
	}
#line 1912 "../src/Commands.vala"
	_tmp83_ = self->priv->to_path_parent_path;
#line 1912 "../src/Commands.vala"
	if (_tmp83_ != NULL) {
#line 17740 "Commands.c"
		gchar* new_path = NULL;
		const gchar* _tmp84_;
		gchar* _tmp85_;
		const gchar* _tmp86_ = NULL;
		const gchar* _tmp87_;
		gchar* path = NULL;
		gchar* _tmp90_;
		TagSourceCollection* _tmp91_;
		const gchar* _tmp92_;
		Tag* t = NULL;
		const gchar* _tmp93_;
		Tag* _tmp94_;
		GeeList* kids = NULL;
		Tag* _tmp95_;
		GeeList* _tmp96_;
		const gchar* _tmp111_;
		GeeMap* _tmp112_;
#line 1913 "../src/Commands.vala"
		_tmp84_ = self->priv->to_path_parent_path;
#line 1913 "../src/Commands.vala"
		_tmp85_ = hierarchical_tag_utilities_get_root_path_form (_tmp84_);
#line 1913 "../src/Commands.vala"
		new_path = _tmp85_;
#line 1914 "../src/Commands.vala"
		_tmp87_ = new_path;
#line 1914 "../src/Commands.vala"
		if (_tmp87_ != NULL) {
#line 17768 "Commands.c"
			const gchar* _tmp88_;
#line 1914 "../src/Commands.vala"
			_tmp88_ = new_path;
#line 1914 "../src/Commands.vala"
			_tmp86_ = _tmp88_;
#line 17774 "Commands.c"
		} else {
			const gchar* _tmp89_;
#line 1914 "../src/Commands.vala"
			_tmp89_ = self->priv->to_path_parent_path;
#line 1914 "../src/Commands.vala"
			_tmp86_ = _tmp89_;
#line 17781 "Commands.c"
		}
#line 1914 "../src/Commands.vala"
		_tmp90_ = g_strdup (_tmp86_);
#line 1914 "../src/Commands.vala"
		path = _tmp90_;
#line 1916 "../src/Commands.vala"
		_tmp91_ = tag_global;
#line 1916 "../src/Commands.vala"
		_tmp92_ = path;
#line 1916 "../src/Commands.vala"
		_vala_assert (tag_source_collection_exists (_tmp91_, _tmp92_, FALSE), "Tag.global.exists(path)");
#line 1918 "../src/Commands.vala"
		_tmp93_ = path;
#line 1918 "../src/Commands.vala"
		_tmp94_ = tag_for_path (_tmp93_);
#line 1918 "../src/Commands.vala"
		t = _tmp94_;
#line 1920 "../src/Commands.vala"
		_tmp95_ = t;
#line 1920 "../src/Commands.vala"
		_tmp96_ = tag_get_hierarchical_children (_tmp95_);
#line 1920 "../src/Commands.vala"
		kids = _tmp96_;
#line 17805 "Commands.c"
		{
			GeeList* _kidtag_list = NULL;
			GeeList* _tmp97_;
			gint _kidtag_size = 0;
			GeeList* _tmp98_;
			gint _tmp99_;
			gint _tmp100_;
			gint _kidtag_index = 0;
#line 1921 "../src/Commands.vala"
			_tmp97_ = kids;
#line 1921 "../src/Commands.vala"
			_kidtag_list = _tmp97_;
#line 1921 "../src/Commands.vala"
			_tmp98_ = _kidtag_list;
#line 1921 "../src/Commands.vala"
			_tmp99_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1921 "../src/Commands.vala"
			_tmp100_ = _tmp99_;
#line 1921 "../src/Commands.vala"
			_kidtag_size = _tmp100_;
#line 1921 "../src/Commands.vala"
			_kidtag_index = -1;
#line 1921 "../src/Commands.vala"
			while (TRUE) {
#line 17830 "Commands.c"
				gint _tmp101_;
				gint _tmp102_;
				Tag* kidtag = NULL;
				GeeList* _tmp103_;
				gpointer _tmp104_;
				Tag* _tmp105_;
				Tag* _tmp106_;
				GeeCollection* _tmp107_;
				GeeCollection* _tmp108_;
				GeeMultiMap* _tmp109_;
				GeeMultiMap* _tmp110_;
#line 1921 "../src/Commands.vala"
				_kidtag_index = _kidtag_index + 1;
#line 1921 "../src/Commands.vala"
				_tmp101_ = _kidtag_index;
#line 1921 "../src/Commands.vala"
				_tmp102_ = _kidtag_size;
#line 1921 "../src/Commands.vala"
				if (!(_tmp101_ < _tmp102_)) {
#line 1921 "../src/Commands.vala"
					break;
#line 17852 "Commands.c"
				}
#line 1921 "../src/Commands.vala"
				_tmp103_ = _kidtag_list;
#line 1921 "../src/Commands.vala"
				_tmp104_ = gee_list_get (_tmp103_, _kidtag_index);
#line 1921 "../src/Commands.vala"
				kidtag = (Tag*) _tmp104_;
#line 1922 "../src/Commands.vala"
				_tmp105_ = kidtag;
#line 1922 "../src/Commands.vala"
				_tmp106_ = kidtag;
#line 1922 "../src/Commands.vala"
				_tmp107_ = tag_get_sources (_tmp106_);
#line 1922 "../src/Commands.vala"
				_tmp108_ = _tmp107_;
#line 1922 "../src/Commands.vala"
				_tmp109_ = tag_detach_many (_tmp105_, _tmp108_);
#line 1922 "../src/Commands.vala"
				_tmp110_ = _tmp109_;
#line 1922 "../src/Commands.vala"
				_g_object_unref0 (_tmp110_);
#line 1922 "../src/Commands.vala"
				_g_object_unref0 (_tmp108_);
#line 1921 "../src/Commands.vala"
				_g_object_unref0 (kidtag);
#line 17878 "Commands.c"
			}
		}
#line 1924 "../src/Commands.vala"
		_tmp111_ = path;
#line 1924 "../src/Commands.vala"
		_tmp112_ = self->priv->existing_dest_child_structure;
#line 1924 "../src/Commands.vala"
		reparent_tag_command_restore_child_attachments_at (self, _tmp111_, _tmp112_);
#line 1912 "../src/Commands.vala"
		_g_object_unref0 (kids);
#line 1912 "../src/Commands.vala"
		_g_object_unref0 (t);
#line 1912 "../src/Commands.vala"
		_g_free0 (path);
#line 1912 "../src/Commands.vala"
		_g_free0 (new_path);
#line 17895 "Commands.c"
	} else {
		GeeSet* _tmp113_;
		const gchar* _tmp114_;
		Tag* _tmp115_;
		Tag* _tmp116_;
		const gchar* _tmp117_;
		Tag* _tmp118_;
		Tag* _tmp119_;
		GeeCollection* _tmp120_;
		GeeCollection* _tmp121_;
		GeeMultiMap* _tmp122_;
		GeeMultiMap* _tmp123_;
		const gchar* _tmp124_;
		Tag* _tmp125_;
		Tag* _tmp126_;
		GeeSet* _tmp127_;
		GeeList* kids = NULL;
		const gchar* _tmp128_;
		Tag* _tmp129_;
		Tag* _tmp130_;
		GeeList* _tmp131_;
		GeeList* _tmp132_;
		const gchar* _tmp147_;
		GeeMap* _tmp148_;
#line 1926 "../src/Commands.vala"
		_tmp113_ = self->priv->existing_dest_membership;
#line 1926 "../src/Commands.vala"
		_vala_assert (_tmp113_ != NULL, "existing_dest_membership != null");
#line 1927 "../src/Commands.vala"
		_tmp114_ = self->priv->to_path;
#line 1927 "../src/Commands.vala"
		_tmp115_ = tag_for_path (_tmp114_);
#line 1927 "../src/Commands.vala"
		_tmp116_ = _tmp115_;
#line 1927 "../src/Commands.vala"
		_tmp117_ = self->priv->to_path;
#line 1927 "../src/Commands.vala"
		_tmp118_ = tag_for_path (_tmp117_);
#line 1927 "../src/Commands.vala"
		_tmp119_ = _tmp118_;
#line 1927 "../src/Commands.vala"
		_tmp120_ = tag_get_sources (_tmp119_);
#line 1927 "../src/Commands.vala"
		_tmp121_ = _tmp120_;
#line 1927 "../src/Commands.vala"
		_tmp122_ = tag_detach_many (_tmp116_, _tmp121_);
#line 1927 "../src/Commands.vala"
		_tmp123_ = _tmp122_;
#line 1927 "../src/Commands.vala"
		_g_object_unref0 (_tmp123_);
#line 1927 "../src/Commands.vala"
		_g_object_unref0 (_tmp121_);
#line 1927 "../src/Commands.vala"
		_g_object_unref0 (_tmp119_);
#line 1927 "../src/Commands.vala"
		_g_object_unref0 (_tmp116_);
#line 1928 "../src/Commands.vala"
		_tmp124_ = self->priv->to_path;
#line 1928 "../src/Commands.vala"
		_tmp125_ = tag_for_path (_tmp124_);
#line 1928 "../src/Commands.vala"
		_tmp126_ = _tmp125_;
#line 1928 "../src/Commands.vala"
		_tmp127_ = self->priv->existing_dest_membership;
#line 1928 "../src/Commands.vala"
		tag_attach_many (_tmp126_, G_TYPE_CHECK_INSTANCE_CAST (_tmp127_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1928 "../src/Commands.vala"
		_g_object_unref0 (_tmp126_);
#line 1930 "../src/Commands.vala"
		_tmp128_ = self->priv->to_path;
#line 1930 "../src/Commands.vala"
		_tmp129_ = tag_for_path (_tmp128_);
#line 1930 "../src/Commands.vala"
		_tmp130_ = _tmp129_;
#line 1930 "../src/Commands.vala"
		_tmp131_ = tag_get_hierarchical_children (_tmp130_);
#line 1930 "../src/Commands.vala"
		_tmp132_ = _tmp131_;
#line 1930 "../src/Commands.vala"
		_g_object_unref0 (_tmp130_);
#line 1930 "../src/Commands.vala"
		kids = _tmp132_;
#line 17978 "Commands.c"
		{
			GeeList* _kidtag_list = NULL;
			GeeList* _tmp133_;
			gint _kidtag_size = 0;
			GeeList* _tmp134_;
			gint _tmp135_;
			gint _tmp136_;
			gint _kidtag_index = 0;
#line 1931 "../src/Commands.vala"
			_tmp133_ = kids;
#line 1931 "../src/Commands.vala"
			_kidtag_list = _tmp133_;
#line 1931 "../src/Commands.vala"
			_tmp134_ = _kidtag_list;
#line 1931 "../src/Commands.vala"
			_tmp135_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp134_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1931 "../src/Commands.vala"
			_tmp136_ = _tmp135_;
#line 1931 "../src/Commands.vala"
			_kidtag_size = _tmp136_;
#line 1931 "../src/Commands.vala"
			_kidtag_index = -1;
#line 1931 "../src/Commands.vala"
			while (TRUE) {
#line 18003 "Commands.c"
				gint _tmp137_;
				gint _tmp138_;
				Tag* kidtag = NULL;
				GeeList* _tmp139_;
				gpointer _tmp140_;
				Tag* _tmp141_;
				Tag* _tmp142_;
				GeeCollection* _tmp143_;
				GeeCollection* _tmp144_;
				GeeMultiMap* _tmp145_;
				GeeMultiMap* _tmp146_;
#line 1931 "../src/Commands.vala"
				_kidtag_index = _kidtag_index + 1;
#line 1931 "../src/Commands.vala"
				_tmp137_ = _kidtag_index;
#line 1931 "../src/Commands.vala"
				_tmp138_ = _kidtag_size;
#line 1931 "../src/Commands.vala"
				if (!(_tmp137_ < _tmp138_)) {
#line 1931 "../src/Commands.vala"
					break;
#line 18025 "Commands.c"
				}
#line 1931 "../src/Commands.vala"
				_tmp139_ = _kidtag_list;
#line 1931 "../src/Commands.vala"
				_tmp140_ = gee_list_get (_tmp139_, _kidtag_index);
#line 1931 "../src/Commands.vala"
				kidtag = (Tag*) _tmp140_;
#line 1932 "../src/Commands.vala"
				_tmp141_ = kidtag;
#line 1932 "../src/Commands.vala"
				_tmp142_ = kidtag;
#line 1932 "../src/Commands.vala"
				_tmp143_ = tag_get_sources (_tmp142_);
#line 1932 "../src/Commands.vala"
				_tmp144_ = _tmp143_;
#line 1932 "../src/Commands.vala"
				_tmp145_ = tag_detach_many (_tmp141_, _tmp144_);
#line 1932 "../src/Commands.vala"
				_tmp146_ = _tmp145_;
#line 1932 "../src/Commands.vala"
				_g_object_unref0 (_tmp146_);
#line 1932 "../src/Commands.vala"
				_g_object_unref0 (_tmp144_);
#line 1931 "../src/Commands.vala"
				_g_object_unref0 (kidtag);
#line 18051 "Commands.c"
			}
		}
#line 1934 "../src/Commands.vala"
		_tmp147_ = self->priv->to_path;
#line 1934 "../src/Commands.vala"
		_tmp148_ = self->priv->existing_dest_child_structure;
#line 1934 "../src/Commands.vala"
		reparent_tag_command_restore_child_attachments_at (self, _tmp147_, _tmp148_);
#line 1912 "../src/Commands.vala"
		_g_object_unref0 (kids);
#line 18062 "Commands.c"
	}
#line 1879 "../src/Commands.vala"
	_g_free0 (unwind_target);
#line 18066 "Commands.c"
}

static void
reparent_tag_command_save_after_state (ReparentTagCommand* self)
{
	GeeList* _tmp0_;
	GeeArrayList* _tmp1_;
	TagSourceCollection* _tmp2_;
	const gchar* _tmp3_;
	Tag* to_tag = NULL;
	const gchar* _tmp4_;
	Tag* _tmp5_;
	GeeList* _tmp6_;
	Tag* _tmp7_;
	SourceProxy* _tmp8_;
	SourceProxy* _tmp9_;
	GeeList* to_children = NULL;
	Tag* _tmp10_;
	GeeList* _tmp11_;
#line 1938 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1939 "../src/Commands.vala"
	_tmp0_ = self->priv->after_state;
#line 1939 "../src/Commands.vala"
	_vala_assert (_tmp0_ == NULL, "after_state == null");
#line 1941 "../src/Commands.vala"
	_tmp1_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 1941 "../src/Commands.vala"
	_g_object_unref0 (self->priv->after_state);
#line 1941 "../src/Commands.vala"
	self->priv->after_state = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1944 "../src/Commands.vala"
	_tmp2_ = tag_global;
#line 1944 "../src/Commands.vala"
	_tmp3_ = self->priv->to_path;
#line 1944 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp2_, _tmp3_, FALSE), "Tag.global.exists(to_path)");
#line 1945 "../src/Commands.vala"
	_tmp4_ = self->priv->to_path;
#line 1945 "../src/Commands.vala"
	_tmp5_ = tag_for_path (_tmp4_);
#line 1945 "../src/Commands.vala"
	to_tag = _tmp5_;
#line 1946 "../src/Commands.vala"
	_tmp6_ = self->priv->after_state;
#line 1946 "../src/Commands.vala"
	_tmp7_ = to_tag;
#line 1946 "../src/Commands.vala"
	_tmp8_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PROXYABLE, Proxyable));
#line 1946 "../src/Commands.vala"
	_tmp9_ = _tmp8_;
#line 1946 "../src/Commands.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), _tmp9_);
#line 1946 "../src/Commands.vala"
	_source_proxy_unref0 (_tmp9_);
#line 1949 "../src/Commands.vala"
	_tmp10_ = to_tag;
#line 1949 "../src/Commands.vala"
	_tmp11_ = tag_get_hierarchical_children (_tmp10_);
#line 1949 "../src/Commands.vala"
	to_children = _tmp11_;
#line 18128 "Commands.c"
	{
		gint i = 0;
		GeeList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 1950 "../src/Commands.vala"
		_tmp12_ = to_children;
#line 1950 "../src/Commands.vala"
		_tmp13_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1950 "../src/Commands.vala"
		_tmp14_ = _tmp13_;
#line 1950 "../src/Commands.vala"
		i = _tmp14_ - 1;
#line 18142 "Commands.c"
		{
			gboolean _tmp15_ = FALSE;
#line 1950 "../src/Commands.vala"
			_tmp15_ = TRUE;
#line 1950 "../src/Commands.vala"
			while (TRUE) {
#line 18149 "Commands.c"
				GeeList* _tmp17_;
				GeeList* _tmp18_;
				gpointer _tmp19_;
				Tag* _tmp20_;
				SourceProxy* _tmp21_;
				SourceProxy* _tmp22_;
#line 1950 "../src/Commands.vala"
				if (!_tmp15_) {
#line 18158 "Commands.c"
					gint _tmp16_;
#line 1950 "../src/Commands.vala"
					_tmp16_ = i;
#line 1950 "../src/Commands.vala"
					i = _tmp16_ - 1;
#line 18164 "Commands.c"
				}
#line 1950 "../src/Commands.vala"
				_tmp15_ = FALSE;
#line 1950 "../src/Commands.vala"
				if (!(i >= 0)) {
#line 1950 "../src/Commands.vala"
					break;
#line 18172 "Commands.c"
				}
#line 1951 "../src/Commands.vala"
				_tmp17_ = self->priv->after_state;
#line 1951 "../src/Commands.vala"
				_tmp18_ = to_children;
#line 1951 "../src/Commands.vala"
				_tmp19_ = gee_list_get (_tmp18_, i);
#line 1951 "../src/Commands.vala"
				_tmp20_ = (Tag*) _tmp19_;
#line 1951 "../src/Commands.vala"
				_tmp21_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PROXYABLE, Proxyable));
#line 1951 "../src/Commands.vala"
				_tmp22_ = _tmp21_;
#line 1951 "../src/Commands.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp22_);
#line 1951 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp22_);
#line 1951 "../src/Commands.vala"
				_g_object_unref0 (_tmp20_);
#line 18192 "Commands.c"
			}
		}
	}
#line 1938 "../src/Commands.vala"
	_g_object_unref0 (to_children);
#line 1938 "../src/Commands.vala"
	_g_object_unref0 (to_tag);
#line 18200 "Commands.c"
}

static void
reparent_tag_command_restore_after_state (ReparentTagCommand* self)
{
	GeeList* _tmp0_;
#line 1954 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1955 "../src/Commands.vala"
	_tmp0_ = self->priv->after_state;
#line 1955 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "after_state != null");
#line 18213 "Commands.c"
	{
		gint i = 0;
#line 1957 "../src/Commands.vala"
		i = 0;
#line 18218 "Commands.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1957 "../src/Commands.vala"
			_tmp1_ = TRUE;
#line 1957 "../src/Commands.vala"
			while (TRUE) {
#line 18225 "Commands.c"
				GeeList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				GeeList* _tmp6_;
				gpointer _tmp7_;
				SourceProxy* _tmp8_;
				DataSource* _tmp9_;
				DataSource* _tmp10_;
#line 1957 "../src/Commands.vala"
				if (!_tmp1_) {
#line 18236 "Commands.c"
					gint _tmp2_;
#line 1957 "../src/Commands.vala"
					_tmp2_ = i;
#line 1957 "../src/Commands.vala"
					i = _tmp2_ + 1;
#line 18242 "Commands.c"
				}
#line 1957 "../src/Commands.vala"
				_tmp1_ = FALSE;
#line 1957 "../src/Commands.vala"
				_tmp3_ = self->priv->after_state;
#line 1957 "../src/Commands.vala"
				_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1957 "../src/Commands.vala"
				_tmp5_ = _tmp4_;
#line 1957 "../src/Commands.vala"
				if (!(i < _tmp5_)) {
#line 1957 "../src/Commands.vala"
					break;
#line 18256 "Commands.c"
				}
#line 1958 "../src/Commands.vala"
				_tmp6_ = self->priv->after_state;
#line 1958 "../src/Commands.vala"
				_tmp7_ = gee_list_get (_tmp6_, i);
#line 1958 "../src/Commands.vala"
				_tmp8_ = (SourceProxy*) _tmp7_;
#line 1958 "../src/Commands.vala"
				_tmp9_ = source_proxy_get_source (_tmp8_);
#line 1958 "../src/Commands.vala"
				_tmp10_ = _tmp9_;
#line 1958 "../src/Commands.vala"
				_g_object_unref0 (_tmp10_);
#line 1958 "../src/Commands.vala"
				_source_proxy_unref0 (_tmp8_);
#line 18272 "Commands.c"
			}
		}
	}
}

static void
reparent_tag_command_prepare_parent (ReparentTagCommand* self,
                                     const gchar* path)
{
	Tag* new_parent = NULL;
	Tag* _tmp22_;
#line 1961 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1961 "../src/Commands.vala"
	g_return_if_fail (path != NULL);
#line 1963 "../src/Commands.vala"
	new_parent = NULL;
#line 1964 "../src/Commands.vala"
	if (g_str_has_prefix (path, TAG_PATH_SEPARATOR_STRING)) {
#line 18292 "Commands.c"
		GeeList* parent_paths = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 1965 "../src/Commands.vala"
		_tmp0_ = hierarchical_tag_utilities_enumerate_parent_paths (path);
#line 1965 "../src/Commands.vala"
		parent_paths = _tmp0_;
#line 1966 "../src/Commands.vala"
		_tmp1_ = parent_paths;
#line 1966 "../src/Commands.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1966 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 1966 "../src/Commands.vala"
		if (_tmp3_ > 0) {
#line 18310 "Commands.c"
			gchar* immediate_parent_path = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gpointer _tmp8_;
			TagSourceCollection* _tmp9_;
			const gchar* _tmp10_;
#line 1967 "../src/Commands.vala"
			_tmp4_ = parent_paths;
#line 1967 "../src/Commands.vala"
			_tmp5_ = parent_paths;
#line 1967 "../src/Commands.vala"
			_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1967 "../src/Commands.vala"
			_tmp7_ = _tmp6_;
#line 1967 "../src/Commands.vala"
			_tmp8_ = gee_list_get (_tmp4_, _tmp7_ - 1);
#line 1967 "../src/Commands.vala"
			immediate_parent_path = (gchar*) _tmp8_;
#line 1968 "../src/Commands.vala"
			_tmp9_ = tag_global;
#line 1968 "../src/Commands.vala"
			_tmp10_ = immediate_parent_path;
#line 1968 "../src/Commands.vala"
			if (tag_source_collection_exists (_tmp9_, _tmp10_, FALSE)) {
#line 18337 "Commands.c"
				const gchar* _tmp11_;
				Tag* _tmp12_;
#line 1969 "../src/Commands.vala"
				_tmp11_ = immediate_parent_path;
#line 1969 "../src/Commands.vala"
				_tmp12_ = tag_for_path (_tmp11_);
#line 1969 "../src/Commands.vala"
				_g_object_unref0 (new_parent);
#line 1969 "../src/Commands.vala"
				new_parent = _tmp12_;
#line 18348 "Commands.c"
			} else {
				TagSourceCollection* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gboolean _tmp17_;
#line 1970 "../src/Commands.vala"
				_tmp13_ = tag_global;
#line 1970 "../src/Commands.vala"
				_tmp14_ = immediate_parent_path;
#line 1970 "../src/Commands.vala"
				_tmp15_ = string_substring (_tmp14_, (glong) 1, (glong) -1);
#line 1970 "../src/Commands.vala"
				_tmp16_ = _tmp15_;
#line 1970 "../src/Commands.vala"
				_tmp17_ = tag_source_collection_exists (_tmp13_, _tmp16_, FALSE);
#line 1970 "../src/Commands.vala"
				_g_free0 (_tmp16_);
#line 1970 "../src/Commands.vala"
				if (_tmp17_) {
#line 18369 "Commands.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					Tag* _tmp21_;
#line 1971 "../src/Commands.vala"
					_tmp18_ = immediate_parent_path;
#line 1971 "../src/Commands.vala"
					_tmp19_ = string_substring (_tmp18_, (glong) 1, (glong) -1);
#line 1971 "../src/Commands.vala"
					_tmp20_ = _tmp19_;
#line 1971 "../src/Commands.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 1971 "../src/Commands.vala"
					_g_object_unref0 (new_parent);
#line 1971 "../src/Commands.vala"
					new_parent = _tmp21_;
#line 1971 "../src/Commands.vala"
					_g_free0 (_tmp20_);
#line 18388 "Commands.c"
				} else {
#line 1973 "../src/Commands.vala"
					g_assert_not_reached ();
#line 18392 "Commands.c"
				}
			}
#line 1966 "../src/Commands.vala"
			_g_free0 (immediate_parent_path);
#line 18397 "Commands.c"
		}
#line 1964 "../src/Commands.vala"
		_g_object_unref0 (parent_paths);
#line 18401 "Commands.c"
	}
#line 1976 "../src/Commands.vala"
	_tmp22_ = new_parent;
#line 1976 "../src/Commands.vala"
	if (_tmp22_ != NULL) {
#line 18407 "Commands.c"
		Tag* _tmp23_;
#line 1977 "../src/Commands.vala"
		_tmp23_ = new_parent;
#line 1977 "../src/Commands.vala"
		tag_promote (_tmp23_);
#line 18413 "Commands.c"
	}
#line 1961 "../src/Commands.vala"
	_g_object_unref0 (new_parent);
#line 18417 "Commands.c"
}

static void
reparent_tag_command_do_source_parent_detachments (ReparentTagCommand* self)
{
	TagSourceCollection* _tmp0_;
	const gchar* _tmp1_;
	Tag* from_tag = NULL;
	const gchar* _tmp2_;
	Tag* _tmp3_;
	GeeMap* _tmp4_;
#line 1980 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 1981 "../src/Commands.vala"
	_tmp0_ = tag_global;
#line 1981 "../src/Commands.vala"
	_tmp1_ = self->priv->from_path;
#line 1981 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp0_, _tmp1_, FALSE), "Tag.global.exists(from_path)");
#line 1982 "../src/Commands.vala"
	_tmp2_ = self->priv->from_path;
#line 1982 "../src/Commands.vala"
	_tmp3_ = tag_for_path (_tmp2_);
#line 1982 "../src/Commands.vala"
	from_tag = _tmp3_;
#line 1985 "../src/Commands.vala"
	_tmp4_ = self->priv->src_parent_detachments;
#line 1985 "../src/Commands.vala"
	if (_tmp4_ == NULL) {
#line 18447 "Commands.c"
		GeeHashMap* _tmp5_;
#line 1986 "../src/Commands.vala"
		_tmp5_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1986 "../src/Commands.vala"
		_g_object_unref0 (self->priv->src_parent_detachments);
#line 1986 "../src/Commands.vala"
		self->priv->src_parent_detachments = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_MAP, GeeMap);
#line 18455 "Commands.c"
		{
			GeeIterator* _source_it = NULL;
			Tag* _tmp6_;
			GeeCollection* _tmp7_;
			GeeCollection* _tmp8_;
			GeeIterator* _tmp9_;
			GeeIterator* _tmp10_;
#line 1987 "../src/Commands.vala"
			_tmp6_ = from_tag;
#line 1987 "../src/Commands.vala"
			_tmp7_ = tag_get_sources (_tmp6_);
#line 1987 "../src/Commands.vala"
			_tmp8_ = _tmp7_;
#line 1987 "../src/Commands.vala"
			_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1987 "../src/Commands.vala"
			_tmp10_ = _tmp9_;
#line 1987 "../src/Commands.vala"
			_g_object_unref0 (_tmp8_);
#line 1987 "../src/Commands.vala"
			_source_it = _tmp10_;
#line 1987 "../src/Commands.vala"
			while (TRUE) {
#line 18479 "Commands.c"
				GeeIterator* _tmp11_;
				MediaSource* source = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				Tag* current_parent = NULL;
				Tag* _tmp14_;
				Tag* _tmp15_;
				gint running_attach_count = 0;
				Tag* _tmp16_;
				MediaSource* _tmp17_;
#line 1987 "../src/Commands.vala"
				_tmp11_ = _source_it;
#line 1987 "../src/Commands.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 1987 "../src/Commands.vala"
					break;
#line 18496 "Commands.c"
				}
#line 1987 "../src/Commands.vala"
				_tmp12_ = _source_it;
#line 1987 "../src/Commands.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 1987 "../src/Commands.vala"
				source = (MediaSource*) _tmp13_;
#line 1988 "../src/Commands.vala"
				_tmp14_ = from_tag;
#line 1988 "../src/Commands.vala"
				_tmp15_ = tag_get_hierarchical_parent (_tmp14_);
#line 1988 "../src/Commands.vala"
				current_parent = _tmp15_;
#line 1989 "../src/Commands.vala"
				_tmp16_ = from_tag;
#line 1989 "../src/Commands.vala"
				_tmp17_ = source;
#line 1989 "../src/Commands.vala"
				running_attach_count = tag_get_attachment_count (_tmp16_, _tmp17_) + 1;
#line 1990 "../src/Commands.vala"
				while (TRUE) {
#line 18518 "Commands.c"
					Tag* _tmp18_;
					gchar* current_parent_path = NULL;
					Tag* _tmp19_;
					gchar* _tmp20_;
					GeeMap* _tmp21_;
					const gchar* _tmp22_;
					gint curr_parent_attach_count = 0;
					Tag* _tmp27_;
					MediaSource* _tmp28_;
					gint _tmp34_;
					Tag* _tmp35_;
					Tag* _tmp36_;
#line 1990 "../src/Commands.vala"
					_tmp18_ = current_parent;
#line 1990 "../src/Commands.vala"
					if (!(_tmp18_ != NULL)) {
#line 1990 "../src/Commands.vala"
						break;
#line 18537 "Commands.c"
					}
#line 1991 "../src/Commands.vala"
					_tmp19_ = current_parent;
#line 1991 "../src/Commands.vala"
					_tmp20_ = tag_get_path (_tmp19_);
#line 1991 "../src/Commands.vala"
					current_parent_path = _tmp20_;
#line 1992 "../src/Commands.vala"
					_tmp21_ = self->priv->src_parent_detachments;
#line 1992 "../src/Commands.vala"
					_tmp22_ = current_parent_path;
#line 1992 "../src/Commands.vala"
					if (!gee_map_has_key (_tmp21_, _tmp22_)) {
#line 18551 "Commands.c"
						GeeMap* _tmp23_;
						const gchar* _tmp24_;
						GeeHashSet* _tmp25_;
						GeeHashSet* _tmp26_;
#line 1993 "../src/Commands.vala"
						_tmp23_ = self->priv->src_parent_detachments;
#line 1993 "../src/Commands.vala"
						_tmp24_ = current_parent_path;
#line 1993 "../src/Commands.vala"
						_tmp25_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1993 "../src/Commands.vala"
						_tmp26_ = _tmp25_;
#line 1993 "../src/Commands.vala"
						gee_map_set (_tmp23_, _tmp24_, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_SET, GeeSet));
#line 1993 "../src/Commands.vala"
						_g_object_unref0 (_tmp26_);
#line 18568 "Commands.c"
					}
#line 1995 "../src/Commands.vala"
					_tmp27_ = current_parent;
#line 1995 "../src/Commands.vala"
					_tmp28_ = source;
#line 1995 "../src/Commands.vala"
					curr_parent_attach_count = tag_get_attachment_count (_tmp27_, _tmp28_);
#line 1997 "../src/Commands.vala"
					_vala_assert (curr_parent_attach_count >= running_attach_count, "curr_parent_attach_count >= running_attach_count");
#line 2001 "../src/Commands.vala"
					if (curr_parent_attach_count == running_attach_count) {
#line 18580 "Commands.c"
						GeeMap* _tmp29_;
						const gchar* _tmp30_;
						gpointer _tmp31_;
						GeeSet* _tmp32_;
						MediaSource* _tmp33_;
#line 2002 "../src/Commands.vala"
						_tmp29_ = self->priv->src_parent_detachments;
#line 2002 "../src/Commands.vala"
						_tmp30_ = current_parent_path;
#line 2002 "../src/Commands.vala"
						_tmp31_ = gee_map_get (_tmp29_, _tmp30_);
#line 2002 "../src/Commands.vala"
						_tmp32_ = (GeeSet*) _tmp31_;
#line 2002 "../src/Commands.vala"
						_tmp33_ = source;
#line 2002 "../src/Commands.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_COLLECTION, GeeCollection), _tmp33_);
#line 2002 "../src/Commands.vala"
						_g_object_unref0 (_tmp32_);
#line 18600 "Commands.c"
					}
#line 2004 "../src/Commands.vala"
					_tmp34_ = running_attach_count;
#line 2004 "../src/Commands.vala"
					running_attach_count = _tmp34_ + 1;
#line 2005 "../src/Commands.vala"
					_tmp35_ = current_parent;
#line 2005 "../src/Commands.vala"
					_tmp36_ = tag_get_hierarchical_parent (_tmp35_);
#line 2005 "../src/Commands.vala"
					_g_object_unref0 (current_parent);
#line 2005 "../src/Commands.vala"
					current_parent = _tmp36_;
#line 1990 "../src/Commands.vala"
					_g_free0 (current_parent_path);
#line 18616 "Commands.c"
				}
#line 1987 "../src/Commands.vala"
				_g_object_unref0 (current_parent);
#line 1987 "../src/Commands.vala"
				_g_object_unref0 (source);
#line 18622 "Commands.c"
			}
#line 1987 "../src/Commands.vala"
			_g_object_unref0 (_source_it);
#line 18626 "Commands.c"
		}
	}
	{
		GeeIterator* _p_it = NULL;
		GeeMap* _tmp37_;
		GeeSet* _tmp38_;
		GeeSet* _tmp39_;
		GeeSet* _tmp40_;
		GeeIterator* _tmp41_;
		GeeIterator* _tmp42_;
#line 2011 "../src/Commands.vala"
		_tmp37_ = self->priv->src_parent_detachments;
#line 2011 "../src/Commands.vala"
		_tmp38_ = gee_map_get_keys (_tmp37_);
#line 2011 "../src/Commands.vala"
		_tmp39_ = _tmp38_;
#line 2011 "../src/Commands.vala"
		_tmp40_ = _tmp39_;
#line 2011 "../src/Commands.vala"
		_tmp41_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2011 "../src/Commands.vala"
		_tmp42_ = _tmp41_;
#line 2011 "../src/Commands.vala"
		_g_object_unref0 (_tmp40_);
#line 2011 "../src/Commands.vala"
		_p_it = _tmp42_;
#line 2011 "../src/Commands.vala"
		while (TRUE) {
#line 18655 "Commands.c"
			GeeIterator* _tmp43_;
			gchar* p = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
#line 2011 "../src/Commands.vala"
			_tmp43_ = _p_it;
#line 2011 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp43_)) {
#line 2011 "../src/Commands.vala"
				break;
#line 18666 "Commands.c"
			}
#line 2011 "../src/Commands.vala"
			_tmp44_ = _p_it;
#line 2011 "../src/Commands.vala"
			_tmp45_ = gee_iterator_get (_tmp44_);
#line 2011 "../src/Commands.vala"
			p = (gchar*) _tmp45_;
#line 18674 "Commands.c"
			{
				GeeIterator* _s_it = NULL;
				GeeMap* _tmp46_;
				const gchar* _tmp47_;
				gpointer _tmp48_;
				GeeSet* _tmp49_;
				GeeIterator* _tmp50_;
				GeeIterator* _tmp51_;
#line 2012 "../src/Commands.vala"
				_tmp46_ = self->priv->src_parent_detachments;
#line 2012 "../src/Commands.vala"
				_tmp47_ = p;
#line 2012 "../src/Commands.vala"
				_tmp48_ = gee_map_get (_tmp46_, _tmp47_);
#line 2012 "../src/Commands.vala"
				_tmp49_ = (GeeSet*) _tmp48_;
#line 2012 "../src/Commands.vala"
				_tmp50_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2012 "../src/Commands.vala"
				_tmp51_ = _tmp50_;
#line 2012 "../src/Commands.vala"
				_g_object_unref0 (_tmp49_);
#line 2012 "../src/Commands.vala"
				_s_it = _tmp51_;
#line 2012 "../src/Commands.vala"
				while (TRUE) {
#line 18701 "Commands.c"
					GeeIterator* _tmp52_;
					MediaSource* s = NULL;
					GeeIterator* _tmp53_;
					gpointer _tmp54_;
					const gchar* _tmp55_;
					Tag* _tmp56_;
					Tag* _tmp57_;
					MediaSource* _tmp58_;
					GeeList* _tmp59_;
					GeeList* _tmp60_;
#line 2012 "../src/Commands.vala"
					_tmp52_ = _s_it;
#line 2012 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp52_)) {
#line 2012 "../src/Commands.vala"
						break;
#line 18718 "Commands.c"
					}
#line 2012 "../src/Commands.vala"
					_tmp53_ = _s_it;
#line 2012 "../src/Commands.vala"
					_tmp54_ = gee_iterator_get (_tmp53_);
#line 2012 "../src/Commands.vala"
					s = (MediaSource*) _tmp54_;
#line 2013 "../src/Commands.vala"
					_tmp55_ = p;
#line 2013 "../src/Commands.vala"
					_tmp56_ = tag_for_path (_tmp55_);
#line 2013 "../src/Commands.vala"
					_tmp57_ = _tmp56_;
#line 2013 "../src/Commands.vala"
					_tmp58_ = s;
#line 2013 "../src/Commands.vala"
					_tmp59_ = tag_detach (_tmp57_, _tmp58_);
#line 2013 "../src/Commands.vala"
					_tmp60_ = _tmp59_;
#line 2013 "../src/Commands.vala"
					_g_object_unref0 (_tmp60_);
#line 2013 "../src/Commands.vala"
					_g_object_unref0 (_tmp57_);
#line 2012 "../src/Commands.vala"
					_g_object_unref0 (s);
#line 18744 "Commands.c"
				}
#line 2012 "../src/Commands.vala"
				_g_object_unref0 (_s_it);
#line 18748 "Commands.c"
			}
#line 2011 "../src/Commands.vala"
			_g_free0 (p);
#line 18752 "Commands.c"
		}
#line 2011 "../src/Commands.vala"
		_g_object_unref0 (_p_it);
#line 18756 "Commands.c"
	}
#line 1980 "../src/Commands.vala"
	_g_object_unref0 (from_tag);
#line 18760 "Commands.c"
}

static void
reparent_tag_command_do_source_parent_reattachments (ReparentTagCommand* self)
{
	GeeMap* _tmp0_;
#line 2016 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 2017 "../src/Commands.vala"
	_tmp0_ = self->priv->src_parent_detachments;
#line 2017 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "src_parent_detachments != null");
#line 18773 "Commands.c"
	{
		GeeIterator* _p_it = NULL;
		GeeMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 2019 "../src/Commands.vala"
		_tmp1_ = self->priv->src_parent_detachments;
#line 2019 "../src/Commands.vala"
		_tmp2_ = gee_map_get_keys (_tmp1_);
#line 2019 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2019 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2019 "../src/Commands.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2019 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2019 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 2019 "../src/Commands.vala"
		_p_it = _tmp6_;
#line 2019 "../src/Commands.vala"
		while (TRUE) {
#line 18800 "Commands.c"
			GeeIterator* _tmp7_;
			gchar* p = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
#line 2019 "../src/Commands.vala"
			_tmp7_ = _p_it;
#line 2019 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 2019 "../src/Commands.vala"
				break;
#line 18811 "Commands.c"
			}
#line 2019 "../src/Commands.vala"
			_tmp8_ = _p_it;
#line 2019 "../src/Commands.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 2019 "../src/Commands.vala"
			p = (gchar*) _tmp9_;
#line 18819 "Commands.c"
			{
				GeeIterator* _s_it = NULL;
				GeeMap* _tmp10_;
				const gchar* _tmp11_;
				gpointer _tmp12_;
				GeeSet* _tmp13_;
				GeeIterator* _tmp14_;
				GeeIterator* _tmp15_;
#line 2020 "../src/Commands.vala"
				_tmp10_ = self->priv->src_parent_detachments;
#line 2020 "../src/Commands.vala"
				_tmp11_ = p;
#line 2020 "../src/Commands.vala"
				_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 2020 "../src/Commands.vala"
				_tmp13_ = (GeeSet*) _tmp12_;
#line 2020 "../src/Commands.vala"
				_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2020 "../src/Commands.vala"
				_tmp15_ = _tmp14_;
#line 2020 "../src/Commands.vala"
				_g_object_unref0 (_tmp13_);
#line 2020 "../src/Commands.vala"
				_s_it = _tmp15_;
#line 2020 "../src/Commands.vala"
				while (TRUE) {
#line 18846 "Commands.c"
					GeeIterator* _tmp16_;
					MediaSource* s = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					const gchar* _tmp19_;
					Tag* _tmp20_;
					Tag* _tmp21_;
					MediaSource* _tmp22_;
#line 2020 "../src/Commands.vala"
					_tmp16_ = _s_it;
#line 2020 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 2020 "../src/Commands.vala"
						break;
#line 18861 "Commands.c"
					}
#line 2020 "../src/Commands.vala"
					_tmp17_ = _s_it;
#line 2020 "../src/Commands.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 2020 "../src/Commands.vala"
					s = (MediaSource*) _tmp18_;
#line 2021 "../src/Commands.vala"
					_tmp19_ = p;
#line 2021 "../src/Commands.vala"
					_tmp20_ = tag_for_path (_tmp19_);
#line 2021 "../src/Commands.vala"
					_tmp21_ = _tmp20_;
#line 2021 "../src/Commands.vala"
					_tmp22_ = s;
#line 2021 "../src/Commands.vala"
					tag_attach (_tmp21_, _tmp22_);
#line 2021 "../src/Commands.vala"
					_g_object_unref0 (_tmp21_);
#line 2020 "../src/Commands.vala"
					_g_object_unref0 (s);
#line 18883 "Commands.c"
				}
#line 2020 "../src/Commands.vala"
				_g_object_unref0 (_s_it);
#line 18887 "Commands.c"
			}
#line 2019 "../src/Commands.vala"
			_g_free0 (p);
#line 18891 "Commands.c"
		}
#line 2019 "../src/Commands.vala"
		_g_object_unref0 (_p_it);
#line 18895 "Commands.c"
	}
}

static void
reparent_tag_command_do_destination_parent_detachments (ReparentTagCommand* self)
{
	GeeMap* _tmp0_;
#line 2024 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 2025 "../src/Commands.vala"
	_tmp0_ = self->priv->dest_parent_attachments;
#line 2025 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "dest_parent_attachments != null");
#line 18909 "Commands.c"
	{
		GeeIterator* _p_it = NULL;
		GeeMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 2027 "../src/Commands.vala"
		_tmp1_ = self->priv->dest_parent_attachments;
#line 2027 "../src/Commands.vala"
		_tmp2_ = gee_map_get_keys (_tmp1_);
#line 2027 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2027 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2027 "../src/Commands.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2027 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2027 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 2027 "../src/Commands.vala"
		_p_it = _tmp6_;
#line 2027 "../src/Commands.vala"
		while (TRUE) {
#line 18936 "Commands.c"
			GeeIterator* _tmp7_;
			gchar* p = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
#line 2027 "../src/Commands.vala"
			_tmp7_ = _p_it;
#line 2027 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 2027 "../src/Commands.vala"
				break;
#line 18947 "Commands.c"
			}
#line 2027 "../src/Commands.vala"
			_tmp8_ = _p_it;
#line 2027 "../src/Commands.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 2027 "../src/Commands.vala"
			p = (gchar*) _tmp9_;
#line 18955 "Commands.c"
			{
				GeeIterator* _s_it = NULL;
				GeeMap* _tmp10_;
				const gchar* _tmp11_;
				gpointer _tmp12_;
				GeeSet* _tmp13_;
				GeeIterator* _tmp14_;
				GeeIterator* _tmp15_;
#line 2028 "../src/Commands.vala"
				_tmp10_ = self->priv->dest_parent_attachments;
#line 2028 "../src/Commands.vala"
				_tmp11_ = p;
#line 2028 "../src/Commands.vala"
				_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 2028 "../src/Commands.vala"
				_tmp13_ = (GeeSet*) _tmp12_;
#line 2028 "../src/Commands.vala"
				_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2028 "../src/Commands.vala"
				_tmp15_ = _tmp14_;
#line 2028 "../src/Commands.vala"
				_g_object_unref0 (_tmp13_);
#line 2028 "../src/Commands.vala"
				_s_it = _tmp15_;
#line 2028 "../src/Commands.vala"
				while (TRUE) {
#line 18982 "Commands.c"
					GeeIterator* _tmp16_;
					MediaSource* s = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					const gchar* _tmp19_;
					Tag* _tmp20_;
					Tag* _tmp21_;
					MediaSource* _tmp22_;
					GeeList* _tmp23_;
					GeeList* _tmp24_;
#line 2028 "../src/Commands.vala"
					_tmp16_ = _s_it;
#line 2028 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 2028 "../src/Commands.vala"
						break;
#line 18999 "Commands.c"
					}
#line 2028 "../src/Commands.vala"
					_tmp17_ = _s_it;
#line 2028 "../src/Commands.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 2028 "../src/Commands.vala"
					s = (MediaSource*) _tmp18_;
#line 2029 "../src/Commands.vala"
					_tmp19_ = p;
#line 2029 "../src/Commands.vala"
					_tmp20_ = tag_for_path (_tmp19_);
#line 2029 "../src/Commands.vala"
					_tmp21_ = _tmp20_;
#line 2029 "../src/Commands.vala"
					_tmp22_ = s;
#line 2029 "../src/Commands.vala"
					_tmp23_ = tag_detach (_tmp21_, _tmp22_);
#line 2029 "../src/Commands.vala"
					_tmp24_ = _tmp23_;
#line 2029 "../src/Commands.vala"
					_g_object_unref0 (_tmp24_);
#line 2029 "../src/Commands.vala"
					_g_object_unref0 (_tmp21_);
#line 2028 "../src/Commands.vala"
					_g_object_unref0 (s);
#line 19025 "Commands.c"
				}
#line 2028 "../src/Commands.vala"
				_g_object_unref0 (_s_it);
#line 19029 "Commands.c"
			}
#line 2027 "../src/Commands.vala"
			_g_free0 (p);
#line 19033 "Commands.c"
		}
#line 2027 "../src/Commands.vala"
		_g_object_unref0 (_p_it);
#line 19037 "Commands.c"
	}
}

static void
reparent_tag_command_do_destination_parent_reattachments (ReparentTagCommand* self)
{
	GeeMap* _tmp0_;
#line 2032 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 2033 "../src/Commands.vala"
	_tmp0_ = self->priv->dest_parent_attachments;
#line 2033 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "dest_parent_attachments != null");
#line 19051 "Commands.c"
	{
		GeeIterator* _p_it = NULL;
		GeeMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 2035 "../src/Commands.vala"
		_tmp1_ = self->priv->dest_parent_attachments;
#line 2035 "../src/Commands.vala"
		_tmp2_ = gee_map_get_keys (_tmp1_);
#line 2035 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2035 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2035 "../src/Commands.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2035 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2035 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 2035 "../src/Commands.vala"
		_p_it = _tmp6_;
#line 2035 "../src/Commands.vala"
		while (TRUE) {
#line 19078 "Commands.c"
			GeeIterator* _tmp7_;
			gchar* p = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
#line 2035 "../src/Commands.vala"
			_tmp7_ = _p_it;
#line 2035 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 2035 "../src/Commands.vala"
				break;
#line 19089 "Commands.c"
			}
#line 2035 "../src/Commands.vala"
			_tmp8_ = _p_it;
#line 2035 "../src/Commands.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 2035 "../src/Commands.vala"
			p = (gchar*) _tmp9_;
#line 19097 "Commands.c"
			{
				GeeIterator* _s_it = NULL;
				GeeMap* _tmp10_;
				const gchar* _tmp11_;
				gpointer _tmp12_;
				GeeSet* _tmp13_;
				GeeIterator* _tmp14_;
				GeeIterator* _tmp15_;
#line 2036 "../src/Commands.vala"
				_tmp10_ = self->priv->dest_parent_attachments;
#line 2036 "../src/Commands.vala"
				_tmp11_ = p;
#line 2036 "../src/Commands.vala"
				_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 2036 "../src/Commands.vala"
				_tmp13_ = (GeeSet*) _tmp12_;
#line 2036 "../src/Commands.vala"
				_tmp14_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2036 "../src/Commands.vala"
				_tmp15_ = _tmp14_;
#line 2036 "../src/Commands.vala"
				_g_object_unref0 (_tmp13_);
#line 2036 "../src/Commands.vala"
				_s_it = _tmp15_;
#line 2036 "../src/Commands.vala"
				while (TRUE) {
#line 19124 "Commands.c"
					GeeIterator* _tmp16_;
					MediaSource* s = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					const gchar* _tmp19_;
					Tag* _tmp20_;
					Tag* _tmp21_;
					MediaSource* _tmp22_;
#line 2036 "../src/Commands.vala"
					_tmp16_ = _s_it;
#line 2036 "../src/Commands.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 2036 "../src/Commands.vala"
						break;
#line 19139 "Commands.c"
					}
#line 2036 "../src/Commands.vala"
					_tmp17_ = _s_it;
#line 2036 "../src/Commands.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 2036 "../src/Commands.vala"
					s = (MediaSource*) _tmp18_;
#line 2037 "../src/Commands.vala"
					_tmp19_ = p;
#line 2037 "../src/Commands.vala"
					_tmp20_ = tag_for_path (_tmp19_);
#line 2037 "../src/Commands.vala"
					_tmp21_ = _tmp20_;
#line 2037 "../src/Commands.vala"
					_tmp22_ = s;
#line 2037 "../src/Commands.vala"
					tag_attach (_tmp21_, _tmp22_);
#line 2037 "../src/Commands.vala"
					_g_object_unref0 (_tmp21_);
#line 2036 "../src/Commands.vala"
					_g_object_unref0 (s);
#line 19161 "Commands.c"
				}
#line 2036 "../src/Commands.vala"
				_g_object_unref0 (_s_it);
#line 19165 "Commands.c"
			}
#line 2035 "../src/Commands.vala"
			_g_free0 (p);
#line 19169 "Commands.c"
		}
#line 2035 "../src/Commands.vala"
		_g_object_unref0 (_p_it);
#line 19173 "Commands.c"
	}
}

static void
reparent_tag_command_copy_subtree (ReparentTagCommand* self,
                                   const gchar* from,
                                   const gchar* to)
{
	TagSourceCollection* _tmp0_;
	Tag* from_tag = NULL;
	Tag* _tmp1_;
	Tag* to_tag = NULL;
	Tag* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeList* from_children = NULL;
	Tag* _tmp42_;
	GeeList* _tmp43_;
#line 2040 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 2040 "../src/Commands.vala"
	g_return_if_fail (from != NULL);
#line 2040 "../src/Commands.vala"
	g_return_if_fail (to != NULL);
#line 2041 "../src/Commands.vala"
	_tmp0_ = tag_global;
#line 2041 "../src/Commands.vala"
	_vala_assert (tag_source_collection_exists (_tmp0_, from, FALSE), "Tag.global.exists(from)");
#line 2042 "../src/Commands.vala"
	_tmp1_ = tag_for_path (from);
#line 2042 "../src/Commands.vala"
	from_tag = _tmp1_;
#line 2045 "../src/Commands.vala"
	_tmp2_ = tag_for_path (to);
#line 2045 "../src/Commands.vala"
	to_tag = _tmp2_;
#line 2049 "../src/Commands.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2049 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dest_parent_attachments);
#line 2049 "../src/Commands.vala"
	self->priv->dest_parent_attachments = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MAP, GeeMap);
#line 19215 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		Tag* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 2050 "../src/Commands.vala"
		_tmp4_ = from_tag;
#line 2050 "../src/Commands.vala"
		_tmp5_ = tag_get_sources (_tmp4_);
#line 2050 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2050 "../src/Commands.vala"
		_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2050 "../src/Commands.vala"
		_tmp8_ = _tmp7_;
#line 2050 "../src/Commands.vala"
		_g_object_unref0 (_tmp6_);
#line 2050 "../src/Commands.vala"
		_source_it = _tmp8_;
#line 2050 "../src/Commands.vala"
		while (TRUE) {
#line 19239 "Commands.c"
			GeeIterator* _tmp9_;
			MediaSource* source = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			Tag* current_parent = NULL;
			Tag* _tmp12_;
			Tag* _tmp13_;
#line 2050 "../src/Commands.vala"
			_tmp9_ = _source_it;
#line 2050 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 2050 "../src/Commands.vala"
				break;
#line 19253 "Commands.c"
			}
#line 2050 "../src/Commands.vala"
			_tmp10_ = _source_it;
#line 2050 "../src/Commands.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 2050 "../src/Commands.vala"
			source = (MediaSource*) _tmp11_;
#line 2051 "../src/Commands.vala"
			_tmp12_ = to_tag;
#line 2051 "../src/Commands.vala"
			_tmp13_ = tag_get_hierarchical_parent (_tmp12_);
#line 2051 "../src/Commands.vala"
			current_parent = _tmp13_;
#line 2052 "../src/Commands.vala"
			while (TRUE) {
#line 19269 "Commands.c"
				Tag* _tmp14_;
				gchar* current_parent_path = NULL;
				Tag* _tmp15_;
				gchar* _tmp16_;
				GeeMap* _tmp17_;
				const gchar* _tmp18_;
				Tag* _tmp23_;
				MediaSource* _tmp24_;
				Tag* _tmp30_;
				Tag* _tmp31_;
#line 2052 "../src/Commands.vala"
				_tmp14_ = current_parent;
#line 2052 "../src/Commands.vala"
				if (!(_tmp14_ != NULL)) {
#line 2052 "../src/Commands.vala"
					break;
#line 19286 "Commands.c"
				}
#line 2053 "../src/Commands.vala"
				_tmp15_ = current_parent;
#line 2053 "../src/Commands.vala"
				_tmp16_ = tag_get_path (_tmp15_);
#line 2053 "../src/Commands.vala"
				current_parent_path = _tmp16_;
#line 2054 "../src/Commands.vala"
				_tmp17_ = self->priv->dest_parent_attachments;
#line 2054 "../src/Commands.vala"
				_tmp18_ = current_parent_path;
#line 2054 "../src/Commands.vala"
				if (!gee_map_has_key (_tmp17_, _tmp18_)) {
#line 19300 "Commands.c"
					GeeMap* _tmp19_;
					const gchar* _tmp20_;
					GeeHashSet* _tmp21_;
					GeeHashSet* _tmp22_;
#line 2055 "../src/Commands.vala"
					_tmp19_ = self->priv->dest_parent_attachments;
#line 2055 "../src/Commands.vala"
					_tmp20_ = current_parent_path;
#line 2055 "../src/Commands.vala"
					_tmp21_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2055 "../src/Commands.vala"
					_tmp22_ = _tmp21_;
#line 2055 "../src/Commands.vala"
					gee_map_set (_tmp19_, _tmp20_, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_SET, GeeSet));
#line 2055 "../src/Commands.vala"
					_g_object_unref0 (_tmp22_);
#line 19317 "Commands.c"
				}
#line 2057 "../src/Commands.vala"
				_tmp23_ = current_parent;
#line 2057 "../src/Commands.vala"
				_tmp24_ = source;
#line 2057 "../src/Commands.vala"
				if (!tag_contains (_tmp23_, _tmp24_)) {
#line 19325 "Commands.c"
					GeeMap* _tmp25_;
					const gchar* _tmp26_;
					gpointer _tmp27_;
					GeeSet* _tmp28_;
					MediaSource* _tmp29_;
#line 2058 "../src/Commands.vala"
					_tmp25_ = self->priv->dest_parent_attachments;
#line 2058 "../src/Commands.vala"
					_tmp26_ = current_parent_path;
#line 2058 "../src/Commands.vala"
					_tmp27_ = gee_map_get (_tmp25_, _tmp26_);
#line 2058 "../src/Commands.vala"
					_tmp28_ = (GeeSet*) _tmp27_;
#line 2058 "../src/Commands.vala"
					_tmp29_ = source;
#line 2058 "../src/Commands.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_COLLECTION, GeeCollection), _tmp29_);
#line 2058 "../src/Commands.vala"
					_g_object_unref0 (_tmp28_);
#line 19345 "Commands.c"
				}
#line 2060 "../src/Commands.vala"
				_tmp30_ = current_parent;
#line 2060 "../src/Commands.vala"
				_tmp31_ = tag_get_hierarchical_parent (_tmp30_);
#line 2060 "../src/Commands.vala"
				_g_object_unref0 (current_parent);
#line 2060 "../src/Commands.vala"
				current_parent = _tmp31_;
#line 2052 "../src/Commands.vala"
				_g_free0 (current_parent_path);
#line 19357 "Commands.c"
			}
#line 2050 "../src/Commands.vala"
			_g_object_unref0 (current_parent);
#line 2050 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 19363 "Commands.c"
		}
#line 2050 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 19367 "Commands.c"
	}
	{
		GeeIterator* _source_it = NULL;
		Tag* _tmp32_;
		GeeCollection* _tmp33_;
		GeeCollection* _tmp34_;
		GeeIterator* _tmp35_;
		GeeIterator* _tmp36_;
#line 2064 "../src/Commands.vala"
		_tmp32_ = from_tag;
#line 2064 "../src/Commands.vala"
		_tmp33_ = tag_get_sources (_tmp32_);
#line 2064 "../src/Commands.vala"
		_tmp34_ = _tmp33_;
#line 2064 "../src/Commands.vala"
		_tmp35_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2064 "../src/Commands.vala"
		_tmp36_ = _tmp35_;
#line 2064 "../src/Commands.vala"
		_g_object_unref0 (_tmp34_);
#line 2064 "../src/Commands.vala"
		_source_it = _tmp36_;
#line 2064 "../src/Commands.vala"
		while (TRUE) {
#line 19392 "Commands.c"
			GeeIterator* _tmp37_;
			MediaSource* source = NULL;
			GeeIterator* _tmp38_;
			gpointer _tmp39_;
			Tag* _tmp40_;
			MediaSource* _tmp41_;
#line 2064 "../src/Commands.vala"
			_tmp37_ = _source_it;
#line 2064 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp37_)) {
#line 2064 "../src/Commands.vala"
				break;
#line 19405 "Commands.c"
			}
#line 2064 "../src/Commands.vala"
			_tmp38_ = _source_it;
#line 2064 "../src/Commands.vala"
			_tmp39_ = gee_iterator_get (_tmp38_);
#line 2064 "../src/Commands.vala"
			source = (MediaSource*) _tmp39_;
#line 2065 "../src/Commands.vala"
			_tmp40_ = to_tag;
#line 2065 "../src/Commands.vala"
			_tmp41_ = source;
#line 2065 "../src/Commands.vala"
			tag_attach (_tmp40_, _tmp41_);
#line 2064 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 19421 "Commands.c"
		}
#line 2064 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 19425 "Commands.c"
	}
#line 2069 "../src/Commands.vala"
	_tmp42_ = from_tag;
#line 2069 "../src/Commands.vala"
	_tmp43_ = tag_get_hierarchical_children (_tmp42_);
#line 2069 "../src/Commands.vala"
	from_children = _tmp43_;
#line 19433 "Commands.c"
	{
		gint i = 0;
		GeeList* _tmp44_;
		gint _tmp45_;
		gint _tmp46_;
#line 2070 "../src/Commands.vala"
		_tmp44_ = from_children;
#line 2070 "../src/Commands.vala"
		_tmp45_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2070 "../src/Commands.vala"
		_tmp46_ = _tmp45_;
#line 2070 "../src/Commands.vala"
		i = _tmp46_ - 1;
#line 19447 "Commands.c"
		{
			gboolean _tmp47_ = FALSE;
#line 2070 "../src/Commands.vala"
			_tmp47_ = TRUE;
#line 2070 "../src/Commands.vala"
			while (TRUE) {
#line 19454 "Commands.c"
				Tag* from_child = NULL;
				GeeList* _tmp49_;
				gpointer _tmp50_;
				gchar* child_subpath = NULL;
				Tag* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				Tag* to_child = NULL;
				Tag* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				const gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				Tag* _tmp66_;
				Tag* _tmp67_;
#line 2070 "../src/Commands.vala"
				if (!_tmp47_) {
#line 19479 "Commands.c"
					gint _tmp48_;
#line 2070 "../src/Commands.vala"
					_tmp48_ = i;
#line 2070 "../src/Commands.vala"
					i = _tmp48_ - 1;
#line 19485 "Commands.c"
				}
#line 2070 "../src/Commands.vala"
				_tmp47_ = FALSE;
#line 2070 "../src/Commands.vala"
				if (!(i >= 0)) {
#line 2070 "../src/Commands.vala"
					break;
#line 19493 "Commands.c"
				}
#line 2071 "../src/Commands.vala"
				_tmp49_ = from_children;
#line 2071 "../src/Commands.vala"
				_tmp50_ = gee_list_get (_tmp49_, i);
#line 2071 "../src/Commands.vala"
				from_child = (Tag*) _tmp50_;
#line 2073 "../src/Commands.vala"
				_tmp51_ = from_child;
#line 2073 "../src/Commands.vala"
				_tmp52_ = tag_get_path (_tmp51_);
#line 2073 "../src/Commands.vala"
				_tmp53_ = _tmp52_;
#line 2073 "../src/Commands.vala"
				_tmp54_ = g_strconcat (from, TAG_PATH_SEPARATOR_STRING, NULL);
#line 2073 "../src/Commands.vala"
				_tmp55_ = _tmp54_;
#line 2073 "../src/Commands.vala"
				_tmp56_ = string_replace (_tmp53_, _tmp55_, "");
#line 2073 "../src/Commands.vala"
				_tmp57_ = _tmp56_;
#line 2073 "../src/Commands.vala"
				_g_free0 (_tmp55_);
#line 2073 "../src/Commands.vala"
				_g_free0 (_tmp53_);
#line 2073 "../src/Commands.vala"
				child_subpath = _tmp57_;
#line 2076 "../src/Commands.vala"
				_tmp58_ = to_tag;
#line 2076 "../src/Commands.vala"
				_tmp59_ = tag_get_path (_tmp58_);
#line 2076 "../src/Commands.vala"
				_tmp60_ = _tmp59_;
#line 2076 "../src/Commands.vala"
				_tmp61_ = g_strconcat (_tmp60_, TAG_PATH_SEPARATOR_STRING, NULL);
#line 2076 "../src/Commands.vala"
				_tmp62_ = _tmp61_;
#line 2076 "../src/Commands.vala"
				_tmp63_ = child_subpath;
#line 2076 "../src/Commands.vala"
				_tmp64_ = g_strconcat (_tmp62_, _tmp63_, NULL);
#line 2076 "../src/Commands.vala"
				_tmp65_ = _tmp64_;
#line 2076 "../src/Commands.vala"
				_tmp66_ = tag_for_path (_tmp65_);
#line 2076 "../src/Commands.vala"
				_tmp67_ = _tmp66_;
#line 2076 "../src/Commands.vala"
				_g_free0 (_tmp65_);
#line 2076 "../src/Commands.vala"
				_g_free0 (_tmp62_);
#line 2076 "../src/Commands.vala"
				_g_free0 (_tmp60_);
#line 2076 "../src/Commands.vala"
				to_child = _tmp67_;
#line 19549 "Commands.c"
				{
					GeeIterator* _source_it = NULL;
					Tag* _tmp68_;
					GeeCollection* _tmp69_;
					GeeCollection* _tmp70_;
					GeeIterator* _tmp71_;
					GeeIterator* _tmp72_;
#line 2079 "../src/Commands.vala"
					_tmp68_ = from_child;
#line 2079 "../src/Commands.vala"
					_tmp69_ = tag_get_sources (_tmp68_);
#line 2079 "../src/Commands.vala"
					_tmp70_ = _tmp69_;
#line 2079 "../src/Commands.vala"
					_tmp71_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2079 "../src/Commands.vala"
					_tmp72_ = _tmp71_;
#line 2079 "../src/Commands.vala"
					_g_object_unref0 (_tmp70_);
#line 2079 "../src/Commands.vala"
					_source_it = _tmp72_;
#line 2079 "../src/Commands.vala"
					while (TRUE) {
#line 19573 "Commands.c"
						GeeIterator* _tmp73_;
						MediaSource* source = NULL;
						GeeIterator* _tmp74_;
						gpointer _tmp75_;
						Tag* _tmp76_;
						MediaSource* _tmp77_;
#line 2079 "../src/Commands.vala"
						_tmp73_ = _source_it;
#line 2079 "../src/Commands.vala"
						if (!gee_iterator_next (_tmp73_)) {
#line 2079 "../src/Commands.vala"
							break;
#line 19586 "Commands.c"
						}
#line 2079 "../src/Commands.vala"
						_tmp74_ = _source_it;
#line 2079 "../src/Commands.vala"
						_tmp75_ = gee_iterator_get (_tmp74_);
#line 2079 "../src/Commands.vala"
						source = (MediaSource*) _tmp75_;
#line 2080 "../src/Commands.vala"
						_tmp76_ = to_child;
#line 2080 "../src/Commands.vala"
						_tmp77_ = source;
#line 2080 "../src/Commands.vala"
						tag_attach (_tmp76_, _tmp77_);
#line 2079 "../src/Commands.vala"
						_g_object_unref0 (source);
#line 19602 "Commands.c"
					}
#line 2079 "../src/Commands.vala"
					_g_object_unref0 (_source_it);
#line 19606 "Commands.c"
				}
#line 2070 "../src/Commands.vala"
				_g_object_unref0 (to_child);
#line 2070 "../src/Commands.vala"
				_g_free0 (child_subpath);
#line 2070 "../src/Commands.vala"
				_g_object_unref0 (from_child);
#line 19614 "Commands.c"
			}
		}
	}
#line 2040 "../src/Commands.vala"
	_g_object_unref0 (from_children);
#line 2040 "../src/Commands.vala"
	_g_object_unref0 (to_tag);
#line 2040 "../src/Commands.vala"
	_g_object_unref0 (from_tag);
#line 19624 "Commands.c"
}

static void
reparent_tag_command_destroy_subtree (ReparentTagCommand* self,
                                      const gchar* client_path)
{
	gchar* victim_path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	TagSourceCollection* _tmp3_;
	const gchar* _tmp4_;
	Tag* victim = NULL;
	const gchar* _tmp5_;
	Tag* _tmp6_;
	GeeList* victim_children = NULL;
	Tag* _tmp7_;
	GeeList* _tmp8_;
	TagSourceCollection* _tmp21_;
	TagSourceCollection* _tmp22_;
	Tag* _tmp23_;
	Marker* _tmp24_;
	Marker* _tmp25_;
#line 2084 "../src/Commands.vala"
	g_return_if_fail (IS_REPARENT_TAG_COMMAND (self));
#line 2084 "../src/Commands.vala"
	g_return_if_fail (client_path != NULL);
#line 2085 "../src/Commands.vala"
	_tmp0_ = hierarchical_tag_utilities_get_root_path_form (client_path);
#line 2085 "../src/Commands.vala"
	victim_path = _tmp0_;
#line 2086 "../src/Commands.vala"
	_tmp1_ = victim_path;
#line 2086 "../src/Commands.vala"
	if (_tmp1_ == NULL) {
#line 19659 "Commands.c"
		gchar* _tmp2_;
#line 2087 "../src/Commands.vala"
		_tmp2_ = g_strdup (client_path);
#line 2087 "../src/Commands.vala"
		_g_free0 (victim_path);
#line 2087 "../src/Commands.vala"
		victim_path = _tmp2_;
#line 19667 "Commands.c"
	}
#line 2089 "../src/Commands.vala"
	_tmp3_ = tag_global;
#line 2089 "../src/Commands.vala"
	_tmp4_ = victim_path;
#line 2089 "../src/Commands.vala"
	if (!tag_source_collection_exists (_tmp3_, _tmp4_, FALSE)) {
#line 2090 "../src/Commands.vala"
		_g_free0 (victim_path);
#line 2090 "../src/Commands.vala"
		return;
#line 19679 "Commands.c"
	}
#line 2092 "../src/Commands.vala"
	_tmp5_ = victim_path;
#line 2092 "../src/Commands.vala"
	_tmp6_ = tag_for_path (_tmp5_);
#line 2092 "../src/Commands.vala"
	victim = _tmp6_;
#line 2095 "../src/Commands.vala"
	_tmp7_ = victim;
#line 2095 "../src/Commands.vala"
	_tmp8_ = tag_get_hierarchical_children (_tmp7_);
#line 2095 "../src/Commands.vala"
	victim_children = _tmp8_;
#line 19693 "Commands.c"
	{
		gint i = 0;
#line 2096 "../src/Commands.vala"
		i = 0;
#line 19698 "Commands.c"
		{
			gboolean _tmp9_ = FALSE;
#line 2096 "../src/Commands.vala"
			_tmp9_ = TRUE;
#line 2096 "../src/Commands.vala"
			while (TRUE) {
#line 19705 "Commands.c"
				GeeList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				TagSourceCollection* _tmp14_;
				TagSourceCollection* _tmp15_;
				GeeList* _tmp16_;
				gpointer _tmp17_;
				Tag* _tmp18_;
				Marker* _tmp19_;
				Marker* _tmp20_;
#line 2096 "../src/Commands.vala"
				if (!_tmp9_) {
#line 19718 "Commands.c"
					gint _tmp10_;
#line 2096 "../src/Commands.vala"
					_tmp10_ = i;
#line 2096 "../src/Commands.vala"
					i = _tmp10_ + 1;
#line 19724 "Commands.c"
				}
#line 2096 "../src/Commands.vala"
				_tmp9_ = FALSE;
#line 2096 "../src/Commands.vala"
				_tmp11_ = victim_children;
#line 2096 "../src/Commands.vala"
				_tmp12_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2096 "../src/Commands.vala"
				_tmp13_ = _tmp12_;
#line 2096 "../src/Commands.vala"
				if (!(i < _tmp13_)) {
#line 2096 "../src/Commands.vala"
					break;
#line 19738 "Commands.c"
				}
#line 2097 "../src/Commands.vala"
				_tmp14_ = tag_global;
#line 2097 "../src/Commands.vala"
				_tmp15_ = tag_global;
#line 2097 "../src/Commands.vala"
				_tmp16_ = victim_children;
#line 2097 "../src/Commands.vala"
				_tmp17_ = gee_list_get (_tmp16_, i);
#line 2097 "../src/Commands.vala"
				_tmp18_ = (Tag*) _tmp17_;
#line 2097 "../src/Commands.vala"
				_tmp19_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_DATA_OBJECT, DataObject));
#line 2097 "../src/Commands.vala"
				_tmp20_ = _tmp19_;
#line 2097 "../src/Commands.vala"
				source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp20_, TRUE, NULL, NULL, NULL);
#line 2097 "../src/Commands.vala"
				_g_object_unref0 (_tmp20_);
#line 2097 "../src/Commands.vala"
				_g_object_unref0 (_tmp18_);
#line 19760 "Commands.c"
			}
		}
	}
#line 2100 "../src/Commands.vala"
	_tmp21_ = tag_global;
#line 2100 "../src/Commands.vala"
	_tmp22_ = tag_global;
#line 2100 "../src/Commands.vala"
	_tmp23_ = victim;
#line 2100 "../src/Commands.vala"
	_tmp24_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_DATA_OBJECT, DataObject));
#line 2100 "../src/Commands.vala"
	_tmp25_ = _tmp24_;
#line 2100 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp25_, TRUE, NULL, NULL, NULL);
#line 2100 "../src/Commands.vala"
	_g_object_unref0 (_tmp25_);
#line 2084 "../src/Commands.vala"
	_g_object_unref0 (victim_children);
#line 2084 "../src/Commands.vala"
	_g_object_unref0 (victim);
#line 2084 "../src/Commands.vala"
	_g_free0 (victim_path);
#line 19784 "Commands.c"
}

static void
reparent_tag_command_real_execute (Command* base)
{
	ReparentTagCommand * self;
	GeeList* _tmp0_;
#line 2103 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REPARENT_TAG_COMMAND, ReparentTagCommand);
#line 2104 "../src/Commands.vala"
	_tmp0_ = self->priv->after_state;
#line 2104 "../src/Commands.vala"
	if (_tmp0_ == NULL) {
#line 19798 "Commands.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 2105 "../src/Commands.vala"
		reparent_tag_command_save_before_state (self);
#line 2107 "../src/Commands.vala"
		_tmp1_ = self->priv->to_path;
#line 2107 "../src/Commands.vala"
		reparent_tag_command_prepare_parent (self, _tmp1_);
#line 2109 "../src/Commands.vala"
		_tmp2_ = self->priv->from_path;
#line 2109 "../src/Commands.vala"
		_tmp3_ = self->priv->to_path;
#line 2109 "../src/Commands.vala"
		reparent_tag_command_copy_subtree (self, _tmp2_, _tmp3_);
#line 2111 "../src/Commands.vala"
		reparent_tag_command_save_after_state (self);
#line 2113 "../src/Commands.vala"
		reparent_tag_command_do_source_parent_detachments (self);
#line 2115 "../src/Commands.vala"
		_tmp4_ = self->priv->from_path;
#line 2115 "../src/Commands.vala"
		reparent_tag_command_destroy_subtree (self, _tmp4_);
#line 19823 "Commands.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GeeMap* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 2117 "../src/Commands.vala"
		_tmp5_ = self->priv->to_path;
#line 2117 "../src/Commands.vala"
		reparent_tag_command_prepare_parent (self, _tmp5_);
#line 2119 "../src/Commands.vala"
		reparent_tag_command_restore_after_state (self);
#line 2121 "../src/Commands.vala"
		_tmp6_ = self->priv->to_path;
#line 2121 "../src/Commands.vala"
		_tmp7_ = self->priv->in_play_child_structure;
#line 2121 "../src/Commands.vala"
		reparent_tag_command_restore_child_attachments_at (self, _tmp6_, _tmp7_);
#line 2122 "../src/Commands.vala"
		_tmp8_ = self->priv->to_path;
#line 2122 "../src/Commands.vala"
		reparent_tag_command_reattach_in_play_sources_at (self, _tmp8_);
#line 2124 "../src/Commands.vala"
		reparent_tag_command_do_source_parent_detachments (self);
#line 2125 "../src/Commands.vala"
		reparent_tag_command_do_destination_parent_reattachments (self);
#line 2127 "../src/Commands.vala"
		_tmp9_ = self->priv->from_path;
#line 2127 "../src/Commands.vala"
		reparent_tag_command_destroy_subtree (self, _tmp9_);
#line 19854 "Commands.c"
	}
}

static void
reparent_tag_command_real_undo (Command* base)
{
	ReparentTagCommand * self;
	GeeList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp3_;
	GeeMap* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 2131 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REPARENT_TAG_COMMAND, ReparentTagCommand);
#line 2132 "../src/Commands.vala"
	_tmp0_ = self->priv->src_before_state;
#line 2132 "../src/Commands.vala"
	_vala_assert (_tmp0_ != NULL, "src_before_state != null");
#line 2134 "../src/Commands.vala"
	_tmp1_ = self->priv->from_path;
#line 2134 "../src/Commands.vala"
	reparent_tag_command_prepare_parent (self, _tmp1_);
#line 2136 "../src/Commands.vala"
	reparent_tag_command_restore_before_state (self);
#line 2138 "../src/Commands.vala"
	if (!self->priv->to_path_exists) {
#line 19884 "Commands.c"
		const gchar* _tmp2_;
#line 2139 "../src/Commands.vala"
		_tmp2_ = self->priv->to_path;
#line 2139 "../src/Commands.vala"
		reparent_tag_command_destroy_subtree (self, _tmp2_);
#line 19890 "Commands.c"
	}
#line 2141 "../src/Commands.vala"
	_tmp3_ = self->priv->from_path;
#line 2141 "../src/Commands.vala"
	_tmp4_ = self->priv->in_play_child_structure;
#line 2141 "../src/Commands.vala"
	reparent_tag_command_restore_child_attachments_at (self, _tmp3_, _tmp4_);
#line 2142 "../src/Commands.vala"
	_tmp5_ = self->priv->from_path;
#line 2142 "../src/Commands.vala"
	reparent_tag_command_reattach_in_play_sources_at (self, _tmp5_);
#line 2144 "../src/Commands.vala"
	reparent_tag_command_do_source_parent_reattachments (self);
#line 2145 "../src/Commands.vala"
	reparent_tag_command_do_destination_parent_detachments (self);
#line 2147 "../src/Commands.vala"
	_tmp6_ = self->priv->to_path;
#line 2147 "../src/Commands.vala"
	hierarchical_tag_utilities_cleanup_root_path (_tmp6_);
#line 2148 "../src/Commands.vala"
	_tmp7_ = self->priv->from_path;
#line 2148 "../src/Commands.vala"
	hierarchical_tag_utilities_cleanup_root_path (_tmp7_);
#line 2149 "../src/Commands.vala"
	_tmp8_ = self->priv->to_path_parent_path;
#line 2149 "../src/Commands.vala"
	if (_tmp8_ != NULL) {
#line 19918 "Commands.c"
		const gchar* _tmp9_;
#line 2150 "../src/Commands.vala"
		_tmp9_ = self->priv->to_path_parent_path;
#line 2150 "../src/Commands.vala"
		hierarchical_tag_utilities_cleanup_root_path (_tmp9_);
#line 19924 "Commands.c"
	}
}

static void
reparent_tag_command_class_init (ReparentTagCommandClass * klass,
                                 gpointer klass_data)
{
#line 1695 "../src/Commands.vala"
	reparent_tag_command_parent_class = g_type_class_peek_parent (klass);
#line 1695 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &ReparentTagCommand_private_offset);
#line 1695 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) reparent_tag_command_real_execute;
#line 1695 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) reparent_tag_command_real_undo;
#line 1695 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = reparent_tag_command_finalize;
#line 19942 "Commands.c"
}

static void
reparent_tag_command_instance_init (ReparentTagCommand * self,
                                    gpointer klass)
{
	GeeHashSet* _tmp0_;
#line 1695 "../src/Commands.vala"
	self->priv = reparent_tag_command_get_instance_private (self);
#line 1699 "../src/Commands.vala"
	self->priv->src_before_state = NULL;
#line 1700 "../src/Commands.vala"
	self->priv->dest_before_state = NULL;
#line 1701 "../src/Commands.vala"
	self->priv->after_state = NULL;
#line 1702 "../src/Commands.vala"
	_tmp0_ = gee_hash_set_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1702 "../src/Commands.vala"
	self->priv->sources_in_play = _tmp0_;
#line 1703 "../src/Commands.vala"
	self->priv->dest_parent_attachments = NULL;
#line 1704 "../src/Commands.vala"
	self->priv->src_parent_detachments = NULL;
#line 1705 "../src/Commands.vala"
	self->priv->in_play_child_structure = NULL;
#line 1706 "../src/Commands.vala"
	self->priv->existing_dest_child_structure = NULL;
#line 1707 "../src/Commands.vala"
	self->priv->existing_dest_membership = NULL;
#line 1708 "../src/Commands.vala"
	self->priv->to_path_exists = FALSE;
#line 19974 "Commands.c"
}

static void
reparent_tag_command_finalize (GObject * obj)
{
	ReparentTagCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	VideoSourceCollection* _tmp2_;
	guint _tmp3_;
#line 1695 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REPARENT_TAG_COMMAND, ReparentTagCommand);
#line 1740 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 1740 "../src/Commands.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1740 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _reparent_tag_command_on_items_destroyed_source_collection_items_destroyed, self);
#line 1741 "../src/Commands.vala"
	_tmp2_ = video_global;
#line 1741 "../src/Commands.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1741 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _reparent_tag_command_on_items_destroyed_source_collection_items_destroyed, self);
#line 1696 "../src/Commands.vala"
	_g_free0 (self->priv->from_path);
#line 1697 "../src/Commands.vala"
	_g_free0 (self->priv->to_path);
#line 1698 "../src/Commands.vala"
	_g_free0 (self->priv->to_path_parent_path);
#line 1699 "../src/Commands.vala"
	_g_object_unref0 (self->priv->src_before_state);
#line 1700 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dest_before_state);
#line 1701 "../src/Commands.vala"
	_g_object_unref0 (self->priv->after_state);
#line 1702 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources_in_play);
#line 1703 "../src/Commands.vala"
	_g_object_unref0 (self->priv->dest_parent_attachments);
#line 1704 "../src/Commands.vala"
	_g_object_unref0 (self->priv->src_parent_detachments);
#line 1705 "../src/Commands.vala"
	_g_object_unref0 (self->priv->in_play_child_structure);
#line 1706 "../src/Commands.vala"
	_g_object_unref0 (self->priv->existing_dest_child_structure);
#line 1707 "../src/Commands.vala"
	_g_object_unref0 (self->priv->existing_dest_membership);
#line 1695 "../src/Commands.vala"
	G_OBJECT_CLASS (reparent_tag_command_parent_class)->finalize (obj);
#line 20025 "Commands.c"
}

static GType
reparent_tag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ReparentTagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) reparent_tag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ReparentTagCommand), 0, (GInstanceInitFunc) reparent_tag_command_instance_init, NULL };
	GType reparent_tag_command_type_id;
	reparent_tag_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "ReparentTagCommand", &g_define_type_info, 0);
	ReparentTagCommand_private_offset = g_type_add_instance_private (reparent_tag_command_type_id, sizeof (ReparentTagCommandPrivate));
	return reparent_tag_command_type_id;
}

GType
reparent_tag_command_get_type (void)
{
	static volatile gsize reparent_tag_command_type_id__once = 0;
	if (g_once_init_enter (&reparent_tag_command_type_id__once)) {
		GType reparent_tag_command_type_id;
		reparent_tag_command_type_id = reparent_tag_command_get_type_once ();
		g_once_init_leave (&reparent_tag_command_type_id__once, reparent_tag_command_type_id);
	}
	return reparent_tag_command_type_id__once;
}

static inline gpointer
modify_tags_command_get_instance_private (ModifyTagsCommand* self)
{
	return G_STRUCT_MEMBER_P (self, ModifyTagsCommand_private_offset);
}

static void
_modify_tags_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                          gpointer self)
{
#line 2193 "../src/Commands.vala"
	modify_tags_command_on_proxy_broken ((ModifyTagsCommand*) self);
#line 20062 "Commands.c"
}

ModifyTagsCommand*
modify_tags_command_construct (GType object_type,
                               MediaSource* media,
                               GeeCollection* new_tag_list)
{
	ModifyTagsCommand * self = NULL;
	MediaSource* _tmp0_;
	GeeList* original_tags = NULL;
	TagSourceCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	GeeSortedSet* new_paths = NULL;
	GeeTreeSet* _tmp17_;
#line 2159 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (media), NULL);
#line 2159 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_tag_list, GEE_TYPE_COLLECTION), NULL);
#line 2160 "../src/Commands.vala"
	self = (ModifyTagsCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (media, TYPE_DATA_SOURCE, DataSource), RESOURCES_MODIFY_TAGS_LABEL, "");
#line 2162 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (media);
#line 2162 "../src/Commands.vala"
	_g_object_unref0 (self->priv->media);
#line 2162 "../src/Commands.vala"
	self->priv->media = _tmp0_;
#line 2165 "../src/Commands.vala"
	_tmp1_ = tag_global;
#line 2165 "../src/Commands.vala"
	_tmp2_ = tag_source_collection_fetch_for_source (_tmp1_, media);
#line 2165 "../src/Commands.vala"
	original_tags = _tmp2_;
#line 2166 "../src/Commands.vala"
	_tmp3_ = original_tags;
#line 2166 "../src/Commands.vala"
	if (_tmp3_ != NULL) {
#line 20100 "Commands.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			gint _tag_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tag_index = 0;
#line 2167 "../src/Commands.vala"
			_tmp4_ = original_tags;
#line 2167 "../src/Commands.vala"
			_tag_list = _tmp4_;
#line 2167 "../src/Commands.vala"
			_tmp5_ = _tag_list;
#line 2167 "../src/Commands.vala"
			_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2167 "../src/Commands.vala"
			_tmp7_ = _tmp6_;
#line 2167 "../src/Commands.vala"
			_tag_size = _tmp7_;
#line 2167 "../src/Commands.vala"
			_tag_index = -1;
#line 2167 "../src/Commands.vala"
			while (TRUE) {
#line 20125 "Commands.c"
				gint _tmp8_;
				gint _tmp9_;
				Tag* tag = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				SourceProxy* proxy = NULL;
				Tag* _tmp12_;
				SourceProxy* _tmp13_;
				GeeArrayList* _tmp14_;
				SourceProxy* _tmp15_;
				SourceProxy* _tmp16_;
#line 2167 "../src/Commands.vala"
				_tag_index = _tag_index + 1;
#line 2167 "../src/Commands.vala"
				_tmp8_ = _tag_index;
#line 2167 "../src/Commands.vala"
				_tmp9_ = _tag_size;
#line 2167 "../src/Commands.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 2167 "../src/Commands.vala"
					break;
#line 20147 "Commands.c"
				}
#line 2167 "../src/Commands.vala"
				_tmp10_ = _tag_list;
#line 2167 "../src/Commands.vala"
				_tmp11_ = gee_list_get (_tmp10_, _tag_index);
#line 2167 "../src/Commands.vala"
				tag = (Tag*) _tmp11_;
#line 2168 "../src/Commands.vala"
				_tmp12_ = tag;
#line 2168 "../src/Commands.vala"
				_tmp13_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_PROXYABLE, Proxyable));
#line 2168 "../src/Commands.vala"
				proxy = _tmp13_;
#line 2169 "../src/Commands.vala"
				_tmp14_ = self->priv->to_remove;
#line 2169 "../src/Commands.vala"
				_tmp15_ = proxy;
#line 2169 "../src/Commands.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 2170 "../src/Commands.vala"
				_tmp16_ = proxy;
#line 2170 "../src/Commands.vala"
				g_signal_connect_object (_tmp16_, "broken", (GCallback) _modify_tags_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 2167 "../src/Commands.vala"
				_source_proxy_unref0 (proxy);
#line 2167 "../src/Commands.vala"
				_g_object_unref0 (tag);
#line 20175 "Commands.c"
			}
		}
	}
#line 2176 "../src/Commands.vala"
	_tmp17_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 2176 "../src/Commands.vala"
	new_paths = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_SORTED_SET, GeeSortedSet);
#line 20183 "Commands.c"
	{
		GeeIterator* _new_tag_it = NULL;
		GeeIterator* _tmp18_;
#line 2177 "../src/Commands.vala"
		_tmp18_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (new_tag_list, GEE_TYPE_ITERABLE, GeeIterable));
#line 2177 "../src/Commands.vala"
		_new_tag_it = _tmp18_;
#line 2177 "../src/Commands.vala"
		while (TRUE) {
#line 20193 "Commands.c"
			GeeIterator* _tmp19_;
			Tag* new_tag = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			gchar* new_tag_path = NULL;
			Tag* _tmp22_;
			gchar* _tmp23_;
			GeeSortedSet* _tmp24_;
			const gchar* _tmp25_;
			GeeSortedSet* _tmp26_;
			const gchar* _tmp27_;
			GeeList* _tmp28_;
			GeeList* _tmp29_;
#line 2177 "../src/Commands.vala"
			_tmp19_ = _new_tag_it;
#line 2177 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 2177 "../src/Commands.vala"
				break;
#line 20213 "Commands.c"
			}
#line 2177 "../src/Commands.vala"
			_tmp20_ = _new_tag_it;
#line 2177 "../src/Commands.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 2177 "../src/Commands.vala"
			new_tag = (Tag*) _tmp21_;
#line 2178 "../src/Commands.vala"
			_tmp22_ = new_tag;
#line 2178 "../src/Commands.vala"
			_tmp23_ = tag_get_path (_tmp22_);
#line 2178 "../src/Commands.vala"
			new_tag_path = _tmp23_;
#line 2180 "../src/Commands.vala"
			_tmp24_ = new_paths;
#line 2180 "../src/Commands.vala"
			_tmp25_ = new_tag_path;
#line 2180 "../src/Commands.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection), _tmp25_);
#line 2181 "../src/Commands.vala"
			_tmp26_ = new_paths;
#line 2181 "../src/Commands.vala"
			_tmp27_ = new_tag_path;
#line 2181 "../src/Commands.vala"
			_tmp28_ = hierarchical_tag_utilities_enumerate_parent_paths (_tmp27_);
#line 2181 "../src/Commands.vala"
			_tmp29_ = _tmp28_;
#line 2181 "../src/Commands.vala"
			gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2181 "../src/Commands.vala"
			_g_object_unref0 (_tmp29_);
#line 2177 "../src/Commands.vala"
			_g_free0 (new_tag_path);
#line 2177 "../src/Commands.vala"
			_g_object_unref0 (new_tag);
#line 20249 "Commands.c"
		}
#line 2177 "../src/Commands.vala"
		_g_object_unref0 (_new_tag_it);
#line 20253 "Commands.c"
	}
	{
		GeeIterator* _path_it = NULL;
		GeeSortedSet* _tmp30_;
		GeeIterator* _tmp31_;
#line 2184 "../src/Commands.vala"
		_tmp30_ = new_paths;
#line 2184 "../src/Commands.vala"
		_tmp31_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2184 "../src/Commands.vala"
		_path_it = _tmp31_;
#line 2184 "../src/Commands.vala"
		while (TRUE) {
#line 20267 "Commands.c"
			GeeIterator* _tmp32_;
			gchar* path = NULL;
			GeeIterator* _tmp33_;
			gpointer _tmp34_;
			SourceProxy* proxy = NULL;
			const gchar* _tmp35_;
			Tag* _tmp36_;
			Tag* _tmp37_;
			SourceProxy* _tmp38_;
			SourceProxy* _tmp39_;
			GeeArrayList* _tmp40_;
			SourceProxy* _tmp41_;
			SourceProxy* _tmp42_;
#line 2184 "../src/Commands.vala"
			_tmp32_ = _path_it;
#line 2184 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp32_)) {
#line 2184 "../src/Commands.vala"
				break;
#line 20287 "Commands.c"
			}
#line 2184 "../src/Commands.vala"
			_tmp33_ = _path_it;
#line 2184 "../src/Commands.vala"
			_tmp34_ = gee_iterator_get (_tmp33_);
#line 2184 "../src/Commands.vala"
			path = (gchar*) _tmp34_;
#line 2185 "../src/Commands.vala"
			_tmp35_ = path;
#line 2185 "../src/Commands.vala"
			_tmp36_ = tag_for_path (_tmp35_);
#line 2185 "../src/Commands.vala"
			_tmp37_ = _tmp36_;
#line 2185 "../src/Commands.vala"
			_tmp38_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_PROXYABLE, Proxyable));
#line 2185 "../src/Commands.vala"
			_tmp39_ = _tmp38_;
#line 2185 "../src/Commands.vala"
			_g_object_unref0 (_tmp37_);
#line 2185 "../src/Commands.vala"
			proxy = _tmp39_;
#line 2186 "../src/Commands.vala"
			_tmp40_ = self->priv->to_add;
#line 2186 "../src/Commands.vala"
			_tmp41_ = proxy;
#line 2186 "../src/Commands.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp41_);
#line 2187 "../src/Commands.vala"
			_tmp42_ = proxy;
#line 2187 "../src/Commands.vala"
			g_signal_connect_object (_tmp42_, "broken", (GCallback) _modify_tags_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 2184 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 2184 "../src/Commands.vala"
			_g_free0 (path);
#line 20323 "Commands.c"
		}
#line 2184 "../src/Commands.vala"
		_g_object_unref0 (_path_it);
#line 20327 "Commands.c"
	}
#line 2159 "../src/Commands.vala"
	_g_object_unref0 (new_paths);
#line 2159 "../src/Commands.vala"
	_g_object_unref0 (original_tags);
#line 2159 "../src/Commands.vala"
	return self;
#line 20335 "Commands.c"
}

ModifyTagsCommand*
modify_tags_command_new (MediaSource* media,
                         GeeCollection* new_tag_list)
{
#line 2159 "../src/Commands.vala"
	return modify_tags_command_construct (TYPE_MODIFY_TAGS_COMMAND, media, new_tag_list);
#line 20344 "Commands.c"
}

static void
modify_tags_command_real_execute (Command* base)
{
	ModifyTagsCommand * self;
#line 2199 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommand);
#line 20353 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2200 "../src/Commands.vala"
		_tmp0_ = self->priv->to_remove;
#line 2200 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2200 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2200 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2200 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2200 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2200 "../src/Commands.vala"
		_proxy_index = -1;
#line 2200 "../src/Commands.vala"
		while (TRUE) {
#line 20378 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			SourceProxy* _tmp8_;
			DataSource* _tmp9_;
			Tag* _tmp10_;
			MediaSource* _tmp11_;
			GeeList* _tmp12_;
			GeeList* _tmp13_;
#line 2200 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2200 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2200 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2200 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2200 "../src/Commands.vala"
				break;
#line 20400 "Commands.c"
			}
#line 2200 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2200 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2200 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2201 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2201 "../src/Commands.vala"
			_tmp9_ = source_proxy_get_source (_tmp8_);
#line 2201 "../src/Commands.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_TAG, Tag);
#line 2201 "../src/Commands.vala"
			_tmp11_ = self->priv->media;
#line 2201 "../src/Commands.vala"
			_tmp12_ = tag_detach (_tmp10_, _tmp11_);
#line 2201 "../src/Commands.vala"
			_tmp13_ = _tmp12_;
#line 2201 "../src/Commands.vala"
			_g_object_unref0 (_tmp13_);
#line 2201 "../src/Commands.vala"
			_g_object_unref0 (_tmp10_);
#line 2200 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20426 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp14_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _proxy_index = 0;
#line 2203 "../src/Commands.vala"
		_tmp14_ = self->priv->to_add;
#line 2203 "../src/Commands.vala"
		_proxy_list = _tmp14_;
#line 2203 "../src/Commands.vala"
		_tmp15_ = _proxy_list;
#line 2203 "../src/Commands.vala"
		_tmp16_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2203 "../src/Commands.vala"
		_tmp17_ = _tmp16_;
#line 2203 "../src/Commands.vala"
		_proxy_size = _tmp17_;
#line 2203 "../src/Commands.vala"
		_proxy_index = -1;
#line 2203 "../src/Commands.vala"
		while (TRUE) {
#line 20453 "Commands.c"
			gint _tmp18_;
			gint _tmp19_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp20_;
			gpointer _tmp21_;
			SourceProxy* _tmp22_;
			DataSource* _tmp23_;
			Tag* _tmp24_;
			MediaSource* _tmp25_;
#line 2203 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2203 "../src/Commands.vala"
			_tmp18_ = _proxy_index;
#line 2203 "../src/Commands.vala"
			_tmp19_ = _proxy_size;
#line 2203 "../src/Commands.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 2203 "../src/Commands.vala"
				break;
#line 20473 "Commands.c"
			}
#line 2203 "../src/Commands.vala"
			_tmp20_ = _proxy_list;
#line 2203 "../src/Commands.vala"
			_tmp21_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2203 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp21_;
#line 2204 "../src/Commands.vala"
			_tmp22_ = proxy;
#line 2204 "../src/Commands.vala"
			_tmp23_ = source_proxy_get_source (_tmp22_);
#line 2204 "../src/Commands.vala"
			_tmp24_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_TAG, Tag);
#line 2204 "../src/Commands.vala"
			_tmp25_ = self->priv->media;
#line 2204 "../src/Commands.vala"
			tag_attach (_tmp24_, _tmp25_);
#line 2204 "../src/Commands.vala"
			_g_object_unref0 (_tmp24_);
#line 2203 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20495 "Commands.c"
		}
	}
}

static void
modify_tags_command_real_undo (Command* base)
{
	ModifyTagsCommand * self;
#line 2207 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommand);
#line 20506 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2208 "../src/Commands.vala"
		_tmp0_ = self->priv->to_add;
#line 2208 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2208 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2208 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2208 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2208 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2208 "../src/Commands.vala"
		_proxy_index = -1;
#line 2208 "../src/Commands.vala"
		while (TRUE) {
#line 20531 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			SourceProxy* _tmp8_;
			DataSource* _tmp9_;
			Tag* _tmp10_;
			MediaSource* _tmp11_;
			GeeList* _tmp12_;
			GeeList* _tmp13_;
#line 2208 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2208 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2208 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2208 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2208 "../src/Commands.vala"
				break;
#line 20553 "Commands.c"
			}
#line 2208 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2208 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2208 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2209 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2209 "../src/Commands.vala"
			_tmp9_ = source_proxy_get_source (_tmp8_);
#line 2209 "../src/Commands.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_TAG, Tag);
#line 2209 "../src/Commands.vala"
			_tmp11_ = self->priv->media;
#line 2209 "../src/Commands.vala"
			_tmp12_ = tag_detach (_tmp10_, _tmp11_);
#line 2209 "../src/Commands.vala"
			_tmp13_ = _tmp12_;
#line 2209 "../src/Commands.vala"
			_g_object_unref0 (_tmp13_);
#line 2209 "../src/Commands.vala"
			_g_object_unref0 (_tmp10_);
#line 2208 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20579 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp14_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _proxy_index = 0;
#line 2211 "../src/Commands.vala"
		_tmp14_ = self->priv->to_remove;
#line 2211 "../src/Commands.vala"
		_proxy_list = _tmp14_;
#line 2211 "../src/Commands.vala"
		_tmp15_ = _proxy_list;
#line 2211 "../src/Commands.vala"
		_tmp16_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2211 "../src/Commands.vala"
		_tmp17_ = _tmp16_;
#line 2211 "../src/Commands.vala"
		_proxy_size = _tmp17_;
#line 2211 "../src/Commands.vala"
		_proxy_index = -1;
#line 2211 "../src/Commands.vala"
		while (TRUE) {
#line 20606 "Commands.c"
			gint _tmp18_;
			gint _tmp19_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp20_;
			gpointer _tmp21_;
			SourceProxy* _tmp22_;
			DataSource* _tmp23_;
			Tag* _tmp24_;
			MediaSource* _tmp25_;
#line 2211 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2211 "../src/Commands.vala"
			_tmp18_ = _proxy_index;
#line 2211 "../src/Commands.vala"
			_tmp19_ = _proxy_size;
#line 2211 "../src/Commands.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 2211 "../src/Commands.vala"
				break;
#line 20626 "Commands.c"
			}
#line 2211 "../src/Commands.vala"
			_tmp20_ = _proxy_list;
#line 2211 "../src/Commands.vala"
			_tmp21_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2211 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp21_;
#line 2212 "../src/Commands.vala"
			_tmp22_ = proxy;
#line 2212 "../src/Commands.vala"
			_tmp23_ = source_proxy_get_source (_tmp22_);
#line 2212 "../src/Commands.vala"
			_tmp24_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_TAG, Tag);
#line 2212 "../src/Commands.vala"
			_tmp25_ = self->priv->media;
#line 2212 "../src/Commands.vala"
			tag_attach (_tmp24_, _tmp25_);
#line 2212 "../src/Commands.vala"
			_g_object_unref0 (_tmp24_);
#line 2211 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20648 "Commands.c"
		}
	}
}

static void
modify_tags_command_on_proxy_broken (ModifyTagsCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 2215 "../src/Commands.vala"
	g_return_if_fail (IS_MODIFY_TAGS_COMMAND (self));
#line 2216 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 2216 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2216 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 2216 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 20668 "Commands.c"
}

static void
modify_tags_command_class_init (ModifyTagsCommandClass * klass,
                                gpointer klass_data)
{
#line 2154 "../src/Commands.vala"
	modify_tags_command_parent_class = g_type_class_peek_parent (klass);
#line 2154 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &ModifyTagsCommand_private_offset);
#line 2154 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) modify_tags_command_real_execute;
#line 2154 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) modify_tags_command_real_undo;
#line 2154 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = modify_tags_command_finalize;
#line 20685 "Commands.c"
}

static void
modify_tags_command_instance_init (ModifyTagsCommand * self,
                                   gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 2154 "../src/Commands.vala"
	self->priv = modify_tags_command_get_instance_private (self);
#line 2156 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 2156 "../src/Commands.vala"
	self->priv->to_add = _tmp0_;
#line 2157 "../src/Commands.vala"
	_tmp1_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 2157 "../src/Commands.vala"
	self->priv->to_remove = _tmp1_;
#line 20704 "Commands.c"
}

static void
modify_tags_command_finalize (GObject * obj)
{
	ModifyTagsCommand * self;
#line 2154 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MODIFY_TAGS_COMMAND, ModifyTagsCommand);
#line 20713 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2192 "../src/Commands.vala"
		_tmp0_ = self->priv->to_add;
#line 2192 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2192 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2192 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2192 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2192 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2192 "../src/Commands.vala"
		_proxy_index = -1;
#line 2192 "../src/Commands.vala"
		while (TRUE) {
#line 20738 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			SourceProxy* _tmp8_;
			guint _tmp9_;
#line 2192 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2192 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2192 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2192 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2192 "../src/Commands.vala"
				break;
#line 20756 "Commands.c"
			}
#line 2192 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2192 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2192 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2193 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2193 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp9_, NULL, FALSE);
#line 2193 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _modify_tags_command_on_proxy_broken_source_proxy_broken, self);
#line 2192 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20772 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp10_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _proxy_index = 0;
#line 2195 "../src/Commands.vala"
		_tmp10_ = self->priv->to_remove;
#line 2195 "../src/Commands.vala"
		_proxy_list = _tmp10_;
#line 2195 "../src/Commands.vala"
		_tmp11_ = _proxy_list;
#line 2195 "../src/Commands.vala"
		_tmp12_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2195 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 2195 "../src/Commands.vala"
		_proxy_size = _tmp13_;
#line 2195 "../src/Commands.vala"
		_proxy_index = -1;
#line 2195 "../src/Commands.vala"
		while (TRUE) {
#line 20799 "Commands.c"
			gint _tmp14_;
			gint _tmp15_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp16_;
			gpointer _tmp17_;
			SourceProxy* _tmp18_;
			guint _tmp19_;
#line 2195 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2195 "../src/Commands.vala"
			_tmp14_ = _proxy_index;
#line 2195 "../src/Commands.vala"
			_tmp15_ = _proxy_size;
#line 2195 "../src/Commands.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 2195 "../src/Commands.vala"
				break;
#line 20817 "Commands.c"
			}
#line 2195 "../src/Commands.vala"
			_tmp16_ = _proxy_list;
#line 2195 "../src/Commands.vala"
			_tmp17_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2195 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp17_;
#line 2196 "../src/Commands.vala"
			_tmp18_ = proxy;
#line 2196 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp19_, NULL, FALSE);
#line 2196 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _modify_tags_command_on_proxy_broken_source_proxy_broken, self);
#line 2195 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 20833 "Commands.c"
		}
	}
#line 2155 "../src/Commands.vala"
	_g_object_unref0 (self->priv->media);
#line 2156 "../src/Commands.vala"
	_g_object_unref0 (self->priv->to_add);
#line 2157 "../src/Commands.vala"
	_g_object_unref0 (self->priv->to_remove);
#line 2154 "../src/Commands.vala"
	G_OBJECT_CLASS (modify_tags_command_parent_class)->finalize (obj);
#line 20844 "Commands.c"
}

static GType
modify_tags_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ModifyTagsCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) modify_tags_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ModifyTagsCommand), 0, (GInstanceInitFunc) modify_tags_command_instance_init, NULL };
	GType modify_tags_command_type_id;
	modify_tags_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "ModifyTagsCommand", &g_define_type_info, 0);
	ModifyTagsCommand_private_offset = g_type_add_instance_private (modify_tags_command_type_id, sizeof (ModifyTagsCommandPrivate));
	return modify_tags_command_type_id;
}

GType
modify_tags_command_get_type (void)
{
	static volatile gsize modify_tags_command_type_id__once = 0;
	if (g_once_init_enter (&modify_tags_command_type_id__once)) {
		GType modify_tags_command_type_id;
		modify_tags_command_type_id = modify_tags_command_get_type_once ();
		g_once_init_leave (&modify_tags_command_type_id__once, modify_tags_command_type_id);
	}
	return modify_tags_command_type_id__once;
}

static inline gpointer
tag_untag_photos_command_get_instance_private (TagUntagPhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, TagUntagPhotosCommand_private_offset);
}

static void
_tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                DataSource* source,
                                                                                gpointer self)
{
#line 2240 "../src/Commands.vala"
	tag_untag_photos_command_on_source_destroyed ((TagUntagPhotosCommand*) self, source);
#line 20882 "Commands.c"
}

TagUntagPhotosCommand*
tag_untag_photos_command_construct (GType object_type,
                                    Tag* tag,
                                    GeeCollection* sources,
                                    gint count,
                                    gboolean attach)
{
	TagUntagPhotosCommand * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GeeCollection* _tmp9_;
	LibraryPhotoSourceCollection* _tmp10_;
	VideoSourceCollection* _tmp11_;
#line 2226 "../src/Commands.vala"
	g_return_val_if_fail (IS_TAG (tag), NULL);
#line 2226 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 2228 "../src/Commands.vala"
	if (attach) {
#line 20905 "Commands.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 2228 "../src/Commands.vala"
		_tmp1_ = tag_get_user_visible_name (tag);
#line 2228 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 2228 "../src/Commands.vala"
		_tmp3_ = resources_tag_photos_label (_tmp2_, count);
#line 2228 "../src/Commands.vala"
		_g_free0 (_tmp0_);
#line 2228 "../src/Commands.vala"
		_tmp0_ = _tmp3_;
#line 2228 "../src/Commands.vala"
		_g_free0 (_tmp2_);
#line 20921 "Commands.c"
	} else {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 2229 "../src/Commands.vala"
		_tmp4_ = tag_get_user_visible_name (tag);
#line 2229 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 2229 "../src/Commands.vala"
		_tmp6_ = resources_untag_photos_label (_tmp5_, count);
#line 2229 "../src/Commands.vala"
		_g_free0 (_tmp0_);
#line 2229 "../src/Commands.vala"
		_tmp0_ = _tmp6_;
#line 2229 "../src/Commands.vala"
		_g_free0 (_tmp5_);
#line 20938 "Commands.c"
	}
#line 2227 "../src/Commands.vala"
	_tmp7_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_DATA_OBJECT, DataObject));
#line 2227 "../src/Commands.vala"
	_tmp8_ = _tmp7_;
#line 2227 "../src/Commands.vala"
	self = (TagUntagPhotosCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (tag, TYPE_PROXYABLE, Proxyable), _tmp0_, _tmp8_);
#line 2227 "../src/Commands.vala"
	_g_free0 (_tmp8_);
#line 2232 "../src/Commands.vala"
	_tmp9_ = _g_object_ref0 (sources);
#line 2232 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources);
#line 2232 "../src/Commands.vala"
	self->priv->sources = _tmp9_;
#line 2233 "../src/Commands.vala"
	self->priv->attach = attach;
#line 2235 "../src/Commands.vala"
	_tmp10_ = library_photo_global;
#line 2235 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 2236 "../src/Commands.vala"
	_tmp11_ = video_global;
#line 2236 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 2226 "../src/Commands.vala"
	_g_free0 (_tmp0_);
#line 2226 "../src/Commands.vala"
	return self;
#line 20968 "Commands.c"
}

TagUntagPhotosCommand*
tag_untag_photos_command_new (Tag* tag,
                              GeeCollection* sources,
                              gint count,
                              gboolean attach)
{
#line 2226 "../src/Commands.vala"
	return tag_untag_photos_command_construct (TYPE_TAG_UNTAG_PHOTOS_COMMAND, tag, sources, count, attach);
#line 20979 "Commands.c"
}

static void
tag_untag_photos_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                 DataSource* source)
{
	TagUntagPhotosCommand * self;
#line 2244 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommand);
#line 2244 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2245 "../src/Commands.vala"
	if (self->priv->attach) {
#line 2246 "../src/Commands.vala"
		tag_untag_photos_command_do_attach (self, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 20995 "Commands.c"
	} else {
#line 2248 "../src/Commands.vala"
		tag_untag_photos_command_do_detach (self, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 20999 "Commands.c"
	}
}

static void
tag_untag_photos_command_real_undo_on_source (SimpleProxyableCommand* base,
                                              DataSource* source)
{
	TagUntagPhotosCommand * self;
#line 2251 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommand);
#line 2251 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2252 "../src/Commands.vala"
	if (self->priv->attach) {
#line 2253 "../src/Commands.vala"
		tag_untag_photos_command_do_detach (self, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 21016 "Commands.c"
	} else {
#line 2255 "../src/Commands.vala"
		tag_untag_photos_command_do_attach (self, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_TAG, Tag));
#line 21020 "Commands.c"
	}
}

static void
tag_untag_photos_command_do_attach (TagUntagPhotosCommand* self,
                                    Tag* tag)
{
	GeeMultiMap* _tmp0_;
#line 2258 "../src/Commands.vala"
	g_return_if_fail (IS_TAG_UNTAG_PHOTOS_COMMAND (self));
#line 2258 "../src/Commands.vala"
	g_return_if_fail (IS_TAG (tag));
#line 2260 "../src/Commands.vala"
	_tmp0_ = self->priv->detached_from;
#line 2260 "../src/Commands.vala"
	if (_tmp0_ == NULL) {
#line 21037 "Commands.c"
		GeeCollection* _tmp1_;
		GeeArrayList* _tmp2_;
		Tag* curr_tmp = NULL;
		Tag* _tmp3_;
#line 2261 "../src/Commands.vala"
		_tmp1_ = self->priv->sources;
#line 2261 "../src/Commands.vala"
		tag_attach_many (tag, _tmp1_);
#line 2263 "../src/Commands.vala"
		_tmp2_ = gee_array_list_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 2263 "../src/Commands.vala"
		_g_object_unref0 (self->priv->attached_to);
#line 2263 "../src/Commands.vala"
		self->priv->attached_to = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 2265 "../src/Commands.vala"
		_tmp3_ = _g_object_ref0 (tag);
#line 2265 "../src/Commands.vala"
		curr_tmp = _tmp3_;
#line 2267 "../src/Commands.vala"
		while (TRUE) {
#line 21058 "Commands.c"
			Tag* _tmp4_;
			GeeList* _tmp5_;
			Tag* _tmp6_;
			Tag* _tmp7_;
			Tag* _tmp8_;
#line 2267 "../src/Commands.vala"
			_tmp4_ = curr_tmp;
#line 2267 "../src/Commands.vala"
			if (!(_tmp4_ != NULL)) {
#line 2267 "../src/Commands.vala"
				break;
#line 21070 "Commands.c"
			}
#line 2268 "../src/Commands.vala"
			_tmp5_ = self->priv->attached_to;
#line 2268 "../src/Commands.vala"
			_tmp6_ = curr_tmp;
#line 2268 "../src/Commands.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), _tmp6_);
#line 2269 "../src/Commands.vala"
			_tmp7_ = curr_tmp;
#line 2269 "../src/Commands.vala"
			_tmp8_ = tag_get_hierarchical_parent (_tmp7_);
#line 2269 "../src/Commands.vala"
			_g_object_unref0 (curr_tmp);
#line 2269 "../src/Commands.vala"
			curr_tmp = _tmp8_;
#line 21086 "Commands.c"
		}
#line 2272 "../src/Commands.vala"
		_g_object_unref0 (curr_tmp);
#line 2272 "../src/Commands.vala"
		return;
#line 21092 "Commands.c"
	}
	{
		GeeIterator* _detached_tag_it = NULL;
		GeeMultiMap* _tmp9_;
		GeeMultiSet* _tmp10_;
		GeeMultiSet* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 2276 "../src/Commands.vala"
		_tmp9_ = self->priv->detached_from;
#line 2276 "../src/Commands.vala"
		_tmp10_ = gee_multi_map_get_all_keys (_tmp9_);
#line 2276 "../src/Commands.vala"
		_tmp11_ = _tmp10_;
#line 2276 "../src/Commands.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2276 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 2276 "../src/Commands.vala"
		_g_object_unref0 (_tmp11_);
#line 2276 "../src/Commands.vala"
		_detached_tag_it = _tmp13_;
#line 2276 "../src/Commands.vala"
		while (TRUE) {
#line 21117 "Commands.c"
			GeeIterator* _tmp14_;
			Tag* detached_tag = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			Tag* _tmp17_;
			GeeMultiMap* _tmp18_;
			Tag* _tmp19_;
			GeeCollection* _tmp20_;
			GeeCollection* _tmp21_;
#line 2276 "../src/Commands.vala"
			_tmp14_ = _detached_tag_it;
#line 2276 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 2276 "../src/Commands.vala"
				break;
#line 21133 "Commands.c"
			}
#line 2276 "../src/Commands.vala"
			_tmp15_ = _detached_tag_it;
#line 2276 "../src/Commands.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 2276 "../src/Commands.vala"
			detached_tag = (Tag*) _tmp16_;
#line 2277 "../src/Commands.vala"
			_tmp17_ = detached_tag;
#line 2277 "../src/Commands.vala"
			_tmp18_ = self->priv->detached_from;
#line 2277 "../src/Commands.vala"
			_tmp19_ = detached_tag;
#line 2277 "../src/Commands.vala"
			_tmp20_ = gee_multi_map_get (_tmp18_, _tmp19_);
#line 2277 "../src/Commands.vala"
			_tmp21_ = _tmp20_;
#line 2277 "../src/Commands.vala"
			tag_attach_many (_tmp17_, _tmp21_);
#line 2277 "../src/Commands.vala"
			_g_object_unref0 (_tmp21_);
#line 2276 "../src/Commands.vala"
			_g_object_unref0 (detached_tag);
#line 21157 "Commands.c"
		}
#line 2276 "../src/Commands.vala"
		_g_object_unref0 (_detached_tag_it);
#line 21161 "Commands.c"
	}
#line 2279 "../src/Commands.vala"
	_g_object_unref0 (self->priv->detached_from);
#line 2279 "../src/Commands.vala"
	self->priv->detached_from = NULL;
#line 2280 "../src/Commands.vala"
	simple_proxyable_command_clear_added_proxies (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand));
#line 21169 "Commands.c"
}

static void
tag_untag_photos_command_do_detach (TagUntagPhotosCommand* self,
                                    Tag* tag)
{
	GeeList* _tmp0_;
#line 2283 "../src/Commands.vala"
	g_return_if_fail (IS_TAG_UNTAG_PHOTOS_COMMAND (self));
#line 2283 "../src/Commands.vala"
	g_return_if_fail (IS_TAG (tag));
#line 2284 "../src/Commands.vala"
	_tmp0_ = self->priv->attached_to;
#line 2284 "../src/Commands.vala"
	if (_tmp0_ == NULL) {
#line 21185 "Commands.c"
		GeeCollection* _tmp1_;
		GeeMultiMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 2288 "../src/Commands.vala"
		_tmp1_ = self->priv->sources;
#line 2288 "../src/Commands.vala"
		_tmp2_ = tag_detach_many (tag, _tmp1_);
#line 2288 "../src/Commands.vala"
		_g_object_unref0 (self->priv->detached_from);
#line 2288 "../src/Commands.vala"
		self->priv->detached_from = _tmp2_;
#line 2292 "../src/Commands.vala"
		_tmp3_ = self->priv->detached_from;
#line 2292 "../src/Commands.vala"
		_tmp4_ = gee_multi_map_get_keys (_tmp3_);
#line 2292 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 2292 "../src/Commands.vala"
		simple_proxyable_command_add_proxyables (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_SIMPLE_PROXYABLE_COMMAND, SimpleProxyableCommand), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2292 "../src/Commands.vala"
		_g_object_unref0 (_tmp5_);
#line 21209 "Commands.c"
	} else {
		{
			GeeList* _t_list = NULL;
			GeeList* _tmp6_;
			gint _t_size = 0;
			GeeList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _t_index = 0;
#line 2294 "../src/Commands.vala"
			_tmp6_ = self->priv->attached_to;
#line 2294 "../src/Commands.vala"
			_t_list = _tmp6_;
#line 2294 "../src/Commands.vala"
			_tmp7_ = _t_list;
#line 2294 "../src/Commands.vala"
			_tmp8_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2294 "../src/Commands.vala"
			_tmp9_ = _tmp8_;
#line 2294 "../src/Commands.vala"
			_t_size = _tmp9_;
#line 2294 "../src/Commands.vala"
			_t_index = -1;
#line 2294 "../src/Commands.vala"
			while (TRUE) {
#line 21235 "Commands.c"
				gint _tmp10_;
				gint _tmp11_;
				Tag* t = NULL;
				GeeList* _tmp12_;
				gpointer _tmp13_;
#line 2294 "../src/Commands.vala"
				_t_index = _t_index + 1;
#line 2294 "../src/Commands.vala"
				_tmp10_ = _t_index;
#line 2294 "../src/Commands.vala"
				_tmp11_ = _t_size;
#line 2294 "../src/Commands.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 2294 "../src/Commands.vala"
					break;
#line 21251 "Commands.c"
				}
#line 2294 "../src/Commands.vala"
				_tmp12_ = _t_list;
#line 2294 "../src/Commands.vala"
				_tmp13_ = gee_list_get (_tmp12_, _t_index);
#line 2294 "../src/Commands.vala"
				t = (Tag*) _tmp13_;
#line 21259 "Commands.c"
				{
					GeeIterator* _ms_it = NULL;
					GeeCollection* _tmp14_;
					GeeIterator* _tmp15_;
#line 2295 "../src/Commands.vala"
					_tmp14_ = self->priv->sources;
#line 2295 "../src/Commands.vala"
					_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2295 "../src/Commands.vala"
					_ms_it = _tmp15_;
#line 2295 "../src/Commands.vala"
					while (TRUE) {
#line 21272 "Commands.c"
						GeeIterator* _tmp16_;
						MediaSource* ms = NULL;
						GeeIterator* _tmp17_;
						gpointer _tmp18_;
						Tag* _tmp19_;
						MediaSource* _tmp20_;
#line 2295 "../src/Commands.vala"
						_tmp16_ = _ms_it;
#line 2295 "../src/Commands.vala"
						if (!gee_iterator_next (_tmp16_)) {
#line 2295 "../src/Commands.vala"
							break;
#line 21285 "Commands.c"
						}
#line 2295 "../src/Commands.vala"
						_tmp17_ = _ms_it;
#line 2295 "../src/Commands.vala"
						_tmp18_ = gee_iterator_get (_tmp17_);
#line 2295 "../src/Commands.vala"
						ms = (MediaSource*) _tmp18_;
#line 2297 "../src/Commands.vala"
						_tmp19_ = t;
#line 2297 "../src/Commands.vala"
						_tmp20_ = ms;
#line 2297 "../src/Commands.vala"
						if (tag_get_attachment_count (_tmp19_, _tmp20_) < 2) {
#line 21299 "Commands.c"
							Tag* _tmp21_;
							MediaSource* _tmp22_;
							GeeList* _tmp23_;
							GeeList* _tmp24_;
#line 2299 "../src/Commands.vala"
							_tmp21_ = t;
#line 2299 "../src/Commands.vala"
							_tmp22_ = ms;
#line 2299 "../src/Commands.vala"
							_tmp23_ = tag_detach (_tmp21_, _tmp22_);
#line 2299 "../src/Commands.vala"
							_tmp24_ = _tmp23_;
#line 2299 "../src/Commands.vala"
							_g_object_unref0 (_tmp24_);
#line 21314 "Commands.c"
						}
#line 2295 "../src/Commands.vala"
						_g_object_unref0 (ms);
#line 21318 "Commands.c"
					}
#line 2295 "../src/Commands.vala"
					_g_object_unref0 (_ms_it);
#line 21322 "Commands.c"
				}
#line 2294 "../src/Commands.vala"
				_g_object_unref0 (t);
#line 21326 "Commands.c"
			}
		}
	}
}

static void
tag_untag_photos_command_on_source_destroyed (TagUntagPhotosCommand* self,
                                              DataSource* source)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeCollection* _tmp2_;
#line 2306 "../src/Commands.vala"
	g_return_if_fail (IS_TAG_UNTAG_PHOTOS_COMMAND (self));
#line 2306 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2307 "../src/Commands.vala"
	_tmp0_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATA_OBJECT, DataObject));
#line 2307 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2307 "../src/Commands.vala"
	g_debug ("Commands.vala:2307: on_source_destroyed: %s", _tmp1_);
#line 2307 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2308 "../src/Commands.vala"
	_tmp2_ = self->priv->sources;
#line 2308 "../src/Commands.vala"
	if (gee_collection_contains (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource))) {
#line 21355 "Commands.c"
		CommandManager* _tmp3_;
		CommandManager* _tmp4_;
#line 2309 "../src/Commands.vala"
		_tmp3_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 2309 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2309 "../src/Commands.vala"
		command_manager_reset (_tmp4_);
#line 2309 "../src/Commands.vala"
		_command_manager_unref0 (_tmp4_);
#line 21366 "Commands.c"
	}
}

static void
tag_untag_photos_command_class_init (TagUntagPhotosCommandClass * klass,
                                     gpointer klass_data)
{
#line 2220 "../src/Commands.vala"
	tag_untag_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 2220 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &TagUntagPhotosCommand_private_offset);
#line 2220 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) tag_untag_photos_command_real_execute_on_source;
#line 2220 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) tag_untag_photos_command_real_undo_on_source;
#line 2220 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = tag_untag_photos_command_finalize;
#line 21384 "Commands.c"
}

static void
tag_untag_photos_command_instance_init (TagUntagPhotosCommand * self,
                                        gpointer klass)
{
#line 2220 "../src/Commands.vala"
	self->priv = tag_untag_photos_command_get_instance_private (self);
#line 2223 "../src/Commands.vala"
	self->priv->detached_from = NULL;
#line 2224 "../src/Commands.vala"
	self->priv->attached_to = NULL;
#line 21397 "Commands.c"
}

static void
tag_untag_photos_command_finalize (GObject * obj)
{
	TagUntagPhotosCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	VideoSourceCollection* _tmp2_;
	guint _tmp3_;
#line 2220 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAG_UNTAG_PHOTOS_COMMAND, TagUntagPhotosCommand);
#line 2240 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 2240 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 2240 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 2241 "../src/Commands.vala"
	_tmp2_ = video_global;
#line 2241 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 2241 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _tag_untag_photos_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 2221 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources);
#line 2223 "../src/Commands.vala"
	_g_object_unref0 (self->priv->detached_from);
#line 2224 "../src/Commands.vala"
	_g_object_unref0 (self->priv->attached_to);
#line 2220 "../src/Commands.vala"
	G_OBJECT_CLASS (tag_untag_photos_command_parent_class)->finalize (obj);
#line 21430 "Commands.c"
}

static GType
tag_untag_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TagUntagPhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tag_untag_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TagUntagPhotosCommand), 0, (GInstanceInitFunc) tag_untag_photos_command_instance_init, NULL };
	GType tag_untag_photos_command_type_id;
	tag_untag_photos_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "TagUntagPhotosCommand", &g_define_type_info, 0);
	TagUntagPhotosCommand_private_offset = g_type_add_instance_private (tag_untag_photos_command_type_id, sizeof (TagUntagPhotosCommandPrivate));
	return tag_untag_photos_command_type_id;
}

GType
tag_untag_photos_command_get_type (void)
{
	static volatile gsize tag_untag_photos_command_type_id__once = 0;
	if (g_once_init_enter (&tag_untag_photos_command_type_id__once)) {
		GType tag_untag_photos_command_type_id;
		tag_untag_photos_command_type_id = tag_untag_photos_command_get_type_once ();
		g_once_init_leave (&tag_untag_photos_command_type_id__once, tag_untag_photos_command_type_id);
	}
	return tag_untag_photos_command_type_id__once;
}

static inline gpointer
rename_saved_search_command_get_instance_private (RenameSavedSearchCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RenameSavedSearchCommand_private_offset);
}

RenameSavedSearchCommand*
rename_saved_search_command_construct (GType object_type,
                                       SavedSearch* search,
                                       const gchar* new_name)
{
	RenameSavedSearchCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SavedSearch* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 2318 "../src/Commands.vala"
	g_return_val_if_fail (IS_SAVED_SEARCH (search), NULL);
#line 2318 "../src/Commands.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 2319 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_OBJECT, DataObject));
#line 2319 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2319 "../src/Commands.vala"
	_tmp2_ = resources_rename_search_label (_tmp1_, new_name);
#line 2319 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2319 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_OBJECT, DataObject));
#line 2319 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2319 "../src/Commands.vala"
	self = (RenameSavedSearchCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_SOURCE, DataSource), _tmp3_, _tmp5_);
#line 2319 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2319 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 2319 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2321 "../src/Commands.vala"
	_tmp6_ = _g_object_ref0 (search);
#line 2321 "../src/Commands.vala"
	_g_object_unref0 (self->priv->search);
#line 2321 "../src/Commands.vala"
	self->priv->search = _tmp6_;
#line 2322 "../src/Commands.vala"
	_tmp7_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_OBJECT, DataObject));
#line 2322 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 2322 "../src/Commands.vala"
	self->priv->old_name = _tmp7_;
#line 2323 "../src/Commands.vala"
	_tmp8_ = g_strdup (new_name);
#line 2323 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 2323 "../src/Commands.vala"
	self->priv->new_name = _tmp8_;
#line 2318 "../src/Commands.vala"
	return self;
#line 21520 "Commands.c"
}

RenameSavedSearchCommand*
rename_saved_search_command_new (SavedSearch* search,
                                 const gchar* new_name)
{
#line 2318 "../src/Commands.vala"
	return rename_saved_search_command_construct (TYPE_RENAME_SAVED_SEARCH_COMMAND, search, new_name);
#line 21529 "Commands.c"
}

static void
rename_saved_search_command_real_execute (Command* base)
{
	RenameSavedSearchCommand * self;
	SavedSearch* _tmp0_;
	const gchar* _tmp1_;
#line 2326 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommand);
#line 2327 "../src/Commands.vala"
	_tmp0_ = self->priv->search;
#line 2327 "../src/Commands.vala"
	_tmp1_ = self->priv->new_name;
#line 2327 "../src/Commands.vala"
	if (!saved_search_rename (_tmp0_, _tmp1_)) {
#line 21546 "Commands.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2328 "../src/Commands.vala"
		_tmp2_ = self->priv->new_name;
#line 2328 "../src/Commands.vala"
		_tmp3_ = resources_rename_search_exists_message (_tmp2_);
#line 2328 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2328 "../src/Commands.vala"
		app_window_error_message (_tmp4_, NULL);
#line 2328 "../src/Commands.vala"
		_g_free0 (_tmp4_);
#line 21560 "Commands.c"
	}
}

static void
rename_saved_search_command_real_undo (Command* base)
{
	RenameSavedSearchCommand * self;
	SavedSearch* _tmp0_;
	const gchar* _tmp1_;
#line 2331 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommand);
#line 2332 "../src/Commands.vala"
	_tmp0_ = self->priv->search;
#line 2332 "../src/Commands.vala"
	_tmp1_ = self->priv->old_name;
#line 2332 "../src/Commands.vala"
	if (!saved_search_rename (_tmp0_, _tmp1_)) {
#line 21578 "Commands.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2333 "../src/Commands.vala"
		_tmp2_ = self->priv->old_name;
#line 2333 "../src/Commands.vala"
		_tmp3_ = resources_rename_search_exists_message (_tmp2_);
#line 2333 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2333 "../src/Commands.vala"
		app_window_error_message (_tmp4_, NULL);
#line 2333 "../src/Commands.vala"
		_g_free0 (_tmp4_);
#line 21592 "Commands.c"
	}
}

static void
rename_saved_search_command_class_init (RenameSavedSearchCommandClass * klass,
                                        gpointer klass_data)
{
#line 2313 "../src/Commands.vala"
	rename_saved_search_command_parent_class = g_type_class_peek_parent (klass);
#line 2313 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RenameSavedSearchCommand_private_offset);
#line 2313 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) rename_saved_search_command_real_execute;
#line 2313 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) rename_saved_search_command_real_undo;
#line 2313 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rename_saved_search_command_finalize;
#line 21610 "Commands.c"
}

static void
rename_saved_search_command_instance_init (RenameSavedSearchCommand * self,
                                           gpointer klass)
{
#line 2313 "../src/Commands.vala"
	self->priv = rename_saved_search_command_get_instance_private (self);
#line 21619 "Commands.c"
}

static void
rename_saved_search_command_finalize (GObject * obj)
{
	RenameSavedSearchCommand * self;
#line 2313 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RENAME_SAVED_SEARCH_COMMAND, RenameSavedSearchCommand);
#line 2314 "../src/Commands.vala"
	_g_object_unref0 (self->priv->search);
#line 2315 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 2316 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 2313 "../src/Commands.vala"
	G_OBJECT_CLASS (rename_saved_search_command_parent_class)->finalize (obj);
#line 21636 "Commands.c"
}

static GType
rename_saved_search_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RenameSavedSearchCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rename_saved_search_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RenameSavedSearchCommand), 0, (GInstanceInitFunc) rename_saved_search_command_instance_init, NULL };
	GType rename_saved_search_command_type_id;
	rename_saved_search_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "RenameSavedSearchCommand", &g_define_type_info, 0);
	RenameSavedSearchCommand_private_offset = g_type_add_instance_private (rename_saved_search_command_type_id, sizeof (RenameSavedSearchCommandPrivate));
	return rename_saved_search_command_type_id;
}

GType
rename_saved_search_command_get_type (void)
{
	static volatile gsize rename_saved_search_command_type_id__once = 0;
	if (g_once_init_enter (&rename_saved_search_command_type_id__once)) {
		GType rename_saved_search_command_type_id;
		rename_saved_search_command_type_id = rename_saved_search_command_get_type_once ();
		g_once_init_leave (&rename_saved_search_command_type_id__once, rename_saved_search_command_type_id);
	}
	return rename_saved_search_command_type_id__once;
}

static inline gpointer
delete_saved_search_command_get_instance_private (DeleteSavedSearchCommand* self)
{
	return G_STRUCT_MEMBER_P (self, DeleteSavedSearchCommand_private_offset);
}

DeleteSavedSearchCommand*
delete_saved_search_command_construct (GType object_type,
                                       SavedSearch* search)
{
	DeleteSavedSearchCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	SavedSearch* _tmp6_;
#line 2340 "../src/Commands.vala"
	g_return_val_if_fail (IS_SAVED_SEARCH (search), NULL);
#line 2341 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_OBJECT, DataObject));
#line 2341 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2341 "../src/Commands.vala"
	_tmp2_ = resources_delete_search_label (_tmp1_);
#line 2341 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2341 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_OBJECT, DataObject));
#line 2341 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2341 "../src/Commands.vala"
	self = (DeleteSavedSearchCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (search, TYPE_DATA_SOURCE, DataSource), _tmp3_, _tmp5_);
#line 2341 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2341 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 2341 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2343 "../src/Commands.vala"
	_tmp6_ = _g_object_ref0 (search);
#line 2343 "../src/Commands.vala"
	_g_object_unref0 (self->priv->search);
#line 2343 "../src/Commands.vala"
	self->priv->search = _tmp6_;
#line 2340 "../src/Commands.vala"
	return self;
#line 21709 "Commands.c"
}

DeleteSavedSearchCommand*
delete_saved_search_command_new (SavedSearch* search)
{
#line 2340 "../src/Commands.vala"
	return delete_saved_search_command_construct (TYPE_DELETE_SAVED_SEARCH_COMMAND, search);
#line 21717 "Commands.c"
}

static void
delete_saved_search_command_real_execute (Command* base)
{
	DeleteSavedSearchCommand * self;
	SavedSearchTable* _tmp0_;
	SavedSearchTable* _tmp1_;
	SavedSearch* _tmp2_;
#line 2346 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand);
#line 2347 "../src/Commands.vala"
	_tmp0_ = saved_search_table_get_instance ();
#line 2347 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2347 "../src/Commands.vala"
	_tmp2_ = self->priv->search;
#line 2347 "../src/Commands.vala"
	saved_search_table_remove (_tmp1_, _tmp2_);
#line 2347 "../src/Commands.vala"
	_saved_search_table_unref0 (_tmp1_);
#line 21739 "Commands.c"
}

static void
delete_saved_search_command_real_undo (Command* base)
{
	DeleteSavedSearchCommand * self;
	SavedSearch* _tmp0_;
#line 2350 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand);
#line 2351 "../src/Commands.vala"
	_tmp0_ = self->priv->search;
#line 2351 "../src/Commands.vala"
	saved_search_reconstitute (_tmp0_);
#line 21753 "Commands.c"
}

static void
delete_saved_search_command_class_init (DeleteSavedSearchCommandClass * klass,
                                        gpointer klass_data)
{
#line 2337 "../src/Commands.vala"
	delete_saved_search_command_parent_class = g_type_class_peek_parent (klass);
#line 2337 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &DeleteSavedSearchCommand_private_offset);
#line 2337 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) delete_saved_search_command_real_execute;
#line 2337 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) delete_saved_search_command_real_undo;
#line 2337 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = delete_saved_search_command_finalize;
#line 21770 "Commands.c"
}

static void
delete_saved_search_command_instance_init (DeleteSavedSearchCommand * self,
                                           gpointer klass)
{
#line 2337 "../src/Commands.vala"
	self->priv = delete_saved_search_command_get_instance_private (self);
#line 21779 "Commands.c"
}

static void
delete_saved_search_command_finalize (GObject * obj)
{
	DeleteSavedSearchCommand * self;
#line 2337 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELETE_SAVED_SEARCH_COMMAND, DeleteSavedSearchCommand);
#line 2338 "../src/Commands.vala"
	_g_object_unref0 (self->priv->search);
#line 2337 "../src/Commands.vala"
	G_OBJECT_CLASS (delete_saved_search_command_parent_class)->finalize (obj);
#line 21792 "Commands.c"
}

static GType
delete_saved_search_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeleteSavedSearchCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delete_saved_search_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeleteSavedSearchCommand), 0, (GInstanceInitFunc) delete_saved_search_command_instance_init, NULL };
	GType delete_saved_search_command_type_id;
	delete_saved_search_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "DeleteSavedSearchCommand", &g_define_type_info, 0);
	DeleteSavedSearchCommand_private_offset = g_type_add_instance_private (delete_saved_search_command_type_id, sizeof (DeleteSavedSearchCommandPrivate));
	return delete_saved_search_command_type_id;
}

GType
delete_saved_search_command_get_type (void)
{
	static volatile gsize delete_saved_search_command_type_id__once = 0;
	if (g_once_init_enter (&delete_saved_search_command_type_id__once)) {
		GType delete_saved_search_command_type_id;
		delete_saved_search_command_type_id = delete_saved_search_command_get_type_once ();
		g_once_init_leave (&delete_saved_search_command_type_id__once, delete_saved_search_command_type_id);
	}
	return delete_saved_search_command_type_id__once;
}

static inline gpointer
trash_untrash_photos_command_get_instance_private (TrashUntrashPhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, TrashUntrashPhotosCommand_private_offset);
}

static void
_trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                   DataSource* source,
                                                                                   gpointer self)
{
#line 2372 "../src/Commands.vala"
	trash_untrash_photos_command_on_photo_destroyed ((TrashUntrashPhotosCommand*) self, source);
#line 21830 "Commands.c"
}

TrashUntrashPhotosCommand*
trash_untrash_photos_command_construct (GType object_type,
                                        GeeCollection* sources,
                                        gboolean to_trash)
{
	TrashUntrashPhotosCommand * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GeeCollection* _tmp2_;
	LibraryPhotoSourceCollection* _tmp3_;
	VideoSourceCollection* _tmp4_;
#line 2359 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 2361 "../src/Commands.vala"
	if (to_trash) {
#line 2361 "../src/Commands.vala"
		_tmp0_ = _ ("Move Photos to Trash");
#line 21850 "Commands.c"
	} else {
#line 2361 "../src/Commands.vala"
		_tmp0_ = _ ("Restore Photos from Trash");
#line 21854 "Commands.c"
	}
#line 2362 "../src/Commands.vala"
	if (to_trash) {
#line 2362 "../src/Commands.vala"
		_tmp1_ = _ ("Move the photos to the Shotwell trash");
#line 21860 "Commands.c"
	} else {
#line 2362 "../src/Commands.vala"
		_tmp1_ = _ ("Restore the photos back to the Shotwell library");
#line 21864 "Commands.c"
	}
#line 2360 "../src/Commands.vala"
	self = (TrashUntrashPhotosCommand*) page_command_construct (object_type, _tmp0_, _tmp1_);
#line 2364 "../src/Commands.vala"
	_tmp2_ = _g_object_ref0 (sources);
#line 2364 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources);
#line 2364 "../src/Commands.vala"
	self->priv->sources = _tmp2_;
#line 2365 "../src/Commands.vala"
	self->priv->to_trash = to_trash;
#line 2367 "../src/Commands.vala"
	_tmp3_ = library_photo_global;
#line 2367 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed, self, 0);
#line 2368 "../src/Commands.vala"
	_tmp4_ = video_global;
#line 2368 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed, self, 0);
#line 2359 "../src/Commands.vala"
	return self;
#line 21886 "Commands.c"
}

TrashUntrashPhotosCommand*
trash_untrash_photos_command_new (GeeCollection* sources,
                                  gboolean to_trash)
{
#line 2359 "../src/Commands.vala"
	return trash_untrash_photos_command_construct (TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, sources, to_trash);
#line 21895 "Commands.c"
}

static ProgressDialog*
trash_untrash_photos_command_get_progress_dialog (TrashUntrashPhotosCommand* self,
                                                  gboolean to_trash)
{
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_ = NULL;
	ProgressDialog* dialog = NULL;
	AppWindow* _tmp4_;
	AppWindow* _tmp5_;
	ProgressDialog* _tmp6_;
	ProgressDialog* _tmp7_;
	ProgressDialog* _tmp8_;
	GeeCollection* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	ProgressDialog* result;
#line 2376 "../src/Commands.vala"
	g_return_val_if_fail (IS_TRASH_UNTRASH_PHOTOS_COMMAND (self), NULL);
#line 2377 "../src/Commands.vala"
	_tmp0_ = self->priv->sources;
#line 2377 "../src/Commands.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 2377 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 2377 "../src/Commands.vala"
	if (_tmp2_ <= 5) {
#line 2378 "../src/Commands.vala"
		result = NULL;
#line 2378 "../src/Commands.vala"
		return result;
#line 21930 "Commands.c"
	}
#line 2381 "../src/Commands.vala"
	if (to_trash) {
#line 2381 "../src/Commands.vala"
		_tmp3_ = _ ("Moving Photos to Trash");
#line 21936 "Commands.c"
	} else {
#line 2381 "../src/Commands.vala"
		_tmp3_ = _ ("Restoring Photos From Trash");
#line 21940 "Commands.c"
	}
#line 2380 "../src/Commands.vala"
	_tmp4_ = app_window_get_instance ();
#line 2380 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2380 "../src/Commands.vala"
	_tmp6_ = progress_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_window_get_type (), GtkWindow), _tmp3_, NULL);
#line 2380 "../src/Commands.vala"
	g_object_ref_sink (_tmp6_);
#line 2380 "../src/Commands.vala"
	_tmp7_ = _tmp6_;
#line 2380 "../src/Commands.vala"
	_g_object_unref0 (_tmp5_);
#line 2380 "../src/Commands.vala"
	dialog = _tmp7_;
#line 2382 "../src/Commands.vala"
	_tmp8_ = dialog;
#line 2382 "../src/Commands.vala"
	_tmp9_ = self->priv->sources;
#line 2382 "../src/Commands.vala"
	_tmp10_ = gee_collection_get_size (_tmp9_);
#line 2382 "../src/Commands.vala"
	_tmp11_ = _tmp10_;
#line 2382 "../src/Commands.vala"
	progress_dialog_update_display_every (_tmp8_, CLAMP (_tmp11_ / 5, 2, 10));
#line 2384 "../src/Commands.vala"
	result = dialog;
#line 2384 "../src/Commands.vala"
	return result;
#line 21970 "Commands.c"
}

static gboolean
_progress_dialog_monitor_progress_monitor (guint64 current,
                                           guint64 total,
                                           gboolean do_event_loop,
                                           gpointer self)
{
	gboolean result;
	result = progress_dialog_monitor ((ProgressDialog*) self, current, total, do_event_loop);
#line 2392 "../src/Commands.vala"
	return result;
#line 21983 "Commands.c"
}

static void
trash_untrash_photos_command_real_execute (Command* base)
{
	TrashUntrashPhotosCommand * self;
	ProgressDialog* dialog = NULL;
	ProgressDialog* _tmp0_;
	ProgressMonitor monitor = NULL;
	gpointer monitor_target;
	GDestroyNotify monitor_target_destroy_notify;
	ProgressDialog* _tmp1_;
	ProgressDialog* _tmp5_;
#line 2387 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommand);
#line 2388 "../src/Commands.vala"
	_tmp0_ = trash_untrash_photos_command_get_progress_dialog (self, self->priv->to_trash);
#line 2388 "../src/Commands.vala"
	dialog = _tmp0_;
#line 2390 "../src/Commands.vala"
	monitor = NULL;
#line 2390 "../src/Commands.vala"
	monitor_target = NULL;
#line 2390 "../src/Commands.vala"
	monitor_target_destroy_notify = NULL;
#line 2391 "../src/Commands.vala"
	_tmp1_ = dialog;
#line 2391 "../src/Commands.vala"
	if (_tmp1_ != NULL) {
#line 22013 "Commands.c"
		ProgressDialog* _tmp2_;
#line 2392 "../src/Commands.vala"
		_tmp2_ = dialog;
#line 2392 "../src/Commands.vala"
		(monitor_target_destroy_notify == NULL) ? NULL : (monitor_target_destroy_notify (monitor_target), NULL);
#line 2392 "../src/Commands.vala"
		monitor = NULL;
#line 2392 "../src/Commands.vala"
		monitor_target = NULL;
#line 2392 "../src/Commands.vala"
		monitor_target_destroy_notify = NULL;
#line 2392 "../src/Commands.vala"
		monitor = _progress_dialog_monitor_progress_monitor;
#line 2392 "../src/Commands.vala"
		monitor_target = g_object_ref (_tmp2_);
#line 2392 "../src/Commands.vala"
		monitor_target_destroy_notify = g_object_unref;
#line 22031 "Commands.c"
	}
#line 2394 "../src/Commands.vala"
	if (self->priv->to_trash) {
#line 22035 "Commands.c"
		ProgressMonitor _tmp3_;
		gpointer _tmp3__target;
#line 2395 "../src/Commands.vala"
		_tmp3_ = monitor;
#line 2395 "../src/Commands.vala"
		_tmp3__target = monitor_target;
#line 2395 "../src/Commands.vala"
		trash_untrash_photos_command_trash (self, _tmp3_, _tmp3__target);
#line 22044 "Commands.c"
	} else {
		ProgressMonitor _tmp4_;
		gpointer _tmp4__target;
#line 2397 "../src/Commands.vala"
		_tmp4_ = monitor;
#line 2397 "../src/Commands.vala"
		_tmp4__target = monitor_target;
#line 2397 "../src/Commands.vala"
		trash_untrash_photos_command_untrash (self, _tmp4_, _tmp4__target);
#line 22054 "Commands.c"
	}
#line 2399 "../src/Commands.vala"
	_tmp5_ = dialog;
#line 2399 "../src/Commands.vala"
	if (_tmp5_ != NULL) {
#line 22060 "Commands.c"
		ProgressDialog* _tmp6_;
#line 2400 "../src/Commands.vala"
		_tmp6_ = dialog;
#line 2400 "../src/Commands.vala"
		progress_dialog_close (_tmp6_);
#line 22066 "Commands.c"
	}
#line 2387 "../src/Commands.vala"
	(monitor_target_destroy_notify == NULL) ? NULL : (monitor_target_destroy_notify (monitor_target), NULL);
#line 2387 "../src/Commands.vala"
	monitor = NULL;
#line 2387 "../src/Commands.vala"
	monitor_target = NULL;
#line 2387 "../src/Commands.vala"
	monitor_target_destroy_notify = NULL;
#line 2387 "../src/Commands.vala"
	_g_object_unref0 (dialog);
#line 22078 "Commands.c"
}

static void
trash_untrash_photos_command_real_undo (Command* base)
{
	TrashUntrashPhotosCommand * self;
	ProgressDialog* dialog = NULL;
	ProgressDialog* _tmp0_;
	ProgressMonitor monitor = NULL;
	gpointer monitor_target;
	GDestroyNotify monitor_target_destroy_notify;
	ProgressDialog* _tmp1_;
	ProgressDialog* _tmp5_;
#line 2403 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommand);
#line 2404 "../src/Commands.vala"
	_tmp0_ = trash_untrash_photos_command_get_progress_dialog (self, !self->priv->to_trash);
#line 2404 "../src/Commands.vala"
	dialog = _tmp0_;
#line 2406 "../src/Commands.vala"
	monitor = NULL;
#line 2406 "../src/Commands.vala"
	monitor_target = NULL;
#line 2406 "../src/Commands.vala"
	monitor_target_destroy_notify = NULL;
#line 2407 "../src/Commands.vala"
	_tmp1_ = dialog;
#line 2407 "../src/Commands.vala"
	if (_tmp1_ != NULL) {
#line 22108 "Commands.c"
		ProgressDialog* _tmp2_;
#line 2408 "../src/Commands.vala"
		_tmp2_ = dialog;
#line 2408 "../src/Commands.vala"
		(monitor_target_destroy_notify == NULL) ? NULL : (monitor_target_destroy_notify (monitor_target), NULL);
#line 2408 "../src/Commands.vala"
		monitor = NULL;
#line 2408 "../src/Commands.vala"
		monitor_target = NULL;
#line 2408 "../src/Commands.vala"
		monitor_target_destroy_notify = NULL;
#line 2408 "../src/Commands.vala"
		monitor = _progress_dialog_monitor_progress_monitor;
#line 2408 "../src/Commands.vala"
		monitor_target = g_object_ref (_tmp2_);
#line 2408 "../src/Commands.vala"
		monitor_target_destroy_notify = g_object_unref;
#line 22126 "Commands.c"
	}
#line 2410 "../src/Commands.vala"
	if (self->priv->to_trash) {
#line 22130 "Commands.c"
		ProgressMonitor _tmp3_;
		gpointer _tmp3__target;
#line 2411 "../src/Commands.vala"
		_tmp3_ = monitor;
#line 2411 "../src/Commands.vala"
		_tmp3__target = monitor_target;
#line 2411 "../src/Commands.vala"
		trash_untrash_photos_command_untrash (self, _tmp3_, _tmp3__target);
#line 22139 "Commands.c"
	} else {
		ProgressMonitor _tmp4_;
		gpointer _tmp4__target;
#line 2413 "../src/Commands.vala"
		_tmp4_ = monitor;
#line 2413 "../src/Commands.vala"
		_tmp4__target = monitor_target;
#line 2413 "../src/Commands.vala"
		trash_untrash_photos_command_trash (self, _tmp4_, _tmp4__target);
#line 22149 "Commands.c"
	}
#line 2415 "../src/Commands.vala"
	_tmp5_ = dialog;
#line 2415 "../src/Commands.vala"
	if (_tmp5_ != NULL) {
#line 22155 "Commands.c"
		ProgressDialog* _tmp6_;
#line 2416 "../src/Commands.vala"
		_tmp6_ = dialog;
#line 2416 "../src/Commands.vala"
		progress_dialog_close (_tmp6_);
#line 22161 "Commands.c"
	}
#line 2403 "../src/Commands.vala"
	(monitor_target_destroy_notify == NULL) ? NULL : (monitor_target_destroy_notify (monitor_target), NULL);
#line 2403 "../src/Commands.vala"
	monitor = NULL;
#line 2403 "../src/Commands.vala"
	monitor_target = NULL;
#line 2403 "../src/Commands.vala"
	monitor_target_destroy_notify = NULL;
#line 2403 "../src/Commands.vala"
	_g_object_unref0 (dialog);
#line 22173 "Commands.c"
}

static void
trash_untrash_photos_command_trash (TrashUntrashPhotosCommand* self,
                                    ProgressMonitor monitor,
                                    gpointer monitor_target)
{
	gint ctr = 0;
	gint count = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	LibraryPhotoSourceCollection* _tmp3_;
	TransactionController* _tmp4_;
	TransactionController* _tmp5_;
	VideoSourceCollection* _tmp6_;
	TransactionController* _tmp7_;
	TransactionController* _tmp8_;
	LibraryPhotoSourceCollection* _tmp18_;
	TransactionController* _tmp19_;
	TransactionController* _tmp20_;
	VideoSourceCollection* _tmp21_;
	TransactionController* _tmp22_;
	TransactionController* _tmp23_;
#line 2419 "../src/Commands.vala"
	g_return_if_fail (IS_TRASH_UNTRASH_PHOTOS_COMMAND (self));
#line 2420 "../src/Commands.vala"
	ctr = 0;
#line 2421 "../src/Commands.vala"
	_tmp0_ = self->priv->sources;
#line 2421 "../src/Commands.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 2421 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 2421 "../src/Commands.vala"
	count = _tmp2_;
#line 2423 "../src/Commands.vala"
	_tmp3_ = library_photo_global;
#line 2423 "../src/Commands.vala"
	_tmp4_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2423 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2423 "../src/Commands.vala"
	transaction_controller_begin (_tmp5_);
#line 2424 "../src/Commands.vala"
	_tmp6_ = video_global;
#line 2424 "../src/Commands.vala"
	_tmp7_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2424 "../src/Commands.vala"
	_tmp8_ = _tmp7_;
#line 2424 "../src/Commands.vala"
	transaction_controller_begin (_tmp8_);
#line 22226 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
#line 2426 "../src/Commands.vala"
		_tmp9_ = self->priv->sources;
#line 2426 "../src/Commands.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2426 "../src/Commands.vala"
		_source_it = _tmp10_;
#line 2426 "../src/Commands.vala"
		while (TRUE) {
#line 22239 "Commands.c"
			GeeIterator* _tmp11_;
			MediaSource* source = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MediaSource* _tmp14_;
#line 2426 "../src/Commands.vala"
			_tmp11_ = _source_it;
#line 2426 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 2426 "../src/Commands.vala"
				break;
#line 22251 "Commands.c"
			}
#line 2426 "../src/Commands.vala"
			_tmp12_ = _source_it;
#line 2426 "../src/Commands.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 2426 "../src/Commands.vala"
			source = (MediaSource*) _tmp13_;
#line 2427 "../src/Commands.vala"
			_tmp14_ = source;
#line 2427 "../src/Commands.vala"
			media_source_trash (_tmp14_);
#line 2428 "../src/Commands.vala"
			if (monitor != NULL) {
#line 22265 "Commands.c"
				ProgressMonitor _tmp15_;
				gpointer _tmp15__target;
				gint _tmp16_;
				gint _tmp17_;
#line 2429 "../src/Commands.vala"
				_tmp15_ = monitor;
#line 2429 "../src/Commands.vala"
				_tmp15__target = monitor_target;
#line 2429 "../src/Commands.vala"
				ctr = ctr + 1;
#line 2429 "../src/Commands.vala"
				_tmp16_ = ctr;
#line 2429 "../src/Commands.vala"
				_tmp17_ = count;
#line 2429 "../src/Commands.vala"
				_tmp15_ ((guint64) _tmp16_, (guint64) _tmp17_, TRUE, _tmp15__target);
#line 22282 "Commands.c"
			}
#line 2426 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 22286 "Commands.c"
		}
#line 2426 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 22290 "Commands.c"
	}
#line 2432 "../src/Commands.vala"
	_tmp18_ = library_photo_global;
#line 2432 "../src/Commands.vala"
	_tmp19_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2432 "../src/Commands.vala"
	_tmp20_ = _tmp19_;
#line 2432 "../src/Commands.vala"
	transaction_controller_commit (_tmp20_);
#line 2433 "../src/Commands.vala"
	_tmp21_ = video_global;
#line 2433 "../src/Commands.vala"
	_tmp22_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2433 "../src/Commands.vala"
	_tmp23_ = _tmp22_;
#line 2433 "../src/Commands.vala"
	transaction_controller_commit (_tmp23_);
#line 22308 "Commands.c"
}

static void
trash_untrash_photos_command_untrash (TrashUntrashPhotosCommand* self,
                                      ProgressMonitor monitor,
                                      gpointer monitor_target)
{
	gint ctr = 0;
	gint count = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	LibraryPhotoSourceCollection* _tmp3_;
	TransactionController* _tmp4_;
	TransactionController* _tmp5_;
	VideoSourceCollection* _tmp6_;
	TransactionController* _tmp7_;
	TransactionController* _tmp8_;
	LibraryPhotoSourceCollection* _tmp18_;
	TransactionController* _tmp19_;
	TransactionController* _tmp20_;
	VideoSourceCollection* _tmp21_;
	TransactionController* _tmp22_;
	TransactionController* _tmp23_;
#line 2436 "../src/Commands.vala"
	g_return_if_fail (IS_TRASH_UNTRASH_PHOTOS_COMMAND (self));
#line 2437 "../src/Commands.vala"
	ctr = 0;
#line 2438 "../src/Commands.vala"
	_tmp0_ = self->priv->sources;
#line 2438 "../src/Commands.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 2438 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 2438 "../src/Commands.vala"
	count = _tmp2_;
#line 2440 "../src/Commands.vala"
	_tmp3_ = library_photo_global;
#line 2440 "../src/Commands.vala"
	_tmp4_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2440 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2440 "../src/Commands.vala"
	transaction_controller_begin (_tmp5_);
#line 2441 "../src/Commands.vala"
	_tmp6_ = video_global;
#line 2441 "../src/Commands.vala"
	_tmp7_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2441 "../src/Commands.vala"
	_tmp8_ = _tmp7_;
#line 2441 "../src/Commands.vala"
	transaction_controller_begin (_tmp8_);
#line 22361 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
#line 2443 "../src/Commands.vala"
		_tmp9_ = self->priv->sources;
#line 2443 "../src/Commands.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2443 "../src/Commands.vala"
		_source_it = _tmp10_;
#line 2443 "../src/Commands.vala"
		while (TRUE) {
#line 22374 "Commands.c"
			GeeIterator* _tmp11_;
			MediaSource* source = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			MediaSource* _tmp14_;
#line 2443 "../src/Commands.vala"
			_tmp11_ = _source_it;
#line 2443 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 2443 "../src/Commands.vala"
				break;
#line 22386 "Commands.c"
			}
#line 2443 "../src/Commands.vala"
			_tmp12_ = _source_it;
#line 2443 "../src/Commands.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 2443 "../src/Commands.vala"
			source = (MediaSource*) _tmp13_;
#line 2444 "../src/Commands.vala"
			_tmp14_ = source;
#line 2444 "../src/Commands.vala"
			media_source_untrash (_tmp14_);
#line 2445 "../src/Commands.vala"
			if (monitor != NULL) {
#line 22400 "Commands.c"
				ProgressMonitor _tmp15_;
				gpointer _tmp15__target;
				gint _tmp16_;
				gint _tmp17_;
#line 2446 "../src/Commands.vala"
				_tmp15_ = monitor;
#line 2446 "../src/Commands.vala"
				_tmp15__target = monitor_target;
#line 2446 "../src/Commands.vala"
				ctr = ctr + 1;
#line 2446 "../src/Commands.vala"
				_tmp16_ = ctr;
#line 2446 "../src/Commands.vala"
				_tmp17_ = count;
#line 2446 "../src/Commands.vala"
				_tmp15_ ((guint64) _tmp16_, (guint64) _tmp17_, TRUE, _tmp15__target);
#line 22417 "Commands.c"
			}
#line 2443 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 22421 "Commands.c"
		}
#line 2443 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 22425 "Commands.c"
	}
#line 2449 "../src/Commands.vala"
	_tmp18_ = library_photo_global;
#line 2449 "../src/Commands.vala"
	_tmp19_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2449 "../src/Commands.vala"
	_tmp20_ = _tmp19_;
#line 2449 "../src/Commands.vala"
	transaction_controller_commit (_tmp20_);
#line 2450 "../src/Commands.vala"
	_tmp21_ = video_global;
#line 2450 "../src/Commands.vala"
	_tmp22_ = media_source_collection_get_transaction_controller (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 2450 "../src/Commands.vala"
	_tmp23_ = _tmp22_;
#line 2450 "../src/Commands.vala"
	transaction_controller_commit (_tmp23_);
#line 22443 "Commands.c"
}

static void
trash_untrash_photos_command_on_photo_destroyed (TrashUntrashPhotosCommand* self,
                                                 DataSource* source)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 2453 "../src/Commands.vala"
	g_return_if_fail (IS_TRASH_UNTRASH_PHOTOS_COMMAND (self));
#line 2453 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2456 "../src/Commands.vala"
	_tmp0_ = self->priv->sources;
#line 2456 "../src/Commands.vala"
	gee_collection_remove (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 2460 "../src/Commands.vala"
	_tmp1_ = self->priv->sources;
#line 2460 "../src/Commands.vala"
	_tmp2_ = gee_collection_get_size (_tmp1_);
#line 2460 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2460 "../src/Commands.vala"
	if (_tmp3_ == 0) {
#line 22470 "Commands.c"
		CommandManager* _tmp4_;
		CommandManager* _tmp5_;
#line 2461 "../src/Commands.vala"
		_tmp4_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 2461 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 2461 "../src/Commands.vala"
		command_manager_reset (_tmp5_);
#line 2461 "../src/Commands.vala"
		_command_manager_unref0 (_tmp5_);
#line 22481 "Commands.c"
	}
}

static void
trash_untrash_photos_command_class_init (TrashUntrashPhotosCommandClass * klass,
                                         gpointer klass_data)
{
#line 2355 "../src/Commands.vala"
	trash_untrash_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 2355 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &TrashUntrashPhotosCommand_private_offset);
#line 2355 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) trash_untrash_photos_command_real_execute;
#line 2355 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) trash_untrash_photos_command_real_undo;
#line 2355 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = trash_untrash_photos_command_finalize;
#line 22499 "Commands.c"
}

static void
trash_untrash_photos_command_instance_init (TrashUntrashPhotosCommand * self,
                                            gpointer klass)
{
#line 2355 "../src/Commands.vala"
	self->priv = trash_untrash_photos_command_get_instance_private (self);
#line 22508 "Commands.c"
}

static void
trash_untrash_photos_command_finalize (GObject * obj)
{
	TrashUntrashPhotosCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	VideoSourceCollection* _tmp2_;
	guint _tmp3_;
#line 2355 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TRASH_UNTRASH_PHOTOS_COMMAND, TrashUntrashPhotosCommand);
#line 2372 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 2372 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 2372 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed, self);
#line 2373 "../src/Commands.vala"
	_tmp2_ = video_global;
#line 2373 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 2373 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _trash_untrash_photos_command_on_photo_destroyed_source_collection_item_destroyed, self);
#line 2356 "../src/Commands.vala"
	_g_object_unref0 (self->priv->sources);
#line 2355 "../src/Commands.vala"
	G_OBJECT_CLASS (trash_untrash_photos_command_parent_class)->finalize (obj);
#line 22537 "Commands.c"
}

static GType
trash_untrash_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TrashUntrashPhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trash_untrash_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrashUntrashPhotosCommand), 0, (GInstanceInitFunc) trash_untrash_photos_command_instance_init, NULL };
	GType trash_untrash_photos_command_type_id;
	trash_untrash_photos_command_type_id = g_type_register_static (TYPE_PAGE_COMMAND, "TrashUntrashPhotosCommand", &g_define_type_info, 0);
	TrashUntrashPhotosCommand_private_offset = g_type_add_instance_private (trash_untrash_photos_command_type_id, sizeof (TrashUntrashPhotosCommandPrivate));
	return trash_untrash_photos_command_type_id;
}

GType
trash_untrash_photos_command_get_type (void)
{
	static volatile gsize trash_untrash_photos_command_type_id__once = 0;
	if (g_once_init_enter (&trash_untrash_photos_command_type_id__once)) {
		GType trash_untrash_photos_command_type_id;
		trash_untrash_photos_command_type_id = trash_untrash_photos_command_get_type_once ();
		g_once_init_leave (&trash_untrash_photos_command_type_id__once, trash_untrash_photos_command_type_id);
	}
	return trash_untrash_photos_command_type_id__once;
}

static inline gpointer
flag_unflag_command_get_instance_private (FlagUnflagCommand* self)
{
	return G_STRUCT_MEMBER_P (self, FlagUnflagCommand_private_offset);
}

FlagUnflagCommand*
flag_unflag_command_construct (GType object_type,
                               GeeCollection* sources,
                               gboolean flag)
{
	FlagUnflagCommand * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
#line 2475 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 2477 "../src/Commands.vala"
	if (flag) {
#line 2477 "../src/Commands.vala"
		_tmp0_ = _ ("Flag");
#line 22584 "Commands.c"
	} else {
#line 2477 "../src/Commands.vala"
		_tmp0_ = _ ("Unflag");
#line 22588 "Commands.c"
	}
#line 2478 "../src/Commands.vala"
	if (flag) {
#line 2478 "../src/Commands.vala"
		_tmp1_ = FLAG_UNFLAG_COMMAND_FLAG_SELECTED_STRING;
#line 22594 "Commands.c"
	} else {
#line 2478 "../src/Commands.vala"
		_tmp1_ = FLAG_UNFLAG_COMMAND_UNFLAG_SELECTED_STRING;
#line 22598 "Commands.c"
	}
#line 2476 "../src/Commands.vala"
	self = (FlagUnflagCommand*) multiple_data_source_at_once_command_construct (object_type, sources, _tmp0_, _tmp1_);
#line 2480 "../src/Commands.vala"
	self->priv->flag = flag;
#line 2482 "../src/Commands.vala"
	_tmp2_ = gee_collection_get_size (sources);
#line 2482 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2482 "../src/Commands.vala"
	if (_tmp3_ >= FLAG_UNFLAG_COMMAND_MIN_PROGRESS_BAR_THRESHOLD) {
#line 22610 "Commands.c"
		const gchar* _tmp4_ = NULL;
		ProgressDialog* _tmp5_;
		ProgressDialog* _tmp6_;
#line 2484 "../src/Commands.vala"
		if (flag) {
#line 2484 "../src/Commands.vala"
			_tmp4_ = FLAG_UNFLAG_COMMAND_FLAG_PROGRESS;
#line 22618 "Commands.c"
		} else {
#line 2484 "../src/Commands.vala"
			_tmp4_ = FLAG_UNFLAG_COMMAND_UNFLAG_PROGRESS;
#line 22622 "Commands.c"
		}
#line 2483 "../src/Commands.vala"
		_tmp5_ = progress_dialog_new (NULL, _tmp4_, NULL);
#line 2483 "../src/Commands.vala"
		g_object_ref_sink (_tmp5_);
#line 2483 "../src/Commands.vala"
		_g_object_unref0 (self->priv->progress_dialog);
#line 2483 "../src/Commands.vala"
		self->priv->progress_dialog = _tmp5_;
#line 2486 "../src/Commands.vala"
		_tmp6_ = self->priv->progress_dialog;
#line 2486 "../src/Commands.vala"
		gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget));
#line 22636 "Commands.c"
	}
#line 2475 "../src/Commands.vala"
	return self;
#line 22640 "Commands.c"
}

FlagUnflagCommand*
flag_unflag_command_new (GeeCollection* sources,
                         gboolean flag)
{
#line 2475 "../src/Commands.vala"
	return flag_unflag_command_construct (TYPE_FLAG_UNFLAG_COMMAND, sources, flag);
#line 22649 "Commands.c"
}

static void
flag_unflag_command_real_execute_on_all (MultipleDataSourceAtOnceCommand* base,
                                         GeeCollection* sources)
{
	FlagUnflagCommand * self;
	gint num_processed = 0;
	ProgressDialog* _tmp11_;
#line 2490 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommand);
#line 2490 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 2491 "../src/Commands.vala"
	num_processed = 0;
#line 22665 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 2493 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 2493 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 2493 "../src/Commands.vala"
		while (TRUE) {
#line 22675 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
			gint _tmp5_;
			ProgressDialog* _tmp6_;
#line 2493 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 2493 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 2493 "../src/Commands.vala"
				break;
#line 22689 "Commands.c"
			}
#line 2493 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 2493 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 2493 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 2494 "../src/Commands.vala"
			_tmp4_ = source;
#line 2494 "../src/Commands.vala"
			flag_unflag_command_flag_unflag (self, _tmp4_, self->priv->flag);
#line 2496 "../src/Commands.vala"
			_tmp5_ = num_processed;
#line 2496 "../src/Commands.vala"
			num_processed = _tmp5_ + 1;
#line 2498 "../src/Commands.vala"
			_tmp6_ = self->priv->progress_dialog;
#line 2498 "../src/Commands.vala"
			if (_tmp6_ != NULL) {
#line 22709 "Commands.c"
				ProgressDialog* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				ProgressDialog* _tmp10_;
#line 2499 "../src/Commands.vala"
				_tmp7_ = self->priv->progress_dialog;
#line 2499 "../src/Commands.vala"
				_tmp8_ = gee_collection_get_size (sources);
#line 2499 "../src/Commands.vala"
				_tmp9_ = _tmp8_;
#line 2499 "../src/Commands.vala"
				progress_dialog_set_fraction (_tmp7_, num_processed, _tmp9_);
#line 2500 "../src/Commands.vala"
				_tmp10_ = self->priv->progress_dialog;
#line 2500 "../src/Commands.vala"
				gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
#line 2501 "../src/Commands.vala"
				spin_event_loop ();
#line 22728 "Commands.c"
			}
#line 2493 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 22732 "Commands.c"
		}
#line 2493 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 22736 "Commands.c"
	}
#line 2505 "../src/Commands.vala"
	_tmp11_ = self->priv->progress_dialog;
#line 2505 "../src/Commands.vala"
	if (_tmp11_ != NULL) {
#line 22742 "Commands.c"
		ProgressDialog* _tmp12_;
#line 2506 "../src/Commands.vala"
		_tmp12_ = self->priv->progress_dialog;
#line 2506 "../src/Commands.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 22748 "Commands.c"
	}
}

static void
flag_unflag_command_real_undo_on_all (MultipleDataSourceAtOnceCommand* base,
                                      GeeCollection* sources)
{
	FlagUnflagCommand * self;
#line 2509 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommand);
#line 2509 "../src/Commands.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION));
#line 22761 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 2510 "../src/Commands.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 2510 "../src/Commands.vala"
		_source_it = _tmp0_;
#line 2510 "../src/Commands.vala"
		while (TRUE) {
#line 22771 "Commands.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataSource* _tmp4_;
#line 2510 "../src/Commands.vala"
			_tmp1_ = _source_it;
#line 2510 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 2510 "../src/Commands.vala"
				break;
#line 22783 "Commands.c"
			}
#line 2510 "../src/Commands.vala"
			_tmp2_ = _source_it;
#line 2510 "../src/Commands.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 2510 "../src/Commands.vala"
			source = (DataSource*) _tmp3_;
#line 2511 "../src/Commands.vala"
			_tmp4_ = source;
#line 2511 "../src/Commands.vala"
			flag_unflag_command_flag_unflag (self, _tmp4_, !self->priv->flag);
#line 2510 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 22797 "Commands.c"
		}
#line 2510 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 22801 "Commands.c"
	}
}

static void
flag_unflag_command_flag_unflag (FlagUnflagCommand* self,
                                 DataSource* source,
                                 gboolean flag)
{
	Flaggable* flaggable = NULL;
	Flaggable* _tmp0_;
	Flaggable* _tmp1_;
#line 2514 "../src/Commands.vala"
	g_return_if_fail (IS_FLAG_UNFLAG_COMMAND (self));
#line 2514 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2515 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (IS_FLAGGABLE (source) ? ((Flaggable*) source) : NULL);
#line 2515 "../src/Commands.vala"
	flaggable = _tmp0_;
#line 2516 "../src/Commands.vala"
	_tmp1_ = flaggable;
#line 2516 "../src/Commands.vala"
	if (_tmp1_ != NULL) {
#line 2517 "../src/Commands.vala"
		if (flag) {
#line 22827 "Commands.c"
			Flaggable* _tmp2_;
#line 2518 "../src/Commands.vala"
			_tmp2_ = flaggable;
#line 2518 "../src/Commands.vala"
			flaggable_mark_flagged (_tmp2_);
#line 22833 "Commands.c"
		} else {
			Flaggable* _tmp3_;
#line 2520 "../src/Commands.vala"
			_tmp3_ = flaggable;
#line 2520 "../src/Commands.vala"
			flaggable_mark_unflagged (_tmp3_);
#line 22840 "Commands.c"
		}
	}
#line 2514 "../src/Commands.vala"
	_g_object_unref0 (flaggable);
#line 22845 "Commands.c"
}

static void
flag_unflag_command_class_init (FlagUnflagCommandClass * klass,
                                gpointer klass_data)
{
#line 2465 "../src/Commands.vala"
	flag_unflag_command_parent_class = g_type_class_peek_parent (klass);
#line 2465 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &FlagUnflagCommand_private_offset);
#line 2465 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->execute_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) flag_unflag_command_real_execute_on_all;
#line 2465 "../src/Commands.vala"
	((MultipleDataSourceAtOnceCommandClass *) klass)->undo_on_all = (void (*) (MultipleDataSourceAtOnceCommand*, GeeCollection*)) flag_unflag_command_real_undo_on_all;
#line 2465 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = flag_unflag_command_finalize;
#line 22862 "Commands.c"
}

static void
flag_unflag_command_instance_init (FlagUnflagCommand * self,
                                   gpointer klass)
{
#line 2465 "../src/Commands.vala"
	self->priv = flag_unflag_command_get_instance_private (self);
#line 2473 "../src/Commands.vala"
	self->priv->progress_dialog = NULL;
#line 22873 "Commands.c"
}

static void
flag_unflag_command_finalize (GObject * obj)
{
	FlagUnflagCommand * self;
#line 2465 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FLAG_UNFLAG_COMMAND, FlagUnflagCommand);
#line 2473 "../src/Commands.vala"
	_g_object_unref0 (self->priv->progress_dialog);
#line 2465 "../src/Commands.vala"
	G_OBJECT_CLASS (flag_unflag_command_parent_class)->finalize (obj);
#line 22886 "Commands.c"
}

static GType
flag_unflag_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FlagUnflagCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) flag_unflag_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FlagUnflagCommand), 0, (GInstanceInitFunc) flag_unflag_command_instance_init, NULL };
	GType flag_unflag_command_type_id;
	flag_unflag_command_type_id = g_type_register_static (TYPE_MULTIPLE_DATA_SOURCE_AT_ONCE_COMMAND, "FlagUnflagCommand", &g_define_type_info, 0);
	FlagUnflagCommand_private_offset = g_type_add_instance_private (flag_unflag_command_type_id, sizeof (FlagUnflagCommandPrivate));
	return flag_unflag_command_type_id;
}

GType
flag_unflag_command_get_type (void)
{
	static volatile gsize flag_unflag_command_type_id__once = 0;
	if (g_once_init_enter (&flag_unflag_command_type_id__once)) {
		GType flag_unflag_command_type_id;
		flag_unflag_command_type_id = flag_unflag_command_get_type_once ();
		g_once_init_leave (&flag_unflag_command_type_id__once, flag_unflag_command_type_id);
	}
	return flag_unflag_command_type_id__once;
}

static inline gpointer
remove_faces_from_photos_command_get_instance_private (RemoveFacesFromPhotosCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RemoveFacesFromPhotosCommand_private_offset);
}

static void
_remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender,
                                                                                        DataSource* source,
                                                                                        gpointer self)
{
#line 2546 "../src/Commands.vala"
	remove_faces_from_photos_command_on_source_destroyed ((RemoveFacesFromPhotosCommand*) self, source);
#line 22924 "Commands.c"
}

RemoveFacesFromPhotosCommand*
remove_faces_from_photos_command_construct (GType object_type,
                                            Face* face,
                                            GeeCollection* sources)
{
	RemoveFacesFromPhotosCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	LibraryPhotoSourceCollection* _tmp22_;
	VideoSourceCollection* _tmp23_;
#line 2528 "../src/Commands.vala"
	g_return_val_if_fail (IS_FACE (face), NULL);
#line 2528 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sources, GEE_TYPE_COLLECTION), NULL);
#line 2529 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2529 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2529 "../src/Commands.vala"
	_tmp2_ = gee_collection_get_size (sources);
#line 2529 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2529 "../src/Commands.vala"
	_tmp4_ = resources_remove_face_from_photos_label (_tmp1_, _tmp3_);
#line 2529 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2529 "../src/Commands.vala"
	_tmp6_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2529 "../src/Commands.vala"
	_tmp7_ = _tmp6_;
#line 2529 "../src/Commands.vala"
	self = (RemoveFacesFromPhotosCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_PROXYABLE, Proxyable), _tmp5_, _tmp7_);
#line 2529 "../src/Commands.vala"
	_g_free0 (_tmp7_);
#line 2529 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2529 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 22971 "Commands.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp8_;
#line 2533 "../src/Commands.vala"
		_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (sources, GEE_TYPE_ITERABLE, GeeIterable));
#line 2533 "../src/Commands.vala"
		_source_it = _tmp8_;
#line 2533 "../src/Commands.vala"
		while (TRUE) {
#line 22981 "Commands.c"
			GeeIterator* _tmp9_;
			MediaSource* source = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			FaceLocation* face_location = NULL;
			FaceID _tmp12_ = {0};
			MediaSource* _tmp13_;
			PhotoID _tmp14_ = {0};
			FaceLocation* _tmp15_;
			FaceLocation* _tmp16_;
			GeeMap* _tmp17_;
			MediaSource* _tmp18_;
			FaceLocation* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 2533 "../src/Commands.vala"
			_tmp9_ = _source_it;
#line 2533 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 2533 "../src/Commands.vala"
				break;
#line 23003 "Commands.c"
			}
#line 2533 "../src/Commands.vala"
			_tmp10_ = _source_it;
#line 2533 "../src/Commands.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 2533 "../src/Commands.vala"
			source = (MediaSource*) _tmp11_;
#line 2534 "../src/Commands.vala"
			face_get_face_id (face, &_tmp12_);
#line 2534 "../src/Commands.vala"
			_tmp13_ = source;
#line 2534 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_PHOTO, Photo), &_tmp14_);
#line 2534 "../src/Commands.vala"
			_tmp15_ = face_location_get_face_location (&_tmp12_, &_tmp14_);
#line 2534 "../src/Commands.vala"
			face_location = _tmp15_;
#line 2536 "../src/Commands.vala"
			_tmp16_ = face_location;
#line 2536 "../src/Commands.vala"
			_vala_assert (_tmp16_ != NULL, "face_location != null");
#line 2538 "../src/Commands.vala"
			_tmp17_ = self->priv->map_source_geometry;
#line 2538 "../src/Commands.vala"
			_tmp18_ = source;
#line 2538 "../src/Commands.vala"
			_tmp19_ = face_location;
#line 2538 "../src/Commands.vala"
			_tmp20_ = face_location_get_serialized_geometry (_tmp19_);
#line 2538 "../src/Commands.vala"
			_tmp21_ = _tmp20_;
#line 2538 "../src/Commands.vala"
			gee_map_set (_tmp17_, _tmp18_, _tmp21_);
#line 2538 "../src/Commands.vala"
			_g_free0 (_tmp21_);
#line 2533 "../src/Commands.vala"
			_g_object_unref0 (face_location);
#line 2533 "../src/Commands.vala"
			_g_object_unref0 (source);
#line 23043 "Commands.c"
		}
#line 2533 "../src/Commands.vala"
		_g_object_unref0 (_source_it);
#line 23047 "Commands.c"
	}
#line 2541 "../src/Commands.vala"
	_tmp22_ = library_photo_global;
#line 2541 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 2542 "../src/Commands.vala"
	_tmp23_ = video_global;
#line 2542 "../src/Commands.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, TYPE_SOURCE_COLLECTION, SourceCollection), "item-destroyed", (GCallback) _remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed, self, 0);
#line 2528 "../src/Commands.vala"
	return self;
#line 23059 "Commands.c"
}

RemoveFacesFromPhotosCommand*
remove_faces_from_photos_command_new (Face* face,
                                      GeeCollection* sources)
{
#line 2528 "../src/Commands.vala"
	return remove_faces_from_photos_command_construct (TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, face, sources);
#line 23068 "Commands.c"
}

static void
remove_faces_from_photos_command_real_execute_on_source (SimpleProxyableCommand* base,
                                                         DataSource* source)
{
	RemoveFacesFromPhotosCommand * self;
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
#line 2550 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommand);
#line 2550 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2551 "../src/Commands.vala"
	_tmp0_ = self->priv->map_source_geometry;
#line 2551 "../src/Commands.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 2551 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 2551 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2551 "../src/Commands.vala"
	face_detach_many (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2551 "../src/Commands.vala"
	_g_object_unref0 (_tmp3_);
#line 23096 "Commands.c"
}

static void
remove_faces_from_photos_command_real_undo_on_source (SimpleProxyableCommand* base,
                                                      DataSource* source)
{
	RemoveFacesFromPhotosCommand * self;
	Face* face = NULL;
	Face* _tmp0_;
	Face* _tmp1_;
	GeeMap* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
#line 2554 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommand);
#line 2554 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2555 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face));
#line 2555 "../src/Commands.vala"
	face = _tmp0_;
#line 2557 "../src/Commands.vala"
	_tmp1_ = face;
#line 2557 "../src/Commands.vala"
	_tmp2_ = self->priv->map_source_geometry;
#line 2557 "../src/Commands.vala"
	_tmp3_ = gee_map_get_keys (_tmp2_);
#line 2557 "../src/Commands.vala"
	_tmp4_ = _tmp3_;
#line 2557 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2557 "../src/Commands.vala"
	face_attach_many (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2557 "../src/Commands.vala"
	_g_object_unref0 (_tmp5_);
#line 23133 "Commands.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 2558 "../src/Commands.vala"
		_tmp6_ = self->priv->map_source_geometry;
#line 2558 "../src/Commands.vala"
		_tmp7_ = gee_map_get_entries (_tmp6_);
#line 2558 "../src/Commands.vala"
		_tmp8_ = _tmp7_;
#line 2558 "../src/Commands.vala"
		_tmp9_ = _tmp8_;
#line 2558 "../src/Commands.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2558 "../src/Commands.vala"
		_tmp11_ = _tmp10_;
#line 2558 "../src/Commands.vala"
		_g_object_unref0 (_tmp9_);
#line 2558 "../src/Commands.vala"
		_entry_it = _tmp11_;
#line 2558 "../src/Commands.vala"
		while (TRUE) {
#line 23160 "Commands.c"
			GeeIterator* _tmp12_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			Face* _tmp15_;
			FaceID _tmp16_ = {0};
			GeeMapEntry* _tmp17_;
			gconstpointer _tmp18_;
			gconstpointer _tmp19_;
			PhotoID _tmp20_ = {0};
			GeeMapEntry* _tmp21_;
			gconstpointer _tmp22_;
			gconstpointer _tmp23_;
			FaceLocationData _tmp24_ = {0};
			FaceLocation* _tmp25_;
			FaceLocation* _tmp26_;
#line 2558 "../src/Commands.vala"
			_tmp12_ = _entry_it;
#line 2558 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 2558 "../src/Commands.vala"
				break;
#line 23183 "Commands.c"
			}
#line 2558 "../src/Commands.vala"
			_tmp13_ = _entry_it;
#line 2558 "../src/Commands.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 2558 "../src/Commands.vala"
			entry = (GeeMapEntry*) _tmp14_;
#line 2559 "../src/Commands.vala"
			_tmp15_ = face;
#line 2559 "../src/Commands.vala"
			face_get_face_id (_tmp15_, &_tmp16_);
#line 2559 "../src/Commands.vala"
			_tmp17_ = entry;
#line 2559 "../src/Commands.vala"
			_tmp18_ = gee_map_entry_get_key (_tmp17_);
#line 2559 "../src/Commands.vala"
			_tmp19_ = _tmp18_;
#line 2559 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST ((MediaSource*) _tmp19_, TYPE_PHOTO, Photo), &_tmp20_);
#line 2559 "../src/Commands.vala"
			_tmp21_ = entry;
#line 2559 "../src/Commands.vala"
			_tmp22_ = gee_map_entry_get_value (_tmp21_);
#line 2559 "../src/Commands.vala"
			_tmp23_ = _tmp22_;
#line 2559 "../src/Commands.vala"
			_g_free0 (_tmp24_.geometry);
#line 2559 "../src/Commands.vala"
			_tmp24_.geometry = (const gchar*) _tmp23_;
#line 2559 "../src/Commands.vala"
			_g_free0 (_tmp24_.vec);
#line 2559 "../src/Commands.vala"
			_tmp24_.vec = NULL;
#line 2559 "../src/Commands.vala"
			_tmp25_ = face_location_create (&_tmp16_, &_tmp20_, &_tmp24_);
#line 2559 "../src/Commands.vala"
			_tmp26_ = _tmp25_;
#line 2559 "../src/Commands.vala"
			_g_object_unref0 (_tmp26_);
#line 2558 "../src/Commands.vala"
			_g_object_unref0 (entry);
#line 23225 "Commands.c"
		}
#line 2558 "../src/Commands.vala"
		_g_object_unref0 (_entry_it);
#line 23229 "Commands.c"
	}
#line 2554 "../src/Commands.vala"
	_g_object_unref0 (face);
#line 23233 "Commands.c"
}

static void
remove_faces_from_photos_command_on_source_destroyed (RemoveFacesFromPhotosCommand* self,
                                                      DataSource* source)
{
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_;
#line 2563 "../src/Commands.vala"
	g_return_if_fail (IS_REMOVE_FACES_FROM_PHOTOS_COMMAND (self));
#line 2563 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2564 "../src/Commands.vala"
	_tmp0_ = self->priv->map_source_geometry;
#line 2564 "../src/Commands.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 2564 "../src/Commands.vala"
	_tmp2_ = _tmp1_;
#line 2564 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2564 "../src/Commands.vala"
	_tmp4_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_MEDIA_SOURCE, MediaSource));
#line 2564 "../src/Commands.vala"
	_g_object_unref0 (_tmp3_);
#line 2564 "../src/Commands.vala"
	if (_tmp4_) {
#line 23263 "Commands.c"
		CommandManager* _tmp5_;
		CommandManager* _tmp6_;
#line 2565 "../src/Commands.vala"
		_tmp5_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 2565 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2565 "../src/Commands.vala"
		command_manager_reset (_tmp6_);
#line 2565 "../src/Commands.vala"
		_command_manager_unref0 (_tmp6_);
#line 23274 "Commands.c"
	}
}

static void
remove_faces_from_photos_command_class_init (RemoveFacesFromPhotosCommandClass * klass,
                                             gpointer klass_data)
{
#line 2525 "../src/Commands.vala"
	remove_faces_from_photos_command_parent_class = g_type_class_peek_parent (klass);
#line 2525 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RemoveFacesFromPhotosCommand_private_offset);
#line 2525 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) remove_faces_from_photos_command_real_execute_on_source;
#line 2525 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) remove_faces_from_photos_command_real_undo_on_source;
#line 2525 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = remove_faces_from_photos_command_finalize;
#line 23292 "Commands.c"
}

static void
remove_faces_from_photos_command_instance_init (RemoveFacesFromPhotosCommand * self,
                                                gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 2525 "../src/Commands.vala"
	self->priv = remove_faces_from_photos_command_get_instance_private (self);
#line 2526 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2526 "../src/Commands.vala"
	self->priv->map_source_geometry = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 23306 "Commands.c"
}

static void
remove_faces_from_photos_command_finalize (GObject * obj)
{
	RemoveFacesFromPhotosCommand * self;
	LibraryPhotoSourceCollection* _tmp0_;
	guint _tmp1_;
	VideoSourceCollection* _tmp2_;
	guint _tmp3_;
#line 2525 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REMOVE_FACES_FROM_PHOTOS_COMMAND, RemoveFacesFromPhotosCommand);
#line 2546 "../src/Commands.vala"
	_tmp0_ = library_photo_global;
#line 2546 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 2546 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 2547 "../src/Commands.vala"
	_tmp2_ = video_global;
#line 2547 "../src/Commands.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
#line 2547 "../src/Commands.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SOURCE_COLLECTION, SourceCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _remove_faces_from_photos_command_on_source_destroyed_source_collection_item_destroyed, self);
#line 2526 "../src/Commands.vala"
	_g_object_unref0 (self->priv->map_source_geometry);
#line 2525 "../src/Commands.vala"
	G_OBJECT_CLASS (remove_faces_from_photos_command_parent_class)->finalize (obj);
#line 23335 "Commands.c"
}

static GType
remove_faces_from_photos_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RemoveFacesFromPhotosCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) remove_faces_from_photos_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RemoveFacesFromPhotosCommand), 0, (GInstanceInitFunc) remove_faces_from_photos_command_instance_init, NULL };
	GType remove_faces_from_photos_command_type_id;
	remove_faces_from_photos_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "RemoveFacesFromPhotosCommand", &g_define_type_info, 0);
	RemoveFacesFromPhotosCommand_private_offset = g_type_add_instance_private (remove_faces_from_photos_command_type_id, sizeof (RemoveFacesFromPhotosCommandPrivate));
	return remove_faces_from_photos_command_type_id;
}

GType
remove_faces_from_photos_command_get_type (void)
{
	static volatile gsize remove_faces_from_photos_command_type_id__once = 0;
	if (g_once_init_enter (&remove_faces_from_photos_command_type_id__once)) {
		GType remove_faces_from_photos_command_type_id;
		remove_faces_from_photos_command_type_id = remove_faces_from_photos_command_get_type_once ();
		g_once_init_leave (&remove_faces_from_photos_command_type_id__once, remove_faces_from_photos_command_type_id);
	}
	return remove_faces_from_photos_command_type_id__once;
}

static inline gpointer
rename_face_command_get_instance_private (RenameFaceCommand* self)
{
	return G_STRUCT_MEMBER_P (self, RenameFaceCommand_private_offset);
}

RenameFaceCommand*
rename_face_command_construct (GType object_type,
                               Face* face,
                               const gchar* new_name)
{
	RenameFaceCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 2573 "../src/Commands.vala"
	g_return_val_if_fail (IS_FACE (face), NULL);
#line 2573 "../src/Commands.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 2574 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2574 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2574 "../src/Commands.vala"
	_tmp2_ = resources_rename_face_label (_tmp1_, new_name);
#line 2574 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2574 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2574 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2574 "../src/Commands.vala"
	self = (RenameFaceCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_PROXYABLE, Proxyable), _tmp3_, _tmp5_);
#line 2574 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2574 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 2574 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2576 "../src/Commands.vala"
	_tmp6_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2576 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 2576 "../src/Commands.vala"
	self->priv->old_name = _tmp6_;
#line 2577 "../src/Commands.vala"
	_tmp7_ = g_strdup (new_name);
#line 2577 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 2577 "../src/Commands.vala"
	self->priv->new_name = _tmp7_;
#line 2573 "../src/Commands.vala"
	return self;
#line 23418 "Commands.c"
}

RenameFaceCommand*
rename_face_command_new (Face* face,
                         const gchar* new_name)
{
#line 2573 "../src/Commands.vala"
	return rename_face_command_construct (TYPE_RENAME_FACE_COMMAND, face, new_name);
#line 23427 "Commands.c"
}

static void
rename_face_command_real_execute_on_source (SimpleProxyableCommand* base,
                                            DataSource* source)
{
	RenameFaceCommand * self;
	const gchar* _tmp0_;
#line 2580 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_FACE_COMMAND, RenameFaceCommand);
#line 2580 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2581 "../src/Commands.vala"
	_tmp0_ = self->priv->new_name;
#line 2581 "../src/Commands.vala"
	if (!face_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face), _tmp0_)) {
#line 23444 "Commands.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 2582 "../src/Commands.vala"
		_tmp1_ = self->priv->new_name;
#line 2582 "../src/Commands.vala"
		_tmp2_ = resources_rename_face_exists_message (_tmp1_);
#line 2582 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2582 "../src/Commands.vala"
		app_window_error_message (_tmp3_, NULL);
#line 2582 "../src/Commands.vala"
		_g_free0 (_tmp3_);
#line 23458 "Commands.c"
	}
}

static void
rename_face_command_real_undo_on_source (SimpleProxyableCommand* base,
                                         DataSource* source)
{
	RenameFaceCommand * self;
	const gchar* _tmp0_;
#line 2585 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_RENAME_FACE_COMMAND, RenameFaceCommand);
#line 2585 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2586 "../src/Commands.vala"
	_tmp0_ = self->priv->old_name;
#line 2586 "../src/Commands.vala"
	if (!face_rename (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face), _tmp0_)) {
#line 23476 "Commands.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 2587 "../src/Commands.vala"
		_tmp1_ = self->priv->old_name;
#line 2587 "../src/Commands.vala"
		_tmp2_ = resources_rename_face_exists_message (_tmp1_);
#line 2587 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2587 "../src/Commands.vala"
		app_window_error_message (_tmp3_, NULL);
#line 2587 "../src/Commands.vala"
		_g_free0 (_tmp3_);
#line 23490 "Commands.c"
	}
}

static void
rename_face_command_class_init (RenameFaceCommandClass * klass,
                                gpointer klass_data)
{
#line 2569 "../src/Commands.vala"
	rename_face_command_parent_class = g_type_class_peek_parent (klass);
#line 2569 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &RenameFaceCommand_private_offset);
#line 2569 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_face_command_real_execute_on_source;
#line 2569 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) rename_face_command_real_undo_on_source;
#line 2569 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = rename_face_command_finalize;
#line 23508 "Commands.c"
}

static void
rename_face_command_instance_init (RenameFaceCommand * self,
                                   gpointer klass)
{
#line 2569 "../src/Commands.vala"
	self->priv = rename_face_command_get_instance_private (self);
#line 23517 "Commands.c"
}

static void
rename_face_command_finalize (GObject * obj)
{
	RenameFaceCommand * self;
#line 2569 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RENAME_FACE_COMMAND, RenameFaceCommand);
#line 2570 "../src/Commands.vala"
	_g_free0 (self->priv->old_name);
#line 2571 "../src/Commands.vala"
	_g_free0 (self->priv->new_name);
#line 2569 "../src/Commands.vala"
	G_OBJECT_CLASS (rename_face_command_parent_class)->finalize (obj);
#line 23532 "Commands.c"
}

static GType
rename_face_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RenameFaceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rename_face_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RenameFaceCommand), 0, (GInstanceInitFunc) rename_face_command_instance_init, NULL };
	GType rename_face_command_type_id;
	rename_face_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "RenameFaceCommand", &g_define_type_info, 0);
	RenameFaceCommand_private_offset = g_type_add_instance_private (rename_face_command_type_id, sizeof (RenameFaceCommandPrivate));
	return rename_face_command_type_id;
}

GType
rename_face_command_get_type (void)
{
	static volatile gsize rename_face_command_type_id__once = 0;
	if (g_once_init_enter (&rename_face_command_type_id__once)) {
		GType rename_face_command_type_id;
		rename_face_command_type_id = rename_face_command_get_type_once ();
		g_once_init_leave (&rename_face_command_type_id__once, rename_face_command_type_id);
	}
	return rename_face_command_type_id__once;
}

static inline gpointer
set_face_ref_command_get_instance_private (SetFaceRefCommand* self)
{
	return G_STRUCT_MEMBER_P (self, SetFaceRefCommand_private_offset);
}

SetFaceRefCommand*
set_face_ref_command_construct (GType object_type,
                                Face* face,
                                MediaSource* source)
{
	SetFaceRefCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GeeMap* face_loc_map = NULL;
	GeeMap* _tmp6_;
	FaceID _tmp7_ = {0};
	gpointer _tmp8_;
#line 2594 "../src/Commands.vala"
	g_return_val_if_fail (IS_FACE (face), NULL);
#line 2594 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (source), NULL);
#line 2595 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2595 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2595 "../src/Commands.vala"
	_tmp2_ = resources_set_face_from_photo_label (_tmp1_);
#line 2595 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2595 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2595 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2595 "../src/Commands.vala"
	self = (SetFaceRefCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_PROXYABLE, Proxyable), _tmp3_, _tmp5_);
#line 2595 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2595 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 2595 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2596 "../src/Commands.vala"
	_tmp6_ = face_location_get_locations_by_photo (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_PHOTO, Photo));
#line 2596 "../src/Commands.vala"
	face_loc_map = _tmp6_;
#line 2597 "../src/Commands.vala"
	face_get_face_id (face, &_tmp7_);
#line 2597 "../src/Commands.vala"
	_tmp8_ = gee_map_get (face_loc_map, &_tmp7_);
#line 2597 "../src/Commands.vala"
	_g_object_unref0 (self->priv->face_loc);
#line 2597 "../src/Commands.vala"
	self->priv->face_loc = (FaceLocation*) _tmp8_;
#line 2594 "../src/Commands.vala"
	_g_object_unref0 (face_loc_map);
#line 2594 "../src/Commands.vala"
	return self;
#line 23619 "Commands.c"
}

SetFaceRefCommand*
set_face_ref_command_new (Face* face,
                          MediaSource* source)
{
#line 2594 "../src/Commands.vala"
	return set_face_ref_command_construct (TYPE_SET_FACE_REF_COMMAND, face, source);
#line 23628 "Commands.c"
}

static void
set_face_ref_command_real_execute_on_source (SimpleProxyableCommand* base,
                                             DataSource* source)
{
	SetFaceRefCommand * self;
	FaceLocation* _tmp0_;
#line 2600 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommand);
#line 2600 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2601 "../src/Commands.vala"
	_tmp0_ = self->priv->face_loc;
#line 2601 "../src/Commands.vala"
	if (!face_set_reference (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face), _tmp0_)) {
#line 23645 "Commands.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 2602 "../src/Commands.vala"
		_tmp1_ = resources_set_face_from_photo_error ();
#line 2602 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 2602 "../src/Commands.vala"
		app_window_error_message (_tmp2_, NULL);
#line 2602 "../src/Commands.vala"
		_g_free0 (_tmp2_);
#line 23656 "Commands.c"
	}
}

static void
set_face_ref_command_real_undo_on_source (SimpleProxyableCommand* base,
                                          DataSource* source)
{
	SetFaceRefCommand * self;
#line 2605 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommand);
#line 2605 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 23669 "Commands.c"
}

static void
set_face_ref_command_class_init (SetFaceRefCommandClass * klass,
                                 gpointer klass_data)
{
#line 2591 "../src/Commands.vala"
	set_face_ref_command_parent_class = g_type_class_peek_parent (klass);
#line 2591 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &SetFaceRefCommand_private_offset);
#line 2591 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) set_face_ref_command_real_execute_on_source;
#line 2591 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) set_face_ref_command_real_undo_on_source;
#line 2591 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = set_face_ref_command_finalize;
#line 23686 "Commands.c"
}

static void
set_face_ref_command_instance_init (SetFaceRefCommand * self,
                                    gpointer klass)
{
#line 2591 "../src/Commands.vala"
	self->priv = set_face_ref_command_get_instance_private (self);
#line 23695 "Commands.c"
}

static void
set_face_ref_command_finalize (GObject * obj)
{
	SetFaceRefCommand * self;
#line 2591 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SET_FACE_REF_COMMAND, SetFaceRefCommand);
#line 2592 "../src/Commands.vala"
	_g_object_unref0 (self->priv->face_loc);
#line 2591 "../src/Commands.vala"
	G_OBJECT_CLASS (set_face_ref_command_parent_class)->finalize (obj);
#line 23708 "Commands.c"
}

static GType
set_face_ref_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SetFaceRefCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) set_face_ref_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SetFaceRefCommand), 0, (GInstanceInitFunc) set_face_ref_command_instance_init, NULL };
	GType set_face_ref_command_type_id;
	set_face_ref_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "SetFaceRefCommand", &g_define_type_info, 0);
	SetFaceRefCommand_private_offset = g_type_add_instance_private (set_face_ref_command_type_id, sizeof (SetFaceRefCommandPrivate));
	return set_face_ref_command_type_id;
}

GType
set_face_ref_command_get_type (void)
{
	static volatile gsize set_face_ref_command_type_id__once = 0;
	if (g_once_init_enter (&set_face_ref_command_type_id__once)) {
		GType set_face_ref_command_type_id;
		set_face_ref_command_type_id = set_face_ref_command_get_type_once ();
		g_once_init_leave (&set_face_ref_command_type_id__once, set_face_ref_command_type_id);
	}
	return set_face_ref_command_type_id__once;
}

static inline gpointer
delete_face_command_get_instance_private (DeleteFaceCommand* self)
{
	return G_STRUCT_MEMBER_P (self, DeleteFaceCommand_private_offset);
}

DeleteFaceCommand*
delete_face_command_construct (GType object_type,
                               Face* face)
{
	DeleteFaceCommand * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GeeMap* temp = NULL;
	GeeMap* _tmp6_;
	GeeMap* _tmp7_;
#line 2615 "../src/Commands.vala"
	g_return_val_if_fail (IS_FACE (face), NULL);
#line 2616 "../src/Commands.vala"
	_tmp0_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2616 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2616 "../src/Commands.vala"
	_tmp2_ = resources_delete_face_label (_tmp1_);
#line 2616 "../src/Commands.vala"
	_tmp3_ = _tmp2_;
#line 2616 "../src/Commands.vala"
	_tmp4_ = data_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_DATA_OBJECT, DataObject));
#line 2616 "../src/Commands.vala"
	_tmp5_ = _tmp4_;
#line 2616 "../src/Commands.vala"
	self = (DeleteFaceCommand*) simple_proxyable_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (face, TYPE_PROXYABLE, Proxyable), _tmp3_, _tmp5_);
#line 2616 "../src/Commands.vala"
	_g_free0 (_tmp5_);
#line 2616 "../src/Commands.vala"
	_g_free0 (_tmp3_);
#line 2616 "../src/Commands.vala"
	_g_free0 (_tmp1_);
#line 2620 "../src/Commands.vala"
	_tmp6_ = face_location_get_locations_by_face (face);
#line 2620 "../src/Commands.vala"
	temp = _tmp6_;
#line 2621 "../src/Commands.vala"
	_tmp7_ = temp;
#line 2621 "../src/Commands.vala"
	_vala_assert (_tmp7_ != NULL, "temp != null");
#line 23783 "Commands.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp8_;
		GeeSet* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 2622 "../src/Commands.vala"
		_tmp8_ = temp;
#line 2622 "../src/Commands.vala"
		_tmp9_ = gee_map_get_entries (_tmp8_);
#line 2622 "../src/Commands.vala"
		_tmp10_ = _tmp9_;
#line 2622 "../src/Commands.vala"
		_tmp11_ = _tmp10_;
#line 2622 "../src/Commands.vala"
		_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2622 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 2622 "../src/Commands.vala"
		_g_object_unref0 (_tmp11_);
#line 2622 "../src/Commands.vala"
		_entry_it = _tmp13_;
#line 2622 "../src/Commands.vala"
		while (TRUE) {
#line 23810 "Commands.c"
			GeeIterator* _tmp14_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			GeeMap* _tmp17_;
			GeeMapEntry* _tmp18_;
			gconstpointer _tmp19_;
			gconstpointer _tmp20_;
			GeeMapEntry* _tmp21_;
			gconstpointer _tmp22_;
			gconstpointer _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 2622 "../src/Commands.vala"
			_tmp14_ = _entry_it;
#line 2622 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 2622 "../src/Commands.vala"
				break;
#line 23830 "Commands.c"
			}
#line 2622 "../src/Commands.vala"
			_tmp15_ = _entry_it;
#line 2622 "../src/Commands.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 2622 "../src/Commands.vala"
			entry = (GeeMapEntry*) _tmp16_;
#line 2623 "../src/Commands.vala"
			_tmp17_ = self->priv->photo_geometry_map;
#line 2623 "../src/Commands.vala"
			_tmp18_ = entry;
#line 2623 "../src/Commands.vala"
			_tmp19_ = gee_map_entry_get_key (_tmp18_);
#line 2623 "../src/Commands.vala"
			_tmp20_ = _tmp19_;
#line 2623 "../src/Commands.vala"
			_tmp21_ = entry;
#line 2623 "../src/Commands.vala"
			_tmp22_ = gee_map_entry_get_value (_tmp21_);
#line 2623 "../src/Commands.vala"
			_tmp23_ = _tmp22_;
#line 2623 "../src/Commands.vala"
			_tmp24_ = face_location_get_serialized_geometry ((FaceLocation*) _tmp23_);
#line 2623 "../src/Commands.vala"
			_tmp25_ = _tmp24_;
#line 2623 "../src/Commands.vala"
			gee_map_set (_tmp17_, (PhotoID*) _tmp20_, _tmp25_);
#line 2623 "../src/Commands.vala"
			_g_free0 (_tmp25_);
#line 2622 "../src/Commands.vala"
			_g_object_unref0 (entry);
#line 23862 "Commands.c"
		}
#line 2622 "../src/Commands.vala"
		_g_object_unref0 (_entry_it);
#line 23866 "Commands.c"
	}
#line 2615 "../src/Commands.vala"
	_g_object_unref0 (temp);
#line 2615 "../src/Commands.vala"
	return self;
#line 23872 "Commands.c"
}

DeleteFaceCommand*
delete_face_command_new (Face* face)
{
#line 2615 "../src/Commands.vala"
	return delete_face_command_construct (TYPE_DELETE_FACE_COMMAND, face);
#line 23880 "Commands.c"
}

static void
delete_face_command_real_execute_on_source (SimpleProxyableCommand* base,
                                            DataSource* source)
{
	DeleteFaceCommand * self;
	FaceID face_id = {0};
	FaceID _tmp0_ = {0};
	FaceSourceCollection* _tmp14_;
	FaceSourceCollection* _tmp15_;
	Marker* _tmp16_;
	Marker* _tmp17_;
#line 2626 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_FACE_COMMAND, DeleteFaceCommand);
#line 2626 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2627 "../src/Commands.vala"
	face_get_face_id (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face), &_tmp0_);
#line 2627 "../src/Commands.vala"
	face_id = _tmp0_;
#line 23902 "Commands.c"
	{
		GeeIterator* _photo_id_it = NULL;
		GeeMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 2628 "../src/Commands.vala"
		_tmp1_ = self->priv->photo_geometry_map;
#line 2628 "../src/Commands.vala"
		_tmp2_ = gee_map_get_keys (_tmp1_);
#line 2628 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2628 "../src/Commands.vala"
		_tmp4_ = _tmp3_;
#line 2628 "../src/Commands.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2628 "../src/Commands.vala"
		_tmp6_ = _tmp5_;
#line 2628 "../src/Commands.vala"
		_g_object_unref0 (_tmp4_);
#line 2628 "../src/Commands.vala"
		_photo_id_it = _tmp6_;
#line 2628 "../src/Commands.vala"
		while (TRUE) {
#line 23929 "Commands.c"
			GeeIterator* _tmp7_;
			PhotoID photo_id = {0};
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			PhotoID* _tmp10_;
			PhotoID _tmp11_;
			FaceID _tmp12_;
			PhotoID _tmp13_;
#line 2628 "../src/Commands.vala"
			_tmp7_ = _photo_id_it;
#line 2628 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 2628 "../src/Commands.vala"
				break;
#line 23944 "Commands.c"
			}
#line 2628 "../src/Commands.vala"
			_tmp8_ = _photo_id_it;
#line 2628 "../src/Commands.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 2628 "../src/Commands.vala"
			_tmp10_ = (PhotoID*) _tmp9_;
#line 2628 "../src/Commands.vala"
			_tmp11_ = *_tmp10_;
#line 2628 "../src/Commands.vala"
			_photo_id_free0 (_tmp10_);
#line 2628 "../src/Commands.vala"
			photo_id = _tmp11_;
#line 2629 "../src/Commands.vala"
			_tmp12_ = face_id;
#line 2629 "../src/Commands.vala"
			_tmp13_ = photo_id;
#line 2629 "../src/Commands.vala"
			face_location_destroy (&_tmp12_, &_tmp13_);
#line 23964 "Commands.c"
		}
#line 2628 "../src/Commands.vala"
		_g_object_unref0 (_photo_id_it);
#line 23968 "Commands.c"
	}
#line 2631 "../src/Commands.vala"
	_tmp14_ = face_global;
#line 2631 "../src/Commands.vala"
	_tmp15_ = face_global;
#line 2631 "../src/Commands.vala"
	_tmp16_ = data_collection_mark (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_DATA_OBJECT, DataObject));
#line 2631 "../src/Commands.vala"
	_tmp17_ = _tmp16_;
#line 2631 "../src/Commands.vala"
	source_collection_destroy_marked (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp17_, FALSE, NULL, NULL, NULL);
#line 2631 "../src/Commands.vala"
	_g_object_unref0 (_tmp17_);
#line 23982 "Commands.c"
}

static void
delete_face_command_real_undo_on_source (SimpleProxyableCommand* base,
                                         DataSource* source)
{
	DeleteFaceCommand * self;
#line 2634 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_DELETE_FACE_COMMAND, DeleteFaceCommand);
#line 2634 "../src/Commands.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2637 "../src/Commands.vala"
	_vala_assert (IS_FACE (source), "source is Face");
#line 23996 "Commands.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 2639 "../src/Commands.vala"
		_tmp0_ = self->priv->photo_geometry_map;
#line 2639 "../src/Commands.vala"
		_tmp1_ = gee_map_get_entries (_tmp0_);
#line 2639 "../src/Commands.vala"
		_tmp2_ = _tmp1_;
#line 2639 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2639 "../src/Commands.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2639 "../src/Commands.vala"
		_tmp5_ = _tmp4_;
#line 2639 "../src/Commands.vala"
		_g_object_unref0 (_tmp3_);
#line 2639 "../src/Commands.vala"
		_entry_it = _tmp5_;
#line 2639 "../src/Commands.vala"
		while (TRUE) {
#line 24023 "Commands.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			Photo* photo = NULL;
			LibraryPhotoSourceCollection* _tmp9_;
			GeeMapEntry* _tmp10_;
			gconstpointer _tmp11_;
			gconstpointer _tmp12_;
			PhotoID _tmp13_;
			LibraryPhoto* _tmp14_;
			Photo* _tmp15_;
#line 2639 "../src/Commands.vala"
			_tmp6_ = _entry_it;
#line 2639 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 2639 "../src/Commands.vala"
				break;
#line 24042 "Commands.c"
			}
#line 2639 "../src/Commands.vala"
			_tmp7_ = _entry_it;
#line 2639 "../src/Commands.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 2639 "../src/Commands.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 2640 "../src/Commands.vala"
			_tmp9_ = library_photo_global;
#line 2640 "../src/Commands.vala"
			_tmp10_ = entry;
#line 2640 "../src/Commands.vala"
			_tmp11_ = gee_map_entry_get_key (_tmp10_);
#line 2640 "../src/Commands.vala"
			_tmp12_ = _tmp11_;
#line 2640 "../src/Commands.vala"
			_tmp13_ = *((PhotoID*) _tmp12_);
#line 2640 "../src/Commands.vala"
			_tmp14_ = library_photo_source_collection_fetch (_tmp9_, &_tmp13_);
#line 2640 "../src/Commands.vala"
			photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo);
#line 2642 "../src/Commands.vala"
			_tmp15_ = photo;
#line 2642 "../src/Commands.vala"
			if (_tmp15_ != NULL) {
#line 24068 "Commands.c"
				Face* face = NULL;
				Face* _tmp16_;
				Face* _tmp17_;
				Photo* _tmp18_;
				Face* _tmp19_;
				FaceID _tmp20_ = {0};
				GeeMapEntry* _tmp21_;
				gconstpointer _tmp22_;
				gconstpointer _tmp23_;
				GeeMapEntry* _tmp24_;
				gconstpointer _tmp25_;
				gconstpointer _tmp26_;
				FaceLocationData _tmp27_ = {0};
				PhotoID _tmp28_;
				FaceLocation* _tmp29_;
				FaceLocation* _tmp30_;
#line 2643 "../src/Commands.vala"
				_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_FACE, Face));
#line 2643 "../src/Commands.vala"
				face = _tmp16_;
#line 2645 "../src/Commands.vala"
				_tmp17_ = face;
#line 2645 "../src/Commands.vala"
				_tmp18_ = photo;
#line 2645 "../src/Commands.vala"
				face_attach (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_MEDIA_SOURCE, MediaSource));
#line 2646 "../src/Commands.vala"
				_tmp19_ = face;
#line 2646 "../src/Commands.vala"
				face_get_face_id (_tmp19_, &_tmp20_);
#line 2646 "../src/Commands.vala"
				_tmp21_ = entry;
#line 2646 "../src/Commands.vala"
				_tmp22_ = gee_map_entry_get_key (_tmp21_);
#line 2646 "../src/Commands.vala"
				_tmp23_ = _tmp22_;
#line 2646 "../src/Commands.vala"
				_tmp24_ = entry;
#line 2646 "../src/Commands.vala"
				_tmp25_ = gee_map_entry_get_value (_tmp24_);
#line 2646 "../src/Commands.vala"
				_tmp26_ = _tmp25_;
#line 2646 "../src/Commands.vala"
				_g_free0 (_tmp27_.geometry);
#line 2646 "../src/Commands.vala"
				_tmp27_.geometry = (const gchar*) _tmp26_;
#line 2646 "../src/Commands.vala"
				_g_free0 (_tmp27_.vec);
#line 2646 "../src/Commands.vala"
				_tmp27_.vec = NULL;
#line 2646 "../src/Commands.vala"
				_tmp28_ = *((PhotoID*) _tmp23_);
#line 2646 "../src/Commands.vala"
				_tmp29_ = face_location_create (&_tmp20_, &_tmp28_, &_tmp27_);
#line 2646 "../src/Commands.vala"
				_tmp30_ = _tmp29_;
#line 2646 "../src/Commands.vala"
				_g_object_unref0 (_tmp30_);
#line 2642 "../src/Commands.vala"
				_g_object_unref0 (face);
#line 24129 "Commands.c"
			}
#line 2639 "../src/Commands.vala"
			_g_object_unref0 (photo);
#line 2639 "../src/Commands.vala"
			_g_object_unref0 (entry);
#line 24135 "Commands.c"
		}
#line 2639 "../src/Commands.vala"
		_g_object_unref0 (_entry_it);
#line 24139 "Commands.c"
	}
}

static void
delete_face_command_class_init (DeleteFaceCommandClass * klass,
                                gpointer klass_data)
{
#line 2611 "../src/Commands.vala"
	delete_face_command_parent_class = g_type_class_peek_parent (klass);
#line 2611 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &DeleteFaceCommand_private_offset);
#line 2611 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->execute_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) delete_face_command_real_execute_on_source;
#line 2611 "../src/Commands.vala"
	((SimpleProxyableCommandClass *) klass)->undo_on_source = (void (*) (SimpleProxyableCommand*, DataSource*)) delete_face_command_real_undo_on_source;
#line 2611 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = delete_face_command_finalize;
#line 24157 "Commands.c"
}

static void
delete_face_command_instance_init (DeleteFaceCommand * self,
                                   gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 2611 "../src/Commands.vala"
	self->priv = delete_face_command_get_instance_private (self);
#line 2612 "../src/Commands.vala"
	_tmp0_ = gee_hash_map_new (TYPE_PHOTO_ID, (GBoxedCopyFunc) photo_id_dup, (GDestroyNotify) photo_id_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GeeHashDataFunc) face_location_photo_id_hash, NULL, NULL, (GeeEqualDataFunc) face_location_photo_ids_equal, NULL, NULL, NULL, NULL, NULL);
#line 2612 "../src/Commands.vala"
	self->priv->photo_geometry_map = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 24171 "Commands.c"
}

static void
delete_face_command_finalize (GObject * obj)
{
	DeleteFaceCommand * self;
#line 2611 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELETE_FACE_COMMAND, DeleteFaceCommand);
#line 2612 "../src/Commands.vala"
	_g_object_unref0 (self->priv->photo_geometry_map);
#line 2611 "../src/Commands.vala"
	G_OBJECT_CLASS (delete_face_command_parent_class)->finalize (obj);
#line 24184 "Commands.c"
}

static GType
delete_face_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeleteFaceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delete_face_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DeleteFaceCommand), 0, (GInstanceInitFunc) delete_face_command_instance_init, NULL };
	GType delete_face_command_type_id;
	delete_face_command_type_id = g_type_register_static (TYPE_SIMPLE_PROXYABLE_COMMAND, "DeleteFaceCommand", &g_define_type_info, 0);
	DeleteFaceCommand_private_offset = g_type_add_instance_private (delete_face_command_type_id, sizeof (DeleteFaceCommandPrivate));
	return delete_face_command_type_id;
}

GType
delete_face_command_get_type (void)
{
	static volatile gsize delete_face_command_type_id__once = 0;
	if (g_once_init_enter (&delete_face_command_type_id__once)) {
		GType delete_face_command_type_id;
		delete_face_command_type_id = delete_face_command_get_type_once ();
		g_once_init_leave (&delete_face_command_type_id__once, delete_face_command_type_id);
	}
	return delete_face_command_type_id__once;
}

static inline gpointer
modify_faces_command_get_instance_private (ModifyFacesCommand* self)
{
	return G_STRUCT_MEMBER_P (self, ModifyFacesCommand_private_offset);
}

static void
_modify_faces_command_on_proxy_broken_source_proxy_broken (SourceProxy* _sender,
                                                           gpointer self)
{
#line 2715 "../src/Commands.vala"
	modify_faces_command_on_proxy_broken ((ModifyFacesCommand*) self);
#line 24221 "Commands.c"
}

ModifyFacesCommand*
modify_faces_command_construct (GType object_type,
                                MediaSource* media,
                                GeeMap* new_face_list)
{
	ModifyFacesCommand * self = NULL;
	MediaSource* _tmp0_;
	GeeCollection* original_faces = NULL;
	FaceSourceCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeCollection* _tmp3_;
#line 2660 "../src/Commands.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (media), NULL);
#line 2660 "../src/Commands.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_face_list, GEE_TYPE_MAP), NULL);
#line 2661 "../src/Commands.vala"
	self = (ModifyFacesCommand*) single_data_source_command_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (media, TYPE_DATA_SOURCE, DataSource), RESOURCES_MODIFY_FACES_LABEL, "");
#line 2663 "../src/Commands.vala"
	_tmp0_ = _g_object_ref0 (media);
#line 2663 "../src/Commands.vala"
	_g_object_unref0 (self->priv->media);
#line 2663 "../src/Commands.vala"
	self->priv->media = _tmp0_;
#line 2666 "../src/Commands.vala"
	_tmp1_ = face_global;
#line 2666 "../src/Commands.vala"
	_tmp2_ = face_source_collection_fetch_for_source (_tmp1_, media);
#line 2666 "../src/Commands.vala"
	original_faces = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 2667 "../src/Commands.vala"
	_tmp3_ = original_faces;
#line 2667 "../src/Commands.vala"
	if (_tmp3_ != NULL) {
#line 24257 "Commands.c"
		{
			GeeIterator* _face_it = NULL;
			GeeCollection* _tmp4_;
			GeeIterator* _tmp5_;
#line 2668 "../src/Commands.vala"
			_tmp4_ = original_faces;
#line 2668 "../src/Commands.vala"
			_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2668 "../src/Commands.vala"
			_face_it = _tmp5_;
#line 2668 "../src/Commands.vala"
			while (TRUE) {
#line 24270 "Commands.c"
				GeeIterator* _tmp6_;
				Face* face = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				GeeSet* _tmp9_;
				GeeSet* _tmp10_;
				GeeSet* _tmp11_;
				Face* _tmp12_;
				gboolean _tmp13_;
#line 2668 "../src/Commands.vala"
				_tmp6_ = _face_it;
#line 2668 "../src/Commands.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2668 "../src/Commands.vala"
					break;
#line 24286 "Commands.c"
				}
#line 2668 "../src/Commands.vala"
				_tmp7_ = _face_it;
#line 2668 "../src/Commands.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2668 "../src/Commands.vala"
				face = (Face*) _tmp8_;
#line 2669 "../src/Commands.vala"
				_tmp9_ = gee_map_get_keys (new_face_list);
#line 2669 "../src/Commands.vala"
				_tmp10_ = _tmp9_;
#line 2669 "../src/Commands.vala"
				_tmp11_ = _tmp10_;
#line 2669 "../src/Commands.vala"
				_tmp12_ = face;
#line 2669 "../src/Commands.vala"
				_tmp13_ = !gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), _tmp12_);
#line 2669 "../src/Commands.vala"
				_g_object_unref0 (_tmp11_);
#line 2669 "../src/Commands.vala"
				if (_tmp13_) {
#line 24308 "Commands.c"
					SourceProxy* proxy = NULL;
					Face* _tmp14_;
					SourceProxy* _tmp15_;
					GeeArrayList* _tmp16_;
					SourceProxy* _tmp17_;
					SourceProxy* _tmp18_;
					FaceLocation* face_location = NULL;
					Face* _tmp19_;
					FaceID _tmp20_ = {0};
					PhotoID _tmp21_ = {0};
					FaceLocation* _tmp22_;
					FaceLocation* _tmp23_;
					GeeMap* _tmp24_;
					SourceProxy* _tmp25_;
					FaceLocation* _tmp26_;
					FaceLocationData _tmp27_ = {0};
					FaceLocationData _tmp28_;
					FaceLocationData _tmp29_;
#line 2670 "../src/Commands.vala"
					_tmp14_ = face;
#line 2670 "../src/Commands.vala"
					_tmp15_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PROXYABLE, Proxyable));
#line 2670 "../src/Commands.vala"
					proxy = _tmp15_;
#line 2672 "../src/Commands.vala"
					_tmp16_ = self->priv->to_remove;
#line 2672 "../src/Commands.vala"
					_tmp17_ = proxy;
#line 2672 "../src/Commands.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 2673 "../src/Commands.vala"
					_tmp18_ = proxy;
#line 2673 "../src/Commands.vala"
					g_signal_connect_object (_tmp18_, "broken", (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 2675 "../src/Commands.vala"
					_tmp19_ = face;
#line 2675 "../src/Commands.vala"
					face_get_face_id (_tmp19_, &_tmp20_);
#line 2675 "../src/Commands.vala"
					photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (media, TYPE_PHOTO, Photo), &_tmp21_);
#line 2675 "../src/Commands.vala"
					_tmp22_ = face_location_get_face_location (&_tmp20_, &_tmp21_);
#line 2675 "../src/Commands.vala"
					face_location = _tmp22_;
#line 2677 "../src/Commands.vala"
					_tmp23_ = face_location;
#line 2677 "../src/Commands.vala"
					_vala_assert (_tmp23_ != NULL, "face_location != null");
#line 2679 "../src/Commands.vala"
					_tmp24_ = self->priv->geometries;
#line 2679 "../src/Commands.vala"
					_tmp25_ = proxy;
#line 2679 "../src/Commands.vala"
					_tmp26_ = face_location;
#line 2679 "../src/Commands.vala"
					face_location_get_face_data (_tmp26_, &_tmp27_);
#line 2679 "../src/Commands.vala"
					_tmp28_ = _tmp27_;
#line 2679 "../src/Commands.vala"
					_tmp29_ = _tmp28_;
#line 2679 "../src/Commands.vala"
					gee_map_set (_tmp24_, _tmp25_, &_tmp29_);
#line 2679 "../src/Commands.vala"
					face_location_data_destroy (&_tmp28_);
#line 2669 "../src/Commands.vala"
					_g_object_unref0 (face_location);
#line 2669 "../src/Commands.vala"
					_source_proxy_unref0 (proxy);
#line 24377 "Commands.c"
				}
#line 2668 "../src/Commands.vala"
				_g_object_unref0 (face);
#line 24381 "Commands.c"
			}
#line 2668 "../src/Commands.vala"
			_g_object_unref0 (_face_it);
#line 24385 "Commands.c"
		}
	}
	{
		GeeIterator* _entry_it = NULL;
		GeeSet* _tmp30_;
		GeeSet* _tmp31_;
		GeeSet* _tmp32_;
		GeeIterator* _tmp33_;
		GeeIterator* _tmp34_;
#line 2685 "../src/Commands.vala"
		_tmp30_ = gee_map_get_entries (new_face_list);
#line 2685 "../src/Commands.vala"
		_tmp31_ = _tmp30_;
#line 2685 "../src/Commands.vala"
		_tmp32_ = _tmp31_;
#line 2685 "../src/Commands.vala"
		_tmp33_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2685 "../src/Commands.vala"
		_tmp34_ = _tmp33_;
#line 2685 "../src/Commands.vala"
		_g_object_unref0 (_tmp32_);
#line 2685 "../src/Commands.vala"
		_entry_it = _tmp34_;
#line 2685 "../src/Commands.vala"
		while (TRUE) {
#line 24411 "Commands.c"
			GeeIterator* _tmp35_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp36_;
			gpointer _tmp37_;
			gboolean _tmp38_ = FALSE;
			GeeCollection* _tmp39_;
#line 2685 "../src/Commands.vala"
			_tmp35_ = _entry_it;
#line 2685 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp35_)) {
#line 2685 "../src/Commands.vala"
				break;
#line 24424 "Commands.c"
			}
#line 2685 "../src/Commands.vala"
			_tmp36_ = _entry_it;
#line 2685 "../src/Commands.vala"
			_tmp37_ = gee_iterator_get (_tmp36_);
#line 2685 "../src/Commands.vala"
			entry = (GeeMapEntry*) _tmp37_;
#line 2686 "../src/Commands.vala"
			_tmp39_ = original_faces;
#line 2686 "../src/Commands.vala"
			if (_tmp39_ == NULL) {
#line 2686 "../src/Commands.vala"
				_tmp38_ = TRUE;
#line 24438 "Commands.c"
			} else {
				GeeCollection* _tmp40_;
				GeeMapEntry* _tmp41_;
				gconstpointer _tmp42_;
				gconstpointer _tmp43_;
#line 2686 "../src/Commands.vala"
				_tmp40_ = original_faces;
#line 2686 "../src/Commands.vala"
				_tmp41_ = entry;
#line 2686 "../src/Commands.vala"
				_tmp42_ = gee_map_entry_get_key (_tmp41_);
#line 2686 "../src/Commands.vala"
				_tmp43_ = _tmp42_;
#line 2686 "../src/Commands.vala"
				_tmp38_ = !gee_collection_contains (_tmp40_, (Face*) _tmp43_);
#line 24454 "Commands.c"
			}
#line 2686 "../src/Commands.vala"
			if (_tmp38_) {
#line 24458 "Commands.c"
				SourceProxy* proxy = NULL;
				GeeMapEntry* _tmp44_;
				gconstpointer _tmp45_;
				gconstpointer _tmp46_;
				SourceProxy* _tmp47_;
				GeeArrayList* _tmp48_;
				SourceProxy* _tmp49_;
				SourceProxy* _tmp50_;
				GeeMap* _tmp51_;
				SourceProxy* _tmp52_;
				GeeMapEntry* _tmp53_;
				gconstpointer _tmp54_;
				gconstpointer _tmp55_;
#line 2687 "../src/Commands.vala"
				_tmp44_ = entry;
#line 2687 "../src/Commands.vala"
				_tmp45_ = gee_map_entry_get_key (_tmp44_);
#line 2687 "../src/Commands.vala"
				_tmp46_ = _tmp45_;
#line 2687 "../src/Commands.vala"
				_tmp47_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST ((Face*) _tmp46_, TYPE_PROXYABLE, Proxyable));
#line 2687 "../src/Commands.vala"
				proxy = _tmp47_;
#line 2689 "../src/Commands.vala"
				_tmp48_ = self->priv->to_add;
#line 2689 "../src/Commands.vala"
				_tmp49_ = proxy;
#line 2689 "../src/Commands.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp49_);
#line 2690 "../src/Commands.vala"
				_tmp50_ = proxy;
#line 2690 "../src/Commands.vala"
				g_signal_connect_object (_tmp50_, "broken", (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 2692 "../src/Commands.vala"
				_tmp51_ = self->priv->geometries;
#line 2692 "../src/Commands.vala"
				_tmp52_ = proxy;
#line 2692 "../src/Commands.vala"
				_tmp53_ = entry;
#line 2692 "../src/Commands.vala"
				_tmp54_ = gee_map_entry_get_value (_tmp53_);
#line 2692 "../src/Commands.vala"
				_tmp55_ = _tmp54_;
#line 2692 "../src/Commands.vala"
				gee_map_set (_tmp51_, _tmp52_, (FaceLocationData*) _tmp55_);
#line 2686 "../src/Commands.vala"
				_source_proxy_unref0 (proxy);
#line 24506 "Commands.c"
			} else {
				FaceLocation* face_location = NULL;
				GeeMapEntry* _tmp56_;
				gconstpointer _tmp57_;
				gconstpointer _tmp58_;
				FaceID _tmp59_ = {0};
				PhotoID _tmp60_ = {0};
				FaceLocation* _tmp61_;
				FaceLocation* _tmp62_;
				gchar* old_geometry = NULL;
				FaceLocation* _tmp63_;
				gchar* _tmp64_;
				const gchar* _tmp65_;
				GeeMapEntry* _tmp66_;
				gconstpointer _tmp67_;
				gconstpointer _tmp68_;
				const gchar* _tmp69_;
#line 2696 "../src/Commands.vala"
				_tmp56_ = entry;
#line 2696 "../src/Commands.vala"
				_tmp57_ = gee_map_entry_get_key (_tmp56_);
#line 2696 "../src/Commands.vala"
				_tmp58_ = _tmp57_;
#line 2696 "../src/Commands.vala"
				face_get_face_id ((Face*) _tmp58_, &_tmp59_);
#line 2696 "../src/Commands.vala"
				photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (media, TYPE_PHOTO, Photo), &_tmp60_);
#line 2696 "../src/Commands.vala"
				_tmp61_ = face_location_get_face_location (&_tmp59_, &_tmp60_);
#line 2696 "../src/Commands.vala"
				face_location = _tmp61_;
#line 2698 "../src/Commands.vala"
				_tmp62_ = face_location;
#line 2698 "../src/Commands.vala"
				_vala_assert (_tmp62_ != NULL, "face_location != null");
#line 2700 "../src/Commands.vala"
				_tmp63_ = face_location;
#line 2700 "../src/Commands.vala"
				_tmp64_ = face_location_get_serialized_geometry (_tmp63_);
#line 2700 "../src/Commands.vala"
				old_geometry = _tmp64_;
#line 2701 "../src/Commands.vala"
				_tmp65_ = old_geometry;
#line 2701 "../src/Commands.vala"
				_tmp66_ = entry;
#line 2701 "../src/Commands.vala"
				_tmp67_ = gee_map_entry_get_value (_tmp66_);
#line 2701 "../src/Commands.vala"
				_tmp68_ = _tmp67_;
#line 2701 "../src/Commands.vala"
				_tmp69_ = (*((FaceLocationData*) _tmp68_)).geometry;
#line 2701 "../src/Commands.vala"
				if (g_strcmp0 (_tmp65_, _tmp69_) != 0) {
#line 24560 "Commands.c"
					SourceProxy* proxy = NULL;
					GeeMapEntry* _tmp70_;
					gconstpointer _tmp71_;
					gconstpointer _tmp72_;
					SourceProxy* _tmp73_;
					GeeMap* _tmp74_;
					SourceProxy* _tmp75_;
					GeeMapEntry* _tmp76_;
					gconstpointer _tmp77_;
					gconstpointer _tmp78_;
					SourceProxy* _tmp79_;
					GeeMap* _tmp80_;
					SourceProxy* _tmp81_;
					FaceLocation* _tmp82_;
					FaceLocationData _tmp83_ = {0};
					FaceLocationData _tmp84_;
					FaceLocationData _tmp85_;
#line 2702 "../src/Commands.vala"
					_tmp70_ = entry;
#line 2702 "../src/Commands.vala"
					_tmp71_ = gee_map_entry_get_key (_tmp70_);
#line 2702 "../src/Commands.vala"
					_tmp72_ = _tmp71_;
#line 2702 "../src/Commands.vala"
					_tmp73_ = proxyable_get_proxy (G_TYPE_CHECK_INSTANCE_CAST ((Face*) _tmp72_, TYPE_PROXYABLE, Proxyable));
#line 2702 "../src/Commands.vala"
					proxy = _tmp73_;
#line 2704 "../src/Commands.vala"
					_tmp74_ = self->priv->to_update;
#line 2704 "../src/Commands.vala"
					_tmp75_ = proxy;
#line 2704 "../src/Commands.vala"
					_tmp76_ = entry;
#line 2704 "../src/Commands.vala"
					_tmp77_ = gee_map_entry_get_value (_tmp76_);
#line 2704 "../src/Commands.vala"
					_tmp78_ = _tmp77_;
#line 2704 "../src/Commands.vala"
					gee_map_set (_tmp74_, _tmp75_, (FaceLocationData*) _tmp78_);
#line 2705 "../src/Commands.vala"
					_tmp79_ = proxy;
#line 2705 "../src/Commands.vala"
					g_signal_connect_object (_tmp79_, "broken", (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self, 0);
#line 2707 "../src/Commands.vala"
					_tmp80_ = self->priv->geometries;
#line 2707 "../src/Commands.vala"
					_tmp81_ = proxy;
#line 2707 "../src/Commands.vala"
					_tmp82_ = face_location;
#line 2707 "../src/Commands.vala"
					face_location_get_face_data (_tmp82_, &_tmp83_);
#line 2707 "../src/Commands.vala"
					_tmp84_ = _tmp83_;
#line 2707 "../src/Commands.vala"
					_tmp85_ = _tmp84_;
#line 2707 "../src/Commands.vala"
					gee_map_set (_tmp80_, _tmp81_, &_tmp85_);
#line 2707 "../src/Commands.vala"
					face_location_data_destroy (&_tmp84_);
#line 2701 "../src/Commands.vala"
					_source_proxy_unref0 (proxy);
#line 24622 "Commands.c"
				}
#line 2686 "../src/Commands.vala"
				_g_free0 (old_geometry);
#line 2686 "../src/Commands.vala"
				_g_object_unref0 (face_location);
#line 24628 "Commands.c"
			}
#line 2685 "../src/Commands.vala"
			_g_object_unref0 (entry);
#line 24632 "Commands.c"
		}
#line 2685 "../src/Commands.vala"
		_g_object_unref0 (_entry_it);
#line 24636 "Commands.c"
	}
#line 2660 "../src/Commands.vala"
	_g_object_unref0 (original_faces);
#line 2660 "../src/Commands.vala"
	return self;
#line 24642 "Commands.c"
}

ModifyFacesCommand*
modify_faces_command_new (MediaSource* media,
                          GeeMap* new_face_list)
{
#line 2660 "../src/Commands.vala"
	return modify_faces_command_construct (TYPE_MODIFY_FACES_COMMAND, media, new_face_list);
#line 24651 "Commands.c"
}

static void
modify_faces_command_real_execute (Command* base)
{
	ModifyFacesCommand * self;
#line 2724 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommand);
#line 24660 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2725 "../src/Commands.vala"
		_tmp0_ = self->priv->to_add;
#line 2725 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2725 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2725 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2725 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2725 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2725 "../src/Commands.vala"
		_proxy_index = -1;
#line 2725 "../src/Commands.vala"
		while (TRUE) {
#line 24685 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Face* face = NULL;
			SourceProxy* _tmp8_;
			DataSource* _tmp9_;
			Face* _tmp10_;
			MediaSource* _tmp11_;
			Face* _tmp12_;
			FaceID _tmp13_ = {0};
			MediaSource* _tmp14_;
			PhotoID _tmp15_ = {0};
			GeeMap* _tmp16_;
			SourceProxy* _tmp17_;
			gpointer _tmp18_;
			FaceLocationData* _tmp19_;
			FaceLocationData _tmp20_;
			FaceLocation* _tmp21_;
			FaceLocation* _tmp22_;
#line 2725 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2725 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2725 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2725 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2725 "../src/Commands.vala"
				break;
#line 24717 "Commands.c"
			}
#line 2725 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2725 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2725 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2726 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2726 "../src/Commands.vala"
			_tmp9_ = source_proxy_get_source (_tmp8_);
#line 2726 "../src/Commands.vala"
			face = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_FACE, Face);
#line 2727 "../src/Commands.vala"
			_tmp10_ = face;
#line 2727 "../src/Commands.vala"
			_tmp11_ = self->priv->media;
#line 2727 "../src/Commands.vala"
			face_attach (_tmp10_, _tmp11_);
#line 2728 "../src/Commands.vala"
			_tmp12_ = face;
#line 2728 "../src/Commands.vala"
			face_get_face_id (_tmp12_, &_tmp13_);
#line 2728 "../src/Commands.vala"
			_tmp14_ = self->priv->media;
#line 2728 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_PHOTO, Photo), &_tmp15_);
#line 2728 "../src/Commands.vala"
			_tmp16_ = self->priv->geometries;
#line 2728 "../src/Commands.vala"
			_tmp17_ = proxy;
#line 2728 "../src/Commands.vala"
			_tmp18_ = gee_map_get (_tmp16_, _tmp17_);
#line 2728 "../src/Commands.vala"
			_tmp19_ = (FaceLocationData*) _tmp18_;
#line 2728 "../src/Commands.vala"
			_tmp20_ = *_tmp19_;
#line 2728 "../src/Commands.vala"
			_tmp21_ = face_location_create (&_tmp13_, &_tmp15_, &_tmp20_);
#line 2728 "../src/Commands.vala"
			_tmp22_ = _tmp21_;
#line 2728 "../src/Commands.vala"
			_g_object_unref0 (_tmp22_);
#line 2728 "../src/Commands.vala"
			_face_location_data_free0 (_tmp19_);
#line 2725 "../src/Commands.vala"
			_g_object_unref0 (face);
#line 2725 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 24767 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp23_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _proxy_index = 0;
#line 2731 "../src/Commands.vala"
		_tmp23_ = self->priv->to_remove;
#line 2731 "../src/Commands.vala"
		_proxy_list = _tmp23_;
#line 2731 "../src/Commands.vala"
		_tmp24_ = _proxy_list;
#line 2731 "../src/Commands.vala"
		_tmp25_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2731 "../src/Commands.vala"
		_tmp26_ = _tmp25_;
#line 2731 "../src/Commands.vala"
		_proxy_size = _tmp26_;
#line 2731 "../src/Commands.vala"
		_proxy_index = -1;
#line 2731 "../src/Commands.vala"
		while (TRUE) {
#line 24794 "Commands.c"
			gint _tmp27_;
			gint _tmp28_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp29_;
			gpointer _tmp30_;
			SourceProxy* _tmp31_;
			DataSource* _tmp32_;
			Face* _tmp33_;
			MediaSource* _tmp34_;
#line 2731 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2731 "../src/Commands.vala"
			_tmp27_ = _proxy_index;
#line 2731 "../src/Commands.vala"
			_tmp28_ = _proxy_size;
#line 2731 "../src/Commands.vala"
			if (!(_tmp27_ < _tmp28_)) {
#line 2731 "../src/Commands.vala"
				break;
#line 24814 "Commands.c"
			}
#line 2731 "../src/Commands.vala"
			_tmp29_ = _proxy_list;
#line 2731 "../src/Commands.vala"
			_tmp30_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2731 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp30_;
#line 2732 "../src/Commands.vala"
			_tmp31_ = proxy;
#line 2732 "../src/Commands.vala"
			_tmp32_ = source_proxy_get_source (_tmp31_);
#line 2732 "../src/Commands.vala"
			_tmp33_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_FACE, Face);
#line 2732 "../src/Commands.vala"
			_tmp34_ = self->priv->media;
#line 2732 "../src/Commands.vala"
			face_detach (_tmp33_, _tmp34_);
#line 2732 "../src/Commands.vala"
			_g_object_unref0 (_tmp33_);
#line 2731 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 24836 "Commands.c"
		}
	}
	{
		GeeIterator* _entry_it = NULL;
		GeeMap* _tmp35_;
		GeeSet* _tmp36_;
		GeeSet* _tmp37_;
		GeeSet* _tmp38_;
		GeeIterator* _tmp39_;
		GeeIterator* _tmp40_;
#line 2734 "../src/Commands.vala"
		_tmp35_ = self->priv->to_update;
#line 2734 "../src/Commands.vala"
		_tmp36_ = gee_map_get_entries (_tmp35_);
#line 2734 "../src/Commands.vala"
		_tmp37_ = _tmp36_;
#line 2734 "../src/Commands.vala"
		_tmp38_ = _tmp37_;
#line 2734 "../src/Commands.vala"
		_tmp39_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2734 "../src/Commands.vala"
		_tmp40_ = _tmp39_;
#line 2734 "../src/Commands.vala"
		_g_object_unref0 (_tmp38_);
#line 2734 "../src/Commands.vala"
		_entry_it = _tmp40_;
#line 2734 "../src/Commands.vala"
		while (TRUE) {
#line 24865 "Commands.c"
			GeeIterator* _tmp41_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp42_;
			gpointer _tmp43_;
			Face* face = NULL;
			GeeMapEntry* _tmp44_;
			gconstpointer _tmp45_;
			gconstpointer _tmp46_;
			DataSource* _tmp47_;
			Face* _tmp48_;
			FaceID _tmp49_ = {0};
			MediaSource* _tmp50_;
			PhotoID _tmp51_ = {0};
			GeeMapEntry* _tmp52_;
			gconstpointer _tmp53_;
			gconstpointer _tmp54_;
			FaceLocationData _tmp55_;
			FaceLocation* _tmp56_;
			FaceLocation* _tmp57_;
#line 2734 "../src/Commands.vala"
			_tmp41_ = _entry_it;
#line 2734 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp41_)) {
#line 2734 "../src/Commands.vala"
				break;
#line 24891 "Commands.c"
			}
#line 2734 "../src/Commands.vala"
			_tmp42_ = _entry_it;
#line 2734 "../src/Commands.vala"
			_tmp43_ = gee_iterator_get (_tmp42_);
#line 2734 "../src/Commands.vala"
			entry = (GeeMapEntry*) _tmp43_;
#line 2735 "../src/Commands.vala"
			_tmp44_ = entry;
#line 2735 "../src/Commands.vala"
			_tmp45_ = gee_map_entry_get_key (_tmp44_);
#line 2735 "../src/Commands.vala"
			_tmp46_ = _tmp45_;
#line 2735 "../src/Commands.vala"
			_tmp47_ = source_proxy_get_source ((SourceProxy*) _tmp46_);
#line 2735 "../src/Commands.vala"
			face = G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_FACE, Face);
#line 2736 "../src/Commands.vala"
			_tmp48_ = face;
#line 2736 "../src/Commands.vala"
			face_get_face_id (_tmp48_, &_tmp49_);
#line 2736 "../src/Commands.vala"
			_tmp50_ = self->priv->media;
#line 2736 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, TYPE_PHOTO, Photo), &_tmp51_);
#line 2736 "../src/Commands.vala"
			_tmp52_ = entry;
#line 2736 "../src/Commands.vala"
			_tmp53_ = gee_map_entry_get_value (_tmp52_);
#line 2736 "../src/Commands.vala"
			_tmp54_ = _tmp53_;
#line 2736 "../src/Commands.vala"
			_tmp55_ = *((FaceLocationData*) _tmp54_);
#line 2736 "../src/Commands.vala"
			_tmp56_ = face_location_create (&_tmp49_, &_tmp51_, &_tmp55_);
#line 2736 "../src/Commands.vala"
			_tmp57_ = _tmp56_;
#line 2736 "../src/Commands.vala"
			_g_object_unref0 (_tmp57_);
#line 2734 "../src/Commands.vala"
			_g_object_unref0 (face);
#line 2734 "../src/Commands.vala"
			_g_object_unref0 (entry);
#line 24935 "Commands.c"
		}
#line 2734 "../src/Commands.vala"
		_g_object_unref0 (_entry_it);
#line 24939 "Commands.c"
	}
}

static void
modify_faces_command_real_undo (Command* base)
{
	ModifyFacesCommand * self;
#line 2740 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommand);
#line 24949 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2741 "../src/Commands.vala"
		_tmp0_ = self->priv->to_add;
#line 2741 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2741 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2741 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2741 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2741 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2741 "../src/Commands.vala"
		_proxy_index = -1;
#line 2741 "../src/Commands.vala"
		while (TRUE) {
#line 24974 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			SourceProxy* _tmp8_;
			DataSource* _tmp9_;
			Face* _tmp10_;
			MediaSource* _tmp11_;
#line 2741 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2741 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2741 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2741 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2741 "../src/Commands.vala"
				break;
#line 24994 "Commands.c"
			}
#line 2741 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2741 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2741 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2742 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2742 "../src/Commands.vala"
			_tmp9_ = source_proxy_get_source (_tmp8_);
#line 2742 "../src/Commands.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_FACE, Face);
#line 2742 "../src/Commands.vala"
			_tmp11_ = self->priv->media;
#line 2742 "../src/Commands.vala"
			face_detach (_tmp10_, _tmp11_);
#line 2742 "../src/Commands.vala"
			_g_object_unref0 (_tmp10_);
#line 2741 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25016 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp12_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _proxy_index = 0;
#line 2744 "../src/Commands.vala"
		_tmp12_ = self->priv->to_remove;
#line 2744 "../src/Commands.vala"
		_proxy_list = _tmp12_;
#line 2744 "../src/Commands.vala"
		_tmp13_ = _proxy_list;
#line 2744 "../src/Commands.vala"
		_tmp14_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2744 "../src/Commands.vala"
		_tmp15_ = _tmp14_;
#line 2744 "../src/Commands.vala"
		_proxy_size = _tmp15_;
#line 2744 "../src/Commands.vala"
		_proxy_index = -1;
#line 2744 "../src/Commands.vala"
		while (TRUE) {
#line 25043 "Commands.c"
			gint _tmp16_;
			gint _tmp17_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			Face* face = NULL;
			SourceProxy* _tmp20_;
			DataSource* _tmp21_;
			Face* _tmp22_;
			MediaSource* _tmp23_;
			Face* _tmp24_;
			FaceID _tmp25_ = {0};
			MediaSource* _tmp26_;
			PhotoID _tmp27_ = {0};
			GeeMap* _tmp28_;
			SourceProxy* _tmp29_;
			gpointer _tmp30_;
			FaceLocationData* _tmp31_;
			FaceLocationData _tmp32_;
			FaceLocation* _tmp33_;
			FaceLocation* _tmp34_;
#line 2744 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2744 "../src/Commands.vala"
			_tmp16_ = _proxy_index;
#line 2744 "../src/Commands.vala"
			_tmp17_ = _proxy_size;
#line 2744 "../src/Commands.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 2744 "../src/Commands.vala"
				break;
#line 25075 "Commands.c"
			}
#line 2744 "../src/Commands.vala"
			_tmp18_ = _proxy_list;
#line 2744 "../src/Commands.vala"
			_tmp19_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2744 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp19_;
#line 2745 "../src/Commands.vala"
			_tmp20_ = proxy;
#line 2745 "../src/Commands.vala"
			_tmp21_ = source_proxy_get_source (_tmp20_);
#line 2745 "../src/Commands.vala"
			face = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_FACE, Face);
#line 2746 "../src/Commands.vala"
			_tmp22_ = face;
#line 2746 "../src/Commands.vala"
			_tmp23_ = self->priv->media;
#line 2746 "../src/Commands.vala"
			face_attach (_tmp22_, _tmp23_);
#line 2747 "../src/Commands.vala"
			_tmp24_ = face;
#line 2747 "../src/Commands.vala"
			face_get_face_id (_tmp24_, &_tmp25_);
#line 2747 "../src/Commands.vala"
			_tmp26_ = self->priv->media;
#line 2747 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_PHOTO, Photo), &_tmp27_);
#line 2747 "../src/Commands.vala"
			_tmp28_ = self->priv->geometries;
#line 2747 "../src/Commands.vala"
			_tmp29_ = proxy;
#line 2747 "../src/Commands.vala"
			_tmp30_ = gee_map_get (_tmp28_, _tmp29_);
#line 2747 "../src/Commands.vala"
			_tmp31_ = (FaceLocationData*) _tmp30_;
#line 2747 "../src/Commands.vala"
			_tmp32_ = *_tmp31_;
#line 2747 "../src/Commands.vala"
			_tmp33_ = face_location_create (&_tmp25_, &_tmp27_, &_tmp32_);
#line 2747 "../src/Commands.vala"
			_tmp34_ = _tmp33_;
#line 2747 "../src/Commands.vala"
			_g_object_unref0 (_tmp34_);
#line 2747 "../src/Commands.vala"
			_face_location_data_free0 (_tmp31_);
#line 2744 "../src/Commands.vala"
			_g_object_unref0 (face);
#line 2744 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25125 "Commands.c"
		}
	}
	{
		GeeIterator* _proxy_it = NULL;
		GeeMap* _tmp35_;
		GeeSet* _tmp36_;
		GeeSet* _tmp37_;
		GeeSet* _tmp38_;
		GeeIterator* _tmp39_;
		GeeIterator* _tmp40_;
#line 2750 "../src/Commands.vala"
		_tmp35_ = self->priv->to_update;
#line 2750 "../src/Commands.vala"
		_tmp36_ = gee_map_get_keys (_tmp35_);
#line 2750 "../src/Commands.vala"
		_tmp37_ = _tmp36_;
#line 2750 "../src/Commands.vala"
		_tmp38_ = _tmp37_;
#line 2750 "../src/Commands.vala"
		_tmp39_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2750 "../src/Commands.vala"
		_tmp40_ = _tmp39_;
#line 2750 "../src/Commands.vala"
		_g_object_unref0 (_tmp38_);
#line 2750 "../src/Commands.vala"
		_proxy_it = _tmp40_;
#line 2750 "../src/Commands.vala"
		while (TRUE) {
#line 25154 "Commands.c"
			GeeIterator* _tmp41_;
			SourceProxy* proxy = NULL;
			GeeIterator* _tmp42_;
			gpointer _tmp43_;
			Face* face = NULL;
			SourceProxy* _tmp44_;
			DataSource* _tmp45_;
			Face* _tmp46_;
			FaceID _tmp47_ = {0};
			MediaSource* _tmp48_;
			PhotoID _tmp49_ = {0};
			GeeMap* _tmp50_;
			SourceProxy* _tmp51_;
			gpointer _tmp52_;
			FaceLocationData* _tmp53_;
			FaceLocationData _tmp54_;
			FaceLocation* _tmp55_;
			FaceLocation* _tmp56_;
#line 2750 "../src/Commands.vala"
			_tmp41_ = _proxy_it;
#line 2750 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp41_)) {
#line 2750 "../src/Commands.vala"
				break;
#line 25179 "Commands.c"
			}
#line 2750 "../src/Commands.vala"
			_tmp42_ = _proxy_it;
#line 2750 "../src/Commands.vala"
			_tmp43_ = gee_iterator_get (_tmp42_);
#line 2750 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp43_;
#line 2751 "../src/Commands.vala"
			_tmp44_ = proxy;
#line 2751 "../src/Commands.vala"
			_tmp45_ = source_proxy_get_source (_tmp44_);
#line 2751 "../src/Commands.vala"
			face = G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_FACE, Face);
#line 2752 "../src/Commands.vala"
			_tmp46_ = face;
#line 2752 "../src/Commands.vala"
			face_get_face_id (_tmp46_, &_tmp47_);
#line 2752 "../src/Commands.vala"
			_tmp48_ = self->priv->media;
#line 2752 "../src/Commands.vala"
			photo_get_photo_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_PHOTO, Photo), &_tmp49_);
#line 2752 "../src/Commands.vala"
			_tmp50_ = self->priv->geometries;
#line 2752 "../src/Commands.vala"
			_tmp51_ = proxy;
#line 2752 "../src/Commands.vala"
			_tmp52_ = gee_map_get (_tmp50_, _tmp51_);
#line 2752 "../src/Commands.vala"
			_tmp53_ = (FaceLocationData*) _tmp52_;
#line 2752 "../src/Commands.vala"
			_tmp54_ = *_tmp53_;
#line 2752 "../src/Commands.vala"
			_tmp55_ = face_location_create (&_tmp47_, &_tmp49_, &_tmp54_);
#line 2752 "../src/Commands.vala"
			_tmp56_ = _tmp55_;
#line 2752 "../src/Commands.vala"
			_g_object_unref0 (_tmp56_);
#line 2752 "../src/Commands.vala"
			_face_location_data_free0 (_tmp53_);
#line 2750 "../src/Commands.vala"
			_g_object_unref0 (face);
#line 2750 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25223 "Commands.c"
		}
#line 2750 "../src/Commands.vala"
		_g_object_unref0 (_proxy_it);
#line 25227 "Commands.c"
	}
}

static void
modify_faces_command_on_proxy_broken (ModifyFacesCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 2756 "../src/Commands.vala"
	g_return_if_fail (IS_MODIFY_FACES_COMMAND (self));
#line 2757 "../src/Commands.vala"
	_tmp0_ = command_get_command_manager (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_COMMAND, Command));
#line 2757 "../src/Commands.vala"
	_tmp1_ = _tmp0_;
#line 2757 "../src/Commands.vala"
	command_manager_reset (_tmp1_);
#line 2757 "../src/Commands.vala"
	_command_manager_unref0 (_tmp1_);
#line 25246 "Commands.c"
}

static void
modify_faces_command_class_init (ModifyFacesCommandClass * klass,
                                 gpointer klass_data)
{
#line 2653 "../src/Commands.vala"
	modify_faces_command_parent_class = g_type_class_peek_parent (klass);
#line 2653 "../src/Commands.vala"
	g_type_class_adjust_private_offset (klass, &ModifyFacesCommand_private_offset);
#line 2653 "../src/Commands.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) modify_faces_command_real_execute;
#line 2653 "../src/Commands.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) modify_faces_command_real_undo;
#line 2653 "../src/Commands.vala"
	G_OBJECT_CLASS (klass)->finalize = modify_faces_command_finalize;
#line 25263 "Commands.c"
}

static void
modify_faces_command_instance_init (ModifyFacesCommand * self,
                                    gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
#line 2653 "../src/Commands.vala"
	self->priv = modify_faces_command_get_instance_private (self);
#line 2655 "../src/Commands.vala"
	_tmp0_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 2655 "../src/Commands.vala"
	self->priv->to_add = _tmp0_;
#line 2656 "../src/Commands.vala"
	_tmp1_ = gee_array_list_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, NULL, NULL, NULL);
#line 2656 "../src/Commands.vala"
	self->priv->to_remove = _tmp1_;
#line 2657 "../src/Commands.vala"
	_tmp2_ = gee_hash_map_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, TYPE_FACE_LOCATION_DATA, (GBoxedCopyFunc) face_location_data_dup, (GDestroyNotify) face_location_data_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2657 "../src/Commands.vala"
	self->priv->to_update = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MAP, GeeMap);
#line 2658 "../src/Commands.vala"
	_tmp3_ = gee_hash_map_new (TYPE_SOURCE_PROXY, (GBoxedCopyFunc) source_proxy_ref, (GDestroyNotify) source_proxy_unref, TYPE_FACE_LOCATION_DATA, (GBoxedCopyFunc) face_location_data_dup, (GDestroyNotify) face_location_data_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2658 "../src/Commands.vala"
	self->priv->geometries = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_MAP, GeeMap);
#line 25292 "Commands.c"
}

static void
modify_faces_command_finalize (GObject * obj)
{
	ModifyFacesCommand * self;
#line 2653 "../src/Commands.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MODIFY_FACES_COMMAND, ModifyFacesCommand);
#line 25301 "Commands.c"
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp0_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _proxy_index = 0;
#line 2714 "../src/Commands.vala"
		_tmp0_ = self->priv->to_add;
#line 2714 "../src/Commands.vala"
		_proxy_list = _tmp0_;
#line 2714 "../src/Commands.vala"
		_tmp1_ = _proxy_list;
#line 2714 "../src/Commands.vala"
		_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2714 "../src/Commands.vala"
		_tmp3_ = _tmp2_;
#line 2714 "../src/Commands.vala"
		_proxy_size = _tmp3_;
#line 2714 "../src/Commands.vala"
		_proxy_index = -1;
#line 2714 "../src/Commands.vala"
		while (TRUE) {
#line 25326 "Commands.c"
			gint _tmp4_;
			gint _tmp5_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			SourceProxy* _tmp8_;
			guint _tmp9_;
#line 2714 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2714 "../src/Commands.vala"
			_tmp4_ = _proxy_index;
#line 2714 "../src/Commands.vala"
			_tmp5_ = _proxy_size;
#line 2714 "../src/Commands.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 2714 "../src/Commands.vala"
				break;
#line 25344 "Commands.c"
			}
#line 2714 "../src/Commands.vala"
			_tmp6_ = _proxy_list;
#line 2714 "../src/Commands.vala"
			_tmp7_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2714 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp7_;
#line 2715 "../src/Commands.vala"
			_tmp8_ = proxy;
#line 2715 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp9_, NULL, FALSE);
#line 2715 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self);
#line 2714 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25360 "Commands.c"
		}
	}
	{
		GeeArrayList* _proxy_list = NULL;
		GeeArrayList* _tmp10_;
		gint _proxy_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _proxy_index = 0;
#line 2717 "../src/Commands.vala"
		_tmp10_ = self->priv->to_remove;
#line 2717 "../src/Commands.vala"
		_proxy_list = _tmp10_;
#line 2717 "../src/Commands.vala"
		_tmp11_ = _proxy_list;
#line 2717 "../src/Commands.vala"
		_tmp12_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 2717 "../src/Commands.vala"
		_tmp13_ = _tmp12_;
#line 2717 "../src/Commands.vala"
		_proxy_size = _tmp13_;
#line 2717 "../src/Commands.vala"
		_proxy_index = -1;
#line 2717 "../src/Commands.vala"
		while (TRUE) {
#line 25387 "Commands.c"
			gint _tmp14_;
			gint _tmp15_;
			SourceProxy* proxy = NULL;
			GeeArrayList* _tmp16_;
			gpointer _tmp17_;
			SourceProxy* _tmp18_;
			guint _tmp19_;
#line 2717 "../src/Commands.vala"
			_proxy_index = _proxy_index + 1;
#line 2717 "../src/Commands.vala"
			_tmp14_ = _proxy_index;
#line 2717 "../src/Commands.vala"
			_tmp15_ = _proxy_size;
#line 2717 "../src/Commands.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 2717 "../src/Commands.vala"
				break;
#line 25405 "Commands.c"
			}
#line 2717 "../src/Commands.vala"
			_tmp16_ = _proxy_list;
#line 2717 "../src/Commands.vala"
			_tmp17_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _proxy_index);
#line 2717 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp17_;
#line 2718 "../src/Commands.vala"
			_tmp18_ = proxy;
#line 2718 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp19_, NULL, FALSE);
#line 2718 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self);
#line 2717 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25421 "Commands.c"
		}
	}
	{
		GeeIterator* _proxy_it = NULL;
		GeeMap* _tmp20_;
		GeeSet* _tmp21_;
		GeeSet* _tmp22_;
		GeeSet* _tmp23_;
		GeeIterator* _tmp24_;
		GeeIterator* _tmp25_;
#line 2720 "../src/Commands.vala"
		_tmp20_ = self->priv->to_update;
#line 2720 "../src/Commands.vala"
		_tmp21_ = gee_map_get_keys (_tmp20_);
#line 2720 "../src/Commands.vala"
		_tmp22_ = _tmp21_;
#line 2720 "../src/Commands.vala"
		_tmp23_ = _tmp22_;
#line 2720 "../src/Commands.vala"
		_tmp24_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2720 "../src/Commands.vala"
		_tmp25_ = _tmp24_;
#line 2720 "../src/Commands.vala"
		_g_object_unref0 (_tmp23_);
#line 2720 "../src/Commands.vala"
		_proxy_it = _tmp25_;
#line 2720 "../src/Commands.vala"
		while (TRUE) {
#line 25450 "Commands.c"
			GeeIterator* _tmp26_;
			SourceProxy* proxy = NULL;
			GeeIterator* _tmp27_;
			gpointer _tmp28_;
			SourceProxy* _tmp29_;
			guint _tmp30_;
#line 2720 "../src/Commands.vala"
			_tmp26_ = _proxy_it;
#line 2720 "../src/Commands.vala"
			if (!gee_iterator_next (_tmp26_)) {
#line 2720 "../src/Commands.vala"
				break;
#line 25463 "Commands.c"
			}
#line 2720 "../src/Commands.vala"
			_tmp27_ = _proxy_it;
#line 2720 "../src/Commands.vala"
			_tmp28_ = gee_iterator_get (_tmp27_);
#line 2720 "../src/Commands.vala"
			proxy = (SourceProxy*) _tmp28_;
#line 2721 "../src/Commands.vala"
			_tmp29_ = proxy;
#line 2721 "../src/Commands.vala"
			g_signal_parse_name ("broken", TYPE_SOURCE_PROXY, &_tmp30_, NULL, FALSE);
#line 2721 "../src/Commands.vala"
			g_signal_handlers_disconnect_matched (_tmp29_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp30_, 0, NULL, (GCallback) _modify_faces_command_on_proxy_broken_source_proxy_broken, self);
#line 2720 "../src/Commands.vala"
			_source_proxy_unref0 (proxy);
#line 25479 "Commands.c"
		}
#line 2720 "../src/Commands.vala"
		_g_object_unref0 (_proxy_it);
#line 25483 "Commands.c"
	}
#line 2654 "../src/Commands.vala"
	_g_object_unref0 (self->priv->media);
#line 2655 "../src/Commands.vala"
	_g_object_unref0 (self->priv->to_add);
#line 2656 "../src/Commands.vala"
	_g_object_unref0 (self->priv->to_remove);
#line 2657 "../src/Commands.vala"
	_g_object_unref0 (self->priv->to_update);
#line 2658 "../src/Commands.vala"
	_g_object_unref0 (self->priv->geometries);
#line 2653 "../src/Commands.vala"
	G_OBJECT_CLASS (modify_faces_command_parent_class)->finalize (obj);
#line 25497 "Commands.c"
}

static GType
modify_faces_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ModifyFacesCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) modify_faces_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ModifyFacesCommand), 0, (GInstanceInitFunc) modify_faces_command_instance_init, NULL };
	GType modify_faces_command_type_id;
	modify_faces_command_type_id = g_type_register_static (TYPE_SINGLE_DATA_SOURCE_COMMAND, "ModifyFacesCommand", &g_define_type_info, 0);
	ModifyFacesCommand_private_offset = g_type_add_instance_private (modify_faces_command_type_id, sizeof (ModifyFacesCommandPrivate));
	return modify_faces_command_type_id;
}

GType
modify_faces_command_get_type (void)
{
	static volatile gsize modify_faces_command_type_id__once = 0;
	if (g_once_init_enter (&modify_faces_command_type_id__once)) {
		GType modify_faces_command_type_id;
		modify_faces_command_type_id = modify_faces_command_get_type_once ();
		g_once_init_leave (&modify_faces_command_type_id__once, modify_faces_command_type_id);
	}
	return modify_faces_command_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

