/* DirectoryMonitor.c generated by valac 0.56.3, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;
enum  {
	DIRECTORY_MONITOR_0_PROPERTY,
	DIRECTORY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* directory_monitor_properties[DIRECTORY_MONITOR_NUM_PROPERTIES];
typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;
enum  {
	DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL,
	DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_CREATED_SIGNAL,
	DIRECTORY_MONITOR_FILE_MOVED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL,
	DIRECTORY_MONITOR_CLOSED_SIGNAL,
	DIRECTORY_MONITOR_NUM_SIGNALS
};
static guint directory_monitor_signals[DIRECTORY_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	gint _dir_child_size;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _dir_child_index;
	gint _tmp9_;
	gint _tmp10_;
	GFile* dir_child;
	GeeArrayList* _tmp11_;
	gpointer _tmp12_;
	GFileInfo* dir_info;
	DirectoryMonitorFileInfoMap* _tmp13_;
	GFile* _tmp14_;
	GFileInfo* _tmp15_;
	GFileInfo* _tmp16_;
	GFile* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GFile* _tmp20_;
	GFileInfo* _tmp21_;
	GFile* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFileInfo* _tmp27_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp28_;
	gint _file_child_size;
	GeeArrayList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _file_child_index;
	gint _tmp32_;
	gint _tmp33_;
	GFile* file_child;
	GeeArrayList* _tmp34_;
	gpointer _tmp35_;
	GFileInfo* file_info;
	DirectoryMonitorFileInfoMap* _tmp36_;
	GFile* _tmp37_;
	GFileInfo* _tmp38_;
	GFileInfo* _tmp39_;
	GFile* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GFile* _tmp47_;
	GFile* _tmp48_;
	GFileInfo* _tmp49_;
	DirectoryMonitorFileInfoMap* _tmp50_;
	gboolean updated;
	DirectoryMonitorFileInfoMap* _tmp51_;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	gint _dir_child_size;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _dir_child_index;
	gint _tmp9_;
	gint _tmp10_;
	GFile* dir_child;
	GeeArrayList* _tmp11_;
	gpointer _tmp12_;
	GFile* _tmp13_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp14_;
	gint _file_child_size;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _file_child_index;
	gint _tmp18_;
	gint _tmp19_;
	GFile* file_child;
	GeeArrayList* _tmp20_;
	gpointer _tmp21_;
	DirectoryMonitorFileInfoMap* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	DirectoryMonitorFileInfoMap* _tmp25_;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFileInfo* _tmp5_;
	GCancellable* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
	GError* err;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GFileInfo* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	GFileInfo* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GFileInfo* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GFileInfo* _tmp26_;
	GEnumValue* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* enumerator;
	GCancellable* _tmp30_;
	GFileEnumerator* _tmp31_;
	gboolean _tmp32_;
	GList* infos;
	GFileEnumerator* _tmp33_;
	GCancellable* _tmp34_;
	GList* _tmp35_;
	GList* _tmp36_;
	GList* _tmp37_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp38_;
	GFileInfo* info;
	GFileInfo* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gboolean _tmp42_;
	GFileInfo* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GFileInfo* _tmp46_;
	GFileInfo* _tmp47_;
	const gchar* _tmp48_;
	GFile* _tmp49_;
	GFile* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GFileInfo* _tmp53_;
	GFileInfo* _tmp54_;
	GeeHashMap* _tmp55_;
	GeeHashMap* _tmp56_;
	GeeHashMap* _tmp57_;
	GFileInfo* _tmp58_;
	const gchar* _tmp59_;
	GFile* _tmp60_;
	GFile* _tmp61_;
	GFileInfo* _tmp62_;
	GeeHashMap* _tmp63_;
	GeeHashMap* _tmp64_;
	GeeHashMap* _tmp65_;
	GFileInfo* _tmp66_;
	const gchar* _tmp67_;
	GFile* _tmp68_;
	GFile* _tmp69_;
	GFileInfo* _tmp70_;
	GError* err2;
	gchar* _tmp71_;
	gchar* _tmp72_;
	GError* _tmp73_;
	const gchar* _tmp74_;
	GFileInfo* _tmp75_;
	GFileInfo* _tmp76_;
	GFileInfo* _tmp77_;
	GeeHashMap* _tmp78_;
	GeeHashMap* _tmp79_;
	gboolean _tmp80_;
	GeeHashMap* _tmp81_;
	GeeIterator* _subdir_it;
	GeeHashMap* _tmp82_;
	GeeSet* _tmp83_;
	GeeSet* _tmp84_;
	GeeSet* _tmp85_;
	GeeIterator* _tmp86_;
	GeeIterator* _tmp87_;
	GeeIterator* _tmp88_;
	GFile* subdir;
	GeeIterator* _tmp89_;
	gpointer _tmp90_;
	gint _tmp91_;
	GFile* _tmp92_;
	GeeHashMap* _tmp93_;
	GFile* _tmp94_;
	gpointer _tmp95_;
	GFileInfo* _tmp96_;
	GFile* _tmp97_;
	GeeHashMap* _tmp98_;
	GFile* _tmp99_;
	gpointer _tmp100_;
	GFileInfo* _tmp101_;
	GError* _inner_error0_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMapIterator* _tmp2_;
	gpointer _tmp3_;
	GFile* _tmp4_;
	GeeMapIterator* _tmp5_;
	gpointer _tmp6_;
	GFileInfo* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	GFile* _tmp10_;
	GeeMapIterator* _tmp11_;
	gpointer _tmp12_;
	GFileInfo* _tmp13_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};

static gint DirectoryMonitor_private_offset;
static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gint DirectoryMonitorFileInfoMap_private_offset;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

VALA_EXTERN GType directory_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DirectoryMonitor, g_object_unref)
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags) G_GNUC_UNUSED ;
static void directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                           gpointer v_object) G_GNUC_UNUSED ;
static void directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                            gpointer v_object) G_GNUC_UNUSED ;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED ;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DirectoryMonitorQueryInfoQueueElement, directory_monitor_query_info_queue_element_unref)
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags) G_GNUC_UNUSED ;
static void directory_monitor_value_set_file_info_map (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED ;
static void directory_monitor_value_take_file_info_map (GValue* value,
                                                 gpointer v_object) G_GNUC_UNUSED ;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED ;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DirectoryMonitorFileInfoMap, directory_monitor_file_info_map_unref)
VALA_EXTERN void directory_monitor_notify_root_deleted (DirectoryMonitor* self,
                                            GFile* root);
VALA_EXTERN void directory_monitor_notify_root_moved (DirectoryMonitor* self,
                                          GFile* old_root,
                                          GFile* new_root,
                                          GFileInfo* new_root_info);
VALA_EXTERN void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
VALA_EXTERN void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self,
                                                        GFile* file,
                                                        GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_file_discovered (DirectoryMonitor* self,
                                               GFile* file,
                                               GFileInfo* info);
VALA_EXTERN void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                             GFile* dir,
                                                             GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_directory_discovered (DirectoryMonitor* self,
                                                    GFile* dir,
                                                    GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_discovery_failed (DirectoryMonitor* self,
                                                const gchar* reason);
VALA_EXTERN void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
VALA_EXTERN void directory_monitor_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info);
VALA_EXTERN void directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file);
VALA_EXTERN void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file);
VALA_EXTERN void directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file);
VALA_EXTERN void directory_monitor_notify_directory_created (DirectoryMonitor* self,
                                                 GFile* dir,
                                                 GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_directory_moved (DirectoryMonitor* self,
                                               GFile* old_dir,
                                               GFile* new_dir,
                                               GFileInfo* new_dir_info);
VALA_EXTERN void directory_monitor_notify_directory_altered (DirectoryMonitor* self,
                                                 GFile* dir);
VALA_EXTERN void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                              GFile* dir,
                                                              GFileInfo* info);
VALA_EXTERN void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                            GFile* dir);
VALA_EXTERN void directory_monitor_notify_directory_deleted (DirectoryMonitor* self,
                                                 GFile* dir);
VALA_EXTERN void directory_monitor_notify_closed (DirectoryMonitor* self);
VALA_EXTERN void directory_monitor_close (DirectoryMonitor* self);
static GType directory_monitor_ftype_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
VALA_EXTERN DirectoryMonitor* directory_monitor_new (GFile* root,
                                         gboolean recurse,
                                         gboolean monitoring);
VALA_EXTERN DirectoryMonitor* directory_monitor_construct (GType object_type,
                                               GFile* root,
                                               gboolean recurse,
                                               gboolean monitoring);
VALA_EXTERN void directory_monitor_mdbg (const gchar* msg);
VALA_EXTERN gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
VALA_EXTERN gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                                 GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                                   GFile* old_root,
                                                   GFile* new_root,
                                                   GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                               GFile* old_root,
                                               GFile* new_root,
                                               GFileInfo* new_root_info);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                     const gchar* reason);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                     GFile* file,
                                                     GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile** old_file,
                                                GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                                   GFile* old_file,
                                                   GFile* new_file,
                                                   GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                               GFile* old_file,
                                               GFile* new_file,
                                               GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* file,
                                                                  GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                              GFile* file,
                                                              GFileInfo* info);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                            GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                     GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                          GFile* dir,
                                                          GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                         GFile* root,
                                                         DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                        GFile* old_dir,
                                                        GFileInfo* old_dir_info,
                                                        GFile* new_dir,
                                                        GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                      GFile* dir,
                                                      GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                              GFile* old_dir,
                                                              GFileInfo* old_dir_info,
                                                              GFile* new_dir,
                                                              GFileInfo* new_dir_info,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                     GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_);
VALA_EXTERN gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                                   GFile* root,
                                                   GeeCollection* files,
                                                   GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                                     GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self,
                                           GFile* dir,
                                           GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self,
                                        GFile* dir,
                                        GFileInfo* info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                                    GFile* old_dir,
                                                    GFile* new_dir,
                                                    GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                      GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                       GFile* dir,
                                                                       GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                   GFile* dir,
                                                                   GFileInfo* info);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                                 GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       gboolean already_removed,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                              GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                      GFile* dir);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
VALA_EXTERN GFile* directory_monitor_get_root (DirectoryMonitor* self);
VALA_EXTERN gboolean directory_monitor_is_in_root (DirectoryMonitor* self,
                                       GFile* file);
VALA_EXTERN gboolean directory_monitor_has_started (DirectoryMonitor* self);
VALA_EXTERN void directory_monitor_start_discovery (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self,
                                      GFile* dir,
                                      GFileInfo* dir_info,
                                      gboolean in_discovery,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self,
                                       GAsyncResult* _res_);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                       GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
static void directory_monitor_explore_async_data_free (gpointer _data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                                   GFile* file,
                                                   GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                                    gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* get_file_info_id (GFileInfo* info);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
VALA_EXTERN guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                               GeeMap* map,
                                               gboolean in_discovery,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                      GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                               GFile* file,
                                               GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                        GFile* file,
                                                                        GFile* other_file,
                                                                        GFileMonitorEvent event_type,
                                                                        gpointer self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                                                       GFile* file,
                                                                                       GFile* other_file,
                                                                                       GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type,
                                                                                             DirectoryMonitor* owner,
                                                                                             GFile* file,
                                                                                             GFile* other_file,
                                                                                             GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                              GObject* source,
                                                              GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                     GAsyncResult* res,
                                                                                     gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self,
                                            DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                                   GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileInfo* info,
                                                      GFileMonitorEvent event);
VALA_EXTERN GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self,
                                            GFile* file);
VALA_EXTERN gulong now_ms (void);
VALA_EXTERN GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
VALA_EXTERN GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self,
                                              GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                                       GFile* file,
                                                       GCancellable* cancellable);
static void directory_monitor_real_root_moved (DirectoryMonitor* self,
                                        GFile* old_root,
                                        GFile* new_root,
                                        GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                          GFile* root);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                              const gchar* reason);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_file_created (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self,
                                        GFile* old_file,
                                        GFile* new_file,
                                        GFileInfo* new_file_info);
static void directory_monitor_real_file_altered (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                       GFile* file,
                                                       GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                     GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_directory_created (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                             GFile* old_dir,
                                             GFile* new_dir,
                                             GFileInfo* new_dir_info);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                            GFile* dir,
                                                            GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_closed (DirectoryMonitor* self);
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj);
static GType directory_monitor_query_info_queue_element_get_type_once (void);
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                         GFile* file,
                                                         GFileInfo* info,
                                                         GFile** normalized,
                                                         gchar** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                                 GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj);
static GType directory_monitor_file_info_map_get_type_once (void);
static void directory_monitor_finalize (GObject * obj);
static GType directory_monitor_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
directory_monitor_get_instance_private (DirectoryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitor_private_offset);
}

static GType
directory_monitor_ftype_get_type_once (void)
{
	static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
	GType directory_monitor_ftype_type_id;
	directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
	return directory_monitor_ftype_type_id;
}

static GType
directory_monitor_ftype_get_type (void)
{
	static volatile gsize directory_monitor_ftype_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__once)) {
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = directory_monitor_ftype_get_type_once ();
		g_once_init_leave (&directory_monitor_ftype_type_id__once, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 465 "../src/DirectoryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 1016 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_construct (GType object_type,
                             GFile* root,
                             gboolean recurse,
                             gboolean monitoring)
{
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
#line 464 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_file_get_type ()), NULL);
#line 464 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 465 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 465 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 465 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp0_;
#line 466 "../src/DirectoryMonitor.vala"
	self->priv->recurse = recurse;
#line 467 "../src/DirectoryMonitor.vala"
	self->priv->monitoring = monitoring;
#line 464 "../src/DirectoryMonitor.vala"
	return self;
#line 1043 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_new (GFile* root,
                       gboolean recurse,
                       gboolean monitoring)
{
#line 464 "../src/DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 1053 "DirectoryMonitor.c"
}

void
directory_monitor_mdbg (const gchar* msg)
{
#line 470 "../src/DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 1061 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_recursive (DirectoryMonitor* self)
{
	gboolean result;
#line 476 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 477 "../src/DirectoryMonitor.vala"
	result = self->priv->recurse;
#line 477 "../src/DirectoryMonitor.vala"
	return result;
#line 1074 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_monitoring (DirectoryMonitor* self)
{
	gboolean result;
#line 480 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 481 "../src/DirectoryMonitor.vala"
	result = self->priv->monitoring;
#line 481 "../src/DirectoryMonitor.vala"
	return result;
#line 1087 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                            GFile* root)
{
	GFile* _tmp0_;
#line 484 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_file_get_type ()));
#line 485 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 485 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, root), "this.root.equal(root)");
#line 487 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 488 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL], 0, root);
#line 1105 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_deleted (DirectoryMonitor* self,
                                       GFile* root)
{
	DirectoryMonitorClass* _klass_;
#line 484 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 484 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 484 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_root_deleted) {
#line 484 "../src/DirectoryMonitor.vala"
		_klass_->notify_root_deleted (self, root);
#line 1121 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                              GFile* old_root,
                                              GFile* new_root,
                                              GFileInfo* new_root_info)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_root, g_file_get_type ()));
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root, g_file_get_type ()));
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root_info, g_file_info_get_type ()));
#line 492 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 492 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, old_root, NULL);
#line 493 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 495 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 495 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_root, new_root_info);
#line 496 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 498 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (new_root);
#line 498 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 498 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp2_;
#line 500 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
#line 1164 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                          GFile* old_root,
                                          GFile* new_root,
                                          GFileInfo* new_root_info)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 503 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_root, g_file_get_type ()));
#line 503 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root, g_file_get_type ()));
#line 503 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root_info, g_file_info_get_type ()));
#line 504 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 504 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, old_root), "this.root.equal(old_root)");
#line 506 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (old_root);
#line 506 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 506 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_file_get_path (new_root);
#line 506 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 506 "../src/DirectoryMonitor.vala"
	_tmp5_ = g_strdup_printf ("root moved: %s -> %s", _tmp2_, _tmp4_);
#line 506 "../src/DirectoryMonitor.vala"
	_tmp6_ = _tmp5_;
#line 506 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp6_);
#line 506 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp6_);
#line 506 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 506 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 507 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL], 0, old_root, new_root, new_root_info);
#line 1212 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_moved (DirectoryMonitor* self,
                                     GFile* old_root,
                                     GFile* new_root,
                                     GFileInfo* new_root_info)
{
	DirectoryMonitorClass* _klass_;
#line 503 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 503 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 503 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_root_moved) {
#line 503 "../src/DirectoryMonitor.vala"
		_klass_->notify_root_moved (self, old_root, new_root, new_root_info);
#line 1230 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_started (DirectoryMonitor* self)
{
#line 511 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 512 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL], 0);
#line 1241 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_started (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 510 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 510 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 510 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_started) {
#line 510 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_started (self);
#line 1256 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                        GFile* file,
                                                        GFileInfo* info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 515 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 515 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 516 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 516 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_file_info_map_update (_tmp0_, file, info)) {
#line 1274 "DirectoryMonitor.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 517 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (file);
#line 517 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 517 "../src/DirectoryMonitor.vala"
		g_debug ("DirectoryMonitor.vala:517: DirectoryMonitor.internal_notify_file_disco" \
"vered: %s discovered but not added to file map", _tmp2_);
#line 517 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp2_);
#line 520 "../src/DirectoryMonitor.vala"
		return;
#line 1287 "DirectoryMonitor.c"
	}
#line 523 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, file, info);
#line 1291 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self,
                                                   GFile* file,
                                                   GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 515 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 515 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 515 "../src/DirectoryMonitor.vala"
	if (_klass_->internal_notify_file_discovered) {
#line 515 "../src/DirectoryMonitor.vala"
		_klass_->internal_notify_file_discovered (self, file, info);
#line 1308 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                               GFile* file,
                                               GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 526 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 526 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 527 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 527 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 527 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file discovered: %s", _tmp1_);
#line 527 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 527 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 527 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 527 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 528 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL], 0, file, info);
#line 1341 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_discovered (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 526 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 526 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 526 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_discovered) {
#line 526 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_discovered (self, file, info);
#line 1358 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                             GFile* dir,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 531 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 531 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 532 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 532 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 533 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 535 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, dir, info);
#line 1381 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                        GFile* dir,
                                                        GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 531 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 531 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 531 "../src/DirectoryMonitor.vala"
	if (_klass_->internal_notify_directory_discovered) {
#line 531 "../src/DirectoryMonitor.vala"
		_klass_->internal_notify_directory_discovered (self, dir, info);
#line 1398 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                    GFile* dir,
                                                    GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 539 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 539 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 539 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory discovered: %s", _tmp1_);
#line 539 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 539 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 539 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 539 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 540 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL], 0, dir, info);
#line 1431 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_discovered (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 538 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 538 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_discovered) {
#line 538 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_discovered (self, dir, info);
#line 1448 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                const gchar* reason)
{
#line 543 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 544 "../src/DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:544: discovery failed: %s", reason);
#line 545 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL], 0, reason);
#line 1462 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_failed (DirectoryMonitor* self,
                                           const gchar* reason)
{
	DirectoryMonitorClass* _klass_;
#line 543 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 543 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 543 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_failed) {
#line 543 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_failed (self, reason);
#line 1478 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self)
{
#line 549 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL], 0);
#line 1487 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_completed (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 548 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 548 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 548 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_discovery_completed) {
#line 548 "../src/DirectoryMonitor.vala"
		_klass_->notify_discovery_completed (self);
#line 1502 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info)
{
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 552 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 552 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 552 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 555 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp1_);
#line 555 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 555 "../src/DirectoryMonitor.vala"
	old_file = _tmp0_;
#line 555 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 555 "../src/DirectoryMonitor.vala"
	old_file_info = _tmp1_;
#line 555 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1534 "DirectoryMonitor.c"
		GFile* _tmp3_;
#line 556 "../src/DirectoryMonitor.vala"
		_tmp3_ = old_file;
#line 556 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, _tmp3_, file, info);
#line 1540 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp4_;
#line 558 "../src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->files;
#line 558 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp4_, file, info);
#line 559 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 561 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, file, info);
#line 1552 "DirectoryMonitor.c"
	}
#line 552 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 552 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 1558 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 565 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 565 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 566 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 566 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 566 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file created: %s", _tmp1_);
#line 566 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 566 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 566 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 566 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 567 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL], 0, file, info);
#line 1590 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_created (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 565 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 565 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 565 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_created) {
#line 565 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_created (self, file, info);
#line 1607 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                              GFile* old_file,
                                              GFile* new_file,
                                              GFileInfo* new_file_info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
#line 570 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 570 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 570 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 570 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file_info, g_file_info_get_type ()));
#line 573 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 573 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_tmp0_, old_file, NULL);
#line 575 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 575 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_file, new_file_info);
#line 576 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 578 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
#line 1640 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 581 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 581 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 581 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file_info, g_file_info_get_type ()));
#line 582 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_file);
#line 582 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 582 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_file);
#line 582 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 582 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("file moved: %s -> %s", _tmp1_, _tmp3_);
#line 582 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 582 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 582 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 582 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 582 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 583 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL], 0, old_file, new_file, new_file_info);
#line 1683 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                     GFile* old_file,
                                     GFile* new_file,
                                     GFileInfo* new_file_info)
{
	DirectoryMonitorClass* _klass_;
#line 581 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 581 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 581 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_moved) {
#line 581 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1701 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 586 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 587 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 587 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 587 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file altered: %s", _tmp1_);
#line 587 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 587 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 587 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 587 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 588 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL], 0, file);
#line 1731 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                       GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 586 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 586 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 586 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_altered) {
#line 586 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_altered (self, file);
#line 1747 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 591 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 591 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 591 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 592 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 592 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, file, info);
#line 593 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 595 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, file, info);
#line 1772 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 599 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 599 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 599 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file alteration completed: %s", _tmp1_);
#line 599 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 599 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 599 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 599 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 600 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL], 0, file, info);
#line 1804 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 598 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 598 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_alteration_completed) {
#line 598 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_alteration_completed (self, file, info);
#line 1821 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 603 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 604 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 604 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 604 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file attributes altered: %s", _tmp1_);
#line 604 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 604 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 604 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 604 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 605 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL], 0, file);
#line 1851 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                  GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 603 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 603 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 603 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_attributes_altered) {
#line 603 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_attributes_altered (self, file);
#line 1867 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                GFile* file)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 608 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 608 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 609 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 609 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, file, NULL);
#line 610 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 612 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, file);
#line 1889 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 615 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 616 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 616 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 616 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file deleted: %s", _tmp1_);
#line 616 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 616 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 616 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 616 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 617 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL], 0, file);
#line 1918 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                       GFile* file)
{
	DirectoryMonitorClass* _klass_;
#line 615 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 615 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 615 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_file_deleted) {
#line 615 "../src/DirectoryMonitor.vala"
		_klass_->notify_file_deleted (self, file);
#line 1934 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                     GFile* dir,
                                                     GFileInfo* info)
{
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 620 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 620 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 620 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 623 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp1_);
#line 623 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 623 "../src/DirectoryMonitor.vala"
	old_dir = _tmp0_;
#line 623 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 623 "../src/DirectoryMonitor.vala"
	old_dir_info = _tmp1_;
#line 623 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1966 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
#line 629 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->files;
#line 629 "../src/DirectoryMonitor.vala"
		_tmp4_ = old_dir;
#line 629 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 629 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (_tmp3_, _tmp4_, _tmp5_);
#line 631 "../src/DirectoryMonitor.vala"
		_tmp6_ = old_dir;
#line 631 "../src/DirectoryMonitor.vala"
		_tmp7_ = old_dir_info;
#line 631 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, _tmp6_, _tmp7_, dir, info);
#line 1986 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp8_;
#line 633 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->files;
#line 633 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp8_, dir, info);
#line 634 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 636 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, dir, info);
#line 1998 "DirectoryMonitor.c"
	}
#line 620 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 620 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 2004 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                 GFile* dir,
                                                 GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 640 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 640 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 641 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 641 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 641 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory created: %s", _tmp1_);
#line 641 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 641 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 641 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 641 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 642 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL], 0, dir, info);
#line 2036 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_created (DirectoryMonitor* self,
                                            GFile* dir,
                                            GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 640 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 640 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 640 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_created) {
#line 640 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_created (self, dir, info);
#line 2053 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                   GFile* old_dir,
                                                   GFileInfo* old_dir_info,
                                                   GFile* new_dir,
                                                   GFileInfo* new_dir_info)
{
#line 645 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 645 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir, g_file_get_type ()));
#line 645 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir_info, g_file_info_get_type ()));
#line 645 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir, g_file_get_type ()));
#line 645 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir_info, g_file_info_get_type ()));
#line 647 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, old_dir, old_dir_info, new_dir, new_dir_info, NULL, NULL);
#line 2076 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = _data;
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, _data_);
#line 2096 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                         GFile* old_dir,
                                                         GFileInfo* old_dir_info,
                                                         GFile* new_dir,
                                                         GFileInfo* new_dir_info,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* _tmp4_;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir, g_file_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir_info, g_file_info_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir, g_file_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir_info, g_file_info_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 60 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
#line 60 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (old_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->old_dir = _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (old_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->old_dir_info = _tmp2_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp3_ = _g_object_ref0 (new_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->new_dir = _tmp3_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (new_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->new_dir_info = _tmp4_;
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2160 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                GAsyncResult* _res_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2170 "DirectoryMonitor.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 652 "../src/DirectoryMonitor.vala"
	return result;
#line 2182 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 667 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 667 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 667 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 667 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2199 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
#line 683 "../src/DirectoryMonitor.vala"
	return result;
#line 2209 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_)
{
#line 650 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 650 "../src/DirectoryMonitor.vala"
		case 0:
#line 2219 "DirectoryMonitor.c"
		goto _state_0;
#line 650 "../src/DirectoryMonitor.vala"
		case 1:
#line 2223 "DirectoryMonitor.c"
		goto _state_1;
#line 650 "../src/DirectoryMonitor.vala"
		case 2:
#line 2227 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 650 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2232 "DirectoryMonitor.c"
	}
	_state_0:
#line 652 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 652 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 653 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 653 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 654 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 654 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 654 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 654 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->old_dir, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 655 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2253 "DirectoryMonitor.c"
		{
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp5_;
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->_dir_child_list;
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp8_;
#line 659 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 659 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 659 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 659 "../src/DirectoryMonitor.vala"
				_data_->_tmp9_ = _data_->_dir_child_index;
#line 659 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_size;
#line 659 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 659 "../src/DirectoryMonitor.vala"
					break;
#line 2281 "DirectoryMonitor.c"
				}
#line 659 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = _data_->_dir_child_list;
#line 659 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_dir_child_index);
#line 659 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp12_;
#line 660 "../src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->self->priv->files;
#line 660 "../src/DirectoryMonitor.vala"
				_data_->_tmp14_ = _data_->dir_child;
#line 660 "../src/DirectoryMonitor.vala"
				_data_->_tmp15_ = directory_monitor_file_info_map_get_info (_data_->_tmp13_, _data_->_tmp14_);
#line 660 "../src/DirectoryMonitor.vala"
				_data_->dir_info = _data_->_tmp15_;
#line 661 "../src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->dir_info;
#line 661 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp16_ == NULL) {
#line 662 "../src/DirectoryMonitor.vala"
					_data_->_tmp17_ = _data_->dir_child;
#line 662 "../src/DirectoryMonitor.vala"
					_data_->_tmp18_ = g_file_get_path (_data_->_tmp17_);
#line 662 "../src/DirectoryMonitor.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 662 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:662: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp19_);
#line 662 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp19_);
#line 664 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_info);
#line 664 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_child);
#line 664 "../src/DirectoryMonitor.vala"
					continue;
#line 2317 "DirectoryMonitor.c"
				}
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->dir_child;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->dir_info;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->dir_child;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp23_ = g_file_get_basename (_data_->_tmp22_);
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp24_ = _data_->_tmp23_;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp25_ = g_file_get_child (_data_->new_dir, _data_->_tmp24_);
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp27_ = _data_->dir_info;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 667 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved (_data_->self, _data_->_tmp20_, _data_->_tmp21_, _data_->_tmp26_, _data_->_tmp27_, directory_monitor_async_internal_notify_directory_moved_ready, _data_);
#line 667 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2341 "DirectoryMonitor.c"
				_state_1:
#line 667 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (_data_->self, _data_->_res_);
#line 667 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp26_);
#line 667 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp24_);
#line 659 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_info);
#line 659 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2353 "DirectoryMonitor.c"
			}
		}
		{
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_tmp28_ = _data_->file_children;
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp28_;
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_tmp29_ = _data_->_file_child_list;
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_tmp30_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp29_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp31_;
#line 672 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 672 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 672 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 672 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->_file_child_index;
#line 672 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->_file_child_size;
#line 672 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp32_ < _data_->_tmp33_)) {
#line 672 "../src/DirectoryMonitor.vala"
					break;
#line 2383 "DirectoryMonitor.c"
				}
#line 672 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->_file_child_list;
#line 672 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp34_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_file_child_index);
#line 672 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp35_;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->self->priv->files;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp37_ = _data_->file_child;
#line 673 "../src/DirectoryMonitor.vala"
				_data_->_tmp38_ = directory_monitor_file_info_map_get_info (_data_->_tmp36_, _data_->_tmp37_);
#line 673 "../src/DirectoryMonitor.vala"
				_data_->file_info = _data_->_tmp38_;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp39_ = _data_->file_info;
#line 674 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp39_ == NULL) {
#line 675 "../src/DirectoryMonitor.vala"
					_data_->_tmp40_ = _data_->file_child;
#line 675 "../src/DirectoryMonitor.vala"
					_data_->_tmp41_ = g_file_get_path (_data_->_tmp40_);
#line 675 "../src/DirectoryMonitor.vala"
					_data_->_tmp42_ = _data_->_tmp41_;
#line 675 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:675: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp42_);
#line 675 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp42_);
#line 677 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_info);
#line 677 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_child);
#line 677 "../src/DirectoryMonitor.vala"
					continue;
#line 2419 "DirectoryMonitor.c"
				}
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp43_ = _data_->file_child;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp44_ = _data_->file_child;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp45_ = g_file_get_basename (_data_->_tmp44_);
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp46_ = _data_->_tmp45_;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp47_ = g_file_get_child (_data_->new_dir, _data_->_tmp46_);
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp48_ = _data_->_tmp47_;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp49_ = _data_->file_info;
#line 680 "../src/DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (_data_->self, _data_->_tmp43_, _data_->_tmp48_, _data_->_tmp49_);
#line 680 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp48_);
#line 680 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp46_);
#line 683 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, _data_, NULL);
#line 684 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 684 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2447 "DirectoryMonitor.c"
				_state_2:
				;
#line 672 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_info);
#line 672 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2454 "DirectoryMonitor.c"
			}
		}
	}
#line 690 "../src/DirectoryMonitor.vala"
	_data_->_tmp50_ = _data_->self->priv->files;
#line 690 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_data_->_tmp50_, _data_->old_dir, NULL);
#line 692 "../src/DirectoryMonitor.vala"
	_data_->_tmp51_ = _data_->self->priv->files;
#line 692 "../src/DirectoryMonitor.vala"
	_data_->updated = directory_monitor_file_info_map_update (_data_->_tmp51_, _data_->new_dir, _data_->new_dir_info);
#line 693 "../src/DirectoryMonitor.vala"
	_vala_assert (_data_->updated, "updated");
#line 696 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (_data_->self, _data_->old_dir, _data_->old_dir_info);
#line 697 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->new_dir, _data_->new_dir_info);
#line 699 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (_data_->self, _data_->old_dir, _data_->new_dir, _data_->new_dir_info);
#line 650 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 650 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 650 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 650 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 650 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 650 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2486 "DirectoryMonitor.c"
		}
	}
#line 650 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 650 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 2493 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                               GFile* old_dir,
                                               GFile* new_dir,
                                               GFileInfo* new_dir_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
#line 702 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir, g_file_get_type ()));
#line 702 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir, g_file_get_type ()));
#line 702 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir_info, g_file_info_get_type ()));
#line 703 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_dir);
#line 703 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 703 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_dir);
#line 703 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 703 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("directory moved: %s -> %s", _tmp1_, _tmp3_);
#line 703 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 703 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 703 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 703 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 703 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 704 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL], 0, old_dir, new_dir, new_dir_info);
#line 706 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->root;
#line 706 "../src/DirectoryMonitor.vala"
	if (g_file_equal (old_dir, _tmp6_)) {
#line 707 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
#line 2543 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_moved (DirectoryMonitor* self,
                                          GFile* old_dir,
                                          GFile* new_dir,
                                          GFileInfo* new_dir_info)
{
	DirectoryMonitorClass* _klass_;
#line 702 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 702 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 702 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_moved) {
#line 702 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 2562 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 710 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 711 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 711 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 711 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory altered: %s", _tmp1_);
#line 711 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 711 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 711 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 711 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 712 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL], 0, dir);
#line 2592 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_altered (DirectoryMonitor* self,
                                            GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 710 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 710 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 710 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_altered) {
#line 710 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_altered (self, dir);
#line 2608 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 715 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 715 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 715 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 716 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 716 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 717 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 719 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
#line 2633 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                              GFile* dir,
                                                              GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 723 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 723 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 723 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory alteration completed: %s", _tmp1_);
#line 723 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 723 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 723 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 723 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 724 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL], 0, dir, info);
#line 2665 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info)
{
	DirectoryMonitorClass* _klass_;
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 722 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 722 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_alteration_completed) {
#line 722 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_alteration_completed (self, dir, info);
#line 2682 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                            GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 727 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 728 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 728 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 728 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory attributes altered: %s", _tmp1_);
#line 728 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 728 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 728 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 728 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 729 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL], 0, dir);
#line 2712 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                       GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 727 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 727 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 727 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_attributes_altered) {
#line 727 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_attributes_altered (self, dir);
#line 2728 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                     GFile* dir)
{
	GFileInfo* info = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
#line 732 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 732 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 733 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 733 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, dir);
#line 733 "../src/DirectoryMonitor.vala"
	info = _tmp1_;
#line 734 "../src/DirectoryMonitor.vala"
	_vala_assert (info != NULL, "info != null");
#line 737 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, dir, info);
#line 739 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, dir, FALSE, NULL, NULL);
#line 732 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 2757 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_data_free (gpointer _data)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = _data;
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, _data_);
#line 2771 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                  GFile* dir,
                                                  gboolean already_removed,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 60 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
#line 60 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_->already_removed = already_removed;
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2808 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                         GAsyncResult* _res_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2818 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 762 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 762 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 762 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 762 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2835 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
#line 771 "../src/DirectoryMonitor.vala"
	return result;
#line 2845 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_)
{
#line 742 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 742 "../src/DirectoryMonitor.vala"
		case 0:
#line 2855 "DirectoryMonitor.c"
		goto _state_0;
#line 742 "../src/DirectoryMonitor.vala"
		case 1:
#line 2859 "DirectoryMonitor.c"
		goto _state_1;
#line 742 "../src/DirectoryMonitor.vala"
		case 2:
#line 2863 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 742 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2868 "DirectoryMonitor.c"
	}
	_state_0:
#line 750 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 750 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 751 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 751 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 752 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 752 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 752 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 752 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->dir, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 753 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2889 "DirectoryMonitor.c"
		{
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp5_;
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->_dir_child_list;
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp8_;
#line 761 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 761 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 761 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 761 "../src/DirectoryMonitor.vala"
				_data_->_tmp9_ = _data_->_dir_child_index;
#line 761 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_size;
#line 761 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp9_ < _data_->_tmp10_)) {
#line 761 "../src/DirectoryMonitor.vala"
					break;
#line 2917 "DirectoryMonitor.c"
				}
#line 761 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = _data_->_dir_child_list;
#line 761 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_dir_child_index);
#line 761 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp12_;
#line 762 "../src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->dir_child;
#line 762 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 762 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted (_data_->self, _data_->_tmp13_, FALSE, directory_monitor_async_notify_directory_deleted_ready, _data_);
#line 762 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2933 "DirectoryMonitor.c"
				_state_1:
#line 762 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (_data_->self, _data_->_res_);
#line 761 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2939 "DirectoryMonitor.c"
			}
		}
		{
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->file_children;
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp14_;
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_tmp15_ = _data_->_file_child_list;
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_tmp16_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp17_;
#line 766 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 766 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 766 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 766 "../src/DirectoryMonitor.vala"
				_data_->_tmp18_ = _data_->_file_child_index;
#line 766 "../src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->_file_child_size;
#line 766 "../src/DirectoryMonitor.vala"
				if (!(_data_->_tmp18_ < _data_->_tmp19_)) {
#line 766 "../src/DirectoryMonitor.vala"
					break;
#line 2969 "DirectoryMonitor.c"
				}
#line 766 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->_file_child_list;
#line 766 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_file_child_index);
#line 766 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp21_;
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->self->priv->files;
#line 767 "../src/DirectoryMonitor.vala"
				_data_->_tmp23_ = _data_->file_child;
#line 767 "../src/DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (_data_->_tmp22_, _data_->_tmp23_, NULL);
#line 769 "../src/DirectoryMonitor.vala"
				_data_->_tmp24_ = _data_->file_child;
#line 769 "../src/DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (_data_->self, _data_->_tmp24_);
#line 771 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, _data_, NULL);
#line 772 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 772 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2993 "DirectoryMonitor.c"
				_state_2:
				;
#line 766 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2998 "DirectoryMonitor.c"
			}
		}
	}
#line 776 "../src/DirectoryMonitor.vala"
	if (!_data_->already_removed) {
#line 777 "../src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->self->priv->files;
#line 777 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_data_->_tmp25_, _data_->dir, NULL);
#line 3008 "DirectoryMonitor.c"
	}
#line 779 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (_data_->self, _data_->dir);
#line 742 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 742 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 742 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 742 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 742 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 742 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3024 "DirectoryMonitor.c"
		}
	}
#line 742 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 742 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 3031 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
#line 782 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 783 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 783 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 783 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory deleted: %s", _tmp1_);
#line 783 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 783 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 783 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 783 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 784 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL], 0, dir);
#line 786 "../src/DirectoryMonitor.vala"
	_tmp4_ = self->priv->root;
#line 786 "../src/DirectoryMonitor.vala"
	if (g_file_equal (dir, _tmp4_)) {
#line 787 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, dir);
#line 3067 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_deleted (DirectoryMonitor* self,
                                            GFile* dir)
{
	DirectoryMonitorClass* _klass_;
#line 782 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 782 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 782 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_directory_deleted) {
#line 782 "../src/DirectoryMonitor.vala"
		_klass_->notify_directory_deleted (self, dir);
#line 3084 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_real_notify_closed (DirectoryMonitor* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 791 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 791 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 791 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 791 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("monitoring of %s closed", _tmp2_);
#line 791 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 791 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 791 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 791 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 792 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL], 0);
#line 3114 "DirectoryMonitor.c"
}

void
directory_monitor_notify_closed (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 790 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 790 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 790 "../src/DirectoryMonitor.vala"
	if (_klass_->notify_closed) {
#line 790 "../src/DirectoryMonitor.vala"
		_klass_->notify_closed (self);
#line 3129 "DirectoryMonitor.c"
	}
}

GFile*
directory_monitor_get_root (DirectoryMonitor* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 795 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 796 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 796 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 796 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 796 "../src/DirectoryMonitor.vala"
	return result;
#line 3149 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_in_root (DirectoryMonitor* self,
                              GFile* file)
{
	GFile* _tmp0_;
	gboolean result;
#line 799 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 799 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 800 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 800 "../src/DirectoryMonitor.vala"
	result = g_file_has_prefix (file, _tmp0_);
#line 800 "../src/DirectoryMonitor.vala"
	return result;
#line 3168 "DirectoryMonitor.c"
}

gboolean
directory_monitor_has_started (DirectoryMonitor* self)
{
	gboolean result;
#line 803 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 804 "../src/DirectoryMonitor.vala"
	result = self->priv->started;
#line 804 "../src/DirectoryMonitor.vala"
	return result;
#line 3181 "DirectoryMonitor.c"
}

void
directory_monitor_start_discovery (DirectoryMonitor* self)
{
	GFile* _tmp0_;
#line 807 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 808 "../src/DirectoryMonitor.vala"
	_vala_assert (!self->priv->started, "!started");
#line 810 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 811 "../src/DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 813 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 816 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 817 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 817 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async (self, _tmp0_, NULL, TRUE, NULL, NULL);
#line 3204 "DirectoryMonitor.c"
}

static void
directory_monitor_real_close (DirectoryMonitor* self)
{
	GCancellable* _tmp0_;
	GeeHashMap* _tmp11_;
#line 824 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 824 "../src/DirectoryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 3216 "DirectoryMonitor.c"
	{
		GeeIterator* _monitor_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 827 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 827 "../src/DirectoryMonitor.vala"
		_tmp2_ = gee_abstract_map_get_values (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 827 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 827 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 827 "../src/DirectoryMonitor.vala"
		_tmp5_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ITERABLE, GeeIterable));
#line 827 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 827 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 827 "../src/DirectoryMonitor.vala"
		_monitor_it = _tmp6_;
#line 827 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 3243 "DirectoryMonitor.c"
			GeeIterator* _tmp7_;
			GFileMonitor* monitor = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GFileMonitor* _tmp10_;
#line 827 "../src/DirectoryMonitor.vala"
			_tmp7_ = _monitor_it;
#line 827 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 827 "../src/DirectoryMonitor.vala"
				break;
#line 3255 "DirectoryMonitor.c"
			}
#line 827 "../src/DirectoryMonitor.vala"
			_tmp8_ = _monitor_it;
#line 827 "../src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 827 "../src/DirectoryMonitor.vala"
			monitor = (GFileMonitor*) _tmp9_;
#line 828 "../src/DirectoryMonitor.vala"
			_tmp10_ = monitor;
#line 828 "../src/DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, _tmp10_);
#line 827 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3269 "DirectoryMonitor.c"
		}
#line 827 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_monitor_it);
#line 3273 "DirectoryMonitor.c"
	}
#line 830 "../src/DirectoryMonitor.vala"
	_tmp11_ = self->priv->monitors;
#line 830 "../src/DirectoryMonitor.vala"
	gee_abstract_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 832 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 3281 "DirectoryMonitor.c"
}

void
directory_monitor_close (DirectoryMonitor* self)
{
	DirectoryMonitorClass* _klass_;
#line 822 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 822 "../src/DirectoryMonitor.vala"
	_klass_ = DIRECTORY_MONITOR_GET_CLASS (self);
#line 822 "../src/DirectoryMonitor.vala"
	if (_klass_->close) {
#line 822 "../src/DirectoryMonitor.vala"
		_klass_->close (self);
#line 3296 "DirectoryMonitor.c"
	}
}

static DirectoryMonitorFType
directory_monitor_get_ftype (GFileInfo* info)
{
	GFileType file_type = 0;
	DirectoryMonitorFType result;
#line 835 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), 0);
#line 836 "../src/DirectoryMonitor.vala"
	file_type = g_file_info_get_file_type (info);
#line 837 "../src/DirectoryMonitor.vala"
	switch (file_type) {
#line 837 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_REGULAR:
#line 3313 "DirectoryMonitor.c"
		{
#line 839 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 839 "../src/DirectoryMonitor.vala"
			return result;
#line 3319 "DirectoryMonitor.c"
		}
#line 837 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 3323 "DirectoryMonitor.c"
		{
#line 842 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 842 "../src/DirectoryMonitor.vala"
			return result;
#line 3329 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 845 "../src/DirectoryMonitor.vala"
			_tmp0_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), file_type);
#line 845 "../src/DirectoryMonitor.vala"
			_tmp1_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp0_ != NULL) ? _tmp0_->value_name : NULL);
#line 845 "../src/DirectoryMonitor.vala"
			_tmp2_ = _tmp1_;
#line 845 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp2_);
#line 845 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp2_);
#line 846 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 846 "../src/DirectoryMonitor.vala"
			return result;
#line 3350 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_explore_async_data_free (gpointer _data)
{
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = _data;
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorExploreAsyncData, _data_);
#line 3368 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async (DirectoryMonitor* self,
                                 GFile* dir,
                                 GFileInfo* dir_info,
                                 gboolean in_discovery,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((dir_info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (dir_info, g_file_info_get_type ()));
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 60 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
#line 60 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->dir_info = _tmp2_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3415 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_finish (DirectoryMonitor* self,
                                  GAsyncResult* _res_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3425 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 863 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 863 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 863 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 863 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3442 "DirectoryMonitor.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 913 "../src/DirectoryMonitor.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3450 "DirectoryMonitor.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 913 "../src/DirectoryMonitor.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3458 "DirectoryMonitor.c"
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 935 "../src/DirectoryMonitor.vala"
	return result;
#line 3469 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_)
{
#line 850 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 850 "../src/DirectoryMonitor.vala"
		case 0:
#line 3479 "DirectoryMonitor.c"
		goto _state_0;
#line 850 "../src/DirectoryMonitor.vala"
		case 1:
#line 3483 "DirectoryMonitor.c"
		goto _state_1;
#line 850 "../src/DirectoryMonitor.vala"
		case 2:
#line 3487 "DirectoryMonitor.c"
		goto _state_2;
#line 850 "../src/DirectoryMonitor.vala"
		case 3:
#line 3491 "DirectoryMonitor.c"
		goto _state_3;
#line 850 "../src/DirectoryMonitor.vala"
		case 4:
#line 3495 "DirectoryMonitor.c"
		goto _state_4;
#line 850 "../src/DirectoryMonitor.vala"
		case 5:
#line 3499 "DirectoryMonitor.c"
		goto _state_5;
		default:
#line 850 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 3504 "DirectoryMonitor.c"
	}
	_state_0:
#line 851 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->files;
#line 851 "../src/DirectoryMonitor.vala"
	if (directory_monitor_file_info_map_contains (_data_->_tmp0_, _data_->dir, _data_->dir_info)) {
#line 852 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = g_file_get_path (_data_->dir);
#line 852 "../src/DirectoryMonitor.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 852 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:852: Directory loop detected at %s, not explorin" \
"g", _data_->_tmp2_);
#line 852 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp2_);
#line 854 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 856 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 856 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 856 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 856 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3529 "DirectoryMonitor.c"
			}
		}
#line 856 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 856 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3536 "DirectoryMonitor.c"
	}
#line 860 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->dir_info);
#line 860 "../src/DirectoryMonitor.vala"
	_data_->local_dir_info = _data_->_tmp3_;
#line 861 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->local_dir_info;
#line 861 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp4_ == NULL) {
#line 3546 "DirectoryMonitor.c"
		{
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_state_ = 1;
#line 863 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp6_, directory_monitor_explore_async_ready, _data_);
#line 863 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3556 "DirectoryMonitor.c"
			_state_1:
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = g_file_query_info_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->_tmp7_;
#line 863 "../src/DirectoryMonitor.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3564 "DirectoryMonitor.c"
				goto __catch0_g_error;
			}
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp5_;
#line 863 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = NULL;
#line 863 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 863 "../src/DirectoryMonitor.vala"
			_data_->local_dir_info = _data_->_tmp8_;
#line 862 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp5_);
#line 3577 "DirectoryMonitor.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 862 "../src/DirectoryMonitor.vala"
			_data_->err = _data_->_inner_error0_;
#line 862 "../src/DirectoryMonitor.vala"
			_data_->_inner_error0_ = NULL;
#line 866 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = g_file_get_path (_data_->dir);
#line 866 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 866 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->err;
#line 866 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 866 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:866: Unable to retrieve info on %s: %s", _data_->_tmp10_, _data_->_tmp12_);
#line 866 "../src/DirectoryMonitor.vala"
			_g_free0 (_data_->_tmp10_);
#line 868 "../src/DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 870 "../src/DirectoryMonitor.vala"
			_g_error_free0 (_data_->err);
#line 870 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 870 "../src/DirectoryMonitor.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 870 "../src/DirectoryMonitor.vala"
			if (_data_->_state_ != 0) {
#line 870 "../src/DirectoryMonitor.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 870 "../src/DirectoryMonitor.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3612 "DirectoryMonitor.c"
				}
			}
#line 870 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 870 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3619 "DirectoryMonitor.c"
		}
		__finally0:
#line 862 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 862 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 862 "../src/DirectoryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 862 "../src/DirectoryMonitor.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 862 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 862 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3634 "DirectoryMonitor.c"
		}
	}
#line 874 "../src/DirectoryMonitor.vala"
	_data_->_tmp13_ = _data_->local_dir_info;
#line 874 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_is_hidden (_data_->_tmp13_)) {
#line 875 "../src/DirectoryMonitor.vala"
		_data_->_tmp14_ = g_file_get_path (_data_->dir);
#line 875 "../src/DirectoryMonitor.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 875 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:875: Ignoring hidden directory %s", _data_->_tmp15_);
#line 875 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp15_);
#line 877 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 879 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 879 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 879 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 879 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 879 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3661 "DirectoryMonitor.c"
			}
		}
#line 879 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 879 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3668 "DirectoryMonitor.c"
	}
#line 884 "../src/DirectoryMonitor.vala"
	_data_->_tmp16_ = _data_->local_dir_info;
#line 884 "../src/DirectoryMonitor.vala"
	_data_->_tmp17_ = get_file_info_id (_data_->_tmp16_);
#line 884 "../src/DirectoryMonitor.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 884 "../src/DirectoryMonitor.vala"
	_data_->_tmp19_ = _data_->_tmp18_ == NULL;
#line 884 "../src/DirectoryMonitor.vala"
	_g_free0 (_data_->_tmp18_);
#line 884 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp19_) {
#line 885 "../src/DirectoryMonitor.vala"
		_data_->_tmp20_ = _data_->local_dir_info;
#line 885 "../src/DirectoryMonitor.vala"
		_data_->_tmp21_ = g_file_get_uri (_data_->dir);
#line 885 "../src/DirectoryMonitor.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 885 "../src/DirectoryMonitor.vala"
		g_file_info_set_attribute_string (_data_->_tmp20_, G_FILE_ATTRIBUTE_ID_FILE, _data_->_tmp22_);
#line 885 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp22_);
#line 3692 "DirectoryMonitor.c"
	}
#line 890 "../src/DirectoryMonitor.vala"
	_data_->_tmp23_ = _data_->local_dir_info;
#line 890 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_file_type (_data_->_tmp23_) != G_FILE_TYPE_DIRECTORY) {
#line 891 "../src/DirectoryMonitor.vala"
		_data_->_tmp24_ = g_file_get_path (_data_->dir);
#line 891 "../src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 891 "../src/DirectoryMonitor.vala"
		_data_->_tmp26_ = _data_->local_dir_info;
#line 892 "../src/DirectoryMonitor.vala"
		_data_->_tmp27_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), g_file_info_get_file_type (_data_->_tmp26_));
#line 891 "../src/DirectoryMonitor.vala"
		_data_->_tmp28_ = g_strdup_printf (_ ("Unable to monitor %s: Not a directory (%s)"), _data_->_tmp25_, (_data_->_tmp27_ != NULL) ? _data_->_tmp27_->value_name : NULL);
#line 891 "../src/DirectoryMonitor.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 891 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (_data_->self, _data_->_tmp29_);
#line 891 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp29_);
#line 891 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp25_);
#line 894 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 896 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 896 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 896 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 896 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 896 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3728 "DirectoryMonitor.c"
			}
		}
#line 896 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 896 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3735 "DirectoryMonitor.c"
	}
#line 903 "../src/DirectoryMonitor.vala"
	_data_->dir_map = NULL;
#line 904 "../src/DirectoryMonitor.vala"
	_data_->file_map = NULL;
#line 3741 "DirectoryMonitor.c"
	{
#line 907 "../src/DirectoryMonitor.vala"
		_data_->_tmp30_ = _data_->self->priv->cancellable;
#line 907 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 2;
#line 907 "../src/DirectoryMonitor.vala"
		g_file_enumerate_children_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp30_, directory_monitor_explore_async_ready, _data_);
#line 907 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3751 "DirectoryMonitor.c"
		_state_2:
#line 907 "../src/DirectoryMonitor.vala"
		_data_->_tmp31_ = g_file_enumerate_children_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 907 "../src/DirectoryMonitor.vala"
		_data_->enumerator = _data_->_tmp31_;
#line 907 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3759 "DirectoryMonitor.c"
			goto __catch1_g_error;
		}
		{
#line 909 "../src/DirectoryMonitor.vala"
			_data_->_tmp32_ = TRUE;
#line 909 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 909 "../src/DirectoryMonitor.vala"
				if (!_data_->_tmp32_) {
#line 3769 "DirectoryMonitor.c"
				}
#line 909 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = FALSE;
#line 910 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->enumerator;
#line 910 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->self->priv->cancellable;
#line 910 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 3;
#line 910 "../src/DirectoryMonitor.vala"
				g_file_enumerator_next_files_async (_data_->_tmp33_, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp34_, directory_monitor_explore_async_ready, _data_);
#line 910 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 3783 "DirectoryMonitor.c"
				_state_3:
#line 910 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = g_file_enumerator_next_files_finish (_data_->_tmp33_, _data_->_res_, &_data_->_inner_error0_);
#line 910 "../src/DirectoryMonitor.vala"
				_data_->infos = _data_->_tmp35_;
#line 910 "../src/DirectoryMonitor.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 910 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->enumerator);
#line 3793 "DirectoryMonitor.c"
					goto __catch1_g_error;
				}
#line 912 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->infos;
#line 912 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp36_ == NULL) {
#line 913 "../src/DirectoryMonitor.vala"
					(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 913 "../src/DirectoryMonitor.vala"
					break;
#line 3804 "DirectoryMonitor.c"
				}
#line 915 "../src/DirectoryMonitor.vala"
				_data_->_tmp37_ = _data_->infos;
#line 3808 "DirectoryMonitor.c"
				{
#line 915 "../src/DirectoryMonitor.vala"
					_data_->info_collection = _data_->_tmp37_;
#line 915 "../src/DirectoryMonitor.vala"
					for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 915 "../src/DirectoryMonitor.vala"
						_data_->_tmp38_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 915 "../src/DirectoryMonitor.vala"
						_data_->info = _data_->_tmp38_;
#line 3818 "DirectoryMonitor.c"
						{
#line 916 "../src/DirectoryMonitor.vala"
							_data_->_tmp39_ = _data_->info;
#line 916 "../src/DirectoryMonitor.vala"
							_data_->_tmp40_ = get_file_info_id (_data_->_tmp39_);
#line 916 "../src/DirectoryMonitor.vala"
							_data_->_tmp41_ = _data_->_tmp40_;
#line 916 "../src/DirectoryMonitor.vala"
							_data_->_tmp42_ = _data_->_tmp41_ == NULL;
#line 916 "../src/DirectoryMonitor.vala"
							_g_free0 (_data_->_tmp41_);
#line 916 "../src/DirectoryMonitor.vala"
							if (_data_->_tmp42_) {
#line 917 "../src/DirectoryMonitor.vala"
								_data_->_tmp43_ = _data_->info;
#line 917 "../src/DirectoryMonitor.vala"
								_data_->_tmp44_ = g_file_get_uri (_data_->dir);
#line 917 "../src/DirectoryMonitor.vala"
								_data_->_tmp45_ = _data_->_tmp44_;
#line 917 "../src/DirectoryMonitor.vala"
								g_file_info_set_attribute_string (_data_->_tmp43_, G_FILE_ATTRIBUTE_ID_FILE, _data_->_tmp45_);
#line 917 "../src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp45_);
#line 3842 "DirectoryMonitor.c"
							}
#line 921 "../src/DirectoryMonitor.vala"
							_data_->_tmp46_ = _data_->info;
#line 921 "../src/DirectoryMonitor.vala"
							if (g_file_info_get_is_hidden (_data_->_tmp46_)) {
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp47_ = _data_->info;
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp48_ = g_file_info_get_name (_data_->_tmp47_);
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp49_ = g_file_get_child (_data_->dir, _data_->_tmp48_);
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp50_ = _data_->_tmp49_;
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp51_ = g_file_get_path (_data_->_tmp50_);
#line 922 "../src/DirectoryMonitor.vala"
								_data_->_tmp52_ = _data_->_tmp51_;
#line 922 "../src/DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:922: Skipping hidden file/directory %s", _data_->_tmp52_);
#line 922 "../src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp52_);
#line 922 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->_tmp50_);
#line 925 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 925 "../src/DirectoryMonitor.vala"
								continue;
#line 3870 "DirectoryMonitor.c"
							}
#line 929 "../src/DirectoryMonitor.vala"
							_data_->_tmp53_ = _data_->info;
#line 929 "../src/DirectoryMonitor.vala"
							if (!directory_monitor_is_file_symlink_supported (_data_->_tmp53_)) {
#line 930 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 930 "../src/DirectoryMonitor.vala"
								continue;
#line 3880 "DirectoryMonitor.c"
							}
#line 932 "../src/DirectoryMonitor.vala"
							_data_->_tmp54_ = _data_->info;
#line 932 "../src/DirectoryMonitor.vala"
							switch (g_file_info_get_file_type (_data_->_tmp54_)) {
#line 932 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_REGULAR:
#line 3888 "DirectoryMonitor.c"
								{
#line 934 "../src/DirectoryMonitor.vala"
									_data_->_tmp55_ = _data_->file_map;
#line 934 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp55_ == NULL) {
#line 935 "../src/DirectoryMonitor.vala"
										_data_->_tmp56_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 935 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->file_map);
#line 935 "../src/DirectoryMonitor.vala"
										_data_->file_map = _data_->_tmp56_;
#line 3900 "DirectoryMonitor.c"
									}
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp57_ = _data_->file_map;
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp58_ = _data_->info;
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp59_ = g_file_info_get_name (_data_->_tmp58_);
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp60_ = g_file_get_child (_data_->dir, _data_->_tmp59_);
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp61_ = _data_->_tmp60_;
#line 937 "../src/DirectoryMonitor.vala"
									_data_->_tmp62_ = _data_->info;
#line 937 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp57_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->_tmp61_, _data_->_tmp62_);
#line 937 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp61_);
#line 938 "../src/DirectoryMonitor.vala"
									break;
#line 3920 "DirectoryMonitor.c"
								}
#line 932 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 3924 "DirectoryMonitor.c"
								{
#line 941 "../src/DirectoryMonitor.vala"
									_data_->_tmp63_ = _data_->dir_map;
#line 941 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp63_ == NULL) {
#line 942 "../src/DirectoryMonitor.vala"
										_data_->_tmp64_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 942 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->dir_map);
#line 942 "../src/DirectoryMonitor.vala"
										_data_->dir_map = _data_->_tmp64_;
#line 3936 "DirectoryMonitor.c"
									}
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp65_ = _data_->dir_map;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp66_ = _data_->info;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp67_ = g_file_info_get_name (_data_->_tmp66_);
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp68_ = g_file_get_child (_data_->dir, _data_->_tmp67_);
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp69_ = _data_->_tmp68_;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp70_ = _data_->info;
#line 944 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp65_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->_tmp69_, _data_->_tmp70_);
#line 944 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp69_);
#line 945 "../src/DirectoryMonitor.vala"
									break;
#line 3956 "DirectoryMonitor.c"
								}
								default:
								{
#line 949 "../src/DirectoryMonitor.vala"
									break;
#line 3962 "DirectoryMonitor.c"
								}
							}
#line 915 "../src/DirectoryMonitor.vala"
							_g_object_unref0 (_data_->info);
#line 3967 "DirectoryMonitor.c"
						}
					}
				}
#line 909 "../src/DirectoryMonitor.vala"
				(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 3973 "DirectoryMonitor.c"
			}
		}
#line 906 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->enumerator);
#line 3978 "DirectoryMonitor.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 906 "../src/DirectoryMonitor.vala"
		_data_->err2 = _data_->_inner_error0_;
#line 906 "../src/DirectoryMonitor.vala"
		_data_->_inner_error0_ = NULL;
#line 954 "../src/DirectoryMonitor.vala"
		_data_->_tmp71_ = g_file_get_path (_data_->dir);
#line 954 "../src/DirectoryMonitor.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 954 "../src/DirectoryMonitor.vala"
		_data_->_tmp73_ = _data_->err2;
#line 954 "../src/DirectoryMonitor.vala"
		_data_->_tmp74_ = _data_->_tmp73_->message;
#line 954 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:954: Aborted directory traversal of %s: %s", _data_->_tmp72_, _data_->_tmp74_);
#line 954 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp72_);
#line 956 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 958 "../src/DirectoryMonitor.vala"
		_g_error_free0 (_data_->err2);
#line 958 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 958 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 958 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 958 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 958 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 958 "../src/DirectoryMonitor.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 958 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4017 "DirectoryMonitor.c"
			}
		}
#line 958 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 958 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4024 "DirectoryMonitor.c"
	}
	__finally1:
#line 906 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 906 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 906 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 906 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 906 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 906 "../src/DirectoryMonitor.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 906 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 906 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4043 "DirectoryMonitor.c"
	}
#line 962 "../src/DirectoryMonitor.vala"
	if (_data_->in_discovery) {
#line 963 "../src/DirectoryMonitor.vala"
		_data_->_tmp75_ = _data_->local_dir_info;
#line 963 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (_data_->self, _data_->dir, _data_->_tmp75_);
#line 4051 "DirectoryMonitor.c"
	} else {
#line 965 "../src/DirectoryMonitor.vala"
		_data_->_tmp76_ = _data_->local_dir_info;
#line 965 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (_data_->self, _data_->dir, _data_->_tmp76_);
#line 4057 "DirectoryMonitor.c"
	}
#line 969 "../src/DirectoryMonitor.vala"
	_data_->_tmp77_ = _data_->local_dir_info;
#line 969 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->dir, _data_->_tmp77_);
#line 972 "../src/DirectoryMonitor.vala"
	_data_->_tmp78_ = _data_->file_map;
#line 972 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp78_ != NULL) {
#line 973 "../src/DirectoryMonitor.vala"
		_data_->_tmp79_ = _data_->file_map;
#line 973 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 4;
#line 973 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp79_, GEE_TYPE_MAP, GeeMap), _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 973 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4075 "DirectoryMonitor.c"
		_state_4:
#line 973 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (_data_->self, _data_->_res_);
#line 4079 "DirectoryMonitor.c"
	}
#line 976 "../src/DirectoryMonitor.vala"
	if (_data_->self->priv->recurse) {
#line 976 "../src/DirectoryMonitor.vala"
		_data_->_tmp81_ = _data_->dir_map;
#line 976 "../src/DirectoryMonitor.vala"
		_data_->_tmp80_ = _data_->_tmp81_ != NULL;
#line 4087 "DirectoryMonitor.c"
	} else {
#line 976 "../src/DirectoryMonitor.vala"
		_data_->_tmp80_ = FALSE;
#line 4091 "DirectoryMonitor.c"
	}
#line 976 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp80_) {
#line 4095 "DirectoryMonitor.c"
		{
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp82_ = _data_->dir_map;
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp83_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp82_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp84_ = _data_->_tmp83_;
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp85_ = _data_->_tmp84_;
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp86_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp85_, GEE_TYPE_ITERABLE, GeeIterable));
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_tmp87_ = _data_->_tmp86_;
#line 977 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp85_);
#line 977 "../src/DirectoryMonitor.vala"
			_data_->_subdir_it = _data_->_tmp87_;
#line 977 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 977 "../src/DirectoryMonitor.vala"
				_data_->_tmp88_ = _data_->_subdir_it;
#line 977 "../src/DirectoryMonitor.vala"
				if (!gee_iterator_next (_data_->_tmp88_)) {
#line 977 "../src/DirectoryMonitor.vala"
					break;
#line 4121 "DirectoryMonitor.c"
				}
#line 977 "../src/DirectoryMonitor.vala"
				_data_->_tmp89_ = _data_->_subdir_it;
#line 977 "../src/DirectoryMonitor.vala"
				_data_->_tmp90_ = gee_iterator_get (_data_->_tmp89_);
#line 977 "../src/DirectoryMonitor.vala"
				_data_->subdir = (GFile*) _data_->_tmp90_;
#line 978 "../src/DirectoryMonitor.vala"
				_data_->self->priv->outstanding_exploration_dirs = _data_->self->priv->outstanding_exploration_dirs + 1;
#line 978 "../src/DirectoryMonitor.vala"
				_data_->_tmp91_ = _data_->self->priv->outstanding_exploration_dirs;
#line 978 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp91_ > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_tmp92_ = _data_->subdir;
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_tmp93_ = _data_->dir_map;
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_tmp94_ = _data_->subdir;
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_tmp95_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp93_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->_tmp94_);
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_tmp96_ = (GFileInfo*) _data_->_tmp95_;
#line 979 "../src/DirectoryMonitor.vala"
					_data_->_state_ = 5;
#line 979 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp92_, _data_->_tmp96_, _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 979 "../src/DirectoryMonitor.vala"
					return FALSE;
#line 4151 "DirectoryMonitor.c"
					_state_5:
#line 979 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_finish (_data_->self, _data_->_res_);
#line 979 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp96_);
#line 4157 "DirectoryMonitor.c"
				} else {
#line 981 "../src/DirectoryMonitor.vala"
					_data_->_tmp97_ = _data_->subdir;
#line 981 "../src/DirectoryMonitor.vala"
					_data_->_tmp98_ = _data_->dir_map;
#line 981 "../src/DirectoryMonitor.vala"
					_data_->_tmp99_ = _data_->subdir;
#line 981 "../src/DirectoryMonitor.vala"
					_data_->_tmp100_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp98_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _data_->_tmp99_);
#line 981 "../src/DirectoryMonitor.vala"
					_data_->_tmp101_ = (GFileInfo*) _data_->_tmp100_;
#line 981 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp97_, _data_->_tmp101_, _data_->in_discovery, NULL, NULL);
#line 981 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp101_);
#line 4173 "DirectoryMonitor.c"
				}
#line 977 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->subdir);
#line 4177 "DirectoryMonitor.c"
			}
#line 977 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_subdir_it);
#line 4181 "DirectoryMonitor.c"
		}
	}
#line 985 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 850 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_map);
#line 850 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_map);
#line 850 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->local_dir_info);
#line 850 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 850 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 850 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 850 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4200 "DirectoryMonitor.c"
		}
	}
#line 850 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 850 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4207 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_data_free (gpointer _data)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = _data;
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, _data_);
#line 4221 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                          GeeMap* map,
                                          gboolean in_discovery,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	DirectoryMonitor* _tmp0_;
	GeeMap* _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 60 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
#line 60 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (map);
#line 60 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 60 "../src/DirectoryMonitor.vala"
	_data_->map = _tmp1_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_files_co (_data_);
#line 4258 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                 GAsyncResult* _res_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
#line 60 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4268 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_notify_directory_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
#line 996 "../src/DirectoryMonitor.vala"
	return result;
#line 4278 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_)
{
#line 988 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 988 "../src/DirectoryMonitor.vala"
		case 0:
#line 4288 "DirectoryMonitor.c"
		goto _state_0;
#line 988 "../src/DirectoryMonitor.vala"
		case 1:
#line 4292 "DirectoryMonitor.c"
		goto _state_1;
		default:
#line 988 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 4297 "DirectoryMonitor.c"
	}
	_state_0:
#line 989 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_map_map_iterator (_data_->map);
#line 989 "../src/DirectoryMonitor.vala"
	_data_->iter = _data_->_tmp0_;
#line 990 "../src/DirectoryMonitor.vala"
	while (TRUE) {
#line 990 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = _data_->iter;
#line 990 "../src/DirectoryMonitor.vala"
		if (!gee_map_iterator_next (_data_->_tmp1_)) {
#line 990 "../src/DirectoryMonitor.vala"
			break;
#line 4312 "DirectoryMonitor.c"
		}
#line 991 "../src/DirectoryMonitor.vala"
		if (_data_->in_discovery) {
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp2_ = _data_->iter;
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp3_ = gee_map_iterator_get_key (_data_->_tmp2_);
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp4_ = (GFile*) _data_->_tmp3_;
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->iter;
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = gee_map_iterator_get_value (_data_->_tmp5_);
#line 992 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = (GFileInfo*) _data_->_tmp6_;
#line 992 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (_data_->self, _data_->_tmp4_, _data_->_tmp7_);
#line 992 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 992 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 4334 "DirectoryMonitor.c"
		} else {
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->iter;
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = gee_map_iterator_get_key (_data_->_tmp8_);
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = (GFile*) _data_->_tmp9_;
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->iter;
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = gee_map_iterator_get_value (_data_->_tmp11_);
#line 994 "../src/DirectoryMonitor.vala"
			_data_->_tmp13_ = (GFileInfo*) _data_->_tmp12_;
#line 994 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (_data_->self, _data_->_tmp10_, _data_->_tmp13_);
#line 994 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 994 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 4354 "DirectoryMonitor.c"
		}
#line 996 "../src/DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, _data_, NULL);
#line 997 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 1;
#line 997 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4362 "DirectoryMonitor.c"
		_state_1:
		;
	}
#line 988 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->iter);
#line 988 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 988 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 988 "../src/DirectoryMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 988 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4376 "DirectoryMonitor.c"
		}
	}
#line 988 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 988 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4383 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                               gboolean in_discovery)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1003 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1004 "../src/DirectoryMonitor.vala"
	_vala_assert (self->priv->outstanding_exploration_dirs > 0, "outstanding_exploration_dirs > 0");
#line 1005 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->outstanding_exploration_dirs;
#line 1005 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = _tmp0_ - 1;
#line 1007 "../src/DirectoryMonitor.vala"
	if (in_discovery) {
#line 1007 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->outstanding_exploration_dirs == 0;
#line 4404 "DirectoryMonitor.c"
	} else {
#line 1007 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4408 "DirectoryMonitor.c"
	}
#line 1007 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1008 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 4414 "DirectoryMonitor.c"
	}
}

static void
_directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                   GFile* file,
                                                                   GFile* other_file,
                                                                   GFileMonitorEvent event_type,
                                                                   gpointer self)
{
#line 1036 "../src/DirectoryMonitor.vala"
	directory_monitor_on_monitor_notification ((DirectoryMonitor*) self, file, other_file, event_type);
#line 4427 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_add_monitor (DirectoryMonitor* self,
                               GFile* dir,
                               GFileInfo* info)
{
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp13_;
	const gchar* _tmp14_;
	GFileMonitor* _tmp15_;
	GFileMonitor* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1014 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1014 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), FALSE);
#line 1014 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1015 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1016 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1016 "../src/DirectoryMonitor.vala"
		return result;
#line 4464 "DirectoryMonitor.c"
	}
#line 1018 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1018 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1018 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1019 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1019 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1020 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1020 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1020 "../src/DirectoryMonitor.vala"
		return result;
#line 4482 "DirectoryMonitor.c"
	}
#line 1023 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1023 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1023 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_)) {
#line 1024 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1024 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1024 "../src/DirectoryMonitor.vala"
		return result;
#line 4496 "DirectoryMonitor.c"
	}
#line 1026 "../src/DirectoryMonitor.vala"
	monitor = NULL;
#line 4500 "DirectoryMonitor.c"
	{
		GFileMonitor* _tmp5_ = NULL;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 1028 "../src/DirectoryMonitor.vala"
		_tmp6_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error0_);
#line 1028 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp6_;
#line 1028 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4511 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 1028 "../src/DirectoryMonitor.vala"
		_tmp7_ = _tmp5_;
#line 1028 "../src/DirectoryMonitor.vala"
		_tmp5_ = NULL;
#line 1028 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1028 "../src/DirectoryMonitor.vala"
		monitor = _tmp7_;
#line 1027 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 4524 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 1027 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 1027 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 1030 "../src/DirectoryMonitor.vala"
		_tmp8_ = g_file_get_path (dir);
#line 1030 "../src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 1030 "../src/DirectoryMonitor.vala"
		_tmp10_ = err;
#line 1030 "../src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->message;
#line 1030 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1030: Unable to monitor %s: %s", _tmp9_, _tmp11_);
#line 1030 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp9_);
#line 1032 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1032 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 1032 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1032 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1032 "../src/DirectoryMonitor.vala"
		return result;
#line 4560 "DirectoryMonitor.c"
	}
	__finally0:
#line 1027 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4565 "DirectoryMonitor.c"
		gboolean _tmp12_ = FALSE;
#line 1027 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1027 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1027 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1027 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 1027 "../src/DirectoryMonitor.vala"
		return _tmp12_;
#line 4577 "DirectoryMonitor.c"
	}
#line 1035 "../src/DirectoryMonitor.vala"
	_tmp13_ = self->priv->monitors;
#line 1035 "../src/DirectoryMonitor.vala"
	_tmp14_ = id;
#line 1035 "../src/DirectoryMonitor.vala"
	_tmp15_ = monitor;
#line 1035 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, _tmp15_);
#line 1036 "../src/DirectoryMonitor.vala"
	_tmp16_ = monitor;
#line 1036 "../src/DirectoryMonitor.vala"
	g_signal_connect_object (_tmp16_, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1038 "../src/DirectoryMonitor.vala"
	_tmp17_ = g_file_get_path (dir);
#line 1038 "../src/DirectoryMonitor.vala"
	_tmp18_ = _tmp17_;
#line 1038 "../src/DirectoryMonitor.vala"
	_tmp19_ = g_strdup_printf ("Added monitor for %s", _tmp18_);
#line 1038 "../src/DirectoryMonitor.vala"
	_tmp20_ = _tmp19_;
#line 1038 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp20_);
#line 1038 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp20_);
#line 1038 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp18_);
#line 1040 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1040 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1040 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1040 "../src/DirectoryMonitor.vala"
	return result;
#line 4613 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_remove_monitor (DirectoryMonitor* self,
                                  GFile* dir,
                                  GFileInfo* info)
{
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	GFileMonitor* _tmp6_;
	gboolean removed = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	GFileMonitor* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean result;
#line 1044 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1044 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), FALSE);
#line 1044 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1045 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1046 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1046 "../src/DirectoryMonitor.vala"
		return result;
#line 4651 "DirectoryMonitor.c"
	}
#line 1048 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1048 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1048 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1049 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1049 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1050 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1050 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1050 "../src/DirectoryMonitor.vala"
		return result;
#line 4669 "DirectoryMonitor.c"
	}
#line 1052 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1052 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1052 "../src/DirectoryMonitor.vala"
	_tmp5_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 1052 "../src/DirectoryMonitor.vala"
	monitor = (GFileMonitor*) _tmp5_;
#line 1053 "../src/DirectoryMonitor.vala"
	_tmp6_ = monitor;
#line 1053 "../src/DirectoryMonitor.vala"
	if (_tmp6_ == NULL) {
#line 1054 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1054 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1054 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1054 "../src/DirectoryMonitor.vala"
		return result;
#line 4691 "DirectoryMonitor.c"
	}
#line 1056 "../src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->monitors;
#line 1056 "../src/DirectoryMonitor.vala"
	_tmp8_ = id;
#line 1056 "../src/DirectoryMonitor.vala"
	removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, NULL);
#line 1057 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 1059 "../src/DirectoryMonitor.vala"
	_tmp9_ = monitor;
#line 1059 "../src/DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, _tmp9_);
#line 1061 "../src/DirectoryMonitor.vala"
	_tmp10_ = g_file_get_path (dir);
#line 1061 "../src/DirectoryMonitor.vala"
	_tmp11_ = _tmp10_;
#line 1061 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup_printf ("Removed monitor for %s", _tmp11_);
#line 1061 "../src/DirectoryMonitor.vala"
	_tmp13_ = _tmp12_;
#line 1061 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp13_);
#line 1061 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp13_);
#line 1061 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp11_);
#line 1063 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1063 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1063 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1063 "../src/DirectoryMonitor.vala"
	return result;
#line 4727 "DirectoryMonitor.c"
}

static void
directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                  GFileMonitor* monitor)
{
	guint _tmp0_;
#line 1066 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1066 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, g_file_monitor_get_type ()));
#line 1067 "../src/DirectoryMonitor.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp0_, NULL, FALSE);
#line 1067 "../src/DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1068 "../src/DirectoryMonitor.vala"
	g_file_monitor_cancel (monitor);
#line 4745 "DirectoryMonitor.c"
}

static void
_directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                GAsyncResult* res,
                                                                                gpointer self)
{
#line 1088 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_on_completed ((DirectoryMonitorQueryInfoQueueElement*) self, source_object, res);
#line 1088 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_unref (self);
#line 4757 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events ((DirectoryMonitor*) self);
#line 1097 "../src/DirectoryMonitor.vala"
	return result;
#line 4767 "DirectoryMonitor.c"
}

static void
directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	DirectoryMonitorQueryInfoQueueElement* query_info = NULL;
	DirectoryMonitorQueryInfoQueueElement* _tmp8_;
	GeeQueue* _tmp9_;
	DirectoryMonitorQueryInfoQueueElement* _tmp10_;
#line 1071 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1071 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1071 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()));
#line 1073 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 4794 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1073 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1073 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1073 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 4802 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1073 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(none)");
#line 1073 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1073 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 4811 "DirectoryMonitor.c"
	}
#line 1072 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1072 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1072 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1072 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1072 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1072 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1072 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1072 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1082 "../src/DirectoryMonitor.vala"
	_tmp8_ = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
#line 1082 "../src/DirectoryMonitor.vala"
	query_info = _tmp8_;
#line 1083 "../src/DirectoryMonitor.vala"
	_tmp9_ = self->priv->query_info_queue;
#line 1083 "../src/DirectoryMonitor.vala"
	_tmp10_ = query_info;
#line 1083 "../src/DirectoryMonitor.vala"
	gee_queue_offer (_tmp9_, _tmp10_);
#line 1085 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1085 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1085 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 4845 "DirectoryMonitor.c"
		{
			GCancellable* _tmp11_;
			DirectoryMonitorQueryInfoQueueElement* _tmp12_;
#line 1088 "../src/DirectoryMonitor.vala"
			_tmp11_ = self->priv->cancellable;
#line 1088 "../src/DirectoryMonitor.vala"
			_tmp12_ = query_info;
#line 1088 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp11_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp12_));
#line 1090 "../src/DirectoryMonitor.vala"
			break;
#line 4857 "DirectoryMonitor.c"
		}
#line 1085 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 4861 "DirectoryMonitor.c"
		{
#line 1096 "../src/DirectoryMonitor.vala"
			if (self->priv->delete_timer_id == ((guint) 0)) {
#line 1097 "../src/DirectoryMonitor.vala"
				self->priv->delete_timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 4867 "DirectoryMonitor.c"
			}
#line 1098 "../src/DirectoryMonitor.vala"
			break;
#line 4871 "DirectoryMonitor.c"
		}
#line 1085 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 4875 "DirectoryMonitor.c"
		{
#line 1103 "../src/DirectoryMonitor.vala"
			if (other_file != NULL) {
#line 4879 "DirectoryMonitor.c"
				GCancellable* _tmp13_;
				DirectoryMonitorQueryInfoQueueElement* _tmp14_;
#line 1104 "../src/DirectoryMonitor.vala"
				_tmp13_ = self->priv->cancellable;
#line 1104 "../src/DirectoryMonitor.vala"
				_tmp14_ = query_info;
#line 1104 "../src/DirectoryMonitor.vala"
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp13_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp14_));
#line 4888 "DirectoryMonitor.c"
			} else {
				GeeQueue* _tmp15_;
				DirectoryMonitorQueryInfoQueueElement* _tmp16_;
#line 1107 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1107: Unable to process MOVED event: no other_fi" \
"le");
#line 1108 "../src/DirectoryMonitor.vala"
				_tmp15_ = self->priv->query_info_queue;
#line 1108 "../src/DirectoryMonitor.vala"
				_tmp16_ = query_info;
#line 1108 "../src/DirectoryMonitor.vala"
				gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), _tmp16_);
#line 4900 "DirectoryMonitor.c"
			}
#line 1110 "../src/DirectoryMonitor.vala"
			break;
#line 4904 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorQueryInfoQueueElement* _tmp17_;
			DirectoryMonitorQueryInfoQueueElement* _tmp18_;
#line 1114 "../src/DirectoryMonitor.vala"
			_tmp17_ = query_info;
#line 1114 "../src/DirectoryMonitor.vala"
			_tmp17_->completed = TRUE;
#line 1115 "../src/DirectoryMonitor.vala"
			_tmp18_ = query_info;
#line 1115 "../src/DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, _tmp18_);
#line 1116 "../src/DirectoryMonitor.vala"
			break;
#line 4920 "DirectoryMonitor.c"
		}
	}
#line 1071 "../src/DirectoryMonitor.vala"
	_directory_monitor_query_info_queue_element_unref0 (query_info);
#line 1071 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 4927 "DirectoryMonitor.c"
}

static void
directory_monitor_process_query_queue (DirectoryMonitor* self,
                                       DirectoryMonitorQueryInfoQueueElement* query_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 1120 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1120 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((query_info == NULL) || DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (query_info));
#line 1123 "../src/DirectoryMonitor.vala"
	if (query_info != NULL) {
#line 4942 "DirectoryMonitor.c"
		GFileInfo* _tmp2_;
#line 1123 "../src/DirectoryMonitor.vala"
		_tmp2_ = query_info->info;
#line 1123 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_ != NULL;
#line 4948 "DirectoryMonitor.c"
	} else {
#line 1123 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4952 "DirectoryMonitor.c"
	}
#line 1123 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1123 "../src/DirectoryMonitor.vala"
		_tmp0_ = query_info->event == G_FILE_MONITOR_EVENT_CREATED;
#line 4958 "DirectoryMonitor.c"
	} else {
#line 1123 "../src/DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 4962 "DirectoryMonitor.c"
	}
#line 1123 "../src/DirectoryMonitor.vala"
	if (_tmp0_) {
#line 4966 "DirectoryMonitor.c"
		GFile* match = NULL;
		DirectoryMonitorFileInfoMap* _tmp3_;
		GFileInfo* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 1126 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->files;
#line 1126 "../src/DirectoryMonitor.vala"
		_tmp4_ = query_info->info;
#line 1126 "../src/DirectoryMonitor.vala"
		_tmp5_ = directory_monitor_file_info_map_find_match (_tmp3_, _tmp4_);
#line 1126 "../src/DirectoryMonitor.vala"
		match = _tmp5_;
#line 1127 "../src/DirectoryMonitor.vala"
		_tmp6_ = match;
#line 1127 "../src/DirectoryMonitor.vala"
		if (_tmp6_ != NULL) {
#line 4984 "DirectoryMonitor.c"
			gboolean matched = FALSE;
#line 1128 "../src/DirectoryMonitor.vala"
			matched = FALSE;
#line 4988 "DirectoryMonitor.c"
			{
				GeeIterator* _enqueued_it = NULL;
				GeeQueue* _tmp7_;
				GeeIterator* _tmp8_;
#line 1129 "../src/DirectoryMonitor.vala"
				_tmp7_ = self->priv->query_info_queue;
#line 1129 "../src/DirectoryMonitor.vala"
				_tmp8_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1129 "../src/DirectoryMonitor.vala"
				_enqueued_it = _tmp8_;
#line 1129 "../src/DirectoryMonitor.vala"
				while (TRUE) {
#line 5001 "DirectoryMonitor.c"
					GeeIterator* _tmp9_;
					DirectoryMonitorQueryInfoQueueElement* enqueued = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					DirectoryMonitorQueryInfoQueueElement* _tmp14_;
					GFile* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					DirectoryMonitorQueryInfoQueueElement* _tmp22_;
					GFile* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					DirectoryMonitorQueryInfoQueueElement* _tmp28_;
					DirectoryMonitorQueryInfoQueueElement* _tmp29_;
					GFile* _tmp30_;
					GFile* _tmp31_;
					DirectoryMonitorQueryInfoQueueElement* _tmp32_;
					GFileInfo* _tmp33_;
					GFileInfo* _tmp34_;
					DirectoryMonitorQueryInfoQueueElement* _tmp35_;
#line 1129 "../src/DirectoryMonitor.vala"
					_tmp9_ = _enqueued_it;
#line 1129 "../src/DirectoryMonitor.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 1129 "../src/DirectoryMonitor.vala"
						break;
#line 5032 "DirectoryMonitor.c"
					}
#line 1129 "../src/DirectoryMonitor.vala"
					_tmp10_ = _enqueued_it;
#line 1129 "../src/DirectoryMonitor.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 1129 "../src/DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp11_;
#line 1130 "../src/DirectoryMonitor.vala"
					_tmp14_ = enqueued;
#line 1130 "../src/DirectoryMonitor.vala"
					if (_tmp14_->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 1130 "../src/DirectoryMonitor.vala"
						_tmp13_ = TRUE;
#line 5046 "DirectoryMonitor.c"
					} else {
						DirectoryMonitorQueryInfoQueueElement* _tmp15_;
#line 1131 "../src/DirectoryMonitor.vala"
						_tmp15_ = enqueued;
#line 1131 "../src/DirectoryMonitor.vala"
						_tmp13_ = _tmp15_->completed;
#line 5053 "DirectoryMonitor.c"
					}
#line 1130 "../src/DirectoryMonitor.vala"
					if (_tmp13_) {
#line 1130 "../src/DirectoryMonitor.vala"
						_tmp12_ = TRUE;
#line 5059 "DirectoryMonitor.c"
					} else {
						GFile* _tmp16_;
						DirectoryMonitorQueryInfoQueueElement* _tmp17_;
						GFile* _tmp18_;
#line 1132 "../src/DirectoryMonitor.vala"
						_tmp16_ = match;
#line 1132 "../src/DirectoryMonitor.vala"
						_tmp17_ = enqueued;
#line 1132 "../src/DirectoryMonitor.vala"
						_tmp18_ = _tmp17_->file;
#line 1132 "../src/DirectoryMonitor.vala"
						_tmp12_ = !g_file_equal (_tmp16_, _tmp18_);
#line 5072 "DirectoryMonitor.c"
					}
#line 1130 "../src/DirectoryMonitor.vala"
					if (_tmp12_) {
#line 1133 "../src/DirectoryMonitor.vala"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1133 "../src/DirectoryMonitor.vala"
						continue;
#line 5080 "DirectoryMonitor.c"
					}
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp19_ = query_info->file;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp20_ = g_file_get_path (_tmp19_);
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp21_ = _tmp20_;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp22_ = enqueued;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp23_ = _tmp22_->file;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp24_ = g_file_get_path (_tmp23_);
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp25_ = _tmp24_;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp26_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp21_, _tmp25_);
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp27_ = _tmp26_;
#line 1136 "../src/DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp27_);
#line 1136 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp27_);
#line 1136 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp25_);
#line 1136 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp21_);
#line 1139 "../src/DirectoryMonitor.vala"
					_tmp28_ = enqueued;
#line 1139 "../src/DirectoryMonitor.vala"
					_tmp28_->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1140 "../src/DirectoryMonitor.vala"
					_tmp29_ = enqueued;
#line 1140 "../src/DirectoryMonitor.vala"
					_tmp30_ = query_info->file;
#line 1140 "../src/DirectoryMonitor.vala"
					_tmp31_ = _g_object_ref0 (_tmp30_);
#line 1140 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp29_->other_file);
#line 1140 "../src/DirectoryMonitor.vala"
					_tmp29_->other_file = _tmp31_;
#line 1141 "../src/DirectoryMonitor.vala"
					_tmp32_ = enqueued;
#line 1141 "../src/DirectoryMonitor.vala"
					_tmp33_ = query_info->info;
#line 1141 "../src/DirectoryMonitor.vala"
					_tmp34_ = _g_object_ref0 (_tmp33_);
#line 1141 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp32_->info);
#line 1141 "../src/DirectoryMonitor.vala"
					_tmp32_->info = _tmp34_;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp35_ = enqueued;
#line 1142 "../src/DirectoryMonitor.vala"
					_tmp35_->completed = TRUE;
#line 1144 "../src/DirectoryMonitor.vala"
					matched = TRUE;
#line 1146 "../src/DirectoryMonitor.vala"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1146 "../src/DirectoryMonitor.vala"
					break;
#line 5142 "DirectoryMonitor.c"
				}
#line 1129 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_enqueued_it);
#line 5146 "DirectoryMonitor.c"
			}
#line 1149 "../src/DirectoryMonitor.vala"
			if (matched) {
#line 5150 "DirectoryMonitor.c"
				GeeQueue* _tmp36_;
#line 1150 "../src/DirectoryMonitor.vala"
				_tmp36_ = self->priv->query_info_queue;
#line 1150 "../src/DirectoryMonitor.vala"
				gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_COLLECTION, GeeCollection), query_info);
#line 5156 "DirectoryMonitor.c"
			}
		}
#line 1123 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 5161 "DirectoryMonitor.c"
	}
	{
		gboolean _tmp37_ = FALSE;
#line 1155 "../src/DirectoryMonitor.vala"
		_tmp37_ = TRUE;
#line 1155 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5169 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* next = NULL;
			GeeQueue* _tmp38_;
			gpointer _tmp39_;
			gboolean _tmp40_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp41_;
			DirectoryMonitorQueryInfoQueueElement* n = NULL;
			GeeQueue* _tmp43_;
			gpointer _tmp44_;
			DirectoryMonitorQueryInfoQueueElement* _tmp45_;
			DirectoryMonitorQueryInfoQueueElement* _tmp46_;
			DirectoryMonitorQueryInfoQueueElement* _tmp47_;
			DirectoryMonitorQueryInfoQueueElement* _tmp48_;
			GEnumValue* _tmp49_;
			DirectoryMonitorQueryInfoQueueElement* _tmp50_;
			GFile* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			DirectoryMonitorQueryInfoQueueElement* _tmp56_;
			GError* _tmp57_;
			gboolean _tmp69_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp70_;
			GFileInfo* _tmp71_;
			gboolean _tmp84_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp85_;
			GFileInfo* _tmp86_;
			DirectoryMonitorQueryInfoQueueElement* _tmp97_;
			GFile* _tmp98_;
			DirectoryMonitorQueryInfoQueueElement* _tmp99_;
			GFile* _tmp100_;
			DirectoryMonitorQueryInfoQueueElement* _tmp101_;
			GFileInfo* _tmp102_;
			DirectoryMonitorQueryInfoQueueElement* _tmp103_;
#line 1155 "../src/DirectoryMonitor.vala"
			if (!_tmp37_) {
#line 5206 "DirectoryMonitor.c"
			}
#line 1155 "../src/DirectoryMonitor.vala"
			_tmp37_ = FALSE;
#line 1157 "../src/DirectoryMonitor.vala"
			_tmp38_ = self->priv->query_info_queue;
#line 1157 "../src/DirectoryMonitor.vala"
			_tmp39_ = gee_queue_peek (_tmp38_);
#line 1157 "../src/DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp39_;
#line 1158 "../src/DirectoryMonitor.vala"
			_tmp41_ = next;
#line 1158 "../src/DirectoryMonitor.vala"
			if (_tmp41_ == NULL) {
#line 1158 "../src/DirectoryMonitor.vala"
				_tmp40_ = TRUE;
#line 5222 "DirectoryMonitor.c"
			} else {
				DirectoryMonitorQueryInfoQueueElement* _tmp42_;
#line 1158 "../src/DirectoryMonitor.vala"
				_tmp42_ = next;
#line 1158 "../src/DirectoryMonitor.vala"
				_tmp40_ = !_tmp42_->completed;
#line 5229 "DirectoryMonitor.c"
			}
#line 1158 "../src/DirectoryMonitor.vala"
			if (_tmp40_) {
#line 1159 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1159 "../src/DirectoryMonitor.vala"
				break;
#line 5237 "DirectoryMonitor.c"
			}
#line 1162 "../src/DirectoryMonitor.vala"
			_tmp43_ = self->priv->query_info_queue;
#line 1162 "../src/DirectoryMonitor.vala"
			_tmp44_ = gee_queue_poll (_tmp43_);
#line 1162 "../src/DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp44_;
#line 1163 "../src/DirectoryMonitor.vala"
			_tmp45_ = next;
#line 1163 "../src/DirectoryMonitor.vala"
			_tmp46_ = n;
#line 1163 "../src/DirectoryMonitor.vala"
			_vala_assert (_tmp45_ == _tmp46_, "next == n");
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp47_ = next;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp48_ = next;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp49_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp48_->event);
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp50_ = next;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp51_ = _tmp50_->file;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp52_ = g_file_get_path (_tmp51_);
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp53_ = _tmp52_;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp54_ = g_strdup_printf ("Completed info query %u for %s on %s", _tmp47_->position, (_tmp49_ != NULL) ? _tmp49_->value_name : NULL, _tmp53_);
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp55_ = _tmp54_;
#line 1165 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp55_);
#line 1165 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp55_);
#line 1165 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp53_);
#line 1168 "../src/DirectoryMonitor.vala"
			_tmp56_ = next;
#line 1168 "../src/DirectoryMonitor.vala"
			_tmp57_ = _tmp56_->err;
#line 1168 "../src/DirectoryMonitor.vala"
			if (_tmp57_ != NULL) {
#line 5281 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp58_;
				GFile* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				DirectoryMonitorQueryInfoQueueElement* _tmp62_;
				GEnumValue* _tmp63_;
				DirectoryMonitorQueryInfoQueueElement* _tmp64_;
				GError* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp58_ = next;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp59_ = _tmp58_->file;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp60_ = g_file_get_path (_tmp59_);
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp61_ = _tmp60_;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp62_ = next;
#line 1170 "../src/DirectoryMonitor.vala"
				_tmp63_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp62_->event);
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp64_ = next;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp65_ = _tmp64_->err;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp66_ = _tmp65_->message;
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp67_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp61_, (_tmp63_ != NULL) ? _tmp63_->value_name : NULL, _tmp66_);
#line 1169 "../src/DirectoryMonitor.vala"
				_tmp68_ = _tmp67_;
#line 1169 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp68_);
#line 1169 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp68_);
#line 1169 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp61_);
#line 1172 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1172 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1172 "../src/DirectoryMonitor.vala"
				continue;
#line 5327 "DirectoryMonitor.c"
			}
#line 1176 "../src/DirectoryMonitor.vala"
			_tmp70_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
			_tmp71_ = _tmp70_->info;
#line 1176 "../src/DirectoryMonitor.vala"
			if (_tmp71_ != NULL) {
#line 5335 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp72_;
				GFileInfo* _tmp73_;
				gchar* _tmp74_;
				gchar* _tmp75_;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp72_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp73_ = _tmp72_->info;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp74_ = get_file_info_id (_tmp73_);
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp75_ = _tmp74_;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp69_ = _tmp75_ == NULL;
#line 1176 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp75_);
#line 5352 "DirectoryMonitor.c"
			} else {
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp69_ = FALSE;
#line 5356 "DirectoryMonitor.c"
			}
#line 1176 "../src/DirectoryMonitor.vala"
			if (_tmp69_) {
#line 5360 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp76_;
				GFile* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				DirectoryMonitorQueryInfoQueueElement* _tmp80_;
				GEnumValue* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp76_ = next;
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp77_ = _tmp76_->file;
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp78_ = g_file_get_path (_tmp77_);
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp79_ = _tmp78_;
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp80_ = next;
#line 1178 "../src/DirectoryMonitor.vala"
				_tmp81_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp80_->event);
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp82_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp79_, (_tmp81_ != NULL) ? _tmp81_->value_name : NULL);
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp83_ = _tmp82_;
#line 1177 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp83_);
#line 1177 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp83_);
#line 1177 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp79_);
#line 1180 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1180 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1180 "../src/DirectoryMonitor.vala"
				continue;
#line 5397 "DirectoryMonitor.c"
			}
#line 1184 "../src/DirectoryMonitor.vala"
			_tmp85_ = next;
#line 1184 "../src/DirectoryMonitor.vala"
			_tmp86_ = _tmp85_->info;
#line 1184 "../src/DirectoryMonitor.vala"
			if (_tmp86_ != NULL) {
#line 5405 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp87_;
				GFileInfo* _tmp88_;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp87_ = next;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp88_ = _tmp87_->info;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp84_ = !directory_monitor_is_file_symlink_supported (_tmp88_);
#line 5414 "DirectoryMonitor.c"
			} else {
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp84_ = FALSE;
#line 5418 "DirectoryMonitor.c"
			}
#line 1184 "../src/DirectoryMonitor.vala"
			if (_tmp84_) {
#line 5422 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp89_;
				GFile* _tmp90_;
				gchar* _tmp91_;
				gchar* _tmp92_;
				DirectoryMonitorQueryInfoQueueElement* _tmp93_;
				GEnumValue* _tmp94_;
				gchar* _tmp95_;
				gchar* _tmp96_;
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp89_ = next;
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp90_ = _tmp89_->file;
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp91_ = g_file_get_path (_tmp90_);
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp92_ = _tmp91_;
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp93_ = next;
#line 1186 "../src/DirectoryMonitor.vala"
				_tmp94_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp93_->event);
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp95_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp92_, (_tmp94_ != NULL) ? _tmp94_->value_name : NULL);
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp96_ = _tmp95_;
#line 1185 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp96_);
#line 1185 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp96_);
#line 1185 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp92_);
#line 1188 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1188 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1188 "../src/DirectoryMonitor.vala"
				continue;
#line 5459 "DirectoryMonitor.c"
			}
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp97_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp98_ = _tmp97_->file;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp99_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp100_ = _tmp99_->other_file;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp101_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp102_ = _tmp101_->info;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp103_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, _tmp98_, _tmp100_, _tmp102_, _tmp103_->event);
#line 1155 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (n);
#line 1155 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (next);
#line 5481 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFile* other_file,
                                                 GFileInfo* info,
                                                 GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1195 "../src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1195 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1195 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()));
#line 1195 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 1198 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 5509 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1198 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1198 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1198 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 5517 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1198 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(null)");
#line 1198 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1198 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 5526 "DirectoryMonitor.c"
	}
#line 1197 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1197 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1197 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1197 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1197 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1197 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1197 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1197 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1202 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 5548 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1204 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1206 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1207 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1207 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5559 "DirectoryMonitor.c"
				{
#line 1209 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, file, info);
#line 1210 "../src/DirectoryMonitor.vala"
					break;
#line 5565 "DirectoryMonitor.c"
				}
#line 1207 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5569 "DirectoryMonitor.c"
				{
					gint _tmp8_;
#line 1217 "../src/DirectoryMonitor.vala"
					_tmp8_ = self->priv->outstanding_exploration_dirs;
#line 1217 "../src/DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs = _tmp8_ + 1;
#line 1218 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
#line 1219 "../src/DirectoryMonitor.vala"
					break;
#line 5580 "DirectoryMonitor.c"
				}
				default:
				{
#line 1222 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1223 "../src/DirectoryMonitor.vala"
					break;
#line 5588 "DirectoryMonitor.c"
				}
			}
#line 1225 "../src/DirectoryMonitor.vala"
			break;
#line 5593 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 5597 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp15_;
#line 1229 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1231 "../src/DirectoryMonitor.vala"
			_tmp9_ = directory_monitor_get_file_info (self, file);
#line 1231 "../src/DirectoryMonitor.vala"
			local_info = _tmp9_;
#line 1232 "../src/DirectoryMonitor.vala"
			_tmp10_ = local_info;
#line 1232 "../src/DirectoryMonitor.vala"
			if (_tmp10_ == NULL) {
#line 5614 "DirectoryMonitor.c"
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 1233 "../src/DirectoryMonitor.vala"
				_tmp11_ = g_file_get_path (file);
#line 1233 "../src/DirectoryMonitor.vala"
				_tmp12_ = _tmp11_;
#line 1233 "../src/DirectoryMonitor.vala"
				_tmp13_ = g_strdup_printf ("Changed event for unknown file %s", _tmp12_);
#line 1233 "../src/DirectoryMonitor.vala"
				_tmp14_ = _tmp13_;
#line 1233 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp14_);
#line 1233 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp14_);
#line 1233 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp12_);
#line 1235 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1235 "../src/DirectoryMonitor.vala"
				break;
#line 5637 "DirectoryMonitor.c"
			}
#line 1238 "../src/DirectoryMonitor.vala"
			_tmp15_ = local_info;
#line 1238 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp15_);
#line 1239 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1239 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5647 "DirectoryMonitor.c"
				{
#line 1241 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, file);
#line 1242 "../src/DirectoryMonitor.vala"
					break;
#line 5653 "DirectoryMonitor.c"
				}
#line 1239 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5657 "DirectoryMonitor.c"
				{
#line 1245 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, file);
#line 1246 "../src/DirectoryMonitor.vala"
					break;
#line 5663 "DirectoryMonitor.c"
				}
				default:
				{
#line 1249 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1250 "../src/DirectoryMonitor.vala"
					break;
#line 5671 "DirectoryMonitor.c"
				}
			}
#line 1252 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1252 "../src/DirectoryMonitor.vala"
			break;
#line 5678 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 5682 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1255 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1257 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1258 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1258 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5693 "DirectoryMonitor.c"
				{
#line 1260 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
#line 1261 "../src/DirectoryMonitor.vala"
					break;
#line 5699 "DirectoryMonitor.c"
				}
#line 1258 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5703 "DirectoryMonitor.c"
				{
#line 1264 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
#line 1265 "../src/DirectoryMonitor.vala"
					break;
#line 5709 "DirectoryMonitor.c"
				}
				default:
				{
#line 1268 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1269 "../src/DirectoryMonitor.vala"
					break;
#line 5717 "DirectoryMonitor.c"
				}
			}
#line 1271 "../src/DirectoryMonitor.vala"
			break;
#line 5722 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 5726 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
#line 1274 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1275 "../src/DirectoryMonitor.vala"
			_vala_assert (other_file != NULL, "other_file != null");
#line 1279 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1280 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1280 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5739 "DirectoryMonitor.c"
				{
#line 1282 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
#line 1283 "../src/DirectoryMonitor.vala"
					break;
#line 5745 "DirectoryMonitor.c"
				}
#line 1280 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5749 "DirectoryMonitor.c"
				{
					GFileInfo* old_dir_info = NULL;
					DirectoryMonitorFileInfoMap* _tmp16_;
					GFileInfo* _tmp17_;
					GFileInfo* _tmp18_;
					GFileInfo* _tmp21_;
#line 1287 "../src/DirectoryMonitor.vala"
					_tmp16_ = self->priv->files;
#line 1287 "../src/DirectoryMonitor.vala"
					_tmp17_ = directory_monitor_file_info_map_get_info (_tmp16_, file);
#line 1287 "../src/DirectoryMonitor.vala"
					old_dir_info = _tmp17_;
#line 1288 "../src/DirectoryMonitor.vala"
					_tmp18_ = old_dir_info;
#line 1288 "../src/DirectoryMonitor.vala"
					if (_tmp18_ == NULL) {
#line 5766 "DirectoryMonitor.c"
						gchar* _tmp19_;
						gchar* _tmp20_;
#line 1289 "../src/DirectoryMonitor.vala"
						_tmp19_ = g_file_get_path (file);
#line 1289 "../src/DirectoryMonitor.vala"
						_tmp20_ = _tmp19_;
#line 1289 "../src/DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1289: Directory moved event for unknown file %s", _tmp20_);
#line 1289 "../src/DirectoryMonitor.vala"
						_g_free0 (_tmp20_);
#line 1291 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (old_dir_info);
#line 1291 "../src/DirectoryMonitor.vala"
						break;
#line 5781 "DirectoryMonitor.c"
					}
#line 1294 "../src/DirectoryMonitor.vala"
					_tmp21_ = old_dir_info;
#line 1294 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, file, _tmp21_, other_file, info);
#line 1295 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (old_dir_info);
#line 1295 "../src/DirectoryMonitor.vala"
					break;
#line 5791 "DirectoryMonitor.c"
				}
				default:
				{
#line 1298 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1299 "../src/DirectoryMonitor.vala"
					break;
#line 5799 "DirectoryMonitor.c"
				}
			}
#line 1301 "../src/DirectoryMonitor.vala"
			break;
#line 5804 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 5808 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp26_;
#line 1304 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1306 "../src/DirectoryMonitor.vala"
			_tmp22_ = directory_monitor_get_file_info (self, file);
#line 1306 "../src/DirectoryMonitor.vala"
			local_info = _tmp22_;
#line 1307 "../src/DirectoryMonitor.vala"
			_tmp23_ = local_info;
#line 1307 "../src/DirectoryMonitor.vala"
			if (_tmp23_ == NULL) {
#line 5825 "DirectoryMonitor.c"
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 1308 "../src/DirectoryMonitor.vala"
				_tmp24_ = g_file_get_path (file);
#line 1308 "../src/DirectoryMonitor.vala"
				_tmp25_ = _tmp24_;
#line 1308 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1308: Deleted event for unknown file %s", _tmp25_);
#line 1308 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp25_);
#line 1310 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1310 "../src/DirectoryMonitor.vala"
				break;
#line 5840 "DirectoryMonitor.c"
			}
#line 1313 "../src/DirectoryMonitor.vala"
			_tmp26_ = local_info;
#line 1313 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp26_);
#line 1314 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1314 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5850 "DirectoryMonitor.c"
				{
#line 1316 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, file);
#line 1317 "../src/DirectoryMonitor.vala"
					break;
#line 5856 "DirectoryMonitor.c"
				}
#line 1314 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5860 "DirectoryMonitor.c"
				{
#line 1320 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, file);
#line 1321 "../src/DirectoryMonitor.vala"
					break;
#line 5866 "DirectoryMonitor.c"
				}
				default:
				{
#line 1324 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1325 "../src/DirectoryMonitor.vala"
					break;
#line 5874 "DirectoryMonitor.c"
				}
			}
#line 1327 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1327 "../src/DirectoryMonitor.vala"
			break;
#line 5881 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 5885 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp27_;
			GFileInfo* _tmp28_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp31_;
#line 1331 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1333 "../src/DirectoryMonitor.vala"
			_tmp27_ = directory_monitor_get_file_info (self, file);
#line 1333 "../src/DirectoryMonitor.vala"
			local_info = _tmp27_;
#line 1334 "../src/DirectoryMonitor.vala"
			_tmp28_ = local_info;
#line 1334 "../src/DirectoryMonitor.vala"
			if (_tmp28_ == NULL) {
#line 5902 "DirectoryMonitor.c"
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 1335 "../src/DirectoryMonitor.vala"
				_tmp29_ = g_file_get_path (file);
#line 1335 "../src/DirectoryMonitor.vala"
				_tmp30_ = _tmp29_;
#line 1335 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1335: Attribute changed event for unknown file %" \
"s", _tmp30_);
#line 1335 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp30_);
#line 1337 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1337 "../src/DirectoryMonitor.vala"
				break;
#line 5917 "DirectoryMonitor.c"
			}
#line 1340 "../src/DirectoryMonitor.vala"
			_tmp31_ = local_info;
#line 1340 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp31_);
#line 1341 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 1341 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5927 "DirectoryMonitor.c"
				{
#line 1343 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, file);
#line 1344 "../src/DirectoryMonitor.vala"
					break;
#line 5933 "DirectoryMonitor.c"
				}
#line 1341 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5937 "DirectoryMonitor.c"
				{
#line 1347 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, file);
#line 1348 "../src/DirectoryMonitor.vala"
					break;
#line 5943 "DirectoryMonitor.c"
				}
				default:
				{
#line 1351 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1352 "../src/DirectoryMonitor.vala"
					break;
#line 5951 "DirectoryMonitor.c"
				}
			}
#line 1354 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1354 "../src/DirectoryMonitor.vala"
			break;
#line 5958 "DirectoryMonitor.c"
		}
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
#line 1202 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
#line 5964 "DirectoryMonitor.c"
		{
#line 1359 "../src/DirectoryMonitor.vala"
			break;
#line 5968 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp32_;
#line 1362 "../src/DirectoryMonitor.vala"
			_tmp32_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1362 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1362: Unknown directory monitor event %s", (_tmp32_ != NULL) ? _tmp32_->value_name : NULL);
#line 1363 "../src/DirectoryMonitor.vala"
			break;
#line 5979 "DirectoryMonitor.c"
		}
	}
#line 1195 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 5984 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info,
                                       GFile** old_file,
                                       GFileInfo** old_file_info)
{
	GFile* _vala_old_file = NULL;
	GFileInfo* _vala_old_file_info = NULL;
	GFile* match = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean result;
#line 1369 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1369 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1369 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1372 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->parent_moved;
#line 1372 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_find_match (_tmp0_, info);
#line 1372 "../src/DirectoryMonitor.vala"
	match = _tmp1_;
#line 1373 "../src/DirectoryMonitor.vala"
	_tmp2_ = match;
#line 1373 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 6017 "DirectoryMonitor.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
		DirectoryMonitorFileInfoMap* _tmp8_;
		GFile* _tmp9_;
#line 1374 "../src/DirectoryMonitor.vala"
		_tmp3_ = match;
#line 1374 "../src/DirectoryMonitor.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1374 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 1374 "../src/DirectoryMonitor.vala"
		_vala_old_file = _tmp4_;
#line 1375 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 1375 "../src/DirectoryMonitor.vala"
		_tmp6_ = match;
#line 1375 "../src/DirectoryMonitor.vala"
		_tmp7_ = directory_monitor_file_info_map_get_info (_tmp5_, _tmp6_);
#line 1375 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 1375 "../src/DirectoryMonitor.vala"
		_vala_old_file_info = _tmp7_;
#line 1377 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->parent_moved;
#line 1377 "../src/DirectoryMonitor.vala"
		_tmp9_ = match;
#line 1377 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_tmp8_, _tmp9_, info);
#line 1379 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1379 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 1379 "../src/DirectoryMonitor.vala"
		if (old_file) {
#line 1379 "../src/DirectoryMonitor.vala"
			*old_file = _vala_old_file;
#line 6057 "DirectoryMonitor.c"
		} else {
#line 1379 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file);
#line 6061 "DirectoryMonitor.c"
		}
#line 1379 "../src/DirectoryMonitor.vala"
		if (old_file_info) {
#line 1379 "../src/DirectoryMonitor.vala"
			*old_file_info = _vala_old_file_info;
#line 6067 "DirectoryMonitor.c"
		} else {
#line 1379 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file_info);
#line 6071 "DirectoryMonitor.c"
		}
#line 1379 "../src/DirectoryMonitor.vala"
		return result;
#line 6075 "DirectoryMonitor.c"
	}
#line 1382 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file);
#line 1382 "../src/DirectoryMonitor.vala"
	_vala_old_file = NULL;
#line 1383 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file_info);
#line 1383 "../src/DirectoryMonitor.vala"
	_vala_old_file_info = NULL;
#line 1385 "../src/DirectoryMonitor.vala"
	result = FALSE;
#line 1385 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (match);
#line 1385 "../src/DirectoryMonitor.vala"
	if (old_file) {
#line 1385 "../src/DirectoryMonitor.vala"
		*old_file = _vala_old_file;
#line 6093 "DirectoryMonitor.c"
	} else {
#line 1385 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 6097 "DirectoryMonitor.c"
	}
#line 1385 "../src/DirectoryMonitor.vala"
	if (old_file_info) {
#line 1385 "../src/DirectoryMonitor.vala"
		*old_file_info = _vala_old_file_info;
#line 6103 "DirectoryMonitor.c"
	} else {
#line 1385 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 6107 "DirectoryMonitor.c"
	}
#line 1385 "../src/DirectoryMonitor.vala"
	return result;
#line 6111 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self)
{
	gulong expiration = 0UL;
	gboolean any_deleted = FALSE;
	gboolean any_expired = FALSE;
	gboolean result;
#line 1388 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1389 "../src/DirectoryMonitor.vala"
	expiration = now_ms () - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1391 "../src/DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1392 "../src/DirectoryMonitor.vala"
	any_expired = FALSE;
#line 6129 "DirectoryMonitor.c"
	{
		GeeIterator* _element_it = NULL;
		GeeQueue* _tmp0_;
		GeeIterator* _tmp1_;
#line 1393 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->query_info_queue;
#line 1393 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1393 "../src/DirectoryMonitor.vala"
		_element_it = _tmp1_;
#line 1393 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 6142 "DirectoryMonitor.c"
			GeeIterator* _tmp2_;
			DirectoryMonitorQueryInfoQueueElement* element = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DirectoryMonitorQueryInfoQueueElement* _tmp5_;
			DirectoryMonitorQueryInfoQueueElement* _tmp6_;
			DirectoryMonitorQueryInfoQueueElement* _tmp7_;
#line 1393 "../src/DirectoryMonitor.vala"
			_tmp2_ = _element_it;
#line 1393 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1393 "../src/DirectoryMonitor.vala"
				break;
#line 6156 "DirectoryMonitor.c"
			}
#line 1393 "../src/DirectoryMonitor.vala"
			_tmp3_ = _element_it;
#line 1393 "../src/DirectoryMonitor.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1393 "../src/DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp4_;
#line 1394 "../src/DirectoryMonitor.vala"
			_tmp5_ = element;
#line 1394 "../src/DirectoryMonitor.vala"
			if (_tmp5_->event != G_FILE_MONITOR_EVENT_DELETED) {
#line 1395 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1395 "../src/DirectoryMonitor.vala"
				continue;
#line 6172 "DirectoryMonitor.c"
			}
#line 1397 "../src/DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1399 "../src/DirectoryMonitor.vala"
			_tmp6_ = element;
#line 1399 "../src/DirectoryMonitor.vala"
			if (_tmp6_->time_created_msec > expiration) {
#line 1400 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1400 "../src/DirectoryMonitor.vala"
				continue;
#line 6184 "DirectoryMonitor.c"
			}
#line 1403 "../src/DirectoryMonitor.vala"
			_tmp7_ = element;
#line 1403 "../src/DirectoryMonitor.vala"
			_tmp7_->completed = TRUE;
#line 1404 "../src/DirectoryMonitor.vala"
			any_expired = TRUE;
#line 1393 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (element);
#line 6194 "DirectoryMonitor.c"
		}
#line 1393 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_element_it);
#line 6198 "DirectoryMonitor.c"
	}
#line 1407 "../src/DirectoryMonitor.vala"
	if (any_expired) {
#line 1408 "../src/DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 6204 "DirectoryMonitor.c"
	}
#line 1410 "../src/DirectoryMonitor.vala"
	if (!any_deleted) {
#line 1411 "../src/DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 6210 "DirectoryMonitor.c"
	}
#line 1413 "../src/DirectoryMonitor.vala"
	result = any_deleted;
#line 1413 "../src/DirectoryMonitor.vala"
	return result;
#line 6216 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_get_file_info (DirectoryMonitor* self,
                                 GFile* file)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* result;
#line 1417 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1417 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1418 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1418 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, file);
#line 1418 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1418 "../src/DirectoryMonitor.vala"
	return result;
#line 6238 "DirectoryMonitor.c"
}

GeeCollection*
directory_monitor_get_files (DirectoryMonitor* self)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 1423 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1424 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1424 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_all (_tmp0_);
#line 1424 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1424 "../src/DirectoryMonitor.vala"
	return result;
#line 6257 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_query_file_info (DirectoryMonitor* self,
                                   GFile* file)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	GCancellable* _tmp1_;
	GFileInfo* _tmp2_;
	GFileInfo* result;
#line 1430 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1430 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1431 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1431 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->cancellable;
#line 1431 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_query_info (_tmp0_, file, _tmp1_);
#line 1431 "../src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 1431 "../src/DirectoryMonitor.vala"
	return result;
#line 6282 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_file_symlink_supported (GFileInfo* info)
{
	DirectoryMonitorFType ftype = 0;
	gboolean result;
#line 1441 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1442 "../src/DirectoryMonitor.vala"
	if (!g_file_info_get_is_symlink (info)) {
#line 1443 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1443 "../src/DirectoryMonitor.vala"
		return result;
#line 6298 "DirectoryMonitor.c"
	}
#line 1445 "../src/DirectoryMonitor.vala"
	ftype = directory_monitor_get_ftype (info);
#line 1446 "../src/DirectoryMonitor.vala"
	switch (ftype) {
#line 1446 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6306 "DirectoryMonitor.c"
		{
#line 1448 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1448 "../src/DirectoryMonitor.vala"
			return result;
#line 6312 "DirectoryMonitor.c"
		}
#line 1446 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6316 "DirectoryMonitor.c"
		{
#line 1451 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1451 "../src/DirectoryMonitor.vala"
			return result;
#line 6322 "DirectoryMonitor.c"
		}
		default:
		{
#line 1454 "../src/DirectoryMonitor.vala"
			_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1456 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 1456 "../src/DirectoryMonitor.vala"
			return result;
#line 6332 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_real_root_moved (DirectoryMonitor* self,
                                   GFile* old_root,
                                   GFile* new_root,
                                   GFileInfo* new_root_info)
{
#line 386 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_root, g_file_get_type ()));
#line 386 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root, g_file_get_type ()));
#line 386 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_root_info, g_file_info_get_type ()));
#line 6349 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 60 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6374 "DirectoryMonitor.c"
	} else {
#line 60 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6380 "DirectoryMonitor.c"
	}
#line 60 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 6386 "DirectoryMonitor.c"
}

static void
directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                     GFile* root)
{
#line 394 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_file_get_type ()));
#line 6395 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_started (DirectoryMonitor* self)
{
}

static void
directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                        GFile* file,
                                        GFileInfo* info)
{
#line 400 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 400 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6412 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 60 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6437 "DirectoryMonitor.c"
	} else {
#line 60 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6443 "DirectoryMonitor.c"
	}
#line 60 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6449 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info)
{
#line 403 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 403 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6461 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                         const gchar* reason)
{
#line 408 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 6470 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_completed (DirectoryMonitor* self)
{
#line 412 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 413 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 6480 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_created (DirectoryMonitor* self,
                                     GFile* file,
                                     GFileInfo* info)
{
#line 416 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 416 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6492 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_moved (DirectoryMonitor* self,
                                   GFile* old_file,
                                   GFile* new_file,
                                   GFileInfo* new_file_info)
{
#line 419 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_file, g_file_get_type ()));
#line 419 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file, g_file_get_type ()));
#line 419 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_file_info, g_file_info_get_type ()));
#line 6507 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_altered (DirectoryMonitor* self,
                                     GFile* file)
{
#line 423 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 6516 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info)
{
#line 428 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 428 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6528 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                GFile* file)
{
#line 431 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 6537 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                     GFile* file)
{
#line 434 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 6546 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_created (DirectoryMonitor* self,
                                          GFile* dir,
                                          GFileInfo* info)
{
#line 438 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 438 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6558 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                        GFile* old_dir,
                                        GFile* new_dir,
                                        GFileInfo* new_dir_info)
{
#line 442 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_dir, g_file_get_type ()));
#line 442 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir, g_file_get_type ()));
#line 442 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_dir_info, g_file_info_get_type ()));
#line 6573 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 446 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 6582 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       GFileInfo* info)
{
#line 451 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 451 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
#line 6594 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                     GFile* dir)
{
#line 454 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 6603 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 458 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 6612 "DirectoryMonitor.c"
}

static void
directory_monitor_real_closed (DirectoryMonitor* self)
{
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_construct (GType object_type,
                                                      DirectoryMonitor* owner,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileMonitorEvent event)
{
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	guint _tmp3_;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((other_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (other_file, g_file_get_type ()), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 98 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 98 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 98 "../src/DirectoryMonitor.vala"
	self->owner = _tmp0_;
#line 99 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 99 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 99 "../src/DirectoryMonitor.vala"
	self->file = _tmp1_;
#line 100 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (other_file);
#line 100 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 100 "../src/DirectoryMonitor.vala"
	self->other_file = _tmp2_;
#line 101 "../src/DirectoryMonitor.vala"
	self->event = event;
#line 102 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_query_info_queue_element_current;
#line 102 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_current = _tmp3_ + 1;
#line 102 "../src/DirectoryMonitor.vala"
	self->position = _tmp3_;
#line 103 "../src/DirectoryMonitor.vala"
	self->time_created_msec = now_ms ();
#line 96 "../src/DirectoryMonitor.vala"
	return self;
#line 6670 "DirectoryMonitor.c"
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event)
{
#line 96 "../src/DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 6681 "DirectoryMonitor.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 117 "../src/DirectoryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 6689 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                         GObject* source,
                                                         GAsyncResult* aresult)
{
	GFile* source_file = NULL;
	GFile* _tmp0_;
	DirectoryMonitor* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 106 "../src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
#line 106 "../src/DirectoryMonitor.vala"
	g_return_if_fail ((source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (source, G_TYPE_OBJECT));
#line 106 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (aresult, g_async_result_get_type ()));
#line 107 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, g_file_get_type (), GFile));
#line 107 "../src/DirectoryMonitor.vala"
	source_file = _tmp0_;
#line 6711 "DirectoryMonitor.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 111 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_file_query_info_finish (source_file, aresult, &_inner_error0_);
#line 111 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_;
#line 111 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6726 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 111 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp1_;
#line 111 "../src/DirectoryMonitor.vala"
		_tmp1_ = NULL;
#line 111 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (self->info);
#line 111 "../src/DirectoryMonitor.vala"
		self->info = _tmp3_;
#line 112 "../src/DirectoryMonitor.vala"
		_tmp4_ = self->info;
#line 112 "../src/DirectoryMonitor.vala"
		_tmp5_ = get_file_info_id (_tmp4_);
#line 112 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 112 "../src/DirectoryMonitor.vala"
		_tmp7_ = _tmp6_ == NULL;
#line 112 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp6_);
#line 112 "../src/DirectoryMonitor.vala"
		if (_tmp7_) {
#line 6749 "DirectoryMonitor.c"
			GFileInfo* _tmp8_;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 113 "../src/DirectoryMonitor.vala"
			_tmp8_ = self->info;
#line 113 "../src/DirectoryMonitor.vala"
			_tmp9_ = self->file;
#line 113 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_uri (_tmp9_);
#line 113 "../src/DirectoryMonitor.vala"
			_tmp11_ = _tmp10_;
#line 113 "../src/DirectoryMonitor.vala"
			g_file_info_set_attribute_string (_tmp8_, G_FILE_ATTRIBUTE_ID_FILE, _tmp11_);
#line 113 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp11_);
#line 6766 "DirectoryMonitor.c"
		}
#line 110 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 6770 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp12_;
		GError* _tmp13_;
#line 110 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 110 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 117 "../src/DirectoryMonitor.vala"
		_tmp12_ = err;
#line 117 "../src/DirectoryMonitor.vala"
		_tmp13_ = _g_error_copy0 (_tmp12_);
#line 117 "../src/DirectoryMonitor.vala"
		_g_error_free0 (self->err);
#line 117 "../src/DirectoryMonitor.vala"
		self->err = _tmp13_;
#line 110 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 6792 "DirectoryMonitor.c"
	}
	__finally0:
#line 110 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (source_file);
#line 110 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 110 "../src/DirectoryMonitor.vala"
		return;
#line 6805 "DirectoryMonitor.c"
	}
#line 121 "../src/DirectoryMonitor.vala"
	self->completed = TRUE;
#line 124 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->owner;
#line 124 "../src/DirectoryMonitor.vala"
	directory_monitor_process_query_queue (_tmp14_, self);
#line 106 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (source_file);
#line 6815 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_init (GValue* value)
{
#line 83 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 6823 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_free_value (GValue* value)
{
#line 83 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 83 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
#line 6833 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 83 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 83 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
#line 6845 "DirectoryMonitor.c"
	} else {
#line 83 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6849 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value)
{
#line 83 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6858 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 83 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 6869 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement * object;
		object = collect_values[0].v_pointer;
#line 83 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 83 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6876 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 83 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6880 "DirectoryMonitor.c"
		}
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
#line 6884 "DirectoryMonitor.c"
	} else {
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6888 "DirectoryMonitor.c"
	}
#line 83 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6892 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	DirectoryMonitorQueryInfoQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 83 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 83 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6907 "DirectoryMonitor.c"
	}
#line 83 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 83 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 6913 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 83 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 6917 "DirectoryMonitor.c"
	} else {
#line 83 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6921 "DirectoryMonitor.c"
	}
#line 83 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6925 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
#line 83 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 83 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 83 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 6944 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_query_info_queue_element (const GValue* value)
{
#line 83 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6954 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                      gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 83 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 83 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6976 "DirectoryMonitor.c"
	} else {
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6980 "DirectoryMonitor.c"
	}
#line 83 "../src/DirectoryMonitor.vala"
	if (old) {
#line 83 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 6986 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                       gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 83 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 7007 "DirectoryMonitor.c"
	} else {
#line 83 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7011 "DirectoryMonitor.c"
	}
#line 83 "../src/DirectoryMonitor.vala"
	if (old) {
#line 83 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 7017 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass,
                                                       gpointer klass_data)
{
#line 83 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 83 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorQueryInfoQueueElementClass *) klass)->finalize = directory_monitor_query_info_queue_element_finalize;
#line 7029 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self,
                                                          gpointer klass)
{
#line 92 "../src/DirectoryMonitor.vala"
	self->info = NULL;
#line 93 "../src/DirectoryMonitor.vala"
	self->err = NULL;
#line 94 "../src/DirectoryMonitor.vala"
	self->completed = FALSE;
#line 83 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 7044 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj)
{
	DirectoryMonitorQueryInfoQueueElement * self;
#line 83 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement);
#line 83 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 86 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 87 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 88 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 92 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->info);
#line 93 "../src/DirectoryMonitor.vala"
	_g_error_free0 (self->err);
#line 7065 "DirectoryMonitor.c"
}

static GType
directory_monitor_query_info_queue_element_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType directory_monitor_query_info_queue_element_type_id;
	directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return directory_monitor_query_info_queue_element_type_id;
}

static GType
directory_monitor_query_info_queue_element_get_type (void)
{
	static volatile gsize directory_monitor_query_info_queue_element_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__once)) {
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = directory_monitor_query_info_queue_element_get_type_once ();
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__once, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__once;
}

static gpointer
directory_monitor_query_info_queue_element_ref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 83 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 83 "../src/DirectoryMonitor.vala"
	return instance;
#line 7100 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_unref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 83 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 83 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 83 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7114 "DirectoryMonitor.c"
	}
}

static inline gpointer
directory_monitor_file_info_map_get_instance_private (DirectoryMonitorFileInfoMap* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitorFileInfoMap_private_offset);
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_construct (GType object_type)
{
	DirectoryMonitorFileInfoMap* self = NULL;
#line 138 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
#line 138 "../src/DirectoryMonitor.vala"
	return self;
#line 7132 "DirectoryMonitor.c"
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_new (void)
{
#line 138 "../src/DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 7140 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile** normalized,
                                                gchar** id)
{
	GFile* _vala_normalized = NULL;
	gchar* _vala_id = NULL;
	GFileInfo* local_info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gchar* file_id = NULL;
	GFileInfo* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	GFile* known_file = NULL;
	GeeHashMap* _tmp8_;
	const gchar* _tmp9_;
	gpointer _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp13_ = NULL;
	GFile* _tmp14_;
	GFile* _tmp16_;
	gboolean result;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 144 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (info);
#line 144 "../src/DirectoryMonitor.vala"
	local_info = _tmp0_;
#line 145 "../src/DirectoryMonitor.vala"
	_tmp1_ = local_info;
#line 145 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 7183 "DirectoryMonitor.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		GFileInfo* _tmp4_;
#line 146 "../src/DirectoryMonitor.vala"
		_tmp2_ = self->priv->map;
#line 146 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 146 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 146 "../src/DirectoryMonitor.vala"
		local_info = (GFileInfo*) _tmp3_;
#line 147 "../src/DirectoryMonitor.vala"
		_tmp4_ = local_info;
#line 147 "../src/DirectoryMonitor.vala"
		if (_tmp4_ == NULL) {
#line 148 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 148 "../src/DirectoryMonitor.vala"
			_vala_normalized = NULL;
#line 149 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 149 "../src/DirectoryMonitor.vala"
			_vala_id = NULL;
#line 151 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 151 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 151 "../src/DirectoryMonitor.vala"
			if (normalized) {
#line 151 "../src/DirectoryMonitor.vala"
				*normalized = _vala_normalized;
#line 7215 "DirectoryMonitor.c"
			} else {
#line 151 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_vala_normalized);
#line 7219 "DirectoryMonitor.c"
			}
#line 151 "../src/DirectoryMonitor.vala"
			if (id) {
#line 151 "../src/DirectoryMonitor.vala"
				*id = _vala_id;
#line 7225 "DirectoryMonitor.c"
			} else {
#line 151 "../src/DirectoryMonitor.vala"
				_g_free0 (_vala_id);
#line 7229 "DirectoryMonitor.c"
			}
#line 151 "../src/DirectoryMonitor.vala"
			return result;
#line 7233 "DirectoryMonitor.c"
		}
	}
#line 155 "../src/DirectoryMonitor.vala"
	_tmp5_ = local_info;
#line 155 "../src/DirectoryMonitor.vala"
	_tmp6_ = get_file_info_id (_tmp5_);
#line 155 "../src/DirectoryMonitor.vala"
	file_id = _tmp6_;
#line 156 "../src/DirectoryMonitor.vala"
	_tmp7_ = file_id;
#line 156 "../src/DirectoryMonitor.vala"
	if (_tmp7_ == NULL) {
#line 157 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 157 "../src/DirectoryMonitor.vala"
		_vala_normalized = NULL;
#line 158 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 158 "../src/DirectoryMonitor.vala"
		_vala_id = NULL;
#line 160 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 160 "../src/DirectoryMonitor.vala"
		_g_free0 (file_id);
#line 160 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 160 "../src/DirectoryMonitor.vala"
		if (normalized) {
#line 160 "../src/DirectoryMonitor.vala"
			*normalized = _vala_normalized;
#line 7264 "DirectoryMonitor.c"
		} else {
#line 160 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 7268 "DirectoryMonitor.c"
		}
#line 160 "../src/DirectoryMonitor.vala"
		if (id) {
#line 160 "../src/DirectoryMonitor.vala"
			*id = _vala_id;
#line 7274 "DirectoryMonitor.c"
		} else {
#line 160 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 7278 "DirectoryMonitor.c"
		}
#line 160 "../src/DirectoryMonitor.vala"
		return result;
#line 7282 "DirectoryMonitor.c"
	}
#line 163 "../src/DirectoryMonitor.vala"
	_tmp8_ = self->priv->id_map;
#line 163 "../src/DirectoryMonitor.vala"
	_tmp9_ = file_id;
#line 163 "../src/DirectoryMonitor.vala"
	_tmp10_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp9_);
#line 163 "../src/DirectoryMonitor.vala"
	known_file = (GFile*) _tmp10_;
#line 165 "../src/DirectoryMonitor.vala"
	_tmp11_ = file_id;
#line 165 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
#line 165 "../src/DirectoryMonitor.vala"
	_g_free0 (_vala_id);
#line 165 "../src/DirectoryMonitor.vala"
	_vala_id = _tmp12_;
#line 166 "../src/DirectoryMonitor.vala"
	_tmp14_ = known_file;
#line 166 "../src/DirectoryMonitor.vala"
	if (_tmp14_ != NULL) {
#line 7304 "DirectoryMonitor.c"
		GFile* _tmp15_;
#line 166 "../src/DirectoryMonitor.vala"
		_tmp15_ = known_file;
#line 166 "../src/DirectoryMonitor.vala"
		_tmp13_ = _tmp15_;
#line 7310 "DirectoryMonitor.c"
	} else {
#line 166 "../src/DirectoryMonitor.vala"
		_tmp13_ = file;
#line 7314 "DirectoryMonitor.c"
	}
#line 166 "../src/DirectoryMonitor.vala"
	_tmp16_ = _g_object_ref0 (_tmp13_);
#line 166 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_normalized);
#line 166 "../src/DirectoryMonitor.vala"
	_vala_normalized = _tmp16_;
#line 168 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 168 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (known_file);
#line 168 "../src/DirectoryMonitor.vala"
	_g_free0 (file_id);
#line 168 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (local_info);
#line 168 "../src/DirectoryMonitor.vala"
	if (normalized) {
#line 168 "../src/DirectoryMonitor.vala"
		*normalized = _vala_normalized;
#line 7334 "DirectoryMonitor.c"
	} else {
#line 168 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 7338 "DirectoryMonitor.c"
	}
#line 168 "../src/DirectoryMonitor.vala"
	if (id) {
#line 168 "../src/DirectoryMonitor.vala"
		*id = _vala_id;
#line 7344 "DirectoryMonitor.c"
	} else {
#line 168 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 7348 "DirectoryMonitor.c"
	}
#line 168 "../src/DirectoryMonitor.vala"
	return result;
#line 7352 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	GeeHashMap* _tmp0_;
	gchar* existing_id = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_;
	GeeHashMap* _tmp12_;
	GFile* _tmp13_;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	gboolean result;
#line 171 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 171 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 171 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 173 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 173 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file)) {
#line 7386 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp1_;
#line 174 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->map;
#line 174 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file, NULL);
#line 175 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7395 "DirectoryMonitor.c"
	}
#line 179 "../src/DirectoryMonitor.vala"
	_tmp2_ = get_file_info_id (info);
#line 179 "../src/DirectoryMonitor.vala"
	existing_id = _tmp2_;
#line 180 "../src/DirectoryMonitor.vala"
	_tmp4_ = existing_id;
#line 180 "../src/DirectoryMonitor.vala"
	if (_tmp4_ != NULL) {
#line 7405 "DirectoryMonitor.c"
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
#line 180 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->id_map;
#line 180 "../src/DirectoryMonitor.vala"
		_tmp6_ = existing_id;
#line 180 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_);
#line 7414 "DirectoryMonitor.c"
	} else {
#line 180 "../src/DirectoryMonitor.vala"
		_tmp3_ = FALSE;
#line 7418 "DirectoryMonitor.c"
	}
#line 180 "../src/DirectoryMonitor.vala"
	if (_tmp3_) {
#line 7422 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
#line 181 "../src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->id_map;
#line 181 "../src/DirectoryMonitor.vala"
		_tmp8_ = existing_id;
#line 181 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp8_, NULL);
#line 182 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7434 "DirectoryMonitor.c"
	}
#line 187 "../src/DirectoryMonitor.vala"
	_tmp11_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp9_, &_tmp10_);
#line 187 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 187 "../src/DirectoryMonitor.vala"
	normalized = _tmp9_;
#line 187 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 187 "../src/DirectoryMonitor.vala"
	id = _tmp10_;
#line 187 "../src/DirectoryMonitor.vala"
	if (!_tmp11_) {
#line 188 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 188 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 188 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 188 "../src/DirectoryMonitor.vala"
		_g_free0 (existing_id);
#line 188 "../src/DirectoryMonitor.vala"
		return result;
#line 7458 "DirectoryMonitor.c"
	}
#line 190 "../src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->map;
#line 190 "../src/DirectoryMonitor.vala"
	_tmp13_ = normalized;
#line 190 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_, info);
#line 191 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->priv->id_map;
#line 191 "../src/DirectoryMonitor.vala"
	_tmp15_ = id;
#line 191 "../src/DirectoryMonitor.vala"
	_tmp16_ = normalized;
#line 191 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_, _tmp16_);
#line 193 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 193 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 193 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 193 "../src/DirectoryMonitor.vala"
	_g_free0 (existing_id);
#line 193 "../src/DirectoryMonitor.vala"
	return result;
#line 7484 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 196 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 196 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 196 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 199 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 199 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 199 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 199 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 199 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 199 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 200 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 200 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 200 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 200 "../src/DirectoryMonitor.vala"
		return result;
#line 7528 "DirectoryMonitor.c"
	}
#line 202 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->map;
#line 202 "../src/DirectoryMonitor.vala"
	_tmp4_ = normalized;
#line 202 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_, NULL);
#line 203 "../src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->id_map;
#line 203 "../src/DirectoryMonitor.vala"
	_tmp6_ = id;
#line 203 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp6_, NULL);
#line 205 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 205 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 205 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 205 "../src/DirectoryMonitor.vala"
	return result;
#line 7550 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                            GeeCollection* files)
{
#line 210 "../src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 210 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (files, GEE_TYPE_COLLECTION));
#line 7561 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp0_;
#line 211 "../src/DirectoryMonitor.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (files, GEE_TYPE_ITERABLE, GeeIterable));
#line 211 "../src/DirectoryMonitor.vala"
		_file_it = _tmp0_;
#line 211 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7571 "DirectoryMonitor.c"
			GeeIterator* _tmp1_;
			GFile* file = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GFile* _tmp4_;
#line 211 "../src/DirectoryMonitor.vala"
			_tmp1_ = _file_it;
#line 211 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 211 "../src/DirectoryMonitor.vala"
				break;
#line 7583 "DirectoryMonitor.c"
			}
#line 211 "../src/DirectoryMonitor.vala"
			_tmp2_ = _file_it;
#line 211 "../src/DirectoryMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 211 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp3_;
#line 212 "../src/DirectoryMonitor.vala"
			_tmp4_ = file;
#line 212 "../src/DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, _tmp4_, NULL);
#line 211 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 7597 "DirectoryMonitor.c"
		}
#line 211 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7601 "DirectoryMonitor.c"
	}
}

static gboolean
directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                          GFile* file,
                                          GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 215 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 215 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 215 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 218 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 218 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 218 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 218 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 218 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 218 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 219 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 219 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 219 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 219 "../src/DirectoryMonitor.vala"
		return result;
#line 7644 "DirectoryMonitor.c"
	}
#line 221 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->id_map;
#line 221 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 221 "../src/DirectoryMonitor.vala"
	result = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp4_);
#line 221 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 221 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 221 "../src/DirectoryMonitor.vala"
	return result;
#line 7658 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	gchar* result;
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), NULL);
#line 226 "../src/DirectoryMonitor.vala"
	if (info != NULL) {
#line 7680 "DirectoryMonitor.c"
		gchar* _tmp0_;
#line 227 "../src/DirectoryMonitor.vala"
		_tmp0_ = get_file_info_id (info);
#line 227 "../src/DirectoryMonitor.vala"
		result = _tmp0_;
#line 227 "../src/DirectoryMonitor.vala"
		return result;
#line 7688 "DirectoryMonitor.c"
	}
#line 231 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp1_, &_tmp2_);
#line 231 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 231 "../src/DirectoryMonitor.vala"
	normalized = _tmp1_;
#line 231 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 231 "../src/DirectoryMonitor.vala"
	id = _tmp2_;
#line 231 "../src/DirectoryMonitor.vala"
	if (!_tmp3_) {
#line 232 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 232 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 232 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 232 "../src/DirectoryMonitor.vala"
		return result;
#line 7710 "DirectoryMonitor.c"
	}
#line 234 "../src/DirectoryMonitor.vala"
	result = id;
#line 234 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 234 "../src/DirectoryMonitor.vala"
	return result;
#line 7718 "DirectoryMonitor.c"
}

static GeeCollection*
directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result;
#line 237 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 238 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 238 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 238 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 238 "../src/DirectoryMonitor.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 238 "../src/DirectoryMonitor.vala"
	return result;
#line 7740 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                          GFile* file)
{
	GFileInfo* info = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GFileInfo* _tmp2_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_;
	GeeHashMap* _tmp6_;
	GFile* _tmp7_;
	gpointer _tmp8_;
	GFileInfo* result;
#line 241 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 241 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 243 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 243 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 243 "../src/DirectoryMonitor.vala"
	info = (GFileInfo*) _tmp1_;
#line 244 "../src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 244 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 245 "../src/DirectoryMonitor.vala"
		result = info;
#line 245 "../src/DirectoryMonitor.vala"
		return result;
#line 7778 "DirectoryMonitor.c"
	}
#line 249 "../src/DirectoryMonitor.vala"
	_tmp5_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp3_, &_tmp4_);
#line 249 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 249 "../src/DirectoryMonitor.vala"
	normalized = _tmp3_;
#line 249 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 249 "../src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 249 "../src/DirectoryMonitor.vala"
	if (!_tmp5_) {
#line 250 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 250 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 250 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 250 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 250 "../src/DirectoryMonitor.vala"
		return result;
#line 7802 "DirectoryMonitor.c"
	}
#line 252 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->map;
#line 252 "../src/DirectoryMonitor.vala"
	_tmp7_ = normalized;
#line 252 "../src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp7_);
#line 252 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp8_;
#line 252 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 252 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 252 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 252 "../src/DirectoryMonitor.vala"
	return result;
#line 7820 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                            GFile* file,
                                            GCancellable* cancellable)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp9_;
	gchar* id = NULL;
	GFileInfo* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* normalized = NULL;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	gpointer _tmp19_;
	GFile* _tmp20_;
	GeeHashMap* _tmp21_;
	gpointer _tmp22_;
	GError* _inner_error0_ = NULL;
	GFileInfo* result;
#line 255 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 255 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 255 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 256 "../src/DirectoryMonitor.vala"
	_tmp0_ = directory_monitor_file_info_map_get_info (self, file);
#line 256 "../src/DirectoryMonitor.vala"
	info = _tmp0_;
#line 257 "../src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 257 "../src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 258 "../src/DirectoryMonitor.vala"
		result = info;
#line 258 "../src/DirectoryMonitor.vala"
		return result;
#line 7864 "DirectoryMonitor.c"
	}
	{
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
#line 263 "../src/DirectoryMonitor.vala"
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, cancellable, &_inner_error0_);
#line 263 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp3_;
#line 263 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7876 "DirectoryMonitor.c"
			goto __catch0_g_error;
		}
#line 263 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp2_;
#line 263 "../src/DirectoryMonitor.vala"
		_tmp2_ = NULL;
#line 263 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 263 "../src/DirectoryMonitor.vala"
		info = _tmp4_;
#line 262 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp2_);
#line 7889 "DirectoryMonitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 262 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 262 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 265 "../src/DirectoryMonitor.vala"
		_tmp5_ = g_file_get_path (file);
#line 265 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 265 "../src/DirectoryMonitor.vala"
		_tmp7_ = err;
#line 265 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_->message;
#line 265 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:265: Unable to query file ID of %s: %s", _tmp6_, _tmp8_);
#line 265 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp6_);
#line 267 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 267 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 267 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 267 "../src/DirectoryMonitor.vala"
		return result;
#line 7923 "DirectoryMonitor.c"
	}
	__finally0:
#line 262 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 262 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 262 "../src/DirectoryMonitor.vala"
		return NULL;
#line 7936 "DirectoryMonitor.c"
	}
#line 270 "../src/DirectoryMonitor.vala"
	_tmp9_ = info;
#line 270 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_is_file_symlink_supported (_tmp9_)) {
#line 271 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 271 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 271 "../src/DirectoryMonitor.vala"
		return result;
#line 7948 "DirectoryMonitor.c"
	}
#line 273 "../src/DirectoryMonitor.vala"
	_tmp10_ = info;
#line 273 "../src/DirectoryMonitor.vala"
	_tmp11_ = g_file_info_get_attribute_string (_tmp10_, G_FILE_ATTRIBUTE_ID_FILE);
#line 273 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 273 "../src/DirectoryMonitor.vala"
	id = _tmp12_;
#line 274 "../src/DirectoryMonitor.vala"
	_tmp13_ = id;
#line 274 "../src/DirectoryMonitor.vala"
	if (_tmp13_ == NULL) {
#line 7962 "DirectoryMonitor.c"
		GFileInfo* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 275 "../src/DirectoryMonitor.vala"
		_tmp14_ = info;
#line 275 "../src/DirectoryMonitor.vala"
		_tmp15_ = g_file_get_uri (file);
#line 275 "../src/DirectoryMonitor.vala"
		_tmp16_ = _tmp15_;
#line 275 "../src/DirectoryMonitor.vala"
		g_file_info_set_attribute_string (_tmp14_, G_FILE_ATTRIBUTE_ID_FILE, _tmp16_);
#line 275 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp16_);
#line 7976 "DirectoryMonitor.c"
	}
#line 279 "../src/DirectoryMonitor.vala"
	_tmp17_ = self->priv->id_map;
#line 279 "../src/DirectoryMonitor.vala"
	_tmp18_ = id;
#line 279 "../src/DirectoryMonitor.vala"
	_tmp19_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp18_);
#line 279 "../src/DirectoryMonitor.vala"
	normalized = (GFile*) _tmp19_;
#line 280 "../src/DirectoryMonitor.vala"
	_tmp20_ = normalized;
#line 280 "../src/DirectoryMonitor.vala"
	if (_tmp20_ == NULL) {
#line 281 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 281 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 281 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 281 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 281 "../src/DirectoryMonitor.vala"
		return result;
#line 8000 "DirectoryMonitor.c"
	}
#line 283 "../src/DirectoryMonitor.vala"
	_tmp21_ = self->priv->map;
#line 283 "../src/DirectoryMonitor.vala"
	_tmp22_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), file);
#line 283 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp22_;
#line 283 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 283 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 283 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 283 "../src/DirectoryMonitor.vala"
	return result;
#line 8016 "DirectoryMonitor.c"
}

static GFile*
directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                            GFileInfo* match)
{
	gchar* match_id = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint64 match_size = 0LL;
	GDateTime* match_time = NULL;
	GDateTime* _tmp2_;
	GFile* result;
#line 286 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 286 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (match, g_file_info_get_type ()), NULL);
#line 287 "../src/DirectoryMonitor.vala"
	_tmp0_ = get_file_info_id (match);
#line 287 "../src/DirectoryMonitor.vala"
	match_id = _tmp0_;
#line 288 "../src/DirectoryMonitor.vala"
	_tmp1_ = match_id;
#line 288 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 289 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 289 "../src/DirectoryMonitor.vala"
		_g_free0 (match_id);
#line 289 "../src/DirectoryMonitor.vala"
		return result;
#line 8048 "DirectoryMonitor.c"
	}
#line 292 "../src/DirectoryMonitor.vala"
	match_size = g_file_info_get_size (match);
#line 293 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_info_get_modification_date_time (match);
#line 293 "../src/DirectoryMonitor.vala"
	match_time = _tmp2_;
#line 8056 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 295 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 295 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 295 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 295 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 295 "../src/DirectoryMonitor.vala"
		_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 295 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_;
#line 295 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp6_);
#line 295 "../src/DirectoryMonitor.vala"
		_file_it = _tmp8_;
#line 295 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8083 "DirectoryMonitor.c"
			GeeIterator* _tmp9_;
			GFile* file = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			GFileInfo* info = NULL;
			GeeHashMap* _tmp12_;
			GFile* _tmp13_;
			gpointer _tmp14_;
			GFileInfo* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gboolean _tmp19_;
			GFileInfo* _tmp20_;
			GDateTime* time = NULL;
			GFileInfo* _tmp21_;
			GDateTime* _tmp22_;
			GDateTime* _tmp23_;
			GDateTime* _tmp24_;
#line 295 "../src/DirectoryMonitor.vala"
			_tmp9_ = _file_it;
#line 295 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 295 "../src/DirectoryMonitor.vala"
				break;
#line 8109 "DirectoryMonitor.c"
			}
#line 295 "../src/DirectoryMonitor.vala"
			_tmp10_ = _file_it;
#line 295 "../src/DirectoryMonitor.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 295 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp11_;
#line 296 "../src/DirectoryMonitor.vala"
			_tmp12_ = self->priv->map;
#line 296 "../src/DirectoryMonitor.vala"
			_tmp13_ = file;
#line 296 "../src/DirectoryMonitor.vala"
			_tmp14_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp13_);
#line 296 "../src/DirectoryMonitor.vala"
			info = (GFileInfo*) _tmp14_;
#line 299 "../src/DirectoryMonitor.vala"
			_tmp15_ = info;
#line 299 "../src/DirectoryMonitor.vala"
			_tmp16_ = get_file_info_id (_tmp15_);
#line 299 "../src/DirectoryMonitor.vala"
			_tmp17_ = _tmp16_;
#line 299 "../src/DirectoryMonitor.vala"
			_tmp18_ = match_id;
#line 299 "../src/DirectoryMonitor.vala"
			_tmp19_ = g_strcmp0 (_tmp17_, _tmp18_) == 0;
#line 299 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp17_);
#line 299 "../src/DirectoryMonitor.vala"
			if (_tmp19_) {
#line 300 "../src/DirectoryMonitor.vala"
				result = file;
#line 300 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 300 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_file_it);
#line 300 "../src/DirectoryMonitor.vala"
				_g_date_time_unref0 (match_time);
#line 300 "../src/DirectoryMonitor.vala"
				_g_free0 (match_id);
#line 300 "../src/DirectoryMonitor.vala"
				return result;
#line 8151 "DirectoryMonitor.c"
			}
#line 303 "../src/DirectoryMonitor.vala"
			_tmp20_ = info;
#line 303 "../src/DirectoryMonitor.vala"
			if (match_size != g_file_info_get_size (_tmp20_)) {
#line 304 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 304 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 304 "../src/DirectoryMonitor.vala"
				continue;
#line 8163 "DirectoryMonitor.c"
			}
#line 306 "../src/DirectoryMonitor.vala"
			_tmp21_ = info;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp22_ = g_file_info_get_modification_date_time (_tmp21_);
#line 306 "../src/DirectoryMonitor.vala"
			time = _tmp22_;
#line 308 "../src/DirectoryMonitor.vala"
			_tmp23_ = time;
#line 308 "../src/DirectoryMonitor.vala"
			_tmp24_ = match_time;
#line 308 "../src/DirectoryMonitor.vala"
			if (!g_date_time_equal (_tmp23_, _tmp24_)) {
#line 309 "../src/DirectoryMonitor.vala"
				_g_date_time_unref0 (time);
#line 309 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 309 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 309 "../src/DirectoryMonitor.vala"
				continue;
#line 8185 "DirectoryMonitor.c"
			}
#line 311 "../src/DirectoryMonitor.vala"
			result = file;
#line 311 "../src/DirectoryMonitor.vala"
			_g_date_time_unref0 (time);
#line 311 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (info);
#line 311 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_file_it);
#line 311 "../src/DirectoryMonitor.vala"
			_g_date_time_unref0 (match_time);
#line 311 "../src/DirectoryMonitor.vala"
			_g_free0 (match_id);
#line 311 "../src/DirectoryMonitor.vala"
			return result;
#line 8201 "DirectoryMonitor.c"
		}
#line 295 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8205 "DirectoryMonitor.c"
	}
#line 314 "../src/DirectoryMonitor.vala"
	result = NULL;
#line 314 "../src/DirectoryMonitor.vala"
	_g_date_time_unref0 (match_time);
#line 314 "../src/DirectoryMonitor.vala"
	_g_free0 (match_id);
#line 314 "../src/DirectoryMonitor.vala"
	return result;
#line 8215 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                    GFile* root,
                                                    DirectoryMonitorFileInfoMap* descendents)
{
	GeeArrayList* pruned = NULL;
	GeeArrayList* _tmp24_;
#line 317 "../src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 317 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_file_get_type ()));
#line 317 "../src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
#line 318 "../src/DirectoryMonitor.vala"
	pruned = NULL;
#line 8233 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 319 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 319 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 319 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 319 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 319 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 319 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 319 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 319 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 319 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8260 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
#line 319 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 319 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 319 "../src/DirectoryMonitor.vala"
				break;
#line 8274 "DirectoryMonitor.c"
			}
#line 319 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 319 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 319 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 320 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 320 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 320 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 321 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 8290 "DirectoryMonitor.c"
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp22_;
				GFile* _tmp23_;
#line 321 "../src/DirectoryMonitor.vala"
				_tmp11_ = parent;
#line 321 "../src/DirectoryMonitor.vala"
				if (!(_tmp11_ != NULL)) {
#line 321 "../src/DirectoryMonitor.vala"
					break;
#line 8301 "DirectoryMonitor.c"
				}
#line 322 "../src/DirectoryMonitor.vala"
				_tmp12_ = parent;
#line 322 "../src/DirectoryMonitor.vala"
				if (g_file_equal (_tmp12_, root)) {
#line 8307 "DirectoryMonitor.c"
					GeeArrayList* _tmp13_;
					GeeArrayList* _tmp15_;
					GFile* _tmp16_;
					GFile* _tmp17_;
					GeeHashMap* _tmp18_;
					GFile* _tmp19_;
					gpointer _tmp20_;
					GFileInfo* _tmp21_;
#line 323 "../src/DirectoryMonitor.vala"
					_tmp13_ = pruned;
#line 323 "../src/DirectoryMonitor.vala"
					if (_tmp13_ == NULL) {
#line 8320 "DirectoryMonitor.c"
						GeeArrayList* _tmp14_;
#line 324 "../src/DirectoryMonitor.vala"
						_tmp14_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 324 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (pruned);
#line 324 "../src/DirectoryMonitor.vala"
						pruned = _tmp14_;
#line 8328 "DirectoryMonitor.c"
					}
#line 326 "../src/DirectoryMonitor.vala"
					_tmp15_ = pruned;
#line 326 "../src/DirectoryMonitor.vala"
					_tmp16_ = file;
#line 326 "../src/DirectoryMonitor.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp16_);
#line 327 "../src/DirectoryMonitor.vala"
					_tmp17_ = file;
#line 327 "../src/DirectoryMonitor.vala"
					_tmp18_ = self->priv->map;
#line 327 "../src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 327 "../src/DirectoryMonitor.vala"
					_tmp20_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp19_);
#line 327 "../src/DirectoryMonitor.vala"
					_tmp21_ = (GFileInfo*) _tmp20_;
#line 327 "../src/DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (descendents, _tmp17_, _tmp21_);
#line 327 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp21_);
#line 329 "../src/DirectoryMonitor.vala"
					break;
#line 8352 "DirectoryMonitor.c"
				}
#line 332 "../src/DirectoryMonitor.vala"
				_tmp22_ = parent;
#line 332 "../src/DirectoryMonitor.vala"
				_tmp23_ = g_file_get_parent (_tmp22_);
#line 332 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 332 "../src/DirectoryMonitor.vala"
				parent = _tmp23_;
#line 8362 "DirectoryMonitor.c"
			}
#line 319 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 319 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8368 "DirectoryMonitor.c"
		}
#line 319 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8372 "DirectoryMonitor.c"
	}
#line 336 "../src/DirectoryMonitor.vala"
	_tmp24_ = pruned;
#line 336 "../src/DirectoryMonitor.vala"
	if (_tmp24_ != NULL) {
#line 8378 "DirectoryMonitor.c"
		GeeArrayList* _tmp25_;
#line 337 "../src/DirectoryMonitor.vala"
		_tmp25_ = pruned;
#line 337 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection));
#line 8384 "DirectoryMonitor.c"
	}
#line 317 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (pruned);
#line 8388 "DirectoryMonitor.c"
}

static gint
directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                              GFile* root,
                                              GeeCollection* files,
                                              GeeCollection* dirs)
{
	gint count = 0;
	gint result;
#line 342 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
#line 342 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (root, g_file_get_type ()), 0);
#line 342 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (files, GEE_TYPE_COLLECTION), 0);
#line 342 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dirs, GEE_TYPE_COLLECTION), 0);
#line 343 "../src/DirectoryMonitor.vala"
	count = 0;
#line 8409 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 344 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 344 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 344 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 344 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 344 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 344 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 344 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 344 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 344 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8436 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFile* _tmp12_;
			DirectoryMonitorFType ftype = 0;
			GeeHashMap* _tmp14_;
			GFile* _tmp15_;
			gpointer _tmp16_;
			GFileInfo* _tmp17_;
			DirectoryMonitorFType _tmp18_;
#line 344 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 344 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 344 "../src/DirectoryMonitor.vala"
				break;
#line 8458 "DirectoryMonitor.c"
			}
#line 344 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 344 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 344 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 345 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 345 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 345 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 346 "../src/DirectoryMonitor.vala"
			_tmp12_ = parent;
#line 346 "../src/DirectoryMonitor.vala"
			if (_tmp12_ == NULL) {
#line 346 "../src/DirectoryMonitor.vala"
				_tmp11_ = TRUE;
#line 8478 "DirectoryMonitor.c"
			} else {
				GFile* _tmp13_;
#line 346 "../src/DirectoryMonitor.vala"
				_tmp13_ = parent;
#line 346 "../src/DirectoryMonitor.vala"
				_tmp11_ = !g_file_equal (_tmp13_, root);
#line 8485 "DirectoryMonitor.c"
			}
#line 346 "../src/DirectoryMonitor.vala"
			if (_tmp11_) {
#line 347 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 347 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 347 "../src/DirectoryMonitor.vala"
				continue;
#line 8495 "DirectoryMonitor.c"
			}
#line 349 "../src/DirectoryMonitor.vala"
			_tmp14_ = self->priv->map;
#line 349 "../src/DirectoryMonitor.vala"
			_tmp15_ = file;
#line 349 "../src/DirectoryMonitor.vala"
			_tmp16_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_);
#line 349 "../src/DirectoryMonitor.vala"
			_tmp17_ = (GFileInfo*) _tmp16_;
#line 349 "../src/DirectoryMonitor.vala"
			_tmp18_ = directory_monitor_get_ftype (_tmp17_);
#line 349 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_tmp17_);
#line 349 "../src/DirectoryMonitor.vala"
			ftype = _tmp18_;
#line 350 "../src/DirectoryMonitor.vala"
			switch (ftype) {
#line 350 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 8515 "DirectoryMonitor.c"
				{
					GFile* _tmp19_;
					gint _tmp20_;
#line 352 "../src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 352 "../src/DirectoryMonitor.vala"
					gee_collection_add (files, _tmp19_);
#line 353 "../src/DirectoryMonitor.vala"
					_tmp20_ = count;
#line 353 "../src/DirectoryMonitor.vala"
					count = _tmp20_ + 1;
#line 354 "../src/DirectoryMonitor.vala"
					break;
#line 8529 "DirectoryMonitor.c"
				}
#line 350 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 8533 "DirectoryMonitor.c"
				{
					GFile* _tmp21_;
					gint _tmp22_;
#line 357 "../src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 357 "../src/DirectoryMonitor.vala"
					gee_collection_add (dirs, _tmp21_);
#line 358 "../src/DirectoryMonitor.vala"
					_tmp22_ = count;
#line 358 "../src/DirectoryMonitor.vala"
					count = _tmp22_ + 1;
#line 359 "../src/DirectoryMonitor.vala"
					break;
#line 8547 "DirectoryMonitor.c"
				}
				default:
				{
#line 362 "../src/DirectoryMonitor.vala"
					_vala_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 363 "../src/DirectoryMonitor.vala"
					break;
#line 8555 "DirectoryMonitor.c"
				}
			}
#line 344 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 344 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8562 "DirectoryMonitor.c"
		}
#line 344 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8566 "DirectoryMonitor.c"
	}
#line 367 "../src/DirectoryMonitor.vala"
	result = count;
#line 367 "../src/DirectoryMonitor.vala"
	return result;
#line 8572 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_init (GValue* value)
{
#line 132 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 8580 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_free_value (GValue* value)
{
#line 132 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 132 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
#line 8590 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_file_info_map_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 132 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 132 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
#line 8602 "DirectoryMonitor.c"
	} else {
#line 132 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8606 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_file_info_map_peek_pointer (const GValue* value)
{
#line 132 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8615 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 132 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 8626 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap * object;
		object = collect_values[0].v_pointer;
#line 132 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 132 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8633 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 132 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8637 "DirectoryMonitor.c"
		}
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
#line 8641 "DirectoryMonitor.c"
	} else {
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8645 "DirectoryMonitor.c"
	}
#line 132 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8649 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	DirectoryMonitorFileInfoMap ** object_p;
	object_p = collect_values[0].v_pointer;
#line 132 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 132 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8664 "DirectoryMonitor.c"
	}
#line 132 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 132 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 8670 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 132 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 8674 "DirectoryMonitor.c"
	} else {
#line 132 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8678 "DirectoryMonitor.c"
	}
#line 132 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8682 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_file_info_map (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	DirectoryMonitorParamSpecFileInfoMap* spec;
#line 132 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 132 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 132 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 132 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 8701 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_file_info_map (const GValue* value)
{
#line 132 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 132 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8711 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_file_info_map (GValue* value,
                                           gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 132 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 132 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 132 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 132 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 132 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 132 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8733 "DirectoryMonitor.c"
	} else {
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8737 "DirectoryMonitor.c"
	}
#line 132 "../src/DirectoryMonitor.vala"
	if (old) {
#line 132 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8743 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_file_info_map (GValue* value,
                                            gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 132 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 132 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 132 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 132 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 132 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 8764 "DirectoryMonitor.c"
	} else {
#line 132 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8768 "DirectoryMonitor.c"
	}
#line 132 "../src/DirectoryMonitor.vala"
	if (old) {
#line 132 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8774 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass,
                                            gpointer klass_data)
{
#line 132 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
#line 132 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorFileInfoMapClass *) klass)->finalize = directory_monitor_file_info_map_finalize;
#line 132 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitorFileInfoMap_private_offset);
#line 8788 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 132 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_file_info_map_get_instance_private (self);
#line 133 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 133 "../src/DirectoryMonitor.vala"
	self->priv->map = _tmp0_;
#line 135 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 135 "../src/DirectoryMonitor.vala"
	self->priv->id_map = _tmp1_;
#line 132 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 8809 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj)
{
	DirectoryMonitorFileInfoMap * self;
#line 132 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap);
#line 132 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 133 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->map);
#line 135 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->id_map);
#line 8824 "DirectoryMonitor.c"
}

static GType
directory_monitor_file_info_map_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType directory_monitor_file_info_map_type_id;
	directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
	DirectoryMonitorFileInfoMap_private_offset = g_type_add_instance_private (directory_monitor_file_info_map_type_id, sizeof (DirectoryMonitorFileInfoMapPrivate));
	return directory_monitor_file_info_map_type_id;
}

static GType
directory_monitor_file_info_map_get_type (void)
{
	static volatile gsize directory_monitor_file_info_map_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__once)) {
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = directory_monitor_file_info_map_get_type_once ();
		g_once_init_leave (&directory_monitor_file_info_map_type_id__once, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__once;
}

static gpointer
directory_monitor_file_info_map_ref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 132 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 132 "../src/DirectoryMonitor.vala"
	return instance;
#line 8860 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_unref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 132 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 132 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
#line 132 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8874 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_class_init (DirectoryMonitorClass * klass,
                              gpointer klass_data)
{
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 60 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitor_private_offset);
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_root_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_root_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_started = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_started;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_file_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_directory_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_failed = (void (*) (DirectoryMonitor*, const gchar*)) directory_monitor_real_notify_discovery_failed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_completed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_created;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_alteration_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_attributes_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_created;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_alteration_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_attributes_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_closed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_closed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->close = (void (*) (DirectoryMonitor*)) directory_monitor_real_close;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_moved = directory_monitor_real_root_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_deleted = directory_monitor_real_root_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_started = directory_monitor_real_discovery_started;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_discovered = directory_monitor_real_file_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_discovered = directory_monitor_real_directory_discovered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_failed = directory_monitor_real_discovery_failed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_completed = directory_monitor_real_discovery_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_created = directory_monitor_real_file_created;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_moved = directory_monitor_real_file_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_altered = directory_monitor_real_file_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_deleted = directory_monitor_real_file_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_created = directory_monitor_real_directory_created;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_moved = directory_monitor_real_directory_moved;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_altered = directory_monitor_real_directory_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_deleted = directory_monitor_real_directory_deleted;
#line 60 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->closed = directory_monitor_real_closed;
#line 60 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL] = g_signal_new ("root-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL] = g_signal_new ("root-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL] = g_signal_new ("discovery-started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL] = g_signal_new ("file-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL] = g_signal_new ("directory-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL] = g_signal_new ("discovery-failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL] = g_signal_new ("discovery-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL] = g_signal_new ("file-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL] = g_signal_new ("file-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL] = g_signal_new ("file-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("file-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("file-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL] = g_signal_new ("file-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL] = g_signal_new ("directory-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL] = g_signal_new ("directory-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL] = g_signal_new ("directory-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("directory-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("directory-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL] = g_signal_new ("directory-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 60 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9014 "DirectoryMonitor.c"
}

static void
directory_monitor_instance_init (DirectoryMonitor * self,
                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GCancellable* _tmp4_;
#line 60 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_get_instance_private (self);
#line 374 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 374 "../src/DirectoryMonitor.vala"
	self->priv->monitors = _tmp0_;
#line 375 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, (GDestroyNotify) directory_monitor_query_info_queue_element_unref, NULL, NULL, NULL);
#line 375 "../src/DirectoryMonitor.vala"
	self->priv->query_info_queue = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_QUEUE, GeeQueue);
#line 377 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_new ();
#line 377 "../src/DirectoryMonitor.vala"
	self->priv->files = _tmp2_;
#line 378 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_new ();
#line 378 "../src/DirectoryMonitor.vala"
	self->priv->parent_moved = _tmp3_;
#line 379 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_cancellable_new ();
#line 379 "../src/DirectoryMonitor.vala"
	self->priv->cancellable = _tmp4_;
#line 380 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 0;
#line 381 "../src/DirectoryMonitor.vala"
	self->priv->started = FALSE;
#line 382 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 383 "../src/DirectoryMonitor.vala"
	self->priv->delete_timer_id = (guint) 0;
#line 9056 "DirectoryMonitor.c"
}

static void
directory_monitor_finalize (GObject * obj)
{
	DirectoryMonitor * self;
#line 60 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRECTORY_MONITOR, DirectoryMonitor);
#line 371 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 374 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 375 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->query_info_queue);
#line 377 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->files);
#line 378 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
#line 379 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 60 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
#line 9079 "DirectoryMonitor.c"
}

static GType
directory_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
	GType directory_monitor_type_id;
	directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
	DirectoryMonitor_private_offset = g_type_add_instance_private (directory_monitor_type_id, sizeof (DirectoryMonitorPrivate));
	return directory_monitor_type_id;
}

GType
directory_monitor_get_type (void)
{
	static volatile gsize directory_monitor_type_id__once = 0;
	if (g_once_init_enter (&directory_monitor_type_id__once)) {
		GType directory_monitor_type_id;
		directory_monitor_type_id = directory_monitor_get_type_once ();
		g_once_init_leave (&directory_monitor_type_id__once, directory_monitor_type_id);
	}
	return directory_monitor_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

