/* PhotoTable.c generated by valac 0.56.3, the Vala compiler
 * generated from PhotoTable.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include "shotwell-graphics-processor.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <sqlite3.h>
#include <gio/gio.h>

#define PHOTO_ID_INVALID ((gint64) -1)
#define PHOTO_TYPENAME "thumb"
#define IMPORT_ID_INVALID ((gint64) 0)
#define UTIL_USEC_PER_SEC ((gint64) 1000000)
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
#define EVENT_ID_INVALID ((gint64) -1)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPhotoRow ParamSpecPhotoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
typedef struct _PhotoTablePrivate PhotoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_DATABASE_ERROR (database_error_get_type ())
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecBackingPhotoRow ParamSpecBackingPhotoRow;

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
typedef struct _BackingPhotoTablePrivate BackingPhotoTablePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PhotoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	GDateTime* exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	gint64 time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	GpsCoords gps_coords;
	gchar* comment;
	gchar* backlinks;
	gint64 time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _ParamSpecPhotoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _PhotoTable {
	DatabaseTable parent_instance;
	PhotoTablePrivate * priv;
};

struct _PhotoTableClass {
	DatabaseTableClass parent_class;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	gint64 time_created;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

struct _ParamSpecBackingPhotoRow {
	GParamSpec parent_instance;
};

struct _BackingPhotoTable {
	DatabaseTable parent_instance;
	BackingPhotoTablePrivate * priv;
};

struct _BackingPhotoTableClass {
	DatabaseTableClass parent_class;
};

static gpointer photo_row_parent_class = NULL;
static gpointer photo_table_parent_class = NULL;
static PhotoTable* photo_table_instance;
static PhotoTable* photo_table_instance = NULL;
VALA_EXTERN sqlite3* database_table_db;
static gpointer backing_photo_row_parent_class = NULL;
static gpointer backing_photo_table_parent_class = NULL;
static BackingPhotoTable* backing_photo_table_instance;
static BackingPhotoTable* backing_photo_table_instance = NULL;

VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN void photo_id_init (PhotoID *self,
                    gint64 id);
VALA_EXTERN gboolean photo_id_is_invalid (PhotoID *self);
VALA_EXTERN gboolean photo_id_is_valid (PhotoID *self);
VALA_EXTERN guint photo_id_hash (PhotoID *self);
VALA_EXTERN guint int64_hash (gint64* n);
VALA_EXTERN gboolean photo_id_equal (void* a,
                         void* b);
VALA_EXTERN gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN void import_id_init (ImportID *self,
                     gint64 id);
VALA_EXTERN void import_id_generate (ImportID* result);
VALA_EXTERN gboolean import_id_is_invalid (ImportID *self);
VALA_EXTERN gboolean import_id_is_valid (ImportID *self);
VALA_EXTERN gint import_id_compare_func (ImportID* a,
                             ImportID* b);
VALA_EXTERN gint64 import_id_comparator (void* a,
                             void* b);
VALA_EXTERN gpointer photo_row_ref (gpointer instance);
VALA_EXTERN void photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_photo_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_photo_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_photo_row (const GValue* value);
VALA_EXTERN GType photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoRow, photo_row_unref)
VALA_EXTERN gpointer backing_photo_row_ref (gpointer instance);
VALA_EXTERN void backing_photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer value_get_backing_photo_row (const GValue* value);
VALA_EXTERN GType backing_photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoRow, backing_photo_row_unref)
VALA_EXTERN GType event_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EventID* event_id_dup (const EventID* self);
VALA_EXTERN void event_id_free (EventID* self);
VALA_EXTERN GType orientation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gps_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GpsCoords* gps_coords_dup (const GpsCoords* self);
VALA_EXTERN void gps_coords_free (GpsCoords* self);
VALA_EXTERN GType backing_photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
VALA_EXTERN void backing_photo_id_free (BackingPhotoID* self);
VALA_EXTERN GType raw_developer_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoRow* photo_row_new (void);
VALA_EXTERN PhotoRow* photo_row_construct (GType object_type);
VALA_EXTERN BackingPhotoRow* backing_photo_row_new (void);
VALA_EXTERN BackingPhotoRow* backing_photo_row_construct (GType object_type);
VALA_EXTERN void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
VALA_EXTERN RawDeveloper* raw_developer_as_array (gint* result_length1);
static void photo_row_finalize (PhotoRow * obj);
static GType photo_row_get_type_once (void);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTable, database_table_unref)
static PhotoTable* photo_table_new (void);
static PhotoTable* photo_table_construct (GType object_type);
VALA_EXTERN DatabaseTable* database_table_construct (GType object_type);
VALA_EXTERN void database_table_fatal (const gchar* op,
                           gint res);
VALA_EXTERN void database_table_warning (const gchar* op,
                             gint res);
VALA_EXTERN void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VALA_EXTERN PhotoTable* photo_table_get_instance (void);
VALA_EXTERN void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
VALA_EXTERN gint64 now_sec (void);
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN gint photo_file_format_serialize (PhotoFileFormat self);
VALA_EXTERN gint rating_serialize (Rating self);
VALA_EXTERN gchar* raw_developer_to_string (RawDeveloper self);
VALA_EXTERN void event_id_init (EventID *self,
                    gint64 id);
VALA_EXTERN GQuark database_error_quark (void);
GType database_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
VALA_EXTERN void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
VALA_EXTERN gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          GDateTime* timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static void photo_table_validate_orientation (PhotoTable* self,
                                       PhotoRow* row);
VALA_EXTERN gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
VALA_EXTERN PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
VALA_EXTERN GeeHashMap* photo_table_marshall_all_transformations (const gchar* trans);
VALA_EXTERN Rating rating_unserialize (gint value);
VALA_EXTERN PhotoFileFormat photo_file_format_unserialize (gint value);
VALA_EXTERN RawDeveloper raw_developer_from_string (const gchar* value);
VALA_EXTERN GeeArrayList* photo_table_get_all (PhotoTable* self);
VALA_EXTERN void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
VALA_EXTERN gchar* photo_table_unmarshall_all_transformations (GeeHashMap* transformations);
VALA_EXTERN gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
VALA_EXTERN gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
VALA_EXTERN void photo_table_set_gps_coords (PhotoTable* self,
                                 PhotoID* photo_id,
                                 GpsCoords* new_gps_coords,
                                 GError** error);
VALA_EXTERN void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
VALA_EXTERN void database_table_update_double_by_id_2 (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           gdouble value,
                                           GError** error);
VALA_EXTERN gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
VALA_EXTERN void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
VALA_EXTERN void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
VALA_EXTERN void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   GDateTime* timestamp,
                                   GError** error);
VALA_EXTERN void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
VALA_EXTERN gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        GDateTime* time);
VALA_EXTERN gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
VALA_EXTERN void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
VALA_EXTERN gboolean photo_table_remove_by_file (PhotoTable* self,
                                     GFile* file);
VALA_EXTERN void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
VALA_EXTERN void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
VALA_EXTERN GeeArrayList* photo_table_get_photos (PhotoTable* self);
VALA_EXTERN gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
VALA_EXTERN gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
VALA_EXTERN gboolean photo_table_set_rating (PhotoTable* self,
                                 PhotoID* photo_id,
                                 Rating rating);
VALA_EXTERN gint photo_table_get_event_photo_count (PhotoTable* self,
                                        EventID* event_id);
VALA_EXTERN GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
VALA_EXTERN gboolean photo_table_event_has_photos (PhotoTable* self,
                                       EventID* event_id);
VALA_EXTERN gboolean photo_table_drop_event (PhotoTable* self,
                                 EventID* event_id);
VALA_EXTERN gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_table_get_raw_transformations (PhotoTable* self,
                                            PhotoID* photo_id);
VALA_EXTERN gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt** stmt);
static gboolean photo_table_set_raw_transformations (PhotoTable* self,
                                              PhotoID* photo_id,
                                              const gchar* trans);
VALA_EXTERN gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations);
VALA_EXTERN gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
VALA_EXTERN gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
VALA_EXTERN gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
static sqlite3_stmt* photo_table_get_duplicate_stmt (PhotoTable* self,
                                              GFile* file,
                                              const gchar* thumbnail_md5,
                                              const gchar* md5,
                                              PhotoFileFormat file_format);
VALA_EXTERN gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
VALA_EXTERN PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
static void _vala_array_add2 (PhotoID* * array,
                       gint* length,
                       gint* size,
                       const PhotoID* value);
VALA_EXTERN void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
VALA_EXTERN void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
VALA_EXTERN void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
VALA_EXTERN void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
VALA_EXTERN void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
VALA_EXTERN void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
VALA_EXTERN void photo_table_upgrade_for_unset_timestamp (GError** error);
static void photo_table_finalize (DatabaseTable * obj);
static GType photo_table_get_type_once (void);
VALA_EXTERN gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
VALA_EXTERN gboolean backing_photo_id_is_valid (BackingPhotoID *self);
VALA_EXTERN gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
VALA_EXTERN gboolean backing_photo_row_is_touched (BackingPhotoRow* self,
                                       GFileInfo* info);
VALA_EXTERN void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void backing_photo_row_finalize (BackingPhotoRow * obj);
static GType backing_photo_row_get_type_once (void);
VALA_EXTERN GType backing_photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoTable, database_table_unref)
static BackingPhotoTable* backing_photo_table_new (void);
static BackingPhotoTable* backing_photo_table_construct (GType object_type);
VALA_EXTERN BackingPhotoTable* backing_photo_table_get_instance (void);
VALA_EXTERN void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
VALA_EXTERN BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
VALA_EXTERN void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
VALA_EXTERN void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GDateTime* timestamp,
                                            gint64 filesize,
                                            GError** error);
VALA_EXTERN void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
VALA_EXTERN void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
VALA_EXTERN void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           GDateTime* timestamp,
                                           GError** error);
static void backing_photo_table_finalize (DatabaseTable * obj);
static GType backing_photo_table_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
photo_id_init (PhotoID *self,
               gint64 id)
{
#line 12 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (PhotoID));
#line 13 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 673 "PhotoTable.c"
}

gboolean
photo_id_is_invalid (PhotoID *self)
{
	gboolean result;
#line 17 "../src/db/PhotoTable.vala"
	result = (*self).id == PHOTO_ID_INVALID;
#line 17 "../src/db/PhotoTable.vala"
	return result;
#line 684 "PhotoTable.c"
}

gboolean
photo_id_is_valid (PhotoID *self)
{
	gboolean result;
#line 21 "../src/db/PhotoTable.vala"
	result = (*self).id != PHOTO_ID_INVALID;
#line 21 "../src/db/PhotoTable.vala"
	return result;
#line 695 "PhotoTable.c"
}

guint
photo_id_hash (PhotoID *self)
{
	guint result;
#line 25 "../src/db/PhotoTable.vala"
	result = int64_hash (&(*self).id);
#line 25 "../src/db/PhotoTable.vala"
	return result;
#line 706 "PhotoTable.c"
}

gboolean
photo_id_equal (void* a,
                void* b)
{
	gboolean result;
#line 29 "../src/db/PhotoTable.vala"
	result = (*((PhotoID*) a)).id == (*((PhotoID*) b)).id;
#line 29 "../src/db/PhotoTable.vala"
	return result;
#line 718 "PhotoTable.c"
}

gchar*
photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id)
{
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 32 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 33 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 33 "../src/db/PhotoTable.vala"
	_tmp1_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", PHOTO_TYPENAME, _tmp0_.id);
#line 33 "../src/db/PhotoTable.vala"
	result = _tmp1_;
#line 33 "../src/db/PhotoTable.vala"
	return result;
#line 737 "PhotoTable.c"
}

PhotoID*
photo_id_dup (const PhotoID* self)
{
	PhotoID* dup;
#line 7 "../src/db/PhotoTable.vala"
	dup = g_new0 (PhotoID, 1);
#line 7 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (PhotoID));
#line 7 "../src/db/PhotoTable.vala"
	return dup;
#line 750 "PhotoTable.c"
}

void
photo_id_free (PhotoID* self)
{
#line 7 "../src/db/PhotoTable.vala"
	g_free (self);
#line 758 "PhotoTable.c"
}

static GType
photo_id_get_type_once (void)
{
	GType photo_id_type_id;
	photo_id_type_id = g_boxed_type_register_static ("PhotoID", (GBoxedCopyFunc) photo_id_dup, (GBoxedFreeFunc) photo_id_free);
	return photo_id_type_id;
}

GType
photo_id_get_type (void)
{
	static volatile gsize photo_id_type_id__once = 0;
	if (g_once_init_enter (&photo_id_type_id__once)) {
		GType photo_id_type_id;
		photo_id_type_id = photo_id_get_type_once ();
		g_once_init_leave (&photo_id_type_id__once, photo_id_type_id);
	}
	return photo_id_type_id__once;
}

void
import_id_init (ImportID *self,
                gint64 id)
{
#line 42 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (ImportID));
#line 43 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 789 "PhotoTable.c"
}

void
import_id_generate (ImportID* result)
{
	gint64 id = 0LL;
	ImportID _tmp0_ = {0};
#line 47 "../src/db/PhotoTable.vala"
	id = g_get_real_time () / UTIL_USEC_PER_SEC;
#line 49 "../src/db/PhotoTable.vala"
	import_id_init (&_tmp0_, id);
#line 49 "../src/db/PhotoTable.vala"
	*result = _tmp0_;
#line 49 "../src/db/PhotoTable.vala"
	return;
#line 805 "PhotoTable.c"
}

gboolean
import_id_is_invalid (ImportID *self)
{
	gboolean result;
#line 53 "../src/db/PhotoTable.vala"
	result = (*self).id == IMPORT_ID_INVALID;
#line 53 "../src/db/PhotoTable.vala"
	return result;
#line 816 "PhotoTable.c"
}

gboolean
import_id_is_valid (ImportID *self)
{
	gboolean result;
#line 57 "../src/db/PhotoTable.vala"
	result = (*self).id != IMPORT_ID_INVALID;
#line 57 "../src/db/PhotoTable.vala"
	return result;
#line 827 "PhotoTable.c"
}

gint
import_id_compare_func (ImportID* a,
                        ImportID* b)
{
	gboolean _tmp0_ = FALSE;
	gint result;
#line 61 "../src/db/PhotoTable.vala"
	if (a != NULL) {
#line 61 "../src/db/PhotoTable.vala"
		_tmp0_ = b != NULL;
#line 840 "PhotoTable.c"
	} else {
#line 61 "../src/db/PhotoTable.vala"
		_tmp0_ = FALSE;
#line 844 "PhotoTable.c"
	}
#line 61 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "a != null && b != null");
#line 62 "../src/db/PhotoTable.vala"
	result = (gint) ((*a).id - (*b).id);
#line 62 "../src/db/PhotoTable.vala"
	return result;
#line 852 "PhotoTable.c"
}

gint64
import_id_comparator (void* a,
                      void* b)
{
	gint64 result;
#line 66 "../src/db/PhotoTable.vala"
	result = (*((ImportID*) a)).id - (*((ImportID*) b)).id;
#line 66 "../src/db/PhotoTable.vala"
	return result;
#line 864 "PhotoTable.c"
}

ImportID*
import_id_dup (const ImportID* self)
{
	ImportID* dup;
#line 37 "../src/db/PhotoTable.vala"
	dup = g_new0 (ImportID, 1);
#line 37 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (ImportID));
#line 37 "../src/db/PhotoTable.vala"
	return dup;
#line 877 "PhotoTable.c"
}

void
import_id_free (ImportID* self)
{
#line 37 "../src/db/PhotoTable.vala"
	g_free (self);
#line 885 "PhotoTable.c"
}

static GType
import_id_get_type_once (void)
{
	GType import_id_type_id;
	import_id_type_id = g_boxed_type_register_static ("ImportID", (GBoxedCopyFunc) import_id_dup, (GBoxedFreeFunc) import_id_free);
	return import_id_type_id;
}

GType
import_id_get_type (void)
{
	static volatile gsize import_id_type_id__once = 0;
	if (g_once_init_enter (&import_id_type_id__once)) {
		GType import_id_type_id;
		import_id_type_id = import_id_get_type_once ();
		g_once_init_leave (&import_id_type_id__once, import_id_type_id);
	}
	return import_id_type_id__once;
}

PhotoRow*
photo_row_construct (GType object_type)
{
	PhotoRow* self = NULL;
	BackingPhotoRow* _tmp0_;
	gint _tmp1_ = 0;
	RawDeveloper* _tmp2_;
	RawDeveloper* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID* _tmp4_;
	gint _tmp5_ = 0;
	RawDeveloper* _tmp6_;
	gint _tmp9_ = 0;
	RawDeveloper* _tmp10_;
	RawDeveloper* _tmp11_;
	gint _tmp11__length1;
	BackingPhotoID* _tmp12_;
	gint _tmp13_ = 0;
	RawDeveloper* _tmp14_;
#line 99 "../src/db/PhotoTable.vala"
	self = (PhotoRow*) g_type_create_instance (object_type);
#line 100 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_row_new ();
#line 100 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 100 "../src/db/PhotoTable.vala"
	self->master = _tmp0_;
#line 101 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&self->editable_id, BACKING_PHOTO_ID_INVALID);
#line 102 "../src/db/PhotoTable.vala"
	_tmp2_ = raw_developer_as_array (&_tmp1_);
#line 102 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp3__length1 = _tmp1_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp4_ = g_new0 (BackingPhotoID, _tmp1_);
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids = _tmp4_;
#line 102 "../src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp1_;
#line 102 "../src/db/PhotoTable.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 103 "../src/db/PhotoTable.vala"
	_tmp6_ = raw_developer_as_array (&_tmp5_);
#line 955 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 103 "../src/db/PhotoTable.vala"
		d_collection = _tmp6_;
#line 103 "../src/db/PhotoTable.vala"
		d_collection_length1 = _tmp5_;
#line 103 "../src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 967 "PhotoTable.c"
			RawDeveloper d = 0;
#line 103 "../src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 971 "PhotoTable.c"
			{
				BackingPhotoID* _tmp7_;
				gint _tmp7__length1;
				BackingPhotoID _tmp8_ = {0};
#line 104 "../src/db/PhotoTable.vala"
				_tmp7_ = self->development_ids;
#line 104 "../src/db/PhotoTable.vala"
				_tmp7__length1 = self->development_ids_length1;
#line 104 "../src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp8_, BACKING_PHOTO_ID_INVALID);
#line 104 "../src/db/PhotoTable.vala"
				_tmp7_[d] = _tmp8_;
#line 984 "PhotoTable.c"
			}
		}
#line 103 "../src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 989 "PhotoTable.c"
	}
#line 105 "../src/db/PhotoTable.vala"
	memset (&self->gps_coords, 0, sizeof (GpsCoords));
#line 106 "../src/db/PhotoTable.vala"
	_tmp10_ = raw_developer_as_array (&_tmp9_);
#line 106 "../src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp11__length1 = _tmp9_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp12_ = g_new0 (BackingPhotoID, _tmp9_);
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids = _tmp12_;
#line 106 "../src/db/PhotoTable.vala"
	self->development_ids_length1 = _tmp9_;
#line 106 "../src/db/PhotoTable.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 107 "../src/db/PhotoTable.vala"
	_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 1011 "PhotoTable.c"
	{
		RawDeveloper* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 107 "../src/db/PhotoTable.vala"
		d_collection = _tmp14_;
#line 107 "../src/db/PhotoTable.vala"
		d_collection_length1 = _tmp13_;
#line 107 "../src/db/PhotoTable.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 1023 "PhotoTable.c"
			RawDeveloper d = 0;
#line 107 "../src/db/PhotoTable.vala"
			d = d_collection[d_it];
#line 1027 "PhotoTable.c"
			{
				BackingPhotoID* _tmp15_;
				gint _tmp15__length1;
				BackingPhotoID _tmp16_ = {0};
#line 108 "../src/db/PhotoTable.vala"
				_tmp15_ = self->development_ids;
#line 108 "../src/db/PhotoTable.vala"
				_tmp15__length1 = self->development_ids_length1;
#line 108 "../src/db/PhotoTable.vala"
				backing_photo_id_init (&_tmp16_, BACKING_PHOTO_ID_INVALID);
#line 108 "../src/db/PhotoTable.vala"
				_tmp15_[d] = _tmp16_;
#line 1040 "PhotoTable.c"
			}
		}
#line 107 "../src/db/PhotoTable.vala"
		d_collection = (g_free (d_collection), NULL);
#line 1045 "PhotoTable.c"
	}
#line 99 "../src/db/PhotoTable.vala"
	return self;
#line 1049 "PhotoTable.c"
}

PhotoRow*
photo_row_new (void)
{
#line 99 "../src/db/PhotoTable.vala"
	return photo_row_construct (TYPE_PHOTO_ROW);
#line 1057 "PhotoTable.c"
}

static void
value_photo_row_init (GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 1065 "PhotoTable.c"
}

static void
value_photo_row_free_value (GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (value->data[0].v_pointer);
#line 1075 "PhotoTable.c"
	}
}

static void
value_photo_row_copy_value (const GValue* src_value,
                            GValue* dest_value)
{
#line 70 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = photo_row_ref (src_value->data[0].v_pointer);
#line 1087 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1091 "PhotoTable.c"
	}
}

static gpointer
value_photo_row_peek_pointer (const GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1100 "PhotoTable.c"
}

static gchar*
value_photo_row_collect_value (GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
#line 70 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 1111 "PhotoTable.c"
		PhotoRow * object;
		object = collect_values[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 70 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1118 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 70 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1122 "PhotoTable.c"
		}
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = photo_row_ref (object);
#line 1126 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1130 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	return NULL;
#line 1134 "PhotoTable.c"
}

static gchar*
value_photo_row_lcopy_value (const GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
	PhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 70 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1149 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 1155 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 1159 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		*object_p = photo_row_ref (value->data[0].v_pointer);
#line 1163 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	return NULL;
#line 1167 "PhotoTable.c"
}

GParamSpec*
param_spec_photo_row (const gchar* name,
                      const gchar* nick,
                      const gchar* blurb,
                      GType object_type,
                      GParamFlags flags)
{
	ParamSpecPhotoRow* spec;
#line 70 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_ROW), NULL);
#line 70 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 70 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 70 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 1186 "PhotoTable.c"
}

gpointer
value_get_photo_row (const GValue* value)
{
#line 70 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW), NULL);
#line 70 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 1196 "PhotoTable.c"
}

void
value_set_photo_row (GValue* value,
                     gpointer v_object)
{
	PhotoRow * old;
#line 70 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 70 "../src/db/PhotoTable.vala"
		photo_row_ref (value->data[0].v_pointer);
#line 1218 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1222 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (old) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1228 "PhotoTable.c"
	}
}

void
value_take_photo_row (GValue* value,
                      gpointer v_object)
{
	PhotoRow * old;
#line 70 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 70 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_ROW));
#line 70 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1249 "PhotoTable.c"
	} else {
#line 70 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 1253 "PhotoTable.c"
	}
#line 70 "../src/db/PhotoTable.vala"
	if (old) {
#line 70 "../src/db/PhotoTable.vala"
		photo_row_unref (old);
#line 1259 "PhotoTable.c"
	}
}

static void
photo_row_class_init (PhotoRowClass * klass,
                      gpointer klass_data)
{
#line 70 "../src/db/PhotoTable.vala"
	photo_row_parent_class = g_type_class_peek_parent (klass);
#line 70 "../src/db/PhotoTable.vala"
	((PhotoRowClass *) klass)->finalize = photo_row_finalize;
#line 1271 "PhotoTable.c"
}

static void
photo_row_instance_init (PhotoRow * self,
                         gpointer klass)
{
#line 70 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 1280 "PhotoTable.c"
}

static void
photo_row_finalize (PhotoRow * obj)
{
	PhotoRow * self;
#line 70 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_ROW, PhotoRow);
#line 70 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 72 "../src/db/PhotoTable.vala"
	_backing_photo_row_unref0 (self->master);
#line 73 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (self->exposure_time);
#line 77 "../src/db/PhotoTable.vala"
	_g_object_unref0 (self->transformations);
#line 78 "../src/db/PhotoTable.vala"
	_g_free0 (self->md5);
#line 79 "../src/db/PhotoTable.vala"
	_g_free0 (self->thumbnail_md5);
#line 80 "../src/db/PhotoTable.vala"
	_g_free0 (self->exif_md5);
#line 84 "../src/db/PhotoTable.vala"
	_g_free0 (self->title);
#line 86 "../src/db/PhotoTable.vala"
	_g_free0 (self->comment);
#line 87 "../src/db/PhotoTable.vala"
	_g_free0 (self->backlinks);
#line 96 "../src/db/PhotoTable.vala"
	self->development_ids = (g_free (self->development_ids), NULL);
#line 1311 "PhotoTable.c"
}

static GType
photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_row_init, value_photo_row_free_value, value_photo_row_copy_value, value_photo_row_peek_pointer, "p", value_photo_row_collect_value, "p", value_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoRow), 0, (GInstanceInitFunc) photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_row_type_id;
	photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return photo_row_type_id;
}

GType
photo_row_get_type (void)
{
	static volatile gsize photo_row_type_id__once = 0;
	if (g_once_init_enter (&photo_row_type_id__once)) {
		GType photo_row_type_id;
		photo_row_type_id = photo_row_get_type_once ();
		g_once_init_leave (&photo_row_type_id__once, photo_row_type_id);
	}
	return photo_row_type_id__once;
}

gpointer
photo_row_ref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 70 "../src/db/PhotoTable.vala"
	return instance;
#line 1346 "PhotoTable.c"
}

void
photo_row_unref (gpointer instance)
{
	PhotoRow * self;
	self = instance;
#line 70 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 70 "../src/db/PhotoTable.vala"
		PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 70 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1360 "PhotoTable.c"
	}
}

static PhotoTable*
photo_table_construct (GType object_type)
{
	PhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* stmt2 = NULL;
	gint res2 = 0;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3* _tmp12_;
	sqlite3_stmt* _tmp13_ = NULL;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	sqlite3* _tmp16_;
	sqlite3_stmt* _tmp17_ = NULL;
	gint _tmp18_;
	sqlite3_stmt* _tmp19_;
	sqlite3* _tmp20_;
	sqlite3_stmt* _tmp21_ = NULL;
	gint _tmp22_;
	sqlite3_stmt* _tmp23_;
#line 115 "../src/db/PhotoTable.vala"
	self = (PhotoTable*) database_table_construct (object_type);
#line 117 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 117 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS PhotoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "orientation INTEGER, " "original_orientation INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "transformations TEXT, " "md5 TEXT, " "thumbnail_md5 TEXT, " "exif_md5 TEXT, " "time_created INTEGER, " "flags INTEGER DEFAULT 0, " "rating INTEGER DEFAULT 0, " "file_format INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "editable_id INTEGER DEFAULT -1, " "metadata_dirty INTEGER DEFAULT 0, " "developer TEXT, " "develop_shotwell_id INTEGER DEFAULT -1, " "develop_camera_id INTEGER DEFAULT -1, " "develop_embedded_id INTEGER DEFAULT -1, " "has_gps INTEGER DEFAULT -1, " "gps_lat REAL, " "gps_lon REAL, " "comment TEXT" ")", -1, &_tmp1_, NULL);
#line 117 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 117 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 117 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 151 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 153 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 153 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 154 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 155 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res);
#line 1418 "PhotoTable.c"
	}
#line 159 "../src/db/PhotoTable.vala"
	_tmp4_ = database_table_db;
#line 159 "../src/db/PhotoTable.vala"
	_tmp6_ = sqlite3_prepare_v2 (_tmp4_, "CREATE INDEX IF NOT EXISTS PhotoEventIDIndex ON PhotoTable (event_id)", -1, &_tmp5_, NULL);
#line 159 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 159 "../src/db/PhotoTable.vala"
	stmt2 = _tmp5_;
#line 159 "../src/db/PhotoTable.vala"
	res2 = _tmp6_;
#line 161 "../src/db/PhotoTable.vala"
	_vala_assert (res2 == SQLITE_OK, "res2 == Sqlite.OK");
#line 163 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt2;
#line 163 "../src/db/PhotoTable.vala"
	res2 = sqlite3_step (_tmp7_);
#line 164 "../src/db/PhotoTable.vala"
	if (res2 != SQLITE_DONE) {
#line 165 "../src/db/PhotoTable.vala"
		database_table_fatal ("create photo table", res2);
#line 1440 "PhotoTable.c"
	}
#line 171 "../src/db/PhotoTable.vala"
	_tmp8_ = database_table_db;
#line 171 "../src/db/PhotoTable.vala"
	_tmp10_ = sqlite3_prepare_v2 (_tmp8_, "DROP INDEX IF EXISTS PhotoTableMD5Format", -1, &_tmp9_, NULL);
#line 171 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 171 "../src/db/PhotoTable.vala"
	stmt = _tmp9_;
#line 171 "../src/db/PhotoTable.vala"
	res = _tmp10_;
#line 172 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 173 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 173 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp11_);
#line 174 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 175 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to drop old PhotoTable index", res);
#line 1462 "PhotoTable.c"
	}
#line 178 "../src/db/PhotoTable.vala"
	_tmp12_ = database_table_db;
#line 178 "../src/db/PhotoTable.vala"
	_tmp14_ = sqlite3_prepare_v2 (_tmp12_, "CREATE INDEX IF NOT EXISTS PhotoTableMD5FormatV2 on PhotoTable(md5, fi" \
"le_format)", -1, &_tmp13_, NULL);
#line 178 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 178 "../src/db/PhotoTable.vala"
	stmt = _tmp13_;
#line 178 "../src/db/PhotoTable.vala"
	res = _tmp14_;
#line 179 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 180 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 180 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp15_);
#line 181 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 182 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", res);
#line 1484 "PhotoTable.c"
	}
#line 186 "../src/db/PhotoTable.vala"
	_tmp16_ = database_table_db;
#line 186 "../src/db/PhotoTable.vala"
	_tmp18_ = sqlite3_prepare_v2 (_tmp16_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5Format on PhotoTable(" \
"thumbnail_md5, file_format)", -1, &_tmp17_, NULL);
#line 186 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 186 "../src/db/PhotoTable.vala"
	stmt = _tmp17_;
#line 186 "../src/db/PhotoTable.vala"
	res = _tmp18_;
#line 187 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 188 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 188 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp19_);
#line 189 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 190 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on md5 and file_format", res);
#line 1506 "PhotoTable.c"
	}
#line 194 "../src/db/PhotoTable.vala"
	_tmp20_ = database_table_db;
#line 194 "../src/db/PhotoTable.vala"
	_tmp22_ = sqlite3_prepare_v2 (_tmp20_, "CREATE INDEX IF NOT EXISTS PhotoTableThumbnailMD5MD5 on PhotoTable(thu" \
"mbnail_md5, md5)", -1, &_tmp21_, NULL);
#line 194 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 194 "../src/db/PhotoTable.vala"
	stmt = _tmp21_;
#line 194 "../src/db/PhotoTable.vala"
	res = _tmp22_;
#line 195 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 196 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 196 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp23_);
#line 197 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 198 "../src/db/PhotoTable.vala"
		database_table_warning ("Failed to create index on thumbnail_md5 and md5", res);
#line 1528 "PhotoTable.c"
	}
#line 201 "../src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "PhotoTable");
#line 115 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 115 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 115 "../src/db/PhotoTable.vala"
	return self;
#line 1538 "PhotoTable.c"
}

static PhotoTable*
photo_table_new (void)
{
#line 115 "../src/db/PhotoTable.vala"
	return photo_table_construct (TYPE_PHOTO_TABLE);
#line 1546 "PhotoTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 208 "../src/db/PhotoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 1554 "PhotoTable.c"
}

PhotoTable*
photo_table_get_instance (void)
{
	PhotoTable* _tmp0_;
	PhotoTable* _tmp2_;
	PhotoTable* _tmp3_;
	PhotoTable* result;
#line 205 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_instance;
#line 205 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 1568 "PhotoTable.c"
		PhotoTable* _tmp1_;
#line 206 "../src/db/PhotoTable.vala"
		_tmp1_ = photo_table_new ();
#line 206 "../src/db/PhotoTable.vala"
		_database_table_unref0 (photo_table_instance);
#line 206 "../src/db/PhotoTable.vala"
		photo_table_instance = _tmp1_;
#line 1576 "PhotoTable.c"
	}
#line 208 "../src/db/PhotoTable.vala"
	_tmp2_ = photo_table_instance;
#line 208 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 208 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 208 "../src/db/PhotoTable.vala"
	return result;
#line 1586 "PhotoTable.c"
}

void
photo_table_add (PhotoTable* self,
                 PhotoRow* photo_row,
                 PhotoID* result)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	BackingPhotoRow* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	BackingPhotoRow* _tmp9_;
	Dimensions _tmp10_;
	sqlite3_stmt* _tmp11_;
	BackingPhotoRow* _tmp12_;
	Dimensions _tmp13_;
	sqlite3_stmt* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	GDateTime* _tmp18_;
	GDateTime* _tmp19_;
	sqlite3_stmt* _tmp23_;
	BackingPhotoRow* _tmp24_;
	sqlite3_stmt* _tmp25_;
	BackingPhotoRow* _tmp26_;
	sqlite3_stmt* _tmp27_;
	ImportID _tmp28_;
	sqlite3_stmt* _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GDestroyNotify _tmp33_;
	sqlite3_stmt* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	GDestroyNotify _tmp37_;
	sqlite3_stmt* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GDestroyNotify _tmp41_;
	sqlite3_stmt* _tmp42_;
	sqlite3_stmt* _tmp43_;
	BackingPhotoRow* _tmp44_;
	sqlite3_stmt* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	GDestroyNotify _tmp48_;
	sqlite3_stmt* _tmp49_;
	sqlite3_stmt* _tmp50_;
	sqlite3_stmt* _tmp51_;
	gchar* _tmp52_;
	GDestroyNotify _tmp53_;
	sqlite3_stmt* _tmp54_;
	GpsCoords _tmp55_;
	sqlite3_stmt* _tmp56_;
	GpsCoords _tmp57_;
	sqlite3_stmt* _tmp58_;
	GpsCoords _tmp59_;
	sqlite3_stmt* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	GDestroyNotify _tmp63_;
	sqlite3_stmt* _tmp64_;
	sqlite3* _tmp66_;
	BackingPhotoRow* _tmp67_;
	PhotoID _tmp68_;
#line 213 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 213 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (photo_row));
#line 215 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 215 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO PhotoTable (filename, width, height, filesize, timestamp, " \
"exposure_time, " "orientation, original_orientation, import_id, event_id, md5, thumbnail" \
"_md5, " "exif_md5, time_created, file_format, title, rating, editable_id, devel" \
"oper, has_gps, gps_lat, gps_lon, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?)", -1, &_tmp1_, NULL);
#line 215 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 215 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 215 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 221 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 223 "../src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 225 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 225 "../src/db/PhotoTable.vala"
	_tmp4_ = photo_row->master;
#line 225 "../src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_->filepath;
#line 225 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 225 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 225 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp6_, -1, _tmp7_);
#line 226 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 227 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 227 "../src/db/PhotoTable.vala"
	_tmp9_ = photo_row->master;
#line 227 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->dim;
#line 227 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 2, _tmp10_.width);
#line 228 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 229 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 229 "../src/db/PhotoTable.vala"
	_tmp12_ = photo_row->master;
#line 229 "../src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->dim;
#line 229 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 3, _tmp13_.height);
#line 230 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 231 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 231 "../src/db/PhotoTable.vala"
	_tmp15_ = photo_row->master;
#line 231 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 4, _tmp15_->filesize);
#line 232 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 233 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 233 "../src/db/PhotoTable.vala"
	_tmp17_ = photo_row->master;
#line 233 "../src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_->timestamp;
#line 233 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp16_, 5, g_date_time_to_unix (_tmp18_));
#line 234 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 235 "../src/db/PhotoTable.vala"
	_tmp19_ = photo_row->exposure_time;
#line 235 "../src/db/PhotoTable.vala"
	if (_tmp19_ == NULL) {
#line 1736 "PhotoTable.c"
		sqlite3_stmt* _tmp20_;
#line 236 "../src/db/PhotoTable.vala"
		_tmp20_ = stmt;
#line 236 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_null (_tmp20_, 6);
#line 1742 "PhotoTable.c"
	} else {
		sqlite3_stmt* _tmp21_;
		GDateTime* _tmp22_;
#line 238 "../src/db/PhotoTable.vala"
		_tmp21_ = stmt;
#line 238 "../src/db/PhotoTable.vala"
		_tmp22_ = photo_row->exposure_time;
#line 238 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_int64 (_tmp21_, 6, g_date_time_to_unix (_tmp22_));
#line 1752 "PhotoTable.c"
	}
#line 240 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 241 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 241 "../src/db/PhotoTable.vala"
	_tmp24_ = photo_row->master;
#line 241 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp23_, 7, (gint) _tmp24_->original_orientation);
#line 242 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 243 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 243 "../src/db/PhotoTable.vala"
	_tmp26_ = photo_row->master;
#line 243 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp25_, 8, (gint) _tmp26_->original_orientation);
#line 244 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 245 "../src/db/PhotoTable.vala"
	_tmp27_ = stmt;
#line 245 "../src/db/PhotoTable.vala"
	_tmp28_ = photo_row->import_id;
#line 245 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp27_, 9, _tmp28_.id);
#line 246 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 247 "../src/db/PhotoTable.vala"
	_tmp29_ = stmt;
#line 247 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp29_, 10, EVENT_ID_INVALID);
#line 248 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 249 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 249 "../src/db/PhotoTable.vala"
	_tmp31_ = photo_row->md5;
#line 249 "../src/db/PhotoTable.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 249 "../src/db/PhotoTable.vala"
	_tmp33_ = g_free;
#line 249 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp30_, 11, _tmp32_, -1, _tmp33_);
#line 250 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 251 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 251 "../src/db/PhotoTable.vala"
	_tmp35_ = photo_row->thumbnail_md5;
#line 251 "../src/db/PhotoTable.vala"
	_tmp36_ = g_strdup (_tmp35_);
#line 251 "../src/db/PhotoTable.vala"
	_tmp37_ = g_free;
#line 251 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp34_, 12, _tmp36_, -1, _tmp37_);
#line 252 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 253 "../src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 253 "../src/db/PhotoTable.vala"
	_tmp39_ = photo_row->exif_md5;
#line 253 "../src/db/PhotoTable.vala"
	_tmp40_ = g_strdup (_tmp39_);
#line 253 "../src/db/PhotoTable.vala"
	_tmp41_ = g_free;
#line 253 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp38_, 13, _tmp40_, -1, _tmp41_);
#line 254 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 255 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 255 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp42_, 14, time_created);
#line 256 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 257 "../src/db/PhotoTable.vala"
	_tmp43_ = stmt;
#line 257 "../src/db/PhotoTable.vala"
	_tmp44_ = photo_row->master;
#line 257 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp43_, 15, photo_file_format_serialize (_tmp44_->file_format));
#line 258 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 259 "../src/db/PhotoTable.vala"
	_tmp45_ = stmt;
#line 259 "../src/db/PhotoTable.vala"
	_tmp46_ = photo_row->title;
#line 259 "../src/db/PhotoTable.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 259 "../src/db/PhotoTable.vala"
	_tmp48_ = g_free;
#line 259 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp45_, 16, _tmp47_, -1, _tmp48_);
#line 260 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 261 "../src/db/PhotoTable.vala"
	_tmp49_ = stmt;
#line 261 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp49_, 17, (gint64) rating_serialize (photo_row->rating));
#line 262 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 263 "../src/db/PhotoTable.vala"
	_tmp50_ = stmt;
#line 263 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp50_, 18, BACKING_PHOTO_ID_INVALID);
#line 264 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 265 "../src/db/PhotoTable.vala"
	_tmp51_ = stmt;
#line 265 "../src/db/PhotoTable.vala"
	_tmp52_ = raw_developer_to_string (photo_row->developer);
#line 265 "../src/db/PhotoTable.vala"
	_tmp53_ = g_free;
#line 265 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp51_, 19, _tmp52_, -1, _tmp53_);
#line 266 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 267 "../src/db/PhotoTable.vala"
	_tmp54_ = stmt;
#line 267 "../src/db/PhotoTable.vala"
	_tmp55_ = photo_row->gps_coords;
#line 267 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp54_, 20, _tmp55_.has_gps);
#line 268 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 269 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 269 "../src/db/PhotoTable.vala"
	_tmp57_ = photo_row->gps_coords;
#line 269 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp56_, 21, _tmp57_.latitude);
#line 270 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 271 "../src/db/PhotoTable.vala"
	_tmp58_ = stmt;
#line 271 "../src/db/PhotoTable.vala"
	_tmp59_ = photo_row->gps_coords;
#line 271 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp58_, 22, _tmp59_.longitude);
#line 272 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 273 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 273 "../src/db/PhotoTable.vala"
	_tmp61_ = photo_row->comment;
#line 273 "../src/db/PhotoTable.vala"
	_tmp62_ = g_strdup (_tmp61_);
#line 273 "../src/db/PhotoTable.vala"
	_tmp63_ = g_free;
#line 273 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp60_, 23, _tmp62_, -1, _tmp63_);
#line 274 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 276 "../src/db/PhotoTable.vala"
	_tmp64_ = stmt;
#line 276 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp64_);
#line 277 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1912 "PhotoTable.c"
		PhotoID _tmp65_ = {0};
#line 278 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 279 "../src/db/PhotoTable.vala"
			database_table_fatal ("add_photo", res);
#line 1918 "PhotoTable.c"
		}
#line 281 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp65_, PHOTO_ID_INVALID);
#line 281 "../src/db/PhotoTable.vala"
		*result = _tmp65_;
#line 281 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 281 "../src/db/PhotoTable.vala"
		return;
#line 1928 "PhotoTable.c"
	}
#line 285 "../src/db/PhotoTable.vala"
	_tmp66_ = database_table_db;
#line 285 "../src/db/PhotoTable.vala"
	photo_id_init (&photo_row->photo_id, sqlite3_last_insert_rowid (_tmp66_));
#line 286 "../src/db/PhotoTable.vala"
	_tmp67_ = photo_row->master;
#line 286 "../src/db/PhotoTable.vala"
	photo_row->orientation = _tmp67_->original_orientation;
#line 287 "../src/db/PhotoTable.vala"
	event_id_init (&photo_row->event_id, EVENT_ID_INVALID);
#line 288 "../src/db/PhotoTable.vala"
	photo_row->time_created = time_created;
#line 289 "../src/db/PhotoTable.vala"
	photo_row->flags = (guint64) 0;
#line 291 "../src/db/PhotoTable.vala"
	_tmp68_ = photo_row->photo_id;
#line 291 "../src/db/PhotoTable.vala"
	*result = _tmp68_;
#line 291 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 291 "../src/db/PhotoTable.vala"
	return;
#line 1952 "PhotoTable.c"
}

void
photo_table_reimport (PhotoTable* self,
                      PhotoRow* row,
                      GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_reimported = 0LL;
	sqlite3_stmt* _tmp3_;
	BackingPhotoRow* _tmp4_;
	Dimensions _tmp5_;
	sqlite3_stmt* _tmp6_;
	BackingPhotoRow* _tmp7_;
	Dimensions _tmp8_;
	sqlite3_stmt* _tmp9_;
	BackingPhotoRow* _tmp10_;
	sqlite3_stmt* _tmp11_;
	BackingPhotoRow* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	sqlite3_stmt* _tmp18_;
	BackingPhotoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	BackingPhotoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	GDestroyNotify _tmp25_;
	sqlite3_stmt* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GDestroyNotify _tmp29_;
	sqlite3_stmt* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	GDestroyNotify _tmp33_;
	sqlite3_stmt* _tmp34_;
	BackingPhotoRow* _tmp35_;
	sqlite3_stmt* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	GDestroyNotify _tmp39_;
	sqlite3_stmt* _tmp40_;
	GpsCoords _tmp41_;
	sqlite3_stmt* _tmp42_;
	GpsCoords _tmp43_;
	sqlite3_stmt* _tmp44_;
	GpsCoords _tmp45_;
	sqlite3_stmt* _tmp46_;
	sqlite3_stmt* _tmp47_;
	PhotoID _tmp48_;
	sqlite3_stmt* _tmp49_;
	BackingPhotoRow* _tmp50_;
	GError* _inner_error0_ = NULL;
#line 299 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 299 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 301 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 301 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET width = ?, height = ?, filesize = ?, timestamp =" \
" ?, " "exposure_time = ?, orientation = ?, original_orientation = ?, md5 = ?," \
" " "exif_md5 = ?, thumbnail_md5 = ?, file_format = ?, title = ?, " "has_gps = ?, gps_lat = ?, gps_lon = ?, time_reimported = ? " "WHERE id = ?", -1, &_tmp1_, NULL);
#line 301 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 301 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 301 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 307 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 309 "../src/db/PhotoTable.vala"
	time_reimported = now_sec ();
#line 311 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 311 "../src/db/PhotoTable.vala"
	_tmp4_ = row->master;
#line 311 "../src/db/PhotoTable.vala"
	_tmp5_ = _tmp4_->dim;
#line 311 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp3_, 1, _tmp5_.width);
#line 312 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 313 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 313 "../src/db/PhotoTable.vala"
	_tmp7_ = row->master;
#line 313 "../src/db/PhotoTable.vala"
	_tmp8_ = _tmp7_->dim;
#line 313 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp6_, 2, _tmp8_.height);
#line 314 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 315 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 315 "../src/db/PhotoTable.vala"
	_tmp10_ = row->master;
#line 315 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp9_, 3, _tmp10_->filesize);
#line 316 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 317 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 317 "../src/db/PhotoTable.vala"
	_tmp12_ = row->master;
#line 317 "../src/db/PhotoTable.vala"
	_tmp13_ = _tmp12_->timestamp;
#line 317 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp11_, 4, g_date_time_to_unix (_tmp13_));
#line 318 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 319 "../src/db/PhotoTable.vala"
	_tmp14_ = row->exposure_time;
#line 319 "../src/db/PhotoTable.vala"
	if (_tmp14_ == NULL) {
#line 2072 "PhotoTable.c"
		sqlite3_stmt* _tmp15_;
#line 320 "../src/db/PhotoTable.vala"
		_tmp15_ = stmt;
#line 320 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_null (_tmp15_, 5);
#line 2078 "PhotoTable.c"
	} else {
		sqlite3_stmt* _tmp16_;
		GDateTime* _tmp17_;
#line 322 "../src/db/PhotoTable.vala"
		_tmp16_ = stmt;
#line 322 "../src/db/PhotoTable.vala"
		_tmp17_ = row->exposure_time;
#line 322 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_int64 (_tmp16_, 5, g_date_time_to_unix (_tmp17_));
#line 2088 "PhotoTable.c"
	}
#line 324 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 325 "../src/db/PhotoTable.vala"
	_tmp18_ = stmt;
#line 325 "../src/db/PhotoTable.vala"
	_tmp19_ = row->master;
#line 325 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp18_, 6, (gint) _tmp19_->original_orientation);
#line 326 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 327 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 327 "../src/db/PhotoTable.vala"
	_tmp21_ = row->master;
#line 327 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp20_, 7, (gint) _tmp21_->original_orientation);
#line 328 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 329 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 329 "../src/db/PhotoTable.vala"
	_tmp23_ = row->md5;
#line 329 "../src/db/PhotoTable.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 329 "../src/db/PhotoTable.vala"
	_tmp25_ = g_free;
#line 329 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp22_, 8, _tmp24_, -1, _tmp25_);
#line 330 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 331 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 331 "../src/db/PhotoTable.vala"
	_tmp27_ = row->exif_md5;
#line 331 "../src/db/PhotoTable.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 331 "../src/db/PhotoTable.vala"
	_tmp29_ = g_free;
#line 331 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp26_, 9, _tmp28_, -1, _tmp29_);
#line 332 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 333 "../src/db/PhotoTable.vala"
	_tmp30_ = stmt;
#line 333 "../src/db/PhotoTable.vala"
	_tmp31_ = row->thumbnail_md5;
#line 333 "../src/db/PhotoTable.vala"
	_tmp32_ = g_strdup (_tmp31_);
#line 333 "../src/db/PhotoTable.vala"
	_tmp33_ = g_free;
#line 333 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp30_, 10, _tmp32_, -1, _tmp33_);
#line 334 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 335 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 335 "../src/db/PhotoTable.vala"
	_tmp35_ = row->master;
#line 335 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp34_, 11, photo_file_format_serialize (_tmp35_->file_format));
#line 336 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 337 "../src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 337 "../src/db/PhotoTable.vala"
	_tmp37_ = row->title;
#line 337 "../src/db/PhotoTable.vala"
	_tmp38_ = g_strdup (_tmp37_);
#line 337 "../src/db/PhotoTable.vala"
	_tmp39_ = g_free;
#line 337 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp36_, 12, _tmp38_, -1, _tmp39_);
#line 338 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 339 "../src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 339 "../src/db/PhotoTable.vala"
	_tmp41_ = row->gps_coords;
#line 339 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp40_, 13, _tmp41_.has_gps);
#line 340 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 341 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 341 "../src/db/PhotoTable.vala"
	_tmp43_ = row->gps_coords;
#line 341 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp42_, 14, _tmp43_.latitude);
#line 342 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 343 "../src/db/PhotoTable.vala"
	_tmp44_ = stmt;
#line 343 "../src/db/PhotoTable.vala"
	_tmp45_ = row->gps_coords;
#line 343 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp44_, 15, _tmp45_.longitude);
#line 344 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 345 "../src/db/PhotoTable.vala"
	_tmp46_ = stmt;
#line 345 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp46_, 16, time_reimported);
#line 346 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 347 "../src/db/PhotoTable.vala"
	_tmp47_ = stmt;
#line 347 "../src/db/PhotoTable.vala"
	_tmp48_ = row->photo_id;
#line 347 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp47_, 17, _tmp48_.id);
#line 348 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 350 "../src/db/PhotoTable.vala"
	_tmp49_ = stmt;
#line 350 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp49_);
#line 351 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 352 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoTable.reimport_master", res, &_inner_error0_);
#line 352 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 352 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 352 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 352 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 352 "../src/db/PhotoTable.vala"
				return;
#line 2220 "PhotoTable.c"
			} else {
#line 352 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 352 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 352 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 352 "../src/db/PhotoTable.vala"
				return;
#line 2230 "PhotoTable.c"
			}
		}
	}
#line 354 "../src/db/PhotoTable.vala"
	row->time_reimported = time_reimported;
#line 355 "../src/db/PhotoTable.vala"
	_tmp50_ = row->master;
#line 355 "../src/db/PhotoTable.vala"
	row->orientation = _tmp50_->original_orientation;
#line 299 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2242 "PhotoTable.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 388 "../src/db/PhotoTable.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 2250 "PhotoTable.c"
}

gboolean
photo_table_master_exif_updated (PhotoTable* self,
                                 PhotoID* photoID,
                                 gint64 filesize,
                                 GDateTime* timestamp,
                                 const gchar* md5,
                                 const gchar* exif_md5,
                                 const gchar* thumbnail_md5,
                                 PhotoRow* row)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	sqlite3_stmt* _tmp11_;
	gchar* _tmp12_;
	GDestroyNotify _tmp13_;
	sqlite3_stmt* _tmp14_;
	PhotoID _tmp15_;
	sqlite3_stmt* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	GDateTime* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gboolean result;
#line 358 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 358 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photoID != NULL, FALSE);
#line 358 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (timestamp != NULL, FALSE);
#line 358 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (md5 != NULL, FALSE);
#line 358 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_ROW (row), FALSE);
#line 361 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 361 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET filesize = ?, timestamp = ?, md5 = ?, exif_md5 =" \
" ?," "thumbnail_md5 =? WHERE id = ?", -1, &_tmp1_, NULL);
#line 361 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 361 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 361 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 364 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 366 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 366 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, filesize);
#line 367 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 368 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 368 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, g_date_time_to_unix (timestamp));
#line 369 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 370 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 370 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (md5);
#line 370 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 370 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp5_, 3, _tmp6_, -1, _tmp7_);
#line 371 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 372 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 372 "../src/db/PhotoTable.vala"
	_tmp9_ = g_strdup (exif_md5);
#line 372 "../src/db/PhotoTable.vala"
	_tmp10_ = g_free;
#line 372 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp8_, 4, _tmp9_, -1, _tmp10_);
#line 373 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 374 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 374 "../src/db/PhotoTable.vala"
	_tmp12_ = g_strdup (thumbnail_md5);
#line 374 "../src/db/PhotoTable.vala"
	_tmp13_ = g_free;
#line 374 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp11_, 5, _tmp12_, -1, _tmp13_);
#line 375 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 376 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 376 "../src/db/PhotoTable.vala"
	_tmp15_ = *photoID;
#line 376 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp14_, 6, _tmp15_.id);
#line 377 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 379 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 379 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp16_);
#line 380 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 381 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 382 "../src/db/PhotoTable.vala"
			database_table_fatal ("write_update_photo", res);
#line 2371 "PhotoTable.c"
		}
#line 384 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 384 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 384 "../src/db/PhotoTable.vala"
		return result;
#line 2379 "PhotoTable.c"
	}
#line 387 "../src/db/PhotoTable.vala"
	_tmp17_ = row->master;
#line 387 "../src/db/PhotoTable.vala"
	_tmp17_->filesize = filesize;
#line 388 "../src/db/PhotoTable.vala"
	_tmp18_ = row->master;
#line 388 "../src/db/PhotoTable.vala"
	_tmp19_ = _g_date_time_ref0 (timestamp);
#line 388 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp18_->timestamp);
#line 388 "../src/db/PhotoTable.vala"
	_tmp18_->timestamp = _tmp19_;
#line 389 "../src/db/PhotoTable.vala"
	_tmp20_ = g_strdup (md5);
#line 389 "../src/db/PhotoTable.vala"
	_g_free0 (row->md5);
#line 389 "../src/db/PhotoTable.vala"
	row->md5 = _tmp20_;
#line 390 "../src/db/PhotoTable.vala"
	_tmp21_ = g_strdup (exif_md5);
#line 390 "../src/db/PhotoTable.vala"
	_g_free0 (row->exif_md5);
#line 390 "../src/db/PhotoTable.vala"
	row->exif_md5 = _tmp21_;
#line 391 "../src/db/PhotoTable.vala"
	_tmp22_ = g_strdup (thumbnail_md5);
#line 391 "../src/db/PhotoTable.vala"
	_g_free0 (row->thumbnail_md5);
#line 391 "../src/db/PhotoTable.vala"
	row->thumbnail_md5 = _tmp22_;
#line 393 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 393 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 393 "../src/db/PhotoTable.vala"
	return result;
#line 2417 "PhotoTable.c"
}

static void
photo_table_validate_orientation (PhotoTable* self,
                                  PhotoRow* row)
{
	gboolean _tmp0_ = FALSE;
#line 404 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 404 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 405 "../src/db/PhotoTable.vala"
	if (row->orientation < ORIENTATION_MIN) {
#line 405 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 2433 "PhotoTable.c"
	} else {
#line 406 "../src/db/PhotoTable.vala"
		_tmp0_ = row->orientation > ORIENTATION_MAX;
#line 2437 "PhotoTable.c"
	}
#line 405 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 2441 "PhotoTable.c"
		PhotoID _tmp1_;
#line 408 "../src/db/PhotoTable.vala"
		_tmp1_ = row->photo_id;
#line 408 "../src/db/PhotoTable.vala"
		photo_table_set_orientation (self, &_tmp1_, ORIENTATION_MIN);
#line 409 "../src/db/PhotoTable.vala"
		row->orientation = ORIENTATION_MIN;
#line 2449 "PhotoTable.c"
	}
}

PhotoRow*
photo_table_get_row (PhotoTable* self,
                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	PhotoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	PhotoRow* row = NULL;
	PhotoRow* _tmp6_;
	PhotoRow* _tmp7_;
	PhotoID _tmp8_;
	PhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	sqlite3_stmt* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	PhotoRow* _tmp18_;
	BackingPhotoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	PhotoRow* _tmp21_;
	BackingPhotoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	GDateTime* _tmp24_;
	sqlite3_stmt* _tmp25_;
	PhotoRow* _tmp30_;
	sqlite3_stmt* _tmp31_;
	PhotoRow* _tmp32_;
	BackingPhotoRow* _tmp33_;
	sqlite3_stmt* _tmp34_;
	PhotoRow* _tmp35_;
	sqlite3_stmt* _tmp36_;
	PhotoRow* _tmp37_;
	sqlite3_stmt* _tmp38_;
	PhotoRow* _tmp39_;
	sqlite3_stmt* _tmp40_;
	const gchar* _tmp41_;
	GeeHashMap* _tmp42_;
	PhotoRow* _tmp43_;
	sqlite3_stmt* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	PhotoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	PhotoRow* _tmp51_;
	sqlite3_stmt* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	PhotoRow* _tmp55_;
	sqlite3_stmt* _tmp56_;
	PhotoRow* _tmp57_;
	sqlite3_stmt* _tmp58_;
	PhotoRow* _tmp59_;
	sqlite3_stmt* _tmp60_;
	PhotoRow* _tmp61_;
	BackingPhotoRow* _tmp62_;
	sqlite3_stmt* _tmp63_;
	PhotoRow* _tmp64_;
	sqlite3_stmt* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	PhotoRow* _tmp68_;
	sqlite3_stmt* _tmp69_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
	PhotoRow* _tmp72_;
	sqlite3_stmt* _tmp73_;
	PhotoRow* _tmp74_;
	sqlite3_stmt* _tmp75_;
	PhotoRow* _tmp76_;
	sqlite3_stmt* _tmp77_;
	RawDeveloper _tmp78_ = 0;
	sqlite3_stmt* _tmp79_;
	const gchar* _tmp80_;
	PhotoRow* _tmp83_;
	PhotoRow* _tmp84_;
	BackingPhotoID* _tmp85_;
	gint _tmp85__length1;
	sqlite3_stmt* _tmp86_;
	BackingPhotoID _tmp87_ = {0};
	PhotoRow* _tmp88_;
	BackingPhotoID* _tmp89_;
	gint _tmp89__length1;
	sqlite3_stmt* _tmp90_;
	BackingPhotoID _tmp91_ = {0};
	PhotoRow* _tmp92_;
	BackingPhotoID* _tmp93_;
	gint _tmp93__length1;
	sqlite3_stmt* _tmp94_;
	BackingPhotoID _tmp95_ = {0};
	PhotoRow* _tmp96_;
	sqlite3_stmt* _tmp97_;
	PhotoRow* _tmp98_;
	sqlite3_stmt* _tmp99_;
	PhotoRow* _tmp100_;
	sqlite3_stmt* _tmp101_;
	PhotoRow* _tmp102_;
	sqlite3_stmt* _tmp103_;
	const gchar* _tmp104_;
	gchar* _tmp105_;
	PhotoRow* result;
#line 413 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 413 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 415 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 415 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, filesize, timestamp, exposure_time, or" \
"ientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " "time_reimported, editable_id, metadata_dirty, developer, develop_shotw" \
"ell_id, " "develop_camera_id, develop_embedded_id, has_gps, gps_lat, gps_lon, com" \
"ment " "FROM PhotoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 415 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 415 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 415 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 423 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 425 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 425 "../src/db/PhotoTable.vala"
	_tmp4_ = *photo_id;
#line 425 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 426 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 428 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 428 "../src/db/PhotoTable.vala"
	if (sqlite3_step (_tmp5_) != SQLITE_ROW) {
#line 429 "../src/db/PhotoTable.vala"
		result = NULL;
#line 429 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 429 "../src/db/PhotoTable.vala"
		return result;
#line 2598 "PhotoTable.c"
	}
#line 431 "../src/db/PhotoTable.vala"
	_tmp6_ = photo_row_new ();
#line 431 "../src/db/PhotoTable.vala"
	row = _tmp6_;
#line 432 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 432 "../src/db/PhotoTable.vala"
	_tmp8_ = *photo_id;
#line 432 "../src/db/PhotoTable.vala"
	_tmp7_->photo_id = _tmp8_;
#line 433 "../src/db/PhotoTable.vala"
	_tmp9_ = row;
#line 433 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->master;
#line 433 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 433 "../src/db/PhotoTable.vala"
	_tmp12_ = (const gchar*) sqlite3_column_text (_tmp11_, 0);
#line 433 "../src/db/PhotoTable.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 433 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp10_->filepath);
#line 433 "../src/db/PhotoTable.vala"
	_tmp10_->filepath = _tmp13_;
#line 434 "../src/db/PhotoTable.vala"
	_tmp14_ = row;
#line 434 "../src/db/PhotoTable.vala"
	_tmp15_ = _tmp14_->master;
#line 434 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 434 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 434 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp15_->dim, sqlite3_column_int (_tmp16_, 1), sqlite3_column_int (_tmp17_, 2));
#line 435 "../src/db/PhotoTable.vala"
	_tmp18_ = row;
#line 435 "../src/db/PhotoTable.vala"
	_tmp19_ = _tmp18_->master;
#line 435 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 435 "../src/db/PhotoTable.vala"
	_tmp19_->filesize = sqlite3_column_int64 (_tmp20_, 3);
#line 436 "../src/db/PhotoTable.vala"
	_tmp21_ = row;
#line 436 "../src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_->master;
#line 436 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 436 "../src/db/PhotoTable.vala"
	_tmp24_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp23_, 4));
#line 436 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp22_->timestamp);
#line 436 "../src/db/PhotoTable.vala"
	_tmp22_->timestamp = _tmp24_;
#line 437 "../src/db/PhotoTable.vala"
	_tmp25_ = stmt;
#line 437 "../src/db/PhotoTable.vala"
	if (sqlite3_column_type (_tmp25_, 5) == SQLITE_NULL) {
#line 2658 "PhotoTable.c"
		PhotoRow* _tmp26_;
#line 438 "../src/db/PhotoTable.vala"
		_tmp26_ = row;
#line 438 "../src/db/PhotoTable.vala"
		_g_date_time_unref0 (_tmp26_->exposure_time);
#line 438 "../src/db/PhotoTable.vala"
		_tmp26_->exposure_time = NULL;
#line 2666 "PhotoTable.c"
	} else {
		PhotoRow* _tmp27_;
		sqlite3_stmt* _tmp28_;
		GDateTime* _tmp29_;
#line 440 "../src/db/PhotoTable.vala"
		_tmp27_ = row;
#line 440 "../src/db/PhotoTable.vala"
		_tmp28_ = stmt;
#line 440 "../src/db/PhotoTable.vala"
		_tmp29_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp28_, 5));
#line 440 "../src/db/PhotoTable.vala"
		_g_date_time_unref0 (_tmp27_->exposure_time);
#line 440 "../src/db/PhotoTable.vala"
		_tmp27_->exposure_time = _tmp29_;
#line 2681 "PhotoTable.c"
	}
#line 442 "../src/db/PhotoTable.vala"
	_tmp30_ = row;
#line 442 "../src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 442 "../src/db/PhotoTable.vala"
	_tmp30_->orientation = (Orientation) sqlite3_column_int (_tmp31_, 6);
#line 443 "../src/db/PhotoTable.vala"
	_tmp32_ = row;
#line 443 "../src/db/PhotoTable.vala"
	_tmp33_ = _tmp32_->master;
#line 443 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 443 "../src/db/PhotoTable.vala"
	_tmp33_->original_orientation = (Orientation) sqlite3_column_int (_tmp34_, 7);
#line 444 "../src/db/PhotoTable.vala"
	_tmp35_ = row;
#line 444 "../src/db/PhotoTable.vala"
	_tmp36_ = stmt;
#line 444 "../src/db/PhotoTable.vala"
	_tmp35_->import_id.id = sqlite3_column_int64 (_tmp36_, 8);
#line 445 "../src/db/PhotoTable.vala"
	_tmp37_ = row;
#line 445 "../src/db/PhotoTable.vala"
	_tmp38_ = stmt;
#line 445 "../src/db/PhotoTable.vala"
	_tmp37_->event_id.id = sqlite3_column_int64 (_tmp38_, 9);
#line 446 "../src/db/PhotoTable.vala"
	_tmp39_ = row;
#line 446 "../src/db/PhotoTable.vala"
	_tmp40_ = stmt;
#line 446 "../src/db/PhotoTable.vala"
	_tmp41_ = (const gchar*) sqlite3_column_text (_tmp40_, 10);
#line 446 "../src/db/PhotoTable.vala"
	_tmp42_ = photo_table_marshall_all_transformations (_tmp41_);
#line 446 "../src/db/PhotoTable.vala"
	_g_object_unref0 (_tmp39_->transformations);
#line 446 "../src/db/PhotoTable.vala"
	_tmp39_->transformations = _tmp42_;
#line 447 "../src/db/PhotoTable.vala"
	_tmp43_ = row;
#line 447 "../src/db/PhotoTable.vala"
	_tmp44_ = stmt;
#line 447 "../src/db/PhotoTable.vala"
	_tmp45_ = (const gchar*) sqlite3_column_text (_tmp44_, 11);
#line 447 "../src/db/PhotoTable.vala"
	_tmp46_ = g_strdup (_tmp45_);
#line 447 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp43_->md5);
#line 447 "../src/db/PhotoTable.vala"
	_tmp43_->md5 = _tmp46_;
#line 448 "../src/db/PhotoTable.vala"
	_tmp47_ = row;
#line 448 "../src/db/PhotoTable.vala"
	_tmp48_ = stmt;
#line 448 "../src/db/PhotoTable.vala"
	_tmp49_ = (const gchar*) sqlite3_column_text (_tmp48_, 12);
#line 448 "../src/db/PhotoTable.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 448 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp47_->thumbnail_md5);
#line 448 "../src/db/PhotoTable.vala"
	_tmp47_->thumbnail_md5 = _tmp50_;
#line 449 "../src/db/PhotoTable.vala"
	_tmp51_ = row;
#line 449 "../src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 449 "../src/db/PhotoTable.vala"
	_tmp53_ = (const gchar*) sqlite3_column_text (_tmp52_, 13);
#line 449 "../src/db/PhotoTable.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 449 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp51_->exif_md5);
#line 449 "../src/db/PhotoTable.vala"
	_tmp51_->exif_md5 = _tmp54_;
#line 450 "../src/db/PhotoTable.vala"
	_tmp55_ = row;
#line 450 "../src/db/PhotoTable.vala"
	_tmp56_ = stmt;
#line 450 "../src/db/PhotoTable.vala"
	_tmp55_->time_created = sqlite3_column_int64 (_tmp56_, 14);
#line 451 "../src/db/PhotoTable.vala"
	_tmp57_ = row;
#line 451 "../src/db/PhotoTable.vala"
	_tmp58_ = stmt;
#line 451 "../src/db/PhotoTable.vala"
	_tmp57_->flags = (guint64) sqlite3_column_int64 (_tmp58_, 15);
#line 452 "../src/db/PhotoTable.vala"
	_tmp59_ = row;
#line 452 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 452 "../src/db/PhotoTable.vala"
	_tmp59_->rating = rating_unserialize (sqlite3_column_int (_tmp60_, 16));
#line 453 "../src/db/PhotoTable.vala"
	_tmp61_ = row;
#line 453 "../src/db/PhotoTable.vala"
	_tmp62_ = _tmp61_->master;
#line 453 "../src/db/PhotoTable.vala"
	_tmp63_ = stmt;
#line 453 "../src/db/PhotoTable.vala"
	_tmp62_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp63_, 17));
#line 454 "../src/db/PhotoTable.vala"
	_tmp64_ = row;
#line 454 "../src/db/PhotoTable.vala"
	_tmp65_ = stmt;
#line 454 "../src/db/PhotoTable.vala"
	_tmp66_ = (const gchar*) sqlite3_column_text (_tmp65_, 18);
#line 454 "../src/db/PhotoTable.vala"
	_tmp67_ = g_strdup (_tmp66_);
#line 454 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp64_->title);
#line 454 "../src/db/PhotoTable.vala"
	_tmp64_->title = _tmp67_;
#line 455 "../src/db/PhotoTable.vala"
	_tmp68_ = row;
#line 455 "../src/db/PhotoTable.vala"
	_tmp69_ = stmt;
#line 455 "../src/db/PhotoTable.vala"
	_tmp70_ = (const gchar*) sqlite3_column_text (_tmp69_, 19);
#line 455 "../src/db/PhotoTable.vala"
	_tmp71_ = g_strdup (_tmp70_);
#line 455 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp68_->backlinks);
#line 455 "../src/db/PhotoTable.vala"
	_tmp68_->backlinks = _tmp71_;
#line 456 "../src/db/PhotoTable.vala"
	_tmp72_ = row;
#line 456 "../src/db/PhotoTable.vala"
	_tmp73_ = stmt;
#line 456 "../src/db/PhotoTable.vala"
	_tmp72_->time_reimported = sqlite3_column_int64 (_tmp73_, 20);
#line 457 "../src/db/PhotoTable.vala"
	_tmp74_ = row;
#line 457 "../src/db/PhotoTable.vala"
	_tmp75_ = stmt;
#line 457 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp74_->editable_id, sqlite3_column_int64 (_tmp75_, 21));
#line 458 "../src/db/PhotoTable.vala"
	_tmp76_ = row;
#line 458 "../src/db/PhotoTable.vala"
	_tmp77_ = stmt;
#line 458 "../src/db/PhotoTable.vala"
	_tmp76_->metadata_dirty = sqlite3_column_int (_tmp77_, 22) != 0;
#line 459 "../src/db/PhotoTable.vala"
	_tmp79_ = stmt;
#line 459 "../src/db/PhotoTable.vala"
	_tmp80_ = (const gchar*) sqlite3_column_text (_tmp79_, 23);
#line 459 "../src/db/PhotoTable.vala"
	if (_tmp80_ != NULL) {
#line 2831 "PhotoTable.c"
		sqlite3_stmt* _tmp81_;
		const gchar* _tmp82_;
#line 459 "../src/db/PhotoTable.vala"
		_tmp81_ = stmt;
#line 459 "../src/db/PhotoTable.vala"
		_tmp82_ = (const gchar*) sqlite3_column_text (_tmp81_, 23);
#line 459 "../src/db/PhotoTable.vala"
		_tmp78_ = raw_developer_from_string (_tmp82_);
#line 2840 "PhotoTable.c"
	} else {
#line 460 "../src/db/PhotoTable.vala"
		_tmp78_ = RAW_DEVELOPER_CAMERA;
#line 2844 "PhotoTable.c"
	}
#line 459 "../src/db/PhotoTable.vala"
	_tmp83_ = row;
#line 459 "../src/db/PhotoTable.vala"
	_tmp83_->developer = _tmp78_;
#line 461 "../src/db/PhotoTable.vala"
	_tmp84_ = row;
#line 461 "../src/db/PhotoTable.vala"
	_tmp85_ = _tmp84_->development_ids;
#line 461 "../src/db/PhotoTable.vala"
	_tmp85__length1 = _tmp84_->development_ids_length1;
#line 461 "../src/db/PhotoTable.vala"
	_tmp86_ = stmt;
#line 461 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp87_, sqlite3_column_int64 (_tmp86_, 24));
#line 461 "../src/db/PhotoTable.vala"
	_tmp85_[RAW_DEVELOPER_SHOTWELL] = _tmp87_;
#line 462 "../src/db/PhotoTable.vala"
	_tmp88_ = row;
#line 462 "../src/db/PhotoTable.vala"
	_tmp89_ = _tmp88_->development_ids;
#line 462 "../src/db/PhotoTable.vala"
	_tmp89__length1 = _tmp88_->development_ids_length1;
#line 462 "../src/db/PhotoTable.vala"
	_tmp90_ = stmt;
#line 462 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp91_, sqlite3_column_int64 (_tmp90_, 25));
#line 462 "../src/db/PhotoTable.vala"
	_tmp89_[RAW_DEVELOPER_CAMERA] = _tmp91_;
#line 463 "../src/db/PhotoTable.vala"
	_tmp92_ = row;
#line 463 "../src/db/PhotoTable.vala"
	_tmp93_ = _tmp92_->development_ids;
#line 463 "../src/db/PhotoTable.vala"
	_tmp93__length1 = _tmp92_->development_ids_length1;
#line 463 "../src/db/PhotoTable.vala"
	_tmp94_ = stmt;
#line 463 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp95_, sqlite3_column_int64 (_tmp94_, 26));
#line 463 "../src/db/PhotoTable.vala"
	_tmp93_[RAW_DEVELOPER_EMBEDDED] = _tmp95_;
#line 464 "../src/db/PhotoTable.vala"
	_tmp96_ = row;
#line 464 "../src/db/PhotoTable.vala"
	_tmp97_ = stmt;
#line 464 "../src/db/PhotoTable.vala"
	_tmp96_->gps_coords.has_gps = sqlite3_column_int (_tmp97_, 27);
#line 465 "../src/db/PhotoTable.vala"
	_tmp98_ = row;
#line 465 "../src/db/PhotoTable.vala"
	_tmp99_ = stmt;
#line 465 "../src/db/PhotoTable.vala"
	_tmp98_->gps_coords.latitude = sqlite3_column_double (_tmp99_, 28);
#line 466 "../src/db/PhotoTable.vala"
	_tmp100_ = row;
#line 466 "../src/db/PhotoTable.vala"
	_tmp101_ = stmt;
#line 466 "../src/db/PhotoTable.vala"
	_tmp100_->gps_coords.longitude = sqlite3_column_double (_tmp101_, 29);
#line 467 "../src/db/PhotoTable.vala"
	_tmp102_ = row;
#line 467 "../src/db/PhotoTable.vala"
	_tmp103_ = stmt;
#line 467 "../src/db/PhotoTable.vala"
	_tmp104_ = (const gchar*) sqlite3_column_text (_tmp103_, 30);
#line 467 "../src/db/PhotoTable.vala"
	_tmp105_ = g_strdup (_tmp104_);
#line 467 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp102_->comment);
#line 467 "../src/db/PhotoTable.vala"
	_tmp102_->comment = _tmp105_;
#line 469 "../src/db/PhotoTable.vala"
	result = row;
#line 469 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 469 "../src/db/PhotoTable.vala"
	return result;
#line 2922 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_all (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result;
#line 472 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 474 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 474 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, filesize, timestamp, exposure_time" \
", orientation, " "original_orientation, import_id, event_id, transformations, md5, thumb" \
"nail_md5, " "exif_md5, time_created, flags, rating, file_format, title, backlinks, " \
"time_reimported, " "editable_id, metadata_dirty, developer, develop_shotwell_id, develop_c" \
"amera_id, " "develop_embedded_id, has_gps, gps_lat, gps_lon, comment FROM PhotoTabl" \
"e", -1, &_tmp1_, NULL);
#line 474 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 474 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 474 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 481 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 483 "../src/db/PhotoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_PHOTO_ROW, (GBoxedCopyFunc) photo_row_ref, (GDestroyNotify) photo_row_unref, NULL, NULL, NULL);
#line 483 "../src/db/PhotoTable.vala"
	all = _tmp3_;
#line 485 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 2956 "PhotoTable.c"
		sqlite3_stmt* _tmp4_;
		PhotoRow* row = NULL;
		PhotoRow* _tmp5_;
		PhotoRow* _tmp6_;
		sqlite3_stmt* _tmp7_;
		PhotoRow* _tmp8_;
		BackingPhotoRow* _tmp9_;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		PhotoRow* _tmp13_;
		BackingPhotoRow* _tmp14_;
		sqlite3_stmt* _tmp15_;
		sqlite3_stmt* _tmp16_;
		PhotoRow* _tmp17_;
		BackingPhotoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		PhotoRow* _tmp20_;
		BackingPhotoRow* _tmp21_;
		sqlite3_stmt* _tmp22_;
		GDateTime* _tmp23_;
		sqlite3_stmt* _tmp24_;
		PhotoRow* _tmp29_;
		sqlite3_stmt* _tmp30_;
		PhotoRow* _tmp31_;
		BackingPhotoRow* _tmp32_;
		sqlite3_stmt* _tmp33_;
		PhotoRow* _tmp34_;
		sqlite3_stmt* _tmp35_;
		PhotoRow* _tmp36_;
		sqlite3_stmt* _tmp37_;
		PhotoRow* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_;
		GeeHashMap* _tmp41_;
		PhotoRow* _tmp42_;
		sqlite3_stmt* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		PhotoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		PhotoRow* _tmp50_;
		sqlite3_stmt* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		PhotoRow* _tmp54_;
		sqlite3_stmt* _tmp55_;
		PhotoRow* _tmp56_;
		sqlite3_stmt* _tmp57_;
		PhotoRow* _tmp58_;
		sqlite3_stmt* _tmp59_;
		PhotoRow* _tmp60_;
		BackingPhotoRow* _tmp61_;
		sqlite3_stmt* _tmp62_;
		PhotoRow* _tmp63_;
		sqlite3_stmt* _tmp64_;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		PhotoRow* _tmp67_;
		sqlite3_stmt* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		PhotoRow* _tmp71_;
		sqlite3_stmt* _tmp72_;
		PhotoRow* _tmp73_;
		sqlite3_stmt* _tmp74_;
		PhotoRow* _tmp75_;
		sqlite3_stmt* _tmp76_;
		RawDeveloper _tmp77_ = 0;
		sqlite3_stmt* _tmp78_;
		const gchar* _tmp79_;
		PhotoRow* _tmp82_;
		PhotoRow* _tmp83_;
		BackingPhotoID* _tmp84_;
		gint _tmp84__length1;
		sqlite3_stmt* _tmp85_;
		BackingPhotoID _tmp86_ = {0};
		PhotoRow* _tmp87_;
		BackingPhotoID* _tmp88_;
		gint _tmp88__length1;
		sqlite3_stmt* _tmp89_;
		BackingPhotoID _tmp90_ = {0};
		PhotoRow* _tmp91_;
		BackingPhotoID* _tmp92_;
		gint _tmp92__length1;
		sqlite3_stmt* _tmp93_;
		BackingPhotoID _tmp94_ = {0};
		PhotoRow* _tmp95_;
		sqlite3_stmt* _tmp96_;
		PhotoRow* _tmp97_;
		sqlite3_stmt* _tmp98_;
		PhotoRow* _tmp99_;
		sqlite3_stmt* _tmp100_;
		PhotoRow* _tmp101_;
		sqlite3_stmt* _tmp102_;
		const gchar* _tmp103_;
		gchar* _tmp104_;
		PhotoRow* _tmp105_;
		GeeArrayList* _tmp106_;
		PhotoRow* _tmp107_;
#line 485 "../src/db/PhotoTable.vala"
		_tmp4_ = stmt;
#line 485 "../src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp4_);
#line 485 "../src/db/PhotoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 485 "../src/db/PhotoTable.vala"
			break;
#line 3067 "PhotoTable.c"
		}
#line 486 "../src/db/PhotoTable.vala"
		_tmp5_ = photo_row_new ();
#line 486 "../src/db/PhotoTable.vala"
		row = _tmp5_;
#line 487 "../src/db/PhotoTable.vala"
		_tmp6_ = row;
#line 487 "../src/db/PhotoTable.vala"
		_tmp7_ = stmt;
#line 487 "../src/db/PhotoTable.vala"
		_tmp6_->photo_id.id = sqlite3_column_int64 (_tmp7_, 0);
#line 488 "../src/db/PhotoTable.vala"
		_tmp8_ = row;
#line 488 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_->master;
#line 488 "../src/db/PhotoTable.vala"
		_tmp10_ = stmt;
#line 488 "../src/db/PhotoTable.vala"
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 488 "../src/db/PhotoTable.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 488 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp9_->filepath);
#line 488 "../src/db/PhotoTable.vala"
		_tmp9_->filepath = _tmp12_;
#line 489 "../src/db/PhotoTable.vala"
		_tmp13_ = row;
#line 489 "../src/db/PhotoTable.vala"
		_tmp14_ = _tmp13_->master;
#line 489 "../src/db/PhotoTable.vala"
		_tmp15_ = stmt;
#line 489 "../src/db/PhotoTable.vala"
		_tmp16_ = stmt;
#line 489 "../src/db/PhotoTable.vala"
		dimensions_init (&_tmp14_->dim, sqlite3_column_int (_tmp15_, 2), sqlite3_column_int (_tmp16_, 3));
#line 490 "../src/db/PhotoTable.vala"
		_tmp17_ = row;
#line 490 "../src/db/PhotoTable.vala"
		_tmp18_ = _tmp17_->master;
#line 490 "../src/db/PhotoTable.vala"
		_tmp19_ = stmt;
#line 490 "../src/db/PhotoTable.vala"
		_tmp18_->filesize = sqlite3_column_int64 (_tmp19_, 4);
#line 491 "../src/db/PhotoTable.vala"
		_tmp20_ = row;
#line 491 "../src/db/PhotoTable.vala"
		_tmp21_ = _tmp20_->master;
#line 491 "../src/db/PhotoTable.vala"
		_tmp22_ = stmt;
#line 491 "../src/db/PhotoTable.vala"
		_tmp23_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp22_, 5));
#line 491 "../src/db/PhotoTable.vala"
		_g_date_time_unref0 (_tmp21_->timestamp);
#line 491 "../src/db/PhotoTable.vala"
		_tmp21_->timestamp = _tmp23_;
#line 492 "../src/db/PhotoTable.vala"
		_tmp24_ = stmt;
#line 492 "../src/db/PhotoTable.vala"
		if (sqlite3_column_type (_tmp24_, 6) == SQLITE_NULL) {
#line 3127 "PhotoTable.c"
			PhotoRow* _tmp25_;
#line 493 "../src/db/PhotoTable.vala"
			_tmp25_ = row;
#line 493 "../src/db/PhotoTable.vala"
			_g_date_time_unref0 (_tmp25_->exposure_time);
#line 493 "../src/db/PhotoTable.vala"
			_tmp25_->exposure_time = NULL;
#line 3135 "PhotoTable.c"
		} else {
			PhotoRow* _tmp26_;
			sqlite3_stmt* _tmp27_;
			GDateTime* _tmp28_;
#line 495 "../src/db/PhotoTable.vala"
			_tmp26_ = row;
#line 495 "../src/db/PhotoTable.vala"
			_tmp27_ = stmt;
#line 495 "../src/db/PhotoTable.vala"
			_tmp28_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp27_, 6));
#line 495 "../src/db/PhotoTable.vala"
			_g_date_time_unref0 (_tmp26_->exposure_time);
#line 495 "../src/db/PhotoTable.vala"
			_tmp26_->exposure_time = _tmp28_;
#line 3150 "PhotoTable.c"
		}
#line 497 "../src/db/PhotoTable.vala"
		_tmp29_ = row;
#line 497 "../src/db/PhotoTable.vala"
		_tmp30_ = stmt;
#line 497 "../src/db/PhotoTable.vala"
		_tmp29_->orientation = (Orientation) sqlite3_column_int (_tmp30_, 7);
#line 498 "../src/db/PhotoTable.vala"
		_tmp31_ = row;
#line 498 "../src/db/PhotoTable.vala"
		_tmp32_ = _tmp31_->master;
#line 498 "../src/db/PhotoTable.vala"
		_tmp33_ = stmt;
#line 498 "../src/db/PhotoTable.vala"
		_tmp32_->original_orientation = (Orientation) sqlite3_column_int (_tmp33_, 8);
#line 499 "../src/db/PhotoTable.vala"
		_tmp34_ = row;
#line 499 "../src/db/PhotoTable.vala"
		_tmp35_ = stmt;
#line 499 "../src/db/PhotoTable.vala"
		_tmp34_->import_id.id = sqlite3_column_int64 (_tmp35_, 9);
#line 500 "../src/db/PhotoTable.vala"
		_tmp36_ = row;
#line 500 "../src/db/PhotoTable.vala"
		_tmp37_ = stmt;
#line 500 "../src/db/PhotoTable.vala"
		_tmp36_->event_id.id = sqlite3_column_int64 (_tmp37_, 10);
#line 501 "../src/db/PhotoTable.vala"
		_tmp38_ = row;
#line 501 "../src/db/PhotoTable.vala"
		_tmp39_ = stmt;
#line 501 "../src/db/PhotoTable.vala"
		_tmp40_ = (const gchar*) sqlite3_column_text (_tmp39_, 11);
#line 501 "../src/db/PhotoTable.vala"
		_tmp41_ = photo_table_marshall_all_transformations (_tmp40_);
#line 501 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp38_->transformations);
#line 501 "../src/db/PhotoTable.vala"
		_tmp38_->transformations = _tmp41_;
#line 502 "../src/db/PhotoTable.vala"
		_tmp42_ = row;
#line 502 "../src/db/PhotoTable.vala"
		_tmp43_ = stmt;
#line 502 "../src/db/PhotoTable.vala"
		_tmp44_ = (const gchar*) sqlite3_column_text (_tmp43_, 12);
#line 502 "../src/db/PhotoTable.vala"
		_tmp45_ = g_strdup (_tmp44_);
#line 502 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp42_->md5);
#line 502 "../src/db/PhotoTable.vala"
		_tmp42_->md5 = _tmp45_;
#line 503 "../src/db/PhotoTable.vala"
		_tmp46_ = row;
#line 503 "../src/db/PhotoTable.vala"
		_tmp47_ = stmt;
#line 503 "../src/db/PhotoTable.vala"
		_tmp48_ = (const gchar*) sqlite3_column_text (_tmp47_, 13);
#line 503 "../src/db/PhotoTable.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 503 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp46_->thumbnail_md5);
#line 503 "../src/db/PhotoTable.vala"
		_tmp46_->thumbnail_md5 = _tmp49_;
#line 504 "../src/db/PhotoTable.vala"
		_tmp50_ = row;
#line 504 "../src/db/PhotoTable.vala"
		_tmp51_ = stmt;
#line 504 "../src/db/PhotoTable.vala"
		_tmp52_ = (const gchar*) sqlite3_column_text (_tmp51_, 14);
#line 504 "../src/db/PhotoTable.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 504 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp50_->exif_md5);
#line 504 "../src/db/PhotoTable.vala"
		_tmp50_->exif_md5 = _tmp53_;
#line 505 "../src/db/PhotoTable.vala"
		_tmp54_ = row;
#line 505 "../src/db/PhotoTable.vala"
		_tmp55_ = stmt;
#line 505 "../src/db/PhotoTable.vala"
		_tmp54_->time_created = sqlite3_column_int64 (_tmp55_, 15);
#line 506 "../src/db/PhotoTable.vala"
		_tmp56_ = row;
#line 506 "../src/db/PhotoTable.vala"
		_tmp57_ = stmt;
#line 506 "../src/db/PhotoTable.vala"
		_tmp56_->flags = (guint64) sqlite3_column_int64 (_tmp57_, 16);
#line 507 "../src/db/PhotoTable.vala"
		_tmp58_ = row;
#line 507 "../src/db/PhotoTable.vala"
		_tmp59_ = stmt;
#line 507 "../src/db/PhotoTable.vala"
		_tmp58_->rating = rating_unserialize (sqlite3_column_int (_tmp59_, 17));
#line 508 "../src/db/PhotoTable.vala"
		_tmp60_ = row;
#line 508 "../src/db/PhotoTable.vala"
		_tmp61_ = _tmp60_->master;
#line 508 "../src/db/PhotoTable.vala"
		_tmp62_ = stmt;
#line 508 "../src/db/PhotoTable.vala"
		_tmp61_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp62_, 18));
#line 509 "../src/db/PhotoTable.vala"
		_tmp63_ = row;
#line 509 "../src/db/PhotoTable.vala"
		_tmp64_ = stmt;
#line 509 "../src/db/PhotoTable.vala"
		_tmp65_ = (const gchar*) sqlite3_column_text (_tmp64_, 19);
#line 509 "../src/db/PhotoTable.vala"
		_tmp66_ = g_strdup (_tmp65_);
#line 509 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp63_->title);
#line 509 "../src/db/PhotoTable.vala"
		_tmp63_->title = _tmp66_;
#line 510 "../src/db/PhotoTable.vala"
		_tmp67_ = row;
#line 510 "../src/db/PhotoTable.vala"
		_tmp68_ = stmt;
#line 510 "../src/db/PhotoTable.vala"
		_tmp69_ = (const gchar*) sqlite3_column_text (_tmp68_, 20);
#line 510 "../src/db/PhotoTable.vala"
		_tmp70_ = g_strdup (_tmp69_);
#line 510 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp67_->backlinks);
#line 510 "../src/db/PhotoTable.vala"
		_tmp67_->backlinks = _tmp70_;
#line 511 "../src/db/PhotoTable.vala"
		_tmp71_ = row;
#line 511 "../src/db/PhotoTable.vala"
		_tmp72_ = stmt;
#line 511 "../src/db/PhotoTable.vala"
		_tmp71_->time_reimported = sqlite3_column_int64 (_tmp72_, 21);
#line 512 "../src/db/PhotoTable.vala"
		_tmp73_ = row;
#line 512 "../src/db/PhotoTable.vala"
		_tmp74_ = stmt;
#line 512 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp73_->editable_id, sqlite3_column_int64 (_tmp74_, 22));
#line 513 "../src/db/PhotoTable.vala"
		_tmp75_ = row;
#line 513 "../src/db/PhotoTable.vala"
		_tmp76_ = stmt;
#line 513 "../src/db/PhotoTable.vala"
		_tmp75_->metadata_dirty = sqlite3_column_int (_tmp76_, 23) != 0;
#line 514 "../src/db/PhotoTable.vala"
		_tmp78_ = stmt;
#line 514 "../src/db/PhotoTable.vala"
		_tmp79_ = (const gchar*) sqlite3_column_text (_tmp78_, 24);
#line 514 "../src/db/PhotoTable.vala"
		if (_tmp79_ != NULL) {
#line 3300 "PhotoTable.c"
			sqlite3_stmt* _tmp80_;
			const gchar* _tmp81_;
#line 514 "../src/db/PhotoTable.vala"
			_tmp80_ = stmt;
#line 514 "../src/db/PhotoTable.vala"
			_tmp81_ = (const gchar*) sqlite3_column_text (_tmp80_, 24);
#line 514 "../src/db/PhotoTable.vala"
			_tmp77_ = raw_developer_from_string (_tmp81_);
#line 3309 "PhotoTable.c"
		} else {
#line 515 "../src/db/PhotoTable.vala"
			_tmp77_ = RAW_DEVELOPER_CAMERA;
#line 3313 "PhotoTable.c"
		}
#line 514 "../src/db/PhotoTable.vala"
		_tmp82_ = row;
#line 514 "../src/db/PhotoTable.vala"
		_tmp82_->developer = _tmp77_;
#line 516 "../src/db/PhotoTable.vala"
		_tmp83_ = row;
#line 516 "../src/db/PhotoTable.vala"
		_tmp84_ = _tmp83_->development_ids;
#line 516 "../src/db/PhotoTable.vala"
		_tmp84__length1 = _tmp83_->development_ids_length1;
#line 516 "../src/db/PhotoTable.vala"
		_tmp85_ = stmt;
#line 516 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp86_, sqlite3_column_int64 (_tmp85_, 25));
#line 516 "../src/db/PhotoTable.vala"
		_tmp84_[RAW_DEVELOPER_SHOTWELL] = _tmp86_;
#line 517 "../src/db/PhotoTable.vala"
		_tmp87_ = row;
#line 517 "../src/db/PhotoTable.vala"
		_tmp88_ = _tmp87_->development_ids;
#line 517 "../src/db/PhotoTable.vala"
		_tmp88__length1 = _tmp87_->development_ids_length1;
#line 517 "../src/db/PhotoTable.vala"
		_tmp89_ = stmt;
#line 517 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp90_, sqlite3_column_int64 (_tmp89_, 26));
#line 517 "../src/db/PhotoTable.vala"
		_tmp88_[RAW_DEVELOPER_CAMERA] = _tmp90_;
#line 518 "../src/db/PhotoTable.vala"
		_tmp91_ = row;
#line 518 "../src/db/PhotoTable.vala"
		_tmp92_ = _tmp91_->development_ids;
#line 518 "../src/db/PhotoTable.vala"
		_tmp92__length1 = _tmp91_->development_ids_length1;
#line 518 "../src/db/PhotoTable.vala"
		_tmp93_ = stmt;
#line 518 "../src/db/PhotoTable.vala"
		backing_photo_id_init (&_tmp94_, sqlite3_column_int64 (_tmp93_, 27));
#line 518 "../src/db/PhotoTable.vala"
		_tmp92_[RAW_DEVELOPER_EMBEDDED] = _tmp94_;
#line 519 "../src/db/PhotoTable.vala"
		_tmp95_ = row;
#line 519 "../src/db/PhotoTable.vala"
		_tmp96_ = stmt;
#line 519 "../src/db/PhotoTable.vala"
		_tmp95_->gps_coords.has_gps = sqlite3_column_int (_tmp96_, 28);
#line 520 "../src/db/PhotoTable.vala"
		_tmp97_ = row;
#line 520 "../src/db/PhotoTable.vala"
		_tmp98_ = stmt;
#line 520 "../src/db/PhotoTable.vala"
		_tmp97_->gps_coords.latitude = sqlite3_column_double (_tmp98_, 29);
#line 521 "../src/db/PhotoTable.vala"
		_tmp99_ = row;
#line 521 "../src/db/PhotoTable.vala"
		_tmp100_ = stmt;
#line 521 "../src/db/PhotoTable.vala"
		_tmp99_->gps_coords.longitude = sqlite3_column_double (_tmp100_, 30);
#line 522 "../src/db/PhotoTable.vala"
		_tmp101_ = row;
#line 522 "../src/db/PhotoTable.vala"
		_tmp102_ = stmt;
#line 522 "../src/db/PhotoTable.vala"
		_tmp103_ = (const gchar*) sqlite3_column_text (_tmp102_, 31);
#line 522 "../src/db/PhotoTable.vala"
		_tmp104_ = g_strdup (_tmp103_);
#line 522 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp101_->comment);
#line 522 "../src/db/PhotoTable.vala"
		_tmp101_->comment = _tmp104_;
#line 524 "../src/db/PhotoTable.vala"
		_tmp105_ = row;
#line 524 "../src/db/PhotoTable.vala"
		photo_table_validate_orientation (self, _tmp105_);
#line 526 "../src/db/PhotoTable.vala"
		_tmp106_ = all;
#line 526 "../src/db/PhotoTable.vala"
		_tmp107_ = row;
#line 526 "../src/db/PhotoTable.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp107_);
#line 485 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (row);
#line 3397 "PhotoTable.c"
	}
#line 529 "../src/db/PhotoTable.vala"
	result = all;
#line 529 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 529 "../src/db/PhotoTable.vala"
	return result;
#line 3405 "PhotoTable.c"
}

void
photo_table_duplicate (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_filename,
                       BackingPhotoID* editable_id,
                       BackingPhotoID* develop_shotwell,
                       BackingPhotoID* develop_camera_id,
                       BackingPhotoID* develop_embedded_id,
                       PhotoID* result)
{
	PhotoRow* original = NULL;
	PhotoID _tmp0_;
	PhotoRow* _tmp1_;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	sqlite3_stmt* _tmp5_;
	gchar* _tmp6_;
	GDestroyNotify _tmp7_;
	sqlite3_stmt* _tmp8_;
	PhotoRow* _tmp9_;
	BackingPhotoRow* _tmp10_;
	Dimensions _tmp11_;
	sqlite3_stmt* _tmp12_;
	PhotoRow* _tmp13_;
	BackingPhotoRow* _tmp14_;
	Dimensions _tmp15_;
	sqlite3_stmt* _tmp16_;
	PhotoRow* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	PhotoRow* _tmp20_;
	BackingPhotoRow* _tmp21_;
	GDateTime* _tmp22_;
	sqlite3_stmt* _tmp23_;
	PhotoRow* _tmp24_;
	GDateTime* _tmp25_;
	sqlite3_stmt* _tmp26_;
	PhotoRow* _tmp27_;
	sqlite3_stmt* _tmp28_;
	PhotoRow* _tmp29_;
	BackingPhotoRow* _tmp30_;
	sqlite3_stmt* _tmp31_;
	PhotoRow* _tmp32_;
	ImportID _tmp33_;
	sqlite3_stmt* _tmp34_;
	PhotoRow* _tmp35_;
	EventID _tmp36_;
	sqlite3_stmt* _tmp37_;
	PhotoRow* _tmp38_;
	GeeHashMap* _tmp39_;
	gchar* _tmp40_;
	GDestroyNotify _tmp41_;
	sqlite3_stmt* _tmp42_;
	PhotoRow* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	GDestroyNotify _tmp46_;
	sqlite3_stmt* _tmp47_;
	PhotoRow* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	GDestroyNotify _tmp51_;
	sqlite3_stmt* _tmp52_;
	PhotoRow* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	GDestroyNotify _tmp56_;
	sqlite3_stmt* _tmp57_;
	sqlite3_stmt* _tmp58_;
	PhotoRow* _tmp59_;
	sqlite3_stmt* _tmp60_;
	PhotoRow* _tmp61_;
	sqlite3_stmt* _tmp62_;
	PhotoRow* _tmp63_;
	BackingPhotoRow* _tmp64_;
	sqlite3_stmt* _tmp65_;
	PhotoRow* _tmp66_;
	const gchar* _tmp67_;
	gchar* _tmp68_;
	GDestroyNotify _tmp69_;
	sqlite3_stmt* _tmp70_;
	PhotoRow* _tmp71_;
	GpsCoords _tmp72_;
	sqlite3_stmt* _tmp73_;
	PhotoRow* _tmp74_;
	GpsCoords _tmp75_;
	sqlite3_stmt* _tmp76_;
	PhotoRow* _tmp77_;
	GpsCoords _tmp78_;
	sqlite3_stmt* _tmp79_;
	BackingPhotoID _tmp80_;
	sqlite3_stmt* _tmp81_;
	PhotoRow* _tmp82_;
	gchar* _tmp83_;
	GDestroyNotify _tmp84_;
	sqlite3_stmt* _tmp85_;
	BackingPhotoID _tmp86_;
	sqlite3_stmt* _tmp87_;
	BackingPhotoID _tmp88_;
	sqlite3_stmt* _tmp89_;
	BackingPhotoID _tmp90_;
	sqlite3_stmt* _tmp91_;
	PhotoRow* _tmp92_;
	const gchar* _tmp93_;
	gchar* _tmp94_;
	GDestroyNotify _tmp95_;
	sqlite3_stmt* _tmp96_;
	sqlite3* _tmp98_;
	PhotoID _tmp99_ = {0};
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (new_filename != NULL);
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_shotwell != NULL);
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_camera_id != NULL);
#line 534 "../src/db/PhotoTable.vala"
	g_return_if_fail (develop_embedded_id != NULL);
#line 538 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 538 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_row (self, &_tmp0_);
#line 538 "../src/db/PhotoTable.vala"
	original = _tmp1_;
#line 541 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_db;
#line 541 "../src/db/PhotoTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, "INSERT INTO PhotoTable (filename, width, height, filesize, " "timestamp, exposure_time, orientation, original_orientation, import_id" \
", event_id, " "transformations, md5, thumbnail_md5, exif_md5, time_created, flags, ra" \
"ting, " "file_format, title, has_gps, gps_lat, gps_lon, editable_id, developer," \
" " "develop_shotwell_id, develop_camera_id, develop_embedded_id, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?," \
" ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp3_, NULL);
#line 541 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 541 "../src/db/PhotoTable.vala"
	stmt = _tmp3_;
#line 541 "../src/db/PhotoTable.vala"
	res = _tmp4_;
#line 548 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 550 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 550 "../src/db/PhotoTable.vala"
	_tmp6_ = g_strdup (new_filename);
#line 550 "../src/db/PhotoTable.vala"
	_tmp7_ = g_free;
#line 550 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp5_, 1, _tmp6_, -1, _tmp7_);
#line 551 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 552 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 552 "../src/db/PhotoTable.vala"
	_tmp9_ = original;
#line 552 "../src/db/PhotoTable.vala"
	_tmp10_ = _tmp9_->master;
#line 552 "../src/db/PhotoTable.vala"
	_tmp11_ = _tmp10_->dim;
#line 552 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 2, _tmp11_.width);
#line 553 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 554 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 554 "../src/db/PhotoTable.vala"
	_tmp13_ = original;
#line 554 "../src/db/PhotoTable.vala"
	_tmp14_ = _tmp13_->master;
#line 554 "../src/db/PhotoTable.vala"
	_tmp15_ = _tmp14_->dim;
#line 554 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp12_, 3, _tmp15_.height);
#line 555 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 556 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 556 "../src/db/PhotoTable.vala"
	_tmp17_ = original;
#line 556 "../src/db/PhotoTable.vala"
	_tmp18_ = _tmp17_->master;
#line 556 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp16_, 4, _tmp18_->filesize);
#line 557 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 558 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 558 "../src/db/PhotoTable.vala"
	_tmp20_ = original;
#line 558 "../src/db/PhotoTable.vala"
	_tmp21_ = _tmp20_->master;
#line 558 "../src/db/PhotoTable.vala"
	_tmp22_ = _tmp21_->timestamp;
#line 558 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp19_, 5, g_date_time_to_unix (_tmp22_));
#line 559 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 560 "../src/db/PhotoTable.vala"
	_tmp23_ = stmt;
#line 560 "../src/db/PhotoTable.vala"
	_tmp24_ = original;
#line 560 "../src/db/PhotoTable.vala"
	_tmp25_ = _tmp24_->exposure_time;
#line 560 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp23_, 6, g_date_time_to_unix (_tmp25_));
#line 561 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 562 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 562 "../src/db/PhotoTable.vala"
	_tmp27_ = original;
#line 562 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp26_, 7, (gint) _tmp27_->orientation);
#line 563 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 564 "../src/db/PhotoTable.vala"
	_tmp28_ = stmt;
#line 564 "../src/db/PhotoTable.vala"
	_tmp29_ = original;
#line 564 "../src/db/PhotoTable.vala"
	_tmp30_ = _tmp29_->master;
#line 564 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp28_, 8, (gint) _tmp30_->original_orientation);
#line 565 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 566 "../src/db/PhotoTable.vala"
	_tmp31_ = stmt;
#line 566 "../src/db/PhotoTable.vala"
	_tmp32_ = original;
#line 566 "../src/db/PhotoTable.vala"
	_tmp33_ = _tmp32_->import_id;
#line 566 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp31_, 9, _tmp33_.id);
#line 567 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 568 "../src/db/PhotoTable.vala"
	_tmp34_ = stmt;
#line 568 "../src/db/PhotoTable.vala"
	_tmp35_ = original;
#line 568 "../src/db/PhotoTable.vala"
	_tmp36_ = _tmp35_->event_id;
#line 568 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp34_, 10, _tmp36_.id);
#line 569 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 570 "../src/db/PhotoTable.vala"
	_tmp37_ = stmt;
#line 570 "../src/db/PhotoTable.vala"
	_tmp38_ = original;
#line 570 "../src/db/PhotoTable.vala"
	_tmp39_ = _tmp38_->transformations;
#line 570 "../src/db/PhotoTable.vala"
	_tmp40_ = photo_table_unmarshall_all_transformations (_tmp39_);
#line 570 "../src/db/PhotoTable.vala"
	_tmp41_ = g_free;
#line 570 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp37_, 11, _tmp40_, -1, _tmp41_);
#line 571 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 572 "../src/db/PhotoTable.vala"
	_tmp42_ = stmt;
#line 572 "../src/db/PhotoTable.vala"
	_tmp43_ = original;
#line 572 "../src/db/PhotoTable.vala"
	_tmp44_ = _tmp43_->md5;
#line 572 "../src/db/PhotoTable.vala"
	_tmp45_ = g_strdup (_tmp44_);
#line 572 "../src/db/PhotoTable.vala"
	_tmp46_ = g_free;
#line 572 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp42_, 12, _tmp45_, -1, _tmp46_);
#line 573 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 574 "../src/db/PhotoTable.vala"
	_tmp47_ = stmt;
#line 574 "../src/db/PhotoTable.vala"
	_tmp48_ = original;
#line 574 "../src/db/PhotoTable.vala"
	_tmp49_ = _tmp48_->thumbnail_md5;
#line 574 "../src/db/PhotoTable.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 574 "../src/db/PhotoTable.vala"
	_tmp51_ = g_free;
#line 574 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp47_, 13, _tmp50_, -1, _tmp51_);
#line 575 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 576 "../src/db/PhotoTable.vala"
	_tmp52_ = stmt;
#line 576 "../src/db/PhotoTable.vala"
	_tmp53_ = original;
#line 576 "../src/db/PhotoTable.vala"
	_tmp54_ = _tmp53_->exif_md5;
#line 576 "../src/db/PhotoTable.vala"
	_tmp55_ = g_strdup (_tmp54_);
#line 576 "../src/db/PhotoTable.vala"
	_tmp56_ = g_free;
#line 576 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp52_, 14, _tmp55_, -1, _tmp56_);
#line 577 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 578 "../src/db/PhotoTable.vala"
	_tmp57_ = stmt;
#line 578 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp57_, 15, now_sec ());
#line 579 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 580 "../src/db/PhotoTable.vala"
	_tmp58_ = stmt;
#line 580 "../src/db/PhotoTable.vala"
	_tmp59_ = original;
#line 580 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp58_, 16, (gint64) _tmp59_->flags);
#line 581 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 582 "../src/db/PhotoTable.vala"
	_tmp60_ = stmt;
#line 582 "../src/db/PhotoTable.vala"
	_tmp61_ = original;
#line 582 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp60_, 17, (gint64) rating_serialize (_tmp61_->rating));
#line 583 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 584 "../src/db/PhotoTable.vala"
	_tmp62_ = stmt;
#line 584 "../src/db/PhotoTable.vala"
	_tmp63_ = original;
#line 584 "../src/db/PhotoTable.vala"
	_tmp64_ = _tmp63_->master;
#line 584 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp62_, 18, photo_file_format_serialize (_tmp64_->file_format));
#line 585 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 586 "../src/db/PhotoTable.vala"
	_tmp65_ = stmt;
#line 586 "../src/db/PhotoTable.vala"
	_tmp66_ = original;
#line 586 "../src/db/PhotoTable.vala"
	_tmp67_ = _tmp66_->title;
#line 586 "../src/db/PhotoTable.vala"
	_tmp68_ = g_strdup (_tmp67_);
#line 586 "../src/db/PhotoTable.vala"
	_tmp69_ = g_free;
#line 586 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp65_, 19, _tmp68_, -1, _tmp69_);
#line 587 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 588 "../src/db/PhotoTable.vala"
	_tmp70_ = stmt;
#line 588 "../src/db/PhotoTable.vala"
	_tmp71_ = original;
#line 588 "../src/db/PhotoTable.vala"
	_tmp72_ = _tmp71_->gps_coords;
#line 588 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp70_, 20, _tmp72_.has_gps);
#line 589 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 590 "../src/db/PhotoTable.vala"
	_tmp73_ = stmt;
#line 590 "../src/db/PhotoTable.vala"
	_tmp74_ = original;
#line 590 "../src/db/PhotoTable.vala"
	_tmp75_ = _tmp74_->gps_coords;
#line 590 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp73_, 21, _tmp75_.latitude);
#line 591 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 592 "../src/db/PhotoTable.vala"
	_tmp76_ = stmt;
#line 592 "../src/db/PhotoTable.vala"
	_tmp77_ = original;
#line 592 "../src/db/PhotoTable.vala"
	_tmp78_ = _tmp77_->gps_coords;
#line 592 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_double (_tmp76_, 22, _tmp78_.longitude);
#line 593 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 594 "../src/db/PhotoTable.vala"
	_tmp79_ = stmt;
#line 594 "../src/db/PhotoTable.vala"
	_tmp80_ = *editable_id;
#line 594 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp79_, 23, _tmp80_.id);
#line 595 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 596 "../src/db/PhotoTable.vala"
	_tmp81_ = stmt;
#line 596 "../src/db/PhotoTable.vala"
	_tmp82_ = original;
#line 596 "../src/db/PhotoTable.vala"
	_tmp83_ = raw_developer_to_string (_tmp82_->developer);
#line 596 "../src/db/PhotoTable.vala"
	_tmp84_ = g_free;
#line 596 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp81_, 24, _tmp83_, -1, _tmp84_);
#line 597 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 598 "../src/db/PhotoTable.vala"
	_tmp85_ = stmt;
#line 598 "../src/db/PhotoTable.vala"
	_tmp86_ = *develop_shotwell;
#line 598 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp85_, 25, _tmp86_.id);
#line 599 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 600 "../src/db/PhotoTable.vala"
	_tmp87_ = stmt;
#line 600 "../src/db/PhotoTable.vala"
	_tmp88_ = *develop_camera_id;
#line 600 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp87_, 26, _tmp88_.id);
#line 601 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 602 "../src/db/PhotoTable.vala"
	_tmp89_ = stmt;
#line 602 "../src/db/PhotoTable.vala"
	_tmp90_ = *develop_embedded_id;
#line 602 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp89_, 27, _tmp90_.id);
#line 603 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 604 "../src/db/PhotoTable.vala"
	_tmp91_ = stmt;
#line 604 "../src/db/PhotoTable.vala"
	_tmp92_ = original;
#line 604 "../src/db/PhotoTable.vala"
	_tmp93_ = _tmp92_->comment;
#line 604 "../src/db/PhotoTable.vala"
	_tmp94_ = g_strdup (_tmp93_);
#line 604 "../src/db/PhotoTable.vala"
	_tmp95_ = g_free;
#line 604 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp91_, 28, _tmp94_, -1, _tmp95_);
#line 605 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 607 "../src/db/PhotoTable.vala"
	_tmp96_ = stmt;
#line 607 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp96_);
#line 608 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 3852 "PhotoTable.c"
		PhotoID _tmp97_ = {0};
#line 609 "../src/db/PhotoTable.vala"
		if (res != SQLITE_CONSTRAINT) {
#line 610 "../src/db/PhotoTable.vala"
			database_table_fatal ("duplicate", res);
#line 3858 "PhotoTable.c"
		}
#line 612 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp97_, PHOTO_ID_INVALID);
#line 612 "../src/db/PhotoTable.vala"
		*result = _tmp97_;
#line 612 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 612 "../src/db/PhotoTable.vala"
		_photo_row_unref0 (original);
#line 612 "../src/db/PhotoTable.vala"
		return;
#line 3870 "PhotoTable.c"
	}
#line 615 "../src/db/PhotoTable.vala"
	_tmp98_ = database_table_db;
#line 615 "../src/db/PhotoTable.vala"
	photo_id_init (&_tmp99_, sqlite3_last_insert_rowid (_tmp98_));
#line 615 "../src/db/PhotoTable.vala"
	*result = _tmp99_;
#line 615 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 615 "../src/db/PhotoTable.vala"
	_photo_row_unref0 (original);
#line 615 "../src/db/PhotoTable.vala"
	return;
#line 3884 "PhotoTable.c"
}

gboolean
photo_table_set_title (PhotoTable* self,
                       PhotoID* photo_id,
                       const gchar* new_title)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result;
#line 618 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 618 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 619 "../src/db/PhotoTable.vala"
	if (new_title != NULL) {
#line 619 "../src/db/PhotoTable.vala"
		_tmp0_ = new_title;
#line 3903 "PhotoTable.c"
	} else {
#line 619 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 3907 "PhotoTable.c"
	}
#line 619 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 619 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "title", _tmp0_);
#line 619 "../src/db/PhotoTable.vala"
	return result;
#line 3915 "PhotoTable.c"
}

void
photo_table_set_gps_coords (PhotoTable* self,
                            PhotoID* photo_id,
                            GpsCoords* new_gps_coords,
                            GError** error)
{
	PhotoID _tmp0_;
	GpsCoords _tmp1_;
	GpsCoords _tmp2_;
	GError* _inner_error0_ = NULL;
#line 622 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 622 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 622 "../src/db/PhotoTable.vala"
	g_return_if_fail (new_gps_coords != NULL);
#line 623 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 623 "../src/db/PhotoTable.vala"
	_tmp1_ = *new_gps_coords;
#line 623 "../src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "has_gps", _tmp1_.has_gps, &_inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 623 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 623 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
			return;
#line 3948 "PhotoTable.c"
		} else {
#line 623 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 623 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 623 "../src/db/PhotoTable.vala"
			return;
#line 3956 "PhotoTable.c"
		}
	}
#line 624 "../src/db/PhotoTable.vala"
	_tmp2_ = *new_gps_coords;
#line 624 "../src/db/PhotoTable.vala"
	if (_tmp2_.has_gps > 0) {
#line 3963 "PhotoTable.c"
		PhotoID _tmp3_;
		GpsCoords _tmp4_;
		PhotoID _tmp5_;
		GpsCoords _tmp6_;
#line 625 "../src/db/PhotoTable.vala"
		_tmp3_ = *photo_id;
#line 625 "../src/db/PhotoTable.vala"
		_tmp4_ = *new_gps_coords;
#line 625 "../src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp3_.id, "gps_lat", _tmp4_.latitude, &_inner_error0_);
#line 625 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 625 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 625 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 625 "../src/db/PhotoTable.vala"
				return;
#line 3982 "PhotoTable.c"
			} else {
#line 625 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 625 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 625 "../src/db/PhotoTable.vala"
				return;
#line 3990 "PhotoTable.c"
			}
		}
#line 626 "../src/db/PhotoTable.vala"
		_tmp5_ = *photo_id;
#line 626 "../src/db/PhotoTable.vala"
		_tmp6_ = *new_gps_coords;
#line 626 "../src/db/PhotoTable.vala"
		database_table_update_double_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp5_.id, "gps_lon", _tmp6_.longitude, &_inner_error0_);
#line 626 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 626 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 626 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 626 "../src/db/PhotoTable.vala"
				return;
#line 4007 "PhotoTable.c"
			} else {
#line 626 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 626 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 626 "../src/db/PhotoTable.vala"
				return;
#line 4015 "PhotoTable.c"
			}
		}
	}
}

gboolean
photo_table_set_comment (PhotoTable* self,
                         PhotoID* photo_id,
                         const gchar* new_comment)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	gboolean result;
#line 630 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 630 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 631 "../src/db/PhotoTable.vala"
	if (new_comment != NULL) {
#line 631 "../src/db/PhotoTable.vala"
		_tmp0_ = new_comment;
#line 4037 "PhotoTable.c"
	} else {
#line 631 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 4041 "PhotoTable.c"
	}
#line 631 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 631 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "comment", _tmp0_);
#line 631 "../src/db/PhotoTable.vala"
	return result;
#line 4049 "PhotoTable.c"
}

void
photo_table_set_filepath (PhotoTable* self,
                          PhotoID* photo_id,
                          const gchar* filepath,
                          GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 634 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 634 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 634 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 635 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 635 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filename", filepath, &_inner_error0_);
#line 635 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 635 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 635 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 635 "../src/db/PhotoTable.vala"
			return;
#line 4078 "PhotoTable.c"
		} else {
#line 635 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 635 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 635 "../src/db/PhotoTable.vala"
			return;
#line 4086 "PhotoTable.c"
		}
	}
}

void
photo_table_update_timestamp (PhotoTable* self,
                              PhotoID* photo_id,
                              GDateTime* timestamp,
                              GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 638 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 638 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 638 "../src/db/PhotoTable.vala"
	g_return_if_fail (timestamp != NULL);
#line 639 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 639 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", g_date_time_to_unix (timestamp), &_inner_error0_);
#line 639 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 639 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 639 "../src/db/PhotoTable.vala"
			return;
#line 4117 "PhotoTable.c"
		} else {
#line 639 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 639 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 639 "../src/db/PhotoTable.vala"
			return;
#line 4125 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_set_exposure_time (PhotoTable* self,
                               PhotoID* photo_id,
                               GDateTime* time)
{
	PhotoID _tmp0_;
	gboolean result;
#line 642 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 642 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 642 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (time != NULL, FALSE);
#line 643 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 643 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "exposure_time", g_date_time_to_unix (time));
#line 643 "../src/db/PhotoTable.vala"
	return result;
#line 4149 "PhotoTable.c"
}

void
photo_table_set_import_id (PhotoTable* self,
                           PhotoID* photo_id,
                           ImportID* import_id,
                           GError** error)
{
	PhotoID _tmp0_;
	ImportID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 646 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 646 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 646 "../src/db/PhotoTable.vala"
	g_return_if_fail (import_id != NULL);
#line 647 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 647 "../src/db/PhotoTable.vala"
	_tmp1_ = *import_id;
#line 647 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "import_id", _tmp1_.id, &_inner_error0_);
#line 647 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 647 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 647 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 647 "../src/db/PhotoTable.vala"
			return;
#line 4181 "PhotoTable.c"
		} else {
#line 647 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 647 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 647 "../src/db/PhotoTable.vala"
			return;
#line 4189 "PhotoTable.c"
		}
	}
}

gboolean
photo_table_remove_by_file (PhotoTable* self,
                            GFile* file)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	gchar* _tmp4_;
	GDestroyNotify _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result;
#line 650 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 650 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 652 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 652 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM PhotoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 652 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 652 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 652 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 653 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 655 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 655 "../src/db/PhotoTable.vala"
	_tmp4_ = g_file_get_path (file);
#line 655 "../src/db/PhotoTable.vala"
	_tmp5_ = g_free;
#line 655 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp4_, -1, _tmp5_);
#line 656 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 658 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 658 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 659 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 660 "../src/db/PhotoTable.vala"
		database_table_warning ("remove", res);
#line 662 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 662 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 662 "../src/db/PhotoTable.vala"
		return result;
#line 4248 "PhotoTable.c"
	}
#line 665 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 665 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 665 "../src/db/PhotoTable.vala"
	return result;
#line 4256 "PhotoTable.c"
}

void
photo_table_remove (PhotoTable* self,
                    PhotoID* photo_id,
                    GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 668 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 668 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 669 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 669 "../src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 669 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 669 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 669 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 669 "../src/db/PhotoTable.vala"
			return;
#line 4282 "PhotoTable.c"
		} else {
#line 669 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 669 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 669 "../src/db/PhotoTable.vala"
			return;
#line 4290 "PhotoTable.c"
		}
	}
}

GeeArrayList*
photo_table_get_photos (PhotoTable* self)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	GeeArrayList* photo_ids = NULL;
	GeeArrayList* _tmp3_;
	GeeArrayList* result;
#line 672 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 674 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 674 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable", -1, &_tmp1_, NULL);
#line 674 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 674 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 674 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 675 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 677 "../src/db/PhotoTable.vala"
	_tmp3_ = gee_array_list_new (TYPE_PHOTO_ID, (GBoxedCopyFunc) photo_id_dup, (GDestroyNotify) photo_id_free, NULL, NULL, NULL);
#line 677 "../src/db/PhotoTable.vala"
	photo_ids = _tmp3_;
#line 4324 "PhotoTable.c"
	{
		gboolean _tmp4_ = FALSE;
#line 678 "../src/db/PhotoTable.vala"
		_tmp4_ = TRUE;
#line 678 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4331 "PhotoTable.c"
			sqlite3_stmt* _tmp5_;
			GeeArrayList* _tmp6_;
			sqlite3_stmt* _tmp7_;
			PhotoID _tmp8_ = {0};
#line 678 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 4338 "PhotoTable.c"
			}
#line 678 "../src/db/PhotoTable.vala"
			_tmp4_ = FALSE;
#line 679 "../src/db/PhotoTable.vala"
			_tmp5_ = stmt;
#line 679 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp5_);
#line 680 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 681 "../src/db/PhotoTable.vala"
				break;
#line 4350 "PhotoTable.c"
			} else {
#line 682 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 683 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_photos", res);
#line 685 "../src/db/PhotoTable.vala"
					break;
#line 4358 "PhotoTable.c"
				}
			}
#line 688 "../src/db/PhotoTable.vala"
			_tmp6_ = photo_ids;
#line 688 "../src/db/PhotoTable.vala"
			_tmp7_ = stmt;
#line 688 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp8_, sqlite3_column_int64 (_tmp7_, 0));
#line 688 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp8_);
#line 4369 "PhotoTable.c"
		}
	}
#line 691 "../src/db/PhotoTable.vala"
	result = photo_ids;
#line 691 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 691 "../src/db/PhotoTable.vala"
	return result;
#line 4378 "PhotoTable.c"
}

gboolean
photo_table_set_orientation (PhotoTable* self,
                             PhotoID* photo_id,
                             Orientation orientation)
{
	PhotoID _tmp0_;
	gboolean result;
#line 694 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 694 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 695 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 695 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "orientation", (gint) orientation);
#line 695 "../src/db/PhotoTable.vala"
	return result;
#line 4398 "PhotoTable.c"
}

gboolean
photo_table_replace_flags (PhotoTable* self,
                           PhotoID* photo_id,
                           guint64 flags)
{
	PhotoID _tmp0_;
	gboolean result;
#line 698 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 698 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 699 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 699 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "flags", (gint64) flags);
#line 699 "../src/db/PhotoTable.vala"
	return result;
#line 4418 "PhotoTable.c"
}

gboolean
photo_table_set_rating (PhotoTable* self,
                        PhotoID* photo_id,
                        Rating rating)
{
	PhotoID _tmp0_;
	gboolean result;
#line 702 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 702 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 703 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 703 "../src/db/PhotoTable.vala"
	result = database_table_update_int_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "rating", rating_serialize (rating));
#line 703 "../src/db/PhotoTable.vala"
	return result;
#line 4438 "PhotoTable.c"
}

gint
photo_table_get_event_photo_count (PhotoTable* self,
                                   EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	gint count = 0;
	gint result;
#line 706 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), 0);
#line 706 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, 0);
#line 708 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 708 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 708 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 708 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 708 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 709 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 711 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 711 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 711 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 712 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 714 "../src/db/PhotoTable.vala"
	count = 0;
#line 4480 "PhotoTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 715 "../src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 715 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4487 "PhotoTable.c"
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
#line 715 "../src/db/PhotoTable.vala"
			if (!_tmp5_) {
#line 4492 "PhotoTable.c"
			}
#line 715 "../src/db/PhotoTable.vala"
			_tmp5_ = FALSE;
#line 716 "../src/db/PhotoTable.vala"
			_tmp6_ = stmt;
#line 716 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp6_);
#line 717 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 718 "../src/db/PhotoTable.vala"
				break;
#line 4504 "PhotoTable.c"
			} else {
#line 719 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 720 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_photo_count", res);
#line 722 "../src/db/PhotoTable.vala"
					break;
#line 4512 "PhotoTable.c"
				}
			}
#line 725 "../src/db/PhotoTable.vala"
			_tmp7_ = count;
#line 725 "../src/db/PhotoTable.vala"
			count = _tmp7_ + 1;
#line 4519 "PhotoTable.c"
		}
	}
#line 728 "../src/db/PhotoTable.vala"
	result = count;
#line 728 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 728 "../src/db/PhotoTable.vala"
	return result;
#line 4528 "PhotoTable.c"
}

GeeArrayList*
photo_table_get_event_source_ids (PhotoTable* self,
                                  EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* result;
#line 731 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 731 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 733 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 733 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 733 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 733 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 733 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 734 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 736 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 736 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 736 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 737 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 739 "../src/db/PhotoTable.vala"
	_tmp5_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 739 "../src/db/PhotoTable.vala"
	_result_ = _tmp5_;
#line 4573 "PhotoTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 740 "../src/db/PhotoTable.vala"
		_tmp6_ = TRUE;
#line 740 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 4580 "PhotoTable.c"
			sqlite3_stmt* _tmp7_;
			GeeArrayList* _tmp8_;
			sqlite3_stmt* _tmp9_;
			PhotoID _tmp10_ = {0};
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 740 "../src/db/PhotoTable.vala"
			if (!_tmp6_) {
#line 4589 "PhotoTable.c"
			}
#line 740 "../src/db/PhotoTable.vala"
			_tmp6_ = FALSE;
#line 741 "../src/db/PhotoTable.vala"
			_tmp7_ = stmt;
#line 741 "../src/db/PhotoTable.vala"
			res = sqlite3_step (_tmp7_);
#line 742 "../src/db/PhotoTable.vala"
			if (res == SQLITE_DONE) {
#line 743 "../src/db/PhotoTable.vala"
				break;
#line 4601 "PhotoTable.c"
			} else {
#line 744 "../src/db/PhotoTable.vala"
				if (res != SQLITE_ROW) {
#line 745 "../src/db/PhotoTable.vala"
					database_table_fatal ("get_event_source_ids", res);
#line 747 "../src/db/PhotoTable.vala"
					break;
#line 4609 "PhotoTable.c"
				}
			}
#line 750 "../src/db/PhotoTable.vala"
			_tmp8_ = _result_;
#line 750 "../src/db/PhotoTable.vala"
			_tmp9_ = stmt;
#line 750 "../src/db/PhotoTable.vala"
			photo_id_init (&_tmp10_, sqlite3_column_int64 (_tmp9_, 0));
#line 750 "../src/db/PhotoTable.vala"
			_tmp11_ = photo_id_upgrade_photo_id_to_source_id (&_tmp10_);
#line 750 "../src/db/PhotoTable.vala"
			_tmp12_ = _tmp11_;
#line 750 "../src/db/PhotoTable.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 750 "../src/db/PhotoTable.vala"
			_g_free0 (_tmp12_);
#line 4626 "PhotoTable.c"
		}
	}
#line 753 "../src/db/PhotoTable.vala"
	result = _result_;
#line 753 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 753 "../src/db/PhotoTable.vala"
	return result;
#line 4635 "PhotoTable.c"
}

gboolean
photo_table_event_has_photos (PhotoTable* self,
                              EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	EventID _tmp4_;
	sqlite3_stmt* _tmp5_;
	gboolean result;
#line 756 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 756 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 758 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 758 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM PhotoTable WHERE event_id = ? LIMIT 1", -1, &_tmp1_, NULL);
#line 758 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 758 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 758 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 759 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 761 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 761 "../src/db/PhotoTable.vala"
	_tmp4_ = *event_id;
#line 761 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 762 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 764 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 764 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 765 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 766 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 766 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 766 "../src/db/PhotoTable.vala"
		return result;
#line 4687 "PhotoTable.c"
	} else {
#line 767 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 768 "../src/db/PhotoTable.vala"
			database_table_fatal ("event_has_photos", res);
#line 770 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 770 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 770 "../src/db/PhotoTable.vala"
			return result;
#line 4699 "PhotoTable.c"
		}
	}
#line 773 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 773 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 773 "../src/db/PhotoTable.vala"
	return result;
#line 4708 "PhotoTable.c"
}

gboolean
photo_table_drop_event (PhotoTable* self,
                        EventID* event_id)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	sqlite3_stmt* _tmp6_;
	gboolean result;
#line 776 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 776 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 778 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 778 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 778 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 778 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 778 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 779 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 781 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 781 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, EVENT_ID_INVALID);
#line 782 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 783 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 783 "../src/db/PhotoTable.vala"
	_tmp5_ = *event_id;
#line 783 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, _tmp5_.id);
#line 784 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 786 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 786 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp6_);
#line 787 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 788 "../src/db/PhotoTable.vala"
		database_table_fatal ("drop_event", res);
#line 790 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 790 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 790 "../src/db/PhotoTable.vala"
		return result;
#line 4769 "PhotoTable.c"
	}
#line 793 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 793 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 793 "../src/db/PhotoTable.vala"
	return result;
#line 4777 "PhotoTable.c"
}

gboolean
photo_table_set_event (PhotoTable* self,
                       PhotoID* photo_id,
                       EventID* event_id)
{
	PhotoID _tmp0_;
	EventID _tmp1_;
	gboolean result;
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 796 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 797 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 797 "../src/db/PhotoTable.vala"
	_tmp1_ = *event_id;
#line 797 "../src/db/PhotoTable.vala"
	result = database_table_update_int64_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "event_id", _tmp1_.id);
#line 797 "../src/db/PhotoTable.vala"
	return result;
#line 4802 "PhotoTable.c"
}

static gchar*
photo_table_get_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id)
{
	sqlite3_stmt* stmt = NULL;
	PhotoID _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gboolean _tmp2_;
	gchar* trans = NULL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* result;
#line 800 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 800 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 802 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 802 "../src/db/PhotoTable.vala"
	_tmp2_ = database_table_select_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "transformations", &_tmp1_);
#line 802 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 802 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 802 "../src/db/PhotoTable.vala"
	if (!_tmp2_) {
#line 803 "../src/db/PhotoTable.vala"
		result = NULL;
#line 803 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 803 "../src/db/PhotoTable.vala"
		return result;
#line 4840 "PhotoTable.c"
	}
#line 805 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 805 "../src/db/PhotoTable.vala"
	_tmp4_ = (const gchar*) sqlite3_column_text (_tmp3_, 0);
#line 805 "../src/db/PhotoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 805 "../src/db/PhotoTable.vala"
	trans = _tmp5_;
#line 806 "../src/db/PhotoTable.vala"
	_tmp7_ = trans;
#line 806 "../src/db/PhotoTable.vala"
	if (_tmp7_ == NULL) {
#line 806 "../src/db/PhotoTable.vala"
		_tmp6_ = TRUE;
#line 4856 "PhotoTable.c"
	} else {
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 806 "../src/db/PhotoTable.vala"
		_tmp8_ = trans;
#line 806 "../src/db/PhotoTable.vala"
		_tmp9_ = strlen (_tmp8_);
#line 806 "../src/db/PhotoTable.vala"
		_tmp10_ = _tmp9_;
#line 806 "../src/db/PhotoTable.vala"
		_tmp6_ = _tmp10_ == 0;
#line 4869 "PhotoTable.c"
	}
#line 806 "../src/db/PhotoTable.vala"
	if (_tmp6_) {
#line 807 "../src/db/PhotoTable.vala"
		result = NULL;
#line 807 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 807 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 807 "../src/db/PhotoTable.vala"
		return result;
#line 4881 "PhotoTable.c"
	}
#line 809 "../src/db/PhotoTable.vala"
	result = trans;
#line 809 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 809 "../src/db/PhotoTable.vala"
	return result;
#line 4889 "PhotoTable.c"
}

static gboolean
photo_table_set_raw_transformations (PhotoTable* self,
                                     PhotoID* photo_id,
                                     const gchar* trans)
{
	PhotoID _tmp0_;
	gboolean result;
#line 812 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 812 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 812 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 813 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 813 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "transformations", trans);
#line 813 "../src/db/PhotoTable.vala"
	return result;
#line 4911 "PhotoTable.c"
}

gboolean
photo_table_set_transformation_state (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation,
                                      GeeHashMap* transformations)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	PhotoID _tmp8_;
	sqlite3_stmt* _tmp9_;
	gboolean result;
#line 816 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 816 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 816 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), FALSE);
#line 819 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 819 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET orientation = ?, transformations = ? WHERE id = " \
"?", -1, &_tmp1_, NULL);
#line 819 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 819 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 819 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 821 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 823 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 823 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp3_, 1, (gint) orientation);
#line 824 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 825 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 825 "../src/db/PhotoTable.vala"
	_tmp5_ = photo_table_unmarshall_all_transformations (transformations);
#line 825 "../src/db/PhotoTable.vala"
	_tmp6_ = g_free;
#line 825 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp4_, 2, _tmp5_, -1, _tmp6_);
#line 826 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 827 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 827 "../src/db/PhotoTable.vala"
	_tmp8_ = *photo_id;
#line 827 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 3, _tmp8_.id);
#line 828 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 830 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 830 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp9_);
#line 831 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 832 "../src/db/PhotoTable.vala"
		database_table_fatal ("set_transformation_state", res);
#line 834 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 834 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 834 "../src/db/PhotoTable.vala"
		return result;
#line 4989 "PhotoTable.c"
	}
#line 837 "../src/db/PhotoTable.vala"
	result = TRUE;
#line 837 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 837 "../src/db/PhotoTable.vala"
	return result;
#line 4997 "PhotoTable.c"
}

GeeHashMap*
photo_table_marshall_all_transformations (const gchar* trans)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 841 "../src/db/PhotoTable.vala"
	if (trans == NULL) {
#line 841 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 5010 "PhotoTable.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 841 "../src/db/PhotoTable.vala"
		_tmp1_ = strlen (trans);
#line 841 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 841 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp2_ == 0;
#line 5020 "PhotoTable.c"
	}
#line 841 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 842 "../src/db/PhotoTable.vala"
		result = NULL;
#line 842 "../src/db/PhotoTable.vala"
		return result;
#line 5028 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GeeHashMap* map = NULL;
		GeeHashMap* _tmp8_;
		gchar** objects = NULL;
		GKeyFile* _tmp9_;
		gsize _tmp10_ = 0;
		gchar** _tmp11_;
		gint objects_length1;
		gint _objects_size_;
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 845 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 845 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 846 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 846 "../src/db/PhotoTable.vala"
		_tmp6_ = strlen (trans);
#line 846 "../src/db/PhotoTable.vala"
		_tmp7_ = _tmp6_;
#line 846 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, trans, (gsize) _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 846 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 846 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5063 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 846 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 847 "../src/db/PhotoTable.vala"
			result = NULL;
#line 847 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 847 "../src/db/PhotoTable.vala"
			return result;
#line 5074 "PhotoTable.c"
		}
#line 849 "../src/db/PhotoTable.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 849 "../src/db/PhotoTable.vala"
		map = _tmp8_;
#line 851 "../src/db/PhotoTable.vala"
		_tmp9_ = keyfile;
#line 851 "../src/db/PhotoTable.vala"
		_tmp11_ = g_key_file_get_groups (_tmp9_, &_tmp10_);
#line 851 "../src/db/PhotoTable.vala"
		objects = _tmp11_;
#line 851 "../src/db/PhotoTable.vala"
		objects_length1 = _tmp10_;
#line 851 "../src/db/PhotoTable.vala"
		_objects_size_ = objects_length1;
#line 852 "../src/db/PhotoTable.vala"
		_tmp12_ = objects;
#line 852 "../src/db/PhotoTable.vala"
		_tmp12__length1 = objects_length1;
#line 5094 "PhotoTable.c"
		{
			gchar** object_collection = NULL;
			gint object_collection_length1 = 0;
			gint _object_collection_size_ = 0;
			gint object_it = 0;
#line 852 "../src/db/PhotoTable.vala"
			object_collection = _tmp12_;
#line 852 "../src/db/PhotoTable.vala"
			object_collection_length1 = _tmp12__length1;
#line 852 "../src/db/PhotoTable.vala"
			for (object_it = 0; object_it < object_collection_length1; object_it = object_it + 1) {
#line 5106 "PhotoTable.c"
				gchar* _tmp13_;
				gchar* object = NULL;
#line 852 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strdup (object_collection[object_it]);
#line 852 "../src/db/PhotoTable.vala"
				object = _tmp13_;
#line 5113 "PhotoTable.c"
				{
					gchar** keys = NULL;
					GKeyFile* _tmp14_;
					const gchar* _tmp15_;
					gsize _tmp16_ = 0;
					gchar** _tmp17_;
					gint keys_length1;
					gint _keys_size_;
					gboolean _tmp18_ = FALSE;
					gchar** _tmp19_;
					gint _tmp19__length1;
					KeyValueMap* key_map = NULL;
					const gchar* _tmp21_;
					KeyValueMap* _tmp22_;
					GeeHashMap* _tmp35_;
					const gchar* _tmp36_;
					KeyValueMap* _tmp37_;
#line 853 "../src/db/PhotoTable.vala"
					_tmp14_ = keyfile;
#line 853 "../src/db/PhotoTable.vala"
					_tmp15_ = object;
#line 853 "../src/db/PhotoTable.vala"
					_tmp17_ = g_key_file_get_keys (_tmp14_, _tmp15_, &_tmp16_, &_inner_error0_);
#line 853 "../src/db/PhotoTable.vala"
					keys = _tmp17_;
#line 853 "../src/db/PhotoTable.vala"
					keys_length1 = _tmp16_;
#line 853 "../src/db/PhotoTable.vala"
					_keys_size_ = keys_length1;
#line 853 "../src/db/PhotoTable.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 853 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 853 "../src/db/PhotoTable.vala"
						objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 853 "../src/db/PhotoTable.vala"
						_g_object_unref0 (map);
#line 853 "../src/db/PhotoTable.vala"
						_g_key_file_unref0 (keyfile);
#line 5153 "PhotoTable.c"
						goto __catch0_g_error;
					}
#line 854 "../src/db/PhotoTable.vala"
					_tmp19_ = keys;
#line 854 "../src/db/PhotoTable.vala"
					_tmp19__length1 = keys_length1;
#line 854 "../src/db/PhotoTable.vala"
					if (_tmp19_ == NULL) {
#line 854 "../src/db/PhotoTable.vala"
						_tmp18_ = TRUE;
#line 5164 "PhotoTable.c"
					} else {
						gchar** _tmp20_;
						gint _tmp20__length1;
#line 854 "../src/db/PhotoTable.vala"
						_tmp20_ = keys;
#line 854 "../src/db/PhotoTable.vala"
						_tmp20__length1 = keys_length1;
#line 854 "../src/db/PhotoTable.vala"
						_tmp18_ = _tmp20__length1 == 0;
#line 5174 "PhotoTable.c"
					}
#line 854 "../src/db/PhotoTable.vala"
					if (_tmp18_) {
#line 855 "../src/db/PhotoTable.vala"
						keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 855 "../src/db/PhotoTable.vala"
						_g_free0 (object);
#line 855 "../src/db/PhotoTable.vala"
						continue;
#line 5184 "PhotoTable.c"
					}
#line 857 "../src/db/PhotoTable.vala"
					_tmp21_ = object;
#line 857 "../src/db/PhotoTable.vala"
					_tmp22_ = key_value_map_new (_tmp21_);
#line 857 "../src/db/PhotoTable.vala"
					key_map = _tmp22_;
#line 5192 "PhotoTable.c"
					{
						gint ctr = 0;
#line 858 "../src/db/PhotoTable.vala"
						ctr = 0;
#line 5197 "PhotoTable.c"
						{
							gboolean _tmp23_ = FALSE;
#line 858 "../src/db/PhotoTable.vala"
							_tmp23_ = TRUE;
#line 858 "../src/db/PhotoTable.vala"
							while (TRUE) {
#line 5204 "PhotoTable.c"
								gchar** _tmp25_;
								gint _tmp25__length1;
								gchar* _tmp26_ = NULL;
								GKeyFile* _tmp27_;
								const gchar* _tmp28_;
								gchar** _tmp29_;
								gint _tmp29__length1;
								const gchar* _tmp30_;
								gchar* _tmp31_;
								KeyValueMap* _tmp32_;
								gchar** _tmp33_;
								gint _tmp33__length1;
								const gchar* _tmp34_;
#line 858 "../src/db/PhotoTable.vala"
								if (!_tmp23_) {
#line 5220 "PhotoTable.c"
									gint _tmp24_;
#line 858 "../src/db/PhotoTable.vala"
									_tmp24_ = ctr;
#line 858 "../src/db/PhotoTable.vala"
									ctr = _tmp24_ + 1;
#line 5226 "PhotoTable.c"
								}
#line 858 "../src/db/PhotoTable.vala"
								_tmp23_ = FALSE;
#line 858 "../src/db/PhotoTable.vala"
								_tmp25_ = keys;
#line 858 "../src/db/PhotoTable.vala"
								_tmp25__length1 = keys_length1;
#line 858 "../src/db/PhotoTable.vala"
								if (!(ctr < _tmp25__length1)) {
#line 858 "../src/db/PhotoTable.vala"
									break;
#line 5238 "PhotoTable.c"
								}
#line 859 "../src/db/PhotoTable.vala"
								_tmp27_ = keyfile;
#line 859 "../src/db/PhotoTable.vala"
								_tmp28_ = object;
#line 859 "../src/db/PhotoTable.vala"
								_tmp29_ = keys;
#line 859 "../src/db/PhotoTable.vala"
								_tmp29__length1 = keys_length1;
#line 859 "../src/db/PhotoTable.vala"
								_tmp30_ = _tmp29_[ctr];
#line 859 "../src/db/PhotoTable.vala"
								_tmp31_ = g_key_file_get_string (_tmp27_, _tmp28_, _tmp30_, &_inner_error0_);
#line 859 "../src/db/PhotoTable.vala"
								_tmp26_ = _tmp31_;
#line 859 "../src/db/PhotoTable.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 859 "../src/db/PhotoTable.vala"
									_key_value_map_unref0 (key_map);
#line 859 "../src/db/PhotoTable.vala"
									keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 859 "../src/db/PhotoTable.vala"
									_g_free0 (object);
#line 859 "../src/db/PhotoTable.vala"
									objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 859 "../src/db/PhotoTable.vala"
									_g_object_unref0 (map);
#line 859 "../src/db/PhotoTable.vala"
									_g_key_file_unref0 (keyfile);
#line 5268 "PhotoTable.c"
									goto __catch0_g_error;
								}
#line 859 "../src/db/PhotoTable.vala"
								_tmp32_ = key_map;
#line 859 "../src/db/PhotoTable.vala"
								_tmp33_ = keys;
#line 859 "../src/db/PhotoTable.vala"
								_tmp33__length1 = keys_length1;
#line 859 "../src/db/PhotoTable.vala"
								_tmp34_ = _tmp33_[ctr];
#line 859 "../src/db/PhotoTable.vala"
								key_value_map_set_string (_tmp32_, _tmp34_, _tmp26_);
#line 858 "../src/db/PhotoTable.vala"
								_g_free0 (_tmp26_);
#line 5283 "PhotoTable.c"
							}
						}
					}
#line 861 "../src/db/PhotoTable.vala"
					_tmp35_ = map;
#line 861 "../src/db/PhotoTable.vala"
					_tmp36_ = object;
#line 861 "../src/db/PhotoTable.vala"
					_tmp37_ = key_map;
#line 861 "../src/db/PhotoTable.vala"
					gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp36_, _tmp37_);
#line 852 "../src/db/PhotoTable.vala"
					_key_value_map_unref0 (key_map);
#line 852 "../src/db/PhotoTable.vala"
					keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 852 "../src/db/PhotoTable.vala"
					_g_free0 (object);
#line 5301 "PhotoTable.c"
				}
			}
		}
#line 864 "../src/db/PhotoTable.vala"
		result = map;
#line 864 "../src/db/PhotoTable.vala"
		objects = (_vala_array_free (objects, objects_length1, (GDestroyNotify) g_free), NULL);
#line 864 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 864 "../src/db/PhotoTable.vala"
		return result;
#line 5313 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp38_;
#line 844 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 844 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 866 "../src/db/PhotoTable.vala"
		_tmp38_ = err->message;
#line 866 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:866: %s", _tmp38_);
#line 844 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5330 "PhotoTable.c"
	}
	__finally0:
#line 844 "../src/db/PhotoTable.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 844 "../src/db/PhotoTable.vala"
	g_clear_error (&_inner_error0_);
#line 844 "../src/db/PhotoTable.vala"
	return NULL;
#line 5339 "PhotoTable.c"
}

gchar*
photo_table_unmarshall_all_transformations (GeeHashMap* transformations)
{
	gboolean _tmp0_ = FALSE;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp6_;
	gsize length = 0UL;
	gchar* unmarshalled = NULL;
	GKeyFile* _tmp33_;
	gsize _tmp34_ = 0UL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gchar* result;
#line 870 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((transformations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (transformations, GEE_TYPE_HASH_MAP), NULL);
#line 871 "../src/db/PhotoTable.vala"
	if (transformations == NULL) {
#line 871 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 5364 "PhotoTable.c"
	} else {
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 871 "../src/db/PhotoTable.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 871 "../src/db/PhotoTable.vala"
		_tmp2_ = _tmp1_;
#line 871 "../src/db/PhotoTable.vala"
		_tmp3_ = _tmp2_;
#line 871 "../src/db/PhotoTable.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 871 "../src/db/PhotoTable.vala"
		_tmp5_ = _tmp4_;
#line 871 "../src/db/PhotoTable.vala"
		_tmp0_ = _tmp5_ == 0;
#line 871 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp3_);
#line 5385 "PhotoTable.c"
	}
#line 871 "../src/db/PhotoTable.vala"
	if (_tmp0_) {
#line 872 "../src/db/PhotoTable.vala"
		result = NULL;
#line 872 "../src/db/PhotoTable.vala"
		return result;
#line 5393 "PhotoTable.c"
	}
#line 874 "../src/db/PhotoTable.vala"
	_tmp6_ = g_key_file_new ();
#line 874 "../src/db/PhotoTable.vala"
	keyfile = _tmp6_;
#line 5399 "PhotoTable.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 876 "../src/db/PhotoTable.vala"
		_tmp7_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 876 "../src/db/PhotoTable.vala"
		_tmp8_ = _tmp7_;
#line 876 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 876 "../src/db/PhotoTable.vala"
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 876 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 876 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_tmp9_);
#line 876 "../src/db/PhotoTable.vala"
		_object_it = _tmp11_;
#line 876 "../src/db/PhotoTable.vala"
		while (TRUE) {
#line 5423 "PhotoTable.c"
			GeeIterator* _tmp12_;
			gchar* object = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			KeyValueMap* map = NULL;
			const gchar* _tmp15_;
			gpointer _tmp16_;
#line 876 "../src/db/PhotoTable.vala"
			_tmp12_ = _object_it;
#line 876 "../src/db/PhotoTable.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 876 "../src/db/PhotoTable.vala"
				break;
#line 5437 "PhotoTable.c"
			}
#line 876 "../src/db/PhotoTable.vala"
			_tmp13_ = _object_it;
#line 876 "../src/db/PhotoTable.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 876 "../src/db/PhotoTable.vala"
			object = (gchar*) _tmp14_;
#line 877 "../src/db/PhotoTable.vala"
			_tmp15_ = object;
#line 877 "../src/db/PhotoTable.vala"
			_tmp16_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (transformations, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp15_);
#line 877 "../src/db/PhotoTable.vala"
			map = (KeyValueMap*) _tmp16_;
#line 5451 "PhotoTable.c"
			{
				GeeIterator* _key_it = NULL;
				KeyValueMap* _tmp17_;
				GeeSet* _tmp18_;
				GeeSet* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 879 "../src/db/PhotoTable.vala"
				_tmp17_ = map;
#line 879 "../src/db/PhotoTable.vala"
				_tmp18_ = key_value_map_get_keys (_tmp17_);
#line 879 "../src/db/PhotoTable.vala"
				_tmp19_ = _tmp18_;
#line 879 "../src/db/PhotoTable.vala"
				_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ITERABLE, GeeIterable));
#line 879 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 879 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_tmp19_);
#line 879 "../src/db/PhotoTable.vala"
				_key_it = _tmp21_;
#line 879 "../src/db/PhotoTable.vala"
				while (TRUE) {
#line 5475 "PhotoTable.c"
					GeeIterator* _tmp22_;
					gchar* key = NULL;
					GeeIterator* _tmp23_;
					gpointer _tmp24_;
					gchar* value = NULL;
					KeyValueMap* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					GKeyFile* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
#line 879 "../src/db/PhotoTable.vala"
					_tmp22_ = _key_it;
#line 879 "../src/db/PhotoTable.vala"
					if (!gee_iterator_next (_tmp22_)) {
#line 879 "../src/db/PhotoTable.vala"
						break;
#line 5495 "PhotoTable.c"
					}
#line 879 "../src/db/PhotoTable.vala"
					_tmp23_ = _key_it;
#line 879 "../src/db/PhotoTable.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 879 "../src/db/PhotoTable.vala"
					key = (gchar*) _tmp24_;
#line 880 "../src/db/PhotoTable.vala"
					_tmp25_ = map;
#line 880 "../src/db/PhotoTable.vala"
					_tmp26_ = key;
#line 880 "../src/db/PhotoTable.vala"
					_tmp27_ = key_value_map_get_string (_tmp25_, _tmp26_, NULL);
#line 880 "../src/db/PhotoTable.vala"
					value = _tmp27_;
#line 881 "../src/db/PhotoTable.vala"
					_tmp28_ = value;
#line 881 "../src/db/PhotoTable.vala"
					_vala_assert (_tmp28_ != NULL, "value != null");
#line 883 "../src/db/PhotoTable.vala"
					_tmp29_ = keyfile;
#line 883 "../src/db/PhotoTable.vala"
					_tmp30_ = object;
#line 883 "../src/db/PhotoTable.vala"
					_tmp31_ = key;
#line 883 "../src/db/PhotoTable.vala"
					_tmp32_ = value;
#line 883 "../src/db/PhotoTable.vala"
					g_key_file_set_string (_tmp29_, _tmp30_, _tmp31_, _tmp32_);
#line 879 "../src/db/PhotoTable.vala"
					_g_free0 (value);
#line 879 "../src/db/PhotoTable.vala"
					_g_free0 (key);
#line 5529 "PhotoTable.c"
				}
#line 879 "../src/db/PhotoTable.vala"
				_g_object_unref0 (_key_it);
#line 5533 "PhotoTable.c"
			}
#line 876 "../src/db/PhotoTable.vala"
			_key_value_map_unref0 (map);
#line 876 "../src/db/PhotoTable.vala"
			_g_free0 (object);
#line 5539 "PhotoTable.c"
		}
#line 876 "../src/db/PhotoTable.vala"
		_g_object_unref0 (_object_it);
#line 5543 "PhotoTable.c"
	}
#line 888 "../src/db/PhotoTable.vala"
	_tmp33_ = keyfile;
#line 888 "../src/db/PhotoTable.vala"
	_tmp35_ = g_key_file_to_data (_tmp33_, &_tmp34_, NULL);
#line 888 "../src/db/PhotoTable.vala"
	length = _tmp34_;
#line 888 "../src/db/PhotoTable.vala"
	unmarshalled = _tmp35_;
#line 889 "../src/db/PhotoTable.vala"
	_tmp36_ = unmarshalled;
#line 889 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp36_ != NULL, "unmarshalled != null");
#line 890 "../src/db/PhotoTable.vala"
	_tmp37_ = unmarshalled;
#line 890 "../src/db/PhotoTable.vala"
	_tmp38_ = strlen (_tmp37_);
#line 890 "../src/db/PhotoTable.vala"
	_tmp39_ = _tmp38_;
#line 890 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp39_ > 0, "unmarshalled.length > 0");
#line 892 "../src/db/PhotoTable.vala"
	result = unmarshalled;
#line 892 "../src/db/PhotoTable.vala"
	_g_key_file_unref0 (keyfile);
#line 892 "../src/db/PhotoTable.vala"
	return result;
#line 5571 "PhotoTable.c"
}

gboolean
photo_table_set_transformation (PhotoTable* self,
                                PhotoID* photo_id,
                                KeyValueMap* map)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	PhotoID _tmp33_;
	const gchar* _tmp34_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 895 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 895 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 895 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, TYPE_KEY_VALUE_MAP), FALSE);
#line 896 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 896 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 896 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 5598 "PhotoTable.c"
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp2_;
		const gchar* _tmp3_;
		GeeSet* keys = NULL;
		GeeSet* _tmp10_;
		gsize length = 0UL;
		GKeyFile* _tmp24_;
		gsize _tmp25_ = 0UL;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 899 "../src/db/PhotoTable.vala"
		_tmp2_ = g_key_file_new ();
#line 899 "../src/db/PhotoTable.vala"
		keyfile = _tmp2_;
#line 900 "../src/db/PhotoTable.vala"
		_tmp3_ = trans;
#line 900 "../src/db/PhotoTable.vala"
		if (_tmp3_ != NULL) {
#line 5621 "PhotoTable.c"
			gboolean _tmp4_ = FALSE;
			GKeyFile* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 901 "../src/db/PhotoTable.vala"
			_tmp5_ = keyfile;
#line 901 "../src/db/PhotoTable.vala"
			_tmp6_ = trans;
#line 901 "../src/db/PhotoTable.vala"
			_tmp7_ = trans;
#line 901 "../src/db/PhotoTable.vala"
			_tmp8_ = strlen (_tmp7_);
#line 901 "../src/db/PhotoTable.vala"
			_tmp9_ = _tmp8_;
#line 901 "../src/db/PhotoTable.vala"
			_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 901 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 901 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 5644 "PhotoTable.c"
				goto __catch0_g_error;
			}
#line 901 "../src/db/PhotoTable.vala"
			if (!_tmp4_) {
#line 902 "../src/db/PhotoTable.vala"
				result = FALSE;
#line 902 "../src/db/PhotoTable.vala"
				_g_key_file_unref0 (keyfile);
#line 902 "../src/db/PhotoTable.vala"
				_g_free0 (trans);
#line 902 "../src/db/PhotoTable.vala"
				return result;
#line 5657 "PhotoTable.c"
			}
		}
#line 905 "../src/db/PhotoTable.vala"
		_tmp10_ = key_value_map_get_keys (map);
#line 905 "../src/db/PhotoTable.vala"
		keys = _tmp10_;
#line 5664 "PhotoTable.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp11_;
			GeeIterator* _tmp12_;
#line 906 "../src/db/PhotoTable.vala"
			_tmp11_ = keys;
#line 906 "../src/db/PhotoTable.vala"
			_tmp12_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ITERABLE, GeeIterable));
#line 906 "../src/db/PhotoTable.vala"
			_key_it = _tmp12_;
#line 906 "../src/db/PhotoTable.vala"
			while (TRUE) {
#line 5677 "PhotoTable.c"
				GeeIterator* _tmp13_;
				gchar* key = NULL;
				GeeIterator* _tmp14_;
				gpointer _tmp15_;
				gchar* value = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GKeyFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 906 "../src/db/PhotoTable.vala"
				_tmp13_ = _key_it;
#line 906 "../src/db/PhotoTable.vala"
				if (!gee_iterator_next (_tmp13_)) {
#line 906 "../src/db/PhotoTable.vala"
					break;
#line 5697 "PhotoTable.c"
				}
#line 906 "../src/db/PhotoTable.vala"
				_tmp14_ = _key_it;
#line 906 "../src/db/PhotoTable.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 906 "../src/db/PhotoTable.vala"
				key = (gchar*) _tmp15_;
#line 907 "../src/db/PhotoTable.vala"
				_tmp16_ = key;
#line 907 "../src/db/PhotoTable.vala"
				_tmp17_ = key_value_map_get_string (map, _tmp16_, NULL);
#line 907 "../src/db/PhotoTable.vala"
				value = _tmp17_;
#line 908 "../src/db/PhotoTable.vala"
				_tmp18_ = value;
#line 908 "../src/db/PhotoTable.vala"
				_vala_assert (_tmp18_ != NULL, "value != null");
#line 910 "../src/db/PhotoTable.vala"
				_tmp19_ = keyfile;
#line 910 "../src/db/PhotoTable.vala"
				_tmp20_ = key_value_map_get_group (map);
#line 910 "../src/db/PhotoTable.vala"
				_tmp21_ = _tmp20_;
#line 910 "../src/db/PhotoTable.vala"
				_tmp22_ = key;
#line 910 "../src/db/PhotoTable.vala"
				_tmp23_ = value;
#line 910 "../src/db/PhotoTable.vala"
				g_key_file_set_string (_tmp19_, _tmp21_, _tmp22_, _tmp23_);
#line 910 "../src/db/PhotoTable.vala"
				_g_free0 (_tmp21_);
#line 906 "../src/db/PhotoTable.vala"
				_g_free0 (value);
#line 906 "../src/db/PhotoTable.vala"
				_g_free0 (key);
#line 5733 "PhotoTable.c"
			}
#line 906 "../src/db/PhotoTable.vala"
			_g_object_unref0 (_key_it);
#line 5737 "PhotoTable.c"
		}
#line 914 "../src/db/PhotoTable.vala"
		_tmp24_ = keyfile;
#line 914 "../src/db/PhotoTable.vala"
		_tmp26_ = g_key_file_to_data (_tmp24_, &_tmp25_, NULL);
#line 914 "../src/db/PhotoTable.vala"
		length = _tmp25_;
#line 914 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 914 "../src/db/PhotoTable.vala"
		trans = _tmp26_;
#line 915 "../src/db/PhotoTable.vala"
		_tmp27_ = trans;
#line 915 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp27_ != NULL, "trans != null");
#line 916 "../src/db/PhotoTable.vala"
		_tmp28_ = trans;
#line 916 "../src/db/PhotoTable.vala"
		_tmp29_ = strlen (_tmp28_);
#line 916 "../src/db/PhotoTable.vala"
		_tmp30_ = _tmp29_;
#line 916 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp30_ > 0, "trans.length > 0");
#line 898 "../src/db/PhotoTable.vala"
		_g_object_unref0 (keys);
#line 898 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 5765 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp31_;
#line 898 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 898 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 918 "../src/db/PhotoTable.vala"
		_tmp31_ = err->message;
#line 918 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:918: %s", _tmp31_);
#line 898 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5782 "PhotoTable.c"
	}
	__finally0:
#line 898 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5787 "PhotoTable.c"
		gboolean _tmp32_ = FALSE;
#line 898 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 898 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 898 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 898 "../src/db/PhotoTable.vala"
		return _tmp32_;
#line 5797 "PhotoTable.c"
	}
#line 921 "../src/db/PhotoTable.vala"
	_tmp33_ = *photo_id;
#line 921 "../src/db/PhotoTable.vala"
	_tmp34_ = trans;
#line 921 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp33_, _tmp34_);
#line 921 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 921 "../src/db/PhotoTable.vala"
	return result;
#line 5809 "PhotoTable.c"
}

gboolean
photo_table_remove_transformation (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* object)
{
	gchar* trans = NULL;
	PhotoID _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoID _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 924 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 924 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 924 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 925 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 925 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 925 "../src/db/PhotoTable.vala"
	trans = _tmp1_;
#line 926 "../src/db/PhotoTable.vala"
	_tmp2_ = trans;
#line 926 "../src/db/PhotoTable.vala"
	if (_tmp2_ == NULL) {
#line 927 "../src/db/PhotoTable.vala"
		result = TRUE;
#line 927 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 927 "../src/db/PhotoTable.vala"
		return result;
#line 5847 "PhotoTable.c"
	}
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		GKeyFile* _tmp10_;
		GKeyFile* _tmp11_;
		gsize length = 0UL;
		GKeyFile* _tmp12_;
		gsize _tmp13_ = 0UL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 930 "../src/db/PhotoTable.vala"
		_tmp3_ = g_key_file_new ();
#line 930 "../src/db/PhotoTable.vala"
		keyfile = _tmp3_;
#line 931 "../src/db/PhotoTable.vala"
		_tmp5_ = keyfile;
#line 931 "../src/db/PhotoTable.vala"
		_tmp6_ = trans;
#line 931 "../src/db/PhotoTable.vala"
		_tmp7_ = trans;
#line 931 "../src/db/PhotoTable.vala"
		_tmp8_ = strlen (_tmp7_);
#line 931 "../src/db/PhotoTable.vala"
		_tmp9_ = _tmp8_;
#line 931 "../src/db/PhotoTable.vala"
		_tmp4_ = g_key_file_load_from_data (_tmp5_, _tmp6_, (gsize) _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 931 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 931 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5885 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 931 "../src/db/PhotoTable.vala"
		if (!_tmp4_) {
#line 932 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 932 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 932 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 932 "../src/db/PhotoTable.vala"
			return result;
#line 5898 "PhotoTable.c"
		}
#line 934 "../src/db/PhotoTable.vala"
		_tmp10_ = keyfile;
#line 934 "../src/db/PhotoTable.vala"
		if (!g_key_file_has_group (_tmp10_, object)) {
#line 935 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 935 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 935 "../src/db/PhotoTable.vala"
			_g_free0 (trans);
#line 935 "../src/db/PhotoTable.vala"
			return result;
#line 5912 "PhotoTable.c"
		}
#line 937 "../src/db/PhotoTable.vala"
		_tmp11_ = keyfile;
#line 937 "../src/db/PhotoTable.vala"
		g_key_file_remove_group (_tmp11_, object, &_inner_error0_);
#line 937 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 937 "../src/db/PhotoTable.vala"
			_g_key_file_unref0 (keyfile);
#line 5922 "PhotoTable.c"
			goto __catch0_g_error;
		}
#line 940 "../src/db/PhotoTable.vala"
		_tmp12_ = keyfile;
#line 940 "../src/db/PhotoTable.vala"
		_tmp14_ = g_key_file_to_data (_tmp12_, &_tmp13_, NULL);
#line 940 "../src/db/PhotoTable.vala"
		length = _tmp13_;
#line 940 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 940 "../src/db/PhotoTable.vala"
		trans = _tmp14_;
#line 941 "../src/db/PhotoTable.vala"
		_tmp15_ = trans;
#line 941 "../src/db/PhotoTable.vala"
		_vala_assert (_tmp15_ != NULL, "trans != null");
#line 929 "../src/db/PhotoTable.vala"
		_g_key_file_unref0 (keyfile);
#line 5941 "PhotoTable.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp16_;
#line 929 "../src/db/PhotoTable.vala"
		err = _inner_error0_;
#line 929 "../src/db/PhotoTable.vala"
		_inner_error0_ = NULL;
#line 943 "../src/db/PhotoTable.vala"
		_tmp16_ = err->message;
#line 943 "../src/db/PhotoTable.vala"
		g_error ("PhotoTable.vala:943: %s", _tmp16_);
#line 929 "../src/db/PhotoTable.vala"
		_g_error_free0 (err);
#line 5958 "PhotoTable.c"
	}
	__finally0:
#line 929 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5963 "PhotoTable.c"
		gboolean _tmp17_ = FALSE;
#line 929 "../src/db/PhotoTable.vala"
		_g_free0 (trans);
#line 929 "../src/db/PhotoTable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 929 "../src/db/PhotoTable.vala"
		g_clear_error (&_inner_error0_);
#line 929 "../src/db/PhotoTable.vala"
		return _tmp17_;
#line 5973 "PhotoTable.c"
	}
#line 946 "../src/db/PhotoTable.vala"
	_tmp18_ = *photo_id;
#line 946 "../src/db/PhotoTable.vala"
	_tmp19_ = trans;
#line 946 "../src/db/PhotoTable.vala"
	result = photo_table_set_raw_transformations (self, &_tmp18_, _tmp19_);
#line 946 "../src/db/PhotoTable.vala"
	_g_free0 (trans);
#line 946 "../src/db/PhotoTable.vala"
	return result;
#line 5985 "PhotoTable.c"
}

gboolean
photo_table_remove_all_transformations (PhotoTable* self,
                                        PhotoID* photo_id)
{
	PhotoID _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	PhotoID _tmp4_;
	gboolean result;
#line 949 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 949 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (photo_id != NULL, FALSE);
#line 950 "../src/db/PhotoTable.vala"
	_tmp0_ = *photo_id;
#line 950 "../src/db/PhotoTable.vala"
	_tmp1_ = photo_table_get_raw_transformations (self, &_tmp0_);
#line 950 "../src/db/PhotoTable.vala"
	_tmp2_ = _tmp1_;
#line 950 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_ == NULL;
#line 950 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp2_);
#line 950 "../src/db/PhotoTable.vala"
	if (_tmp3_) {
#line 951 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 951 "../src/db/PhotoTable.vala"
		return result;
#line 6018 "PhotoTable.c"
	}
#line 953 "../src/db/PhotoTable.vala"
	_tmp4_ = *photo_id;
#line 953 "../src/db/PhotoTable.vala"
	result = database_table_update_text_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp4_.id, "transformations", "");
#line 953 "../src/db/PhotoTable.vala"
	return result;
#line 6026 "PhotoTable.c"
}

static sqlite3_stmt*
photo_table_get_duplicate_stmt (PhotoTable* self,
                                GFile* file,
                                const gchar* thumbnail_md5,
                                const gchar* md5,
                                PhotoFileFormat file_format)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* sql = NULL;
	gchar* _tmp2_;
	gboolean first = FALSE;
	gboolean _tmp5_ = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp22_;
	const gchar* _tmp23_;
	sqlite3_stmt* _tmp24_ = NULL;
	gint _tmp25_;
	gint col = 0;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	sqlite3_stmt* result;
#line 958 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 958 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 960 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 960 "../src/db/PhotoTable.vala"
		_tmp1_ = TRUE;
#line 6060 "PhotoTable.c"
	} else {
#line 960 "../src/db/PhotoTable.vala"
		_tmp1_ = thumbnail_md5 != NULL;
#line 6064 "PhotoTable.c"
	}
#line 960 "../src/db/PhotoTable.vala"
	if (_tmp1_) {
#line 960 "../src/db/PhotoTable.vala"
		_tmp0_ = TRUE;
#line 6070 "PhotoTable.c"
	} else {
#line 960 "../src/db/PhotoTable.vala"
		_tmp0_ = md5 != NULL;
#line 6074 "PhotoTable.c"
	}
#line 960 "../src/db/PhotoTable.vala"
	_vala_assert (_tmp0_, "file != null || thumbnail_md5 != null || md5 != null");
#line 962 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup ("SELECT id FROM PhotoTable WHERE");
#line 962 "../src/db/PhotoTable.vala"
	sql = _tmp2_;
#line 963 "../src/db/PhotoTable.vala"
	first = TRUE;
#line 965 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 6086 "PhotoTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 966 "../src/db/PhotoTable.vala"
		_tmp3_ = sql;
#line 966 "../src/db/PhotoTable.vala"
		_tmp4_ = g_strconcat (_tmp3_, " filename=?", NULL);
#line 966 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 966 "../src/db/PhotoTable.vala"
		sql = _tmp4_;
#line 967 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 6099 "PhotoTable.c"
	}
#line 970 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 970 "../src/db/PhotoTable.vala"
		_tmp5_ = TRUE;
#line 6105 "PhotoTable.c"
	} else {
#line 970 "../src/db/PhotoTable.vala"
		_tmp5_ = md5 != NULL;
#line 6109 "PhotoTable.c"
	}
#line 970 "../src/db/PhotoTable.vala"
	if (_tmp5_) {
#line 6113 "PhotoTable.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
#line 971 "../src/db/PhotoTable.vala"
		if (first) {
#line 6120 "PhotoTable.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 972 "../src/db/PhotoTable.vala"
			_tmp6_ = sql;
#line 972 "../src/db/PhotoTable.vala"
			_tmp7_ = g_strconcat (_tmp6_, " ((", NULL);
#line 972 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 972 "../src/db/PhotoTable.vala"
			sql = _tmp7_;
#line 6131 "PhotoTable.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 974 "../src/db/PhotoTable.vala"
			_tmp8_ = sql;
#line 974 "../src/db/PhotoTable.vala"
			_tmp9_ = g_strconcat (_tmp8_, " OR ((", NULL);
#line 974 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 974 "../src/db/PhotoTable.vala"
			sql = _tmp9_;
#line 6143 "PhotoTable.c"
		}
#line 975 "../src/db/PhotoTable.vala"
		first = FALSE;
#line 977 "../src/db/PhotoTable.vala"
		if (md5 != NULL) {
#line 6149 "PhotoTable.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 978 "../src/db/PhotoTable.vala"
			_tmp10_ = sql;
#line 978 "../src/db/PhotoTable.vala"
			_tmp11_ = g_strconcat (_tmp10_, " md5=?", NULL);
#line 978 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 978 "../src/db/PhotoTable.vala"
			sql = _tmp11_;
#line 6160 "PhotoTable.c"
		}
#line 981 "../src/db/PhotoTable.vala"
		if (thumbnail_md5 != NULL) {
#line 982 "../src/db/PhotoTable.vala"
			if (md5 == NULL) {
#line 6166 "PhotoTable.c"
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 983 "../src/db/PhotoTable.vala"
				_tmp12_ = sql;
#line 983 "../src/db/PhotoTable.vala"
				_tmp13_ = g_strconcat (_tmp12_, " thumbnail_md5=?", NULL);
#line 983 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 983 "../src/db/PhotoTable.vala"
				sql = _tmp13_;
#line 6177 "PhotoTable.c"
			} else {
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 985 "../src/db/PhotoTable.vala"
				_tmp14_ = sql;
#line 985 "../src/db/PhotoTable.vala"
				_tmp15_ = g_strconcat (_tmp14_, " OR (md5 IS NULL AND thumbnail_md5=?)", NULL);
#line 985 "../src/db/PhotoTable.vala"
				_g_free0 (sql);
#line 985 "../src/db/PhotoTable.vala"
				sql = _tmp15_;
#line 6189 "PhotoTable.c"
			}
		}
#line 988 "../src/db/PhotoTable.vala"
		_tmp16_ = sql;
#line 988 "../src/db/PhotoTable.vala"
		_tmp17_ = g_strconcat (_tmp16_, ")", NULL);
#line 988 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 988 "../src/db/PhotoTable.vala"
		sql = _tmp17_;
#line 990 "../src/db/PhotoTable.vala"
		if (file_format != PHOTO_FILE_FORMAT_UNKNOWN) {
#line 6202 "PhotoTable.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 991 "../src/db/PhotoTable.vala"
			_tmp18_ = sql;
#line 991 "../src/db/PhotoTable.vala"
			_tmp19_ = g_strconcat (_tmp18_, " AND file_format=?", NULL);
#line 991 "../src/db/PhotoTable.vala"
			_g_free0 (sql);
#line 991 "../src/db/PhotoTable.vala"
			sql = _tmp19_;
#line 6213 "PhotoTable.c"
		}
#line 993 "../src/db/PhotoTable.vala"
		_tmp20_ = sql;
#line 993 "../src/db/PhotoTable.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 993 "../src/db/PhotoTable.vala"
		_g_free0 (sql);
#line 993 "../src/db/PhotoTable.vala"
		sql = _tmp21_;
#line 6223 "PhotoTable.c"
	}
#line 997 "../src/db/PhotoTable.vala"
	_tmp22_ = database_table_db;
#line 997 "../src/db/PhotoTable.vala"
	_tmp23_ = sql;
#line 997 "../src/db/PhotoTable.vala"
	_tmp25_ = sqlite3_prepare_v2 (_tmp22_, _tmp23_, -1, &_tmp24_, NULL);
#line 997 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 997 "../src/db/PhotoTable.vala"
	stmt = _tmp24_;
#line 997 "../src/db/PhotoTable.vala"
	res = _tmp25_;
#line 998 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1000 "../src/db/PhotoTable.vala"
	col = 1;
#line 1002 "../src/db/PhotoTable.vala"
	if (file != NULL) {
#line 6243 "PhotoTable.c"
		sqlite3_stmt* _tmp26_;
		gint _tmp27_;
		gchar* _tmp28_;
		GDestroyNotify _tmp29_;
#line 1003 "../src/db/PhotoTable.vala"
		_tmp26_ = stmt;
#line 1003 "../src/db/PhotoTable.vala"
		_tmp27_ = col;
#line 1003 "../src/db/PhotoTable.vala"
		col = _tmp27_ + 1;
#line 1003 "../src/db/PhotoTable.vala"
		_tmp28_ = g_file_get_path (file);
#line 1003 "../src/db/PhotoTable.vala"
		_tmp29_ = g_free;
#line 1003 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp26_, _tmp27_, _tmp28_, -1, _tmp29_);
#line 1004 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6262 "PhotoTable.c"
	}
#line 1007 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 6266 "PhotoTable.c"
		sqlite3_stmt* _tmp30_;
		gint _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		GDestroyNotify _tmp34_;
#line 1008 "../src/db/PhotoTable.vala"
		_tmp30_ = stmt;
#line 1008 "../src/db/PhotoTable.vala"
		_tmp31_ = col;
#line 1008 "../src/db/PhotoTable.vala"
		col = _tmp31_ + 1;
#line 1008 "../src/db/PhotoTable.vala"
		_tmp32_ = thumbnail_md5;
#line 1008 "../src/db/PhotoTable.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 1008 "../src/db/PhotoTable.vala"
		_tmp34_ = g_free;
#line 1008 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp30_, _tmp31_, _tmp33_, -1, _tmp34_);
#line 1009 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6288 "PhotoTable.c"
	}
#line 1012 "../src/db/PhotoTable.vala"
	if (md5 != NULL) {
#line 6292 "PhotoTable.c"
		sqlite3_stmt* _tmp35_;
		gint _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		GDestroyNotify _tmp39_;
#line 1013 "../src/db/PhotoTable.vala"
		_tmp35_ = stmt;
#line 1013 "../src/db/PhotoTable.vala"
		_tmp36_ = col;
#line 1013 "../src/db/PhotoTable.vala"
		col = _tmp36_ + 1;
#line 1013 "../src/db/PhotoTable.vala"
		_tmp37_ = md5;
#line 1013 "../src/db/PhotoTable.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 1013 "../src/db/PhotoTable.vala"
		_tmp39_ = g_free;
#line 1013 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_text (_tmp35_, _tmp36_, _tmp38_, -1, _tmp39_);
#line 1014 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6314 "PhotoTable.c"
	}
#line 1017 "../src/db/PhotoTable.vala"
	if (thumbnail_md5 != NULL) {
#line 1017 "../src/db/PhotoTable.vala"
		_tmp41_ = TRUE;
#line 6320 "PhotoTable.c"
	} else {
#line 1017 "../src/db/PhotoTable.vala"
		_tmp41_ = md5 != NULL;
#line 6324 "PhotoTable.c"
	}
#line 1017 "../src/db/PhotoTable.vala"
	if (_tmp41_) {
#line 1017 "../src/db/PhotoTable.vala"
		_tmp40_ = file_format != PHOTO_FILE_FORMAT_UNKNOWN;
#line 6330 "PhotoTable.c"
	} else {
#line 1017 "../src/db/PhotoTable.vala"
		_tmp40_ = FALSE;
#line 6334 "PhotoTable.c"
	}
#line 1017 "../src/db/PhotoTable.vala"
	if (_tmp40_) {
#line 6338 "PhotoTable.c"
		sqlite3_stmt* _tmp42_;
		gint _tmp43_;
#line 1018 "../src/db/PhotoTable.vala"
		_tmp42_ = stmt;
#line 1018 "../src/db/PhotoTable.vala"
		_tmp43_ = col;
#line 1018 "../src/db/PhotoTable.vala"
		col = _tmp43_ + 1;
#line 1018 "../src/db/PhotoTable.vala"
		res = sqlite3_bind_int (_tmp42_, _tmp43_, photo_file_format_serialize (file_format));
#line 1019 "../src/db/PhotoTable.vala"
		_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 6351 "PhotoTable.c"
	}
#line 1022 "../src/db/PhotoTable.vala"
	result = stmt;
#line 1022 "../src/db/PhotoTable.vala"
	_g_free0 (sql);
#line 1022 "../src/db/PhotoTable.vala"
	return result;
#line 6359 "PhotoTable.c"
}

gboolean
photo_table_has_duplicate (PhotoTable* self,
                           GFile* file,
                           const gchar* thumbnail_md5,
                           const gchar* md5,
                           PhotoFileFormat file_format)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gboolean result;
#line 1025 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), FALSE);
#line 1025 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 1026 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1026 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1027 "../src/db/PhotoTable.vala"
	_tmp1_ = stmt;
#line 1027 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp1_);
#line 1029 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 1031 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1031 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1031 "../src/db/PhotoTable.vala"
		return result;
#line 6394 "PhotoTable.c"
	} else {
#line 1032 "../src/db/PhotoTable.vala"
		if (res == SQLITE_ROW) {
#line 1034 "../src/db/PhotoTable.vala"
			result = TRUE;
#line 1034 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1034 "../src/db/PhotoTable.vala"
			return result;
#line 6404 "PhotoTable.c"
		} else {
#line 1036 "../src/db/PhotoTable.vala"
			database_table_fatal ("has_duplicate", res);
#line 1038 "../src/db/PhotoTable.vala"
			result = FALSE;
#line 1038 "../src/db/PhotoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 1038 "../src/db/PhotoTable.vala"
			return result;
#line 6414 "PhotoTable.c"
		}
	}
}

static void
_vala_array_add2 (PhotoID* * array,
                  gint* length,
                  gint* size,
                  const PhotoID* value)
{
#line 1050 "../src/db/PhotoTable.vala"
	if ((*length) == (*size)) {
#line 1050 "../src/db/PhotoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1050 "../src/db/PhotoTable.vala"
		*array = g_renew (PhotoID, *array, *size);
#line 6431 "PhotoTable.c"
	}
#line 1050 "../src/db/PhotoTable.vala"
	(*array)[(*length)++] = *value;
#line 6435 "PhotoTable.c"
}

PhotoID*
photo_table_get_duplicate_ids (PhotoTable* self,
                               GFile* file,
                               const gchar* thumbnail_md5,
                               const gchar* md5,
                               PhotoFileFormat file_format,
                               gint* result_length1)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	PhotoID* ids = NULL;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp2_;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID* result;
#line 1042 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_PHOTO_TABLE (self), NULL);
#line 1042 "../src/db/PhotoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1044 "../src/db/PhotoTable.vala"
	_tmp0_ = photo_table_get_duplicate_stmt (self, file, thumbnail_md5, md5, file_format);
#line 1044 "../src/db/PhotoTable.vala"
	stmt = _tmp0_;
#line 1046 "../src/db/PhotoTable.vala"
	_tmp1_ = g_new0 (PhotoID, 0);
#line 1046 "../src/db/PhotoTable.vala"
	ids = _tmp1_;
#line 1046 "../src/db/PhotoTable.vala"
	ids_length1 = 0;
#line 1046 "../src/db/PhotoTable.vala"
	_ids_size_ = ids_length1;
#line 1048 "../src/db/PhotoTable.vala"
	_tmp2_ = stmt;
#line 1048 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp2_);
#line 1049 "../src/db/PhotoTable.vala"
	while (TRUE) {
#line 6479 "PhotoTable.c"
		sqlite3_stmt* _tmp3_;
		PhotoID _tmp4_ = {0};
		sqlite3_stmt* _tmp5_;
#line 1049 "../src/db/PhotoTable.vala"
		if (!(res == SQLITE_ROW)) {
#line 1049 "../src/db/PhotoTable.vala"
			break;
#line 6487 "PhotoTable.c"
		}
#line 1050 "../src/db/PhotoTable.vala"
		_tmp3_ = stmt;
#line 1050 "../src/db/PhotoTable.vala"
		photo_id_init (&_tmp4_, sqlite3_column_int64 (_tmp3_, 0));
#line 1050 "../src/db/PhotoTable.vala"
		_vala_array_add2 (&ids, &ids_length1, &_ids_size_, &_tmp4_);
#line 1051 "../src/db/PhotoTable.vala"
		_tmp5_ = stmt;
#line 1051 "../src/db/PhotoTable.vala"
		res = sqlite3_step (_tmp5_);
#line 6499 "PhotoTable.c"
	}
#line 1054 "../src/db/PhotoTable.vala"
	_tmp6_ = ids;
#line 1054 "../src/db/PhotoTable.vala"
	_tmp6__length1 = ids_length1;
#line 1054 "../src/db/PhotoTable.vala"
	if (result_length1) {
#line 1054 "../src/db/PhotoTable.vala"
		*result_length1 = _tmp6__length1;
#line 6509 "PhotoTable.c"
	}
#line 1054 "../src/db/PhotoTable.vala"
	result = _tmp6_;
#line 1054 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1054 "../src/db/PhotoTable.vala"
	return result;
#line 6517 "PhotoTable.c"
}

void
photo_table_update_backlinks (PhotoTable* self,
                              PhotoID* photo_id,
                              const gchar* backlinks,
                              GError** error)
{
	const gchar* _tmp0_ = NULL;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1057 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1057 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1058 "../src/db/PhotoTable.vala"
	if (backlinks != NULL) {
#line 1058 "../src/db/PhotoTable.vala"
		_tmp0_ = backlinks;
#line 6537 "PhotoTable.c"
	} else {
#line 1058 "../src/db/PhotoTable.vala"
		_tmp0_ = "";
#line 6541 "PhotoTable.c"
	}
#line 1058 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1058 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "backlinks", _tmp0_, &_inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1058 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1058 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
			return;
#line 6555 "PhotoTable.c"
		} else {
#line 1058 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1058 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1058 "../src/db/PhotoTable.vala"
			return;
#line 6563 "PhotoTable.c"
		}
	}
}

void
photo_table_attach_editable (PhotoTable* self,
                             PhotoRow* row,
                             BackingPhotoID* editable_id,
                             GError** error)
{
	PhotoID _tmp0_;
	BackingPhotoID _tmp1_;
	BackingPhotoID _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1061 "../src/db/PhotoTable.vala"
	g_return_if_fail (editable_id != NULL);
#line 1062 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1062 "../src/db/PhotoTable.vala"
	_tmp1_ = *editable_id;
#line 1062 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "editable_id", _tmp1_.id, &_inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1062 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1062 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
			return;
#line 6598 "PhotoTable.c"
		} else {
#line 1062 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1062 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1062 "../src/db/PhotoTable.vala"
			return;
#line 6606 "PhotoTable.c"
		}
	}
#line 1064 "../src/db/PhotoTable.vala"
	_tmp2_ = *editable_id;
#line 1064 "../src/db/PhotoTable.vala"
	row->editable_id = _tmp2_;
#line 6613 "PhotoTable.c"
}

void
photo_table_detach_editable (PhotoTable* self,
                             PhotoRow* row,
                             GError** error)
{
	PhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1067 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1067 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1068 "../src/db/PhotoTable.vala"
	_tmp0_ = row->photo_id;
#line 1068 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "editable_id", BACKING_PHOTO_ID_INVALID, &_inner_error0_);
#line 1068 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1068 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1068 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1068 "../src/db/PhotoTable.vala"
			return;
#line 6639 "PhotoTable.c"
		} else {
#line 1068 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1068 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1068 "../src/db/PhotoTable.vala"
			return;
#line 6647 "PhotoTable.c"
		}
	}
#line 1070 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&row->editable_id, BACKING_PHOTO_ID_INVALID);
#line 6652 "PhotoTable.c"
}

void
photo_table_set_metadata_dirty (PhotoTable* self,
                                PhotoID* photo_id,
                                gboolean dirty,
                                GError** error)
{
	gint _tmp0_ = 0;
	PhotoID _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1073 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1073 "../src/db/PhotoTable.vala"
	g_return_if_fail (photo_id != NULL);
#line 1074 "../src/db/PhotoTable.vala"
	if (dirty) {
#line 1074 "../src/db/PhotoTable.vala"
		_tmp0_ = 1;
#line 6672 "PhotoTable.c"
	} else {
#line 1074 "../src/db/PhotoTable.vala"
		_tmp0_ = 0;
#line 6676 "PhotoTable.c"
	}
#line 1074 "../src/db/PhotoTable.vala"
	_tmp1_ = *photo_id;
#line 1074 "../src/db/PhotoTable.vala"
	database_table_update_int_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp1_.id, "metadata_dirty", _tmp0_, &_inner_error0_);
#line 1074 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1074 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1074 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1074 "../src/db/PhotoTable.vala"
			return;
#line 6690 "PhotoTable.c"
		} else {
#line 1074 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1074 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1074 "../src/db/PhotoTable.vala"
			return;
#line 6698 "PhotoTable.c"
		}
	}
}

void
photo_table_update_raw_development (PhotoTable* self,
                                    PhotoRow* row,
                                    RawDeveloper rd,
                                    BackingPhotoID* backing_photo_id,
                                    GError** error)
{
	gchar* col = NULL;
	BackingPhotoID* _tmp3_;
	gint _tmp3__length1;
	BackingPhotoID _tmp4_;
	PhotoID _tmp5_;
	const gchar* _tmp6_;
	BackingPhotoID _tmp7_;
	BackingPhotoID _tmp8_;
	GError* _inner_error0_ = NULL;
#line 1077 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1077 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1077 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_photo_id != NULL);
#line 1081 "../src/db/PhotoTable.vala"
	switch (rd) {
#line 1081 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6729 "PhotoTable.c"
		{
			gchar* _tmp0_;
#line 1083 "../src/db/PhotoTable.vala"
			_tmp0_ = g_strdup ("develop_shotwell_id");
#line 1083 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1083 "../src/db/PhotoTable.vala"
			col = _tmp0_;
#line 1084 "../src/db/PhotoTable.vala"
			break;
#line 6740 "PhotoTable.c"
		}
#line 1081 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6744 "PhotoTable.c"
		{
			gchar* _tmp1_;
#line 1087 "../src/db/PhotoTable.vala"
			_tmp1_ = g_strdup ("develop_camera_id");
#line 1087 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1087 "../src/db/PhotoTable.vala"
			col = _tmp1_;
#line 1088 "../src/db/PhotoTable.vala"
			break;
#line 6755 "PhotoTable.c"
		}
#line 1081 "../src/db/PhotoTable.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6759 "PhotoTable.c"
		{
			gchar* _tmp2_;
#line 1091 "../src/db/PhotoTable.vala"
			_tmp2_ = g_strdup ("develop_embedded_id");
#line 1091 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1091 "../src/db/PhotoTable.vala"
			col = _tmp2_;
#line 1092 "../src/db/PhotoTable.vala"
			break;
#line 6770 "PhotoTable.c"
		}
		default:
		{
#line 1095 "../src/db/PhotoTable.vala"
			g_assert_not_reached ();
#line 6776 "PhotoTable.c"
		}
	}
#line 1098 "../src/db/PhotoTable.vala"
	_tmp3_ = row->development_ids;
#line 1098 "../src/db/PhotoTable.vala"
	_tmp3__length1 = row->development_ids_length1;
#line 1098 "../src/db/PhotoTable.vala"
	_tmp4_ = *backing_photo_id;
#line 1098 "../src/db/PhotoTable.vala"
	_tmp3_[rd] = _tmp4_;
#line 1099 "../src/db/PhotoTable.vala"
	_tmp5_ = row->photo_id;
#line 1099 "../src/db/PhotoTable.vala"
	_tmp6_ = col;
#line 1099 "../src/db/PhotoTable.vala"
	_tmp7_ = *backing_photo_id;
#line 1099 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp5_.id, _tmp6_, _tmp7_.id, &_inner_error0_);
#line 1099 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1099 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1099 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1099 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1099 "../src/db/PhotoTable.vala"
			return;
#line 6805 "PhotoTable.c"
		} else {
#line 1099 "../src/db/PhotoTable.vala"
			_g_free0 (col);
#line 1099 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1099 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1099 "../src/db/PhotoTable.vala"
			return;
#line 6815 "PhotoTable.c"
		}
	}
#line 1101 "../src/db/PhotoTable.vala"
	_tmp8_ = *backing_photo_id;
#line 1101 "../src/db/PhotoTable.vala"
	if (_tmp8_.id != BACKING_PHOTO_ID_INVALID) {
#line 6822 "PhotoTable.c"
		PhotoID _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1102 "../src/db/PhotoTable.vala"
		_tmp9_ = row->photo_id;
#line 1102 "../src/db/PhotoTable.vala"
		_tmp10_ = raw_developer_to_string (rd);
#line 1102 "../src/db/PhotoTable.vala"
		_tmp11_ = _tmp10_;
#line 1102 "../src/db/PhotoTable.vala"
		database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp9_.id, "developer", _tmp11_, &_inner_error0_);
#line 1102 "../src/db/PhotoTable.vala"
		_g_free0 (_tmp11_);
#line 1102 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1102 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1102 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1102 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1102 "../src/db/PhotoTable.vala"
				return;
#line 6846 "PhotoTable.c"
			} else {
#line 1102 "../src/db/PhotoTable.vala"
				_g_free0 (col);
#line 1102 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1102 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1102 "../src/db/PhotoTable.vala"
				return;
#line 6856 "PhotoTable.c"
			}
		}
	}
#line 1077 "../src/db/PhotoTable.vala"
	_g_free0 (col);
#line 6862 "PhotoTable.c"
}

void
photo_table_remove_development (PhotoTable* self,
                                PhotoRow* row,
                                RawDeveloper rd,
                                GError** error)
{
	BackingPhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1105 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_TABLE (self));
#line 1105 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_PHOTO_ROW (row));
#line 1106 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&_tmp0_, BACKING_PHOTO_ID_INVALID);
#line 1106 "../src/db/PhotoTable.vala"
	photo_table_update_raw_development (self, row, rd, &_tmp0_, &_inner_error0_);
#line 1106 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1106 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1106 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1106 "../src/db/PhotoTable.vala"
			return;
#line 6889 "PhotoTable.c"
		} else {
#line 1106 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1106 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1106 "../src/db/PhotoTable.vala"
			return;
#line 6897 "PhotoTable.c"
		}
	}
}

void
photo_table_upgrade_for_unset_timestamp (GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1111 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1111 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE PhotoTable SET exposure_time = NULL WHERE exposure_time = '0'", -1, &_tmp1_, NULL);
#line 1111 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1111 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1111 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1112 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1113 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1113 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 1114 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1115 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoTable.upgrade_for_unset_timestamp", res, &_inner_error0_);
#line 1115 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1115 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1115 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1115 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1115 "../src/db/PhotoTable.vala"
				return;
#line 6942 "PhotoTable.c"
			} else {
#line 1115 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1115 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1115 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1115 "../src/db/PhotoTable.vala"
				return;
#line 6952 "PhotoTable.c"
			}
		}
	}
#line 1109 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 6958 "PhotoTable.c"
}

static void
photo_table_class_init (PhotoTableClass * klass,
                        gpointer klass_data)
{
#line 112 "../src/db/PhotoTable.vala"
	photo_table_parent_class = g_type_class_peek_parent (klass);
#line 112 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = photo_table_finalize;
#line 6969 "PhotoTable.c"
}

static void
photo_table_instance_init (PhotoTable * self,
                           gpointer klass)
{
}

static void
photo_table_finalize (DatabaseTable * obj)
{
	PhotoTable * self;
#line 112 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TABLE, PhotoTable);
#line 112 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (photo_table_parent_class)->finalize (obj);
#line 6986 "PhotoTable.c"
}

static GType
photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTable), 0, (GInstanceInitFunc) photo_table_instance_init, NULL };
	GType photo_table_type_id;
	photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "PhotoTable", &g_define_type_info, 0);
	return photo_table_type_id;
}

GType
photo_table_get_type (void)
{
	static volatile gsize photo_table_type_id__once = 0;
	if (g_once_init_enter (&photo_table_type_id__once)) {
		GType photo_table_type_id;
		photo_table_type_id = photo_table_get_type_once ();
		g_once_init_leave (&photo_table_type_id__once, photo_table_type_id);
	}
	return photo_table_type_id__once;
}

void
backing_photo_id_init (BackingPhotoID *self,
                       gint64 id)
{
#line 1136 "../src/db/PhotoTable.vala"
	memset (self, 0, sizeof (BackingPhotoID));
#line 1137 "../src/db/PhotoTable.vala"
	(*self).id = id;
#line 7018 "PhotoTable.c"
}

gboolean
backing_photo_id_is_invalid (BackingPhotoID *self)
{
	gboolean result;
#line 1141 "../src/db/PhotoTable.vala"
	result = (*self).id == BACKING_PHOTO_ID_INVALID;
#line 1141 "../src/db/PhotoTable.vala"
	return result;
#line 7029 "PhotoTable.c"
}

gboolean
backing_photo_id_is_valid (BackingPhotoID *self)
{
	gboolean result;
#line 1145 "../src/db/PhotoTable.vala"
	result = (*self).id != BACKING_PHOTO_ID_INVALID;
#line 1145 "../src/db/PhotoTable.vala"
	return result;
#line 7040 "PhotoTable.c"
}

BackingPhotoID*
backing_photo_id_dup (const BackingPhotoID* self)
{
	BackingPhotoID* dup;
#line 1131 "../src/db/PhotoTable.vala"
	dup = g_new0 (BackingPhotoID, 1);
#line 1131 "../src/db/PhotoTable.vala"
	memcpy (dup, self, sizeof (BackingPhotoID));
#line 1131 "../src/db/PhotoTable.vala"
	return dup;
#line 7053 "PhotoTable.c"
}

void
backing_photo_id_free (BackingPhotoID* self)
{
#line 1131 "../src/db/PhotoTable.vala"
	g_free (self);
#line 7061 "PhotoTable.c"
}

static GType
backing_photo_id_get_type_once (void)
{
	GType backing_photo_id_type_id;
	backing_photo_id_type_id = g_boxed_type_register_static ("BackingPhotoID", (GBoxedCopyFunc) backing_photo_id_dup, (GBoxedFreeFunc) backing_photo_id_free);
	return backing_photo_id_type_id;
}

GType
backing_photo_id_get_type (void)
{
	static volatile gsize backing_photo_id_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_id_type_id__once)) {
		GType backing_photo_id_type_id;
		backing_photo_id_type_id = backing_photo_id_get_type_once ();
		g_once_init_leave (&backing_photo_id_type_id__once, backing_photo_id_type_id);
	}
	return backing_photo_id_type_id__once;
}

gboolean
backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                     GFileInfo* info)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 1159 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1159 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1160 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 1161 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1161 "../src/db/PhotoTable.vala"
		return result;
#line 7104 "PhotoTable.c"
	}
#line 1163 "../src/db/PhotoTable.vala"
	_tmp0_ = self->timestamp;
#line 1163 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 1164 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1164 "../src/db/PhotoTable.vala"
		return result;
#line 7114 "PhotoTable.c"
	}
#line 1166 "../src/db/PhotoTable.vala"
	_tmp1_ = self->timestamp;
#line 1166 "../src/db/PhotoTable.vala"
	_tmp2_ = g_file_info_get_modification_date_time (info);
#line 1166 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 1166 "../src/db/PhotoTable.vala"
	_tmp4_ = g_date_time_equal (_tmp1_, _tmp3_);
#line 1166 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp3_);
#line 1166 "../src/db/PhotoTable.vala"
	result = _tmp4_;
#line 1166 "../src/db/PhotoTable.vala"
	return result;
#line 7130 "PhotoTable.c"
}

gboolean
backing_photo_row_is_touched (BackingPhotoRow* self,
                              GFileInfo* info)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 1169 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_ROW (self), FALSE);
#line 1169 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), FALSE);
#line 1170 "../src/db/PhotoTable.vala"
	if (self->filesize != g_file_info_get_size (info)) {
#line 1171 "../src/db/PhotoTable.vala"
		result = FALSE;
#line 1171 "../src/db/PhotoTable.vala"
		return result;
#line 7153 "PhotoTable.c"
	}
#line 1173 "../src/db/PhotoTable.vala"
	_tmp0_ = self->timestamp;
#line 1173 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 1174 "../src/db/PhotoTable.vala"
		result = TRUE;
#line 1174 "../src/db/PhotoTable.vala"
		return result;
#line 7163 "PhotoTable.c"
	}
#line 1176 "../src/db/PhotoTable.vala"
	_tmp1_ = self->timestamp;
#line 1176 "../src/db/PhotoTable.vala"
	_tmp2_ = g_file_info_get_modification_date_time (info);
#line 1176 "../src/db/PhotoTable.vala"
	_tmp3_ = _tmp2_;
#line 1176 "../src/db/PhotoTable.vala"
	_tmp4_ = !g_date_time_equal (_tmp1_, _tmp3_);
#line 1176 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp3_);
#line 1176 "../src/db/PhotoTable.vala"
	result = _tmp4_;
#line 1176 "../src/db/PhotoTable.vala"
	return result;
#line 7179 "PhotoTable.c"
}

void
backing_photo_row_copy_from (BackingPhotoRow* self,
                             BackingPhotoRow* from)
{
	BackingPhotoID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	Dimensions _tmp5_;
#line 1180 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (self));
#line 1180 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (from));
#line 1181 "../src/db/PhotoTable.vala"
	_tmp0_ = from->id;
#line 1181 "../src/db/PhotoTable.vala"
	self->id = _tmp0_;
#line 1182 "../src/db/PhotoTable.vala"
	self->time_created = from->time_created;
#line 1183 "../src/db/PhotoTable.vala"
	_tmp1_ = from->filepath;
#line 1183 "../src/db/PhotoTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1183 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 1183 "../src/db/PhotoTable.vala"
	self->filepath = _tmp2_;
#line 1184 "../src/db/PhotoTable.vala"
	self->filesize = from->filesize;
#line 1185 "../src/db/PhotoTable.vala"
	_tmp3_ = from->timestamp;
#line 1185 "../src/db/PhotoTable.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 1185 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (self->timestamp);
#line 1185 "../src/db/PhotoTable.vala"
	self->timestamp = _tmp4_;
#line 1186 "../src/db/PhotoTable.vala"
	self->file_format = from->file_format;
#line 1187 "../src/db/PhotoTable.vala"
	_tmp5_ = from->dim;
#line 1187 "../src/db/PhotoTable.vala"
	self->dim = _tmp5_;
#line 1188 "../src/db/PhotoTable.vala"
	self->original_orientation = from->original_orientation;
#line 7228 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_construct (GType object_type)
{
	BackingPhotoRow* self = NULL;
#line 1149 "../src/db/PhotoTable.vala"
	self = (BackingPhotoRow*) g_type_create_instance (object_type);
#line 1149 "../src/db/PhotoTable.vala"
	return self;
#line 7239 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_row_new (void)
{
#line 1149 "../src/db/PhotoTable.vala"
	return backing_photo_row_construct (TYPE_BACKING_PHOTO_ROW);
#line 7247 "PhotoTable.c"
}

static void
value_backing_photo_row_init (GValue* value)
{
#line 1149 "../src/db/PhotoTable.vala"
	value->data[0].v_pointer = NULL;
#line 7255 "PhotoTable.c"
}

static void
value_backing_photo_row_free_value (GValue* value)
{
#line 1149 "../src/db/PhotoTable.vala"
	if (value->data[0].v_pointer) {
#line 1149 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (value->data[0].v_pointer);
#line 7265 "PhotoTable.c"
	}
}

static void
value_backing_photo_row_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 1149 "../src/db/PhotoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 1149 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = backing_photo_row_ref (src_value->data[0].v_pointer);
#line 7277 "PhotoTable.c"
	} else {
#line 1149 "../src/db/PhotoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7281 "PhotoTable.c"
	}
}

static gpointer
value_backing_photo_row_peek_pointer (const GValue* value)
{
#line 1149 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 7290 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 1149 "../src/db/PhotoTable.vala"
	if (collect_values[0].v_pointer) {
#line 7301 "PhotoTable.c"
		BackingPhotoRow * object;
		object = collect_values[0].v_pointer;
#line 1149 "../src/db/PhotoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1149 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7308 "PhotoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1149 "../src/db/PhotoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7312 "PhotoTable.c"
		}
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = backing_photo_row_ref (object);
#line 7316 "PhotoTable.c"
	} else {
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7320 "PhotoTable.c"
	}
#line 1149 "../src/db/PhotoTable.vala"
	return NULL;
#line 7324 "PhotoTable.c"
}

static gchar*
value_backing_photo_row_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BackingPhotoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1149 "../src/db/PhotoTable.vala"
	if (!object_p) {
#line 1149 "../src/db/PhotoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7339 "PhotoTable.c"
	}
#line 1149 "../src/db/PhotoTable.vala"
	if (!value->data[0].v_pointer) {
#line 1149 "../src/db/PhotoTable.vala"
		*object_p = NULL;
#line 7345 "PhotoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1149 "../src/db/PhotoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 7349 "PhotoTable.c"
	} else {
#line 1149 "../src/db/PhotoTable.vala"
		*object_p = backing_photo_row_ref (value->data[0].v_pointer);
#line 7353 "PhotoTable.c"
	}
#line 1149 "../src/db/PhotoTable.vala"
	return NULL;
#line 7357 "PhotoTable.c"
}

GParamSpec*
param_spec_backing_photo_row (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecBackingPhotoRow* spec;
#line 1149 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1149 "../src/db/PhotoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1149 "../src/db/PhotoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1149 "../src/db/PhotoTable.vala"
	return G_PARAM_SPEC (spec);
#line 7376 "PhotoTable.c"
}

gpointer
value_get_backing_photo_row (const GValue* value)
{
#line 1149 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW), NULL);
#line 1149 "../src/db/PhotoTable.vala"
	return value->data[0].v_pointer;
#line 7386 "PhotoTable.c"
}

void
value_set_backing_photo_row (GValue* value,
                             gpointer v_object)
{
	BackingPhotoRow * old;
#line 1149 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1149 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1149 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 1149 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1149 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 1149 "../src/db/PhotoTable.vala"
		backing_photo_row_ref (value->data[0].v_pointer);
#line 7408 "PhotoTable.c"
	} else {
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7412 "PhotoTable.c"
	}
#line 1149 "../src/db/PhotoTable.vala"
	if (old) {
#line 1149 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 7418 "PhotoTable.c"
	}
}

void
value_take_backing_photo_row (GValue* value,
                              gpointer v_object)
{
	BackingPhotoRow * old;
#line 1149 "../src/db/PhotoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKING_PHOTO_ROW));
#line 1149 "../src/db/PhotoTable.vala"
	old = value->data[0].v_pointer;
#line 1149 "../src/db/PhotoTable.vala"
	if (v_object) {
#line 1149 "../src/db/PhotoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKING_PHOTO_ROW));
#line 1149 "../src/db/PhotoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = v_object;
#line 7439 "PhotoTable.c"
	} else {
#line 1149 "../src/db/PhotoTable.vala"
		value->data[0].v_pointer = NULL;
#line 7443 "PhotoTable.c"
	}
#line 1149 "../src/db/PhotoTable.vala"
	if (old) {
#line 1149 "../src/db/PhotoTable.vala"
		backing_photo_row_unref (old);
#line 7449 "PhotoTable.c"
	}
}

static void
backing_photo_row_class_init (BackingPhotoRowClass * klass,
                              gpointer klass_data)
{
#line 1149 "../src/db/PhotoTable.vala"
	backing_photo_row_parent_class = g_type_class_peek_parent (klass);
#line 1149 "../src/db/PhotoTable.vala"
	((BackingPhotoRowClass *) klass)->finalize = backing_photo_row_finalize;
#line 7461 "PhotoTable.c"
}

static void
backing_photo_row_instance_init (BackingPhotoRow * self,
                                 gpointer klass)
{
#line 1152 "../src/db/PhotoTable.vala"
	self->filepath = NULL;
#line 1149 "../src/db/PhotoTable.vala"
	self->ref_count = 1;
#line 7472 "PhotoTable.c"
}

static void
backing_photo_row_finalize (BackingPhotoRow * obj)
{
	BackingPhotoRow * self;
#line 1149 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_ROW, BackingPhotoRow);
#line 1149 "../src/db/PhotoTable.vala"
	g_signal_handlers_destroy (self);
#line 1152 "../src/db/PhotoTable.vala"
	_g_free0 (self->filepath);
#line 1154 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (self->timestamp);
#line 7487 "PhotoTable.c"
}

static GType
backing_photo_row_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_backing_photo_row_init, value_backing_photo_row_free_value, value_backing_photo_row_copy_value, value_backing_photo_row_peek_pointer, "p", value_backing_photo_row_collect_value, "p", value_backing_photo_row_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoRow), 0, (GInstanceInitFunc) backing_photo_row_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType backing_photo_row_type_id;
	backing_photo_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackingPhotoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return backing_photo_row_type_id;
}

GType
backing_photo_row_get_type (void)
{
	static volatile gsize backing_photo_row_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_row_type_id__once)) {
		GType backing_photo_row_type_id;
		backing_photo_row_type_id = backing_photo_row_get_type_once ();
		g_once_init_leave (&backing_photo_row_type_id__once, backing_photo_row_type_id);
	}
	return backing_photo_row_type_id__once;
}

gpointer
backing_photo_row_ref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1149 "../src/db/PhotoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1149 "../src/db/PhotoTable.vala"
	return instance;
#line 7522 "PhotoTable.c"
}

void
backing_photo_row_unref (gpointer instance)
{
	BackingPhotoRow * self;
	self = instance;
#line 1149 "../src/db/PhotoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1149 "../src/db/PhotoTable.vala"
		BACKING_PHOTO_ROW_GET_CLASS (self)->finalize (self);
#line 1149 "../src/db/PhotoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7536 "PhotoTable.c"
	}
}

static BackingPhotoTable*
backing_photo_table_construct (GType object_type)
{
	BackingPhotoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
#line 1195 "../src/db/PhotoTable.vala"
	self = (BackingPhotoTable*) database_table_construct (object_type);
#line 1196 "../src/db/PhotoTable.vala"
	database_table_set_table_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), "BackingPhotoTable");
#line 1199 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1199 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "BackingPhotoTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT UNIQUE NOT NULL, " "timestamp INTEGER, " "filesize INTEGER, " "width INTEGER, " "height INTEGER, " "original_orientation INTEGER, " "file_format INTEGER, " "time_created INTEGER " ")", -1, &_tmp1_, NULL);
#line 1199 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1199 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1199 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1212 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1214 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1214 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp3_);
#line 1215 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1216 "../src/db/PhotoTable.vala"
		database_table_fatal ("create PhotoBackingTable", res);
#line 7574 "PhotoTable.c"
	}
#line 1195 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1195 "../src/db/PhotoTable.vala"
	return self;
#line 7580 "PhotoTable.c"
}

static BackingPhotoTable*
backing_photo_table_new (void)
{
#line 1195 "../src/db/PhotoTable.vala"
	return backing_photo_table_construct (TYPE_BACKING_PHOTO_TABLE);
#line 7588 "PhotoTable.c"
}

BackingPhotoTable*
backing_photo_table_get_instance (void)
{
	BackingPhotoTable* _tmp0_;
	BackingPhotoTable* _tmp2_;
	BackingPhotoTable* _tmp3_;
	BackingPhotoTable* result;
#line 1220 "../src/db/PhotoTable.vala"
	_tmp0_ = backing_photo_table_instance;
#line 1220 "../src/db/PhotoTable.vala"
	if (_tmp0_ == NULL) {
#line 7602 "PhotoTable.c"
		BackingPhotoTable* _tmp1_;
#line 1221 "../src/db/PhotoTable.vala"
		_tmp1_ = backing_photo_table_new ();
#line 1221 "../src/db/PhotoTable.vala"
		_database_table_unref0 (backing_photo_table_instance);
#line 1221 "../src/db/PhotoTable.vala"
		backing_photo_table_instance = _tmp1_;
#line 7610 "PhotoTable.c"
	}
#line 1223 "../src/db/PhotoTable.vala"
	_tmp2_ = backing_photo_table_instance;
#line 1223 "../src/db/PhotoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 1223 "../src/db/PhotoTable.vala"
	result = _tmp3_;
#line 1223 "../src/db/PhotoTable.vala"
	return result;
#line 7620 "PhotoTable.c"
}

void
backing_photo_table_add (BackingPhotoTable* self,
                         BackingPhotoRow* state,
                         GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint64 time_created = 0LL;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GDestroyNotify _tmp6_;
	sqlite3_stmt* _tmp7_;
	GDateTime* _tmp8_;
	sqlite3_stmt* _tmp9_;
	sqlite3_stmt* _tmp10_;
	Dimensions _tmp11_;
	sqlite3_stmt* _tmp12_;
	Dimensions _tmp13_;
	sqlite3_stmt* _tmp14_;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	sqlite3_stmt* _tmp17_;
	sqlite3* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 1226 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1226 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (state));
#line 1228 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1228 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO BackingPhotoTable " "(filepath, timestamp, filesize, width, height, original_orientation, " "file_format, time_created) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 1228 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1228 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1228 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1233 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1235 "../src/db/PhotoTable.vala"
	time_created = now_sec ();
#line 1237 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1237 "../src/db/PhotoTable.vala"
	_tmp4_ = state->filepath;
#line 1237 "../src/db/PhotoTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1237 "../src/db/PhotoTable.vala"
	_tmp6_ = g_free;
#line 1237 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_text (_tmp3_, 1, _tmp5_, -1, _tmp6_);
#line 1238 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1239 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1239 "../src/db/PhotoTable.vala"
	_tmp8_ = state->timestamp;
#line 1239 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 2, g_date_time_to_unix (_tmp8_));
#line 1240 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1241 "../src/db/PhotoTable.vala"
	_tmp9_ = stmt;
#line 1241 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp9_, 3, state->filesize);
#line 1242 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1243 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1243 "../src/db/PhotoTable.vala"
	_tmp11_ = state->dim;
#line 1243 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 4, _tmp11_.width);
#line 1244 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1245 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1245 "../src/db/PhotoTable.vala"
	_tmp13_ = state->dim;
#line 1245 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp12_, 5, _tmp13_.height);
#line 1246 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1247 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1247 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp14_, 6, (gint) state->original_orientation);
#line 1248 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1249 "../src/db/PhotoTable.vala"
	_tmp15_ = stmt;
#line 1249 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp15_, 7, photo_file_format_serialize (state->file_format));
#line 1250 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1251 "../src/db/PhotoTable.vala"
	_tmp16_ = stmt;
#line 1251 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp16_, 8, (gint64) time_created);
#line 1252 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1254 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 1254 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp17_);
#line 1255 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1256 "../src/db/PhotoTable.vala"
		database_table_throw_error ("PhotoBackingTable.add", res, &_inner_error0_);
#line 1256 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1256 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1256 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1256 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1256 "../src/db/PhotoTable.vala"
				return;
#line 7747 "PhotoTable.c"
			} else {
#line 1256 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1256 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1256 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1256 "../src/db/PhotoTable.vala"
				return;
#line 7757 "PhotoTable.c"
			}
		}
	}
#line 1258 "../src/db/PhotoTable.vala"
	_tmp18_ = database_table_db;
#line 1258 "../src/db/PhotoTable.vala"
	backing_photo_id_init (&state->id, sqlite3_last_insert_rowid (_tmp18_));
#line 1259 "../src/db/PhotoTable.vala"
	state->time_created = time_created;
#line 1226 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 7769 "PhotoTable.c"
}

BackingPhotoRow*
backing_photo_table_fetch (BackingPhotoTable* self,
                           BackingPhotoID* id,
                           GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	BackingPhotoID _tmp4_;
	sqlite3_stmt* _tmp5_;
	BackingPhotoRow* row = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	BackingPhotoID _tmp8_;
	BackingPhotoRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	BackingPhotoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	GDateTime* _tmp15_;
	BackingPhotoRow* _tmp16_;
	sqlite3_stmt* _tmp17_;
	BackingPhotoRow* _tmp18_;
	sqlite3_stmt* _tmp19_;
	sqlite3_stmt* _tmp20_;
	BackingPhotoRow* _tmp21_;
	sqlite3_stmt* _tmp22_;
	BackingPhotoRow* _tmp23_;
	sqlite3_stmt* _tmp24_;
	BackingPhotoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	GError* _inner_error0_ = NULL;
	BackingPhotoRow* result;
#line 1262 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (IS_BACKING_PHOTO_TABLE (self), NULL);
#line 1262 "../src/db/PhotoTable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1264 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1264 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filepath, timestamp, filesize, width, height, " "original_orientation, file_format, time_created FROM BackingPhotoTable" \
" WHERE id=?", -1, &_tmp1_, NULL);
#line 1264 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1264 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1264 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1267 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1269 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1269 "../src/db/PhotoTable.vala"
	_tmp4_ = *id;
#line 1269 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, _tmp4_.id);
#line 1270 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1272 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1272 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp5_);
#line 1273 "../src/db/PhotoTable.vala"
	if (res == SQLITE_DONE) {
#line 1274 "../src/db/PhotoTable.vala"
		result = NULL;
#line 1274 "../src/db/PhotoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 1274 "../src/db/PhotoTable.vala"
		return result;
#line 7845 "PhotoTable.c"
	} else {
#line 1275 "../src/db/PhotoTable.vala"
		if (res != SQLITE_ROW) {
#line 1276 "../src/db/PhotoTable.vala"
			database_table_throw_error ("BackingPhotoTable.fetch_for_photo", res, &_inner_error0_);
#line 1276 "../src/db/PhotoTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1276 "../src/db/PhotoTable.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1276 "../src/db/PhotoTable.vala"
					g_propagate_error (error, _inner_error0_);
#line 1276 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1276 "../src/db/PhotoTable.vala"
					return NULL;
#line 7861 "PhotoTable.c"
				} else {
#line 1276 "../src/db/PhotoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 1276 "../src/db/PhotoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1276 "../src/db/PhotoTable.vala"
					g_clear_error (&_inner_error0_);
#line 1276 "../src/db/PhotoTable.vala"
					return NULL;
#line 7871 "PhotoTable.c"
				}
			}
		}
	}
#line 1278 "../src/db/PhotoTable.vala"
	_tmp6_ = backing_photo_row_new ();
#line 1278 "../src/db/PhotoTable.vala"
	row = _tmp6_;
#line 1279 "../src/db/PhotoTable.vala"
	_tmp7_ = row;
#line 1279 "../src/db/PhotoTable.vala"
	_tmp8_ = *id;
#line 1279 "../src/db/PhotoTable.vala"
	_tmp7_->id = _tmp8_;
#line 1280 "../src/db/PhotoTable.vala"
	_tmp9_ = row;
#line 1280 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1280 "../src/db/PhotoTable.vala"
	_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
#line 1280 "../src/db/PhotoTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 1280 "../src/db/PhotoTable.vala"
	_g_free0 (_tmp9_->filepath);
#line 1280 "../src/db/PhotoTable.vala"
	_tmp9_->filepath = _tmp12_;
#line 1281 "../src/db/PhotoTable.vala"
	_tmp13_ = row;
#line 1281 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1281 "../src/db/PhotoTable.vala"
	_tmp15_ = g_date_time_new_from_unix_utc (sqlite3_column_int64 (_tmp14_, 1));
#line 1281 "../src/db/PhotoTable.vala"
	_g_date_time_unref0 (_tmp13_->timestamp);
#line 1281 "../src/db/PhotoTable.vala"
	_tmp13_->timestamp = _tmp15_;
#line 1282 "../src/db/PhotoTable.vala"
	_tmp16_ = row;
#line 1282 "../src/db/PhotoTable.vala"
	_tmp17_ = stmt;
#line 1282 "../src/db/PhotoTable.vala"
	_tmp16_->filesize = sqlite3_column_int64 (_tmp17_, 2);
#line 1283 "../src/db/PhotoTable.vala"
	_tmp18_ = row;
#line 1283 "../src/db/PhotoTable.vala"
	_tmp19_ = stmt;
#line 1283 "../src/db/PhotoTable.vala"
	_tmp20_ = stmt;
#line 1283 "../src/db/PhotoTable.vala"
	dimensions_init (&_tmp18_->dim, sqlite3_column_int (_tmp19_, 3), sqlite3_column_int (_tmp20_, 4));
#line 1284 "../src/db/PhotoTable.vala"
	_tmp21_ = row;
#line 1284 "../src/db/PhotoTable.vala"
	_tmp22_ = stmt;
#line 1284 "../src/db/PhotoTable.vala"
	_tmp21_->original_orientation = (Orientation) sqlite3_column_int (_tmp22_, 5);
#line 1285 "../src/db/PhotoTable.vala"
	_tmp23_ = row;
#line 1285 "../src/db/PhotoTable.vala"
	_tmp24_ = stmt;
#line 1285 "../src/db/PhotoTable.vala"
	_tmp23_->file_format = photo_file_format_unserialize (sqlite3_column_int (_tmp24_, 6));
#line 1286 "../src/db/PhotoTable.vala"
	_tmp25_ = row;
#line 1286 "../src/db/PhotoTable.vala"
	_tmp26_ = stmt;
#line 1286 "../src/db/PhotoTable.vala"
	_tmp25_->time_created = sqlite3_column_int64 (_tmp26_, 7);
#line 1288 "../src/db/PhotoTable.vala"
	result = row;
#line 1288 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1288 "../src/db/PhotoTable.vala"
	return result;
#line 7946 "PhotoTable.c"
}

void
backing_photo_table_update (BackingPhotoTable* self,
                            BackingPhotoRow* row,
                            GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	GDateTime* _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	Dimensions _tmp7_;
	sqlite3_stmt* _tmp8_;
	Dimensions _tmp9_;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	sqlite3_stmt* _tmp12_;
	BackingPhotoID _tmp13_;
	sqlite3_stmt* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 1292 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1292 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_ROW (row));
#line 1294 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1294 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=?, " "width=?, height=?, original_orientation=?, file_format=? " "WHERE id=?", -1, &_tmp1_, NULL);
#line 1294 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1294 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1294 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1298 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1300 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1300 "../src/db/PhotoTable.vala"
	_tmp4_ = row->timestamp;
#line 1300 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, g_date_time_to_unix (_tmp4_));
#line 1301 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1302 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1302 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp5_, 2, row->filesize);
#line 1303 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1304 "../src/db/PhotoTable.vala"
	_tmp6_ = stmt;
#line 1304 "../src/db/PhotoTable.vala"
	_tmp7_ = row->dim;
#line 1304 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp6_, 3, _tmp7_.width);
#line 1305 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1306 "../src/db/PhotoTable.vala"
	_tmp8_ = stmt;
#line 1306 "../src/db/PhotoTable.vala"
	_tmp9_ = row->dim;
#line 1306 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp8_, 4, _tmp9_.height);
#line 1307 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1308 "../src/db/PhotoTable.vala"
	_tmp10_ = stmt;
#line 1308 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp10_, 5, (gint) row->original_orientation);
#line 1309 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1310 "../src/db/PhotoTable.vala"
	_tmp11_ = stmt;
#line 1310 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int (_tmp11_, 6, photo_file_format_serialize (row->file_format));
#line 1311 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1312 "../src/db/PhotoTable.vala"
	_tmp12_ = stmt;
#line 1312 "../src/db/PhotoTable.vala"
	_tmp13_ = row->id;
#line 1312 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp12_, 7, _tmp13_.id);
#line 1313 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1315 "../src/db/PhotoTable.vala"
	_tmp14_ = stmt;
#line 1315 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp14_);
#line 1316 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1317 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update", res, &_inner_error0_);
#line 1317 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1317 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1317 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1317 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1317 "../src/db/PhotoTable.vala"
				return;
#line 8056 "PhotoTable.c"
			} else {
#line 1317 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1317 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1317 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1317 "../src/db/PhotoTable.vala"
				return;
#line 8066 "PhotoTable.c"
			}
		}
	}
#line 1292 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 8072 "PhotoTable.c"
}

void
backing_photo_table_update_attributes (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       GDateTime* timestamp,
                                       gint64 filesize,
                                       GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	BackingPhotoID _tmp6_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 1320 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1320 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1320 "../src/db/PhotoTable.vala"
	g_return_if_fail (timestamp != NULL);
#line 1322 "../src/db/PhotoTable.vala"
	_tmp0_ = database_table_db;
#line 1322 "../src/db/PhotoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE BackingPhotoTable SET timestamp=?, filesize=? WHERE id=?", -1, &_tmp1_, NULL);
#line 1322 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1322 "../src/db/PhotoTable.vala"
	stmt = _tmp1_;
#line 1322 "../src/db/PhotoTable.vala"
	res = _tmp2_;
#line 1324 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1326 "../src/db/PhotoTable.vala"
	_tmp3_ = stmt;
#line 1326 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp3_, 1, g_date_time_to_unix (timestamp));
#line 1327 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1328 "../src/db/PhotoTable.vala"
	_tmp4_ = stmt;
#line 1328 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp4_, 2, filesize);
#line 1329 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1330 "../src/db/PhotoTable.vala"
	_tmp5_ = stmt;
#line 1330 "../src/db/PhotoTable.vala"
	_tmp6_ = *id;
#line 1330 "../src/db/PhotoTable.vala"
	res = sqlite3_bind_int64 (_tmp5_, 3, _tmp6_.id);
#line 1331 "../src/db/PhotoTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1333 "../src/db/PhotoTable.vala"
	_tmp7_ = stmt;
#line 1333 "../src/db/PhotoTable.vala"
	res = sqlite3_step (_tmp7_);
#line 1334 "../src/db/PhotoTable.vala"
	if (res != SQLITE_DONE) {
#line 1335 "../src/db/PhotoTable.vala"
		database_table_throw_error ("BackingPhotoTable.update_attributes", res, &_inner_error0_);
#line 1335 "../src/db/PhotoTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1335 "../src/db/PhotoTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1335 "../src/db/PhotoTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 1335 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1335 "../src/db/PhotoTable.vala"
				return;
#line 8149 "PhotoTable.c"
			} else {
#line 1335 "../src/db/PhotoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 1335 "../src/db/PhotoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1335 "../src/db/PhotoTable.vala"
				g_clear_error (&_inner_error0_);
#line 1335 "../src/db/PhotoTable.vala"
				return;
#line 8159 "PhotoTable.c"
			}
		}
	}
#line 1320 "../src/db/PhotoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 8165 "PhotoTable.c"
}

void
backing_photo_table_remove (BackingPhotoTable* self,
                            BackingPhotoID* backing_id,
                            GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1338 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1338 "../src/db/PhotoTable.vala"
	g_return_if_fail (backing_id != NULL);
#line 1339 "../src/db/PhotoTable.vala"
	_tmp0_ = *backing_id;
#line 1339 "../src/db/PhotoTable.vala"
	database_table_delete_by_id (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, &_inner_error0_);
#line 1339 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1339 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1339 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1339 "../src/db/PhotoTable.vala"
			return;
#line 8191 "PhotoTable.c"
		} else {
#line 1339 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1339 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1339 "../src/db/PhotoTable.vala"
			return;
#line 8199 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_set_filepath (BackingPhotoTable* self,
                                  BackingPhotoID* id,
                                  const gchar* filepath,
                                  GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1342 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1342 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1342 "../src/db/PhotoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 1343 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1343 "../src/db/PhotoTable.vala"
	database_table_update_text_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "filepath", filepath, &_inner_error0_);
#line 1343 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1343 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1343 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1343 "../src/db/PhotoTable.vala"
			return;
#line 8230 "PhotoTable.c"
		} else {
#line 1343 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1343 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1343 "../src/db/PhotoTable.vala"
			return;
#line 8238 "PhotoTable.c"
		}
	}
}

void
backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                      BackingPhotoID* id,
                                      GDateTime* timestamp,
                                      GError** error)
{
	BackingPhotoID _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1346 "../src/db/PhotoTable.vala"
	g_return_if_fail (IS_BACKING_PHOTO_TABLE (self));
#line 1346 "../src/db/PhotoTable.vala"
	g_return_if_fail (id != NULL);
#line 1346 "../src/db/PhotoTable.vala"
	g_return_if_fail (timestamp != NULL);
#line 1347 "../src/db/PhotoTable.vala"
	_tmp0_ = *id;
#line 1347 "../src/db/PhotoTable.vala"
	database_table_update_int64_by_id_2 (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_TABLE, DatabaseTable), _tmp0_.id, "timestamp", g_date_time_to_unix (timestamp), &_inner_error0_);
#line 1347 "../src/db/PhotoTable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1347 "../src/db/PhotoTable.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1347 "../src/db/PhotoTable.vala"
			g_propagate_error (error, _inner_error0_);
#line 1347 "../src/db/PhotoTable.vala"
			return;
#line 8269 "PhotoTable.c"
		} else {
#line 1347 "../src/db/PhotoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1347 "../src/db/PhotoTable.vala"
			g_clear_error (&_inner_error0_);
#line 1347 "../src/db/PhotoTable.vala"
			return;
#line 8277 "PhotoTable.c"
		}
	}
}

static void
backing_photo_table_class_init (BackingPhotoTableClass * klass,
                                gpointer klass_data)
{
#line 1192 "../src/db/PhotoTable.vala"
	backing_photo_table_parent_class = g_type_class_peek_parent (klass);
#line 1192 "../src/db/PhotoTable.vala"
	((DatabaseTableClass *) klass)->finalize = backing_photo_table_finalize;
#line 8290 "PhotoTable.c"
}

static void
backing_photo_table_instance_init (BackingPhotoTable * self,
                                   gpointer klass)
{
}

static void
backing_photo_table_finalize (DatabaseTable * obj)
{
	BackingPhotoTable * self;
#line 1192 "../src/db/PhotoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable);
#line 1192 "../src/db/PhotoTable.vala"
	DATABASE_TABLE_CLASS (backing_photo_table_parent_class)->finalize (obj);
#line 8307 "PhotoTable.c"
}

static GType
backing_photo_table_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackingPhotoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) backing_photo_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackingPhotoTable), 0, (GInstanceInitFunc) backing_photo_table_instance_init, NULL };
	GType backing_photo_table_type_id;
	backing_photo_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "BackingPhotoTable", &g_define_type_info, 0);
	return backing_photo_table_type_id;
}

GType
backing_photo_table_get_type (void)
{
	static volatile gsize backing_photo_table_type_id__once = 0;
	if (g_once_init_enter (&backing_photo_table_type_id__once)) {
		GType backing_photo_table_type_id;
		backing_photo_table_type_id = backing_photo_table_get_type_once ();
		g_once_init_leave (&backing_photo_table_type_id__once, backing_photo_table_type_id);
	}
	return backing_photo_table_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

