/* PhotoMetadata.c generated by valac 0.56.3, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include "metadata.h"
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>

#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
#define TAG_PATH_SEPARATOR_STRING "/"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_KEYWORD_TRANSFORMER (keyword_transformer_get_type ())
#define KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYWORD_TRANSFORMER, KeywordTransformer))
#define KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYWORD_TRANSFORMER, KeywordTransformerClass))
#define IS_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYWORD_TRANSFORMER))
#define IS_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYWORD_TRANSFORMER))
#define KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYWORD_TRANSFORMER, KeywordTransformerClass))

typedef struct _KeywordTransformer KeywordTransformer;
typedef struct _KeywordTransformerClass KeywordTransformerClass;
typedef struct _KeywordTransformerPrivate KeywordTransformerPrivate;
typedef struct _ParamSpecKeywordTransformer ParamSpecKeywordTransformer;

#define TYPE_NULL_KEYWORD_TRANSFORMER (null_keyword_transformer_get_type ())
#define NULL_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformer))
#define NULL_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformerClass))
#define IS_NULL_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NULL_KEYWORD_TRANSFORMER))
#define IS_NULL_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NULL_KEYWORD_TRANSFORMER))
#define NULL_KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformerClass))

typedef struct _NullKeywordTransformer NullKeywordTransformer;
typedef struct _NullKeywordTransformerClass NullKeywordTransformerClass;
typedef struct _NullKeywordTransformerPrivate NullKeywordTransformerPrivate;

#define TYPE_ACD_SEE_KEYWORD_TRANSFORMER (acd_see_keyword_transformer_get_type ())
#define ACD_SEE_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer))
#define ACD_SEE_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformerClass))
#define IS_ACD_SEE_KEYWORD_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER))
#define IS_ACD_SEE_KEYWORD_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACD_SEE_KEYWORD_TRANSFORMER))
#define ACD_SEE_KEYWORD_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformerClass))

typedef struct _ACDSeeKeywordTransformer ACDSeeKeywordTransformer;
typedef struct _ACDSeeKeywordTransformerClass ACDSeeKeywordTransformerClass;
typedef struct _ACDSeeKeywordTransformerPrivate ACDSeeKeywordTransformerPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_markup_parse_context_unref0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
#define HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField))
#define HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))
#define IS_HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define IS_HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define HIERARCHICAL_KEYWORD_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))

typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
typedef struct _HierarchicalKeywordFieldClass HierarchicalKeywordFieldClass;
typedef struct _HierarchicalKeywordFieldPrivate HierarchicalKeywordFieldPrivate;
#define _keyword_transformer_unref0(var) ((var == NULL) ? NULL : (var = (keyword_transformer_unref (var), NULL)))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, gpointer user_data);
typedef struct _Block1Data Block1Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;
typedef struct _Block6Data Block6Data;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_GPS_COORDS (gps_coords_get_type ())
typedef struct _GpsCoords GpsCoords;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeywordTransformer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KeywordTransformerPrivate * priv;
};

struct _KeywordTransformerClass {
	GTypeClass parent_class;
	void (*finalize) (KeywordTransformer *self);
	GeeList* (*transform) (KeywordTransformer* self, const gchar* input, GError** error);
};

struct _ParamSpecKeywordTransformer {
	GParamSpec parent_instance;
};

struct _NullKeywordTransformer {
	KeywordTransformer parent_instance;
	NullKeywordTransformerPrivate * priv;
};

struct _NullKeywordTransformerClass {
	KeywordTransformerClass parent_class;
};

struct _ACDSeeKeywordTransformer {
	KeywordTransformer parent_instance;
	ACDSeeKeywordTransformerPrivate * priv;
};

struct _ACDSeeKeywordTransformerClass {
	KeywordTransformerClass parent_class;
};

struct _ACDSeeKeywordTransformerPrivate {
	GMarkupParser parser;
	GError* error;
	GeeArrayQueue* stack;
	GeeArrayList* result;
	gboolean assigned;
};

struct _HierarchicalKeywordField {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HierarchicalKeywordFieldPrivate * priv;
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
	KeywordTransformer* transformer;
};

struct _HierarchicalKeywordFieldClass {
	GTypeClass parent_class;
	void (*finalize) (HierarchicalKeywordField *self);
};

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	GBytes* (*flatten) (PhotoPreview* self, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
	gchar* metadata_hash;
	gchar* thumbnail_md5;
};

struct _Block1Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata* self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata* self;
	glong value;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataRational rational;
};

struct _Block5Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataDateTime* date_time;
};

struct _Block6Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* comment;
};

struct _GpsCoords {
	gint has_gps;
	gdouble latitude;
	gdouble longitude;
};

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};

static gpointer keyword_transformer_parent_class = NULL;
static gpointer null_keyword_transformer_parent_class = NULL;
static gint ACDSeeKeywordTransformer_private_offset;
static gpointer acd_see_keyword_transformer_parent_class = NULL;
static gpointer hierarchical_keyword_field_parent_class = NULL;
static gint PhotoPreview_private_offset;
static gpointer photo_preview_parent_class = NULL;
static gint PhotoMetadata_private_offset;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
VALA_EXTERN gchar** photo_metadata_HEIGHT_TAGS;
VALA_EXTERN gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_COMMENT_TAGS;
static gint photo_metadata_COMMENT_TAGS_length1;
static gchar** photo_metadata_COMMENT_TAGS = NULL;
static gint photo_metadata_COMMENT_TAGS_length1 = 0;
static gint _photo_metadata_COMMENT_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gchar** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static gchar** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

VALA_EXTERN GType metadata_domain_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer keyword_transformer_ref (gpointer instance);
VALA_EXTERN void keyword_transformer_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_keyword_transformer (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_keyword_transformer (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_keyword_transformer (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_keyword_transformer (const GValue* value);
VALA_EXTERN GType keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KeywordTransformer, keyword_transformer_unref)
VALA_EXTERN GeeList* keyword_transformer_transform (KeywordTransformer* self,
                                        const gchar* input,
                                        GError** error);
static GeeList* keyword_transformer_real_transform (KeywordTransformer* self,
                                             const gchar* input,
                                             GError** error);
VALA_EXTERN KeywordTransformer* keyword_transformer_construct (GType object_type);
static void keyword_transformer_finalize (KeywordTransformer * obj);
static GType keyword_transformer_get_type_once (void);
VALA_EXTERN GType null_keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NullKeywordTransformer, keyword_transformer_unref)
static GeeList* null_keyword_transformer_real_transform (KeywordTransformer* base,
                                                  const gchar* input,
                                                  GError** error);
VALA_EXTERN NullKeywordTransformer* null_keyword_transformer_new (void);
VALA_EXTERN NullKeywordTransformer* null_keyword_transformer_construct (GType object_type);
static GType null_keyword_transformer_get_type_once (void);
VALA_EXTERN GType acd_see_keyword_transformer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ACDSeeKeywordTransformer, keyword_transformer_unref)
VALA_EXTERN ACDSeeKeywordTransformer* acd_see_keyword_transformer_new (void);
VALA_EXTERN ACDSeeKeywordTransformer* acd_see_keyword_transformer_construct (GType object_type);
static void acd_see_keyword_transformer_on_start (ACDSeeKeywordTransformer* self,
                                           GMarkupParseContext* ctx,
                                           const gchar* name,
                                           gchar** attribute_names,
                                           gchar** attribute_values,
                                           GError** error);
static void _acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func (GMarkupParseContext* context,
                                                                              const gchar* element_name,
                                                                              gchar** attribute_names,
                                                                              gchar** attribute_values,
                                                                              gpointer self,
                                                                              GError** error);
static void acd_see_keyword_transformer_on_end (ACDSeeKeywordTransformer* self,
                                         GMarkupParseContext* ctx,
                                         const gchar* name,
                                         GError** error);
static void _acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func (GMarkupParseContext* context,
                                                                          const gchar* element_name,
                                                                          gpointer self,
                                                                          GError** error);
static void acd_see_keyword_transformer_on_text (ACDSeeKeywordTransformer* self,
                                          GMarkupParseContext* ctx,
                                          const gchar* text,
                                          GError** error);
static void _acd_see_keyword_transformer_on_text_gmarkup_parser_text_func (GMarkupParseContext* context,
                                                                    const gchar* text,
                                                                    gsize text_len,
                                                                    gpointer self,
                                                                    GError** error);
static void acd_see_keyword_transformer_on_error (ACDSeeKeywordTransformer* self,
                                           GMarkupParseContext* ctx,
                                           GError* _error_);
static void _acd_see_keyword_transformer_on_error_gmarkup_parser_error_func (GMarkupParseContext* context,
                                                                      GError* _error_,
                                                                      gpointer self);
static GeeList* acd_see_keyword_transformer_real_transform (KeywordTransformer* base,
                                                     const gchar* input,
                                                     GError** error);
static void acd_see_keyword_transformer_finalize (KeywordTransformer * obj);
static GType acd_see_keyword_transformer_get_type_once (void);
VALA_EXTERN gpointer hierarchical_keyword_field_ref (gpointer instance);
VALA_EXTERN void hierarchical_keyword_field_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
VALA_EXTERN void value_set_hierarchical_keyword_field (GValue* value,
                                           gpointer v_object);
VALA_EXTERN void value_take_hierarchical_keyword_field (GValue* value,
                                            gpointer v_object);
VALA_EXTERN gpointer value_get_hierarchical_keyword_field (const GValue* value);
VALA_EXTERN GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalKeywordField, hierarchical_keyword_field_unref)
VALA_EXTERN HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name,
                                                          const gchar* path_separator,
                                                          gboolean wants_leading_separator,
                                                          gboolean is_writeable,
                                                          KeywordTransformer* transformer);
VALA_EXTERN HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type,
                                                                const gchar* field_name,
                                                                const gchar* path_separator,
                                                                gboolean wants_leading_separator,
                                                                gboolean is_writeable,
                                                                KeywordTransformer* transformer);
static void hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj);
static GType hierarchical_keyword_field_get_type_once (void);
VALA_EXTERN gpointer photo_preview_ref (gpointer instance);
VALA_EXTERN void photo_preview_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_photo_preview (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_photo_preview (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_photo_preview (const GValue* value);
VALA_EXTERN GType photo_preview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoPreview, photo_preview_unref)
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN GBytes* photo_preview_flatten (PhotoPreview* self,
                               GError** error);
VALA_EXTERN GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
VALA_EXTERN PhotoPreview* photo_preview_construct (GType object_type,
                                       const gchar* name,
                                       Dimensions* dimensions,
                                       guint32 size,
                                       const gchar* mime_type,
                                       const gchar* extension);
VALA_EXTERN gchar* photo_preview_get_name (PhotoPreview* self);
VALA_EXTERN void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
VALA_EXTERN guint32 photo_preview_get_size (PhotoPreview* self);
VALA_EXTERN gchar* photo_preview_get_mime_type (PhotoPreview* self);
VALA_EXTERN gchar* photo_preview_get_extension (PhotoPreview* self);
static GBytes* photo_preview_real_flatten (PhotoPreview* self,
                                    GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self,
                                          GError** error);
static void photo_preview_finalize (PhotoPreview * obj);
static GType photo_preview_get_type_once (void);
VALA_EXTERN GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
VALA_EXTERN GType photo_metadata_set_option_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType prepare_input_text_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoMetadata* photo_metadata_new (void);
VALA_EXTERN PhotoMetadata* photo_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base,
                                         GFile* file,
                                         GError** error);
VALA_EXTERN void photo_metadata_write_to_file (PhotoMetadata* self,
                                   GFile* file,
                                   GError** error);
VALA_EXTERN void photo_metadata_read_from_buffer (PhotoMetadata* self,
                                      guint8* buffer,
                                      gint buffer_length1,
                                      gint length,
                                      GError** error);
VALA_EXTERN void photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                            GBytes* buffer,
                                            GError** error);
VALA_EXTERN MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
VALA_EXTERN gboolean photo_metadata_has_domain (PhotoMetadata* self,
                                    MetadataDomain domain);
VALA_EXTERN gboolean photo_metadata_has_exif (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_has_xmp (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_has_iptc (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                             MetadataDomain domain);
VALA_EXTERN gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_has_tag (PhotoMetadata* self,
                                 const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self,
                                          GCompareDataFunc compare_func,
                                          gpointer compare_func_target,
                                          GDestroyNotify compare_func_target_destroy_notify);
VALA_EXTERN GeeCollection* photo_metadata_get_tags (PhotoMetadata* self,
                                        MetadataDomain domain,
                                        GCompareDataFunc compare_func,
                                        gpointer compare_func_target,
                                        GDestroyNotify compare_func_target_destroy_notify);
VALA_EXTERN GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self,
                                            GCompareDataFunc compare_func,
                                            gpointer compare_func_target,
                                            GDestroyNotify compare_func_target_destroy_notify);
VALA_EXTERN gchar* photo_metadata_get_tag_label (PhotoMetadata* self,
                                     const gchar* tag);
VALA_EXTERN gchar* photo_metadata_get_tag_description (PhotoMetadata* self,
                                           const gchar* tag);
VALA_EXTERN gchar* photo_metadata_get_string (PhotoMetadata* self,
                                  const gchar* tag,
                                  PrepareInputTextOptions options);
VALA_EXTERN gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
VALA_EXTERN gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                              const gchar* tag,
                                              PrepareInputTextOptions options);
VALA_EXTERN gchar* photo_metadata_get_first_string (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1);
VALA_EXTERN gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                                    gchar** tags,
                                                    gint tags_length1);
VALA_EXTERN GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self,
                                             const gchar* tag);
VALA_EXTERN GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                                   gchar** tags,
                                                   gint tags_length1);
VALA_EXTERN void photo_metadata_set_string (PhotoMetadata* self,
                                const gchar* tag,
                                const gchar* value,
                                PrepareInputTextOptions options,
                                gint length);
static void photo_metadata_set_all_generic (PhotoMetadata* self,
                                     gchar** tags,
                                     gint tags_length1,
                                     PhotoMetadataSetOption option,
                                     PhotoMetadataSetGenericValue setter,
                                     gpointer setter_target);
VALA_EXTERN void photo_metadata_set_all_string (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1,
                                    const gchar* value,
                                    PhotoMetadataSetOption option);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda5_ (Block1Data* _data1_,
                 const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
VALA_EXTERN void photo_metadata_set_string_multiple (PhotoMetadata* self,
                                         const gchar* tag,
                                         GeeCollection* collection);
static void _vala_array_add46 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add47 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN void photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1,
                                             GeeCollection* values,
                                             PhotoMetadataSetOption option);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda6_ (Block2Data* _data2_,
                 const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
VALA_EXTERN gboolean photo_metadata_get_long (PhotoMetadata* self,
                                  const gchar* tag,
                                  glong* value);
VALA_EXTERN gboolean photo_metadata_get_first_long (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        glong* value);
VALA_EXTERN void photo_metadata_set_long (PhotoMetadata* self,
                              const gchar* tag,
                              glong value);
VALA_EXTERN void photo_metadata_set_all_long (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  glong value,
                                  PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda7_ (Block3Data* _data3_,
                 const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
VALA_EXTERN gboolean photo_metadata_get_rational (PhotoMetadata* self,
                                      const gchar* tag,
                                      MetadataRational* rational);
VALA_EXTERN gboolean photo_metadata_get_first_rational (PhotoMetadata* self,
                                            gchar** tags,
                                            gint tags_length1,
                                            MetadataRational* rational);
VALA_EXTERN void photo_metadata_set_rational (PhotoMetadata* self,
                                  const gchar* tag,
                                  MetadataRational* rational);
VALA_EXTERN void photo_metadata_set_all_rational (PhotoMetadata* self,
                                      gchar** tags,
                                      gint tags_length1,
                                      MetadataRational* rational,
                                      PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda8_ (Block4Data* _data4_,
                 const gchar* tag);
static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
VALA_EXTERN MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self,
                                                const gchar* tag);
VALA_EXTERN MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self,
                                                      gchar** tags,
                                                      gint tags_length1);
VALA_EXTERN void photo_metadata_set_date_time (PhotoMetadata* self,
                                   const gchar* tag,
                                   MetadataDateTime* date_time);
VALA_EXTERN void photo_metadata_set_all_date_time (PhotoMetadata* self,
                                       gchar** tags,
                                       gint tags_length1,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda9_ (Block5Data* _data5_,
                 const gchar* tag);
static void ___lambda9__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
VALA_EXTERN gchar* photo_metadata_exif_hash (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_thumbnail_hash (PhotoMetadata* self);
VALA_EXTERN guint photo_metadata_get_preview_count (PhotoMetadata* self);
VALA_EXTERN PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                                                              const gchar* name,
                                                                              guint number,
                                                                              GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type,
                                                                                    PhotoMetadata* owner,
                                                                                    const gchar* name,
                                                                                    guint number,
                                                                                    GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadataInternalPhotoPreview, photo_preview_unref)
VALA_EXTERN void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
VALA_EXTERN void photo_metadata_remove_tags (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1);
VALA_EXTERN void photo_metadata_clear_domain (PhotoMetadata* self,
                                  MetadataDomain domain);
VALA_EXTERN void photo_metadata_clear (PhotoMetadata* self);
VALA_EXTERN MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                                MetadataDateTime* date_time,
                                                PhotoMetadataSetOption option);
VALA_EXTERN MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
VALA_EXTERN MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                             MetadataDateTime* date_time,
                                             PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
VALA_EXTERN Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
VALA_EXTERN void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
VALA_EXTERN gboolean is_string_empty (const gchar* s);
VALA_EXTERN void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_comment (MediaMetadata* base);
VALA_EXTERN void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment,
                                 PhotoMetadataSetOption option);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda10_ (Block6Data* _data6_,
                   const gchar* tag);
static void ____lambda10__photo_metadata_set_generic_value (const gchar* tag,
                                                     gpointer self);
VALA_EXTERN GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
VALA_EXTERN gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
VALA_EXTERN gpointer hierarchical_tag_index_ref (gpointer instance);
VALA_EXTERN void hierarchical_tag_index_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_hierarchical_tag_index (const GValue* value);
VALA_EXTERN GType hierarchical_tag_index_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HierarchicalTagIndex, hierarchical_tag_index_unref)
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                        HierarchicalTagIndex* index);
VALA_EXTERN GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
VALA_EXTERN void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
VALA_EXTERN HierarchicalTagIndex* hierarchical_tag_index_new (void);
VALA_EXTERN HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
VALA_EXTERN GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
VALA_EXTERN void hierarchical_tag_index_add_path (HierarchicalTagIndex* self,
                                      const gchar* tag,
                                      const gchar* path);
VALA_EXTERN GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
VALA_EXTERN gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
VALA_EXTERN GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
VALA_EXTERN gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag,
                                                const gchar* foreign_separator);
VALA_EXTERN gboolean photo_metadata_has_orientation (PhotoMetadata* self);
VALA_EXTERN GType orientation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Orientation photo_metadata_get_orientation (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
VALA_EXTERN gboolean photo_metadata_get_gps (PhotoMetadata* self,
                                 gdouble* longitude,
                                 gchar** long_ref,
                                 gdouble* latitude,
                                 gchar** lat_ref,
                                 gdouble* altitude);
VALA_EXTERN GType gps_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GpsCoords* gps_coords_dup (const GpsCoords* self);
VALA_EXTERN void gps_coords_free (GpsCoords* self);
VALA_EXTERN void photo_metadata_get_gps_coords (PhotoMetadata* self,
                                    GpsCoords* result);
VALA_EXTERN void photo_metadata_set_gps_coords (PhotoMetadata* self,
                                    GpsCoords* gps_coords);
VALA_EXTERN gboolean photo_metadata_get_exposure (PhotoMetadata* self,
                                      MetadataRational* exposure);
VALA_EXTERN gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_get_iso (PhotoMetadata* self,
                                 glong* iso);
VALA_EXTERN gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_get_aperture (PhotoMetadata* self,
                                      MetadataRational* aperture);
VALA_EXTERN gchar* photo_metadata_get_aperture_string (PhotoMetadata* self,
                                           gboolean pango_formatted);
VALA_EXTERN gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_get_flash (PhotoMetadata* self,
                                   glong* flash);
VALA_EXTERN gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
VALA_EXTERN gboolean photo_metadata_get_focal_length (PhotoMetadata* self,
                                          MetadataRational* focal_length);
VALA_EXTERN gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_get_artist (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_get_copyright (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_get_software (PhotoMetadata* self);
VALA_EXTERN void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
VALA_EXTERN void photo_metadata_remove_software (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Rating photo_metadata_get_rating (PhotoMetadata* self);
VALA_EXTERN Rating rating_unserialize (gint value);
VALA_EXTERN void photo_metadata_set_rating (PhotoMetadata* self,
                                Rating rating);
VALA_EXTERN gint rating_serialize (Rating self);
static GBytes* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                            GError** error);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj);
static GType photo_metadata_internal_photo_preview_get_type_once (void);
static void photo_metadata_finalize (MediaMetadata * obj);
static GType photo_metadata_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gint RESOURCES_rating_thresholds[6];

static GType
metadata_domain_get_type_once (void)
{
	static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
	GType metadata_domain_type_id;
	metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
	return metadata_domain_type_id;
}

GType
metadata_domain_get_type (void)
{
	static volatile gsize metadata_domain_type_id__once = 0;
	if (g_once_init_enter (&metadata_domain_type_id__once)) {
		GType metadata_domain_type_id;
		metadata_domain_type_id = metadata_domain_get_type_once ();
		g_once_init_leave (&metadata_domain_type_id__once, metadata_domain_type_id);
	}
	return metadata_domain_type_id__once;
}

static GeeList*
keyword_transformer_real_transform (KeywordTransformer* self,
                                    const gchar* input,
                                    GError** error)
{
#line 32 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `keyword_transformer_transform'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 968 "PhotoMetadata.c"
}

GeeList*
keyword_transformer_transform (KeywordTransformer* self,
                               const gchar* input,
                               GError** error)
{
	KeywordTransformerClass* _klass_;
#line 32 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_KEYWORD_TRANSFORMER (self), NULL);
#line 32 "../src/photos/PhotoMetadata.vala"
	_klass_ = KEYWORD_TRANSFORMER_GET_CLASS (self);
#line 32 "../src/photos/PhotoMetadata.vala"
	if (_klass_->transform) {
#line 32 "../src/photos/PhotoMetadata.vala"
		return _klass_->transform (self, input, error);
#line 985 "PhotoMetadata.c"
	}
#line 32 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 989 "PhotoMetadata.c"
}

KeywordTransformer*
keyword_transformer_construct (GType object_type)
{
	KeywordTransformer* self = NULL;
#line 31 "../src/photos/PhotoMetadata.vala"
	self = (KeywordTransformer*) g_type_create_instance (object_type);
#line 31 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1000 "PhotoMetadata.c"
}

static void
value_keyword_transformer_init (GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1008 "PhotoMetadata.c"
}

static void
value_keyword_transformer_free_value (GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (value->data[0].v_pointer);
#line 1018 "PhotoMetadata.c"
	}
}

static void
value_keyword_transformer_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = keyword_transformer_ref (src_value->data[0].v_pointer);
#line 1030 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1034 "PhotoMetadata.c"
	}
}

static gpointer
value_keyword_transformer_peek_pointer (const GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1043 "PhotoMetadata.c"
}

static gchar*
value_keyword_transformer_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1054 "PhotoMetadata.c"
		KeywordTransformer * object;
		object = collect_values[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1061 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1065 "PhotoMetadata.c"
		}
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = keyword_transformer_ref (object);
#line 1069 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1073 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1077 "PhotoMetadata.c"
}

static gchar*
value_keyword_transformer_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	KeywordTransformer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 31 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1092 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1098 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1102 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		*object_p = keyword_transformer_ref (value->data[0].v_pointer);
#line 1106 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1110 "PhotoMetadata.c"
}

GParamSpec*
param_spec_keyword_transformer (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecKeywordTransformer* spec;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_KEYWORD_TRANSFORMER), NULL);
#line 31 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1129 "PhotoMetadata.c"
}

gpointer
value_get_keyword_transformer (const GValue* value)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER), NULL);
#line 31 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1139 "PhotoMetadata.c"
}

void
value_set_keyword_transformer (GValue* value,
                               gpointer v_object)
{
	KeywordTransformer * old;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_ref (value->data[0].v_pointer);
#line 1161 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1165 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (old);
#line 1171 "PhotoMetadata.c"
	}
}

void
value_take_keyword_transformer (GValue* value,
                                gpointer v_object)
{
	KeywordTransformer * old;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEYWORD_TRANSFORMER));
#line 31 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1192 "PhotoMetadata.c"
	} else {
#line 31 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1196 "PhotoMetadata.c"
	}
#line 31 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "../src/photos/PhotoMetadata.vala"
		keyword_transformer_unref (old);
#line 1202 "PhotoMetadata.c"
	}
}

static void
keyword_transformer_class_init (KeywordTransformerClass * klass,
                                gpointer klass_data)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->finalize = keyword_transformer_finalize;
#line 31 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) keyword_transformer_real_transform;
#line 1216 "PhotoMetadata.c"
}

static void
keyword_transformer_instance_init (KeywordTransformer * self,
                                   gpointer klass)
{
#line 31 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1225 "PhotoMetadata.c"
}

static void
keyword_transformer_finalize (KeywordTransformer * obj)
{
	KeywordTransformer * self;
#line 31 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer);
#line 31 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 1236 "PhotoMetadata.c"
}

static GType
keyword_transformer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_keyword_transformer_init, value_keyword_transformer_free_value, value_keyword_transformer_copy_value, value_keyword_transformer_peek_pointer, "p", value_keyword_transformer_collect_value, "p", value_keyword_transformer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (KeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeywordTransformer), 0, (GInstanceInitFunc) keyword_transformer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType keyword_transformer_type_id;
	keyword_transformer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KeywordTransformer", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return keyword_transformer_type_id;
}

GType
keyword_transformer_get_type (void)
{
	static volatile gsize keyword_transformer_type_id__once = 0;
	if (g_once_init_enter (&keyword_transformer_type_id__once)) {
		GType keyword_transformer_type_id;
		keyword_transformer_type_id = keyword_transformer_get_type_once ();
		g_once_init_leave (&keyword_transformer_type_id__once, keyword_transformer_type_id);
	}
	return keyword_transformer_type_id__once;
}

gpointer
keyword_transformer_ref (gpointer instance)
{
	KeywordTransformer * self;
	self = instance;
#line 31 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 1271 "PhotoMetadata.c"
}

void
keyword_transformer_unref (gpointer instance)
{
	KeywordTransformer * self;
	self = instance;
#line 31 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "../src/photos/PhotoMetadata.vala"
		KEYWORD_TRANSFORMER_GET_CLASS (self)->finalize (self);
#line 31 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1285 "PhotoMetadata.c"
	}
}

static GeeList*
null_keyword_transformer_real_transform (KeywordTransformer* base,
                                         const gchar* input,
                                         GError** error)
{
	NullKeywordTransformer * self;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 36 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_NULL_KEYWORD_TRANSFORMER, NullKeywordTransformer);
#line 36 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 37 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 37 "../src/photos/PhotoMetadata.vala"
	_result_ = _tmp0_;
#line 38 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_result_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), input);
#line 40 "../src/photos/PhotoMetadata.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_result_, GEE_TYPE_LIST, GeeList);
#line 40 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1312 "PhotoMetadata.c"
}

NullKeywordTransformer*
null_keyword_transformer_construct (GType object_type)
{
	NullKeywordTransformer* self = NULL;
#line 35 "../src/photos/PhotoMetadata.vala"
	self = (NullKeywordTransformer*) keyword_transformer_construct (object_type);
#line 35 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1323 "PhotoMetadata.c"
}

NullKeywordTransformer*
null_keyword_transformer_new (void)
{
#line 35 "../src/photos/PhotoMetadata.vala"
	return null_keyword_transformer_construct (TYPE_NULL_KEYWORD_TRANSFORMER);
#line 1331 "PhotoMetadata.c"
}

static void
null_keyword_transformer_class_init (NullKeywordTransformerClass * klass,
                                     gpointer klass_data)
{
#line 35 "../src/photos/PhotoMetadata.vala"
	null_keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) null_keyword_transformer_real_transform;
#line 1342 "PhotoMetadata.c"
}

static void
null_keyword_transformer_instance_init (NullKeywordTransformer * self,
                                        gpointer klass)
{
}

static GType
null_keyword_transformer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NullKeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) null_keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NullKeywordTransformer), 0, (GInstanceInitFunc) null_keyword_transformer_instance_init, NULL };
	GType null_keyword_transformer_type_id;
	null_keyword_transformer_type_id = g_type_register_static (TYPE_KEYWORD_TRANSFORMER, "NullKeywordTransformer", &g_define_type_info, 0);
	return null_keyword_transformer_type_id;
}

GType
null_keyword_transformer_get_type (void)
{
	static volatile gsize null_keyword_transformer_type_id__once = 0;
	if (g_once_init_enter (&null_keyword_transformer_type_id__once)) {
		GType null_keyword_transformer_type_id;
		null_keyword_transformer_type_id = null_keyword_transformer_get_type_once ();
		g_once_init_leave (&null_keyword_transformer_type_id__once, null_keyword_transformer_type_id);
	}
	return null_keyword_transformer_type_id__once;
}

static inline gpointer
acd_see_keyword_transformer_get_instance_private (ACDSeeKeywordTransformer* self)
{
	return G_STRUCT_MEMBER_P (self, ACDSeeKeywordTransformer_private_offset);
}

static void
_acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func (GMarkupParseContext* context,
                                                                         const gchar* element_name,
                                                                         gchar** attribute_names,
                                                                         gchar** attribute_values,
                                                                         gpointer self,
                                                                         GError** error)
{
#line 64 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_start ((ACDSeeKeywordTransformer*) self, context, element_name, attribute_names, attribute_values, error);
#line 1388 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func (GMarkupParseContext* context,
                                                                     const gchar* element_name,
                                                                     gpointer self,
                                                                     GError** error)
{
#line 65 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_end ((ACDSeeKeywordTransformer*) self, context, element_name, error);
#line 1399 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_text_gmarkup_parser_text_func (GMarkupParseContext* context,
                                                               const gchar* text,
                                                               gsize text_len,
                                                               gpointer self,
                                                               GError** error)
{
#line 66 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_text ((ACDSeeKeywordTransformer*) self, context, text, error);
#line 1411 "PhotoMetadata.c"
}

static void
_acd_see_keyword_transformer_on_error_gmarkup_parser_error_func (GMarkupParseContext* context,
                                                                 GError* _error_,
                                                                 gpointer self)
{
#line 67 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_on_error ((ACDSeeKeywordTransformer*) self, context, _error_);
#line 1421 "PhotoMetadata.c"
}

ACDSeeKeywordTransformer*
acd_see_keyword_transformer_construct (GType object_type)
{
	ACDSeeKeywordTransformer* self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayQueue* _tmp1_;
#line 62 "../src/photos/PhotoMetadata.vala"
	self = (ACDSeeKeywordTransformer*) keyword_transformer_construct (object_type);
#line 63 "../src/photos/PhotoMetadata.vala"
	memset (&self->priv->parser, 0, sizeof (GMarkupParser));
#line 64 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.start_element = _acd_see_keyword_transformer_on_start_gmarkup_parser_start_element_func;
#line 65 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.end_element = _acd_see_keyword_transformer_on_end_gmarkup_parser_end_element_func;
#line 66 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.text = _acd_see_keyword_transformer_on_text_gmarkup_parser_text_func;
#line 67 "../src/photos/PhotoMetadata.vala"
	self->priv->parser.error = _acd_see_keyword_transformer_on_error_gmarkup_parser_error_func;
#line 68 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 68 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->result);
#line 68 "../src/photos/PhotoMetadata.vala"
	self->priv->result = _tmp0_;
#line 69 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_array_queue_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 69 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->stack);
#line 69 "../src/photos/PhotoMetadata.vala"
	self->priv->stack = _tmp1_;
#line 62 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1456 "PhotoMetadata.c"
}

ACDSeeKeywordTransformer*
acd_see_keyword_transformer_new (void)
{
#line 62 "../src/photos/PhotoMetadata.vala"
	return acd_see_keyword_transformer_construct (TYPE_ACD_SEE_KEYWORD_TRANSFORMER);
#line 1464 "PhotoMetadata.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 1472 "PhotoMetadata.c"
}

static GeeList*
acd_see_keyword_transformer_real_transform (KeywordTransformer* base,
                                            const gchar* input,
                                            GError** error)
{
	ACDSeeKeywordTransformer * self;
	GeeArrayQueue* _tmp0_;
	GeeArrayList* _tmp1_;
	GMarkupParseContext* ctx = NULL;
	GMarkupParser _tmp2_;
	GMarkupParseContext* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	GeeList* _tmp7_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 72 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer);
#line 72 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 73 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->stack;
#line 73 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 74 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->result;
#line 74 "../src/photos/PhotoMetadata.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->parser;
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_markup_parse_context_new (&_tmp2_, 0, self, NULL);
#line 75 "../src/photos/PhotoMetadata.vala"
	ctx = _tmp3_;
#line 77 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = strlen (input);
#line 77 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 77 "../src/photos/PhotoMetadata.vala"
	g_markup_parse_context_parse (ctx, input, (gssize) _tmp5_, &_inner_error0_);
#line 77 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 77 "../src/photos/PhotoMetadata.vala"
		_g_markup_parse_context_unref0 (ctx);
#line 77 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 1524 "PhotoMetadata.c"
	}
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->result;
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList));
#line 79 "../src/photos/PhotoMetadata.vala"
	result = _tmp7_;
#line 79 "../src/photos/PhotoMetadata.vala"
	_g_markup_parse_context_unref0 (ctx);
#line 79 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1536 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_on_start (ACDSeeKeywordTransformer* self,
                                      GMarkupParseContext* ctx,
                                      const gchar* name,
                                      gchar** attribute_names,
                                      gchar** attribute_values,
                                      GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (name != NULL);
#line 90 "../src/photos/PhotoMetadata.vala"
	self->priv->assigned = FALSE;
#line 91 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Categories") == 0) {
#line 92 "../src/photos/PhotoMetadata.vala"
		return;
#line 1561 "PhotoMetadata.c"
	}
#line 95 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Category") != 0) {
#line 96 "../src/photos/PhotoMetadata.vala"
		return;
#line 1567 "PhotoMetadata.c"
	}
#line 99 "../src/photos/PhotoMetadata.vala"
	g_markup_collect_attributes (name, attribute_names, attribute_values, &_inner_error0_, G_MARKUP_COLLECT_BOOLEAN, "Assigned", &_tmp0_, G_MARKUP_COLLECT_INVALID);
#line 99 "../src/photos/PhotoMetadata.vala"
	self->priv->assigned = _tmp0_;
#line 99 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/photos/PhotoMetadata.vala"
		if (_inner_error0_->domain == G_MARKUP_ERROR) {
#line 99 "../src/photos/PhotoMetadata.vala"
			g_propagate_error (error, _inner_error0_);
#line 99 "../src/photos/PhotoMetadata.vala"
			return;
#line 1581 "PhotoMetadata.c"
		} else {
#line 99 "../src/photos/PhotoMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/photos/PhotoMetadata.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/photos/PhotoMetadata.vala"
			return;
#line 1589 "PhotoMetadata.c"
		}
	}
}

static void
acd_see_keyword_transformer_on_end (ACDSeeKeywordTransformer* self,
                                    GMarkupParseContext* ctx,
                                    const gchar* name,
                                    GError** error)
{
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 106 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (name != NULL);
#line 108 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (name, "Category") == 0) {
#line 1608 "PhotoMetadata.c"
		GeeArrayQueue* _tmp0_;
		gpointer _tmp1_;
		gchar* _tmp2_;
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->stack;
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_deque_poll_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_DEQUE, GeeDeque));
#line 109 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = (gchar*) _tmp1_;
#line 109 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp2_);
#line 1620 "PhotoMetadata.c"
	}
}

static void
acd_see_keyword_transformer_on_text (ACDSeeKeywordTransformer* self,
                                     GMarkupParseContext* ctx,
                                     const gchar* text,
                                     GError** error)
{
	GeeArrayQueue* _tmp0_;
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 113 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (text != NULL);
#line 115 "../src/photos/PhotoMetadata.vala"
	if (g_strcmp0 (text, "") == 0) {
#line 116 "../src/photos/PhotoMetadata.vala"
		return;
#line 1641 "PhotoMetadata.c"
	}
#line 119 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->stack;
#line 119 "../src/photos/PhotoMetadata.vala"
	gee_deque_offer_tail (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_DEQUE, GeeDeque), text);
#line 120 "../src/photos/PhotoMetadata.vala"
	if (self->priv->assigned) {
#line 1649 "PhotoMetadata.c"
		GString* builder = NULL;
		GString* _tmp1_;
		GString* _tmp9_;
		GeeArrayList* _tmp12_;
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 121 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = g_string_new ("");
#line 121 "../src/photos/PhotoMetadata.vala"
		builder = _tmp1_;
#line 1660 "PhotoMetadata.c"
		{
			GeeIterator* _f_it = NULL;
			GeeArrayQueue* _tmp2_;
			GeeIterator* _tmp3_;
#line 122 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->stack;
#line 122 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 122 "../src/photos/PhotoMetadata.vala"
			_f_it = _tmp3_;
#line 122 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 1673 "PhotoMetadata.c"
				GeeIterator* _tmp4_;
				gchar* f = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				GString* _tmp7_;
				const gchar* _tmp8_;
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _f_it;
#line 122 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp4_)) {
#line 122 "../src/photos/PhotoMetadata.vala"
					break;
#line 1686 "PhotoMetadata.c"
				}
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _f_it;
#line 122 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 122 "../src/photos/PhotoMetadata.vala"
				f = (gchar*) _tmp6_;
#line 123 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = builder;
#line 123 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = f;
#line 123 "../src/photos/PhotoMetadata.vala"
				g_string_append_printf (_tmp7_, "%s|", _tmp8_);
#line 122 "../src/photos/PhotoMetadata.vala"
				_g_free0 (f);
#line 1702 "PhotoMetadata.c"
			}
#line 122 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_f_it);
#line 1706 "PhotoMetadata.c"
		}
#line 125 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = builder;
#line 125 "../src/photos/PhotoMetadata.vala"
		if (_tmp9_->len > ((gssize) 0)) {
#line 1712 "PhotoMetadata.c"
			GString* _tmp10_;
			GString* _tmp11_;
#line 126 "../src/photos/PhotoMetadata.vala"
			_tmp10_ = builder;
#line 126 "../src/photos/PhotoMetadata.vala"
			_tmp11_ = builder;
#line 126 "../src/photos/PhotoMetadata.vala"
			g_string_truncate (_tmp10_, (gsize) (_tmp11_->len - 1));
#line 1721 "PhotoMetadata.c"
		}
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->result;
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = builder;
#line 128 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_->str;
#line 128 "../src/photos/PhotoMetadata.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 120 "../src/photos/PhotoMetadata.vala"
		_g_string_free0 (builder);
#line 1733 "PhotoMetadata.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 133 "../src/photos/PhotoMetadata.vala"
	return self ? g_error_copy (self) : NULL;
#line 1742 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_on_error (ACDSeeKeywordTransformer* self,
                                      GMarkupParseContext* ctx,
                                      GError* _error_)
{
	GError* _tmp0_;
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_ACD_SEE_KEYWORD_TRANSFORMER (self));
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (ctx != NULL);
#line 132 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (_error_ != NULL);
#line 133 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_error_copy0 (_error_);
#line 133 "../src/photos/PhotoMetadata.vala"
	_g_error_free0 (self->priv->error);
#line 133 "../src/photos/PhotoMetadata.vala"
	self->priv->error = _tmp0_;
#line 1763 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_class_init (ACDSeeKeywordTransformerClass * klass,
                                        gpointer klass_data)
{
#line 55 "../src/photos/PhotoMetadata.vala"
	acd_see_keyword_transformer_parent_class = g_type_class_peek_parent (klass);
#line 55 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->finalize = acd_see_keyword_transformer_finalize;
#line 55 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &ACDSeeKeywordTransformer_private_offset);
#line 55 "../src/photos/PhotoMetadata.vala"
	((KeywordTransformerClass *) klass)->transform = (GeeList* (*) (KeywordTransformer*, const gchar*, GError**)) acd_see_keyword_transformer_real_transform;
#line 1778 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_instance_init (ACDSeeKeywordTransformer * self,
                                           gpointer klass)
{
#line 55 "../src/photos/PhotoMetadata.vala"
	self->priv = acd_see_keyword_transformer_get_instance_private (self);
#line 1787 "PhotoMetadata.c"
}

static void
acd_see_keyword_transformer_finalize (KeywordTransformer * obj)
{
	ACDSeeKeywordTransformer * self;
#line 55 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACD_SEE_KEYWORD_TRANSFORMER, ACDSeeKeywordTransformer);
#line 57 "../src/photos/PhotoMetadata.vala"
	_g_error_free0 (self->priv->error);
#line 58 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->stack);
#line 59 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->result);
#line 55 "../src/photos/PhotoMetadata.vala"
	KEYWORD_TRANSFORMER_CLASS (acd_see_keyword_transformer_parent_class)->finalize (obj);
#line 1804 "PhotoMetadata.c"
}

static GType
acd_see_keyword_transformer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ACDSeeKeywordTransformerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) acd_see_keyword_transformer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ACDSeeKeywordTransformer), 0, (GInstanceInitFunc) acd_see_keyword_transformer_instance_init, NULL };
	GType acd_see_keyword_transformer_type_id;
	acd_see_keyword_transformer_type_id = g_type_register_static (TYPE_KEYWORD_TRANSFORMER, "ACDSeeKeywordTransformer", &g_define_type_info, 0);
	ACDSeeKeywordTransformer_private_offset = g_type_add_instance_private (acd_see_keyword_transformer_type_id, sizeof (ACDSeeKeywordTransformerPrivate));
	return acd_see_keyword_transformer_type_id;
}

GType
acd_see_keyword_transformer_get_type (void)
{
	static volatile gsize acd_see_keyword_transformer_type_id__once = 0;
	if (g_once_init_enter (&acd_see_keyword_transformer_type_id__once)) {
		GType acd_see_keyword_transformer_type_id;
		acd_see_keyword_transformer_type_id = acd_see_keyword_transformer_get_type_once ();
		g_once_init_leave (&acd_see_keyword_transformer_type_id__once, acd_see_keyword_transformer_type_id);
	}
	return acd_see_keyword_transformer_type_id__once;
}

static gpointer
_keyword_transformer_ref0 (gpointer self)
{
#line 156 "../src/photos/PhotoMetadata.vala"
	return self ? keyword_transformer_ref (self) : NULL;
#line 1834 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_construct (GType object_type,
                                      const gchar* field_name,
                                      const gchar* path_separator,
                                      gboolean wants_leading_separator,
                                      gboolean is_writeable,
                                      KeywordTransformer* transformer)
{
	HierarchicalKeywordField* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	KeywordTransformer* _tmp2_;
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_KEYWORD_TRANSFORMER (transformer), NULL);
#line 146 "../src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 152 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (field_name);
#line 152 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 152 "../src/photos/PhotoMetadata.vala"
	self->field_name = _tmp0_;
#line 153 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (path_separator);
#line 153 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 153 "../src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp1_;
#line 154 "../src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = wants_leading_separator;
#line 155 "../src/photos/PhotoMetadata.vala"
	self->is_writeable = is_writeable;
#line 156 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _keyword_transformer_ref0 (transformer);
#line 156 "../src/photos/PhotoMetadata.vala"
	_keyword_transformer_unref0 (self->transformer);
#line 156 "../src/photos/PhotoMetadata.vala"
	self->transformer = _tmp2_;
#line 146 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1881 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_new (const gchar* field_name,
                                const gchar* path_separator,
                                gboolean wants_leading_separator,
                                gboolean is_writeable,
                                KeywordTransformer* transformer)
{
#line 146 "../src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable, transformer);
#line 1893 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_init (GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1901 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_free_value (GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 1911 "PhotoMetadata.c"
	}
}

static void
value_hierarchical_keyword_field_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 1923 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1927 "PhotoMetadata.c"
	}
}

static gpointer
value_hierarchical_keyword_field_peek_pointer (const GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1936 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1947 "PhotoMetadata.c"
		HierarchicalKeywordField * object;
		object = collect_values[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 139 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1954 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 139 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1958 "PhotoMetadata.c"
		}
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 1962 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1966 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1970 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	HierarchicalKeywordField ** object_p;
	object_p = collect_values[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 139 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1985 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1991 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1995 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 1999 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2003 "PhotoMetadata.c"
}

GParamSpec*
param_spec_hierarchical_keyword_field (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	ParamSpecHierarchicalKeywordField* spec;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 139 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 139 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 139 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 2022 "PhotoMetadata.c"
}

gpointer
value_get_hierarchical_keyword_field (const GValue* value)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 139 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2032 "PhotoMetadata.c"
}

void
value_set_hierarchical_keyword_field (GValue* value,
                                      gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 2054 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2058 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 2064 "PhotoMetadata.c"
	}
}

void
value_take_hierarchical_keyword_field (GValue* value,
                                       gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 139 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 2085 "PhotoMetadata.c"
	} else {
#line 139 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2089 "PhotoMetadata.c"
	}
#line 139 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 139 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 2095 "PhotoMetadata.c"
	}
}

static void
hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass,
                                       gpointer klass_data)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 139 "../src/photos/PhotoMetadata.vala"
	((HierarchicalKeywordFieldClass *) klass)->finalize = hierarchical_keyword_field_finalize;
#line 2107 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self,
                                          gpointer klass)
{
#line 139 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 2116 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj)
{
	HierarchicalKeywordField * self;
#line 139 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField);
#line 139 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 140 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 141 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 144 "../src/photos/PhotoMetadata.vala"
	_keyword_transformer_unref0 (self->transformer);
#line 2133 "PhotoMetadata.c"
}

static GType
hierarchical_keyword_field_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType hierarchical_keyword_field_type_id;
	hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return hierarchical_keyword_field_type_id;
}

GType
hierarchical_keyword_field_get_type (void)
{
	static volatile gsize hierarchical_keyword_field_type_id__once = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__once)) {
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = hierarchical_keyword_field_get_type_once ();
		g_once_init_leave (&hierarchical_keyword_field_type_id__once, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__once;
}

gpointer
hierarchical_keyword_field_ref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 139 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 139 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 2168 "PhotoMetadata.c"
}

void
hierarchical_keyword_field_unref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 139 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 139 "../src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 139 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2182 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_preview_get_instance_private (PhotoPreview* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPreview_private_offset);
}

PhotoPreview*
photo_preview_construct (GType object_type,
                         const gchar* name,
                         Dimensions* dimensions,
                         guint32 size,
                         const gchar* mime_type,
                         const gchar* extension)
{
	PhotoPreview* self = NULL;
	gchar* _tmp0_;
	Dimensions _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 167 "../src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 168 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (name);
#line 168 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 168 "../src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp0_;
#line 169 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *dimensions;
#line 169 "../src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp1_;
#line 170 "../src/photos/PhotoMetadata.vala"
	self->priv->size = size;
#line 171 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (mime_type);
#line 171 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 171 "../src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp2_;
#line 172 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (extension);
#line 172 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 172 "../src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp3_;
#line 167 "../src/photos/PhotoMetadata.vala"
	return self;
#line 2241 "PhotoMetadata.c"
}

gchar*
photo_preview_get_name (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 175 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 176 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 176 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 176 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 176 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2260 "PhotoMetadata.c"
}

void
photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                    Dimensions* result)
{
	Dimensions _tmp0_;
#line 179 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 180 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 180 "../src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 180 "../src/photos/PhotoMetadata.vala"
	return;
#line 2276 "PhotoMetadata.c"
}

guint32
photo_preview_get_size (PhotoPreview* self)
{
	guint32 result;
#line 183 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 184 "../src/photos/PhotoMetadata.vala"
	result = self->priv->size;
#line 184 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2289 "PhotoMetadata.c"
}

gchar*
photo_preview_get_mime_type (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 187 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 188 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 188 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 188 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 188 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2308 "PhotoMetadata.c"
}

gchar*
photo_preview_get_extension (PhotoPreview* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 191 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 192 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 192 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 192 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 192 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2327 "PhotoMetadata.c"
}

static GBytes*
photo_preview_real_flatten (PhotoPreview* self,
                            GError** error)
{
#line 195 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 195 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2338 "PhotoMetadata.c"
}

GBytes*
photo_preview_flatten (PhotoPreview* self,
                       GError** error)
{
	PhotoPreviewClass* _klass_;
#line 195 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 195 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 195 "../src/photos/PhotoMetadata.vala"
	if (_klass_->flatten) {
#line 195 "../src/photos/PhotoMetadata.vala"
		return _klass_->flatten (self, error);
#line 2354 "PhotoMetadata.c"
	}
#line 195 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2358 "PhotoMetadata.c"
}

static GdkPixbuf*
photo_preview_real_get_pixbuf (PhotoPreview* self,
                               GError** error)
{
	GBytes* flattened = NULL;
	GBytes* _tmp0_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 198 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_preview_flatten (self, &_inner_error0_);
#line 198 "../src/photos/PhotoMetadata.vala"
	flattened = _tmp0_;
#line 198 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 198 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 2379 "PhotoMetadata.c"
	}
	{
		GdkPixbuf* _tmp1_ = NULL;
		GMemoryInputStream* _tmp2_;
		GMemoryInputStream* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = (GMemoryInputStream*) g_memory_input_stream_new_from_bytes (flattened);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp3_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp5_;
#line 203 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2402 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp1_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 203 "../src/photos/PhotoMetadata.vala"
		result = _tmp6_;
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp1_);
#line 203 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 203 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2417 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 202 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 202 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->name;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = err;
#line 206 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_->message;
#line 206 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:206: Unable to decode thumbnail for %s: %s", _tmp7_, _tmp9_);
#line 208 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 208 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 208 "../src/photos/PhotoMetadata.vala"
		_g_bytes_unref0 (flattened);
#line 208 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2446 "PhotoMetadata.c"
	}
	__finally0:
#line 202 "../src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 202 "../src/photos/PhotoMetadata.vala"
	_g_bytes_unref0 (flattened);
#line 202 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2455 "PhotoMetadata.c"
}

GdkPixbuf*
photo_preview_get_pixbuf (PhotoPreview* self,
                          GError** error)
{
	PhotoPreviewClass* _klass_;
#line 197 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 197 "../src/photos/PhotoMetadata.vala"
	_klass_ = PHOTO_PREVIEW_GET_CLASS (self);
#line 197 "../src/photos/PhotoMetadata.vala"
	if (_klass_->get_pixbuf) {
#line 197 "../src/photos/PhotoMetadata.vala"
		return _klass_->get_pixbuf (self, error);
#line 2471 "PhotoMetadata.c"
	}
#line 197 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2475 "PhotoMetadata.c"
}

static void
value_photo_preview_init (GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 2483 "PhotoMetadata.c"
}

static void
value_photo_preview_free_value (GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 2493 "PhotoMetadata.c"
	}
}

static void
value_photo_preview_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 2505 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2509 "PhotoMetadata.c"
	}
}

static gpointer
value_photo_preview_peek_pointer (const GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2518 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 2529 "PhotoMetadata.c"
		PhotoPreview * object;
		object = collect_values[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 160 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2536 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 160 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2540 "PhotoMetadata.c"
		}
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 2544 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2548 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2552 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PhotoPreview ** object_p;
	object_p = collect_values[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 160 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2567 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 2573 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 2577 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 2581 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 2585 "PhotoMetadata.c"
}

GParamSpec*
param_spec_photo_preview (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPhotoPreview* spec;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 160 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 160 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 160 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 2604 "PhotoMetadata.c"
}

gpointer
value_get_photo_preview (const GValue* value)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 160 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 2614 "PhotoMetadata.c"
}

void
value_set_photo_preview (GValue* value,
                         gpointer v_object)
{
	PhotoPreview * old;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 2636 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2640 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 2646 "PhotoMetadata.c"
	}
}

void
value_take_photo_preview (GValue* value,
                          gpointer v_object)
{
	PhotoPreview * old;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 160 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 2667 "PhotoMetadata.c"
	} else {
#line 160 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 2671 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 160 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 2677 "PhotoMetadata.c"
	}
}

static void
photo_preview_class_init (PhotoPreviewClass * klass,
                          gpointer klass_data)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_preview_finalize;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPreview_private_offset);
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_preview_real_flatten;
#line 160 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoPreview*, GError**)) photo_preview_real_get_pixbuf;
#line 2695 "PhotoMetadata.c"
}

static void
photo_preview_instance_init (PhotoPreview * self,
                             gpointer klass)
{
#line 160 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_preview_get_instance_private (self);
#line 160 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 2706 "PhotoMetadata.c"
}

static void
photo_preview_finalize (PhotoPreview * obj)
{
	PhotoPreview * self;
#line 160 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 160 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 161 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 164 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 165 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 2723 "PhotoMetadata.c"
}

static GType
photo_preview_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType photo_preview_type_id;
	photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	PhotoPreview_private_offset = g_type_add_instance_private (photo_preview_type_id, sizeof (PhotoPreviewPrivate));
	return photo_preview_type_id;
}

GType
photo_preview_get_type (void)
{
	static volatile gsize photo_preview_type_id__once = 0;
	if (g_once_init_enter (&photo_preview_type_id__once)) {
		GType photo_preview_type_id;
		photo_preview_type_id = photo_preview_get_type_once ();
		g_once_init_leave (&photo_preview_type_id__once, photo_preview_type_id);
	}
	return photo_preview_type_id__once;
}

gpointer
photo_preview_ref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 160 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 160 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 2759 "PhotoMetadata.c"
}

void
photo_preview_unref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 160 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 160 "../src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 160 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2773 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_metadata_get_instance_private (PhotoMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoMetadata_private_offset);
}

static GType
photo_metadata_set_option_get_type_once (void)
{
	static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
	GType photo_metadata_set_option_type_id;
	photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
	return photo_metadata_set_option_type_id;
}

GType
photo_metadata_set_option_get_type (void)
{
	static volatile gsize photo_metadata_set_option_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__once)) {
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = photo_metadata_set_option_get_type_once ();
		g_once_init_leave (&photo_metadata_set_option_type_id__once, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__once;
}

PhotoMetadata*
photo_metadata_construct (GType object_type)
{
	PhotoMetadata* self = NULL;
#line 260 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 260 "../src/photos/PhotoMetadata.vala"
	return self;
#line 2812 "PhotoMetadata.c"
}

PhotoMetadata*
photo_metadata_new (void)
{
#line 260 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 2820 "PhotoMetadata.c"
}

static void
photo_metadata_real_read_from_file (MediaMetadata* base,
                                    GFile* file,
                                    GError** error)
{
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 263 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 263 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 264 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 264 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 264 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 265 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 265 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 267 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 267 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (file);
#line 267 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 267 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp3_, &_inner_error0_);
#line 267 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 267 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 267 "../src/photos/PhotoMetadata.vala"
		return;
#line 2868 "PhotoMetadata.c"
	}
#line 268 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_file_get_path (file);
#line 268 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 268 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_file (_tmp5_);
#line 268 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 268 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 268 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 269 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_file_get_basename (file);
#line 269 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 269 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 2888 "PhotoMetadata.c"
}

void
photo_metadata_write_to_file (PhotoMetadata* self,
                              GFile* file,
                              GError** error)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 272 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 272 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 273 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 273 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_file_get_path (file);
#line 273 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 273 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp2_, &_inner_error0_);
#line 273 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 273 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 273 "../src/photos/PhotoMetadata.vala"
		return;
#line 2920 "PhotoMetadata.c"
	}
}

void
photo_metadata_read_from_buffer (PhotoMetadata* self,
                                 guint8* buffer,
                                 gint buffer_length1,
                                 gint length,
                                 GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	ExifData* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 276 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 277 "../src/photos/PhotoMetadata.vala"
	if (length <= 0) {
#line 278 "../src/photos/PhotoMetadata.vala"
		length = buffer_length1;
#line 2942 "PhotoMetadata.c"
	}
#line 280 "../src/photos/PhotoMetadata.vala"
	_vala_assert (buffer_length1 >= length, "buffer.length >= length");
#line 282 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 282 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 282 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 283 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 283 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 285 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 285 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp1_, buffer + 0, (glong) (length - 0), &_inner_error0_);
#line 285 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 285 "../src/photos/PhotoMetadata.vala"
		return;
#line 2966 "PhotoMetadata.c"
	}
#line 286 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = exif_data_new_from_data (buffer + 0, (gint) (length - 0));
#line 286 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 286 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp2_;
#line 287 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length);
#line 287 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 287 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp3_;
#line 2980 "PhotoMetadata.c"
}

void
photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                       GBytes* buffer,
                                       GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gsize _tmp2_ = 0;
	guint8* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 290 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 290 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (buffer != NULL);
#line 291 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 291 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 291 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 292 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 292 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 294 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 294 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_bytes_get_data (buffer, &_tmp2_);
#line 294 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp1_, _tmp3_, (glong) _tmp2_, &_inner_error0_);
#line 294 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 294 "../src/photos/PhotoMetadata.vala"
		return;
#line 3023 "PhotoMetadata.c"
	}
#line 295 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_bytes_get_data (buffer, &_tmp4_);
#line 295 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_data (_tmp5_, (gint) _tmp4_);
#line 295 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 295 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 296 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup_printf ("<app1 segment %zu bytes>", g_bytes_get_size (buffer));
#line 296 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 296 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 3039 "PhotoMetadata.c"
}

MetadataDomain
photo_metadata_get_tag_domain (const gchar* tag)
{
	MetadataDomain result;
#line 299 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 300 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 301 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 301 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3054 "PhotoMetadata.c"
	}
#line 303 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 304 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 304 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3062 "PhotoMetadata.c"
	}
#line 306 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 307 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 307 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3070 "PhotoMetadata.c"
	}
#line 309 "../src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 309 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3076 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_domain (PhotoMetadata* self,
                           MetadataDomain domain)
{
	gboolean result;
#line 312 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 313 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 313 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3090 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 315 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 315 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_exif (_tmp0_);
#line 315 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3099 "PhotoMetadata.c"
		}
#line 313 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3103 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 318 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 318 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_xmp (_tmp1_);
#line 318 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3112 "PhotoMetadata.c"
		}
#line 313 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3116 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 321 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 321 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_iptc (_tmp2_);
#line 321 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3125 "PhotoMetadata.c"
		}
		default:
#line 313 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 3130 "PhotoMetadata.c"
		{
#line 325 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 325 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3136 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_has_exif (PhotoMetadata* self)
{
	gboolean result;
#line 329 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 330 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 330 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3151 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_xmp (PhotoMetadata* self)
{
	gboolean result;
#line 333 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 334 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 334 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3164 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_iptc (PhotoMetadata* self)
{
	gboolean result;
#line 337 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 338 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 338 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3177 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                    MetadataDomain domain)
{
	gboolean result;
#line 341 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 342 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 342 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3191 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 344 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 344 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_exif (_tmp0_);
#line 344 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3200 "PhotoMetadata.c"
		}
#line 342 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3204 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 347 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 347 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_xmp (_tmp1_);
#line 347 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3213 "PhotoMetadata.c"
		}
#line 342 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3217 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 350 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 350 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_iptc (_tmp2_);
#line 350 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3226 "PhotoMetadata.c"
		}
		default:
#line 342 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 3231 "PhotoMetadata.c"
		{
#line 354 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 354 "../src/photos/PhotoMetadata.vala"
			return result;
#line 3237 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_can_write_exif (PhotoMetadata* self)
{
	gboolean result;
#line 358 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 359 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 359 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3252 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_xmp (PhotoMetadata* self)
{
	gboolean result;
#line 362 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 363 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 363 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3265 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_iptc (PhotoMetadata* self)
{
	gboolean result;
#line 366 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 367 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 367 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3278 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_tag (PhotoMetadata* self,
                        const gchar* tag)
{
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 370 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 370 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 3292 "PhotoMetadata.c"
	{
		gboolean _tmp0_ = FALSE;
		GExiv2Metadata* _tmp1_;
#line 372 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 372 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gexiv2_metadata_try_has_tag (_tmp1_, tag, &_inner_error0_);
#line 372 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3302 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 372 "../src/photos/PhotoMetadata.vala"
		result = _tmp0_;
#line 372 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3309 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 371 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 374 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 374 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3320 "PhotoMetadata.c"
	}
	__finally0:
#line 371 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 371 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 371 "../src/photos/PhotoMetadata.vala"
	return _tmp2_;
#line 3329 "PhotoMetadata.c"
}

static GeeSet*
photo_metadata_create_string_set (PhotoMetadata* self,
                                  GCompareDataFunc compare_func,
                                  gpointer compare_func_target,
                                  GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* result;
#line 378 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 380 "../src/photos/PhotoMetadata.vala"
	if (compare_func == NULL) {
#line 3343 "PhotoMetadata.c"
		GeeHashSet* _tmp0_;
#line 381 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 381 "../src/photos/PhotoMetadata.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 381 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 381 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 381 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 381 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 381 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3359 "PhotoMetadata.c"
	} else {
		GCompareDataFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		GeeTreeSet* _tmp2_;
#line 383 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = compare_func;
#line 383 "../src/photos/PhotoMetadata.vala"
		_tmp1__target = compare_func_target;
#line 383 "../src/photos/PhotoMetadata.vala"
		_tmp1__target_destroy_notify = compare_func_target_destroy_notify;
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 383 "../src/photos/PhotoMetadata.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_SET, GeeSet);
#line 383 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3391 "PhotoMetadata.c"
	}
}

GeeCollection*
photo_metadata_get_tags (PhotoMetadata* self,
                         MetadataDomain domain,
                         GCompareDataFunc compare_func,
                         gpointer compare_func_target,
                         GDestroyNotify compare_func_target_destroy_notify)
{
	gchar** tags = NULL;
	gint tags_length1;
	gint _tags_size_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeCollection* collection = NULL;
	GCompareDataFunc _tmp12_;
	gpointer _tmp12__target;
	GDestroyNotify _tmp12__target_destroy_notify;
	GeeSet* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GeeCollection* result;
#line 386 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 388 "../src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 388 "../src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 388 "../src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 389 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 389 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 3428 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
			gchar** _tmp1_;
			gchar** _tmp2_;
#line 391 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 391 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (_tmp0_);
#line 391 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 391 "../src/photos/PhotoMetadata.vala"
			tags = _tmp2_;
#line 391 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp1_);
#line 391 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 392 "../src/photos/PhotoMetadata.vala"
			break;
#line 3447 "PhotoMetadata.c"
		}
#line 389 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 3451 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gchar** _tmp4_;
			gchar** _tmp5_;
#line 395 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 395 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_ = gexiv2_metadata_get_xmp_tags (_tmp3_);
#line 395 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 395 "../src/photos/PhotoMetadata.vala"
			tags = _tmp5_;
#line 395 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp4_);
#line 395 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 396 "../src/photos/PhotoMetadata.vala"
			break;
#line 3470 "PhotoMetadata.c"
		}
#line 389 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 3474 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp6_;
			gchar** _tmp7_;
			gchar** _tmp8_;
#line 399 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 399 "../src/photos/PhotoMetadata.vala"
			_tmp8_ = _tmp7_ = gexiv2_metadata_get_iptc_tags (_tmp6_);
#line 399 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 399 "../src/photos/PhotoMetadata.vala"
			tags = _tmp8_;
#line 399 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp7_);
#line 399 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 400 "../src/photos/PhotoMetadata.vala"
			break;
#line 3493 "PhotoMetadata.c"
		}
		default:
		{
#line 403 "../src/photos/PhotoMetadata.vala"
			break;
#line 3499 "PhotoMetadata.c"
		}
	}
#line 406 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = tags;
#line 406 "../src/photos/PhotoMetadata.vala"
	_tmp10__length1 = tags_length1;
#line 406 "../src/photos/PhotoMetadata.vala"
	if (_tmp10_ == NULL) {
#line 406 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = TRUE;
#line 3510 "PhotoMetadata.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 406 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = tags;
#line 406 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = tags_length1;
#line 406 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp11__length1 == 0;
#line 3520 "PhotoMetadata.c"
	}
#line 406 "../src/photos/PhotoMetadata.vala"
	if (_tmp9_) {
#line 407 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 407 "../src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 407 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 407 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 407 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 407 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 407 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3538 "PhotoMetadata.c"
	}
#line 409 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = compare_func;
#line 409 "../src/photos/PhotoMetadata.vala"
	_tmp12__target = compare_func_target;
#line 409 "../src/photos/PhotoMetadata.vala"
	_tmp12__target_destroy_notify = compare_func_target_destroy_notify;
#line 409 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 409 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 409 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 409 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_create_string_set (self, _tmp12_, _tmp12__target, _tmp12__target_destroy_notify);
#line 409 "../src/photos/PhotoMetadata.vala"
	collection = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection);
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = tags;
#line 410 "../src/photos/PhotoMetadata.vala"
	_tmp14__length1 = tags_length1;
#line 3560 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 410 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp14_;
#line 410 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp14__length1;
#line 410 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 3572 "PhotoMetadata.c"
			gchar* _tmp15_;
			gchar* tag = NULL;
#line 410 "../src/photos/PhotoMetadata.vala"
			_tmp15_ = g_strdup (tag_collection[tag_it]);
#line 410 "../src/photos/PhotoMetadata.vala"
			tag = _tmp15_;
#line 3579 "PhotoMetadata.c"
			{
				GeeCollection* _tmp16_;
				const gchar* _tmp17_;
#line 411 "../src/photos/PhotoMetadata.vala"
				_tmp16_ = collection;
#line 411 "../src/photos/PhotoMetadata.vala"
				_tmp17_ = tag;
#line 411 "../src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp16_, _tmp17_);
#line 410 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3591 "PhotoMetadata.c"
			}
		}
	}
#line 413 "../src/photos/PhotoMetadata.vala"
	result = collection;
#line 413 "../src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 413 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 413 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 413 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 413 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 413 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3609 "PhotoMetadata.c"
}

GeeCollection*
photo_metadata_get_all_tags (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeCollection* all_tags = NULL;
	GCompareDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeSet* _tmp1_;
	GeeCollection* exif_tags = NULL;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	GeeCollection* xmp_tags = NULL;
	GeeCollection* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GeeCollection* _tmp12_;
	GeeCollection* iptc_tags = NULL;
	GeeCollection* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeCollection* _tmp31_;
	GeeCollection* result;
#line 416 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 418 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 418 "../src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 418 "../src/photos/PhotoMetadata.vala"
	_tmp0__target_destroy_notify = compare_func_target_destroy_notify;
#line 418 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 418 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 418 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 418 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 418 "../src/photos/PhotoMetadata.vala"
	all_tags = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 420 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL, NULL, NULL);
#line 420 "../src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 421 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 3667 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 3679 "PhotoMetadata.c"
	} else {
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 3683 "PhotoMetadata.c"
	}
#line 421 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 3687 "PhotoMetadata.c"
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 422 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = all_tags;
#line 422 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = exif_tags;
#line 422 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp8_, _tmp9_);
#line 3696 "PhotoMetadata.c"
	}
#line 424 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL, NULL, NULL);
#line 424 "../src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp10_;
#line 425 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = xmp_tags;
#line 425 "../src/photos/PhotoMetadata.vala"
	if (_tmp12_ != NULL) {
#line 3706 "PhotoMetadata.c"
		GeeCollection* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = xmp_tags;
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = gee_collection_get_size (_tmp13_);
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp15_ > 0;
#line 3718 "PhotoMetadata.c"
	} else {
#line 425 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 3722 "PhotoMetadata.c"
	}
#line 425 "../src/photos/PhotoMetadata.vala"
	if (_tmp11_) {
#line 3726 "PhotoMetadata.c"
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 426 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = all_tags;
#line 426 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = xmp_tags;
#line 426 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp16_, _tmp17_);
#line 3735 "PhotoMetadata.c"
	}
#line 428 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL, NULL, NULL);
#line 428 "../src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp18_;
#line 429 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = iptc_tags;
#line 429 "../src/photos/PhotoMetadata.vala"
	if (_tmp20_ != NULL) {
#line 3745 "PhotoMetadata.c"
		GeeCollection* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 429 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = iptc_tags;
#line 429 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (_tmp21_);
#line 429 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 429 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp23_ > 0;
#line 3757 "PhotoMetadata.c"
	} else {
#line 429 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 3761 "PhotoMetadata.c"
	}
#line 429 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 3765 "PhotoMetadata.c"
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
#line 430 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = all_tags;
#line 430 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = iptc_tags;
#line 430 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp24_, _tmp25_);
#line 3774 "PhotoMetadata.c"
	}
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = all_tags;
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = gee_collection_get_size (_tmp27_);
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp28_;
#line 432 "../src/photos/PhotoMetadata.vala"
	if (_tmp29_ > 0) {
#line 3784 "PhotoMetadata.c"
		GeeCollection* _tmp30_;
#line 432 "../src/photos/PhotoMetadata.vala"
		_tmp30_ = all_tags;
#line 432 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp30_;
#line 3790 "PhotoMetadata.c"
	} else {
#line 432 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = NULL;
#line 3794 "PhotoMetadata.c"
	}
#line 432 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = _g_object_ref0 (_tmp26_);
#line 432 "../src/photos/PhotoMetadata.vala"
	result = _tmp31_;
#line 432 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 432 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 432 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 432 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 432 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 432 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 432 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 432 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 432 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3818 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_label (PhotoMetadata* self,
                              const gchar* tag)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 435 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 3831 "PhotoMetadata.c"
	{
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 437 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gexiv2_metadata_try_get_tag_label (tag, &_inner_error0_);
#line 437 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 437 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3842 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 437 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = g_strdup (_tmp0_);
#line 437 "../src/photos/PhotoMetadata.vala"
		result = _tmp2_;
#line 437 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3851 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 436 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 439 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 439 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3862 "PhotoMetadata.c"
	}
	__finally0:
#line 436 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 436 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 436 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 3871 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_description (PhotoMetadata* self,
                                    const gchar* tag)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 443 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 443 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 3884 "PhotoMetadata.c"
	{
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 445 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gexiv2_metadata_try_get_tag_description (tag, &_inner_error0_);
#line 445 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 445 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3895 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 445 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = g_strdup (_tmp0_);
#line 445 "../src/photos/PhotoMetadata.vala"
		result = _tmp2_;
#line 445 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3904 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 444 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 447 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 447 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3915 "PhotoMetadata.c"
	}
	__finally0:
#line 444 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 444 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 444 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 3924 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string (PhotoMetadata* self,
                           const gchar* tag,
                           PrepareInputTextOptions options)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 451 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 451 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 3938 "PhotoMetadata.c"
	{
		gchar* _tmp0_ = NULL;
		GExiv2Metadata* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 453 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 453 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gexiv2_metadata_try_get_tag_string (_tmp1_, tag, &_inner_error0_);
#line 453 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp2_;
#line 453 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3952 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 453 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = prepare_input_text (_tmp0_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 453 "../src/photos/PhotoMetadata.vala"
		result = _tmp3_;
#line 453 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp0_);
#line 453 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3963 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 452 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 455 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 455 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3974 "PhotoMetadata.c"
	}
	__finally0:
#line 452 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 452 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 452 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 3983 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                       const gchar* tag,
                                       PrepareInputTextOptions options)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 459 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 459 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 3997 "PhotoMetadata.c"
	{
		gchar* _tmp0_ = NULL;
		GExiv2Metadata* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gexiv2_metadata_try_get_tag_interpreted_string (_tmp1_, tag, &_inner_error0_);
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp2_;
#line 461 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4011 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 461 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = prepare_input_text (_tmp0_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 461 "../src/photos/PhotoMetadata.vala"
		result = _tmp3_;
#line 461 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp0_);
#line 461 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4022 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 460 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 463 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 463 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4033 "PhotoMetadata.c"
	}
	__finally0:
#line 460 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 460 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 460 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 4042 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1)
{
	gchar* result;
#line 467 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4053 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 468 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 468 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 468 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4065 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 468 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 468 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4072 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 469 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 469 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 469 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 470 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 470 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 471 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 471 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 471 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4094 "PhotoMetadata.c"
				}
#line 468 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 468 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4100 "PhotoMetadata.c"
			}
		}
	}
#line 474 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 474 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4108 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1)
{
	gchar* result;
#line 477 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4119 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 478 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 478 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 478 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4131 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 478 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 478 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4138 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 479 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 479 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_interpreted (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 479 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 480 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 480 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 481 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 481 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 481 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4160 "PhotoMetadata.c"
				}
#line 478 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 478 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4166 "PhotoMetadata.c"
			}
		}
	}
#line 484 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 484 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4174 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_string_multiple (PhotoMetadata* self,
                                    const gchar* tag)
{
	GError* _inner_error0_ = NULL;
	GeeList* result;
#line 493 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 493 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 4187 "PhotoMetadata.c"
	{
		gchar** values = NULL;
		GExiv2Metadata* _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint values_length1;
		gint _values_size_;
		gboolean _tmp3_ = FALSE;
		gchar** _tmp4_;
		gint _tmp4__length1;
		GeeList* list = NULL;
		GeeArrayList* _tmp6_;
		GeeHashSet* collection = NULL;
		GeeHashSet* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		GeeList* _tmp20_ = NULL;
		GeeList* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		GeeList* _tmp25_;
#line 495 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 495 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp1_ = gexiv2_metadata_try_get_tag_multiple (_tmp0_, tag, &_inner_error0_);
#line 495 "../src/photos/PhotoMetadata.vala"
		values = _tmp2_;
#line 495 "../src/photos/PhotoMetadata.vala"
		values_length1 = _vala_array_length (_tmp1_);
#line 495 "../src/photos/PhotoMetadata.vala"
		_values_size_ = values_length1;
#line 495 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4221 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 496 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = values;
#line 496 "../src/photos/PhotoMetadata.vala"
		_tmp4__length1 = values_length1;
#line 496 "../src/photos/PhotoMetadata.vala"
		if (_tmp4_ == NULL) {
#line 496 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = TRUE;
#line 4232 "PhotoMetadata.c"
		} else {
			gchar** _tmp5_;
			gint _tmp5__length1;
#line 496 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = values;
#line 496 "../src/photos/PhotoMetadata.vala"
			_tmp5__length1 = values_length1;
#line 496 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp5__length1 == 0;
#line 4242 "PhotoMetadata.c"
		}
#line 496 "../src/photos/PhotoMetadata.vala"
		if (_tmp3_) {
#line 497 "../src/photos/PhotoMetadata.vala"
			result = NULL;
#line 497 "../src/photos/PhotoMetadata.vala"
			values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 497 "../src/photos/PhotoMetadata.vala"
			return result;
#line 4252 "PhotoMetadata.c"
		}
#line 499 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 499 "../src/photos/PhotoMetadata.vala"
		list = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList);
#line 501 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 501 "../src/photos/PhotoMetadata.vala"
		collection = _tmp7_;
#line 502 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = values;
#line 502 "../src/photos/PhotoMetadata.vala"
		_tmp8__length1 = values_length1;
#line 4266 "PhotoMetadata.c"
		{
			gchar** value_collection = NULL;
			gint value_collection_length1 = 0;
			gint _value_collection_size_ = 0;
			gint value_it = 0;
#line 502 "../src/photos/PhotoMetadata.vala"
			value_collection = _tmp8_;
#line 502 "../src/photos/PhotoMetadata.vala"
			value_collection_length1 = _tmp8__length1;
#line 502 "../src/photos/PhotoMetadata.vala"
			for (value_it = 0; value_it < value_collection_length1; value_it = value_it + 1) {
#line 4278 "PhotoMetadata.c"
				gchar* _tmp9_;
				gchar* value = NULL;
#line 502 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = g_strdup (value_collection[value_it]);
#line 502 "../src/photos/PhotoMetadata.vala"
				value = _tmp9_;
#line 4285 "PhotoMetadata.c"
				{
					gchar* prepped = NULL;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gboolean _tmp12_ = FALSE;
					const gchar* _tmp13_;
#line 503 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = value;
#line 503 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = prepare_input_text (_tmp10_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 503 "../src/photos/PhotoMetadata.vala"
					prepped = _tmp11_;
#line 506 "../src/photos/PhotoMetadata.vala"
					_tmp13_ = prepped;
#line 506 "../src/photos/PhotoMetadata.vala"
					if (_tmp13_ != NULL) {
#line 4302 "PhotoMetadata.c"
						GeeHashSet* _tmp14_;
						const gchar* _tmp15_;
#line 506 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = collection;
#line 506 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = prepped;
#line 506 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = !gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 4311 "PhotoMetadata.c"
					} else {
#line 506 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = FALSE;
#line 4315 "PhotoMetadata.c"
					}
#line 506 "../src/photos/PhotoMetadata.vala"
					if (_tmp12_) {
#line 4319 "PhotoMetadata.c"
						GeeList* _tmp16_;
						const gchar* _tmp17_;
						GeeHashSet* _tmp18_;
						const gchar* _tmp19_;
#line 507 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = list;
#line 507 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = prepped;
#line 507 "../src/photos/PhotoMetadata.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_COLLECTION, GeeCollection), _tmp17_);
#line 508 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = collection;
#line 508 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = prepped;
#line 508 "../src/photos/PhotoMetadata.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 4336 "PhotoMetadata.c"
					}
#line 502 "../src/photos/PhotoMetadata.vala"
					_g_free0 (prepped);
#line 502 "../src/photos/PhotoMetadata.vala"
					_g_free0 (value);
#line 4342 "PhotoMetadata.c"
				}
			}
		}
#line 512 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = list;
#line 512 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 512 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 512 "../src/photos/PhotoMetadata.vala"
		if (_tmp23_ > 0) {
#line 4354 "PhotoMetadata.c"
			GeeList* _tmp24_;
#line 512 "../src/photos/PhotoMetadata.vala"
			_tmp24_ = list;
#line 512 "../src/photos/PhotoMetadata.vala"
			_tmp20_ = _tmp24_;
#line 4360 "PhotoMetadata.c"
		} else {
#line 512 "../src/photos/PhotoMetadata.vala"
			_tmp20_ = NULL;
#line 4364 "PhotoMetadata.c"
		}
#line 512 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = _g_object_ref0 (_tmp20_);
#line 512 "../src/photos/PhotoMetadata.vala"
		result = _tmp25_;
#line 512 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (collection);
#line 512 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (list);
#line 512 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 512 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4378 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 494 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 514 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 514 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4389 "PhotoMetadata.c"
	}
	__finally0:
#line 494 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 494 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 4398 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                          gchar** tags,
                                          gint tags_length1)
{
	GeeList* result;
#line 524 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 4409 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 525 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 525 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 525 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4421 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 525 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 525 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4428 "PhotoMetadata.c"
			{
				GeeList* values = NULL;
				const gchar* _tmp1_;
				GeeList* _tmp2_;
				gboolean _tmp3_ = FALSE;
				GeeList* _tmp4_;
#line 526 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 526 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_multiple (self, _tmp1_);
#line 526 "../src/photos/PhotoMetadata.vala"
				values = _tmp2_;
#line 527 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = values;
#line 527 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 4445 "PhotoMetadata.c"
					GeeList* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 527 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = values;
#line 527 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 527 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp6_;
#line 527 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = _tmp7_ > 0;
#line 4457 "PhotoMetadata.c"
				} else {
#line 527 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 4461 "PhotoMetadata.c"
				}
#line 527 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 528 "../src/photos/PhotoMetadata.vala"
					result = values;
#line 528 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 528 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4471 "PhotoMetadata.c"
				}
#line 525 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 525 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4477 "PhotoMetadata.c"
			}
		}
	}
#line 531 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 531 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4485 "PhotoMetadata.c"
}

void
photo_metadata_set_string (PhotoMetadata* self,
                           const gchar* tag,
                           const gchar* value,
                           PrepareInputTextOptions options,
                           gint length)
{
	gchar* prepped = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 534 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 534 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 534 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 536 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = prepare_input_text (value, options, length);
#line 536 "../src/photos/PhotoMetadata.vala"
	prepped = _tmp0_;
#line 537 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = prepped;
#line 537 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 538 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:538: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 540 "../src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 540 "../src/photos/PhotoMetadata.vala"
		return;
#line 4519 "PhotoMetadata.c"
	}
	{
		GExiv2Metadata* _tmp2_;
		const gchar* _tmp3_;
#line 544 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = self->priv->exiv2;
#line 544 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = prepped;
#line 544 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_set_tag_string (_tmp2_, tag, _tmp3_, &_inner_error0_);
#line 544 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4532 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 543 "../src/photos/PhotoMetadata.vala"
		_error_ = _inner_error0_;
#line 543 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 546 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->source_name;
#line 546 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _error_;
#line 546 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp5_->message;
#line 546 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:546: Unable to set tag %s to string %s from source " \
"%s: %s", tag, value, _tmp4_, _tmp6_);
#line 543 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (_error_);
#line 4557 "PhotoMetadata.c"
	}
	__finally0:
#line 543 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 543 "../src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 543 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 543 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 543 "../src/photos/PhotoMetadata.vala"
		return;
#line 4570 "PhotoMetadata.c"
	}
#line 534 "../src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 4574 "PhotoMetadata.c"
}

static void
photo_metadata_set_all_generic (PhotoMetadata* self,
                                gchar** tags,
                                gint tags_length1,
                                PhotoMetadataSetOption option,
                                PhotoMetadataSetGenericValue setter,
                                gpointer setter_target)
{
	gboolean written = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 552 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 553 "../src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 4592 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 554 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 554 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 554 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 4604 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 554 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 554 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4611 "PhotoMetadata.c"
			{
				gboolean _tmp1_ = FALSE;
#line 555 "../src/photos/PhotoMetadata.vala"
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 555 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = TRUE;
#line 4618 "PhotoMetadata.c"
				} else {
					const gchar* _tmp2_;
#line 555 "../src/photos/PhotoMetadata.vala"
					_tmp2_ = tag;
#line 555 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (_tmp2_));
#line 4625 "PhotoMetadata.c"
				}
#line 555 "../src/photos/PhotoMetadata.vala"
				if (_tmp1_) {
#line 4629 "PhotoMetadata.c"
					const gchar* _tmp3_;
#line 556 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = tag;
#line 556 "../src/photos/PhotoMetadata.vala"
					setter (_tmp3_, setter_target);
#line 557 "../src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 4637 "PhotoMetadata.c"
				}
#line 554 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4641 "PhotoMetadata.c"
			}
		}
	}
#line 561 "../src/photos/PhotoMetadata.vala"
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 561 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = !written;
#line 4649 "PhotoMetadata.c"
	} else {
#line 561 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = FALSE;
#line 4653 "PhotoMetadata.c"
	}
#line 561 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 561 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = tags_length1 > 0;
#line 4659 "PhotoMetadata.c"
	} else {
#line 561 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 4663 "PhotoMetadata.c"
	}
#line 561 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4667 "PhotoMetadata.c"
		MetadataDomain default_domain = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 562 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = tags[0];
#line 562 "../src/photos/PhotoMetadata.vala"
		default_domain = photo_metadata_get_tag_domain (_tmp6_);
#line 565 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = tags[0];
#line 565 "../src/photos/PhotoMetadata.vala"
		setter (_tmp7_, setter_target);
#line 4679 "PhotoMetadata.c"
		{
			gint ctr = 0;
#line 568 "../src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 4684 "PhotoMetadata.c"
			{
				gboolean _tmp8_ = FALSE;
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = TRUE;
#line 568 "../src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 4691 "PhotoMetadata.c"
					const gchar* _tmp10_;
#line 568 "../src/photos/PhotoMetadata.vala"
					if (!_tmp8_) {
#line 4695 "PhotoMetadata.c"
						gint _tmp9_;
#line 568 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = ctr;
#line 568 "../src/photos/PhotoMetadata.vala"
						ctr = _tmp9_ + 1;
#line 4701 "PhotoMetadata.c"
					}
#line 568 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = FALSE;
#line 568 "../src/photos/PhotoMetadata.vala"
					if (!(ctr < tags_length1)) {
#line 568 "../src/photos/PhotoMetadata.vala"
						break;
#line 4709 "PhotoMetadata.c"
					}
#line 569 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = tags[ctr];
#line 569 "../src/photos/PhotoMetadata.vala"
					if (photo_metadata_get_tag_domain (_tmp10_) == default_domain) {
#line 4715 "PhotoMetadata.c"
						const gchar* _tmp11_;
#line 570 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = tags[ctr];
#line 570 "../src/photos/PhotoMetadata.vala"
						setter (_tmp11_, setter_target);
#line 4721 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 575 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 575 "../src/photos/PhotoMetadata.vala"
	return _data1_;
#line 4736 "PhotoMetadata.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 575 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 4746 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 575 "../src/photos/PhotoMetadata.vala"
		self = _data1_->self;
#line 575 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data1_->value);
#line 575 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 575 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block1Data, _data1_);
#line 4756 "PhotoMetadata.c"
	}
}

static void
__lambda5_ (Block1Data* _data1_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 576 "../src/photos/PhotoMetadata.vala"
	self = _data1_->self;
#line 576 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 576 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data1_->value, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 4771 "PhotoMetadata.c"
}

static void
___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 576 "../src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 4780 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               const gchar* value,
                               PhotoMetadataSetOption option)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
#line 575 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 575 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 575 "../src/photos/PhotoMetadata.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 575 "../src/photos/PhotoMetadata.vala"
	_data1_->_ref_count_ = 1;
#line 575 "../src/photos/PhotoMetadata.vala"
	_data1_->self = media_metadata_ref (self);
#line 575 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (value);
#line 575 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data1_->value);
#line 575 "../src/photos/PhotoMetadata.vala"
	_data1_->value = _tmp0_;
#line 576 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda5__photo_metadata_set_generic_value, _data1_);
#line 575 "../src/photos/PhotoMetadata.vala"
	block1_data_unref (_data1_);
#line 575 "../src/photos/PhotoMetadata.vala"
	_data1_ = NULL;
#line 4814 "PhotoMetadata.c"
}

static void
_vala_array_add46 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 584 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 584 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 584 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4829 "PhotoMetadata.c"
	}
#line 584 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 584 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 4835 "PhotoMetadata.c"
}

static void
_vala_array_add47 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 596 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 596 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 596 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4850 "PhotoMetadata.c"
	}
#line 596 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 596 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 4856 "PhotoMetadata.c"
}

void
photo_metadata_set_string_multiple (PhotoMetadata* self,
                                    const gchar* tag,
                                    GeeCollection* collection)
{
	gchar** values = NULL;
	gchar** _tmp0_;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GError* _inner_error0_ = NULL;
#line 579 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 579 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 579 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (collection, GEE_TYPE_COLLECTION));
#line 580 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 580 "../src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 580 "../src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 580 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 4885 "PhotoMetadata.c"
	{
		GeeIterator* _value_it = NULL;
		GeeIterator* _tmp1_;
#line 581 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (collection, GEE_TYPE_ITERABLE, GeeIterable));
#line 581 "../src/photos/PhotoMetadata.vala"
		_value_it = _tmp1_;
#line 581 "../src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 4895 "PhotoMetadata.c"
			GeeIterator* _tmp2_;
			gchar* value = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gchar* prepped = NULL;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_;
#line 581 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _value_it;
#line 581 "../src/photos/PhotoMetadata.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 581 "../src/photos/PhotoMetadata.vala"
				break;
#line 4910 "PhotoMetadata.c"
			}
#line 581 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 581 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 581 "../src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp4_;
#line 582 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = value;
#line 582 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = prepare_input_text (_tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 582 "../src/photos/PhotoMetadata.vala"
			prepped = _tmp6_;
#line 583 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = prepped;
#line 583 "../src/photos/PhotoMetadata.vala"
			if (_tmp7_ != NULL) {
#line 4928 "PhotoMetadata.c"
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 584 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = prepped;
#line 584 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 584 "../src/photos/PhotoMetadata.vala"
				_vala_array_add46 (&values, &values_length1, &_values_size_, _tmp9_);
#line 4937 "PhotoMetadata.c"
			} else {
				const gchar* _tmp10_;
#line 586 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 586 "../src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:586: Unable to set string %s to %s: invalid UTF-8", _tmp10_, tag);
#line 4944 "PhotoMetadata.c"
			}
#line 581 "../src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 581 "../src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 4950 "PhotoMetadata.c"
		}
#line 581 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 4954 "PhotoMetadata.c"
	}
#line 589 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = values;
#line 589 "../src/photos/PhotoMetadata.vala"
	_tmp11__length1 = values_length1;
#line 589 "../src/photos/PhotoMetadata.vala"
	if (_tmp11__length1 == 0) {
#line 590 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 590 "../src/photos/PhotoMetadata.vala"
		return;
#line 4966 "PhotoMetadata.c"
	}
#line 596 "../src/photos/PhotoMetadata.vala"
	_vala_array_add47 (&values, &values_length1, &_values_size_, NULL);
#line 4970 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
#line 599 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->exiv2;
#line 599 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = values;
#line 599 "../src/photos/PhotoMetadata.vala"
		_tmp13__length1 = values_length1;
#line 599 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_set_tag_multiple (_tmp12_, tag, _tmp13_, &_inner_error0_);
#line 599 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4985 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 598 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 598 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = values;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp14__length1 = values_length1;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = self->priv->source_name;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = err;
#line 601 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = _tmp16_->message;
#line 601 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:601: Unable to set %d strings to tag %s from source" \
" %s: %s", _tmp14__length1, tag, _tmp15_, _tmp17_);
#line 598 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 5016 "PhotoMetadata.c"
	}
	__finally0:
#line 598 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 598 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 598 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 598 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 598 "../src/photos/PhotoMetadata.vala"
		return;
#line 5029 "PhotoMetadata.c"
	}
#line 579 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 5033 "PhotoMetadata.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 605 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 605 "../src/photos/PhotoMetadata.vala"
	return _data2_;
#line 5043 "PhotoMetadata.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 605 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 5053 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 605 "../src/photos/PhotoMetadata.vala"
		self = _data2_->self;
#line 605 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data2_->values);
#line 605 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 605 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block2Data, _data2_);
#line 5063 "PhotoMetadata.c"
	}
}

static void
__lambda6_ (Block2Data* _data2_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 606 "../src/photos/PhotoMetadata.vala"
	self = _data2_->self;
#line 606 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 606 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, tag, _data2_->values);
#line 5078 "PhotoMetadata.c"
}

static void
___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 606 "../src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 5087 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        GeeCollection* values,
                                        PhotoMetadataSetOption option)
{
	Block2Data* _data2_;
	GeeCollection* _tmp0_;
#line 605 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 605 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (values, GEE_TYPE_COLLECTION));
#line 605 "../src/photos/PhotoMetadata.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 605 "../src/photos/PhotoMetadata.vala"
	_data2_->_ref_count_ = 1;
#line 605 "../src/photos/PhotoMetadata.vala"
	_data2_->self = media_metadata_ref (self);
#line 605 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_object_ref0 (values);
#line 605 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_data2_->values);
#line 605 "../src/photos/PhotoMetadata.vala"
	_data2_->values = _tmp0_;
#line 606 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda6__photo_metadata_set_generic_value, _data2_);
#line 605 "../src/photos/PhotoMetadata.vala"
	block2_data_unref (_data2_);
#line 605 "../src/photos/PhotoMetadata.vala"
	_data2_ = NULL;
#line 5121 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong* value)
{
	glong _vala_value = 0L;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 609 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 609 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 610 "../src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 611 "../src/photos/PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 612 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 612 "../src/photos/PhotoMetadata.vala"
		if (value) {
#line 612 "../src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 5146 "PhotoMetadata.c"
		}
#line 612 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5150 "PhotoMetadata.c"
	}
	{
		glong _tmp0_ = 0L;
		GExiv2Metadata* _tmp1_;
#line 616 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 616 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gexiv2_metadata_try_get_tag_long (_tmp1_, tag, &_inner_error0_);
#line 616 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5161 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 616 "../src/photos/PhotoMetadata.vala"
		_vala_value = _tmp0_;
#line 5166 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 615 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 618 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 618 "../src/photos/PhotoMetadata.vala"
		if (value) {
#line 618 "../src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 5179 "PhotoMetadata.c"
		}
#line 618 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5183 "PhotoMetadata.c"
	}
	__finally0:
#line 615 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5188 "PhotoMetadata.c"
		gboolean _tmp2_ = FALSE;
#line 615 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 615 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 615 "../src/photos/PhotoMetadata.vala"
		return _tmp2_;
#line 5196 "PhotoMetadata.c"
	}
#line 621 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 621 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 621 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 5204 "PhotoMetadata.c"
	}
#line 621 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5208 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_long (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               glong* value)
{
	glong _vala_value = 0L;
	gboolean result;
#line 624 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 5221 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 625 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 625 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 625 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5233 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 625 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 625 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5240 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				glong _tmp2_ = 0L;
				gboolean _tmp3_;
#line 626 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 626 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_long (self, _tmp1_, &_tmp2_);
#line 626 "../src/photos/PhotoMetadata.vala"
				_vala_value = _tmp2_;
#line 626 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 627 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 627 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 627 "../src/photos/PhotoMetadata.vala"
					if (value) {
#line 627 "../src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 5261 "PhotoMetadata.c"
					}
#line 627 "../src/photos/PhotoMetadata.vala"
					return result;
#line 5265 "PhotoMetadata.c"
				}
#line 625 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5269 "PhotoMetadata.c"
			}
		}
	}
#line 630 "../src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 632 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 632 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 632 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 5281 "PhotoMetadata.c"
	}
#line 632 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5285 "PhotoMetadata.c"
}

void
photo_metadata_set_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong value)
{
	GError* _inner_error0_ = NULL;
#line 635 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 635 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 5298 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
#line 637 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 637 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_set_tag_long (_tmp0_, tag, value, &_inner_error0_);
#line 637 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5307 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 636 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 636 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 639 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->source_name;
#line 639 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = err;
#line 639 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_->message;
#line 639 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:639: Unable to set tag %s to long %ld from source %" \
"s: %s", tag, value, _tmp1_, _tmp3_);
#line 636 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 5332 "PhotoMetadata.c"
	}
	__finally0:
#line 636 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 636 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 636 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 636 "../src/photos/PhotoMetadata.vala"
		return;
#line 5343 "PhotoMetadata.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 643 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 643 "../src/photos/PhotoMetadata.vala"
	return _data3_;
#line 5354 "PhotoMetadata.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 643 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 5364 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 643 "../src/photos/PhotoMetadata.vala"
		self = _data3_->self;
#line 643 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 643 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 5372 "PhotoMetadata.c"
	}
}

static void
__lambda7_ (Block3Data* _data3_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 644 "../src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 644 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 644 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, tag, _data3_->value);
#line 5387 "PhotoMetadata.c"
}

static void
___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 644 "../src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 5396 "PhotoMetadata.c"
}

void
photo_metadata_set_all_long (PhotoMetadata* self,
                             gchar** tags,
                             gint tags_length1,
                             glong value,
                             PhotoMetadataSetOption option)
{
	Block3Data* _data3_;
#line 643 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 643 "../src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 643 "../src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 643 "../src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 643 "../src/photos/PhotoMetadata.vala"
	_data3_->value = value;
#line 644 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda7__photo_metadata_set_generic_value, _data3_);
#line 643 "../src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 643 "../src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 5423 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gint numerator = 0;
	gint denominator = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 647 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 647 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 5440 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
#line 650 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 650 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_get_exif_tag_rational (_tmp0_, tag, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 650 "../src/photos/PhotoMetadata.vala"
		numerator = _tmp1_;
#line 650 "../src/photos/PhotoMetadata.vala"
		denominator = _tmp2_;
#line 650 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5455 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 651 "../src/photos/PhotoMetadata.vala"
		metadata_rational_init (&_vala_rational, numerator, denominator);
#line 5460 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 649 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 653 "../src/photos/PhotoMetadata.vala"
		metadata_rational_init_invalid (&_vala_rational);
#line 654 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 654 "../src/photos/PhotoMetadata.vala"
		if (rational) {
#line 654 "../src/photos/PhotoMetadata.vala"
			*rational = _vala_rational;
#line 5475 "PhotoMetadata.c"
		}
#line 654 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5479 "PhotoMetadata.c"
	}
	__finally0:
#line 649 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5484 "PhotoMetadata.c"
		gboolean _tmp3_ = FALSE;
#line 649 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 649 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 649 "../src/photos/PhotoMetadata.vala"
		return _tmp3_;
#line 5492 "PhotoMetadata.c"
	}
#line 657 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 657 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 657 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 5500 "PhotoMetadata.c"
	}
#line 657 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5504 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_rational (PhotoMetadata* self,
                                   gchar** tags,
                                   gint tags_length1,
                                   MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gboolean result;
#line 660 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 5517 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 661 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 661 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 661 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5529 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 661 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 661 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5536 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				MetadataRational _tmp2_ = {0};
				gboolean _tmp3_;
#line 662 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 662 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_rational (self, _tmp1_, &_tmp2_);
#line 662 "../src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp2_;
#line 662 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 663 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 663 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 663 "../src/photos/PhotoMetadata.vala"
					if (rational) {
#line 663 "../src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 5557 "PhotoMetadata.c"
					}
#line 663 "../src/photos/PhotoMetadata.vala"
					return result;
#line 5561 "PhotoMetadata.c"
				}
#line 661 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5565 "PhotoMetadata.c"
			}
		}
	}
#line 666 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 668 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 668 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 668 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 5577 "PhotoMetadata.c"
	}
#line 668 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5581 "PhotoMetadata.c"
}

void
photo_metadata_set_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	GError* _inner_error0_ = NULL;
#line 671 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 671 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 671 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 5596 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
		MetadataRational _tmp1_;
		MetadataRational _tmp2_;
#line 673 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 673 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = *rational;
#line 673 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = *rational;
#line 673 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_set_exif_tag_rational (_tmp0_, tag, _tmp1_.numerator, _tmp2_.denominator, &_inner_error0_);
#line 673 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5611 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 672 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 672 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 675 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = metadata_rational_to_string (rational);
#line 675 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 675 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->source_name;
#line 675 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = err;
#line 675 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_->message;
#line 675 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:675: Unable to set tag %s to rational %s from sourc" \
"e %s: %s", tag, _tmp4_, _tmp5_, _tmp7_);
#line 675 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp4_);
#line 672 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 5644 "PhotoMetadata.c"
	}
	__finally0:
#line 672 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 672 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 672 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 672 "../src/photos/PhotoMetadata.vala"
		return;
#line 5655 "PhotoMetadata.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 680 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 680 "../src/photos/PhotoMetadata.vala"
	return _data4_;
#line 5666 "PhotoMetadata.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 680 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 5676 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 680 "../src/photos/PhotoMetadata.vala"
		self = _data4_->self;
#line 680 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 680 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 5684 "PhotoMetadata.c"
	}
}

static void
__lambda8_ (Block4Data* _data4_,
            const gchar* tag)
{
	PhotoMetadata* self;
	MetadataRational _tmp0_;
#line 681 "../src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 681 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 681 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _data4_->rational;
#line 681 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, tag, &_tmp0_);
#line 5702 "PhotoMetadata.c"
}

static void
___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 681 "../src/photos/PhotoMetadata.vala"
	__lambda8_ (self, tag);
#line 5711 "PhotoMetadata.c"
}

void
photo_metadata_set_all_rational (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1,
                                 MetadataRational* rational,
                                 PhotoMetadataSetOption option)
{
	Block4Data* _data4_;
	MetadataRational _tmp0_;
#line 680 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 680 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 680 "../src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 680 "../src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 680 "../src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 680 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 680 "../src/photos/PhotoMetadata.vala"
	_data4_->rational = _tmp0_;
#line 681 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda8__photo_metadata_set_generic_value, _data4_);
#line 680 "../src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 680 "../src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 5743 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_date_time (PhotoMetadata* self,
                              const gchar* tag)
{
	gchar* value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	MetadataDateTime* result;
#line 684 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 684 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 685 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string (self, tag, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 685 "../src/photos/PhotoMetadata.vala"
	value = _tmp0_;
#line 686 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = value;
#line 686 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 687 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 687 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 687 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5773 "PhotoMetadata.c"
	}
	{
#line 690 "../src/photos/PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 690 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 5780 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp2_ = NULL;
				const gchar* _tmp3_;
				MetadataDateTime* _tmp4_;
				MetadataDateTime* _tmp5_;
#line 692 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 692 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = metadata_date_time_new_from_xmp (_tmp3_, &_inner_error0_);
#line 692 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = _tmp4_;
#line 692 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5794 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 692 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp2_;
#line 692 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = NULL;
#line 692 "../src/photos/PhotoMetadata.vala"
				result = _tmp5_;
#line 692 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp2_);
#line 692 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 692 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5809 "PhotoMetadata.c"
			}
#line 690 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 5813 "PhotoMetadata.c"
			{
#line 697 "../src/photos/PhotoMetadata.vala"
				result = NULL;
#line 697 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 697 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5821 "PhotoMetadata.c"
			}
			default:
#line 690 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 5826 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp6_ = NULL;
				const gchar* _tmp7_;
				MetadataDateTime* _tmp8_;
				MetadataDateTime* _tmp9_;
#line 701 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = value;
#line 701 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = metadata_date_time_new_from_exif (_tmp7_, &_inner_error0_);
#line 701 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp8_;
#line 701 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5840 "PhotoMetadata.c"
					goto __catch0_g_error;
				}
#line 701 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp6_;
#line 701 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = NULL;
#line 701 "../src/photos/PhotoMetadata.vala"
				result = _tmp9_;
#line 701 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp6_);
#line 701 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 701 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5855 "PhotoMetadata.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 689 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 689 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 704 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 704 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = err;
#line 704 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_->message;
#line 704 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:704: Unable to read date/time %s from source %s: %s", tag, _tmp10_, _tmp12_);
#line 706 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 706 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 706 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 706 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5886 "PhotoMetadata.c"
	}
	__finally0:
#line 689 "../src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 689 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 689 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 689 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 5897 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_first_date_time (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1)
{
	MetadataDateTime* result;
#line 710 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 5908 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 711 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 711 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 711 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 5920 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 711 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 711 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5927 "PhotoMetadata.c"
			{
				MetadataDateTime* date_time = NULL;
				const gchar* _tmp1_;
				MetadataDateTime* _tmp2_;
				MetadataDateTime* _tmp3_;
#line 712 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 712 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_date_time (self, _tmp1_);
#line 712 "../src/photos/PhotoMetadata.vala"
				date_time = _tmp2_;
#line 713 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = date_time;
#line 713 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 714 "../src/photos/PhotoMetadata.vala"
					result = date_time;
#line 714 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 714 "../src/photos/PhotoMetadata.vala"
					return result;
#line 5949 "PhotoMetadata.c"
				}
#line 711 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 711 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5955 "PhotoMetadata.c"
			}
		}
	}
#line 717 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 717 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5963 "PhotoMetadata.c"
}

void
photo_metadata_set_date_time (PhotoMetadata* self,
                              const gchar* tag,
                              MetadataDateTime* date_time)
{
#line 720 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 720 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 720 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 721 "../src/photos/PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 721 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 5981 "PhotoMetadata.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 723 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = metadata_date_time_get_exif_label (date_time);
#line 723 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _tmp0_;
#line 723 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 723 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp1_);
#line 724 "../src/photos/PhotoMetadata.vala"
			break;
#line 5995 "PhotoMetadata.c"
		}
#line 721 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 5999 "PhotoMetadata.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 727 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = metadata_date_time_get_xmp_label (date_time);
#line 727 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_;
#line 727 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 727 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp3_);
#line 728 "../src/photos/PhotoMetadata.vala"
			break;
#line 6013 "PhotoMetadata.c"
		}
		default:
#line 721 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 6018 "PhotoMetadata.c"
		{
			const gchar* _tmp4_;
			GEnumValue* _tmp5_;
#line 733 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->source_name;
#line 734 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), photo_metadata_get_tag_domain (tag));
#line 733 "../src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:733: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, _tmp4_, (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 735 "../src/photos/PhotoMetadata.vala"
			break;
#line 6030 "PhotoMetadata.c"
		}
	}
}

static gpointer
_metadata_date_time_ref0 (gpointer self)
{
#line 739 "../src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 6040 "PhotoMetadata.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 739 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 739 "../src/photos/PhotoMetadata.vala"
	return _data5_;
#line 6050 "PhotoMetadata.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 739 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 6060 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 739 "../src/photos/PhotoMetadata.vala"
		self = _data5_->self;
#line 739 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data5_->date_time);
#line 739 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 739 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 6070 "PhotoMetadata.c"
	}
}

static void
__lambda9_ (Block5Data* _data5_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 740 "../src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 740 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 740 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, tag, _data5_->date_time);
#line 6085 "PhotoMetadata.c"
}

static void
___lambda9__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 740 "../src/photos/PhotoMetadata.vala"
	__lambda9_ (self, tag);
#line 6094 "PhotoMetadata.c"
}

void
photo_metadata_set_all_date_time (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  MetadataDateTime* date_time,
                                  PhotoMetadataSetOption option)
{
	Block5Data* _data5_;
	MetadataDateTime* _tmp0_;
#line 739 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 739 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 739 "../src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 739 "../src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 739 "../src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 739 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _metadata_date_time_ref0 (date_time);
#line 739 "../src/photos/PhotoMetadata.vala"
	_metadata_date_time_unref0 (_data5_->date_time);
#line 739 "../src/photos/PhotoMetadata.vala"
	_data5_->date_time = _tmp0_;
#line 740 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda9__photo_metadata_set_generic_value, _data5_);
#line 739 "../src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 739 "../src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 6128 "PhotoMetadata.c"
}

gchar*
photo_metadata_exif_hash (PhotoMetadata* self)
{
	ExifData* _tmp0_;
	const gchar* _tmp1_;
	gchar* hash = NULL;
	guchar* thumb = NULL;
	ExifData* _tmp4_;
	guchar* _tmp5_;
	guint thumb_size = 0U;
	ExifData* _tmp6_;
	ExifData* _tmp7_;
	ExifData* _tmp8_;
	guchar* saved_data = NULL;
	guint saved_size = 0U;
	ExifData* _tmp9_;
	ExifData* _tmp10_;
	guchar* _tmp11_;
	ExifData* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gchar* result;
#line 744 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 745 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 745 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 746 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 746 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6162 "PhotoMetadata.c"
	}
#line 748 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->metadata_hash;
#line 748 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 6168 "PhotoMetadata.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 749 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = self->priv->metadata_hash;
#line 749 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 749 "../src/photos/PhotoMetadata.vala"
		result = _tmp3_;
#line 749 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6179 "PhotoMetadata.c"
	}
#line 752 "../src/photos/PhotoMetadata.vala"
	hash = NULL;
#line 754 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 754 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_->data;
#line 754 "../src/photos/PhotoMetadata.vala"
	thumb = _tmp5_;
#line 755 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->exif;
#line 755 "../src/photos/PhotoMetadata.vala"
	thumb_size = _tmp6_->size;
#line 758 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->priv->exif;
#line 758 "../src/photos/PhotoMetadata.vala"
	_tmp7_->data = NULL;
#line 759 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = self->priv->exif;
#line 759 "../src/photos/PhotoMetadata.vala"
	_tmp8_->size = (guint) 0;
#line 761 "../src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 762 "../src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 764 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = self->priv->exif;
#line 764 "../src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp9_, &saved_data, &saved_size);
#line 766 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = self->priv->exif;
#line 766 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = thumb;
#line 766 "../src/photos/PhotoMetadata.vala"
	_tmp10_->data = _tmp11_;
#line 767 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = self->priv->exif;
#line 767 "../src/photos/PhotoMetadata.vala"
	_tmp12_->size = thumb_size;
#line 769 "../src/photos/PhotoMetadata.vala"
	if (saved_size > ((guint) 0)) {
#line 6221 "PhotoMetadata.c"
		guchar* _tmp14_;
#line 769 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = saved_data;
#line 769 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = _tmp14_ != NULL;
#line 6227 "PhotoMetadata.c"
	} else {
#line 769 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = FALSE;
#line 6231 "PhotoMetadata.c"
	}
#line 769 "../src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 6235 "PhotoMetadata.c"
		GChecksum* md5 = NULL;
		GChecksum* _tmp15_;
		GChecksum* _tmp16_;
		guchar* _tmp17_;
		ExifMem* _tmp18_;
		ExifMem* _tmp19_;
		guchar* _tmp20_;
		GChecksum* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 770 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = g_checksum_new (G_CHECKSUM_MD5);
#line 770 "../src/photos/PhotoMetadata.vala"
		md5 = _tmp15_;
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = md5;
#line 771 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = saved_data;
#line 771 "../src/photos/PhotoMetadata.vala"
		g_checksum_update (_tmp16_, (guchar*) _tmp17_, (gsize) saved_size);
#line 772 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = exif_mem_new_default ();
#line 772 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp18_;
#line 772 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = saved_data;
#line 772 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp19_, _tmp20_);
#line 772 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp19_);
#line 774 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = md5;
#line 774 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = g_checksum_get_string (_tmp21_);
#line 774 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 774 "../src/photos/PhotoMetadata.vala"
		_g_free0 (self->priv->metadata_hash);
#line 774 "../src/photos/PhotoMetadata.vala"
		self->priv->metadata_hash = _tmp23_;
#line 769 "../src/photos/PhotoMetadata.vala"
		_g_checksum_free0 (md5);
#line 6278 "PhotoMetadata.c"
	}
#line 777 "../src/photos/PhotoMetadata.vala"
	result = hash;
#line 777 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6284 "PhotoMetadata.c"
}

gchar*
photo_metadata_thumbnail_hash (PhotoMetadata* self)
{
	const gchar* _tmp0_;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	GExiv2Metadata* _tmp3_;
	guint8* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	gchar* result;
#line 781 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 782 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->thumbnail_md5;
#line 782 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 6305 "PhotoMetadata.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 783 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->thumbnail_md5;
#line 783 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 783 "../src/photos/PhotoMetadata.vala"
		result = _tmp2_;
#line 783 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6316 "PhotoMetadata.c"
	}
#line 787 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = self->priv->exiv2;
#line 787 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gexiv2_metadata_get_exif_thumbnail (_tmp3_, &_tmp4_, &_tmp5_);
#line 787 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 787 "../src/photos/PhotoMetadata.vala"
	buffer = _tmp4_;
#line 787 "../src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp5_;
#line 787 "../src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 787 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 6332 "PhotoMetadata.c"
		GChecksum* md5 = NULL;
		GChecksum* _tmp7_;
		GChecksum* _tmp8_;
		guchar* _tmp9_;
		gint _tmp9__length1;
		guchar* _tmp10_;
		gint _tmp10__length1;
		GChecksum* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 788 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = g_checksum_new (G_CHECKSUM_MD5);
#line 788 "../src/photos/PhotoMetadata.vala"
		md5 = _tmp7_;
#line 789 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = md5;
#line 789 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = buffer;
#line 789 "../src/photos/PhotoMetadata.vala"
		_tmp9__length1 = buffer_length1;
#line 789 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = buffer;
#line 789 "../src/photos/PhotoMetadata.vala"
		_tmp10__length1 = buffer_length1;
#line 789 "../src/photos/PhotoMetadata.vala"
		g_checksum_update (_tmp8_, _tmp9_, (gsize) _tmp10__length1);
#line 791 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = md5;
#line 791 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = g_checksum_get_string (_tmp11_);
#line 791 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 791 "../src/photos/PhotoMetadata.vala"
		_g_free0 (self->priv->thumbnail_md5);
#line 791 "../src/photos/PhotoMetadata.vala"
		self->priv->thumbnail_md5 = _tmp13_;
#line 793 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = self->priv->thumbnail_md5;
#line 793 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 793 "../src/photos/PhotoMetadata.vala"
		result = _tmp15_;
#line 793 "../src/photos/PhotoMetadata.vala"
		_g_checksum_free0 (md5);
#line 793 "../src/photos/PhotoMetadata.vala"
		buffer = (g_free (buffer), NULL);
#line 793 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6383 "PhotoMetadata.c"
	}
#line 796 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 796 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 796 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6391 "PhotoMetadata.c"
}

guint
photo_metadata_get_preview_count (PhotoMetadata* self)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	guint result;
#line 799 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 800 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 800 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 800 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 800 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 800 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 802 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 802 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 802 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 6425 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 802 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 802 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 802 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 6434 "PhotoMetadata.c"
	} else {
#line 802 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 6438 "PhotoMetadata.c"
	}
#line 802 "../src/photos/PhotoMetadata.vala"
	result = (guint) _tmp3_;
#line 802 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6444 "PhotoMetadata.c"
}

PhotoPreview*
photo_metadata_get_preview (PhotoMetadata* self,
                            guint number)
{
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp6_;
	GExiv2PreviewProperties** _tmp7_;
	gint _tmp7__length1;
	GExiv2PreviewProperties* _tmp8_;
	PhotoMetadataInternalPhotoPreview* _tmp9_;
	PhotoPreview* result;
#line 806 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 807 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 807 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 807 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 807 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 807 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 808 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 808 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 808 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 6486 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= number;
#line 6496 "PhotoMetadata.c"
	}
#line 808 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 809 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 809 "../src/photos/PhotoMetadata.vala"
		return result;
#line 6504 "PhotoMetadata.c"
	}
#line 811 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->source_name;
#line 811 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = props;
#line 811 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = props_length1;
#line 811 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_[number];
#line 811 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = photo_metadata_internal_photo_preview_new (self, _tmp6_, number, _tmp8_);
#line 811 "../src/photos/PhotoMetadata.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 811 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6520 "PhotoMetadata.c"
}

void
photo_metadata_remove_exif_thumbnail (PhotoMetadata* self)
{
	ExifData* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 814 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 6530 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
#line 816 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 816 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_erase_exif_thumbnail (_tmp0_, &_inner_error0_);
#line 816 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6539 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 815 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 6548 "PhotoMetadata.c"
	}
	__finally0:
#line 815 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 815 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 815 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 815 "../src/photos/PhotoMetadata.vala"
		return;
#line 6559 "PhotoMetadata.c"
	}
#line 819 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 819 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 6565 "PhotoMetadata.c"
		ExifMem* _tmp2_;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 820 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 820 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 820 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 820 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 820 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 820 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 821 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 821 "../src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 822 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 822 "../src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 6592 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_tag (PhotoMetadata* self,
                           const gchar* tag)
{
	GError* _inner_error0_ = NULL;
#line 826 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 826 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 6605 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
#line 828 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 828 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_clear_tag (_tmp0_, tag, &_inner_error0_);
#line 828 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6614 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 827 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 6623 "PhotoMetadata.c"
	}
	__finally0:
#line 827 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 827 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 827 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 827 "../src/photos/PhotoMetadata.vala"
		return;
#line 6634 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_tags (PhotoMetadata* self,
                            gchar** tags,
                            gint tags_length1)
{
#line 832 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 6645 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 833 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 833 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 833 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 6657 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 833 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 833 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 6664 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
#line 834 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 834 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp1_);
#line 833 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 6673 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_clear_domain (PhotoMetadata* self,
                             MetadataDomain domain)
{
#line 837 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 838 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 838 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 6689 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 840 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 840 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp0_);
#line 841 "../src/photos/PhotoMetadata.vala"
			break;
#line 6698 "PhotoMetadata.c"
		}
#line 838 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 6702 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 844 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 844 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp1_);
#line 845 "../src/photos/PhotoMetadata.vala"
			break;
#line 6711 "PhotoMetadata.c"
		}
#line 838 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 6715 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 848 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 848 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp2_);
#line 849 "../src/photos/PhotoMetadata.vala"
			break;
#line 6724 "PhotoMetadata.c"
		}
		default:
		{
#line 852 "../src/photos/PhotoMetadata.vala"
			break;
#line 6730 "PhotoMetadata.c"
		}
	}
}

void
photo_metadata_clear (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
#line 856 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 857 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 857 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 6745 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_modification_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 867 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 868 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 868 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 868 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 868 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 868 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6767 "PhotoMetadata.c"
}

void
photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                           MetadataDateTime* date_time,
                                           PhotoMetadataSetOption option)
{
#line 871 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 871 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 873 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6781 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 874 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 874 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 874 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6790 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 876 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 876 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 876 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6800 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_exposure_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 888 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 889 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 889 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 889 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 889 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 889 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6823 "PhotoMetadata.c"
}

void
photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option)
{
#line 892 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 892 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 894 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6837 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 895 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 895 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 895 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6846 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 897 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 897 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 897 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6856 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_digitized_date_time (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 905 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 906 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 906 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 906 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 906 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 906 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6879 "PhotoMetadata.c"
}

void
photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                        MetadataDateTime* date_time,
                                        PhotoMetadataSetOption option)
{
#line 909 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 909 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (date_time, TYPE_METADATA_DATE_TIME));
#line 911 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 6893 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 912 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 912 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 912 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 6902 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 914 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 6912 "PhotoMetadata.c"
	}
}

static MetadataDateTime*
photo_metadata_real_get_creation_date_time (MediaMetadata* base)
{
	PhotoMetadata * self;
	MetadataDateTime* creation = NULL;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	MetadataDateTime* result;
#line 917 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 918 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 918 "../src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 919 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 919 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 6934 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_;
#line 920 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 920 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 920 "../src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 6942 "PhotoMetadata.c"
	}
#line 922 "../src/photos/PhotoMetadata.vala"
	result = creation;
#line 922 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6948 "PhotoMetadata.c"
}

static gpointer
_dimensions_dup0 (gpointer self)
{
#line 953 "../src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 6956 "PhotoMetadata.c"
}

Dimensions*
photo_metadata_get_pixel_dimensions (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	Dimensions* result;
#line 939 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 941 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 941 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 941 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 941 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 941 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0__length1 == _tmp1__length1, "WIDTH_TAGS.length == HEIGHT_TAGS.length");
#line 6979 "PhotoMetadata.c"
	{
		gint ctr = 0;
#line 942 "../src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 6984 "PhotoMetadata.c"
		{
			gboolean _tmp2_ = FALSE;
#line 942 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 942 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6991 "PhotoMetadata.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				glong width = 0L;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				glong _tmp7_ = 0L;
				gboolean _tmp8_;
				glong height = 0L;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				glong _tmp11_ = 0L;
				gboolean _tmp12_;
				Dimensions _tmp13_ = {0};
				Dimensions* _tmp14_;
#line 942 "../src/photos/PhotoMetadata.vala"
				if (!_tmp2_) {
#line 7010 "PhotoMetadata.c"
					gint _tmp3_;
#line 942 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = ctr;
#line 942 "../src/photos/PhotoMetadata.vala"
					ctr = _tmp3_ + 1;
#line 7016 "PhotoMetadata.c"
				}
#line 942 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 942 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_WIDTH_TAGS;
#line 942 "../src/photos/PhotoMetadata.vala"
				_tmp4__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 942 "../src/photos/PhotoMetadata.vala"
				if (!(ctr < _tmp4__length1)) {
#line 942 "../src/photos/PhotoMetadata.vala"
					break;
#line 7028 "PhotoMetadata.c"
				}
#line 946 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_WIDTH_TAGS;
#line 946 "../src/photos/PhotoMetadata.vala"
				_tmp5__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 946 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp5_[ctr];
#line 946 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = photo_metadata_get_long (self, _tmp6_, &_tmp7_);
#line 946 "../src/photos/PhotoMetadata.vala"
				width = _tmp7_;
#line 946 "../src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 947 "../src/photos/PhotoMetadata.vala"
					continue;
#line 7044 "PhotoMetadata.c"
				}
#line 950 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = photo_metadata_HEIGHT_TAGS;
#line 950 "../src/photos/PhotoMetadata.vala"
				_tmp9__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 950 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_[ctr];
#line 950 "../src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_get_long (self, _tmp10_, &_tmp11_);
#line 950 "../src/photos/PhotoMetadata.vala"
				height = _tmp11_;
#line 950 "../src/photos/PhotoMetadata.vala"
				if (!_tmp12_) {
#line 951 "../src/photos/PhotoMetadata.vala"
					continue;
#line 7060 "PhotoMetadata.c"
				}
#line 953 "../src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp13_, (gint) width, (gint) height);
#line 953 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = _dimensions_dup0 (&_tmp13_);
#line 953 "../src/photos/PhotoMetadata.vala"
				result = _tmp14_;
#line 953 "../src/photos/PhotoMetadata.vala"
				return result;
#line 7070 "PhotoMetadata.c"
			}
		}
	}
#line 956 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 956 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7078 "PhotoMetadata.c"
}

void
photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                     Dimensions* dim,
                                     PhotoMetadataSetOption option)
{
#line 959 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 960 "../src/photos/PhotoMetadata.vala"
	if (dim != NULL) {
#line 7090 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 961 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 961 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 961 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp0_, (gint) _tmp0__length1, (glong) (*dim).width, option);
#line 962 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 962 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 962 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, (gint) _tmp1__length1, (glong) (*dim).height, option);
#line 7107 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 964 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_WIDTH_TAGS;
#line 964 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 964 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 965 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_HEIGHT_TAGS;
#line 965 "../src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 965 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp3_, (gint) _tmp3__length1);
#line 7125 "PhotoMetadata.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 7147 "PhotoMetadata.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 7166 "PhotoMetadata.c"
}

static gchar*
photo_metadata_real_get_title (MediaMetadata* base)
{
	PhotoMetadata * self;
	GeeList* _tmp0_ = NULL;
	GeeList* titles = NULL;
	GeeList* _tmp4_;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeList* _tmp7_;
	gchar* title = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp20_;
	gchar* _tmp24_;
	gchar* result;
#line 999 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 1007 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 7192 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 1008 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 1008 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 1008 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 7200 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		GeeList* _tmp3_;
#line 1009 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 1009 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 1009 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_get_first_string_multiple (self, _tmp2_, (gint) _tmp2__length1);
#line 1009 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 1009 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp3_;
#line 7215 "PhotoMetadata.c"
	}
#line 1007 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 1007 "../src/photos/PhotoMetadata.vala"
	titles = _tmp4_;
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = titles;
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (_tmp7_ != NULL) {
#line 7225 "PhotoMetadata.c"
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = titles;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp10_ > 0;
#line 7237 "PhotoMetadata.c"
	} else {
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = FALSE;
#line 7241 "PhotoMetadata.c"
	}
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 7245 "PhotoMetadata.c"
		GeeList* _tmp11_;
		gpointer _tmp12_;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = titles;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = gee_list_get (_tmp11_, 0);
#line 1014 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = (gchar*) _tmp12_;
#line 7256 "PhotoMetadata.c"
	} else {
#line 1014 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = NULL;
#line 7262 "PhotoMetadata.c"
	}
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup (_tmp5_);
#line 1014 "../src/photos/PhotoMetadata.vala"
	title = _tmp13_;
#line 1017 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = title;
#line 1017 "../src/photos/PhotoMetadata.vala"
	if (_tmp14_ != NULL) {
#line 7272 "PhotoMetadata.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 1018 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = title;
#line 1018 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 1018 "../src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 1018 "../src/photos/PhotoMetadata.vala"
		title = _tmp16_;
#line 7283 "PhotoMetadata.c"
	}
#line 1021 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = title;
#line 1021 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_tmp20_)) {
#line 7289 "PhotoMetadata.c"
		const gchar* _tmp21_;
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = title;
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = !string_contains (_tmp21_, "\n");
#line 7295 "PhotoMetadata.c"
	} else {
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 7299 "PhotoMetadata.c"
	}
#line 1021 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 7303 "PhotoMetadata.c"
		const gchar* _tmp22_;
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = title;
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = !string_contains (_tmp22_, "\r");
#line 7309 "PhotoMetadata.c"
	} else {
#line 1021 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = FALSE;
#line 7313 "PhotoMetadata.c"
	}
#line 1021 "../src/photos/PhotoMetadata.vala"
	if (_tmp18_) {
#line 7317 "PhotoMetadata.c"
		const gchar* _tmp23_;
#line 1022 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = title;
#line 1022 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = _tmp23_;
#line 7323 "PhotoMetadata.c"
	} else {
#line 1022 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = NULL;
#line 7327 "PhotoMetadata.c"
	}
#line 1021 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup (_tmp17_);
#line 1021 "../src/photos/PhotoMetadata.vala"
	result = _tmp24_;
#line 1021 "../src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 1021 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 1021 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 1021 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 1021 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7343 "PhotoMetadata.c"
}

void
photo_metadata_set_title (PhotoMetadata* self,
                          const gchar* title,
                          PhotoMetadataSetOption option)
{
#line 1025 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1026 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 1027 "../src/photos/PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 1028 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 7359 "PhotoMetadata.c"
		} else {
			gchar** _tmp0_;
			gint _tmp0__length1;
#line 1030 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 1030 "../src/photos/PhotoMetadata.vala"
			_tmp0__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 1030 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp0_, (gint) _tmp0__length1, title, option);
#line 7369 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 1032 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 1032 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 1032 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 7380 "PhotoMetadata.c"
	}
}

static gchar*
photo_metadata_real_get_comment (MediaMetadata* base)
{
	PhotoMetadata * self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* result;
#line 1041 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_COMMENT_TAGS;
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 1042 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1042 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7404 "PhotoMetadata.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 1045 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 1045 "../src/photos/PhotoMetadata.vala"
	return _data6_;
#line 7414 "PhotoMetadata.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 1045 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 7424 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 1045 "../src/photos/PhotoMetadata.vala"
		self = _data6_->self;
#line 1045 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data6_->comment);
#line 1045 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 1045 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block6Data, _data6_);
#line 7434 "PhotoMetadata.c"
	}
}

static void
___lambda10_ (Block6Data* _data6_,
              const gchar* tag)
{
	PhotoMetadata* self;
#line 1050 "../src/photos/PhotoMetadata.vala"
	self = _data6_->self;
#line 1050 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 1052 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data6_->comment, PHOTO_METADATA_PREPARE_STRING_OPTIONS & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF), 4095);
#line 7449 "PhotoMetadata.c"
}

static void
____lambda10__photo_metadata_set_generic_value (const gchar* tag,
                                                gpointer self)
{
#line 1050 "../src/photos/PhotoMetadata.vala"
	___lambda10_ (self, tag);
#line 7458 "PhotoMetadata.c"
}

void
photo_metadata_set_comment (PhotoMetadata* self,
                            const gchar* comment,
                            PhotoMetadataSetOption option)
{
	Block6Data* _data6_;
	gchar* _tmp0_;
#line 1045 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1045 "../src/photos/PhotoMetadata.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 1045 "../src/photos/PhotoMetadata.vala"
	_data6_->_ref_count_ = 1;
#line 1045 "../src/photos/PhotoMetadata.vala"
	_data6_->self = media_metadata_ref (self);
#line 1045 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (comment);
#line 1045 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data6_->comment);
#line 1045 "../src/photos/PhotoMetadata.vala"
	_data6_->comment = _tmp0_;
#line 1049 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_data6_->comment)) {
#line 7484 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 1050 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_COMMENT_TAGS;
#line 1050 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 1050 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_generic (self, _tmp1_, (gint) _tmp1__length1, option, ____lambda10__photo_metadata_set_generic_value, _data6_);
#line 7493 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 1056 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_COMMENT_TAGS;
#line 1056 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_COMMENT_TAGS_length1;
#line 1056 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 7503 "PhotoMetadata.c"
	}
#line 1045 "../src/photos/PhotoMetadata.vala"
	block6_data_unref (_data6_);
#line 1045 "../src/photos/PhotoMetadata.vala"
	_data6_ = NULL;
#line 7509 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_keywords (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* keywords = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	GeeSet* _tmp23_;
	GeeSet* _tmp28_;
	GeeSet* result;
#line 1076 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1077 "../src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 1078 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 1078 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 7534 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 1078 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 1078 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 1078 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 7546 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 1078 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 1078 "../src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 7553 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				const gchar* _tmp2_;
				GeeList* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
#line 1079 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 1079 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 1079 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1080 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 1080 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 7570 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 1080 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 1080 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 1080 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 1080 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 7582 "PhotoMetadata.c"
				} else {
#line 1080 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 7586 "PhotoMetadata.c"
				}
#line 1080 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 7590 "PhotoMetadata.c"
					GeeSet* _tmp9_;
#line 1081 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = keywords;
#line 1081 "../src/photos/PhotoMetadata.vala"
					if (_tmp9_ == NULL) {
#line 7596 "PhotoMetadata.c"
						GCompareDataFunc _tmp10_;
						gpointer _tmp10__target;
						GDestroyNotify _tmp10__target_destroy_notify;
						GeeSet* _tmp11_;
#line 1082 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = compare_func;
#line 1082 "../src/photos/PhotoMetadata.vala"
						_tmp10__target = compare_func_target;
#line 1082 "../src/photos/PhotoMetadata.vala"
						_tmp10__target_destroy_notify = compare_func_target_destroy_notify;
#line 1082 "../src/photos/PhotoMetadata.vala"
						compare_func = NULL;
#line 1082 "../src/photos/PhotoMetadata.vala"
						compare_func_target = NULL;
#line 1082 "../src/photos/PhotoMetadata.vala"
						compare_func_target_destroy_notify = NULL;
#line 1082 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = photo_metadata_create_string_set (self, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify);
#line 1082 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 1082 "../src/photos/PhotoMetadata.vala"
						keywords = _tmp11_;
#line 7619 "PhotoMetadata.c"
					}
					{
						GeeIterator* _current_value_it = NULL;
						GeeCollection* _tmp12_;
						GeeIterator* _tmp13_;
#line 1084 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = values;
#line 1084 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1084 "../src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp13_;
#line 1084 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 7633 "PhotoMetadata.c"
							GeeIterator* _tmp14_;
							gchar* current_value = NULL;
							GeeIterator* _tmp15_;
							gpointer _tmp16_;
							GeeSet* _tmp17_;
							const gchar* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
#line 1084 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = _current_value_it;
#line 1084 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp14_)) {
#line 1084 "../src/photos/PhotoMetadata.vala"
								break;
#line 7648 "PhotoMetadata.c"
							}
#line 1084 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = _current_value_it;
#line 1084 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_get (_tmp15_);
#line 1084 "../src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp16_;
#line 1085 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = keywords;
#line 1085 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = current_value;
#line 1085 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp18_);
#line 1085 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = _tmp19_;
#line 1085 "../src/photos/PhotoMetadata.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp20_);
#line 1085 "../src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp20_);
#line 1084 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 7670 "PhotoMetadata.c"
						}
#line 1084 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 7674 "PhotoMetadata.c"
					}
				}
#line 1078 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1078 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 7681 "PhotoMetadata.c"
			}
		}
	}
#line 1089 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = keywords;
#line 1089 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ != NULL) {
#line 7689 "PhotoMetadata.c"
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = keywords;
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp25_;
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp26_ > 0;
#line 7701 "PhotoMetadata.c"
	} else {
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 7705 "PhotoMetadata.c"
	}
#line 1089 "../src/photos/PhotoMetadata.vala"
	if (_tmp22_) {
#line 7709 "PhotoMetadata.c"
		GeeSet* _tmp27_;
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp27_ = keywords;
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp27_;
#line 7715 "PhotoMetadata.c"
	} else {
#line 1089 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 7719 "PhotoMetadata.c"
	}
#line 1089 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = _g_object_ref0 (_tmp21_);
#line 1089 "../src/photos/PhotoMetadata.vala"
	result = _tmp28_;
#line 1089 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 1089 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 1089 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 1089 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 1089 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 1089 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7737 "PhotoMetadata.c"
}

static gpointer
_hierarchical_keyword_field_ref0 (gpointer self)
{
#line 1093 "../src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 7745 "PhotoMetadata.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 7767 "PhotoMetadata.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 7771 "PhotoMetadata.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 7777 "PhotoMetadata.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 7781 "PhotoMetadata.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 7785 "PhotoMetadata.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 7793 "PhotoMetadata.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 7821 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 7830 "PhotoMetadata.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 7844 "PhotoMetadata.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 7853 "PhotoMetadata.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 7867 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 7876 "PhotoMetadata.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 7885 "PhotoMetadata.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 7908 "PhotoMetadata.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 7917 "PhotoMetadata.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 7936 "PhotoMetadata.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 7940 "PhotoMetadata.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 7946 "PhotoMetadata.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 7956 "PhotoMetadata.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 7964 "PhotoMetadata.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 7968 "PhotoMetadata.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 7974 "PhotoMetadata.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 7984 "PhotoMetadata.c"
}

static void
photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                   HierarchicalTagIndex* index)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	HierarchicalKeywordField** _tmp4_;
	gint _tmp4__length1;
#line 1092 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1092 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((index == NULL) || IS_HIERARCHICAL_TAG_INDEX (index));
#line 1093 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1093 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 8003 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 1093 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 1093 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 1093 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 8015 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* current_field = NULL;
#line 1093 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 1093 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 8022 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
#line 1094 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 1094 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 1094 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 1093 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 8034 "PhotoMetadata.c"
			}
		}
	}
#line 1096 "../src/photos/PhotoMetadata.vala"
	if (index == NULL) {
#line 1097 "../src/photos/PhotoMetadata.vala"
		return;
#line 8042 "PhotoMetadata.c"
	}
#line 1099 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1099 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 8048 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 1099 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp4_;
#line 1099 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp4__length1;
#line 1099 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < current_field_collection_length1; current_field_it = current_field_it + 1) {
#line 8060 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp5_;
			HierarchicalKeywordField* current_field = NULL;
#line 1099 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 1099 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp5_;
#line 8067 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp6_;
				GeeSet* writeable_set = NULL;
				GeeTreeSet* _tmp7_;
				HierarchicalKeywordField* _tmp24_;
				const gchar* _tmp25_;
				GeeSet* _tmp26_;
#line 1100 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = current_field;
#line 1100 "../src/photos/PhotoMetadata.vala"
				if (!_tmp6_->is_writeable) {
#line 1101 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 1101 "../src/photos/PhotoMetadata.vala"
					continue;
#line 8083 "PhotoMetadata.c"
				}
#line 1103 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1103 "../src/photos/PhotoMetadata.vala"
				writeable_set = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_SET, GeeSet);
#line 8089 "PhotoMetadata.c"
				{
					GeeIterator* _current_path_it = NULL;
					GeeCollection* _tmp8_;
					GeeCollection* _tmp9_;
					GeeIterator* _tmp10_;
					GeeIterator* _tmp11_;
#line 1105 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_index_get_all_paths (index);
#line 1105 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 1105 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1105 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 1105 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp9_);
#line 1105 "../src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp11_;
#line 1105 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 8110 "PhotoMetadata.c"
						GeeIterator* _tmp12_;
						gchar* current_path = NULL;
						GeeIterator* _tmp13_;
						gpointer _tmp14_;
						gchar* writeable_path = NULL;
						const gchar* _tmp15_;
						HierarchicalKeywordField* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						HierarchicalKeywordField* _tmp19_;
						GeeSet* _tmp22_;
						const gchar* _tmp23_;
#line 1105 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = _current_path_it;
#line 1105 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp12_)) {
#line 1105 "../src/photos/PhotoMetadata.vala"
							break;
#line 8129 "PhotoMetadata.c"
						}
#line 1105 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_path_it;
#line 1105 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterator_get (_tmp13_);
#line 1105 "../src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp14_;
#line 1106 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = current_path;
#line 1106 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_field;
#line 1106 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = _tmp16_->path_separator;
#line 1106 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = string_replace (_tmp15_, TAG_PATH_SEPARATOR_STRING, _tmp17_);
#line 1106 "../src/photos/PhotoMetadata.vala"
						writeable_path = _tmp18_;
#line 1108 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = current_field;
#line 1108 "../src/photos/PhotoMetadata.vala"
						if (!_tmp19_->wants_leading_separator) {
#line 8151 "PhotoMetadata.c"
							const gchar* _tmp20_;
							gchar* _tmp21_;
#line 1109 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = writeable_path;
#line 1109 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = string_substring (_tmp20_, (glong) 1, (glong) -1);
#line 1109 "../src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 1109 "../src/photos/PhotoMetadata.vala"
							writeable_path = _tmp21_;
#line 8162 "PhotoMetadata.c"
						}
#line 1111 "../src/photos/PhotoMetadata.vala"
						_tmp22_ = writeable_set;
#line 1111 "../src/photos/PhotoMetadata.vala"
						_tmp23_ = writeable_path;
#line 1111 "../src/photos/PhotoMetadata.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection), _tmp23_);
#line 1105 "../src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 1105 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 8174 "PhotoMetadata.c"
					}
#line 1105 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 8178 "PhotoMetadata.c"
				}
#line 1114 "../src/photos/PhotoMetadata.vala"
				_tmp24_ = current_field;
#line 1114 "../src/photos/PhotoMetadata.vala"
				_tmp25_ = _tmp24_->field_name;
#line 1114 "../src/photos/PhotoMetadata.vala"
				_tmp26_ = writeable_set;
#line 1114 "../src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp25_, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1099 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 1099 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 8192 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_set_keywords (PhotoMetadata* self,
                             GeeCollection* keywords,
                             PhotoMetadataSetOption option)
{
	HierarchicalTagIndex* htag_index = NULL;
	HierarchicalTagIndex* _tmp0_;
	GeeSet* flat_keywords = NULL;
	GeeTreeSet* _tmp1_;
#line 1118 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1118 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (keywords, GEE_TYPE_COLLECTION));
#line 1119 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 1119 "../src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1120 "../src/photos/PhotoMetadata.vala"
	flat_keywords = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 1122 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 8221 "PhotoMetadata.c"
		GeeSet* _tmp19_;
		HierarchicalTagIndex* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		{
			GeeIterator* _keyword_it = NULL;
			GeeIterator* _tmp2_;
#line 1123 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (keywords, GEE_TYPE_ITERABLE, GeeIterable));
#line 1123 "../src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp2_;
#line 1123 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 8235 "PhotoMetadata.c"
				GeeIterator* _tmp3_;
				gchar* keyword = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				const gchar* _tmp6_;
#line 1123 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _keyword_it;
#line 1123 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 1123 "../src/photos/PhotoMetadata.vala"
					break;
#line 8247 "PhotoMetadata.c"
				}
#line 1123 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _keyword_it;
#line 1123 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 1123 "../src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp5_;
#line 1124 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = keyword;
#line 1124 "../src/photos/PhotoMetadata.vala"
				if (g_str_has_prefix (_tmp6_, TAG_PATH_SEPARATOR_STRING)) {
#line 8259 "PhotoMetadata.c"
					GeeCollection* path_components = NULL;
					const gchar* _tmp7_;
					GeeList* _tmp8_;
#line 1125 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = keyword;
#line 1125 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_utilities_enumerate_path_components (_tmp7_);
#line 1125 "../src/photos/PhotoMetadata.vala"
					path_components = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection);
#line 8269 "PhotoMetadata.c"
					{
						GeeIterator* _component_it = NULL;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
#line 1127 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = path_components;
#line 1127 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1127 "../src/photos/PhotoMetadata.vala"
						_component_it = _tmp10_;
#line 1127 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 8282 "PhotoMetadata.c"
							GeeIterator* _tmp11_;
							gchar* component = NULL;
							GeeIterator* _tmp12_;
							gpointer _tmp13_;
							HierarchicalTagIndex* _tmp14_;
							const gchar* _tmp15_;
							const gchar* _tmp16_;
#line 1127 "../src/photos/PhotoMetadata.vala"
							_tmp11_ = _component_it;
#line 1127 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp11_)) {
#line 1127 "../src/photos/PhotoMetadata.vala"
								break;
#line 8296 "PhotoMetadata.c"
							}
#line 1127 "../src/photos/PhotoMetadata.vala"
							_tmp12_ = _component_it;
#line 1127 "../src/photos/PhotoMetadata.vala"
							_tmp13_ = gee_iterator_get (_tmp12_);
#line 1127 "../src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp13_;
#line 1128 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = htag_index;
#line 1128 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = component;
#line 1128 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = keyword;
#line 1128 "../src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp14_, _tmp15_, _tmp16_);
#line 1127 "../src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 8314 "PhotoMetadata.c"
						}
#line 1127 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 8318 "PhotoMetadata.c"
					}
#line 1124 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 8322 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp17_;
					const gchar* _tmp18_;
#line 1130 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = flat_keywords;
#line 1130 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = keyword;
#line 1130 "../src/photos/PhotoMetadata.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp18_);
#line 8332 "PhotoMetadata.c"
				}
#line 1123 "../src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 8336 "PhotoMetadata.c"
			}
#line 1123 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 8340 "PhotoMetadata.c"
		}
#line 1134 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = flat_keywords;
#line 1134 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = htag_index;
#line 1134 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = hierarchical_tag_index_get_all_tags (_tmp20_);
#line 1134 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_;
#line 1134 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), _tmp22_);
#line 1134 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp22_);
#line 8354 "PhotoMetadata.c"
	}
#line 1137 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 8358 "PhotoMetadata.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		GeeSet* _tmp24_;
		HierarchicalTagIndex* _tmp25_;
#line 1138 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = photo_metadata_KEYWORD_TAGS;
#line 1138 "../src/photos/PhotoMetadata.vala"
		_tmp23__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 1138 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 1138 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp23_, (gint) _tmp23__length1, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection), option);
#line 1139 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 1139 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp25_);
#line 8375 "PhotoMetadata.c"
	} else {
		gchar** _tmp26_;
		gint _tmp26__length1;
#line 1141 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = photo_metadata_KEYWORD_TAGS;
#line 1141 "../src/photos/PhotoMetadata.vala"
		_tmp26__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 1141 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp26_, (gint) _tmp26__length1);
#line 1142 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 8387 "PhotoMetadata.c"
	}
#line 1118 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 1118 "../src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 8393 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_hierarchical_keywords (PhotoMetadata* self)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	gboolean result;
#line 1146 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1147 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1147 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 8408 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 1147 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 1147 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 1147 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 8420 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* field = NULL;
#line 1147 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 1147 "../src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 8427 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
				GeeList* _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_;
#line 1148 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 1148 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 1148 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 1148 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1150 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 1150 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 8447 "PhotoMetadata.c"
					GeeCollection* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
#line 1150 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 1150 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 1150 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 1150 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 8459 "PhotoMetadata.c"
				} else {
#line 1150 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 8463 "PhotoMetadata.c"
				}
#line 1150 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_) {
#line 1151 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 1151 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 1151 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 1151 "../src/photos/PhotoMetadata.vala"
					return result;
#line 8475 "PhotoMetadata.c"
				}
#line 1147 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1147 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 8481 "PhotoMetadata.c"
			}
		}
	}
#line 1154 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 1154 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8489 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_hierarchical_keywords (PhotoMetadata* self)
{
	GeeSet* h_keywords = NULL;
	GeeSet* _tmp0_;
	HierarchicalKeywordField** _tmp1_;
	gint _tmp1__length1;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 1157 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1158 "../src/photos/PhotoMetadata.vala"
	_vala_assert (photo_metadata_has_hierarchical_keywords (self), "has_hierarchical_keywords()");
#line 1160 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_create_string_set (self, NULL, NULL, NULL);
#line 1160 "../src/photos/PhotoMetadata.vala"
	h_keywords = _tmp0_;
#line 1162 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 1162 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 8513 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 1162 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp1_;
#line 1162 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp1__length1;
#line 1162 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
#line 8525 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp2_;
			HierarchicalKeywordField* field = NULL;
#line 1162 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 1162 "../src/photos/PhotoMetadata.vala"
			field = _tmp2_;
#line 8532 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp3_;
				const gchar* _tmp4_;
				GeeList* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeCollection* _tmp7_;
				GeeArrayList* transformed_values = NULL;
				GeeArrayList* _tmp11_;
#line 1163 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = field;
#line 1163 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _tmp3_->field_name;
#line 1163 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_get_string_multiple (self, _tmp4_);
#line 1163 "../src/photos/PhotoMetadata.vala"
				values = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1165 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = values;
#line 1165 "../src/photos/PhotoMetadata.vala"
				if (_tmp7_ == NULL) {
#line 1165 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = TRUE;
#line 8556 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
#line 1165 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = values;
#line 1165 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = gee_collection_get_size (_tmp8_);
#line 1165 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = _tmp9_;
#line 1165 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = _tmp10_ < 1;
#line 8569 "PhotoMetadata.c"
				}
#line 1165 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_) {
#line 1166 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 1166 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 1166 "../src/photos/PhotoMetadata.vala"
					continue;
#line 8579 "PhotoMetadata.c"
				}
#line 1168 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1168 "../src/photos/PhotoMetadata.vala"
				transformed_values = _tmp11_;
#line 8585 "PhotoMetadata.c"
				{
					GeeIterator* _current_value_it = NULL;
					GeeCollection* _tmp12_;
					GeeIterator* _tmp13_;
#line 1169 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = values;
#line 1169 "../src/photos/PhotoMetadata.vala"
					_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1169 "../src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp13_;
#line 1169 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 8598 "PhotoMetadata.c"
						GeeIterator* _tmp14_;
						gchar* current_value = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
#line 1169 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = _current_value_it;
#line 1169 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp14_)) {
#line 1169 "../src/photos/PhotoMetadata.vala"
							break;
#line 8609 "PhotoMetadata.c"
						}
#line 1169 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = _current_value_it;
#line 1169 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = gee_iterator_get (_tmp15_);
#line 1169 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp16_;
#line 8617 "PhotoMetadata.c"
						{
							GeeList* transformed = NULL;
							HierarchicalKeywordField* _tmp17_;
							KeywordTransformer* _tmp18_;
							const gchar* _tmp19_;
							GeeList* _tmp20_;
							GeeArrayList* _tmp21_;
							GeeList* _tmp22_;
#line 1171 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = field;
#line 1171 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = _tmp17_->transformer;
#line 1171 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = current_value;
#line 1171 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = keyword_transformer_transform (_tmp18_, _tmp19_, &_inner_error0_);
#line 1171 "../src/photos/PhotoMetadata.vala"
							transformed = _tmp20_;
#line 1171 "../src/photos/PhotoMetadata.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8638 "PhotoMetadata.c"
								goto __catch0_g_error;
							}
#line 1172 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = transformed_values;
#line 1172 "../src/photos/PhotoMetadata.vala"
							_tmp22_ = transformed;
#line 1172 "../src/photos/PhotoMetadata.vala"
							gee_array_list_add_all (_tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (transformed);
#line 8649 "PhotoMetadata.c"
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* _error_ = NULL;
							const gchar* _tmp23_;
							GError* _tmp24_;
							const gchar* _tmp25_;
#line 1170 "../src/photos/PhotoMetadata.vala"
							_error_ = _inner_error0_;
#line 1170 "../src/photos/PhotoMetadata.vala"
							_inner_error0_ = NULL;
#line 1174 "../src/photos/PhotoMetadata.vala"
							_tmp23_ = current_value;
#line 1174 "../src/photos/PhotoMetadata.vala"
							_tmp24_ = _error_;
#line 1174 "../src/photos/PhotoMetadata.vala"
							_tmp25_ = _tmp24_->message;
#line 1174 "../src/photos/PhotoMetadata.vala"
							g_critical ("PhotoMetadata.vala:1174: Failed to transform tag value %s: %s", _tmp23_, _tmp25_);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_error_free0 (_error_);
#line 8672 "PhotoMetadata.c"
						}
						__finally0:
#line 1170 "../src/photos/PhotoMetadata.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (_current_value_it);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (transformed_values);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (values);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_hierarchical_keyword_field_unref0 (field);
#line 1170 "../src/photos/PhotoMetadata.vala"
							_g_object_unref0 (h_keywords);
#line 1170 "../src/photos/PhotoMetadata.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1170 "../src/photos/PhotoMetadata.vala"
							g_clear_error (&_inner_error0_);
#line 1170 "../src/photos/PhotoMetadata.vala"
							return NULL;
#line 8695 "PhotoMetadata.c"
						}
#line 1169 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 8699 "PhotoMetadata.c"
					}
#line 1169 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 8703 "PhotoMetadata.c"
				}
				{
					GeeArrayList* _current_value_list = NULL;
					GeeArrayList* _tmp26_;
					gint _current_value_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _current_value_index = 0;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_tmp26_ = transformed_values;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_current_value_list = _tmp26_;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_tmp27_ = _current_value_list;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_tmp28_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1180 "../src/photos/PhotoMetadata.vala"
					_tmp29_ = _tmp28_;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_current_value_size = _tmp29_;
#line 1180 "../src/photos/PhotoMetadata.vala"
					_current_value_index = -1;
#line 1180 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 8729 "PhotoMetadata.c"
						gint _tmp30_;
						gint _tmp31_;
						gchar* current_value = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						gchar* canonicalized = NULL;
						const gchar* _tmp34_;
						HierarchicalKeywordField* _tmp35_;
						const gchar* _tmp36_;
						gchar* _tmp37_;
						const gchar* _tmp38_;
#line 1180 "../src/photos/PhotoMetadata.vala"
						_current_value_index = _current_value_index + 1;
#line 1180 "../src/photos/PhotoMetadata.vala"
						_tmp30_ = _current_value_index;
#line 1180 "../src/photos/PhotoMetadata.vala"
						_tmp31_ = _current_value_size;
#line 1180 "../src/photos/PhotoMetadata.vala"
						if (!(_tmp30_ < _tmp31_)) {
#line 1180 "../src/photos/PhotoMetadata.vala"
							break;
#line 8751 "PhotoMetadata.c"
						}
#line 1180 "../src/photos/PhotoMetadata.vala"
						_tmp32_ = _current_value_list;
#line 1180 "../src/photos/PhotoMetadata.vala"
						_tmp33_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _current_value_index);
#line 1180 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp33_;
#line 1181 "../src/photos/PhotoMetadata.vala"
						_tmp34_ = current_value;
#line 1181 "../src/photos/PhotoMetadata.vala"
						_tmp35_ = field;
#line 1181 "../src/photos/PhotoMetadata.vala"
						_tmp36_ = _tmp35_->path_separator;
#line 1181 "../src/photos/PhotoMetadata.vala"
						_tmp37_ = hierarchical_tag_utilities_canonicalize (_tmp34_, _tmp36_);
#line 1181 "../src/photos/PhotoMetadata.vala"
						canonicalized = _tmp37_;
#line 1185 "../src/photos/PhotoMetadata.vala"
						_tmp38_ = canonicalized;
#line 1185 "../src/photos/PhotoMetadata.vala"
						if (_tmp38_ != NULL) {
#line 8773 "PhotoMetadata.c"
							GeeSet* _tmp39_;
							const gchar* _tmp40_;
#line 1186 "../src/photos/PhotoMetadata.vala"
							_tmp39_ = h_keywords;
#line 1186 "../src/photos/PhotoMetadata.vala"
							_tmp40_ = canonicalized;
#line 1186 "../src/photos/PhotoMetadata.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _tmp40_);
#line 8782 "PhotoMetadata.c"
						}
#line 1180 "../src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 1180 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 8788 "PhotoMetadata.c"
					}
				}
#line 1162 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (transformed_values);
#line 1162 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 1162 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 8797 "PhotoMetadata.c"
			}
		}
	}
#line 1190 "../src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 1190 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8805 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_orientation (PhotoMetadata* self)
{
	gboolean _tmp4_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1193 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 8816 "PhotoMetadata.c"
	{
		GExiv2Orientation _tmp0_ = 0;
		GExiv2Metadata* _tmp1_;
#line 1195 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->exiv2;
#line 1195 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gexiv2_metadata_try_get_orientation (_tmp1_, &_inner_error0_);
#line 1195 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8826 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 1195 "../src/photos/PhotoMetadata.vala"
		result = _tmp0_ == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 1195 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8833 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 1194 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 1194 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 1197 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = err;
#line 1197 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_->message;
#line 1197 "../src/photos/PhotoMetadata.vala"
		g_debug ("PhotoMetadata.vala:1197: Failed to get orientation: %s", _tmp3_);
#line 1198 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1198 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 1198 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8857 "PhotoMetadata.c"
	}
	__finally0:
#line 1194 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1194 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 1194 "../src/photos/PhotoMetadata.vala"
	return _tmp4_;
#line 8866 "PhotoMetadata.c"
}

Orientation
photo_metadata_get_orientation (PhotoMetadata* self)
{
	GError* _inner_error0_ = NULL;
	Orientation result;
#line 1203 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 8876 "PhotoMetadata.c"
	{
		GExiv2Orientation orientation = 0;
		GExiv2Metadata* _tmp0_;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 1207 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 1207 "../src/photos/PhotoMetadata.vala"
		orientation = gexiv2_metadata_try_get_orientation (_tmp0_, &_inner_error0_);
#line 1207 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8888 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 1208 "../src/photos/PhotoMetadata.vala"
		if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 1208 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 8895 "PhotoMetadata.c"
		} else {
#line 1208 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = orientation < ORIENTATION_MIN;
#line 8899 "PhotoMetadata.c"
		}
#line 1208 "../src/photos/PhotoMetadata.vala"
		if (_tmp2_) {
#line 1208 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = TRUE;
#line 8905 "PhotoMetadata.c"
		} else {
#line 1209 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = orientation > ORIENTATION_MAX;
#line 8909 "PhotoMetadata.c"
		}
#line 1208 "../src/photos/PhotoMetadata.vala"
		if (_tmp1_) {
#line 1210 "../src/photos/PhotoMetadata.vala"
			result = ORIENTATION_TOP_LEFT;
#line 1210 "../src/photos/PhotoMetadata.vala"
			return result;
#line 8917 "PhotoMetadata.c"
		} else {
#line 1212 "../src/photos/PhotoMetadata.vala"
			result = (Orientation) orientation;
#line 1212 "../src/photos/PhotoMetadata.vala"
			return result;
#line 8923 "PhotoMetadata.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1206 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1214 "../src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 1214 "../src/photos/PhotoMetadata.vala"
		return result;
#line 8935 "PhotoMetadata.c"
	}
	__finally0:
#line 1206 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1206 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 1206 "../src/photos/PhotoMetadata.vala"
	return 0;
#line 8944 "PhotoMetadata.c"
}

void
photo_metadata_set_orientation (PhotoMetadata* self,
                                Orientation orientation)
{
	GError* _inner_error0_ = NULL;
#line 1218 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 8954 "PhotoMetadata.c"
	{
		GExiv2Metadata* _tmp0_;
#line 1221 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = self->priv->exiv2;
#line 1221 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_set_orientation (_tmp0_, (GExiv2Orientation) orientation, &_inner_error0_);
#line 1221 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8963 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1220 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 1220 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 1223 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = err;
#line 1223 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp1_->message;
#line 1223 "../src/photos/PhotoMetadata.vala"
		g_debug ("PhotoMetadata.vala:1223: Failed to set the orientation: %s", _tmp2_);
#line 1220 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 8985 "PhotoMetadata.c"
	}
	__finally0:
#line 1220 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1220 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1220 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1220 "../src/photos/PhotoMetadata.vala"
		return;
#line 8996 "PhotoMetadata.c"
	}
}

gboolean
photo_metadata_get_gps (PhotoMetadata* self,
                        gdouble* longitude,
                        gchar** long_ref,
                        gdouble* latitude,
                        gchar** lat_ref,
                        gdouble* altitude)
{
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1227 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1229 "../src/photos/PhotoMetadata.vala"
	_vala_longitude = 0.0;
#line 1230 "../src/photos/PhotoMetadata.vala"
	_vala_latitude = 0.0;
#line 1231 "../src/photos/PhotoMetadata.vala"
	_vala_altitude = 0.0;
#line 9025 "PhotoMetadata.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GExiv2Metadata* _tmp2_;
		gdouble _tmp3_ = 0.0;
		gboolean _tmp4_;
#line 1233 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = self->priv->exiv2;
#line 1233 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = gexiv2_metadata_try_get_gps_longitude (_tmp2_, &_tmp3_, &_inner_error0_);
#line 1233 "../src/photos/PhotoMetadata.vala"
		_vala_longitude = _tmp3_;
#line 1233 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp4_;
#line 1233 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9042 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 1233 "../src/photos/PhotoMetadata.vala"
		if (!_tmp1_) {
#line 1233 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = TRUE;
#line 9049 "PhotoMetadata.c"
		} else {
			gboolean _tmp5_ = FALSE;
			GExiv2Metadata* _tmp6_;
			gdouble _tmp7_ = 0.0;
			gboolean _tmp8_;
#line 1233 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 1233 "../src/photos/PhotoMetadata.vala"
			_tmp8_ = gexiv2_metadata_try_get_gps_latitude (_tmp6_, &_tmp7_, &_inner_error0_);
#line 1233 "../src/photos/PhotoMetadata.vala"
			_vala_latitude = _tmp7_;
#line 1233 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp8_;
#line 1233 "../src/photos/PhotoMetadata.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9065 "PhotoMetadata.c"
				goto __catch0_g_error;
			}
#line 1233 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = !_tmp5_;
#line 9070 "PhotoMetadata.c"
		}
#line 1233 "../src/photos/PhotoMetadata.vala"
		if (_tmp0_) {
#line 1234 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 1234 "../src/photos/PhotoMetadata.vala"
			_vala_long_ref = NULL;
#line 1235 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 1235 "../src/photos/PhotoMetadata.vala"
			_vala_lat_ref = NULL;
#line 1237 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 1237 "../src/photos/PhotoMetadata.vala"
			if (longitude) {
#line 1237 "../src/photos/PhotoMetadata.vala"
				*longitude = _vala_longitude;
#line 9088 "PhotoMetadata.c"
			}
#line 1237 "../src/photos/PhotoMetadata.vala"
			if (long_ref) {
#line 1237 "../src/photos/PhotoMetadata.vala"
				*long_ref = _vala_long_ref;
#line 9094 "PhotoMetadata.c"
			} else {
#line 1237 "../src/photos/PhotoMetadata.vala"
				_g_free0 (_vala_long_ref);
#line 9098 "PhotoMetadata.c"
			}
#line 1237 "../src/photos/PhotoMetadata.vala"
			if (latitude) {
#line 1237 "../src/photos/PhotoMetadata.vala"
				*latitude = _vala_latitude;
#line 9104 "PhotoMetadata.c"
			}
#line 1237 "../src/photos/PhotoMetadata.vala"
			if (lat_ref) {
#line 1237 "../src/photos/PhotoMetadata.vala"
				*lat_ref = _vala_lat_ref;
#line 9110 "PhotoMetadata.c"
			} else {
#line 1237 "../src/photos/PhotoMetadata.vala"
				_g_free0 (_vala_lat_ref);
#line 9114 "PhotoMetadata.c"
			}
#line 1237 "../src/photos/PhotoMetadata.vala"
			if (altitude) {
#line 1237 "../src/photos/PhotoMetadata.vala"
				*altitude = _vala_altitude;
#line 9120 "PhotoMetadata.c"
			}
#line 1237 "../src/photos/PhotoMetadata.vala"
			return result;
#line 9124 "PhotoMetadata.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 1232 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 1232 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 1240 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = err;
#line 1240 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_->message;
#line 1240 "../src/photos/PhotoMetadata.vala"
		g_debug ("PhotoMetadata.vala:1240: Failed to get GPS lon/lat: %s", _tmp10_);
#line 1232 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 9145 "PhotoMetadata.c"
	}
	__finally0:
#line 1232 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9150 "PhotoMetadata.c"
		gboolean _tmp11_ = FALSE;
#line 1232 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1232 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1232 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1232 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1232 "../src/photos/PhotoMetadata.vala"
		return _tmp11_;
#line 9162 "PhotoMetadata.c"
	}
	{
		GExiv2Metadata* _tmp12_;
		gdouble _tmp13_ = 0.0;
#line 1244 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->exiv2;
#line 1244 "../src/photos/PhotoMetadata.vala"
		gexiv2_metadata_try_get_gps_altitude (_tmp12_, &_tmp13_, &_inner_error0_);
#line 1244 "../src/photos/PhotoMetadata.vala"
		_vala_altitude = _tmp13_;
#line 1244 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9175 "PhotoMetadata.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 1243 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 1243 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 1246 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = err;
#line 1246 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_->message;
#line 1246 "../src/photos/PhotoMetadata.vala"
		g_debug ("PhotoMetadata.vala:1246: Failed to get GPS altitude: %s", _tmp15_);
#line 1243 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 9197 "PhotoMetadata.c"
	}
	__finally1:
#line 1243 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9202 "PhotoMetadata.c"
		gboolean _tmp16_ = FALSE;
#line 1243 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1243 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1243 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1243 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1243 "../src/photos/PhotoMetadata.vala"
		return _tmp16_;
#line 9214 "PhotoMetadata.c"
	}
#line 1249 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1249 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 1249 "../src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp17_;
#line 1250 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1250 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 1250 "../src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp18_;
#line 1252 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1252 "../src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 1252 "../src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 9234 "PhotoMetadata.c"
	}
#line 1252 "../src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 1252 "../src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 9240 "PhotoMetadata.c"
	} else {
#line 1252 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 9244 "PhotoMetadata.c"
	}
#line 1252 "../src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 1252 "../src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 9250 "PhotoMetadata.c"
	}
#line 1252 "../src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 1252 "../src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 9256 "PhotoMetadata.c"
	} else {
#line 1252 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 9260 "PhotoMetadata.c"
	}
#line 1252 "../src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 1252 "../src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 9266 "PhotoMetadata.c"
	}
#line 1252 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9270 "PhotoMetadata.c"
}

void
photo_metadata_get_gps_coords (PhotoMetadata* self,
                               GpsCoords* result)
{
	GpsCoords gps_coords = {0};
	GError* _inner_error0_ = NULL;
#line 1255 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1256 "../src/photos/PhotoMetadata.vala"
	memset (&gps_coords, 0, sizeof (GpsCoords));
#line 9283 "PhotoMetadata.c"
	{
		gdouble altitude = 0.0;
		gint _tmp0_ = 0;
		gboolean _tmp1_ = FALSE;
		GExiv2Metadata* _tmp2_;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gboolean _tmp6_;
		GpsCoords _tmp7_;
#line 1259 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = self->priv->exiv2;
#line 1259 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gexiv2_metadata_try_get_gps_info (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1259 "../src/photos/PhotoMetadata.vala"
		gps_coords.longitude = _tmp3_;
#line 1259 "../src/photos/PhotoMetadata.vala"
		gps_coords.latitude = _tmp4_;
#line 1259 "../src/photos/PhotoMetadata.vala"
		altitude = _tmp5_;
#line 1259 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp6_;
#line 1259 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9308 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 1259 "../src/photos/PhotoMetadata.vala"
		if (_tmp1_) {
#line 1259 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = 1;
#line 9315 "PhotoMetadata.c"
		} else {
#line 1259 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = 0;
#line 9319 "PhotoMetadata.c"
		}
#line 1259 "../src/photos/PhotoMetadata.vala"
		gps_coords.has_gps = _tmp0_;
#line 1260 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = gps_coords;
#line 1260 "../src/photos/PhotoMetadata.vala"
		if (_tmp7_.has_gps > 0) {
#line 9327 "PhotoMetadata.c"
			gboolean _tmp8_ = FALSE;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp14_ = FALSE;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gboolean _tmp17_;
#line 1261 "../src/photos/PhotoMetadata.vala"
			_tmp9_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1261 "../src/photos/PhotoMetadata.vala"
			_tmp10_ = _tmp9_;
#line 1261 "../src/photos/PhotoMetadata.vala"
			_tmp11_ = g_strcmp0 (_tmp10_, "W") == 0;
#line 1261 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp10_);
#line 1261 "../src/photos/PhotoMetadata.vala"
			if (_tmp11_) {
#line 9346 "PhotoMetadata.c"
				GpsCoords _tmp12_;
#line 1261 "../src/photos/PhotoMetadata.vala"
				_tmp12_ = gps_coords;
#line 1261 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = _tmp12_.longitude > ((gdouble) 0);
#line 9352 "PhotoMetadata.c"
			} else {
#line 1261 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = FALSE;
#line 9356 "PhotoMetadata.c"
			}
#line 1261 "../src/photos/PhotoMetadata.vala"
			if (_tmp8_) {
#line 9360 "PhotoMetadata.c"
				GpsCoords _tmp13_;
#line 1262 "../src/photos/PhotoMetadata.vala"
				_tmp13_ = gps_coords;
#line 1262 "../src/photos/PhotoMetadata.vala"
				gps_coords.longitude = -_tmp13_.longitude;
#line 9366 "PhotoMetadata.c"
			}
#line 1263 "../src/photos/PhotoMetadata.vala"
			_tmp15_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1263 "../src/photos/PhotoMetadata.vala"
			_tmp16_ = _tmp15_;
#line 1263 "../src/photos/PhotoMetadata.vala"
			_tmp17_ = g_strcmp0 (_tmp16_, "S") == 0;
#line 1263 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp16_);
#line 1263 "../src/photos/PhotoMetadata.vala"
			if (_tmp17_) {
#line 9378 "PhotoMetadata.c"
				GpsCoords _tmp18_;
#line 1263 "../src/photos/PhotoMetadata.vala"
				_tmp18_ = gps_coords;
#line 1263 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = _tmp18_.latitude > ((gdouble) 0);
#line 9384 "PhotoMetadata.c"
			} else {
#line 1263 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = FALSE;
#line 9388 "PhotoMetadata.c"
			}
#line 1263 "../src/photos/PhotoMetadata.vala"
			if (_tmp14_) {
#line 9392 "PhotoMetadata.c"
				GpsCoords _tmp19_;
#line 1264 "../src/photos/PhotoMetadata.vala"
				_tmp19_ = gps_coords;
#line 1264 "../src/photos/PhotoMetadata.vala"
				gps_coords.latitude = -_tmp19_.latitude;
#line 9398 "PhotoMetadata.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1257 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1267 "../src/photos/PhotoMetadata.vala"
		gps_coords.has_gps = 0;
#line 9409 "PhotoMetadata.c"
	}
	__finally0:
#line 1257 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1257 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1257 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1257 "../src/photos/PhotoMetadata.vala"
		return;
#line 9420 "PhotoMetadata.c"
	}
#line 1270 "../src/photos/PhotoMetadata.vala"
	*result = gps_coords;
#line 1270 "../src/photos/PhotoMetadata.vala"
	return;
#line 9426 "PhotoMetadata.c"
}

void
photo_metadata_set_gps_coords (PhotoMetadata* self,
                               GpsCoords* gps_coords)
{
	GError* _inner_error0_ = NULL;
#line 1273 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1273 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (gps_coords != NULL);
#line 9438 "PhotoMetadata.c"
	{
		GpsCoords _tmp0_;
#line 1275 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = *gps_coords;
#line 1275 "../src/photos/PhotoMetadata.vala"
		if (_tmp0_.has_gps > 0) {
#line 9445 "PhotoMetadata.c"
			gdouble altitude = 0.0;
			GExiv2Metadata* _tmp1_;
			gdouble _tmp2_ = 0.0;
			GExiv2Metadata* _tmp3_;
			GpsCoords _tmp4_;
			GpsCoords _tmp5_;
#line 1276 "../src/photos/PhotoMetadata.vala"
			altitude = 0.0;
#line 1277 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 1277 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_try_get_gps_altitude (_tmp1_, &_tmp2_, &_inner_error0_);
#line 1277 "../src/photos/PhotoMetadata.vala"
			altitude = _tmp2_;
#line 1277 "../src/photos/PhotoMetadata.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9462 "PhotoMetadata.c"
				goto __catch0_g_error;
			}
#line 1278 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 1278 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = *gps_coords;
#line 1278 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = *gps_coords;
#line 1278 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_try_set_gps_info (_tmp3_, _tmp4_.longitude, _tmp5_.latitude, altitude, &_inner_error0_);
#line 1278 "../src/photos/PhotoMetadata.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9475 "PhotoMetadata.c"
				goto __catch0_g_error;
			}
		} else {
			GExiv2Metadata* _tmp6_;
#line 1280 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 1280 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_try_delete_gps_info (_tmp6_, &_inner_error0_);
#line 1280 "../src/photos/PhotoMetadata.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9486 "PhotoMetadata.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 1274 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 1274 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 1282 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = err;
#line 1282 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp7_->message;
#line 1282 "../src/photos/PhotoMetadata.vala"
		g_debug ("PhotoMetadata.vala:1282: Failed to set or remove GPS info: %s", _tmp8_);
#line 1274 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 9509 "PhotoMetadata.c"
	}
	__finally0:
#line 1274 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1274 "../src/photos/PhotoMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1274 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 1274 "../src/photos/PhotoMetadata.vala"
		return;
#line 9520 "PhotoMetadata.c"
	}
}

gboolean
photo_metadata_get_exposure (PhotoMetadata* self,
                             MetadataRational* exposure)
{
	MetadataRational _vala_exposure = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1286 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1287 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1287 "../src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1287 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1287 "../src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1287 "../src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 9544 "PhotoMetadata.c"
	}
#line 1287 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9548 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_string (PhotoMetadata* self)
{
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 1290 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1292 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1292 "../src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1292 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1293 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1293 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9571 "PhotoMetadata.c"
	}
#line 1295 "../src/photos/PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 1296 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1296 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9579 "PhotoMetadata.c"
	}
#line 1298 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1298 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1298 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9587 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_iso (PhotoMetadata* self,
                        glong* iso)
{
	glong _vala_iso = 0L;
	gboolean fetched_ok = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 1301 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1302 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1302 "../src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1302 "../src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1304 "../src/photos/PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 1305 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1305 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1305 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 9616 "PhotoMetadata.c"
		}
#line 1305 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9620 "PhotoMetadata.c"
	}
#line 1309 "../src/photos/PhotoMetadata.vala"
	if (_vala_iso < ((glong) 6)) {
#line 1309 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 9626 "PhotoMetadata.c"
	} else {
#line 1309 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _vala_iso > ((glong) 409600);
#line 9630 "PhotoMetadata.c"
	}
#line 1309 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1310 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1310 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1310 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 9640 "PhotoMetadata.c"
		}
#line 1310 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9644 "PhotoMetadata.c"
	}
#line 1312 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1312 "../src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1312 "../src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 9652 "PhotoMetadata.c"
	}
#line 1312 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9656 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_iso_string (PhotoMetadata* self)
{
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 1315 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1317 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1317 "../src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1317 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1318 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1318 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9679 "PhotoMetadata.c"
	}
#line 1320 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1320 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1320 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9687 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_aperture (PhotoMetadata* self,
                             MetadataRational* aperture)
{
	MetadataRational _vala_aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1323 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1324 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1324 "../src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1324 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1324 "../src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1324 "../src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 9710 "PhotoMetadata.c"
	}
#line 1324 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9714 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_aperture_string (PhotoMetadata* self,
                                    gboolean pango_formatted)
{
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble aperture_value = 0.0;
	MetadataRational _tmp2_;
	MetadataRational _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 1327 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1329 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1329 "../src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1329 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1330 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1330 "../src/photos/PhotoMetadata.vala"
		return result;
#line 9746 "PhotoMetadata.c"
	}
#line 1332 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1332 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = aperture;
#line 1332 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp2_.numerator) / ((gdouble) _tmp3_.denominator);
#line 1333 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 1335 "../src/photos/PhotoMetadata.vala"
	if (pango_formatted) {
#line 1335 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "<i>f</i>/";
#line 9760 "PhotoMetadata.c"
	} else {
#line 1335 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "f/";
#line 9764 "PhotoMetadata.c"
	}
#line 1336 "../src/photos/PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == ((gdouble) 0)) {
#line 1336 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.0f";
#line 9770 "PhotoMetadata.c"
	} else {
#line 1336 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.1f";
#line 9774 "PhotoMetadata.c"
	}
#line 1335 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup_printf (_tmp5_, aperture_value);
#line 1335 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 1335 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 1335 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = _tmp8_;
#line 1335 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 1335 "../src/photos/PhotoMetadata.vala"
	result = _tmp9_;
#line 1335 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9790 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_make (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1339 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1340 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1340 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1340 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9806 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_model (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1343 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1344 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1344 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1344 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9822 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_flash (PhotoMetadata* self,
                          glong* flash)
{
	glong _vala_flash = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean result;
#line 1347 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1349 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1349 "../src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1349 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1349 "../src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1349 "../src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 9845 "PhotoMetadata.c"
	}
#line 1349 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9849 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_flash_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1352 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1354 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1354 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1354 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9865 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_focal_length (PhotoMetadata* self,
                                 MetadataRational* focal_length)
{
	MetadataRational _vala_focal_length = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 1357 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 1358 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1358 "../src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1358 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1358 "../src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1358 "../src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 9888 "PhotoMetadata.c"
	}
#line 1358 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9892 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_focal_length_string (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1361 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1362 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1362 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1362 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9908 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_artist (PhotoMetadata* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* result;
#line 1371 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1372 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 1372 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 1372 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 1372 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1372 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9930 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_copyright (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1375 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1376 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1376 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1376 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9946 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_software (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1379 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1380 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1380 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1380 "../src/photos/PhotoMetadata.vala"
	return result;
#line 9962 "PhotoMetadata.c"
}

void
photo_metadata_set_software (PhotoMetadata* self,
                             const gchar* software,
                             const gchar* version)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1383 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1383 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1383 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1385 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%s %s", software, version);
#line 1385 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1385 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1385 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1387 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_iptc (self)) {
#line 1388 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", software, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1389 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 9992 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_software (PhotoMetadata* self)
{
#line 1393 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1394 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1395 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1396 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 10007 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_bias (PhotoMetadata* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 1399 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 1400 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1400 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1400 "../src/photos/PhotoMetadata.vala"
	return result;
#line 10023 "PhotoMetadata.c"
}

Rating
photo_metadata_get_rating (PhotoMetadata* self)
{
	gchar* rating_string = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint int_percent_rating = 0;
	const gchar* _tmp6_;
	Rating result;
#line 1411 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1412 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_RATING_TAGS;
#line 1412 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_RATING_TAGS_length1;
#line 1412 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string (self, _tmp0_, (gint) _tmp0__length1);
#line 1412 "../src/photos/PhotoMetadata.vala"
	rating_string = _tmp1_;
#line 1413 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = rating_string;
#line 1413 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_ != NULL) {
#line 10053 "PhotoMetadata.c"
		const gchar* _tmp3_;
#line 1414 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = rating_string;
#line 1414 "../src/photos/PhotoMetadata.vala"
		result = rating_unserialize (atoi (_tmp3_));
#line 1414 "../src/photos/PhotoMetadata.vala"
		_g_free0 (rating_string);
#line 1414 "../src/photos/PhotoMetadata.vala"
		return result;
#line 10063 "PhotoMetadata.c"
	}
#line 1416 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_get_string (self, "Exif.Image.RatingPercent", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1416 "../src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1416 "../src/photos/PhotoMetadata.vala"
	rating_string = _tmp4_;
#line 1417 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = rating_string;
#line 1417 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ == NULL) {
#line 1418 "../src/photos/PhotoMetadata.vala"
		result = RATING_UNRATED;
#line 1418 "../src/photos/PhotoMetadata.vala"
		_g_free0 (rating_string);
#line 1418 "../src/photos/PhotoMetadata.vala"
		return result;
#line 10081 "PhotoMetadata.c"
	}
#line 1421 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = rating_string;
#line 1421 "../src/photos/PhotoMetadata.vala"
	int_percent_rating = atoi (_tmp6_);
#line 10087 "PhotoMetadata.c"
	{
		gint i = 0;
#line 1422 "../src/photos/PhotoMetadata.vala"
		i = 5;
#line 10092 "PhotoMetadata.c"
		{
			gboolean _tmp7_ = FALSE;
#line 1422 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = TRUE;
#line 1422 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 10099 "PhotoMetadata.c"
				gint _tmp9_;
#line 1422 "../src/photos/PhotoMetadata.vala"
				if (!_tmp7_) {
#line 10103 "PhotoMetadata.c"
					gint _tmp8_;
#line 1422 "../src/photos/PhotoMetadata.vala"
					i = i - 1;
#line 1422 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = i;
#line 10109 "PhotoMetadata.c"
				}
#line 1422 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = FALSE;
#line 1422 "../src/photos/PhotoMetadata.vala"
				if (!(i >= 0)) {
#line 1422 "../src/photos/PhotoMetadata.vala"
					break;
#line 10117 "PhotoMetadata.c"
				}
#line 1423 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = RESOURCES_rating_thresholds[i];
#line 1423 "../src/photos/PhotoMetadata.vala"
				if (int_percent_rating >= _tmp9_) {
#line 1424 "../src/photos/PhotoMetadata.vala"
					result = rating_unserialize (i);
#line 1424 "../src/photos/PhotoMetadata.vala"
					_g_free0 (rating_string);
#line 1424 "../src/photos/PhotoMetadata.vala"
					return result;
#line 10129 "PhotoMetadata.c"
				}
			}
		}
	}
#line 1426 "../src/photos/PhotoMetadata.vala"
	result = rating_unserialize (-1);
#line 1426 "../src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1426 "../src/photos/PhotoMetadata.vala"
	return result;
#line 10140 "PhotoMetadata.c"
}

void
photo_metadata_set_rating (PhotoMetadata* self,
                           Rating rating)
{
	gint int_rating = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1434 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1435 "../src/photos/PhotoMetadata.vala"
	int_rating = rating_serialize (rating);
#line 1436 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%i", int_rating);
#line 1436 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1436 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1436 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1437 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%i", int_rating);
#line 1437 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1437 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Rating", _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1437 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 1439 "../src/photos/PhotoMetadata.vala"
	if (0 <= int_rating) {
#line 10174 "PhotoMetadata.c"
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1440 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = RESOURCES_rating_thresholds[int_rating];
#line 1440 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 1440 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp5_;
#line 1440 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Image.RatingPercent", _tmp6_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1440 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp6_);
#line 10188 "PhotoMetadata.c"
	} else {
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 1442 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = g_strdup_printf ("%i", int_rating);
#line 1442 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp7_;
#line 1442 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Image.RatingPercent", _tmp8_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 1442 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp8_);
#line 10200 "PhotoMetadata.c"
	}
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 237 "../src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 10209 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_construct (GType object_type,
                                                 PhotoMetadata* owner,
                                                 const gchar* name,
                                                 guint number,
                                                 GExiv2PreviewProperties* props)
{
	PhotoMetadataInternalPhotoPreview* self = NULL;
	Dimensions _tmp0_ = {0};
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 232 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (props, gexiv2_preview_properties_get_type ()), NULL);
#line 234 "../src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props));
#line 234 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_preview_properties_get_mime_type (props);
#line 234 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_extension (props);
#line 234 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, &_tmp0_, gexiv2_preview_properties_get_size (props), _tmp1_, _tmp2_);
#line 237 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _media_metadata_ref0 (owner);
#line 237 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 237 "../src/photos/PhotoMetadata.vala"
	self->owner = _tmp3_;
#line 238 "../src/photos/PhotoMetadata.vala"
	self->number = number;
#line 232 "../src/photos/PhotoMetadata.vala"
	return self;
#line 10248 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                           const gchar* name,
                                           guint number,
                                           GExiv2PreviewProperties* props)
{
#line 232 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 10259 "PhotoMetadata.c"
}

static GBytes*
photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                    GError** error)
{
	PhotoMetadataInternalPhotoPreview * self;
	GExiv2PreviewProperties** props = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
	GBytes* result;
#line 241 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 242 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 242 "../src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 242 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 242 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 243 "../src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 10299 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > self->number;
#line 10308 "PhotoMetadata.c"
	} else {
#line 243 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 10312 "PhotoMetadata.c"
	}
#line 243 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp4_, "props != null && props.length > number");
#line 10316 "PhotoMetadata.c"
	{
		GExiv2PreviewImage* _tmp7_ = NULL;
		PhotoMetadata* _tmp8_;
		GExiv2Metadata* _tmp9_;
		GExiv2PreviewProperties** _tmp10_;
		gint _tmp10__length1;
		GExiv2PreviewProperties* _tmp11_;
		GExiv2PreviewImage* _tmp12_;
		guint32 _tmp13_ = 0;
		guint8* _tmp14_;
		GBytes* _tmp15_;
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = self->owner;
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_->priv->exiv2;
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = props;
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp10__length1 = props_length1;
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp10_[self->number];
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = gexiv2_metadata_try_get_preview_image (_tmp9_, _tmp11_, &_inner_error0_);
#line 247 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp12_;
#line 247 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10344 "PhotoMetadata.c"
			goto __catch0_g_error;
		}
#line 246 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = gexiv2_preview_image_get_data (_tmp7_, &_tmp13_);
#line 246 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = g_bytes_new (_tmp14_, _tmp13_);
#line 246 "../src/photos/PhotoMetadata.vala"
		result = _tmp15_;
#line 246 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp7_);
#line 246 "../src/photos/PhotoMetadata.vala"
		return result;
#line 10357 "PhotoMetadata.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GBytes* _tmp16_;
#line 245 "../src/photos/PhotoMetadata.vala"
		g_clear_error (&_inner_error0_);
#line 249 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = g_bytes_new (NULL, 0);
#line 249 "../src/photos/PhotoMetadata.vala"
		result = _tmp16_;
#line 249 "../src/photos/PhotoMetadata.vala"
		return result;
#line 10371 "PhotoMetadata.c"
	}
	__finally0:
#line 245 "../src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 245 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 10378 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass,
                                                  gpointer klass_data)
{
#line 228 "../src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 228 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 228 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (GBytes* (*) (PhotoPreview*, GError**)) photo_metadata_internal_photo_preview_real_flatten;
#line 10391 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self,
                                                     gpointer klass)
{
}

static void
photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj)
{
	PhotoMetadataInternalPhotoPreview * self;
#line 228 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 229 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 228 "../src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 10410 "PhotoMetadata.c"
}

static GType
photo_metadata_internal_photo_preview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
	GType photo_metadata_internal_photo_preview_type_id;
	photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
	return photo_metadata_internal_photo_preview_type_id;
}

static GType
photo_metadata_internal_photo_preview_get_type (void)
{
	static volatile gsize photo_metadata_internal_photo_preview_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__once)) {
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = photo_metadata_internal_photo_preview_get_type_once ();
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__once, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__once;
}

static void
photo_metadata_class_init (PhotoMetadataClass * klass,
                           gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar** _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar** _tmp37_;
	NullKeywordTransformer* _tmp38_;
	NullKeywordTransformer* _tmp39_;
	HierarchicalKeywordField* _tmp40_;
	NullKeywordTransformer* _tmp41_;
	NullKeywordTransformer* _tmp42_;
	HierarchicalKeywordField* _tmp43_;
	ACDSeeKeywordTransformer* _tmp44_;
	ACDSeeKeywordTransformer* _tmp45_;
	HierarchicalKeywordField* _tmp46_;
	NullKeywordTransformer* _tmp47_;
	NullKeywordTransformer* _tmp48_;
	HierarchicalKeywordField* _tmp49_;
	NullKeywordTransformer* _tmp50_;
	NullKeywordTransformer* _tmp51_;
	HierarchicalKeywordField* _tmp52_;
	HierarchicalKeywordField** _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar** _tmp63_;
#line 213 "../src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = photo_metadata_finalize;
#line 213 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoMetadata_private_offset);
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) photo_metadata_real_read_from_file;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) photo_metadata_real_get_creation_date_time;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_title;
#line 213 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_comment;
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup ("Xmp.acdsee.datetime");
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp4_[0] = _tmp0_;
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp4_[1] = _tmp1_;
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp4_[2] = _tmp2_;
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp4_[3] = _tmp3_;
#line 860 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp4_;
#line 860 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 4;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Xmp.xmp.CreateDate");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = g_strdup ("Exif.Image.DateTime");
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = g_new0 (gchar*, 6 + 1);
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[0] = _tmp5_;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[1] = _tmp6_;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[2] = _tmp7_;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[3] = _tmp8_;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[4] = _tmp9_;
#line 879 "../src/photos/PhotoMetadata.vala"
	_tmp11_[5] = _tmp10_;
#line 879 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp11_;
#line 879 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp14_[0] = _tmp12_;
#line 900 "../src/photos/PhotoMetadata.vala"
	_tmp14_[1] = _tmp13_;
#line 900 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp14_;
#line 900 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = g_new0 (gchar*, 4 + 1);
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp19_[0] = _tmp15_;
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp19_[1] = _tmp16_;
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp19_[2] = _tmp17_;
#line 925 "../src/photos/PhotoMetadata.vala"
	_tmp19_[3] = _tmp18_;
#line 925 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp19_;
#line 925 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.tiff.ImageLength");
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_new0 (gchar*, 4 + 1);
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp24_[0] = _tmp20_;
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp24_[1] = _tmp21_;
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp24_[2] = _tmp22_;
#line 932 "../src/photos/PhotoMetadata.vala"
	_tmp24_[3] = _tmp23_;
#line 932 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp24_;
#line 932 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Iptc.Application2.Caption");
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Xmp.dc.title");
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Iptc.Application2.Headline");
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = g_strdup ("Xmp.photoshop.Headline");
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.acdsee.caption");
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_ = g_new0 (gchar*, 5 + 1);
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_[0] = _tmp25_;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_[1] = _tmp26_;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_[2] = _tmp27_;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_[3] = _tmp28_;
#line 991 "../src/photos/PhotoMetadata.vala"
	_tmp30_[4] = _tmp29_;
#line 991 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp30_;
#line 991 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 5;
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = g_strdup ("Exif.Photo.UserComment");
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp32_ = g_strdup ("Xmp.acdsee.notes");
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp33_ = g_new0 (gchar*, 2 + 1);
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp33_[0] = _tmp31_;
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp33_[1] = _tmp32_;
#line 1036 "../src/photos/PhotoMetadata.vala"
	photo_metadata_COMMENT_TAGS = _tmp33_;
#line 1036 "../src/photos/PhotoMetadata.vala"
	photo_metadata_COMMENT_TAGS_length1 = 2;
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp34_ = g_strdup ("Xmp.dc.subject");
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp35_ = g_strdup ("Iptc.Application2.Keywords");
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Xmp.xmp.Label");
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp37_ = g_new0 (gchar*, 3 + 1);
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp37_[0] = _tmp34_;
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp37_[1] = _tmp35_;
#line 1059 "../src/photos/PhotoMetadata.vala"
	_tmp37_[2] = _tmp36_;
#line 1059 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp37_;
#line 1059 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 3;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp38_ = null_keyword_transformer_new ();
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp39_ = _tmp38_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp40_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp41_ = null_keyword_transformer_new ();
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp42_ = _tmp41_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp43_ = hierarchical_keyword_field_new ("Xmp.acdsee.keywords", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp44_ = acd_see_keyword_transformer_new ();
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp45_ = _tmp44_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp46_ = hierarchical_keyword_field_new ("Xmp.acdsee.categories", "|", FALSE, FALSE, G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp47_ = null_keyword_transformer_new ();
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp48_ = _tmp47_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp49_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE, G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp50_ = null_keyword_transformer_new ();
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp51_ = _tmp50_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp52_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE, G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, TYPE_KEYWORD_TRANSFORMER, KeywordTransformer));
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_ = g_new0 (HierarchicalKeywordField*, 5 + 1);
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_[0] = _tmp40_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_[1] = _tmp43_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_[2] = _tmp46_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_[3] = _tmp49_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	_tmp53_[4] = _tmp52_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp53_;
#line 1065 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 5;
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp54_ = g_strdup ("Exif.Image.Artist");
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp55_ = g_strdup ("Exif.Canon.OwnerName");
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp56_ = g_strdup ("Xmp.acdsee.author");
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp57_ = g_new0 (gchar*, 3 + 1);
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp57_[0] = _tmp54_;
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp57_[1] = _tmp55_;
#line 1365 "../src/photos/PhotoMetadata.vala"
	_tmp57_[2] = _tmp56_;
#line 1365 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp57_;
#line 1365 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 3;
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp58_ = g_strdup ("Xmp.xmp.Rating");
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp59_ = g_strdup ("Iptc.Application2.Urgency");
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp60_ = g_strdup ("Xmp.photoshop.Urgency");
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp61_ = g_strdup ("Exif.Image.Rating");
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp62_ = g_strdup ("Xmp.acdsee.rating");
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_ = g_new0 (gchar*, 5 + 1);
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_[0] = _tmp58_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_[1] = _tmp59_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_[2] = _tmp60_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_[3] = _tmp61_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	_tmp63_[4] = _tmp62_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS = _tmp63_;
#line 1403 "../src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS_length1 = 5;
#line 10774 "PhotoMetadata.c"
}

static void
photo_metadata_instance_init (PhotoMetadata * self,
                              gpointer klass)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 213 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_metadata_get_instance_private (self);
#line 254 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 254 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 255 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 256 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 256 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 257 "../src/photos/PhotoMetadata.vala"
	self->priv->metadata_hash = NULL;
#line 258 "../src/photos/PhotoMetadata.vala"
	self->priv->thumbnail_md5 = NULL;
#line 10799 "PhotoMetadata.c"
}

static void
photo_metadata_finalize (MediaMetadata * obj)
{
	PhotoMetadata * self;
#line 213 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 254 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 255 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 256 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 257 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->metadata_hash);
#line 258 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->thumbnail_md5);
#line 213 "../src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 10820 "PhotoMetadata.c"
}

static GType
photo_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
	GType photo_metadata_type_id;
	photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
	PhotoMetadata_private_offset = g_type_add_instance_private (photo_metadata_type_id, sizeof (PhotoMetadataPrivate));
	return photo_metadata_type_id;
}

GType
photo_metadata_get_type (void)
{
	static volatile gsize photo_metadata_type_id__once = 0;
	if (g_once_init_enter (&photo_metadata_type_id__once)) {
		GType photo_metadata_type_id;
		photo_metadata_type_id = photo_metadata_get_type_once ();
		g_once_init_leave (&photo_metadata_type_id__once, photo_metadata_type_id);
	}
	return photo_metadata_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

